/*
* Copyright (C) International Computer Science Institute, 1994.  COPYRIGHT 
* NOTICE: This code is provided "AS IS" WITHOUT ANY WARRANTY and is subject
* to the terms of the SATHER LIBRARY GENERAL PUBLIC LICENSE contained in   
* the file "Doc/License" of the Sather distribution.  The license is also  
* available from ICSI, 1947 Center St., Suite 600, Berkeley CA 94704, USA.
* -----> Please email comments to "sather-bugs@icsi.berkeley.edu". <-----
*/

/* This file is included at the head of the compiler-generated header file. */

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <sys/utsname.h>
#if defined(V_RISCOS) && defined(R_5_0) /* yoshida@agusa.nuie.nagoya-u.ac.jp */
# ifdef _SETJMP_H
#  define _SETJMP_H
#  include <setjmp.h>
# endif
#else
# include <setjmp.h>
#endif
#include <setjmp.h>
#include <signal.h>
#include <limits.h>
#include <sys/types.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>

#if !defined(__NeXT__)
# include <unistd.h>
#endif

#if !defined(__NeXT__) && !defined(__EMX__) && !defined(__NetBSD__) && !defined(__FreeBSD__)
#  include <values.h>
#endif

#ifdef WIN32        /* From robert@crclund.abb.se */
# include <io.h>
# define lseek _lseek
# define read _read
# define open _open
# define close _close
# define O_RDONLY _O_RDONLY
#endif

/* Determine the machine type: */
# if defined(sun) && defined(sparc)
#   define SPARC
    /* Test for SunOS 5.x */
#     include <errno.h>
#     ifdef ECHRNG
#       define SUNOS5
#     else
#       define SUNOS4
#     endif
# endif
# if defined(NeXT) && defined(mc68000)
#   define M68K
#   define NEXT
# endif
# if defined(vax)
#    define VAX
#    ifdef ultrix
#       define ULTRIX
#    else
#       define BSD
#    endif
# endif

#if defined(SPARC) && defined(SUNOS5) && defined(__SUNPRO_C)
# include <sunmath.h>             
#endif

/* ALLOCATE(x) returns a zeroed memory region of size and type x.
 * The Boehm GC_malloc, unlike regular malloc, zeros memory.
 * The compiler emits typedefs such that "x_struct" is the name
 * of the struct type that *x refers to.
*/

#define ALLOCATE(x) ((x) GC_malloc(sizeof(struct x##_struct)))

/* These may be defined as appropriate to the target system */

typedef char BOOL;
#define FALSE 0
#define TRUE 1

#if defined(V_RISCOS) && defined(R_5_0) /* yoshida@agusa.nuie.nagoya-u.ac.jp */
# ifndef _MAXFLOAT
#  define _MAXFLOAT
#  define MAXFLOAT          ((float)3.40282346638528860e+38)
# endif
# define M_LOG2E             1.4426950408889634074
#endif

#ifdef ALPHA
    typedef int INT;
    #define SUINT_MAX UINT_MAX
    #define SINT_MAX INT_MAX
    #define SINT_MIN INT_MIN
#else
    typedef long INT;
    #define SUINT_MAX ULONG_MAX
    #define SINT_MAX LONG_MAX
    #define SINT_MIN LONG_MIN
#endif
typedef char CHAR;
typedef float FLT;
typedef double FLTD;
typedef double FLTX;  /* This is a hack */
typedef double FLTDX; /* This is a hack */
typedef void* EXT_OB;

/* Little boxes made of ticky-tacky */

typedef struct BOOL_boxed_struct { INT tag; BOOL value_part; } *BOOL_boxed;
typedef struct CHAR_boxed_struct { INT tag; CHAR value_part; } *CHAR_boxed;
typedef struct INT_boxed_struct { INT tag; INT value_part; } *INT_boxed;
typedef struct FLT_boxed_struct { INT tag; FLT value_part; } *FLT_boxed;
typedef struct FLTD_boxed_struct { INT tag; FLTD value_part; } *FLTD_boxed;
typedef struct FLTX_boxed_struct { INT tag; FLTX value_part; } *FLTX_boxed;
typedef struct FLTDX_boxed_struct { INT tag; FLTDX value_part; } *FLTDX_boxed;
typedef struct EXT_OB_boxed_struct { INT tag; EXT_OB value_part; } *EXT_OB_boxed;

/* Layouts for the Sather classes which are built-in */

typedef struct {
    signed int tag:16;
#ifdef DESTROY_CHK
    unsigned int destroyed:1;
#endif
#ifdef DETERMINISTIC
    unsigned int id;
#endif
  } OB_HEADER;

typedef struct STR_struct {
    OB_HEADER header;
    INT asize;
    CHAR arr_part[1];
} *STR;

typedef struct OB_struct {
    OB_HEADER header;
} *OB;

typedef struct CLEARED_EX_struct {
    OB_HEADER header;
} *CLEARED_EX;

#undef ferror
#undef feof

/* include floating-point support */
#include "floatmath.h"

/* include exception handling support */
#include "exception.h"

STR gen_SYS_str_for_tp(INT);
BOOL gen_SYS_ob_eq(OB,OB);

