#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_CONST_struct {
 OB_HEADER header;
 } *dAM_CONST;

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_FRAME_LAYOUT_struct {/* layout for ABSTRACT_FRAME_LAYOUT */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct SIG_struct *sig11;
 STR str1;
 } *ABSTRACT_FRAME_LAYOUT;

typedef struct ABSTRACT_LAYOUT_struct {/* layout for ABSTRACT_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct PROG_struct *prog1;
 STR str1;
 } *ABSTRACT_LAYOUT;

typedef struct AM_OUT_struct {/* layout for AM_OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *AM_OUT;

typedef struct ARRAYdAM_CONST_struct {/* layout for ARRAY{$AM_CONST} */
 OB_HEADER header;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *ARRAYdAM_CONST;


typedef struct ARRAYdAM_CONST_eltb_dAM__frame_struct {
 ARRAYdAM_CONST self;/* Formal argument: self */
 INT state;
 dAM_CONST ret_val;
 ARRAYdAM_CONST L31;
 struct ARRAYdAM_CONST_aeltb_dAM_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdAM_CONST_eltb_dAM__frame;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;


typedef struct ARRAYdTP_eltb_dTP_frame_struct {
 ARRAYdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 ARRAYdTP L31;
 struct ARRAYdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdTP_eltb_dTP_frame;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IFC_TBL_struct {/* layout for IFC_TBL */
 OB_HEADER header;
 struct FMAPdTPIFC_struct *tbl;
 struct FSETTUPIDENTINT_struct *abs_cur;
 struct PROG_struct *prog1;
 } *IFC_TBL;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_upb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_upb_INT_frame;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct RAT_struct {/* layout for RAT */
 struct INTI_struct *u;
 struct INTI_struct *v;
 } RAT;
static RAT RAT_zero;

typedef struct RAT_boxed_struct {
 OB_HEADER header;
 RAT value_part;
 } *RAT_boxed;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SIG_TBL_struct {/* layout for SIG_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *SIG_TBL;


typedef struct SIG_TBL_eltb_SIG_frame_struct {
 SIG_TBL self;/* Formal argument: self */
 INT state;
 SIG ret_val;
 SIG_TBL L31;
 SIG r;
 struct SIG_TBL_aeltb_SIG_frame_struct *nested1; /* nested iter frame */
 } *SIG_TBL_eltb_SIG_frame;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_GRAPH_ABS_DES_struct {/* layout for TP_GRAPH_ABS_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *tbl;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *dollar_lock1;
 struct TP_CLASS_struct *gate1;
 struct TP_CLASS_struct *mutex1;
 } *TP_GRAPH_ABS_DES;

typedef struct TP_ITER_struct {/* layout for TP_ITER */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct ARRAYBOOL_struct *hot;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ITER;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPSIGABSTRACT_FRAME_LAY_struct {/* layout for TUP{SIG,ABSTRACT_FRAME_LAYOUT} */
 struct ABSTRACT_FRAME_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGABSTRACT_FRAME_LAY;
static TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY_zero;

typedef struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct {
 OB_HEADER header;
 TUPSIGABSTRACT_FRAME_LAY value_part;
 } *TUPSIGABSTRACT_FRAME_LAY_boxed;

typedef struct AM_ANY_EXPR_struct {/* layout for AM_ANY_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_ANY_EXPR;

typedef struct AM_ARRAY_EXPR_struct {/* layout for AM_ARRAY_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ARRAY_EXPR;


typedef struct AM_ARRAY_EXPR_aeltb_dAM__frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_ARRAY_EXPR_aeltb_dAM__frame;


typedef struct AM_ARRAY_EXPR_aindb_INT_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_aindb_INT_frame;


typedef struct AM_ARRAY_EXPR_asetb_dAM__frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_asetb_dAM__frame;


typedef struct AM_ARRAY_EXPR_eltb_dAM_E_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ARRAY_EXPR L31;
 struct AM_ARRAY_EXPR_aeltb_dAM__frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_eltb_dAM_E_frame;


typedef struct AM_ARRAY_EXPR_indb_INT_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 AM_ARRAY_EXPR L31;
 struct AM_ARRAY_EXPR_aindb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_indb_INT_frame;


typedef struct AM_ARRAY_EXPR_setb_dAM_E_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ARRAY_EXPR L21;
 struct AM_ARRAY_EXPR_asetb_dAM__frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_setb_dAM_E_frame;

typedef struct AM_ARR_CONST_struct {/* layout for AM_ARR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYdAM_CONST_struct *elts;
 struct SFILE_ID_struct source11;
 struct TP_CLASS_struct *elt_tp;
 } *AM_ARR_CONST;

typedef struct AM_ARR_EXPR_struct {/* layout for AM_ARR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_ARR_EXPR;

typedef struct AM_ASSERT_STMT_struct {/* layout for AM_ASSERT_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_ASSERT_STMT;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTACH_STMT_struct {/* layout for AM_ATTACH_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_STMT_struct *next1;
 struct AM_LOCAL_EXPR_struct *gate1;
 struct AM_LOCAL_EXPR_struct *helper;
 struct SFILE_ID_struct source11;
 struct SIG_struct *rout1;
 } *AM_ATTACH_STMT;

typedef struct AM_ATTR_EXPR_struct {/* layout for AM_ATTR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_ATTR_EXPR;

typedef struct AM_AT_EXPR_struct {/* layout for AM_AT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *e11;
 struct SFILE_ID_struct source11;
 } *AM_AT_EXPR;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;


typedef struct AM_BND_CREATE_EXPR_aeltb_frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_BND_CREATE_EXPR_aeltb_frame;


typedef struct AM_BND_CREATE_EXPR_aindb_frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_aindb_frame;


typedef struct AM_BND_CREATE_EXPR_asetb_frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_asetb_frame;


typedef struct AM_BND_CREATE_EXPR_eltb__frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_CREATE_EXPR L31;
 struct AM_BND_CREATE_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_eltb__frame;


typedef struct AM_BND_CREATE_EXPR_indb__frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 AM_BND_CREATE_EXPR L31;
 struct AM_BND_CREATE_EXPR_aindb_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_indb__frame;


typedef struct AM_BND_CREATE_EXPR_setb__frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_CREATE_EXPR L21;
 struct AM_BND_CREATE_EXPR_asetb_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_setb__frame;

typedef struct AM_BND_ITER_CALL_EXPR_struct {/* layout for AM_BND_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *bi;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ITER_CALL_EXPR;


typedef struct AM_BND_ITER_CALL_EXPR_ae_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_BND_ITER_CALL_EXPR_ae_frame;


typedef struct AM_BND_ITER_CALL_EXPR_as2_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ITER_CALL_EXPR_as2_frame;


typedef struct AM_BND_ITER_CALL_EXPR_el_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_ITER_CALL_EXPR L31;
 struct AM_BND_ITER_CALL_EXPR_ae_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ITER_CALL_EXPR_el_frame;


typedef struct AM_BND_ITER_CALL_EXPR_se_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_ITER_CALL_EXPR L21;
 struct AM_BND_ITER_CALL_EXPR_as2_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ITER_CALL_EXPR_se_frame;

typedef struct AM_BND_ROUT_CALL_EXPR_struct {/* layout for AM_BND_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *br;
 struct SFILE_ID_struct source11;
 struct TP_ROUT_struct *br_tp;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ROUT_CALL_EXPR;


typedef struct AM_BND_ROUT_CALL_EXPR_ae_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_BND_ROUT_CALL_EXPR_ae_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_ai_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_ai_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_as2_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_as2_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_el_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_ROUT_CALL_EXPR L31;
 struct AM_BND_ROUT_CALL_EXPR_ae_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_el_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_in_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 AM_BND_ROUT_CALL_EXPR L31;
 struct AM_BND_ROUT_CALL_EXPR_ai_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_in_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_se_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_ROUT_CALL_EXPR L21;
 struct AM_BND_ROUT_CALL_EXPR_as2_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_se_frame;

typedef struct AM_BOOL_CONST_struct {/* layout for AM_BOOL_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 BOOL val11;
 } *AM_BOOL_CONST;

typedef struct AM_BREAK_STMT_struct {/* layout for AM_BREAK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_BREAK_STMT;

typedef struct AM_CASE_STMT_struct {/* layout for AM_CASE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTFLISTdAM_CONST_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_CASE_STMT;

typedef struct AM_CHAR_CONST_struct {/* layout for AM_CHAR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 CHAR bval;
 } *AM_CHAR_CONST;

typedef struct AM_CLUSTER_EXPR_struct {/* layout for AM_CLUSTER_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_CLUSTER_EXPR;

typedef struct AM_CONST_struct {/* layout for AM_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_CONST;

typedef struct AM_EXCEPT_EXPR_struct {/* layout for AM_EXCEPT_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_EXCEPT_EXPR;

typedef struct AM_EXPR_STMT_struct {/* layout for AM_EXPR_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_EXPR_STMT;

typedef struct AM_EXT_CALL_EXPR_struct {/* layout for AM_EXT_CALL_EXPR */
 OB_HEADER header;
 struct IDENT_struct nm1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_EXT_CALL_EXPR;


typedef struct AM_EXT_CALL_EXPR_aeltb_d_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_EXT_CALL_EXPR_aeltb_d_frame;


typedef struct AM_EXT_CALL_EXPR_asetb_d_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_EXT_CALL_EXPR_asetb_d_frame;


typedef struct AM_EXT_CALL_EXPR_eltb_dA_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_EXT_CALL_EXPR L31;
 struct AM_EXT_CALL_EXPR_aeltb_d_frame_struct *nested1; /* nested iter frame */
 } *AM_EXT_CALL_EXPR_eltb_dA_frame;


typedef struct AM_EXT_CALL_EXPR_setb_dA_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_EXT_CALL_EXPR L21;
 struct AM_EXT_CALL_EXPR_asetb_d_frame_struct *nested1; /* nested iter frame */
 } *AM_EXT_CALL_EXPR_setb_dA_frame;

typedef struct AM_FAR_EXPR_struct {/* layout for AM_FAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_FAR_EXPR;

typedef struct AM_FLTDX_CONST_struct {/* layout for AM_FLTDX_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTDX_CONST;

typedef struct AM_FLTD_CONST_struct {/* layout for AM_FLTD_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTD_CONST;

typedef struct AM_FLTI_CONST_struct {/* layout for AM_FLTI_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTI_CONST;

typedef struct AM_FLTX_CONST_struct {/* layout for AM_FLTX_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTX_CONST;

typedef struct AM_FLT_CONST_struct {/* layout for AM_FLT_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLT_CONST;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_HERE_EXPR_struct {/* layout for AM_HERE_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_HERE_EXPR;

typedef struct AM_IF_EXPR_struct {/* layout for AM_IF_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *if_false;
 struct dAM_EXPR_struct *if_true;
 struct dAM_EXPR_struct *test11;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IF_EXPR;

typedef struct AM_IF_STMT_struct {/* layout for AM_IF_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *if_false;
 struct dAM_STMT_struct *if_true;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_IF_STMT;

typedef struct AM_INITIAL_STMT_struct {/* layout for AM_INITIAL_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *stmts;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_INITIAL_STMT;

typedef struct AM_INTI_CONST_struct {/* layout for AM_INTI_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_INTI_CONST;

typedef struct AM_INT_CONST_struct {/* layout for AM_INT_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_INT_CONST;

typedef struct AM_INVARIANT_STMT_struct {/* layout for AM_INVARIANT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 } *AM_INVARIANT_STMT;

typedef struct AM_IS_VOID_EXPR_struct {/* layout for AM_IS_VOID_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IS_VOID_EXPR;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;


typedef struct AM_ITER_CALL_EXPR_aeltb__frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_ITER_CALL_EXPR_aeltb__frame;


typedef struct AM_ITER_CALL_EXPR_aindb__frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_aindb__frame;


typedef struct AM_ITER_CALL_EXPR_asetb__frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_asetb__frame;


typedef struct AM_ITER_CALL_EXPR_eltb_d_frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ITER_CALL_EXPR L31;
 struct AM_ITER_CALL_EXPR_aeltb__frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_eltb_d_frame;


typedef struct AM_ITER_CALL_EXPR_indb_I_frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 INT ret_val;
 AM_ITER_CALL_EXPR L31;
 struct AM_ITER_CALL_EXPR_aindb__frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_indb_I_frame;


typedef struct AM_ITER_CALL_EXPR_setb_d_frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ITER_CALL_EXPR L21;
 struct AM_ITER_CALL_EXPR_asetb__frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_setb_d_frame;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_LOCK_STMT_struct {/* layout for AM_LOCK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_LOCK_STMT;

typedef struct AM_LOOP_STMT_struct {/* layout for AM_LOOP_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct SFILE_ID_struct source11;
 BOOL has_yield;
 } *AM_LOOP_STMT;

typedef struct AM_NEAR_EXPR_struct {/* layout for AM_NEAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_NEAR_EXPR;

typedef struct AM_NEW_EXPR_struct {/* layout for AM_NEW_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *asz1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_NEW_EXPR;

typedef struct AM_OB_DEF_struct {/* layout for AM_OB_DEF */
 OB_HEADER header;
 struct dTP_struct *arr1;
 struct dTP_struct *tp1;
 struct FMAPIDENTdTP_struct *at11;
 INT asize;
 struct SFILE_ID_struct source11;
 } *AM_OB_DEF;

typedef struct AM_POST_STMT_struct {/* layout for AM_POST_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_POST_STMT;

typedef struct AM_PRE_STMT_struct {/* layout for AM_PRE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_PRE_STMT;

typedef struct AM_PROTECT_STMT_struct {/* layout for AM_PROTECT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_PROTECT_STMT;

typedef struct AM_RAISE_STMT_struct {/* layout for AM_RAISE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RAISE_STMT;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;


typedef struct AM_ROUT_CALL_EXPR_aeltb__frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 INT i;
 } *AM_ROUT_CALL_EXPR_aeltb__frame;


typedef struct AM_ROUT_CALL_EXPR_asetb__frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_asetb__frame;


typedef struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ROUT_CALL_EXPR L31;
 struct AM_ROUT_CALL_EXPR_aeltb__frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_eltb_d_frame;


typedef struct AM_ROUT_CALL_EXPR_setb_d_frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ROUT_CALL_EXPR L21;
 struct AM_ROUT_CALL_EXPR_asetb__frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_setb_d_frame;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AM_STMT_EXPR_struct {/* layout for AM_STMT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *stmts;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 struct SFILE_ID_struct source11;
 } *AM_STMT_EXPR;

typedef struct AM_STR_CONST_struct {/* layout for AM_STR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 STR bval;
 } *AM_STR_CONST;

typedef struct AM_TRY_STMT_struct {/* layout for AM_TRY_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *then_part1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_TRY_STMT;

typedef struct AM_TYPECASE_STMT_struct {/* layout for AM_TYPECASE_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *void_stmts;
 struct AM_LOCAL_EXPR_struct *test11;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL has_void_stmts;
 BOOL no_else;
 } *AM_TYPECASE_STMT;

typedef struct AM_UNCAUGHT_STMT_struct {/* layout for AM_UNCAUGHT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNCAUGHT_STMT;

typedef struct AM_UNLOCK_STMT_struct {/* layout for AM_UNLOCK_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *lock1;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNLOCK_STMT;

typedef struct AM_VARR_ASSIGN_EXPR_struct {/* layout for AM_VARR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_VARR_ASSIGN_EXPR;

typedef struct AM_VATTR_ASSIGN_EXPR_struct {/* layout for AM_VATTR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_VATTR_ASSIGN_EXPR;

typedef struct AM_VOID_CONST_struct {/* layout for AM_VOID_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_VOID_CONST;

typedef struct AM_WHERE_EXPR_struct {/* layout for AM_WHERE_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_WHERE_EXPR;

typedef struct AM_WITH_NEAR_STMT_struct {/* layout for AM_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *near_part;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *objects1;
 struct SFILE_ID_struct source11;
 } *AM_WITH_NEAR_STMT;

typedef struct AM_YIELD_STMT_struct {/* layout for AM_YIELD_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 INT ret1;
 struct SFILE_ID_struct source11;
 } *AM_YIELD_STMT;

typedef struct ARRAYINT_struct {/* layout for ARRAY{INT} */
 OB_HEADER header;
 INT asize;
 INT arr_part[1];
 } *ARRAYINT;


typedef struct ARRAYINT_indb_INT_frame_struct {
 ARRAYINT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 ARRAYINT L31;
 struct ARRAYINT_aindb_INT_frame_struct *nested1; /* nested iter frame */
 } *ARRAYINT_indb_INT_frame;

typedef struct AS_CHAR_LIT_EXPR_struct {/* layout for AS_CHAR_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT val11;
 struct SFILE_ID_struct source11;
 } *AS_CHAR_LIT_EXPR;

typedef struct AS_FLT_LIT_EXPR_struct {/* layout for AS_FLT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT tp1;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AS_FLT_LIT_EXPR;

typedef struct AS_INT_LIT_EXPR_struct {/* layout for AS_INT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 BOOL is_inti;
 } *AS_INT_LIT_EXPR;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;

typedef struct FLISTdAM_STMT_struct {/* layout for FLIST{$AM_STMT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_STMT_struct *arr_part[1];
 } *FLISTdAM_STMT;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTdTP_struct {/* layout for FLIST{$TP} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FLISTdTP;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;

typedef struct FLISTFLISTdAM_CONST_struct {/* layout for FLIST{FLIST{$AM_CONST}} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FLISTdAM_CONST_struct *arr_part[1];
 } *FLISTFLISTdAM_CONST;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPSIGABSTRACT_FRAME_LA_struct {/* layout for FMAP{SIG,ABSTRACT_FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGABSTRACT_FRAME_LAY_struct arr_part[1];
 } *FMAPSIGABSTRACT_FRAME_LA;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;

typedef struct FSETABSTRACT_LAYOUT_struct {/* layout for FSET{ABSTRACT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ABSTRACT_LAYOUT_struct *arr_part[1];
 } *FSETABSTRACT_LAYOUT;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern FMAPSIGABSTRACT_FRAME_LA ABSTRACT_FRAME_LAYOUT_la1;
extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSETABSTRACT_LAYOUT ABSTRACT_LAYOUT_layouts;
extern TP_CLASS TP_BUILTIN_bool;
extern TP_CLASS TP_BUILTIN_int;

/* Function declarations */

ABSTRACT_FRAME_LAYOUT ABSTRACT_FRAME_LAYOUT_cr(ABSTRACT_FRAME_LAYOUT, SIG, PROG);
ABSTRACT_FRAME_LAYOUT FMAPSIGABSTRACT_FRAME_LA6(FMAPSIGABSTRACT_FRAME_LA, SIG);
ABSTRACT_LAYOUT ABSTRACT_LAYOUT_create_d(ABSTRACT_LAYOUT, dTP, PROG);
AM_ANY_EXPR AM_ANY_EXPR_create_SFILE(AM_ANY_EXPR, SFILE_ID);
AM_ARRAY_EXPR AM_ARRAY_EXPR_create_INT(AM_ARRAY_EXPR, INT, SFILE_ID);
AM_ARR_EXPR AM_ARR_EXPR_create_SFILE(AM_ARR_EXPR, SFILE_ID);
AM_ASSERT_STMT AM_ASSERT_STMT_create_SF(AM_ASSERT_STMT, SFILE_ID);
AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT, SFILE_ID);
AM_ATTACH_STMT AM_ATTACH_STMT_create_SF(AM_ATTACH_STMT, SFILE_ID);
AM_ATTR_EXPR AM_ATTR_EXPR_create_SFIL(AM_ATTR_EXPR, SFILE_ID);
AM_AT_EXPR AM_AT_EXPR_create_SFILE_(AM_AT_EXPR, SFILE_ID);
AM_BND_CREATE_EXPR AM_BND_CREATE_EXPR_creat(AM_BND_CREATE_EXPR, INT, SFILE_ID);
AM_BND_CREATE_EXPR AM_BND_CREATE_EXPR_creat1(AM_BND_CREATE_EXPR, INT);
AM_BND_ITER_CALL_EXPR AM_BND_ITER_CALL_EXPR_cr(AM_BND_ITER_CALL_EXPR, INT, SFILE_ID);
AM_BND_ROUT_CALL_EXPR AM_BND_ROUT_CALL_EXPR_cr(AM_BND_ROUT_CALL_EXPR, INT, SFILE_ID);
AM_BOOL_CONST AM_BOOL_CONST_create_SFI(AM_BOOL_CONST, SFILE_ID);
AM_BREAK_STMT AM_BREAK_STMT_create_SFI(AM_BREAK_STMT, SFILE_ID);
AM_CASE_STMT AM_CASE_STMT_create_SFIL(AM_CASE_STMT, SFILE_ID);
AM_CHAR_CONST AM_CHAR_CONST_create_AS_(AM_CHAR_CONST, AS_CHAR_LIT_EXPR);
AM_CLUSTER_EXPR AM_CLUSTER_EXPR_create_S(AM_CLUSTER_EXPR, SFILE_ID);
AM_EXCEPT_EXPR AM_EXCEPT_EXPR_create_dT(AM_EXCEPT_EXPR, dTP);
AM_EXPR_STMT AM_EXPR_STMT_create_SFIL(AM_EXPR_STMT, SFILE_ID);
AM_EXT_CALL_EXPR AM_EXT_CALL_EXPR_create_(AM_EXT_CALL_EXPR, INT, SFILE_ID);
AM_EXT_CALL_EXPR AM_EXT_CALL_EXPR_create_1(AM_EXT_CALL_EXPR, INT, SFILE_ID, IDENT);
AM_FAR_EXPR AM_FAR_EXPR_create_SFILE(AM_FAR_EXPR, SFILE_ID);
AM_FLTDX_CONST AM_FLTDX_CONST_create_AS(AM_FLTDX_CONST, AS_FLT_LIT_EXPR);
AM_FLTD_CONST AM_FLTD_CONST_create_AS_(AM_FLTD_CONST, AS_FLT_LIT_EXPR);
AM_FLTI_CONST AM_FLTI_CONST_create_AS_(AM_FLTI_CONST, AS_FLT_LIT_EXPR);
AM_FLTX_CONST AM_FLTX_CONST_create_AS_(AM_FLTX_CONST, AS_FLT_LIT_EXPR);
AM_FLT_CONST AM_FLT_CONST_create_AS_F(AM_FLT_CONST, AS_FLT_LIT_EXPR);
AM_GLOBAL_EXPR AM_GLOBAL_EXPR_create_SF(AM_GLOBAL_EXPR, SFILE_ID);
AM_HERE_EXPR AM_HERE_EXPR_create_SFIL(AM_HERE_EXPR, SFILE_ID);
AM_IF_EXPR AM_IF_EXPR_create_SFILE_(AM_IF_EXPR, SFILE_ID);
AM_IF_STMT AM_IF_STMT_create_SFILE_(AM_IF_STMT, SFILE_ID);
AM_INITIAL_STMT AM_INITIAL_STMT_create_S(AM_INITIAL_STMT, SFILE_ID);
AM_INTI_CONST AM_INTI_CONST_create_AS_(AM_INTI_CONST, AS_INT_LIT_EXPR);
AM_INT_CONST AM_INT_CONST_create_AS_I(AM_INT_CONST, AS_INT_LIT_EXPR);
AM_INT_CONST AM_INT_CONST_create_SFIL(AM_INT_CONST, SFILE_ID);
AM_INVARIANT_STMT AM_INVARIANT_STMT_copy_A(AM_INVARIANT_STMT);
AM_INVARIANT_STMT AM_INVARIANT_STMT_create(AM_INVARIANT_STMT, SFILE_ID);
AM_IS_VOID_EXPR AM_IS_VOID_EXPR_create_S(AM_IS_VOID_EXPR, SFILE_ID);
AM_ITER_CALL_EXPR AM_ITER_CALL_EXPR_create(AM_ITER_CALL_EXPR, INT, SFILE_ID);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI(AM_LOCAL_EXPR, SFILE_ID, IDENT, dTP, AS_TYPE_SPEC);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI1(AM_LOCAL_EXPR, SFILE_ID, IDENT, dTP);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI2(AM_LOCAL_EXPR, SFILE_ID);
AM_LOCAL_EXPR AM_ROUT_DEF_aget_INT_AM_(AM_ROUT_DEF, INT);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aget_(FLISTAM_LOCAL_EXPR, INT);
AM_LOCK_STMT AM_LOCK_STMT_create_SFIL(AM_LOCK_STMT, SFILE_ID);
AM_LOOP_STMT AM_LOOP_STMT_create_SFIL(AM_LOOP_STMT, SFILE_ID);
AM_NEAR_EXPR AM_NEAR_EXPR_create_SFIL(AM_NEAR_EXPR, SFILE_ID);
AM_NEW_EXPR AM_NEW_EXPR_create_SFILE(AM_NEW_EXPR, SFILE_ID);
AM_OB_DEF AM_OB_DEF_create_SFILE_I(AM_OB_DEF, SFILE_ID);
AM_POST_STMT AM_POST_STMT_copy_AM_POS(AM_POST_STMT);
AM_POST_STMT AM_POST_STMT_create_SFIL(AM_POST_STMT, SFILE_ID);
AM_PRE_STMT AM_PRE_STMT_create_SFILE(AM_PRE_STMT, SFILE_ID);
AM_PROTECT_STMT AM_PROTECT_STMT_create_S(AM_PROTECT_STMT, SFILE_ID);
AM_RAISE_STMT AM_RAISE_STMT_create_SFI(AM_RAISE_STMT, SFILE_ID);
AM_RETURN_STMT AM_RETURN_STMT_create_SF(AM_RETURN_STMT, SFILE_ID);
AM_ROUT_CALL_EXPR AM_ROUT_CALL_EXPR_create(AM_ROUT_CALL_EXPR, INT, SFILE_ID);
BOOL AM_ROUT_CALL_EXPR_needs_(AM_ROUT_CALL_EXPR);
BOOL AM_ROUT_CALL_EXPR_needs_1(AM_ROUT_CALL_EXPR);
BOOL FSETdTP_is_empty_BOOL(FSETdTP);
BOOL SIG_is_iter_BOOL(SIG);
FLISTdAM_CONST FLISTFLISTdAM_CONST_aget(FLISTFLISTdAM_CONST, INT);
FLISTdLAYOUT ABSTRACT_FRAME_LAYOUT_de(ABSTRACT_FRAME_LAYOUT);
FLISTdLAYOUT ABSTRACT_LAYOUT_dependen(ABSTRACT_LAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT, dLAYOUT);
FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA16(FMAPSIGABSTRACT_FRAME_LA, SIG, ABSTRACT_FRAME_LAYOUT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_inse(FSETABSTRACT_LAYOUT, ABSTRACT_LAYOUT);
FSETdTP TP_GRAPH_ABS_DES_des_of_(TP_GRAPH_ABS_DES, TP_CLASS);
IFC IFC_TBL_ifc_of_dTP_IFC(IFC_TBL, dTP);
INT AM_ARRAY_EXPR_aindb_INT(AM_ARRAY_EXPR_aindb_INT_frame);
INT AM_ARRAY_EXPR_asize_INT(AM_ARRAY_EXPR);
INT AM_ARRAY_EXPR_indb_INT(AM_ARRAY_EXPR_indb_INT_frame);
INT AM_BND_CREATE_EXPR_aindb(AM_BND_CREATE_EXPR_aindb_frame);
INT AM_BND_CREATE_EXPR_asize(AM_BND_CREATE_EXPR);
INT AM_BND_CREATE_EXPR_indb_(AM_BND_CREATE_EXPR_indb__frame);
INT AM_BND_ITER_CALL_EXPR_as(AM_BND_ITER_CALL_EXPR);
INT AM_BND_ITER_CALL_EXPR_si(AM_BND_ITER_CALL_EXPR);
INT AM_BND_ROUT_CALL_EXPR_ai(AM_BND_ROUT_CALL_EXPR_ai_frame);
INT AM_BND_ROUT_CALL_EXPR_as(AM_BND_ROUT_CALL_EXPR);
INT AM_BND_ROUT_CALL_EXPR_in(AM_BND_ROUT_CALL_EXPR_in_frame);
INT AM_EXT_CALL_EXPR_asize_I(AM_EXT_CALL_EXPR);
INT AM_ITER_CALL_EXPR_aindb_(AM_ITER_CALL_EXPR_aindb__frame);
INT AM_ITER_CALL_EXPR_asize_(AM_ITER_CALL_EXPR);
INT AM_ITER_CALL_EXPR_indb_I(AM_ITER_CALL_EXPR_indb_I_frame);
INT AM_ITER_CALL_EXPR_size_I(AM_ITER_CALL_EXPR);
INT AM_ROUT_CALL_EXPR_asize_(AM_ROUT_CALL_EXPR);
INT AM_ROUT_DEF_size_INT(AM_ROUT_DEF);
INT ARRAYINT_aget_INT_INT(ARRAYINT, INT);
INT ARRAYINT_indb_INT(ARRAYINT_indb_INT_frame);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTFLISTdAM_CONST_size(FLISTFLISTdAM_CONST);
INT FLISTdAM_CONST_size_INT(FLISTdAM_CONST);
INT FLISTdTP_size_INT(FLISTdTP);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_upb_INT(INT_upb_INT_frame);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
SFILE_ID AM_ANY_EXPR_source_SFILE(AM_ANY_EXPR);
SFILE_ID AM_ARRAY_EXPR_source_SFI(AM_ARRAY_EXPR);
SFILE_ID AM_ARR_CONST_source_SFIL(AM_ARR_CONST);
SFILE_ID AM_ARR_EXPR_source_SFILE(AM_ARR_EXPR);
SFILE_ID AM_ASSERT_STMT_source_SF(AM_ASSERT_STMT);
SFILE_ID AM_ASSIGN_STMT_source_SF(AM_ASSIGN_STMT);
SFILE_ID AM_ATTACH_STMT_source_SF(AM_ATTACH_STMT);
SFILE_ID AM_ATTR_EXPR_source_SFIL(AM_ATTR_EXPR);
SFILE_ID AM_AT_EXPR_source_SFILE_(AM_AT_EXPR);
SFILE_ID AM_BND_CREATE_EXPR_sourc(AM_BND_CREATE_EXPR);
SFILE_ID AM_BND_ITER_CALL_EXPR_so(AM_BND_ITER_CALL_EXPR);
SFILE_ID AM_BND_ROUT_CALL_EXPR_so(AM_BND_ROUT_CALL_EXPR);
SFILE_ID AM_BOOL_CONST_source_SFI(AM_BOOL_CONST);
SFILE_ID AM_BREAK_STMT_source_SFI(AM_BREAK_STMT);
SFILE_ID AM_CASE_STMT_source_SFIL(AM_CASE_STMT);
SFILE_ID AM_CHAR_CONST_source_SFI(AM_CHAR_CONST);
SFILE_ID AM_CLUSTER_EXPR_source_S(AM_CLUSTER_EXPR);
SFILE_ID AM_CONST_source_SFILE_ID(AM_CONST);
SFILE_ID AM_EXCEPT_EXPR_source_SF(AM_EXCEPT_EXPR);
SFILE_ID AM_EXPR_STMT_source_SFIL(AM_EXPR_STMT);
SFILE_ID AM_EXT_CALL_EXPR_source_(AM_EXT_CALL_EXPR);
SFILE_ID AM_FAR_EXPR_source_SFILE(AM_FAR_EXPR);
SFILE_ID AM_FLTDX_CONST_source_SF(AM_FLTDX_CONST);
SFILE_ID AM_FLTD_CONST_source_SFI(AM_FLTD_CONST);
SFILE_ID AM_FLTI_CONST_source_SFI(AM_FLTI_CONST);
SFILE_ID AM_FLTX_CONST_source_SFI(AM_FLTX_CONST);
SFILE_ID AM_FLT_CONST_source_SFIL(AM_FLT_CONST);
SFILE_ID AM_GLOBAL_EXPR_source_SF(AM_GLOBAL_EXPR);
SFILE_ID AM_HERE_EXPR_source_SFIL(AM_HERE_EXPR);
SFILE_ID AM_IF_EXPR_source_SFILE_(AM_IF_EXPR);
SFILE_ID AM_IF_STMT_source_SFILE_(AM_IF_STMT);
SFILE_ID AM_INITIAL_STMT_source_S(AM_INITIAL_STMT);
SFILE_ID AM_INTI_CONST_source_SFI(AM_INTI_CONST);
SFILE_ID AM_INT_CONST_source_SFIL(AM_INT_CONST);
SFILE_ID AM_INVARIANT_STMT_source(AM_INVARIANT_STMT);
SFILE_ID AM_IS_VOID_EXPR_source_S(AM_IS_VOID_EXPR);
SFILE_ID AM_ITER_CALL_EXPR_source(AM_ITER_CALL_EXPR);
SFILE_ID AM_LOCAL_EXPR_source_SFI(AM_LOCAL_EXPR);
SFILE_ID AM_LOCK_STMT_source_SFIL(AM_LOCK_STMT);
SFILE_ID AM_LOOP_STMT_source_SFIL(AM_LOOP_STMT);
SFILE_ID AM_NEAR_EXPR_source_SFIL(AM_NEAR_EXPR);
SFILE_ID AM_NEW_EXPR_source_SFILE(AM_NEW_EXPR);
SFILE_ID AM_OB_DEF_source_SFILE_I(AM_OB_DEF);
SFILE_ID AM_POST_STMT_source_SFIL(AM_POST_STMT);
SFILE_ID AM_PRE_STMT_source_SFILE(AM_PRE_STMT);
SFILE_ID AM_PROTECT_STMT_source_S(AM_PROTECT_STMT);
SFILE_ID AM_RAISE_STMT_source_SFI(AM_RAISE_STMT);
SFILE_ID AM_RETURN_STMT_source_SF(AM_RETURN_STMT);
SFILE_ID AM_ROUT_CALL_EXPR_source(AM_ROUT_CALL_EXPR);
SIG SIG_TBL_eltb_SIG(SIG_TBL_eltb_SIG_frame);
STR ABSTRACT_FRAME_LAYOUT_st(ABSTRACT_FRAME_LAYOUT);
STR ABSTRACT_FRAME_LAYOUT_ty(ABSTRACT_FRAME_LAYOUT, CGEN);
STR ABSTRACT_LAYOUT_makestr_(ABSTRACT_LAYOUT);
STR ABSTRACT_LAYOUT_str_STR(ABSTRACT_LAYOUT);
STR ABSTRACT_LAYOUT_typedef_(ABSTRACT_LAYOUT, CGEN);
STR INTI_str_STR(INTI);
STR MANGLE_mangle_dOB_dOB_ST(MANGLE, OB, OB);
STR RAT_str_STR(RAT);
STR STR_plus_dSTR_STR(STR, dSTR);
STR TP_CLASS_str_STR(TP_CLASS);
dAM_CONST ARRAYdAM_CONST_eltb_dAM_(ARRAYdAM_CONST_eltb_dAM__frame);
dAM_CONST FLISTdAM_CONST_aget_INT_(FLISTdAM_CONST, INT);
dAM_EXPR AM_ARRAY_EXPR_aeltb_dAM_(AM_ARRAY_EXPR_aeltb_dAM__frame);
dAM_EXPR AM_ARRAY_EXPR_aget_INT_d(AM_ARRAY_EXPR, INT);
dAM_EXPR AM_ARRAY_EXPR_eltb_dAM_E(AM_ARRAY_EXPR_eltb_dAM_E_frame);
dAM_EXPR AM_BND_CREATE_EXPR_aeltb(AM_BND_CREATE_EXPR_aeltb_frame);
dAM_EXPR AM_BND_CREATE_EXPR_aget_(AM_BND_CREATE_EXPR, INT);
dAM_EXPR AM_BND_CREATE_EXPR_eltb_(AM_BND_CREATE_EXPR_eltb__frame);
dAM_EXPR AM_BND_ITER_CALL_EXPR_ae(AM_BND_ITER_CALL_EXPR_ae_frame);
dAM_EXPR AM_BND_ITER_CALL_EXPR_ag(AM_BND_ITER_CALL_EXPR, INT);
dAM_EXPR AM_BND_ITER_CALL_EXPR_el(AM_BND_ITER_CALL_EXPR_el_frame);
dAM_EXPR AM_BND_ROUT_CALL_EXPR_ae(AM_BND_ROUT_CALL_EXPR_ae_frame);
dAM_EXPR AM_BND_ROUT_CALL_EXPR_ag(AM_BND_ROUT_CALL_EXPR, INT);
dAM_EXPR AM_BND_ROUT_CALL_EXPR_el(AM_BND_ROUT_CALL_EXPR_el_frame);
dAM_EXPR AM_EXT_CALL_EXPR_aeltb_d(AM_EXT_CALL_EXPR_aeltb_d_frame);
dAM_EXPR AM_EXT_CALL_EXPR_aget_IN(AM_EXT_CALL_EXPR, INT);
dAM_EXPR AM_EXT_CALL_EXPR_eltb_dA(AM_EXT_CALL_EXPR_eltb_dA_frame);
dAM_EXPR AM_ITER_CALL_EXPR_aeltb_(AM_ITER_CALL_EXPR_aeltb__frame);
dAM_EXPR AM_ITER_CALL_EXPR_aget_I(AM_ITER_CALL_EXPR, INT);
dAM_EXPR AM_ITER_CALL_EXPR_eltb_d(AM_ITER_CALL_EXPR_eltb_d_frame);
dAM_EXPR AM_ROUT_CALL_EXPR_aeltb_(AM_ROUT_CALL_EXPR_aeltb__frame);
dAM_EXPR AM_ROUT_CALL_EXPR_aget_I(AM_ROUT_CALL_EXPR, INT);
dAM_EXPR AM_ROUT_CALL_EXPR_eltb_d(AM_ROUT_CALL_EXPR_eltb_d_frame);
dAM_STMT AM_ASSERT_STMT_next_dAM_(AM_ASSERT_STMT);
dAM_STMT AM_ASSIGN_STMT_next_dAM_(AM_ASSIGN_STMT);
dAM_STMT AM_ATTACH_STMT_next_dAM_(AM_ATTACH_STMT);
dAM_STMT AM_BREAK_STMT_next_dAM_S(AM_BREAK_STMT);
dAM_STMT AM_CASE_STMT_next_dAM_ST(AM_CASE_STMT);
dAM_STMT AM_EXPR_STMT_next_dAM_ST(AM_EXPR_STMT);
dAM_STMT AM_IF_STMT_next_dAM_STMT(AM_IF_STMT);
dAM_STMT AM_INITIAL_STMT_next_dAM(AM_INITIAL_STMT);
dAM_STMT AM_INVARIANT_STMT_next_d(AM_INVARIANT_STMT);
dAM_STMT AM_LOCK_STMT_next_dAM_ST(AM_LOCK_STMT);
dAM_STMT AM_LOOP_STMT_next_dAM_ST(AM_LOOP_STMT);
dAM_STMT AM_POST_STMT_next_dAM_ST(AM_POST_STMT);
dAM_STMT AM_PRE_STMT_next_dAM_STM(AM_PRE_STMT);
dAM_STMT AM_PROTECT_STMT_next_dAM(AM_PROTECT_STMT);
dAM_STMT AM_RAISE_STMT_next_dAM_S(AM_RAISE_STMT);
dAM_STMT AM_RETURN_STMT_next_dAM_(AM_RETURN_STMT);
dAM_STMT FLISTdAM_STMT_aget_INT_d(FLISTdAM_STMT, INT);
dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT, dTP);
dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL, dTP);
dTP AM_ANY_EXPR_tp_dTP(AM_ANY_EXPR);
dTP AM_ARRAY_EXPR_tp_dTP(AM_ARRAY_EXPR);
dTP AM_ARR_CONST_tp_dTP(AM_ARR_CONST);
dTP AM_ARR_EXPR_tp_dTP(AM_ARR_EXPR);
dTP AM_ATTR_EXPR_tp_dTP(AM_ATTR_EXPR);
dTP AM_AT_EXPR_tp_dTP(AM_AT_EXPR);
dTP AM_BND_CREATE_EXPR_tp_dT(AM_BND_CREATE_EXPR);
dTP AM_BND_ITER_CALL_EXPR_tp(AM_BND_ITER_CALL_EXPR);
dTP AM_BND_ROUT_CALL_EXPR_tp(AM_BND_ROUT_CALL_EXPR);
dTP AM_BOOL_CONST_tp_dTP(AM_BOOL_CONST);
dTP AM_CHAR_CONST_tp_dTP(AM_CHAR_CONST);
dTP AM_CLUSTER_EXPR_tp_dTP(AM_CLUSTER_EXPR);
dTP AM_CONST_tp_dTP(AM_CONST);
dTP AM_EXCEPT_EXPR_tp_dTP(AM_EXCEPT_EXPR);
dTP AM_EXT_CALL_EXPR_tp_dTP(AM_EXT_CALL_EXPR);
dTP AM_FAR_EXPR_tp_dTP(AM_FAR_EXPR);
dTP AM_FLTDX_CONST_tp_dTP(AM_FLTDX_CONST);
dTP AM_FLTD_CONST_tp_dTP(AM_FLTD_CONST);
dTP AM_FLTI_CONST_tp_dTP(AM_FLTI_CONST);
dTP AM_FLTX_CONST_tp_dTP(AM_FLTX_CONST);
dTP AM_FLT_CONST_tp_dTP(AM_FLT_CONST);
dTP AM_GLOBAL_EXPR_tp_dTP(AM_GLOBAL_EXPR);
dTP AM_HERE_EXPR_tp_dTP(AM_HERE_EXPR);
dTP AM_IF_EXPR_tp_dTP(AM_IF_EXPR);
dTP AM_INTI_CONST_tp_dTP(AM_INTI_CONST);
dTP AM_INT_CONST_tp_dTP(AM_INT_CONST);
dTP AM_IS_VOID_EXPR_tp_dTP(AM_IS_VOID_EXPR);
dTP AM_ITER_CALL_EXPR_tp_dTP(AM_ITER_CALL_EXPR);
dTP AM_LOCAL_EXPR_tp_dTP(AM_LOCAL_EXPR);
dTP AM_NEAR_EXPR_tp_dTP(AM_NEAR_EXPR);
dTP AM_NEW_EXPR_tp_dTP(AM_NEW_EXPR);
dTP AM_ROUT_CALL_EXPR_tp_dTP(AM_ROUT_CALL_EXPR);
dTP ARRAYdTP_eltb_dTP(ARRAYdTP_eltb_dTP_frame);
dTP FLISTdTP_aget_INT_dTP(FLISTdTP, INT);
extern const int dAM_EXPR_tp_dTP_offset;

extern const dTP (*dAM_EXPR_tp_dTP[])(dAM_EXPR);
extern const int dAM_STMT_next_dAM_STMT1_offset;

extern const  (*dAM_STMT_next_dAM_STMT1[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT_offset;

extern const dAM_STMT (*dAM_STMT_next_dAM_STMT[])(dAM_STMT);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void ABSTRACT_FRAME_LAYOUT_la(ABSTRACT_FRAME_LAYOUT, FMAPSIGABSTRACT_FRAME_LA);
void ABSTRACT_LAYOUT_layouts_(ABSTRACT_LAYOUT, FSETABSTRACT_LAYOUT);
void AM_ARRAY_EXPR_aset_INT_d(AM_ARRAY_EXPR, INT, dAM_EXPR);
void AM_ARRAY_EXPR_asetb_dAM_(AM_ARRAY_EXPR_asetb_dAM__frame);
void AM_ARRAY_EXPR_setb_dAM_E(AM_ARRAY_EXPR_setb_dAM_E_frame);
void AM_ASSERT_STMT_append_dA(AM_ASSERT_STMT, dAM_STMT);
void AM_ASSERT_STMT_next_dAM_1(AM_ASSERT_STMT, dAM_STMT);
void AM_ASSIGN_STMT_append_dA(AM_ASSIGN_STMT, dAM_STMT);
void AM_ASSIGN_STMT_next_dAM_1(AM_ASSIGN_STMT, dAM_STMT);
void AM_ATTACH_STMT_append_dA(AM_ATTACH_STMT, dAM_STMT);
void AM_ATTACH_STMT_next_dAM_1(AM_ATTACH_STMT, dAM_STMT);
void AM_BND_CREATE_EXPR_aset_(AM_BND_CREATE_EXPR, INT, dAM_EXPR);
void AM_BND_CREATE_EXPR_asetb(AM_BND_CREATE_EXPR_asetb_frame);
void AM_BND_CREATE_EXPR_setb_(AM_BND_CREATE_EXPR_setb__frame);
void AM_BND_ITER_CALL_EXPR_as1(AM_BND_ITER_CALL_EXPR, INT, dAM_EXPR);
void AM_BND_ITER_CALL_EXPR_as2(AM_BND_ITER_CALL_EXPR_as2_frame);
void AM_BND_ITER_CALL_EXPR_se(AM_BND_ITER_CALL_EXPR_se_frame);
void AM_BND_ROUT_CALL_EXPR_as1(AM_BND_ROUT_CALL_EXPR, INT, dAM_EXPR);
void AM_BND_ROUT_CALL_EXPR_as2(AM_BND_ROUT_CALL_EXPR_as2_frame);
void AM_BND_ROUT_CALL_EXPR_se(AM_BND_ROUT_CALL_EXPR_se_frame);
void AM_BREAK_STMT_append_dAM(AM_BREAK_STMT, dAM_STMT);
void AM_BREAK_STMT_next_dAM_S1(AM_BREAK_STMT, dAM_STMT);
void AM_CASE_STMT_append_dAM_(AM_CASE_STMT, dAM_STMT);
void AM_CASE_STMT_next_dAM_ST1(AM_CASE_STMT, dAM_STMT);
void AM_EXPR_STMT_append_dAM_(AM_EXPR_STMT, dAM_STMT);
void AM_EXPR_STMT_next_dAM_ST1(AM_EXPR_STMT, dAM_STMT);
void AM_EXT_CALL_EXPR_aset_IN(AM_EXT_CALL_EXPR, INT, dAM_EXPR);
void AM_EXT_CALL_EXPR_asetb_d(AM_EXT_CALL_EXPR_asetb_d_frame);
void AM_EXT_CALL_EXPR_setb_dA(AM_EXT_CALL_EXPR_setb_dA_frame);
void AM_IF_STMT_append_dAM_ST(AM_IF_STMT, dAM_STMT);
void AM_IF_STMT_next_dAM_STMT1(AM_IF_STMT, dAM_STMT);
void AM_INITIAL_STMT_append_d(AM_INITIAL_STMT, dAM_STMT);
void AM_INITIAL_STMT_next_dAM1(AM_INITIAL_STMT, dAM_STMT);
void AM_INVARIANT_STMT_append(AM_INVARIANT_STMT, dAM_STMT);
void AM_INVARIANT_STMT_next_d1(AM_INVARIANT_STMT, dAM_STMT);
void AM_ITER_CALL_EXPR_aset_I(AM_ITER_CALL_EXPR, INT, dAM_EXPR);
void AM_ITER_CALL_EXPR_asetb_(AM_ITER_CALL_EXPR_asetb__frame);
void AM_ITER_CALL_EXPR_setb_d(AM_ITER_CALL_EXPR_setb_d_frame);
void AM_LOCK_STMT_append_dAM_(AM_LOCK_STMT, dAM_STMT);
void AM_LOCK_STMT_next_dAM_ST1(AM_LOCK_STMT, dAM_STMT);
void AM_LOOP_STMT_append_dAM_(AM_LOOP_STMT, dAM_STMT);
void AM_LOOP_STMT_next_dAM_ST1(AM_LOOP_STMT, dAM_STMT);
void AM_OUT_AM_ANY_EXPR_out_A(AM_OUT, AM_ANY_EXPR);
void AM_OUT_AM_ARRAY_EXPR_out(AM_OUT, AM_ARRAY_EXPR);
void AM_OUT_AM_ARR_CONST_out_(AM_OUT, AM_ARR_CONST);
void AM_OUT_AM_ARR_EXPR_out_A(AM_OUT, AM_ARR_EXPR);
void AM_OUT_AM_ASSERT_STMT_ou(AM_OUT, AM_ASSERT_STMT);
void AM_OUT_AM_ASSIGN_STMT_ou(AM_OUT, AM_ASSIGN_STMT);
void AM_OUT_AM_ATTACH_STMT_ou(AM_OUT, AM_ATTACH_STMT);
void AM_OUT_AM_ATTR_EXPR_out_(AM_OUT, AM_ATTR_EXPR);
void AM_OUT_AM_AT_EXPR_out_AM(AM_OUT, AM_AT_EXPR);
void AM_OUT_AM_BND_CREATE_EXP(AM_OUT, AM_BND_CREATE_EXPR);
void AM_OUT_AM_BND_ITER_CALL_(AM_OUT, AM_BND_ITER_CALL_EXPR);
void AM_OUT_AM_BND_ROUT_CALL_(AM_OUT, AM_BND_ROUT_CALL_EXPR);
void AM_OUT_AM_BOOL_CONST_out(AM_OUT, AM_BOOL_CONST);
void AM_OUT_AM_BREAK_STMT_out(AM_OUT, AM_BREAK_STMT);
void AM_OUT_AM_CASE_STMT_out_(AM_OUT, AM_CASE_STMT);
void AM_OUT_AM_CHAR_CONST_out(AM_OUT, AM_CHAR_CONST);
void AM_OUT_AM_CLUSTER_EXPR_o(AM_OUT, AM_CLUSTER_EXPR);
void AM_OUT_AM_CONST_out_dAM_(AM_OUT, dAM_CONST);
void AM_OUT_AM_EXCEPT_EXPR_ou(AM_OUT, AM_EXCEPT_EXPR);
void AM_OUT_AM_EXPR_STMT_out_(AM_OUT, AM_EXPR_STMT);
void AM_OUT_AM_EXPR_out_dAM_E(AM_OUT, dAM_EXPR);
void AM_OUT_AM_EXT_CALL_EXPR_(AM_OUT, AM_EXT_CALL_EXPR);
void AM_OUT_AM_FAR_EXPR_out_A(AM_OUT, AM_FAR_EXPR);
void AM_OUT_AM_FLTDX_CONST_ou(AM_OUT, AM_FLTDX_CONST);
void AM_OUT_AM_FLTD_CONST_out(AM_OUT, AM_FLTD_CONST);
void AM_OUT_AM_FLTI_CONST_out(AM_OUT, AM_FLTI_CONST);
void AM_OUT_AM_FLTX_CONST_out(AM_OUT, AM_FLTX_CONST);
void AM_OUT_AM_FLT_CONST_out_(AM_OUT, AM_FLT_CONST);
void AM_OUT_AM_GLOBAL_EXPR_ou(AM_OUT, AM_GLOBAL_EXPR);
void AM_OUT_AM_HERE_EXPR_out_(AM_OUT, AM_HERE_EXPR);
void AM_OUT_AM_IF_EXPR_out_AM(AM_OUT, AM_IF_EXPR);
void AM_OUT_AM_IF_STMT_out_AM(AM_OUT, AM_IF_STMT);
void AM_OUT_AM_INITIAL_STMT_o(AM_OUT, AM_INITIAL_STMT);
void AM_OUT_AM_INTI_CONST_out(AM_OUT, AM_INTI_CONST);
void AM_OUT_AM_INT_CONST_out_(AM_OUT, AM_INT_CONST);
void AM_OUT_AM_INVARIANT_STMT(AM_OUT, AM_INVARIANT_STMT);
void AM_OUT_AM_IS_VOID_EXPR_o(AM_OUT, AM_IS_VOID_EXPR);
void AM_OUT_AM_ITER_CALL_EXPR(AM_OUT, AM_ITER_CALL_EXPR);
void AM_OUT_AM_LOCAL_EXPR_out(AM_OUT, AM_LOCAL_EXPR);
void AM_OUT_AM_LOCK_STMT_out_(AM_OUT, AM_LOCK_STMT);
void AM_OUT_AM_LOOP_STMT_out_(AM_OUT, AM_LOOP_STMT);
void AM_OUT_AM_NEAR_EXPR_out_(AM_OUT, AM_NEAR_EXPR);
void AM_OUT_AM_NEW_EXPR_out_A(AM_OUT, AM_NEW_EXPR);
void AM_OUT_AM_POST_STMT_out_(AM_OUT, AM_POST_STMT);
void AM_OUT_AM_PRE_STMT_out_A(AM_OUT, AM_PRE_STMT);
void AM_OUT_AM_PROTECT_STMT_o(AM_OUT, AM_PROTECT_STMT);
void AM_OUT_AM_RAISE_STMT_out(AM_OUT, AM_RAISE_STMT);
void AM_OUT_AM_RETURN_STMT_ou(AM_OUT, AM_RETURN_STMT);
void AM_OUT_AM_ROUT_CALL_EXPR(AM_OUT, AM_ROUT_CALL_EXPR);
void AM_OUT_AM_ROUT_DEF_out_A(AM_OUT, AM_ROUT_DEF);
void AM_OUT_AM_STMT_EXPR_out_(AM_OUT, AM_STMT_EXPR);
void AM_OUT_AM_STMT_out_dAM_S(AM_OUT, dAM_STMT);
void AM_OUT_AM_STR_CONST_out_(AM_OUT, AM_STR_CONST);
void AM_OUT_AM_TRY_STMT_out_A(AM_OUT, AM_TRY_STMT);
void AM_OUT_AM_TYPECASE_STMT_(AM_OUT, AM_TYPECASE_STMT);
void AM_OUT_AM_UNCAUGHT_STMT_(AM_OUT, AM_UNCAUGHT_STMT);
void AM_OUT_AM_UNLOCK_STMT_ou(AM_OUT, AM_UNLOCK_STMT);
void AM_OUT_AM_VARR_ASSIGN_EX(AM_OUT, AM_VARR_ASSIGN_EXPR);
void AM_OUT_AM_VATTR_ASSIGN_E(AM_OUT, AM_VATTR_ASSIGN_EXPR);
void AM_OUT_AM_VOID_CONST_out(AM_OUT, AM_VOID_CONST);
void AM_OUT_AM_WHERE_EXPR_out(AM_OUT, AM_WHERE_EXPR);
void AM_OUT_AM_WITH_NEAR_STMT(AM_OUT, AM_WITH_NEAR_STMT);
void AM_OUT_AM_YIELD_STMT_out(AM_OUT, AM_YIELD_STMT);
void AM_POST_STMT_append_dAM_(AM_POST_STMT, dAM_STMT);
void AM_POST_STMT_next_dAM_ST1(AM_POST_STMT, dAM_STMT);
void AM_PRE_STMT_append_dAM_S(AM_PRE_STMT, dAM_STMT);
void AM_PRE_STMT_next_dAM_STM1(AM_PRE_STMT, dAM_STMT);
void AM_PROTECT_STMT_append_d(AM_PROTECT_STMT, dAM_STMT);
void AM_PROTECT_STMT_next_dAM1(AM_PROTECT_STMT, dAM_STMT);
void AM_RAISE_STMT_append_dAM(AM_RAISE_STMT, dAM_STMT);
void AM_RAISE_STMT_next_dAM_S1(AM_RAISE_STMT, dAM_STMT);
void AM_RETURN_STMT_append_dA(AM_RETURN_STMT, dAM_STMT);
void AM_RETURN_STMT_next_dAM_1(AM_RETURN_STMT, dAM_STMT);
void AM_ROUT_CALL_EXPR_aset_I(AM_ROUT_CALL_EXPR, INT, dAM_EXPR);
void AM_ROUT_CALL_EXPR_asetb_(AM_ROUT_CALL_EXPR_asetb__frame);
void AM_ROUT_CALL_EXPR_setb_d(AM_ROUT_CALL_EXPR_setb_d_frame);
void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL, FMAPdTPdLAYOUT);
void MANGLE_forbid_STR(MANGLE, STR);
void OUT_plus_dSTR(OUT, dSTR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




ABSTRACT_FRAME_LAYOUT ABSTRACT_FRAME_LAYOUT_cr(ABSTRACT_FRAME_LAYOUT self, SIG sig1, PROG p) {
 ABSTRACT_FRAME_LAYOUT ret_val;
 ABSTRACT_FRAME_LAYOUT res;
 ABSTRACT_FRAME_LAYOUT L1;
 extern STR abstractframe;
 res = FMAPSIGABSTRACT_FRAME_LA6(ABSTRACT_FRAME_LAYOUT_la1, sig1);
 if ((res==((ABSTRACT_FRAME_LAYOUT) NULL))) {
  L1 = ((ABSTRACT_FRAME_LAYOUT) rt_alloc(sizeof(struct ABSTRACT_FRAME_LAYOUT_struct), ABSTRACT_FRAME_LAYOUT_tag));
  res = L1;
  SATTR(res,sig11,sig1);
  SATTR(res,prog1,p);
  SATTR(res,str1,STR_plus_dSTR_STR(ATTR(ATTR(res,sig11),str), ((dSTR) ((STR) &abstractframe))));
  ABSTRACT_FRAME_LAYOUT_la(self, FMAPSIGABSTRACT_FRAME_LA16(ABSTRACT_FRAME_LAYOUT_la1, sig1, res));
 }
 ret_val = res;
 return ret_val;
}


ABSTRACT_LAYOUT ABSTRACT_LAYOUT_create_d(ABSTRACT_LAYOUT self, dTP tp, PROG p) {
 ABSTRACT_LAYOUT ret_val;
 dLAYOUT r;
 ABSTRACT_LAYOUT res = ((ABSTRACT_LAYOUT) NULL);
 BOOL L1;
 ABSTRACT_LAYOUT L2;
 r = FMAPdTPdLAYOUT_get_dTP_d(LAYOUT_TBL_layout_tbl, tp);
 L1 = (r==((dLAYOUT) NULL));
 if ((!(L1))) {
  if (r==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(r)) {
   case ABSTRACT_LAYOUT_tag:
    res = ((ABSTRACT_LAYOUT) r); break;
   default: ;
    FATAL("No applicable type in typecase");
  }
 }
 else {
  L2 = ((ABSTRACT_LAYOUT) rt_alloc(sizeof(struct ABSTRACT_LAYOUT_struct), ABSTRACT_LAYOUT_tag));
  res = L2;
  SATTR(res,tp1,tp);
  SATTR(res,prog1,p);
  SATTR(res,str1,ABSTRACT_LAYOUT_makestr_(res));
  ABSTRACT_LAYOUT_layouts_(self, FSETABSTRACT_LAYOUT_inse(ABSTRACT_LAYOUT_layouts, res));
  LAYOUT_TBL_layout_tbl_FM(((LAYOUT_TBL) NULL), FMAPdTPdLAYOUT_insert_dT(LAYOUT_TBL_layout_tbl, tp, ((dLAYOUT) res)));
 }
 ret_val = res;
 return ret_val;
}


AM_ANY_EXPR AM_ANY_EXPR_create_SFILE(AM_ANY_EXPR self, SFILE_ID src1) {
 AM_ANY_EXPR ret_val;
 AM_ANY_EXPR r;
 AM_ANY_EXPR L1;
 L1 = ((AM_ANY_EXPR) rt_alloc_atomic(sizeof(struct AM_ANY_EXPR_struct), AM_ANY_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_ARRAY_EXPR AM_ARRAY_EXPR_create_INT(AM_ARRAY_EXPR self, INT nargs, SFILE_ID source1) {
 AM_ARRAY_EXPR ret_val;
 AM_ARRAY_EXPR r;
 AM_ARRAY_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_ARRAY_EXPR) rt_arr_alloc(sizeof(struct AM_ARRAY_EXPR_struct), AM_ARRAY_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ARR_EXPR AM_ARR_EXPR_create_SFILE(AM_ARR_EXPR self, SFILE_ID source1) {
 AM_ARR_EXPR ret_val;
 AM_ARR_EXPR r;
 AM_ARR_EXPR L1;
 L1 = ((AM_ARR_EXPR) rt_alloc(sizeof(struct AM_ARR_EXPR_struct), AM_ARR_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ASSERT_STMT AM_ASSERT_STMT_create_SF(AM_ASSERT_STMT self, SFILE_ID source1) {
 AM_ASSERT_STMT ret_val;
 AM_ASSERT_STMT r;
 AM_ASSERT_STMT L1;
 L1 = ((AM_ASSERT_STMT) rt_alloc(sizeof(struct AM_ASSERT_STMT_struct), AM_ASSERT_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ATTACH_STMT AM_ATTACH_STMT_create_SF(AM_ATTACH_STMT self, SFILE_ID source1) {
 AM_ATTACH_STMT ret_val;
 AM_ATTACH_STMT r;
 AM_ATTACH_STMT L1;
 L1 = ((AM_ATTACH_STMT) rt_alloc(sizeof(struct AM_ATTACH_STMT_struct), AM_ATTACH_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ATTR_EXPR AM_ATTR_EXPR_create_SFIL(AM_ATTR_EXPR self, SFILE_ID source1) {
 AM_ATTR_EXPR ret_val;
 AM_ATTR_EXPR r;
 AM_ATTR_EXPR L1;
 L1 = ((AM_ATTR_EXPR) rt_alloc(sizeof(struct AM_ATTR_EXPR_struct), AM_ATTR_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_AT_EXPR AM_AT_EXPR_create_SFILE_(AM_AT_EXPR self, SFILE_ID src1) {
 AM_AT_EXPR ret_val;
 AM_AT_EXPR r;
 AM_AT_EXPR L1;
 L1 = ((AM_AT_EXPR) rt_alloc(sizeof(struct AM_AT_EXPR_struct), AM_AT_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_BND_CREATE_EXPR AM_BND_CREATE_EXPR_creat(AM_BND_CREATE_EXPR self, INT nargs, SFILE_ID source1) {
 AM_BND_CREATE_EXPR ret_val;
 AM_BND_CREATE_EXPR r;
 AM_BND_CREATE_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_BND_CREATE_EXPR) rt_arr_alloc(sizeof(struct AM_BND_CREATE_EXPR_struct), AM_BND_CREATE_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_BND_CREATE_EXPR AM_BND_CREATE_EXPR_creat1(AM_BND_CREATE_EXPR self, INT n) {
 AM_BND_CREATE_EXPR ret_val;
 AM_BND_CREATE_EXPR L1;
 INT L2;
 L2 = n;
 L1 = ((AM_BND_CREATE_EXPR) rt_arr_alloc(sizeof(struct AM_BND_CREATE_EXPR_struct), AM_BND_CREATE_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 ret_val = L1;
 return ret_val;
}


AM_BND_ITER_CALL_EXPR AM_BND_ITER_CALL_EXPR_cr(AM_BND_ITER_CALL_EXPR self, INT nargs, SFILE_ID source1) {
 AM_BND_ITER_CALL_EXPR ret_val;
 AM_BND_ITER_CALL_EXPR r;
 AM_BND_ITER_CALL_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_BND_ITER_CALL_EXPR) rt_arr_alloc(sizeof(struct AM_BND_ITER_CALL_EXPR_struct), AM_BND_ITER_CALL_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_BND_ROUT_CALL_EXPR AM_BND_ROUT_CALL_EXPR_cr(AM_BND_ROUT_CALL_EXPR self, INT nargs, SFILE_ID source1) {
 AM_BND_ROUT_CALL_EXPR ret_val;
 AM_BND_ROUT_CALL_EXPR r;
 AM_BND_ROUT_CALL_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_BND_ROUT_CALL_EXPR) rt_arr_alloc(sizeof(struct AM_BND_ROUT_CALL_EXPR_struct), AM_BND_ROUT_CALL_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_BOOL_CONST AM_BOOL_CONST_create_SFI(AM_BOOL_CONST self, SFILE_ID src1) {
 AM_BOOL_CONST ret_val;
 AM_BOOL_CONST r;
 AM_BOOL_CONST L1;
 L1 = ((AM_BOOL_CONST) rt_alloc(sizeof(struct AM_BOOL_CONST_struct), AM_BOOL_CONST_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_BREAK_STMT AM_BREAK_STMT_create_SFI(AM_BREAK_STMT self, SFILE_ID source1) {
 AM_BREAK_STMT ret_val;
 AM_BREAK_STMT r;
 AM_BREAK_STMT L1;
 L1 = ((AM_BREAK_STMT) rt_alloc(sizeof(struct AM_BREAK_STMT_struct), AM_BREAK_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_CASE_STMT AM_CASE_STMT_create_SFIL(AM_CASE_STMT self, SFILE_ID source1) {
 AM_CASE_STMT ret_val;
 AM_CASE_STMT r;
 AM_CASE_STMT L1;
 L1 = ((AM_CASE_STMT) rt_alloc(sizeof(struct AM_CASE_STMT_struct), AM_CASE_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_CHAR_CONST AM_CHAR_CONST_create_AS_(AM_CHAR_CONST self, AS_CHAR_LIT_EXPR t) {
 AM_CHAR_CONST ret_val;
 AM_CHAR_CONST r;
 AM_CHAR_CONST L1;
 INT L2;
 L1 = ((AM_CHAR_CONST) rt_alloc(sizeof(struct AM_CHAR_CONST_struct), AM_CHAR_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 L2 = ATTR(t,val11);
 SATTR(r,bval,((CHAR)L2));
 ret_val = r;
 return ret_val;
}


AM_CLUSTER_EXPR AM_CLUSTER_EXPR_create_S(AM_CLUSTER_EXPR self, SFILE_ID src1) {
 AM_CLUSTER_EXPR ret_val;
 AM_CLUSTER_EXPR r;
 AM_CLUSTER_EXPR L1;
 L1 = ((AM_CLUSTER_EXPR) rt_alloc_atomic(sizeof(struct AM_CLUSTER_EXPR_struct), AM_CLUSTER_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_EXCEPT_EXPR AM_EXCEPT_EXPR_create_dT(AM_EXCEPT_EXPR self, dTP tp) {
 AM_EXCEPT_EXPR ret_val;
 AM_EXCEPT_EXPR r;
 AM_EXCEPT_EXPR L1;
 L1 = ((AM_EXCEPT_EXPR) rt_alloc(sizeof(struct AM_EXCEPT_EXPR_struct), AM_EXCEPT_EXPR_tag));
 r = L1;
 SATTR(r,tp_at,tp);
 ret_val = r;
 return ret_val;
}


AM_EXPR_STMT AM_EXPR_STMT_create_SFIL(AM_EXPR_STMT self, SFILE_ID source1) {
 AM_EXPR_STMT ret_val;
 AM_EXPR_STMT r;
 AM_EXPR_STMT L1;
 L1 = ((AM_EXPR_STMT) rt_alloc(sizeof(struct AM_EXPR_STMT_struct), AM_EXPR_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_EXT_CALL_EXPR AM_EXT_CALL_EXPR_create_(AM_EXT_CALL_EXPR self, INT nargs, SFILE_ID source1) {
 AM_EXT_CALL_EXPR ret_val;
 AM_EXT_CALL_EXPR r;
 AM_EXT_CALL_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_EXT_CALL_EXPR) rt_arr_alloc(sizeof(struct AM_EXT_CALL_EXPR_struct), AM_EXT_CALL_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_EXT_CALL_EXPR AM_EXT_CALL_EXPR_create_1(AM_EXT_CALL_EXPR self, INT nargs, SFILE_ID source1, IDENT nm) {
 AM_EXT_CALL_EXPR ret_val;
 AM_EXT_CALL_EXPR r;
 r = AM_EXT_CALL_EXPR_create_(self, nargs, source1);
 SATTR(r,nm1,nm);
 ret_val = r;
 return ret_val;
}


AM_FAR_EXPR AM_FAR_EXPR_create_SFILE(AM_FAR_EXPR self, SFILE_ID src1) {
 AM_FAR_EXPR ret_val;
 AM_FAR_EXPR r;
 AM_FAR_EXPR L1;
 L1 = ((AM_FAR_EXPR) rt_alloc(sizeof(struct AM_FAR_EXPR_struct), AM_FAR_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_FLTDX_CONST AM_FLTDX_CONST_create_AS(AM_FLTDX_CONST self, AS_FLT_LIT_EXPR t) {
 AM_FLTDX_CONST ret_val;
 AM_FLTDX_CONST r;
 AM_FLTDX_CONST L1;
 L1 = ((AM_FLTDX_CONST) rt_alloc(sizeof(struct AM_FLTDX_CONST_struct), AM_FLTDX_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_FLTD_CONST AM_FLTD_CONST_create_AS_(AM_FLTD_CONST self, AS_FLT_LIT_EXPR t) {
 AM_FLTD_CONST ret_val;
 AM_FLTD_CONST r;
 AM_FLTD_CONST L1;
 L1 = ((AM_FLTD_CONST) rt_alloc(sizeof(struct AM_FLTD_CONST_struct), AM_FLTD_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_FLTI_CONST AM_FLTI_CONST_create_AS_(AM_FLTI_CONST self, AS_FLT_LIT_EXPR t) {
 AM_FLTI_CONST ret_val;
 AM_FLTI_CONST r;
 AM_FLTI_CONST L1;
 L1 = ((AM_FLTI_CONST) rt_alloc(sizeof(struct AM_FLTI_CONST_struct), AM_FLTI_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_FLTX_CONST AM_FLTX_CONST_create_AS_(AM_FLTX_CONST self, AS_FLT_LIT_EXPR t) {
 AM_FLTX_CONST ret_val;
 AM_FLTX_CONST r;
 AM_FLTX_CONST L1;
 L1 = ((AM_FLTX_CONST) rt_alloc(sizeof(struct AM_FLTX_CONST_struct), AM_FLTX_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_FLT_CONST AM_FLT_CONST_create_AS_F(AM_FLT_CONST self, AS_FLT_LIT_EXPR t) {
 AM_FLT_CONST ret_val;
 AM_FLT_CONST r;
 AM_FLT_CONST L1;
 L1 = ((AM_FLT_CONST) rt_alloc(sizeof(struct AM_FLT_CONST_struct), AM_FLT_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_GLOBAL_EXPR AM_GLOBAL_EXPR_create_SF(AM_GLOBAL_EXPR self, SFILE_ID source1) {
 AM_GLOBAL_EXPR ret_val;
 AM_GLOBAL_EXPR r;
 AM_GLOBAL_EXPR L1;
 L1 = ((AM_GLOBAL_EXPR) rt_alloc(sizeof(struct AM_GLOBAL_EXPR_struct), AM_GLOBAL_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_HERE_EXPR AM_HERE_EXPR_create_SFIL(AM_HERE_EXPR self, SFILE_ID src1) {
 AM_HERE_EXPR ret_val;
 AM_HERE_EXPR r;
 AM_HERE_EXPR L1;
 L1 = ((AM_HERE_EXPR) rt_alloc_atomic(sizeof(struct AM_HERE_EXPR_struct), AM_HERE_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_IF_EXPR AM_IF_EXPR_create_SFILE_(AM_IF_EXPR self, SFILE_ID source1) {
 AM_IF_EXPR ret_val;
 AM_IF_EXPR r;
 AM_IF_EXPR L1;
 L1 = ((AM_IF_EXPR) rt_alloc(sizeof(struct AM_IF_EXPR_struct), AM_IF_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_IF_STMT AM_IF_STMT_create_SFILE_(AM_IF_STMT self, SFILE_ID source1) {
 AM_IF_STMT ret_val;
 AM_IF_STMT r;
 AM_IF_STMT L1;
 L1 = ((AM_IF_STMT) rt_alloc(sizeof(struct AM_IF_STMT_struct), AM_IF_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_INITIAL_STMT AM_INITIAL_STMT_create_S(AM_INITIAL_STMT self, SFILE_ID source1) {
 AM_INITIAL_STMT ret_val;
 AM_INITIAL_STMT r;
 AM_INITIAL_STMT L1;
 L1 = ((AM_INITIAL_STMT) rt_alloc(sizeof(struct AM_INITIAL_STMT_struct), AM_INITIAL_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_INTI_CONST AM_INTI_CONST_create_AS_(AM_INTI_CONST self, AS_INT_LIT_EXPR t) {
 AM_INTI_CONST ret_val;
 AM_INTI_CONST r;
 AM_INTI_CONST L1;
 L1 = ((AM_INTI_CONST) rt_alloc(sizeof(struct AM_INTI_CONST_struct), AM_INTI_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_INT_CONST AM_INT_CONST_create_AS_I(AM_INT_CONST self, AS_INT_LIT_EXPR t) {
 AM_INT_CONST ret_val;
 AM_INT_CONST r;
 AM_INT_CONST L1;
 L1 = ((AM_INT_CONST) rt_alloc(sizeof(struct AM_INT_CONST_struct), AM_INT_CONST_tag));
 r = L1;
 SATTR(r,source11,ATTR(t,source11));
 SATTR(r,val11,ATTR(t,val11));
 ret_val = r;
 return ret_val;
}


AM_INT_CONST AM_INT_CONST_create_SFIL(AM_INT_CONST self, SFILE_ID source1) {
 AM_INT_CONST ret_val;
 AM_INT_CONST r;
 AM_INT_CONST L1;
 L1 = ((AM_INT_CONST) rt_alloc(sizeof(struct AM_INT_CONST_struct), AM_INT_CONST_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_INVARIANT_STMT AM_INVARIANT_STMT_copy_A(AM_INVARIANT_STMT self) {
 AM_INVARIANT_STMT ret_val;
 AM_INVARIANT_STMT res;
 res = AM_INVARIANT_STMT_create(((AM_INVARIANT_STMT) NULL), ATTR(self,source11));
 SATTR(res,sig11,ATTR(self,sig11));
 ret_val = res;
 return ret_val;
}


AM_INVARIANT_STMT AM_INVARIANT_STMT_create(AM_INVARIANT_STMT self, SFILE_ID source1) {
 AM_INVARIANT_STMT ret_val;
 AM_INVARIANT_STMT r;
 AM_INVARIANT_STMT L1;
 L1 = ((AM_INVARIANT_STMT) rt_alloc(sizeof(struct AM_INVARIANT_STMT_struct), AM_INVARIANT_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_IS_VOID_EXPR AM_IS_VOID_EXPR_create_S(AM_IS_VOID_EXPR self, SFILE_ID source1) {
 AM_IS_VOID_EXPR ret_val;
 AM_IS_VOID_EXPR r;
 AM_IS_VOID_EXPR L1;
 L1 = ((AM_IS_VOID_EXPR) rt_alloc(sizeof(struct AM_IS_VOID_EXPR_struct), AM_IS_VOID_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ITER_CALL_EXPR AM_ITER_CALL_EXPR_create(AM_ITER_CALL_EXPR self, INT nargs, SFILE_ID source1) {
 AM_ITER_CALL_EXPR ret_val;
 AM_ITER_CALL_EXPR r;
 AM_ITER_CALL_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_ITER_CALL_EXPR) rt_arr_alloc(sizeof(struct AM_ITER_CALL_EXPR_struct), AM_ITER_CALL_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI(AM_LOCAL_EXPR self, SFILE_ID src1, IDENT name11, dTP tp, AS_TYPE_SPEC as_tp) {
 AM_LOCAL_EXPR ret_val;
 AM_LOCAL_EXPR r;
 AM_LOCAL_EXPR L1;
 L1 = ((AM_LOCAL_EXPR) rt_alloc(sizeof(struct AM_LOCAL_EXPR_struct), AM_LOCAL_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 SATTR(r,name1,name11);
 SATTR(r,tp_at,tp);
 SATTR(r,as_type,as_tp);
 ret_val = r;
 return ret_val;
}


AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI1(AM_LOCAL_EXPR self, SFILE_ID src1, IDENT name11, dTP tp) {
 AM_LOCAL_EXPR ret_val;
 AM_LOCAL_EXPR r;
 AM_LOCAL_EXPR L1;
 L1 = ((AM_LOCAL_EXPR) rt_alloc(sizeof(struct AM_LOCAL_EXPR_struct), AM_LOCAL_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 SATTR(r,name1,name11);
 SATTR(r,tp_at,tp);
 ret_val = r;
 return ret_val;
}


AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI2(AM_LOCAL_EXPR self, SFILE_ID source1) {
 AM_LOCAL_EXPR ret_val;
 AM_LOCAL_EXPR r;
 AM_LOCAL_EXPR L1;
 L1 = ((AM_LOCAL_EXPR) rt_alloc(sizeof(struct AM_LOCAL_EXPR_struct), AM_LOCAL_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_LOCK_STMT AM_LOCK_STMT_create_SFIL(AM_LOCK_STMT self, SFILE_ID source1) {
 AM_LOCK_STMT ret_val;
 AM_LOCK_STMT r;
 AM_LOCK_STMT L1;
 L1 = ((AM_LOCK_STMT) rt_alloc(sizeof(struct AM_LOCK_STMT_struct), AM_LOCK_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_LOOP_STMT AM_LOOP_STMT_create_SFIL(AM_LOOP_STMT self, SFILE_ID source1) {
 AM_LOOP_STMT ret_val;
 AM_LOOP_STMT r;
 AM_LOOP_STMT L1;
 L1 = ((AM_LOOP_STMT) rt_alloc(sizeof(struct AM_LOOP_STMT_struct), AM_LOOP_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_NEAR_EXPR AM_NEAR_EXPR_create_SFIL(AM_NEAR_EXPR self, SFILE_ID src1) {
 AM_NEAR_EXPR ret_val;
 AM_NEAR_EXPR r;
 AM_NEAR_EXPR L1;
 L1 = ((AM_NEAR_EXPR) rt_alloc(sizeof(struct AM_NEAR_EXPR_struct), AM_NEAR_EXPR_tag));
 r = L1;
 SATTR(r,source11,src1);
 ret_val = r;
 return ret_val;
}


AM_NEW_EXPR AM_NEW_EXPR_create_SFILE(AM_NEW_EXPR self, SFILE_ID source1) {
 AM_NEW_EXPR ret_val;
 AM_NEW_EXPR r;
 AM_NEW_EXPR L1;
 L1 = ((AM_NEW_EXPR) rt_alloc(sizeof(struct AM_NEW_EXPR_struct), AM_NEW_EXPR_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_POST_STMT AM_POST_STMT_copy_AM_POS(AM_POST_STMT self) {
 AM_POST_STMT ret_val;
 AM_POST_STMT res;
 res = AM_POST_STMT_create_SFIL(((AM_POST_STMT) NULL), ATTR(self,source11));
 SATTR(res,tp1,ATTR(self,tp1));
 SATTR(res,test11,ATTR(self,test11));
 ret_val = res;
 return ret_val;
}


AM_POST_STMT AM_POST_STMT_create_SFIL(AM_POST_STMT self, SFILE_ID source1) {
 AM_POST_STMT ret_val;
 AM_POST_STMT r;
 AM_POST_STMT L1;
 L1 = ((AM_POST_STMT) rt_alloc(sizeof(struct AM_POST_STMT_struct), AM_POST_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_PRE_STMT AM_PRE_STMT_create_SFILE(AM_PRE_STMT self, SFILE_ID source1) {
 AM_PRE_STMT ret_val;
 AM_PRE_STMT r;
 AM_PRE_STMT L1;
 L1 = ((AM_PRE_STMT) rt_alloc(sizeof(struct AM_PRE_STMT_struct), AM_PRE_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_PROTECT_STMT AM_PROTECT_STMT_create_S(AM_PROTECT_STMT self, SFILE_ID source1) {
 AM_PROTECT_STMT ret_val;
 AM_PROTECT_STMT r;
 AM_PROTECT_STMT L1;
 L1 = ((AM_PROTECT_STMT) rt_alloc(sizeof(struct AM_PROTECT_STMT_struct), AM_PROTECT_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_RAISE_STMT AM_RAISE_STMT_create_SFI(AM_RAISE_STMT self, SFILE_ID source1) {
 AM_RAISE_STMT ret_val;
 AM_RAISE_STMT r;
 AM_RAISE_STMT L1;
 L1 = ((AM_RAISE_STMT) rt_alloc(sizeof(struct AM_RAISE_STMT_struct), AM_RAISE_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_RETURN_STMT AM_RETURN_STMT_create_SF(AM_RETURN_STMT self, SFILE_ID source1) {
 AM_RETURN_STMT ret_val;
 AM_RETURN_STMT r;
 AM_RETURN_STMT L1;
 L1 = ((AM_RETURN_STMT) rt_alloc(sizeof(struct AM_RETURN_STMT_struct), AM_RETURN_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


AM_ROUT_CALL_EXPR AM_ROUT_CALL_EXPR_create(AM_ROUT_CALL_EXPR self, INT nargs, SFILE_ID source1) {
 AM_ROUT_CALL_EXPR ret_val;
 AM_ROUT_CALL_EXPR r;
 AM_ROUT_CALL_EXPR L1;
 INT L2;
 L2 = nargs;
 L1 = ((AM_ROUT_CALL_EXPR) rt_arr_alloc(sizeof(struct AM_ROUT_CALL_EXPR_struct), AM_ROUT_CALL_EXPR_tag, sizeof(dAM_EXPR) , L2));
 L1->asize = L2;
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}


BOOL AM_ROUT_CALL_EXPR_needs_(AM_ROUT_CALL_EXPR self) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = ATTR(ATTR(self,fun),needs_import);
 return ret_val;
}


BOOL AM_ROUT_CALL_EXPR_needs_1(AM_ROUT_CALL_EXPR self) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = ATTR(ATTR(self,fun),needs_export);
 return ret_val;
}


FLISTdLAYOUT ABSTRACT_LAYOUT_dependen(ABSTRACT_LAYOUT self) {
 FLISTdLAYOUT ret_val;
 FLISTdLAYOUT res;
 SIG_TBL L11;
 SIG sig1;
 ARRAYdTP L21;
 SIG L3;
 dTP L4;
 BOOL L5;
 res = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct SIG_TBL_eltb_SIG_frame_struct other1_0;
  SIG_TBL_eltb_SIG_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(self,prog1),ifc_tbl), ATTR(self,tp1)),sigs1);
    noname1->self = L11;
   }
   L3 = SIG_TBL_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   sig1 = L3;
   if (SIG_is_iter_BOOL(sig1)) {
    {
     struct ARRAYdTP_eltb_dTP_frame_struct other2_0;
     ARRAYdTP_eltb_dTP_frame 
     noname2 = &other2_0;
     noname2->state = 0;
     while (1) {
      if (noname2->state == 0) {
       L21 = ATTR(sig1,args1);
       noname2->self = L21;
      }
      L4 = ARRAYdTP_eltb_dTP(noname2);
      if (noname2->state == -1) {
       goto after_loop1;
      }
      res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), L4));
     }
    }
    after_loop1: ;
    L5 = (ATTR(sig1,ret1)==((dTP) NULL));
    if ((!(L5))) {
     res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), ATTR(sig1,ret1)));
    }
   }
  }
 }
 after_loop: ;
 ret_val = res;
 return ret_val;
}


INT AM_ARRAY_EXPR_aindb_INT(AM_ARRAY_EXPR_aindb_INT_frame frame) {
 INT dummy = ((INT) 0);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return L1;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


INT AM_ARRAY_EXPR_indb_INT(AM_ARRAY_EXPR_indb_INT_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ARRAY_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ARRAY_EXPR_aindb_INT_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_ARRAY_EXPR_aindb_INT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT AM_BND_CREATE_EXPR_aindb(AM_BND_CREATE_EXPR_aindb_frame frame) {
 INT dummy = ((INT) 0);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return L1;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


INT AM_BND_CREATE_EXPR_indb_(AM_BND_CREATE_EXPR_indb__frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_CREATE_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_CREATE_EXPR_aindb_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_BND_CREATE_EXPR_aindb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT AM_BND_ITER_CALL_EXPR_si(AM_BND_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((AM_BND_ITER_CALL_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = (ASIZE(self));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT AM_BND_ROUT_CALL_EXPR_ai(AM_BND_ROUT_CALL_EXPR_ai_frame frame) {
 INT dummy = ((INT) 0);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return L1;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


INT AM_BND_ROUT_CALL_EXPR_in(AM_BND_ROUT_CALL_EXPR_in_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_ROUT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_ROUT_CALL_EXPR_ai_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_BND_ROUT_CALL_EXPR_ai(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT AM_ITER_CALL_EXPR_aindb_(AM_ITER_CALL_EXPR_aindb__frame frame) {
 INT dummy = ((INT) 0);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return L1;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


INT AM_ITER_CALL_EXPR_indb_I(AM_ITER_CALL_EXPR_indb_I_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ITER_CALL_EXPR_aindb__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_ITER_CALL_EXPR_aindb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT AM_ITER_CALL_EXPR_size_I(AM_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((AM_ITER_CALL_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = (ASIZE(self));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


SFILE_ID AM_ANY_EXPR_source_SFILE(AM_ANY_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ARRAY_EXPR_source_SFI(AM_ARRAY_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ARR_CONST_source_SFIL(AM_ARR_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ARR_EXPR_source_SFILE(AM_ARR_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ASSERT_STMT_source_SF(AM_ASSERT_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ASSIGN_STMT_source_SF(AM_ASSIGN_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ATTACH_STMT_source_SF(AM_ATTACH_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ATTR_EXPR_source_SFIL(AM_ATTR_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_AT_EXPR_source_SFILE_(AM_AT_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_BND_CREATE_EXPR_sourc(AM_BND_CREATE_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_BND_ITER_CALL_EXPR_so(AM_BND_ITER_CALL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_BND_ROUT_CALL_EXPR_so(AM_BND_ROUT_CALL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_BOOL_CONST_source_SFI(AM_BOOL_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_BREAK_STMT_source_SFI(AM_BREAK_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_CASE_STMT_source_SFIL(AM_CASE_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_CHAR_CONST_source_SFI(AM_CHAR_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_CLUSTER_EXPR_source_S(AM_CLUSTER_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_CONST_source_SFILE_ID(AM_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_EXCEPT_EXPR_source_SF(AM_EXCEPT_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_EXPR_STMT_source_SFIL(AM_EXPR_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_EXT_CALL_EXPR_source_(AM_EXT_CALL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FAR_EXPR_source_SFILE(AM_FAR_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FLTDX_CONST_source_SF(AM_FLTDX_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FLTD_CONST_source_SFI(AM_FLTD_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FLTI_CONST_source_SFI(AM_FLTI_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FLTX_CONST_source_SFI(AM_FLTX_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_FLT_CONST_source_SFIL(AM_FLT_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_GLOBAL_EXPR_source_SF(AM_GLOBAL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_HERE_EXPR_source_SFIL(AM_HERE_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_IF_EXPR_source_SFILE_(AM_IF_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_IF_STMT_source_SFILE_(AM_IF_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_INITIAL_STMT_source_S(AM_INITIAL_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_INTI_CONST_source_SFI(AM_INTI_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_INT_CONST_source_SFIL(AM_INT_CONST self) {
 return ATTR(self,source11);
}


SFILE_ID AM_INVARIANT_STMT_source(AM_INVARIANT_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_IS_VOID_EXPR_source_S(AM_IS_VOID_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ITER_CALL_EXPR_source(AM_ITER_CALL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_LOCAL_EXPR_source_SFI(AM_LOCAL_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_LOCK_STMT_source_SFIL(AM_LOCK_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_LOOP_STMT_source_SFIL(AM_LOOP_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_NEAR_EXPR_source_SFIL(AM_NEAR_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_NEW_EXPR_source_SFILE(AM_NEW_EXPR self) {
 return ATTR(self,source11);
}


SFILE_ID AM_OB_DEF_source_SFILE_I(AM_OB_DEF self) {
 return ATTR(self,source11);
}


SFILE_ID AM_POST_STMT_source_SFIL(AM_POST_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_PRE_STMT_source_SFILE(AM_PRE_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_PROTECT_STMT_source_S(AM_PROTECT_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_RAISE_STMT_source_SFI(AM_RAISE_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_RETURN_STMT_source_SF(AM_RETURN_STMT self) {
 return ATTR(self,source11);
}


SFILE_ID AM_ROUT_CALL_EXPR_source(AM_ROUT_CALL_EXPR self) {
 return ATTR(self,source11);
}


STR ABSTRACT_FRAME_LAYOUT_st(ABSTRACT_FRAME_LAYOUT self) {
 return ATTR(self,str1);
}


STR ABSTRACT_FRAME_LAYOUT_ty(ABSTRACT_FRAME_LAYOUT self, CGEN c) {
 STR ret_val;
 MANGLE m;
 STR res;
 ARRAYdTP L11;
 dTP fi;
 INT L21 = ((INT) 0);
 extern STR typedefstruct;
 STR L3;
 extern STR S_frame_struct1;
 STR L4;
 extern STR S_frame_struct2;
 dSTR L5;
 STR L6;
 STR L7;
 extern STR self7;
 dTP L8;
 dSTR L9;
 STR L10;
 STR L12;
 dSTR L13;
 STR L14;
 extern STR arg2;
 STR L15;
 INT L16;
 dSTR L17;
 STR L18;
 dSTR L19;
 extern STR Formalargument;
 STR L20;
 dTP L22;
 STR L23;
 extern STR name112;
 extern STR INTstate;
 extern STR name113;
 STR L24;
 STR L25;
 extern STR S_frame5;
 m = ATTR(c,mangler);
 L3 = STR_plus_dSTR_STR(((STR) &typedefstruct), ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,sig11)), ((OB) c))));
 res = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &S_frame_struct1)));
 L4 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,sig11)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L4, ((dSTR) ((STR) &S_frame_struct2))));
 L5 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L5)->value_part = ' ';
 L6 = STR_plus_dSTR_STR(res, L5);
 L7 = STR_plus_dSTR_STR(L6, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,sig11),tp)), ((OB) c))));
 res = STR_plus_dSTR_STR(L7, ((dSTR) ((STR) &self7)));
 {
  struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
  ARRAYdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  struct INT_upb_INT_frame_struct other1_1;
  INT_upb_INT_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,sig11),args1);
    noname1->self = L11;
   }
   L8 = ARRAYdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   fi = L8;
   L9 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L9)->value_part = ' ';
   L10 = STR_plus_dSTR_STR(res, L9);
   L12 = STR_plus_dSTR_STR(L10, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) fi), ((OB) c))));
   L13 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L13)->value_part = ' ';
   L14 = STR_plus_dSTR_STR(L12, L13);
   L15 = STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &arg2)));
   if (noname2->state == 0) {
    L21 = 1;
    noname2->self = L21;
   }
   L16 = INT_upb_INT(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   L17 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
   ((INT_boxed) L17)->value_part = L16;
   L18 = STR_plus_dSTR_STR(L15, L17);
   L19 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L19)->value_part = ';';
   res = STR_plus_dSTR_STR(L18, L19);
   L20 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &Formalargument)));
   L22 = fi;
   if (L22==NULL) {
    FATAL("Dispatch on void in ABSTRACT_FRAME_LAYOUT::typedef(CGEN):STR");
   }
   L23 = STR_plus_dSTR_STR(L20, ((dSTR) (*dTP_str_STR[TAG(L22)+dTP_str_STR_offset])(L22)));
   res = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &name112)));
  }
 }
 after_loop: ;
 res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &INTstate)));
 L24 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name113)));
 L25 = STR_plus_dSTR_STR(L24, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,sig11)), ((OB) c))));
 res = STR_plus_dSTR_STR(L25, ((dSTR) ((STR) &S_frame5)));
 ret_val = res;
 return ret_val;
}


STR ABSTRACT_LAYOUT_str_STR(ABSTRACT_LAYOUT self) {
 return ATTR(self,str1);
}


STR ABSTRACT_LAYOUT_typedef_(ABSTRACT_LAYOUT self, CGEN c) {
 STR ret_val;
 MANGLE m;
 STR decl_str;
 SIG_TBL L11;
 SIG sig1;
 dTP fst;
 FSETdTP descendents;
 ABSTRACT_FRAME_LAYOUT abs_frame;
 dTP the_tp;
 STR L2;
 extern STR S_struct1;
 extern STR typedefstruct1;
 STR L3;
 extern STR S_struct2;
 STR L4;
 extern STR OB_HEADERheader;
 STR L5;
 extern STR name113;
 STR L6;
 STR L7;
 extern STR name114;
 SIG L8;
 OUT L9;
 extern STR Nosignaturesfor;
 OUT L10;
 dTP L12;
 OUT L13;
 extern STR name15;
 BOOL L14;
 STR L15;
 extern STR S_entry1;
 extern STR Dispatchtableentryfor;
 STR L16;
 STR L17;
 extern STR name112;
 extern STR typedefstruct1;
 STR L18;
 STR L19;
 extern STR S_entry2;
 STR L20;
 extern STR const3;
 BOOL L21;
 extern STR void1;
 extern STR iter;
 STR L22;
 STR L23;
 extern STR S_frameframe3;
 extern STR constvoidalloc_frame;
 STR L24;
 extern STR name115;
 STR L25;
 STR L26;
 extern STR S_entry3;
 m = ATTR(c,mangler);
 L2 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,tp1)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &S_struct1))));
 L3 = STR_plus_dSTR_STR(((STR) &typedefstruct1), ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,tp1)), ((OB) c))));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &S_struct2)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ((STR) &OB_HEADERheader)));
 L6 = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name113)));
 L7 = STR_plus_dSTR_STR(L6, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,tp1)), ((OB) c))));
 decl_str = STR_plus_dSTR_STR(L7, ((dSTR) ((STR) &name114)));
 {
  struct SIG_TBL_eltb_SIG_frame_struct other1_0;
  SIG_TBL_eltb_SIG_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(c,prog1),ifc_tbl), ATTR(self,tp1)),sigs1);
    noname1->self = L11;
   }
   L8 = SIG_TBL_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   sig1 = L8;
   if ((sig1==((SIG) NULL))) {
    L9 = OUT_create_OUT(((OUT) NULL));
    L10 = OUT_plus_dSTR_OUT(L9, ((dSTR) ((STR) &Nosignaturesfor)));
    L12 = ATTR(self,tp1);
    if (L12==NULL) {
     FATAL("Dispatch on void in ABSTRACT_LAYOUT::typedef(CGEN):STR");
    }
    L13 = OUT_plus_dSTR_OUT(L10, ((dSTR) (*dTP_str_STR[TAG(L12)+dTP_str_STR_offset])(L12)));
    OUT_plus_dSTR(L13, ((dSTR) ((STR) &name15)));
    ret_val = decl_str;
    return ret_val;
   }
   if (SIG_is_iter_BOOL(sig1)) {
    fst = ATTR(self,tp1);
    if (fst==NULL) {
     FATAL("Void object of typecase");
    } else
    switch (TAG(fst)) {
     case TP_CLASS_tag:
      descendents = TP_GRAPH_ABS_DES_des_of_(ATTR(ATTR(c,prog1),tp_graph_abs_des), ((TP_CLASS) fst));
      if ((descendents==((FSETdTP) NULL))) {
       L14 = TRUE;
      } else {
       L14 = FSETdTP_is_empty_BOOL(descendents);
      }
      if (L14) {
       ret_val = decl_str;
       return ret_val;
      } break;
     default: ;
      FATAL("No applicable type in typecase");
    }
    abs_frame = ABSTRACT_FRAME_LAYOUT_cr(((ABSTRACT_FRAME_LAYOUT) NULL), sig1, ATTR(c,prog1));
    decl_str = STR_plus_dSTR_STR(decl_str, ((dSTR) ABSTRACT_FRAME_LAYOUT_ty(abs_frame, c)));
    the_tp = ATTR(sig1,tp);
    L15 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) sig1), ((OB) c));
    MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L15, ((dSTR) ((STR) &S_entry1))));
    L16 = STR_plus_dSTR_STR(decl_str, ((dSTR) ((STR) &Dispatchtableentryfor)));
    L17 = STR_plus_dSTR_STR(L16, ((dSTR) ATTR(sig1,str)));
    decl_str = STR_plus_dSTR_STR(L17, ((dSTR) ((STR) &name112)));
    L18 = STR_plus_dSTR_STR(decl_str, ((dSTR) ((STR) &typedefstruct1)));
    L19 = STR_plus_dSTR_STR(L18, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) sig1), ((OB) c))));
    L20 = STR_plus_dSTR_STR(L19, ((dSTR) ((STR) &S_entry2)));
    decl_str = STR_plus_dSTR_STR(L20, ((dSTR) ((STR) &const3)));
    L21 = (ATTR(sig1,ret1)==((dTP) NULL));
    if ((!(L21))) {
     decl_str = STR_plus_dSTR_STR(decl_str, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(sig1,ret1)), ((OB) c))));
    }
    else {
     decl_str = STR_plus_dSTR_STR(decl_str, ((dSTR) ((STR) &void1)));
    }
    L22 = STR_plus_dSTR_STR(decl_str, ((dSTR) ((STR) &iter)));
    L23 = STR_plus_dSTR_STR(L22, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) sig1), ((OB) c))));
    decl_str = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &S_frameframe3)));
    L24 = STR_plus_dSTR_STR(decl_str, ((dSTR) ((STR) &constvoidalloc_frame)));
    L25 = STR_plus_dSTR_STR(L24, ((dSTR) ((STR) &name115)));
    L26 = STR_plus_dSTR_STR(L25, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) sig1), ((OB) c))));
    decl_str = STR_plus_dSTR_STR(L26, ((dSTR) ((STR) &S_entry3)));
   }
  }
 }
 after_loop: ;
 ret_val = decl_str;
 return ret_val;
}


dAM_EXPR AM_ARRAY_EXPR_aeltb_dAM_(AM_ARRAY_EXPR_aeltb_dAM__frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_ARRAY_EXPR_aget_INT_d(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_ARRAY_EXPR_aget_INT_d(AM_ARRAY_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_ARRAY_EXPR_eltb_dAM_E(AM_ARRAY_EXPR_eltb_dAM_E_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ARRAY_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ARRAY_EXPR_aeltb_dAM__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_ARRAY_EXPR_aeltb_dAM_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_CREATE_EXPR_aeltb(AM_BND_CREATE_EXPR_aeltb_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_BND_CREATE_EXPR_aget_(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_CREATE_EXPR_aget_(AM_BND_CREATE_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_BND_CREATE_EXPR_eltb_(AM_BND_CREATE_EXPR_eltb__frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_CREATE_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_CREATE_EXPR_aeltb_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_BND_CREATE_EXPR_aeltb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_ITER_CALL_EXPR_ae(AM_BND_ITER_CALL_EXPR_ae_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_BND_ITER_CALL_EXPR_ag(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_ITER_CALL_EXPR_ag(AM_BND_ITER_CALL_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_BND_ITER_CALL_EXPR_el(AM_BND_ITER_CALL_EXPR_el_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_ITER_CALL_EXPR_ae_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_BND_ITER_CALL_EXPR_ae(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_ROUT_CALL_EXPR_ae(AM_BND_ROUT_CALL_EXPR_ae_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_BND_ROUT_CALL_EXPR_ag(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_BND_ROUT_CALL_EXPR_ag(AM_BND_ROUT_CALL_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_BND_ROUT_CALL_EXPR_el(AM_BND_ROUT_CALL_EXPR_el_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_ROUT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_ROUT_CALL_EXPR_ae_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_BND_ROUT_CALL_EXPR_ae(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_EXT_CALL_EXPR_aeltb_d(AM_EXT_CALL_EXPR_aeltb_d_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_EXT_CALL_EXPR_aget_IN(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_EXT_CALL_EXPR_aget_IN(AM_EXT_CALL_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_EXT_CALL_EXPR_eltb_dA(AM_EXT_CALL_EXPR_eltb_dA_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_EXT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_EXT_CALL_EXPR_aeltb_d_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_EXT_CALL_EXPR_aeltb_d(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_ITER_CALL_EXPR_aeltb_(AM_ITER_CALL_EXPR_aeltb__frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_ITER_CALL_EXPR_aget_I(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_ITER_CALL_EXPR_aget_I(AM_ITER_CALL_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_ITER_CALL_EXPR_eltb_d(AM_ITER_CALL_EXPR_eltb_d_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ITER_CALL_EXPR_aeltb__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_ITER_CALL_EXPR_aeltb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_ROUT_CALL_EXPR_aeltb_(AM_ROUT_CALL_EXPR_aeltb__frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return AM_ROUT_CALL_EXPR_aget_I(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dAM_EXPR AM_ROUT_CALL_EXPR_aget_I(AM_ROUT_CALL_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR AM_ROUT_CALL_EXPR_eltb_d(AM_ROUT_CALL_EXPR_eltb_d_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ROUT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ROUT_CALL_EXPR_aeltb__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = AM_ROUT_CALL_EXPR_aeltb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_STMT AM_ASSERT_STMT_next_dAM_(AM_ASSERT_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_ASSIGN_STMT_next_dAM_(AM_ASSIGN_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_ATTACH_STMT_next_dAM_(AM_ATTACH_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_BREAK_STMT_next_dAM_S(AM_BREAK_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_CASE_STMT_next_dAM_ST(AM_CASE_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_EXPR_STMT_next_dAM_ST(AM_EXPR_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_IF_STMT_next_dAM_STMT(AM_IF_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_INITIAL_STMT_next_dAM(AM_INITIAL_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_INVARIANT_STMT_next_d(AM_INVARIANT_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_LOCK_STMT_next_dAM_ST(AM_LOCK_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_LOOP_STMT_next_dAM_ST(AM_LOOP_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_POST_STMT_next_dAM_ST(AM_POST_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_PRE_STMT_next_dAM_STM(AM_PRE_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_PROTECT_STMT_next_dAM(AM_PROTECT_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_RAISE_STMT_next_dAM_S(AM_RAISE_STMT self) {
 return ATTR(self,next1);
}


dAM_STMT AM_RETURN_STMT_next_dAM_(AM_RETURN_STMT self) {
 return ATTR(self,next1);
}


dTP AM_ARRAY_EXPR_tp_dTP(AM_ARRAY_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}


dTP AM_BND_CREATE_EXPR_tp_dT(AM_BND_CREATE_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}


dTP AM_BND_ITER_CALL_EXPR_tp(AM_BND_ITER_CALL_EXPR self) {
 dTP ret_val;
 dTP bitp;
 dAM_EXPR L1;
 L1 = ATTR(self,bi);
 if (L1==NULL) {
  FATAL("Dispatch on void in AM_BND_ITER_CALL_EXPR::tp:$TP");
 }
 bitp = (*dAM_EXPR_tp_dTP[TAG(L1)+dAM_EXPR_tp_dTP_offset])(L1);
 if (bitp==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(bitp)) {
  case TP_ITER_tag:
   ret_val = ATTR(((TP_ITER) bitp),ret);
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


dTP AM_BND_ROUT_CALL_EXPR_tp(AM_BND_ROUT_CALL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,br_tp),ret);
 return ret_val;
}


dTP AM_EXT_CALL_EXPR_tp_dTP(AM_EXT_CALL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,fun),ret1);
 return ret_val;
}


dTP AM_ITER_CALL_EXPR_tp_dTP(AM_ITER_CALL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,fun),ret1);
 return ret_val;
}


dTP AM_ROUT_CALL_EXPR_tp_dTP(AM_ROUT_CALL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,fun),ret1);
 return ret_val;
}


void ABSTRACT_FRAME_LAYOUT_la(ABSTRACT_FRAME_LAYOUT self, FMAPSIGABSTRACT_FRAME_LA layouts) {
 ABSTRACT_FRAME_LAYOUT_la1 = layouts;
}


void ABSTRACT_LAYOUT_layouts_(ABSTRACT_LAYOUT self, FSETABSTRACT_LAYOUT layouts) {
 ABSTRACT_LAYOUT_layouts = layouts;
}


void AM_ARRAY_EXPR_aset_INT_d(AM_ARRAY_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_ARRAY_EXPR_asetb_dAM_(AM_ARRAY_EXPR_asetb_dAM__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_ARRAY_EXPR_aset_INT_d(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_ARRAY_EXPR_setb_dAM_E(AM_ARRAY_EXPR_setb_dAM_E_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ARRAY_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ARRAY_EXPR_asetb_dAM__frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_ARRAY_EXPR_asetb_dAM_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_ASSERT_STMT_next_dAM_1(AM_ASSERT_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_ASSIGN_STMT_append_dA(AM_ASSIGN_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_ASSIGN_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_ASSIGN_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_ASSIGN_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}


void AM_ASSIGN_STMT_next_dAM_1(AM_ASSIGN_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_ATTACH_STMT_next_dAM_1(AM_ATTACH_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_BND_CREATE_EXPR_aset_(AM_BND_CREATE_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_BND_CREATE_EXPR_asetb(AM_BND_CREATE_EXPR_asetb_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_BND_CREATE_EXPR_aset_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_BND_CREATE_EXPR_setb_(AM_BND_CREATE_EXPR_setb__frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_CREATE_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_CREATE_EXPR_asetb_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_BND_CREATE_EXPR_asetb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_BND_ITER_CALL_EXPR_as1(AM_BND_ITER_CALL_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_BND_ITER_CALL_EXPR_as2(AM_BND_ITER_CALL_EXPR_as2_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_BND_ITER_CALL_EXPR_as1(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_BND_ITER_CALL_EXPR_se(AM_BND_ITER_CALL_EXPR_se_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_ITER_CALL_EXPR_as2_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_BND_ITER_CALL_EXPR_as2(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_BND_ROUT_CALL_EXPR_as1(AM_BND_ROUT_CALL_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_BND_ROUT_CALL_EXPR_as2(AM_BND_ROUT_CALL_EXPR_as2_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_BND_ROUT_CALL_EXPR_as1(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_BND_ROUT_CALL_EXPR_se(AM_BND_ROUT_CALL_EXPR_se_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_BND_ROUT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_BND_ROUT_CALL_EXPR_as2_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_BND_ROUT_CALL_EXPR_as2(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_BREAK_STMT_next_dAM_S1(AM_BREAK_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_CASE_STMT_next_dAM_ST1(AM_CASE_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_EXPR_STMT_next_dAM_ST1(AM_EXPR_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_EXT_CALL_EXPR_aset_IN(AM_EXT_CALL_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_EXT_CALL_EXPR_asetb_d(AM_EXT_CALL_EXPR_asetb_d_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_EXT_CALL_EXPR_aset_IN(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_EXT_CALL_EXPR_setb_dA(AM_EXT_CALL_EXPR_setb_dA_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_EXT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_EXT_CALL_EXPR_asetb_d_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_EXT_CALL_EXPR_asetb_d(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_IF_STMT_next_dAM_STMT1(AM_IF_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_INITIAL_STMT_next_dAM1(AM_INITIAL_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_INVARIANT_STMT_next_d1(AM_INVARIANT_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_ITER_CALL_EXPR_aset_I(AM_ITER_CALL_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_ITER_CALL_EXPR_asetb_(AM_ITER_CALL_EXPR_asetb__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_ITER_CALL_EXPR_aset_I(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_ITER_CALL_EXPR_setb_d(AM_ITER_CALL_EXPR_setb_d_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ITER_CALL_EXPR_asetb__frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_ITER_CALL_EXPR_asetb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void AM_LOCK_STMT_next_dAM_ST1(AM_LOCK_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_LOOP_STMT_next_dAM_ST1(AM_LOOP_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_OUT_AM_ANY_EXPR_out_A(AM_OUT self, AM_ANY_EXPR a) {
 OUT L1;
 extern STR voidAM_ANY_EXPR;
 OUT L2;
 extern STR AM_ANY_EXPR1;
 if ((a==((AM_ANY_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ANY_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ANY_EXPR1)));
}


void AM_OUT_AM_ARRAY_EXPR_out(AM_OUT self, AM_ARRAY_EXPR a) {
 AM_ARRAY_EXPR L11;
 OUT L2;
 extern STR void1;
 OUT L3;
 extern STR AM_ARRAY_EXPR1;
 OUT L4;
 extern STR tp1;
 OUT L5;
 dTP L6;
 OUT L7;
 extern STR name25;
 dAM_EXPR L8;
 if ((a==((AM_ARRAY_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &void1)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_ARRAY_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &tp1)));
 L6 = ATTR(a,tp_at);
 if (L6==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_ARRAY_EXPR_out(AM_ARRAY_EXPR)");
 }
 OUT_plus_dSTR(L5, ((dSTR) (*dTP_str_STR[TAG(L6)+dTP_str_STR_offset])(L6)));
 {
  struct AM_ARRAY_EXPR_eltb_dAM_E_frame_struct other1_0;
  AM_ARRAY_EXPR_eltb_dAM_E_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   L7 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L7, ((dSTR) ((STR) &name25)));
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L8 = AM_ARRAY_EXPR_eltb_dAM_E(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L8);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_ARR_CONST_out_(AM_OUT self, AM_ARR_CONST a) {
 ARRAYdAM_CONST L11;
 OUT L2;
 extern STR voidAM_ARR_CONST;
 OUT L3;
 extern STR AM_ARR_CONST1;
 OUT L4;
 extern STR elt_tp;
 OUT L5;
 OUT L6;
 extern STR elts;
 dAM_CONST L7;
 if ((a==((AM_ARR_CONST) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_ARR_CONST)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_ARR_CONST1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &elt_tp)));
 OUT_plus_dSTR(L5, ((dSTR) TP_CLASS_str_STR(ATTR(a,elt_tp))));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &elts)));
 {
  struct ARRAYdAM_CONST_eltb_dAM__frame_struct other1_0;
  ARRAYdAM_CONST_eltb_dAM__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(a,elts);
    noname1->self = L11;
   }
   L7 = ARRAYdAM_CONST_eltb_dAM_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, ((dAM_EXPR) L7));
  }
 }
 after_loop: ;
}


void AM_OUT_AM_ARR_EXPR_out_A(AM_OUT self, AM_ARR_EXPR a) {
 OUT L1;
 extern STR voidAM_ARR_EXPR;
 OUT L2;
 extern STR AM_ARR_EXPR1;
 OUT L3;
 extern STR ob1;
 OUT L4;
 extern STR ind1;
 OUT L5;
 extern STR tp1;
 OUT L6;
 dTP L7;
 if ((a==((AM_ARR_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ARR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ARR_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &ob1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ob1));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &ind1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ind1));
 L5 = OUT_create_OUT(((OUT) NULL));
 L6 = OUT_plus_dSTR_OUT(L5, ((dSTR) ((STR) &tp1)));
 L7 = ATTR(a,tp_at);
 if (L7==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_ARR_EXPR_out(AM_ARR_EXPR)");
 }
 OUT_plus_dSTR(L6, ((dSTR) (*dTP_str_STR[TAG(L7)+dTP_str_STR_offset])(L7)));
}


void AM_OUT_AM_ASSERT_STMT_ou(AM_OUT self, AM_ASSERT_STMT a) {
 OUT L1;
 extern STR voidAM_ASSERT_STMT;
 OUT L2;
 extern STR AM_ASSERT_STMT1;
 OUT L3;
 extern STR test11;
 if ((a==((AM_ASSERT_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ASSERT_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ASSERT_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
}


void AM_OUT_AM_ASSIGN_STMT_ou(AM_OUT self, AM_ASSIGN_STMT a) {
 OUT L1;
 extern STR voidAM_ASSIGN_STMT;
 OUT L2;
 extern STR AM_ASSIGN_STMT1;
 OUT L3;
 extern STR dest;
 OUT L4;
 extern STR src11;
 if ((a==((AM_ASSIGN_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ASSIGN_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ASSIGN_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &dest)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,dest));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &src11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,src11));
}


void AM_OUT_AM_ATTACH_STMT_ou(AM_OUT self, AM_ATTACH_STMT a) {
 OUT L1;
 extern STR voidAM_ATTACH_STMT;
 OUT L2;
 extern STR AM_ATTACH_STMT1;
 OUT L3;
 extern STR routine1;
 OUT L4;
 OUT L5;
 extern STR helper;
 OUT L6;
 extern STR gate1;
 OUT L7;
 extern STR at21;
 OUT L8;
 extern STR any3;
 OUT L9;
 extern STR name31;
 if ((a==((AM_ATTACH_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ATTACH_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ATTACH_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &routine1)));
 OUT_plus_dSTR(L4, ((dSTR) ATTR(ATTR(a,rout1),str)));
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &helper)));
 AM_OUT_AM_LOCAL_EXPR_out(self, ATTR(a,helper));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &gate1)));
 AM_OUT_AM_LOCAL_EXPR_out(self, ATTR(a,gate1));
 L7 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L7, ((dSTR) ((STR) &at21)));
 if ((ATTR(a,at11)==((dAM_EXPR) NULL))) {
  L8 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L8, ((dSTR) ((STR) &any3)));
 }
 else {
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,at11));
 }
 L9 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L9, ((dSTR) ((STR) &name31)));
}


void AM_OUT_AM_ATTR_EXPR_out_(AM_OUT self, AM_ATTR_EXPR a) {
 OUT L1;
 extern STR voidAM_ATTR_EXPR;
 OUT L2;
 extern STR AM_ATTR_EXPR1;
 OUT L3;
 extern STR ob1;
 OUT L4;
 extern STR at11;
 OUT L5;
 OUT L6;
 extern STR self_tp;
 OUT L7;
 dTP L8;
 OUT L9;
 extern STR tp1;
 OUT L10;
 dTP L11;
 if ((a==((AM_ATTR_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ATTR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ATTR_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &ob1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ob1));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &at11)));
 OUT_plus_dSTR(L5, ((dSTR) ATTR(a,at11).str));
 L6 = OUT_create_OUT(((OUT) NULL));
 L7 = OUT_plus_dSTR_OUT(L6, ((dSTR) ((STR) &self_tp)));
 L8 = ATTR(a,self_tp);
 if (L8==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_ATTR_EXPR_out(AM_ATTR_EXPR)");
 }
 OUT_plus_dSTR(L7, ((dSTR) (*dTP_str_STR[TAG(L8)+dTP_str_STR_offset])(L8)));
 L9 = OUT_create_OUT(((OUT) NULL));
 L10 = OUT_plus_dSTR_OUT(L9, ((dSTR) ((STR) &tp1)));
 L11 = ATTR(a,tp_at);
 if (L11==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_ATTR_EXPR_out(AM_ATTR_EXPR)");
 }
 OUT_plus_dSTR(L10, ((dSTR) (*dTP_str_STR[TAG(L11)+dTP_str_STR_offset])(L11)));
}


void AM_OUT_AM_AT_EXPR_out_AM(AM_OUT self, AM_AT_EXPR a) {
 OUT L1;
 extern STR voidAM_AT_EXPR;
 OUT L2;
 extern STR AM_AT_EXPR1;
 OUT L3;
 extern STR expr;
 OUT L4;
 extern STR at11;
 if ((a==((AM_AT_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_AT_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_AT_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,e11));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &at11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,at11));
}


void AM_OUT_AM_BND_CREATE_EXP(AM_OUT self, AM_BND_CREATE_EXPR a) {
 AM_BND_CREATE_EXPR L11;
 INT i = ((INT) 0);
 ARRAYINT L21;
 INT j = ((INT) 0);
 ARRAYINT L31;
 INT j11 = ((INT) 0);
 OUT L4;
 extern STR voidAM_BMD_CREATE_EXPR;
 OUT L5;
 extern STR AM_BMD_CREATE_EXPR;
 OUT L6;
 extern STR args1;
 INT L7;
 OUT L8;
 extern STR name25;
 OUT L9;
 extern STR name31;
 OUT L10;
 extern STR fun;
 OUT L12;
 OUT L13;
 extern STR bnd_args;
 INT L14;
 OUT L15;
 extern STR name25;
 OUT L16;
 dSTR L17;
 OUT L18;
 extern STR unbnd_args;
 INT L19;
 OUT L20;
 extern STR name25;
 OUT L22;
 dSTR L23;
 OUT L24;
 extern STR name31;
 OUT L25;
 extern STR tp_at;
 OUT L26;
 dTP L27;
 if ((a==((AM_BND_CREATE_EXPR) NULL))) {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &voidAM_BMD_CREATE_EXPR)));
  return;
 }
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &AM_BMD_CREATE_EXPR)));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &args1)));
 {
  struct AM_BND_CREATE_EXPR_indb__frame_struct other1_0;
  AM_BND_CREATE_EXPR_indb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L7 = AM_BND_CREATE_EXPR_indb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   i = L7;
   if ((i!=0)) {
    L8 = OUT_create_OUT(((OUT) NULL));
    OUT_plus_dSTR(L8, ((dSTR) ((STR) &name25)));
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, AM_BND_CREATE_EXPR_aget_(a, i));
  }
 }
 after_loop: ;
 L9 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L9, ((dSTR) ((STR) &name31)));
 L10 = OUT_create_OUT(((OUT) NULL));
 L12 = OUT_plus_dSTR_OUT(L10, ((dSTR) ((STR) &fun)));
 OUT_plus_dSTR(L12, ((dSTR) ATTR(ATTR(a,fun),str)));
 L13 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L13, ((dSTR) ((STR) &bnd_args)));
 {
  struct ARRAYINT_indb_INT_frame_struct other2_0;
  ARRAYINT_indb_INT_frame 
  noname2 = &other2_0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = ATTR(a,bnd_args);
    noname2->self = L21;
   }
   L14 = ARRAYINT_indb_INT(noname2);
   if (noname2->state == -1) {
    goto after_loop1;
   }
   j = L14;
   if ((j!=0)) {
    L15 = OUT_create_OUT(((OUT) NULL));
    OUT_plus_dSTR(L15, ((dSTR) ((STR) &name25)));
   }
   L16 = OUT_create_OUT(((OUT) NULL));
   L17 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
   ((INT_boxed) L17)->value_part = ARRAYINT_aget_INT_INT(ATTR(a,bnd_args), j);
   OUT_plus_dSTR(L16, L17);
  }
 }
 after_loop1: ;
 L18 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L18, ((dSTR) ((STR) &unbnd_args)));
 {
  struct ARRAYINT_indb_INT_frame_struct other3_0;
  ARRAYINT_indb_INT_frame 
  noname3 = &other3_0;
  noname3->state = 0;
  while (1) {
   if (noname3->state == 0) {
    L31 = ATTR(a,unbnd_args);
    noname3->self = L31;
   }
   L19 = ARRAYINT_indb_INT(noname3);
   if (noname3->state == -1) {
    goto after_loop2;
   }
   j11 = L19;
   if ((j11!=0)) {
    L20 = OUT_create_OUT(((OUT) NULL));
    OUT_plus_dSTR(L20, ((dSTR) ((STR) &name25)));
   }
   L22 = OUT_create_OUT(((OUT) NULL));
   L23 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
   ((INT_boxed) L23)->value_part = ARRAYINT_aget_INT_INT(ATTR(a,unbnd_args), j11);
   OUT_plus_dSTR(L22, L23);
  }
 }
 after_loop2: ;
 L24 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L24, ((dSTR) ((STR) &name31)));
 L25 = OUT_create_OUT(((OUT) NULL));
 L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) ((STR) &tp_at)));
 L27 = ATTR(a,tp_at);
 if (L27==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_BND_CREATE_EXPR_out(AM_BND_CREATE_EXPR)");
 }
 OUT_plus_dSTR(L26, ((dSTR) (*dTP_str_STR[TAG(L27)+dTP_str_STR_offset])(L27)));
}


void AM_OUT_AM_BND_ITER_CALL_(AM_OUT self, AM_BND_ITER_CALL_EXPR a) {
 AM_BND_ITER_CALL_EXPR L11;
 OUT L2;
 extern STR voidAM_BND_ITER_CALL_EXP;
 OUT L3;
 extern STR AM_BND_ITER_CALL_EXPR1;
 OUT L4;
 extern STR bi;
 OUT L5;
 extern STR init1;
 OUT L6;
 extern STR args2;
 dAM_EXPR L7;
 if ((a==((AM_BND_ITER_CALL_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_BND_ITER_CALL_EXP)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_BND_ITER_CALL_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &bi)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,bi));
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &init1)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,init1));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &args2)));
 {
  struct AM_BND_ITER_CALL_EXPR_el_frame_struct other1_0;
  AM_BND_ITER_CALL_EXPR_el_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L7 = AM_BND_ITER_CALL_EXPR_el(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L7);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_BND_ROUT_CALL_(AM_OUT self, AM_BND_ROUT_CALL_EXPR a) {
 AM_BND_ROUT_CALL_EXPR L11;
 OUT L2;
 extern STR voidAM_BND_ROUT_CALL_EXP;
 OUT L3;
 extern STR AM_BND_ROUT_CALL_EXPR1;
 OUT L4;
 extern STR br;
 OUT L5;
 extern STR args2;
 dAM_EXPR L6;
 if ((a==((AM_BND_ROUT_CALL_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_BND_ROUT_CALL_EXP)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_BND_ROUT_CALL_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &br)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,br));
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &args2)));
 {
  struct AM_BND_ROUT_CALL_EXPR_el_frame_struct other1_0;
  AM_BND_ROUT_CALL_EXPR_el_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L6 = AM_BND_ROUT_CALL_EXPR_el(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L6);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_BOOL_CONST_out(AM_OUT self, AM_BOOL_CONST a) {
 OUT L1;
 extern STR voidAM_BOOL_CONST;
 OUT L2;
 extern STR AM_BOOL_CONST1;
 OUT L3;
 extern STR valtrue;
 OUT L4;
 extern STR valfalse;
 if ((a==((AM_BOOL_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_BOOL_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_BOOL_CONST1)));
 if (ATTR(a,val11)) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &valtrue)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &valfalse)));
 }
}


void AM_OUT_AM_BREAK_STMT_out(AM_OUT self, AM_BREAK_STMT a) {
 OUT L1;
 extern STR voidAM_BREAK_STMT;
 OUT L2;
 extern STR AM_BREAK_STMT1;
 if ((a==((AM_BREAK_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_BREAK_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_BREAK_STMT1)));
}


void AM_OUT_AM_CASE_STMT_out_(AM_OUT self, AM_CASE_STMT a) {
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 OUT L1;
 extern STR voidAM_CASE_STMT;
 OUT L2;
 extern STR AM_CASE_STMT1;
 OUT L3;
 extern STR test11;
 OUT L4;
 extern STR branches;
 INT L5;
 OUT L6;
 extern STR name21;
 INT L7;
 FLISTdAM_CONST L8;
 OUT L9;
 extern STR name25;
 OUT L10;
 extern STR name31;
 OUT L11;
 extern STR else_stmts;
 if ((a==((AM_CASE_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_CASE_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_CASE_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &branches)));
 i = 0;
 while (1) {
  L5 = FLISTFLISTdAM_CONST_size(ATTR(a,tgts));
  if ((i<L5)) {
  }
  else {
   goto after_loop;
  }
  L6 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name21)));
  j = 0;
  while (1) {
   L7 = FLISTdAM_CONST_size_INT(FLISTFLISTdAM_CONST_aget(ATTR(a,tgts), i));
   if ((j<L7)) {
   }
   else {
    goto after_loop1;
   }
   L8 = FLISTFLISTdAM_CONST_aget(ATTR(a,tgts), i);
   AM_OUT_AM_CONST_out_dAM_(self, FLISTdAM_CONST_aget_INT_(L8, j));
   L9 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L9, ((dSTR) ((STR) &name25)));
   j = (INTPLUS(j,1));
  }
  after_loop1: ;
  AM_OUT_AM_STMT_out_dAM_S(self, FLISTdAM_STMT_aget_INT_d(ATTR(a,stmts), i));
  L10 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L10, ((dSTR) ((STR) &name31)));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 L11 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L11, ((dSTR) ((STR) &else_stmts)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,else_stmts));
}


void AM_OUT_AM_CHAR_CONST_out(AM_OUT self, AM_CHAR_CONST a) {
 OUT L1;
 extern STR voidAM_CHAR_CONST;
 OUT L2;
 extern STR AM_CHAR_CONST1;
 OUT L3;
 extern STR bval;
 OUT L4;
 dSTR L5;
 OUT L6;
 extern STR name8;
 if ((a==((AM_CHAR_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_CHAR_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_CHAR_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &bval)));
 L5 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L5)->value_part = ATTR(a,bval);
 L6 = OUT_plus_dSTR_OUT(L4, L5);
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &name8)));
}


void AM_OUT_AM_CLUSTER_EXPR_o(AM_OUT self, AM_CLUSTER_EXPR a) {
 OUT L1;
 extern STR voidAM_CLUSTER_EXPR;
 OUT L2;
 extern STR AM_CLUSTER_EXPR1;
 if ((a==((AM_CLUSTER_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_CLUSTER_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_CLUSTER_EXPR1)));
}


void AM_OUT_AM_CONST_out_dAM_(AM_OUT self, dAM_CONST a) {
 OUT L1;
 extern STR voiddAM_CONST;
 OUT L2;
 extern STR name21;
 OUT L3;
 extern STR name20;
 if ((a==((dAM_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voiddAM_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &name21)));
 if (a==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(a)) {
  case AM_VOID_CONST_tag:
   AM_OUT_AM_VOID_CONST_out(self, ((AM_VOID_CONST) a)); break;
  case AM_ARR_CONST_tag:
   AM_OUT_AM_ARR_CONST_out_(self, ((AM_ARR_CONST) a)); break;
  case AM_BOOL_CONST_tag:
   AM_OUT_AM_BOOL_CONST_out(self, ((AM_BOOL_CONST) a)); break;
  case AM_CHAR_CONST_tag:
   AM_OUT_AM_CHAR_CONST_out(self, ((AM_CHAR_CONST) a)); break;
  case AM_STR_CONST_tag:
   AM_OUT_AM_STR_CONST_out_(self, ((AM_STR_CONST) a)); break;
  case AM_INT_CONST_tag:
   AM_OUT_AM_INT_CONST_out_(self, ((AM_INT_CONST) a)); break;
  case AM_INTI_CONST_tag:
   AM_OUT_AM_INTI_CONST_out(self, ((AM_INTI_CONST) a)); break;
  case AM_FLT_CONST_tag:
   AM_OUT_AM_FLT_CONST_out_(self, ((AM_FLT_CONST) a)); break;
  case AM_FLTD_CONST_tag:
   AM_OUT_AM_FLTD_CONST_out(self, ((AM_FLTD_CONST) a)); break;
  case AM_FLTX_CONST_tag:
   AM_OUT_AM_FLTX_CONST_out(self, ((AM_FLTX_CONST) a)); break;
  case AM_FLTDX_CONST_tag:
   AM_OUT_AM_FLTDX_CONST_ou(self, ((AM_FLTDX_CONST) a)); break;
  case AM_FLTI_CONST_tag:
   AM_OUT_AM_FLTI_CONST_out(self, ((AM_FLTI_CONST) a)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &name20)));
}


void AM_OUT_AM_EXCEPT_EXPR_ou(AM_OUT self, AM_EXCEPT_EXPR a) {
 OUT L1;
 extern STR voidAM_EXCEPT_EXPR;
 OUT L2;
 extern STR AM_EXCEPT_EXPR1;
 if ((a==((AM_EXCEPT_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_EXCEPT_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_EXCEPT_EXPR1)));
}


void AM_OUT_AM_EXPR_STMT_out_(AM_OUT self, AM_EXPR_STMT a) {
 OUT L1;
 extern STR voidAM_EXPR_STMT;
 OUT L2;
 extern STR AM_EXPR_STMT1;
 OUT L3;
 extern STR expr;
 if ((a==((AM_EXPR_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_EXPR_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_EXPR_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,expr));
}


void AM_OUT_AM_EXPR_out_dAM_E(AM_OUT self, dAM_EXPR a) {
 OUT L1;
 extern STR voiddAM_EXPR;
 OUT L2;
 extern STR name21;
 OUT L3;
 extern STR name20;
 if ((a==((dAM_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voiddAM_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &name21)));
 if (a==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(a)) {
  case AM_LOCAL_EXPR_tag:
   AM_OUT_AM_LOCAL_EXPR_out(self, ((AM_LOCAL_EXPR) a)); break;
  case AM_ARRAY_EXPR_tag:
   AM_OUT_AM_ARRAY_EXPR_out(self, ((AM_ARRAY_EXPR) a)); break;
  case AM_BND_CREATE_EXPR_tag:
   AM_OUT_AM_BND_CREATE_EXP(self, ((AM_BND_CREATE_EXPR) a)); break;
  case AM_IF_EXPR_tag:
   AM_OUT_AM_IF_EXPR_out_AM(self, ((AM_IF_EXPR) a)); break;
  case AM_NEW_EXPR_tag:
   AM_OUT_AM_NEW_EXPR_out_A(self, ((AM_NEW_EXPR) a)); break;
  case AM_IS_VOID_EXPR_tag:
   AM_OUT_AM_IS_VOID_EXPR_o(self, ((AM_IS_VOID_EXPR) a)); break;
  case AM_GLOBAL_EXPR_tag:
   AM_OUT_AM_GLOBAL_EXPR_ou(self, ((AM_GLOBAL_EXPR) a)); break;
  case AM_ATTR_EXPR_tag:
   AM_OUT_AM_ATTR_EXPR_out_(self, ((AM_ATTR_EXPR) a)); break;
  case AM_ARR_EXPR_tag:
   AM_OUT_AM_ARR_EXPR_out_A(self, ((AM_ARR_EXPR) a)); break;
  case AM_VATTR_ASSIGN_EXPR_tag:
   AM_OUT_AM_VATTR_ASSIGN_E(self, ((AM_VATTR_ASSIGN_EXPR) a)); break;
  case AM_VARR_ASSIGN_EXPR_tag:
   AM_OUT_AM_VARR_ASSIGN_EX(self, ((AM_VARR_ASSIGN_EXPR) a)); break;
  case AM_EXCEPT_EXPR_tag:
   AM_OUT_AM_EXCEPT_EXPR_ou(self, ((AM_EXCEPT_EXPR) a)); break;
  case AM_STMT_EXPR_tag:
   AM_OUT_AM_STMT_EXPR_out_(self, ((AM_STMT_EXPR) a)); break;
  case AM_ROUT_CALL_EXPR_tag:
   AM_OUT_AM_ROUT_CALL_EXPR(self, ((AM_ROUT_CALL_EXPR) a)); break;
  case AM_ITER_CALL_EXPR_tag:
   AM_OUT_AM_ITER_CALL_EXPR(self, ((AM_ITER_CALL_EXPR) a)); break;
  case AM_BND_ROUT_CALL_EXPR_tag:
   AM_OUT_AM_BND_ROUT_CALL_(self, ((AM_BND_ROUT_CALL_EXPR) a)); break;
  case AM_BND_ITER_CALL_EXPR_tag:
   AM_OUT_AM_BND_ITER_CALL_(self, ((AM_BND_ITER_CALL_EXPR) a)); break;
  case AM_EXT_CALL_EXPR_tag:
   AM_OUT_AM_EXT_CALL_EXPR_(self, ((AM_EXT_CALL_EXPR) a)); break;
  case AM_VOID_CONST_tag:
   AM_OUT_AM_VOID_CONST_out(self, ((AM_VOID_CONST) a)); break;
  case AM_ARR_CONST_tag:
   AM_OUT_AM_ARR_CONST_out_(self, ((AM_ARR_CONST) a)); break;
  case AM_BOOL_CONST_tag:
   AM_OUT_AM_BOOL_CONST_out(self, ((AM_BOOL_CONST) a)); break;
  case AM_CHAR_CONST_tag:
   AM_OUT_AM_CHAR_CONST_out(self, ((AM_CHAR_CONST) a)); break;
  case AM_STR_CONST_tag:
   AM_OUT_AM_STR_CONST_out_(self, ((AM_STR_CONST) a)); break;
  case AM_INT_CONST_tag:
   AM_OUT_AM_INT_CONST_out_(self, ((AM_INT_CONST) a)); break;
  case AM_INTI_CONST_tag:
   AM_OUT_AM_INTI_CONST_out(self, ((AM_INTI_CONST) a)); break;
  case AM_FLT_CONST_tag:
   AM_OUT_AM_FLT_CONST_out_(self, ((AM_FLT_CONST) a)); break;
  case AM_FLTD_CONST_tag:
   AM_OUT_AM_FLTD_CONST_out(self, ((AM_FLTD_CONST) a)); break;
  case AM_FLTX_CONST_tag:
   AM_OUT_AM_FLTX_CONST_out(self, ((AM_FLTX_CONST) a)); break;
  case AM_FLTDX_CONST_tag:
   AM_OUT_AM_FLTDX_CONST_ou(self, ((AM_FLTDX_CONST) a)); break;
  case AM_FLTI_CONST_tag:
   AM_OUT_AM_FLTI_CONST_out(self, ((AM_FLTI_CONST) a)); break;
  case AM_HERE_EXPR_tag:
   AM_OUT_AM_HERE_EXPR_out_(self, ((AM_HERE_EXPR) a)); break;
  case AM_ANY_EXPR_tag:
   AM_OUT_AM_ANY_EXPR_out_A(self, ((AM_ANY_EXPR) a)); break;
  case AM_WHERE_EXPR_tag:
   AM_OUT_AM_WHERE_EXPR_out(self, ((AM_WHERE_EXPR) a)); break;
  case AM_NEAR_EXPR_tag:
   AM_OUT_AM_NEAR_EXPR_out_(self, ((AM_NEAR_EXPR) a)); break;
  case AM_FAR_EXPR_tag:
   AM_OUT_AM_FAR_EXPR_out_A(self, ((AM_FAR_EXPR) a)); break;
  case AM_AT_EXPR_tag:
   AM_OUT_AM_AT_EXPR_out_AM(self, ((AM_AT_EXPR) a)); break;
  case AM_CLUSTER_EXPR_tag:
   AM_OUT_AM_CLUSTER_EXPR_o(self, ((AM_CLUSTER_EXPR) a)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &name20)));
}


void AM_OUT_AM_EXT_CALL_EXPR_(AM_OUT self, AM_EXT_CALL_EXPR a) {
 AM_EXT_CALL_EXPR L11;
 OUT L2;
 extern STR voidAM_EXT_CALL_EXPR;
 OUT L3;
 extern STR AM_EXT_CALL_EXPR1;
 OUT L4;
 extern STR fun;
 OUT L5;
 OUT L6;
 extern STR args2;
 dAM_EXPR L7;
 if ((a==((AM_EXT_CALL_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_EXT_CALL_EXPR)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_EXT_CALL_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &fun)));
 OUT_plus_dSTR(L5, ((dSTR) ATTR(ATTR(a,fun),str)));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &args2)));
 {
  struct AM_EXT_CALL_EXPR_eltb_dA_frame_struct other1_0;
  AM_EXT_CALL_EXPR_eltb_dA_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L7 = AM_EXT_CALL_EXPR_eltb_dA(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L7);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_FAR_EXPR_out_A(AM_OUT self, AM_FAR_EXPR a) {
 OUT L1;
 extern STR voidAM_FAR_EXPR;
 OUT L2;
 extern STR AM_FAR_EXPR1;
 OUT L3;
 extern STR expr;
 if ((a==((AM_FAR_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FAR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FAR_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,arg1));
}


void AM_OUT_AM_FLTDX_CONST_ou(AM_OUT self, AM_FLTDX_CONST a) {
 OUT L1;
 extern STR voidAM_FLTDX_CONST;
 OUT L2;
 extern STR AM_FLTDX_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_FLTDX_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FLTDX_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FLTDX_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) RAT_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_FLTD_CONST_out(AM_OUT self, AM_FLTD_CONST a) {
 OUT L1;
 extern STR voidAM_FLTD_CONST;
 OUT L2;
 extern STR AM_FLTD_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_FLTD_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FLTD_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FLTD_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) RAT_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_FLTI_CONST_out(AM_OUT self, AM_FLTI_CONST a) {
 OUT L1;
 extern STR voidAM_FLTI_CONST;
 OUT L2;
 extern STR AM_FLTI_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_FLTI_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FLTI_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FLTI_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) RAT_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_FLTX_CONST_out(AM_OUT self, AM_FLTX_CONST a) {
 OUT L1;
 extern STR voidAM_FLTX_CONST;
 OUT L2;
 extern STR AM_FLTX_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_FLTX_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FLTX_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FLTX_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) RAT_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_FLT_CONST_out_(AM_OUT self, AM_FLT_CONST a) {
 OUT L1;
 extern STR voidAM_FLT_CONST;
 OUT L2;
 extern STR AM_FLT_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_FLT_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_FLT_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_FLT_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) RAT_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_GLOBAL_EXPR_ou(AM_OUT self, AM_GLOBAL_EXPR a) {
 OUT L1;
 extern STR voidAM_GLOBAL_EXPR;
 OUT L2;
 extern STR AM_GLOBAL_EXPR1;
 OUT L3;
 extern STR name32;
 OUT L4;
 extern STR void1;
 OUT L5;
 OUT L6;
 extern STR tp1;
 OUT L7;
 extern STR void1;
 OUT L8;
 dTP L9;
 OUT L10;
 extern STR class_tp;
 OUT L11;
 extern STR void1;
 OUT L12;
 dTP L13;
 OUT L14;
 extern STR init1;
 if ((a==((AM_GLOBAL_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_GLOBAL_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_GLOBAL_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &name32)));
 if ((ATTR(a,name1).str==(STR)0)) {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &void1)));
 }
 else {
  L5 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L5, ((dSTR) ATTR(a,name1).str));
 }
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &tp1)));
 if ((ATTR(a,tp_at)==((dTP) NULL))) {
  L7 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L7, ((dSTR) ((STR) &void1)));
 }
 else {
  L8 = OUT_create_OUT(((OUT) NULL));
  L9 = ATTR(a,tp_at);
  if (L9==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_GLOBAL_EXPR_out(AM_GLOBAL_EXPR)");
  }
  OUT_plus_dSTR(L8, ((dSTR) (*dTP_str_STR[TAG(L9)+dTP_str_STR_offset])(L9)));
 }
 L10 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L10, ((dSTR) ((STR) &class_tp)));
 if ((ATTR(a,class_tp)==((dTP) NULL))) {
  L11 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L11, ((dSTR) ((STR) &void1)));
 }
 else {
  L12 = OUT_create_OUT(((OUT) NULL));
  L13 = ATTR(a,class_tp);
  if (L13==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_GLOBAL_EXPR_out(AM_GLOBAL_EXPR)");
  }
  OUT_plus_dSTR(L12, ((dSTR) (*dTP_str_STR[TAG(L13)+dTP_str_STR_offset])(L13)));
 }
 L14 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L14, ((dSTR) ((STR) &init1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,init1));
}


void AM_OUT_AM_HERE_EXPR_out_(AM_OUT self, AM_HERE_EXPR a) {
 OUT L1;
 extern STR voidAM_HERE_EXPR;
 OUT L2;
 extern STR AM_HERE_EXPR1;
 if ((a==((AM_HERE_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_HERE_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_HERE_EXPR1)));
}


void AM_OUT_AM_IF_EXPR_out_AM(AM_OUT self, AM_IF_EXPR a) {
 OUT L1;
 extern STR voidAM_IF_EXPR;
 OUT L2;
 extern STR AM_IF_EXPR1;
 OUT L3;
 extern STR test11;
 OUT L4;
 extern STR if_true;
 OUT L5;
 extern STR if_false;
 if ((a==((AM_IF_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_IF_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_IF_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &if_true)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,if_true));
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &if_false)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,if_false));
}


void AM_OUT_AM_IF_STMT_out_AM(AM_OUT self, AM_IF_STMT a) {
 OUT L1;
 extern STR voidAM_IF_STMT;
 OUT L2;
 extern STR AM_IF_STMT1;
 OUT L3;
 extern STR test11;
 OUT L4;
 extern STR if_true;
 OUT L5;
 extern STR if_false;
 if ((a==((AM_IF_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_IF_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_IF_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &if_true)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,if_true));
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &if_false)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,if_false));
}


void AM_OUT_AM_INITIAL_STMT_o(AM_OUT self, AM_INITIAL_STMT a) {
 OUT L1;
 extern STR voidAM_INITIAL_STMT;
 OUT L2;
 extern STR AM_INITIAL_STMT1;
 OUT L3;
 extern STR stmts1;
 if ((a==((AM_INITIAL_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_INITIAL_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_INITIAL_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &stmts1)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,stmts));
}


void AM_OUT_AM_INTI_CONST_out(AM_OUT self, AM_INTI_CONST a) {
 OUT L1;
 extern STR voidAM_INTI_CONST;
 OUT L2;
 extern STR AM_INTI_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_INTI_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_INTI_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_INTI_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) INTI_str_STR(ATTR(a,val11))));
}


void AM_OUT_AM_INT_CONST_out_(AM_OUT self, AM_INT_CONST a) {
 OUT L1;
 extern STR voidAM_INT_CONST;
 OUT L2;
 extern STR AM_INT_CONST1;
 OUT L3;
 extern STR val11;
 OUT L4;
 if ((a==((AM_INT_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_INT_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_INT_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &val11)));
 OUT_plus_dSTR(L4, ((dSTR) ATTR(a,val11)));
}


void AM_OUT_AM_INVARIANT_STMT(AM_OUT self, AM_INVARIANT_STMT a) {
 OUT L1;
 extern STR voidAM_INVARIANT_STMT;
 OUT L2;
 extern STR AM_INVARIANT_STMT1;
 if ((a==((AM_INVARIANT_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_INVARIANT_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_INVARIANT_STMT1)));
}


void AM_OUT_AM_IS_VOID_EXPR_o(AM_OUT self, AM_IS_VOID_EXPR a) {
 OUT L1;
 extern STR voidAM_IS_VOID_EXPR;
 OUT L2;
 extern STR AM_IS_VOID_EXPR1;
 OUT L3;
 extern STR arg1;
 if ((a==((AM_IS_VOID_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_IS_VOID_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_IS_VOID_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &arg1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,arg1));
}


void AM_OUT_AM_ITER_CALL_EXPR(AM_OUT self, AM_ITER_CALL_EXPR a) {
 AM_ITER_CALL_EXPR L11;
 OUT L2;
 extern STR voidAM_ITER_CALL_EXPR;
 OUT L3;
 extern STR AM_ITER_CALL_EXPR1;
 OUT L4;
 extern STR fun;
 OUT L5;
 OUT L6;
 extern STR init1;
 OUT L7;
 extern STR args2;
 dAM_EXPR L8;
 if ((a==((AM_ITER_CALL_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_ITER_CALL_EXPR)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_ITER_CALL_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &fun)));
 OUT_plus_dSTR(L5, ((dSTR) ATTR(ATTR(a,fun),str)));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &init1)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,init1));
 L7 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L7, ((dSTR) ((STR) &args2)));
 {
  struct AM_ITER_CALL_EXPR_eltb_d_frame_struct other1_0;
  AM_ITER_CALL_EXPR_eltb_d_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L8 = AM_ITER_CALL_EXPR_eltb_d(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L8);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_LOCK_STMT_out_(AM_OUT self, AM_LOCK_STMT a) {
 OUT L1;
 extern STR voidAM_LOCK_STMT;
 OUT L2;
 extern STR AM_LOCK_STMT1;
 OUT L3;
 extern STR body;
 if ((a==((AM_LOCK_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_LOCK_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_LOCK_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &body)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,body));
}


void AM_OUT_AM_LOOP_STMT_out_(AM_OUT self, AM_LOOP_STMT a) {
 OUT L1;
 extern STR voidAM_LOOP_STMT;
 OUT L2;
 extern STR AM_LOOP_STMT1;
 OUT L3;
 extern STR has_yieldtrue;
 OUT L4;
 extern STR has_yieldfalse;
 OUT L5;
 extern STR body;
 if ((a==((AM_LOOP_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_LOOP_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_LOOP_STMT1)));
 if (ATTR(a,has_yield)) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &has_yieldtrue)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &has_yieldfalse)));
 }
 L5 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L5, ((dSTR) ((STR) &body)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,body));
}


void AM_OUT_AM_NEAR_EXPR_out_(AM_OUT self, AM_NEAR_EXPR a) {
 OUT L1;
 extern STR voidAM_NEAR_EXPR;
 OUT L2;
 extern STR AM_NEAR_EXPR1;
 OUT L3;
 extern STR expr;
 if ((a==((AM_NEAR_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_NEAR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_NEAR_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,arg1));
}


void AM_OUT_AM_NEW_EXPR_out_A(AM_OUT self, AM_NEW_EXPR a) {
 OUT L1;
 extern STR voidAM_NEW_EXPR;
 OUT L2;
 extern STR AM_NEW_EXPR1;
 OUT L3;
 extern STR asz1;
 if ((a==((AM_NEW_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_NEW_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_NEW_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &asz1)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,asz1));
}


void AM_OUT_AM_POST_STMT_out_(AM_OUT self, AM_POST_STMT a) {
 OUT L1;
 extern STR voidAM_POST_STMT;
 OUT L2;
 extern STR AM_POST_STMT1;
 OUT L3;
 extern STR test11;
 if ((a==((AM_POST_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_POST_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_POST_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
}


void AM_OUT_AM_PRE_STMT_out_A(AM_OUT self, AM_PRE_STMT a) {
 OUT L1;
 extern STR voidAM_PRE_STMT;
 OUT L2;
 extern STR AM_PRE_STMT1;
 OUT L3;
 extern STR test11;
 if ((a==((AM_PRE_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_PRE_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_PRE_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,test11));
}


void AM_OUT_AM_PROTECT_STMT_o(AM_OUT self, AM_PROTECT_STMT a) {
 INT i = ((INT) 0);
 OUT L1;
 extern STR voidAM_PROTECT_STMT;
 OUT L2;
 extern STR AM_PROTECT_STMT1;
 OUT L3;
 extern STR body;
 OUT L4;
 extern STR branches;
 INT L5;
 OUT L6;
 extern STR name21;
 OUT L7;
 dTP L8;
 OUT L9;
 extern STR name25;
 OUT L10;
 extern STR name31;
 OUT L11;
 extern STR else_stmts;
 if ((a==((AM_PROTECT_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_PROTECT_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_PROTECT_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &body)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,body));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &branches)));
 i = 0;
 while (1) {
  L5 = FLISTdTP_size_INT(ATTR(a,tgts));
  if ((i<L5)) {
  }
  else {
   goto after_loop;
  }
  L6 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name21)));
  L7 = OUT_create_OUT(((OUT) NULL));
  L8 = FLISTdTP_aget_INT_dTP(ATTR(a,tgts), i);
  if (L8==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_PROTECT_STMT_out(AM_PROTECT_STMT)");
  }
  L9 = OUT_plus_dSTR_OUT(L7, ((dSTR) (*dTP_str_STR[TAG(L8)+dTP_str_STR_offset])(L8)));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &name25)));
  AM_OUT_AM_STMT_out_dAM_S(self, FLISTdAM_STMT_aget_INT_d(ATTR(a,stmts), i));
  L10 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L10, ((dSTR) ((STR) &name31)));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 L11 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L11, ((dSTR) ((STR) &else_stmts)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,else_stmts));
}


void AM_OUT_AM_RAISE_STMT_out(AM_OUT self, AM_RAISE_STMT a) {
 OUT L1;
 extern STR voidAM_RAISE_STMT;
 OUT L2;
 extern STR AM_RAISE_STMT1;
 OUT L3;
 extern STR val11;
 if ((a==((AM_RAISE_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_RAISE_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_RAISE_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &val11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,val11));
}


void AM_OUT_AM_RETURN_STMT_ou(AM_OUT self, AM_RETURN_STMT a) {
 OUT L1;
 extern STR voidAM_RETURN_STMT;
 OUT L2;
 extern STR AM_RETURN_STMT1;
 OUT L3;
 extern STR val11;
 if ((a==((AM_RETURN_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_RETURN_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_RETURN_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &val11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,val11));
}


void AM_OUT_AM_ROUT_CALL_EXPR(AM_OUT self, AM_ROUT_CALL_EXPR a) {
 AM_ROUT_CALL_EXPR L11;
 OUT L2;
 extern STR voidAM_ROUT_CALL_EXPR;
 OUT L3;
 extern STR AM_ROUT_CALL_EXPR1;
 OUT L4;
 extern STR fun;
 OUT L5;
 OUT L6;
 extern STR args2;
 dAM_EXPR L7;
 if ((a==((AM_ROUT_CALL_EXPR) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L2, ((dSTR) ((STR) &voidAM_ROUT_CALL_EXPR)));
  return;
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &AM_ROUT_CALL_EXPR1)));
 L4 = OUT_create_OUT(((OUT) NULL));
 L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &fun)));
 OUT_plus_dSTR(L5, ((dSTR) ATTR(ATTR(a,fun),str)));
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &args2)));
 {
  struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct other1_0;
  AM_ROUT_CALL_EXPR_eltb_d_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = a;
    noname1->self = L11;
   }
   L7 = AM_ROUT_CALL_EXPR_eltb_d(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   AM_OUT_AM_EXPR_out_dAM_E(self, L7);
  }
 }
 after_loop: ;
}


void AM_OUT_AM_ROUT_DEF_out_A(AM_OUT self, AM_ROUT_DEF a) {
 INT i = ((INT) 0);
 INT i1 = ((INT) 0);
 OUT L1;
 extern STR voidAM_ROUT_DEF;
 OUT L2;
 extern STR AM_ROUT_DEF1;
 OUT L3;
 extern STR voidsig;
 OUT L4;
 extern STR sig11;
 OUT L5;
 OUT L6;
 extern STR name20;
 OUT L7;
 extern STR isabstract;
 INT L8;
 OUT L9;
 extern STR args3;
 INT L10;
 OUT L11;
 extern STR name25;
 OUT L12;
 extern STR name20;
 OUT L13;
 extern STR voidlocals;
 OUT L14;
 extern STR locals1;
 INT L15;
 OUT L16;
 extern STR name25;
 OUT L17;
 extern STR name20;
 OUT L18;
 extern STR needsimport;
 OUT L19;
 extern STR needsexport;
 OUT L20;
 extern STR voidcode;
 OUT L21;
 extern STR code2;
 OUT L22;
 extern STR name33;
 if ((a==((AM_ROUT_DEF) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_ROUT_DEF)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_ROUT_DEF1)));
 if ((ATTR(a,sig11)==((SIG) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &voidsig)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &sig11)));
  L6 = OUT_plus_dSTR_OUT(L5, ((dSTR) ATTR(ATTR(a,sig11),str)));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name20)));
 }
 if (ATTR(a,is_abstract)) {
  L7 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L7, ((dSTR) ((STR) &isabstract)));
  return;
 }
 L8 = AM_ROUT_DEF_size_INT(a);
 if ((L8>1)) {
  L9 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &args3)));
  i = 1;
  while (1) {
   L10 = (ASIZE(a));
   if ((i<L10)) {
   }
   else {
    goto after_loop;
   }
   AM_OUT_AM_LOCAL_EXPR_out(self, AM_ROUT_DEF_aget_INT_AM_(a, i));
   L11 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L11, ((dSTR) ((STR) &name25)));
   i = (INTPLUS(i,1));
  }
  after_loop: ;
  L12 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L12, ((dSTR) ((STR) &name20)));
 }
 if ((ATTR(a,locals1)==((FLISTAM_LOCAL_EXPR) NULL))) {
  L13 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L13, ((dSTR) ((STR) &voidlocals)));
 }
 else {
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &locals1)));
  i1 = 0;
  while (1) {
   L15 = FLISTAM_LOCAL_EXPR_size_(ATTR(a,locals1));
   if ((i1<L15)) {
   }
   else {
    goto after_loop1;
   }
   AM_OUT_AM_LOCAL_EXPR_out(self, FLISTAM_LOCAL_EXPR_aget_(ATTR(a,locals1), i1));
   L16 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L16, ((dSTR) ((STR) &name25)));
   i1 = (INTPLUS(i1,1));
  }
  after_loop1: ;
  L17 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L17, ((dSTR) ((STR) &name20)));
 }
 if (ATTR(ATTR(a,sig11),needs_import)) {
  L18 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L18, ((dSTR) ((STR) &needsimport)));
 }
 if (ATTR(ATTR(a,sig11),needs_export)) {
  L19 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L19, ((dSTR) ((STR) &needsexport)));
 }
 if ((ATTR(a,code11)==((dAM_STMT) NULL))) {
  L20 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L20, ((dSTR) ((STR) &voidcode)));
 }
 else {
  L21 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L21, ((dSTR) ((STR) &code2)));
  AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,code11));
 }
 L22 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L22, ((dSTR) ((STR) &name33)));
}


void AM_OUT_AM_STMT_EXPR_out_(AM_OUT self, AM_STMT_EXPR a) {
 OUT L1;
 extern STR voidAM_STMT_EXPR;
 OUT L2;
 extern STR AM_STMT_EXPR1;
 OUT L3;
 extern STR voidstmts;
 OUT L4;
 extern STR stmts1;
 OUT L5;
 extern STR voidexpr;
 OUT L6;
 extern STR expr;
 if ((a==((AM_STMT_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_STMT_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_STMT_EXPR1)));
 if ((ATTR(a,stmts)==((dAM_STMT) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &voidstmts)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &stmts1)));
  AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,stmts));
 }
 if ((ATTR(a,expr)==((dAM_EXPR) NULL))) {
  L5 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L5, ((dSTR) ((STR) &voidexpr)));
 }
 else {
  L6 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &expr)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,expr));
 }
}


void AM_OUT_AM_STMT_out_dAM_S(AM_OUT self, dAM_STMT a) {
 OUT L1;
 extern STR voiddAM_STMT;
 OUT L2;
 extern STR name21;
 OUT L3;
 extern STR name20;
 dAM_STMT L4;
 BOOL L5;
 dAM_STMT L6;
 if ((a==((dAM_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voiddAM_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &name21)));
 if (a==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(a)) {
  case AM_ASSIGN_STMT_tag:
   AM_OUT_AM_ASSIGN_STMT_ou(self, ((AM_ASSIGN_STMT) a)); break;
  case AM_IF_STMT_tag:
   AM_OUT_AM_IF_STMT_out_AM(self, ((AM_IF_STMT) a)); break;
  case AM_LOOP_STMT_tag:
   AM_OUT_AM_LOOP_STMT_out_(self, ((AM_LOOP_STMT) a)); break;
  case AM_BREAK_STMT_tag:
   AM_OUT_AM_BREAK_STMT_out(self, ((AM_BREAK_STMT) a)); break;
  case AM_RETURN_STMT_tag:
   AM_OUT_AM_RETURN_STMT_ou(self, ((AM_RETURN_STMT) a)); break;
  case AM_YIELD_STMT_tag:
   AM_OUT_AM_YIELD_STMT_out(self, ((AM_YIELD_STMT) a)); break;
  case AM_CASE_STMT_tag:
   AM_OUT_AM_CASE_STMT_out_(self, ((AM_CASE_STMT) a)); break;
  case AM_TYPECASE_STMT_tag:
   AM_OUT_AM_TYPECASE_STMT_(self, ((AM_TYPECASE_STMT) a)); break;
  case AM_PRE_STMT_tag:
   AM_OUT_AM_PRE_STMT_out_A(self, ((AM_PRE_STMT) a)); break;
  case AM_POST_STMT_tag:
   AM_OUT_AM_POST_STMT_out_(self, ((AM_POST_STMT) a)); break;
  case AM_INITIAL_STMT_tag:
   AM_OUT_AM_INITIAL_STMT_o(self, ((AM_INITIAL_STMT) a)); break;
  case AM_ASSERT_STMT_tag:
   AM_OUT_AM_ASSERT_STMT_ou(self, ((AM_ASSERT_STMT) a)); break;
  case AM_INVARIANT_STMT_tag:
   AM_OUT_AM_INVARIANT_STMT(self, ((AM_INVARIANT_STMT) a)); break;
  case AM_PROTECT_STMT_tag:
   AM_OUT_AM_PROTECT_STMT_o(self, ((AM_PROTECT_STMT) a)); break;
  case AM_RAISE_STMT_tag:
   AM_OUT_AM_RAISE_STMT_out(self, ((AM_RAISE_STMT) a)); break;
  case AM_EXPR_STMT_tag:
   AM_OUT_AM_EXPR_STMT_out_(self, ((AM_EXPR_STMT) a)); break;
  case AM_UNCAUGHT_STMT_tag:
   AM_OUT_AM_UNCAUGHT_STMT_(self, ((AM_UNCAUGHT_STMT) a)); break;
  case AM_ATTACH_STMT_tag:
   AM_OUT_AM_ATTACH_STMT_ou(self, ((AM_ATTACH_STMT) a)); break;
  case AM_LOCK_STMT_tag:
   AM_OUT_AM_LOCK_STMT_out_(self, ((AM_LOCK_STMT) a)); break;
  case AM_UNLOCK_STMT_tag:
   AM_OUT_AM_UNLOCK_STMT_ou(self, ((AM_UNLOCK_STMT) a)); break;
  case AM_TRY_STMT_tag:
   AM_OUT_AM_TRY_STMT_out_A(self, ((AM_TRY_STMT) a)); break;
  case AM_WITH_NEAR_STMT_tag:
   AM_OUT_AM_WITH_NEAR_STMT(self, ((AM_WITH_NEAR_STMT) a)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &name20)));
 L4 = a;
 if (L4==NULL) {
  FATAL("Dispatch on void in AM_OUT::AM_STMT_out($AM_STMT)");
 }
 L5 = ((*dAM_STMT_next_dAM_STMT[TAG(L4)+dAM_STMT_next_dAM_STMT_offset])(L4)==((dAM_STMT) NULL));
 if ((!(L5))) {
  L6 = a;
  if (L6==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_STMT_out($AM_STMT)");
  }
  AM_OUT_AM_STMT_out_dAM_S(self, (*dAM_STMT_next_dAM_STMT[TAG(L6)+dAM_STMT_next_dAM_STMT_offset])(L6));
 }
}


void AM_OUT_AM_STR_CONST_out_(AM_OUT self, AM_STR_CONST a) {
 OUT L1;
 extern STR voidAM_STR_CONST;
 OUT L2;
 extern STR AM_STR_CONST1;
 OUT L3;
 extern STR bval1;
 OUT L4;
 if ((a==((AM_STR_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_STR_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_STR_CONST1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &bval1)));
 OUT_plus_dSTR(L4, ((dSTR) ATTR(a,bval)));
}


void AM_OUT_AM_TRY_STMT_out_A(AM_OUT self, AM_TRY_STMT a) {
 OUT L1;
 extern STR voidAM_TRY_STMT;
 OUT L2;
 extern STR AM_TRY_STMT1;
 OUT L3;
 extern STR then3;
 OUT L4;
 extern STR then3;
 if ((a==((AM_TRY_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_TRY_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_TRY_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &then3)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,then_part1));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &then3)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,else_part1));
}


void AM_OUT_AM_TYPECASE_STMT_(AM_OUT self, AM_TYPECASE_STMT a) {
 INT i = ((INT) 0);
 OUT L1;
 extern STR voidAM_TYPECASE_STMT;
 OUT L2;
 extern STR AM_TYPECASE_STMT1;
 OUT L3;
 extern STR test11;
 OUT L4;
 extern STR branches;
 INT L5;
 OUT L6;
 extern STR name21;
 OUT L7;
 dTP L8;
 OUT L9;
 extern STR name25;
 OUT L10;
 extern STR name31;
 OUT L11;
 extern STR else_stmts;
 if ((a==((AM_TYPECASE_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_TYPECASE_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_TYPECASE_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &test11)));
 AM_OUT_AM_LOCAL_EXPR_out(self, ATTR(a,test11));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &branches)));
 i = 0;
 while (1) {
  L5 = FLISTdTP_size_INT(ATTR(a,tgts));
  if ((i<L5)) {
  }
  else {
   goto after_loop;
  }
  L6 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name21)));
  L7 = OUT_create_OUT(((OUT) NULL));
  L8 = FLISTdTP_aget_INT_dTP(ATTR(a,tgts), i);
  if (L8==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_TYPECASE_STMT_out(AM_TYPECASE_STMT)");
  }
  L9 = OUT_plus_dSTR_OUT(L7, ((dSTR) (*dTP_str_STR[TAG(L8)+dTP_str_STR_offset])(L8)));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &name25)));
  AM_OUT_AM_STMT_out_dAM_S(self, FLISTdAM_STMT_aget_INT_d(ATTR(a,stmts), i));
  L10 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L10, ((dSTR) ((STR) &name31)));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 L11 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L11, ((dSTR) ((STR) &else_stmts)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,else_stmts));
}


void AM_OUT_AM_UNCAUGHT_STMT_(AM_OUT self, AM_UNCAUGHT_STMT a) {
 OUT L1;
 extern STR voidAM_UNCAUGHT_STMT;
 OUT L2;
 extern STR AM_UNCAUGHT_STMT1;
 if ((a==((AM_UNCAUGHT_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_UNCAUGHT_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_UNCAUGHT_STMT1)));
}


void AM_OUT_AM_UNLOCK_STMT_ou(AM_OUT self, AM_UNLOCK_STMT a) {
 OUT L1;
 extern STR voidAM_UNLOCK_STMT;
 OUT L2;
 extern STR AM_UNLOCK_STMT1;
 OUT L3;
 extern STR expr;
 if ((a==((AM_UNLOCK_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_UNLOCK_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_UNLOCK_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,lock1));
}


void AM_OUT_AM_VARR_ASSIGN_EX(AM_OUT self, AM_VARR_ASSIGN_EXPR a) {
 OUT L1;
 extern STR voidAM_VARR_EXPR;
 OUT L2;
 extern STR AM_VARR_EXPR;
 OUT L3;
 extern STR voidob;
 OUT L4;
 extern STR ob1;
 OUT L5;
 extern STR voidind;
 OUT L6;
 extern STR ind1;
 OUT L7;
 extern STR voidval;
 OUT L8;
 extern STR val11;
 if ((a==((AM_VARR_ASSIGN_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_VARR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_VARR_EXPR)));
 if ((ATTR(a,ob1)==((dAM_EXPR) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &voidob)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &ob1)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ob1));
 }
 if ((ATTR(a,ind1)==((dAM_EXPR) NULL))) {
  L5 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L5, ((dSTR) ((STR) &voidind)));
 }
 else {
  L6 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &ind1)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ind1));
 }
 if ((ATTR(a,val11)==((dAM_EXPR) NULL))) {
  L7 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L7, ((dSTR) ((STR) &voidval)));
 }
 else {
  L8 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L8, ((dSTR) ((STR) &val11)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,val11));
 }
}


void AM_OUT_AM_VATTR_ASSIGN_E(AM_OUT self, AM_VATTR_ASSIGN_EXPR a) {
 OUT L1;
 extern STR voidAM_VATTR_EXPR;
 OUT L2;
 extern STR AM_VATTR_EXPR;
 OUT L3;
 extern STR voidob;
 OUT L4;
 extern STR ob1;
 OUT L5;
 extern STR voidat;
 OUT L6;
 extern STR at11;
 OUT L7;
 OUT L8;
 extern STR voidval;
 OUT L9;
 extern STR val11;
 if ((a==((AM_VATTR_ASSIGN_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_VATTR_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_VATTR_EXPR)));
 if ((ATTR(a,ob1)==((dAM_EXPR) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &voidob)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &ob1)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,ob1));
 }
 if ((ATTR(a,at11).str==(STR)0)) {
  L5 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L5, ((dSTR) ((STR) &voidat)));
 }
 else {
  L6 = OUT_create_OUT(((OUT) NULL));
  L7 = OUT_plus_dSTR_OUT(L6, ((dSTR) ((STR) &at11)));
  OUT_plus_dSTR(L7, ((dSTR) ATTR(a,at11).str));
 }
 if ((ATTR(a,val11)==((dAM_EXPR) NULL))) {
  L8 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L8, ((dSTR) ((STR) &voidval)));
 }
 else {
  L9 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &val11)));
  AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,val11));
 }
}


void AM_OUT_AM_VOID_CONST_out(AM_OUT self, AM_VOID_CONST a) {
 OUT L1;
 extern STR voidvoidAM_VOID_CONST;
 OUT L2;
 extern STR AM_VOID_CONST1;
 OUT L3;
 extern STR void5;
 OUT L4;
 dTP L5;
 OUT L6;
 extern STR name20;
 if ((a==((AM_VOID_CONST) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidvoidAM_VOID_CONST)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_VOID_CONST1)));
 if ((ATTR(a,tp_at)==((dTP) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &void5)));
 }
 else {
  L4 = OUT_create_OUT(((OUT) NULL));
  L5 = ATTR(a,tp_at);
  if (L5==NULL) {
   FATAL("Dispatch on void in AM_OUT::AM_VOID_CONST_out(AM_VOID_CONST)");
  }
  L6 = OUT_plus_dSTR_OUT(L4, ((dSTR) (*dTP_str_STR[TAG(L5)+dTP_str_STR_offset])(L5)));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name20)));
 }
}


void AM_OUT_AM_WHERE_EXPR_out(AM_OUT self, AM_WHERE_EXPR a) {
 OUT L1;
 extern STR voidAM_WHERE_EXPR;
 OUT L2;
 extern STR AM_WHERE_EXPR1;
 OUT L3;
 extern STR expr;
 if ((a==((AM_WHERE_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_WHERE_EXPR)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_WHERE_EXPR1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &expr)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,arg1));
}


void AM_OUT_AM_WITH_NEAR_STMT(AM_OUT self, AM_WITH_NEAR_STMT a) {
 OUT L1;
 extern STR voidAM_WITH_NEAR_STMT;
 OUT L2;
 extern STR AM_WITH_NEAR_STMT1;
 OUT L3;
 extern STR near2;
 OUT L4;
 extern STR else3;
 if ((a==((AM_WITH_NEAR_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_WITH_NEAR_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_WITH_NEAR_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &near2)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,near_part));
 L4 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L4, ((dSTR) ((STR) &else3)));
 AM_OUT_AM_STMT_out_dAM_S(self, ATTR(a,else_part1));
}


void AM_OUT_AM_YIELD_STMT_out(AM_OUT self, AM_YIELD_STMT a) {
 OUT L1;
 extern STR voidAM_YIELD_STMT;
 OUT L2;
 extern STR AM_YIELD_STMT1;
 OUT L3;
 extern STR ret1;
 OUT L4;
 dSTR L5;
 OUT L6;
 extern STR val11;
 if ((a==((AM_YIELD_STMT) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_YIELD_STMT)));
  return;
 }
 L2 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L2, ((dSTR) ((STR) &AM_YIELD_STMT1)));
 L3 = OUT_create_OUT(((OUT) NULL));
 L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ((STR) &ret1)));
 L5 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
 ((INT_boxed) L5)->value_part = ATTR(a,ret1);
 OUT_plus_dSTR(L4, L5);
 L6 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L6, ((dSTR) ((STR) &val11)));
 AM_OUT_AM_EXPR_out_dAM_E(self, ATTR(a,val11));
}


void AM_POST_STMT_next_dAM_ST1(AM_POST_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_PRE_STMT_next_dAM_STM1(AM_PRE_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_PROTECT_STMT_next_dAM1(AM_PROTECT_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_RAISE_STMT_next_dAM_S1(AM_RAISE_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_RETURN_STMT_next_dAM_1(AM_RETURN_STMT self, dAM_STMT next) {
 SATTR(self,next1,next);
}


void AM_ROUT_CALL_EXPR_aset_I(AM_ROUT_CALL_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void AM_ROUT_CALL_EXPR_asetb_(AM_ROUT_CALL_EXPR_asetb__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   AM_ROUT_CALL_EXPR_aset_I(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void AM_ROUT_CALL_EXPR_setb_d(AM_ROUT_CALL_EXPR_setb_d_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((AM_ROUT_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(AM_ROUT_CALL_EXPR_asetb__frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    AM_ROUT_CALL_EXPR_asetb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}

/* C for type ABSTRACT_FRAME_LAYOUT */




FLISTdLAYOUT ABSTRACT_FRAME_LAYOUT_de(ABSTRACT_FRAME_LAYOUT self) {
 FLISTdLAYOUT ret_val;
 FLISTdLAYOUT res;
 ARRAYdTP L11;
 dTP L2;
 BOOL L3;
 res = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
  ARRAYdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,sig11),args1);
    noname1->self = L11;
   }
   L2 = ARRAYdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), L2));
  }
 }
 after_loop: ;
 L3 = (ATTR(ATTR(self,sig11),ret1)==((dTP) NULL));
 if ((!(L3))) {
  res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), ATTR(ATTR(self,sig11),ret1)));
 }
 ret_val = res;
 return ret_val;
}

/* C for type ABSTRACT_LAYOUT */




STR ABSTRACT_LAYOUT_makestr_(ABSTRACT_LAYOUT self) {
 STR ret_val;
 dTP L1;
 STR L2;
 extern STR Abstract;
 L1 = ATTR(self,tp1);
 if (L1==NULL) {
  FATAL("Dispatch on void in ABSTRACT_LAYOUT::makestr:STR");
 }
 L2 = (*dTP_str_STR[TAG(L1)+dTP_str_STR_offset])(L1);
 ret_val = STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &Abstract)));
 return ret_val;
}

/* C for type AM_ANY_EXPR */




dTP AM_ANY_EXPR_tp_dTP(AM_ANY_EXPR self) {
 dTP ret_val;
 ret_val = ((dTP) TP_BUILTIN_int);
 return ret_val;
}

/* C for type AM_ARRAY_EXPR */




INT AM_ARRAY_EXPR_asize_INT(AM_ARRAY_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_ARR_CONST */




dTP AM_ARR_CONST_tp_dTP(AM_ARR_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_ARR_EXPR */




dTP AM_ARR_EXPR_tp_dTP(AM_ARR_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_ASSERT_STMT */




void AM_ASSERT_STMT_append_dA(AM_ASSERT_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_ASSERT_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_ASSERT_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_ASSERT_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_ASSIGN_STMT */




AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT self, SFILE_ID source1) {
 AM_ASSIGN_STMT ret_val;
 AM_ASSIGN_STMT r;
 AM_ASSIGN_STMT L1;
 L1 = ((AM_ASSIGN_STMT) rt_alloc(sizeof(struct AM_ASSIGN_STMT_struct), AM_ASSIGN_STMT_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}

/* C for type AM_ATTACH_STMT */




void AM_ATTACH_STMT_append_dA(AM_ATTACH_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_ATTACH_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_ATTACH_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_ATTACH_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_ATTR_EXPR */




dTP AM_ATTR_EXPR_tp_dTP(AM_ATTR_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_AT_EXPR */




dTP AM_AT_EXPR_tp_dTP(AM_AT_EXPR self) {
 dTP ret_val;
 dAM_EXPR L1;
 L1 = ATTR(self,e11);
 if (L1==NULL) {
  FATAL("Dispatch on void in AM_AT_EXPR::tp:$TP");
 }
 ret_val = (*dAM_EXPR_tp_dTP[TAG(L1)+dAM_EXPR_tp_dTP_offset])(L1);
 return ret_val;
}

/* C for type AM_BND_CREATE_EXPR */




INT AM_BND_CREATE_EXPR_asize(AM_BND_CREATE_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_BND_ITER_CALL_EXPR */




INT AM_BND_ITER_CALL_EXPR_as(AM_BND_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_BND_ROUT_CALL_EXPR */




INT AM_BND_ROUT_CALL_EXPR_as(AM_BND_ROUT_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_BOOL_CONST */




dTP AM_BOOL_CONST_tp_dTP(AM_BOOL_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_BREAK_STMT */




void AM_BREAK_STMT_append_dAM(AM_BREAK_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_BREAK_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_BREAK_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_BREAK_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_CASE_STMT */




void AM_CASE_STMT_append_dAM_(AM_CASE_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_CASE_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_CASE_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_CASE_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_CHAR_CONST */




dTP AM_CHAR_CONST_tp_dTP(AM_CHAR_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_CLUSTER_EXPR */




dTP AM_CLUSTER_EXPR_tp_dTP(AM_CLUSTER_EXPR self) {
 dTP ret_val;
 ret_val = ((dTP) TP_BUILTIN_int);
 return ret_val;
}

/* C for type AM_CONST */




dTP AM_CONST_tp_dTP(AM_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_EXCEPT_EXPR */




dTP AM_EXCEPT_EXPR_tp_dTP(AM_EXCEPT_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_EXPR_STMT */




void AM_EXPR_STMT_append_dAM_(AM_EXPR_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_EXPR_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_EXPR_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_EXPR_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_EXT_CALL_EXPR */




INT AM_EXT_CALL_EXPR_asize_I(AM_EXT_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_FAR_EXPR */




dTP AM_FAR_EXPR_tp_dTP(AM_FAR_EXPR self) {
 dTP ret_val;
 ret_val = ((dTP) TP_BUILTIN_bool);
 return ret_val;
}

/* C for type AM_FLTDX_CONST */




dTP AM_FLTDX_CONST_tp_dTP(AM_FLTDX_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_FLTD_CONST */




dTP AM_FLTD_CONST_tp_dTP(AM_FLTD_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_FLTI_CONST */




dTP AM_FLTI_CONST_tp_dTP(AM_FLTI_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_FLTX_CONST */




dTP AM_FLTX_CONST_tp_dTP(AM_FLTX_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_FLT_CONST */




dTP AM_FLT_CONST_tp_dTP(AM_FLT_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_GLOBAL_EXPR */




dTP AM_GLOBAL_EXPR_tp_dTP(AM_GLOBAL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_HERE_EXPR */




dTP AM_HERE_EXPR_tp_dTP(AM_HERE_EXPR self) {
 dTP ret_val;
 ret_val = ((dTP) TP_BUILTIN_int);
 return ret_val;
}

/* C for type AM_IF_EXPR */




dTP AM_IF_EXPR_tp_dTP(AM_IF_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_IF_STMT */




void AM_IF_STMT_append_dAM_ST(AM_IF_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_IF_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_IF_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_IF_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_INITIAL_STMT */




void AM_INITIAL_STMT_append_d(AM_INITIAL_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_INITIAL_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_INITIAL_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_INITIAL_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_INTI_CONST */




dTP AM_INTI_CONST_tp_dTP(AM_INTI_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_INT_CONST */




dTP AM_INT_CONST_tp_dTP(AM_INT_CONST self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_INVARIANT_STMT */




void AM_INVARIANT_STMT_append(AM_INVARIANT_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_INVARIANT_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_INVARIANT_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_INVARIANT_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_IS_VOID_EXPR */




dTP AM_IS_VOID_EXPR_tp_dTP(AM_IS_VOID_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_ITER_CALL_EXPR */




INT AM_ITER_CALL_EXPR_asize_(AM_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type AM_LOCAL_EXPR */




dTP AM_LOCAL_EXPR_tp_dTP(AM_LOCAL_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_LOCK_STMT */




void AM_LOCK_STMT_append_dAM_(AM_LOCK_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_LOCK_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_LOCK_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_LOCK_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_LOOP_STMT */




void AM_LOOP_STMT_append_dAM_(AM_LOOP_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_LOOP_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_LOOP_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_LOOP_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_NEAR_EXPR */




dTP AM_NEAR_EXPR_tp_dTP(AM_NEAR_EXPR self) {
 dTP ret_val;
 ret_val = ((dTP) TP_BUILTIN_bool);
 return ret_val;
}

/* C for type AM_NEW_EXPR */




dTP AM_NEW_EXPR_tp_dTP(AM_NEW_EXPR self) {
 dTP ret_val;
 ret_val = ATTR(self,tp_at);
 return ret_val;
}

/* C for type AM_OB_DEF */




AM_OB_DEF AM_OB_DEF_create_SFILE_I(AM_OB_DEF self, SFILE_ID source1) {
 AM_OB_DEF ret_val;
 AM_OB_DEF r;
 AM_OB_DEF L1;
 L1 = ((AM_OB_DEF) rt_alloc(sizeof(struct AM_OB_DEF_struct), AM_OB_DEF_tag));
 r = L1;
 SATTR(r,source11,source1);
 ret_val = r;
 return ret_val;
}

/* C for type AM_OUT */




void AM_OUT_AM_LOCAL_EXPR_out(AM_OUT self, AM_LOCAL_EXPR a) {
 OUT L1;
 extern STR voidAM_LOCAL_EXPR;
 BOOL L2;
 OUT L3;
 extern STR nonamenotype;
 OUT L4;
 extern STR noname1;
 OUT L5;
 dTP L6;
 OUT L7;
 OUT L8;
 extern STR notype;
 OUT L9;
 OUT L10;
 extern STR name30;
 OUT L11;
 dTP L12;
 if ((a==((AM_LOCAL_EXPR) NULL))) {
  L1 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L1, ((dSTR) ((STR) &voidAM_LOCAL_EXPR)));
  return;
 }
 if ((ATTR(a,name1).str==(STR)0)) {
  L2 = (ATTR(a,tp_at)==((dTP) NULL));
 } else {
  L2 = FALSE;
 }
 if (L2) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &nonamenotype)));
 }
 else {
  if ((ATTR(a,name1).str==(STR)0)) {
   L4 = OUT_create_OUT(((OUT) NULL));
   L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &noname1)));
   L6 = ATTR(a,tp_at);
   if (L6==NULL) {
    FATAL("Dispatch on void in AM_OUT::AM_LOCAL_EXPR_out(AM_LOCAL_EXPR)");
   }
   OUT_plus_dSTR(L5, ((dSTR) (*dTP_str_STR[TAG(L6)+dTP_str_STR_offset])(L6)));
  }
  else {
   if ((ATTR(a,tp_at)==((dTP) NULL))) {
    L7 = OUT_create_OUT(((OUT) NULL));
    L8 = OUT_plus_dSTR_OUT(L7, ((dSTR) ATTR(a,name1).str));
    OUT_plus_dSTR(L8, ((dSTR) ((STR) &notype)));
   }
   else {
    L9 = OUT_create_OUT(((OUT) NULL));
    L10 = OUT_plus_dSTR_OUT(L9, ((dSTR) ATTR(a,name1).str));
    L11 = OUT_plus_dSTR_OUT(L10, ((dSTR) ((STR) &name30)));
    L12 = ATTR(a,tp_at);
    if (L12==NULL) {
     FATAL("Dispatch on void in AM_OUT::AM_LOCAL_EXPR_out(AM_LOCAL_EXPR)");
    }
    OUT_plus_dSTR(L11, ((dSTR) (*dTP_str_STR[TAG(L12)+dTP_str_STR_offset])(L12)));
   }
  }
 }
}

/* C for type AM_POST_STMT */




void AM_POST_STMT_append_dAM_(AM_POST_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_POST_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_POST_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_POST_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_PRE_STMT */




void AM_PRE_STMT_append_dAM_S(AM_PRE_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_PRE_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_PRE_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_PRE_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_PROTECT_STMT */




void AM_PROTECT_STMT_append_d(AM_PROTECT_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_PROTECT_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_PROTECT_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_PROTECT_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_RAISE_STMT */




void AM_RAISE_STMT_append_dAM(AM_RAISE_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_RAISE_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_RAISE_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_RAISE_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_RETURN_STMT */




void AM_RETURN_STMT_append_dA(AM_RETURN_STMT self, dAM_STMT l) {
 dAM_STMT last1;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((ATTR(self,next1)==((dAM_STMT) NULL))) {
  SATTR(self,next1,l);
  return;
 }
 last1 = ATTR(self,next1);
 while (1) {
  L1 = last1;
  if (L1==NULL) {
   FATAL("Dispatch on void in AM_RETURN_STMT::append($AM_STMT)");
  }
  if (((*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1)==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = last1;
  if (L2==NULL) {
   FATAL("Dispatch on void in AM_RETURN_STMT::append($AM_STMT)");
  }
  last1 = (*dAM_STMT_next_dAM_STMT[TAG(L2)+dAM_STMT_next_dAM_STMT_offset])(L2);
 }
 after_loop: ;
 L3 = last1;
 if (L3==NULL) {
  FATAL("Dispatch on void in AM_RETURN_STMT::append($AM_STMT)");
 }
 (*dAM_STMT_next_dAM_STMT1[TAG(L3)+dAM_STMT_next_dAM_STMT1_offset])(L3, l);
}

/* C for type AM_ROUT_CALL_EXPR */




INT AM_ROUT_CALL_EXPR_asize_(AM_ROUT_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}
