#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dBACK_END_struct {
 OB_HEADER header;
 } *dBACK_END;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dPROG_ERR_struct {
 OB_HEADER header;
 } *dPROG_ERR;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_LAYOUT_struct {/* layout for ABSTRACT_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct PROG_struct *prog1;
 STR str1;
 } *ABSTRACT_LAYOUT;

typedef struct AM_OUT_struct {/* layout for AM_OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *AM_OUT;

typedef struct ARG_LAYOUT_struct {/* layout for ARG_LAYOUT */
 OB_HEADER header;
 struct SIG_struct *sig11;
 STR str1;
 } *ARG_LAYOUT;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;


typedef struct ARRAYdTP_eltb_dTP_frame_struct {
 ARRAYdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 ARRAYdTP L31;
 struct ARRAYdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdTP_eltb_dTP_frame;

typedef struct ARRAYFSTR_struct {/* layout for ARRAY{FSTR} */
 OB_HEADER header;
 INT asize;
 struct FSTR_struct *arr_part[1];
 } *ARRAYFSTR;

typedef struct ARRAYSTR_struct {/* layout for ARRAY{STR} */
 OB_HEADER header;
 INT asize;
 STR arr_part[1];
 } *ARRAYSTR;

typedef struct BOUND_OBJECT_LAYOUT_struct {/* layout for BOUND_OBJECT_LAYOUT */
 OB_HEADER header;
 struct AM_BND_CREATE_EXPR_struct *e11;
 STR str1;
 } *BOUND_OBJECT_LAYOUT;

typedef struct BOUND_TYPE_LAYOUT_struct {/* layout for BOUND_TYPE_LAYOUT */
 OB_HEADER header;
 STR str1;
 struct TP_ROUT_struct *tp1;
 } *BOUND_TYPE_LAYOUT;

typedef struct BUILTIN_LAYOUT_struct {/* layout for BUILTIN_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *BUILTIN_LAYOUT;

typedef struct CHANGE_VARS_struct {/* layout for CHANGE_VARS */
 OB_HEADER header;
 struct dAM_STMT_struct *init_hot1;
 struct dAM_STMT_struct *init_nonhot1;
 struct dAM_STMT_struct *init_parms1;
 struct dAM_STMT_struct *init_vars1;
 struct ARRAYINT_struct *pind_hot;
 struct ARRAYINT_struct *pind_nonhot;
 struct FLISTAM_LOCAL_EXPR_struct *new_vars;
 struct FLISTAM_LOCAL_EXPR_struct *saved_vars;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *new_subst;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *saved_subst;
 } *CHANGE_VARS;

typedef struct CHECK_AM_struct {/* layout for CHECK_AM */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *CHECK_AM;

typedef struct CHECK_IFC_CONFORMANCE_struct {/* layout for CHECK_IFC_CONFORMANCE */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *CHECK_IFC_CONFORMANCE;

typedef struct CLASS_LAYOUT_struct {/* layout for CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *CLASS_LAYOUT;

typedef struct CODE_FILE_ARRAY_struct {/* layout for CODE_FILE_ARRAY */
 OB_HEADER header;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *CODE_FILE_ARRAY;

typedef struct ELT_struct {/* layout for ELT */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *as1;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 BOOL is_private1;
 } *ELT;

typedef struct EXTERNAL_LAYOUT_struct {/* layout for EXTERNAL_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *EXTERNAL_LAYOUT;

typedef struct FILE1_struct {/* layout for FILE */
 OB_HEADER header;
 EXT_OB fp;
 } *FILE1;

typedef struct FRAME_LAYOUT_struct {/* layout for FRAME_LAYOUT */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *f1;
 struct PROG_struct *prog1;
 STR str1;
 } *FRAME_LAYOUT;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IFC_TBL_struct {/* layout for IFC_TBL */
 OB_HEADER header;
 struct FMAPdTPIFC_struct *tbl;
 struct FSETTUPIDENTINT_struct *abs_cur;
 struct PROG_struct *prog1;
 } *IFC_TBL;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;


typedef struct INT_downtob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_downtob_INT_INT_frame;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_upb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_upb_INT_frame;


typedef struct INT_uptob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_uptob_INT_INT_frame;

typedef struct LAYOUT_ARRAY_struct {/* layout for LAYOUT_ARRAY */
 OB_HEADER header;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *LAYOUT_ARRAY;


typedef struct LAYOUT_ARRAY_eltb_dLAYOU_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 INT state;
 dLAYOUT ret_val;
 LAYOUT_ARRAY L31;
 struct LAYOUT_ARRAY_aeltb_dLAYO_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARRAY_eltb_dLAYOU_frame;


typedef struct LAYOUT_ARRAY_setb_dLAYOU_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 dLAYOUT arg1;/* Formal argument: val */
 INT state;
 LAYOUT_ARRAY L21;
 struct LAYOUT_ARRAY_asetb_dLAYO_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARRAY_setb_dLAYOU_frame;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct RND_struct {/* layout for RND */
 OB_HEADER header;
 struct MS_RANDOM_GEN_struct *gen;
 } *RND;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SIG_TBL_struct {/* layout for SIG_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *SIG_TBL;


typedef struct SIG_TBL_eltb_SIG_frame_struct {
 SIG_TBL self;/* Formal argument: self */
 INT state;
 SIG ret_val;
 SIG_TBL L31;
 SIG r;
 struct SIG_TBL_aeltb_SIG_frame_struct *nested1; /* nested iter frame */
 } *SIG_TBL_eltb_SIG_frame;


typedef struct STR_separateb_STR_STR_frame_struct {
 STR self;/* Formal argument: self */
 STR arg1;/* Formal argument: s */
 INT state;
 STR ret_val;
 } *STR_separateb_STR_STR_frame;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_GRAPH_struct {/* layout for TP_GRAPH */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_GRAPH_ANC_struct *anc;
 struct TP_GRAPH_DES_struct *des1;
 } *TP_GRAPH;

typedef struct TP_GRAPH_ANC_struct {/* layout for TP_GRAPH_ANC */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *anc_tbl;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *par_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_ANC;

typedef struct TP_GRAPH_DES_struct {/* layout for TP_GRAPH_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *child_tbl;
 struct FMAPTP_CLASSFSETdTP_struct *des_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_DES;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TRANS_struct {/* layout for TRANS */
 OB_HEADER header;
 struct dAM_STMT_struct *cur_lock;
 struct dAM_STMT_struct *init_stmts;
 struct dTP_struct *ex_tp;
 struct AM_INVARIANT_STMT_struct *inv_stmt;
 struct AM_LOCAL_EXPR_struct *cur_cohort;
 struct AM_LOCAL_EXPR_struct *cur_par_ob;
 struct AM_LOCAL_EXPR_struct *cur_param_ob;
 struct AM_LOOP_STMT_struct *cur_loop;
 struct AM_POST_STMT_struct *post_stmt;
 struct AM_ROUT_DEF_struct *cur_rout;
 struct FLISTAM_LOCAL_EXPR_struct *active_locals;
 struct IMPL_struct *impl1;
 INT cur_yield_ind;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *tp_con;
 BOOL in_constant;
 BOOL in_external;
 BOOL in_initial;
 BOOL in_invariant;
 BOOL in_post;
 BOOL in_pre;
 BOOL in_protect_body;
 BOOL in_protect_then;
 } *TRANS;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPAM_BND_CREATE_EXPRBOU_struct {/* layout for TUP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct BOUND_OBJECT_LAYOUT_struct *t2;
 } TUPAM_BND_CREATE_EXPRBOU;
static TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU_zero;

typedef struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRBOU value_part;
 } *TUPAM_BND_CREATE_EXPRBOU_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct TUPIDENTdTP_struct {/* layout for TUP{IDENT,$TP} */
 struct dTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTdTP;
static TUPIDENTdTP TUPIDENTdTP_zero;

typedef struct TUPIDENTdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTdTP value_part;
 } *TUPIDENTdTP_boxed;

typedef struct TUPSIGAM_ROUT_DEF_struct {/* layout for TUP{SIG,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGAM_ROUT_DEF;
static TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_zero;

typedef struct TUPSIGAM_ROUT_DEF_boxed_struct {
 OB_HEADER header;
 TUPSIGAM_ROUT_DEF value_part;
 } *TUPSIGAM_ROUT_DEF_boxed;

typedef struct TUPSIGARG_LAYOUT_struct {/* layout for TUP{SIG,ARG_LAYOUT} */
 struct ARG_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGARG_LAYOUT;
static TUPSIGARG_LAYOUT TUPSIGARG_LAYOUT_zero;

typedef struct TUPSIGARG_LAYOUT_boxed_struct {
 OB_HEADER header;
 TUPSIGARG_LAYOUT value_part;
 } *TUPSIGARG_LAYOUT_boxed;

typedef struct TUPSIGSIG_struct {/* layout for TUP{SIG,SIG} */
 struct SIG_struct *t1;
 struct SIG_struct *t2;
 } TUPSIGSIG;
static TUPSIGSIG TUPSIGSIG_zero;

typedef struct TUPSIGSIG_boxed_struct {
 OB_HEADER header;
 TUPSIGSIG value_part;
 } *TUPSIGSIG_boxed;

typedef struct TUPSTRSTR_struct {/* layout for TUP{STR,STR} */
 STR t1;
 STR t2;
 } TUPSTRSTR;
static TUPSTRSTR TUPSTRSTR_zero;

typedef struct TUPSTRSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRSTR value_part;
 } *TUPSTRSTR_boxed;

typedef struct VALUE_CLASS_LAYOUT_struct {/* layout for VALUE_CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *VALUE_CLASS_LAYOUT;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_OB_DEF_struct {/* layout for AM_OB_DEF */
 OB_HEADER header;
 struct dTP_struct *arr1;
 struct dTP_struct *tp1;
 struct FMAPIDENTdTP_struct *at11;
 INT asize;
 struct SFILE_ID_struct source11;
 } *AM_OB_DEF;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;


typedef struct AM_ROUT_DEF_eltb_AM_LOCA_frame_struct {
 AM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 AM_ROUT_DEF L31;
 struct AM_ROUT_DEF_aeltb_AM_LOC_frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_DEF_eltb_AM_LOCA_frame;

typedef struct AM_VOID_CONST_struct {/* layout for AM_VOID_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_VOID_CONST;

typedef struct ARRAYBOOL_struct {/* layout for ARRAY{BOOL} */
 OB_HEADER header;
 INT asize;
 BOOL arr_part[1];
 } *ARRAYBOOL;

typedef struct ARRAYINT_struct {/* layout for ARRAY{INT} */
 OB_HEADER header;
 INT asize;
 INT arr_part[1];
 } *ARRAYINT;


typedef struct ARRAYINT_eltb_INT_frame_struct {
 ARRAYINT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 ARRAYINT L31;
 struct ARRAYINT_aeltb_INT_frame_struct *nested1; /* nested iter frame */
 } *ARRAYINT_eltb_INT_frame;


typedef struct ARRAYINT_setb_INT_frame_struct {
 ARRAYINT self;/* Formal argument: self */
 INT arg1;/* Formal argument: val */
 INT state;
 ARRAYINT L21;
 struct ARRAYINT_asetb_INT_frame_struct *nested1; /* nested iter frame */
 } *ARRAYINT_setb_INT_frame;


typedef struct ARRAYSTR_eltb_STR_frame_struct {
 ARRAYSTR self;/* Formal argument: self */
 INT state;
 STR ret_val;
 ARRAYSTR L31;
 struct ARRAYSTR_aeltb_STR_frame_struct *nested1; /* nested iter frame */
 } *ARRAYSTR_eltb_STR_frame;


typedef struct ARRAYSTR_setb_STR_frame_struct {
 ARRAYSTR self;/* Formal argument: self */
 STR arg1;/* Formal argument: val */
 INT state;
 ARRAYSTR L21;
 struct ARRAYSTR_asetb_STR_frame_struct *nested1; /* nested iter frame */
 } *ARRAYSTR_setb_STR_frame;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct CODE_FILE_struct {/* layout for CODE_FILE */
 OB_HEADER header;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTFSTR_struct *text1;
 struct FSETdLAYOUT_struct *layouts;
 struct FSETAM_GLOBAL_EXPR_struct *globals;
 struct FSETSIG_struct *decs;
 struct FSETSIG_struct *iters;
 struct FSETSTR_struct *externs1;
 struct FSETTUPSIGSIG_struct *unboxes;
 struct FSTR_struct *ntext;
 INT length1;
 STR name1;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL do_not_merge;
 BOOL is_c_code;
 } *CODE_FILE;


typedef struct CODE_FILE_ARRAY_aeltb_CO_frame_struct {
 CODE_FILE_ARRAY self;/* Formal argument: self */
 INT state;
 CODE_FILE ret_val;
 INT i;
 } *CODE_FILE_ARRAY_aeltb_CO_frame;


typedef struct CODE_FILE_ARRAY_asetb_CO_frame_struct {
 CODE_FILE_ARRAY self;/* Formal argument: self */
 CODE_FILE arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *CODE_FILE_ARRAY_asetb_CO_frame;


typedef struct CODE_FILE_ARRAY_eltb_COD_frame_struct {
 CODE_FILE_ARRAY self;/* Formal argument: self */
 INT state;
 CODE_FILE ret_val;
 CODE_FILE_ARRAY L31;
 struct CODE_FILE_ARRAY_aeltb_CO_frame_struct *nested1; /* nested iter frame */
 } *CODE_FILE_ARRAY_eltb_COD_frame;


typedef struct CODE_FILE_ARRAY_setb_COD_frame_struct {
 CODE_FILE_ARRAY self;/* Formal argument: self */
 CODE_FILE arg1;/* Formal argument: val */
 INT state;
 CODE_FILE_ARRAY L21;
 struct CODE_FILE_ARRAY_asetb_CO_frame_struct *nested1; /* nested iter frame */
 } *CODE_FILE_ARRAY_setb_COD_frame;

typedef struct ELT_TBL_struct {/* layout for ELT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ELT_struct *arr_part[1];
 } *ELT_TBL;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;


typedef struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct {
 FLISTdLAYOUT self;/* Formal argument: self */
 INT state;
 dLAYOUT ret_val;
 FLISTdLAYOUT L31;
 INT L41;
 INT L51;
 struct FLISTdLAYOUT_aeltb_INT_I_frame_struct *nested1; /* nested iter frame */
 } *FLISTdLAYOUT_eltb_dLAYOU_frame;

typedef struct FLISTAM_BND_CREATE_EXPR_struct {/* layout for FLIST{AM_BND_CREATE_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_CREATE_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_CREATE_EXPR;


typedef struct FLISTAM_BND_CREATE_EXPR_4_frame_struct {
 FLISTAM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 AM_BND_CREATE_EXPR ret_val;
 FLISTAM_BND_CREATE_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_BND_CREATE_EXPR_3_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_CREATE_EXPR_4_frame;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FLISTCODE_FILE_struct {/* layout for FLIST{CODE_FILE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *FLISTCODE_FILE;


typedef struct FLISTCODE_FILE_eltb_CODE_frame_struct {
 FLISTCODE_FILE self;/* Formal argument: self */
 INT state;
 CODE_FILE ret_val;
 FLISTCODE_FILE L31;
 INT L41;
 INT L51;
 struct FLISTCODE_FILE_aeltb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTCODE_FILE_eltb_CODE_frame;

typedef struct FLISTFSTR_struct {/* layout for FLIST{FSTR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FSTR_struct *arr_part[1];
 } *FLISTFSTR;

typedef struct FLISTSTR_struct {/* layout for FLIST{STR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 STR arr_part[1];
 } *FLISTSTR;


typedef struct FLISTSTR_eltb_STR_frame_struct {
 FLISTSTR self;/* Formal argument: self */
 INT state;
 STR ret_val;
 FLISTSTR L31;
 INT L41;
 INT L51;
 struct FLISTSTR_aeltb_INT_INT_S_frame_struct *nested1; /* nested iter frame */
 } *FLISTSTR_eltb_STR_frame;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPAM_BND_CREATE_EXPRBO_struct {/* layout for FMAP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_BND_CREATE_EXPRBOU_struct arr_part[1];
 } *FMAPAM_BND_CREATE_EXPRBO;


typedef struct FMAPAM_BND_CREATE_EXPRBO19_frame_struct {
 FMAPAM_BND_CREATE_EXPRBO self;/* Formal argument: self */
 INT state;
 BOUND_OBJECT_LAYOUT ret_val;
 FMAPAM_BND_CREATE_EXPRBO L31;
 TUPAM_BND_CREATE_EXPRBOU e;
 struct FMAPAM_BND_CREATE_EXPRBO13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_BND_CREATE_EXPRBO19_frame;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;

typedef struct FMAPAM_ROUT_DEFFRAME_LAY_struct {/* layout for FMAP{AM_ROUT_DEF,FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFRAME_LAYO_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFRAME_LAY;


typedef struct FMAPAM_ROUT_DEFFRAME_LAY19_frame_struct {
 FMAPAM_ROUT_DEFFRAME_LAY self;/* Formal argument: self */
 INT state;
 FRAME_LAYOUT ret_val;
 FMAPAM_ROUT_DEFFRAME_LAY L31;
 TUPAM_ROUT_DEFFRAME_LAYO e;
 struct FMAPAM_ROUT_DEFFRAME_LAY13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFRAME_LAY19_frame;

typedef struct FMAPIDENTdTP_struct {/* layout for FMAP{IDENT,$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *FMAPIDENTdTP;


typedef struct FMAPIDENTdTP_pairsb_TUPI_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP r;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_pairsb_TUPI_frame;


typedef struct FMAPIDENTdTP_targetsb_dT_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP e;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_targetsb_dT_frame;

typedef struct FMAPSIGAM_ROUT_DEF_struct {/* layout for FMAP{SIG,AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGAM_ROUT_DEF_struct arr_part[1];
 } *FMAPSIGAM_ROUT_DEF;

typedef struct FMAPSIGARG_LAYOUT_struct {/* layout for FMAP{SIG,ARG_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGARG_LAYOUT_struct arr_part[1];
 } *FMAPSIGARG_LAYOUT;


typedef struct FMAPSIGARG_LAYOUT_target_frame_struct {
 FMAPSIGARG_LAYOUT self;/* Formal argument: self */
 INT state;
 ARG_LAYOUT ret_val;
 FMAPSIGARG_LAYOUT L31;
 TUPSIGARG_LAYOUT e;
 struct FMAPSIGARG_LAYOUT_aeltb__frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGARG_LAYOUT_target_frame;

typedef struct FMAPSTRSTR_struct {/* layout for FMAP{STR,STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSTR_struct arr_part[1];
 } *FMAPSTRSTR;

typedef struct FSETdLAYOUT_struct {/* layout for FSET{$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FSETdLAYOUT;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;


typedef struct FSETdTP_eltb_dTP_frame_struct {
 FSETdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FSETdTP L31;
 dTP r;
 struct FSETdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *FSETdTP_eltb_dTP_frame;

typedef struct FSETABSTRACT_LAYOUT_struct {/* layout for FSET{ABSTRACT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ABSTRACT_LAYOUT_struct *arr_part[1];
 } *FSETABSTRACT_LAYOUT;


typedef struct FSETABSTRACT_LAYOUT_eltb_frame_struct {
 FSETABSTRACT_LAYOUT self;/* Formal argument: self */
 INT state;
 ABSTRACT_LAYOUT ret_val;
 FSETABSTRACT_LAYOUT L31;
 ABSTRACT_LAYOUT r;
 struct FSETABSTRACT_LAYOUT_aelt_frame_struct *nested1; /* nested iter frame */
 } *FSETABSTRACT_LAYOUT_eltb_frame;

typedef struct FSETAM_GLOBAL_EXPR_struct {/* layout for FSET{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FSETAM_GLOBAL_EXPR;


typedef struct FSETAM_GLOBAL_EXPR_eltb__frame_struct {
 FSETAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR L31;
 AM_GLOBAL_EXPR r;
 struct FSETAM_GLOBAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FSETAM_GLOBAL_EXPR_eltb__frame;

typedef struct FSETBOUND_TYPE_LAYOUT_struct {/* layout for FSET{BOUND_TYPE_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BOUND_TYPE_LAYOUT_struct *arr_part[1];
 } *FSETBOUND_TYPE_LAYOUT;


typedef struct FSETBOUND_TYPE_LAYOUT_el1_frame_struct {
 FSETBOUND_TYPE_LAYOUT self;/* Formal argument: self */
 INT state;
 BOUND_TYPE_LAYOUT ret_val;
 FSETBOUND_TYPE_LAYOUT L31;
 BOUND_TYPE_LAYOUT r;
 struct FSETBOUND_TYPE_LAYOUT_ae_frame_struct *nested1; /* nested iter frame */
 } *FSETBOUND_TYPE_LAYOUT_el1_frame;

typedef struct FSETBUILTIN_LAYOUT_struct {/* layout for FSET{BUILTIN_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BUILTIN_LAYOUT_struct *arr_part[1];
 } *FSETBUILTIN_LAYOUT;


typedef struct FSETBUILTIN_LAYOUT_eltb__frame_struct {
 FSETBUILTIN_LAYOUT self;/* Formal argument: self */
 INT state;
 BUILTIN_LAYOUT ret_val;
 FSETBUILTIN_LAYOUT L31;
 BUILTIN_LAYOUT r;
 struct FSETBUILTIN_LAYOUT_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FSETBUILTIN_LAYOUT_eltb__frame;

typedef struct FSETCLASS_LAYOUT_struct {/* layout for FSET{CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct CLASS_LAYOUT_struct *arr_part[1];
 } *FSETCLASS_LAYOUT;


typedef struct FSETCLASS_LAYOUT_eltb_CL_frame_struct {
 FSETCLASS_LAYOUT self;/* Formal argument: self */
 INT state;
 CLASS_LAYOUT ret_val;
 FSETCLASS_LAYOUT L31;
 CLASS_LAYOUT r;
 struct FSETCLASS_LAYOUT_aeltb_C_frame_struct *nested1; /* nested iter frame */
 } *FSETCLASS_LAYOUT_eltb_CL_frame;

typedef struct FSETEXTERNAL_LAYOUT_struct {/* layout for FSET{EXTERNAL_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct EXTERNAL_LAYOUT_struct *arr_part[1];
 } *FSETEXTERNAL_LAYOUT;


typedef struct FSETEXTERNAL_LAYOUT_eltb_frame_struct {
 FSETEXTERNAL_LAYOUT self;/* Formal argument: self */
 INT state;
 EXTERNAL_LAYOUT ret_val;
 FSETEXTERNAL_LAYOUT L31;
 EXTERNAL_LAYOUT r;
 struct FSETEXTERNAL_LAYOUT_aelt_frame_struct *nested1; /* nested iter frame */
 } *FSETEXTERNAL_LAYOUT_eltb_frame;

typedef struct FSETSIG_struct {/* layout for FSET{SIG} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *FSETSIG;


typedef struct FSETSIG_eltb_SIG_frame_struct {
 FSETSIG self;/* Formal argument: self */
 INT state;
 SIG ret_val;
 FSETSIG L31;
 SIG r;
 struct FSETSIG_aeltb_SIG_frame_struct *nested1; /* nested iter frame */
 } *FSETSIG_eltb_SIG_frame;

typedef struct FSETSTR_struct {/* layout for FSET{STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 STR arr_part[1];
 } *FSETSTR;


typedef struct FSETSTR_eltb_STR_frame_struct {
 FSETSTR self;/* Formal argument: self */
 INT state;
 STR ret_val;
 FSETSTR L31;
 STR r;
 struct FSETSTR_aeltb_STR_frame_struct *nested1; /* nested iter frame */
 } *FSETSTR_eltb_STR_frame;

typedef struct FSETTP_CLASS_struct {/* layout for FSET{TP_CLASS} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_CLASS_struct *arr_part[1];
 } *FSETTP_CLASS;


typedef struct FSETTP_CLASS_eltb_TP_CLA_frame_struct {
 FSETTP_CLASS self;/* Formal argument: self */
 INT state;
 TP_CLASS ret_val;
 FSETTP_CLASS L31;
 TP_CLASS r;
 struct FSETTP_CLASS_aeltb_TP_CL_frame_struct *nested1; /* nested iter frame */
 } *FSETTP_CLASS_eltb_TP_CLA_frame;

typedef struct FSETTUPSIGSIG_struct {/* layout for FSET{TUP{SIG,SIG}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGSIG_struct arr_part[1];
 } *FSETTUPSIGSIG;


typedef struct FSETTUPSIGSIG_eltb_TUPSI_frame_struct {
 FSETTUPSIGSIG self;/* Formal argument: self */
 INT state;
 TUPSIGSIG ret_val;
 FSETTUPSIGSIG L31;
 TUPSIGSIG r;
 struct FSETTUPSIGSIG_aeltb_TUPS_frame_struct *nested1; /* nested iter frame */
 } *FSETTUPSIGSIG_eltb_TUPSI_frame;

typedef struct FSETVALUE_CLASS_LAYOUT_struct {/* layout for FSET{VALUE_CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct VALUE_CLASS_LAYOUT_struct *arr_part[1];
 } *FSETVALUE_CLASS_LAYOUT;


typedef struct FSETVALUE_CLASS_LAYOUT_e1_frame_struct {
 FSETVALUE_CLASS_LAYOUT self;/* Formal argument: self */
 INT state;
 VALUE_CLASS_LAYOUT ret_val;
 FSETVALUE_CLASS_LAYOUT L31;
 VALUE_CLASS_LAYOUT r;
 struct FSETVALUE_CLASS_LAYOUT_a5_frame_struct *nested1; /* nested iter frame */
 } *FSETVALUE_CLASS_LAYOUT_e1_frame;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct LAYOUT_ARR_struct {/* layout for LAYOUT_ARR */
 OB_HEADER header;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *LAYOUT_ARR;


typedef struct LAYOUT_ARR_eltb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 LAYOUT_ARR L31;
 struct LAYOUT_ARR_aeltb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_eltb_TUPIDENT_frame;


typedef struct LAYOUT_ARR_setb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 TUPIDENTdTP arg1;/* Formal argument: val */
 INT state;
 LAYOUT_ARR L21;
 struct LAYOUT_ARR_asetb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_setb_TUPIDENT_frame;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;


typedef struct ARRAYFSTR_eltb_FSTR_frame_struct {
 ARRAYFSTR self;/* Formal argument: self */
 INT state;
 FSTR ret_val;
 ARRAYFSTR L31;
 struct ARRAYFSTR_aeltb_FSTR_frame_struct *nested1; /* nested iter frame */
 } *ARRAYFSTR_eltb_FSTR_frame;


typedef struct ARRAYFSTR_setb_FSTR_frame_struct {
 ARRAYFSTR self;/* Formal argument: self */
 FSTR arg1;/* Formal argument: val */
 INT state;
 ARRAYFSTR L21;
 struct ARRAYFSTR_asetb_FSTR_frame_struct *nested1; /* nested iter frame */
 } *ARRAYFSTR_setb_FSTR_frame;


typedef struct FLISTFSTR_eltb_FSTR_frame_struct {
 FLISTFSTR self;/* Formal argument: self */
 INT state;
 FSTR ret_val;
 FLISTFSTR L31;
 INT L41;
 INT L51;
 struct FLISTFSTR_aeltb_INT_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTFSTR_eltb_FSTR_frame;

#include "tags.h"

/* Globals */

extern CGEN CODE_FILE_cgen;
extern CGEN LAYOUT_TBL_cgen;
extern FLISTCODE_FILE CODE_FILE_all;
extern FLISTCODE_FILE CODE_FILE_todo;
extern FLISTSTR CODE_FILE_layout_text;
extern FLISTdLAYOUT CODE_FILE_layout_order;
extern FMAPAM_BND_CREATE_EXPRBO BOUND_OBJECT_LAYOUT_layo1;
extern FMAPAM_ROUT_DEFFRAME_LAY FRAME_LAYOUT_layouts;
extern FMAPSIGAM_ROUT_DEF CODE_FILE_iter_sigs;
extern FMAPSIGARG_LAYOUT ARG_LAYOUT_layouts;
extern FMAPSTRSTR CODE_FILE_thumbprints;
extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSETABSTRACT_LAYOUT ABSTRACT_LAYOUT_layouts;
extern FSETBOUND_TYPE_LAYOUT BOUND_TYPE_LAYOUT_layout1;
extern FSETBUILTIN_LAYOUT BUILTIN_LAYOUT_layouts;
extern FSETCLASS_LAYOUT CLASS_LAYOUT_layouts;
extern FSETEXTERNAL_LAYOUT EXTERNAL_LAYOUT_layouts;
extern FSETVALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_layou1;
extern INT CODE_FILE_ARRAY_quicksor1;
extern INT TP_KIND_ext_tp;
extern PROG CODE_FILE_prog;
extern STR CODE_FILE_dir;

/* Function declarations */

ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_eltb(FSETABSTRACT_LAYOUT_eltb_frame);
AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT, SFILE_ID);
AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_4(FLISTAM_BND_CREATE_EXPR_4_frame);
AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_eltb_(FSETAM_GLOBAL_EXPR_eltb__frame);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI2(AM_LOCAL_EXPR, SFILE_ID);
AM_LOCAL_EXPR AM_ROUT_DEF_eltb_AM_LOCA(AM_ROUT_DEF_eltb_AM_LOCA_frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_OB_DEF CGEN_am_ob_def_for_tp_dT(CGEN, dTP);
AM_ROUT_DEF FMAPSIGAM_ROUT_DEF_get_S(FMAPSIGAM_ROUT_DEF, SIG);
AM_ROUT_DEF TRANS_transform_elt_ELT_(TRANS, ELT);
AM_VOID_CONST AM_VOID_CONST_create_SFI(AM_VOID_CONST, SFILE_ID);
ARG_LAYOUT FMAPSIGARG_LAYOUT_target(FMAPSIGARG_LAYOUT_target_frame);
ARRAYFSTR ARRAYFSTR_create_INT_ARR(ARRAYFSTR, INT);
ARRAYINT ARRAYINT_create_INT_ARRA(ARRAYINT, INT);
ARRAYSTR ARRAYSTR_create_INT_ARRA(ARRAYSTR, INT);
BOOL AM_ROUT_DEF_is_iter_BOOL(AM_ROUT_DEF);
BOOL ARRAYBOOL_aget_INT_BOOL(ARRAYBOOL, INT);
BOOL CGEN_is_built_in_type_dT(CGEN, dTP);
BOOL CHAR_is_alpha_BOOL(CHAR);
BOOL CHAR_is_alphanum_BOOL(CHAR);
BOOL CHAR_is_digit_BOOL(CHAR);
BOOL CHAR_is_gt_CHAR_BOOL(CHAR, CHAR);
BOOL CHAR_is_hex_digit_BOOL(CHAR);
BOOL CHAR_is_lower_BOOL(CHAR);
BOOL CHAR_is_lt_CHAR_BOOL(CHAR, CHAR);
BOOL CHAR_is_print_BOOL(CHAR);
BOOL CHAR_is_space_BOOL(CHAR);
BOOL CHAR_is_upper_BOOL(CHAR);
BOOL CODE_FILE_ARRAY_elt_lt_C(CODE_FILE_ARRAY, CODE_FILE, CODE_FILE);
BOOL CODE_FILE_ARRAY_is_sorte(CODE_FILE_ARRAY);
BOOL CODE_FILE_same_options_a(CODE_FILE, CODE_FILE);
BOOL ELT_is_abstract_BOOL(ELT);
BOOL FILE_eof_BOOL(FILE1);
BOOL FILE_error_BOOL(FILE1);
BOOL FLISTdLAYOUT_is_empty_BO(FLISTdLAYOUT);
BOOL FSETdLAYOUT_test_dLAYOUT(FSETdLAYOUT, dLAYOUT);
BOOL IFC_conforms_to_IFC_BOOL(IFC, IFC);
BOOL SIG_is_iter_BOOL(SIG);
BOOL STR_is_lt_STR_BOOL(STR, STR);
BOOL STR_is_neq_STR_BOOL(STR, STR);
BOOL TP_CLASS_is_abstract_BOO(TP_CLASS);
BOUND_OBJECT_LAYOUT FMAPAM_BND_CREATE_EXPRBO19(FMAPAM_BND_CREATE_EXPRBO19_frame);
BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_el1(FSETBOUND_TYPE_LAYOUT_el1_frame);
BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_eltb_(FSETBUILTIN_LAYOUT_eltb__frame);
CHANGE_VARS CHANGE_VARS_create_AM_RO(CHANGE_VARS, AM_ROUT_DEF);
CHAR CHAR_upper_CHAR(CHAR);
CHAR FILE_get_char_CHAR(FILE1);
CHECK_AM CHECK_AM_create_PROG_CHE(CHECK_AM, PROG);
CHECK_IFC_CONFORMANCE CHECK_IFC_CONFORMANCE_cr(CHECK_IFC_CONFORMANCE, PROG);
CLASS_LAYOUT CLASS_LAYOUT_create_dTP_(CLASS_LAYOUT, dTP, PROG);
CLASS_LAYOUT FSETCLASS_LAYOUT_eltb_CL(FSETCLASS_LAYOUT_eltb_CL_frame);
CODE_FILE CODE_FILE_ARRAY_aeltb_CO(CODE_FILE_ARRAY_aeltb_CO_frame);
CODE_FILE CODE_FILE_ARRAY_aget_INT(CODE_FILE_ARRAY, INT);
CODE_FILE CODE_FILE_ARRAY_eltb_COD(CODE_FILE_ARRAY_eltb_COD_frame);
CODE_FILE CODE_FILE_create_STR_COD(CODE_FILE, STR);
CODE_FILE CODE_FILE_plus_dSTR_CODE(CODE_FILE, dSTR);
CODE_FILE FLISTCODE_FILE_eltb_CODE(FLISTCODE_FILE_eltb_CODE_frame);
CODE_FILE_ARRAY CODE_FILE_ARRAY_create_I(CODE_FILE_ARRAY, INT);
ELT ELT_TBL_elt_with_sig_SIG(ELT_TBL, SIG);
EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_eltb(FSETEXTERNAL_LAYOUT_eltb_frame);
FILE1 FILE_open_for_read_STR_F(FILE1, STR);
FILE1 FILE_open_for_write_STR_(FILE1, STR);
FILE1 FILE_plus_dSTR_FILE(FILE1, dSTR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_10(FLISTAM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_18(FLISTAM_BND_CREATE_EXPR, FLISTAM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_6(FLISTAM_BND_CREATE_EXPR);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_creat(FLISTAM_LOCAL_EXPR, INT);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR, AM_LOCAL_EXPR);
FLISTCODE_FILE FLISTCODE_FILE_create_FL(FLISTCODE_FILE);
FLISTCODE_FILE FLISTCODE_FILE_push_CODE(FLISTCODE_FILE, CODE_FILE);
FLISTFSTR FLISTFSTR_concat_FLISTFS(FLISTFSTR, FLISTFSTR);
FLISTFSTR FLISTFSTR_create_FLISTFS(FLISTFSTR);
FLISTFSTR FLISTFSTR_push_FSTR_FLIS(FLISTFSTR, FSTR);
FLISTSTR FLISTSTR_create_FLISTSTR(FLISTSTR);
FLISTSTR FLISTSTR_push_STR_FLISTS(FLISTSTR, STR);
FLISTdLAYOUT CLASS_LAYOUT_dependencie(CLASS_LAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT, dLAYOUT);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA14(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR, AM_LOCAL_EXPR);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA6(FMAPAM_LOCAL_EXPRAM_LOCA, INT);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_creat(FMAPSIGAM_ROUT_DEF);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_inser1(FMAPSIGAM_ROUT_DEF, SIG, AM_ROUT_DEF);
FMAPSTRSTR FMAPSTRSTR_insert_STR_ST(FMAPSTRSTR, STR, STR);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY19(FMAPAM_ROUT_DEFFRAME_LAY19_frame);
FRAME_LAYOUT FRAME_LAYOUT_create_AM_R(FRAME_LAYOUT, AM_ROUT_DEF, PROG);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_creat(FSETAM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_inser(FSETAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_union(FSETAM_GLOBAL_EXPR, FSETAM_GLOBAL_EXPR);
FSETCLASS_LAYOUT FSETCLASS_LAYOUT_insert_(FSETCLASS_LAYOUT, CLASS_LAYOUT);
FSETSIG FSETSIG_create_FSETSIG(FSETSIG);
FSETSIG FSETSIG_insert_SIG_FSETS(FSETSIG, SIG);
FSETSIG FSETSIG_union_FSETSIG_FS(FSETSIG, FSETSIG);
FSETSTR FSETSTR_create_FSETSTR(FSETSTR);
FSETSTR FSETSTR_insert_STR_FSETS(FSETSTR, STR);
FSETSTR FSETSTR_union_FSETSTR_FS(FSETSTR, FSETSTR);
FSETTP_CLASS TP_GRAPH_ANC_get_parents(TP_GRAPH_ANC, TP_CLASS);
FSETTUPSIGSIG FSETTUPSIGSIG_create_FSE(FSETTUPSIGSIG);
FSETTUPSIGSIG FSETTUPSIGSIG_insert_TUP(FSETTUPSIGSIG, TUPSIGSIG);
FSETTUPSIGSIG FSETTUPSIGSIG_union_FSET(FSETTUPSIGSIG, FSETTUPSIGSIG);
FSETdLAYOUT FSETdLAYOUT_create_FSETd(FSETdLAYOUT);
FSETdLAYOUT FSETdLAYOUT_insert_dLAYO(FSETdLAYOUT, dLAYOUT);
FSETdLAYOUT FSETdLAYOUT_union_FSETdL(FSETdLAYOUT, FSETdLAYOUT);
FSETdTP TP_GRAPH_DES_get_childre(TP_GRAPH_DES, TP_CLASS);
FSTR ARRAYFSTR_eltb_FSTR(ARRAYFSTR_eltb_FSTR_frame);
FSTR CODE_FILE_header_info_FS(CODE_FILE);
FSTR FLISTFSTR_eltb_FSTR(FLISTFSTR_eltb_FSTR_frame);
FSTR FSTR_create_FSTR(FSTR);
FSTR FSTR_plus_FSTR_FSTR(FSTR, FSTR);
FSTR FSTR_plus_STR_FSTR(FSTR, STR);
IDENT IDENT_create_STR_IDENT(IDENT, STR);
IFC IFC_TBL_ifc_of_dTP_IFC(IFC_TBL, dTP);
IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL, dTP);
INT AM_ROUT_DEF_size_INT(AM_ROUT_DEF);
INT ARRAYFSTR_size_INT(ARRAYFSTR);
INT ARRAYINT_eltb_INT(ARRAYINT_eltb_INT_frame);
INT CHAR_digit_value_INT(CHAR);
INT CHAR_hash_INT(CHAR);
INT CHAR_hex_digit_value_INT(CHAR);
INT CHAR_octal_digit_value_I(CHAR);
INT CODE_FILE_ARRAY_asize_IN(CODE_FILE_ARRAY);
INT FLISTAM_BND_CREATE_EXPR_11(FLISTAM_BND_CREATE_EXPR);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTCODE_FILE_size_INT(FLISTCODE_FILE);
INT FLISTFSTR_size_INT(FLISTFSTR);
INT FLISTdLAYOUT_size_INT(FLISTdLAYOUT);
INT FMAPIDENTdTP_size_INT(FMAPIDENTdTP);
INT FSETAM_GLOBAL_EXPR_size_(FSETAM_GLOBAL_EXPR);
INT FSETSIG_size_INT(FSETSIG);
INT FSETSTR_size_INT(FSETSTR);
INT FSETTUPSIGSIG_size_INT(FSETTUPSIGSIG);
INT FSETdTP_size_INT(FSETdTP);
INT FSTR_length_INT(FSTR);
INT INT_downtob_INT_INT(INT_downtob_INT_INT_frame);
INT INT_hash_INT(INT);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_upb_INT(INT_upb_INT_frame);
INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame);
INT RND_int_INT_INT_INT(RND, INT, INT);
INT STR_size_INT(STR);
LAYOUT_ARR CLASS_LAYOUT_sorted_fiel(CLASS_LAYOUT, FMAPIDENTdTP);
LAYOUT_ARR LAYOUT_ARR_create_INT_LA(LAYOUT_ARR, INT);
LAYOUT_ARRAY LAYOUT_ARRAY_create_INT_(LAYOUT_ARRAY, INT);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
SIG FSETSIG_eltb_SIG(FSETSIG_eltb_SIG_frame);
SIG IFC_nonconforming_sig_IF(IFC, IFC);
SIG SIG_TBL_eltb_SIG(SIG_TBL_eltb_SIG_frame);
STR ARRAYSTR_eltb_STR(ARRAYSTR_eltb_STR_frame);
STR CHAR_pretty_STR(CHAR);
STR CHAR_str_STR(CHAR);
STR CLASS_LAYOUT_str_STR(CLASS_LAYOUT);
STR CLASS_LAYOUT_typedef_CGE(CLASS_LAYOUT, CGEN);
STR CODE_FILE_bnd_rout_decla(CODE_FILE);
STR CODE_FILE_declaration_fo(CODE_FILE, SIG);
STR CODE_FILE_mang_dOB_STR(CODE_FILE, OB);
STR CODE_FILE_merge_STR(CODE_FILE);
STR CODE_FILE_unbox_dec_SIG_(CODE_FILE, SIG, SIG);
STR FILE_get_str_STR(FILE1);
STR FLISTSTR_eltb_STR(FLISTSTR_eltb_STR_frame);
STR FMAPSTRSTR_get_STR_STR(FMAPSTRSTR, STR);
STR FSETSTR_eltb_STR(FSETSTR_eltb_STR_frame);
STR FSTR_thumbprint_STR(FSTR);
STR INT_octal_str_STR(INT);
STR MANGLE_mangle_dOB_dOB_ST(MANGLE, OB, OB);
STR STR_append_STR_STR_STR(STR, STR, STR);
STR STR_create_CHAR_STR(STR, CHAR);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_replace_suffix_STR_S(STR, STR, STR);
STR STR_separateb_STR_STR(STR_separateb_STR_STR_frame);
STR STR_tail_INT_STR(STR, INT);
STR TP_CLASS_str_STR(TP_CLASS);
TP_CLASS FSETTP_CLASS_eltb_TP_CLA(FSETTP_CLASS_eltb_TP_CLA_frame);
TUPIDENTdTP FMAPIDENTdTP_pairsb_TUPI(FMAPIDENTdTP_pairsb_TUPI_frame);
TUPIDENTdTP LAYOUT_ARR_eltb_TUPIDENT(LAYOUT_ARR_eltb_TUPIDENT_frame);
TUPSIGSIG FSETTUPSIGSIG_eltb_TUPSI(FSETTUPSIGSIG_eltb_TUPSI_frame);
TUPSIGSIG TUPSIGSIG_create_SIG_SIG(TUPSIGSIG, SIG, SIG);
VALUE_CLASS_LAYOUT FSETVALUE_CLASS_LAYOUT_e1(FSETVALUE_CLASS_LAYOUT_e1_frame);
dLAYOUT FLISTdLAYOUT_aget_INT_dL(FLISTdLAYOUT, INT);
dLAYOUT FLISTdLAYOUT_eltb_dLAYOU(FLISTdLAYOUT_eltb_dLAYOU_frame);
dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT, dTP);
dLAYOUT LAYOUT_ARRAY_eltb_dLAYOU(LAYOUT_ARRAY_eltb_dLAYOU_frame);
dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL, dTP);
dTP AM_GLOBAL_EXPR_tp_dTP(AM_GLOBAL_EXPR);
dTP ARRAYdTP_aget_INT_dTP(ARRAYdTP, INT);
dTP ARRAYdTP_eltb_dTP(ARRAYdTP_eltb_dTP_frame);
dTP FMAPIDENTdTP_targetsb_dT(FMAPIDENTdTP_targetsb_dT_frame);
dTP FSETdTP_eltb_dTP(FSETdTP_eltb_dTP_frame);
extern const int dAM_STMT_append_dAM_STMT_offset;

extern const  (*dAM_STMT_append_dAM_STMT[])(dAM_STMT, dAM_STMT);
extern const int dBACK_END_emit_AM_ROUT_D_offset;

extern const  (*dBACK_END_emit_AM_ROUT_D[])(dBACK_END, AM_ROUT_DEF);
extern const int dLAYOUT_dependencies_FLI_offset;

extern const FLISTdLAYOUT (*dLAYOUT_dependencies_FLI[])(dLAYOUT);
extern const int dLAYOUT_str_STR_offset;

extern const STR (*dLAYOUT_str_STR[])(dLAYOUT);
extern const int dLAYOUT_typedef_CGEN_STR_offset;

extern const STR (*dLAYOUT_typedef_CGEN_STR[])(dLAYOUT, CGEN);
extern const int dSTR_str_STR_offset;

extern const STR (*dSTR_str_STR[])(dSTR);
extern const int dTP_is_abstract_BOOL_offset;

extern const BOOL (*dTP_is_abstract_BOOL[])(dTP);
extern const int dTP_is_value_BOOL_offset;

extern const BOOL (*dTP_is_value_BOOL[])(dTP);
extern const int dTP_kind_INT_offset;

extern const INT (*dTP_kind_INT[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void AM_OUT_AM_ROUT_DEF_out_A(AM_OUT, AM_ROUT_DEF);
void ARRAYFSTR_aset_INT_FSTR(ARRAYFSTR, INT, FSTR);
void ARRAYFSTR_setb_FSTR(ARRAYFSTR_setb_FSTR_frame);
void ARRAYFSTR_sort(ARRAYFSTR);
void ARRAYINT_setb_INT(ARRAYINT_setb_INT_frame);
void ARRAYSTR_setb_STR(ARRAYSTR_setb_STR_frame);
void ARRAYSTR_sort(ARRAYSTR);
void CGEN_barf_STR(CGEN, STR);
void CHANGE_VARS_after_one_us(CHANGE_VARS);
void CHANGE_VARS_after_saving(CHANGE_VARS);
void CHANGE_VARS_new_copy_SFI(CHANGE_VARS, SFILE_ID);
void CHECK_AM_check_code(CHECK_AM);
void CHECK_AM_check_sig_SIG(CHECK_AM, SIG);
void CHECK_IFC_CONFORMANCE_ch(CHECK_IFC_CONFORMANCE);
void CHECK_IFC_CONFORMANCE_er(CHECK_IFC_CONFORMANCE, dPROG_ERR);
void CHECK_IFC_CONFORMANCE_er1(CHECK_IFC_CONFORMANCE, STR);
void CLASS_LAYOUT_layouts_FSE(CLASS_LAYOUT, FSETCLASS_LAYOUT);
void CLASS_LAYOUT_make_depend(CLASS_LAYOUT);
void CODE_FILE_ARRAY_aset_INT(CODE_FILE_ARRAY, INT, CODE_FILE);
void CODE_FILE_ARRAY_asetb_CO(CODE_FILE_ARRAY_asetb_CO_frame);
void CODE_FILE_ARRAY_insertio(CODE_FILE_ARRAY, INT, INT);
void CODE_FILE_ARRAY_quicksor(CODE_FILE_ARRAY, INT, INT);
void CODE_FILE_ARRAY_setb_COD(CODE_FILE_ARRAY_setb_COD_frame);
void CODE_FILE_ARRAY_sort(CODE_FILE_ARRAY);
void CODE_FILE_all_FLISTCODE_(CODE_FILE, FLISTCODE_FILE);
void CODE_FILE_cgen_CGEN(CODE_FILE, CGEN);
void CODE_FILE_dir_STR(CODE_FILE, STR);
void CODE_FILE_finalize(CODE_FILE);
void CODE_FILE_generate_layou(CODE_FILE);
void CODE_FILE_good_place_to_(CODE_FILE);
void CODE_FILE_here_is_iter_A(CODE_FILE, AM_ROUT_DEF);
void CODE_FILE_iter_sigs_FMAP(CODE_FILE, FMAPSIGAM_ROUT_DEF);
void CODE_FILE_layout_order_F(CODE_FILE, FLISTdLAYOUT);
void CODE_FILE_layout_text_FL(CODE_FILE, FLISTSTR);
void CODE_FILE_plus_dSTR(CODE_FILE, dSTR);
void CODE_FILE_prog_PROG(CODE_FILE, PROG);
void CODE_FILE_set_directory_(CODE_FILE, PROG, STR);
void CODE_FILE_thumbprints_FM(CODE_FILE, FMAPSTRSTR);
void CODE_FILE_todo_FLISTCODE(CODE_FILE, FLISTCODE_FILE);
void CODE_FILE_uses_bnd_rout_(CODE_FILE, AM_BND_CREATE_EXPR);
void CODE_FILE_uses_extern_ST(CODE_FILE, STR);
void CODE_FILE_uses_global_AM(CODE_FILE, AM_GLOBAL_EXPR);
void CODE_FILE_uses_iter_SIG(CODE_FILE, SIG);
void CODE_FILE_uses_layout_dL(CODE_FILE, dLAYOUT);
void CODE_FILE_uses_sig_SIG(CODE_FILE, SIG);
void CODE_FILE_uses_tp_dTP(CODE_FILE, dTP);
void CODE_FILE_uses_unbox_SIG(CODE_FILE, SIG, SIG);
void FILE_close(FILE1);
void FILE_create_directory_ST(FILE1, STR);
void FILE_plus_dSTR(FILE1, dSTR);
void IFC_show(IFC);
void LAYOUT_ARRAY_setb_dLAYOU(LAYOUT_ARRAY_setb_dLAYOU_frame);
void LAYOUT_ARRAY_sort(LAYOUT_ARRAY);
void LAYOUT_ARR_setb_TUPIDENT(LAYOUT_ARR_setb_TUPIDENT_frame);
void LAYOUT_ARR_sort(LAYOUT_ARR);
void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL, FMAPdTPdLAYOUT);
void MANGLE_forbid_STR(MANGLE, STR);
void OUT_flush(OUT);
void OUT_plus_dSTR(OUT, dSTR);
void PROG_barf_STR(PROG, STR);
void PROG_err_STR(PROG, STR);
void PROG_err_loc_dPROG_ERR(PROG, dPROG_ERR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




BOOL CHAR_is_alpha_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case 'a':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'b':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'c':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'd':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'e':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'f':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'g':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'h':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'i':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'j':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'k':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'l':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'm':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'n':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'o':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'p':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'r':
   ret_val = TRUE;
   return ret_val;
   break;
  case 's':
   ret_val = TRUE;
   return ret_val;
   break;
  case 't':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'u':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'v':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'w':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'x':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'z':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'A':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'B':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'C':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'D':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'E':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'F':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'G':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'H':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'I':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'J':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'K':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'L':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'M':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'N':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'O':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'P':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'R':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'S':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'T':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'U':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'V':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'W':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'X':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Z':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_alphanum_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case 'a':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'b':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'c':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'd':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'e':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'f':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'g':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'h':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'i':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'j':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'k':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'l':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'm':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'n':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'o':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'p':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'r':
   ret_val = TRUE;
   return ret_val;
   break;
  case 's':
   ret_val = TRUE;
   return ret_val;
   break;
  case 't':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'u':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'v':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'w':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'x':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'z':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'A':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'B':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'C':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'D':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'E':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'F':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'G':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'H':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'I':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'J':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'K':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'L':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'M':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'N':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'O':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'P':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'R':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'S':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'T':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'U':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'V':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'W':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'X':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Z':
   ret_val = TRUE;
   return ret_val;
   break;
  case '0':
   ret_val = TRUE;
   return ret_val;
   break;
  case '1':
   ret_val = TRUE;
   return ret_val;
   break;
  case '2':
   ret_val = TRUE;
   return ret_val;
   break;
  case '3':
   ret_val = TRUE;
   return ret_val;
   break;
  case '4':
   ret_val = TRUE;
   return ret_val;
   break;
  case '5':
   ret_val = TRUE;
   return ret_val;
   break;
  case '6':
   ret_val = TRUE;
   return ret_val;
   break;
  case '7':
   ret_val = TRUE;
   return ret_val;
   break;
  case '8':
   ret_val = TRUE;
   return ret_val;
   break;
  case '9':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_digit_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case '0':
   ret_val = TRUE;
   return ret_val;
   break;
  case '1':
   ret_val = TRUE;
   return ret_val;
   break;
  case '2':
   ret_val = TRUE;
   return ret_val;
   break;
  case '3':
   ret_val = TRUE;
   return ret_val;
   break;
  case '4':
   ret_val = TRUE;
   return ret_val;
   break;
  case '5':
   ret_val = TRUE;
   return ret_val;
   break;
  case '6':
   ret_val = TRUE;
   return ret_val;
   break;
  case '7':
   ret_val = TRUE;
   return ret_val;
   break;
  case '8':
   ret_val = TRUE;
   return ret_val;
   break;
  case '9':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_gt_CHAR_BOOL(CHAR self, CHAR c) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 L1 = ((INT)((unsigned char)self));
 L2 = ((INT)((unsigned char)c));
 ret_val = (L1>L2);
 return ret_val;
}


BOOL CHAR_is_hex_digit_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case '0':
   ret_val = TRUE;
   return ret_val;
   break;
  case '1':
   ret_val = TRUE;
   return ret_val;
   break;
  case '2':
   ret_val = TRUE;
   return ret_val;
   break;
  case '3':
   ret_val = TRUE;
   return ret_val;
   break;
  case '4':
   ret_val = TRUE;
   return ret_val;
   break;
  case '5':
   ret_val = TRUE;
   return ret_val;
   break;
  case '6':
   ret_val = TRUE;
   return ret_val;
   break;
  case '7':
   ret_val = TRUE;
   return ret_val;
   break;
  case '8':
   ret_val = TRUE;
   return ret_val;
   break;
  case '9':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'a':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'b':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'c':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'd':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'e':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'f':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'A':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'B':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'C':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'D':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'E':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'F':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_lower_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case 'a':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'b':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'c':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'd':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'e':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'f':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'g':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'h':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'i':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'j':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'k':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'l':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'm':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'n':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'o':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'p':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'r':
   ret_val = TRUE;
   return ret_val;
   break;
  case 's':
   ret_val = TRUE;
   return ret_val;
   break;
  case 't':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'u':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'v':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'w':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'x':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'z':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_lt_CHAR_BOOL(CHAR self, CHAR c) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 L1 = ((INT)((unsigned char)self));
 L2 = ((INT)((unsigned char)c));
 ret_val = (L1<L2);
 return ret_val;
}


BOOL CHAR_is_print_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case ' ':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'a':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'b':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'c':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'd':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'e':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'f':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'g':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'h':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'i':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'j':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'k':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'l':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'm':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'n':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'o':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'p':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'r':
   ret_val = TRUE;
   return ret_val;
   break;
  case 's':
   ret_val = TRUE;
   return ret_val;
   break;
  case 't':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'u':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'v':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'w':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'x':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'z':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'A':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'B':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'C':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'D':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'E':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'F':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'G':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'H':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'I':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'J':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'K':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'L':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'M':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'N':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'O':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'P':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'R':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'S':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'T':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'U':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'V':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'W':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'X':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Z':
   ret_val = TRUE;
   return ret_val;
   break;
  case '0':
   ret_val = TRUE;
   return ret_val;
   break;
  case '1':
   ret_val = TRUE;
   return ret_val;
   break;
  case '2':
   ret_val = TRUE;
   return ret_val;
   break;
  case '3':
   ret_val = TRUE;
   return ret_val;
   break;
  case '4':
   ret_val = TRUE;
   return ret_val;
   break;
  case '5':
   ret_val = TRUE;
   return ret_val;
   break;
  case '6':
   ret_val = TRUE;
   return ret_val;
   break;
  case '7':
   ret_val = TRUE;
   return ret_val;
   break;
  case '8':
   ret_val = TRUE;
   return ret_val;
   break;
  case '9':
   ret_val = TRUE;
   return ret_val;
   break;
  case '!':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\"':
   ret_val = TRUE;
   return ret_val;
   break;
  case '#':
   ret_val = TRUE;
   return ret_val;
   break;
  case '$':
   ret_val = TRUE;
   return ret_val;
   break;
  case '%':
   ret_val = TRUE;
   return ret_val;
   break;
  case '&':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\'':
   ret_val = TRUE;
   return ret_val;
   break;
  case '(':
   ret_val = TRUE;
   return ret_val;
   break;
  case ')':
   ret_val = TRUE;
   return ret_val;
   break;
  case '*':
   ret_val = TRUE;
   return ret_val;
   break;
  case '+':
   ret_val = TRUE;
   return ret_val;
   break;
  case '-':
   ret_val = TRUE;
   return ret_val;
   break;
  case '.':
   ret_val = TRUE;
   return ret_val;
   break;
  case '/':
   ret_val = TRUE;
   return ret_val;
   break;
  case ':':
   ret_val = TRUE;
   return ret_val;
   break;
  case ';':
   ret_val = TRUE;
   return ret_val;
   break;
  case '<':
   ret_val = TRUE;
   return ret_val;
   break;
  case '=':
   ret_val = TRUE;
   return ret_val;
   break;
  case '>':
   ret_val = TRUE;
   return ret_val;
   break;
  case '?':
   ret_val = TRUE;
   return ret_val;
   break;
  case '@':
   ret_val = TRUE;
   return ret_val;
   break;
  case '[':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\\':
   ret_val = TRUE;
   return ret_val;
   break;
  case ']':
   ret_val = TRUE;
   return ret_val;
   break;
  case '^':
   ret_val = TRUE;
   return ret_val;
   break;
  case '_':
   ret_val = TRUE;
   return ret_val;
   break;
  case '`':
   ret_val = TRUE;
   return ret_val;
   break;
  case '{':
   ret_val = TRUE;
   return ret_val;
   break;
  case '|':
   ret_val = TRUE;
   return ret_val;
   break;
  case '}':
   ret_val = TRUE;
   return ret_val;
   break;
  case '~':
   ret_val = TRUE;
   return ret_val;
   break;
  case ',':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_space_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case ' ':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\f':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\n':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\r':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\t':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\v':
   ret_val = TRUE;
   return ret_val;
   break;
  case '\32':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CHAR_is_upper_BOOL(CHAR self) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case 'A':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'B':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'C':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'D':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'E':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'F':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'G':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'H':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'I':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'J':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'K':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'L':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'M':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'N':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'O':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'P':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Q':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'R':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'S':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'T':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'U':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'V':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'W':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'X':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Y':
   ret_val = TRUE;
   return ret_val;
   break;
  case 'Z':
   ret_val = TRUE;
   return ret_val;
   break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CODE_FILE_ARRAY_elt_lt_C(CODE_FILE_ARRAY self, CODE_FILE x, CODE_FILE y) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = STR_is_lt_STR_BOOL(ATTR(x,name1), ATTR(y,name1));
 return ret_val;
}


BOOL CODE_FILE_ARRAY_is_sorte(CODE_FILE_ARRAY self) {
 BOOL ret_val = ((BOOL) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 BOOL L3;
 INT L4;
 INT L5;
 INT L6;
 
 INT L7;
 CODE_FILE L8;
 L3 = (self==((CODE_FILE_ARRAY) NULL));
 if ((!(L3))) {
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = 1;
     L7 = (ASIZE(self));
     L21 = (INTMINUS(L7,1));
     L5 = L11;
     L6 = L21;
     L4 = L5;
    } else {
     L4++;
    }
    if (L4>L6) goto after_loop;
    i = L4;
    L8 = CODE_FILE_ARRAY_aget_INT(self, i);
    if (CODE_FILE_ARRAY_elt_lt_C(self, L8, CODE_FILE_ARRAY_aget_INT(self, (INTMINUS(i,1))))) {
     ret_val = FALSE;
     return ret_val;
    }
   }
  }
  after_loop: ;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL CODE_FILE_same_options_a(CODE_FILE self, CODE_FILE s) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 BOOL L5;
 BOOL L6;
 BOOL L7;
 BOOL L8;
 BOOL L9;
 BOOL L10;
 BOOL L11;
 BOOL L12;
 BOOL L13;
 BOOL L14;
 BOOL L15;
 BOOL L16;
 BOOL L17;
 BOOL L18;
 BOOL L19;
 BOOL L20;
 BOOL L21;
 BOOL L22;
 BOOL L23;
 BOOL L24;
 BOOL L25;
 BOOL L26;
 L9 = ATTR(self,chk_pre);
 L10 = ATTR(s,chk_pre);
 if (((L9)==(L10))) {
  L11 = ATTR(self,chk_post);
  L12 = ATTR(s,chk_post);
  L8 = ((L11)==(L12));
 } else {
  L8 = FALSE;
 }
 if (L8) {
  L13 = ATTR(self,chk_invariant);
  L14 = ATTR(s,chk_invariant);
  L7 = ((L13)==(L14));
 } else {
  L7 = FALSE;
 }
 if (L7) {
  L15 = ATTR(self,chk_assert);
  L16 = ATTR(s,chk_assert);
  L6 = ((L15)==(L16));
 } else {
  L6 = FALSE;
 }
 if (L6) {
  L17 = ATTR(self,chk_arith);
  L18 = ATTR(s,chk_arith);
  L5 = ((L17)==(L18));
 } else {
  L5 = FALSE;
 }
 if (L5) {
  L19 = ATTR(self,chk_bounds);
  L20 = ATTR(s,chk_bounds);
  L4 = ((L19)==(L20));
 } else {
  L4 = FALSE;
 }
 if (L4) {
  L21 = ATTR(self,chk_void);
  L22 = ATTR(s,chk_void);
  L3 = ((L21)==(L22));
 } else {
  L3 = FALSE;
 }
 if (L3) {
  L23 = ATTR(self,chk_when);
  L24 = ATTR(s,chk_when);
  L2 = ((L23)==(L24));
 } else {
  L2 = FALSE;
 }
 if (L2) {
  L25 = ATTR(self,chk_return);
  L26 = ATTR(s,chk_return);
  L1 = ((L25)==(L26));
 } else {
  L1 = FALSE;
 }
 ret_val = L1;
 return ret_val;
}


CHANGE_VARS CHANGE_VARS_create_AM_RO(CHANGE_VARS self, AM_ROUT_DEF rout) {
 CHANGE_VARS ret_val;
 CHANGE_VARS r;
 AM_ROUT_DEF L11;
 AM_LOCAL_EXPR l;
 AM_LOCAL_EXPR m;
 AM_ASSIGN_STMT as;
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 ARRAYINT L31;
 ARRAYINT L41;
 AM_ASSIGN_STMT as1;
 FLISTAM_LOCAL_EXPR L51;
 AM_LOCAL_EXPR l1;
 AM_LOCAL_EXPR m1;
 AM_ASSIGN_STMT as2;
 AM_VOID_CONST vconst;
 CHANGE_VARS L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 AM_LOCAL_EXPR L12;
 extern STR S_;
 STR L13;
 INT L14;
 BOOL L15;
 BOOL L16;
 ARRAYBOOL L17;
 BOOL L18;
 dAM_STMT L19;
 dAM_STMT L20;
 dAM_STMT L22;
 AM_LOCAL_EXPR L23;
 dAM_STMT L24;
 L6 = ((CHANGE_VARS) rt_alloc(sizeof(struct CHANGE_VARS_struct), CHANGE_VARS_tag));
 r = L6;
 L7 = AM_ROUT_DEF_size_INT(rout);
 L8 = FLISTAM_LOCAL_EXPR_size_(ATTR(rout,locals1));
 SATTR(r,saved_subst,FMAPAM_LOCAL_EXPRAM_LOCA6(((FMAPAM_LOCAL_EXPRAM_LOCA) NULL), (INTPLUS(L7,L8))));
 L9 = AM_ROUT_DEF_size_INT(rout);
 L10 = FLISTAM_LOCAL_EXPR_size_(ATTR(rout,locals1));
 SATTR(r,saved_vars,FLISTAM_LOCAL_EXPR_creat(((FLISTAM_LOCAL_EXPR) NULL), (INTPLUS(L9,L10))));
 if (AM_ROUT_DEF_is_iter_BOOL(rout)) {
  SATTR(r,init_hot1,((dAM_STMT) NULL));
  SATTR(r,pind_hot,ARRAYINT_create_INT_ARRA(((ARRAYINT) NULL), AM_ROUT_DEF_size_INT(rout)));
  SATTR(r,init_nonhot1,((dAM_STMT) NULL));
  SATTR(r,pind_nonhot,ARRAYINT_create_INT_ARRA(((ARRAYINT) NULL), AM_ROUT_DEF_size_INT(rout)));
 }
 else {
  SATTR(r,init_parms1,((dAM_STMT) NULL));
 }
 SATTR(r,init_vars1,((dAM_STMT) NULL));
 {
  struct AM_ROUT_DEF_eltb_AM_LOCA_frame_struct other1_0;
  AM_ROUT_DEF_eltb_AM_LOCA_frame 
  noname1 = &other1_0;
  struct INT_upb_INT_frame_struct other1_1;
  INT_upb_INT_frame 
  noname2 = &other1_1;
  struct ARRAYINT_setb_INT_frame_struct other1_2;
  ARRAYINT_setb_INT_frame 
  noname3 = &other1_2;
  struct ARRAYINT_setb_INT_frame_struct other1_3;
  ARRAYINT_setb_INT_frame 
  noname4 = &other1_3;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  noname4->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = rout;
    noname1->self = L11;
   }
   L12 = AM_ROUT_DEF_eltb_AM_LOCA(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   l = L12;
   m = AM_LOCAL_EXPR_create_SFI2(((AM_LOCAL_EXPR) NULL), ATTR(rout,source11));
   SATTR(m,is_volatile,ATTR(l,is_volatile));
   L13 = STR_plus_dSTR_STR(ATTR(ATTR(rout,sig11),name1).str, ((dSTR) ((STR) &S_)));
   SATTR(m,name1,IDENT_create_STR_IDENT(IDENT_zero, STR_plus_dSTR_STR(L13, ((dSTR) ATTR(l,name1).str))));
   SATTR(m,tp_at,ATTR(l,tp_at));
   SATTR(m,needs_init,ATTR(l,needs_init));
   if (AM_ROUT_DEF_is_iter_BOOL(rout)) {
    as = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(rout,source11));
    SATTR(as,dest,((dAM_EXPR) m));
    SATTR(as,src11,((dAM_EXPR) NULL));
    if (noname2->state == 0) {
     L21 = 0;
     noname2->self = L21;
    }
    L14 = INT_upb_INT(noname2);
    if (noname2->state == -1) {
     goto after_loop;
    }
    i = L14;
    if ((ATTR(ATTR(rout,sig11),hot)==((ARRAYBOOL) NULL))) {
     L16 = TRUE;
    } else {
     L16 = (i==0);
    }
    if (L16) {
     L15 = TRUE;
    } else {
     L17 = ATTR(ATTR(rout,sig11),hot);
     L18 = ARRAYBOOL_aget_INT_BOOL(L17, (INTMINUS(i,1)));
     L15 = (!(L18));
    }
    if (L15) {
     if ((ATTR(r,init_nonhot1)==((dAM_STMT) NULL))) {
      SATTR(r,init_nonhot1,((dAM_STMT) as));
     }
     else {
      L19 = ATTR(r,init_nonhot1);
      if (L19==NULL) {
       FATAL("Dispatch on void in CHANGE_VARS::create(AM_ROUT_DEF):CHANGE_VARS");
      }
      (*dAM_STMT_append_dAM_STMT[TAG(L19)+dAM_STMT_append_dAM_STMT_offset])(L19, ((dAM_STMT) as));
     }
     if (noname3->state == 0) {
      L31 = ATTR(r,pind_nonhot);
      noname3->self = L31;
     }
     noname3->arg1 = i;
     ARRAYINT_setb_INT(noname3);
     if (noname3->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
    else {
     if ((ATTR(r,init_hot1)==((dAM_STMT) NULL))) {
      SATTR(r,init_hot1,((dAM_STMT) as));
     }
     else {
      L20 = ATTR(r,init_hot1);
      if (L20==NULL) {
       FATAL("Dispatch on void in CHANGE_VARS::create(AM_ROUT_DEF):CHANGE_VARS");
      }
      (*dAM_STMT_append_dAM_STMT[TAG(L20)+dAM_STMT_append_dAM_STMT_offset])(L20, ((dAM_STMT) as));
     }
     if (noname4->state == 0) {
      L41 = ATTR(r,pind_hot);
      noname4->self = L41;
     }
     noname4->arg1 = i;
     ARRAYINT_setb_INT(noname4);
     if (noname4->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   else {
    as1 = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(rout,source11));
    SATTR(as1,dest,((dAM_EXPR) m));
    SATTR(as1,src11,((dAM_EXPR) NULL));
    if ((ATTR(r,init_parms1)==((dAM_STMT) NULL))) {
     SATTR(r,init_parms1,((dAM_STMT) as1));
    }
    else {
     L22 = ATTR(r,init_parms1);
     if (L22==NULL) {
      FATAL("Dispatch on void in CHANGE_VARS::create(AM_ROUT_DEF):CHANGE_VARS");
     }
     (*dAM_STMT_append_dAM_STMT[TAG(L22)+dAM_STMT_append_dAM_STMT_offset])(L22, ((dAM_STMT) as1));
    }
   }
   SATTR(m,no_assign,ATTR(l,no_assign));
   SATTR(r,saved_subst,FMAPAM_LOCAL_EXPRAM_LOCA14(ATTR(r,saved_subst), l, m));
   SATTR(r,saved_vars,FLISTAM_LOCAL_EXPR_push_(ATTR(r,saved_vars), m));
  }
 }
 after_loop: ;
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other2_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname5 = &other2_0;
  noname5->state = 0;
  while (1) {
   if (noname5->state == 0) {
    L51 = ATTR(rout,locals1);
    noname5->self = L51;
   }
   L23 = FLISTAM_LOCAL_EXPR_eltb_(noname5);
   if (noname5->state == -1) {
    goto after_loop1;
   }
   l1 = L23;
   m1 = AM_LOCAL_EXPR_create_SFI2(((AM_LOCAL_EXPR) NULL), ATTR(rout,source11));
   SATTR(m1,is_volatile,ATTR(l1,is_volatile));
   SATTR(m1,name1,ATTR(l1,name1));
   SATTR(m1,tp_at,ATTR(l1,tp_at));
   SATTR(m1,needs_init,ATTR(l1,needs_init));
   if (ATTR(m1,needs_init)) {
    as2 = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(rout,source11));
    SATTR(as2,dest,((dAM_EXPR) m1));
    vconst = AM_VOID_CONST_create_SFI(((AM_VOID_CONST) NULL), ATTR(rout,source11));
    SATTR(vconst,tp_at,ATTR(m1,tp_at));
    SATTR(as2,src11,((dAM_EXPR) vconst));
    if ((ATTR(r,init_vars1)==((dAM_STMT) NULL))) {
     SATTR(r,init_vars1,((dAM_STMT) as2));
    }
    else {
     L24 = ATTR(r,init_vars1);
     if (L24==NULL) {
      FATAL("Dispatch on void in CHANGE_VARS::create(AM_ROUT_DEF):CHANGE_VARS");
     }
     (*dAM_STMT_append_dAM_STMT[TAG(L24)+dAM_STMT_append_dAM_STMT_offset])(L24, ((dAM_STMT) as2));
    }
   }
   SATTR(m1,no_assign,ATTR(l1,no_assign));
   SATTR(r,saved_subst,FMAPAM_LOCAL_EXPRAM_LOCA14(ATTR(r,saved_subst), l1, m1));
   SATTR(r,saved_vars,FLISTAM_LOCAL_EXPR_push_(ATTR(r,saved_vars), m1));
  }
 }
 after_loop1: ;
 ret_val = r;
 return ret_val;
}


CHAR CHAR_upper_CHAR(CHAR self) {
 CHAR ret_val = ((CHAR) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case 'a':
   ret_val = 'A';
   return ret_val;
   break;
  case 'b':
   ret_val = 'B';
   return ret_val;
   break;
  case 'c':
   ret_val = 'C';
   return ret_val;
   break;
  case 'd':
   ret_val = 'D';
   return ret_val;
   break;
  case 'e':
   ret_val = 'E';
   return ret_val;
   break;
  case 'f':
   ret_val = 'F';
   return ret_val;
   break;
  case 'g':
   ret_val = 'G';
   return ret_val;
   break;
  case 'h':
   ret_val = 'H';
   return ret_val;
   break;
  case 'i':
   ret_val = 'I';
   return ret_val;
   break;
  case 'j':
   ret_val = 'J';
   return ret_val;
   break;
  case 'k':
   ret_val = 'K';
   return ret_val;
   break;
  case 'l':
   ret_val = 'L';
   return ret_val;
   break;
  case 'm':
   ret_val = 'M';
   return ret_val;
   break;
  case 'n':
   ret_val = 'N';
   return ret_val;
   break;
  case 'o':
   ret_val = 'O';
   return ret_val;
   break;
  case 'p':
   ret_val = 'P';
   return ret_val;
   break;
  case 'q':
   ret_val = 'Q';
   return ret_val;
   break;
  case 'r':
   ret_val = 'R';
   return ret_val;
   break;
  case 's':
   ret_val = 'S';
   return ret_val;
   break;
  case 't':
   ret_val = 'T';
   return ret_val;
   break;
  case 'u':
   ret_val = 'U';
   return ret_val;
   break;
  case 'v':
   ret_val = 'V';
   return ret_val;
   break;
  case 'w':
   ret_val = 'W';
   return ret_val;
   break;
  case 'x':
   ret_val = 'X';
   return ret_val;
   break;
  case 'y':
   ret_val = 'Y';
   return ret_val;
   break;
  case 'z':
   ret_val = 'Z';
   return ret_val;
   break;
  default: ;
   ret_val = self;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


CLASS_LAYOUT CLASS_LAYOUT_create_dTP_(CLASS_LAYOUT self, dTP tp, PROG prog) {
 CLASS_LAYOUT ret_val;
 dLAYOUT r;
 CLASS_LAYOUT res = ((CLASS_LAYOUT) NULL);
 BOOL L1;
 CLASS_LAYOUT L2;
 dTP L3;
 STR L4;
 extern STR Class;
 r = FMAPdTPdLAYOUT_get_dTP_d(LAYOUT_TBL_layout_tbl, tp);
 L1 = (r==((dLAYOUT) NULL));
 if ((!(L1))) {
  if (r==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(r)) {
   case CLASS_LAYOUT_tag:
    res = ((CLASS_LAYOUT) r); break;
   default: ;
    FATAL("No applicable type in typecase");
  }
 }
 else {
  L2 = ((CLASS_LAYOUT) rt_alloc(sizeof(struct CLASS_LAYOUT_struct), CLASS_LAYOUT_tag));
  res = L2;
  SATTR(res,tp1,tp);
  SATTR(res,prog1,prog);
  SATTR(res,l1,CGEN_am_ob_def_for_tp_dT(LAYOUT_TBL_cgen, tp));
  L3 = ATTR(res,tp1);
  if (L3==NULL) {
   FATAL("Dispatch on void in CLASS_LAYOUT::create($TP,PROG):CLASS_LAYOUT");
  }
  L4 = (*dTP_str_STR[TAG(L3)+dTP_str_STR_offset])(L3);
  SATTR(res,str1,STR_plus_dSTR_STR(L4, ((dSTR) ((STR) &Class))));
  CLASS_LAYOUT_make_depend(res);
  CLASS_LAYOUT_layouts_FSE(self, FSETCLASS_LAYOUT_insert_(CLASS_LAYOUT_layouts, res));
  LAYOUT_TBL_layout_tbl_FM(((LAYOUT_TBL) NULL), FMAPdTPdLAYOUT_insert_dT(LAYOUT_TBL_layout_tbl, tp, ((dLAYOUT) res)));
 }
 ret_val = res;
 return ret_val;
}


CODE_FILE CODE_FILE_ARRAY_aeltb_CO(CODE_FILE_ARRAY_aeltb_CO_frame frame) {
 CODE_FILE dummy = ((CODE_FILE) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return CODE_FILE_ARRAY_aget_INT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


CODE_FILE CODE_FILE_ARRAY_aget_INT(CODE_FILE_ARRAY self, INT ind) {
 CODE_FILE ret_val;
 return ARR(self,ind);
}


CODE_FILE CODE_FILE_ARRAY_eltb_COD(CODE_FILE_ARRAY_eltb_COD_frame frame) {
 CODE_FILE dummy = ((CODE_FILE) NULL);
 BOOL L1;
 CODE_FILE L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((CODE_FILE_ARRAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(CODE_FILE_ARRAY_aeltb_CO_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = CODE_FILE_ARRAY_aeltb_CO(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


CODE_FILE CODE_FILE_create_STR_COD(CODE_FILE self, STR s) {
 CODE_FILE ret_val;
 CODE_FILE r;
 CODE_FILE L1;
 L1 = ((CODE_FILE) rt_alloc(sizeof(struct CODE_FILE_struct), CODE_FILE_tag));
 r = L1;
 SATTR(r,text1,FLISTFSTR_create_FLISTFS(((FLISTFSTR) NULL)));
 SATTR(r,ntext,FSTR_create_FSTR(((FSTR) NULL)));
 SATTR(r,length1,0);
 SATTR(r,name1,s);
 SATTR(r,decs,FSETSIG_create_FSETSIG(((FSETSIG) NULL)));
 SATTR(r,layouts,FSETdLAYOUT_create_FSETd(((FSETdLAYOUT) NULL)));
 SATTR(r,globals,FSETAM_GLOBAL_EXPR_creat(((FSETAM_GLOBAL_EXPR) NULL)));
 SATTR(r,bnd_rout_creates,FLISTAM_BND_CREATE_EXPR_6(((FLISTAM_BND_CREATE_EXPR) NULL)));
 SATTR(r,unboxes,FSETTUPSIGSIG_create_FSE(((FSETTUPSIGSIG) NULL)));
 SATTR(r,externs1,FSETSTR_create_FSETSTR(((FSETSTR) NULL)));
 SATTR(r,iters,FSETSIG_create_FSETSIG(((FSETSIG) NULL)));
 SATTR(r,do_not_merge,FALSE);
 CODE_FILE_all_FLISTCODE_(self, FLISTCODE_FILE_push_CODE(CODE_FILE_all, r));
 ret_val = r;
 return ret_val;
}


CODE_FILE CODE_FILE_plus_dSTR_CODE(CODE_FILE self, dSTR s) {
 CODE_FILE ret_val;
 FSTR L1;
 dSTR L2;
 L1 = ATTR(self,ntext);
 L2 = s;
 if (L2==NULL) {
  FATAL("Dispatch on void in CODE_FILE::plus($STR):CODE_FILE");
 }
 SATTR(self,ntext,FSTR_plus_STR_FSTR(L1, (*dSTR_str_STR[TAG(L2)+dSTR_str_STR_offset])(L2)));
 ret_val = self;
 return ret_val;
}


FLISTdLAYOUT CLASS_LAYOUT_dependencie(CLASS_LAYOUT self) {
 return ATTR(self,dependencies);
}


FSTR CODE_FILE_header_info_FS(CODE_FILE self) {
 FSTR ret_val;
 FSTR f;
 FLISTdLAYOUT L11;
 dLAYOUT l;
 FLISTSTR L21;
 STR t;
 ARRAYSTR globstr;
 FSETAM_GLOBAL_EXPR L31;
 AM_GLOBAL_EXPR age1;
 ARRAYSTR L41;
 ARRAYSTR L51;
 ARRAYSTR decstr;
 FSETSIG L61;
 ARRAYSTR L71;
 ARRAYSTR L81;
 ARRAYSTR unstr;
 FSETTUPSIGSIG L91;
 TUPSIGSIG pair = TUPSIGSIG_zero;
 ARRAYSTR L101;
 ARRAYSTR L121;
 ARRAYSTR exstr;
 FSETSTR L131;
 ARRAYSTR L141;
 ARRAYSTR L151;
 extern STR definePRE_CHK;
 extern STR definePOST_CHK;
 extern STR defineINVARIANT_CHK;
 extern STR defineASSERT_CHK;
 extern STR defineARITH_CHK;
 extern STR defineBOUNDS_CHK;
 extern STR defineVOID_CHK;
 extern STR defineWHEN_CHK;
 extern STR defineRETURN_CHK;
 extern STR includesatherh;
 extern STR Layouts;
 dLAYOUT L16;
 STR L17;
 extern STR includetagsh;
 extern STR Globals;
 AM_GLOBAL_EXPR L18;
 extern STR extern11;
 STR L19;
 dSTR L20;
 STR L22;
 STR L23;
 extern STR name85;
 STR L24;
 extern STR Functiondeclarations;
 SIG L25;
 STR L26;
 extern STR Boundroutstubsdecls;
 extern STR Unboxdecls;
 TUPSIGSIG L27;
 STR L28;
 extern STR Externalcalls;
 STR L29;
 STR L30;
 extern STR Code;
 f = FSTR_create_FSTR(((FSTR) NULL));
 if (ATTR(self,chk_pre)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &definePRE_CHK));
 }
 if (ATTR(self,chk_post)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &definePOST_CHK));
 }
 if (ATTR(self,chk_invariant)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineINVARIANT_CHK));
 }
 if (ATTR(self,chk_assert)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineASSERT_CHK));
 }
 if (ATTR(self,chk_arith)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineARITH_CHK));
 }
 if (ATTR(self,chk_bounds)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineBOUNDS_CHK));
 }
 if (ATTR(self,chk_void)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineVOID_CHK));
 }
 if (ATTR(self,chk_when)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineWHEN_CHK));
 }
 if (ATTR(self,chk_return)) {
  f = FSTR_plus_STR_FSTR(f, ((STR) &defineRETURN_CHK));
 }
 f = FSTR_plus_STR_FSTR(f, ((STR) &includesatherh));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Layouts));
 {
  struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other1_0;
  FLISTdLAYOUT_eltb_dLAYOU_frame 
  noname1 = &other1_0;
  struct FLISTSTR_eltb_STR_frame_struct other1_1;
  FLISTSTR_eltb_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = CODE_FILE_layout_order;
    noname1->self = L11;
   }
   L16 = FLISTdLAYOUT_eltb_dLAYOU(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   l = L16;
   if (noname2->state == 0) {
    L21 = CODE_FILE_layout_text;
    noname2->self = L21;
   }
   L17 = FLISTSTR_eltb_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   t = L17;
   if (FSETdLAYOUT_test_dLAYOUT(ATTR(self,layouts), l)) {
    f = FSTR_plus_STR_FSTR(f, t);
   }
  }
 }
 after_loop: ;
 f = FSTR_plus_STR_FSTR(f, ((STR) &includetagsh));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Globals));
 globstr = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), FSETAM_GLOBAL_EXPR_size_(ATTR(self,globals)));
 {
  struct FSETAM_GLOBAL_EXPR_eltb__frame_struct other2_0;
  FSETAM_GLOBAL_EXPR_eltb__frame 
  noname3 = &other2_0;
  struct ARRAYSTR_setb_STR_frame_struct other2_1;
  ARRAYSTR_setb_STR_frame 
  noname4 = &other2_1;
  noname3->state = 0;
  noname4->state = 0;
  while (1) {
   if (noname3->state == 0) {
    L31 = ATTR(self,globals);
    noname3->self = L31;
   }
   L18 = FSETAM_GLOBAL_EXPR_eltb_(noname3);
   if (noname3->state == -1) {
    goto after_loop1;
   }
   age1 = L18;
   if (noname4->state == 0) {
    L41 = globstr;
    noname4->self = L41;
   }
   L19 = STR_plus_dSTR_STR(((STR) &extern11), ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) AM_GLOBAL_EXPR_tp_dTP(age1)))));
   L20 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L20)->value_part = ' ';
   L22 = STR_plus_dSTR_STR(L19, L20);
   L23 = STR_plus_dSTR_STR(L22, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) age1))));
   noname4->arg1 = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &name85)));
   ARRAYSTR_setb_STR(noname4);
   if (noname4->state == -1) {
    goto after_loop1;
   }
   /* No return value from iter call */;
  }
 }
 after_loop1: ;
 ARRAYSTR_sort(globstr);
 {
  struct ARRAYSTR_eltb_STR_frame_struct other3_0;
  ARRAYSTR_eltb_STR_frame 
  noname5 = &other3_0;
  noname5->state = 0;
  while (1) {
   if (noname5->state == 0) {
    L51 = globstr;
    noname5->self = L51;
   }
   L24 = ARRAYSTR_eltb_STR(noname5);
   if (noname5->state == -1) {
    goto after_loop2;
   }
   f = FSTR_plus_STR_FSTR(f, L24);
  }
 }
 after_loop2: ;
 SYSDESTROY(((OB) globstr));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Functiondeclarations));
 decstr = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), FSETSIG_size_INT(ATTR(self,decs)));
 {
  struct FSETSIG_eltb_SIG_frame_struct other4_0;
  FSETSIG_eltb_SIG_frame 
  noname6 = &other4_0;
  struct ARRAYSTR_setb_STR_frame_struct other4_1;
  ARRAYSTR_setb_STR_frame 
  noname7 = &other4_1;
  noname6->state = 0;
  noname7->state = 0;
  while (1) {
   if (noname7->state == 0) {
    L71 = decstr;
    noname7->self = L71;
   }
   if (noname6->state == 0) {
    L61 = ATTR(self,decs);
    noname6->self = L61;
   }
   L25 = FSETSIG_eltb_SIG(noname6);
   if (noname6->state == -1) {
    goto after_loop3;
   }
   noname7->arg1 = CODE_FILE_declaration_fo(self, L25);
   ARRAYSTR_setb_STR(noname7);
   if (noname7->state == -1) {
    goto after_loop3;
   }
   /* No return value from iter call */;
  }
 }
 after_loop3: ;
 ARRAYSTR_sort(decstr);
 {
  struct ARRAYSTR_eltb_STR_frame_struct other5_0;
  ARRAYSTR_eltb_STR_frame 
  noname8 = &other5_0;
  noname8->state = 0;
  while (1) {
   if (noname8->state == 0) {
    L81 = decstr;
    noname8->self = L81;
   }
   L26 = ARRAYSTR_eltb_STR(noname8);
   if (noname8->state == -1) {
    goto after_loop4;
   }
   f = FSTR_plus_STR_FSTR(f, L26);
  }
 }
 after_loop4: ;
 SYSDESTROY(((OB) decstr));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Boundroutstubsdecls));
 f = FSTR_plus_STR_FSTR(f, CODE_FILE_bnd_rout_decla(self));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Unboxdecls));
 unstr = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), FSETTUPSIGSIG_size_INT(ATTR(self,unboxes)));
 {
  struct FSETTUPSIGSIG_eltb_TUPSI_frame_struct other6_0;
  FSETTUPSIGSIG_eltb_TUPSI_frame 
  noname9 = &other6_0;
  struct ARRAYSTR_setb_STR_frame_struct other6_1;
  ARRAYSTR_setb_STR_frame 
  noname10 = &other6_1;
  noname9->state = 0;
  noname10->state = 0;
  while (1) {
   if (noname9->state == 0) {
    L91 = ATTR(self,unboxes);
    noname9->self = L91;
   }
   L27 = FSETTUPSIGSIG_eltb_TUPSI(noname9);
   if (noname9->state == -1) {
    goto after_loop5;
   }
   pair = L27;
   if (noname10->state == 0) {
    L101 = unstr;
    noname10->self = L101;
   }
   noname10->arg1 = CODE_FILE_unbox_dec_SIG_(self, pair.t1, pair.t2);
   ARRAYSTR_setb_STR(noname10);
   if (noname10->state == -1) {
    goto after_loop5;
   }
   /* No return value from iter call */;
  }
 }
 after_loop5: ;
 ARRAYSTR_sort(unstr);
 {
  struct ARRAYSTR_eltb_STR_frame_struct other7_0;
  ARRAYSTR_eltb_STR_frame 
  noname11 = &other7_0;
  noname11->state = 0;
  while (1) {
   if (noname11->state == 0) {
    L121 = unstr;
    noname11->self = L121;
   }
   L28 = ARRAYSTR_eltb_STR(noname11);
   if (noname11->state == -1) {
    goto after_loop6;
   }
   f = FSTR_plus_STR_FSTR(f, L28);
  }
 }
 after_loop6: ;
 SYSDESTROY(((OB) unstr));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Externalcalls));
 exstr = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), FSETSTR_size_INT(ATTR(self,externs1)));
 {
  struct FSETSTR_eltb_STR_frame_struct other8_0;
  FSETSTR_eltb_STR_frame 
  noname12 = &other8_0;
  struct ARRAYSTR_setb_STR_frame_struct other8_1;
  ARRAYSTR_setb_STR_frame 
  noname13 = &other8_1;
  noname12->state = 0;
  noname13->state = 0;
  while (1) {
   if (noname13->state == 0) {
    L141 = exstr;
    noname13->self = L141;
   }
   if (noname12->state == 0) {
    L131 = ATTR(self,externs1);
    noname12->self = L131;
   }
   L29 = FSETSTR_eltb_STR(noname12);
   if (noname12->state == -1) {
    goto after_loop7;
   }
   noname13->arg1 = L29;
   ARRAYSTR_setb_STR(noname13);
   if (noname13->state == -1) {
    goto after_loop7;
   }
   /* No return value from iter call */;
  }
 }
 after_loop7: ;
 ARRAYSTR_sort(exstr);
 {
  struct ARRAYSTR_eltb_STR_frame_struct other9_0;
  ARRAYSTR_eltb_STR_frame 
  noname14 = &other9_0;
  noname14->state = 0;
  while (1) {
   if (noname14->state == 0) {
    L151 = exstr;
    noname14->self = L151;
   }
   L30 = ARRAYSTR_eltb_STR(noname14);
   if (noname14->state == -1) {
    goto after_loop8;
   }
   f = FSTR_plus_STR_FSTR(f, L30);
  }
 }
 after_loop8: ;
 SYSDESTROY(((OB) exstr));
 f = FSTR_plus_STR_FSTR(f, ((STR) &Code));
 ret_val = f;
 return ret_val;
}


INT CHAR_digit_value_INT(CHAR self) {
 INT ret_val = ((INT) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case '0':
   ret_val = 0;
   return ret_val;
   break;
  case '1':
   ret_val = 1;
   return ret_val;
   break;
  case '2':
   ret_val = 2;
   return ret_val;
   break;
  case '3':
   ret_val = 3;
   return ret_val;
   break;
  case '4':
   ret_val = 4;
   return ret_val;
   break;
  case '5':
   ret_val = 5;
   return ret_val;
   break;
  case '6':
   ret_val = 6;
   return ret_val;
   break;
  case '7':
   ret_val = 7;
   return ret_val;
   break;
  case '8':
   ret_val = 8;
   return ret_val;
   break;
  case '9':
   ret_val = 9;
   return ret_val;
   break;
  default: ;
   ret_val = -1;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT CHAR_hash_INT(CHAR self) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT(((INT)((unsigned char)self)));
 return ret_val;
}


INT CHAR_hex_digit_value_INT(CHAR self) {
 INT ret_val = ((INT) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case '0':
   ret_val = 0;
   return ret_val;
   break;
  case '1':
   ret_val = 1;
   return ret_val;
   break;
  case '2':
   ret_val = 2;
   return ret_val;
   break;
  case '3':
   ret_val = 3;
   return ret_val;
   break;
  case '4':
   ret_val = 4;
   return ret_val;
   break;
  case '5':
   ret_val = 5;
   return ret_val;
   break;
  case '6':
   ret_val = 6;
   return ret_val;
   break;
  case '7':
   ret_val = 7;
   return ret_val;
   break;
  case '8':
   ret_val = 8;
   return ret_val;
   break;
  case '9':
   ret_val = 9;
   return ret_val;
   break;
  case 'a':
   ret_val = 10;
   return ret_val;
   break;
  case 'A':
   ret_val = 10;
   return ret_val;
   break;
  case 'b':
   ret_val = 11;
   return ret_val;
   break;
  case 'B':
   ret_val = 11;
   return ret_val;
   break;
  case 'c':
   ret_val = 12;
   return ret_val;
   break;
  case 'C':
   ret_val = 12;
   return ret_val;
   break;
  case 'd':
   ret_val = 13;
   return ret_val;
   break;
  case 'D':
   ret_val = 13;
   return ret_val;
   break;
  case 'e':
   ret_val = 14;
   return ret_val;
   break;
  case 'E':
   ret_val = 14;
   return ret_val;
   break;
  case 'f':
   ret_val = 15;
   return ret_val;
   break;
  case 'F':
   ret_val = 15;
   return ret_val;
   break;
  default: ;
   ret_val = -1;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT CHAR_octal_digit_value_I(CHAR self) {
 INT ret_val = ((INT) 0);
 CHAR L11 = ((CHAR) 0);
 L11 = self;
 switch (L11) {
  case '0':
   ret_val = 0;
   return ret_val;
   break;
  case '1':
   ret_val = 1;
   return ret_val;
   break;
  case '2':
   ret_val = 2;
   return ret_val;
   break;
  case '3':
   ret_val = 3;
   return ret_val;
   break;
  case '4':
   ret_val = 4;
   return ret_val;
   break;
  case '5':
   ret_val = 5;
   return ret_val;
   break;
  case '6':
   ret_val = 6;
   return ret_val;
   break;
  case '7':
   ret_val = 7;
   return ret_val;
   break;
  default: ;
   ret_val = -1;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT CODE_FILE_ARRAY_asize_IN(CODE_FILE_ARRAY self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


LAYOUT_ARR CLASS_LAYOUT_sorted_fiel(CLASS_LAYOUT self, FMAPIDENTdTP map) {
 LAYOUT_ARR ret_val;
 LAYOUT_ARR res;
 FMAPIDENTdTP L11;
 LAYOUT_ARR L21;
 TUPIDENTdTP L3;
 res = LAYOUT_ARR_create_INT_LA(((LAYOUT_ARR) NULL), FMAPIDENTdTP_size_INT(map));
 {
  struct FMAPIDENTdTP_pairsb_TUPI_frame_struct other1_0;
  FMAPIDENTdTP_pairsb_TUPI_frame 
  noname1 = &other1_0;
  struct LAYOUT_ARR_setb_TUPIDENT_frame_struct other1_1;
  LAYOUT_ARR_setb_TUPIDENT_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = res;
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = map;
    noname1->self = L11;
   }
   L3 = FMAPIDENTdTP_pairsb_TUPI(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = L3;
   LAYOUT_ARR_setb_TUPIDENT(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   /* No return value from iter call */;
  }
 }
 after_loop: ;
 LAYOUT_ARR_sort(res);
 ret_val = res;
 return ret_val;
}


STR CHAR_pretty_STR(CHAR self) {
 STR ret_val;
 CHAR L11 = ((CHAR) 0);
 STR s;
 BOOL L2;
 BOOL L3;
 extern STR name8;
 dSTR L4;
 STR L5;
 extern STR name8;
 extern STR a2;
 extern STR b2;
 extern STR f1;
 extern STR n1;
 extern STR r2;
 extern STR t1;
 extern STR v;
 extern STR name9;
 extern STR name10;
 extern STR name111;
 INT L6;
 STR L7;
 extern STR name8;
 if (CHAR_is_print_BOOL(self)) {
  L3 = (self!='\'');
 } else {
  L3 = FALSE;
 }
 if (L3) {
  L2 = (self!='\\');
 } else {
  L2 = FALSE;
 }
 if (L2) {
  L4 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L4)->value_part = self;
  L5 = STR_plus_dSTR_STR(((STR) &name8), L4);
  ret_val = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name8)));
  return ret_val;
 }
 L11 = self;
 switch (L11) {
  case '\7':
   ret_val = ((STR) &a2);
   return ret_val;
   break;
  case '\b':
   ret_val = ((STR) &b2);
   return ret_val;
   break;
  case '\f':
   ret_val = ((STR) &f1);
   return ret_val;
   break;
  case '\n':
   ret_val = ((STR) &n1);
   return ret_val;
   break;
  case '\r':
   ret_val = ((STR) &r2);
   return ret_val;
   break;
  case '\t':
   ret_val = ((STR) &t1);
   return ret_val;
   break;
  case '\v':
   ret_val = ((STR) &v);
   return ret_val;
   break;
  case '\\':
   ret_val = ((STR) &name9);
   return ret_val;
   break;
  case '\'':
   ret_val = ((STR) &name10);
   return ret_val;
   break;
  default: ;
   s = INT_octal_str_STR(((INT)((unsigned char)self)));
   L6 = STR_size_INT(s);
   L7 = STR_tail_INT_STR(s, (INTMINUS(L6,2)));
   ret_val = STR_append_STR_STR_STR(((STR) &name111), L7, ((STR) &name8));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


STR CLASS_LAYOUT_str_STR(CLASS_LAYOUT self) {
 return ATTR(self,str1);
}


STR CLASS_LAYOUT_typedef_CGE(CLASS_LAYOUT self, CGEN c) {
 STR ret_val;
 MANGLE m;
 STR cname;
 STR res;
 LAYOUT_ARR L11;
 TUPIDENTdTP p = TUPIDENTdTP_zero;
 extern STR typedefstruct1;
 STR L2;
 extern STR S_struct3;
 extern STR layoutfor;
 STR L3;
 dTP L4;
 STR L5;
 extern STR name112;
 STR L6;
 extern STR S_struct1;
 extern STR OB_HEADERheader;
 BOOL L7;
 TUPIDENTdTP L8;
 dSTR L9;
 STR L10;
 STR L12;
 dSTR L13;
 STR L14;
 OB L15;
 STR L16;
 extern STR name85;
 dTP L17;
 BOOL L18;
 extern STR struct3;
 STR L19;
 STR L20;
 extern STR S_struct4;
 STR L21;
 OB L22;
 STR L23;
 extern STR name85;
 extern STR struct3;
 STR L24;
 STR L25;
 extern STR S_struct5;
 STR L26;
 OB L27;
 STR L28;
 extern STR name85;
 BOOL L29;
 extern STR INTasize;
 dSTR L30;
 STR L31;
 STR L32;
 extern STR arr_part4;
 dTP L33;
 BOOL L34;
 extern STR struct3;
 STR L35;
 STR L36;
 extern STR S_structarr_part;
 extern STR struct3;
 STR L37;
 STR L38;
 extern STR S_structarr_part1;
 INT L39;
 dSTR L40;
 STR L41;
 extern STR name118;
 BOOL L42;
 extern STR CHARfield_so_not_empty;
 extern STR name113;
 STR L43;
 STR L44;
 extern STR name114;
 m = ATTR(c,mangler);
 cname = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),tp1)), ((OB) c));
 L2 = STR_plus_dSTR_STR(((STR) &typedefstruct1), ((dSTR) cname));
 res = STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &S_struct3)));
 L3 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &layoutfor)));
 L4 = ATTR(ATTR(self,l1),tp1);
 if (L4==NULL) {
  FATAL("Dispatch on void in CLASS_LAYOUT::typedef(CGEN):STR");
 }
 L5 = STR_plus_dSTR_STR(L3, ((dSTR) (*dTP_str_STR[TAG(L4)+dTP_str_STR_offset])(L4)));
 res = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name112)));
 L6 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,tp1)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L6, ((dSTR) ((STR) &S_struct1))));
 res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &OB_HEADERheader)));
 L7 = (ATTR(ATTR(self,l1),at11)==((FMAPIDENTdTP) NULL));
 if ((!(L7))) {
  {
   struct LAYOUT_ARR_eltb_TUPIDENT_frame_struct other1_0;
   LAYOUT_ARR_eltb_TUPIDENT_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = CLASS_LAYOUT_sorted_fiel(self, ATTR(ATTR(self,l1),at11));
     noname1->self = L11;
    }
    L8 = LAYOUT_ARR_eltb_TUPIDENT(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    p = L8;
    if (CGEN_is_built_in_type_dT(LAYOUT_TBL_cgen, p.t2)) {
     L9 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
     ((CHAR_boxed) L9)->value_part = ' ';
     L10 = STR_plus_dSTR_STR(res, L9);
     L12 = STR_plus_dSTR_STR(L10, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
     L13 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
     ((CHAR_boxed) L13)->value_part = ' ';
     L14 = STR_plus_dSTR_STR(L12, L13);
     L15 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
     ((IDENT_boxed) L15)->value_part = p.t1;
     L16 = STR_plus_dSTR_STR(L14, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L15, ((OB) ATTR(ATTR(self,l1),tp1)))));
     res = STR_plus_dSTR_STR(L16, ((dSTR) ((STR) &name85)));
    }
    else {
     L17 = p.t2;
     if (L17==NULL) {
      FATAL("Dispatch on void in CLASS_LAYOUT::typedef(CGEN):STR");
     }
     L18 = (*dTP_is_value_BOOL[TAG(L17)+dTP_is_value_BOOL_offset])(L17);
     if ((!(L18))) {
      L19 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
      L20 = STR_plus_dSTR_STR(L19, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
      L21 = STR_plus_dSTR_STR(L20, ((dSTR) ((STR) &S_struct4)));
      L22 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
      ((IDENT_boxed) L22)->value_part = p.t1;
      L23 = STR_plus_dSTR_STR(L21, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L22, ((OB) ATTR(ATTR(self,l1),tp1)))));
      res = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &name85)));
     }
     else {
      L24 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
      L25 = STR_plus_dSTR_STR(L24, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
      L26 = STR_plus_dSTR_STR(L25, ((dSTR) ((STR) &S_struct5)));
      L27 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
      ((IDENT_boxed) L27)->value_part = p.t1;
      L28 = STR_plus_dSTR_STR(L26, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L27, ((OB) ATTR(ATTR(self,l1),tp1)))));
      res = STR_plus_dSTR_STR(L28, ((dSTR) ((STR) &name85)));
     }
    }
   }
  }
  after_loop: ;
 }
 L29 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 if ((!(L29))) {
  res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &INTasize)));
  if (CGEN_is_built_in_type_dT(LAYOUT_TBL_cgen, ATTR(ATTR(self,l1),arr1))) {
   L30 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L30)->value_part = ' ';
   L31 = STR_plus_dSTR_STR(res, L30);
   L32 = STR_plus_dSTR_STR(L31, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
   res = STR_plus_dSTR_STR(L32, ((dSTR) ((STR) &arr_part4)));
  }
  else {
   L33 = ATTR(ATTR(self,l1),arr1);
   if (L33==NULL) {
    FATAL("Dispatch on void in CLASS_LAYOUT::typedef(CGEN):STR");
   }
   L34 = (*dTP_is_value_BOOL[TAG(L33)+dTP_is_value_BOOL_offset])(L33);
   if ((!(L34))) {
    L35 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
    L36 = STR_plus_dSTR_STR(L35, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
    res = STR_plus_dSTR_STR(L36, ((dSTR) ((STR) &S_structarr_part)));
   }
   else {
    L37 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
    L38 = STR_plus_dSTR_STR(L37, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
    res = STR_plus_dSTR_STR(L38, ((dSTR) ((STR) &S_structarr_part1)));
   }
  }
  L39 = ATTR(ATTR(self,l1),asize);
  L40 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L40)->value_part = ((1>L39)?1:L39);
  L41 = STR_plus_dSTR_STR(res, L40);
  res = STR_plus_dSTR_STR(L41, ((dSTR) ((STR) &name118)));
 }
 if ((ATTR(ATTR(self,l1),at11)==((FMAPIDENTdTP) NULL))) {
  L42 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 } else {
  L42 = FALSE;
 }
 if (L42) {
  res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &CHARfield_so_not_empty)));
 }
 L43 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name113)));
 L44 = STR_plus_dSTR_STR(L43, ((dSTR) cname));
 res = STR_plus_dSTR_STR(L44, ((dSTR) ((STR) &name114)));
 ret_val = res;
 return ret_val;
}


STR CODE_FILE_bnd_rout_decla(CODE_FILE self) {
 STR ret_val;
 ARRAYSTR bstr;
 STR s = ((STR) NULL);
 FLISTAM_BND_CREATE_EXPR L11;
 AM_BND_CREATE_EXPR e;
 STR name11;
 ARRAYINT L21;
 INT i = ((INT) 0);
 INT L31 = ((INT) 0);
 INT num1 = ((INT) 0);
 ARRAYSTR L41;
 STR res;
 ARRAYSTR L51;
 AM_BND_CREATE_EXPR L6;
 BOOL L7;
 STR L8;
 dSTR L9;
 extern STR void6;
 STR L10;
 dSTR L12;
 STR L13;
 STR L14;
 extern STR S_ob1;
 INT L15;
 INT L16;
 dTP L17;
 INT L18;
 INT L19;
 extern STR name18;
 STR L20;
 extern STR name18;
 STR L22;
 ARRAYdTP L23;
 extern STR name69;
 extern STR name1;
 STR L24;
 bstr = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), FLISTAM_BND_CREATE_EXPR_11(ATTR(self,bnd_rout_creates)));
 {
  struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
  FLISTAM_BND_CREATE_EXPR_4_frame 
  noname1 = &other1_0;
  struct ARRAYSTR_setb_STR_frame_struct other1_1;
  ARRAYSTR_setb_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,bnd_rout_creates);
    noname1->self = L11;
   }
   L6 = FLISTAM_BND_CREATE_EXPR_4(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L6;
   name11 = CODE_FILE_mang_dOB_STR(self, ((OB) e));
   L7 = (ATTR(ATTR(e,fun),ret1)==((dTP) NULL));
   if ((!(L7))) {
    L8 = CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(ATTR(e,fun),ret1)));
    L9 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L9)->value_part = ' ';
    s = STR_plus_dSTR_STR(L8, L9);
   }
   else {
    s = ((STR) &void6);
   }
   L10 = STR_plus_dSTR_STR(s, ((dSTR) name11));
   L12 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L12)->value_part = '(';
   L13 = STR_plus_dSTR_STR(L10, L12);
   L14 = STR_plus_dSTR_STR(L13, ((dSTR) name11));
   s = STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &S_ob1)));
   {
    struct ARRAYINT_eltb_INT_frame_struct other2_0;
    ARRAYINT_eltb_INT_frame 
    noname3 = &other2_0;
    struct INT_upb_INT_frame_struct other2_1;
    INT_upb_INT_frame 
    noname4 = &other2_1;
    noname3->state = 0;
    noname4->state = 0;
    while (1) {
     if (noname3->state == 0) {
      L21 = ATTR(e,unbnd_args);
      noname3->self = L21;
     }
     L15 = ARRAYINT_eltb_INT(noname3);
     if (noname3->state == -1) {
      goto after_loop1;
     }
     i = L15;
     if (noname4->state == 0) {
      L31 = 0;
      noname4->self = L31;
     }
     L16 = INT_upb_INT(noname4);
     if (noname4->state == -1) {
      goto after_loop1;
     }
     num1 = L16;
     if ((i==0)) {
      L17 = ATTR(ATTR(e,fun),tp);
      if (L17==NULL) {
       FATAL("Dispatch on void in CODE_FILE::bnd_rout_declarations:STR");
      }
      L18 = (*dTP_kind_INT[TAG(L17)+dTP_kind_INT_offset])(L17);
      L19 = TP_KIND_ext_tp;
      if ((L18!=L19)) {
       L20 = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &name18)));
       s = STR_plus_dSTR_STR(L20, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(ATTR(e,fun),tp)))));
      }
     }
     else {
      L22 = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &name18)));
      L23 = ATTR(ATTR(e,fun),args1);
      s = STR_plus_dSTR_STR(L22, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ARRAYdTP_aget_INT_dTP(L23, (INTMINUS(i,1)))))));
     }
    }
   }
   after_loop1: ;
   s = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &name69)));
   if (noname2->state == 0) {
    L41 = bstr;
    noname2->self = L41;
   }
   noname2->arg1 = s;
   ARRAYSTR_setb_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   /* No return value from iter call */;
  }
 }
 after_loop: ;
 ARRAYSTR_sort(bstr);
 res = ((STR) &name1);
 {
  struct ARRAYSTR_eltb_STR_frame_struct other3_0;
  ARRAYSTR_eltb_STR_frame 
  noname5 = &other3_0;
  noname5->state = 0;
  while (1) {
   if (noname5->state == 0) {
    L51 = bstr;
    noname5->self = L51;
   }
   L24 = ARRAYSTR_eltb_STR(noname5);
   if (noname5->state == -1) {
    goto after_loop2;
   }
   res = STR_plus_dSTR_STR(res, ((dSTR) L24));
  }
 }
 after_loop2: ;
 SYSDESTROY(((OB) bstr));
 ret_val = res;
 return ret_val;
}


STR CODE_FILE_declaration_fo(CODE_FILE self, SIG sig1) {
 STR ret_val;
 STR res;
 STR decl;
 ARRAYdTP L11;
 dTP e;
 ARRAYdTP L21;
 STR L31;
 ARRAYdTP L41;
 ARRAYdTP L51;
 extern STR name1;
 dTP L6;
 extern STR externconstint;
 STR L7;
 extern STR S_offset3;
 extern STR const3;
 STR L8;
 extern STR S_entry;
 STR L9;
 STR L10;
 extern STR name102;
 BOOL L12;
 extern STR name96;
 STR L13;
 STR L14;
 extern STR name97;
 STR L15;
 BOOL L16;
 dTP L17;
 extern STR name18;
 STR L18;
 extern STR name31;
 extern STR extern2;
 STR L19;
 STR L20;
 extern STR name85;
 BOOL L22;
 STR L23;
 dSTR L24;
 extern STR void6;
 STR L25;
 dSTR L26;
 STR L27;
 extern STR S_frame3;
 dTP L28;
 INT L29;
 INT L30;
 STR L32;
 extern STR name18;
 dTP L33;
 extern STR OBself;
 extern STR name18;
 STR L34;
 dTP L35;
 extern STR name18;
 STR L36;
 dTP L37;
 extern STR name69;
 res = ((STR) &name1);
 L6 = ATTR(sig1,tp);
 if (L6==NULL) {
  FATAL("Dispatch on void in CODE_FILE::declaration_for(SIG):STR");
 }
 if ((*dTP_is_abstract_BOOL[TAG(L6)+dTP_is_abstract_BOOL_offset])(L6)) {
  L7 = STR_plus_dSTR_STR(((STR) &externconstint), ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
  res = STR_plus_dSTR_STR(L7, ((dSTR) ((STR) &S_offset3)));
  decl = ((STR) &const3);
  if (SIG_is_iter_BOOL(sig1)) {
   L8 = STR_plus_dSTR_STR(decl, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
   L9 = STR_plus_dSTR_STR(L8, ((dSTR) ((STR) &S_entry)));
   L10 = STR_plus_dSTR_STR(L9, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
   decl = STR_plus_dSTR_STR(L10, ((dSTR) ((STR) &name102)));
  }
  else {
   L12 = (ATTR(sig1,ret1)==((dTP) NULL));
   if ((!(L12))) {
    decl = STR_plus_dSTR_STR(decl, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(sig1,ret1)))));
   }
   L13 = STR_plus_dSTR_STR(decl, ((dSTR) ((STR) &name96)));
   L14 = STR_plus_dSTR_STR(L13, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
   L15 = STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &name97)));
   decl = STR_plus_dSTR_STR(L15, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(sig1,tp)))));
   L16 = (ATTR(sig1,args1)==((ARRAYdTP) NULL));
   if ((!(L16))) {
    {
     struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
     ARRAYdTP_eltb_dTP_frame 
     noname1 = &other1_0;
     noname1->state = 0;
     while (1) {
      if (noname1->state == 0) {
       L11 = ATTR(sig1,args1);
       noname1->self = L11;
      }
      L17 = ARRAYdTP_eltb_dTP(noname1);
      if (noname1->state == -1) {
       goto after_loop;
      }
      e = L17;
      L18 = STR_plus_dSTR_STR(decl, ((dSTR) ((STR) &name18)));
      decl = STR_plus_dSTR_STR(L18, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) e))));
     }
    }
    after_loop: ;
   }
   decl = STR_plus_dSTR_STR(decl, ((dSTR) ((STR) &name31)));
  }
  L19 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &extern2)));
  L20 = STR_plus_dSTR_STR(L19, ((dSTR) decl));
  res = STR_plus_dSTR_STR(L20, ((dSTR) ((STR) &name85)));
  ret_val = res;
  return ret_val;
 }
 L22 = (ATTR(sig1,ret1)==((dTP) NULL));
 if ((!(L22))) {
  L23 = STR_plus_dSTR_STR(res, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(sig1,ret1)))));
  L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L24)->value_part = ' ';
  res = STR_plus_dSTR_STR(L23, L24);
 }
 else {
  res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &void6)));
 }
 L25 = STR_plus_dSTR_STR(res, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
 L26 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L26)->value_part = '(';
 res = STR_plus_dSTR_STR(L25, L26);
 if (SIG_is_iter_BOOL(sig1)) {
  L27 = STR_plus_dSTR_STR(res, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) sig1))));
  res = STR_plus_dSTR_STR(L27, ((dSTR) ((STR) &S_frame3)));
 }
 else {
  L28 = ATTR(sig1,tp);
  if (L28==NULL) {
   FATAL("Dispatch on void in CODE_FILE::declaration_for(SIG):STR");
  }
  L29 = (*dTP_kind_INT[TAG(L28)+dTP_kind_INT_offset])(L28);
  L30 = TP_KIND_ext_tp;
  if ((L29==L30)) {
   {
    struct ARRAYdTP_eltb_dTP_frame_struct other2_0;
    ARRAYdTP_eltb_dTP_frame 
    noname2 = &other2_0;
    struct STR_separateb_STR_STR_frame_struct other2_1;
    STR_separateb_STR_STR_frame 
    noname3 = &other2_1;
    noname2->state = 0;
    noname3->state = 0;
    while (1) {
     if (noname3->state == 0) {
      L31 = ((STR) &name18);
      noname3->self = L31;
     }
     if (noname2->state == 0) {
      L21 = ATTR(sig1,args1);
      noname2->self = L21;
     }
     L33 = ARRAYdTP_eltb_dTP(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     noname3->arg1 = CODE_FILE_mang_dOB_STR(self, ((OB) L33));
     L32 = STR_separateb_STR_STR(noname3);
     if (noname3->state == -1) {
      goto after_loop1;
     }
     res = STR_plus_dSTR_STR(res, ((dSTR) L32));
    }
   }
   after_loop1: ;
  }
  else {
   if (ATTR(sig1,is_forked)) {
    res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &OBself)));
    {
     struct ARRAYdTP_eltb_dTP_frame_struct other3_0;
     ARRAYdTP_eltb_dTP_frame 
     noname4 = &other3_0;
     noname4->state = 0;
     while (1) {
      L34 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name18)));
      if (noname4->state == 0) {
       L41 = ATTR(sig1,args1);
       noname4->self = L41;
      }
      L35 = ARRAYdTP_eltb_dTP(noname4);
      if (noname4->state == -1) {
       goto after_loop2;
      }
      res = STR_plus_dSTR_STR(L34, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) L35))));
     }
    }
    after_loop2: ;
   }
   else {
    res = STR_plus_dSTR_STR(res, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(sig1,tp)))));
    {
     struct ARRAYdTP_eltb_dTP_frame_struct other4_0;
     ARRAYdTP_eltb_dTP_frame 
     noname5 = &other4_0;
     noname5->state = 0;
     while (1) {
      L36 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name18)));
      if (noname5->state == 0) {
       L51 = ATTR(sig1,args1);
       noname5->self = L51;
      }
      L37 = ARRAYdTP_eltb_dTP(noname5);
      if (noname5->state == -1) {
       goto after_loop3;
      }
      res = STR_plus_dSTR_STR(L36, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) L37))));
     }
    }
    after_loop3: ;
   }
  }
 }
 res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name69)));
 ret_val = res;
 return ret_val;
}


STR CODE_FILE_mang_dOB_STR(CODE_FILE self, OB ob) {
 STR ret_val;
 ret_val = MANGLE_mangle_dOB_dOB_ST(ATTR(CODE_FILE_cgen,mangler), ob, ((OB) CODE_FILE_cgen));
 return ret_val;
}


STR CODE_FILE_merge_STR(CODE_FILE self) {
 STR ret_val;
 CODE_FILE_ARRAY sorted;
 FLISTCODE_FILE L11;
 CODE_FILE_ARRAY L21;
 CODE_FILE last1;
 CODE_FILE_ARRAY L31;
 CODE_FILE next;
 STR res;
 FLISTCODE_FILE L41;
 CODE_FILE next1;
 CODE_FILE L5;
 CODE_FILE L6;
 INT L7;
 INT L8;
 BOOL L9;
 BOOL L10;
 BOOL L12;
 BOOL L13;
 INT L14;
 INT L15;
 INT L16;
 INT L17;
 INT L18;
 INT L19;
 FLISTFSTR L20;
 BOOL L22;
 FSETdLAYOUT L23;
 BOOL L24;
 FSETSIG L25;
 extern STR name1;
 CODE_FILE L26;
 dSTR L27;
 STR L28;
 extern STR c1;
 sorted = CODE_FILE_ARRAY_create_I(((CODE_FILE_ARRAY) NULL), FLISTCODE_FILE_size_INT(CODE_FILE_all));
 {
  struct FLISTCODE_FILE_eltb_CODE_frame_struct other1_0;
  FLISTCODE_FILE_eltb_CODE_frame 
  noname1 = &other1_0;
  struct CODE_FILE_ARRAY_setb_COD_frame_struct other1_1;
  CODE_FILE_ARRAY_setb_COD_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = sorted;
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = CODE_FILE_all;
    noname1->self = L11;
   }
   L5 = FLISTCODE_FILE_eltb_CODE(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = L5;
   CODE_FILE_ARRAY_setb_COD(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   /* No return value from iter call */;
  }
 }
 after_loop: ;
 CODE_FILE_ARRAY_sort(sorted);
 CODE_FILE_todo_FLISTCODE(self, FLISTCODE_FILE_create_FL(((FLISTCODE_FILE) NULL)));
 last1 = ((CODE_FILE) NULL);
 {
  struct CODE_FILE_ARRAY_eltb_COD_frame_struct other2_0;
  CODE_FILE_ARRAY_eltb_COD_frame 
  noname3 = &other2_0;
  noname3->state = 0;
  while (1) {
   if (noname3->state == 0) {
    L31 = sorted;
    noname3->self = L31;
   }
   L6 = CODE_FILE_ARRAY_eltb_COD(noname3);
   if (noname3->state == -1) {
    goto after_loop1;
   }
   next = L6;
   SATTR(next,text1,FLISTFSTR_push_FSTR_FLIS(ATTR(next,text1), ATTR(next,ntext)));
   L7 = ATTR(next,length1);
   L8 = FSTR_length_INT(ATTR(next,ntext));
   SATTR(next,length1,(INTPLUS(L7,L8)));
   SATTR(next,ntext,FSTR_create_FSTR(((FSTR) NULL)));
   L10 = ATTR(next,is_c_code);
   if ((!(L10))) {
    L9 = TRUE;
   } else {
    L9 = ATTR(next,do_not_merge);
   }
   if (L9) {
    CODE_FILE_todo_FLISTCODE(self, FLISTCODE_FILE_push_CODE(CODE_FILE_todo, next));
   }
   else {
    if ((last1==((CODE_FILE) NULL))) {
     last1 = next;
    }
    else {
     L13 = CODE_FILE_same_options_a(last1, next);
     if ((!(L13))) {
      L12 = TRUE;
     } else {
      L14 = ATTR(last1,length1);
      L15 = ATTR(next,length1);
      L16 = (INTPLUS(L14,L15));
      L17 = ATTR(CODE_FILE_cgen,threshold);
      L12 = (L16>L17);
     }
     if (L12) {
      CODE_FILE_todo_FLISTCODE(self, FLISTCODE_FILE_push_CODE(CODE_FILE_todo, last1));
      last1 = next;
     }
     else {
      SATTR(last1,text1,FLISTFSTR_concat_FLISTFS(ATTR(last1,text1), ATTR(next,text1)));
      L18 = ATTR(last1,length1);
      L19 = ATTR(next,length1);
      SATTR(last1,length1,(INTPLUS(L18,L19)));
      SATTR(last1,decs,FSETSIG_union_FSETSIG_FS(ATTR(last1,decs), ATTR(next,decs)));
      SATTR(last1,layouts,FSETdLAYOUT_union_FSETdL(ATTR(last1,layouts), ATTR(next,layouts)));
      SATTR(last1,globals,FSETAM_GLOBAL_EXPR_union(ATTR(last1,globals), ATTR(next,globals)));
      SATTR(last1,bnd_rout_creates,FLISTAM_BND_CREATE_EXPR_18(ATTR(last1,bnd_rout_creates), ATTR(next,bnd_rout_creates)));
      SATTR(last1,unboxes,FSETTUPSIGSIG_union_FSET(ATTR(last1,unboxes), ATTR(next,unboxes)));
      SATTR(last1,externs1,FSETSTR_union_FSETSTR_FS(ATTR(last1,externs1), ATTR(next,externs1)));
      SATTR(last1,iters,FSETSIG_union_FSETSIG_FS(ATTR(last1,iters), ATTR(next,iters)));
      L20 = ATTR(next,text1);
      SYSDESTROY(((OB) L20));
      L22 = (ATTR(next,layouts)==((FSETdLAYOUT) NULL));
      if ((!(L22))) {
       L23 = ATTR(next,layouts);
       SYSDESTROY(((OB) L23));
      }
      L24 = (ATTR(next,decs)==((FSETSIG) NULL));
      if ((!(L24))) {
       L25 = ATTR(next,decs);
       SYSDESTROY(((OB) L25));
      }
     }
    }
   }
  }
 }
 after_loop1: ;
 CODE_FILE_todo_FLISTCODE(self, FLISTCODE_FILE_push_CODE(CODE_FILE_todo, last1));
 res = ((STR) &name1);
 {
  struct FLISTCODE_FILE_eltb_CODE_frame_struct other3_0;
  FLISTCODE_FILE_eltb_CODE_frame 
  noname4 = &other3_0;
  noname4->state = 0;
  while (1) {
   if (noname4->state == 0) {
    L41 = CODE_FILE_todo;
    noname4->self = L41;
   }
   L26 = FLISTCODE_FILE_eltb_CODE(noname4);
   if (noname4->state == -1) {
    goto after_loop2;
   }
   next1 = L26;
   if (ATTR(next1,is_c_code)) {
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = ' ';
    L28 = STR_plus_dSTR_STR(res, L27);
    res = STR_plus_dSTR_STR(L28, ((dSTR) STR_replace_suffix_STR_S(ATTR(next1,name1), ((STR) &c1), ATTR(CODE_FILE_cgen,c_obj))));
   }
  }
 }
 after_loop2: ;
 ret_val = res;
 return ret_val;
}


STR CODE_FILE_unbox_dec_SIG_(CODE_FILE self, SIG s, SIG abs1) {
 STR ret_val;
 STR res;
 STR name11;
 ARRAYdTP L11;
 dTP se;
 ARRAYdTP L21;
 dTP abse;
 INT L31 = ((INT) 0);
 INT idx = ((INT) 0);
 extern STR name1;
 STR L4;
 extern STR S_unbox;
 extern STR void6;
 STR L5;
 dSTR L6;
 BOOL L7;
 dTP L8;
 dTP L9;
 STR L10;
 dSTR L12;
 STR L13;
 STR L14;
 extern STR S_frame_boxed;
 STR L15;
 dSTR L16;
 STR L17;
 STR L18;
 extern STR S_frame3;
 BOOL L19;
 dTP L20;
 dTP L22;
 STR L23;
 extern STR name21;
 STR L24;
 STR L25;
 extern STR S_boxed2;
 STR L26;
 extern STR name21;
 STR L27;
 dTP L28;
 dTP L29;
 INT L30;
 BOOL L32;
 dTP L33;
 dTP L34;
 extern STR name18;
 STR L35;
 STR L36;
 extern STR S_boxed2;
 extern STR name18;
 STR L37;
 extern STR name69;
 extern STR void10;
 STR L38;
 STR L39;
 extern STR frame_alloc;
 res = ((STR) &name1);
 L4 = CODE_FILE_mang_dOB_STR(self, ((OB) s));
 name11 = STR_plus_dSTR_STR(L4, ((dSTR) ((STR) &S_unbox)));
 if ((ATTR(s,ret1)==((dTP) NULL))) {
  res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &void6)));
 }
 else {
  L5 = STR_plus_dSTR_STR(res, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(abs1,ret1)))));
  L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L6)->value_part = ' ';
  res = STR_plus_dSTR_STR(L5, L6);
 }
 if (SIG_is_iter_BOOL(s)) {
  L8 = ATTR(abs1,tp);
  if (L8==NULL) {
   FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
  }
  if ((*dTP_is_abstract_BOOL[TAG(L8)+dTP_is_abstract_BOOL_offset])(L8)) {
   L9 = ATTR(s,tp);
   if (L9==NULL) {
    FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
   }
   L7 = (*dTP_is_value_BOOL[TAG(L9)+dTP_is_value_BOOL_offset])(L9);
  } else {
   L7 = FALSE;
  }
  if (L7) {
   L10 = STR_plus_dSTR_STR(res, ((dSTR) name11));
   L12 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L12)->value_part = '(';
   L13 = STR_plus_dSTR_STR(L10, L12);
   L14 = STR_plus_dSTR_STR(L13, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) abs1))));
   res = STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &S_frame_boxed)));
  }
  else {
   L15 = STR_plus_dSTR_STR(res, ((dSTR) name11));
   L16 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L16)->value_part = '(';
   L17 = STR_plus_dSTR_STR(L15, L16);
   L18 = STR_plus_dSTR_STR(L17, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) abs1))));
   res = STR_plus_dSTR_STR(L18, ((dSTR) ((STR) &S_frame3)));
  }
 }
 else {
  L20 = ATTR(abs1,tp);
  if (L20==NULL) {
   FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
  }
  if ((*dTP_is_abstract_BOOL[TAG(L20)+dTP_is_abstract_BOOL_offset])(L20)) {
   L22 = ATTR(s,tp);
   if (L22==NULL) {
    FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
   }
   L19 = (*dTP_is_value_BOOL[TAG(L22)+dTP_is_value_BOOL_offset])(L22);
  } else {
   L19 = FALSE;
  }
  if (L19) {
   L23 = STR_plus_dSTR_STR(res, ((dSTR) name11));
   L24 = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &name21)));
   L25 = STR_plus_dSTR_STR(L24, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(s,tp)))));
   res = STR_plus_dSTR_STR(L25, ((dSTR) ((STR) &S_boxed2)));
  }
  else {
   L26 = STR_plus_dSTR_STR(res, ((dSTR) name11));
   L27 = STR_plus_dSTR_STR(L26, ((dSTR) ((STR) &name21)));
   res = STR_plus_dSTR_STR(L27, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) ATTR(s,tp)))));
  }
  {
   struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
   ARRAYdTP_eltb_dTP_frame 
   noname1 = &other1_0;
   struct ARRAYdTP_eltb_dTP_frame_struct other1_1;
   ARRAYdTP_eltb_dTP_frame 
   noname2 = &other1_1;
   struct INT_upb_INT_frame_struct other1_2;
   INT_upb_INT_frame 
   noname3 = &other1_2;
   noname1->state = 0;
   noname2->state = 0;
   noname3->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = ATTR(s,args1);
     noname1->self = L11;
    }
    L28 = ARRAYdTP_eltb_dTP(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    se = L28;
    if (noname2->state == 0) {
     L21 = ATTR(abs1,args1);
     noname2->self = L21;
    }
    L29 = ARRAYdTP_eltb_dTP(noname2);
    if (noname2->state == -1) {
     goto after_loop;
    }
    abse = L29;
    if (noname3->state == 0) {
     L31 = 1;
     noname3->self = L31;
    }
    L30 = INT_upb_INT(noname3);
    if (noname3->state == -1) {
     goto after_loop;
    }
    idx = L30;
    L33 = abse;
    if (L33==NULL) {
     FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
    }
    if ((*dTP_is_abstract_BOOL[TAG(L33)+dTP_is_abstract_BOOL_offset])(L33)) {
     L34 = se;
     if (L34==NULL) {
      FATAL("Dispatch on void in CODE_FILE::unbox_dec(SIG,SIG):STR");
     }
     L32 = (*dTP_is_value_BOOL[TAG(L34)+dTP_is_value_BOOL_offset])(L34);
    } else {
     L32 = FALSE;
    }
    if (L32) {
     L35 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name18)));
     L36 = STR_plus_dSTR_STR(L35, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) se))));
     res = STR_plus_dSTR_STR(L36, ((dSTR) ((STR) &S_boxed2)));
    }
    else {
     L37 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name18)));
     res = STR_plus_dSTR_STR(L37, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) se))));
    }
   }
  }
  after_loop: ;
 }
 res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name69)));
 if (SIG_is_iter_BOOL(s)) {
  L38 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &void10)));
  L39 = STR_plus_dSTR_STR(L38, ((dSTR) CODE_FILE_mang_dOB_STR(self, ((OB) s))));
  res = STR_plus_dSTR_STR(L39, ((dSTR) ((STR) &frame_alloc)));
 }
 ret_val = res;
 return ret_val;
}


void CHANGE_VARS_after_one_us(CHANGE_VARS self) {
 FMAPAM_LOCAL_EXPRAM_LOCA L1;
 L1 = ATTR(self,new_subst);
 SYSDESTROY(((OB) L1));
}


void CHANGE_VARS_after_saving(CHANGE_VARS self) {
 FMAPAM_LOCAL_EXPRAM_LOCA L1;
 L1 = ATTR(self,saved_subst);
 SYSDESTROY(((OB) L1));
}


void CHECK_AM_check_code(CHECK_AM self) {
 FSETdTP tp_done;
 dTP tp;
 FSETdTP L11;
 IFC ti;
 SIG_TBL L21;
 INT L3;
 dTP L4;
 BOOL L5;
 BOOL L6;
 BOOL L7;
 BOOL L8;
 SIG L9;
 while (1) {
  L3 = FSETdTP_size_INT(ATTR(ATTR(self,prog1),tp_done));
  if ((L3==0)) {
   goto after_loop;
  }
  tp_done = ATTR(ATTR(self,prog1),tp_done);
  SATTR(ATTR(self,prog1),tp_done,((FSETdTP) NULL));
  {
   struct FSETdTP_eltb_dTP_frame_struct other2_0;
   FSETdTP_eltb_dTP_frame 
   noname1 = &other2_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = tp_done;
     noname1->self = L11;
    }
    L4 = FSETdTP_eltb_dTP(noname1);
    if (noname1->state == -1) {
     goto after_loop1;
    }
    tp = L4;
    if (tp==NULL) {
    } else
    switch (TAG(tp)) {
     case TP_CLASS_tag:
      L5 = TP_CLASS_is_abstract_BOO(((TP_CLASS) tp));
      if ((!(L5))) {
       ti = IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(self,prog1),ifc_tbl), tp);
       L7 = (ti==((IFC) NULL));
       if ((!(L7))) {
        L8 = (ATTR(ti,sigs1)==((SIG_TBL) NULL));
        L6 = (!(L8));
       } else {
        L6 = FALSE;
       }
       if (L6) {
        {
         struct SIG_TBL_eltb_SIG_frame_struct other3_0;
         SIG_TBL_eltb_SIG_frame 
         noname2 = &other3_0;
         noname2->state = 0;
         while (1) {
          if (noname2->state == 0) {
           L21 = ATTR(ti,sigs1);
           noname2->self = L21;
          }
          L9 = SIG_TBL_eltb_SIG(noname2);
          if (noname2->state == -1) {
           goto after_loop2;
          }
          CHECK_AM_check_sig_SIG(self, L9);
         }
        }
        after_loop2: ;
       }
      } break;
     default: ;
    }
   }
  }
  after_loop1: ;
 }
 after_loop: ;
}


void CHECK_AM_check_sig_SIG(CHECK_AM self, SIG s) {
 ELT elt1;
 AM_ROUT_DEF am;
 OUT L1;
 extern STR Checksig;
 OUT L2;
 OUT L3;
 extern STR name15;
 dTP L4;
 BOOL L5;
 OUT L6;
 extern STR CheckAMfor;
 OUT L7;
 OUT L8;
 extern STR name27;
 OUT L9;
 extern STR name15;
 dBACK_END L10;
 if (ATTR(s,am_created)) {
  return;
 }
 SATTR(s,am_created,TRUE);
 if (ATTR(ATTR(self,prog1),show_checked_sig)) {
  L1 = OUT_create_OUT(((OUT) NULL));
  L2 = OUT_plus_dSTR_OUT(L1, ((dSTR) ((STR) &Checksig)));
  L3 = OUT_plus_dSTR_OUT(L2, ((dSTR) ATTR(s,str)));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &name15)));
 }
 L4 = ATTR(s,tp);
 if (L4==NULL) {
  FATAL("Dispatch on void in CHECK_AM::check_sig(SIG)");
 }
 if ((*dTP_is_abstract_BOOL[TAG(L4)+dTP_is_abstract_BOOL_offset])(L4)) {
  return;
 }
 elt1 = ELT_TBL_elt_with_sig_SIG(ATTR(IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), ATTR(s,tp)),elts), s);
 if (ATTR(elt1,is_external)) {
  L5 = ELT_is_abstract_BOOL(elt1);
 } else {
  L5 = FALSE;
 }
 if (L5) {
  return;
 }
 if ((elt1==((ELT) NULL))) {
  return;
 }
 am = TRANS_transform_elt_ELT_(((TRANS) NULL), elt1);
 if ((am==((AM_ROUT_DEF) NULL))) {
  return;
 }
 if (ATTR(ATTR(self,prog1),show_am_check)) {
  L6 = OUT_create_OUT(((OUT) NULL));
  L7 = OUT_plus_dSTR_OUT(L6, ((dSTR) ((STR) &CheckAMfor)));
  L8 = OUT_plus_dSTR_OUT(L7, ((dSTR) ATTR(ATTR(am,sig11),str)));
  OUT_plus_dSTR(L8, ((dSTR) ((STR) &name27)));
  AM_OUT_AM_ROUT_DEF_out_A(((AM_OUT) NULL), am);
  L9 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &name15)));
 }
 if (ATTR(ATTR(self,prog1),generate_checked_code)) {
  L10 = ATTR(ATTR(self,prog1),back_end);
  if (L10==NULL) {
   FATAL("Dispatch on void in CHECK_AM::check_sig(SIG)");
  }
  (*dBACK_END_emit_AM_ROUT_D[TAG(L10)+dBACK_END_emit_AM_ROUT_D_offset])(L10, am);
 }
}


void CHECK_IFC_CONFORMANCE_ch(CHECK_IFC_CONFORMANCE self) {
 FSETdTP L11;
 dTP tp;
 IFC ti;
 TP_CLASS par11;
 FSETTP_CLASS L21;
 SIG ncs;
 dTP chld;
 FSETdTP L31;
 dTP L4;
 extern STR Cantcomputeinterfaceof;
 STR L5;
 extern STR name5;
 TP_CLASS L6;
 BOOL L7;
 extern STR Theinterfaceoftype;
 STR L8;
 extern STR doesnthaveasignatureconf;
 STR L9;
 STR L10;
 extern STR initsparent;
 STR L12;
 STR L13;
 extern STR name5;
 dTP L14;
 IFC L15;
 BOOL L16;
 extern STR Theinterfaceoftype;
 STR L17;
 extern STR isntconformedtobythechil;
 STR L18;
 STR L19;
 extern STR name5;
 {
  struct FSETdTP_eltb_dTP_frame_struct other1_0;
  FSETdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,prog1),tp_done);
    noname1->self = L11;
   }
   L4 = FSETdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   tp = L4;
   if (tp==NULL) {
   } else
   switch (TAG(tp)) {
    case TP_CLASS_tag:
     ti = IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(self,prog1),ifc_tbl), tp);
     if ((ti==((IFC) NULL))) {
      CHECK_IFC_CONFORMANCE_er(self, ((dPROG_ERR) NULL));
      L5 = STR_plus_dSTR_STR(((STR) &Cantcomputeinterfaceof), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) tp))));
      CHECK_IFC_CONFORMANCE_er1(self, STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name5))));
      return;
     }
     if (ATTR(ATTR(self,prog1),show_ifc)) {
      IFC_show(ti);
     }
     {
      struct FSETTP_CLASS_eltb_TP_CLA_frame_struct other2_0;
      FSETTP_CLASS_eltb_TP_CLA_frame 
      noname2 = &other2_0;
      noname2->state = 0;
      while (1) {
       if (noname2->state == 0) {
        L21 = TP_GRAPH_ANC_get_parents(ATTR(ATTR(ATTR(self,prog1),tp_graph),anc), ((TP_CLASS) tp));
        noname2->self = L21;
       }
       L6 = FSETTP_CLASS_eltb_TP_CLA(noname2);
       if (noname2->state == -1) {
        goto after_loop1;
       }
       par11 = L6;
       ncs = IFC_nonconforming_sig_IF(ti, IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(self,prog1),ifc_tbl), ((dTP) par11)));
       L7 = (ncs==((SIG) NULL));
       if ((!(L7))) {
        CHECK_IFC_CONFORMANCE_er(self, ((dPROG_ERR) NULL));
        L8 = STR_plus_dSTR_STR(((STR) &Theinterfaceoftype), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) tp))));
        L9 = STR_plus_dSTR_STR(L8, ((dSTR) ((STR) &doesnthaveasignatureconf)));
        L10 = STR_plus_dSTR_STR(L9, ((dSTR) ATTR(ncs,str)));
        L12 = STR_plus_dSTR_STR(L10, ((dSTR) ((STR) &initsparent)));
        L13 = STR_plus_dSTR_STR(L12, ((dSTR) TP_CLASS_str_STR(par11)));
        CHECK_IFC_CONFORMANCE_er1(self, STR_plus_dSTR_STR(L13, ((dSTR) ((STR) &name5))));
       }
      }
     }
     after_loop1: ;
     {
      struct FSETdTP_eltb_dTP_frame_struct other3_0;
      FSETdTP_eltb_dTP_frame 
      noname3 = &other3_0;
      noname3->state = 0;
      while (1) {
       if (noname3->state == 0) {
        L31 = TP_GRAPH_DES_get_childre(ATTR(ATTR(ATTR(self,prog1),tp_graph),des1), ((TP_CLASS) tp));
        noname3->self = L31;
       }
       L14 = FSETdTP_eltb_dTP(noname3);
       if (noname3->state == -1) {
        goto after_loop2;
       }
       chld = L14;
       if (chld==NULL) {
        goto after_loop2;
       } else
       switch (TAG(chld)) {
        case TP_CLASS_tag:
         L15 = IFC_TBL_ifc_of_dTP_IFC(ATTR(ATTR(self,prog1),ifc_tbl), chld);
         L16 = IFC_conforms_to_IFC_BOOL(L15, ti);
         if ((!(L16))) {
          CHECK_IFC_CONFORMANCE_er(self, ((dPROG_ERR) NULL));
          L17 = STR_plus_dSTR_STR(((STR) &Theinterfaceoftype), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) tp))));
          L18 = STR_plus_dSTR_STR(L17, ((dSTR) ((STR) &isntconformedtobythechil)));
          L19 = STR_plus_dSTR_STR(L18, ((dSTR) TP_CLASS_str_STR(((TP_CLASS) chld))));
          CHECK_IFC_CONFORMANCE_er1(self, STR_plus_dSTR_STR(L19, ((dSTR) ((STR) &name5))));
         } break;
        default: ;
         goto after_loop2;
       }
      }
     }
     after_loop2: ; break;
    default: ;
   }
  }
 }
 after_loop: ;
}


void CHECK_IFC_CONFORMANCE_er(CHECK_IFC_CONFORMANCE self, dPROG_ERR t) {
 PROG_err_loc_dPROG_ERR(ATTR(self,prog1), t);
}


void CHECK_IFC_CONFORMANCE_er1(CHECK_IFC_CONFORMANCE self, STR s) {
 PROG_err_STR(ATTR(self,prog1), s);
}


void CLASS_LAYOUT_layouts_FSE(CLASS_LAYOUT self, FSETCLASS_LAYOUT layouts) {
 CLASS_LAYOUT_layouts = layouts;
}


void CODE_FILE_ARRAY_aset_INT(CODE_FILE_ARRAY self, INT ind, CODE_FILE val1) {
 SARR(self,ind,val1);
}


void CODE_FILE_ARRAY_asetb_CO(CODE_FILE_ARRAY_asetb_CO_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   CODE_FILE_ARRAY_aset_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void CODE_FILE_ARRAY_insertio(CODE_FILE_ARRAY self, INT l, INT u) {
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 CODE_FILE e;
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT j = ((INT) 0);
 INT L5;
 INT L6;
 INT L7;
 
 INT L8;
 CODE_FILE L9;
 INT L10;
 INT L12;
 {
  BOOL noname1 = TRUE;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = (INTPLUS(l,1));
    L21 = u;
    L6 = L11;
    L7 = L21;
    L5 = L6;
   } else {
    L5++;
   }
   if (L5>L7) goto after_loop;
   i = L5;
   e = CODE_FILE_ARRAY_aget_INT(self, i);
   {
    struct INT_downtob_INT_INT_frame_struct other2_0;
    INT_downtob_INT_INT_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L31 = (INTMINUS(i,1));
      L41 = (INTMINUS(l,1));
      noname2->self = L31;
      noname2->arg1 = L41;
     }
     L8 = INT_downtob_INT_INT(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     j = L8;
     if ((j<l)) {
      CODE_FILE_ARRAY_aset_INT(self, l, e);
      goto after_loop1;
     }
     else {
      L9 = CODE_FILE_ARRAY_aget_INT(self, j);
      if (CODE_FILE_ARRAY_elt_lt_C(self, L9, e)) {
       L10 = (INTPLUS(j,1));
       CODE_FILE_ARRAY_aset_INT(self, L10, e);
       goto after_loop1;
      }
      else {
       L12 = (INTPLUS(j,1));
       CODE_FILE_ARRAY_aset_INT(self, L12, CODE_FILE_ARRAY_aget_INT(self, j));
      }
     }
    }
   }
   after_loop1: ;
  }
 }
 after_loop: ;
}


void CODE_FILE_ARRAY_quicksor(CODE_FILE_ARRAY self, INT l, INT u) {
 INT r = ((INT) 0);
 CODE_FILE t;
 INT m = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 CODE_FILE s;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 
 CODE_FILE L8;
 INT L9;
 INT L10;
 INT L12;
 L3 = (INTMINUS(u,l));
 L4 = CODE_FILE_ARRAY_quicksor1;
 if ((L3>L4)) {
  r = RND_int_INT_INT_INT(((RND) NULL), l, u);
  t = CODE_FILE_ARRAY_aget_INT(self, r);
  CODE_FILE_ARRAY_aset_INT(self, r, CODE_FILE_ARRAY_aget_INT(self, l));
  CODE_FILE_ARRAY_aset_INT(self, l, t);
  m = l;
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = (INTPLUS(l,1));
     L21 = u;
     L6 = L11;
     L7 = L21;
     L5 = L6;
    } else {
     L5++;
    }
    if (L5>L7) goto after_loop;
    i = L5;
    L8 = CODE_FILE_ARRAY_aget_INT(self, i);
    if (CODE_FILE_ARRAY_elt_lt_C(self, L8, t)) {
     m = (INTPLUS(m,1));
     s = CODE_FILE_ARRAY_aget_INT(self, m);
     CODE_FILE_ARRAY_aset_INT(self, m, CODE_FILE_ARRAY_aget_INT(self, i));
     CODE_FILE_ARRAY_aset_INT(self, i, s);
    }
   }
  }
  after_loop: ;
  t = CODE_FILE_ARRAY_aget_INT(self, l);
  CODE_FILE_ARRAY_aset_INT(self, l, CODE_FILE_ARRAY_aget_INT(self, m));
  CODE_FILE_ARRAY_aset_INT(self, m, t);
  L9 = (INTMINUS(m,1));
  if ((l<L9)) {
   CODE_FILE_ARRAY_quicksor(self, l, (INTMINUS(m,1)));
  }
  L10 = (INTPLUS(m,1));
  if ((L10<u)) {
   L12 = (INTPLUS(m,1));
   CODE_FILE_ARRAY_quicksor(self, L12, u);
  }
 }
 else {
  CODE_FILE_ARRAY_insertio(self, l, u);
 }
}


void CODE_FILE_ARRAY_setb_COD(CODE_FILE_ARRAY_setb_COD_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((CODE_FILE_ARRAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(CODE_FILE_ARRAY_asetb_CO_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    CODE_FILE_ARRAY_asetb_CO(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void CODE_FILE_ARRAY_sort(CODE_FILE_ARRAY self) {
 BOOL L1;
 INT L2;
 L1 = (self==((CODE_FILE_ARRAY) NULL));
 if ((!(L1))) {
  L2 = (ASIZE(self));
  CODE_FILE_ARRAY_quicksor(self, 0, (INTMINUS(L2,1)));
 }
}


void CODE_FILE_all_FLISTCODE_(CODE_FILE self, FLISTCODE_FILE all11) {
 CODE_FILE_all = all11;
}


void CODE_FILE_cgen_CGEN(CODE_FILE self, CGEN cgen) {
 CODE_FILE_cgen = cgen;
}


void CODE_FILE_dir_STR(CODE_FILE self, STR dir1) {
 CODE_FILE_dir = dir1;
}


void CODE_FILE_finalize(CODE_FILE self) {
 INT total1 = ((INT) 0);
 INT regen = ((INT) 0);
 FILE1 th;
 FLISTCODE_FILE L11;
 CODE_FILE cc;
 STR oldthp;
 FSTR wholetext;
 FSTR header1;
 ARRAYFSTR textarr;
 FLISTFSTR L21;
 ARRAYFSTR L31;
 ARRAYFSTR L41;
 FSTR t;
 STR newthp;
 FILE1 f;
 dSTR L5;
 STR L6;
 extern STR THUMBPRINTS;
 extern STR Couldntwritethumbprints;
 CODE_FILE L7;
 INT L8;
 FSTR L9;
 INT L10;
 INT L12;
 FSTR L13;
 BOOL L14;
 FLISTFSTR L15;
 BOOL L16;
 dSTR L17;
 dSTR L18;
 STR L19;
 PROG L20;
 extern STR Couldntwrite;
 FILE1 L22;
 dSTR L23;
 FILE1 L24;
 dSTR L25;
 FILE1 L26;
 FILE1 L27;
 dSTR L28;
 OUT L29;
 extern STR Regenerated;
 OUT L30;
 dSTR L32;
 OUT L33;
 extern STR of;
 OUT L34;
 dSTR L35;
 OUT L36;
 extern STR files11;
 CODE_FILE_generate_layou(self);
 total1 = 0;
 regen = 0;
 L5 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L5)->value_part = '/';
 L6 = STR_plus_dSTR_STR(CODE_FILE_dir, L5);
 th = FILE_open_for_write_STR_(((FILE1) NULL), STR_plus_dSTR_STR(L6, ((dSTR) ((STR) &THUMBPRINTS))));
 if (FILE_error_BOOL(th)) {
  PROG_barf_STR(CODE_FILE_prog, ((STR) &Couldntwritethumbprints));
 }
 {
  struct FLISTCODE_FILE_eltb_CODE_frame_struct other1_0;
  FLISTCODE_FILE_eltb_CODE_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = CODE_FILE_todo;
    noname1->self = L11;
   }
   L7 = FLISTCODE_FILE_eltb_CODE(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   cc = L7;
   oldthp = FMAPSTRSTR_get_STR_STR(CODE_FILE_thumbprints, ATTR(cc,name1));
   wholetext = FSTR_create_FSTR(((FSTR) NULL));
   if (ATTR(cc,is_c_code)) {
    header1 = CODE_FILE_header_info_FS(cc);
    wholetext = FSTR_plus_FSTR_FSTR(wholetext, header1);
    SYSDESTROY(((OB) header1));
   }
   L8 = FLISTFSTR_size_INT(ATTR(cc,text1));
   textarr = ARRAYFSTR_create_INT_ARR(((ARRAYFSTR) NULL), (INTPLUS(L8,1)));
   {
    struct FLISTFSTR_eltb_FSTR_frame_struct other2_0;
    FLISTFSTR_eltb_FSTR_frame 
    noname2 = &other2_0;
    struct ARRAYFSTR_setb_FSTR_frame_struct other2_1;
    ARRAYFSTR_setb_FSTR_frame 
    noname3 = &other2_1;
    noname2->state = 0;
    noname3->state = 0;
    while (1) {
     if (noname3->state == 0) {
      L31 = textarr;
      noname3->self = L31;
     }
     if (noname2->state == 0) {
      L21 = ATTR(cc,text1);
      noname2->self = L21;
     }
     L9 = FLISTFSTR_eltb_FSTR(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     noname3->arg1 = L9;
     ARRAYFSTR_setb_FSTR(noname3);
     if (noname3->state == -1) {
      goto after_loop1;
     }
     /* No return value from iter call */;
    }
   }
   after_loop1: ;
   L10 = ARRAYFSTR_size_INT(textarr);
   L12 = (INTMINUS(L10,1));
   ARRAYFSTR_aset_INT_FSTR(textarr, L12, ATTR(cc,ntext));
   ARRAYFSTR_sort(textarr);
   {
    struct ARRAYFSTR_eltb_FSTR_frame_struct other3_0;
    ARRAYFSTR_eltb_FSTR_frame 
    noname4 = &other3_0;
    noname4->state = 0;
    while (1) {
     if (noname4->state == 0) {
      L41 = textarr;
      noname4->self = L41;
     }
     L13 = ARRAYFSTR_eltb_FSTR(noname4);
     if (noname4->state == -1) {
      goto after_loop2;
     }
     t = L13;
     wholetext = FSTR_plus_FSTR_FSTR(wholetext, t);
     SYSDESTROY(((OB) t));
    }
   }
   after_loop2: ;
   L14 = (ATTR(cc,text1)==((FLISTFSTR) NULL));
   if ((!(L14))) {
    L15 = ATTR(cc,text1);
    SYSDESTROY(((OB) L15));
   }
   L16 = (textarr==((ARRAYFSTR) NULL));
   if ((!(L16))) {
    SYSDESTROY(((OB) textarr));
   }
   newthp = FSTR_thumbprint_STR(wholetext);
   L17 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L17)->value_part = '\n';
   if (STR_is_neq_STR_BOOL(oldthp, STR_plus_dSTR_STR(newthp, L17))) {
    L18 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L18)->value_part = '/';
    L19 = STR_plus_dSTR_STR(CODE_FILE_dir, L18);
    f = FILE_open_for_write_STR_(((FILE1) NULL), STR_plus_dSTR_STR(L19, ((dSTR) ATTR(cc,name1))));
    if (FILE_error_BOOL(f)) {
     L20 = CODE_FILE_prog;
     PROG_barf_STR(L20, STR_plus_dSTR_STR(((STR) &Couldntwrite), ((dSTR) ATTR(cc,name1))));
    }
    L22 = FILE_plus_dSTR_FILE(f, ((dSTR) wholetext));
    L23 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L23)->value_part = '\n';
    FILE_plus_dSTR(L22, L23);
    FILE_close(f);
    regen = (INTPLUS(regen,1));
   }
   L24 = FILE_plus_dSTR_FILE(th, ((dSTR) ATTR(cc,name1)));
   L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L25)->value_part = ' ';
   L26 = FILE_plus_dSTR_FILE(L24, L25);
   L27 = FILE_plus_dSTR_FILE(L26, ((dSTR) newthp));
   L28 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L28)->value_part = '\n';
   FILE_plus_dSTR(L27, L28);
   SYSDESTROY(((OB) wholetext));
   total1 = (INTPLUS(total1,1));
  }
 }
 after_loop: ;
 FILE_close(th);
 if (ATTR(CODE_FILE_prog,verbose)) {
  L29 = OUT_create_OUT(((OUT) NULL));
  L30 = OUT_plus_dSTR_OUT(L29, ((dSTR) ((STR) &Regenerated)));
  L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L32)->value_part = regen;
  L33 = OUT_plus_dSTR_OUT(L30, L32);
  L34 = OUT_plus_dSTR_OUT(L33, ((dSTR) ((STR) &of)));
  L35 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L35)->value_part = total1;
  L36 = OUT_plus_dSTR_OUT(L34, L35);
  OUT_flush(OUT_plus_dSTR_OUT(L36, ((dSTR) ((STR) &files11))));
 }
}


void CODE_FILE_generate_layou(CODE_FILE self) {
 FSETdLAYOUT done;
 FLISTdLAYOUT stilltodo;
 FLISTCODE_FILE L11;
 CODE_FILE cc;
 FSETSIG L21;
 SIG sig1;
 AM_ROUT_DEF a;
 FSETBUILTIN_LAYOUT L31;
 FSETEXTERNAL_LAYOUT L41;
 FSETABSTRACT_LAYOUT L51;
 FSETCLASS_LAYOUT L61;
 FSETVALUE_CLASS_LAYOUT L71;
 FMAPAM_BND_CREATE_EXPRBO L81;
 FSETBOUND_TYPE_LAYOUT L91;
 FMAPAM_ROUT_DEFFRAME_LAY L101;
 FMAPSIGARG_LAYOUT L121;
 LAYOUT_ARRAY stillarr;
 FLISTdLAYOUT L131;
 LAYOUT_ARRAY L141;
 LAYOUT_ARRAY L151;
 FLISTdLAYOUT next_stilltodo;
 FLISTdLAYOUT L161;
 dLAYOUT l;
 FLISTdLAYOUT deps;
 BOOL okay = ((BOOL) 0);
 FLISTdLAYOUT L171;
 dLAYOUT d;
 FLISTdLAYOUT L181;
 dLAYOUT d1;
 FLISTCODE_FILE L191;
 CODE_FILE cc1;
 dLAYOUT e;
 FSETdLAYOUT seen;
 dLAYOUT e2 = ((dLAYOUT) NULL);
 FLISTdLAYOUT L201;
 CODE_FILE L22;
 SIG L23;
 dTP L24;
 BOOL L25;
 FSETdLAYOUT L26;
 BUILTIN_LAYOUT L27;
 EXTERNAL_LAYOUT L28;
 ABSTRACT_LAYOUT L29;
 CLASS_LAYOUT L30;
 VALUE_CLASS_LAYOUT L32;
 BOUND_OBJECT_LAYOUT L33;
 BOUND_TYPE_LAYOUT L34;
 FRAME_LAYOUT L35;
 ARG_LAYOUT L36;
 dLAYOUT L37;
 dLAYOUT L38;
 dLAYOUT L39;
 dLAYOUT L40;
 dLAYOUT L42;
 BOOL L43;
 dLAYOUT L44;
 CODE_FILE L45;
 FLISTSTR L46;
 dLAYOUT L47;
 INT L48;
 INT L49;
 OUT L50;
 extern STR Thereappearstobecyclesin;
 OUT L52;
 extern STR Heresonecycle;
 OUT L53;
 dLAYOUT L54;
 OUT L55;
 dSTR L56;
 dLAYOUT L57;
 dLAYOUT L58;
 BOOL L59;
 OUT L60;
 dLAYOUT L62;
 OUT L63;
 dSTR L64;
 extern STR givingup;
 done = FSETdLAYOUT_create_FSETd(((FSETdLAYOUT) NULL));
 CODE_FILE_layout_order_F(self, FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL)));
 CODE_FILE_layout_text_FL(self, FLISTSTR_create_FLISTSTR(((FLISTSTR) NULL)));
 stilltodo = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct FLISTCODE_FILE_eltb_CODE_frame_struct other1_0;
  FLISTCODE_FILE_eltb_CODE_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = CODE_FILE_todo;
    noname1->self = L11;
   }
   L22 = FLISTCODE_FILE_eltb_CODE(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   cc = L22;
   {
    struct FSETSIG_eltb_SIG_frame_struct other2_0;
    FSETSIG_eltb_SIG_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = ATTR(cc,iters);
      noname2->self = L21;
     }
     L23 = FSETSIG_eltb_SIG(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     sig1 = L23;
     L24 = ATTR(sig1,tp);
     if (L24==NULL) {
      FATAL("Dispatch on void in CODE_FILE::generate_layouts");
     }
     L25 = (*dTP_is_abstract_BOOL[TAG(L24)+dTP_is_abstract_BOOL_offset])(L24);
     if ((!(L25))) {
      a = FMAPSIGAM_ROUT_DEF_get_S(CODE_FILE_iter_sigs, sig1);
      L26 = ATTR(cc,layouts);
      SATTR(cc,layouts,FSETdLAYOUT_insert_dLAYO(L26, ((dLAYOUT) FRAME_LAYOUT_create_AM_R(((FRAME_LAYOUT) NULL), a, CODE_FILE_prog))));
     }
    }
   }
   after_loop1: ;
  }
 }
 after_loop: ;
 {
  struct FSETBUILTIN_LAYOUT_eltb__frame_struct other3_0;
  FSETBUILTIN_LAYOUT_eltb__frame 
  noname3 = &other3_0;
  noname3->state = 0;
  while (1) {
   if (noname3->state == 0) {
    L31 = BUILTIN_LAYOUT_layouts;
    noname3->self = L31;
   }
   L27 = FSETBUILTIN_LAYOUT_eltb_(noname3);
   if (noname3->state == -1) {
    goto after_loop2;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L27));
  }
 }
 after_loop2: ;
 {
  struct FSETEXTERNAL_LAYOUT_eltb_frame_struct other4_0;
  FSETEXTERNAL_LAYOUT_eltb_frame 
  noname4 = &other4_0;
  noname4->state = 0;
  while (1) {
   if (noname4->state == 0) {
    L41 = EXTERNAL_LAYOUT_layouts;
    noname4->self = L41;
   }
   L28 = FSETEXTERNAL_LAYOUT_eltb(noname4);
   if (noname4->state == -1) {
    goto after_loop3;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L28));
  }
 }
 after_loop3: ;
 {
  struct FSETABSTRACT_LAYOUT_eltb_frame_struct other5_0;
  FSETABSTRACT_LAYOUT_eltb_frame 
  noname5 = &other5_0;
  noname5->state = 0;
  while (1) {
   if (noname5->state == 0) {
    L51 = ABSTRACT_LAYOUT_layouts;
    noname5->self = L51;
   }
   L29 = FSETABSTRACT_LAYOUT_eltb(noname5);
   if (noname5->state == -1) {
    goto after_loop4;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L29));
  }
 }
 after_loop4: ;
 {
  struct FSETCLASS_LAYOUT_eltb_CL_frame_struct other6_0;
  FSETCLASS_LAYOUT_eltb_CL_frame 
  noname6 = &other6_0;
  noname6->state = 0;
  while (1) {
   if (noname6->state == 0) {
    L61 = CLASS_LAYOUT_layouts;
    noname6->self = L61;
   }
   L30 = FSETCLASS_LAYOUT_eltb_CL(noname6);
   if (noname6->state == -1) {
    goto after_loop5;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L30));
  }
 }
 after_loop5: ;
 {
  struct FSETVALUE_CLASS_LAYOUT_e1_frame_struct other7_0;
  FSETVALUE_CLASS_LAYOUT_e1_frame 
  noname7 = &other7_0;
  noname7->state = 0;
  while (1) {
   if (noname7->state == 0) {
    L71 = VALUE_CLASS_LAYOUT_layou1;
    noname7->self = L71;
   }
   L32 = FSETVALUE_CLASS_LAYOUT_e1(noname7);
   if (noname7->state == -1) {
    goto after_loop6;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L32));
  }
 }
 after_loop6: ;
 {
  struct FMAPAM_BND_CREATE_EXPRBO19_frame_struct other8_0;
  FMAPAM_BND_CREATE_EXPRBO19_frame 
  noname8 = &other8_0;
  noname8->state = 0;
  while (1) {
   if (noname8->state == 0) {
    L81 = BOUND_OBJECT_LAYOUT_layo1;
    noname8->self = L81;
   }
   L33 = FMAPAM_BND_CREATE_EXPRBO19(noname8);
   if (noname8->state == -1) {
    goto after_loop7;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L33));
  }
 }
 after_loop7: ;
 {
  struct FSETBOUND_TYPE_LAYOUT_el1_frame_struct other9_0;
  FSETBOUND_TYPE_LAYOUT_el1_frame 
  noname9 = &other9_0;
  noname9->state = 0;
  while (1) {
   if (noname9->state == 0) {
    L91 = BOUND_TYPE_LAYOUT_layout1;
    noname9->self = L91;
   }
   L34 = FSETBOUND_TYPE_LAYOUT_el1(noname9);
   if (noname9->state == -1) {
    goto after_loop8;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L34));
  }
 }
 after_loop8: ;
 {
  struct FMAPAM_ROUT_DEFFRAME_LAY19_frame_struct other10_0;
  FMAPAM_ROUT_DEFFRAME_LAY19_frame 
  noname10 = &other10_0;
  noname10->state = 0;
  while (1) {
   if (noname10->state == 0) {
    L101 = FRAME_LAYOUT_layouts;
    noname10->self = L101;
   }
   L35 = FMAPAM_ROUT_DEFFRAME_LAY19(noname10);
   if (noname10->state == -1) {
    goto after_loop9;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L35));
  }
 }
 after_loop9: ;
 {
  struct FMAPSIGARG_LAYOUT_target_frame_struct other11_0;
  FMAPSIGARG_LAYOUT_target_frame 
  noname11 = &other11_0;
  noname11->state = 0;
  while (1) {
   if (noname11->state == 0) {
    L121 = ARG_LAYOUT_layouts;
    noname11->self = L121;
   }
   L36 = FMAPSIGARG_LAYOUT_target(noname11);
   if (noname11->state == -1) {
    goto after_loop10;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, ((dLAYOUT) L36));
  }
 }
 after_loop10: ;
 stillarr = LAYOUT_ARRAY_create_INT_(((LAYOUT_ARRAY) NULL), FLISTdLAYOUT_size_INT(stilltodo));
 {
  struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other12_0;
  FLISTdLAYOUT_eltb_dLAYOU_frame 
  noname12 = &other12_0;
  struct LAYOUT_ARRAY_setb_dLAYOU_frame_struct other12_1;
  LAYOUT_ARRAY_setb_dLAYOU_frame 
  noname13 = &other12_1;
  noname12->state = 0;
  noname13->state = 0;
  while (1) {
   if (noname13->state == 0) {
    L141 = stillarr;
    noname13->self = L141;
   }
   if (noname12->state == 0) {
    L131 = stilltodo;
    noname12->self = L131;
   }
   L37 = FLISTdLAYOUT_eltb_dLAYOU(noname12);
   if (noname12->state == -1) {
    goto after_loop11;
   }
   noname13->arg1 = L37;
   LAYOUT_ARRAY_setb_dLAYOU(noname13);
   if (noname13->state == -1) {
    goto after_loop11;
   }
   /* No return value from iter call */;
  }
 }
 after_loop11: ;
 LAYOUT_ARRAY_sort(stillarr);
 stilltodo = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct LAYOUT_ARRAY_eltb_dLAYOU_frame_struct other13_0;
  LAYOUT_ARRAY_eltb_dLAYOU_frame 
  noname14 = &other13_0;
  noname14->state = 0;
  while (1) {
   if (noname14->state == 0) {
    L151 = stillarr;
    noname14->self = L151;
   }
   L38 = LAYOUT_ARRAY_eltb_dLAYOU(noname14);
   if (noname14->state == -1) {
    goto after_loop12;
   }
   stilltodo = FLISTdLAYOUT_push_dLAYOU(stilltodo, L38);
  }
 }
 after_loop12: ;
 SYSDESTROY(((OB) stillarr));
 while (1) {
  if (FLISTdLAYOUT_is_empty_BO(stilltodo)) {
   goto after_loop13;
  }
  next_stilltodo = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
  {
   struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other15_0;
   FLISTdLAYOUT_eltb_dLAYOU_frame 
   noname15 = &other15_0;
   noname15->state = 0;
   while (1) {
    if (noname15->state == 0) {
     L161 = stilltodo;
     noname15->self = L161;
    }
    L39 = FLISTdLAYOUT_eltb_dLAYOU(noname15);
    if (noname15->state == -1) {
     goto after_loop14;
    }
    l = L39;
    L40 = l;
    if (L40==NULL) {
     FATAL("Dispatch on void in CODE_FILE::generate_layouts");
    }
    deps = (*dLAYOUT_dependencies_FLI[TAG(L40)+dLAYOUT_dependencies_FLI_offset])(L40);
    okay = TRUE;
    {
     struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other16_0;
     FLISTdLAYOUT_eltb_dLAYOU_frame 
     noname16 = &other16_0;
     noname16->state = 0;
     while (1) {
      if (okay) {
      }
      else {
       goto after_loop15;
      }
      if (noname16->state == 0) {
       L171 = deps;
       noname16->self = L171;
      }
      L42 = FLISTdLAYOUT_eltb_dLAYOU(noname16);
      if (noname16->state == -1) {
       goto after_loop15;
      }
      d = L42;
      L43 = FSETdLAYOUT_test_dLAYOUT(done, d);
      if ((!(L43))) {
       okay = FALSE;
      }
     }
    }
    after_loop15: ;
    {
     struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other17_0;
     FLISTdLAYOUT_eltb_dLAYOU_frame 
     noname17 = &other17_0;
     noname17->state = 0;
     while (1) {
      if (noname17->state == 0) {
       L181 = deps;
       noname17->self = L181;
      }
      L44 = FLISTdLAYOUT_eltb_dLAYOU(noname17);
      if (noname17->state == -1) {
       goto after_loop16;
      }
      d1 = L44;
      {
       struct FLISTCODE_FILE_eltb_CODE_frame_struct other18_0;
       FLISTCODE_FILE_eltb_CODE_frame 
       noname18 = &other18_0;
       noname18->state = 0;
       while (1) {
        if (noname18->state == 0) {
         L191 = CODE_FILE_todo;
         noname18->self = L191;
        }
        L45 = FLISTCODE_FILE_eltb_CODE(noname18);
        if (noname18->state == -1) {
         goto after_loop17;
        }
        cc1 = L45;
        if (FSETdLAYOUT_test_dLAYOUT(ATTR(cc1,layouts), l)) {
         SATTR(cc1,layouts,FSETdLAYOUT_insert_dLAYO(ATTR(cc1,layouts), d1));
        }
       }
      }
      after_loop17: ;
     }
    }
    after_loop16: ;
    if (okay) {
     CODE_FILE_layout_order_F(self, FLISTdLAYOUT_push_dLAYOU(CODE_FILE_layout_order, l));
     L46 = CODE_FILE_layout_text;
     L47 = l;
     if (L47==NULL) {
      FATAL("Dispatch on void in CODE_FILE::generate_layouts");
     }
     CODE_FILE_layout_text_FL(self, FLISTSTR_push_STR_FLISTS(L46, (*dLAYOUT_typedef_CGEN_STR[TAG(L47)+dLAYOUT_typedef_CGEN_STR_offset])(L47, CODE_FILE_cgen)));
     done = FSETdLAYOUT_insert_dLAYO(done, l);
    }
    else {
     next_stilltodo = FLISTdLAYOUT_push_dLAYOU(next_stilltodo, l);
    }
   }
  }
  after_loop14: ;
  L48 = FLISTdLAYOUT_size_INT(next_stilltodo);
  L49 = FLISTdLAYOUT_size_INT(stilltodo);
  if ((L48==L49)) {
   L50 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L50, ((dSTR) ((STR) &Thereappearstobecyclesin)));
   L52 = OUT_create_OUT(((OUT) NULL));
   OUT_plus_dSTR(L52, ((dSTR) ((STR) &Heresonecycle)));
   e = FLISTdLAYOUT_aget_INT_dL(stilltodo, 0);
   seen = FSETdLAYOUT_create_FSETd(((FSETdLAYOUT) NULL));
   while (1) {
    L53 = OUT_create_OUT(((OUT) NULL));
    L54 = e;
    if (L54==NULL) {
     FATAL("Dispatch on void in CODE_FILE::generate_layouts");
    }
    L55 = OUT_plus_dSTR_OUT(L53, ((dSTR) (*dLAYOUT_str_STR[TAG(L54)+dLAYOUT_str_STR_offset])(L54)));
    L56 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L56)->value_part = '\n';
    OUT_plus_dSTR(L55, L56);
    seen = FSETdLAYOUT_insert_dLAYO(seen, e);
    {
     struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other20_0;
     FLISTdLAYOUT_eltb_dLAYOU_frame 
     noname19 = &other20_0;
     noname19->state = 0;
     while (1) {
      if (noname19->state == 0) {
       L58 = e;
       if (L58==NULL) {
        FATAL("Dispatch on void in CODE_FILE::generate_layouts");
       }
       L201 = (*dLAYOUT_dependencies_FLI[TAG(L58)+dLAYOUT_dependencies_FLI_offset])(L58);
       noname19->self = L201;
      }
      L57 = FLISTdLAYOUT_eltb_dLAYOU(noname19);
      if (noname19->state == -1) {
       goto after_loop19;
      }
      e2 = L57;
      L59 = FSETdLAYOUT_test_dLAYOUT(done, e2);
      if ((!(L59))) {
       goto after_loop19;
      }
     }
    }
    after_loop19: ;
    e = e2;
    if (FSETdLAYOUT_test_dLAYOUT(seen, e)) {
     goto after_loop18;
    }
   }
   after_loop18: ;
   L60 = OUT_create_OUT(((OUT) NULL));
   L62 = e;
   if (L62==NULL) {
    FATAL("Dispatch on void in CODE_FILE::generate_layouts");
   }
   L63 = OUT_plus_dSTR_OUT(L60, ((dSTR) (*dLAYOUT_str_STR[TAG(L62)+dLAYOUT_str_STR_offset])(L62)));
   L64 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L64)->value_part = '\n';
   OUT_plus_dSTR(L63, L64);
   CGEN_barf_STR(CODE_FILE_cgen, ((STR) &givingup));
  }
  stilltodo = next_stilltodo;
 }
 after_loop13: ;
}


void CODE_FILE_good_place_to_(CODE_FILE self) {
 CODE_FILE old1;
 INT L1;
 INT L2;
 BOOL L3;
 INT L4;
 INT L5;
 extern STR c1;
 extern STR xc;
 SATTR(self,text1,FLISTFSTR_push_FSTR_FLIS(ATTR(self,text1), ATTR(self,ntext)));
 L1 = ATTR(self,length1);
 L2 = FSTR_length_INT(ATTR(self,ntext));
 SATTR(self,length1,(INTPLUS(L1,L2)));
 SATTR(self,ntext,FSTR_create_FSTR(((FSTR) NULL)));
 L4 = ATTR(self,length1);
 L5 = ATTR(CODE_FILE_cgen,threshold);
 if ((L4>L5)) {
  L3 = ATTR(self,is_c_code);
 } else {
  L3 = FALSE;
 }
 if (L3) {
  old1 = CODE_FILE_create_STR_COD(((CODE_FILE) NULL), ATTR(self,name1));
  SATTR(old1,text1,ATTR(self,text1));
  SATTR(old1,ntext,ATTR(self,ntext));
  SATTR(old1,length1,ATTR(self,length1));
  SATTR(old1,chk_pre,ATTR(self,chk_pre));
  SATTR(old1,chk_post,ATTR(self,chk_post));
  SATTR(old1,chk_invariant,ATTR(self,chk_invariant));
  SATTR(old1,chk_assert,ATTR(self,chk_assert));
  SATTR(old1,chk_arith,ATTR(self,chk_arith));
  SATTR(old1,chk_bounds,ATTR(self,chk_bounds));
  SATTR(old1,chk_void,ATTR(self,chk_void));
  SATTR(old1,chk_when,ATTR(self,chk_when));
  SATTR(old1,chk_return,ATTR(self,chk_return));
  SATTR(old1,is_c_code,TRUE);
  SATTR(old1,do_not_merge,ATTR(self,do_not_merge));
  SATTR(old1,decs,ATTR(self,decs));
  SATTR(old1,layouts,ATTR(self,layouts));
  SATTR(old1,globals,ATTR(self,globals));
  SATTR(old1,bnd_rout_creates,ATTR(self,bnd_rout_creates));
  SATTR(old1,unboxes,ATTR(self,unboxes));
  SATTR(old1,externs1,ATTR(self,externs1));
  SATTR(old1,iters,ATTR(self,iters));
  SATTR(self,text1,FLISTFSTR_create_FLISTFS(((FLISTFSTR) NULL)));
  SATTR(self,ntext,FSTR_create_FSTR(((FSTR) NULL)));
  SATTR(self,length1,0);
  SATTR(self,name1,STR_replace_suffix_STR_S(ATTR(self,name1), ((STR) &c1), ((STR) &xc)));
  SATTR(self,decs,FSETSIG_create_FSETSIG(((FSETSIG) NULL)));
  SATTR(self,layouts,FSETdLAYOUT_create_FSETd(((FSETdLAYOUT) NULL)));
  SATTR(self,globals,FSETAM_GLOBAL_EXPR_creat(((FSETAM_GLOBAL_EXPR) NULL)));
  SATTR(self,bnd_rout_creates,FLISTAM_BND_CREATE_EXPR_6(((FLISTAM_BND_CREATE_EXPR) NULL)));
  SATTR(self,unboxes,FSETTUPSIGSIG_create_FSE(((FSETTUPSIGSIG) NULL)));
  SATTR(self,externs1,FSETSTR_create_FSETSTR(((FSETSTR) NULL)));
  SATTR(self,iters,FSETSIG_create_FSETSIG(((FSETSIG) NULL)));
 }
}


void CODE_FILE_here_is_iter_A(CODE_FILE self, AM_ROUT_DEF a) {
 CODE_FILE_iter_sigs_FMAP(self, FMAPSIGAM_ROUT_DEF_inser1(CODE_FILE_iter_sigs, ATTR(a,sig11), a));
}


void CODE_FILE_iter_sigs_FMAP(CODE_FILE self, FMAPSIGAM_ROUT_DEF iter_sigs) {
 CODE_FILE_iter_sigs = iter_sigs;
}


void CODE_FILE_layout_order_F(CODE_FILE self, FLISTdLAYOUT layout_order) {
 CODE_FILE_layout_order = layout_order;
}


void CODE_FILE_layout_text_FL(CODE_FILE self, FLISTSTR layout_text) {
 CODE_FILE_layout_text = layout_text;
}


void CODE_FILE_plus_dSTR(CODE_FILE self, dSTR s) {
 FSTR L1;
 dSTR L2;
 L1 = ATTR(self,ntext);
 L2 = s;
 if (L2==NULL) {
  FATAL("Dispatch on void in CODE_FILE::plus($STR)");
 }
 SATTR(self,ntext,FSTR_plus_STR_FSTR(L1, (*dSTR_str_STR[TAG(L2)+dSTR_str_STR_offset])(L2)));
}


void CODE_FILE_set_directory_(CODE_FILE self, PROG p, STR s) {
 dBACK_END cg;
 FILE1 th;
 STR fn;
 CHAR c = ((CHAR) 0);
 dSTR L1;
 STR L2;
 extern STR THUMBPRINTS;
 BOOL L3;
 extern STR name1;
 BOOL L4;
 BOOL L5;
 dSTR L6;
 FMAPSTRSTR L7;
 CODE_FILE_prog_PROG(self, p);
 cg = ATTR(CODE_FILE_prog,back_end);
 if (cg==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(cg)) {
  case CGEN_tag:
   CODE_FILE_cgen_CGEN(self, ((CGEN) cg)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 CODE_FILE_dir_STR(self, s);
 CODE_FILE_iter_sigs_FMAP(self, FMAPSIGAM_ROUT_DEF_creat(((FMAPSIGAM_ROUT_DEF) NULL)));
 FILE_create_directory_ST(((FILE1) NULL), CODE_FILE_dir);
 L1 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L1)->value_part = '/';
 L2 = STR_plus_dSTR_STR(s, L1);
 th = FILE_open_for_read_STR_F(((FILE1) NULL), STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &THUMBPRINTS))));
 L3 = FILE_error_BOOL(th);
 if ((!(L3))) {
  while (1) {
   fn = ((STR) &name1);
   c = FILE_get_char_CHAR(th);
   if (FILE_eof_BOOL(th)) {
    L4 = TRUE;
   } else {
    L4 = FILE_error_BOOL(th);
   }
   if (L4) {
    goto after_loop;
   }
   while (1) {
    if ((c==' ')) {
     L5 = TRUE;
    } else {
     L5 = FILE_error_BOOL(th);
    }
    if (L5) {
     goto after_loop1;
    }
    L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L6)->value_part = c;
    fn = STR_plus_dSTR_STR(fn, L6);
    c = FILE_get_char_CHAR(th);
   }
   after_loop1: ;
   L7 = CODE_FILE_thumbprints;
   CODE_FILE_thumbprints_FM(self, FMAPSTRSTR_insert_STR_ST(L7, fn, FILE_get_str_STR(th)));
  }
  after_loop: ;
 }
}


void CODE_FILE_thumbprints_FM(CODE_FILE self, FMAPSTRSTR thumbprints) {
 CODE_FILE_thumbprints = thumbprints;
}


void CODE_FILE_todo_FLISTCODE(CODE_FILE self, FLISTCODE_FILE todo) {
 CODE_FILE_todo = todo;
}


void CODE_FILE_uses_bnd_rout_(CODE_FILE self, AM_BND_CREATE_EXPR brc) {
 SATTR(self,bnd_rout_creates,FLISTAM_BND_CREATE_EXPR_10(ATTR(self,bnd_rout_creates), brc));
}


void CODE_FILE_uses_extern_ST(CODE_FILE self, STR dec) {
 SATTR(self,externs1,FSETSTR_insert_STR_FSETS(ATTR(self,externs1), dec));
}


void CODE_FILE_uses_global_AM(CODE_FILE self, AM_GLOBAL_EXPR age1) {
 SATTR(self,globals,FSETAM_GLOBAL_EXPR_inser(ATTR(self,globals), age1));
}


void CODE_FILE_uses_iter_SIG(CODE_FILE self, SIG s) {
 SATTR(self,iters,FSETSIG_insert_SIG_FSETS(ATTR(self,iters), s));
}


void CODE_FILE_uses_layout_dL(CODE_FILE self, dLAYOUT l) {
 SATTR(self,layouts,FSETdLAYOUT_insert_dLAYO(ATTR(self,layouts), l));
}


void CODE_FILE_uses_sig_SIG(CODE_FILE self, SIG s) {
 ARRAYdTP L11;
 BOOL L2;
 dTP L3;
 SATTR(self,decs,FSETSIG_insert_SIG_FSETS(ATTR(self,decs), s));
 CODE_FILE_uses_tp_dTP(self, ATTR(s,tp));
 L2 = (ATTR(s,ret1)==((dTP) NULL));
 if ((!(L2))) {
  CODE_FILE_uses_tp_dTP(self, ATTR(s,ret1));
 }
 {
  struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
  ARRAYdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(s,args1);
    noname1->self = L11;
   }
   L3 = ARRAYdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   CODE_FILE_uses_tp_dTP(self, L3);
  }
 }
 after_loop: ;
}


void CODE_FILE_uses_tp_dTP(CODE_FILE self, dTP t) {
 dTP tp;
 ARRAYdTP L11;
 FSETdLAYOUT L2;
 BOOL L3;
 dTP L4;
 BOOL L5;
 L2 = ATTR(self,layouts);
 SATTR(self,layouts,FSETdLAYOUT_insert_dLAYO(L2, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), t)));
 tp = t;
 if (tp==NULL) {
 } else
 switch (TAG(tp)) {
  case TP_ROUT_tag:
   L3 = (ATTR(((TP_ROUT) tp),args)==((ARRAYdTP) NULL));
   if ((!(L3))) {
    {
     struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
     ARRAYdTP_eltb_dTP_frame 
     noname1 = &other1_0;
     noname1->state = 0;
     while (1) {
      if (noname1->state == 0) {
       L11 = ATTR(((TP_ROUT) tp),args);
       noname1->self = L11;
      }
      L4 = ARRAYdTP_eltb_dTP(noname1);
      if (noname1->state == -1) {
       goto after_loop;
      }
      CODE_FILE_uses_tp_dTP(self, L4);
     }
    }
    after_loop: ;
   }
   L5 = (ATTR(((TP_ROUT) tp),ret)==((dTP) NULL));
   if ((!(L5))) {
    CODE_FILE_uses_tp_dTP(self, ATTR(((TP_ROUT) tp),ret));
   } break;
  default: ;
 }
}


void CODE_FILE_uses_unbox_SIG(CODE_FILE self, SIG s, SIG abs1) {
 FSETTUPSIGSIG L1;
 L1 = ATTR(self,unboxes);
 SATTR(self,unboxes,FSETTUPSIGSIG_insert_TUP(L1, TUPSIGSIG_create_SIG_SIG(TUPSIGSIG_zero, s, abs1)));
}

/* C for type CHANGE_VARS */




void CHANGE_VARS_new_copy_SFI(CHANGE_VARS self, SFILE_ID source1) {
 FLISTAM_LOCAL_EXPR L11;
 AM_LOCAL_EXPR l;
 AM_LOCAL_EXPR m;
 AM_LOCAL_EXPR L2;
 SATTR(self,new_subst,FMAPAM_LOCAL_EXPRAM_LOCA6(((FMAPAM_LOCAL_EXPRAM_LOCA) NULL), FLISTAM_LOCAL_EXPR_size_(ATTR(self,saved_vars))));
 SATTR(self,new_vars,FLISTAM_LOCAL_EXPR_creat(((FLISTAM_LOCAL_EXPR) NULL), FLISTAM_LOCAL_EXPR_size_(ATTR(self,saved_vars))));
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other1_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,saved_vars);
    noname1->self = L11;
   }
   L2 = FLISTAM_LOCAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   l = L2;
   m = AM_LOCAL_EXPR_create_SFI2(((AM_LOCAL_EXPR) NULL), source1);
   SATTR(m,is_volatile,ATTR(l,is_volatile));
   SATTR(m,name1,ATTR(l,name1));
   SATTR(m,tp_at,ATTR(l,tp_at));
   SATTR(m,needs_init,ATTR(l,needs_init));
   SATTR(m,no_assign,ATTR(l,no_assign));
   SATTR(self,new_subst,FMAPAM_LOCAL_EXPRAM_LOCA14(ATTR(self,new_subst), l, m));
   SATTR(self,new_vars,FLISTAM_LOCAL_EXPR_push_(ATTR(self,new_vars), m));
  }
 }
 after_loop: ;
}

/* C for type CHAR */




STR CHAR_str_STR(CHAR self) {
 STR ret_val;
 ret_val = STR_create_CHAR_STR(((STR) NULL), self);
 return ret_val;
}

/* C for type CHECK_AM */




CHECK_AM CHECK_AM_create_PROG_CHE(CHECK_AM self, PROG p) {
 CHECK_AM ret_val;
 CHECK_AM r;
 CHECK_AM L1;
 L1 = ((CHECK_AM) rt_alloc(sizeof(struct CHECK_AM_struct), CHECK_AM_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type CHECK_IFC_CONFORMANCE */




CHECK_IFC_CONFORMANCE CHECK_IFC_CONFORMANCE_cr(CHECK_IFC_CONFORMANCE self, PROG p) {
 CHECK_IFC_CONFORMANCE ret_val;
 CHECK_IFC_CONFORMANCE r;
 CHECK_IFC_CONFORMANCE L1;
 L1 = ((CHECK_IFC_CONFORMANCE) rt_alloc(sizeof(struct CHECK_IFC_CONFORMANCE_struct), CHECK_IFC_CONFORMANCE_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type CLASS_LAYOUT */




void CLASS_LAYOUT_make_depend(CLASS_LAYOUT self) {
 FLISTdLAYOUT res;
 FMAPIDENTdTP L11;
 dTP tp;
 dTP L2;
 dTP L3;
 BOOL L4;
 BOOL L5;
 dTP L6;
 res = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct FMAPIDENTdTP_targetsb_dT_frame_struct other1_0;
  FMAPIDENTdTP_targetsb_dT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,l1),at11);
    noname1->self = L11;
   }
   L2 = FMAPIDENTdTP_targetsb_dT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   tp = L2;
   L3 = tp;
   if (L3==NULL) {
    FATAL("Dispatch on void in CLASS_LAYOUT::make_dependencies");
   }
   if ((*dTP_is_value_BOOL[TAG(L3)+dTP_is_value_BOOL_offset])(L3)) {
    res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), tp));
   }
  }
 }
 after_loop: ;
 L5 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 if ((!(L5))) {
  L6 = ATTR(ATTR(self,l1),arr1);
  if (L6==NULL) {
   FATAL("Dispatch on void in CLASS_LAYOUT::make_dependencies");
  }
  L4 = (*dTP_is_value_BOOL[TAG(L6)+dTP_is_value_BOOL_offset])(L6);
 } else {
  L4 = FALSE;
 }
 if (L4) {
  res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), ATTR(ATTR(self,l1),arr1)));
 }
 SATTR(self,dependencies,res);
}

/* C for type CODE_FILE */




void CODE_FILE_prog_PROG(CODE_FILE self, PROG prog) {
 CODE_FILE_prog = prog;
}

/* C for type CODE_FILE_ARRAY */




CODE_FILE_ARRAY CODE_FILE_ARRAY_create_I(CODE_FILE_ARRAY self, INT n) {
 CODE_FILE_ARRAY ret_val;
 CODE_FILE_ARRAY L1;
 INT L2;
 L2 = n;
 L1 = ((CODE_FILE_ARRAY) rt_arr_alloc(sizeof(struct CODE_FILE_ARRAY_struct), CODE_FILE_ARRAY_tag, sizeof(CODE_FILE) , L2));
 L1->asize = L2;
 ret_val = L1;
 return ret_val;
}
