#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAS_CLASS_ELT_struct {
 OB_HEADER header;
 } *dAS_CLASS_ELT;

typedef struct dAS_EXPR_struct {
 OB_HEADER header;
 } *dAS_EXPR;

typedef struct dAS_NODE_struct {
 OB_HEADER header;
 } *dAS_NODE;

typedef struct dAS_STMT_struct {
 OB_HEADER header;
 } *dAS_STMT;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dPARSE_struct {
 OB_HEADER header;
 } *dPARSE;

typedef struct dPROG_ERR_struct {
 OB_HEADER header;
 } *dPROG_ERR;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;

typedef struct ELT_struct {/* layout for ELT */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *as1;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 BOOL is_private1;
 } *ELT;

typedef struct ERR1_struct {/* layout for ERR */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *ERR1;

typedef struct EXTERNAL_LAYOUT_struct {/* layout for EXTERNAL_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *EXTERNAL_LAYOUT;

typedef struct FILE1_struct {/* layout for FILE */
 OB_HEADER header;
 EXT_OB fp;
 } *FILE1;

typedef struct FIND_TYPES_struct {/* layout for FIND_TYPES */
 OB_HEADER header;
 struct FSETdTP_struct *tp_todo;
 struct FSETIDENT_struct *err_names;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *con1;
 } *FIND_TYPES;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_INCLUDE_struct {/* layout for IMPL_INCLUDE */
 OB_HEADER header;
 struct AS_INCLUDE_CLAUSE_struct *as1;
 struct ELT_TBL_struct *elt_tbl;
 struct FSETAS_FEAT_MOD_struct *used_mods;
 struct IMPL_struct *impl;
 struct TP_CLASS_struct *itp;
 struct TP_CLASS_struct *tp1;
 } *IMPL_INCLUDE;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_uptob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_uptob_INT_INT_frame;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct PROG_AS_TBL_struct {/* layout for PROG_AS_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_CLASS_DEF_struct *arr_part[1];
 } *PROG_AS_TBL;

typedef struct RAT_struct {/* layout for RAT */
 struct INTI_struct *u;
 struct INTI_struct *v;
 } RAT;
static RAT RAT_zero;

typedef struct RAT_boxed_struct {
 OB_HEADER header;
 RAT value_part;
 } *RAT_boxed;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SIG_TBL_struct {/* layout for SIG_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *SIG_TBL;


typedef struct STR_separateb_STR_STR_frame_struct {
 STR self;/* Formal argument: self */
 STR arg1;/* Formal argument: s */
 INT state;
 STR ret_val;
 } *STR_separateb_STR_STR_frame;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_CONTEXT_struct {/* layout for TP_CONTEXT */
 OB_HEADER header;
 struct ARRAYdTP_struct *ptypes1;
 struct ARRAYIDENT_struct *pnames1;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *same11;
 BOOL is_abs;
 } *TP_CONTEXT;

typedef struct TP_ITER_struct {/* layout for TP_ITER */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct ARRAYBOOL_struct *hot;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ITER;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TP_TBL_struct {/* layout for TP_TBL */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_CLASS_TBL_struct *class_tbl;
 struct TP_ITER_TBL_struct *iter_tbl;
 struct TP_ROUT_TBL_struct *rout_tbl;
 } *TP_TBL;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;

typedef struct AM_BND_ITER_CALL_EXPR_struct {/* layout for AM_BND_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *bi;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ITER_CALL_EXPR;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AS_AND_EXPR_struct {/* layout for AS_AND_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *e21;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_AND_EXPR;

typedef struct AS_ANY_EXPR_struct {/* layout for AS_ANY_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_ANY_EXPR;

typedef struct AS_ARG_DEC_struct {/* layout for AS_ARG_DEC */
 OB_HEADER header;
 struct AS_ARG_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_ARG_DEC;

typedef struct AS_ARRAY_EXPR_struct {/* layout for AS_ARRAY_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *elts;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_ARRAY_EXPR;

typedef struct AS_ASSERT_STMT_struct {/* layout for AS_ASSERT_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_ASSERT_STMT;

typedef struct AS_ASSIGN_STMT_struct {/* layout for AS_ASSIGN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs_expr;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_ASSIGN_STMT;

typedef struct AS_ATTACH_STMT_struct {/* layout for AS_ATTACH_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL dont_print;
 BOOL transformed;
 } *AS_ATTACH_STMT;

typedef struct AS_ATTR_DEF_struct {/* layout for AS_ATTR_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_ATTR_DEF;

typedef struct AS_AT_EXPR_struct {/* layout for AS_AT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_AT_EXPR;

typedef struct AS_BOOL_LIT_EXPR_struct {/* layout for AS_BOOL_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 BOOL val11;
 } *AS_BOOL_LIT_EXPR;

typedef struct AS_BOUND_CREATE_EXPR_struct {/* layout for AS_BOUND_CREATE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct AS_CALL_EXPR_struct *call1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct SFILE_ID_struct source11;
 BOOL is_iter1;
 } *AS_BOUND_CREATE_EXPR;

typedef struct AS_BREAK_EXPR_struct {/* layout for AS_BREAK_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_BREAK_EXPR;

typedef struct AS_CALL_EXPR_struct {/* layout for AS_CALL_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *args1;
 struct dAS_EXPR_struct *next;
 struct dAS_EXPR_struct *ob1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_array;
 } *AS_CALL_EXPR;

typedef struct AS_CASE_STMT_struct {/* layout for AS_CASE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_CASE_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_CASE_STMT;

typedef struct AS_CASE_WHEN_struct {/* layout for AS_CASE_WHEN */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct AS_CASE_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 } *AS_CASE_WHEN;

typedef struct AS_CHAR_LIT_EXPR_struct {/* layout for AS_CHAR_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT val11;
 struct SFILE_ID_struct source11;
 } *AS_CHAR_LIT_EXPR;

typedef struct AS_CLASS_DEF_struct {/* layout for AS_CLASS_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *body;
 struct AS_CLASS_DEF_struct *next;
 struct AS_PARAM_DEC_struct *params1;
 struct AS_TYPE_SPEC_struct *over;
 struct AS_TYPE_SPEC_struct *under;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 } *AS_CLASS_DEF;

typedef struct AS_CLUSTER_EXPR_struct {/* layout for AS_CLUSTER_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_CLUSTER_EXPR;

typedef struct AS_COHORT_EXPR_struct {/* layout for AS_COHORT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct IDENT_struct name_after_pSather_trafo;
 struct SFILE_ID_struct source11;
 } *AS_COHORT_EXPR;

typedef struct AS_CONST_DEF_struct {/* layout for AS_CONST_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_CONST_DEF;

typedef struct AS_CREATE_EXPR_struct {/* layout for AS_CREATE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *elts;
 struct dAS_EXPR_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_CREATE_EXPR;

typedef struct AS_DEC_STMT_struct {/* layout for AS_DEC_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_DEC_STMT;

typedef struct AS_EXCEPT_EXPR_struct {/* layout for AS_EXCEPT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_EXCEPT_EXPR;

typedef struct AS_EXPR_STMT_struct {/* layout for AS_EXPR_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_EXPR_STMT;

typedef struct AS_FAR_EXPR_struct {/* layout for AS_FAR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_FAR_EXPR;

typedef struct AS_FLT_LIT_EXPR_struct {/* layout for AS_FLT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT tp1;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AS_FLT_LIT_EXPR;

typedef struct AS_FORK_STMT_struct {/* layout for AS_FORK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_FORK_STMT;

typedef struct AS_HERE_EXPR_struct {/* layout for AS_HERE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_HERE_EXPR;

typedef struct AS_IF_STMT_struct {/* layout for AS_IF_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_IF_STMT;

typedef struct AS_INCLUDE_CLAUSE_struct {/* layout for AS_INCLUDE_CLAUSE */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_FEAT_MOD_struct *mods;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_INCLUDE_CLAUSE;

typedef struct AS_INITIAL_EXPR_struct {/* layout for AS_INITIAL_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_INITIAL_EXPR;

typedef struct AS_INT_LIT_EXPR_struct {/* layout for AS_INT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 BOOL is_inti;
 } *AS_INT_LIT_EXPR;

typedef struct AS_IS_VOID_EXPR_struct {/* layout for AS_IS_VOID_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *arg1;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_IS_VOID_EXPR;

typedef struct AS_LOCK_STMT_struct {/* layout for AS_LOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_LOCK_STMT;

typedef struct AS_LOOP_STMT_struct {/* layout for AS_LOOP_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_LOOP_STMT;

typedef struct AS_NEAR_EXPR_struct {/* layout for AS_NEAR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_NEAR_EXPR;

typedef struct AS_NEW_EXPR_struct {/* layout for AS_NEW_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *arg1;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_NEW_EXPR;

typedef struct AS_OR_EXPR_struct {/* layout for AS_OR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *e21;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_OR_EXPR;

typedef struct AS_PARAM_DEC_struct {/* layout for AS_PARAM_DEC */
 OB_HEADER header;
 struct AS_PARAM_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *type_constraint;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 } *AS_PARAM_DEC;

typedef struct AS_PAR_STMT_struct {/* layout for AS_PAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_PAR_STMT;

typedef struct AS_PROTECT_STMT_struct {/* layout for AS_PROTECT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_PROTECT_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_PROTECT_STMT;

typedef struct AS_PROTECT_WHEN_struct {/* layout for AS_PROTECT_WHEN */
 OB_HEADER header;
 struct AS_PROTECT_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_PROTECT_WHEN;

typedef struct AS_QUIT_STMT_struct {/* layout for AS_QUIT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_QUIT_STMT;

typedef struct AS_RAISE_STMT_struct {/* layout for AS_RAISE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RAISE_STMT;

typedef struct AS_RESULT_EXPR_struct {/* layout for AS_RESULT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_RESULT_EXPR;

typedef struct AS_RETURN_STMT_struct {/* layout for AS_RETURN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RETURN_STMT;

typedef struct AS_ROUT_DEF_struct {/* layout for AS_ROUT_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *post_e;
 struct dAS_EXPR_struct *pre_e;
 struct AS_ARG_DEC_struct *args_dec;
 struct AS_STMT_LIST_struct *body;
 struct AS_TYPE_SPEC_struct *ret_dec;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL is_private;
 } *AS_ROUT_DEF;

typedef struct AS_SELF_EXPR_struct {/* layout for AS_SELF_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_SELF_EXPR;

typedef struct AS_SHARED_DEF_struct {/* layout for AS_SHARED_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_SHARED_DEF;

typedef struct AS_STMT_LIST_struct {/* layout for AS_STMT_LIST */
 OB_HEADER header;
 struct dAS_STMT_struct *stmts;
 struct SFILE_ID_struct source11;
 } *AS_STMT_LIST;

typedef struct AS_STR_LIT_EXPR_struct {/* layout for AS_STR_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 STR s11;
 } *AS_STR_LIT_EXPR;

typedef struct AS_TRY_STMT_struct {/* layout for AS_TRY_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_TRY_STMT;

typedef struct AS_TYPECASE_STMT_struct {/* layout for AS_TYPECASE_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_TYPECASE_WHEN_struct *when_part;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed1;
 } *AS_TYPECASE_STMT;

typedef struct AS_TYPECASE_WHEN_struct {/* layout for AS_TYPECASE_WHEN */
 OB_HEADER header;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPECASE_WHEN_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_TYPECASE_WHEN;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct AS_UNDERSCORE_ARG_struct {/* layout for AS_UNDERSCORE_ARG */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_UNDERSCORE_ARG;

typedef struct AS_UNLOCK_STMT_struct {/* layout for AS_UNLOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_UNLOCK_STMT;

typedef struct AS_VOID_EXPR_struct {/* layout for AS_VOID_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_VOID_EXPR;

typedef struct AS_WHERE_EXPR_struct {/* layout for AS_WHERE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_WHERE_EXPR;

typedef struct AS_WITH_NEAR_STMT_struct {/* layout for AS_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_IDENT_LIST_struct *idents;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *near_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 INT elts_size;
 struct SFILE_ID_struct source11;
 BOOL self_occurred;
 BOOL transformed1;
 } *AS_WITH_NEAR_STMT;

typedef struct AS_YIELD_STMT_struct {/* layout for AS_YIELD_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_YIELD_STMT;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct CODE_FILE_struct {/* layout for CODE_FILE */
 OB_HEADER header;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTFSTR_struct *text1;
 struct FSETdLAYOUT_struct *layouts;
 struct FSETAM_GLOBAL_EXPR_struct *globals;
 struct FSETSIG_struct *decs;
 struct FSETSIG_struct *iters;
 struct FSETSTR_struct *externs1;
 struct FSETTUPSIGSIG_struct *unboxes;
 struct FSTR_struct *ntext;
 INT length1;
 STR name1;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL do_not_merge;
 BOOL is_c_code;
 } *CODE_FILE;

typedef struct ELT_TBL_struct {/* layout for ELT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ELT_struct *arr_part[1];
 } *ELT_TBL;


typedef struct ELT_TBL_aeltb_ELT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 INT state;
 ELT ret_val;
 INT i;
 } *ELT_TBL_aeltb_ELT_frame;


typedef struct ELT_TBL_asetb_ELT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 ELT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *ELT_TBL_asetb_ELT_frame;


typedef struct ELT_TBL_eltb_ELT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 INT state;
 ELT ret_val;
 ELT_TBL L31;
 ELT r;
 struct ELT_TBL_aeltb_ELT_frame_struct *nested1; /* nested iter frame */
 } *ELT_TBL_eltb_ELT_frame;


typedef struct ELT_TBL_get_queryb_IDENT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: q */
 INT state;
 ELT ret_val;
 INT h;
 ELT e;
 ELT e1;
 } *ELT_TBL_get_queryb_IDENT_frame;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTAM_BND_CREATE_EXPR_struct {/* layout for FLIST{AM_BND_CREATE_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_CREATE_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_CREATE_EXPR;


typedef struct FLISTAM_BND_CREATE_EXPR_3_frame_struct {
 FLISTAM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_BND_CREATE_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_CREATE_EXPR_3_frame;


typedef struct FLISTAM_BND_CREATE_EXPR_9_frame_struct {
 FLISTAM_BND_CREATE_EXPR self;/* Formal argument: self */
 AM_BND_CREATE_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_CREATE_EXPR_9_frame;


typedef struct FLISTAM_BND_CREATE_EXPR_4_frame_struct {
 FLISTAM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 AM_BND_CREATE_EXPR ret_val;
 FLISTAM_BND_CREATE_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_BND_CREATE_EXPR_3_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_CREATE_EXPR_4_frame;

typedef struct FLISTAM_BND_ITER_CALL_EX_struct {/* layout for FLIST{AM_BND_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_ITER_CALL_EX;


typedef struct FLISTAM_BND_ITER_CALL_EX4_frame_struct {
 FLISTAM_BND_ITER_CALL_EX self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_BND_ITER_CALL_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_ITER_CALL_EX4_frame;


typedef struct FLISTAM_BND_ITER_CALL_EX9_frame_struct {
 FLISTAM_BND_ITER_CALL_EX self;/* Formal argument: self */
 AM_BND_ITER_CALL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_ITER_CALL_EX9_frame;


typedef struct FLISTAM_BND_ITER_CALL_EX5_frame_struct {
 FLISTAM_BND_ITER_CALL_EX self;/* Formal argument: self */
 INT state;
 AM_BND_ITER_CALL_EXPR ret_val;
 FLISTAM_BND_ITER_CALL_EX L31;
 INT L41;
 INT L51;
 struct FLISTAM_BND_ITER_CALL_EX4_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_BND_ITER_CALL_EX5_frame;

typedef struct FLISTAM_GLOBAL_EXPR_struct {/* layout for FLIST{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FLISTAM_GLOBAL_EXPR;


typedef struct FLISTAM_GLOBAL_EXPR_aelt_frame_struct {
 FLISTAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_GLOBAL_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_GLOBAL_EXPR_aelt_frame;


typedef struct FLISTAM_GLOBAL_EXPR_aset1_frame_struct {
 FLISTAM_GLOBAL_EXPR self;/* Formal argument: self */
 AM_GLOBAL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_GLOBAL_EXPR_aset1_frame;


typedef struct FLISTAM_GLOBAL_EXPR_eltb_frame_struct {
 FLISTAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_GLOBAL_EXPR ret_val;
 FLISTAM_GLOBAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_GLOBAL_EXPR_aelt_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_GLOBAL_EXPR_eltb_frame;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;


typedef struct FLISTAM_ITER_CALL_EXPR_a3_frame_struct {
 FLISTAM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_ITER_CALL_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ITER_CALL_EXPR_a3_frame;


typedef struct FLISTAM_ITER_CALL_EXPR_a6_frame_struct {
 FLISTAM_ITER_CALL_EXPR self;/* Formal argument: self */
 AM_ITER_CALL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ITER_CALL_EXPR_a6_frame;


typedef struct FLISTAM_ITER_CALL_EXPR_e_frame_struct {
 FLISTAM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 AM_ITER_CALL_EXPR ret_val;
 FLISTAM_ITER_CALL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_ITER_CALL_EXPR_a3_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ITER_CALL_EXPR_e_frame;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_LOCAL_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_aeltb_frame;


typedef struct FLISTAM_LOCAL_EXPR_asetb_frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 AM_LOCAL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_asetb_frame;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FLISTAM_ROUT_DEF_struct {/* layout for FLIST{AM_ROUT_DEF} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ROUT_DEF_struct *arr_part[1];
 } *FLISTAM_ROUT_DEF;


typedef struct FLISTAM_ROUT_DEF_aeltb_I_frame_struct {
 FLISTAM_ROUT_DEF self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AM_ROUT_DEF ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ROUT_DEF_aeltb_I_frame;


typedef struct FLISTAM_ROUT_DEF_asetb_A_frame_struct {
 FLISTAM_ROUT_DEF self;/* Formal argument: self */
 AM_ROUT_DEF arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ROUT_DEF_asetb_A_frame;


typedef struct FLISTAM_ROUT_DEF_eltb_AM_frame_struct {
 FLISTAM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 AM_ROUT_DEF ret_val;
 FLISTAM_ROUT_DEF L31;
 INT L41;
 INT L51;
 struct FLISTAM_ROUT_DEF_aeltb_I_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ROUT_DEF_eltb_AM_frame;

typedef struct FLISTAS_CLASS_DEF_struct {/* layout for FLIST{AS_CLASS_DEF} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AS_CLASS_DEF_struct *arr_part[1];
 } *FLISTAS_CLASS_DEF;


typedef struct FLISTAS_CLASS_DEF_aeltb__frame_struct {
 FLISTAS_CLASS_DEF self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 AS_CLASS_DEF ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAS_CLASS_DEF_aeltb__frame;


typedef struct FLISTAS_CLASS_DEF_asetb__frame_struct {
 FLISTAS_CLASS_DEF self;/* Formal argument: self */
 AS_CLASS_DEF arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTAS_CLASS_DEF_asetb__frame;


typedef struct FLISTAS_CLASS_DEF_eltb_A_frame_struct {
 FLISTAS_CLASS_DEF self;/* Formal argument: self */
 INT state;
 AS_CLASS_DEF ret_val;
 FLISTAS_CLASS_DEF L31;
 INT L41;
 INT L51;
 struct FLISTAS_CLASS_DEF_aeltb__frame_struct *nested1; /* nested iter frame */
 } *FLISTAS_CLASS_DEF_eltb_A_frame;

typedef struct FLISTCHAR_struct {/* layout for FLIST{CHAR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FLISTCHAR;


typedef struct FLISTCHAR_aeltb_INT_INT__frame_struct {
 FLISTCHAR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 CHAR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTCHAR_aeltb_INT_INT__frame;


typedef struct FLISTCHAR_eltb_CHAR_frame_struct {
 FLISTCHAR self;/* Formal argument: self */
 INT state;
 CHAR ret_val;
 FLISTCHAR L31;
 INT L41;
 INT L51;
 struct FLISTCHAR_aeltb_INT_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTCHAR_eltb_CHAR_frame;

typedef struct FLISTCODE_FILE_struct {/* layout for FLIST{CODE_FILE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *FLISTCODE_FILE;


typedef struct FLISTCODE_FILE_aeltb_INT_frame_struct {
 FLISTCODE_FILE self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 CODE_FILE ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTCODE_FILE_aeltb_INT_frame;


typedef struct FLISTCODE_FILE_asetb_COD_frame_struct {
 FLISTCODE_FILE self;/* Formal argument: self */
 CODE_FILE arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTCODE_FILE_asetb_COD_frame;


typedef struct FLISTCODE_FILE_eltb_CODE_frame_struct {
 FLISTCODE_FILE self;/* Formal argument: self */
 INT state;
 CODE_FILE ret_val;
 FLISTCODE_FILE L31;
 INT L41;
 INT L51;
 struct FLISTCODE_FILE_aeltb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTCODE_FILE_eltb_CODE_frame;

typedef struct FLISTFLISTdAM_CONST_struct {/* layout for FLIST{FLIST{$AM_CONST}} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FLISTdAM_CONST_struct *arr_part[1];
 } *FLISTFLISTdAM_CONST;


typedef struct FLISTFLISTdAM_CONST_aelt_frame_struct {
 FLISTFLISTdAM_CONST self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 FLISTdAM_CONST ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTFLISTdAM_CONST_aelt_frame;


typedef struct FLISTFLISTdAM_CONST_aset1_frame_struct {
 FLISTFLISTdAM_CONST self;/* Formal argument: self */
 FLISTdAM_CONST arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTFLISTdAM_CONST_aset1_frame;


typedef struct FLISTFLISTdAM_CONST_eltb_frame_struct {
 FLISTFLISTdAM_CONST self;/* Formal argument: self */
 INT state;
 FLISTdAM_CONST ret_val;
 FLISTFLISTdAM_CONST L31;
 INT L41;
 INT L51;
 struct FLISTFLISTdAM_CONST_aelt_frame_struct *nested1; /* nested iter frame */
 } *FLISTFLISTdAM_CONST_eltb_frame;

typedef struct FLISTFSTR_struct {/* layout for FLIST{FSTR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FSTR_struct *arr_part[1];
 } *FLISTFSTR;

typedef struct FLISTIDENT_struct {/* layout for FLIST{IDENT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FLISTIDENT;


typedef struct FLISTIDENT_aeltb_INT_INT_frame_struct {
 FLISTIDENT self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 IDENT ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIDENT_aeltb_INT_INT_frame;


typedef struct FLISTIDENT_asetb_IDENT_frame_struct {
 FLISTIDENT self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIDENT_asetb_IDENT_frame;


typedef struct FLISTIDENT_eltb_IDENT_frame_struct {
 FLISTIDENT self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 FLISTIDENT L31;
 INT L41;
 INT L51;
 struct FLISTIDENT_aeltb_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIDENT_eltb_IDENT_frame;

typedef struct FLISTIFC_struct {/* layout for FLIST{IFC} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IFC_struct *arr_part[1];
 } *FLISTIFC;


typedef struct FLISTIFC_aeltb_INT_INT_I_frame_struct {
 FLISTIFC self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 IFC ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIFC_aeltb_INT_INT_I_frame;


typedef struct FLISTIFC_asetb_IFC_frame_struct {
 FLISTIFC self;/* Formal argument: self */
 IFC arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIFC_asetb_IFC_frame;


typedef struct FLISTIFC_eltb_IFC_frame_struct {
 FLISTIFC self;/* Formal argument: self */
 INT state;
 IFC ret_val;
 FLISTIFC L31;
 INT L41;
 INT L51;
 struct FLISTIFC_aeltb_INT_INT_I_frame_struct *nested1; /* nested iter frame */
 } *FLISTIFC_eltb_IFC_frame;

typedef struct FLISTIMPL_INCLUDE_struct {/* layout for FLIST{IMPL_INCLUDE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IMPL_INCLUDE_struct *arr_part[1];
 } *FLISTIMPL_INCLUDE;


typedef struct FLISTIMPL_INCLUDE_aeltb__frame_struct {
 FLISTIMPL_INCLUDE self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 IMPL_INCLUDE ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIMPL_INCLUDE_aeltb__frame;


typedef struct FLISTIMPL_INCLUDE_asetb__frame_struct {
 FLISTIMPL_INCLUDE self;/* Formal argument: self */
 IMPL_INCLUDE arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIMPL_INCLUDE_asetb__frame;


typedef struct FLISTIMPL_INCLUDE_eltb_I_frame_struct {
 FLISTIMPL_INCLUDE self;/* Formal argument: self */
 INT state;
 IMPL_INCLUDE ret_val;
 FLISTIMPL_INCLUDE L31;
 INT L41;
 INT L51;
 struct FLISTIMPL_INCLUDE_aeltb__frame_struct *nested1; /* nested iter frame */
 } *FLISTIMPL_INCLUDE_eltb_I_frame;

typedef struct FLISTINT_struct {/* layout for FLIST{INT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 INT arr_part[1];
 } *FLISTINT;


typedef struct FLISTINT_aeltb_INT_INT_I_frame_struct {
 FLISTINT self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 INT ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTINT_aeltb_INT_INT_I_frame;


typedef struct FLISTINT_asetb_INT_frame_struct {
 FLISTINT self;/* Formal argument: self */
 INT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTINT_asetb_INT_frame;


typedef struct FLISTINT_eltb_INT_frame_struct {
 FLISTINT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 FLISTINT L31;
 INT L41;
 INT L51;
 struct FLISTINT_aeltb_INT_INT_I_frame_struct *nested1; /* nested iter frame */
 } *FLISTINT_eltb_INT_frame;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;


typedef struct FSETdTP_eltb_dTP_frame_struct {
 FSETdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FSETdTP L31;
 dTP r;
 struct FSETdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *FSETdTP_eltb_dTP_frame;

typedef struct FSETEXTERNAL_LAYOUT_struct {/* layout for FSET{EXTERNAL_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct EXTERNAL_LAYOUT_struct *arr_part[1];
 } *FSETEXTERNAL_LAYOUT;

typedef struct FSETIDENT_struct {/* layout for FSET{IDENT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FSETIDENT;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;


typedef struct PROG_AS_TBL_eltb_AS_CLAS_frame_struct {
 PROG_AS_TBL self;/* Formal argument: self */
 INT state;
 AS_CLASS_DEF ret_val;
 PROG_AS_TBL L31;
 AS_CLASS_DEF r;
 struct PROG_AS_TBL_aeltb_AS_CLA_frame_struct *nested1; /* nested iter frame */
 } *PROG_AS_TBL_eltb_AS_CLAS_frame;


typedef struct FLISTFSTR_aeltb_INT_INT__frame_struct {
 FLISTFSTR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 FSTR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTFSTR_aeltb_INT_INT__frame;


typedef struct FLISTFSTR_asetb_FSTR_frame_struct {
 FLISTFSTR self;/* Formal argument: self */
 FSTR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTFSTR_asetb_FSTR_frame;


typedef struct FLISTFSTR_eltb_FSTR_frame_struct {
 FLISTFSTR self;/* Formal argument: self */
 INT state;
 FSTR ret_val;
 FLISTFSTR L31;
 INT L41;
 INT L51;
 struct FLISTFSTR_aeltb_INT_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTFSTR_eltb_FSTR_frame;

#include "tags.h"

/* Globals */

extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSETEXTERNAL_LAYOUT EXTERNAL_LAYOUT_layouts;
extern INT ELT_TBL_load_ratio;

/* Function declarations */

AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_1(FLISTAM_BND_CREATE_EXPR, INT);
AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_13(FLISTAM_BND_CREATE_EXPR);
AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_2(FLISTAM_BND_CREATE_EXPR, INT);
AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_3(FLISTAM_BND_CREATE_EXPR_3_frame);
AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_4(FLISTAM_BND_CREATE_EXPR_4_frame);
AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX2(FLISTAM_BND_ITER_CALL_EX, INT);
AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX3(FLISTAM_BND_ITER_CALL_EX, INT);
AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX4(FLISTAM_BND_ITER_CALL_EX4_frame);
AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX5(FLISTAM_BND_ITER_CALL_EX5_frame);
AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aelt(FLISTAM_GLOBAL_EXPR_aelt_frame);
AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aget(FLISTAM_GLOBAL_EXPR, INT);
AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aref(FLISTAM_GLOBAL_EXPR, INT);
AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_eltb(FLISTAM_GLOBAL_EXPR_eltb_frame);
AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a1(FLISTAM_ITER_CALL_EXPR, INT);
AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a2(FLISTAM_ITER_CALL_EXPR, INT);
AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a3(FLISTAM_ITER_CALL_EXPR_a3_frame);
AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_e(FLISTAM_ITER_CALL_EXPR_e_frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aeltb(FLISTAM_LOCAL_EXPR_aeltb_frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aget_(FLISTAM_LOCAL_EXPR, INT);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aref_(FLISTAM_LOCAL_EXPR, INT);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_pop_A(FLISTAM_LOCAL_EXPR);
AM_ROUT_DEF FLISTAM_ROUT_DEF_aeltb_I(FLISTAM_ROUT_DEF_aeltb_I_frame);
AM_ROUT_DEF FLISTAM_ROUT_DEF_aget_IN(FLISTAM_ROUT_DEF, INT);
AM_ROUT_DEF FLISTAM_ROUT_DEF_aref_ag(FLISTAM_ROUT_DEF, INT);
AM_ROUT_DEF FLISTAM_ROUT_DEF_eltb_AM(FLISTAM_ROUT_DEF_eltb_AM_frame);
AS_CLASS_DEF FIND_TYPES_tree_for_IDEN(FIND_TYPES, IDENT, INT);
AS_CLASS_DEF FLISTAS_CLASS_DEF_aeltb_(FLISTAS_CLASS_DEF_aeltb__frame);
AS_CLASS_DEF FLISTAS_CLASS_DEF_aget_I(FLISTAS_CLASS_DEF, INT);
AS_CLASS_DEF FLISTAS_CLASS_DEF_aref_a(FLISTAS_CLASS_DEF, INT);
AS_CLASS_DEF FLISTAS_CLASS_DEF_eltb_A(FLISTAS_CLASS_DEF_eltb_A_frame);
AS_CLASS_DEF PROG_AS_TBL_eltb_AS_CLAS(PROG_AS_TBL_eltb_AS_CLAS_frame);
AS_TYPE_SPEC AS_TYPE_SPEC_create_AS_T(AS_TYPE_SPEC);
AS_TYPE_SPEC ELT_as_tp_AS_TYPE_SPEC(ELT);
BOOL ELT_TBL_elt_eq_ELT_ELT_B(ELT_TBL, ELT, ELT);
BOOL ELT_TBL_is_elt_nil_ELT_B(ELT_TBL, ELT);
BOOL ELT_TBL_not_too_many_INT(ELT_TBL, INT, INT);
BOOL ELT_TBL_query_test_IDENT(ELT_TBL, IDENT, ELT);
BOOL ELT_TBL_should_grow_BOOL(ELT_TBL);
BOOL ELT_conflicts_with_ELT_B(ELT, ELT);
BOOL ELT_is_abstract_BOOL(ELT);
BOOL ELT_is_attr_access_BOOL(ELT);
BOOL ELT_is_attr_reader_BOOL(ELT);
BOOL ELT_is_attr_writer_BOOL(ELT);
BOOL ELT_is_const_reader_BOOL(ELT);
BOOL ELT_is_invariant_BOOL(ELT);
BOOL ELT_is_shared_reader_BOO(ELT);
BOOL ELT_is_shared_writer_BOO(ELT);
BOOL FILE_eof_BOOL(FILE1);
BOOL FILE_error_BOOL(FILE1);
BOOL FLISTAM_BND_CREATE_EXPR_12(FLISTAM_BND_CREATE_EXPR);
BOOL FLISTAM_BND_CREATE_EXPR_15(FLISTAM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
BOOL FLISTAM_BND_CREATE_EXPR_16(FLISTAM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
BOOL FLISTAM_ITER_CALL_EXPR_c1(FLISTAM_ITER_CALL_EXPR, AM_ITER_CALL_EXPR);
BOOL FLISTAM_ITER_CALL_EXPR_e1(FLISTAM_ITER_CALL_EXPR, AM_ITER_CALL_EXPR, AM_ITER_CALL_EXPR);
BOOL FLISTIFC_is_empty_BOOL(FLISTIFC);
BOOL FLISTIMPL_INCLUDE_is_emp(FLISTIMPL_INCLUDE);
BOOL FSETIDENT_test_IDENT_BOO(FSETIDENT, IDENT);
BOOL FSETdTP_test_dTP_BOOL(FSETdTP, dTP);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL SIG_conflicts_with_SIG_B(SIG, SIG);
BOOL SIG_is_attr_writer_sig_B(SIG);
BOOL SIG_is_eq_SIG_BOOL(SIG, SIG);
BOOL SIG_is_invariant_BOOL(SIG);
BOOL SIG_is_reader_sig_BOOL(SIG);
BOOL SIG_is_shared_writer_sig(SIG);
BOOL TP_CLASS_is_abstract_BOO(TP_CLASS);
CHAR FILE_get_char_CHAR(FILE1);
CHAR FLISTCHAR_aeltb_INT_INT_(FLISTCHAR_aeltb_INT_INT__frame);
CHAR FLISTCHAR_aget_INT_CHAR(FLISTCHAR, INT);
CHAR FLISTCHAR_aref_aget_INT_(FLISTCHAR, INT);
CHAR FLISTCHAR_eltb_CHAR(FLISTCHAR_eltb_CHAR_frame);
CODE_FILE FLISTCODE_FILE_aeltb_INT(FLISTCODE_FILE_aeltb_INT_frame);
CODE_FILE FLISTCODE_FILE_aget_INT_(FLISTCODE_FILE, INT);
CODE_FILE FLISTCODE_FILE_aref_aget(FLISTCODE_FILE, INT);
CODE_FILE FLISTCODE_FILE_eltb_CODE(FLISTCODE_FILE_eltb_CODE_frame);
ELT ELT_TBL_aeltb_ELT(ELT_TBL_aeltb_ELT_frame);
ELT ELT_TBL_aget_INT_ELT(ELT_TBL, INT);
ELT ELT_TBL_elt_conflicting_(ELT_TBL, ELT);
ELT ELT_TBL_elt_nil_ELT(ELT_TBL);
ELT ELT_TBL_elt_same_name_as(ELT_TBL, ELT);
ELT ELT_TBL_elt_with_sig_SIG(ELT_TBL, SIG);
ELT ELT_TBL_eltb_ELT(ELT_TBL_eltb_ELT_frame);
ELT ELT_TBL_get_queryb_IDENT(ELT_TBL_get_queryb_IDENT_frame);
ELT ELT_create_SIG_SIG_dAS_C(ELT, SIG, SIG, dAS_CLASS_ELT, TP_CONTEXT, BOOL);
ELT_TBL ELT_TBL_allocate_INT_ELT(ELT_TBL, INT);
ELT_TBL ELT_TBL_double_size_ELT_(ELT_TBL);
ELT_TBL ELT_TBL_insert_ELT_ELT_T(ELT_TBL, ELT);
ERR1 ERR_create_ERR(ERR1);
ERR1 ERR_plus_dSTR_ERR(ERR1, dSTR);
EXTERNAL_LAYOUT EXTERNAL_LAYOUT_create_d(EXTERNAL_LAYOUT, dTP);
FILE1 FILE_open_for_read_STR_F(FILE1, STR);
FILE1 FILE_open_for_write_STR_(FILE1, STR);
FILE1 FILE_plus_dSTR_FILE(FILE1, dSTR);
FILE1 FILE_stderr_FILE(FILE1);
FILE1 FILE_stdout_FILE(FILE1);
FIND_TYPES FIND_TYPES_create_PROG_F(FIND_TYPES, PROG);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_10(FLISTAM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_14(FLISTAM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_17(FLISTAM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_18(FLISTAM_BND_CREATE_EXPR, FLISTAM_BND_CREATE_EXPR);
FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_6(FLISTAM_BND_CREATE_EXPR);
FLISTAM_BND_ITER_CALL_EX FLISTAM_BND_ITER_CALL_EX10(FLISTAM_BND_ITER_CALL_EX, AM_BND_ITER_CALL_EXPR);
FLISTAM_BND_ITER_CALL_EX FLISTAM_BND_ITER_CALL_EX11(FLISTAM_BND_ITER_CALL_EX, FLISTAM_BND_ITER_CALL_EX);
FLISTAM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_push(FLISTAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_c(FLISTAM_ITER_CALL_EXPR, INT);
FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_c2(FLISTAM_ITER_CALL_EXPR, FLISTAM_ITER_CALL_EXPR);
FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_p(FLISTAM_ITER_CALL_EXPR, AM_ITER_CALL_EXPR);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_conca(FLISTAM_LOCAL_EXPR, FLISTAM_LOCAL_EXPR);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_creat(FLISTAM_LOCAL_EXPR, INT);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR, AM_LOCAL_EXPR);
FLISTAM_ROUT_DEF FLISTAM_ROUT_DEF_create_(FLISTAM_ROUT_DEF);
FLISTAM_ROUT_DEF FLISTAM_ROUT_DEF_push_AM(FLISTAM_ROUT_DEF, AM_ROUT_DEF);
FLISTAS_CLASS_DEF FLISTAS_CLASS_DEF_create(FLISTAS_CLASS_DEF);
FLISTAS_CLASS_DEF FLISTAS_CLASS_DEF_push_A(FLISTAS_CLASS_DEF, AS_CLASS_DEF);
FLISTCODE_FILE FLISTCODE_FILE_create_FL(FLISTCODE_FILE);
FLISTCODE_FILE FLISTCODE_FILE_push_CODE(FLISTCODE_FILE, CODE_FILE);
FLISTFLISTdAM_CONST FLISTFLISTdAM_CONST_push(FLISTFLISTdAM_CONST, FLISTdAM_CONST);
FLISTFSTR FLISTFSTR_concat_FLISTFS(FLISTFSTR, FLISTFSTR);
FLISTFSTR FLISTFSTR_create_FLISTFS(FLISTFSTR);
FLISTFSTR FLISTFSTR_push_FSTR_FLIS(FLISTFSTR, FSTR);
FLISTIDENT FLISTIDENT_create_FLISTI(FLISTIDENT);
FLISTIDENT FLISTIDENT_push_IDENT_FL(FLISTIDENT, IDENT);
FLISTIFC FLISTIFC_push_IFC_FLISTI(FLISTIFC, IFC);
FLISTIMPL_INCLUDE FLISTIMPL_INCLUDE_push_I(FLISTIMPL_INCLUDE, IMPL_INCLUDE);
FLISTINT FLISTINT_create_INT_FLIS(FLISTINT, INT);
FLISTINT FLISTINT_push_INT_FLISTI(FLISTINT, INT);
FLISTdAM_CONST FLISTFLISTdAM_CONST_aelt(FLISTFLISTdAM_CONST_aelt_frame);
FLISTdAM_CONST FLISTFLISTdAM_CONST_aget(FLISTFLISTdAM_CONST, INT);
FLISTdAM_CONST FLISTFLISTdAM_CONST_aref(FLISTFLISTdAM_CONST, INT);
FLISTdAM_CONST FLISTFLISTdAM_CONST_eltb(FLISTFLISTdAM_CONST_eltb_frame);
FLISTdAM_CONST FLISTFLISTdAM_CONST_pop_(FLISTFLISTdAM_CONST);
FLISTdLAYOUT EXTERNAL_LAYOUT_dependen(EXTERNAL_LAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_inse(FSETEXTERNAL_LAYOUT, EXTERNAL_LAYOUT);
FSETIDENT FSETIDENT_insert_IDENT_F(FSETIDENT, IDENT);
FSETdTP FSETdTP_delete_dTP_FSETd(FSETdTP, dTP);
FSETdTP FSETdTP_insert_dTP_FSETd(FSETdTP, dTP);
FSTR FILE_fstr_FSTR(FILE1);
FSTR FILE_get_line_FSTR(FILE1);
FSTR FLISTFSTR_aeltb_INT_INT_(FLISTFSTR_aeltb_INT_INT__frame);
FSTR FLISTFSTR_aget_INT_FSTR(FLISTFSTR, INT);
FSTR FLISTFSTR_aref_aget_INT_(FLISTFSTR, INT);
FSTR FLISTFSTR_eltb_FSTR(FLISTFSTR_eltb_FSTR_frame);
FSTR FSTR_create_FSTR(FSTR);
FSTR FSTR_create_INT_FSTR(FSTR, INT);
FSTR FSTR_create_STR_FSTR(FSTR, STR);
FSTR FSTR_plus_STR_FSTR(FSTR, STR);
FSTR FSTR_push_CHAR_FSTR(FSTR, CHAR);
IDENT ELT_name_IDENT(ELT);
IDENT FLISTIDENT_aeltb_INT_INT(FLISTIDENT_aeltb_INT_INT_frame);
IDENT FLISTIDENT_aget_INT_IDEN(FLISTIDENT, INT);
IDENT FLISTIDENT_aref_aget_INT(FLISTIDENT, INT);
IDENT FLISTIDENT_eltb_IDENT(FLISTIDENT_eltb_IDENT_frame);
IDENT IDENT_create_STR_IDENT(IDENT, STR);
IFC ELT_TBL_public_ifc_IFC(ELT_TBL);
IFC FLISTIFC_aeltb_INT_INT_I(FLISTIFC_aeltb_INT_INT_I_frame);
IFC FLISTIFC_aget_INT_IFC(FLISTIFC, INT);
IFC FLISTIFC_aref_aget_INT_I(FLISTIFC, INT);
IFC FLISTIFC_eltb_IFC(FLISTIFC_eltb_IFC_frame);
IFC FLISTIFC_pop_IFC(FLISTIFC);
IFC IFC_create_SIG_TBL_dTP_I(IFC, SIG_TBL, dTP);
IMPL ELT_impl_IMPL(ELT);
IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL, dTP);
IMPL_INCLUDE FLISTIMPL_INCLUDE_aeltb_(FLISTIMPL_INCLUDE_aeltb__frame);
IMPL_INCLUDE FLISTIMPL_INCLUDE_aget_I(FLISTIMPL_INCLUDE, INT);
IMPL_INCLUDE FLISTIMPL_INCLUDE_aref_a(FLISTIMPL_INCLUDE, INT);
IMPL_INCLUDE FLISTIMPL_INCLUDE_eltb_I(FLISTIMPL_INCLUDE_eltb_I_frame);
IMPL_INCLUDE FLISTIMPL_INCLUDE_pop_IM(FLISTIMPL_INCLUDE);
INT ARRAYdTP_size_INT(ARRAYdTP);
INT AS_PARAM_DEC_size_INT(AS_PARAM_DEC);
INT ELT_TBL_asize_INT(ELT_TBL);
INT ELT_TBL_elt_hash_ELT_INT(ELT_TBL, ELT);
INT ELT_TBL_query_hash_IDENT(ELT_TBL, IDENT);
INT FILE_current_loc_INT(FILE1);
INT FILE_size_INT(FILE1);
INT FLISTAM_BND_CREATE_EXPR_(FLISTAM_BND_CREATE_EXPR);
INT FLISTAM_BND_CREATE_EXPR_11(FLISTAM_BND_CREATE_EXPR);
INT FLISTAM_BND_ITER_CALL_EX1(FLISTAM_BND_ITER_CALL_EX);
INT FLISTAM_GLOBAL_EXPR_asiz(FLISTAM_GLOBAL_EXPR);
INT FLISTAM_ITER_CALL_EXPR_a(FLISTAM_ITER_CALL_EXPR);
INT FLISTAM_ITER_CALL_EXPR_s1(FLISTAM_ITER_CALL_EXPR);
INT FLISTAM_LOCAL_EXPR_asize(FLISTAM_LOCAL_EXPR);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTAM_ROUT_DEF_asize_I(FLISTAM_ROUT_DEF);
INT FLISTAS_CLASS_DEF_asize_(FLISTAS_CLASS_DEF);
INT FLISTCHAR_asize_INT(FLISTCHAR);
INT FLISTCODE_FILE_asize_INT(FLISTCODE_FILE);
INT FLISTCODE_FILE_size_INT(FLISTCODE_FILE);
INT FLISTFLISTdAM_CONST_asiz(FLISTFLISTdAM_CONST);
INT FLISTFLISTdAM_CONST_size(FLISTFLISTdAM_CONST);
INT FLISTFSTR_asize_INT(FLISTFSTR);
INT FLISTFSTR_size_INT(FLISTFSTR);
INT FLISTIDENT_asize_INT(FLISTIDENT);
INT FLISTIDENT_size_INT(FLISTIDENT);
INT FLISTIFC_asize_INT(FLISTIFC);
INT FLISTIFC_size_INT(FLISTIFC);
INT FLISTIMPL_INCLUDE_asize_(FLISTIMPL_INCLUDE);
INT FLISTIMPL_INCLUDE_size_I(FLISTIMPL_INCLUDE);
INT FLISTINT_aeltb_INT_INT_I(FLISTINT_aeltb_INT_INT_I_frame);
INT FLISTINT_aget_INT_INT(FLISTINT, INT);
INT FLISTINT_aref_aget_INT_I(FLISTINT, INT);
INT FLISTINT_asize_INT(FLISTINT);
INT FLISTINT_eltb_INT(FLISTINT_eltb_INT_frame);
INT FLISTINT_pop_INT(FLISTINT);
INT FLISTINT_size_INT(FLISTINT);
INT FSTR_length_INT(FSTR);
INT IDENT_hash_INT(IDENT);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame);
INT STR_length_INT(STR);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
PROG ELT_prog_PROG(ELT);
SIG_TBL SIG_TBL_insert_SIG_SIG_T(SIG_TBL, SIG);
STR CHAR_str_STR(CHAR);
STR EXTERNAL_LAYOUT_makestr_(EXTERNAL_LAYOUT);
STR EXTERNAL_LAYOUT_str_STR(EXTERNAL_LAYOUT);
STR EXTERNAL_LAYOUT_typedef_(EXTERNAL_LAYOUT, CGEN);
STR FILE_get_str_STR(FILE1);
STR FILE_resolve_path_STR_ST(FILE1, STR);
STR FLISTAM_BND_CREATE_EXPR_5(FLISTAM_BND_CREATE_EXPR);
STR FLISTAM_BND_ITER_CALL_EX6(FLISTAM_BND_ITER_CALL_EX);
STR FLISTAM_GLOBAL_EXPR_str_(FLISTAM_GLOBAL_EXPR);
STR FLISTAM_ITER_CALL_EXPR_s(FLISTAM_ITER_CALL_EXPR);
STR FLISTAM_LOCAL_EXPR_str_S(FLISTAM_LOCAL_EXPR);
STR FLISTAM_ROUT_DEF_str_STR(FLISTAM_ROUT_DEF);
STR FLISTAS_CLASS_DEF_str_ST(FLISTAS_CLASS_DEF);
STR FLISTCHAR_str_STR(FLISTCHAR);
STR FLISTCODE_FILE_str_STR(FLISTCODE_FILE);
STR FLISTFLISTdAM_CONST_str_(FLISTFLISTdAM_CONST);
STR FLISTFSTR_str_STR(FLISTFSTR);
STR FLISTIDENT_str_STR(FLISTIDENT);
STR FLISTIFC_str_STR(FLISTIFC);
STR FLISTIMPL_INCLUDE_str_ST(FLISTIMPL_INCLUDE);
STR FLISTINT_str_STR(FLISTINT);
STR FLISTdAM_CONST_str_STR(FLISTdAM_CONST);
STR FSTR_str_STR(FSTR);
STR INT_str_STR(INT);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_separateb_STR_STR(STR_separateb_STR_STR_frame);
STR TP_CLASS_str_STR(TP_CLASS);
TP_CLASS TP_TBL_tp_class_for_IDEN(TP_TBL, IDENT, ARRAYdTP);
TP_CONTEXT TP_CLASS_tp_context_for_(TP_CLASS);
dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT, dTP);
dTP ARRAYdTP_aget_INT_dTP(ARRAYdTP, INT);
dTP ELT_ret_dTP(ELT);
dTP ELT_tp_dTP(ELT);
dTP FSETdTP_eltb_dTP(FSETdTP_eltb_dTP_frame);
dTP FSETdTP_first_elt_dTP(FSETdTP);
dTP TP_CONTEXT_tp_of_AS_TYPE(TP_CONTEXT, AS_TYPE_SPEC);
extern const int dAS_CLASS_ELT_next_dAS_C_offset;

extern const dAS_CLASS_ELT (*dAS_CLASS_ELT_next_dAS_C[])(dAS_CLASS_ELT);
extern const int dPARSE_tree_for_IDENT_IN_offset;

extern const AS_CLASS_DEF (*dPARSE_tree_for_IDENT_IN[])(dPARSE, IDENT, INT);
extern const int dSTR_str_STR_offset;

extern const STR (*dSTR_str_STR[])(dSTR);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void ELT_TBL_aset_INT_ELT(ELT_TBL, INT, ELT);
void ELT_TBL_asetb_ELT(ELT_TBL_asetb_ELT_frame);
void ERR_plus_dSTR(ERR1, dSTR);
void EXTERNAL_LAYOUT_layouts_(EXTERNAL_LAYOUT, FSETEXTERNAL_LAYOUT);
void FILE_close(FILE1);
void FILE_create_directory_ST(FILE1, STR);
void FILE_flush(FILE1);
void FILE_plus_dSTR(FILE1, dSTR);
void FILE_seek_from_end_INT(FILE1, INT);
void FILE_seek_from_front_INT(FILE1, INT);
void FIND_TYPES_do_abs_AS_CLA(FIND_TYPES, AS_CLASS_DEF);
void FIND_TYPES_do_impl_IMPL(FIND_TYPES, IMPL);
void FIND_TYPES_do_tps_dAS_NO(FIND_TYPES, dAS_NODE);
void FIND_TYPES_err_STR(FIND_TYPES, STR);
void FIND_TYPES_err_loc_dPROG(FIND_TYPES, dPROG_ERR);
void FIND_TYPES_find_types(FIND_TYPES);
void FIND_TYPES_process_tp_dT(FIND_TYPES, dTP);
void FIND_TYPES_tbl_out(FIND_TYPES);
void FLISTAM_BND_CREATE_EXPR_7(FLISTAM_BND_CREATE_EXPR, INT, AM_BND_CREATE_EXPR);
void FLISTAM_BND_CREATE_EXPR_8(FLISTAM_BND_CREATE_EXPR, INT, AM_BND_CREATE_EXPR);
void FLISTAM_BND_CREATE_EXPR_9(FLISTAM_BND_CREATE_EXPR_9_frame);
void FLISTAM_BND_ITER_CALL_EX7(FLISTAM_BND_ITER_CALL_EX, INT, AM_BND_ITER_CALL_EXPR);
void FLISTAM_BND_ITER_CALL_EX8(FLISTAM_BND_ITER_CALL_EX, INT, AM_BND_ITER_CALL_EXPR);
void FLISTAM_BND_ITER_CALL_EX9(FLISTAM_BND_ITER_CALL_EX9_frame);
void FLISTAM_GLOBAL_EXPR_aref1(FLISTAM_GLOBAL_EXPR, INT, AM_GLOBAL_EXPR);
void FLISTAM_GLOBAL_EXPR_aset(FLISTAM_GLOBAL_EXPR, INT, AM_GLOBAL_EXPR);
void FLISTAM_GLOBAL_EXPR_aset1(FLISTAM_GLOBAL_EXPR_aset1_frame);
void FLISTAM_ITER_CALL_EXPR_a4(FLISTAM_ITER_CALL_EXPR, INT, AM_ITER_CALL_EXPR);
void FLISTAM_ITER_CALL_EXPR_a5(FLISTAM_ITER_CALL_EXPR, INT, AM_ITER_CALL_EXPR);
void FLISTAM_ITER_CALL_EXPR_a6(FLISTAM_ITER_CALL_EXPR_a6_frame);
void FLISTAM_LOCAL_EXPR_aref_1(FLISTAM_LOCAL_EXPR, INT, AM_LOCAL_EXPR);
void FLISTAM_LOCAL_EXPR_aset_(FLISTAM_LOCAL_EXPR, INT, AM_LOCAL_EXPR);
void FLISTAM_LOCAL_EXPR_asetb(FLISTAM_LOCAL_EXPR_asetb_frame);
void FLISTAM_ROUT_DEF_aref_as(FLISTAM_ROUT_DEF, INT, AM_ROUT_DEF);
void FLISTAM_ROUT_DEF_aset_IN(FLISTAM_ROUT_DEF, INT, AM_ROUT_DEF);
void FLISTAM_ROUT_DEF_asetb_A(FLISTAM_ROUT_DEF_asetb_A_frame);
void FLISTAS_CLASS_DEF_aref_a1(FLISTAS_CLASS_DEF, INT, AS_CLASS_DEF);
void FLISTAS_CLASS_DEF_aset_I(FLISTAS_CLASS_DEF, INT, AS_CLASS_DEF);
void FLISTAS_CLASS_DEF_asetb_(FLISTAS_CLASS_DEF_asetb__frame);
void FLISTCODE_FILE_aref_aset(FLISTCODE_FILE, INT, CODE_FILE);
void FLISTCODE_FILE_aset_INT_(FLISTCODE_FILE, INT, CODE_FILE);
void FLISTCODE_FILE_asetb_COD(FLISTCODE_FILE_asetb_COD_frame);
void FLISTFLISTdAM_CONST_aref1(FLISTFLISTdAM_CONST, INT, FLISTdAM_CONST);
void FLISTFLISTdAM_CONST_aset(FLISTFLISTdAM_CONST, INT, FLISTdAM_CONST);
void FLISTFLISTdAM_CONST_aset1(FLISTFLISTdAM_CONST_aset1_frame);
void FLISTFSTR_aref_aset_INT_(FLISTFSTR, INT, FSTR);
void FLISTFSTR_aset_INT_FSTR(FLISTFSTR, INT, FSTR);
void FLISTFSTR_asetb_FSTR(FLISTFSTR_asetb_FSTR_frame);
void FLISTIDENT_aref_aset_INT(FLISTIDENT, INT, IDENT);
void FLISTIDENT_aset_INT_IDEN(FLISTIDENT, INT, IDENT);
void FLISTIDENT_asetb_IDENT(FLISTIDENT_asetb_IDENT_frame);
void FLISTIFC_aref_aset_INT_I(FLISTIFC, INT, IFC);
void FLISTIFC_aset_INT_IFC(FLISTIFC, INT, IFC);
void FLISTIFC_asetb_IFC(FLISTIFC_asetb_IFC_frame);
void FLISTIMPL_INCLUDE_aref_a1(FLISTIMPL_INCLUDE, INT, IMPL_INCLUDE);
void FLISTIMPL_INCLUDE_aset_I(FLISTIMPL_INCLUDE, INT, IMPL_INCLUDE);
void FLISTIMPL_INCLUDE_asetb_(FLISTIMPL_INCLUDE_asetb__frame);
void FLISTINT_aref_aset_INT_I(FLISTINT, INT, INT);
void FLISTINT_aset_INT_INT(FLISTINT, INT, INT);
void FLISTINT_asetb_INT(FLISTINT_asetb_INT_frame);
void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL, FMAPdTPdLAYOUT);
void OUT_plus_dSTR(OUT, dSTR);
void PROG_err_STR(PROG, STR);
void PROG_err_loc_dPROG_ERR(PROG, dPROG_ERR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


#if defined(__FreeBSD__) || (M_I386 && M_XENIX)
    extern long ftell(const FILE *);
#else
    extern long ftell(FILE *);
#endif
extern FILE *fopen(const char*, const char*);
extern int ferror(FILE *); /* ferror is #undef ed */

/* Code */




AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_1(FLISTAM_BND_CREATE_EXPR self, INT ind) {
 AM_BND_CREATE_EXPR ret_val;
 return ARR(self,ind);
}


AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_13(FLISTAM_BND_CREATE_EXPR self) {
 AM_BND_CREATE_EXPR ret_val;
 AM_BND_CREATE_EXPR r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTAM_BND_CREATE_EXPR_11(self);
 if ((L1==0)) {
  ret_val = ((AM_BND_CREATE_EXPR) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTAM_BND_CREATE_EXPR_2(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTAM_BND_CREATE_EXPR_8(self, L4, ((AM_BND_CREATE_EXPR) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_2(FLISTAM_BND_CREATE_EXPR self, INT ind) {
 AM_BND_CREATE_EXPR ret_val;
 ret_val = FLISTAM_BND_CREATE_EXPR_1(self, ind);
 return ret_val;
}


AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_3(FLISTAM_BND_CREATE_EXPR_3_frame frame) {
 AM_BND_CREATE_EXPR dummy = ((AM_BND_CREATE_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_BND_CREATE_EXPR_2(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_4(FLISTAM_BND_CREATE_EXPR_4_frame frame) {
 AM_BND_CREATE_EXPR dummy = ((AM_BND_CREATE_EXPR) NULL);
 BOOL L1;
 AM_BND_CREATE_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_BND_CREATE_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_BND_CREATE_EXPR_3_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_BND_CREATE_EXPR_3(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX2(FLISTAM_BND_ITER_CALL_EX self, INT ind) {
 AM_BND_ITER_CALL_EXPR ret_val;
 return ARR(self,ind);
}


AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX3(FLISTAM_BND_ITER_CALL_EX self, INT ind) {
 AM_BND_ITER_CALL_EXPR ret_val;
 ret_val = FLISTAM_BND_ITER_CALL_EX2(self, ind);
 return ret_val;
}


AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX4(FLISTAM_BND_ITER_CALL_EX4_frame frame) {
 AM_BND_ITER_CALL_EXPR dummy = ((AM_BND_ITER_CALL_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_BND_ITER_CALL_EX3(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_BND_ITER_CALL_EXPR FLISTAM_BND_ITER_CALL_EX5(FLISTAM_BND_ITER_CALL_EX5_frame frame) {
 AM_BND_ITER_CALL_EXPR dummy = ((AM_BND_ITER_CALL_EXPR) NULL);
 BOOL L1;
 AM_BND_ITER_CALL_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_BND_ITER_CALL_EX) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_BND_ITER_CALL_EX4_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_BND_ITER_CALL_EX4(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aelt(FLISTAM_GLOBAL_EXPR_aelt_frame frame) {
 AM_GLOBAL_EXPR dummy = ((AM_GLOBAL_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_GLOBAL_EXPR_aget(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aget(FLISTAM_GLOBAL_EXPR self, INT ind) {
 AM_GLOBAL_EXPR ret_val;
 ret_val = FLISTAM_GLOBAL_EXPR_aref(self, ind);
 return ret_val;
}


AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_aref(FLISTAM_GLOBAL_EXPR self, INT ind) {
 AM_GLOBAL_EXPR ret_val;
 return ARR(self,ind);
}


AM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_eltb(FLISTAM_GLOBAL_EXPR_eltb_frame frame) {
 AM_GLOBAL_EXPR dummy = ((AM_GLOBAL_EXPR) NULL);
 BOOL L1;
 AM_GLOBAL_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_GLOBAL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_GLOBAL_EXPR_aelt_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_GLOBAL_EXPR_aelt(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a1(FLISTAM_ITER_CALL_EXPR self, INT ind) {
 AM_ITER_CALL_EXPR ret_val;
 return ARR(self,ind);
}


AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a2(FLISTAM_ITER_CALL_EXPR self, INT ind) {
 AM_ITER_CALL_EXPR ret_val;
 ret_val = FLISTAM_ITER_CALL_EXPR_a1(self, ind);
 return ret_val;
}


AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_a3(FLISTAM_ITER_CALL_EXPR_a3_frame frame) {
 AM_ITER_CALL_EXPR dummy = ((AM_ITER_CALL_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_ITER_CALL_EXPR_a2(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_e(FLISTAM_ITER_CALL_EXPR_e_frame frame) {
 AM_ITER_CALL_EXPR dummy = ((AM_ITER_CALL_EXPR) NULL);
 BOOL L1;
 AM_ITER_CALL_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_ITER_CALL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_ITER_CALL_EXPR_a3_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_ITER_CALL_EXPR_a3(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aeltb(FLISTAM_LOCAL_EXPR_aeltb_frame frame) {
 AM_LOCAL_EXPR dummy = ((AM_LOCAL_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_LOCAL_EXPR_aget_(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aget_(FLISTAM_LOCAL_EXPR self, INT ind) {
 AM_LOCAL_EXPR ret_val;
 ret_val = FLISTAM_LOCAL_EXPR_aref_(self, ind);
 return ret_val;
}


AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aref_(FLISTAM_LOCAL_EXPR self, INT ind) {
 AM_LOCAL_EXPR ret_val;
 return ARR(self,ind);
}


AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame frame) {
 AM_LOCAL_EXPR dummy = ((AM_LOCAL_EXPR) NULL);
 BOOL L1;
 AM_LOCAL_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_LOCAL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_LOCAL_EXPR_aeltb_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_LOCAL_EXPR_aeltb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_pop_A(FLISTAM_LOCAL_EXPR self) {
 AM_LOCAL_EXPR ret_val;
 AM_LOCAL_EXPR r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTAM_LOCAL_EXPR_size_(self);
 if ((L1==0)) {
  ret_val = ((AM_LOCAL_EXPR) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTAM_LOCAL_EXPR_aget_(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTAM_LOCAL_EXPR_aset_(self, L4, ((AM_LOCAL_EXPR) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


AM_ROUT_DEF FLISTAM_ROUT_DEF_aeltb_I(FLISTAM_ROUT_DEF_aeltb_I_frame frame) {
 AM_ROUT_DEF dummy = ((AM_ROUT_DEF) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAM_ROUT_DEF_aget_IN(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AM_ROUT_DEF FLISTAM_ROUT_DEF_aget_IN(FLISTAM_ROUT_DEF self, INT ind) {
 AM_ROUT_DEF ret_val;
 ret_val = FLISTAM_ROUT_DEF_aref_ag(self, ind);
 return ret_val;
}


AM_ROUT_DEF FLISTAM_ROUT_DEF_aref_ag(FLISTAM_ROUT_DEF self, INT ind) {
 AM_ROUT_DEF ret_val;
 return ARR(self,ind);
}


AM_ROUT_DEF FLISTAM_ROUT_DEF_eltb_AM(FLISTAM_ROUT_DEF_eltb_AM_frame frame) {
 AM_ROUT_DEF dummy = ((AM_ROUT_DEF) NULL);
 BOOL L1;
 AM_ROUT_DEF L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAM_ROUT_DEF) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAM_ROUT_DEF_aeltb_I_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAM_ROUT_DEF_aeltb_I(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AS_CLASS_DEF FIND_TYPES_tree_for_IDEN(FIND_TYPES self, IDENT nm, INT num1) {
 AS_CLASS_DEF ret_val;
 dPARSE L1;
 L1 = ATTR(ATTR(self,prog1),parse);
 if (L1==NULL) {
  FATAL("Dispatch on void in FIND_TYPES::tree_for(IDENT,INT):AS_CLASS_DEF");
 }
 ret_val = (*dPARSE_tree_for_IDENT_IN[TAG(L1)+dPARSE_tree_for_IDENT_IN_offset])(L1, nm, num1);
 return ret_val;
}


AS_CLASS_DEF FLISTAS_CLASS_DEF_aeltb_(FLISTAS_CLASS_DEF_aeltb__frame frame) {
 AS_CLASS_DEF dummy = ((AS_CLASS_DEF) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTAS_CLASS_DEF_aget_I(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


AS_CLASS_DEF FLISTAS_CLASS_DEF_aget_I(FLISTAS_CLASS_DEF self, INT ind) {
 AS_CLASS_DEF ret_val;
 ret_val = FLISTAS_CLASS_DEF_aref_a(self, ind);
 return ret_val;
}


AS_CLASS_DEF FLISTAS_CLASS_DEF_aref_a(FLISTAS_CLASS_DEF self, INT ind) {
 AS_CLASS_DEF ret_val;
 return ARR(self,ind);
}


AS_CLASS_DEF FLISTAS_CLASS_DEF_eltb_A(FLISTAS_CLASS_DEF_eltb_A_frame frame) {
 AS_CLASS_DEF dummy = ((AS_CLASS_DEF) NULL);
 BOOL L1;
 AS_CLASS_DEF L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTAS_CLASS_DEF) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTAS_CLASS_DEF_aeltb__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTAS_CLASS_DEF_aeltb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AS_TYPE_SPEC ELT_as_tp_AS_TYPE_SPEC(ELT self) {
 AS_TYPE_SPEC ret_val;
 dAS_CLASS_ELT clelt;
 AS_TYPE_SPEC res = ((AS_TYPE_SPEC) NULL);
 BOOL L1;
 extern STR INT1;
 clelt = ATTR(self,as1);
 if (clelt==NULL) {
 } else
 switch (TAG(clelt)) {
  case AS_CONST_DEF_tag:
   L1 = (ATTR(((AS_CONST_DEF) clelt),tp1)==((AS_TYPE_SPEC) NULL));
   if ((!(L1))) {
    res = ATTR(((AS_CONST_DEF) clelt),tp1);
   }
   else {
    res = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
    SATTR(res,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &INT1)));
   } break;
  case AS_SHARED_DEF_tag:
   res = ATTR(((AS_SHARED_DEF) clelt),tp1); break;
  case AS_ATTR_DEF_tag:
   res = ATTR(((AS_ATTR_DEF) clelt),tp1); break;
  default: ;
 }
 ret_val = res;
 return ret_val;
}


BOOL ELT_TBL_elt_eq_ELT_ELT_B(ELT_TBL self, ELT e1, ELT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL ELT_TBL_is_elt_nil_ELT_B(ELT_TBL self, ELT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((ELT) NULL));
 return ret_val;
}


BOOL ELT_TBL_not_too_many_INT(ELT_TBL self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 ELT t = ((ELT) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR possiblyduetoabadhashfun;
 ERR1 L6;
 ELT L7;
 INT L8;
 ERR1 L9;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &possiblyduetoabadhashfun)));
  L7 = ELT_TBL_aget_INT_ELT(self, start1);
  L8 = (SYSTP(((OB) L7)));
  L9 = ERR_plus_dSTR_ERR(L6, ((dSTR) (SYSSTRFORTP(L8))));
  ERR_plus_dSTR(L9, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL ELT_TBL_query_test_IDENT(ELT_TBL self, IDENT name11, ELT e) {
 BOOL ret_val = ((BOOL) 0);
 if ((e==((ELT) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = IDENT_is_eq_IDENT_BOOL(ATTR(ATTR(e,sig11),name1), name11);
 return ret_val;
}


BOOL ELT_TBL_should_grow_BOOL(ELT_TBL self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = ELT_TBL_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL ELT_conflicts_with_ELT_B(ELT self, ELT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = SIG_conflicts_with_SIG_B(ATTR(self,sig11), ATTR(e,sig11));
 return ret_val;
}


BOOL ELT_is_abstract_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_ROUT_DEF_tag:
   ret_val = ATTR(((AS_ROUT_DEF) las),is_abstract);
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_attr_access_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_SHARED_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  case AS_CONST_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  case AS_ATTR_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_attr_reader_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 BOOL L1;
 L1 = SIG_is_reader_sig_BOOL(ATTR(self,sig11));
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_ATTR_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_attr_writer_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 BOOL L1;
 L1 = SIG_is_attr_writer_sig_B(ATTR(self,sig11));
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_ATTR_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_const_reader_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 BOOL L1;
 L1 = SIG_is_reader_sig_BOOL(ATTR(self,sig11));
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_CONST_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_invariant_BOOL(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = SIG_is_invariant_BOOL(ATTR(self,sig11));
 return ret_val;
}


BOOL ELT_is_shared_reader_BOO(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 BOOL L1;
 L1 = SIG_is_reader_sig_BOOL(ATTR(self,sig11));
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_SHARED_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL ELT_is_shared_writer_BOO(ELT self) {
 BOOL ret_val = ((BOOL) 0);
 dAS_CLASS_ELT las;
 BOOL L1;
 L1 = SIG_is_shared_writer_sig(ATTR(self,sig11));
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 las = ATTR(self,as1);
 if (las==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(las)) {
  case AS_SHARED_DEF_tag:
   ret_val = TRUE;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FILE_eof_BOOL(FILE1 self) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = feof(ATTR(self,fp));
 return ret_val;
}


BOOL FILE_error_BOOL(FILE1 self) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 if ((ATTR(self,fp)==((EXT_OB) NULL))) {
  L1 = TRUE;
 } else {
  L1 = ferror(ATTR(self,fp));
 }
 ret_val = L1;
 return ret_val;
}


BOOL FLISTAM_BND_CREATE_EXPR_12(FLISTAM_BND_CREATE_EXPR self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTAM_BND_CREATE_EXPR_11(self);
 ret_val = (L1==0);
 return ret_val;
}


BOOL FLISTAM_BND_CREATE_EXPR_15(FLISTAM_BND_CREATE_EXPR self, AM_BND_CREATE_EXPR e1, AM_BND_CREATE_EXPR e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FLISTAM_BND_CREATE_EXPR_16(FLISTAM_BND_CREATE_EXPR self, AM_BND_CREATE_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 FLISTAM_BND_CREATE_EXPR L11;
 AM_BND_CREATE_EXPR L2;
 {
  struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
  FLISTAM_BND_CREATE_EXPR_4_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_BND_CREATE_EXPR_4(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   if (FLISTAM_BND_CREATE_EXPR_15(self, e, L2)) {
    ret_val = TRUE;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = FALSE;
 return ret_val;
}


BOOL FLISTAM_ITER_CALL_EXPR_c1(FLISTAM_ITER_CALL_EXPR self, AM_ITER_CALL_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 FLISTAM_ITER_CALL_EXPR L11;
 AM_ITER_CALL_EXPR L2;
 {
  struct FLISTAM_ITER_CALL_EXPR_e_frame_struct other1_0;
  FLISTAM_ITER_CALL_EXPR_e_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_ITER_CALL_EXPR_e(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   if (FLISTAM_ITER_CALL_EXPR_e1(self, e, L2)) {
    ret_val = TRUE;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = FALSE;
 return ret_val;
}


BOOL FLISTAM_ITER_CALL_EXPR_e1(FLISTAM_ITER_CALL_EXPR self, AM_ITER_CALL_EXPR e1, AM_ITER_CALL_EXPR e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FLISTIFC_is_empty_BOOL(FLISTIFC self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTIFC_size_INT(self);
 ret_val = (L1==0);
 return ret_val;
}


BOOL FLISTIMPL_INCLUDE_is_emp(FLISTIMPL_INCLUDE self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTIMPL_INCLUDE_size_I(self);
 ret_val = (L1==0);
 return ret_val;
}


CHAR FILE_get_char_CHAR(FILE1 self) {
 CHAR ret_val = ((CHAR) 0);
 ret_val = fgetc(ATTR(self,fp));
 return ret_val;
}


CHAR FLISTCHAR_aeltb_INT_INT_(FLISTCHAR_aeltb_INT_INT__frame frame) {
 CHAR dummy = ((CHAR) 0);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTCHAR_aget_INT_CHAR(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


CHAR FLISTCHAR_aget_INT_CHAR(FLISTCHAR self, INT ind) {
 CHAR ret_val = ((CHAR) 0);
 ret_val = FLISTCHAR_aref_aget_INT_(self, ind);
 return ret_val;
}


CHAR FLISTCHAR_aref_aget_INT_(FLISTCHAR self, INT ind) {
 CHAR ret_val = ((CHAR) 0);
 return ARR(self,ind);
}


CHAR FLISTCHAR_eltb_CHAR(FLISTCHAR_eltb_CHAR_frame frame) {
 CHAR dummy = ((CHAR) 0);
 BOOL L1;
 CHAR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTCHAR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTCHAR_aeltb_INT_INT__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTCHAR_aeltb_INT_INT_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


CODE_FILE FLISTCODE_FILE_aeltb_INT(FLISTCODE_FILE_aeltb_INT_frame frame) {
 CODE_FILE dummy = ((CODE_FILE) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTCODE_FILE_aget_INT_(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


CODE_FILE FLISTCODE_FILE_aget_INT_(FLISTCODE_FILE self, INT ind) {
 CODE_FILE ret_val;
 ret_val = FLISTCODE_FILE_aref_aget(self, ind);
 return ret_val;
}


CODE_FILE FLISTCODE_FILE_aref_aget(FLISTCODE_FILE self, INT ind) {
 CODE_FILE ret_val;
 return ARR(self,ind);
}


CODE_FILE FLISTCODE_FILE_eltb_CODE(FLISTCODE_FILE_eltb_CODE_frame frame) {
 CODE_FILE dummy = ((CODE_FILE) NULL);
 BOOL L1;
 CODE_FILE L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTCODE_FILE) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTCODE_FILE_aeltb_INT_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTCODE_FILE_aeltb_INT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


ELT ELT_TBL_aeltb_ELT(ELT_TBL_aeltb_ELT_frame frame) {
 ELT dummy = ((ELT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return ELT_TBL_aget_INT_ELT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


ELT ELT_TBL_aget_INT_ELT(ELT_TBL self, INT ind) {
 ELT ret_val;
 return ARR(self,ind);
}


ELT ELT_TBL_elt_conflicting_(ELT_TBL self, ELT e) {
 ELT ret_val;
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT r;
 ELT L3;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    L21 = ELT_name_IDENT(e);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = L3;
   if (ELT_conflicts_with_ELT_B(r, e)) {
    ret_val = r;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = ((ELT) NULL);
 return ret_val;
}


ELT ELT_TBL_elt_nil_ELT(ELT_TBL self) {
 ELT ret_val;
 ELT t = ((ELT) NULL);
 ret_val = ((ELT) NULL);
 return ret_val;
}


ELT ELT_TBL_elt_same_name_as(ELT_TBL self, ELT e) {
 ELT ret_val;
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT L3;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    L21 = ELT_name_IDENT(e);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   ret_val = L3;
   return ret_val;
  }
 }
 after_loop: ;
 ret_val = ((ELT) NULL);
 return ret_val;
}


ELT ELT_TBL_elt_with_sig_SIG(ELT_TBL self, SIG s) {
 ELT ret_val;
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT r;
 ELT L3;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    L21 = ATTR(s,name1);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = L3;
   if (SIG_is_eq_SIG_BOOL(s, ATTR(r,sig11))) {
    ret_val = r;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = ((ELT) NULL);
 return ret_val;
}


ELT ELT_TBL_eltb_ELT(ELT_TBL_eltb_ELT_frame frame) {
 ELT dummy = ((ELT) NULL);
 BOOL L1;
 ELT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((ELT_TBL) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(ELT_TBL_aeltb_ELT_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = ELT_TBL_aeltb_ELT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = ELT_TBL_is_elt_nil_ELT_B(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


ELT ELT_TBL_get_queryb_IDENT(ELT_TBL_get_queryb_IDENT_frame frame) {
 ELT dummy = ((ELT) NULL);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  case 2: goto state2;
  }
 state0:;
 if ((frame->self==((ELT_TBL) NULL))) {
  frame->state = -1;
  return;
 }
 L1 = ELT_TBL_query_hash_IDENT(frame->self, frame->arg1);
 L2 = (ASIZE(frame->self));
 L3 = (INTMINUS(L2,2));
 frame->h = (L1&L3);
 while (1) {
  frame->e = ELT_TBL_aget_INT_ELT(frame->self, frame->h);
  if (ELT_TBL_is_elt_nil_ELT_B(frame->self, frame->e)) {
   goto after_loop;
  }
  else {
   if (ELT_TBL_query_test_IDENT(frame->self, frame->arg1, frame->e)) {
    frame->state = 1;
    return frame->e;
    state1:;
   }
  }
  frame->h = (INTPLUS(frame->h,1));
 }
 after_loop: ;
 L4 = (ASIZE(frame->self));
 L5 = (INTMINUS(L4,1));
 if ((frame->h==L5)) {
  frame->h = 0;
  while (1) {
   frame->e1 = ELT_TBL_aget_INT_ELT(frame->self, frame->h);
   if (ELT_TBL_is_elt_nil_ELT_B(frame->self, frame->e1)) {
    goto after_loop1;
   }
   else {
    if (ELT_TBL_query_test_IDENT(frame->self, frame->arg1, frame->e1)) {
     frame->state = 2;
     return frame->e1;
     state2:;
    }
   }
   frame->h = (INTPLUS(frame->h,1));
  }
  after_loop1: ;
 }
 frame->state = -1;
 return dummy;
}


ELT_TBL ELT_TBL_allocate_INT_ELT(ELT_TBL self, INT n) {
 ELT_TBL ret_val;
 ELT_TBL r;
 ELT_TBL L11;
 ELT_TBL L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((ELT_TBL) rt_arr_alloc(sizeof(struct ELT_TBL_struct), ELT_TBL_tag, sizeof(ELT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (ELT_TBL_elt_nil_ELT(self)==((ELT) NULL));
 if ((!(L4))) {
  {
   struct ELT_TBL_asetb_ELT_frame_struct other1_0;
   ELT_TBL_asetb_ELT_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = ELT_TBL_elt_nil_ELT(self);
    ELT_TBL_asetb_ELT(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


ELT_TBL ELT_TBL_double_size_ELT_(ELT_TBL self) {
 ELT_TBL ret_val;
 ELT_TBL r;
 ELT_TBL L11;
 INT L2;
 INT L3;
 INT L4;
 ELT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = ELT_TBL_allocate_INT_ELT(self, (INTPLUS(L4,1)));
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = ELT_TBL_insert_ELT_ELT_T(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


ELT_TBL ELT_TBL_insert_ELT_ELT_T(ELT_TBL self, ELT e) {
 ELT_TBL ret_val;
 ELT_TBL r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 ELT te;
 ELT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if (ELT_TBL_is_elt_nil_ELT_B(self, e)) {
  ret_val = r;
  return ret_val;
 }
 if ((r==((ELT_TBL) NULL))) {
  r = ELT_TBL_allocate_INT_ELT(self, 5);
 }
 else {
  if (ELT_TBL_should_grow_BOOL(self)) {
   r = ELT_TBL_double_size_ELT_(r);
  }
 }
 asz = (ASIZE(r));
 L1 = ELT_TBL_elt_hash_ELT_INT(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = ELT_TBL_aget_INT_ELT(r, h);
  if (ELT_TBL_is_elt_nil_ELT_B(self, te)) {
   goto after_loop;
  }
  else {
   if (ELT_TBL_elt_eq_ELT_ELT_B(self, te, e)) {
    ELT_TBL_aset_INT_ELT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = ELT_TBL_aget_INT_ELT(r, h);
   if (ELT_TBL_is_elt_nil_ELT_B(self, te1)) {
    goto after_loop1;
   }
   else {
    if (ELT_TBL_elt_eq_ELT_ELT_B(self, te1, e)) {
     ELT_TBL_aset_INT_ELT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ELT_TBL_aset_INT_ELT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


ERR1 ERR_plus_dSTR_ERR(ERR1 self, dSTR s) {
 ERR1 ret_val;
 FILE1 L1;
 L1 = FILE_stderr_FILE(((FILE1) NULL));
 FILE_plus_dSTR(L1, s);
 ret_val = self;
 return ret_val;
}


EXTERNAL_LAYOUT EXTERNAL_LAYOUT_create_d(EXTERNAL_LAYOUT self, dTP tp) {
 EXTERNAL_LAYOUT ret_val;
 dLAYOUT r;
 EXTERNAL_LAYOUT res = ((EXTERNAL_LAYOUT) NULL);
 BOOL L1;
 EXTERNAL_LAYOUT L2;
 r = FMAPdTPdLAYOUT_get_dTP_d(LAYOUT_TBL_layout_tbl, tp);
 L1 = (r==((dLAYOUT) NULL));
 if ((!(L1))) {
  if (r==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(r)) {
   case EXTERNAL_LAYOUT_tag:
    res = ((EXTERNAL_LAYOUT) r); break;
   default: ;
    FATAL("No applicable type in typecase");
  }
 }
 else {
  L2 = ((EXTERNAL_LAYOUT) rt_alloc(sizeof(struct EXTERNAL_LAYOUT_struct), EXTERNAL_LAYOUT_tag));
  res = L2;
  SATTR(res,tp1,tp);
  SATTR(res,str1,EXTERNAL_LAYOUT_makestr_(res));
  EXTERNAL_LAYOUT_layouts_(self, FSETEXTERNAL_LAYOUT_inse(EXTERNAL_LAYOUT_layouts, res));
  LAYOUT_TBL_layout_tbl_FM(((LAYOUT_TBL) NULL), FMAPdTPdLAYOUT_insert_dT(LAYOUT_TBL_layout_tbl, tp, ((dLAYOUT) res)));
 }
 ret_val = res;
 return ret_val;
}


FILE1 FILE_open_for_read_STR_F(FILE1 self, STR nm) {
 FILE1 ret_val;
 FILE1 r;
 FILE1 L1;
 extern STR r1;
 STR L2;
 STR L3;
 L1 = ((FILE1) rt_alloc(sizeof(struct FILE1_struct), FILE1_tag));
 r = L1;
 L2 = nm;
 L3 = ((STR) &r1);
 SATTR(r,fp,fopen(((L2==NULL)?NULL:L2->arr_part), ((L3==NULL)?NULL:L3->arr_part)));
 ret_val = r;
 return ret_val;
}


FILE1 FILE_open_for_write_STR_(FILE1 self, STR nm) {
 FILE1 ret_val;
 FILE1 r;
 FILE1 L1;
 extern STR w1;
 STR L2;
 STR L3;
 L1 = ((FILE1) rt_alloc(sizeof(struct FILE1_struct), FILE1_tag));
 r = L1;
 L2 = nm;
 L3 = ((STR) &w1);
 SATTR(r,fp,fopen(((L2==NULL)?NULL:L2->arr_part), ((L3==NULL)?NULL:L3->arr_part)));
 ret_val = r;
 return ret_val;
}


FILE1 FILE_plus_dSTR_FILE(FILE1 self, dSTR s) {
 FILE1 ret_val;
 FILE_plus_dSTR(self, s);
 ret_val = self;
 return ret_val;
}


FILE1 FILE_stdout_FILE(FILE1 self) {
 FILE1 ret_val;
 FILE1 r;
 FILE1 L1;
 L1 = ((FILE1) rt_alloc(sizeof(struct FILE1_struct), FILE1_tag));
 r = L1;
 SATTR(r,fp,(stdout));
 ret_val = r;
 return ret_val;
}


FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_10(FLISTAM_BND_CREATE_EXPR self, AM_BND_CREATE_EXPR e) {
 FLISTAM_BND_CREATE_EXPR ret_val;
 FLISTAM_BND_CREATE_EXPR r = ((FLISTAM_BND_CREATE_EXPR) NULL);
 FLISTAM_BND_CREATE_EXPR L11;
 FLISTAM_BND_CREATE_EXPR L21;
 FLISTAM_BND_CREATE_EXPR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_BND_CREATE_EXPR L7;
 INT L8;
 INT L9;
 AM_BND_CREATE_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_BND_CREATE_EXPR) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_BND_CREATE_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_BND_CREATE_EXPR_struct), FLISTAM_BND_CREATE_EXPR_tag, sizeof(AM_BND_CREATE_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_BND_CREATE_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_BND_CREATE_EXPR_struct), FLISTAM_BND_CREATE_EXPR_tag, sizeof(AM_BND_CREATE_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
    FLISTAM_BND_CREATE_EXPR_4_frame 
    noname1 = &other1_0;
    struct FLISTAM_BND_CREATE_EXPR_9_frame_struct other1_1;
    FLISTAM_BND_CREATE_EXPR_9_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_BND_CREATE_EXPR_4(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_BND_CREATE_EXPR_9(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_BND_CREATE_EXPR_8(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_14(FLISTAM_BND_CREATE_EXPR self) {
 FLISTAM_BND_CREATE_EXPR ret_val;
 FLISTAM_BND_CREATE_EXPR r;
 FLISTAM_BND_CREATE_EXPR L11;
 FLISTAM_BND_CREATE_EXPR L2;
 INT L3;
 AM_BND_CREATE_EXPR L4;
 if ((self==((FLISTAM_BND_CREATE_EXPR) NULL))) {
  ret_val = ((FLISTAM_BND_CREATE_EXPR) NULL);
  return ret_val;
 }
 L3 = (ASIZE(self));
 L2 = ((FLISTAM_BND_CREATE_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_BND_CREATE_EXPR_struct), FLISTAM_BND_CREATE_EXPR_tag, sizeof(AM_BND_CREATE_EXPR) , L3));
 L2->asize = L3;
 r = L2;
 {
  struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
  FLISTAM_BND_CREATE_EXPR_4_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTAM_BND_CREATE_EXPR_4(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FLISTAM_BND_CREATE_EXPR_10(r, L4);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_17(FLISTAM_BND_CREATE_EXPR self, AM_BND_CREATE_EXPR e) {
 FLISTAM_BND_CREATE_EXPR ret_val;
 if (FLISTAM_BND_CREATE_EXPR_16(self, e)) {
  ret_val = self;
  return ret_val;
 }
 else {
  ret_val = FLISTAM_BND_CREATE_EXPR_10(self, e);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_18(FLISTAM_BND_CREATE_EXPR self, FLISTAM_BND_CREATE_EXPR l) {
 FLISTAM_BND_CREATE_EXPR ret_val;
 FLISTAM_BND_CREATE_EXPR r;
 FLISTAM_BND_CREATE_EXPR L11;
 AM_BND_CREATE_EXPR L2;
 r = FLISTAM_BND_CREATE_EXPR_14(self);
 {
  struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
  FLISTAM_BND_CREATE_EXPR_4_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = l;
    noname1->self = L11;
   }
   L2 = FLISTAM_BND_CREATE_EXPR_4(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FLISTAM_BND_CREATE_EXPR_17(r, L2);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


FLISTAM_BND_CREATE_EXPR FLISTAM_BND_CREATE_EXPR_6(FLISTAM_BND_CREATE_EXPR self) {
 FLISTAM_BND_CREATE_EXPR ret_val;
 ret_val = ((FLISTAM_BND_CREATE_EXPR) NULL);
 return ret_val;
}


FLISTAM_BND_ITER_CALL_EX FLISTAM_BND_ITER_CALL_EX10(FLISTAM_BND_ITER_CALL_EX self, AM_BND_ITER_CALL_EXPR e) {
 FLISTAM_BND_ITER_CALL_EX ret_val;
 FLISTAM_BND_ITER_CALL_EX r = ((FLISTAM_BND_ITER_CALL_EX) NULL);
 FLISTAM_BND_ITER_CALL_EX L11;
 FLISTAM_BND_ITER_CALL_EX L21;
 FLISTAM_BND_ITER_CALL_EX L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_BND_ITER_CALL_EX L7;
 INT L8;
 INT L9;
 AM_BND_ITER_CALL_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_BND_ITER_CALL_EX) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_BND_ITER_CALL_EX) rt_arr_alloc(sizeof(struct FLISTAM_BND_ITER_CALL_EX_struct), FLISTAM_BND_ITER_CALL_EX_tag, sizeof(AM_BND_ITER_CALL_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_BND_ITER_CALL_EX) rt_arr_alloc(sizeof(struct FLISTAM_BND_ITER_CALL_EX_struct), FLISTAM_BND_ITER_CALL_EX_tag, sizeof(AM_BND_ITER_CALL_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_BND_ITER_CALL_EX5_frame_struct other1_0;
    FLISTAM_BND_ITER_CALL_EX5_frame 
    noname1 = &other1_0;
    struct FLISTAM_BND_ITER_CALL_EX9_frame_struct other1_1;
    FLISTAM_BND_ITER_CALL_EX9_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_BND_ITER_CALL_EX5(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_BND_ITER_CALL_EX9(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_BND_ITER_CALL_EX8(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAM_BND_ITER_CALL_EX FLISTAM_BND_ITER_CALL_EX11(FLISTAM_BND_ITER_CALL_EX self, FLISTAM_BND_ITER_CALL_EX l) {
 FLISTAM_BND_ITER_CALL_EX ret_val;
 FLISTAM_BND_ITER_CALL_EX res;
 FLISTAM_BND_ITER_CALL_EX L11;
 BOOL L2;
 AM_BND_ITER_CALL_EXPR L3;
 res = self;
 L2 = (l==((FLISTAM_BND_ITER_CALL_EX) NULL));
 if ((!(L2))) {
  {
   struct FLISTAM_BND_ITER_CALL_EX5_frame_struct other1_0;
   FLISTAM_BND_ITER_CALL_EX5_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = l;
     noname1->self = L11;
    }
    L3 = FLISTAM_BND_ITER_CALL_EX5(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    res = FLISTAM_BND_ITER_CALL_EX10(res, L3);
   }
  }
  after_loop: ;
 }
 ret_val = res;
 return ret_val;
}


FLISTAM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_push(FLISTAM_GLOBAL_EXPR self, AM_GLOBAL_EXPR e) {
 FLISTAM_GLOBAL_EXPR ret_val;
 FLISTAM_GLOBAL_EXPR r = ((FLISTAM_GLOBAL_EXPR) NULL);
 FLISTAM_GLOBAL_EXPR L11;
 FLISTAM_GLOBAL_EXPR L21;
 FLISTAM_GLOBAL_EXPR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_GLOBAL_EXPR L7;
 INT L8;
 INT L9;
 AM_GLOBAL_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_GLOBAL_EXPR) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_GLOBAL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_GLOBAL_EXPR_struct), FLISTAM_GLOBAL_EXPR_tag, sizeof(AM_GLOBAL_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_GLOBAL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_GLOBAL_EXPR_struct), FLISTAM_GLOBAL_EXPR_tag, sizeof(AM_GLOBAL_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_GLOBAL_EXPR_eltb_frame_struct other1_0;
    FLISTAM_GLOBAL_EXPR_eltb_frame 
    noname1 = &other1_0;
    struct FLISTAM_GLOBAL_EXPR_aset1_frame_struct other1_1;
    FLISTAM_GLOBAL_EXPR_aset1_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_GLOBAL_EXPR_eltb(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_GLOBAL_EXPR_aset1(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_GLOBAL_EXPR_aset(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_c(FLISTAM_ITER_CALL_EXPR self, INT n) {
 FLISTAM_ITER_CALL_EXPR ret_val;
 FLISTAM_ITER_CALL_EXPR L1;
 INT L2;
 if ((n==0)) {
  ret_val = ((FLISTAM_ITER_CALL_EXPR) NULL);
  return ret_val;
 }
 else {
  L2 = n;
  L1 = ((FLISTAM_ITER_CALL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_ITER_CALL_EXPR_struct), FLISTAM_ITER_CALL_EXPR_tag, sizeof(AM_ITER_CALL_EXPR) , L2));
  L1->asize = L2;
  ret_val = L1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_c2(FLISTAM_ITER_CALL_EXPR self, FLISTAM_ITER_CALL_EXPR l) {
 FLISTAM_ITER_CALL_EXPR ret_val;
 FLISTAM_ITER_CALL_EXPR res;
 FLISTAM_ITER_CALL_EXPR L11;
 BOOL L2;
 AM_ITER_CALL_EXPR L3;
 res = self;
 L2 = (l==((FLISTAM_ITER_CALL_EXPR) NULL));
 if ((!(L2))) {
  {
   struct FLISTAM_ITER_CALL_EXPR_e_frame_struct other1_0;
   FLISTAM_ITER_CALL_EXPR_e_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = l;
     noname1->self = L11;
    }
    L3 = FLISTAM_ITER_CALL_EXPR_e(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    res = FLISTAM_ITER_CALL_EXPR_p(res, L3);
   }
  }
  after_loop: ;
 }
 ret_val = res;
 return ret_val;
}


FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_p(FLISTAM_ITER_CALL_EXPR self, AM_ITER_CALL_EXPR e) {
 FLISTAM_ITER_CALL_EXPR ret_val;
 FLISTAM_ITER_CALL_EXPR r = ((FLISTAM_ITER_CALL_EXPR) NULL);
 FLISTAM_ITER_CALL_EXPR L11;
 FLISTAM_ITER_CALL_EXPR L21;
 FLISTAM_ITER_CALL_EXPR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_ITER_CALL_EXPR L7;
 INT L8;
 INT L9;
 AM_ITER_CALL_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_ITER_CALL_EXPR) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_ITER_CALL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_ITER_CALL_EXPR_struct), FLISTAM_ITER_CALL_EXPR_tag, sizeof(AM_ITER_CALL_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_ITER_CALL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_ITER_CALL_EXPR_struct), FLISTAM_ITER_CALL_EXPR_tag, sizeof(AM_ITER_CALL_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_ITER_CALL_EXPR_e_frame_struct other1_0;
    FLISTAM_ITER_CALL_EXPR_e_frame 
    noname1 = &other1_0;
    struct FLISTAM_ITER_CALL_EXPR_a6_frame_struct other1_1;
    FLISTAM_ITER_CALL_EXPR_a6_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_ITER_CALL_EXPR_e(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_ITER_CALL_EXPR_a6(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_ITER_CALL_EXPR_a5(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_conca(FLISTAM_LOCAL_EXPR self, FLISTAM_LOCAL_EXPR l) {
 FLISTAM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR res;
 FLISTAM_LOCAL_EXPR L11;
 BOOL L2;
 AM_LOCAL_EXPR L3;
 res = self;
 L2 = (l==((FLISTAM_LOCAL_EXPR) NULL));
 if ((!(L2))) {
  {
   struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other1_0;
   FLISTAM_LOCAL_EXPR_eltb__frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = l;
     noname1->self = L11;
    }
    L3 = FLISTAM_LOCAL_EXPR_eltb_(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    res = FLISTAM_LOCAL_EXPR_push_(res, L3);
   }
  }
  after_loop: ;
 }
 ret_val = res;
 return ret_val;
}


FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_creat(FLISTAM_LOCAL_EXPR self, INT n) {
 FLISTAM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L1;
 INT L2;
 if ((n==0)) {
  ret_val = ((FLISTAM_LOCAL_EXPR) NULL);
  return ret_val;
 }
 else {
  L2 = n;
  L1 = ((FLISTAM_LOCAL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_LOCAL_EXPR_struct), FLISTAM_LOCAL_EXPR_tag, sizeof(AM_LOCAL_EXPR) , L2));
  L1->asize = L2;
  ret_val = L1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR self, AM_LOCAL_EXPR e) {
 FLISTAM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR r = ((FLISTAM_LOCAL_EXPR) NULL);
 FLISTAM_LOCAL_EXPR L11;
 FLISTAM_LOCAL_EXPR L21;
 FLISTAM_LOCAL_EXPR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_LOCAL_EXPR L7;
 INT L8;
 INT L9;
 AM_LOCAL_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_LOCAL_EXPR) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_LOCAL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_LOCAL_EXPR_struct), FLISTAM_LOCAL_EXPR_tag, sizeof(AM_LOCAL_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_LOCAL_EXPR) rt_arr_alloc(sizeof(struct FLISTAM_LOCAL_EXPR_struct), FLISTAM_LOCAL_EXPR_tag, sizeof(AM_LOCAL_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other1_0;
    FLISTAM_LOCAL_EXPR_eltb__frame 
    noname1 = &other1_0;
    struct FLISTAM_LOCAL_EXPR_asetb_frame_struct other1_1;
    FLISTAM_LOCAL_EXPR_asetb_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_LOCAL_EXPR_eltb_(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_LOCAL_EXPR_asetb(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_LOCAL_EXPR_aset_(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAM_ROUT_DEF FLISTAM_ROUT_DEF_create_(FLISTAM_ROUT_DEF self) {
 FLISTAM_ROUT_DEF ret_val;
 ret_val = ((FLISTAM_ROUT_DEF) NULL);
 return ret_val;
}


FLISTAM_ROUT_DEF FLISTAM_ROUT_DEF_push_AM(FLISTAM_ROUT_DEF self, AM_ROUT_DEF e) {
 FLISTAM_ROUT_DEF ret_val;
 FLISTAM_ROUT_DEF r = ((FLISTAM_ROUT_DEF) NULL);
 FLISTAM_ROUT_DEF L11;
 FLISTAM_ROUT_DEF L21;
 FLISTAM_ROUT_DEF L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAM_ROUT_DEF L7;
 INT L8;
 INT L9;
 AM_ROUT_DEF L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAM_ROUT_DEF) NULL))) {
  L4 = 5;
  L3 = ((FLISTAM_ROUT_DEF) rt_arr_alloc(sizeof(struct FLISTAM_ROUT_DEF_struct), FLISTAM_ROUT_DEF_tag, sizeof(AM_ROUT_DEF) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAM_ROUT_DEF) rt_arr_alloc(sizeof(struct FLISTAM_ROUT_DEF_struct), FLISTAM_ROUT_DEF_tag, sizeof(AM_ROUT_DEF) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAM_ROUT_DEF_eltb_AM_frame_struct other1_0;
    FLISTAM_ROUT_DEF_eltb_AM_frame 
    noname1 = &other1_0;
    struct FLISTAM_ROUT_DEF_asetb_A_frame_struct other1_1;
    FLISTAM_ROUT_DEF_asetb_A_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAM_ROUT_DEF_eltb_AM(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAM_ROUT_DEF_asetb_A(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAM_ROUT_DEF_aset_IN(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTAS_CLASS_DEF FLISTAS_CLASS_DEF_create(FLISTAS_CLASS_DEF self) {
 FLISTAS_CLASS_DEF ret_val;
 ret_val = ((FLISTAS_CLASS_DEF) NULL);
 return ret_val;
}


FLISTAS_CLASS_DEF FLISTAS_CLASS_DEF_push_A(FLISTAS_CLASS_DEF self, AS_CLASS_DEF e) {
 FLISTAS_CLASS_DEF ret_val;
 FLISTAS_CLASS_DEF r = ((FLISTAS_CLASS_DEF) NULL);
 FLISTAS_CLASS_DEF L11;
 FLISTAS_CLASS_DEF L21;
 FLISTAS_CLASS_DEF L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTAS_CLASS_DEF L7;
 INT L8;
 INT L9;
 AS_CLASS_DEF L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTAS_CLASS_DEF) NULL))) {
  L4 = 5;
  L3 = ((FLISTAS_CLASS_DEF) rt_arr_alloc(sizeof(struct FLISTAS_CLASS_DEF_struct), FLISTAS_CLASS_DEF_tag, sizeof(AS_CLASS_DEF) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTAS_CLASS_DEF) rt_arr_alloc(sizeof(struct FLISTAS_CLASS_DEF_struct), FLISTAS_CLASS_DEF_tag, sizeof(AS_CLASS_DEF) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTAS_CLASS_DEF_eltb_A_frame_struct other1_0;
    FLISTAS_CLASS_DEF_eltb_A_frame 
    noname1 = &other1_0;
    struct FLISTAS_CLASS_DEF_asetb__frame_struct other1_1;
    FLISTAS_CLASS_DEF_asetb__frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTAS_CLASS_DEF_eltb_A(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTAS_CLASS_DEF_asetb_(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTAS_CLASS_DEF_aset_I(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTCODE_FILE FLISTCODE_FILE_create_FL(FLISTCODE_FILE self) {
 FLISTCODE_FILE ret_val;
 ret_val = ((FLISTCODE_FILE) NULL);
 return ret_val;
}


FLISTCODE_FILE FLISTCODE_FILE_push_CODE(FLISTCODE_FILE self, CODE_FILE e) {
 FLISTCODE_FILE ret_val;
 FLISTCODE_FILE r = ((FLISTCODE_FILE) NULL);
 FLISTCODE_FILE L11;
 FLISTCODE_FILE L21;
 FLISTCODE_FILE L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTCODE_FILE L7;
 INT L8;
 INT L9;
 CODE_FILE L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTCODE_FILE) NULL))) {
  L4 = 5;
  L3 = ((FLISTCODE_FILE) rt_arr_alloc(sizeof(struct FLISTCODE_FILE_struct), FLISTCODE_FILE_tag, sizeof(CODE_FILE) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTCODE_FILE) rt_arr_alloc(sizeof(struct FLISTCODE_FILE_struct), FLISTCODE_FILE_tag, sizeof(CODE_FILE) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTCODE_FILE_eltb_CODE_frame_struct other1_0;
    FLISTCODE_FILE_eltb_CODE_frame 
    noname1 = &other1_0;
    struct FLISTCODE_FILE_asetb_COD_frame_struct other1_1;
    FLISTCODE_FILE_asetb_COD_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTCODE_FILE_eltb_CODE(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTCODE_FILE_asetb_COD(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTCODE_FILE_aset_INT_(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTFLISTdAM_CONST FLISTFLISTdAM_CONST_push(FLISTFLISTdAM_CONST self, FLISTdAM_CONST e) {
 FLISTFLISTdAM_CONST ret_val;
 FLISTFLISTdAM_CONST r = ((FLISTFLISTdAM_CONST) NULL);
 FLISTFLISTdAM_CONST L11;
 FLISTFLISTdAM_CONST L21;
 FLISTFLISTdAM_CONST L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTFLISTdAM_CONST L7;
 INT L8;
 INT L9;
 FLISTdAM_CONST L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTFLISTdAM_CONST) NULL))) {
  L4 = 5;
  L3 = ((FLISTFLISTdAM_CONST) rt_arr_alloc(sizeof(struct FLISTFLISTdAM_CONST_struct), FLISTFLISTdAM_CONST_tag, sizeof(FLISTdAM_CONST) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTFLISTdAM_CONST) rt_arr_alloc(sizeof(struct FLISTFLISTdAM_CONST_struct), FLISTFLISTdAM_CONST_tag, sizeof(FLISTdAM_CONST) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTFLISTdAM_CONST_eltb_frame_struct other1_0;
    FLISTFLISTdAM_CONST_eltb_frame 
    noname1 = &other1_0;
    struct FLISTFLISTdAM_CONST_aset1_frame_struct other1_1;
    FLISTFLISTdAM_CONST_aset1_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTFLISTdAM_CONST_eltb(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTFLISTdAM_CONST_aset1(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTFLISTdAM_CONST_aset(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTFSTR FLISTFSTR_concat_FLISTFS(FLISTFSTR self, FLISTFSTR l) {
 FLISTFSTR ret_val;
 FLISTFSTR res;
 FLISTFSTR L11;
 BOOL L2;
 FSTR L3;
 res = self;
 L2 = (l==((FLISTFSTR) NULL));
 if ((!(L2))) {
  {
   struct FLISTFSTR_eltb_FSTR_frame_struct other1_0;
   FLISTFSTR_eltb_FSTR_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = l;
     noname1->self = L11;
    }
    L3 = FLISTFSTR_eltb_FSTR(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    res = FLISTFSTR_push_FSTR_FLIS(res, L3);
   }
  }
  after_loop: ;
 }
 ret_val = res;
 return ret_val;
}


FLISTFSTR FLISTFSTR_create_FLISTFS(FLISTFSTR self) {
 FLISTFSTR ret_val;
 ret_val = ((FLISTFSTR) NULL);
 return ret_val;
}


FLISTFSTR FLISTFSTR_push_FSTR_FLIS(FLISTFSTR self, FSTR e) {
 FLISTFSTR ret_val;
 FLISTFSTR r = ((FLISTFSTR) NULL);
 FLISTFSTR L11;
 FLISTFSTR L21;
 FLISTFSTR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTFSTR L7;
 INT L8;
 INT L9;
 FSTR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTFSTR) NULL))) {
  L4 = 5;
  L3 = ((FLISTFSTR) rt_arr_alloc(sizeof(struct FLISTFSTR_struct), FLISTFSTR_tag, sizeof(FSTR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTFSTR) rt_arr_alloc(sizeof(struct FLISTFSTR_struct), FLISTFSTR_tag, sizeof(FSTR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTFSTR_eltb_FSTR_frame_struct other1_0;
    FLISTFSTR_eltb_FSTR_frame 
    noname1 = &other1_0;
    struct FLISTFSTR_asetb_FSTR_frame_struct other1_1;
    FLISTFSTR_asetb_FSTR_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTFSTR_eltb_FSTR(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTFSTR_asetb_FSTR(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTFSTR_aset_INT_FSTR(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTIDENT FLISTIDENT_create_FLISTI(FLISTIDENT self) {
 FLISTIDENT ret_val;
 ret_val = ((FLISTIDENT) NULL);
 return ret_val;
}


FLISTIDENT FLISTIDENT_push_IDENT_FL(FLISTIDENT self, IDENT e) {
 FLISTIDENT ret_val;
 FLISTIDENT r = ((FLISTIDENT) NULL);
 FLISTIDENT L11;
 FLISTIDENT L21;
 FLISTIDENT L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTIDENT L7;
 INT L8;
 INT L9;
 IDENT L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTIDENT) NULL))) {
  L4 = 5;
  L3 = ((FLISTIDENT) rt_arr_alloc(sizeof(struct FLISTIDENT_struct), FLISTIDENT_tag, sizeof(IDENT) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTIDENT) rt_arr_alloc(sizeof(struct FLISTIDENT_struct), FLISTIDENT_tag, sizeof(IDENT) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTIDENT_eltb_IDENT_frame_struct other1_0;
    FLISTIDENT_eltb_IDENT_frame 
    noname1 = &other1_0;
    struct FLISTIDENT_asetb_IDENT_frame_struct other1_1;
    FLISTIDENT_asetb_IDENT_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTIDENT_eltb_IDENT(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTIDENT_asetb_IDENT(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTIDENT_aset_INT_IDEN(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTIFC FLISTIFC_push_IFC_FLISTI(FLISTIFC self, IFC e) {
 FLISTIFC ret_val;
 FLISTIFC r = ((FLISTIFC) NULL);
 FLISTIFC L11;
 FLISTIFC L21;
 FLISTIFC L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTIFC L7;
 INT L8;
 INT L9;
 IFC L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTIFC) NULL))) {
  L4 = 5;
  L3 = ((FLISTIFC) rt_arr_alloc(sizeof(struct FLISTIFC_struct), FLISTIFC_tag, sizeof(IFC) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTIFC) rt_arr_alloc(sizeof(struct FLISTIFC_struct), FLISTIFC_tag, sizeof(IFC) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTIFC_eltb_IFC_frame_struct other1_0;
    FLISTIFC_eltb_IFC_frame 
    noname1 = &other1_0;
    struct FLISTIFC_asetb_IFC_frame_struct other1_1;
    FLISTIFC_asetb_IFC_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTIFC_eltb_IFC(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTIFC_asetb_IFC(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTIFC_aset_INT_IFC(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTIMPL_INCLUDE FLISTIMPL_INCLUDE_push_I(FLISTIMPL_INCLUDE self, IMPL_INCLUDE e) {
 FLISTIMPL_INCLUDE ret_val;
 FLISTIMPL_INCLUDE r = ((FLISTIMPL_INCLUDE) NULL);
 FLISTIMPL_INCLUDE L11;
 FLISTIMPL_INCLUDE L21;
 FLISTIMPL_INCLUDE L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTIMPL_INCLUDE L7;
 INT L8;
 INT L9;
 IMPL_INCLUDE L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTIMPL_INCLUDE) NULL))) {
  L4 = 5;
  L3 = ((FLISTIMPL_INCLUDE) rt_arr_alloc(sizeof(struct FLISTIMPL_INCLUDE_struct), FLISTIMPL_INCLUDE_tag, sizeof(IMPL_INCLUDE) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTIMPL_INCLUDE) rt_arr_alloc(sizeof(struct FLISTIMPL_INCLUDE_struct), FLISTIMPL_INCLUDE_tag, sizeof(IMPL_INCLUDE) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTIMPL_INCLUDE_eltb_I_frame_struct other1_0;
    FLISTIMPL_INCLUDE_eltb_I_frame 
    noname1 = &other1_0;
    struct FLISTIMPL_INCLUDE_asetb__frame_struct other1_1;
    FLISTIMPL_INCLUDE_asetb__frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTIMPL_INCLUDE_eltb_I(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTIMPL_INCLUDE_asetb_(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTIMPL_INCLUDE_aset_I(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTINT FLISTINT_create_INT_FLIS(FLISTINT self, INT n) {
 FLISTINT ret_val;
 FLISTINT L1;
 INT L2;
 if ((n==0)) {
  ret_val = ((FLISTINT) NULL);
  return ret_val;
 }
 else {
  L2 = n;
  L1 = ((FLISTINT) rt_arr_alloc_atomic(sizeof(struct FLISTINT_struct), FLISTINT_tag, sizeof(INT) , L2));
  L1->asize = L2;
  ret_val = L1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTINT FLISTINT_push_INT_FLISTI(FLISTINT self, INT e) {
 FLISTINT ret_val;
 FLISTINT r = ((FLISTINT) NULL);
 FLISTINT L11;
 FLISTINT L21;
 FLISTINT L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTINT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTINT) NULL))) {
  L4 = 5;
  L3 = ((FLISTINT) rt_arr_alloc_atomic(sizeof(struct FLISTINT_struct), FLISTINT_tag, sizeof(INT) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTINT) rt_arr_alloc_atomic(sizeof(struct FLISTINT_struct), FLISTINT_tag, sizeof(INT) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTINT_eltb_INT_frame_struct other1_0;
    FLISTINT_eltb_INT_frame 
    noname1 = &other1_0;
    struct FLISTINT_asetb_INT_frame_struct other1_1;
    FLISTINT_asetb_INT_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTINT_eltb_INT(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTINT_asetb_INT(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTINT_aset_INT_INT(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdAM_CONST FLISTFLISTdAM_CONST_aelt(FLISTFLISTdAM_CONST_aelt_frame frame) {
 FLISTdAM_CONST dummy = ((FLISTdAM_CONST) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTFLISTdAM_CONST_aget(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


FLISTdAM_CONST FLISTFLISTdAM_CONST_aget(FLISTFLISTdAM_CONST self, INT ind) {
 FLISTdAM_CONST ret_val;
 ret_val = FLISTFLISTdAM_CONST_aref(self, ind);
 return ret_val;
}


FLISTdAM_CONST FLISTFLISTdAM_CONST_aref(FLISTFLISTdAM_CONST self, INT ind) {
 FLISTdAM_CONST ret_val;
 return ARR(self,ind);
}


FLISTdAM_CONST FLISTFLISTdAM_CONST_eltb(FLISTFLISTdAM_CONST_eltb_frame frame) {
 FLISTdAM_CONST dummy = ((FLISTdAM_CONST) NULL);
 BOOL L1;
 FLISTdAM_CONST L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTFLISTdAM_CONST) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTFLISTdAM_CONST_aelt_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTFLISTdAM_CONST_aelt(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


FLISTdAM_CONST FLISTFLISTdAM_CONST_pop_(FLISTFLISTdAM_CONST self) {
 FLISTdAM_CONST ret_val;
 FLISTdAM_CONST r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTFLISTdAM_CONST_size(self);
 if ((L1==0)) {
  ret_val = ((FLISTdAM_CONST) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTFLISTdAM_CONST_aget(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTFLISTdAM_CONST_aset(self, L4, ((FLISTdAM_CONST) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FLISTdLAYOUT EXTERNAL_LAYOUT_dependen(EXTERNAL_LAYOUT self) {
 FLISTdLAYOUT ret_val;
 ret_val = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 return ret_val;
}


FSTR FILE_fstr_FSTR(FILE1 self) {
 FSTR ret_val;
 INT fsize = ((INT) 0);
 FSTR r;
 INT bsize = ((INT) 0);
 FSTR L1;
 fsize = FILE_size_INT(self);
 if ((fsize<=0)) {
  ret_val = ((FSTR) NULL);
  return ret_val;
 }
 r = FSTR_create_INT_FSTR(((FSTR) NULL), fsize);
 FILE_seek_from_front_INT(self, 0);
 L1 = r;
 bsize = fread(((L1==NULL)?NULL:L1->arr_part), 1, fsize, ATTR(self,fp));
 SATTR(r,loc,bsize);
 ret_val = r;
 return ret_val;
}


FSTR FILE_get_line_FSTR(FILE1 self) {
 FSTR ret_val;
 FSTR res;
 CHAR c = ((CHAR) 0);
 res = FSTR_create_FSTR(((FSTR) NULL));
 while (1) {
  c = FILE_get_char_CHAR(self);
  if (FILE_eof_BOOL(self)) {
   ret_val = res;
   return ret_val;
  }
  res = FSTR_push_CHAR_FSTR(res, c);
  if ((c=='\n')) {
   goto after_loop;
  }
 }
 after_loop: ;
 ret_val = res;
 return ret_val;
}


FSTR FLISTFSTR_aeltb_INT_INT_(FLISTFSTR_aeltb_INT_INT__frame frame) {
 FSTR dummy = ((FSTR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTFSTR_aget_INT_FSTR(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


FSTR FLISTFSTR_aget_INT_FSTR(FLISTFSTR self, INT ind) {
 FSTR ret_val;
 ret_val = FLISTFSTR_aref_aget_INT_(self, ind);
 return ret_val;
}


FSTR FLISTFSTR_aref_aget_INT_(FLISTFSTR self, INT ind) {
 FSTR ret_val;
 return ARR(self,ind);
}


FSTR FLISTFSTR_eltb_FSTR(FLISTFSTR_eltb_FSTR_frame frame) {
 FSTR dummy = ((FSTR) NULL);
 BOOL L1;
 FSTR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTFSTR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTFSTR_aeltb_INT_INT__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTFSTR_aeltb_INT_INT_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IDENT ELT_name_IDENT(ELT self) {
 IDENT ret_val = IDENT_zero;
 ret_val = ATTR(ATTR(self,sig11),name1);
 return ret_val;
}


IDENT FLISTIDENT_aeltb_INT_INT(FLISTIDENT_aeltb_INT_INT_frame frame) {
 IDENT dummy = IDENT_zero;
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTIDENT_aget_INT_IDEN(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


IDENT FLISTIDENT_aget_INT_IDEN(FLISTIDENT self, INT ind) {
 IDENT ret_val = IDENT_zero;
 ret_val = FLISTIDENT_aref_aget_INT(self, ind);
 return ret_val;
}


IDENT FLISTIDENT_aref_aget_INT(FLISTIDENT self, INT ind) {
 IDENT ret_val = IDENT_zero;
 return ARR(self,ind);
}


IDENT FLISTIDENT_eltb_IDENT(FLISTIDENT_eltb_IDENT_frame frame) {
 IDENT dummy = IDENT_zero;
 BOOL L1;
 IDENT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTIDENT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTIDENT_aeltb_INT_INT_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTIDENT_aeltb_INT_INT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IFC ELT_TBL_public_ifc_IFC(ELT_TBL self) {
 IFC ret_val;
 SIG_TBL st = ((SIG_TBL) NULL);
 ELT e = ((ELT) NULL);
 ELT_TBL L11;
 BOOL L2;
 INT L3;
 ELT L4;
 BOOL L5;
 if ((self==((ELT_TBL) NULL))) {
  L2 = TRUE;
 } else {
  L3 = ATTR(self,hsize);
  L2 = (L3==0);
 }
 if (L2) {
  ret_val = ((IFC) NULL);
  return ret_val;
 }
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   L5 = ATTR(e,is_private1);
   if ((!(L5))) {
    st = SIG_TBL_insert_SIG_SIG_T(st, ATTR(e,sig11));
   }
  }
 }
 after_loop: ;
 ret_val = IFC_create_SIG_TBL_dTP_I(((IFC) NULL), st, ATTR(ATTR(e,sig11),tp));
 return ret_val;
}


IFC FLISTIFC_aeltb_INT_INT_I(FLISTIFC_aeltb_INT_INT_I_frame frame) {
 IFC dummy = ((IFC) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTIFC_aget_INT_IFC(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


IFC FLISTIFC_aget_INT_IFC(FLISTIFC self, INT ind) {
 IFC ret_val;
 ret_val = FLISTIFC_aref_aget_INT_I(self, ind);
 return ret_val;
}


IFC FLISTIFC_aref_aget_INT_I(FLISTIFC self, INT ind) {
 IFC ret_val;
 return ARR(self,ind);
}


IFC FLISTIFC_eltb_IFC(FLISTIFC_eltb_IFC_frame frame) {
 IFC dummy = ((IFC) NULL);
 BOOL L1;
 IFC L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTIFC) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTIFC_aeltb_INT_INT_I_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTIFC_aeltb_INT_INT_I(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IFC FLISTIFC_pop_IFC(FLISTIFC self) {
 IFC ret_val;
 IFC r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTIFC_size_INT(self);
 if ((L1==0)) {
  ret_val = ((IFC) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTIFC_aget_INT_IFC(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTIFC_aset_INT_IFC(self, L4, ((IFC) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


IMPL ELT_impl_IMPL(ELT self) {
 IMPL ret_val;
 IMPL r;
 IMPL_TBL L1;
 OUT L2;
 extern STR CompilererrorELTimplwith;
 OUT L3;
 OUT L4;
 extern STR returnsvoid;
 L1 = ATTR(ELT_prog_PROG(self),impl_tbl);
 r = IMPL_TBL_impl_of_dTP_IMP(L1, ELT_tp_dTP(self));
 if ((r==((IMPL) NULL))) {
  L2 = OUT_create_OUT(((OUT) NULL));
  L3 = OUT_plus_dSTR_OUT(L2, ((dSTR) ((STR) &CompilererrorELTimplwith)));
  L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) ATTR(ATTR(self,sig11),str)));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &returnsvoid)));
  ret_val = ((IMPL) NULL);
  return ret_val;
 }
 ret_val = r;
 return ret_val;
}


IMPL_INCLUDE FLISTIMPL_INCLUDE_aeltb_(FLISTIMPL_INCLUDE_aeltb__frame frame) {
 IMPL_INCLUDE dummy = ((IMPL_INCLUDE) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTIMPL_INCLUDE_aget_I(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


IMPL_INCLUDE FLISTIMPL_INCLUDE_aget_I(FLISTIMPL_INCLUDE self, INT ind) {
 IMPL_INCLUDE ret_val;
 ret_val = FLISTIMPL_INCLUDE_aref_a(self, ind);
 return ret_val;
}


IMPL_INCLUDE FLISTIMPL_INCLUDE_aref_a(FLISTIMPL_INCLUDE self, INT ind) {
 IMPL_INCLUDE ret_val;
 return ARR(self,ind);
}


IMPL_INCLUDE FLISTIMPL_INCLUDE_eltb_I(FLISTIMPL_INCLUDE_eltb_I_frame frame) {
 IMPL_INCLUDE dummy = ((IMPL_INCLUDE) NULL);
 BOOL L1;
 IMPL_INCLUDE L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTIMPL_INCLUDE) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTIMPL_INCLUDE_aeltb__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTIMPL_INCLUDE_aeltb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IMPL_INCLUDE FLISTIMPL_INCLUDE_pop_IM(FLISTIMPL_INCLUDE self) {
 IMPL_INCLUDE ret_val;
 IMPL_INCLUDE r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTIMPL_INCLUDE_size_I(self);
 if ((L1==0)) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTIMPL_INCLUDE_aget_I(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTIMPL_INCLUDE_aset_I(self, L4, ((IMPL_INCLUDE) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


INT ELT_TBL_asize_INT(ELT_TBL self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT ELT_TBL_elt_hash_ELT_INT(ELT_TBL self, ELT e) {
 INT ret_val = ((INT) 0);
 ret_val = IDENT_hash_INT(ATTR(ATTR(e,sig11),name1));
 return ret_val;
}


INT FILE_current_loc_INT(FILE1 self) {
 INT ret_val = ((INT) 0);
 ret_val = ftell(ATTR(self,fp));
 return ret_val;
}


INT FILE_size_INT(FILE1 self) {
 INT ret_val = ((INT) 0);
 INT current1 = ((INT) 0);
 INT r = ((INT) 0);
 current1 = FILE_current_loc_INT(self);
 FILE_seek_from_end_INT(self, 0);
 r = FILE_current_loc_INT(self);
 FILE_seek_from_front_INT(self, current1);
 ret_val = r;
 return ret_val;
}


INT FLISTAM_BND_CREATE_EXPR_11(FLISTAM_BND_CREATE_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTAM_BND_CREATE_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTAM_ITER_CALL_EXPR_s1(FLISTAM_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTAM_ITER_CALL_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTAM_LOCAL_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTCODE_FILE_size_INT(FLISTCODE_FILE self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTCODE_FILE) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTFLISTdAM_CONST_size(FLISTFLISTdAM_CONST self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTFLISTdAM_CONST) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTFSTR_size_INT(FLISTFSTR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTFSTR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTIDENT_size_INT(FLISTIDENT self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTIDENT) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTIFC_size_INT(FLISTIFC self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTIFC) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTIMPL_INCLUDE_size_I(FLISTIMPL_INCLUDE self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTIMPL_INCLUDE) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTINT_aeltb_INT_INT_I(FLISTINT_aeltb_INT_INT_I_frame frame) {
 INT dummy = ((INT) 0);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTINT_aget_INT_INT(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


INT FLISTINT_aget_INT_INT(FLISTINT self, INT ind) {
 INT ret_val = ((INT) 0);
 ret_val = FLISTINT_aref_aget_INT_I(self, ind);
 return ret_val;
}


INT FLISTINT_aref_aget_INT_I(FLISTINT self, INT ind) {
 INT ret_val = ((INT) 0);
 return ARR(self,ind);
}


INT FLISTINT_eltb_INT(FLISTINT_eltb_INT_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTINT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTINT_aeltb_INT_INT_I_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTINT_aeltb_INT_INT_I(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT FLISTINT_pop_INT(FLISTINT self) {
 INT ret_val = ((INT) 0);
 INT r = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTINT_size_INT(self);
 if ((L1==0)) {
  ret_val = ((INT) 0);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTINT_aget_INT_INT(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTINT_aset_INT_INT(self, L4, ((INT) 0));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


INT FLISTINT_size_INT(FLISTINT self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTINT) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


PROG ELT_prog_PROG(ELT self) {
 PROG ret_val;
 ret_val = ATTR(ATTR(self,con1),prog1);
 return ret_val;
}


STR EXTERNAL_LAYOUT_str_STR(EXTERNAL_LAYOUT self) {
 return ATTR(self,str1);
}


STR EXTERNAL_LAYOUT_typedef_(EXTERNAL_LAYOUT self, CGEN c) {
 STR ret_val;
 extern STR name1;
 ret_val = ((STR) &name1);
 return ret_val;
}


STR FILE_get_str_STR(FILE1 self) {
 STR ret_val;
 ret_val = FSTR_str_STR(FILE_get_line_FSTR(self));
 return ret_val;
}


STR FILE_resolve_path_STR_ST(FILE1 self, STR fn) {
 STR ret_val;
 ret_val = fn;
 return ret_val;
}


STR FLISTAM_BND_CREATE_EXPR_5(FLISTAM_BND_CREATE_EXPR self) {
 STR ret_val;
 FSTR res;
 FLISTAM_BND_CREATE_EXPR L11;
 AM_BND_CREATE_EXPR e;
 extern STR name1;
 AM_BND_CREATE_EXPR L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_BND_CREATE_EXPR_4_frame_struct other1_0;
  FLISTAM_BND_CREATE_EXPR_4_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_BND_CREATE_EXPR_4(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAM_BND_ITER_CALL_EX6(FLISTAM_BND_ITER_CALL_EX self) {
 STR ret_val;
 FSTR res;
 FLISTAM_BND_ITER_CALL_EX L11;
 AM_BND_ITER_CALL_EXPR e;
 extern STR name1;
 AM_BND_ITER_CALL_EXPR L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_BND_ITER_CALL_EX5_frame_struct other1_0;
  FLISTAM_BND_ITER_CALL_EX5_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_BND_ITER_CALL_EX5(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAM_GLOBAL_EXPR_str_(FLISTAM_GLOBAL_EXPR self) {
 STR ret_val;
 FSTR res;
 FLISTAM_GLOBAL_EXPR L11;
 AM_GLOBAL_EXPR e;
 extern STR name1;
 AM_GLOBAL_EXPR L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_GLOBAL_EXPR_eltb_frame_struct other1_0;
  FLISTAM_GLOBAL_EXPR_eltb_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_GLOBAL_EXPR_eltb(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAM_ITER_CALL_EXPR_s(FLISTAM_ITER_CALL_EXPR self) {
 STR ret_val;
 FSTR res;
 FLISTAM_ITER_CALL_EXPR L11;
 AM_ITER_CALL_EXPR e;
 extern STR name1;
 AM_ITER_CALL_EXPR L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_ITER_CALL_EXPR_e_frame_struct other1_0;
  FLISTAM_ITER_CALL_EXPR_e_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_ITER_CALL_EXPR_e(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAM_LOCAL_EXPR_str_S(FLISTAM_LOCAL_EXPR self) {
 STR ret_val;
 FSTR res;
 FLISTAM_LOCAL_EXPR L11;
 AM_LOCAL_EXPR e;
 extern STR name1;
 AM_LOCAL_EXPR L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other1_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_LOCAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAM_ROUT_DEF_str_STR(FLISTAM_ROUT_DEF self) {
 STR ret_val;
 FSTR res;
 FLISTAM_ROUT_DEF L11;
 AM_ROUT_DEF e;
 extern STR name1;
 AM_ROUT_DEF L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAM_ROUT_DEF_eltb_AM_frame_struct other1_0;
  FLISTAM_ROUT_DEF_eltb_AM_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAM_ROUT_DEF_eltb_AM(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTAS_CLASS_DEF_str_ST(FLISTAS_CLASS_DEF self) {
 STR ret_val;
 FSTR res;
 FLISTAS_CLASS_DEF L11;
 AS_CLASS_DEF e;
 extern STR name1;
 AS_CLASS_DEF L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTAS_CLASS_DEF_eltb_A_frame_struct other1_0;
  FLISTAS_CLASS_DEF_eltb_A_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTAS_CLASS_DEF_eltb_A(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTCHAR_str_STR(FLISTCHAR self) {
 STR ret_val;
 FSTR res;
 FLISTCHAR L11;
 CHAR e = ((CHAR) 0);
 STR L21;
 STR L31;
 extern STR name1;
 CHAR L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTCHAR_eltb_CHAR_frame_struct other1_0;
  FLISTCHAR_eltb_CHAR_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTCHAR_eltb_CHAR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = CHAR_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTCODE_FILE_str_STR(FLISTCODE_FILE self) {
 STR ret_val;
 FSTR res;
 FLISTCODE_FILE L11;
 CODE_FILE e;
 extern STR name1;
 CODE_FILE L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTCODE_FILE_eltb_CODE_frame_struct other1_0;
  FLISTCODE_FILE_eltb_CODE_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTCODE_FILE_eltb_CODE(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTFLISTdAM_CONST_str_(FLISTFLISTdAM_CONST self) {
 STR ret_val;
 FSTR res;
 FLISTFLISTdAM_CONST L11;
 FLISTdAM_CONST e;
 STR L21;
 STR L31;
 extern STR name1;
 FLISTdAM_CONST L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTFLISTdAM_CONST_eltb_frame_struct other1_0;
  FLISTFLISTdAM_CONST_eltb_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTFLISTdAM_CONST_eltb(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = FLISTdAM_CONST_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTFSTR_str_STR(FLISTFSTR self) {
 STR ret_val;
 FSTR res;
 FLISTFSTR L11;
 FSTR e;
 STR L21;
 STR L31;
 extern STR name1;
 FSTR L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTFSTR_eltb_FSTR_frame_struct other1_0;
  FLISTFSTR_eltb_FSTR_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTFSTR_eltb_FSTR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = FSTR_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTIDENT_str_STR(FLISTIDENT self) {
 STR ret_val;
 FSTR res;
 FLISTIDENT L11;
 IDENT e = IDENT_zero;
 extern STR name1;
 IDENT L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTIDENT_eltb_IDENT_frame_struct other1_0;
  FLISTIDENT_eltb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTIDENT_eltb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTIFC_str_STR(FLISTIFC self) {
 STR ret_val;
 FSTR res;
 FLISTIFC L11;
 IFC e;
 extern STR name1;
 IFC L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTIFC_eltb_IFC_frame_struct other1_0;
  FLISTIFC_eltb_IFC_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTIFC_eltb_IFC(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTIMPL_INCLUDE_str_ST(FLISTIMPL_INCLUDE self) {
 STR ret_val;
 FSTR res;
 FLISTIMPL_INCLUDE L11;
 IMPL_INCLUDE e;
 extern STR name1;
 IMPL_INCLUDE L2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTIMPL_INCLUDE_eltb_I_frame_struct other1_0;
  FLISTIMPL_INCLUDE_eltb_I_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FLISTIMPL_INCLUDE_eltb_I(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTINT_str_STR(FLISTINT self) {
 STR ret_val;
 FSTR res;
 FLISTINT L11;
 INT e = ((INT) 0);
 STR L21;
 STR L31;
 extern STR name1;
 INT L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTINT_eltb_INT_frame_struct other1_0;
  FLISTINT_eltb_INT_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTINT_eltb_INT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = INT_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


dTP ELT_ret_dTP(ELT self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,sig11),ret1);
 return ret_val;
}


dTP ELT_tp_dTP(ELT self) {
 dTP ret_val;
 ret_val = ATTR(ATTR(self,sig11),tp);
 return ret_val;
}


void ELT_TBL_aset_INT_ELT(ELT_TBL self, INT ind, ELT val1) {
 SARR(self,ind,val1);
}


void ELT_TBL_asetb_ELT(ELT_TBL_asetb_ELT_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   ELT_TBL_aset_INT_ELT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void ERR_plus_dSTR(ERR1 self, dSTR s) {
 FILE1 L1;
 L1 = FILE_stderr_FILE(((FILE1) NULL));
 FILE_plus_dSTR(L1, s);
}


void EXTERNAL_LAYOUT_layouts_(EXTERNAL_LAYOUT self, FSETEXTERNAL_LAYOUT layouts) {
 EXTERNAL_LAYOUT_layouts = layouts;
}


void FILE_close(FILE1 self) {
 fclose(ATTR(self,fp));
}


void FILE_create_directory_ST(FILE1 self, STR nm) {
 STR L1;
 L1 = nm;
 mkdir(((L1==NULL)?NULL:L1->arr_part), 511);
}


void FILE_flush(FILE1 self) {
 fflush(ATTR(self,fp));
}


void FILE_plus_dSTR(FILE1 self, dSTR s) {
 INT fs = ((INT) 0);
 INT fs1 = ((INT) 0);
 STR ss;
 INT fs2 = ((INT) 0);
 STR ss1;
 INT fs3 = ((INT) 0);
 dSTR L1;
 INT L2;
 STR L3;
 CHAR L4;
 INT L5;
 EXT_OB L6;
 INT L7;
 STR L8;
 dSTR L9;
 INT L10;
 STR L11;
 if ((s==((dSTR) NULL))) {
  return;
 }
 if (s==NULL) {
  L1 = s;
  if (L1==NULL) {
   FATAL("Dispatch on void in FILE::plus($STR)");
  }
  ss1 = (*dSTR_str_STR[TAG(L1)+dSTR_str_STR_offset])(L1);
  L2 = STR_length_INT(ss1);
  L3 = ss1;
  fs3 = fwrite(((L3==NULL)?NULL:L3->arr_part), L2, 1, ATTR(self,fp));
 } else
 switch (TAG(s)) {
  case CHAR_tag:
   L4 = ((CHAR_boxed) s)->value_part;
   fputc(L4, ATTR(self,fp)); break;
  case FSTR_tag:
   L5 = FSTR_length_INT(((FSTR) s));
   L6 = ATTR(self,fp);
   fs = (fwrite(((FSTR) s)->arr_part,L5,1,L6)); break;
  case STR_tag:
   L7 = STR_length_INT(((STR) s));
   L8 = ((STR) s);
   fs1 = fwrite(((L8==NULL)?NULL:L8->arr_part), L7, 1, ATTR(self,fp)); break;
  default: ;
   L9 = s;
   if (L9==NULL) {
    FATAL("Dispatch on void in FILE::plus($STR)");
   }
   ss = (*dSTR_str_STR[TAG(L9)+dSTR_str_STR_offset])(L9);
   L10 = STR_length_INT(ss);
   L11 = ss;
   fs2 = fwrite(((L11==NULL)?NULL:L11->arr_part), L10, 1, ATTR(self,fp));
 }
}


void FILE_seek_from_end_INT(FILE1 self, INT off1) {
 INT dummy1 = ((INT) 0);
 dummy1 = fseek(ATTR(self,fp), off1, 2);
}


void FILE_seek_from_front_INT(FILE1 self, INT off1) {
 INT dummy1 = ((INT) 0);
 dummy1 = fseek(ATTR(self,fp), off1, 0);
}


void FIND_TYPES_do_abs_AS_CLA(FIND_TYPES self, AS_CLASS_DEF tcd) {
 dAS_CLASS_ELT tb;
 dAS_CLASS_ELT L1;
 tb = ATTR(tcd,body);
 while (1) {
  if ((tb==((dAS_CLASS_ELT) NULL))) {
   goto after_loop;
  }
  FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) tb));
  L1 = tb;
  if (L1==NULL) {
   FATAL("Dispatch on void in FIND_TYPES::do_abs(AS_CLASS_DEF)");
  }
  tb = (*dAS_CLASS_ELT_next_dAS_C[TAG(L1)+dAS_CLASS_ELT_next_dAS_C_offset])(L1);
 }
 after_loop: ;
}


void FIND_TYPES_do_impl_IMPL(FIND_TYPES self, IMPL im) {
 ELT e;
 ELT_TBL L11;
 ELT L2;
 if ((im==((IMPL) NULL))) {
  return;
 }
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(im,elts);
    noname1->self = L11;
   }
   L2 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
   SATTR(self,con1,ATTR(e,con1));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(e,as1)));
  }
 }
 after_loop: ;
}


void FIND_TYPES_do_tps_dAS_NO(FIND_TYPES self, dAS_NODE as) {
 dAS_CLASS_ELT b;
 BOOL L1;
 dAS_CLASS_ELT L2;
 if ((as==((dAS_NODE) NULL))) {
  return;
 }
 FIND_TYPES_err_loc_dPROG(self, ((dPROG_ERR) as));
 if (as==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(as)) {
  case AS_CLASS_DEF_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CLASS_DEF) as),params1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CLASS_DEF) as),under)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CLASS_DEF) as),over)));
   b = ATTR(((AS_CLASS_DEF) as),body);
   while (1) {
    L1 = (b==((dAS_CLASS_ELT) NULL));
    if ((!(L1))) {
    }
    else {
     goto after_loop;
    }
    if (b==NULL) {
    } else
    switch (TAG(b)) {
     case AS_INCLUDE_CLAUSE_tag:
      FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) b)); break;
     default: ;
    }
    L2 = b;
    if (L2==NULL) {
     FATAL("Dispatch on void in FIND_TYPES::do_tps($AS_NODE)");
    }
    b = (*dAS_CLASS_ELT_next_dAS_C[TAG(L2)+dAS_CLASS_ELT_next_dAS_C_offset])(L2);
   }
   after_loop: ; break;
  case AS_PARAM_DEC_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PARAM_DEC) as),type_constraint)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PARAM_DEC) as),next))); break;
  case AS_TYPE_SPEC_tag:
   FIND_TYPES_process_tp_dT(self, TP_CONTEXT_tp_of_AS_TYPE(ATTR(self,con1), ((AS_TYPE_SPEC) as)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPE_SPEC) as),next))); break;
  case AS_CONST_DEF_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CONST_DEF) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CONST_DEF) as),init1))); break;
  case AS_SHARED_DEF_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_SHARED_DEF) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_SHARED_DEF) as),init1))); break;
  case AS_ATTR_DEF_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ATTR_DEF) as),tp1))); break;
  case AS_ROUT_DEF_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ROUT_DEF) as),args_dec)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ROUT_DEF) as),ret_dec)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ROUT_DEF) as),pre_e)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ROUT_DEF) as),post_e)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ROUT_DEF) as),body))); break;
  case AS_ARG_DEC_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ARG_DEC) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ARG_DEC) as),next))); break;
  case AS_INCLUDE_CLAUSE_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_INCLUDE_CLAUSE) as),tp1))); break;
  case AS_STMT_LIST_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_STMT_LIST) as),stmts))); break;
  case AS_DEC_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_DEC_STMT) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_DEC_STMT) as),next))); break;
  case AS_ASSIGN_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSIGN_STMT) as),lhs_expr)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSIGN_STMT) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSIGN_STMT) as),rhs)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSIGN_STMT) as),next))); break;
  case AS_IF_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_IF_STMT) as),test1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_IF_STMT) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_IF_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_IF_STMT) as),next))); break;
  case AS_LOOP_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_LOOP_STMT) as),body)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_LOOP_STMT) as),next))); break;
  case AS_RETURN_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_RETURN_STMT) as),val11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_RETURN_STMT) as),next))); break;
  case AS_YIELD_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_YIELD_STMT) as),val11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_YIELD_STMT) as),next))); break;
  case AS_QUIT_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_QUIT_STMT) as),next))); break;
  case AS_CASE_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_STMT) as),test1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_STMT) as),when_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_STMT) as),next))); break;
  case AS_CASE_WHEN_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_WHEN) as),val11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_WHEN) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CASE_WHEN) as),next))); break;
  case AS_TYPECASE_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_STMT) as),when_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_STMT) as),next))); break;
  case AS_TYPECASE_WHEN_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_WHEN) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_WHEN) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TYPECASE_WHEN) as),next))); break;
  case AS_ASSERT_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSERT_STMT) as),test1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ASSERT_STMT) as),next))); break;
  case AS_PROTECT_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_STMT) as),body)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_STMT) as),when_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_STMT) as),next))); break;
  case AS_PROTECT_WHEN_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_WHEN) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_WHEN) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PROTECT_WHEN) as),next))); break;
  case AS_RAISE_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_RAISE_STMT) as),val11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_RAISE_STMT) as),next))); break;
  case AS_EXPR_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_EXPR_STMT) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_EXPR_STMT) as),next))); break;
  case AS_SELF_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_SELF_EXPR) as),next))); break;
  case AS_CALL_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CALL_EXPR) as),ob1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CALL_EXPR) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CALL_EXPR) as),args1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CALL_EXPR) as),next))); break;
  case AS_VOID_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_VOID_EXPR) as),next))); break;
  case AS_IS_VOID_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_IS_VOID_EXPR) as),arg1))); break;
  case AS_ARRAY_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ARRAY_EXPR) as),elts)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ARRAY_EXPR) as),next))); break;
  case AS_CREATE_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CREATE_EXPR) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CREATE_EXPR) as),elts)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CREATE_EXPR) as),next))); break;
  case AS_BOUND_CREATE_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_BOUND_CREATE_EXPR) as),call1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_BOUND_CREATE_EXPR) as),ret1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_BOUND_CREATE_EXPR) as),next))); break;
  case AS_UNDERSCORE_ARG_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_UNDERSCORE_ARG) as),tp1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_UNDERSCORE_ARG) as),next))); break;
  case AS_AND_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AND_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AND_EXPR) as),e21)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AND_EXPR) as),next))); break;
  case AS_OR_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_OR_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_OR_EXPR) as),e21)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_OR_EXPR) as),next))); break;
  case AS_EXCEPT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_EXCEPT_EXPR) as),next))); break;
  case AS_NEW_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_NEW_EXPR) as),arg1)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_NEW_EXPR) as),next))); break;
  case AS_INITIAL_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_INITIAL_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_INITIAL_EXPR) as),next))); break;
  case AS_BREAK_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_BREAK_EXPR) as),next))); break;
  case AS_RESULT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_RESULT_EXPR) as),next))); break;
  case AS_BOOL_LIT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_BOOL_LIT_EXPR) as),next))); break;
  case AS_CHAR_LIT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CHAR_LIT_EXPR) as),next))); break;
  case AS_STR_LIT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_STR_LIT_EXPR) as),next))); break;
  case AS_INT_LIT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_INT_LIT_EXPR) as),next))); break;
  case AS_FLT_LIT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FLT_LIT_EXPR) as),next))); break;
  case AS_PAR_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PAR_STMT) as),body)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_PAR_STMT) as),next))); break;
  case AS_ATTACH_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ATTACH_STMT) as),lhs)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ATTACH_STMT) as),rhs)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ATTACH_STMT) as),next))); break;
  case AS_LOCK_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_LOCK_STMT) as),e_list)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_LOCK_STMT) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_LOCK_STMT) as),next))); break;
  case AS_UNLOCK_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_UNLOCK_STMT) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_UNLOCK_STMT) as),next))); break;
  case AS_TRY_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TRY_STMT) as),e_list)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TRY_STMT) as),then_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TRY_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_TRY_STMT) as),next))); break;
  case AS_WITH_NEAR_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_WITH_NEAR_STMT) as),near_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_WITH_NEAR_STMT) as),else_part)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_WITH_NEAR_STMT) as),next))); break;
  case AS_FORK_STMT_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FORK_STMT) as),at11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FORK_STMT) as),body)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FORK_STMT) as),next))); break;
  case AS_HERE_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_HERE_EXPR) as),next))); break;
  case AS_WHERE_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_WHERE_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_WHERE_EXPR) as),next))); break;
  case AS_NEAR_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_NEAR_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_NEAR_EXPR) as),next))); break;
  case AS_FAR_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FAR_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_FAR_EXPR) as),next))); break;
  case AS_AT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AT_EXPR) as),e11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AT_EXPR) as),at11)));
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_AT_EXPR) as),next))); break;
  case AS_ANY_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_ANY_EXPR) as),next))); break;
  case AS_CLUSTER_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_CLUSTER_EXPR) as),next))); break;
  case AS_COHORT_EXPR_tag:
   FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) ATTR(((AS_COHORT_EXPR) as),next))); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
}


void FIND_TYPES_err_STR(FIND_TYPES self, STR s) {
 PROG_err_STR(ATTR(self,prog1), s);
}


void FIND_TYPES_err_loc_dPROG(FIND_TYPES self, dPROG_ERR t) {
 PROG_err_loc_dPROG_ERR(ATTR(self,prog1), t);
}


void FIND_TYPES_find_types(FIND_TYPES self) {
 AS_CLASS_DEF dummy1;
 BOOL got_all = ((BOOL) 0);
 FLISTAS_CLASS_DEF temp1;
 PROG_AS_TBL L11;
 AS_CLASS_DEF tcd;
 FLISTAS_CLASS_DEF L21;
 TP_CLASS tp;
 dTP fe;
 TP_CLASS ctp = ((TP_CLASS) NULL);
 AS_CLASS_DEF tcd1;
 IDENT L3;
 AS_CLASS_DEF L4;
 AS_CLASS_DEF L5;
 INT L6;
 BOOL L7;
 BOOL L8;
 BOOL L9;
 IDENT L10;
 BOOL L12;
 L3 = IDENT_create_STR_IDENT(IDENT_zero, ATTR(ATTR(self,prog1),main_class));
 dummy1 = FIND_TYPES_tree_for_IDEN(self, L3, 0);
 while (1) {
  got_all = TRUE;
  temp1 = FLISTAS_CLASS_DEF_create(((FLISTAS_CLASS_DEF) NULL));
  {
   struct PROG_AS_TBL_eltb_AS_CLAS_frame_struct other2_0;
   PROG_AS_TBL_eltb_AS_CLAS_frame 
   noname1 = &other2_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = ATTR(ATTR(self,prog1),as_tbl);
     noname1->self = L11;
    }
    L4 = PROG_AS_TBL_eltb_AS_CLAS(noname1);
    if (noname1->state == -1) {
     goto after_loop1;
    }
    temp1 = FLISTAS_CLASS_DEF_push_A(temp1, L4);
   }
  }
  after_loop1: ;
  {
   struct FLISTAS_CLASS_DEF_eltb_A_frame_struct other3_0;
   FLISTAS_CLASS_DEF_eltb_A_frame 
   noname2 = &other3_0;
   noname2->state = 0;
   while (1) {
    if (noname2->state == 0) {
     L21 = temp1;
     noname2->self = L21;
    }
    L5 = FLISTAS_CLASS_DEF_eltb_A(noname2);
    if (noname2->state == -1) {
     goto after_loop2;
    }
    tcd = L5;
    L6 = AS_PARAM_DEC_size_INT(ATTR(tcd,params1));
    if ((L6==0)) {
     tp = TP_TBL_tp_class_for_IDEN(ATTR(ATTR(self,prog1),tp_tbl), ATTR(tcd,name1), ((ARRAYdTP) NULL));
     L7 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), ((dTP) tp));
     if ((!(L7))) {
      got_all = FALSE;
      SATTR(self,con1,TP_CLASS_tp_context_for_(tp));
      SATTR(ATTR(self,prog1),tp_done,FSETdTP_insert_dTP_FSETd(ATTR(ATTR(self,prog1),tp_done), ((dTP) tp)));
      FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) tcd));
      if (TP_CLASS_is_abstract_BOO(tp)) {
       FIND_TYPES_do_abs_AS_CLA(self, tcd);
      }
      else {
       FIND_TYPES_do_impl_IMPL(self, IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), ((dTP) tp)));
      }
     }
    }
   }
  }
  after_loop2: ;
  if (got_all) {
   goto after_loop;
  }
 }
 after_loop: ;
 fe = FSETdTP_first_elt_dTP(ATTR(self,tp_todo));
 while (1) {
  L8 = (fe==((dTP) NULL));
  if ((!(L8))) {
  }
  else {
   goto after_loop3;
  }
  SATTR(self,tp_todo,FSETdTP_delete_dTP_FSETd(ATTR(self,tp_todo), fe));
  L9 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), fe);
  if ((!(L9))) {
   if (fe==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(fe)) {
    case TP_CLASS_tag:
     ctp = ((TP_CLASS) fe); break;
    default: ;
     FATAL("No applicable type in typecase");
   }
   L10 = ATTR(ctp,name1);
   tcd1 = FIND_TYPES_tree_for_IDEN(self, L10, ARRAYdTP_size_INT(ATTR(ctp,params)));
   SATTR(self,con1,TP_CLASS_tp_context_for_(ctp));
   SATTR(ATTR(self,prog1),tp_done,FSETdTP_insert_dTP_FSETd(ATTR(ATTR(self,prog1),tp_done), ((dTP) ctp)));
   L12 = (tcd1==((AS_CLASS_DEF) NULL));
   if ((!(L12))) {
    FIND_TYPES_do_tps_dAS_NO(self, ((dAS_NODE) tcd1));
    if (TP_CLASS_is_abstract_BOO(ctp)) {
     FIND_TYPES_do_abs_AS_CLA(self, tcd1);
    }
    else {
     FIND_TYPES_do_impl_IMPL(self, IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), ((dTP) ctp)));
    }
   }
  }
  fe = FSETdTP_first_elt_dTP(ATTR(self,tp_todo));
 }
 after_loop3: ;
 if (ATTR(ATTR(self,prog1),show_types)) {
  FIND_TYPES_tbl_out(self);
 }
}


void FIND_TYPES_process_tp_dT(FIND_TYPES self, dTP t) {
 IDENT nm = IDENT_zero;
 INT pnum = ((INT) 0);
 INT i = ((INT) 0);
 INT i1 = ((INT) 0);
 INT i2 = ((INT) 0);
 BOOL L1;
 extern STR Thereisnosourceclassfort;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 INT L5;
 BOOL L6;
 BOOL L7;
 BOOL L8;
 INT L9;
 BOOL L10;
 if ((t==((dTP) NULL))) {
  return;
 }
 if (t==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(t)) {
  case TP_CLASS_tag:
   nm = ATTR(((TP_CLASS) t),name1);
   pnum = ARRAYdTP_size_INT(ATTR(((TP_CLASS) t),params));
   if ((FIND_TYPES_tree_for_IDEN(self, nm, pnum)==((AS_CLASS_DEF) NULL))) {
    L1 = FSETIDENT_test_IDENT_BOO(ATTR(self,err_names), nm);
    if ((!(L1))) {
     FIND_TYPES_err_STR(self, STR_plus_dSTR_STR(((STR) &Thereisnosourceclassfort), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) t)))));
     SATTR(self,err_names,FSETIDENT_insert_IDENT_F(ATTR(self,err_names), nm));
    }
   }
   else {
    if ((pnum>0)) {
     L2 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), t);
     if ((!(L2))) {
      SATTR(self,tp_todo,FSETdTP_insert_dTP_FSETd(ATTR(self,tp_todo), t));
      i = 0;
      while (1) {
       if ((i<pnum)) {
       }
       else {
        goto after_loop;
       }
       FIND_TYPES_process_tp_dT(self, ARRAYdTP_aget_INT_dTP(ATTR(((TP_CLASS) t),params), i));
       i = (INTPLUS(i,1));
      }
      after_loop: ;
     }
    }
   } break;
  case TP_ROUT_tag:
   L3 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), t);
   if ((!(L3))) {
    SATTR(ATTR(self,prog1),tp_done,FSETdTP_insert_dTP_FSETd(ATTR(ATTR(self,prog1),tp_done), t));
    i1 = 0;
    L4 = (ATTR(((TP_ROUT) t),args)==((ARRAYdTP) NULL));
    if ((!(L4))) {
     while (1) {
      L5 = ARRAYdTP_size_INT(ATTR(((TP_ROUT) t),args));
      if ((i1<L5)) {
      }
      else {
       goto after_loop1;
      }
      FIND_TYPES_process_tp_dT(self, ARRAYdTP_aget_INT_dTP(ATTR(((TP_ROUT) t),args), i1));
      i1 = (INTPLUS(i1,1));
     }
     after_loop1: ;
    }
    L6 = (ATTR(((TP_ROUT) t),ret)==((dTP) NULL));
    if ((!(L6))) {
     FIND_TYPES_process_tp_dT(self, ATTR(((TP_ROUT) t),ret));
    }
   } break;
  case TP_ITER_tag:
   L7 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), t);
   if ((!(L7))) {
    SATTR(ATTR(self,prog1),tp_done,FSETdTP_insert_dTP_FSETd(ATTR(ATTR(self,prog1),tp_done), t));
    i2 = 0;
    L8 = (ATTR(((TP_ITER) t),args)==((ARRAYdTP) NULL));
    if ((!(L8))) {
     while (1) {
      L9 = ARRAYdTP_size_INT(ATTR(((TP_ITER) t),args));
      if ((i2<L9)) {
      }
      else {
       goto after_loop2;
      }
      FIND_TYPES_process_tp_dT(self, ARRAYdTP_aget_INT_dTP(ATTR(((TP_ITER) t),args), i2));
      i2 = (INTPLUS(i2,1));
     }
     after_loop2: ;
    }
    L10 = (ATTR(((TP_ITER) t),ret)==((dTP) NULL));
    if ((!(L10))) {
     FIND_TYPES_process_tp_dT(self, ATTR(((TP_ITER) t),ret));
    }
   } break;
  default: ;
   FATAL("No applicable type in typecase");
 }
}


void FIND_TYPES_tbl_out(FIND_TYPES self) {
 FSETdTP L11;
 STR L21;
 OUT L3;
 extern STR PROG_FIND_TYPES;
 BOOL L4;
 OUT L5;
 STR L6;
 extern STR name25;
 dTP L7;
 dTP L8;
 OUT L9;
 extern STR name26;
 L3 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L3, ((dSTR) ((STR) &PROG_FIND_TYPES)));
 L4 = (ATTR(ATTR(self,prog1),tp_done)==((FSETdTP) NULL));
 if ((!(L4))) {
  {
   struct FSETdTP_eltb_dTP_frame_struct other1_0;
   FSETdTP_eltb_dTP_frame 
   noname1 = &other1_0;
   struct STR_separateb_STR_STR_frame_struct other1_1;
   STR_separateb_STR_STR_frame 
   noname2 = &other1_1;
   noname1->state = 0;
   noname2->state = 0;
   while (1) {
    L5 = OUT_create_OUT(((OUT) NULL));
    if (noname2->state == 0) {
     L21 = ((STR) &name25);
     noname2->self = L21;
    }
    if (noname1->state == 0) {
     L11 = ATTR(ATTR(self,prog1),tp_done);
     noname1->self = L11;
    }
    L7 = FSETdTP_eltb_dTP(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    L8 = L7;
    if (L8==NULL) {
     FATAL("Dispatch on void in FIND_TYPES::tbl_out");
    }
    noname2->arg1 = (*dTP_str_STR[TAG(L8)+dTP_str_STR_offset])(L8);
    L6 = STR_separateb_STR_STR(noname2);
    if (noname2->state == -1) {
     goto after_loop;
    }
    OUT_plus_dSTR(L5, ((dSTR) L6));
   }
  }
  after_loop: ;
 }
 L9 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L9, ((dSTR) ((STR) &name26)));
}


void FLISTAM_BND_CREATE_EXPR_7(FLISTAM_BND_CREATE_EXPR self, INT ind, AM_BND_CREATE_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTAM_BND_CREATE_EXPR_8(FLISTAM_BND_CREATE_EXPR self, INT ind, AM_BND_CREATE_EXPR val1) {
 FLISTAM_BND_CREATE_EXPR_7(self, ind, val1);
}


void FLISTAM_BND_CREATE_EXPR_9(FLISTAM_BND_CREATE_EXPR_9_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_BND_CREATE_EXPR_8(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAM_BND_ITER_CALL_EX7(FLISTAM_BND_ITER_CALL_EX self, INT ind, AM_BND_ITER_CALL_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTAM_BND_ITER_CALL_EX8(FLISTAM_BND_ITER_CALL_EX self, INT ind, AM_BND_ITER_CALL_EXPR val1) {
 FLISTAM_BND_ITER_CALL_EX7(self, ind, val1);
}


void FLISTAM_BND_ITER_CALL_EX9(FLISTAM_BND_ITER_CALL_EX9_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_BND_ITER_CALL_EX8(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAM_GLOBAL_EXPR_aref1(FLISTAM_GLOBAL_EXPR self, INT ind, AM_GLOBAL_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTAM_GLOBAL_EXPR_aset(FLISTAM_GLOBAL_EXPR self, INT ind, AM_GLOBAL_EXPR val1) {
 FLISTAM_GLOBAL_EXPR_aref1(self, ind, val1);
}


void FLISTAM_GLOBAL_EXPR_aset1(FLISTAM_GLOBAL_EXPR_aset1_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_GLOBAL_EXPR_aset(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAM_ITER_CALL_EXPR_a4(FLISTAM_ITER_CALL_EXPR self, INT ind, AM_ITER_CALL_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTAM_ITER_CALL_EXPR_a5(FLISTAM_ITER_CALL_EXPR self, INT ind, AM_ITER_CALL_EXPR val1) {
 FLISTAM_ITER_CALL_EXPR_a4(self, ind, val1);
}


void FLISTAM_ITER_CALL_EXPR_a6(FLISTAM_ITER_CALL_EXPR_a6_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_ITER_CALL_EXPR_a5(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAM_LOCAL_EXPR_aref_1(FLISTAM_LOCAL_EXPR self, INT ind, AM_LOCAL_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTAM_LOCAL_EXPR_aset_(FLISTAM_LOCAL_EXPR self, INT ind, AM_LOCAL_EXPR val1) {
 FLISTAM_LOCAL_EXPR_aref_1(self, ind, val1);
}


void FLISTAM_LOCAL_EXPR_asetb(FLISTAM_LOCAL_EXPR_asetb_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_LOCAL_EXPR_aset_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAM_ROUT_DEF_aref_as(FLISTAM_ROUT_DEF self, INT ind, AM_ROUT_DEF val1) {
 SARR(self,ind,val1);
}


void FLISTAM_ROUT_DEF_aset_IN(FLISTAM_ROUT_DEF self, INT ind, AM_ROUT_DEF val1) {
 FLISTAM_ROUT_DEF_aref_as(self, ind, val1);
}


void FLISTAM_ROUT_DEF_asetb_A(FLISTAM_ROUT_DEF_asetb_A_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAM_ROUT_DEF_aset_IN(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTAS_CLASS_DEF_aref_a1(FLISTAS_CLASS_DEF self, INT ind, AS_CLASS_DEF val1) {
 SARR(self,ind,val1);
}


void FLISTAS_CLASS_DEF_aset_I(FLISTAS_CLASS_DEF self, INT ind, AS_CLASS_DEF val1) {
 FLISTAS_CLASS_DEF_aref_a1(self, ind, val1);
}


void FLISTAS_CLASS_DEF_asetb_(FLISTAS_CLASS_DEF_asetb__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTAS_CLASS_DEF_aset_I(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTCODE_FILE_aref_aset(FLISTCODE_FILE self, INT ind, CODE_FILE val1) {
 SARR(self,ind,val1);
}


void FLISTCODE_FILE_aset_INT_(FLISTCODE_FILE self, INT ind, CODE_FILE val1) {
 FLISTCODE_FILE_aref_aset(self, ind, val1);
}


void FLISTCODE_FILE_asetb_COD(FLISTCODE_FILE_asetb_COD_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTCODE_FILE_aset_INT_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTFLISTdAM_CONST_aref1(FLISTFLISTdAM_CONST self, INT ind, FLISTdAM_CONST val1) {
 SARR(self,ind,val1);
}


void FLISTFLISTdAM_CONST_aset(FLISTFLISTdAM_CONST self, INT ind, FLISTdAM_CONST val1) {
 FLISTFLISTdAM_CONST_aref1(self, ind, val1);
}


void FLISTFLISTdAM_CONST_aset1(FLISTFLISTdAM_CONST_aset1_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTFLISTdAM_CONST_aset(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTFSTR_aref_aset_INT_(FLISTFSTR self, INT ind, FSTR val1) {
 SARR(self,ind,val1);
}


void FLISTFSTR_aset_INT_FSTR(FLISTFSTR self, INT ind, FSTR val1) {
 FLISTFSTR_aref_aset_INT_(self, ind, val1);
}


void FLISTFSTR_asetb_FSTR(FLISTFSTR_asetb_FSTR_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTFSTR_aset_INT_FSTR(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTIDENT_aref_aset_INT(FLISTIDENT self, INT ind, IDENT val1) {
 SARR(self,ind,val1);
}


void FLISTIDENT_aset_INT_IDEN(FLISTIDENT self, INT ind, IDENT val1) {
 FLISTIDENT_aref_aset_INT(self, ind, val1);
}


void FLISTIDENT_asetb_IDENT(FLISTIDENT_asetb_IDENT_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTIDENT_aset_INT_IDEN(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTIFC_aref_aset_INT_I(FLISTIFC self, INT ind, IFC val1) {
 SARR(self,ind,val1);
}


void FLISTIFC_aset_INT_IFC(FLISTIFC self, INT ind, IFC val1) {
 FLISTIFC_aref_aset_INT_I(self, ind, val1);
}


void FLISTIFC_asetb_IFC(FLISTIFC_asetb_IFC_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTIFC_aset_INT_IFC(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTIMPL_INCLUDE_aref_a1(FLISTIMPL_INCLUDE self, INT ind, IMPL_INCLUDE val1) {
 SARR(self,ind,val1);
}


void FLISTIMPL_INCLUDE_aset_I(FLISTIMPL_INCLUDE self, INT ind, IMPL_INCLUDE val1) {
 FLISTIMPL_INCLUDE_aref_a1(self, ind, val1);
}


void FLISTIMPL_INCLUDE_asetb_(FLISTIMPL_INCLUDE_asetb__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTIMPL_INCLUDE_aset_I(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTINT_aref_aset_INT_I(FLISTINT self, INT ind, INT val1) {
 SARR(self,ind,val1);
}


void FLISTINT_aset_INT_INT(FLISTINT self, INT ind, INT val1) {
 FLISTINT_aref_aset_INT_I(self, ind, val1);
}


void FLISTINT_asetb_INT(FLISTINT_asetb_INT_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTINT_aset_INT_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}

/* C for type ELT */




ELT ELT_create_SIG_SIG_dAS_C(ELT self, SIG sig1, SIG srcsig, dAS_CLASS_ELT as, TP_CONTEXT con, BOOL is_private) {
 ELT ret_val;
 ELT r;
 ELT L1;
 L1 = ((ELT) rt_alloc(sizeof(struct ELT_struct), ELT_tag));
 r = L1;
 SATTR(r,sig11,sig1);
 SATTR(r,srcsig1,srcsig);
 SATTR(r,as1,as);
 SATTR(r,con1,con);
 SATTR(r,is_private1,is_private);
 ret_val = r;
 return ret_val;
}

/* C for type ELT_TBL */




INT ELT_TBL_query_hash_IDENT(ELT_TBL self, IDENT i) {
 INT ret_val = ((INT) 0);
 ret_val = IDENT_hash_INT(i);
 return ret_val;
}

/* C for type ERR1 */




ERR1 ERR_create_ERR(ERR1 self) {
 ERR1 ret_val;
 ret_val = self;
 return ret_val;
}

/* C for type EXTERNAL_LAYOUT */




STR EXTERNAL_LAYOUT_makestr_(EXTERNAL_LAYOUT self) {
 STR ret_val;
 dTP L1;
 STR L2;
 extern STR External;
 L1 = ATTR(self,tp1);
 if (L1==NULL) {
  FATAL("Dispatch on void in EXTERNAL_LAYOUT::makestr:STR");
 }
 L2 = (*dTP_str_STR[TAG(L1)+dTP_str_STR_offset])(L1);
 ret_val = STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &External)));
 return ret_val;
}

/* C for type FILE1 */




FILE1 FILE_stderr_FILE(FILE1 self) {
 FILE1 ret_val;
 FILE1 r;
 FILE1 L1;
 L1 = ((FILE1) rt_alloc(sizeof(struct FILE1_struct), FILE1_tag));
 r = L1;
 SATTR(r,fp,(stderr));
 ret_val = r;
 return ret_val;
}

/* C for type FIND_TYPES */




FIND_TYPES FIND_TYPES_create_PROG_F(FIND_TYPES self, PROG p) {
 FIND_TYPES ret_val;
 FIND_TYPES r;
 FIND_TYPES L1;
 L1 = ((FIND_TYPES) rt_alloc(sizeof(struct FIND_TYPES_struct), FIND_TYPES_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type FLISTAM_BND_CREATE_EXPR */




INT FLISTAM_BND_CREATE_EXPR_(FLISTAM_BND_CREATE_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAM_BND_ITER_CALL_EX */




INT FLISTAM_BND_ITER_CALL_EX1(FLISTAM_BND_ITER_CALL_EX self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAM_GLOBAL_EXPR */




INT FLISTAM_GLOBAL_EXPR_asiz(FLISTAM_GLOBAL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAM_ITER_CALL_EXPR */




INT FLISTAM_ITER_CALL_EXPR_a(FLISTAM_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAM_LOCAL_EXPR */




INT FLISTAM_LOCAL_EXPR_asize(FLISTAM_LOCAL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAM_ROUT_DEF */




INT FLISTAM_ROUT_DEF_asize_I(FLISTAM_ROUT_DEF self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTAS_CLASS_DEF */




INT FLISTAS_CLASS_DEF_asize_(FLISTAS_CLASS_DEF self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTCHAR */




INT FLISTCHAR_asize_INT(FLISTCHAR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTCODE_FILE */




INT FLISTCODE_FILE_asize_INT(FLISTCODE_FILE self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTFLISTdAM_CONST */




INT FLISTFLISTdAM_CONST_asiz(FLISTFLISTdAM_CONST self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTFSTR */




INT FLISTFSTR_asize_INT(FLISTFSTR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTIDENT */




INT FLISTIDENT_asize_INT(FLISTIDENT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTIFC */




INT FLISTIFC_asize_INT(FLISTIFC self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTIMPL_INCLUDE */




INT FLISTIMPL_INCLUDE_asize_(FLISTIMPL_INCLUDE self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTINT */




INT FLISTINT_asize_INT(FLISTINT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}
