#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_CONST_struct {
 OB_HEADER header;
 } *dAM_CONST;

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_FRAME_LAYOUT_struct {/* layout for ABSTRACT_FRAME_LAYOUT */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct SIG_struct *sig11;
 STR str1;
 } *ABSTRACT_FRAME_LAYOUT;

typedef struct ARG_LAYOUT_struct {/* layout for ARG_LAYOUT */
 OB_HEADER header;
 struct SIG_struct *sig11;
 STR str1;
 } *ARG_LAYOUT;

typedef struct ARRAYSTR_struct {/* layout for ARRAY{STR} */
 OB_HEADER header;
 INT asize;
 STR arr_part[1];
 } *ARRAYSTR;

typedef struct BOUND_OBJECT_LAYOUT_struct {/* layout for BOUND_OBJECT_LAYOUT */
 OB_HEADER header;
 struct AM_BND_CREATE_EXPR_struct *e11;
 STR str1;
 } *BOUND_OBJECT_LAYOUT;

typedef struct ERR1_struct {/* layout for ERR */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *ERR1;

typedef struct FLTI_struct {/* layout for FLTI */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *FLTI;

typedef struct FRAME_LAYOUT_struct {/* layout for FRAME_LAYOUT */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *f1;
 struct PROG_struct *prog1;
 STR str1;
 } *FRAME_LAYOUT;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_uptob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_uptob_INT_INT_frame;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;


typedef struct STR_separateb_STR_STR_frame_struct {
 STR self;/* Formal argument: self */
 STR arg1;/* Formal argument: s */
 INT state;
 STR ret_val;
 } *STR_separateb_STR_STR_frame;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TUPAM_BND_CREATE_EXPRBOU_struct {/* layout for TUP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct BOUND_OBJECT_LAYOUT_struct *t2;
 } TUPAM_BND_CREATE_EXPRBOU;
static TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU_zero;

typedef struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRBOU value_part;
 } *TUPAM_BND_CREATE_EXPRBOU_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_struct {/* layout for TUP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 struct AM_ROUT_DEF_struct *t1;
 struct FLISTAM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ROUT_DEFFLISTAM_IT;
static TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT_zero;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFLISTAM_IT value_part;
 } *TUPAM_ROUT_DEFFLISTAM_IT_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct TUPIDENTdTP_struct {/* layout for TUP{IDENT,$TP} */
 struct dTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTdTP;
static TUPIDENTdTP TUPIDENTdTP_zero;

typedef struct TUPIDENTdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTdTP value_part;
 } *TUPIDENTdTP_boxed;

typedef struct TUPIDENTAM_GLOBAL_EXPR_struct {/* layout for TUP{IDENT,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTAM_GLOBAL_EXPR;
static TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_zero;

typedef struct TUPIDENTAM_GLOBAL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPIDENTAM_GLOBAL_EXPR value_part;
 } *TUPIDENTAM_GLOBAL_EXPR_boxed;

typedef struct TUPSIGABSTRACT_FRAME_LAY_struct {/* layout for TUP{SIG,ABSTRACT_FRAME_LAYOUT} */
 struct ABSTRACT_FRAME_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGABSTRACT_FRAME_LAY;
static TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY_zero;

typedef struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct {
 OB_HEADER header;
 TUPSIGABSTRACT_FRAME_LAY value_part;
 } *TUPSIGABSTRACT_FRAME_LAY_boxed;

typedef struct TUPSIGAM_ROUT_DEF_struct {/* layout for TUP{SIG,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGAM_ROUT_DEF;
static TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_zero;

typedef struct TUPSIGAM_ROUT_DEF_boxed_struct {
 OB_HEADER header;
 TUPSIGAM_ROUT_DEF value_part;
 } *TUPSIGAM_ROUT_DEF_boxed;

typedef struct TUPSIGARG_LAYOUT_struct {/* layout for TUP{SIG,ARG_LAYOUT} */
 struct ARG_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGARG_LAYOUT;
static TUPSIGARG_LAYOUT TUPSIGARG_LAYOUT_zero;

typedef struct TUPSIGARG_LAYOUT_boxed_struct {
 OB_HEADER header;
 TUPSIGARG_LAYOUT value_part;
 } *TUPSIGARG_LAYOUT_boxed;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;


typedef struct ARRAYSTR_setb_STR_frame_struct {
 ARRAYSTR self;/* Formal argument: self */
 STR arg1;/* Formal argument: val */
 INT state;
 ARRAYSTR L21;
 struct ARRAYSTR_asetb_STR_frame_struct *nested1; /* nested iter frame */
 } *ARRAYSTR_setb_STR_frame;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;


typedef struct FLISTdAM_CONST_aeltb_INT_frame_struct {
 FLISTdAM_CONST self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 dAM_CONST ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_CONST_aeltb_INT_frame;


typedef struct FLISTdAM_CONST_asetb_dAM_frame_struct {
 FLISTdAM_CONST self;/* Formal argument: self */
 dAM_CONST arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_CONST_asetb_dAM_frame;


typedef struct FLISTdAM_CONST_eltb_dAM__frame_struct {
 FLISTdAM_CONST self;/* Formal argument: self */
 INT state;
 dAM_CONST ret_val;
 FLISTdAM_CONST L31;
 INT L41;
 INT L51;
 struct FLISTdAM_CONST_aeltb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_CONST_eltb_dAM__frame;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;


typedef struct FLISTdAM_EXPR_aeltb_INT__frame_struct {
 FLISTdAM_EXPR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 dAM_EXPR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_EXPR_aeltb_INT__frame;


typedef struct FLISTdAM_EXPR_asetb_dAM__frame_struct {
 FLISTdAM_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_EXPR_asetb_dAM__frame;


typedef struct FLISTdAM_EXPR_eltb_dAM_E_frame_struct {
 FLISTdAM_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 FLISTdAM_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTdAM_EXPR_aeltb_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_EXPR_eltb_dAM_E_frame;

typedef struct FLISTdAM_STMT_struct {/* layout for FLIST{$AM_STMT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_STMT_struct *arr_part[1];
 } *FLISTdAM_STMT;


typedef struct FLISTdAM_STMT_aeltb_INT__frame_struct {
 FLISTdAM_STMT self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 dAM_STMT ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_STMT_aeltb_INT__frame;


typedef struct FLISTdAM_STMT_asetb_dAM__frame_struct {
 FLISTdAM_STMT self;/* Formal argument: self */
 dAM_STMT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_STMT_asetb_dAM__frame;


typedef struct FLISTdAM_STMT_eltb_dAM_S_frame_struct {
 FLISTdAM_STMT self;/* Formal argument: self */
 INT state;
 dAM_STMT ret_val;
 FLISTdAM_STMT L31;
 INT L41;
 INT L51;
 struct FLISTdAM_STMT_aeltb_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_STMT_eltb_dAM_S_frame;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;


typedef struct FLISTdLAYOUT_aeltb_INT_I_frame_struct {
 FLISTdLAYOUT self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 dLAYOUT ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdLAYOUT_aeltb_INT_I_frame;


typedef struct FLISTdLAYOUT_asetb_dLAYO_frame_struct {
 FLISTdLAYOUT self;/* Formal argument: self */
 dLAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdLAYOUT_asetb_dLAYO_frame;


typedef struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct {
 FLISTdLAYOUT self;/* Formal argument: self */
 INT state;
 dLAYOUT ret_val;
 FLISTdLAYOUT L31;
 INT L41;
 INT L51;
 struct FLISTdLAYOUT_aeltb_INT_I_frame_struct *nested1; /* nested iter frame */
 } *FLISTdLAYOUT_eltb_dLAYOU_frame;

typedef struct FLISTdTP_struct {/* layout for FLIST{$TP} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FLISTdTP;


typedef struct FLISTdTP_aeltb_INT_INT_d_frame_struct {
 FLISTdTP self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 dTP ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdTP_aeltb_INT_INT_d_frame;


typedef struct FLISTdTP_asetb_dTP_frame_struct {
 FLISTdTP self;/* Formal argument: self */
 dTP arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdTP_asetb_dTP_frame;


typedef struct FLISTdTP_eltb_dTP_frame_struct {
 FLISTdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FLISTdTP L31;
 INT L41;
 INT L51;
 struct FLISTdTP_aeltb_INT_INT_d_frame_struct *nested1; /* nested iter frame */
 } *FLISTdTP_eltb_dTP_frame;


typedef struct FLISTdTP_indb_INT_frame_struct {
 FLISTdTP self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT L31;
 INT L41;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTdTP_indb_INT_frame;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;

typedef struct FLISTSFILE_ID_struct {/* layout for FLIST{SFILE_ID} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct SFILE_ID_struct arr_part[1];
 } *FLISTSFILE_ID;


typedef struct FLISTSFILE_ID_aeltb_INT__frame_struct {
 FLISTSFILE_ID self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 SFILE_ID ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTSFILE_ID_aeltb_INT__frame;


typedef struct FLISTSFILE_ID_asetb_SFIL_frame_struct {
 FLISTSFILE_ID self;/* Formal argument: self */
 SFILE_ID arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTSFILE_ID_asetb_SFIL_frame;


typedef struct FLISTSFILE_ID_eltb_SFILE_frame_struct {
 FLISTSFILE_ID self;/* Formal argument: self */
 INT state;
 SFILE_ID ret_val;
 FLISTSFILE_ID L31;
 INT L41;
 INT L51;
 struct FLISTSFILE_ID_aeltb_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTSFILE_ID_eltb_SFILE_frame;

typedef struct FLISTSIG_struct {/* layout for FLIST{SIG} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *FLISTSIG;


typedef struct FLISTSIG_aeltb_INT_INT_S_frame_struct {
 FLISTSIG self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 SIG ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTSIG_aeltb_INT_INT_S_frame;


typedef struct FLISTSIG_eltb_SIG_frame_struct {
 FLISTSIG self;/* Formal argument: self */
 INT state;
 SIG ret_val;
 FLISTSIG L31;
 INT L41;
 INT L51;
 struct FLISTSIG_aeltb_INT_INT_S_frame_struct *nested1; /* nested iter frame */
 } *FLISTSIG_eltb_SIG_frame;

typedef struct FLISTSTR_struct {/* layout for FLIST{STR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 STR arr_part[1];
 } *FLISTSTR;


typedef struct FLISTSTR_aeltb_INT_INT_S_frame_struct {
 FLISTSTR self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT arg2;/* Formal argument: num */
 INT state;
 STR ret_val;
 INT L21;
 INT L31;
 struct INT_uptob_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTSTR_aeltb_INT_INT_S_frame;


typedef struct FLISTSTR_asetb_STR_frame_struct {
 FLISTSTR self;/* Formal argument: self */
 STR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTSTR_asetb_STR_frame;


typedef struct FLISTSTR_eltb_STR_frame_struct {
 FLISTSTR self;/* Formal argument: self */
 INT state;
 STR ret_val;
 FLISTSTR L31;
 INT L41;
 INT L51;
 struct FLISTSTR_aeltb_INT_INT_S_frame_struct *nested1; /* nested iter frame */
 } *FLISTSTR_eltb_STR_frame;

typedef struct FMAPAM_BND_CREATE_EXPRBO_struct {/* layout for FMAP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_BND_CREATE_EXPRBOU_struct arr_part[1];
 } *FMAPAM_BND_CREATE_EXPRBO;


typedef struct FMAPAM_BND_CREATE_EXPRBO13_frame_struct {
 FMAPAM_BND_CREATE_EXPRBO self;/* Formal argument: self */
 INT state;
 TUPAM_BND_CREATE_EXPRBOU ret_val;
 INT i;
 } *FMAPAM_BND_CREATE_EXPRBO13_frame;


typedef struct FMAPAM_BND_CREATE_EXPRBO9_frame_struct {
 FMAPAM_BND_CREATE_EXPRBO self;/* Formal argument: self */
 TUPAM_BND_CREATE_EXPRBOU arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_BND_CREATE_EXPRBO9_frame;


typedef struct FMAPAM_BND_CREATE_EXPRBO14_frame_struct {
 FMAPAM_BND_CREATE_EXPRBO self;/* Formal argument: self */
 INT state;
 TUPAM_BND_CREATE_EXPRBOU ret_val;
 FMAPAM_BND_CREATE_EXPRBO L31;
 TUPAM_BND_CREATE_EXPRBOU r;
 struct FMAPAM_BND_CREATE_EXPRBO13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_BND_CREATE_EXPRBO14_frame;


typedef struct FMAPAM_BND_CREATE_EXPRBO19_frame_struct {
 FMAPAM_BND_CREATE_EXPRBO self;/* Formal argument: self */
 INT state;
 BOUND_OBJECT_LAYOUT ret_val;
 FMAPAM_BND_CREATE_EXPRBO L31;
 TUPAM_BND_CREATE_EXPRBOU e;
 struct FMAPAM_BND_CREATE_EXPRBO13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_BND_CREATE_EXPRBO19_frame;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;


typedef struct FMAPAM_LOCAL_EXPRAM_LOCA10_frame_struct {
 FMAPAM_LOCAL_EXPRAM_LOCA self;/* Formal argument: self */
 INT state;
 TUPAM_LOCAL_EXPRAM_LOCAL ret_val;
 INT i;
 } *FMAPAM_LOCAL_EXPRAM_LOCA10_frame;


typedef struct FMAPAM_LOCAL_EXPRAM_LOCA4_frame_struct {
 FMAPAM_LOCAL_EXPRAM_LOCA self;/* Formal argument: self */
 TUPAM_LOCAL_EXPRAM_LOCAL arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_LOCAL_EXPRAM_LOCA4_frame;


typedef struct FMAPAM_LOCAL_EXPRAM_LOCA12_frame_struct {
 FMAPAM_LOCAL_EXPRAM_LOCA self;/* Formal argument: self */
 INT state;
 TUPAM_LOCAL_EXPRAM_LOCAL ret_val;
 FMAPAM_LOCAL_EXPRAM_LOCA L31;
 TUPAM_LOCAL_EXPRAM_LOCAL r;
 struct FMAPAM_LOCAL_EXPRAM_LOCA10_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_LOCAL_EXPRAM_LOCA12_frame;

typedef struct FMAPAM_ROUT_DEFFLISTAM_I_struct {/* layout for FMAP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFLISTAM_IT_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFLISTAM_I;


typedef struct FMAPAM_ROUT_DEFFLISTAM_I10_frame_struct {
 FMAPAM_ROUT_DEFFLISTAM_I self;/* Formal argument: self */
 INT state;
 TUPAM_ROUT_DEFFLISTAM_IT ret_val;
 INT i;
 } *FMAPAM_ROUT_DEFFLISTAM_I10_frame;


typedef struct FMAPAM_ROUT_DEFFLISTAM_I5_frame_struct {
 FMAPAM_ROUT_DEFFLISTAM_I self;/* Formal argument: self */
 TUPAM_ROUT_DEFFLISTAM_IT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFLISTAM_I5_frame;


typedef struct FMAPAM_ROUT_DEFFLISTAM_I12_frame_struct {
 FMAPAM_ROUT_DEFFLISTAM_I self;/* Formal argument: self */
 INT state;
 TUPAM_ROUT_DEFFLISTAM_IT ret_val;
 FMAPAM_ROUT_DEFFLISTAM_I L31;
 TUPAM_ROUT_DEFFLISTAM_IT r;
 struct FMAPAM_ROUT_DEFFLISTAM_I10_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFLISTAM_I12_frame;

typedef struct FMAPAM_ROUT_DEFFRAME_LAY_struct {/* layout for FMAP{AM_ROUT_DEF,FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFRAME_LAYO_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFRAME_LAY;


typedef struct FMAPAM_ROUT_DEFFRAME_LAY13_frame_struct {
 FMAPAM_ROUT_DEFFRAME_LAY self;/* Formal argument: self */
 INT state;
 TUPAM_ROUT_DEFFRAME_LAYO ret_val;
 INT i;
 } *FMAPAM_ROUT_DEFFRAME_LAY13_frame;


typedef struct FMAPAM_ROUT_DEFFRAME_LAY9_frame_struct {
 FMAPAM_ROUT_DEFFRAME_LAY self;/* Formal argument: self */
 TUPAM_ROUT_DEFFRAME_LAYO arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFRAME_LAY9_frame;


typedef struct FMAPAM_ROUT_DEFFRAME_LAY14_frame_struct {
 FMAPAM_ROUT_DEFFRAME_LAY self;/* Formal argument: self */
 INT state;
 TUPAM_ROUT_DEFFRAME_LAYO ret_val;
 FMAPAM_ROUT_DEFFRAME_LAY L31;
 TUPAM_ROUT_DEFFRAME_LAYO r;
 struct FMAPAM_ROUT_DEFFRAME_LAY13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFRAME_LAY14_frame;


typedef struct FMAPAM_ROUT_DEFFRAME_LAY19_frame_struct {
 FMAPAM_ROUT_DEFFRAME_LAY self;/* Formal argument: self */
 INT state;
 FRAME_LAYOUT ret_val;
 FMAPAM_ROUT_DEFFRAME_LAY L31;
 TUPAM_ROUT_DEFFRAME_LAYO e;
 struct FMAPAM_ROUT_DEFFRAME_LAY13_frame_struct *nested1; /* nested iter frame */
 } *FMAPAM_ROUT_DEFFRAME_LAY19_frame;

typedef struct FMAPIDENTdTP_struct {/* layout for FMAP{IDENT,$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *FMAPIDENTdTP;


typedef struct FMAPIDENTdTP_aeltb_TUPID_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 INT i;
 } *FMAPIDENTdTP_aeltb_TUPID_frame;


typedef struct FMAPIDENTdTP_asetb_TUPID_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 TUPIDENTdTP arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_asetb_TUPID_frame;


typedef struct FMAPIDENTdTP_pairsb_TUPI_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP r;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_pairsb_TUPI_frame;


typedef struct FMAPIDENTdTP_targetsb_dT_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP e;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_targetsb_dT_frame;

typedef struct FMAPIDENTAM_GLOBAL_EXPR_struct {/* layout for FMAP{IDENT,AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTAM_GLOBAL_EXPR_struct arr_part[1];
 } *FMAPIDENTAM_GLOBAL_EXPR;


typedef struct FMAPIDENTAM_GLOBAL_EXPR_12_frame_struct {
 FMAPIDENTAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 TUPIDENTAM_GLOBAL_EXPR ret_val;
 INT i;
 } *FMAPIDENTAM_GLOBAL_EXPR_12_frame;


typedef struct FMAPIDENTAM_GLOBAL_EXPR_8_frame_struct {
 FMAPIDENTAM_GLOBAL_EXPR self;/* Formal argument: self */
 TUPIDENTAM_GLOBAL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTAM_GLOBAL_EXPR_8_frame;


typedef struct FMAPIDENTAM_GLOBAL_EXPR_13_frame_struct {
 FMAPIDENTAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 TUPIDENTAM_GLOBAL_EXPR ret_val;
 FMAPIDENTAM_GLOBAL_EXPR L31;
 TUPIDENTAM_GLOBAL_EXPR r;
 struct FMAPIDENTAM_GLOBAL_EXPR_12_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTAM_GLOBAL_EXPR_13_frame;

typedef struct FMAPSIGABSTRACT_FRAME_LA_struct {/* layout for FMAP{SIG,ABSTRACT_FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGABSTRACT_FRAME_LAY_struct arr_part[1];
 } *FMAPSIGABSTRACT_FRAME_LA;


typedef struct FMAPSIGABSTRACT_FRAME_LA13_frame_struct {
 FMAPSIGABSTRACT_FRAME_LA self;/* Formal argument: self */
 INT state;
 TUPSIGABSTRACT_FRAME_LAY ret_val;
 INT i;
 } *FMAPSIGABSTRACT_FRAME_LA13_frame;


typedef struct FMAPSIGABSTRACT_FRAME_LA9_frame_struct {
 FMAPSIGABSTRACT_FRAME_LA self;/* Formal argument: self */
 TUPSIGABSTRACT_FRAME_LAY arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGABSTRACT_FRAME_LA9_frame;


typedef struct FMAPSIGABSTRACT_FRAME_LA14_frame_struct {
 FMAPSIGABSTRACT_FRAME_LA self;/* Formal argument: self */
 INT state;
 TUPSIGABSTRACT_FRAME_LAY ret_val;
 FMAPSIGABSTRACT_FRAME_LA L31;
 TUPSIGABSTRACT_FRAME_LAY r;
 struct FMAPSIGABSTRACT_FRAME_LA13_frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGABSTRACT_FRAME_LA14_frame;

typedef struct FMAPSIGAM_ROUT_DEF_struct {/* layout for FMAP{SIG,AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGAM_ROUT_DEF_struct arr_part[1];
 } *FMAPSIGAM_ROUT_DEF;


typedef struct FMAPSIGAM_ROUT_DEF_aeltb_frame_struct {
 FMAPSIGAM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 TUPSIGAM_ROUT_DEF ret_val;
 INT i;
 } *FMAPSIGAM_ROUT_DEF_aeltb_frame;


typedef struct FMAPSIGAM_ROUT_DEF_asetb_frame_struct {
 FMAPSIGAM_ROUT_DEF self;/* Formal argument: self */
 TUPSIGAM_ROUT_DEF arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGAM_ROUT_DEF_asetb_frame;


typedef struct FMAPSIGAM_ROUT_DEF_pairs_frame_struct {
 FMAPSIGAM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 TUPSIGAM_ROUT_DEF ret_val;
 FMAPSIGAM_ROUT_DEF L31;
 TUPSIGAM_ROUT_DEF r;
 struct FMAPSIGAM_ROUT_DEF_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGAM_ROUT_DEF_pairs_frame;

typedef struct FMAPSIGARG_LAYOUT_struct {/* layout for FMAP{SIG,ARG_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGARG_LAYOUT_struct arr_part[1];
 } *FMAPSIGARG_LAYOUT;


typedef struct FMAPSIGARG_LAYOUT_aeltb__frame_struct {
 FMAPSIGARG_LAYOUT self;/* Formal argument: self */
 INT state;
 TUPSIGARG_LAYOUT ret_val;
 INT i;
 } *FMAPSIGARG_LAYOUT_aeltb__frame;


typedef struct FMAPSIGARG_LAYOUT_target_frame_struct {
 FMAPSIGARG_LAYOUT self;/* Formal argument: self */
 INT state;
 ARG_LAYOUT ret_val;
 FMAPSIGARG_LAYOUT L31;
 TUPSIGARG_LAYOUT e;
 struct FMAPSIGARG_LAYOUT_aeltb__frame_struct *nested1; /* nested iter frame */
 } *FMAPSIGARG_LAYOUT_target_frame;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

#include "tags.h"

/* Globals */

extern FLT FLT_log2_e;
extern FSTR FLTD_fdbuf;
extern FSTR FLT_fbuf;
extern INT FMAPAM_BND_CREATE_EXPRBO12;
extern INT FMAPAM_LOCAL_EXPRAM_LOCA7;
extern INT FMAPAM_ROUT_DEFFLISTAM_I8;
extern INT FMAPAM_ROUT_DEFFRAME_LAY12;
extern INT FMAPIDENTAM_GLOBAL_EXPR_11;
extern INT FMAPIDENTdTP_load_ratio;
extern INT FMAPSIGABSTRACT_FRAME_LA12;
extern INT FMAPSIGAM_ROUT_DEF_load_;

/* Function declarations */

ABSTRACT_FRAME_LAYOUT FMAPSIGABSTRACT_FRAME_LA6(FMAPSIGABSTRACT_FRAME_LA, SIG);
AM_BND_CREATE_EXPR FMAPAM_BND_CREATE_EXPRBO7(FMAPAM_BND_CREATE_EXPRBO);
AM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_5(FMAPIDENTAM_GLOBAL_EXPR, IDENT);
AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA1(FMAPAM_LOCAL_EXPRAM_LOCA);
AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA19(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR);
AM_ROUT_DEF FMAPAM_ROUT_DEFFLISTAM_I2(FMAPAM_ROUT_DEFFLISTAM_I);
AM_ROUT_DEF FMAPAM_ROUT_DEFFRAME_LAY7(FMAPAM_ROUT_DEFFRAME_LAY);
AM_ROUT_DEF FMAPSIGAM_ROUT_DEF_get_S(FMAPSIGAM_ROUT_DEF, SIG);
ARG_LAYOUT FMAPSIGARG_LAYOUT_target(FMAPSIGARG_LAYOUT_target_frame);
ARRAYSTR ARRAYSTR_create_INT_ARRA(ARRAYSTR, INT);
ARRAYSTR FLISTSTR_array_ARRAYSTR(FLISTSTR);
BOOL FLISTSIG_is_empty_BOOL(FLISTSIG);
BOOL FLISTSTR_is_empty_BOOL(FLISTSTR);
BOOL FLISTdLAYOUT_is_empty_BO(FLISTdLAYOUT);
BOOL FMAPAM_BND_CREATE_EXPRBO11(FMAPAM_BND_CREATE_EXPRBO);
BOOL FMAPAM_BND_CREATE_EXPRBO18(FMAPAM_BND_CREATE_EXPRBO, INT, INT);
BOOL FMAPAM_BND_CREATE_EXPRBO4(FMAPAM_BND_CREATE_EXPRBO, AM_BND_CREATE_EXPR);
BOOL FMAPAM_BND_CREATE_EXPRBO5(FMAPAM_BND_CREATE_EXPRBO, AM_BND_CREATE_EXPR, AM_BND_CREATE_EXPR);
BOOL FMAPAM_LOCAL_EXPRAM_LOCA11(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR);
BOOL FMAPAM_LOCAL_EXPRAM_LOCA17(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR, AM_LOCAL_EXPR);
BOOL FMAPAM_LOCAL_EXPRAM_LOCA18(FMAPAM_LOCAL_EXPRAM_LOCA, INT, INT);
BOOL FMAPAM_LOCAL_EXPRAM_LOCA8(FMAPAM_LOCAL_EXPRAM_LOCA);
BOOL FMAPAM_ROUT_DEFFLISTAM_I11(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF);
BOOL FMAPAM_ROUT_DEFFLISTAM_I17(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF, AM_ROUT_DEF);
BOOL FMAPAM_ROUT_DEFFLISTAM_I18(FMAPAM_ROUT_DEFFLISTAM_I, INT, INT);
BOOL FMAPAM_ROUT_DEFFLISTAM_I7(FMAPAM_ROUT_DEFFLISTAM_I);
BOOL FMAPAM_ROUT_DEFFRAME_LAY11(FMAPAM_ROUT_DEFFRAME_LAY);
BOOL FMAPAM_ROUT_DEFFRAME_LAY18(FMAPAM_ROUT_DEFFRAME_LAY, INT, INT);
BOOL FMAPAM_ROUT_DEFFRAME_LAY4(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF);
BOOL FMAPAM_ROUT_DEFFRAME_LAY5(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF, AM_ROUT_DEF);
BOOL FMAPIDENTAM_GLOBAL_EXPR_10(FMAPIDENTAM_GLOBAL_EXPR);
BOOL FMAPIDENTAM_GLOBAL_EXPR_17(FMAPIDENTAM_GLOBAL_EXPR, INT, INT);
BOOL FMAPIDENTAM_GLOBAL_EXPR_3(FMAPIDENTAM_GLOBAL_EXPR, IDENT);
BOOL FMAPIDENTAM_GLOBAL_EXPR_4(FMAPIDENTAM_GLOBAL_EXPR, IDENT, IDENT);
BOOL FMAPIDENTdTP_is_key_nil_(FMAPIDENTdTP, IDENT);
BOOL FMAPIDENTdTP_key_eq_IDEN(FMAPIDENTdTP, IDENT, IDENT);
BOOL FMAPIDENTdTP_not_too_man(FMAPIDENTdTP, INT, INT);
BOOL FMAPIDENTdTP_should_grow(FMAPIDENTdTP);
BOOL FMAPSIGABSTRACT_FRAME_LA11(FMAPSIGABSTRACT_FRAME_LA);
BOOL FMAPSIGABSTRACT_FRAME_LA18(FMAPSIGABSTRACT_FRAME_LA, INT, INT);
BOOL FMAPSIGABSTRACT_FRAME_LA4(FMAPSIGABSTRACT_FRAME_LA, SIG);
BOOL FMAPSIGABSTRACT_FRAME_LA5(FMAPSIGABSTRACT_FRAME_LA, SIG, SIG);
BOOL FMAPSIGAM_ROUT_DEF_is_ke(FMAPSIGAM_ROUT_DEF, SIG);
BOOL FMAPSIGAM_ROUT_DEF_key_e(FMAPSIGAM_ROUT_DEF, SIG, SIG);
BOOL FMAPSIGAM_ROUT_DEF_not_t(FMAPSIGAM_ROUT_DEF, INT, INT);
BOOL FMAPSIGAM_ROUT_DEF_shoul(FMAPSIGAM_ROUT_DEF);
BOOL FMAPSIGARG_LAYOUT_is_key(FMAPSIGARG_LAYOUT, SIG);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL SIG_is_eq_SIG_BOOL(SIG, SIG);
BOUND_OBJECT_LAYOUT FMAPAM_BND_CREATE_EXPRBO19(FMAPAM_BND_CREATE_EXPRBO19_frame);
BOUND_OBJECT_LAYOUT FMAPAM_BND_CREATE_EXPRBO6(FMAPAM_BND_CREATE_EXPRBO, AM_BND_CREATE_EXPR);
ERR1 ERR_create_ERR(ERR1);
ERR1 ERR_plus_dSTR_ERR(ERR1, dSTR);
FLISTAM_ITER_CALL_EXPR FMAPAM_ROUT_DEFFLISTAM_I19(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF);
FLISTSFILE_ID FLISTSFILE_ID_push_SFILE(FLISTSFILE_ID, SFILE_ID);
FLISTSTR FLISTSTR_create_FLISTSTR(FLISTSTR);
FLISTSTR FLISTSTR_create_INT_FLIS(FLISTSTR, INT);
FLISTSTR FLISTSTR_push_STR_FLISTS(FLISTSTR, STR);
FLISTdAM_CONST FLISTdAM_CONST_push_dAM_(FLISTdAM_CONST, dAM_CONST);
FLISTdAM_EXPR FLISTdAM_EXPR_concat_FLI(FLISTdAM_EXPR, FLISTdAM_EXPR);
FLISTdAM_EXPR FLISTdAM_EXPR_push_dAM_E(FLISTdAM_EXPR, dAM_EXPR);
FLISTdAM_STMT FLISTdAM_STMT_create_INT(FLISTdAM_STMT, INT);
FLISTdAM_STMT FLISTdAM_STMT_push_dAM_S(FLISTdAM_STMT, dAM_STMT);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT, dLAYOUT);
FLISTdTP FLISTdTP_create_FLISTdTP(FLISTdTP);
FLISTdTP FLISTdTP_push_dTP_FLISTd(FLISTdTP, dTP);
FLT FLT_log2_FLT(FLT);
FLT FLT_log_FLT(FLT);
FLTD FLTD_floor_FLTD(FLTD);
FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO10(FMAPAM_BND_CREATE_EXPRBO, INT);
FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO15(FMAPAM_BND_CREATE_EXPRBO, TUPAM_BND_CREATE_EXPRBOU);
FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO16(FMAPAM_BND_CREATE_EXPRBO, AM_BND_CREATE_EXPR, BOUND_OBJECT_LAYOUT);
FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO17(FMAPAM_BND_CREATE_EXPRBO);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA13(FMAPAM_LOCAL_EXPRAM_LOCA, TUPAM_LOCAL_EXPRAM_LOCAL);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA14(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR, AM_LOCAL_EXPR);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA15(FMAPAM_LOCAL_EXPRAM_LOCA);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA5(FMAPAM_LOCAL_EXPRAM_LOCA, INT);
FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA6(FMAPAM_LOCAL_EXPRAM_LOCA, INT);
FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I1(FMAPAM_ROUT_DEFFLISTAM_I);
FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I13(FMAPAM_ROUT_DEFFLISTAM_I, TUPAM_ROUT_DEFFLISTAM_IT);
FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I14(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF, FLISTAM_ITER_CALL_EXPR);
FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I15(FMAPAM_ROUT_DEFFLISTAM_I);
FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I6(FMAPAM_ROUT_DEFFLISTAM_I, INT);
FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY10(FMAPAM_ROUT_DEFFRAME_LAY, INT);
FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY15(FMAPAM_ROUT_DEFFRAME_LAY, TUPAM_ROUT_DEFFRAME_LAYO);
FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY16(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF, FRAME_LAYOUT);
FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY17(FMAPAM_ROUT_DEFFRAME_LAY);
FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_14(FMAPIDENTAM_GLOBAL_EXPR, TUPIDENTAM_GLOBAL_EXPR);
FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_15(FMAPIDENTAM_GLOBAL_EXPR, IDENT, AM_GLOBAL_EXPR);
FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_16(FMAPIDENTAM_GLOBAL_EXPR);
FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_9(FMAPIDENTAM_GLOBAL_EXPR, INT);
FMAPIDENTdTP FMAPIDENTdTP_allocate_IN(FMAPIDENTdTP, INT);
FMAPIDENTdTP FMAPIDENTdTP_double_size(FMAPIDENTdTP);
FMAPIDENTdTP FMAPIDENTdTP_insert_IDEN(FMAPIDENTdTP, IDENT, dTP);
FMAPIDENTdTP FMAPIDENTdTP_insert_pair(FMAPIDENTdTP, TUPIDENTdTP);
FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA10(FMAPSIGABSTRACT_FRAME_LA, INT);
FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA15(FMAPSIGABSTRACT_FRAME_LA, TUPSIGABSTRACT_FRAME_LAY);
FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA16(FMAPSIGABSTRACT_FRAME_LA, SIG, ABSTRACT_FRAME_LAYOUT);
FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA17(FMAPSIGABSTRACT_FRAME_LA);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_alloc(FMAPSIGAM_ROUT_DEF, INT);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_creat(FMAPSIGAM_ROUT_DEF);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_doubl(FMAPSIGAM_ROUT_DEF);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_inser(FMAPSIGAM_ROUT_DEF, TUPSIGAM_ROUT_DEF);
FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_inser1(FMAPSIGAM_ROUT_DEF, SIG, AM_ROUT_DEF);
FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY19(FMAPAM_ROUT_DEFFRAME_LAY19_frame);
FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY6(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF);
FSTR FLTD_str_in_FSTR_FSTR(FLTD, FSTR);
FSTR FLT_str_in_FSTR_FSTR(FLT, FSTR);
FSTR FSTR_create_INT_FSTR(FSTR, INT);
FSTR FSTR_create_STR_FSTR(FSTR, STR);
FSTR FSTR_plus_STR_FSTR(FSTR, STR);
IDENT FMAPIDENTAM_GLOBAL_EXPR_6(FMAPIDENTAM_GLOBAL_EXPR);
IDENT FMAPIDENTdTP_key_nil_IDE(FMAPIDENTdTP);
INT FLISTSFILE_ID_asize_INT(FLISTSFILE_ID);
INT FLISTSFILE_ID_size_INT(FLISTSFILE_ID);
INT FLISTSIG_asize_INT(FLISTSIG);
INT FLISTSIG_size_INT(FLISTSIG);
INT FLISTSTR_asize_INT(FLISTSTR);
INT FLISTSTR_size_INT(FLISTSTR);
INT FLISTdAM_CONST_asize_INT(FLISTdAM_CONST);
INT FLISTdAM_CONST_size_INT(FLISTdAM_CONST);
INT FLISTdAM_EXPR_asize_INT(FLISTdAM_EXPR);
INT FLISTdAM_EXPR_size_INT(FLISTdAM_EXPR);
INT FLISTdAM_STMT_asize_INT(FLISTdAM_STMT);
INT FLISTdAM_STMT_size_INT(FLISTdAM_STMT);
INT FLISTdLAYOUT_asize_INT(FLISTdLAYOUT);
INT FLISTdLAYOUT_size_INT(FLISTdLAYOUT);
INT FLISTdTP_asize_INT(FLISTdTP);
INT FLISTdTP_indb_INT(FLISTdTP_indb_INT_frame);
INT FLISTdTP_size_INT(FLISTdTP);
INT FLTD_hash_INT(FLTD);
INT FLT_hash_INT(FLT);
INT FMAPAM_BND_CREATE_EXPRBO1(FMAPAM_BND_CREATE_EXPRBO, AM_BND_CREATE_EXPR);
INT FMAPAM_BND_CREATE_EXPRBO2(FMAPAM_BND_CREATE_EXPRBO);
INT FMAPAM_LOCAL_EXPRAM_LOCA16(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR);
INT FMAPAM_LOCAL_EXPRAM_LOCA2(FMAPAM_LOCAL_EXPRAM_LOCA);
INT FMAPAM_ROUT_DEFFLISTAM_I16(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF);
INT FMAPAM_ROUT_DEFFLISTAM_I3(FMAPAM_ROUT_DEFFLISTAM_I);
INT FMAPAM_ROUT_DEFFRAME_LAY1(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF);
INT FMAPAM_ROUT_DEFFRAME_LAY2(FMAPAM_ROUT_DEFFRAME_LAY);
INT FMAPIDENTAM_GLOBAL_EXPR_(FMAPIDENTAM_GLOBAL_EXPR, IDENT);
INT FMAPIDENTAM_GLOBAL_EXPR_1(FMAPIDENTAM_GLOBAL_EXPR);
INT FMAPIDENTdTP_asize_INT(FMAPIDENTdTP);
INT FMAPIDENTdTP_key_hash_ID(FMAPIDENTdTP, IDENT);
INT FMAPIDENTdTP_size_INT(FMAPIDENTdTP);
INT FMAPSIGABSTRACT_FRAME_LA1(FMAPSIGABSTRACT_FRAME_LA, SIG);
INT FMAPSIGABSTRACT_FRAME_LA2(FMAPSIGABSTRACT_FRAME_LA);
INT FMAPSIGAM_ROUT_DEF_asize(FMAPSIGAM_ROUT_DEF);
INT FMAPSIGAM_ROUT_DEF_key_h(FMAPSIGAM_ROUT_DEF, SIG);
INT FMAPSIGARG_LAYOUT_asize_(FMAPSIGARG_LAYOUT);
INT FSTR_size_INT(FSTR);
INT IDENT_hash_INT(IDENT);
INT INT_hash_INT(INT);
INT INT_highest_bit_INT(INT);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
SFILE_ID FLISTSFILE_ID_aeltb_INT_(FLISTSFILE_ID_aeltb_INT__frame);
SFILE_ID FLISTSFILE_ID_aget_INT_S(FLISTSFILE_ID, INT);
SFILE_ID FLISTSFILE_ID_aref_aget_(FLISTSFILE_ID, INT);
SFILE_ID FLISTSFILE_ID_eltb_SFILE(FLISTSFILE_ID_eltb_SFILE_frame);
SIG FLISTSIG_aeltb_INT_INT_S(FLISTSIG_aeltb_INT_INT_S_frame);
SIG FLISTSIG_aget_INT_SIG(FLISTSIG, INT);
SIG FLISTSIG_aref_aget_INT_S(FLISTSIG, INT);
SIG FLISTSIG_eltb_SIG(FLISTSIG_eltb_SIG_frame);
SIG FLISTSIG_pop_SIG(FLISTSIG);
SIG FMAPSIGABSTRACT_FRAME_LA7(FMAPSIGABSTRACT_FRAME_LA);
SIG FMAPSIGAM_ROUT_DEF_key_n(FMAPSIGAM_ROUT_DEF);
STR FLISTSFILE_ID_str_STR(FLISTSFILE_ID);
STR FLISTSIG_str_STR(FLISTSIG);
STR FLISTSTR_aeltb_INT_INT_S(FLISTSTR_aeltb_INT_INT_S_frame);
STR FLISTSTR_aget_INT_STR(FLISTSTR, INT);
STR FLISTSTR_aref_aget_INT_S(FLISTSTR, INT);
STR FLISTSTR_eltb_STR(FLISTSTR_eltb_STR_frame);
STR FLISTSTR_pop_STR(FLISTSTR);
STR FLISTSTR_str_STR(FLISTSTR);
STR FLISTSTR_top_STR(FLISTSTR);
STR FLISTdAM_CONST_str_STR(FLISTdAM_CONST);
STR FLISTdAM_EXPR_str_STR(FLISTdAM_EXPR);
STR FLISTdAM_STMT_str_STR(FLISTdAM_STMT);
STR FLISTdLAYOUT_str_STR(FLISTdLAYOUT);
STR FLISTdTP_str_STR(FLISTdTP);
STR FLTDX_str_STR(FLTDX);
STR FLTD_str_STR(FLTD);
STR FLTI_str_STR(FLTI);
STR FLTX_str_STR(FLTX);
STR FLT_str_STR(FLT);
STR FSTR_str_STR(FSTR);
STR INT_hex_str_STR(INT);
STR SFILE_ID_str_STR(SFILE_ID);
STR STR_pretty_STR(STR);
STR STR_separateb_STR_STR(STR_separateb_STR_STR_frame);
STR STR_str_STR(STR);
TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO13(FMAPAM_BND_CREATE_EXPRBO13_frame);
TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO14(FMAPAM_BND_CREATE_EXPRBO14_frame);
TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO3(FMAPAM_BND_CREATE_EXPRBO, INT);
TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU, AM_BND_CREATE_EXPR, BOUND_OBJECT_LAYOUT);
TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA10(FMAPAM_LOCAL_EXPRAM_LOCA10_frame);
TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA12(FMAPAM_LOCAL_EXPRAM_LOCA12_frame);
TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA9(FMAPAM_LOCAL_EXPRAM_LOCA, INT);
TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL, AM_LOCAL_EXPR, AM_LOCAL_EXPR);
TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I10(FMAPAM_ROUT_DEFFLISTAM_I10_frame);
TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I12(FMAPAM_ROUT_DEFFLISTAM_I12_frame);
TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I9(FMAPAM_ROUT_DEFFLISTAM_I, INT);
TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT, AM_ROUT_DEF, FLISTAM_ITER_CALL_EXPR);
TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY13(FMAPAM_ROUT_DEFFRAME_LAY13_frame);
TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY14(FMAPAM_ROUT_DEFFRAME_LAY14_frame);
TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY3(FMAPAM_ROUT_DEFFRAME_LAY, INT);
TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO, AM_ROUT_DEF, FRAME_LAYOUT);
TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_12(FMAPIDENTAM_GLOBAL_EXPR_12_frame);
TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_13(FMAPIDENTAM_GLOBAL_EXPR_13_frame);
TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_2(FMAPIDENTAM_GLOBAL_EXPR, INT);
TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR, IDENT, AM_GLOBAL_EXPR);
TUPIDENTdTP FMAPIDENTdTP_aeltb_TUPID(FMAPIDENTdTP_aeltb_TUPID_frame);
TUPIDENTdTP FMAPIDENTdTP_aget_INT_TU(FMAPIDENTdTP, INT);
TUPIDENTdTP FMAPIDENTdTP_pairsb_TUPI(FMAPIDENTdTP_pairsb_TUPI_frame);
TUPIDENTdTP TUPIDENTdTP_create_IDENT(TUPIDENTdTP, IDENT, dTP);
TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA13(FMAPSIGABSTRACT_FRAME_LA13_frame);
TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA14(FMAPSIGABSTRACT_FRAME_LA14_frame);
TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA3(FMAPSIGABSTRACT_FRAME_LA, INT);
TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY, SIG, ABSTRACT_FRAME_LAYOUT);
TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_aeltb(FMAPSIGAM_ROUT_DEF_aeltb_frame);
TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_aget_(FMAPSIGAM_ROUT_DEF, INT);
TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_pairs(FMAPSIGAM_ROUT_DEF_pairs_frame);
TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF, SIG, AM_ROUT_DEF);
TUPSIGARG_LAYOUT FMAPSIGARG_LAYOUT_aeltb_(FMAPSIGARG_LAYOUT_aeltb__frame);
TUPSIGARG_LAYOUT FMAPSIGARG_LAYOUT_aget_I(FMAPSIGARG_LAYOUT, INT);
dAM_CONST FLISTdAM_CONST_aeltb_INT(FLISTdAM_CONST_aeltb_INT_frame);
dAM_CONST FLISTdAM_CONST_aget_INT_(FLISTdAM_CONST, INT);
dAM_CONST FLISTdAM_CONST_aref_aget(FLISTdAM_CONST, INT);
dAM_CONST FLISTdAM_CONST_eltb_dAM_(FLISTdAM_CONST_eltb_dAM__frame);
dAM_EXPR FLISTdAM_EXPR_aeltb_INT_(FLISTdAM_EXPR_aeltb_INT__frame);
dAM_EXPR FLISTdAM_EXPR_aget_INT_d(FLISTdAM_EXPR, INT);
dAM_EXPR FLISTdAM_EXPR_aref_aget_(FLISTdAM_EXPR, INT);
dAM_EXPR FLISTdAM_EXPR_eltb_dAM_E(FLISTdAM_EXPR_eltb_dAM_E_frame);
dAM_STMT FLISTdAM_STMT_aeltb_INT_(FLISTdAM_STMT_aeltb_INT__frame);
dAM_STMT FLISTdAM_STMT_aget_INT_d(FLISTdAM_STMT, INT);
dAM_STMT FLISTdAM_STMT_aref_aget_(FLISTdAM_STMT, INT);
dAM_STMT FLISTdAM_STMT_eltb_dAM_S(FLISTdAM_STMT_eltb_dAM_S_frame);
dLAYOUT FLISTdLAYOUT_aeltb_INT_I(FLISTdLAYOUT_aeltb_INT_I_frame);
dLAYOUT FLISTdLAYOUT_aget_INT_dL(FLISTdLAYOUT, INT);
dLAYOUT FLISTdLAYOUT_aref_aget_I(FLISTdLAYOUT, INT);
dLAYOUT FLISTdLAYOUT_eltb_dLAYOU(FLISTdLAYOUT_eltb_dLAYOU_frame);
dTP FLISTdTP_aeltb_INT_INT_d(FLISTdTP_aeltb_INT_INT_d_frame);
dTP FLISTdTP_aget_INT_dTP(FLISTdTP, INT);
dTP FLISTdTP_aref_aget_INT_d(FLISTdTP, INT);
dTP FLISTdTP_eltb_dTP(FLISTdTP_eltb_dTP_frame);
dTP FMAPIDENTdTP_targetsb_dT(FMAPIDENTdTP_targetsb_dT_frame);
extern const int dLAYOUT_str_STR_offset;

extern const STR (*dLAYOUT_str_STR[])(dLAYOUT);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void ARRAYSTR_setb_STR(ARRAYSTR_setb_STR_frame);
void ERR_plus_dSTR(ERR1, dSTR);
void FLISTSFILE_ID_aref_aset_(FLISTSFILE_ID, INT, SFILE_ID);
void FLISTSFILE_ID_aset_INT_S(FLISTSFILE_ID, INT, SFILE_ID);
void FLISTSFILE_ID_asetb_SFIL(FLISTSFILE_ID_asetb_SFIL_frame);
void FLISTSIG_aref_aset_INT_S(FLISTSIG, INT, SIG);
void FLISTSIG_aset_INT_SIG(FLISTSIG, INT, SIG);
void FLISTSTR_aref_aset_INT_S(FLISTSTR, INT, STR);
void FLISTSTR_aset_INT_STR(FLISTSTR, INT, STR);
void FLISTSTR_asetb_STR(FLISTSTR_asetb_STR_frame);
void FLISTdAM_CONST_aref_aset(FLISTdAM_CONST, INT, dAM_CONST);
void FLISTdAM_CONST_aset_INT_(FLISTdAM_CONST, INT, dAM_CONST);
void FLISTdAM_CONST_asetb_dAM(FLISTdAM_CONST_asetb_dAM_frame);
void FLISTdAM_EXPR_aref_aset_(FLISTdAM_EXPR, INT, dAM_EXPR);
void FLISTdAM_EXPR_aset_INT_d(FLISTdAM_EXPR, INT, dAM_EXPR);
void FLISTdAM_EXPR_asetb_dAM_(FLISTdAM_EXPR_asetb_dAM__frame);
void FLISTdAM_STMT_aref_aset_(FLISTdAM_STMT, INT, dAM_STMT);
void FLISTdAM_STMT_aset_INT_d(FLISTdAM_STMT, INT, dAM_STMT);
void FLISTdAM_STMT_asetb_dAM_(FLISTdAM_STMT_asetb_dAM__frame);
void FLISTdLAYOUT_aref_aset_I(FLISTdLAYOUT, INT, dLAYOUT);
void FLISTdLAYOUT_aset_INT_dL(FLISTdLAYOUT, INT, dLAYOUT);
void FLISTdLAYOUT_asetb_dLAYO(FLISTdLAYOUT_asetb_dLAYO_frame);
void FLISTdTP_aref_aset_INT_d(FLISTdTP, INT, dTP);
void FLISTdTP_aset_INT_dTP(FLISTdTP, INT, dTP);
void FLISTdTP_asetb_dTP(FLISTdTP_asetb_dTP_frame);
void FLTD_fdbuf_FSTR(FLTD, FSTR);
void FLT_fbuf_FSTR(FLT, FSTR);
void FMAPAM_BND_CREATE_EXPRBO8(FMAPAM_BND_CREATE_EXPRBO, INT, TUPAM_BND_CREATE_EXPRBOU);
void FMAPAM_BND_CREATE_EXPRBO9(FMAPAM_BND_CREATE_EXPRBO9_frame);
void FMAPAM_LOCAL_EXPRAM_LOCA3(FMAPAM_LOCAL_EXPRAM_LOCA, INT, TUPAM_LOCAL_EXPRAM_LOCAL);
void FMAPAM_LOCAL_EXPRAM_LOCA4(FMAPAM_LOCAL_EXPRAM_LOCA4_frame);
void FMAPAM_ROUT_DEFFLISTAM_I4(FMAPAM_ROUT_DEFFLISTAM_I, INT, TUPAM_ROUT_DEFFLISTAM_IT);
void FMAPAM_ROUT_DEFFLISTAM_I5(FMAPAM_ROUT_DEFFLISTAM_I5_frame);
void FMAPAM_ROUT_DEFFRAME_LAY8(FMAPAM_ROUT_DEFFRAME_LAY, INT, TUPAM_ROUT_DEFFRAME_LAYO);
void FMAPAM_ROUT_DEFFRAME_LAY9(FMAPAM_ROUT_DEFFRAME_LAY9_frame);
void FMAPIDENTAM_GLOBAL_EXPR_7(FMAPIDENTAM_GLOBAL_EXPR, INT, TUPIDENTAM_GLOBAL_EXPR);
void FMAPIDENTAM_GLOBAL_EXPR_8(FMAPIDENTAM_GLOBAL_EXPR_8_frame);
void FMAPIDENTdTP_aset_INT_TU(FMAPIDENTdTP, INT, TUPIDENTdTP);
void FMAPIDENTdTP_asetb_TUPID(FMAPIDENTdTP_asetb_TUPID_frame);
void FMAPSIGABSTRACT_FRAME_LA8(FMAPSIGABSTRACT_FRAME_LA, INT, TUPSIGABSTRACT_FRAME_LAY);
void FMAPSIGABSTRACT_FRAME_LA9(FMAPSIGABSTRACT_FRAME_LA9_frame);
void FMAPSIGAM_ROUT_DEF_aset_(FMAPSIGAM_ROUT_DEF, INT, TUPSIGAM_ROUT_DEF);
void FMAPSIGAM_ROUT_DEF_asetb(FMAPSIGAM_ROUT_DEF_asetb_frame);
void OUT_plus_dSTR(OUT, dSTR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


_FM_F_F(log)

/* Code */




ABSTRACT_FRAME_LAYOUT FMAPSIGABSTRACT_FRAME_LA6(FMAPSIGABSTRACT_FRAME_LA self, SIG k) {
 ABSTRACT_FRAME_LAYOUT ret_val;
 INT h = ((INT) 0);
 SIG tk;
 SIG tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPSIGABSTRACT_FRAME_LA) NULL))) {
  ret_val = ((ABSTRACT_FRAME_LAYOUT) NULL);
  return ret_val;
 }
 L1 = FMAPSIGABSTRACT_FRAME_LA1(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPSIGABSTRACT_FRAME_LA3(self, h).t1;
  if (FMAPSIGABSTRACT_FRAME_LA4(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPSIGABSTRACT_FRAME_LA5(self, tk, k)) {
    ret_val = FMAPSIGABSTRACT_FRAME_LA3(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPSIGABSTRACT_FRAME_LA3(self, h).t1;
   if (FMAPSIGABSTRACT_FRAME_LA4(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPSIGABSTRACT_FRAME_LA5(self, tk1, k)) {
     ret_val = FMAPSIGABSTRACT_FRAME_LA3(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((ABSTRACT_FRAME_LAYOUT) NULL);
 return ret_val;
}


AM_BND_CREATE_EXPR FMAPAM_BND_CREATE_EXPRBO7(FMAPAM_BND_CREATE_EXPRBO self) {
 AM_BND_CREATE_EXPR ret_val;
 AM_BND_CREATE_EXPR k = ((AM_BND_CREATE_EXPR) NULL);
 ret_val = ((AM_BND_CREATE_EXPR) NULL);
 return ret_val;
}


AM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_5(FMAPIDENTAM_GLOBAL_EXPR self, IDENT k) {
 AM_GLOBAL_EXPR ret_val;
 INT h = ((INT) 0);
 IDENT tk = IDENT_zero;
 IDENT tk1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPIDENTAM_GLOBAL_EXPR) NULL))) {
  ret_val = ((AM_GLOBAL_EXPR) NULL);
  return ret_val;
 }
 L1 = FMAPIDENTAM_GLOBAL_EXPR_(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPIDENTAM_GLOBAL_EXPR_2(self, h).t1;
  if (FMAPIDENTAM_GLOBAL_EXPR_3(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPIDENTAM_GLOBAL_EXPR_4(self, tk, k)) {
    ret_val = FMAPIDENTAM_GLOBAL_EXPR_2(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPIDENTAM_GLOBAL_EXPR_2(self, h).t1;
   if (FMAPIDENTAM_GLOBAL_EXPR_3(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPIDENTAM_GLOBAL_EXPR_4(self, tk1, k)) {
     ret_val = FMAPIDENTAM_GLOBAL_EXPR_2(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((AM_GLOBAL_EXPR) NULL);
 return ret_val;
}


AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA19(FMAPAM_LOCAL_EXPRAM_LOCA self, AM_LOCAL_EXPR k) {
 AM_LOCAL_EXPR ret_val;
 INT h = ((INT) 0);
 AM_LOCAL_EXPR tk;
 AM_LOCAL_EXPR tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPAM_LOCAL_EXPRAM_LOCA) NULL))) {
  ret_val = ((AM_LOCAL_EXPR) NULL);
  return ret_val;
 }
 L1 = FMAPAM_LOCAL_EXPRAM_LOCA16(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPAM_LOCAL_EXPRAM_LOCA9(self, h).t1;
  if (FMAPAM_LOCAL_EXPRAM_LOCA11(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPAM_LOCAL_EXPRAM_LOCA17(self, tk, k)) {
    ret_val = FMAPAM_LOCAL_EXPRAM_LOCA9(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_LOCAL_EXPRAM_LOCA9(self, h).t1;
   if (FMAPAM_LOCAL_EXPRAM_LOCA11(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPAM_LOCAL_EXPRAM_LOCA17(self, tk1, k)) {
     ret_val = FMAPAM_LOCAL_EXPRAM_LOCA9(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((AM_LOCAL_EXPR) NULL);
 return ret_val;
}


AM_ROUT_DEF FMAPAM_ROUT_DEFFLISTAM_I2(FMAPAM_ROUT_DEFFLISTAM_I self) {
 AM_ROUT_DEF ret_val;
 AM_ROUT_DEF k = ((AM_ROUT_DEF) NULL);
 ret_val = ((AM_ROUT_DEF) NULL);
 return ret_val;
}


AM_ROUT_DEF FMAPAM_ROUT_DEFFRAME_LAY7(FMAPAM_ROUT_DEFFRAME_LAY self) {
 AM_ROUT_DEF ret_val;
 AM_ROUT_DEF k = ((AM_ROUT_DEF) NULL);
 ret_val = ((AM_ROUT_DEF) NULL);
 return ret_val;
}


AM_ROUT_DEF FMAPSIGAM_ROUT_DEF_get_S(FMAPSIGAM_ROUT_DEF self, SIG k) {
 AM_ROUT_DEF ret_val;
 INT h = ((INT) 0);
 SIG tk;
 SIG tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPSIGAM_ROUT_DEF) NULL))) {
  ret_val = ((AM_ROUT_DEF) NULL);
  return ret_val;
 }
 L1 = FMAPSIGAM_ROUT_DEF_key_h(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPSIGAM_ROUT_DEF_aget_(self, h).t1;
  if (FMAPSIGAM_ROUT_DEF_is_ke(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPSIGAM_ROUT_DEF_key_e(self, tk, k)) {
    ret_val = FMAPSIGAM_ROUT_DEF_aget_(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPSIGAM_ROUT_DEF_aget_(self, h).t1;
   if (FMAPSIGAM_ROUT_DEF_is_ke(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPSIGAM_ROUT_DEF_key_e(self, tk1, k)) {
     ret_val = FMAPSIGAM_ROUT_DEF_aget_(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((AM_ROUT_DEF) NULL);
 return ret_val;
}


ARG_LAYOUT FMAPSIGARG_LAYOUT_target(FMAPSIGARG_LAYOUT_target_frame frame) {
 ARG_LAYOUT dummy = ((ARG_LAYOUT) NULL);
 BOOL L1;
 TUPSIGARG_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPSIGARG_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPSIGARG_LAYOUT_aeltb__frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPSIGARG_LAYOUT_aeltb_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->e = L2;
    L4 = FMAPSIGARG_LAYOUT_is_key(frame->self, frame->e.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->e.t2;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


ARRAYSTR FLISTSTR_array_ARRAYSTR(FLISTSTR self) {
 ARRAYSTR ret_val;
 ARRAYSTR r;
 FLISTSTR L11;
 ARRAYSTR L21;
 STR L3;
 if ((self==((FLISTSTR) NULL))) {
  ret_val = ((ARRAYSTR) NULL);
  return ret_val;
 }
 r = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), ATTR(self,loc));
 {
  struct FLISTSTR_eltb_STR_frame_struct other1_0;
  FLISTSTR_eltb_STR_frame 
  noname1 = &other1_0;
  struct ARRAYSTR_setb_STR_frame_struct other1_1;
  ARRAYSTR_setb_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = r;
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L3 = FLISTSTR_eltb_STR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = L3;
   ARRAYSTR_setb_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   /* No return value from iter call */;
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


BOOL FLISTSIG_is_empty_BOOL(FLISTSIG self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTSIG_size_INT(self);
 ret_val = (L1==0);
 return ret_val;
}


BOOL FLISTSTR_is_empty_BOOL(FLISTSTR self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTSTR_size_INT(self);
 ret_val = (L1==0);
 return ret_val;
}


BOOL FLISTdLAYOUT_is_empty_BO(FLISTdLAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = FLISTdLAYOUT_size_INT(self);
 ret_val = (L1==0);
 return ret_val;
}


BOOL FMAPAM_BND_CREATE_EXPRBO11(FMAPAM_BND_CREATE_EXPRBO self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPAM_BND_CREATE_EXPRBO12;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPAM_BND_CREATE_EXPRBO18(FMAPAM_BND_CREATE_EXPRBO self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_BND_CREATE_EXPR k = ((AM_BND_CREATE_EXPR) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPAM_BND_CREATE_EXPRBOU L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPAM_BND_CREATE_EXPRBO3(self, start1);
  L6 = (OB)((TUPAM_BND_CREATE_EXPRBOU_boxed) rt_alloc(sizeof(struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct), TUPAM_BND_CREATE_EXPRBOU_tag));
  ((TUPAM_BND_CREATE_EXPRBOU_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPAM_BND_CREATE_EXPRBO4(FMAPAM_BND_CREATE_EXPRBO self, AM_BND_CREATE_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_BND_CREATE_EXPR) NULL));
 return ret_val;
}


BOOL FMAPAM_BND_CREATE_EXPRBO5(FMAPAM_BND_CREATE_EXPRBO self, AM_BND_CREATE_EXPR k1, AM_BND_CREATE_EXPR k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (k1==k2);
 return ret_val;
}


BOOL FMAPAM_LOCAL_EXPRAM_LOCA11(FMAPAM_LOCAL_EXPRAM_LOCA self, AM_LOCAL_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_LOCAL_EXPR) NULL));
 return ret_val;
}


BOOL FMAPAM_LOCAL_EXPRAM_LOCA17(FMAPAM_LOCAL_EXPRAM_LOCA self, AM_LOCAL_EXPR k1, AM_LOCAL_EXPR k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (k1==k2);
 return ret_val;
}


BOOL FMAPAM_LOCAL_EXPRAM_LOCA18(FMAPAM_LOCAL_EXPRAM_LOCA self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_LOCAL_EXPR k = ((AM_LOCAL_EXPR) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPAM_LOCAL_EXPRAM_LOCAL L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPAM_LOCAL_EXPRAM_LOCA9(self, start1);
  L6 = (OB)((TUPAM_LOCAL_EXPRAM_LOCAL_boxed) rt_alloc(sizeof(struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct), TUPAM_LOCAL_EXPRAM_LOCAL_tag));
  ((TUPAM_LOCAL_EXPRAM_LOCAL_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPAM_LOCAL_EXPRAM_LOCA8(FMAPAM_LOCAL_EXPRAM_LOCA self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPAM_LOCAL_EXPRAM_LOCA7;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFLISTAM_I11(FMAPAM_ROUT_DEFFLISTAM_I self, AM_ROUT_DEF e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_ROUT_DEF) NULL));
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFLISTAM_I17(FMAPAM_ROUT_DEFFLISTAM_I self, AM_ROUT_DEF k1, AM_ROUT_DEF k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (k1==k2);
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFLISTAM_I18(FMAPAM_ROUT_DEFFLISTAM_I self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_ROUT_DEF k = ((AM_ROUT_DEF) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPAM_ROUT_DEFFLISTAM_IT L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPAM_ROUT_DEFFLISTAM_I9(self, start1);
  L6 = (OB)((TUPAM_ROUT_DEFFLISTAM_IT_boxed) rt_alloc(sizeof(struct TUPAM_ROUT_DEFFLISTAM_IT_boxed_struct), TUPAM_ROUT_DEFFLISTAM_IT_tag));
  ((TUPAM_ROUT_DEFFLISTAM_IT_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFLISTAM_I7(FMAPAM_ROUT_DEFFLISTAM_I self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPAM_ROUT_DEFFLISTAM_I8;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFRAME_LAY11(FMAPAM_ROUT_DEFFRAME_LAY self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPAM_ROUT_DEFFRAME_LAY12;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFRAME_LAY18(FMAPAM_ROUT_DEFFRAME_LAY self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_ROUT_DEF k = ((AM_ROUT_DEF) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPAM_ROUT_DEFFRAME_LAYO L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPAM_ROUT_DEFFRAME_LAY3(self, start1);
  L6 = (OB)((TUPAM_ROUT_DEFFRAME_LAYO_boxed) rt_alloc(sizeof(struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct), TUPAM_ROUT_DEFFRAME_LAYO_tag));
  ((TUPAM_ROUT_DEFFRAME_LAYO_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFRAME_LAY4(FMAPAM_ROUT_DEFFRAME_LAY self, AM_ROUT_DEF e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_ROUT_DEF) NULL));
 return ret_val;
}


BOOL FMAPAM_ROUT_DEFFRAME_LAY5(FMAPAM_ROUT_DEFFRAME_LAY self, AM_ROUT_DEF k1, AM_ROUT_DEF k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (k1==k2);
 return ret_val;
}


BOOL FMAPIDENTAM_GLOBAL_EXPR_10(FMAPIDENTAM_GLOBAL_EXPR self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPIDENTAM_GLOBAL_EXPR_11;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPIDENTAM_GLOBAL_EXPR_17(FMAPIDENTAM_GLOBAL_EXPR self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 IDENT k = IDENT_zero;
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPIDENTAM_GLOBAL_EXPR L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPIDENTAM_GLOBAL_EXPR_2(self, start1);
  L6 = (OB)((TUPIDENTAM_GLOBAL_EXPR_boxed) rt_alloc(sizeof(struct TUPIDENTAM_GLOBAL_EXPR_boxed_struct), TUPIDENTAM_GLOBAL_EXPR_tag));
  ((TUPIDENTAM_GLOBAL_EXPR_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPIDENTAM_GLOBAL_EXPR_3(FMAPIDENTAM_GLOBAL_EXPR self, IDENT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e.str==(STR)0);
 return ret_val;
}


BOOL FMAPIDENTAM_GLOBAL_EXPR_4(FMAPIDENTAM_GLOBAL_EXPR self, IDENT k1, IDENT k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = IDENT_is_eq_IDENT_BOOL(k1, k2);
 return ret_val;
}


BOOL FMAPIDENTdTP_is_key_nil_(FMAPIDENTdTP self, IDENT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e.str==(STR)0);
 return ret_val;
}


BOOL FMAPIDENTdTP_key_eq_IDEN(FMAPIDENTdTP self, IDENT k1, IDENT k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = IDENT_is_eq_IDENT_BOOL(k1, k2);
 return ret_val;
}


BOOL FMAPIDENTdTP_not_too_man(FMAPIDENTdTP self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 IDENT k = IDENT_zero;
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L3;
 extern STR duetoabadhashfunctionint;
 ERR1 L4;
 TUPIDENTdTP L5;
 OB L6;
 INT L7;
 ERR1 L8;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L5 = FMAPIDENTdTP_aget_INT_TU(self, start1);
  L6 = (OB)((TUPIDENTdTP_boxed) rt_alloc(sizeof(struct TUPIDENTdTP_boxed_struct), TUPIDENTdTP_tag));
  ((TUPIDENTdTP_boxed) L6)->value_part = L5;
  L7 = (SYSTP(L6));
  L8 = ERR_plus_dSTR_ERR(L4, ((dSTR) (SYSSTRFORTP(L7))));
  ERR_plus_dSTR(L8, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPIDENTdTP_should_grow(FMAPIDENTdTP self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPIDENTdTP_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPSIGABSTRACT_FRAME_LA11(FMAPSIGABSTRACT_FRAME_LA self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPSIGABSTRACT_FRAME_LA12;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPSIGABSTRACT_FRAME_LA18(FMAPSIGABSTRACT_FRAME_LA self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 SIG k = ((SIG) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 SIG e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 SIG e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPSIGABSTRACT_FRAME_LAY L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 OUT L34;
 dSTR L35;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPSIGABSTRACT_FRAME_LA3(self, start1);
  L10 = (OB)((TUPSIGABSTRACT_FRAME_LAY_boxed) rt_alloc(sizeof(struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct), TUPSIGABSTRACT_FRAME_LAY_tag));
  ((TUPSIGABSTRACT_FRAME_LAY_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPSIGABSTRACT_FRAME_LA3(self, i).t1;
    h = FMAPSIGABSTRACT_FRAME_LA1(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR(ATTR(e,str))));
    L35 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L35)->value_part = '\n';
    OUT_plus_dSTR(L34, L35);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPSIGABSTRACT_FRAME_LA4(FMAPSIGABSTRACT_FRAME_LA self, SIG e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((SIG) NULL));
 return ret_val;
}


BOOL FMAPSIGABSTRACT_FRAME_LA5(FMAPSIGABSTRACT_FRAME_LA self, SIG k1, SIG k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = SIG_is_eq_SIG_BOOL(k1, k2);
 return ret_val;
}


BOOL FMAPSIGAM_ROUT_DEF_is_ke(FMAPSIGAM_ROUT_DEF self, SIG e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((SIG) NULL));
 return ret_val;
}


BOOL FMAPSIGAM_ROUT_DEF_key_e(FMAPSIGAM_ROUT_DEF self, SIG k1, SIG k2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = SIG_is_eq_SIG_BOOL(k1, k2);
 return ret_val;
}


BOOL FMAPSIGAM_ROUT_DEF_not_t(FMAPSIGAM_ROUT_DEF self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 SIG k = ((SIG) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 SIG e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 SIG e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPSIGAM_ROUT_DEF L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 OUT L34;
 dSTR L35;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPSIGAM_ROUT_DEF_aget_(self, start1);
  L10 = (OB)((TUPSIGAM_ROUT_DEF_boxed) rt_alloc(sizeof(struct TUPSIGAM_ROUT_DEF_boxed_struct), TUPSIGAM_ROUT_DEF_tag));
  ((TUPSIGAM_ROUT_DEF_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPSIGAM_ROUT_DEF_aget_(self, i).t1;
    h = FMAPSIGAM_ROUT_DEF_key_h(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR(ATTR(e,str))));
    L35 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L35)->value_part = '\n';
    OUT_plus_dSTR(L34, L35);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPSIGAM_ROUT_DEF_shoul(FMAPSIGAM_ROUT_DEF self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPSIGAM_ROUT_DEF_load_;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPSIGARG_LAYOUT_is_key(FMAPSIGARG_LAYOUT self, SIG e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((SIG) NULL));
 return ret_val;
}


BOUND_OBJECT_LAYOUT FMAPAM_BND_CREATE_EXPRBO19(FMAPAM_BND_CREATE_EXPRBO19_frame frame) {
 BOUND_OBJECT_LAYOUT dummy = ((BOUND_OBJECT_LAYOUT) NULL);
 BOOL L1;
 TUPAM_BND_CREATE_EXPRBOU L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_BND_CREATE_EXPRBO) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_BND_CREATE_EXPRBO13_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_BND_CREATE_EXPRBO13(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->e = L2;
    L4 = FMAPAM_BND_CREATE_EXPRBO4(frame->self, frame->e.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->e.t2;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


BOUND_OBJECT_LAYOUT FMAPAM_BND_CREATE_EXPRBO6(FMAPAM_BND_CREATE_EXPRBO self, AM_BND_CREATE_EXPR k) {
 BOUND_OBJECT_LAYOUT ret_val;
 INT h = ((INT) 0);
 AM_BND_CREATE_EXPR tk;
 AM_BND_CREATE_EXPR tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPAM_BND_CREATE_EXPRBO) NULL))) {
  ret_val = ((BOUND_OBJECT_LAYOUT) NULL);
  return ret_val;
 }
 L1 = FMAPAM_BND_CREATE_EXPRBO1(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPAM_BND_CREATE_EXPRBO3(self, h).t1;
  if (FMAPAM_BND_CREATE_EXPRBO4(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPAM_BND_CREATE_EXPRBO5(self, tk, k)) {
    ret_val = FMAPAM_BND_CREATE_EXPRBO3(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_BND_CREATE_EXPRBO3(self, h).t1;
   if (FMAPAM_BND_CREATE_EXPRBO4(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPAM_BND_CREATE_EXPRBO5(self, tk1, k)) {
     ret_val = FMAPAM_BND_CREATE_EXPRBO3(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((BOUND_OBJECT_LAYOUT) NULL);
 return ret_val;
}


FLISTAM_ITER_CALL_EXPR FMAPAM_ROUT_DEFFLISTAM_I19(FMAPAM_ROUT_DEFFLISTAM_I self, AM_ROUT_DEF k) {
 FLISTAM_ITER_CALL_EXPR ret_val;
 INT h = ((INT) 0);
 AM_ROUT_DEF tk;
 AM_ROUT_DEF tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPAM_ROUT_DEFFLISTAM_I) NULL))) {
  ret_val = ((FLISTAM_ITER_CALL_EXPR) NULL);
  return ret_val;
 }
 L1 = FMAPAM_ROUT_DEFFLISTAM_I16(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPAM_ROUT_DEFFLISTAM_I9(self, h).t1;
  if (FMAPAM_ROUT_DEFFLISTAM_I11(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPAM_ROUT_DEFFLISTAM_I17(self, tk, k)) {
    ret_val = FMAPAM_ROUT_DEFFLISTAM_I9(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_ROUT_DEFFLISTAM_I9(self, h).t1;
   if (FMAPAM_ROUT_DEFFLISTAM_I11(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPAM_ROUT_DEFFLISTAM_I17(self, tk1, k)) {
     ret_val = FMAPAM_ROUT_DEFFLISTAM_I9(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((FLISTAM_ITER_CALL_EXPR) NULL);
 return ret_val;
}


FLISTSFILE_ID FLISTSFILE_ID_push_SFILE(FLISTSFILE_ID self, SFILE_ID e) {
 FLISTSFILE_ID ret_val;
 FLISTSFILE_ID r = ((FLISTSFILE_ID) NULL);
 FLISTSFILE_ID L11;
 FLISTSFILE_ID L21;
 FLISTSFILE_ID L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTSFILE_ID L7;
 INT L8;
 INT L9;
 SFILE_ID L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTSFILE_ID) NULL))) {
  L4 = 5;
  L3 = ((FLISTSFILE_ID) rt_arr_alloc_atomic(sizeof(struct FLISTSFILE_ID_struct), FLISTSFILE_ID_tag, sizeof(SFILE_ID) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTSFILE_ID) rt_arr_alloc_atomic(sizeof(struct FLISTSFILE_ID_struct), FLISTSFILE_ID_tag, sizeof(SFILE_ID) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTSFILE_ID_eltb_SFILE_frame_struct other1_0;
    FLISTSFILE_ID_eltb_SFILE_frame 
    noname1 = &other1_0;
    struct FLISTSFILE_ID_asetb_SFIL_frame_struct other1_1;
    FLISTSFILE_ID_asetb_SFIL_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTSFILE_ID_eltb_SFILE(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTSFILE_ID_asetb_SFIL(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTSFILE_ID_aset_INT_S(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTSTR FLISTSTR_create_FLISTSTR(FLISTSTR self) {
 FLISTSTR ret_val;
 ret_val = ((FLISTSTR) NULL);
 return ret_val;
}


FLISTSTR FLISTSTR_create_INT_FLIS(FLISTSTR self, INT n) {
 FLISTSTR ret_val;
 FLISTSTR L1;
 INT L2;
 if ((n==0)) {
  ret_val = ((FLISTSTR) NULL);
  return ret_val;
 }
 else {
  L2 = n;
  L1 = ((FLISTSTR) rt_arr_alloc(sizeof(struct FLISTSTR_struct), FLISTSTR_tag, sizeof(STR) , L2));
  L1->asize = L2;
  ret_val = L1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTSTR FLISTSTR_push_STR_FLISTS(FLISTSTR self, STR e) {
 FLISTSTR ret_val;
 FLISTSTR r = ((FLISTSTR) NULL);
 FLISTSTR L11;
 FLISTSTR L21;
 FLISTSTR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTSTR L7;
 INT L8;
 INT L9;
 STR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTSTR) NULL))) {
  L4 = 5;
  L3 = ((FLISTSTR) rt_arr_alloc(sizeof(struct FLISTSTR_struct), FLISTSTR_tag, sizeof(STR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTSTR) rt_arr_alloc(sizeof(struct FLISTSTR_struct), FLISTSTR_tag, sizeof(STR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTSTR_eltb_STR_frame_struct other1_0;
    FLISTSTR_eltb_STR_frame 
    noname1 = &other1_0;
    struct FLISTSTR_asetb_STR_frame_struct other1_1;
    FLISTSTR_asetb_STR_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTSTR_eltb_STR(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTSTR_asetb_STR(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTSTR_aset_INT_STR(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdAM_CONST FLISTdAM_CONST_push_dAM_(FLISTdAM_CONST self, dAM_CONST e) {
 FLISTdAM_CONST ret_val;
 FLISTdAM_CONST r = ((FLISTdAM_CONST) NULL);
 FLISTdAM_CONST L11;
 FLISTdAM_CONST L21;
 FLISTdAM_CONST L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTdAM_CONST L7;
 INT L8;
 INT L9;
 dAM_CONST L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTdAM_CONST) NULL))) {
  L4 = 5;
  L3 = ((FLISTdAM_CONST) rt_arr_alloc(sizeof(struct FLISTdAM_CONST_struct), FLISTdAM_CONST_tag, sizeof(dAM_CONST) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTdAM_CONST) rt_arr_alloc(sizeof(struct FLISTdAM_CONST_struct), FLISTdAM_CONST_tag, sizeof(dAM_CONST) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTdAM_CONST_eltb_dAM__frame_struct other1_0;
    FLISTdAM_CONST_eltb_dAM__frame 
    noname1 = &other1_0;
    struct FLISTdAM_CONST_asetb_dAM_frame_struct other1_1;
    FLISTdAM_CONST_asetb_dAM_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTdAM_CONST_eltb_dAM_(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTdAM_CONST_asetb_dAM(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTdAM_CONST_aset_INT_(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdAM_EXPR FLISTdAM_EXPR_concat_FLI(FLISTdAM_EXPR self, FLISTdAM_EXPR l) {
 FLISTdAM_EXPR ret_val;
 FLISTdAM_EXPR res;
 FLISTdAM_EXPR L11;
 BOOL L2;
 dAM_EXPR L3;
 res = self;
 L2 = (l==((FLISTdAM_EXPR) NULL));
 if ((!(L2))) {
  {
   struct FLISTdAM_EXPR_eltb_dAM_E_frame_struct other1_0;
   FLISTdAM_EXPR_eltb_dAM_E_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = l;
     noname1->self = L11;
    }
    L3 = FLISTdAM_EXPR_eltb_dAM_E(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    res = FLISTdAM_EXPR_push_dAM_E(res, L3);
   }
  }
  after_loop: ;
 }
 ret_val = res;
 return ret_val;
}


FLISTdAM_EXPR FLISTdAM_EXPR_push_dAM_E(FLISTdAM_EXPR self, dAM_EXPR e) {
 FLISTdAM_EXPR ret_val;
 FLISTdAM_EXPR r = ((FLISTdAM_EXPR) NULL);
 FLISTdAM_EXPR L11;
 FLISTdAM_EXPR L21;
 FLISTdAM_EXPR L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTdAM_EXPR L7;
 INT L8;
 INT L9;
 dAM_EXPR L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTdAM_EXPR) NULL))) {
  L4 = 5;
  L3 = ((FLISTdAM_EXPR) rt_arr_alloc(sizeof(struct FLISTdAM_EXPR_struct), FLISTdAM_EXPR_tag, sizeof(dAM_EXPR) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTdAM_EXPR) rt_arr_alloc(sizeof(struct FLISTdAM_EXPR_struct), FLISTdAM_EXPR_tag, sizeof(dAM_EXPR) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTdAM_EXPR_eltb_dAM_E_frame_struct other1_0;
    FLISTdAM_EXPR_eltb_dAM_E_frame 
    noname1 = &other1_0;
    struct FLISTdAM_EXPR_asetb_dAM__frame_struct other1_1;
    FLISTdAM_EXPR_asetb_dAM__frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTdAM_EXPR_eltb_dAM_E(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTdAM_EXPR_asetb_dAM_(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTdAM_EXPR_aset_INT_d(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdAM_STMT FLISTdAM_STMT_create_INT(FLISTdAM_STMT self, INT n) {
 FLISTdAM_STMT ret_val;
 FLISTdAM_STMT L1;
 INT L2;
 if ((n==0)) {
  ret_val = ((FLISTdAM_STMT) NULL);
  return ret_val;
 }
 else {
  L2 = n;
  L1 = ((FLISTdAM_STMT) rt_arr_alloc(sizeof(struct FLISTdAM_STMT_struct), FLISTdAM_STMT_tag, sizeof(dAM_STMT) , L2));
  L1->asize = L2;
  ret_val = L1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FLISTdAM_STMT FLISTdAM_STMT_push_dAM_S(FLISTdAM_STMT self, dAM_STMT e) {
 FLISTdAM_STMT ret_val;
 FLISTdAM_STMT r = ((FLISTdAM_STMT) NULL);
 FLISTdAM_STMT L11;
 FLISTdAM_STMT L21;
 FLISTdAM_STMT L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTdAM_STMT L7;
 INT L8;
 INT L9;
 dAM_STMT L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTdAM_STMT) NULL))) {
  L4 = 5;
  L3 = ((FLISTdAM_STMT) rt_arr_alloc(sizeof(struct FLISTdAM_STMT_struct), FLISTdAM_STMT_tag, sizeof(dAM_STMT) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTdAM_STMT) rt_arr_alloc(sizeof(struct FLISTdAM_STMT_struct), FLISTdAM_STMT_tag, sizeof(dAM_STMT) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other1_0;
    FLISTdAM_STMT_eltb_dAM_S_frame 
    noname1 = &other1_0;
    struct FLISTdAM_STMT_asetb_dAM__frame_struct other1_1;
    FLISTdAM_STMT_asetb_dAM__frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTdAM_STMT_eltb_dAM_S(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTdAM_STMT_asetb_dAM_(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTdAM_STMT_aset_INT_d(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT self) {
 FLISTdLAYOUT ret_val;
 ret_val = ((FLISTdLAYOUT) NULL);
 return ret_val;
}


FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT self, dLAYOUT e) {
 FLISTdLAYOUT ret_val;
 FLISTdLAYOUT r = ((FLISTdLAYOUT) NULL);
 FLISTdLAYOUT L11;
 FLISTdLAYOUT L21;
 FLISTdLAYOUT L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTdLAYOUT L7;
 INT L8;
 INT L9;
 dLAYOUT L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTdLAYOUT) NULL))) {
  L4 = 5;
  L3 = ((FLISTdLAYOUT) rt_arr_alloc(sizeof(struct FLISTdLAYOUT_struct), FLISTdLAYOUT_tag, sizeof(dLAYOUT) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTdLAYOUT) rt_arr_alloc(sizeof(struct FLISTdLAYOUT_struct), FLISTdLAYOUT_tag, sizeof(dLAYOUT) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other1_0;
    FLISTdLAYOUT_eltb_dLAYOU_frame 
    noname1 = &other1_0;
    struct FLISTdLAYOUT_asetb_dLAYO_frame_struct other1_1;
    FLISTdLAYOUT_asetb_dLAYO_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTdLAYOUT_eltb_dLAYOU(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTdLAYOUT_asetb_dLAYO(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTdLAYOUT_aset_INT_dL(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLISTdTP FLISTdTP_create_FLISTdTP(FLISTdTP self) {
 FLISTdTP ret_val;
 ret_val = ((FLISTdTP) NULL);
 return ret_val;
}


FLISTdTP FLISTdTP_push_dTP_FLISTd(FLISTdTP self, dTP e) {
 FLISTdTP ret_val;
 FLISTdTP r = ((FLISTdTP) NULL);
 FLISTdTP L11;
 FLISTdTP L21;
 FLISTdTP L3;
 INT L4;
 INT L5;
 INT L6;
 FLISTdTP L7;
 INT L8;
 INT L9;
 dTP L10;
 INT L12;
 INT L13;
 INT L14;
 if ((self==((FLISTdTP) NULL))) {
  L4 = 5;
  L3 = ((FLISTdTP) rt_arr_alloc(sizeof(struct FLISTdTP_struct), FLISTdTP_tag, sizeof(dTP) , L4));
  L3->asize = L4;
  r = L3;
 }
 else {
  L5 = ATTR(self,loc);
  L6 = (ASIZE(self));
  if ((L5<L6)) {
   r = self;
  }
  else {
   L9 = (ASIZE(self));
   L8 = (INTTIMES(2,L9));
   L7 = ((FLISTdTP) rt_arr_alloc(sizeof(struct FLISTdTP_struct), FLISTdTP_tag, sizeof(dTP) , L8));
   L7->asize = L8;
   r = L7;
   SATTR(r,loc,ATTR(self,loc));
   {
    struct FLISTdTP_eltb_dTP_frame_struct other1_0;
    FLISTdTP_eltb_dTP_frame 
    noname1 = &other1_0;
    struct FLISTdTP_asetb_dTP_frame_struct other1_1;
    FLISTdTP_asetb_dTP_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = r;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = self;
      noname1->self = L11;
     }
     L10 = FLISTdTP_eltb_dTP(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = L10;
     FLISTdTP_asetb_dTP(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   SYSDESTROY(((OB) self));
  }
 }
 L12 = ATTR(r,loc);
 SATTR(r,loc,(INTPLUS(L12,1)));
 L13 = ATTR(r,loc);
 L14 = (INTMINUS(L13,1));
 FLISTdTP_aset_INT_dTP(r, L14, e);
 ret_val = r;
 return ret_val;
}


FLT FLT_log2_FLT(FLT self) {
 FLT ret_val = ((FLT) 0);
 FLT L1;
 FLT L2;
 L1 = FLT_log_FLT(self);
 L2 = FLT_log2_e;
 ret_val = (L1*L2);
 return ret_val;
}


FLT FLT_log_FLT(FLT self) {
 FLT ret_val = ((FLT) 0);
 ret_val = r_log(self);
 return ret_val;
}


FLTD FLTD_floor_FLTD(FLTD self) {
 FLTD ret_val = ((FLTD) 0);
 ret_val = floor(self);
 return ret_val;
}


FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO10(FMAPAM_BND_CREATE_EXPRBO self, INT n) {
 FMAPAM_BND_CREATE_EXPRBO ret_val;
 FMAPAM_BND_CREATE_EXPRBO r;
 FMAPAM_BND_CREATE_EXPRBO L11;
 FMAPAM_BND_CREATE_EXPRBO L2;
 INT L3;
 BOOL L4;
 AM_BND_CREATE_EXPR L5;
 L3 = n;
 L2 = ((FMAPAM_BND_CREATE_EXPRBO) rt_arr_alloc(sizeof(struct FMAPAM_BND_CREATE_EXPRBO_struct), FMAPAM_BND_CREATE_EXPRBO_tag, sizeof(TUPAM_BND_CREATE_EXPRBOU) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPAM_BND_CREATE_EXPRBO7(self)==((AM_BND_CREATE_EXPR) NULL));
 if ((!(L4))) {
  {
   struct FMAPAM_BND_CREATE_EXPRBO9_frame_struct other1_0;
   FMAPAM_BND_CREATE_EXPRBO9_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPAM_BND_CREATE_EXPRBO7(self);
    noname1->arg1 = TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU_zero, L5, ((BOUND_OBJECT_LAYOUT) NULL));
    FMAPAM_BND_CREATE_EXPRBO9(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO15(FMAPAM_BND_CREATE_EXPRBO self, TUPAM_BND_CREATE_EXPRBOU p) {
 FMAPAM_BND_CREATE_EXPRBO ret_val;
 ret_val = FMAPAM_BND_CREATE_EXPRBO16(self, p.t1, p.t2);
 return ret_val;
}


FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO16(FMAPAM_BND_CREATE_EXPRBO self, AM_BND_CREATE_EXPR k, BOUND_OBJECT_LAYOUT t) {
 FMAPAM_BND_CREATE_EXPRBO ret_val;
 FMAPAM_BND_CREATE_EXPRBO r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 AM_BND_CREATE_EXPR tk;
 AM_BND_CREATE_EXPR tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPAM_BND_CREATE_EXPRBO) NULL))) {
  r = FMAPAM_BND_CREATE_EXPRBO10(self, 5);
 }
 else {
  if (FMAPAM_BND_CREATE_EXPRBO11(self)) {
   r = FMAPAM_BND_CREATE_EXPRBO17(self);
  }
 }
 L1 = FMAPAM_BND_CREATE_EXPRBO1(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPAM_BND_CREATE_EXPRBO3(r, h).t1;
  if (FMAPAM_BND_CREATE_EXPRBO4(self, tk)) {
   goto after_loop;
  }
  if (FMAPAM_BND_CREATE_EXPRBO5(self, tk, k)) {
   FMAPAM_BND_CREATE_EXPRBO8(r, h, TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_BND_CREATE_EXPRBO3(r, h).t1;
   if (FMAPAM_BND_CREATE_EXPRBO4(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPAM_BND_CREATE_EXPRBO5(self, tk1, k)) {
    FMAPAM_BND_CREATE_EXPRBO8(r, h, TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPAM_BND_CREATE_EXPRBO8(r, h, TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPAM_BND_CREATE_EXPRBO FMAPAM_BND_CREATE_EXPRBO17(FMAPAM_BND_CREATE_EXPRBO self) {
 FMAPAM_BND_CREATE_EXPRBO ret_val;
 INT ns = ((INT) 0);
 FMAPAM_BND_CREATE_EXPRBO r;
 FMAPAM_BND_CREATE_EXPRBO L11;
 INT L2;
 INT L3;
 INT L4;
 TUPAM_BND_CREATE_EXPRBOU L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPAM_BND_CREATE_EXPRBO10(self, ns);
 {
  struct FMAPAM_BND_CREATE_EXPRBO14_frame_struct other1_0;
  FMAPAM_BND_CREATE_EXPRBO14_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPAM_BND_CREATE_EXPRBO14(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPAM_BND_CREATE_EXPRBO15(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA13(FMAPAM_LOCAL_EXPRAM_LOCA self, TUPAM_LOCAL_EXPRAM_LOCAL p) {
 FMAPAM_LOCAL_EXPRAM_LOCA ret_val;
 ret_val = FMAPAM_LOCAL_EXPRAM_LOCA14(self, p.t1, p.t2);
 return ret_val;
}


FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA14(FMAPAM_LOCAL_EXPRAM_LOCA self, AM_LOCAL_EXPR k, AM_LOCAL_EXPR t) {
 FMAPAM_LOCAL_EXPRAM_LOCA ret_val;
 FMAPAM_LOCAL_EXPRAM_LOCA r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 AM_LOCAL_EXPR tk;
 AM_LOCAL_EXPR tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPAM_LOCAL_EXPRAM_LOCA) NULL))) {
  r = FMAPAM_LOCAL_EXPRAM_LOCA5(self, 5);
 }
 else {
  if (FMAPAM_LOCAL_EXPRAM_LOCA8(self)) {
   r = FMAPAM_LOCAL_EXPRAM_LOCA15(self);
  }
 }
 L1 = FMAPAM_LOCAL_EXPRAM_LOCA16(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPAM_LOCAL_EXPRAM_LOCA9(r, h).t1;
  if (FMAPAM_LOCAL_EXPRAM_LOCA11(self, tk)) {
   goto after_loop;
  }
  if (FMAPAM_LOCAL_EXPRAM_LOCA17(self, tk, k)) {
   FMAPAM_LOCAL_EXPRAM_LOCA3(r, h, TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_LOCAL_EXPRAM_LOCA9(r, h).t1;
   if (FMAPAM_LOCAL_EXPRAM_LOCA11(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPAM_LOCAL_EXPRAM_LOCA17(self, tk1, k)) {
    FMAPAM_LOCAL_EXPRAM_LOCA3(r, h, TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPAM_LOCAL_EXPRAM_LOCA3(r, h, TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA15(FMAPAM_LOCAL_EXPRAM_LOCA self) {
 FMAPAM_LOCAL_EXPRAM_LOCA ret_val;
 INT ns = ((INT) 0);
 FMAPAM_LOCAL_EXPRAM_LOCA r;
 FMAPAM_LOCAL_EXPRAM_LOCA L11;
 INT L2;
 INT L3;
 INT L4;
 TUPAM_LOCAL_EXPRAM_LOCAL L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPAM_LOCAL_EXPRAM_LOCA5(self, ns);
 {
  struct FMAPAM_LOCAL_EXPRAM_LOCA12_frame_struct other1_0;
  FMAPAM_LOCAL_EXPRAM_LOCA12_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPAM_LOCAL_EXPRAM_LOCA12(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPAM_LOCAL_EXPRAM_LOCA13(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA5(FMAPAM_LOCAL_EXPRAM_LOCA self, INT n) {
 FMAPAM_LOCAL_EXPRAM_LOCA ret_val;
 FMAPAM_LOCAL_EXPRAM_LOCA r;
 FMAPAM_LOCAL_EXPRAM_LOCA L11;
 FMAPAM_LOCAL_EXPRAM_LOCA L2;
 INT L3;
 BOOL L4;
 AM_LOCAL_EXPR L5;
 L3 = n;
 L2 = ((FMAPAM_LOCAL_EXPRAM_LOCA) rt_arr_alloc(sizeof(struct FMAPAM_LOCAL_EXPRAM_LOCA_struct), FMAPAM_LOCAL_EXPRAM_LOCA_tag, sizeof(TUPAM_LOCAL_EXPRAM_LOCAL) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPAM_LOCAL_EXPRAM_LOCA1(self)==((AM_LOCAL_EXPR) NULL));
 if ((!(L4))) {
  {
   struct FMAPAM_LOCAL_EXPRAM_LOCA4_frame_struct other1_0;
   FMAPAM_LOCAL_EXPRAM_LOCA4_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPAM_LOCAL_EXPRAM_LOCA1(self);
    noname1->arg1 = TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL_zero, L5, ((AM_LOCAL_EXPR) NULL));
    FMAPAM_LOCAL_EXPRAM_LOCA4(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPAM_LOCAL_EXPRAM_LOCA FMAPAM_LOCAL_EXPRAM_LOCA6(FMAPAM_LOCAL_EXPRAM_LOCA self, INT n) {
 FMAPAM_LOCAL_EXPRAM_LOCA ret_val;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 L1 = FMAPAM_LOCAL_EXPRAM_LOCA7;
 L2 = (INTTIMES(3,L1));
 L3 = (INTTIMES(L2,n));
 L4 = INT_highest_bit_INT((INTDIV(L3,4)));
 L5 = (INTPLUS(L4,1));
 L6 = (((unsigned)1<<(unsigned)L5));
 ret_val = FMAPAM_LOCAL_EXPRAM_LOCA5(self, (INTPLUS(L6,1)));
 return ret_val;
}


FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I13(FMAPAM_ROUT_DEFFLISTAM_I self, TUPAM_ROUT_DEFFLISTAM_IT p) {
 FMAPAM_ROUT_DEFFLISTAM_I ret_val;
 ret_val = FMAPAM_ROUT_DEFFLISTAM_I14(self, p.t1, p.t2);
 return ret_val;
}


FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I14(FMAPAM_ROUT_DEFFLISTAM_I self, AM_ROUT_DEF k, FLISTAM_ITER_CALL_EXPR t) {
 FMAPAM_ROUT_DEFFLISTAM_I ret_val;
 FMAPAM_ROUT_DEFFLISTAM_I r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 AM_ROUT_DEF tk;
 AM_ROUT_DEF tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPAM_ROUT_DEFFLISTAM_I) NULL))) {
  r = FMAPAM_ROUT_DEFFLISTAM_I6(self, 5);
 }
 else {
  if (FMAPAM_ROUT_DEFFLISTAM_I7(self)) {
   r = FMAPAM_ROUT_DEFFLISTAM_I15(self);
  }
 }
 L1 = FMAPAM_ROUT_DEFFLISTAM_I16(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPAM_ROUT_DEFFLISTAM_I9(r, h).t1;
  if (FMAPAM_ROUT_DEFFLISTAM_I11(self, tk)) {
   goto after_loop;
  }
  if (FMAPAM_ROUT_DEFFLISTAM_I17(self, tk, k)) {
   FMAPAM_ROUT_DEFFLISTAM_I4(r, h, TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_ROUT_DEFFLISTAM_I9(r, h).t1;
   if (FMAPAM_ROUT_DEFFLISTAM_I11(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPAM_ROUT_DEFFLISTAM_I17(self, tk1, k)) {
    FMAPAM_ROUT_DEFFLISTAM_I4(r, h, TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPAM_ROUT_DEFFLISTAM_I4(r, h, TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I15(FMAPAM_ROUT_DEFFLISTAM_I self) {
 FMAPAM_ROUT_DEFFLISTAM_I ret_val;
 INT ns = ((INT) 0);
 FMAPAM_ROUT_DEFFLISTAM_I r;
 FMAPAM_ROUT_DEFFLISTAM_I L11;
 INT L2;
 INT L3;
 INT L4;
 TUPAM_ROUT_DEFFLISTAM_IT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPAM_ROUT_DEFFLISTAM_I6(self, ns);
 {
  struct FMAPAM_ROUT_DEFFLISTAM_I12_frame_struct other1_0;
  FMAPAM_ROUT_DEFFLISTAM_I12_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPAM_ROUT_DEFFLISTAM_I12(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPAM_ROUT_DEFFLISTAM_I13(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I6(FMAPAM_ROUT_DEFFLISTAM_I self, INT n) {
 FMAPAM_ROUT_DEFFLISTAM_I ret_val;
 FMAPAM_ROUT_DEFFLISTAM_I r;
 FMAPAM_ROUT_DEFFLISTAM_I L11;
 FMAPAM_ROUT_DEFFLISTAM_I L2;
 INT L3;
 BOOL L4;
 AM_ROUT_DEF L5;
 L3 = n;
 L2 = ((FMAPAM_ROUT_DEFFLISTAM_I) rt_arr_alloc(sizeof(struct FMAPAM_ROUT_DEFFLISTAM_I_struct), FMAPAM_ROUT_DEFFLISTAM_I_tag, sizeof(TUPAM_ROUT_DEFFLISTAM_IT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPAM_ROUT_DEFFLISTAM_I2(self)==((AM_ROUT_DEF) NULL));
 if ((!(L4))) {
  {
   struct FMAPAM_ROUT_DEFFLISTAM_I5_frame_struct other1_0;
   FMAPAM_ROUT_DEFFLISTAM_I5_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPAM_ROUT_DEFFLISTAM_I2(self);
    noname1->arg1 = TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT_zero, L5, ((FLISTAM_ITER_CALL_EXPR) NULL));
    FMAPAM_ROUT_DEFFLISTAM_I5(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY10(FMAPAM_ROUT_DEFFRAME_LAY self, INT n) {
 FMAPAM_ROUT_DEFFRAME_LAY ret_val;
 FMAPAM_ROUT_DEFFRAME_LAY r;
 FMAPAM_ROUT_DEFFRAME_LAY L11;
 FMAPAM_ROUT_DEFFRAME_LAY L2;
 INT L3;
 BOOL L4;
 AM_ROUT_DEF L5;
 L3 = n;
 L2 = ((FMAPAM_ROUT_DEFFRAME_LAY) rt_arr_alloc(sizeof(struct FMAPAM_ROUT_DEFFRAME_LAY_struct), FMAPAM_ROUT_DEFFRAME_LAY_tag, sizeof(TUPAM_ROUT_DEFFRAME_LAYO) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPAM_ROUT_DEFFRAME_LAY7(self)==((AM_ROUT_DEF) NULL));
 if ((!(L4))) {
  {
   struct FMAPAM_ROUT_DEFFRAME_LAY9_frame_struct other1_0;
   FMAPAM_ROUT_DEFFRAME_LAY9_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPAM_ROUT_DEFFRAME_LAY7(self);
    noname1->arg1 = TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO_zero, L5, ((FRAME_LAYOUT) NULL));
    FMAPAM_ROUT_DEFFRAME_LAY9(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY15(FMAPAM_ROUT_DEFFRAME_LAY self, TUPAM_ROUT_DEFFRAME_LAYO p) {
 FMAPAM_ROUT_DEFFRAME_LAY ret_val;
 ret_val = FMAPAM_ROUT_DEFFRAME_LAY16(self, p.t1, p.t2);
 return ret_val;
}


FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY16(FMAPAM_ROUT_DEFFRAME_LAY self, AM_ROUT_DEF k, FRAME_LAYOUT t) {
 FMAPAM_ROUT_DEFFRAME_LAY ret_val;
 FMAPAM_ROUT_DEFFRAME_LAY r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 AM_ROUT_DEF tk;
 AM_ROUT_DEF tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPAM_ROUT_DEFFRAME_LAY) NULL))) {
  r = FMAPAM_ROUT_DEFFRAME_LAY10(self, 5);
 }
 else {
  if (FMAPAM_ROUT_DEFFRAME_LAY11(self)) {
   r = FMAPAM_ROUT_DEFFRAME_LAY17(self);
  }
 }
 L1 = FMAPAM_ROUT_DEFFRAME_LAY1(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPAM_ROUT_DEFFRAME_LAY3(r, h).t1;
  if (FMAPAM_ROUT_DEFFRAME_LAY4(self, tk)) {
   goto after_loop;
  }
  if (FMAPAM_ROUT_DEFFRAME_LAY5(self, tk, k)) {
   FMAPAM_ROUT_DEFFRAME_LAY8(r, h, TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_ROUT_DEFFRAME_LAY3(r, h).t1;
   if (FMAPAM_ROUT_DEFFRAME_LAY4(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPAM_ROUT_DEFFRAME_LAY5(self, tk1, k)) {
    FMAPAM_ROUT_DEFFRAME_LAY8(r, h, TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPAM_ROUT_DEFFRAME_LAY8(r, h, TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY17(FMAPAM_ROUT_DEFFRAME_LAY self) {
 FMAPAM_ROUT_DEFFRAME_LAY ret_val;
 INT ns = ((INT) 0);
 FMAPAM_ROUT_DEFFRAME_LAY r;
 FMAPAM_ROUT_DEFFRAME_LAY L11;
 INT L2;
 INT L3;
 INT L4;
 TUPAM_ROUT_DEFFRAME_LAYO L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPAM_ROUT_DEFFRAME_LAY10(self, ns);
 {
  struct FMAPAM_ROUT_DEFFRAME_LAY14_frame_struct other1_0;
  FMAPAM_ROUT_DEFFRAME_LAY14_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPAM_ROUT_DEFFRAME_LAY14(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPAM_ROUT_DEFFRAME_LAY15(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_14(FMAPIDENTAM_GLOBAL_EXPR self, TUPIDENTAM_GLOBAL_EXPR p) {
 FMAPIDENTAM_GLOBAL_EXPR ret_val;
 ret_val = FMAPIDENTAM_GLOBAL_EXPR_15(self, p.t1, p.t2);
 return ret_val;
}


FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_15(FMAPIDENTAM_GLOBAL_EXPR self, IDENT k, AM_GLOBAL_EXPR t) {
 FMAPIDENTAM_GLOBAL_EXPR ret_val;
 FMAPIDENTAM_GLOBAL_EXPR r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 IDENT tk = IDENT_zero;
 IDENT tk1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPIDENTAM_GLOBAL_EXPR) NULL))) {
  r = FMAPIDENTAM_GLOBAL_EXPR_9(self, 5);
 }
 else {
  if (FMAPIDENTAM_GLOBAL_EXPR_10(self)) {
   r = FMAPIDENTAM_GLOBAL_EXPR_16(self);
  }
 }
 L1 = FMAPIDENTAM_GLOBAL_EXPR_(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPIDENTAM_GLOBAL_EXPR_2(r, h).t1;
  if (FMAPIDENTAM_GLOBAL_EXPR_3(self, tk)) {
   goto after_loop;
  }
  if (FMAPIDENTAM_GLOBAL_EXPR_4(self, tk, k)) {
   FMAPIDENTAM_GLOBAL_EXPR_7(r, h, TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPIDENTAM_GLOBAL_EXPR_2(r, h).t1;
   if (FMAPIDENTAM_GLOBAL_EXPR_3(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPIDENTAM_GLOBAL_EXPR_4(self, tk1, k)) {
    FMAPIDENTAM_GLOBAL_EXPR_7(r, h, TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPIDENTAM_GLOBAL_EXPR_7(r, h, TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_16(FMAPIDENTAM_GLOBAL_EXPR self) {
 FMAPIDENTAM_GLOBAL_EXPR ret_val;
 INT ns = ((INT) 0);
 FMAPIDENTAM_GLOBAL_EXPR r;
 FMAPIDENTAM_GLOBAL_EXPR L11;
 INT L2;
 INT L3;
 INT L4;
 TUPIDENTAM_GLOBAL_EXPR L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPIDENTAM_GLOBAL_EXPR_9(self, ns);
 {
  struct FMAPIDENTAM_GLOBAL_EXPR_13_frame_struct other1_0;
  FMAPIDENTAM_GLOBAL_EXPR_13_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPIDENTAM_GLOBAL_EXPR_13(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPIDENTAM_GLOBAL_EXPR_14(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_9(FMAPIDENTAM_GLOBAL_EXPR self, INT n) {
 FMAPIDENTAM_GLOBAL_EXPR ret_val;
 FMAPIDENTAM_GLOBAL_EXPR r;
 FMAPIDENTAM_GLOBAL_EXPR L11;
 FMAPIDENTAM_GLOBAL_EXPR L2;
 INT L3;
 BOOL L4;
 IDENT L5;
 L3 = n;
 L2 = ((FMAPIDENTAM_GLOBAL_EXPR) rt_arr_alloc(sizeof(struct FMAPIDENTAM_GLOBAL_EXPR_struct), FMAPIDENTAM_GLOBAL_EXPR_tag, sizeof(TUPIDENTAM_GLOBAL_EXPR) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPIDENTAM_GLOBAL_EXPR_6(self).str==(STR)0);
 if ((!(L4))) {
  {
   struct FMAPIDENTAM_GLOBAL_EXPR_8_frame_struct other1_0;
   FMAPIDENTAM_GLOBAL_EXPR_8_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPIDENTAM_GLOBAL_EXPR_6(self);
    noname1->arg1 = TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR_zero, L5, ((AM_GLOBAL_EXPR) NULL));
    FMAPIDENTAM_GLOBAL_EXPR_8(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPIDENTdTP FMAPIDENTdTP_allocate_IN(FMAPIDENTdTP self, INT n) {
 FMAPIDENTdTP ret_val;
 FMAPIDENTdTP r;
 FMAPIDENTdTP L11;
 FMAPIDENTdTP L2;
 INT L3;
 BOOL L4;
 IDENT L5;
 L3 = n;
 L2 = ((FMAPIDENTdTP) rt_arr_alloc(sizeof(struct FMAPIDENTdTP_struct), FMAPIDENTdTP_tag, sizeof(TUPIDENTdTP) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPIDENTdTP_key_nil_IDE(self).str==(STR)0);
 if ((!(L4))) {
  {
   struct FMAPIDENTdTP_asetb_TUPID_frame_struct other1_0;
   FMAPIDENTdTP_asetb_TUPID_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPIDENTdTP_key_nil_IDE(self);
    noname1->arg1 = TUPIDENTdTP_create_IDENT(TUPIDENTdTP_zero, L5, ((dTP) NULL));
    FMAPIDENTdTP_asetb_TUPID(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPIDENTdTP FMAPIDENTdTP_double_size(FMAPIDENTdTP self) {
 FMAPIDENTdTP ret_val;
 INT ns = ((INT) 0);
 FMAPIDENTdTP r;
 FMAPIDENTdTP L11;
 INT L2;
 INT L3;
 INT L4;
 TUPIDENTdTP L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPIDENTdTP_allocate_IN(self, ns);
 {
  struct FMAPIDENTdTP_pairsb_TUPI_frame_struct other1_0;
  FMAPIDENTdTP_pairsb_TUPI_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPIDENTdTP_pairsb_TUPI(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPIDENTdTP_insert_pair(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPIDENTdTP FMAPIDENTdTP_insert_IDEN(FMAPIDENTdTP self, IDENT k, dTP t) {
 FMAPIDENTdTP ret_val;
 FMAPIDENTdTP r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 IDENT tk = IDENT_zero;
 IDENT tk1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPIDENTdTP) NULL))) {
  r = FMAPIDENTdTP_allocate_IN(self, 5);
 }
 else {
  if (FMAPIDENTdTP_should_grow(self)) {
   r = FMAPIDENTdTP_double_size(self);
  }
 }
 L1 = FMAPIDENTdTP_key_hash_ID(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPIDENTdTP_aget_INT_TU(r, h).t1;
  if (FMAPIDENTdTP_is_key_nil_(self, tk)) {
   goto after_loop;
  }
  if (FMAPIDENTdTP_key_eq_IDEN(self, tk, k)) {
   FMAPIDENTdTP_aset_INT_TU(r, h, TUPIDENTdTP_create_IDENT(TUPIDENTdTP_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPIDENTdTP_aget_INT_TU(r, h).t1;
   if (FMAPIDENTdTP_is_key_nil_(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPIDENTdTP_key_eq_IDEN(self, tk1, k)) {
    FMAPIDENTdTP_aset_INT_TU(r, h, TUPIDENTdTP_create_IDENT(TUPIDENTdTP_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPIDENTdTP_aset_INT_TU(r, h, TUPIDENTdTP_create_IDENT(TUPIDENTdTP_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPIDENTdTP FMAPIDENTdTP_insert_pair(FMAPIDENTdTP self, TUPIDENTdTP p) {
 FMAPIDENTdTP ret_val;
 ret_val = FMAPIDENTdTP_insert_IDEN(self, p.t1, p.t2);
 return ret_val;
}


FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA10(FMAPSIGABSTRACT_FRAME_LA self, INT n) {
 FMAPSIGABSTRACT_FRAME_LA ret_val;
 FMAPSIGABSTRACT_FRAME_LA r;
 FMAPSIGABSTRACT_FRAME_LA L11;
 FMAPSIGABSTRACT_FRAME_LA L2;
 INT L3;
 BOOL L4;
 SIG L5;
 L3 = n;
 L2 = ((FMAPSIGABSTRACT_FRAME_LA) rt_arr_alloc(sizeof(struct FMAPSIGABSTRACT_FRAME_LA_struct), FMAPSIGABSTRACT_FRAME_LA_tag, sizeof(TUPSIGABSTRACT_FRAME_LAY) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPSIGABSTRACT_FRAME_LA7(self)==((SIG) NULL));
 if ((!(L4))) {
  {
   struct FMAPSIGABSTRACT_FRAME_LA9_frame_struct other1_0;
   FMAPSIGABSTRACT_FRAME_LA9_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPSIGABSTRACT_FRAME_LA7(self);
    noname1->arg1 = TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY_zero, L5, ((ABSTRACT_FRAME_LAYOUT) NULL));
    FMAPSIGABSTRACT_FRAME_LA9(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA15(FMAPSIGABSTRACT_FRAME_LA self, TUPSIGABSTRACT_FRAME_LAY p) {
 FMAPSIGABSTRACT_FRAME_LA ret_val;
 ret_val = FMAPSIGABSTRACT_FRAME_LA16(self, p.t1, p.t2);
 return ret_val;
}


FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA16(FMAPSIGABSTRACT_FRAME_LA self, SIG k, ABSTRACT_FRAME_LAYOUT t) {
 FMAPSIGABSTRACT_FRAME_LA ret_val;
 FMAPSIGABSTRACT_FRAME_LA r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 SIG tk;
 SIG tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPSIGABSTRACT_FRAME_LA) NULL))) {
  r = FMAPSIGABSTRACT_FRAME_LA10(self, 5);
 }
 else {
  if (FMAPSIGABSTRACT_FRAME_LA11(self)) {
   r = FMAPSIGABSTRACT_FRAME_LA17(self);
  }
 }
 L1 = FMAPSIGABSTRACT_FRAME_LA1(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPSIGABSTRACT_FRAME_LA3(r, h).t1;
  if (FMAPSIGABSTRACT_FRAME_LA4(self, tk)) {
   goto after_loop;
  }
  if (FMAPSIGABSTRACT_FRAME_LA5(self, tk, k)) {
   FMAPSIGABSTRACT_FRAME_LA8(r, h, TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPSIGABSTRACT_FRAME_LA3(r, h).t1;
   if (FMAPSIGABSTRACT_FRAME_LA4(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPSIGABSTRACT_FRAME_LA5(self, tk1, k)) {
    FMAPSIGABSTRACT_FRAME_LA8(r, h, TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPSIGABSTRACT_FRAME_LA8(r, h, TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPSIGABSTRACT_FRAME_LA FMAPSIGABSTRACT_FRAME_LA17(FMAPSIGABSTRACT_FRAME_LA self) {
 FMAPSIGABSTRACT_FRAME_LA ret_val;
 INT ns = ((INT) 0);
 FMAPSIGABSTRACT_FRAME_LA r;
 FMAPSIGABSTRACT_FRAME_LA L11;
 INT L2;
 INT L3;
 INT L4;
 TUPSIGABSTRACT_FRAME_LAY L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPSIGABSTRACT_FRAME_LA10(self, ns);
 {
  struct FMAPSIGABSTRACT_FRAME_LA14_frame_struct other1_0;
  FMAPSIGABSTRACT_FRAME_LA14_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPSIGABSTRACT_FRAME_LA14(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPSIGABSTRACT_FRAME_LA15(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_alloc(FMAPSIGAM_ROUT_DEF self, INT n) {
 FMAPSIGAM_ROUT_DEF ret_val;
 FMAPSIGAM_ROUT_DEF r;
 FMAPSIGAM_ROUT_DEF L11;
 FMAPSIGAM_ROUT_DEF L2;
 INT L3;
 BOOL L4;
 SIG L5;
 L3 = n;
 L2 = ((FMAPSIGAM_ROUT_DEF) rt_arr_alloc(sizeof(struct FMAPSIGAM_ROUT_DEF_struct), FMAPSIGAM_ROUT_DEF_tag, sizeof(TUPSIGAM_ROUT_DEF) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPSIGAM_ROUT_DEF_key_n(self)==((SIG) NULL));
 if ((!(L4))) {
  {
   struct FMAPSIGAM_ROUT_DEF_asetb_frame_struct other1_0;
   FMAPSIGAM_ROUT_DEF_asetb_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPSIGAM_ROUT_DEF_key_n(self);
    noname1->arg1 = TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF_zero, L5, ((AM_ROUT_DEF) NULL));
    FMAPSIGAM_ROUT_DEF_asetb(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_doubl(FMAPSIGAM_ROUT_DEF self) {
 FMAPSIGAM_ROUT_DEF ret_val;
 INT ns = ((INT) 0);
 FMAPSIGAM_ROUT_DEF r;
 FMAPSIGAM_ROUT_DEF L11;
 INT L2;
 INT L3;
 INT L4;
 TUPSIGAM_ROUT_DEF L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPSIGAM_ROUT_DEF_alloc(self, ns);
 {
  struct FMAPSIGAM_ROUT_DEF_pairs_frame_struct other1_0;
  FMAPSIGAM_ROUT_DEF_pairs_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPSIGAM_ROUT_DEF_pairs(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPSIGAM_ROUT_DEF_inser(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_inser(FMAPSIGAM_ROUT_DEF self, TUPSIGAM_ROUT_DEF p) {
 FMAPSIGAM_ROUT_DEF ret_val;
 ret_val = FMAPSIGAM_ROUT_DEF_inser1(self, p.t1, p.t2);
 return ret_val;
}


FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_inser1(FMAPSIGAM_ROUT_DEF self, SIG k, AM_ROUT_DEF t) {
 FMAPSIGAM_ROUT_DEF ret_val;
 FMAPSIGAM_ROUT_DEF r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 SIG tk;
 SIG tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPSIGAM_ROUT_DEF) NULL))) {
  r = FMAPSIGAM_ROUT_DEF_alloc(self, 5);
 }
 else {
  if (FMAPSIGAM_ROUT_DEF_shoul(self)) {
   r = FMAPSIGAM_ROUT_DEF_doubl(self);
  }
 }
 L1 = FMAPSIGAM_ROUT_DEF_key_h(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPSIGAM_ROUT_DEF_aget_(r, h).t1;
  if (FMAPSIGAM_ROUT_DEF_is_ke(self, tk)) {
   goto after_loop;
  }
  if (FMAPSIGAM_ROUT_DEF_key_e(self, tk, k)) {
   FMAPSIGAM_ROUT_DEF_aset_(r, h, TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPSIGAM_ROUT_DEF_aget_(r, h).t1;
   if (FMAPSIGAM_ROUT_DEF_is_ke(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPSIGAM_ROUT_DEF_key_e(self, tk1, k)) {
    FMAPSIGAM_ROUT_DEF_aset_(r, h, TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPSIGAM_ROUT_DEF_aset_(r, h, TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY19(FMAPAM_ROUT_DEFFRAME_LAY19_frame frame) {
 FRAME_LAYOUT dummy = ((FRAME_LAYOUT) NULL);
 BOOL L1;
 TUPAM_ROUT_DEFFRAME_LAYO L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_ROUT_DEFFRAME_LAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_ROUT_DEFFRAME_LAY13_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_ROUT_DEFFRAME_LAY13(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->e = L2;
    L4 = FMAPAM_ROUT_DEFFRAME_LAY4(frame->self, frame->e.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->e.t2;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY6(FMAPAM_ROUT_DEFFRAME_LAY self, AM_ROUT_DEF k) {
 FRAME_LAYOUT ret_val;
 INT h = ((INT) 0);
 AM_ROUT_DEF tk;
 AM_ROUT_DEF tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPAM_ROUT_DEFFRAME_LAY) NULL))) {
  ret_val = ((FRAME_LAYOUT) NULL);
  return ret_val;
 }
 L1 = FMAPAM_ROUT_DEFFRAME_LAY1(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPAM_ROUT_DEFFRAME_LAY3(self, h).t1;
  if (FMAPAM_ROUT_DEFFRAME_LAY4(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPAM_ROUT_DEFFRAME_LAY5(self, tk, k)) {
    ret_val = FMAPAM_ROUT_DEFFRAME_LAY3(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPAM_ROUT_DEFFRAME_LAY3(self, h).t1;
   if (FMAPAM_ROUT_DEFFRAME_LAY4(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPAM_ROUT_DEFFRAME_LAY5(self, tk1, k)) {
     ret_val = FMAPAM_ROUT_DEFFRAME_LAY3(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((FRAME_LAYOUT) NULL);
 return ret_val;
}


FSTR FLTD_str_in_FSTR_FSTR(FLTD self, FSTR arg) {
 FSTR ret_val;
 FSTR store_in = ((FSTR) NULL);
 INT sz = ((INT) 0);
 INT L1;
 L1 = FSTR_size_INT(arg);
 if ((L1>=30)) {
  store_in = arg;
 }
 else {
  store_in = FSTR_create_INT_FSTR(((FSTR) NULL), 30);
 }
 sz = (FLTDSTORE(self,store_in));
 SATTR(store_in,loc,sz);
 ret_val = store_in;
 return ret_val;
}


FSTR FLT_str_in_FSTR_FSTR(FLT self, FSTR arg) {
 FSTR ret_val;
 FSTR store_in = ((FSTR) NULL);
 INT sz = ((INT) 0);
 INT L1;
 L1 = FSTR_size_INT(arg);
 if ((L1>=30)) {
  store_in = arg;
 }
 else {
  store_in = FSTR_create_INT_FSTR(((FSTR) NULL), 30);
 }
 sz = (FLTSTORE(self,store_in));
 SATTR(store_in,loc,sz);
 ret_val = store_in;
 return ret_val;
}


IDENT FMAPIDENTAM_GLOBAL_EXPR_6(FMAPIDENTAM_GLOBAL_EXPR self) {
 IDENT ret_val = IDENT_zero;
 IDENT k = IDENT_zero;
 ret_val = IDENT_zero;
 return ret_val;
}


INT FLISTSFILE_ID_size_INT(FLISTSFILE_ID self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTSFILE_ID) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTSIG_size_INT(FLISTSIG self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTSIG) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTSTR_size_INT(FLISTSTR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTSTR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTdAM_CONST_size_INT(FLISTdAM_CONST self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTdAM_CONST) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTdAM_EXPR_size_INT(FLISTdAM_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTdAM_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTdAM_STMT_size_INT(FLISTdAM_STMT self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTdAM_STMT) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTdLAYOUT_size_INT(FLISTdLAYOUT self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTdLAYOUT) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLISTdTP_indb_INT(FLISTdTP_indb_INT_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 INT L2;
 INT L5;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdTP) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(INT_uptob_INT_INT_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = 0;
     L5 = ATTR(frame->self,loc);
     frame->L41 = (INTMINUS(L5,1));
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
    }
    L2 = INT_uptob_INT_INT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT FLISTdTP_size_INT(FLISTdTP self) {
 INT ret_val = ((INT) 0);
 if ((self==((FLISTdTP) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,loc);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FLTD_hash_INT(FLTD self) {
 INT ret_val = ((INT) 0);
 FLTD L1;
 L1 = (FLTDTRUNCATE(self));
 ret_val = (FLTDINT(L1));
 return ret_val;
}


INT FLT_hash_INT(FLT self) {
 INT ret_val = ((INT) 0);
 FLT L1;
 L1 = (FLTTRUNCATE(self));
 ret_val = (FLTINT(L1));
 return ret_val;
}


INT FMAPAM_BND_CREATE_EXPRBO2(FMAPAM_BND_CREATE_EXPRBO self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPAM_LOCAL_EXPRAM_LOCA16(FMAPAM_LOCAL_EXPRAM_LOCA self, AM_LOCAL_EXPR k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}


INT FMAPAM_LOCAL_EXPRAM_LOCA2(FMAPAM_LOCAL_EXPRAM_LOCA self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPAM_ROUT_DEFFLISTAM_I16(FMAPAM_ROUT_DEFFLISTAM_I self, AM_ROUT_DEF k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}


INT FMAPAM_ROUT_DEFFLISTAM_I3(FMAPAM_ROUT_DEFFLISTAM_I self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPAM_ROUT_DEFFRAME_LAY2(FMAPAM_ROUT_DEFFRAME_LAY self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPIDENTAM_GLOBAL_EXPR_1(FMAPIDENTAM_GLOBAL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPIDENTdTP_asize_INT(FMAPIDENTdTP self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPIDENTdTP_key_hash_ID(FMAPIDENTdTP self, IDENT k) {
 INT ret_val = ((INT) 0);
 ret_val = IDENT_hash_INT(k);
 return ret_val;
}


INT FMAPIDENTdTP_size_INT(FMAPIDENTdTP self) {
 INT ret_val = ((INT) 0);
 if ((self==((FMAPIDENTdTP) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,hsize);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FMAPSIGABSTRACT_FRAME_LA2(FMAPSIGABSTRACT_FRAME_LA self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPSIGAM_ROUT_DEF_asize(FMAPSIGAM_ROUT_DEF self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPSIGAM_ROUT_DEF_key_h(FMAPSIGAM_ROUT_DEF self, SIG k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}


SFILE_ID FLISTSFILE_ID_aeltb_INT_(FLISTSFILE_ID_aeltb_INT__frame frame) {
 SFILE_ID dummy = SFILE_ID_zero;
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTSFILE_ID_aget_INT_S(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


SFILE_ID FLISTSFILE_ID_aget_INT_S(FLISTSFILE_ID self, INT ind) {
 SFILE_ID ret_val = SFILE_ID_zero;
 ret_val = FLISTSFILE_ID_aref_aget_(self, ind);
 return ret_val;
}


SFILE_ID FLISTSFILE_ID_aref_aget_(FLISTSFILE_ID self, INT ind) {
 SFILE_ID ret_val = SFILE_ID_zero;
 return ARR(self,ind);
}


SFILE_ID FLISTSFILE_ID_eltb_SFILE(FLISTSFILE_ID_eltb_SFILE_frame frame) {
 SFILE_ID dummy = SFILE_ID_zero;
 BOOL L1;
 SFILE_ID L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTSFILE_ID) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTSFILE_ID_aeltb_INT__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTSFILE_ID_aeltb_INT_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


SIG FLISTSIG_aeltb_INT_INT_S(FLISTSIG_aeltb_INT_INT_S_frame frame) {
 SIG dummy = ((SIG) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTSIG_aget_INT_SIG(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


SIG FLISTSIG_aget_INT_SIG(FLISTSIG self, INT ind) {
 SIG ret_val;
 ret_val = FLISTSIG_aref_aget_INT_S(self, ind);
 return ret_val;
}


SIG FLISTSIG_aref_aget_INT_S(FLISTSIG self, INT ind) {
 SIG ret_val;
 return ARR(self,ind);
}


SIG FLISTSIG_eltb_SIG(FLISTSIG_eltb_SIG_frame frame) {
 SIG dummy = ((SIG) NULL);
 BOOL L1;
 SIG L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTSIG) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTSIG_aeltb_INT_INT_S_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTSIG_aeltb_INT_INT_S(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


SIG FLISTSIG_pop_SIG(FLISTSIG self) {
 SIG ret_val;
 SIG r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTSIG_size_INT(self);
 if ((L1==0)) {
  ret_val = ((SIG) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTSIG_aget_INT_SIG(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTSIG_aset_INT_SIG(self, L4, ((SIG) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


SIG FMAPSIGABSTRACT_FRAME_LA7(FMAPSIGABSTRACT_FRAME_LA self) {
 SIG ret_val;
 SIG k = ((SIG) NULL);
 ret_val = ((SIG) NULL);
 return ret_val;
}


SIG FMAPSIGAM_ROUT_DEF_key_n(FMAPSIGAM_ROUT_DEF self) {
 SIG ret_val;
 SIG k = ((SIG) NULL);
 ret_val = ((SIG) NULL);
 return ret_val;
}


STR FLISTSFILE_ID_str_STR(FLISTSFILE_ID self) {
 STR ret_val;
 FSTR res;
 FLISTSFILE_ID L11;
 SFILE_ID e = SFILE_ID_zero;
 STR L21;
 STR L31;
 extern STR name1;
 SFILE_ID L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTSFILE_ID_eltb_SFILE_frame_struct other1_0;
  FLISTSFILE_ID_eltb_SFILE_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTSFILE_ID_eltb_SFILE(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = SFILE_ID_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTSIG_str_STR(FLISTSIG self) {
 STR ret_val;
 FSTR res;
 FLISTSIG L11;
 SIG e;
 STR L21;
 STR L31;
 extern STR name1;
 SIG L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTSIG_eltb_SIG_frame_struct other1_0;
  FLISTSIG_eltb_SIG_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTSIG_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = ATTR(e,str);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTSTR_aeltb_INT_INT_S(FLISTSTR_aeltb_INT_INT_S_frame frame) {
 STR dummy = ((STR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTSTR_aget_INT_STR(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


STR FLISTSTR_aget_INT_STR(FLISTSTR self, INT ind) {
 STR ret_val;
 ret_val = FLISTSTR_aref_aget_INT_S(self, ind);
 return ret_val;
}


STR FLISTSTR_aref_aget_INT_S(FLISTSTR self, INT ind) {
 STR ret_val;
 return ARR(self,ind);
}


STR FLISTSTR_eltb_STR(FLISTSTR_eltb_STR_frame frame) {
 STR dummy = ((STR) NULL);
 BOOL L1;
 STR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTSTR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTSTR_aeltb_INT_INT_S_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTSTR_aeltb_INT_INT_S(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


STR FLISTSTR_pop_STR(FLISTSTR self) {
 STR ret_val;
 STR r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = FLISTSTR_size_INT(self);
 if ((L1==0)) {
  ret_val = ((STR) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 r = FLISTSTR_aget_INT_STR(self, (INTMINUS(L2,1)));
 L3 = ATTR(self,loc);
 L4 = (INTMINUS(L3,1));
 FLISTSTR_aset_INT_STR(self, L4, ((STR) NULL));
 L5 = ATTR(self,loc);
 SATTR(self,loc,(INTMINUS(L5,1)));
 ret_val = r;
 return ret_val;
}


STR FLISTSTR_str_STR(FLISTSTR self) {
 STR ret_val;
 FSTR res;
 FLISTSTR L11;
 STR e;
 STR L21;
 STR L31;
 extern STR name1;
 STR L4;
 STR L5;
 extern STR name2;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTSTR_eltb_STR_frame_struct other1_0;
  FLISTSTR_eltb_STR_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTSTR_eltb_STR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = STR_str_STR(e);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTSTR_top_STR(FLISTSTR self) {
 STR ret_val;
 INT L1;
 INT L2;
 L1 = FLISTSTR_size_INT(self);
 if ((L1==0)) {
  ret_val = ((STR) NULL);
  return ret_val;
 }
 L2 = ATTR(self,loc);
 ret_val = FLISTSTR_aget_INT_STR(self, (INTMINUS(L2,1)));
 return ret_val;
}


STR FLISTdAM_CONST_str_STR(FLISTdAM_CONST self) {
 STR ret_val;
 FSTR res;
 FLISTdAM_CONST L11;
 dAM_CONST e;
 STR L21;
 extern STR name1;
 dAM_CONST L3;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTdAM_CONST_eltb_dAM__frame_struct other1_0;
  FLISTdAM_CONST_eltb_dAM__frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L3 = FLISTdAM_CONST_eltb_dAM_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L3;
   if (e==NULL) {
   } else
   switch (TAG(e)) {
    default: ;
   }
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTdAM_EXPR_str_STR(FLISTdAM_EXPR self) {
 STR ret_val;
 FSTR res;
 FLISTdAM_EXPR L11;
 dAM_EXPR e;
 STR L21;
 extern STR name1;
 dAM_EXPR L3;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTdAM_EXPR_eltb_dAM_E_frame_struct other1_0;
  FLISTdAM_EXPR_eltb_dAM_E_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L3 = FLISTdAM_EXPR_eltb_dAM_E(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L3;
   if (e==NULL) {
   } else
   switch (TAG(e)) {
    default: ;
   }
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTdAM_STMT_str_STR(FLISTdAM_STMT self) {
 STR ret_val;
 FSTR res;
 FLISTdAM_STMT L11;
 dAM_STMT e;
 STR L21;
 extern STR name1;
 dAM_STMT L3;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other1_0;
  FLISTdAM_STMT_eltb_dAM_S_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L3 = FLISTdAM_STMT_eltb_dAM_S(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L3;
   if (e==NULL) {
   } else
   switch (TAG(e)) {
    default: ;
   }
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTdLAYOUT_str_STR(FLISTdLAYOUT self) {
 STR ret_val;
 FSTR res;
 FLISTdLAYOUT L11;
 dLAYOUT e;
 STR L21;
 STR L31;
 extern STR name1;
 dLAYOUT L4;
 STR L5;
 extern STR name2;
 dLAYOUT L6;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTdLAYOUT_eltb_dLAYOU_frame_struct other1_0;
  FLISTdLAYOUT_eltb_dLAYOU_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTdLAYOUT_eltb_dLAYOU(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   L6 = e;
   if (L6==NULL) {
    FATAL("Dispatch on void in FLIST{$LAYOUT}::str:STR");
   }
   noname2->arg1 = (*dLAYOUT_str_STR[TAG(L6)+dLAYOUT_str_STR_offset])(L6);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLISTdTP_str_STR(FLISTdTP self) {
 STR ret_val;
 FSTR res;
 FLISTdTP L11;
 dTP e;
 STR L21;
 STR L31;
 extern STR name1;
 dTP L4;
 STR L5;
 extern STR name2;
 dTP L6;
 res = FSTR_create_STR_FSTR(((FSTR) NULL), ((STR) &name1));
 {
  struct FLISTdTP_eltb_dTP_frame_struct other1_0;
  FLISTdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  struct STR_separateb_STR_STR_frame_struct other1_2;
  STR_separateb_STR_STR_frame 
  noname3 = &other1_2;
  noname1->state = 0;
  noname2->state = 0;
  noname3->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L4 = FLISTdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L4;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   L6 = e;
   if (L6==NULL) {
    FATAL("Dispatch on void in FLIST{$TP}::str:STR");
   }
   noname2->arg1 = (*dTP_str_STR[TAG(L6)+dTP_str_STR_offset])(L6);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   res = FSTR_plus_STR_FSTR(res, L5);
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR FLTD_str_STR(FLTD self) {
 STR ret_val;
 FSTR fstr;
 BOOL L1;
 INT L2;
 if ((FLTD_fdbuf==((FSTR) NULL))) {
  L1 = TRUE;
 } else {
  L2 = FSTR_size_INT(FLTD_fdbuf);
  L1 = (L2<30);
 }
 if (L1) {
  FLTD_fdbuf_FSTR(self, FSTR_create_INT_FSTR(((FSTR) NULL), 30));
 }
 fstr = FLTD_str_in_FSTR_FSTR(self, FLTD_fdbuf);
 ret_val = FSTR_str_STR(fstr);
 return ret_val;
}


STR FLT_str_STR(FLT self) {
 STR ret_val;
 FSTR fstr;
 BOOL L1;
 INT L2;
 if ((FLT_fbuf==((FSTR) NULL))) {
  L1 = TRUE;
 } else {
  L2 = FSTR_size_INT(FLT_fbuf);
  L1 = (L2<30);
 }
 if (L1) {
  FLT_fbuf_FSTR(self, FSTR_create_INT_FSTR(((FSTR) NULL), 30));
 }
 fstr = FLT_str_in_FSTR_FSTR(self, FLT_fbuf);
 ret_val = FSTR_str_STR(fstr);
 return ret_val;
}


TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO13(FMAPAM_BND_CREATE_EXPRBO13_frame frame) {
 TUPAM_BND_CREATE_EXPRBOU dummy = TUPAM_BND_CREATE_EXPRBOU_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPAM_BND_CREATE_EXPRBO3(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO14(FMAPAM_BND_CREATE_EXPRBO14_frame frame) {
 TUPAM_BND_CREATE_EXPRBOU dummy = TUPAM_BND_CREATE_EXPRBOU_zero;
 BOOL L1;
 TUPAM_BND_CREATE_EXPRBOU L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_BND_CREATE_EXPRBO) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_BND_CREATE_EXPRBO13_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_BND_CREATE_EXPRBO13(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPAM_BND_CREATE_EXPRBO4(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPAM_BND_CREATE_EXPRBOU FMAPAM_BND_CREATE_EXPRBO3(FMAPAM_BND_CREATE_EXPRBO self, INT ind) {
 TUPAM_BND_CREATE_EXPRBOU ret_val = TUPAM_BND_CREATE_EXPRBOU_zero;
 return ARR(self,ind);
}


TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA10(FMAPAM_LOCAL_EXPRAM_LOCA10_frame frame) {
 TUPAM_LOCAL_EXPRAM_LOCAL dummy = TUPAM_LOCAL_EXPRAM_LOCAL_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPAM_LOCAL_EXPRAM_LOCA9(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA12(FMAPAM_LOCAL_EXPRAM_LOCA12_frame frame) {
 TUPAM_LOCAL_EXPRAM_LOCAL dummy = TUPAM_LOCAL_EXPRAM_LOCAL_zero;
 BOOL L1;
 TUPAM_LOCAL_EXPRAM_LOCAL L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_LOCAL_EXPRAM_LOCA) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_LOCAL_EXPRAM_LOCA10_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_LOCAL_EXPRAM_LOCA10(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPAM_LOCAL_EXPRAM_LOCA11(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPAM_LOCAL_EXPRAM_LOCAL FMAPAM_LOCAL_EXPRAM_LOCA9(FMAPAM_LOCAL_EXPRAM_LOCA self, INT ind) {
 TUPAM_LOCAL_EXPRAM_LOCAL ret_val = TUPAM_LOCAL_EXPRAM_LOCAL_zero;
 return ARR(self,ind);
}


TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I10(FMAPAM_ROUT_DEFFLISTAM_I10_frame frame) {
 TUPAM_ROUT_DEFFLISTAM_IT dummy = TUPAM_ROUT_DEFFLISTAM_IT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPAM_ROUT_DEFFLISTAM_I9(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I12(FMAPAM_ROUT_DEFFLISTAM_I12_frame frame) {
 TUPAM_ROUT_DEFFLISTAM_IT dummy = TUPAM_ROUT_DEFFLISTAM_IT_zero;
 BOOL L1;
 TUPAM_ROUT_DEFFLISTAM_IT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_ROUT_DEFFLISTAM_I) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_ROUT_DEFFLISTAM_I10_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_ROUT_DEFFLISTAM_I10(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPAM_ROUT_DEFFLISTAM_I11(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPAM_ROUT_DEFFLISTAM_IT FMAPAM_ROUT_DEFFLISTAM_I9(FMAPAM_ROUT_DEFFLISTAM_I self, INT ind) {
 TUPAM_ROUT_DEFFLISTAM_IT ret_val = TUPAM_ROUT_DEFFLISTAM_IT_zero;
 return ARR(self,ind);
}


TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY13(FMAPAM_ROUT_DEFFRAME_LAY13_frame frame) {
 TUPAM_ROUT_DEFFRAME_LAYO dummy = TUPAM_ROUT_DEFFRAME_LAYO_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPAM_ROUT_DEFFRAME_LAY3(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY14(FMAPAM_ROUT_DEFFRAME_LAY14_frame frame) {
 TUPAM_ROUT_DEFFRAME_LAYO dummy = TUPAM_ROUT_DEFFRAME_LAYO_zero;
 BOOL L1;
 TUPAM_ROUT_DEFFRAME_LAYO L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPAM_ROUT_DEFFRAME_LAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPAM_ROUT_DEFFRAME_LAY13_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPAM_ROUT_DEFFRAME_LAY13(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPAM_ROUT_DEFFRAME_LAY4(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPAM_ROUT_DEFFRAME_LAYO FMAPAM_ROUT_DEFFRAME_LAY3(FMAPAM_ROUT_DEFFRAME_LAY self, INT ind) {
 TUPAM_ROUT_DEFFRAME_LAYO ret_val = TUPAM_ROUT_DEFFRAME_LAYO_zero;
 return ARR(self,ind);
}


TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_12(FMAPIDENTAM_GLOBAL_EXPR_12_frame frame) {
 TUPIDENTAM_GLOBAL_EXPR dummy = TUPIDENTAM_GLOBAL_EXPR_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPIDENTAM_GLOBAL_EXPR_2(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_13(FMAPIDENTAM_GLOBAL_EXPR_13_frame frame) {
 TUPIDENTAM_GLOBAL_EXPR dummy = TUPIDENTAM_GLOBAL_EXPR_zero;
 BOOL L1;
 TUPIDENTAM_GLOBAL_EXPR L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPIDENTAM_GLOBAL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPIDENTAM_GLOBAL_EXPR_12_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPIDENTAM_GLOBAL_EXPR_12(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPIDENTAM_GLOBAL_EXPR_3(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_2(FMAPIDENTAM_GLOBAL_EXPR self, INT ind) {
 TUPIDENTAM_GLOBAL_EXPR ret_val = TUPIDENTAM_GLOBAL_EXPR_zero;
 return ARR(self,ind);
}


TUPIDENTdTP FMAPIDENTdTP_aeltb_TUPID(FMAPIDENTdTP_aeltb_TUPID_frame frame) {
 TUPIDENTdTP dummy = TUPIDENTdTP_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPIDENTdTP_aget_INT_TU(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPIDENTdTP FMAPIDENTdTP_aget_INT_TU(FMAPIDENTdTP self, INT ind) {
 TUPIDENTdTP ret_val = TUPIDENTdTP_zero;
 return ARR(self,ind);
}


TUPIDENTdTP FMAPIDENTdTP_pairsb_TUPI(FMAPIDENTdTP_pairsb_TUPI_frame frame) {
 TUPIDENTdTP dummy = TUPIDENTdTP_zero;
 BOOL L1;
 TUPIDENTdTP L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPIDENTdTP) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPIDENTdTP_aeltb_TUPID_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPIDENTdTP_aeltb_TUPID(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPIDENTdTP_is_key_nil_(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA13(FMAPSIGABSTRACT_FRAME_LA13_frame frame) {
 TUPSIGABSTRACT_FRAME_LAY dummy = TUPSIGABSTRACT_FRAME_LAY_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPSIGABSTRACT_FRAME_LA3(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA14(FMAPSIGABSTRACT_FRAME_LA14_frame frame) {
 TUPSIGABSTRACT_FRAME_LAY dummy = TUPSIGABSTRACT_FRAME_LAY_zero;
 BOOL L1;
 TUPSIGABSTRACT_FRAME_LAY L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPSIGABSTRACT_FRAME_LA) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPSIGABSTRACT_FRAME_LA13_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPSIGABSTRACT_FRAME_LA13(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPSIGABSTRACT_FRAME_LA4(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPSIGABSTRACT_FRAME_LAY FMAPSIGABSTRACT_FRAME_LA3(FMAPSIGABSTRACT_FRAME_LA self, INT ind) {
 TUPSIGABSTRACT_FRAME_LAY ret_val = TUPSIGABSTRACT_FRAME_LAY_zero;
 return ARR(self,ind);
}


TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_aeltb(FMAPSIGAM_ROUT_DEF_aeltb_frame frame) {
 TUPSIGAM_ROUT_DEF dummy = TUPSIGAM_ROUT_DEF_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPSIGAM_ROUT_DEF_aget_(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_aget_(FMAPSIGAM_ROUT_DEF self, INT ind) {
 TUPSIGAM_ROUT_DEF ret_val = TUPSIGAM_ROUT_DEF_zero;
 return ARR(self,ind);
}


TUPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_pairs(FMAPSIGAM_ROUT_DEF_pairs_frame frame) {
 TUPSIGAM_ROUT_DEF dummy = TUPSIGAM_ROUT_DEF_zero;
 BOOL L1;
 TUPSIGAM_ROUT_DEF L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPSIGAM_ROUT_DEF) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPSIGAM_ROUT_DEF_aeltb_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPSIGAM_ROUT_DEF_aeltb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPSIGAM_ROUT_DEF_is_ke(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPSIGARG_LAYOUT FMAPSIGARG_LAYOUT_aeltb_(FMAPSIGARG_LAYOUT_aeltb__frame frame) {
 TUPSIGARG_LAYOUT dummy = TUPSIGARG_LAYOUT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPSIGARG_LAYOUT_aget_I(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPSIGARG_LAYOUT FMAPSIGARG_LAYOUT_aget_I(FMAPSIGARG_LAYOUT self, INT ind) {
 TUPSIGARG_LAYOUT ret_val = TUPSIGARG_LAYOUT_zero;
 return ARR(self,ind);
}


dAM_CONST FLISTdAM_CONST_aeltb_INT(FLISTdAM_CONST_aeltb_INT_frame frame) {
 dAM_CONST dummy = ((dAM_CONST) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTdAM_CONST_aget_INT_(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


dAM_CONST FLISTdAM_CONST_aget_INT_(FLISTdAM_CONST self, INT ind) {
 dAM_CONST ret_val;
 ret_val = FLISTdAM_CONST_aref_aget(self, ind);
 return ret_val;
}


dAM_CONST FLISTdAM_CONST_aref_aget(FLISTdAM_CONST self, INT ind) {
 dAM_CONST ret_val;
 return ARR(self,ind);
}


dAM_CONST FLISTdAM_CONST_eltb_dAM_(FLISTdAM_CONST_eltb_dAM__frame frame) {
 dAM_CONST dummy = ((dAM_CONST) NULL);
 BOOL L1;
 dAM_CONST L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdAM_CONST) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTdAM_CONST_aeltb_INT_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTdAM_CONST_aeltb_INT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR FLISTdAM_EXPR_aeltb_INT_(FLISTdAM_EXPR_aeltb_INT__frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTdAM_EXPR_aget_INT_d(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


dAM_EXPR FLISTdAM_EXPR_aget_INT_d(FLISTdAM_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 ret_val = FLISTdAM_EXPR_aref_aget_(self, ind);
 return ret_val;
}


dAM_EXPR FLISTdAM_EXPR_aref_aget_(FLISTdAM_EXPR self, INT ind) {
 dAM_EXPR ret_val;
 return ARR(self,ind);
}


dAM_EXPR FLISTdAM_EXPR_eltb_dAM_E(FLISTdAM_EXPR_eltb_dAM_E_frame frame) {
 dAM_EXPR dummy = ((dAM_EXPR) NULL);
 BOOL L1;
 dAM_EXPR L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdAM_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTdAM_EXPR_aeltb_INT__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTdAM_EXPR_aeltb_INT_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_STMT FLISTdAM_STMT_aeltb_INT_(FLISTdAM_STMT_aeltb_INT__frame frame) {
 dAM_STMT dummy = ((dAM_STMT) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTdAM_STMT_aget_INT_d(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


dAM_STMT FLISTdAM_STMT_aget_INT_d(FLISTdAM_STMT self, INT ind) {
 dAM_STMT ret_val;
 ret_val = FLISTdAM_STMT_aref_aget_(self, ind);
 return ret_val;
}


dAM_STMT FLISTdAM_STMT_aref_aget_(FLISTdAM_STMT self, INT ind) {
 dAM_STMT ret_val;
 return ARR(self,ind);
}


dAM_STMT FLISTdAM_STMT_eltb_dAM_S(FLISTdAM_STMT_eltb_dAM_S_frame frame) {
 dAM_STMT dummy = ((dAM_STMT) NULL);
 BOOL L1;
 dAM_STMT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdAM_STMT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTdAM_STMT_aeltb_INT__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTdAM_STMT_aeltb_INT_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dLAYOUT FLISTdLAYOUT_aeltb_INT_I(FLISTdLAYOUT_aeltb_INT_I_frame frame) {
 dLAYOUT dummy = ((dLAYOUT) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTdLAYOUT_aget_INT_dL(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


dLAYOUT FLISTdLAYOUT_aget_INT_dL(FLISTdLAYOUT self, INT ind) {
 dLAYOUT ret_val;
 ret_val = FLISTdLAYOUT_aref_aget_I(self, ind);
 return ret_val;
}


dLAYOUT FLISTdLAYOUT_aref_aget_I(FLISTdLAYOUT self, INT ind) {
 dLAYOUT ret_val;
 return ARR(self,ind);
}


dLAYOUT FLISTdLAYOUT_eltb_dLAYOU(FLISTdLAYOUT_eltb_dLAYOU_frame frame) {
 dLAYOUT dummy = ((dLAYOUT) NULL);
 BOOL L1;
 dLAYOUT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdLAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTdLAYOUT_aeltb_INT_I_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTdLAYOUT_aeltb_INT_I(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dTP FLISTdTP_aeltb_INT_INT_d(FLISTdTP_aeltb_INT_INT_d_frame frame) {
 dTP dummy = ((dTP) NULL);
 INT L1;
 INT L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_uptob_INT_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   frame->state = 1;
   if (frame->nested1->state == 0) {
    frame->L21 = frame->arg1;
    L4 = (INTPLUS(frame->arg1,frame->arg2));
    frame->L31 = (INTMINUS(L4,1));
    frame->nested1->self = frame->L21;
    frame->nested1->arg1 = frame->L31;
   }
   L1 = INT_uptob_INT_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   return FLISTdTP_aget_INT_dTP(frame->self, L1);
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return dummy;
}


dTP FLISTdTP_aget_INT_dTP(FLISTdTP self, INT ind) {
 dTP ret_val;
 ret_val = FLISTdTP_aref_aget_INT_d(self, ind);
 return ret_val;
}


dTP FLISTdTP_aref_aget_INT_d(FLISTdTP self, INT ind) {
 dTP ret_val;
 return ARR(self,ind);
}


dTP FLISTdTP_eltb_dTP(FLISTdTP_eltb_dTP_frame frame) {
 dTP dummy = ((dTP) NULL);
 BOOL L1;
 dTP L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FLISTdTP) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FLISTdTP_aeltb_INT_INT_d_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->L41 = 0;
     frame->L51 = ATTR(frame->self,loc);
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
     frame->nested1->arg2 = frame->L51;
    }
    L2 = FLISTdTP_aeltb_INT_INT_d(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dTP FMAPIDENTdTP_targetsb_dT(FMAPIDENTdTP_targetsb_dT_frame frame) {
 dTP dummy = ((dTP) NULL);
 BOOL L1;
 TUPIDENTdTP L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPIDENTdTP) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPIDENTdTP_aeltb_TUPID_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPIDENTdTP_aeltb_TUPID(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->e = L2;
    L4 = FMAPIDENTdTP_is_key_nil_(frame->self, frame->e.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->e.t2;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


void FLISTSFILE_ID_aref_aset_(FLISTSFILE_ID self, INT ind, SFILE_ID val1) {
 SARR(self,ind,val1);
}


void FLISTSFILE_ID_aset_INT_S(FLISTSFILE_ID self, INT ind, SFILE_ID val1) {
 FLISTSFILE_ID_aref_aset_(self, ind, val1);
}


void FLISTSFILE_ID_asetb_SFIL(FLISTSFILE_ID_asetb_SFIL_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTSFILE_ID_aset_INT_S(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTSIG_aref_aset_INT_S(FLISTSIG self, INT ind, SIG val1) {
 SARR(self,ind,val1);
}


void FLISTSIG_aset_INT_SIG(FLISTSIG self, INT ind, SIG val1) {
 FLISTSIG_aref_aset_INT_S(self, ind, val1);
}


void FLISTSTR_aref_aset_INT_S(FLISTSTR self, INT ind, STR val1) {
 SARR(self,ind,val1);
}


void FLISTSTR_aset_INT_STR(FLISTSTR self, INT ind, STR val1) {
 FLISTSTR_aref_aset_INT_S(self, ind, val1);
}


void FLISTSTR_asetb_STR(FLISTSTR_asetb_STR_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTSTR_aset_INT_STR(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTdAM_CONST_aref_aset(FLISTdAM_CONST self, INT ind, dAM_CONST val1) {
 SARR(self,ind,val1);
}


void FLISTdAM_CONST_aset_INT_(FLISTdAM_CONST self, INT ind, dAM_CONST val1) {
 FLISTdAM_CONST_aref_aset(self, ind, val1);
}


void FLISTdAM_CONST_asetb_dAM(FLISTdAM_CONST_asetb_dAM_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTdAM_CONST_aset_INT_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTdAM_EXPR_aref_aset_(FLISTdAM_EXPR self, INT ind, dAM_EXPR val1) {
 SARR(self,ind,val1);
}


void FLISTdAM_EXPR_aset_INT_d(FLISTdAM_EXPR self, INT ind, dAM_EXPR val1) {
 FLISTdAM_EXPR_aref_aset_(self, ind, val1);
}


void FLISTdAM_EXPR_asetb_dAM_(FLISTdAM_EXPR_asetb_dAM__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTdAM_EXPR_aset_INT_d(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTdAM_STMT_aref_aset_(FLISTdAM_STMT self, INT ind, dAM_STMT val1) {
 SARR(self,ind,val1);
}


void FLISTdAM_STMT_aset_INT_d(FLISTdAM_STMT self, INT ind, dAM_STMT val1) {
 FLISTdAM_STMT_aref_aset_(self, ind, val1);
}


void FLISTdAM_STMT_asetb_dAM_(FLISTdAM_STMT_asetb_dAM__frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTdAM_STMT_aset_INT_d(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTdLAYOUT_aref_aset_I(FLISTdLAYOUT self, INT ind, dLAYOUT val1) {
 SARR(self,ind,val1);
}


void FLISTdLAYOUT_aset_INT_dL(FLISTdLAYOUT self, INT ind, dLAYOUT val1) {
 FLISTdLAYOUT_aref_aset_I(self, ind, val1);
}


void FLISTdLAYOUT_asetb_dLAYO(FLISTdLAYOUT_asetb_dLAYO_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTdLAYOUT_aset_INT_dL(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FLISTdTP_aref_aset_INT_d(FLISTdTP self, INT ind, dTP val1) {
 SARR(self,ind,val1);
}


void FLISTdTP_aset_INT_dTP(FLISTdTP self, INT ind, dTP val1) {
 FLISTdTP_aref_aset_INT_d(self, ind, val1);
}


void FLISTdTP_asetb_dTP(FLISTdTP_asetb_dTP_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FLISTdTP_aset_INT_dTP(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPAM_BND_CREATE_EXPRBO8(FMAPAM_BND_CREATE_EXPRBO self, INT ind, TUPAM_BND_CREATE_EXPRBOU val1) {
 SARR(self,ind,val1);
}


void FMAPAM_BND_CREATE_EXPRBO9(FMAPAM_BND_CREATE_EXPRBO9_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPAM_BND_CREATE_EXPRBO8(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPAM_LOCAL_EXPRAM_LOCA3(FMAPAM_LOCAL_EXPRAM_LOCA self, INT ind, TUPAM_LOCAL_EXPRAM_LOCAL val1) {
 SARR(self,ind,val1);
}


void FMAPAM_LOCAL_EXPRAM_LOCA4(FMAPAM_LOCAL_EXPRAM_LOCA4_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPAM_LOCAL_EXPRAM_LOCA3(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPAM_ROUT_DEFFLISTAM_I4(FMAPAM_ROUT_DEFFLISTAM_I self, INT ind, TUPAM_ROUT_DEFFLISTAM_IT val1) {
 SARR(self,ind,val1);
}


void FMAPAM_ROUT_DEFFLISTAM_I5(FMAPAM_ROUT_DEFFLISTAM_I5_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPAM_ROUT_DEFFLISTAM_I4(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPAM_ROUT_DEFFRAME_LAY8(FMAPAM_ROUT_DEFFRAME_LAY self, INT ind, TUPAM_ROUT_DEFFRAME_LAYO val1) {
 SARR(self,ind,val1);
}


void FMAPAM_ROUT_DEFFRAME_LAY9(FMAPAM_ROUT_DEFFRAME_LAY9_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPAM_ROUT_DEFFRAME_LAY8(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPIDENTAM_GLOBAL_EXPR_7(FMAPIDENTAM_GLOBAL_EXPR self, INT ind, TUPIDENTAM_GLOBAL_EXPR val1) {
 SARR(self,ind,val1);
}


void FMAPIDENTAM_GLOBAL_EXPR_8(FMAPIDENTAM_GLOBAL_EXPR_8_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPIDENTAM_GLOBAL_EXPR_7(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPIDENTdTP_aset_INT_TU(FMAPIDENTdTP self, INT ind, TUPIDENTdTP val1) {
 SARR(self,ind,val1);
}


void FMAPIDENTdTP_asetb_TUPID(FMAPIDENTdTP_asetb_TUPID_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPIDENTdTP_aset_INT_TU(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPSIGABSTRACT_FRAME_LA8(FMAPSIGABSTRACT_FRAME_LA self, INT ind, TUPSIGABSTRACT_FRAME_LAY val1) {
 SARR(self,ind,val1);
}


void FMAPSIGABSTRACT_FRAME_LA9(FMAPSIGABSTRACT_FRAME_LA9_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPSIGABSTRACT_FRAME_LA8(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPSIGAM_ROUT_DEF_aset_(FMAPSIGAM_ROUT_DEF self, INT ind, TUPSIGAM_ROUT_DEF val1) {
 SARR(self,ind,val1);
}


void FMAPSIGAM_ROUT_DEF_asetb(FMAPSIGAM_ROUT_DEF_asetb_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPSIGAM_ROUT_DEF_aset_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}

/* C for type FLISTSFILE_ID */




INT FLISTSFILE_ID_asize_INT(FLISTSFILE_ID self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTSIG */




INT FLISTSIG_asize_INT(FLISTSIG self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTSTR */




INT FLISTSTR_asize_INT(FLISTSTR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTdAM_CONST */




INT FLISTdAM_CONST_asize_INT(FLISTdAM_CONST self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTdAM_EXPR */




INT FLISTdAM_EXPR_asize_INT(FLISTdAM_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTdAM_STMT */




INT FLISTdAM_STMT_asize_INT(FLISTdAM_STMT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTdLAYOUT */




INT FLISTdLAYOUT_asize_INT(FLISTdLAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLISTdTP */




INT FLISTdTP_asize_INT(FLISTdTP self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type FLT */




void FLT_fbuf_FSTR(FLT self, FSTR fbuf) {
 FLT_fbuf = fbuf;
}

/* C for type FLTD */




void FLTD_fdbuf_FSTR(FLTD self, FSTR fdbuf) {
 FLTD_fdbuf = fdbuf;
}

/* C for type FLTDX */




STR FLTDX_str_STR(FLTDX self) {
 STR ret_val;
 extern STR FLT_UNDEFstrSTRundefined;
 RAISE(((OB) ((STR) &FLT_UNDEFstrSTRundefined)));
 FATAL("Last statement wasn't return");
}

/* C for type FLTI */




STR FLTI_str_STR(FLTI self) {
 STR ret_val;
 extern STR FLT_UNDEFstrSTRundefined;
 RAISE(((OB) ((STR) &FLT_UNDEFstrSTRundefined)));
 FATAL("Last statement wasn't return");
}

/* C for type FLTX */




STR FLTX_str_STR(FLTX self) {
 STR ret_val;
 extern STR FLT_UNDEFstrSTRundefined;
 RAISE(((OB) ((STR) &FLT_UNDEFstrSTRundefined)));
 FATAL("Last statement wasn't return");
}

/* C for type FMAPAM_BND_CREATE_EXPRBO */




INT FMAPAM_BND_CREATE_EXPRBO1(FMAPAM_BND_CREATE_EXPRBO self, AM_BND_CREATE_EXPR k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}

/* C for type FMAPAM_LOCAL_EXPRAM_LOCA */




AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA1(FMAPAM_LOCAL_EXPRAM_LOCA self) {
 AM_LOCAL_EXPR ret_val;
 AM_LOCAL_EXPR k = ((AM_LOCAL_EXPR) NULL);
 ret_val = ((AM_LOCAL_EXPR) NULL);
 return ret_val;
}

/* C for type FMAPAM_ROUT_DEFFLISTAM_I */




FMAPAM_ROUT_DEFFLISTAM_I FMAPAM_ROUT_DEFFLISTAM_I1(FMAPAM_ROUT_DEFFLISTAM_I self) {
 FMAPAM_ROUT_DEFFLISTAM_I ret_val;
 ret_val = ((FMAPAM_ROUT_DEFFLISTAM_I) NULL);
 return ret_val;
}

/* C for type FMAPAM_ROUT_DEFFRAME_LAY */




INT FMAPAM_ROUT_DEFFRAME_LAY1(FMAPAM_ROUT_DEFFRAME_LAY self, AM_ROUT_DEF k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}

/* C for type FMAPIDENTAM_GLOBAL_EXPR */




INT FMAPIDENTAM_GLOBAL_EXPR_(FMAPIDENTAM_GLOBAL_EXPR self, IDENT k) {
 INT ret_val = ((INT) 0);
 ret_val = IDENT_hash_INT(k);
 return ret_val;
}

/* C for type FMAPIDENTdTP */




IDENT FMAPIDENTdTP_key_nil_IDE(FMAPIDENTdTP self) {
 IDENT ret_val = IDENT_zero;
 IDENT k = IDENT_zero;
 ret_val = IDENT_zero;
 return ret_val;
}

/* C for type FMAPSIGABSTRACT_FRAME_LA */




INT FMAPSIGABSTRACT_FRAME_LA1(FMAPSIGABSTRACT_FRAME_LA self, SIG k) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) k))));
 return ret_val;
}

/* C for type FMAPSIGAM_ROUT_DEF */




FMAPSIGAM_ROUT_DEF FMAPSIGAM_ROUT_DEF_creat(FMAPSIGAM_ROUT_DEF self) {
 FMAPSIGAM_ROUT_DEF ret_val;
 ret_val = ((FMAPSIGAM_ROUT_DEF) NULL);
 return ret_val;
}

/* C for type FMAPSIGARG_LAYOUT */




INT FMAPSIGARG_LAYOUT_asize_(FMAPSIGARG_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}
