#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_LAYOUT_struct {/* layout for ABSTRACT_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct PROG_struct *prog1;
 STR str1;
 } *ABSTRACT_LAYOUT;

typedef struct BOUND_TYPE_LAYOUT_struct {/* layout for BOUND_TYPE_LAYOUT */
 OB_HEADER header;
 STR str1;
 struct TP_ROUT_struct *tp1;
 } *BOUND_TYPE_LAYOUT;

typedef struct BUILTIN_LAYOUT_struct {/* layout for BUILTIN_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *BUILTIN_LAYOUT;

typedef struct CLASS_LAYOUT_struct {/* layout for CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *CLASS_LAYOUT;

typedef struct ERR1_struct {/* layout for ERR */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *ERR1;

typedef struct EXTERNAL_LAYOUT_struct {/* layout for EXTERNAL_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *EXTERNAL_LAYOUT;

typedef struct FRAME_LAYOUT_struct {/* layout for FRAME_LAYOUT */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *f1;
 struct PROG_struct *prog1;
 STR str1;
 } *FRAME_LAYOUT;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_upb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_upb_INT_frame;


typedef struct INT_uptob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_uptob_INT_INT_frame;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPdTPIFC_struct {/* layout for TUP{$TP,IFC} */
 struct dTP_struct *t1;
 struct IFC_struct *t2;
 } TUPdTPIFC;
static TUPdTPIFC TUPdTPIFC_zero;

typedef struct TUPdTPIFC_boxed_struct {
 OB_HEADER header;
 TUPdTPIFC value_part;
 } *TUPdTPIFC_boxed;

typedef struct TUPdTPIMPL_struct {/* layout for TUP{$TP,IMPL} */
 struct dTP_struct *t1;
 struct IMPL_struct *t2;
 } TUPdTPIMPL;
static TUPdTPIMPL TUPdTPIMPL_zero;

typedef struct TUPdTPIMPL_boxed_struct {
 OB_HEADER header;
 TUPdTPIMPL value_part;
 } *TUPdTPIMPL_boxed;

typedef struct TUPdTPINT_struct {/* layout for TUP{$TP,INT} */
 struct dTP_struct *t1;
 INT t2;
 } TUPdTPINT;
static TUPdTPINT TUPdTPINT_zero;

typedef struct TUPdTPINT_boxed_struct {
 OB_HEADER header;
 TUPdTPINT value_part;
 } *TUPdTPINT_boxed;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_struct {/* layout for TUP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 struct AM_ROUT_DEF_struct *t1;
 struct FLISTAM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ROUT_DEFFLISTAM_IT;
static TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT_zero;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFLISTAM_IT value_part;
 } *TUPAM_ROUT_DEFFLISTAM_IT_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;


typedef struct AM_ROUT_DEF_eltb_AM_LOCA_frame_struct {
 AM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 AM_ROUT_DEF L31;
 struct AM_ROUT_DEF_aeltb_AM_LOC_frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_DEF_eltb_AM_LOCA_frame;

typedef struct AS_FEAT_MOD_struct {/* layout for AS_FEAT_MOD */
 OB_HEADER header;
 struct AS_FEAT_MOD_struct *next;
 struct IDENT_struct name1;
 struct IDENT_struct new_name;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_FEAT_MOD;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;


typedef struct FLISTAM_ITER_CALL_EXPR_e_frame_struct {
 FLISTAM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 AM_ITER_CALL_EXPR ret_val;
 FLISTAM_ITER_CALL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_ITER_CALL_EXPR_a3_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_ITER_CALL_EXPR_e_frame;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;


typedef struct FMAPdTPdLAYOUT_aeltb_TUP_frame_struct {
 FMAPdTPdLAYOUT self;/* Formal argument: self */
 INT state;
 TUPdTPdLAYOUT ret_val;
 INT i;
 } *FMAPdTPdLAYOUT_aeltb_TUP_frame;


typedef struct FMAPdTPdLAYOUT_asetb_TUP_frame_struct {
 FMAPdTPdLAYOUT self;/* Formal argument: self */
 TUPdTPdLAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPdLAYOUT_asetb_TUP_frame;


typedef struct FMAPdTPdLAYOUT_pairsb_TU_frame_struct {
 FMAPdTPdLAYOUT self;/* Formal argument: self */
 INT state;
 TUPdTPdLAYOUT ret_val;
 FMAPdTPdLAYOUT L31;
 TUPdTPdLAYOUT r;
 struct FMAPdTPdLAYOUT_aeltb_TUP_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPdLAYOUT_pairsb_TU_frame;

typedef struct FMAPdTPIFC_struct {/* layout for FMAP{$TP,IFC} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIFC_struct arr_part[1];
 } *FMAPdTPIFC;


typedef struct FMAPdTPIFC_aeltb_TUPdTPI_frame_struct {
 FMAPdTPIFC self;/* Formal argument: self */
 INT state;
 TUPdTPIFC ret_val;
 INT i;
 } *FMAPdTPIFC_aeltb_TUPdTPI_frame;


typedef struct FMAPdTPIFC_asetb_TUPdTPI_frame_struct {
 FMAPdTPIFC self;/* Formal argument: self */
 TUPdTPIFC arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPIFC_asetb_TUPdTPI_frame;


typedef struct FMAPdTPIFC_pairsb_TUPdTP_frame_struct {
 FMAPdTPIFC self;/* Formal argument: self */
 INT state;
 TUPdTPIFC ret_val;
 FMAPdTPIFC L31;
 TUPdTPIFC r;
 struct FMAPdTPIFC_aeltb_TUPdTPI_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPIFC_pairsb_TUPdTP_frame;

typedef struct FMAPdTPIMPL_struct {/* layout for FMAP{$TP,IMPL} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIMPL_struct arr_part[1];
 } *FMAPdTPIMPL;


typedef struct FMAPdTPIMPL_aeltb_TUPdTP_frame_struct {
 FMAPdTPIMPL self;/* Formal argument: self */
 INT state;
 TUPdTPIMPL ret_val;
 INT i;
 } *FMAPdTPIMPL_aeltb_TUPdTP_frame;


typedef struct FMAPdTPIMPL_asetb_TUPdTP_frame_struct {
 FMAPdTPIMPL self;/* Formal argument: self */
 TUPdTPIMPL arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPIMPL_asetb_TUPdTP_frame;


typedef struct FMAPdTPIMPL_pairsb_TUPdT_frame_struct {
 FMAPdTPIMPL self;/* Formal argument: self */
 INT state;
 TUPdTPIMPL ret_val;
 FMAPdTPIMPL L31;
 TUPdTPIMPL r;
 struct FMAPdTPIMPL_aeltb_TUPdTP_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPIMPL_pairsb_TUPdT_frame;

typedef struct FMAPdTPINT_struct {/* layout for FMAP{$TP,INT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPINT_struct arr_part[1];
 } *FMAPdTPINT;


typedef struct FMAPdTPINT_aeltb_TUPdTPI_frame_struct {
 FMAPdTPINT self;/* Formal argument: self */
 INT state;
 TUPdTPINT ret_val;
 INT i;
 } *FMAPdTPINT_aeltb_TUPdTPI_frame;


typedef struct FMAPdTPINT_asetb_TUPdTPI_frame_struct {
 FMAPdTPINT self;/* Formal argument: self */
 TUPdTPINT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPINT_asetb_TUPdTPI_frame;


typedef struct FMAPdTPINT_keysb_dTP_frame_struct {
 FMAPdTPINT self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FMAPdTPINT L31;
 dTP r;
 struct FMAPdTPINT_aeltb_TUPdTPI_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPINT_keysb_dTP_frame;


typedef struct FMAPdTPINT_pairsb_TUPdTP_frame_struct {
 FMAPdTPINT self;/* Formal argument: self */
 INT state;
 TUPdTPINT ret_val;
 FMAPdTPINT L31;
 TUPdTPINT r;
 struct FMAPdTPINT_aeltb_TUPdTPI_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPINT_pairsb_TUPdTP_frame;


typedef struct FMAPdTPINT_targetsb_INT_frame_struct {
 FMAPdTPINT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 FMAPdTPINT L31;
 TUPdTPINT e;
 struct FMAPdTPINT_aeltb_TUPdTPI_frame_struct *nested1; /* nested iter frame */
 } *FMAPdTPINT_targetsb_INT_frame;

typedef struct FMAPAM_ROUT_DEFFLISTAM_I_struct {/* layout for FMAP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFLISTAM_IT_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFLISTAM_I;

typedef struct FMAPAM_ROUT_DEFFRAME_LAY_struct {/* layout for FMAP{AM_ROUT_DEF,FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFRAME_LAYO_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFRAME_LAY;

typedef struct FSETABSTRACT_LAYOUT_struct {/* layout for FSET{ABSTRACT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ABSTRACT_LAYOUT_struct *arr_part[1];
 } *FSETABSTRACT_LAYOUT;


typedef struct FSETABSTRACT_LAYOUT_aelt_frame_struct {
 FSETABSTRACT_LAYOUT self;/* Formal argument: self */
 INT state;
 ABSTRACT_LAYOUT ret_val;
 INT i;
 } *FSETABSTRACT_LAYOUT_aelt_frame;


typedef struct FSETABSTRACT_LAYOUT_aset1_frame_struct {
 FSETABSTRACT_LAYOUT self;/* Formal argument: self */
 ABSTRACT_LAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETABSTRACT_LAYOUT_aset1_frame;


typedef struct FSETABSTRACT_LAYOUT_eltb_frame_struct {
 FSETABSTRACT_LAYOUT self;/* Formal argument: self */
 INT state;
 ABSTRACT_LAYOUT ret_val;
 FSETABSTRACT_LAYOUT L31;
 ABSTRACT_LAYOUT r;
 struct FSETABSTRACT_LAYOUT_aelt_frame_struct *nested1; /* nested iter frame */
 } *FSETABSTRACT_LAYOUT_eltb_frame;

typedef struct FSETAM_GLOBAL_EXPR_struct {/* layout for FSET{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FSETAM_GLOBAL_EXPR;


typedef struct FSETAM_GLOBAL_EXPR_aeltb_frame_struct {
 FSETAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_GLOBAL_EXPR ret_val;
 INT i;
 } *FSETAM_GLOBAL_EXPR_aeltb_frame;


typedef struct FSETAM_GLOBAL_EXPR_asetb_frame_struct {
 FSETAM_GLOBAL_EXPR self;/* Formal argument: self */
 AM_GLOBAL_EXPR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETAM_GLOBAL_EXPR_asetb_frame;


typedef struct FSETAM_GLOBAL_EXPR_eltb__frame_struct {
 FSETAM_GLOBAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR L31;
 AM_GLOBAL_EXPR r;
 struct FSETAM_GLOBAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FSETAM_GLOBAL_EXPR_eltb__frame;

typedef struct FSETAM_ROUT_DEF_struct {/* layout for FSET{AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AM_ROUT_DEF_struct *arr_part[1];
 } *FSETAM_ROUT_DEF;


typedef struct FSETAM_ROUT_DEF_aeltb_AM_frame_struct {
 FSETAM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 AM_ROUT_DEF ret_val;
 INT i;
 } *FSETAM_ROUT_DEF_aeltb_AM_frame;


typedef struct FSETAM_ROUT_DEF_asetb_AM_frame_struct {
 FSETAM_ROUT_DEF self;/* Formal argument: self */
 AM_ROUT_DEF arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETAM_ROUT_DEF_asetb_AM_frame;


typedef struct FSETAM_ROUT_DEF_eltb_AM__frame_struct {
 FSETAM_ROUT_DEF self;/* Formal argument: self */
 INT state;
 AM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF L31;
 AM_ROUT_DEF r;
 struct FSETAM_ROUT_DEF_aeltb_AM_frame_struct *nested1; /* nested iter frame */
 } *FSETAM_ROUT_DEF_eltb_AM__frame;

typedef struct FSETAS_FEAT_MOD_struct {/* layout for FSET{AS_FEAT_MOD} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_FEAT_MOD_struct *arr_part[1];
 } *FSETAS_FEAT_MOD;


typedef struct FSETAS_FEAT_MOD_aeltb_AS_frame_struct {
 FSETAS_FEAT_MOD self;/* Formal argument: self */
 INT state;
 AS_FEAT_MOD ret_val;
 INT i;
 } *FSETAS_FEAT_MOD_aeltb_AS_frame;


typedef struct FSETAS_FEAT_MOD_asetb_AS_frame_struct {
 FSETAS_FEAT_MOD self;/* Formal argument: self */
 AS_FEAT_MOD arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETAS_FEAT_MOD_asetb_AS_frame;


typedef struct FSETAS_FEAT_MOD_eltb_AS__frame_struct {
 FSETAS_FEAT_MOD self;/* Formal argument: self */
 INT state;
 AS_FEAT_MOD ret_val;
 FSETAS_FEAT_MOD L31;
 AS_FEAT_MOD r;
 struct FSETAS_FEAT_MOD_aeltb_AS_frame_struct *nested1; /* nested iter frame */
 } *FSETAS_FEAT_MOD_eltb_AS__frame;

typedef struct FSETBOUND_TYPE_LAYOUT_struct {/* layout for FSET{BOUND_TYPE_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BOUND_TYPE_LAYOUT_struct *arr_part[1];
 } *FSETBOUND_TYPE_LAYOUT;


typedef struct FSETBOUND_TYPE_LAYOUT_ae_frame_struct {
 FSETBOUND_TYPE_LAYOUT self;/* Formal argument: self */
 INT state;
 BOUND_TYPE_LAYOUT ret_val;
 INT i;
 } *FSETBOUND_TYPE_LAYOUT_ae_frame;


typedef struct FSETBOUND_TYPE_LAYOUT_as2_frame_struct {
 FSETBOUND_TYPE_LAYOUT self;/* Formal argument: self */
 BOUND_TYPE_LAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETBOUND_TYPE_LAYOUT_as2_frame;


typedef struct FSETBOUND_TYPE_LAYOUT_el1_frame_struct {
 FSETBOUND_TYPE_LAYOUT self;/* Formal argument: self */
 INT state;
 BOUND_TYPE_LAYOUT ret_val;
 FSETBOUND_TYPE_LAYOUT L31;
 BOUND_TYPE_LAYOUT r;
 struct FSETBOUND_TYPE_LAYOUT_ae_frame_struct *nested1; /* nested iter frame */
 } *FSETBOUND_TYPE_LAYOUT_el1_frame;

typedef struct FSETBUILTIN_LAYOUT_struct {/* layout for FSET{BUILTIN_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BUILTIN_LAYOUT_struct *arr_part[1];
 } *FSETBUILTIN_LAYOUT;


typedef struct FSETBUILTIN_LAYOUT_aeltb_frame_struct {
 FSETBUILTIN_LAYOUT self;/* Formal argument: self */
 INT state;
 BUILTIN_LAYOUT ret_val;
 INT i;
 } *FSETBUILTIN_LAYOUT_aeltb_frame;


typedef struct FSETBUILTIN_LAYOUT_asetb_frame_struct {
 FSETBUILTIN_LAYOUT self;/* Formal argument: self */
 BUILTIN_LAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETBUILTIN_LAYOUT_asetb_frame;


typedef struct FSETBUILTIN_LAYOUT_eltb__frame_struct {
 FSETBUILTIN_LAYOUT self;/* Formal argument: self */
 INT state;
 BUILTIN_LAYOUT ret_val;
 FSETBUILTIN_LAYOUT L31;
 BUILTIN_LAYOUT r;
 struct FSETBUILTIN_LAYOUT_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FSETBUILTIN_LAYOUT_eltb__frame;

typedef struct FSETCLASS_LAYOUT_struct {/* layout for FSET{CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct CLASS_LAYOUT_struct *arr_part[1];
 } *FSETCLASS_LAYOUT;


typedef struct FSETCLASS_LAYOUT_aeltb_C_frame_struct {
 FSETCLASS_LAYOUT self;/* Formal argument: self */
 INT state;
 CLASS_LAYOUT ret_val;
 INT i;
 } *FSETCLASS_LAYOUT_aeltb_C_frame;


typedef struct FSETCLASS_LAYOUT_asetb_C_frame_struct {
 FSETCLASS_LAYOUT self;/* Formal argument: self */
 CLASS_LAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETCLASS_LAYOUT_asetb_C_frame;


typedef struct FSETCLASS_LAYOUT_eltb_CL_frame_struct {
 FSETCLASS_LAYOUT self;/* Formal argument: self */
 INT state;
 CLASS_LAYOUT ret_val;
 FSETCLASS_LAYOUT L31;
 CLASS_LAYOUT r;
 struct FSETCLASS_LAYOUT_aeltb_C_frame_struct *nested1; /* nested iter frame */
 } *FSETCLASS_LAYOUT_eltb_CL_frame;

typedef struct FSETEXTERNAL_LAYOUT_struct {/* layout for FSET{EXTERNAL_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct EXTERNAL_LAYOUT_struct *arr_part[1];
 } *FSETEXTERNAL_LAYOUT;


typedef struct FSETEXTERNAL_LAYOUT_aelt_frame_struct {
 FSETEXTERNAL_LAYOUT self;/* Formal argument: self */
 INT state;
 EXTERNAL_LAYOUT ret_val;
 INT i;
 } *FSETEXTERNAL_LAYOUT_aelt_frame;


typedef struct FSETEXTERNAL_LAYOUT_aset1_frame_struct {
 FSETEXTERNAL_LAYOUT self;/* Formal argument: self */
 EXTERNAL_LAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETEXTERNAL_LAYOUT_aset1_frame;


typedef struct FSETEXTERNAL_LAYOUT_eltb_frame_struct {
 FSETEXTERNAL_LAYOUT self;/* Formal argument: self */
 INT state;
 EXTERNAL_LAYOUT ret_val;
 FSETEXTERNAL_LAYOUT L31;
 EXTERNAL_LAYOUT r;
 struct FSETEXTERNAL_LAYOUT_aelt_frame_struct *nested1; /* nested iter frame */
 } *FSETEXTERNAL_LAYOUT_eltb_frame;

typedef struct FSETIDENT_struct {/* layout for FSET{IDENT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FSETIDENT;


typedef struct FSETIDENT_aeltb_IDENT_frame_struct {
 FSETIDENT self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 INT i;
 } *FSETIDENT_aeltb_IDENT_frame;


typedef struct FSETIDENT_asetb_IDENT_frame_struct {
 FSETIDENT self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *FSETIDENT_asetb_IDENT_frame;


typedef struct FSETIDENT_eltb_IDENT_frame_struct {
 FSETIDENT self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 FSETIDENT L31;
 IDENT r;
 struct FSETIDENT_aeltb_IDENT_frame_struct *nested1; /* nested iter frame */
 } *FSETIDENT_eltb_IDENT_frame;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern CGEN LAYOUT_TBL_cgen;
extern FMAPAM_ROUT_DEFFRAME_LAY FRAME_LAYOUT_layouts;
extern INT FMAPdTPIFC_load_ratio;
extern INT FMAPdTPIMPL_load_ratio;
extern INT FMAPdTPINT_load_ratio;
extern INT FMAPdTPdLAYOUT_load_rati;
extern INT FSETABSTRACT_LAYOUT_load;
extern INT FSETAM_GLOBAL_EXPR_load_;
extern INT FSETAM_ROUT_DEF_load_rat;
extern INT FSETAS_FEAT_MOD_load_rat;
extern INT FSETBOUND_TYPE_LAYOUT_lo;
extern INT FSETBUILTIN_LAYOUT_load_;
extern INT FSETCLASS_LAYOUT_load_ra;
extern INT FSETEXTERNAL_LAYOUT_load;
extern INT FSETIDENT_load_ratio;

/* Function declarations */

ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_aelt(FSETABSTRACT_LAYOUT_aelt_frame);
ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_aget(FSETABSTRACT_LAYOUT, INT);
ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_elt_(FSETABSTRACT_LAYOUT);
ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_eltb(FSETABSTRACT_LAYOUT_eltb_frame);
AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_aeltb(FSETAM_GLOBAL_EXPR_aeltb_frame);
AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_aget_(FSETAM_GLOBAL_EXPR, INT);
AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_elt_n(FSETAM_GLOBAL_EXPR);
AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_eltb_(FSETAM_GLOBAL_EXPR_eltb__frame);
AM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_e(FLISTAM_ITER_CALL_EXPR_e_frame);
AM_LOCAL_EXPR AM_ROUT_DEF_eltb_AM_LOCA(AM_ROUT_DEF_eltb_AM_LOCA_frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_ROUT_DEF FSETAM_ROUT_DEF_aeltb_AM(FSETAM_ROUT_DEF_aeltb_AM_frame);
AM_ROUT_DEF FSETAM_ROUT_DEF_aget_INT(FSETAM_ROUT_DEF, INT);
AM_ROUT_DEF FSETAM_ROUT_DEF_elt_nil_(FSETAM_ROUT_DEF);
AM_ROUT_DEF FSETAM_ROUT_DEF_eltb_AM_(FSETAM_ROUT_DEF_eltb_AM__frame);
AM_ROUT_DEF FSETAM_ROUT_DEF_first_el(FSETAM_ROUT_DEF);
AS_FEAT_MOD FSETAS_FEAT_MOD_aeltb_AS(FSETAS_FEAT_MOD_aeltb_AS_frame);
AS_FEAT_MOD FSETAS_FEAT_MOD_aget_INT(FSETAS_FEAT_MOD, INT);
AS_FEAT_MOD FSETAS_FEAT_MOD_elt_nil_(FSETAS_FEAT_MOD);
AS_FEAT_MOD FSETAS_FEAT_MOD_eltb_AS_(FSETAS_FEAT_MOD_eltb_AS__frame);
BOOL FMAPdTPIFC_is_key_nil_dT(FMAPdTPIFC, dTP);
BOOL FMAPdTPIFC_key_eq_dTP_dT(FMAPdTPIFC, dTP, dTP);
BOOL FMAPdTPIFC_not_too_many_(FMAPdTPIFC, INT, INT);
BOOL FMAPdTPIFC_should_grow_B(FMAPdTPIFC);
BOOL FMAPdTPIMPL_is_key_nil_d(FMAPdTPIMPL, dTP);
BOOL FMAPdTPIMPL_key_eq_dTP_d(FMAPdTPIMPL, dTP, dTP);
BOOL FMAPdTPIMPL_not_too_many(FMAPdTPIMPL, INT, INT);
BOOL FMAPdTPIMPL_should_grow_(FMAPdTPIMPL);
BOOL FMAPdTPINT_is_key_nil_dT(FMAPdTPINT, dTP);
BOOL FMAPdTPINT_key_eq_dTP_dT(FMAPdTPINT, dTP, dTP);
BOOL FMAPdTPINT_not_too_many_(FMAPdTPINT, INT, INT);
BOOL FMAPdTPINT_should_grow_B(FMAPdTPINT);
BOOL FMAPdTPdLAYOUT_is_key_ni(FMAPdTPdLAYOUT, dTP);
BOOL FMAPdTPdLAYOUT_key_eq_dT(FMAPdTPdLAYOUT, dTP, dTP);
BOOL FMAPdTPdLAYOUT_not_too_m(FMAPdTPdLAYOUT, INT, INT);
BOOL FMAPdTPdLAYOUT_should_gr(FMAPdTPdLAYOUT);
BOOL FSETABSTRACT_LAYOUT_elt_2(FSETABSTRACT_LAYOUT, ABSTRACT_LAYOUT, ABSTRACT_LAYOUT);
BOOL FSETABSTRACT_LAYOUT_is_e(FSETABSTRACT_LAYOUT, ABSTRACT_LAYOUT);
BOOL FSETABSTRACT_LAYOUT_not_(FSETABSTRACT_LAYOUT, INT, INT);
BOOL FSETABSTRACT_LAYOUT_shou(FSETABSTRACT_LAYOUT);
BOOL FSETAM_GLOBAL_EXPR_elt_e(FSETAM_GLOBAL_EXPR, AM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
BOOL FSETAM_GLOBAL_EXPR_is_el(FSETAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
BOOL FSETAM_GLOBAL_EXPR_not_t(FSETAM_GLOBAL_EXPR, INT, INT);
BOOL FSETAM_GLOBAL_EXPR_shoul(FSETAM_GLOBAL_EXPR);
BOOL FSETAM_ROUT_DEF_elt_eq_A(FSETAM_ROUT_DEF, AM_ROUT_DEF, AM_ROUT_DEF);
BOOL FSETAM_ROUT_DEF_is_elt_n(FSETAM_ROUT_DEF, AM_ROUT_DEF);
BOOL FSETAM_ROUT_DEF_not_too_(FSETAM_ROUT_DEF, INT, INT);
BOOL FSETAM_ROUT_DEF_should_g(FSETAM_ROUT_DEF);
BOOL FSETAM_ROUT_DEF_should_s(FSETAM_ROUT_DEF);
BOOL FSETAM_ROUT_DEF_test_AM_(FSETAM_ROUT_DEF, AM_ROUT_DEF);
BOOL FSETAS_FEAT_MOD_elt_eq_A(FSETAS_FEAT_MOD, AS_FEAT_MOD, AS_FEAT_MOD);
BOOL FSETAS_FEAT_MOD_is_elt_n(FSETAS_FEAT_MOD, AS_FEAT_MOD);
BOOL FSETAS_FEAT_MOD_not_too_(FSETAS_FEAT_MOD, INT, INT);
BOOL FSETAS_FEAT_MOD_should_g(FSETAS_FEAT_MOD);
BOOL FSETAS_FEAT_MOD_test_AS_(FSETAS_FEAT_MOD, AS_FEAT_MOD);
BOOL FSETBOUND_TYPE_LAYOUT_el3(FSETBOUND_TYPE_LAYOUT, BOUND_TYPE_LAYOUT, BOUND_TYPE_LAYOUT);
BOOL FSETBOUND_TYPE_LAYOUT_is(FSETBOUND_TYPE_LAYOUT, BOUND_TYPE_LAYOUT);
BOOL FSETBOUND_TYPE_LAYOUT_no(FSETBOUND_TYPE_LAYOUT, INT, INT);
BOOL FSETBOUND_TYPE_LAYOUT_sh(FSETBOUND_TYPE_LAYOUT);
BOOL FSETBUILTIN_LAYOUT_elt_e(FSETBUILTIN_LAYOUT, BUILTIN_LAYOUT, BUILTIN_LAYOUT);
BOOL FSETBUILTIN_LAYOUT_is_el(FSETBUILTIN_LAYOUT, BUILTIN_LAYOUT);
BOOL FSETBUILTIN_LAYOUT_not_t(FSETBUILTIN_LAYOUT, INT, INT);
BOOL FSETBUILTIN_LAYOUT_shoul(FSETBUILTIN_LAYOUT);
BOOL FSETCLASS_LAYOUT_elt_eq_(FSETCLASS_LAYOUT, CLASS_LAYOUT, CLASS_LAYOUT);
BOOL FSETCLASS_LAYOUT_is_elt_(FSETCLASS_LAYOUT, CLASS_LAYOUT);
BOOL FSETCLASS_LAYOUT_not_too(FSETCLASS_LAYOUT, INT, INT);
BOOL FSETCLASS_LAYOUT_should_(FSETCLASS_LAYOUT);
BOOL FSETEXTERNAL_LAYOUT_elt_2(FSETEXTERNAL_LAYOUT, EXTERNAL_LAYOUT, EXTERNAL_LAYOUT);
BOOL FSETEXTERNAL_LAYOUT_is_e(FSETEXTERNAL_LAYOUT, EXTERNAL_LAYOUT);
BOOL FSETEXTERNAL_LAYOUT_not_(FSETEXTERNAL_LAYOUT, INT, INT);
BOOL FSETEXTERNAL_LAYOUT_shou(FSETEXTERNAL_LAYOUT);
BOOL FSETIDENT_elt_eq_IDENT_I(FSETIDENT, IDENT, IDENT);
BOOL FSETIDENT_is_elt_nil_IDE(FSETIDENT, IDENT);
BOOL FSETIDENT_not_too_many_I(FSETIDENT, INT, INT);
BOOL FSETIDENT_should_grow_BO(FSETIDENT);
BOOL FSETIDENT_test_IDENT_BOO(FSETIDENT, IDENT);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_ae(FSETBOUND_TYPE_LAYOUT_ae_frame);
BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_ag(FSETBOUND_TYPE_LAYOUT, INT);
BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_el(FSETBOUND_TYPE_LAYOUT);
BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_el1(FSETBOUND_TYPE_LAYOUT_el1_frame);
BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_aeltb(FSETBUILTIN_LAYOUT_aeltb_frame);
BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_aget_(FSETBUILTIN_LAYOUT, INT);
BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_elt_n(FSETBUILTIN_LAYOUT);
BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_eltb_(FSETBUILTIN_LAYOUT_eltb__frame);
CLASS_LAYOUT FSETCLASS_LAYOUT_aeltb_C(FSETCLASS_LAYOUT_aeltb_C_frame);
CLASS_LAYOUT FSETCLASS_LAYOUT_aget_IN(FSETCLASS_LAYOUT, INT);
CLASS_LAYOUT FSETCLASS_LAYOUT_elt_nil(FSETCLASS_LAYOUT);
CLASS_LAYOUT FSETCLASS_LAYOUT_eltb_CL(FSETCLASS_LAYOUT_eltb_CL_frame);
ERR1 ERR_create_ERR(ERR1);
ERR1 ERR_plus_dSTR_ERR(ERR1, dSTR);
EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_aelt(FSETEXTERNAL_LAYOUT_aelt_frame);
EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_aget(FSETEXTERNAL_LAYOUT, INT);
EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_elt_(FSETEXTERNAL_LAYOUT);
EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_eltb(FSETEXTERNAL_LAYOUT_eltb_frame);
FLISTAM_ITER_CALL_EXPR FMAPAM_ROUT_DEFFLISTAM_I19(FMAPAM_ROUT_DEFFLISTAM_I, AM_ROUT_DEF);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT, dLAYOUT);
FLISTdLAYOUT FRAME_LAYOUT_dependencie(FRAME_LAYOUT);
FMAPAM_ROUT_DEFFRAME_LAY FMAPAM_ROUT_DEFFRAME_LAY16(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF, FRAME_LAYOUT);
FMAPdTPIFC FMAPdTPIFC_allocate_INT_(FMAPdTPIFC, INT);
FMAPdTPIFC FMAPdTPIFC_double_size_F(FMAPdTPIFC);
FMAPdTPIFC FMAPdTPIFC_insert_dTP_IF(FMAPdTPIFC, dTP, IFC);
FMAPdTPIFC FMAPdTPIFC_insert_pair_T(FMAPdTPIFC, TUPdTPIFC);
FMAPdTPIMPL FMAPdTPIMPL_allocate_INT(FMAPdTPIMPL, INT);
FMAPdTPIMPL FMAPdTPIMPL_double_size_(FMAPdTPIMPL);
FMAPdTPIMPL FMAPdTPIMPL_insert_dTP_I(FMAPdTPIMPL, dTP, IMPL);
FMAPdTPIMPL FMAPdTPIMPL_insert_pair_(FMAPdTPIMPL, TUPdTPIMPL);
FMAPdTPINT FMAPdTPINT_allocate_INT_(FMAPdTPINT, INT);
FMAPdTPINT FMAPdTPINT_create_FMAPdT(FMAPdTPINT);
FMAPdTPINT FMAPdTPINT_double_size_F(FMAPdTPINT);
FMAPdTPINT FMAPdTPINT_insert_dTP_IN(FMAPdTPINT, dTP, INT);
FMAPdTPINT FMAPdTPINT_insert_pair_T(FMAPdTPINT, TUPdTPINT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_allocate_(FMAPdTPdLAYOUT, INT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_double_si(FMAPdTPdLAYOUT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_pa(FMAPdTPdLAYOUT, TUPdTPdLAYOUT);
FRAME_LAYOUT FMAPAM_ROUT_DEFFRAME_LAY6(FMAPAM_ROUT_DEFFRAME_LAY, AM_ROUT_DEF);
FRAME_LAYOUT FRAME_LAYOUT_create_AM_R(FRAME_LAYOUT, AM_ROUT_DEF, PROG);
FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_allo(FSETABSTRACT_LAYOUT, INT);
FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_doub(FSETABSTRACT_LAYOUT);
FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_inse(FSETABSTRACT_LAYOUT, ABSTRACT_LAYOUT);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_alloc(FSETAM_GLOBAL_EXPR, INT);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_copy_(FSETAM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_creat(FSETAM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_doubl(FSETAM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_inser(FSETAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_to_un(FSETAM_GLOBAL_EXPR, FSETAM_GLOBAL_EXPR);
FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_union(FSETAM_GLOBAL_EXPR, FSETAM_GLOBAL_EXPR);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_allocate(FSETAM_ROUT_DEF, INT);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_create_F(FSETAM_ROUT_DEF);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_delete_A(FSETAM_ROUT_DEF, AM_ROUT_DEF);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_double_s(FSETAM_ROUT_DEF);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_halve_si(FSETAM_ROUT_DEF);
FSETAM_ROUT_DEF FSETAM_ROUT_DEF_insert_A(FSETAM_ROUT_DEF, AM_ROUT_DEF);
FSETAS_FEAT_MOD FSETAS_FEAT_MOD_allocate(FSETAS_FEAT_MOD, INT);
FSETAS_FEAT_MOD FSETAS_FEAT_MOD_double_s(FSETAS_FEAT_MOD);
FSETAS_FEAT_MOD FSETAS_FEAT_MOD_insert_A(FSETAS_FEAT_MOD, AS_FEAT_MOD);
FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_al(FSETBOUND_TYPE_LAYOUT, INT);
FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_do(FSETBOUND_TYPE_LAYOUT);
FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_in(FSETBOUND_TYPE_LAYOUT, BOUND_TYPE_LAYOUT);
FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_alloc(FSETBUILTIN_LAYOUT, INT);
FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_doubl(FSETBUILTIN_LAYOUT);
FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_inser(FSETBUILTIN_LAYOUT, BUILTIN_LAYOUT);
FSETCLASS_LAYOUT FSETCLASS_LAYOUT_allocat(FSETCLASS_LAYOUT, INT);
FSETCLASS_LAYOUT FSETCLASS_LAYOUT_double_(FSETCLASS_LAYOUT);
FSETCLASS_LAYOUT FSETCLASS_LAYOUT_insert_(FSETCLASS_LAYOUT, CLASS_LAYOUT);
FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_allo(FSETEXTERNAL_LAYOUT, INT);
FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_doub(FSETEXTERNAL_LAYOUT);
FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_inse(FSETEXTERNAL_LAYOUT, EXTERNAL_LAYOUT);
FSETIDENT FSETIDENT_allocate_INT_F(FSETIDENT, INT);
FSETIDENT FSETIDENT_double_size_FS(FSETIDENT);
FSETIDENT FSETIDENT_insert_IDENT_F(FSETIDENT, IDENT);
IDENT FSETIDENT_aeltb_IDENT(FSETIDENT_aeltb_IDENT_frame);
IDENT FSETIDENT_aget_INT_IDENT(FSETIDENT, INT);
IDENT FSETIDENT_elt_nil_IDENT(FSETIDENT);
IDENT FSETIDENT_eltb_IDENT(FSETIDENT_eltb_IDENT_frame);
IFC FMAPdTPIFC_get_dTP_IFC(FMAPdTPIFC, dTP);
IMPL FMAPdTPIMPL_get_dTP_IMPL(FMAPdTPIMPL, dTP);
INT FMAPdTPIFC_asize_INT(FMAPdTPIFC);
INT FMAPdTPIFC_key_hash_dTP_(FMAPdTPIFC, dTP);
INT FMAPdTPIMPL_asize_INT(FMAPdTPIMPL);
INT FMAPdTPIMPL_key_hash_dTP(FMAPdTPIMPL, dTP);
INT FMAPdTPINT_asize_INT(FMAPdTPINT);
INT FMAPdTPINT_get_dTP_INT(FMAPdTPINT, dTP);
INT FMAPdTPINT_key_hash_dTP_(FMAPdTPINT, dTP);
INT FMAPdTPINT_size_INT(FMAPdTPINT);
INT FMAPdTPINT_targetsb_INT(FMAPdTPINT_targetsb_INT_frame);
INT FMAPdTPdLAYOUT_asize_INT(FMAPdTPdLAYOUT);
INT FMAPdTPdLAYOUT_key_hash_(FMAPdTPdLAYOUT, dTP);
INT FSETABSTRACT_LAYOUT_asiz(FSETABSTRACT_LAYOUT);
INT FSETABSTRACT_LAYOUT_elt_1(FSETABSTRACT_LAYOUT, ABSTRACT_LAYOUT);
INT FSETAM_GLOBAL_EXPR_asize(FSETAM_GLOBAL_EXPR);
INT FSETAM_GLOBAL_EXPR_elt_h(FSETAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
INT FSETAM_GLOBAL_EXPR_size_(FSETAM_GLOBAL_EXPR);
INT FSETAM_ROUT_DEF_asize_IN(FSETAM_ROUT_DEF);
INT FSETAM_ROUT_DEF_elt_hash(FSETAM_ROUT_DEF, AM_ROUT_DEF);
INT FSETAM_ROUT_DEF_size_INT(FSETAM_ROUT_DEF);
INT FSETAS_FEAT_MOD_asize_IN(FSETAS_FEAT_MOD);
INT FSETAS_FEAT_MOD_elt_hash(FSETAS_FEAT_MOD, AS_FEAT_MOD);
INT FSETAS_FEAT_MOD_size_INT(FSETAS_FEAT_MOD);
INT FSETBOUND_TYPE_LAYOUT_as(FSETBOUND_TYPE_LAYOUT);
INT FSETBOUND_TYPE_LAYOUT_el2(FSETBOUND_TYPE_LAYOUT, BOUND_TYPE_LAYOUT);
INT FSETBUILTIN_LAYOUT_asize(FSETBUILTIN_LAYOUT);
INT FSETBUILTIN_LAYOUT_elt_h(FSETBUILTIN_LAYOUT, BUILTIN_LAYOUT);
INT FSETCLASS_LAYOUT_asize_I(FSETCLASS_LAYOUT);
INT FSETCLASS_LAYOUT_elt_has(FSETCLASS_LAYOUT, CLASS_LAYOUT);
INT FSETEXTERNAL_LAYOUT_asiz(FSETEXTERNAL_LAYOUT);
INT FSETEXTERNAL_LAYOUT_elt_1(FSETEXTERNAL_LAYOUT, EXTERNAL_LAYOUT);
INT FSETIDENT_asize_INT(FSETIDENT);
INT FSETIDENT_elt_hash_IDENT(FSETIDENT, IDENT);
INT IDENT_hash_INT(IDENT);
INT INT_hash_INT(INT);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_upb_INT(INT_upb_INT_frame);
INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
STR FRAME_LAYOUT_str_STR(FRAME_LAYOUT);
STR FRAME_LAYOUT_typedef_CGE(FRAME_LAYOUT, CGEN);
STR INT_hex_str_STR(INT);
STR MANGLE_mangle_dOB_dOB_ST(MANGLE, OB, OB);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_pretty_STR(STR);
TUPdTPIFC FMAPdTPIFC_aeltb_TUPdTPI(FMAPdTPIFC_aeltb_TUPdTPI_frame);
TUPdTPIFC FMAPdTPIFC_aget_INT_TUPd(FMAPdTPIFC, INT);
TUPdTPIFC FMAPdTPIFC_pairsb_TUPdTP(FMAPdTPIFC_pairsb_TUPdTP_frame);
TUPdTPIFC TUPdTPIFC_create_dTP_IFC(TUPdTPIFC, dTP, IFC);
TUPdTPIMPL FMAPdTPIMPL_aeltb_TUPdTP(FMAPdTPIMPL_aeltb_TUPdTP_frame);
TUPdTPIMPL FMAPdTPIMPL_aget_INT_TUP(FMAPdTPIMPL, INT);
TUPdTPIMPL FMAPdTPIMPL_pairsb_TUPdT(FMAPdTPIMPL_pairsb_TUPdT_frame);
TUPdTPIMPL TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL, dTP, IMPL);
TUPdTPINT FMAPdTPINT_aeltb_TUPdTPI(FMAPdTPINT_aeltb_TUPdTPI_frame);
TUPdTPINT FMAPdTPINT_aget_INT_TUPd(FMAPdTPINT, INT);
TUPdTPINT FMAPdTPINT_pairsb_TUPdTP(FMAPdTPINT_pairsb_TUPdTP_frame);
TUPdTPINT TUPdTPINT_create_dTP_INT(TUPdTPINT, dTP, INT);
TUPdTPdLAYOUT FMAPdTPdLAYOUT_aeltb_TUP(FMAPdTPdLAYOUT_aeltb_TUP_frame);
TUPdTPdLAYOUT FMAPdTPdLAYOUT_aget_INT_(FMAPdTPdLAYOUT, INT);
TUPdTPdLAYOUT FMAPdTPdLAYOUT_pairsb_TU(FMAPdTPdLAYOUT_pairsb_TU_frame);
TUPdTPdLAYOUT TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT, dTP, dLAYOUT);
dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT, dTP);
dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL, dTP);
dTP AM_LOCAL_EXPR_tp_dTP(AM_LOCAL_EXPR);
dTP FMAPdTPIFC_key_nil_dTP(FMAPdTPIFC);
dTP FMAPdTPIMPL_key_nil_dTP(FMAPdTPIMPL);
dTP FMAPdTPINT_key_nil_dTP(FMAPdTPINT);
dTP FMAPdTPINT_keysb_dTP(FMAPdTPINT_keysb_dTP_frame);
dTP FMAPdTPdLAYOUT_key_nil_d(FMAPdTPdLAYOUT);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void ERR_plus_dSTR(ERR1, dSTR);
void FMAPdTPIFC_aset_INT_TUPd(FMAPdTPIFC, INT, TUPdTPIFC);
void FMAPdTPIFC_asetb_TUPdTPI(FMAPdTPIFC_asetb_TUPdTPI_frame);
void FMAPdTPIMPL_aset_INT_TUP(FMAPdTPIMPL, INT, TUPdTPIMPL);
void FMAPdTPIMPL_asetb_TUPdTP(FMAPdTPIMPL_asetb_TUPdTP_frame);
void FMAPdTPINT_aset_INT_TUPd(FMAPdTPINT, INT, TUPdTPINT);
void FMAPdTPINT_asetb_TUPdTPI(FMAPdTPINT_asetb_TUPdTPI_frame);
void FMAPdTPdLAYOUT_aset_INT_(FMAPdTPdLAYOUT, INT, TUPdTPdLAYOUT);
void FMAPdTPdLAYOUT_asetb_TUP(FMAPdTPdLAYOUT_asetb_TUP_frame);
void FRAME_LAYOUT_layouts_FMA(FRAME_LAYOUT, FMAPAM_ROUT_DEFFRAME_LAY);
void FSETABSTRACT_LAYOUT_aset(FSETABSTRACT_LAYOUT, INT, ABSTRACT_LAYOUT);
void FSETABSTRACT_LAYOUT_aset1(FSETABSTRACT_LAYOUT_aset1_frame);
void FSETAM_GLOBAL_EXPR_aset_(FSETAM_GLOBAL_EXPR, INT, AM_GLOBAL_EXPR);
void FSETAM_GLOBAL_EXPR_asetb(FSETAM_GLOBAL_EXPR_asetb_frame);
void FSETAM_ROUT_DEF_aset_INT(FSETAM_ROUT_DEF, INT, AM_ROUT_DEF);
void FSETAM_ROUT_DEF_asetb_AM(FSETAM_ROUT_DEF_asetb_AM_frame);
void FSETAS_FEAT_MOD_aset_INT(FSETAS_FEAT_MOD, INT, AS_FEAT_MOD);
void FSETAS_FEAT_MOD_asetb_AS(FSETAS_FEAT_MOD_asetb_AS_frame);
void FSETBOUND_TYPE_LAYOUT_as1(FSETBOUND_TYPE_LAYOUT, INT, BOUND_TYPE_LAYOUT);
void FSETBOUND_TYPE_LAYOUT_as2(FSETBOUND_TYPE_LAYOUT_as2_frame);
void FSETBUILTIN_LAYOUT_aset_(FSETBUILTIN_LAYOUT, INT, BUILTIN_LAYOUT);
void FSETBUILTIN_LAYOUT_asetb(FSETBUILTIN_LAYOUT_asetb_frame);
void FSETCLASS_LAYOUT_aset_IN(FSETCLASS_LAYOUT, INT, CLASS_LAYOUT);
void FSETCLASS_LAYOUT_asetb_C(FSETCLASS_LAYOUT_asetb_C_frame);
void FSETEXTERNAL_LAYOUT_aset(FSETEXTERNAL_LAYOUT, INT, EXTERNAL_LAYOUT);
void FSETEXTERNAL_LAYOUT_aset1(FSETEXTERNAL_LAYOUT_aset1_frame);
void FSETIDENT_aset_INT_IDENT(FSETIDENT, INT, IDENT);
void FSETIDENT_asetb_IDENT(FSETIDENT_asetb_IDENT_frame);
void MANGLE_forbid_STR(MANGLE, STR);
void OUT_plus_dSTR(OUT, dSTR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_aelt(FSETABSTRACT_LAYOUT_aelt_frame frame) {
 ABSTRACT_LAYOUT dummy = ((ABSTRACT_LAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETABSTRACT_LAYOUT_aget(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_aget(FSETABSTRACT_LAYOUT self, INT ind) {
 ABSTRACT_LAYOUT ret_val;
 return ARR(self,ind);
}


ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_eltb(FSETABSTRACT_LAYOUT_eltb_frame frame) {
 ABSTRACT_LAYOUT dummy = ((ABSTRACT_LAYOUT) NULL);
 BOOL L1;
 ABSTRACT_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETABSTRACT_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETABSTRACT_LAYOUT_aelt_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETABSTRACT_LAYOUT_aelt(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETABSTRACT_LAYOUT_is_e(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_aeltb(FSETAM_GLOBAL_EXPR_aeltb_frame frame) {
 AM_GLOBAL_EXPR dummy = ((AM_GLOBAL_EXPR) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETAM_GLOBAL_EXPR_aget_(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_aget_(FSETAM_GLOBAL_EXPR self, INT ind) {
 AM_GLOBAL_EXPR ret_val;
 return ARR(self,ind);
}


AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_elt_n(FSETAM_GLOBAL_EXPR self) {
 AM_GLOBAL_EXPR ret_val;
 AM_GLOBAL_EXPR t = ((AM_GLOBAL_EXPR) NULL);
 ret_val = ((AM_GLOBAL_EXPR) NULL);
 return ret_val;
}


AM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_eltb_(FSETAM_GLOBAL_EXPR_eltb__frame frame) {
 AM_GLOBAL_EXPR dummy = ((AM_GLOBAL_EXPR) NULL);
 BOOL L1;
 AM_GLOBAL_EXPR L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETAM_GLOBAL_EXPR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETAM_GLOBAL_EXPR_aeltb_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETAM_GLOBAL_EXPR_aeltb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETAM_GLOBAL_EXPR_is_el(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_ROUT_DEF FSETAM_ROUT_DEF_aeltb_AM(FSETAM_ROUT_DEF_aeltb_AM_frame frame) {
 AM_ROUT_DEF dummy = ((AM_ROUT_DEF) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETAM_ROUT_DEF_aget_INT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


AM_ROUT_DEF FSETAM_ROUT_DEF_aget_INT(FSETAM_ROUT_DEF self, INT ind) {
 AM_ROUT_DEF ret_val;
 return ARR(self,ind);
}


AM_ROUT_DEF FSETAM_ROUT_DEF_elt_nil_(FSETAM_ROUT_DEF self) {
 AM_ROUT_DEF ret_val;
 AM_ROUT_DEF t = ((AM_ROUT_DEF) NULL);
 ret_val = ((AM_ROUT_DEF) NULL);
 return ret_val;
}


AM_ROUT_DEF FSETAM_ROUT_DEF_eltb_AM_(FSETAM_ROUT_DEF_eltb_AM__frame frame) {
 AM_ROUT_DEF dummy = ((AM_ROUT_DEF) NULL);
 BOOL L1;
 AM_ROUT_DEF L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETAM_ROUT_DEF) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETAM_ROUT_DEF_aeltb_AM_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETAM_ROUT_DEF_aeltb_AM(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETAM_ROUT_DEF_is_elt_n(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_ROUT_DEF FSETAM_ROUT_DEF_first_el(FSETAM_ROUT_DEF self) {
 AM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF L11;
 AM_ROUT_DEF r;
 BOOL L2;
 AM_ROUT_DEF L3;
 BOOL L4;
 L2 = (self==((FSETAM_ROUT_DEF) NULL));
 if ((!(L2))) {
  {
   struct FSETAM_ROUT_DEF_aeltb_AM_frame_struct other1_0;
   FSETAM_ROUT_DEF_aeltb_AM_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = self;
     noname1->self = L11;
    }
    L3 = FSETAM_ROUT_DEF_aeltb_AM(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    r = L3;
    L4 = FSETAM_ROUT_DEF_is_elt_n(self, r);
    if ((!(L4))) {
     ret_val = r;
     return ret_val;
    }
   }
  }
  after_loop: ;
 }
 ret_val = FSETAM_ROUT_DEF_elt_nil_(self);
 return ret_val;
}


AS_FEAT_MOD FSETAS_FEAT_MOD_aeltb_AS(FSETAS_FEAT_MOD_aeltb_AS_frame frame) {
 AS_FEAT_MOD dummy = ((AS_FEAT_MOD) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETAS_FEAT_MOD_aget_INT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


AS_FEAT_MOD FSETAS_FEAT_MOD_aget_INT(FSETAS_FEAT_MOD self, INT ind) {
 AS_FEAT_MOD ret_val;
 return ARR(self,ind);
}


AS_FEAT_MOD FSETAS_FEAT_MOD_eltb_AS_(FSETAS_FEAT_MOD_eltb_AS__frame frame) {
 AS_FEAT_MOD dummy = ((AS_FEAT_MOD) NULL);
 BOOL L1;
 AS_FEAT_MOD L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETAS_FEAT_MOD) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETAS_FEAT_MOD_aeltb_AS_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETAS_FEAT_MOD_aeltb_AS(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETAS_FEAT_MOD_is_elt_n(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


BOOL FMAPdTPIFC_is_key_nil_dT(FMAPdTPIFC self, dTP e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dTP) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dTP) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPIFC_key_eq_dTP_dT(FMAPdTPIFC self, dTP k1, dTP k2) {
 BOOL ret_val = ((BOOL) 0);
 if (k1==NULL) {
  ret_val = SYSOBEQ(((OB) k1),((OB) k2));
  return ret_val;
 } else
 switch (TAG(k1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) k1),((OB) k2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPIFC_not_too_many_(FMAPdTPIFC self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dTP k = ((dTP) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dTP e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 dTP e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPdTPIFC L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 dTP L34;
 OUT L35;
 dSTR L36;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPdTPIFC_aget_INT_TUPd(self, start1);
  L10 = (OB)((TUPdTPIFC_boxed) rt_alloc(sizeof(struct TUPdTPIFC_boxed_struct), TUPdTPIFC_tag));
  ((TUPdTPIFC_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPdTPIFC_aget_INT_TUPd(self, i).t1;
    h = FMAPdTPIFC_key_hash_dTP_(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = e;
    if (L34==NULL) {
     FATAL("Dispatch on void in FMAP{$TP,IFC}::not_too_many(INT,INT):BOOL");
    }
    L35 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR((*dTP_str_STR[TAG(L34)+dTP_str_STR_offset])(L34))));
    L36 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L36)->value_part = '\n';
    OUT_plus_dSTR(L35, L36);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPdTPIFC_should_grow_B(FMAPdTPIFC self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPdTPIFC_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPdTPIMPL_is_key_nil_d(FMAPdTPIMPL self, dTP e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dTP) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dTP) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPIMPL_key_eq_dTP_d(FMAPdTPIMPL self, dTP k1, dTP k2) {
 BOOL ret_val = ((BOOL) 0);
 if (k1==NULL) {
  ret_val = SYSOBEQ(((OB) k1),((OB) k2));
  return ret_val;
 } else
 switch (TAG(k1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) k1),((OB) k2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPIMPL_not_too_many(FMAPdTPIMPL self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dTP k = ((dTP) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dTP e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 dTP e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPdTPIMPL L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 dTP L34;
 OUT L35;
 dSTR L36;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPdTPIMPL_aget_INT_TUP(self, start1);
  L10 = (OB)((TUPdTPIMPL_boxed) rt_alloc(sizeof(struct TUPdTPIMPL_boxed_struct), TUPdTPIMPL_tag));
  ((TUPdTPIMPL_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPdTPIMPL_aget_INT_TUP(self, i).t1;
    h = FMAPdTPIMPL_key_hash_dTP(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = e;
    if (L34==NULL) {
     FATAL("Dispatch on void in FMAP{$TP,IMPL}::not_too_many(INT,INT):BOOL");
    }
    L35 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR((*dTP_str_STR[TAG(L34)+dTP_str_STR_offset])(L34))));
    L36 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L36)->value_part = '\n';
    OUT_plus_dSTR(L35, L36);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPdTPIMPL_should_grow_(FMAPdTPIMPL self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPdTPIMPL_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPdTPINT_is_key_nil_dT(FMAPdTPINT self, dTP e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dTP) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dTP) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPINT_key_eq_dTP_dT(FMAPdTPINT self, dTP k1, dTP k2) {
 BOOL ret_val = ((BOOL) 0);
 if (k1==NULL) {
  ret_val = SYSOBEQ(((OB) k1),((OB) k2));
  return ret_val;
 } else
 switch (TAG(k1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) k1),((OB) k2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPINT_not_too_many_(FMAPdTPINT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dTP k = ((dTP) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dTP e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 dTP e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPdTPINT L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 dTP L34;
 OUT L35;
 dSTR L36;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPdTPINT_aget_INT_TUPd(self, start1);
  L10 = (OB)((TUPdTPINT_boxed) rt_alloc(sizeof(struct TUPdTPINT_boxed_struct), TUPdTPINT_tag));
  ((TUPdTPINT_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPdTPINT_aget_INT_TUPd(self, i).t1;
    h = FMAPdTPINT_key_hash_dTP_(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = e;
    if (L34==NULL) {
     FATAL("Dispatch on void in FMAP{$TP,INT}::not_too_many(INT,INT):BOOL");
    }
    L35 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR((*dTP_str_STR[TAG(L34)+dTP_str_STR_offset])(L34))));
    L36 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L36)->value_part = '\n';
    OUT_plus_dSTR(L35, L36);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPdTPINT_should_grow_B(FMAPdTPINT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPdTPINT_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FMAPdTPdLAYOUT_is_key_ni(FMAPdTPdLAYOUT self, dTP e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dTP) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dTP) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPdLAYOUT_key_eq_dT(FMAPdTPdLAYOUT self, dTP k1, dTP k2) {
 BOOL ret_val = ((BOOL) 0);
 if (k1==NULL) {
  ret_val = SYSOBEQ(((OB) k1),((OB) k2));
  return ret_val;
 } else
 switch (TAG(k1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) k1),((OB) k2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL FMAPdTPdLAYOUT_not_too_m(FMAPdTPdLAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dTP k = ((dTP) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dTP e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 dTP e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L7;
 extern STR duetoabadhashfunctionint;
 ERR1 L8;
 TUPdTPdLAYOUT L9;
 OB L10;
 INT L12;
 ERR1 L13;
 extern STR name3;
 OUT L14;
 extern STR Snowballingvalues;
 INT L15;
 INT L16;
 INT L17;
 
 OUT L18;
 dSTR L19;
 OUT L20;
 dSTR L22;
 OUT L23;
 OUT L24;
 dSTR L25;
 OUT L26;
 INT L27;
 INT L28;
 dSTR L29;
 OUT L30;
 dSTR L32;
 OUT L33;
 dTP L34;
 OUT L35;
 dSTR L36;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L9 = FMAPdTPdLAYOUT_aget_INT_(self, start1);
  L10 = (OB)((TUPdTPdLAYOUT_boxed) rt_alloc(sizeof(struct TUPdTPdLAYOUT_boxed_struct), TUPdTPdLAYOUT_tag));
  ((TUPdTPdLAYOUT_boxed) L10)->value_part = L9;
  L12 = (SYSTP(L10));
  L13 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L12))));
  ERR_plus_dSTR(L13, ((dSTR) ((STR) &name3)));
  L14 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L14, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L16 = L11;
     L17 = L21;
     L15 = L16;
    } else {
     L15++;
    }
    if (L15>L17) goto after_loop;
    i = L15;
    e = FMAPdTPdLAYOUT_aget_INT_(self, i).t1;
    h = FMAPdTPdLAYOUT_key_hash_(self, e);
    L18 = OUT_create_OUT(((OUT) NULL));
    L19 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L19)->value_part = i;
    L20 = OUT_plus_dSTR_OUT(L18, L19);
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = '\t';
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = OUT_plus_dSTR_OUT(L23, ((dSTR) INT_hex_str_STR(h)));
    L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L25)->value_part = '\t';
    L26 = OUT_plus_dSTR_OUT(L24, L25);
    L27 = (ASIZE(self));
    L28 = (INTMINUS(L27,2));
    L29 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L29)->value_part = (h&L28);
    L30 = OUT_plus_dSTR_OUT(L26, L29);
    L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L32)->value_part = '\t';
    L33 = OUT_plus_dSTR_OUT(L30, L32);
    L34 = e;
    if (L34==NULL) {
     FATAL("Dispatch on void in FMAP{$TP,$LAYOUT}::not_too_many(INT,INT):BOOL");
    }
    L35 = OUT_plus_dSTR_OUT(L33, ((dSTR) STR_pretty_STR((*dTP_str_STR[TAG(L34)+dTP_str_STR_offset])(L34))));
    L36 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L36)->value_part = '\n';
    OUT_plus_dSTR(L35, L36);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FMAPdTPdLAYOUT_should_gr(FMAPdTPdLAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FMAPdTPdLAYOUT_load_rati;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETABSTRACT_LAYOUT_elt_2(FSETABSTRACT_LAYOUT self, ABSTRACT_LAYOUT e1, ABSTRACT_LAYOUT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETABSTRACT_LAYOUT_is_e(FSETABSTRACT_LAYOUT self, ABSTRACT_LAYOUT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((ABSTRACT_LAYOUT) NULL));
 return ret_val;
}


BOOL FSETABSTRACT_LAYOUT_not_(FSETABSTRACT_LAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 ABSTRACT_LAYOUT t = ((ABSTRACT_LAYOUT) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 ABSTRACT_LAYOUT e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 ABSTRACT_LAYOUT e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco;
 ERR1 L7;
 INT L8;
 ERR1 L9;
 extern STR probably1;
 ERR1 L10;
 extern STR duetoabadhashfunctionint;
 ERR1 L12;
 ABSTRACT_LAYOUT L13;
 INT L14;
 ERR1 L15;
 extern STR name3;
 OUT L16;
 extern STR Snowballingvalues;
 INT L17;
 INT L18;
 INT L19;
 
 OUT L20;
 dSTR L22;
 OUT L23;
 dSTR L24;
 OUT L25;
 OUT L26;
 dSTR L27;
 OUT L28;
 INT L29;
 INT L30;
 dSTR L32;
 OUT L33;
 dSTR L34;
 OUT L35;
 OUT L36;
 dSTR L37;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L8 = (SYSTP(((OB) self)));
  L9 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L8))));
  L10 = ERR_plus_dSTR_ERR(L9, ((dSTR) ((STR) &probably1)));
  L12 = ERR_plus_dSTR_ERR(L10, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L13 = FSETABSTRACT_LAYOUT_aget(self, start1);
  L14 = (SYSTP(((OB) L13)));
  L15 = ERR_plus_dSTR_ERR(L12, ((dSTR) (SYSSTRFORTP(L14))));
  ERR_plus_dSTR(L15, ((dSTR) ((STR) &name3)));
  L16 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L16, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L18 = L11;
     L19 = L21;
     L17 = L18;
    } else {
     L17++;
    }
    if (L17>L19) goto after_loop;
    i = L17;
    e = FSETABSTRACT_LAYOUT_aget(self, i);
    h = FSETABSTRACT_LAYOUT_elt_1(self, e);
    L20 = OUT_create_OUT(((OUT) NULL));
    L22 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L22)->value_part = i;
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L24)->value_part = '\t';
    L25 = OUT_plus_dSTR_OUT(L23, L24);
    L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) INT_hex_str_STR(h)));
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = '\t';
    L28 = OUT_plus_dSTR_OUT(L26, L27);
    L29 = (ASIZE(self));
    L30 = (INTMINUS(L29,2));
    L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L32)->value_part = (h&L30);
    L33 = OUT_plus_dSTR_OUT(L28, L32);
    L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L34)->value_part = '\t';
    L35 = OUT_plus_dSTR_OUT(L33, L34);
    L36 = OUT_plus_dSTR_OUT(L35, ((dSTR) STR_pretty_STR(ATTR(e,str1))));
    L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L37)->value_part = '\n';
    OUT_plus_dSTR(L36, L37);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETABSTRACT_LAYOUT_shou(FSETABSTRACT_LAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETABSTRACT_LAYOUT_load;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETAM_GLOBAL_EXPR_elt_e(FSETAM_GLOBAL_EXPR self, AM_GLOBAL_EXPR e1, AM_GLOBAL_EXPR e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETAM_GLOBAL_EXPR_is_el(FSETAM_GLOBAL_EXPR self, AM_GLOBAL_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_GLOBAL_EXPR) NULL));
 return ret_val;
}


BOOL FSETAM_GLOBAL_EXPR_not_t(FSETAM_GLOBAL_EXPR self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_GLOBAL_EXPR t = ((AM_GLOBAL_EXPR) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR probably1;
 ERR1 L6;
 extern STR duetoabadhashfunctionint;
 ERR1 L7;
 AM_GLOBAL_EXPR L8;
 INT L9;
 ERR1 L10;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &probably1)));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L8 = FSETAM_GLOBAL_EXPR_aget_(self, start1);
  L9 = (SYSTP(((OB) L8)));
  L10 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L9))));
  ERR_plus_dSTR(L10, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETAM_GLOBAL_EXPR_shoul(FSETAM_GLOBAL_EXPR self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETAM_GLOBAL_EXPR_load_;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_elt_eq_A(FSETAM_ROUT_DEF self, AM_ROUT_DEF e1, AM_ROUT_DEF e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_is_elt_n(FSETAM_ROUT_DEF self, AM_ROUT_DEF e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AM_ROUT_DEF) NULL));
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_not_too_(FSETAM_ROUT_DEF self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AM_ROUT_DEF t = ((AM_ROUT_DEF) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR probably1;
 ERR1 L6;
 extern STR duetoabadhashfunctionint;
 ERR1 L7;
 AM_ROUT_DEF L8;
 INT L9;
 ERR1 L10;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &probably1)));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L8 = FSETAM_ROUT_DEF_aget_INT(self, start1);
  L9 = (SYSTP(((OB) L8)));
  L10 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L9))));
  ERR_plus_dSTR(L10, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_should_g(FSETAM_ROUT_DEF self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETAM_ROUT_DEF_load_rat;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_should_s(FSETAM_ROUT_DEF self) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 L2 = (ASIZE(self));
 if ((L2>=33)) {
  L3 = ATTR(self,hsize);
  L4 = (ASIZE(self));
  L5 = (INTMINUS(L4,1));
  L6 = FSETAM_ROUT_DEF_load_rat;
  L7 = (INTTIMES(L6,2));
  L8 = (INTDIV(L5,L7));
  L1 = (L3<L8);
 } else {
  L1 = FALSE;
 }
 ret_val = L1;
 return ret_val;
}


BOOL FSETAM_ROUT_DEF_test_AM_(FSETAM_ROUT_DEF self, AM_ROUT_DEF e) {
 BOOL ret_val = ((BOOL) 0);
 INT h = ((INT) 0);
 AM_ROUT_DEF te;
 AM_ROUT_DEF te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FSETAM_ROUT_DEF) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L1 = FSETAM_ROUT_DEF_elt_hash(self, e);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  te = FSETAM_ROUT_DEF_aget_INT(self, h);
  if (FSETAM_ROUT_DEF_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETAM_ROUT_DEF_elt_eq_A(self, te, e)) {
    ret_val = TRUE;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   te1 = FSETAM_ROUT_DEF_aget_INT(self, h);
   if (FSETAM_ROUT_DEF_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETAM_ROUT_DEF_elt_eq_A(self, te1, e)) {
     ret_val = TRUE;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = FALSE;
 return ret_val;
}


BOOL FSETAS_FEAT_MOD_elt_eq_A(FSETAS_FEAT_MOD self, AS_FEAT_MOD e1, AS_FEAT_MOD e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETAS_FEAT_MOD_is_elt_n(FSETAS_FEAT_MOD self, AS_FEAT_MOD e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((AS_FEAT_MOD) NULL));
 return ret_val;
}


BOOL FSETAS_FEAT_MOD_not_too_(FSETAS_FEAT_MOD self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 AS_FEAT_MOD t = ((AS_FEAT_MOD) NULL);
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR probably1;
 ERR1 L6;
 extern STR duetoabadhashfunctionint;
 ERR1 L7;
 AS_FEAT_MOD L8;
 INT L9;
 ERR1 L10;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &probably1)));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L8 = FSETAS_FEAT_MOD_aget_INT(self, start1);
  L9 = (SYSTP(((OB) L8)));
  L10 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L9))));
  ERR_plus_dSTR(L10, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETAS_FEAT_MOD_should_g(FSETAS_FEAT_MOD self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETAS_FEAT_MOD_load_rat;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETAS_FEAT_MOD_test_AS_(FSETAS_FEAT_MOD self, AS_FEAT_MOD e) {
 BOOL ret_val = ((BOOL) 0);
 INT h = ((INT) 0);
 AS_FEAT_MOD te;
 AS_FEAT_MOD te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FSETAS_FEAT_MOD) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L1 = FSETAS_FEAT_MOD_elt_hash(self, e);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  te = FSETAS_FEAT_MOD_aget_INT(self, h);
  if (FSETAS_FEAT_MOD_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETAS_FEAT_MOD_elt_eq_A(self, te, e)) {
    ret_val = TRUE;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   te1 = FSETAS_FEAT_MOD_aget_INT(self, h);
   if (FSETAS_FEAT_MOD_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETAS_FEAT_MOD_elt_eq_A(self, te1, e)) {
     ret_val = TRUE;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = FALSE;
 return ret_val;
}


BOOL FSETBOUND_TYPE_LAYOUT_el3(FSETBOUND_TYPE_LAYOUT self, BOUND_TYPE_LAYOUT e1, BOUND_TYPE_LAYOUT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETBOUND_TYPE_LAYOUT_is(FSETBOUND_TYPE_LAYOUT self, BOUND_TYPE_LAYOUT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((BOUND_TYPE_LAYOUT) NULL));
 return ret_val;
}


BOOL FSETBOUND_TYPE_LAYOUT_no(FSETBOUND_TYPE_LAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 BOUND_TYPE_LAYOUT t = ((BOUND_TYPE_LAYOUT) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 BOUND_TYPE_LAYOUT e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 BOUND_TYPE_LAYOUT e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco;
 ERR1 L7;
 INT L8;
 ERR1 L9;
 extern STR probably1;
 ERR1 L10;
 extern STR duetoabadhashfunctionint;
 ERR1 L12;
 BOUND_TYPE_LAYOUT L13;
 INT L14;
 ERR1 L15;
 extern STR name3;
 OUT L16;
 extern STR Snowballingvalues;
 INT L17;
 INT L18;
 INT L19;
 
 OUT L20;
 dSTR L22;
 OUT L23;
 dSTR L24;
 OUT L25;
 OUT L26;
 dSTR L27;
 OUT L28;
 INT L29;
 INT L30;
 dSTR L32;
 OUT L33;
 dSTR L34;
 OUT L35;
 OUT L36;
 dSTR L37;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L8 = (SYSTP(((OB) self)));
  L9 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L8))));
  L10 = ERR_plus_dSTR_ERR(L9, ((dSTR) ((STR) &probably1)));
  L12 = ERR_plus_dSTR_ERR(L10, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L13 = FSETBOUND_TYPE_LAYOUT_ag(self, start1);
  L14 = (SYSTP(((OB) L13)));
  L15 = ERR_plus_dSTR_ERR(L12, ((dSTR) (SYSSTRFORTP(L14))));
  ERR_plus_dSTR(L15, ((dSTR) ((STR) &name3)));
  L16 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L16, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L18 = L11;
     L19 = L21;
     L17 = L18;
    } else {
     L17++;
    }
    if (L17>L19) goto after_loop;
    i = L17;
    e = FSETBOUND_TYPE_LAYOUT_ag(self, i);
    h = FSETBOUND_TYPE_LAYOUT_el2(self, e);
    L20 = OUT_create_OUT(((OUT) NULL));
    L22 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L22)->value_part = i;
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L24)->value_part = '\t';
    L25 = OUT_plus_dSTR_OUT(L23, L24);
    L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) INT_hex_str_STR(h)));
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = '\t';
    L28 = OUT_plus_dSTR_OUT(L26, L27);
    L29 = (ASIZE(self));
    L30 = (INTMINUS(L29,2));
    L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L32)->value_part = (h&L30);
    L33 = OUT_plus_dSTR_OUT(L28, L32);
    L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L34)->value_part = '\t';
    L35 = OUT_plus_dSTR_OUT(L33, L34);
    L36 = OUT_plus_dSTR_OUT(L35, ((dSTR) STR_pretty_STR(ATTR(e,str1))));
    L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L37)->value_part = '\n';
    OUT_plus_dSTR(L36, L37);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETBOUND_TYPE_LAYOUT_sh(FSETBOUND_TYPE_LAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETBOUND_TYPE_LAYOUT_lo;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETBUILTIN_LAYOUT_elt_e(FSETBUILTIN_LAYOUT self, BUILTIN_LAYOUT e1, BUILTIN_LAYOUT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETBUILTIN_LAYOUT_is_el(FSETBUILTIN_LAYOUT self, BUILTIN_LAYOUT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((BUILTIN_LAYOUT) NULL));
 return ret_val;
}


BOOL FSETBUILTIN_LAYOUT_not_t(FSETBUILTIN_LAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 BUILTIN_LAYOUT t = ((BUILTIN_LAYOUT) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 BUILTIN_LAYOUT e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 BUILTIN_LAYOUT e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco;
 ERR1 L7;
 INT L8;
 ERR1 L9;
 extern STR probably1;
 ERR1 L10;
 extern STR duetoabadhashfunctionint;
 ERR1 L12;
 BUILTIN_LAYOUT L13;
 INT L14;
 ERR1 L15;
 extern STR name3;
 OUT L16;
 extern STR Snowballingvalues;
 INT L17;
 INT L18;
 INT L19;
 
 OUT L20;
 dSTR L22;
 OUT L23;
 dSTR L24;
 OUT L25;
 OUT L26;
 dSTR L27;
 OUT L28;
 INT L29;
 INT L30;
 dSTR L32;
 OUT L33;
 dSTR L34;
 OUT L35;
 OUT L36;
 dSTR L37;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L8 = (SYSTP(((OB) self)));
  L9 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L8))));
  L10 = ERR_plus_dSTR_ERR(L9, ((dSTR) ((STR) &probably1)));
  L12 = ERR_plus_dSTR_ERR(L10, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L13 = FSETBUILTIN_LAYOUT_aget_(self, start1);
  L14 = (SYSTP(((OB) L13)));
  L15 = ERR_plus_dSTR_ERR(L12, ((dSTR) (SYSSTRFORTP(L14))));
  ERR_plus_dSTR(L15, ((dSTR) ((STR) &name3)));
  L16 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L16, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L18 = L11;
     L19 = L21;
     L17 = L18;
    } else {
     L17++;
    }
    if (L17>L19) goto after_loop;
    i = L17;
    e = FSETBUILTIN_LAYOUT_aget_(self, i);
    h = FSETBUILTIN_LAYOUT_elt_h(self, e);
    L20 = OUT_create_OUT(((OUT) NULL));
    L22 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L22)->value_part = i;
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L24)->value_part = '\t';
    L25 = OUT_plus_dSTR_OUT(L23, L24);
    L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) INT_hex_str_STR(h)));
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = '\t';
    L28 = OUT_plus_dSTR_OUT(L26, L27);
    L29 = (ASIZE(self));
    L30 = (INTMINUS(L29,2));
    L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L32)->value_part = (h&L30);
    L33 = OUT_plus_dSTR_OUT(L28, L32);
    L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L34)->value_part = '\t';
    L35 = OUT_plus_dSTR_OUT(L33, L34);
    L36 = OUT_plus_dSTR_OUT(L35, ((dSTR) STR_pretty_STR(ATTR(e,str1))));
    L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L37)->value_part = '\n';
    OUT_plus_dSTR(L36, L37);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETBUILTIN_LAYOUT_shoul(FSETBUILTIN_LAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETBUILTIN_LAYOUT_load_;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETCLASS_LAYOUT_elt_eq_(FSETCLASS_LAYOUT self, CLASS_LAYOUT e1, CLASS_LAYOUT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETCLASS_LAYOUT_is_elt_(FSETCLASS_LAYOUT self, CLASS_LAYOUT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((CLASS_LAYOUT) NULL));
 return ret_val;
}


BOOL FSETCLASS_LAYOUT_not_too(FSETCLASS_LAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 CLASS_LAYOUT t = ((CLASS_LAYOUT) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 CLASS_LAYOUT e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 CLASS_LAYOUT e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco;
 ERR1 L7;
 INT L8;
 ERR1 L9;
 extern STR probably1;
 ERR1 L10;
 extern STR duetoabadhashfunctionint;
 ERR1 L12;
 CLASS_LAYOUT L13;
 INT L14;
 ERR1 L15;
 extern STR name3;
 OUT L16;
 extern STR Snowballingvalues;
 INT L17;
 INT L18;
 INT L19;
 
 OUT L20;
 dSTR L22;
 OUT L23;
 dSTR L24;
 OUT L25;
 OUT L26;
 dSTR L27;
 OUT L28;
 INT L29;
 INT L30;
 dSTR L32;
 OUT L33;
 dSTR L34;
 OUT L35;
 OUT L36;
 dSTR L37;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L8 = (SYSTP(((OB) self)));
  L9 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L8))));
  L10 = ERR_plus_dSTR_ERR(L9, ((dSTR) ((STR) &probably1)));
  L12 = ERR_plus_dSTR_ERR(L10, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L13 = FSETCLASS_LAYOUT_aget_IN(self, start1);
  L14 = (SYSTP(((OB) L13)));
  L15 = ERR_plus_dSTR_ERR(L12, ((dSTR) (SYSSTRFORTP(L14))));
  ERR_plus_dSTR(L15, ((dSTR) ((STR) &name3)));
  L16 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L16, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L18 = L11;
     L19 = L21;
     L17 = L18;
    } else {
     L17++;
    }
    if (L17>L19) goto after_loop;
    i = L17;
    e = FSETCLASS_LAYOUT_aget_IN(self, i);
    h = FSETCLASS_LAYOUT_elt_has(self, e);
    L20 = OUT_create_OUT(((OUT) NULL));
    L22 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L22)->value_part = i;
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L24)->value_part = '\t';
    L25 = OUT_plus_dSTR_OUT(L23, L24);
    L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) INT_hex_str_STR(h)));
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = '\t';
    L28 = OUT_plus_dSTR_OUT(L26, L27);
    L29 = (ASIZE(self));
    L30 = (INTMINUS(L29,2));
    L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L32)->value_part = (h&L30);
    L33 = OUT_plus_dSTR_OUT(L28, L32);
    L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L34)->value_part = '\t';
    L35 = OUT_plus_dSTR_OUT(L33, L34);
    L36 = OUT_plus_dSTR_OUT(L35, ((dSTR) STR_pretty_STR(ATTR(e,str1))));
    L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L37)->value_part = '\n';
    OUT_plus_dSTR(L36, L37);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETCLASS_LAYOUT_should_(FSETCLASS_LAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETCLASS_LAYOUT_load_ra;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETEXTERNAL_LAYOUT_elt_2(FSETEXTERNAL_LAYOUT self, EXTERNAL_LAYOUT e1, EXTERNAL_LAYOUT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e1==e2);
 return ret_val;
}


BOOL FSETEXTERNAL_LAYOUT_is_e(FSETEXTERNAL_LAYOUT self, EXTERNAL_LAYOUT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e==((EXTERNAL_LAYOUT) NULL));
 return ret_val;
}


BOOL FSETEXTERNAL_LAYOUT_not_(FSETEXTERNAL_LAYOUT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 EXTERNAL_LAYOUT t = ((EXTERNAL_LAYOUT) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 EXTERNAL_LAYOUT e;
 INT h = ((INT) 0);
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT i1 = ((INT) 0);
 EXTERNAL_LAYOUT e1;
 INT h1 = ((INT) 0);
 INT L5;
 ERR1 L6;
 extern STR Foundaproblemexcessiveco;
 ERR1 L7;
 INT L8;
 ERR1 L9;
 extern STR probably1;
 ERR1 L10;
 extern STR duetoabadhashfunctionint;
 ERR1 L12;
 EXTERNAL_LAYOUT L13;
 INT L14;
 ERR1 L15;
 extern STR name3;
 OUT L16;
 extern STR Snowballingvalues;
 INT L17;
 INT L18;
 INT L19;
 
 OUT L20;
 dSTR L22;
 OUT L23;
 dSTR L24;
 OUT L25;
 OUT L26;
 dSTR L27;
 OUT L28;
 INT L29;
 INT L30;
 dSTR L32;
 OUT L33;
 dSTR L34;
 OUT L35;
 OUT L36;
 dSTR L37;
 L5 = (INTPLUS(start1,50));
 if ((finish>L5)) {
  L6 = ERR_create_ERR(((ERR1) NULL));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L8 = (SYSTP(((OB) self)));
  L9 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L8))));
  L10 = ERR_plus_dSTR_ERR(L9, ((dSTR) ((STR) &probably1)));
  L12 = ERR_plus_dSTR_ERR(L10, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L13 = FSETEXTERNAL_LAYOUT_aget(self, start1);
  L14 = (SYSTP(((OB) L13)));
  L15 = ERR_plus_dSTR_ERR(L12, ((dSTR) (SYSSTRFORTP(L14))));
  ERR_plus_dSTR(L15, ((dSTR) ((STR) &name3)));
  L16 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L16, ((dSTR) ((STR) &Snowballingvalues)));
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = start1;
     L21 = (INTMINUS(finish,1));
     L18 = L11;
     L19 = L21;
     L17 = L18;
    } else {
     L17++;
    }
    if (L17>L19) goto after_loop;
    i = L17;
    e = FSETEXTERNAL_LAYOUT_aget(self, i);
    h = FSETEXTERNAL_LAYOUT_elt_1(self, e);
    L20 = OUT_create_OUT(((OUT) NULL));
    L22 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L22)->value_part = i;
    L23 = OUT_plus_dSTR_OUT(L20, L22);
    L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L24)->value_part = '\t';
    L25 = OUT_plus_dSTR_OUT(L23, L24);
    L26 = OUT_plus_dSTR_OUT(L25, ((dSTR) INT_hex_str_STR(h)));
    L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L27)->value_part = '\t';
    L28 = OUT_plus_dSTR_OUT(L26, L27);
    L29 = (ASIZE(self));
    L30 = (INTMINUS(L29,2));
    L32 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
    ((INT_boxed) L32)->value_part = (h&L30);
    L33 = OUT_plus_dSTR_OUT(L28, L32);
    L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L34)->value_part = '\t';
    L35 = OUT_plus_dSTR_OUT(L33, L34);
    L36 = OUT_plus_dSTR_OUT(L35, ((dSTR) STR_pretty_STR(ATTR(e,str1))));
    L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L37)->value_part = '\n';
    OUT_plus_dSTR(L36, L37);
   }
  }
  after_loop: ;
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETEXTERNAL_LAYOUT_shou(FSETEXTERNAL_LAYOUT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETEXTERNAL_LAYOUT_load;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETIDENT_elt_eq_IDENT_I(FSETIDENT self, IDENT e1, IDENT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = IDENT_is_eq_IDENT_BOOL(e1, e2);
 return ret_val;
}


BOOL FSETIDENT_is_elt_nil_IDE(FSETIDENT self, IDENT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e.str==(STR)0);
 return ret_val;
}


BOOL FSETIDENT_not_too_many_I(FSETIDENT self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 IDENT t = IDENT_zero;
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR probably1;
 ERR1 L6;
 extern STR duetoabadhashfunctionint;
 ERR1 L7;
 IDENT L8;
 OB L9;
 INT L10;
 ERR1 L11;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &probably1)));
  L7 = ERR_plus_dSTR_ERR(L6, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L8 = FSETIDENT_aget_INT_IDENT(self, start1);
  L9 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
  ((IDENT_boxed) L9)->value_part = L8;
  L10 = (SYSTP(L9));
  L11 = ERR_plus_dSTR_ERR(L7, ((dSTR) (SYSSTRFORTP(L10))));
  ERR_plus_dSTR(L11, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL FSETIDENT_should_grow_BO(FSETIDENT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = FSETIDENT_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL FSETIDENT_test_IDENT_BOO(FSETIDENT self, IDENT e) {
 BOOL ret_val = ((BOOL) 0);
 INT h = ((INT) 0);
 IDENT te = IDENT_zero;
 IDENT te1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FSETIDENT) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L1 = FSETIDENT_elt_hash_IDENT(self, e);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  te = FSETIDENT_aget_INT_IDENT(self, h);
  if (FSETIDENT_is_elt_nil_IDE(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETIDENT_elt_eq_IDENT_I(self, te, e)) {
    ret_val = TRUE;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   te1 = FSETIDENT_aget_INT_IDENT(self, h);
   if (FSETIDENT_is_elt_nil_IDE(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETIDENT_elt_eq_IDENT_I(self, te1, e)) {
     ret_val = TRUE;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = FALSE;
 return ret_val;
}


BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_ae(FSETBOUND_TYPE_LAYOUT_ae_frame frame) {
 BOUND_TYPE_LAYOUT dummy = ((BOUND_TYPE_LAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETBOUND_TYPE_LAYOUT_ag(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_ag(FSETBOUND_TYPE_LAYOUT self, INT ind) {
 BOUND_TYPE_LAYOUT ret_val;
 return ARR(self,ind);
}


BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_el1(FSETBOUND_TYPE_LAYOUT_el1_frame frame) {
 BOUND_TYPE_LAYOUT dummy = ((BOUND_TYPE_LAYOUT) NULL);
 BOOL L1;
 BOUND_TYPE_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETBOUND_TYPE_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETBOUND_TYPE_LAYOUT_ae_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETBOUND_TYPE_LAYOUT_ae(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETBOUND_TYPE_LAYOUT_is(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_aeltb(FSETBUILTIN_LAYOUT_aeltb_frame frame) {
 BUILTIN_LAYOUT dummy = ((BUILTIN_LAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETBUILTIN_LAYOUT_aget_(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_aget_(FSETBUILTIN_LAYOUT self, INT ind) {
 BUILTIN_LAYOUT ret_val;
 return ARR(self,ind);
}


BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_eltb_(FSETBUILTIN_LAYOUT_eltb__frame frame) {
 BUILTIN_LAYOUT dummy = ((BUILTIN_LAYOUT) NULL);
 BOOL L1;
 BUILTIN_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETBUILTIN_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETBUILTIN_LAYOUT_aeltb_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETBUILTIN_LAYOUT_aeltb(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETBUILTIN_LAYOUT_is_el(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


CLASS_LAYOUT FSETCLASS_LAYOUT_aeltb_C(FSETCLASS_LAYOUT_aeltb_C_frame frame) {
 CLASS_LAYOUT dummy = ((CLASS_LAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETCLASS_LAYOUT_aget_IN(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


CLASS_LAYOUT FSETCLASS_LAYOUT_aget_IN(FSETCLASS_LAYOUT self, INT ind) {
 CLASS_LAYOUT ret_val;
 return ARR(self,ind);
}


CLASS_LAYOUT FSETCLASS_LAYOUT_eltb_CL(FSETCLASS_LAYOUT_eltb_CL_frame frame) {
 CLASS_LAYOUT dummy = ((CLASS_LAYOUT) NULL);
 BOOL L1;
 CLASS_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETCLASS_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETCLASS_LAYOUT_aeltb_C_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETCLASS_LAYOUT_aeltb_C(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETCLASS_LAYOUT_is_elt_(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_aelt(FSETEXTERNAL_LAYOUT_aelt_frame frame) {
 EXTERNAL_LAYOUT dummy = ((EXTERNAL_LAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETEXTERNAL_LAYOUT_aget(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_aget(FSETEXTERNAL_LAYOUT self, INT ind) {
 EXTERNAL_LAYOUT ret_val;
 return ARR(self,ind);
}


EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_eltb(FSETEXTERNAL_LAYOUT_eltb_frame frame) {
 EXTERNAL_LAYOUT dummy = ((EXTERNAL_LAYOUT) NULL);
 BOOL L1;
 EXTERNAL_LAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETEXTERNAL_LAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETEXTERNAL_LAYOUT_aelt_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETEXTERNAL_LAYOUT_aelt(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETEXTERNAL_LAYOUT_is_e(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


FLISTdLAYOUT FRAME_LAYOUT_dependencie(FRAME_LAYOUT self) {
 FLISTdLAYOUT ret_val;
 FLISTdLAYOUT res;
 AM_ROUT_DEF L11;
 FLISTAM_LOCAL_EXPR L21;
 AM_LOCAL_EXPR L3;
 AM_LOCAL_EXPR L4;
 res = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct AM_ROUT_DEF_eltb_AM_LOCA_frame_struct other1_0;
  AM_ROUT_DEF_eltb_AM_LOCA_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,f1);
    noname1->self = L11;
   }
   L3 = AM_ROUT_DEF_eltb_AM_LOCA(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), AM_LOCAL_EXPR_tp_dTP(L3)));
  }
 }
 after_loop: ;
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other2_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname2 = &other2_0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = ATTR(ATTR(self,f1),locals1);
    noname2->self = L21;
   }
   L4 = FLISTAM_LOCAL_EXPR_eltb_(noname2);
   if (noname2->state == -1) {
    goto after_loop1;
   }
   res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), AM_LOCAL_EXPR_tp_dTP(L4)));
  }
 }
 after_loop1: ;
 ret_val = res;
 return ret_val;
}


FMAPdTPIFC FMAPdTPIFC_allocate_INT_(FMAPdTPIFC self, INT n) {
 FMAPdTPIFC ret_val;
 FMAPdTPIFC r;
 FMAPdTPIFC L11;
 FMAPdTPIFC L2;
 INT L3;
 BOOL L4;
 dTP L5;
 L3 = n;
 L2 = ((FMAPdTPIFC) rt_arr_alloc(sizeof(struct FMAPdTPIFC_struct), FMAPdTPIFC_tag, sizeof(TUPdTPIFC) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPdTPIFC_key_nil_dTP(self)==((dTP) NULL));
 if ((!(L4))) {
  {
   struct FMAPdTPIFC_asetb_TUPdTPI_frame_struct other1_0;
   FMAPdTPIFC_asetb_TUPdTPI_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPdTPIFC_key_nil_dTP(self);
    noname1->arg1 = TUPdTPIFC_create_dTP_IFC(TUPdTPIFC_zero, L5, ((IFC) NULL));
    FMAPdTPIFC_asetb_TUPdTPI(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPdTPIFC FMAPdTPIFC_double_size_F(FMAPdTPIFC self) {
 FMAPdTPIFC ret_val;
 INT ns = ((INT) 0);
 FMAPdTPIFC r;
 FMAPdTPIFC L11;
 INT L2;
 INT L3;
 INT L4;
 TUPdTPIFC L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPdTPIFC_allocate_INT_(self, ns);
 {
  struct FMAPdTPIFC_pairsb_TUPdTP_frame_struct other1_0;
  FMAPdTPIFC_pairsb_TUPdTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPdTPIFC_pairsb_TUPdTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPdTPIFC_insert_pair_T(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPdTPIFC FMAPdTPIFC_insert_dTP_IF(FMAPdTPIFC self, dTP k, IFC t) {
 FMAPdTPIFC ret_val;
 FMAPdTPIFC r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPdTPIFC) NULL))) {
  r = FMAPdTPIFC_allocate_INT_(self, 5);
 }
 else {
  if (FMAPdTPIFC_should_grow_B(self)) {
   r = FMAPdTPIFC_double_size_F(self);
  }
 }
 L1 = FMAPdTPIFC_key_hash_dTP_(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPdTPIFC_aget_INT_TUPd(r, h).t1;
  if (FMAPdTPIFC_is_key_nil_dT(self, tk)) {
   goto after_loop;
  }
  if (FMAPdTPIFC_key_eq_dTP_dT(self, tk, k)) {
   FMAPdTPIFC_aset_INT_TUPd(r, h, TUPdTPIFC_create_dTP_IFC(TUPdTPIFC_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPIFC_aget_INT_TUPd(r, h).t1;
   if (FMAPdTPIFC_is_key_nil_dT(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPdTPIFC_key_eq_dTP_dT(self, tk1, k)) {
    FMAPdTPIFC_aset_INT_TUPd(r, h, TUPdTPIFC_create_dTP_IFC(TUPdTPIFC_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPdTPIFC_aset_INT_TUPd(r, h, TUPdTPIFC_create_dTP_IFC(TUPdTPIFC_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPdTPIFC FMAPdTPIFC_insert_pair_T(FMAPdTPIFC self, TUPdTPIFC p) {
 FMAPdTPIFC ret_val;
 ret_val = FMAPdTPIFC_insert_dTP_IF(self, p.t1, p.t2);
 return ret_val;
}


FMAPdTPIMPL FMAPdTPIMPL_allocate_INT(FMAPdTPIMPL self, INT n) {
 FMAPdTPIMPL ret_val;
 FMAPdTPIMPL r;
 FMAPdTPIMPL L11;
 FMAPdTPIMPL L2;
 INT L3;
 BOOL L4;
 dTP L5;
 L3 = n;
 L2 = ((FMAPdTPIMPL) rt_arr_alloc(sizeof(struct FMAPdTPIMPL_struct), FMAPdTPIMPL_tag, sizeof(TUPdTPIMPL) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPdTPIMPL_key_nil_dTP(self)==((dTP) NULL));
 if ((!(L4))) {
  {
   struct FMAPdTPIMPL_asetb_TUPdTP_frame_struct other1_0;
   FMAPdTPIMPL_asetb_TUPdTP_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPdTPIMPL_key_nil_dTP(self);
    noname1->arg1 = TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL_zero, L5, ((IMPL) NULL));
    FMAPdTPIMPL_asetb_TUPdTP(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPdTPIMPL FMAPdTPIMPL_double_size_(FMAPdTPIMPL self) {
 FMAPdTPIMPL ret_val;
 INT ns = ((INT) 0);
 FMAPdTPIMPL r;
 FMAPdTPIMPL L11;
 INT L2;
 INT L3;
 INT L4;
 TUPdTPIMPL L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPdTPIMPL_allocate_INT(self, ns);
 {
  struct FMAPdTPIMPL_pairsb_TUPdT_frame_struct other1_0;
  FMAPdTPIMPL_pairsb_TUPdT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPdTPIMPL_pairsb_TUPdT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPdTPIMPL_insert_pair_(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPdTPIMPL FMAPdTPIMPL_insert_dTP_I(FMAPdTPIMPL self, dTP k, IMPL t) {
 FMAPdTPIMPL ret_val;
 FMAPdTPIMPL r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPdTPIMPL) NULL))) {
  r = FMAPdTPIMPL_allocate_INT(self, 5);
 }
 else {
  if (FMAPdTPIMPL_should_grow_(self)) {
   r = FMAPdTPIMPL_double_size_(self);
  }
 }
 L1 = FMAPdTPIMPL_key_hash_dTP(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPdTPIMPL_aget_INT_TUP(r, h).t1;
  if (FMAPdTPIMPL_is_key_nil_d(self, tk)) {
   goto after_loop;
  }
  if (FMAPdTPIMPL_key_eq_dTP_d(self, tk, k)) {
   FMAPdTPIMPL_aset_INT_TUP(r, h, TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPIMPL_aget_INT_TUP(r, h).t1;
   if (FMAPdTPIMPL_is_key_nil_d(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPdTPIMPL_key_eq_dTP_d(self, tk1, k)) {
    FMAPdTPIMPL_aset_INT_TUP(r, h, TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPdTPIMPL_aset_INT_TUP(r, h, TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPdTPIMPL FMAPdTPIMPL_insert_pair_(FMAPdTPIMPL self, TUPdTPIMPL p) {
 FMAPdTPIMPL ret_val;
 ret_val = FMAPdTPIMPL_insert_dTP_I(self, p.t1, p.t2);
 return ret_val;
}


FMAPdTPINT FMAPdTPINT_allocate_INT_(FMAPdTPINT self, INT n) {
 FMAPdTPINT ret_val;
 FMAPdTPINT r;
 FMAPdTPINT L11;
 FMAPdTPINT L2;
 INT L3;
 BOOL L4;
 dTP L5;
 L3 = n;
 L2 = ((FMAPdTPINT) rt_arr_alloc(sizeof(struct FMAPdTPINT_struct), FMAPdTPINT_tag, sizeof(TUPdTPINT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPdTPINT_key_nil_dTP(self)==((dTP) NULL));
 if ((!(L4))) {
  {
   struct FMAPdTPINT_asetb_TUPdTPI_frame_struct other1_0;
   FMAPdTPINT_asetb_TUPdTPI_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPdTPINT_key_nil_dTP(self);
    noname1->arg1 = TUPdTPINT_create_dTP_INT(TUPdTPINT_zero, L5, ((INT) 0));
    FMAPdTPINT_asetb_TUPdTPI(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPdTPINT FMAPdTPINT_double_size_F(FMAPdTPINT self) {
 FMAPdTPINT ret_val;
 INT ns = ((INT) 0);
 FMAPdTPINT r;
 FMAPdTPINT L11;
 INT L2;
 INT L3;
 INT L4;
 TUPdTPINT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPdTPINT_allocate_INT_(self, ns);
 {
  struct FMAPdTPINT_pairsb_TUPdTP_frame_struct other1_0;
  FMAPdTPINT_pairsb_TUPdTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPdTPINT_pairsb_TUPdTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPdTPINT_insert_pair_T(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPdTPINT FMAPdTPINT_insert_dTP_IN(FMAPdTPINT self, dTP k, INT t) {
 FMAPdTPINT ret_val;
 FMAPdTPINT r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPdTPINT) NULL))) {
  r = FMAPdTPINT_allocate_INT_(self, 5);
 }
 else {
  if (FMAPdTPINT_should_grow_B(self)) {
   r = FMAPdTPINT_double_size_F(self);
  }
 }
 L1 = FMAPdTPINT_key_hash_dTP_(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPdTPINT_aget_INT_TUPd(r, h).t1;
  if (FMAPdTPINT_is_key_nil_dT(self, tk)) {
   goto after_loop;
  }
  if (FMAPdTPINT_key_eq_dTP_dT(self, tk, k)) {
   FMAPdTPINT_aset_INT_TUPd(r, h, TUPdTPINT_create_dTP_INT(TUPdTPINT_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPINT_aget_INT_TUPd(r, h).t1;
   if (FMAPdTPINT_is_key_nil_dT(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPdTPINT_key_eq_dTP_dT(self, tk1, k)) {
    FMAPdTPINT_aset_INT_TUPd(r, h, TUPdTPINT_create_dTP_INT(TUPdTPINT_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPdTPINT_aset_INT_TUPd(r, h, TUPdTPINT_create_dTP_INT(TUPdTPINT_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPdTPINT FMAPdTPINT_insert_pair_T(FMAPdTPINT self, TUPdTPINT p) {
 FMAPdTPINT ret_val;
 ret_val = FMAPdTPINT_insert_dTP_IN(self, p.t1, p.t2);
 return ret_val;
}


FMAPdTPdLAYOUT FMAPdTPdLAYOUT_allocate_(FMAPdTPdLAYOUT self, INT n) {
 FMAPdTPdLAYOUT ret_val;
 FMAPdTPdLAYOUT r;
 FMAPdTPdLAYOUT L11;
 FMAPdTPdLAYOUT L2;
 INT L3;
 BOOL L4;
 dTP L5;
 L3 = n;
 L2 = ((FMAPdTPdLAYOUT) rt_arr_alloc(sizeof(struct FMAPdTPdLAYOUT_struct), FMAPdTPdLAYOUT_tag, sizeof(TUPdTPdLAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FMAPdTPdLAYOUT_key_nil_d(self)==((dTP) NULL));
 if ((!(L4))) {
  {
   struct FMAPdTPdLAYOUT_asetb_TUP_frame_struct other1_0;
   FMAPdTPdLAYOUT_asetb_TUP_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = FMAPdTPdLAYOUT_key_nil_d(self);
    noname1->arg1 = TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT_zero, L5, ((dLAYOUT) NULL));
    FMAPdTPdLAYOUT_asetb_TUP(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FMAPdTPdLAYOUT FMAPdTPdLAYOUT_double_si(FMAPdTPdLAYOUT self) {
 FMAPdTPdLAYOUT ret_val;
 INT ns = ((INT) 0);
 FMAPdTPdLAYOUT r;
 FMAPdTPdLAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 TUPdTPdLAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = FMAPdTPdLAYOUT_allocate_(self, ns);
 {
  struct FMAPdTPdLAYOUT_pairsb_TU_frame_struct other1_0;
  FMAPdTPdLAYOUT_pairsb_TU_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FMAPdTPdLAYOUT_pairsb_TU(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FMAPdTPdLAYOUT_insert_pa(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT self, dTP k, dLAYOUT t) {
 FMAPdTPdLAYOUT ret_val;
 FMAPdTPdLAYOUT r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((FMAPdTPdLAYOUT) NULL))) {
  r = FMAPdTPdLAYOUT_allocate_(self, 5);
 }
 else {
  if (FMAPdTPdLAYOUT_should_gr(self)) {
   r = FMAPdTPdLAYOUT_double_si(self);
  }
 }
 L1 = FMAPdTPdLAYOUT_key_hash_(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = FMAPdTPdLAYOUT_aget_INT_(r, h).t1;
  if (FMAPdTPdLAYOUT_is_key_ni(self, tk)) {
   goto after_loop;
  }
  if (FMAPdTPdLAYOUT_key_eq_dT(self, tk, k)) {
   FMAPdTPdLAYOUT_aset_INT_(r, h, TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPdLAYOUT_aget_INT_(r, h).t1;
   if (FMAPdTPdLAYOUT_is_key_ni(self, tk1)) {
    goto after_loop1;
   }
   if (FMAPdTPdLAYOUT_key_eq_dT(self, tk1, k)) {
    FMAPdTPdLAYOUT_aset_INT_(r, h, TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FMAPdTPdLAYOUT_aset_INT_(r, h, TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_pa(FMAPdTPdLAYOUT self, TUPdTPdLAYOUT p) {
 FMAPdTPdLAYOUT ret_val;
 ret_val = FMAPdTPdLAYOUT_insert_dT(self, p.t1, p.t2);
 return ret_val;
}


FRAME_LAYOUT FRAME_LAYOUT_create_AM_R(FRAME_LAYOUT self, AM_ROUT_DEF f, PROG p) {
 FRAME_LAYOUT ret_val;
 FRAME_LAYOUT res;
 FRAME_LAYOUT L1;
 extern STR frame2;
 res = FMAPAM_ROUT_DEFFRAME_LAY6(FRAME_LAYOUT_layouts, f);
 if ((res==((FRAME_LAYOUT) NULL))) {
  L1 = ((FRAME_LAYOUT) rt_alloc(sizeof(struct FRAME_LAYOUT_struct), FRAME_LAYOUT_tag));
  res = L1;
  SATTR(res,f1,f);
  SATTR(res,prog1,p);
  SATTR(res,str1,STR_plus_dSTR_STR(ATTR(ATTR(ATTR(res,f1),sig11),str), ((dSTR) ((STR) &frame2))));
  FRAME_LAYOUT_layouts_FMA(self, FMAPAM_ROUT_DEFFRAME_LAY16(FRAME_LAYOUT_layouts, f, res));
 }
 ret_val = res;
 return ret_val;
}


FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_allo(FSETABSTRACT_LAYOUT self, INT n) {
 FSETABSTRACT_LAYOUT ret_val;
 FSETABSTRACT_LAYOUT r;
 FSETABSTRACT_LAYOUT L11;
 FSETABSTRACT_LAYOUT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETABSTRACT_LAYOUT) rt_arr_alloc(sizeof(struct FSETABSTRACT_LAYOUT_struct), FSETABSTRACT_LAYOUT_tag, sizeof(ABSTRACT_LAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETABSTRACT_LAYOUT_elt_(self)==((ABSTRACT_LAYOUT) NULL));
 if ((!(L4))) {
  {
   struct FSETABSTRACT_LAYOUT_aset1_frame_struct other1_0;
   FSETABSTRACT_LAYOUT_aset1_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETABSTRACT_LAYOUT_elt_(self);
    FSETABSTRACT_LAYOUT_aset1(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_doub(FSETABSTRACT_LAYOUT self) {
 FSETABSTRACT_LAYOUT ret_val;
 FSETABSTRACT_LAYOUT r;
 FSETABSTRACT_LAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 ABSTRACT_LAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETABSTRACT_LAYOUT_allo(self, (INTPLUS(L4,1)));
 {
  struct FSETABSTRACT_LAYOUT_eltb_frame_struct other1_0;
  FSETABSTRACT_LAYOUT_eltb_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETABSTRACT_LAYOUT_eltb(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETABSTRACT_LAYOUT_inse(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_inse(FSETABSTRACT_LAYOUT self, ABSTRACT_LAYOUT e) {
 FSETABSTRACT_LAYOUT ret_val;
 FSETABSTRACT_LAYOUT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 ABSTRACT_LAYOUT te;
 ABSTRACT_LAYOUT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETABSTRACT_LAYOUT) NULL))) {
  r = FSETABSTRACT_LAYOUT_allo(self, 5);
 }
 else {
  if (FSETABSTRACT_LAYOUT_shou(self)) {
   r = FSETABSTRACT_LAYOUT_doub(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETABSTRACT_LAYOUT_elt_1(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETABSTRACT_LAYOUT_aget(r, h);
  if (FSETABSTRACT_LAYOUT_is_e(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETABSTRACT_LAYOUT_elt_2(self, te, e)) {
    FSETABSTRACT_LAYOUT_aset(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETABSTRACT_LAYOUT_aget(r, h);
   if (FSETABSTRACT_LAYOUT_is_e(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETABSTRACT_LAYOUT_elt_2(self, te1, e)) {
     FSETABSTRACT_LAYOUT_aset(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETABSTRACT_LAYOUT_aset(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_alloc(FSETAM_GLOBAL_EXPR self, INT n) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR r;
 FSETAM_GLOBAL_EXPR L11;
 FSETAM_GLOBAL_EXPR L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETAM_GLOBAL_EXPR) rt_arr_alloc(sizeof(struct FSETAM_GLOBAL_EXPR_struct), FSETAM_GLOBAL_EXPR_tag, sizeof(AM_GLOBAL_EXPR) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETAM_GLOBAL_EXPR_elt_n(self)==((AM_GLOBAL_EXPR) NULL));
 if ((!(L4))) {
  {
   struct FSETAM_GLOBAL_EXPR_asetb_frame_struct other1_0;
   FSETAM_GLOBAL_EXPR_asetb_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETAM_GLOBAL_EXPR_elt_n(self);
    FSETAM_GLOBAL_EXPR_asetb(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_copy_(FSETAM_GLOBAL_EXPR self) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR r = ((FSETAM_GLOBAL_EXPR) NULL);
 FSETAM_GLOBAL_EXPR L11;
 AM_GLOBAL_EXPR L2;
 {
  struct FSETAM_GLOBAL_EXPR_eltb__frame_struct other1_0;
  FSETAM_GLOBAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L2 = FSETAM_GLOBAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAM_GLOBAL_EXPR_inser(r, L2);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_doubl(FSETAM_GLOBAL_EXPR self) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR r;
 FSETAM_GLOBAL_EXPR L11;
 INT L2;
 INT L3;
 INT L4;
 AM_GLOBAL_EXPR L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETAM_GLOBAL_EXPR_alloc(self, (INTPLUS(L4,1)));
 {
  struct FSETAM_GLOBAL_EXPR_eltb__frame_struct other1_0;
  FSETAM_GLOBAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETAM_GLOBAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAM_GLOBAL_EXPR_inser(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_inser(FSETAM_GLOBAL_EXPR self, AM_GLOBAL_EXPR e) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 AM_GLOBAL_EXPR te;
 AM_GLOBAL_EXPR te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETAM_GLOBAL_EXPR) NULL))) {
  r = FSETAM_GLOBAL_EXPR_alloc(self, 5);
 }
 else {
  if (FSETAM_GLOBAL_EXPR_shoul(self)) {
   r = FSETAM_GLOBAL_EXPR_doubl(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETAM_GLOBAL_EXPR_elt_h(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETAM_GLOBAL_EXPR_aget_(r, h);
  if (FSETAM_GLOBAL_EXPR_is_el(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETAM_GLOBAL_EXPR_elt_e(self, te, e)) {
    FSETAM_GLOBAL_EXPR_aset_(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETAM_GLOBAL_EXPR_aget_(r, h);
   if (FSETAM_GLOBAL_EXPR_is_el(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETAM_GLOBAL_EXPR_elt_e(self, te1, e)) {
     FSETAM_GLOBAL_EXPR_aset_(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETAM_GLOBAL_EXPR_aset_(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_to_un(FSETAM_GLOBAL_EXPR self, FSETAM_GLOBAL_EXPR s) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR r;
 FSETAM_GLOBAL_EXPR L11;
 AM_GLOBAL_EXPR L2;
 r = self;
 {
  struct FSETAM_GLOBAL_EXPR_eltb__frame_struct other1_0;
  FSETAM_GLOBAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = s;
    noname1->self = L11;
   }
   L2 = FSETAM_GLOBAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAM_GLOBAL_EXPR_inser(r, L2);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_union(FSETAM_GLOBAL_EXPR self, FSETAM_GLOBAL_EXPR s) {
 FSETAM_GLOBAL_EXPR ret_val;
 FSETAM_GLOBAL_EXPR L1;
 L1 = FSETAM_GLOBAL_EXPR_copy_(self);
 ret_val = FSETAM_GLOBAL_EXPR_to_un(L1, s);
 return ret_val;
}


FSETAM_ROUT_DEF FSETAM_ROUT_DEF_allocate(FSETAM_ROUT_DEF self, INT n) {
 FSETAM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF r;
 FSETAM_ROUT_DEF L11;
 FSETAM_ROUT_DEF L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETAM_ROUT_DEF) rt_arr_alloc(sizeof(struct FSETAM_ROUT_DEF_struct), FSETAM_ROUT_DEF_tag, sizeof(AM_ROUT_DEF) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETAM_ROUT_DEF_elt_nil_(self)==((AM_ROUT_DEF) NULL));
 if ((!(L4))) {
  {
   struct FSETAM_ROUT_DEF_asetb_AM_frame_struct other1_0;
   FSETAM_ROUT_DEF_asetb_AM_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETAM_ROUT_DEF_elt_nil_(self);
    FSETAM_ROUT_DEF_asetb_AM(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETAM_ROUT_DEF FSETAM_ROUT_DEF_delete_A(FSETAM_ROUT_DEF self, AM_ROUT_DEF e) {
 FSETAM_ROUT_DEF ret_val;
 INT h = ((INT) 0);
 AM_ROUT_DEF te;
 INT i = ((INT) 0);
 AM_ROUT_DEF te1;
 INT hsh = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L11;
 BOOL L12;
 BOOL L13;
 if ((self==((FSETAM_ROUT_DEF) NULL))) {
  ret_val = ((FSETAM_ROUT_DEF) NULL);
  return ret_val;
 }
 L1 = FSETAM_ROUT_DEF_elt_hash(self, e);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  te = FSETAM_ROUT_DEF_aget_INT(self, h);
  if (FSETAM_ROUT_DEF_is_elt_n(self, te)) {
   ret_val = self;
   return ret_val;
  }
  else {
   if (FSETAM_ROUT_DEF_elt_eq_A(self, te, e)) {
    goto after_loop;
   }
  }
  L4 = (ASIZE(self));
  L5 = (INTMINUS(L4,2));
  if ((h==L5)) {
   h = 0;
  }
  else {
   h = (INTPLUS(h,1));
  }
 }
 after_loop: ;
 FSETAM_ROUT_DEF_aset_INT(self, h, FSETAM_ROUT_DEF_elt_nil_(self));
 L6 = ATTR(self,hsize);
 SATTR(self,hsize,(INTMINUS(L6,1)));
 i = h;
 while (1) {
  L7 = (ASIZE(self));
  L8 = (INTMINUS(L7,2));
  if ((i==L8)) {
   i = 0;
  }
  else {
   i = (INTPLUS(i,1));
  }
  te1 = FSETAM_ROUT_DEF_aget_INT(self, i);
  if (FSETAM_ROUT_DEF_is_elt_n(self, te1)) {
   goto after_loop1;
  }
  L9 = FSETAM_ROUT_DEF_elt_hash(self, te1);
  L10 = (ASIZE(self));
  L11 = (INTMINUS(L10,2));
  hsh = (L9&L11);
  if ((hsh<=i)) {
   if ((h<i)) {
    L12 = (h>=hsh);
   } else {
    L12 = FALSE;
   }
   if (L12) {
    FSETAM_ROUT_DEF_aset_INT(self, h, FSETAM_ROUT_DEF_aget_INT(self, i));
    h = i;
    FSETAM_ROUT_DEF_aset_INT(self, i, FSETAM_ROUT_DEF_elt_nil_(self));
   }
  }
  else {
   if ((h>=hsh)) {
    L13 = TRUE;
   } else {
    L13 = (h<i);
   }
   if (L13) {
    FSETAM_ROUT_DEF_aset_INT(self, h, FSETAM_ROUT_DEF_aget_INT(self, i));
    h = i;
    FSETAM_ROUT_DEF_aset_INT(self, i, FSETAM_ROUT_DEF_elt_nil_(self));
   }
  }
 }
 after_loop1: ;
 if (FSETAM_ROUT_DEF_should_s(self)) {
  ret_val = FSETAM_ROUT_DEF_halve_si(self);
  return ret_val;
 }
 else {
  ret_val = self;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


FSETAM_ROUT_DEF FSETAM_ROUT_DEF_double_s(FSETAM_ROUT_DEF self) {
 FSETAM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF r;
 FSETAM_ROUT_DEF L11;
 INT L2;
 INT L3;
 INT L4;
 AM_ROUT_DEF L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETAM_ROUT_DEF_allocate(self, (INTPLUS(L4,1)));
 {
  struct FSETAM_ROUT_DEF_eltb_AM__frame_struct other1_0;
  FSETAM_ROUT_DEF_eltb_AM__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETAM_ROUT_DEF_eltb_AM_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAM_ROUT_DEF_insert_A(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETAM_ROUT_DEF FSETAM_ROUT_DEF_halve_si(FSETAM_ROUT_DEF self) {
 FSETAM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF r;
 FSETAM_ROUT_DEF L11;
 INT L2;
 INT L3;
 INT L4;
 AM_ROUT_DEF L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTDIV(L3,2));
 r = FSETAM_ROUT_DEF_allocate(self, (INTPLUS(L4,1)));
 {
  struct FSETAM_ROUT_DEF_eltb_AM__frame_struct other1_0;
  FSETAM_ROUT_DEF_eltb_AM__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETAM_ROUT_DEF_eltb_AM_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAM_ROUT_DEF_insert_A(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETAM_ROUT_DEF FSETAM_ROUT_DEF_insert_A(FSETAM_ROUT_DEF self, AM_ROUT_DEF e) {
 FSETAM_ROUT_DEF ret_val;
 FSETAM_ROUT_DEF r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 AM_ROUT_DEF te;
 AM_ROUT_DEF te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETAM_ROUT_DEF) NULL))) {
  r = FSETAM_ROUT_DEF_allocate(self, 5);
 }
 else {
  if (FSETAM_ROUT_DEF_should_g(self)) {
   r = FSETAM_ROUT_DEF_double_s(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETAM_ROUT_DEF_elt_hash(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETAM_ROUT_DEF_aget_INT(r, h);
  if (FSETAM_ROUT_DEF_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETAM_ROUT_DEF_elt_eq_A(self, te, e)) {
    FSETAM_ROUT_DEF_aset_INT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETAM_ROUT_DEF_aget_INT(r, h);
   if (FSETAM_ROUT_DEF_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETAM_ROUT_DEF_elt_eq_A(self, te1, e)) {
     FSETAM_ROUT_DEF_aset_INT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETAM_ROUT_DEF_aset_INT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETAS_FEAT_MOD FSETAS_FEAT_MOD_allocate(FSETAS_FEAT_MOD self, INT n) {
 FSETAS_FEAT_MOD ret_val;
 FSETAS_FEAT_MOD r;
 FSETAS_FEAT_MOD L11;
 FSETAS_FEAT_MOD L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETAS_FEAT_MOD) rt_arr_alloc(sizeof(struct FSETAS_FEAT_MOD_struct), FSETAS_FEAT_MOD_tag, sizeof(AS_FEAT_MOD) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETAS_FEAT_MOD_elt_nil_(self)==((AS_FEAT_MOD) NULL));
 if ((!(L4))) {
  {
   struct FSETAS_FEAT_MOD_asetb_AS_frame_struct other1_0;
   FSETAS_FEAT_MOD_asetb_AS_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETAS_FEAT_MOD_elt_nil_(self);
    FSETAS_FEAT_MOD_asetb_AS(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETAS_FEAT_MOD FSETAS_FEAT_MOD_double_s(FSETAS_FEAT_MOD self) {
 FSETAS_FEAT_MOD ret_val;
 FSETAS_FEAT_MOD r;
 FSETAS_FEAT_MOD L11;
 INT L2;
 INT L3;
 INT L4;
 AS_FEAT_MOD L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETAS_FEAT_MOD_allocate(self, (INTPLUS(L4,1)));
 {
  struct FSETAS_FEAT_MOD_eltb_AS__frame_struct other1_0;
  FSETAS_FEAT_MOD_eltb_AS__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETAS_FEAT_MOD_eltb_AS_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETAS_FEAT_MOD_insert_A(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETAS_FEAT_MOD FSETAS_FEAT_MOD_insert_A(FSETAS_FEAT_MOD self, AS_FEAT_MOD e) {
 FSETAS_FEAT_MOD ret_val;
 FSETAS_FEAT_MOD r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 AS_FEAT_MOD te;
 AS_FEAT_MOD te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETAS_FEAT_MOD) NULL))) {
  r = FSETAS_FEAT_MOD_allocate(self, 5);
 }
 else {
  if (FSETAS_FEAT_MOD_should_g(self)) {
   r = FSETAS_FEAT_MOD_double_s(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETAS_FEAT_MOD_elt_hash(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETAS_FEAT_MOD_aget_INT(r, h);
  if (FSETAS_FEAT_MOD_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETAS_FEAT_MOD_elt_eq_A(self, te, e)) {
    FSETAS_FEAT_MOD_aset_INT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETAS_FEAT_MOD_aget_INT(r, h);
   if (FSETAS_FEAT_MOD_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETAS_FEAT_MOD_elt_eq_A(self, te1, e)) {
     FSETAS_FEAT_MOD_aset_INT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETAS_FEAT_MOD_aset_INT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_al(FSETBOUND_TYPE_LAYOUT self, INT n) {
 FSETBOUND_TYPE_LAYOUT ret_val;
 FSETBOUND_TYPE_LAYOUT r;
 FSETBOUND_TYPE_LAYOUT L11;
 FSETBOUND_TYPE_LAYOUT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETBOUND_TYPE_LAYOUT) rt_arr_alloc(sizeof(struct FSETBOUND_TYPE_LAYOUT_struct), FSETBOUND_TYPE_LAYOUT_tag, sizeof(BOUND_TYPE_LAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETBOUND_TYPE_LAYOUT_el(self)==((BOUND_TYPE_LAYOUT) NULL));
 if ((!(L4))) {
  {
   struct FSETBOUND_TYPE_LAYOUT_as2_frame_struct other1_0;
   FSETBOUND_TYPE_LAYOUT_as2_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETBOUND_TYPE_LAYOUT_el(self);
    FSETBOUND_TYPE_LAYOUT_as2(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_do(FSETBOUND_TYPE_LAYOUT self) {
 FSETBOUND_TYPE_LAYOUT ret_val;
 FSETBOUND_TYPE_LAYOUT r;
 FSETBOUND_TYPE_LAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 BOUND_TYPE_LAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETBOUND_TYPE_LAYOUT_al(self, (INTPLUS(L4,1)));
 {
  struct FSETBOUND_TYPE_LAYOUT_el1_frame_struct other1_0;
  FSETBOUND_TYPE_LAYOUT_el1_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETBOUND_TYPE_LAYOUT_el1(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETBOUND_TYPE_LAYOUT_in(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETBOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_in(FSETBOUND_TYPE_LAYOUT self, BOUND_TYPE_LAYOUT e) {
 FSETBOUND_TYPE_LAYOUT ret_val;
 FSETBOUND_TYPE_LAYOUT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 BOUND_TYPE_LAYOUT te;
 BOUND_TYPE_LAYOUT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETBOUND_TYPE_LAYOUT) NULL))) {
  r = FSETBOUND_TYPE_LAYOUT_al(self, 5);
 }
 else {
  if (FSETBOUND_TYPE_LAYOUT_sh(self)) {
   r = FSETBOUND_TYPE_LAYOUT_do(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETBOUND_TYPE_LAYOUT_el2(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETBOUND_TYPE_LAYOUT_ag(r, h);
  if (FSETBOUND_TYPE_LAYOUT_is(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETBOUND_TYPE_LAYOUT_el3(self, te, e)) {
    FSETBOUND_TYPE_LAYOUT_as1(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETBOUND_TYPE_LAYOUT_ag(r, h);
   if (FSETBOUND_TYPE_LAYOUT_is(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETBOUND_TYPE_LAYOUT_el3(self, te1, e)) {
     FSETBOUND_TYPE_LAYOUT_as1(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETBOUND_TYPE_LAYOUT_as1(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_alloc(FSETBUILTIN_LAYOUT self, INT n) {
 FSETBUILTIN_LAYOUT ret_val;
 FSETBUILTIN_LAYOUT r;
 FSETBUILTIN_LAYOUT L11;
 FSETBUILTIN_LAYOUT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETBUILTIN_LAYOUT) rt_arr_alloc(sizeof(struct FSETBUILTIN_LAYOUT_struct), FSETBUILTIN_LAYOUT_tag, sizeof(BUILTIN_LAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETBUILTIN_LAYOUT_elt_n(self)==((BUILTIN_LAYOUT) NULL));
 if ((!(L4))) {
  {
   struct FSETBUILTIN_LAYOUT_asetb_frame_struct other1_0;
   FSETBUILTIN_LAYOUT_asetb_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETBUILTIN_LAYOUT_elt_n(self);
    FSETBUILTIN_LAYOUT_asetb(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_doubl(FSETBUILTIN_LAYOUT self) {
 FSETBUILTIN_LAYOUT ret_val;
 FSETBUILTIN_LAYOUT r;
 FSETBUILTIN_LAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 BUILTIN_LAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETBUILTIN_LAYOUT_alloc(self, (INTPLUS(L4,1)));
 {
  struct FSETBUILTIN_LAYOUT_eltb__frame_struct other1_0;
  FSETBUILTIN_LAYOUT_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETBUILTIN_LAYOUT_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETBUILTIN_LAYOUT_inser(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETBUILTIN_LAYOUT FSETBUILTIN_LAYOUT_inser(FSETBUILTIN_LAYOUT self, BUILTIN_LAYOUT e) {
 FSETBUILTIN_LAYOUT ret_val;
 FSETBUILTIN_LAYOUT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 BUILTIN_LAYOUT te;
 BUILTIN_LAYOUT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETBUILTIN_LAYOUT) NULL))) {
  r = FSETBUILTIN_LAYOUT_alloc(self, 5);
 }
 else {
  if (FSETBUILTIN_LAYOUT_shoul(self)) {
   r = FSETBUILTIN_LAYOUT_doubl(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETBUILTIN_LAYOUT_elt_h(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETBUILTIN_LAYOUT_aget_(r, h);
  if (FSETBUILTIN_LAYOUT_is_el(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETBUILTIN_LAYOUT_elt_e(self, te, e)) {
    FSETBUILTIN_LAYOUT_aset_(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETBUILTIN_LAYOUT_aget_(r, h);
   if (FSETBUILTIN_LAYOUT_is_el(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETBUILTIN_LAYOUT_elt_e(self, te1, e)) {
     FSETBUILTIN_LAYOUT_aset_(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETBUILTIN_LAYOUT_aset_(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETCLASS_LAYOUT FSETCLASS_LAYOUT_allocat(FSETCLASS_LAYOUT self, INT n) {
 FSETCLASS_LAYOUT ret_val;
 FSETCLASS_LAYOUT r;
 FSETCLASS_LAYOUT L11;
 FSETCLASS_LAYOUT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETCLASS_LAYOUT) rt_arr_alloc(sizeof(struct FSETCLASS_LAYOUT_struct), FSETCLASS_LAYOUT_tag, sizeof(CLASS_LAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETCLASS_LAYOUT_elt_nil(self)==((CLASS_LAYOUT) NULL));
 if ((!(L4))) {
  {
   struct FSETCLASS_LAYOUT_asetb_C_frame_struct other1_0;
   FSETCLASS_LAYOUT_asetb_C_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETCLASS_LAYOUT_elt_nil(self);
    FSETCLASS_LAYOUT_asetb_C(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETCLASS_LAYOUT FSETCLASS_LAYOUT_double_(FSETCLASS_LAYOUT self) {
 FSETCLASS_LAYOUT ret_val;
 FSETCLASS_LAYOUT r;
 FSETCLASS_LAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 CLASS_LAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETCLASS_LAYOUT_allocat(self, (INTPLUS(L4,1)));
 {
  struct FSETCLASS_LAYOUT_eltb_CL_frame_struct other1_0;
  FSETCLASS_LAYOUT_eltb_CL_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETCLASS_LAYOUT_eltb_CL(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETCLASS_LAYOUT_insert_(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETCLASS_LAYOUT FSETCLASS_LAYOUT_insert_(FSETCLASS_LAYOUT self, CLASS_LAYOUT e) {
 FSETCLASS_LAYOUT ret_val;
 FSETCLASS_LAYOUT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 CLASS_LAYOUT te;
 CLASS_LAYOUT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETCLASS_LAYOUT) NULL))) {
  r = FSETCLASS_LAYOUT_allocat(self, 5);
 }
 else {
  if (FSETCLASS_LAYOUT_should_(self)) {
   r = FSETCLASS_LAYOUT_double_(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETCLASS_LAYOUT_elt_has(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETCLASS_LAYOUT_aget_IN(r, h);
  if (FSETCLASS_LAYOUT_is_elt_(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETCLASS_LAYOUT_elt_eq_(self, te, e)) {
    FSETCLASS_LAYOUT_aset_IN(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETCLASS_LAYOUT_aget_IN(r, h);
   if (FSETCLASS_LAYOUT_is_elt_(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETCLASS_LAYOUT_elt_eq_(self, te1, e)) {
     FSETCLASS_LAYOUT_aset_IN(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETCLASS_LAYOUT_aset_IN(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_allo(FSETEXTERNAL_LAYOUT self, INT n) {
 FSETEXTERNAL_LAYOUT ret_val;
 FSETEXTERNAL_LAYOUT r;
 FSETEXTERNAL_LAYOUT L11;
 FSETEXTERNAL_LAYOUT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETEXTERNAL_LAYOUT) rt_arr_alloc(sizeof(struct FSETEXTERNAL_LAYOUT_struct), FSETEXTERNAL_LAYOUT_tag, sizeof(EXTERNAL_LAYOUT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETEXTERNAL_LAYOUT_elt_(self)==((EXTERNAL_LAYOUT) NULL));
 if ((!(L4))) {
  {
   struct FSETEXTERNAL_LAYOUT_aset1_frame_struct other1_0;
   FSETEXTERNAL_LAYOUT_aset1_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETEXTERNAL_LAYOUT_elt_(self);
    FSETEXTERNAL_LAYOUT_aset1(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_doub(FSETEXTERNAL_LAYOUT self) {
 FSETEXTERNAL_LAYOUT ret_val;
 FSETEXTERNAL_LAYOUT r;
 FSETEXTERNAL_LAYOUT L11;
 INT L2;
 INT L3;
 INT L4;
 EXTERNAL_LAYOUT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETEXTERNAL_LAYOUT_allo(self, (INTPLUS(L4,1)));
 {
  struct FSETEXTERNAL_LAYOUT_eltb_frame_struct other1_0;
  FSETEXTERNAL_LAYOUT_eltb_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETEXTERNAL_LAYOUT_eltb(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETEXTERNAL_LAYOUT_inse(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETEXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_inse(FSETEXTERNAL_LAYOUT self, EXTERNAL_LAYOUT e) {
 FSETEXTERNAL_LAYOUT ret_val;
 FSETEXTERNAL_LAYOUT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 EXTERNAL_LAYOUT te;
 EXTERNAL_LAYOUT te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETEXTERNAL_LAYOUT) NULL))) {
  r = FSETEXTERNAL_LAYOUT_allo(self, 5);
 }
 else {
  if (FSETEXTERNAL_LAYOUT_shou(self)) {
   r = FSETEXTERNAL_LAYOUT_doub(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETEXTERNAL_LAYOUT_elt_1(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETEXTERNAL_LAYOUT_aget(r, h);
  if (FSETEXTERNAL_LAYOUT_is_e(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETEXTERNAL_LAYOUT_elt_2(self, te, e)) {
    FSETEXTERNAL_LAYOUT_aset(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETEXTERNAL_LAYOUT_aget(r, h);
   if (FSETEXTERNAL_LAYOUT_is_e(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETEXTERNAL_LAYOUT_elt_2(self, te1, e)) {
     FSETEXTERNAL_LAYOUT_aset(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETEXTERNAL_LAYOUT_aset(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


FSETIDENT FSETIDENT_allocate_INT_F(FSETIDENT self, INT n) {
 FSETIDENT ret_val;
 FSETIDENT r;
 FSETIDENT L11;
 FSETIDENT L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((FSETIDENT) rt_arr_alloc(sizeof(struct FSETIDENT_struct), FSETIDENT_tag, sizeof(IDENT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (FSETIDENT_elt_nil_IDENT(self).str==(STR)0);
 if ((!(L4))) {
  {
   struct FSETIDENT_asetb_IDENT_frame_struct other1_0;
   FSETIDENT_asetb_IDENT_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = FSETIDENT_elt_nil_IDENT(self);
    FSETIDENT_asetb_IDENT(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


FSETIDENT FSETIDENT_double_size_FS(FSETIDENT self) {
 FSETIDENT ret_val;
 FSETIDENT r;
 FSETIDENT L11;
 INT L2;
 INT L3;
 INT L4;
 IDENT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = FSETIDENT_allocate_INT_F(self, (INTPLUS(L4,1)));
 {
  struct FSETIDENT_eltb_IDENT_frame_struct other1_0;
  FSETIDENT_eltb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = FSETIDENT_eltb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = FSETIDENT_insert_IDENT_F(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


FSETIDENT FSETIDENT_insert_IDENT_F(FSETIDENT self, IDENT e) {
 FSETIDENT ret_val;
 FSETIDENT r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 IDENT te = IDENT_zero;
 IDENT te1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if ((r==((FSETIDENT) NULL))) {
  r = FSETIDENT_allocate_INT_F(self, 5);
 }
 else {
  if (FSETIDENT_should_grow_BO(self)) {
   r = FSETIDENT_double_size_FS(self);
  }
 }
 asz = (ASIZE(r));
 L1 = FSETIDENT_elt_hash_IDENT(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = FSETIDENT_aget_INT_IDENT(r, h);
  if (FSETIDENT_is_elt_nil_IDE(self, te)) {
   goto after_loop;
  }
  else {
   if (FSETIDENT_elt_eq_IDENT_I(self, te, e)) {
    FSETIDENT_aset_INT_IDENT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = FSETIDENT_aget_INT_IDENT(r, h);
   if (FSETIDENT_is_elt_nil_IDE(self, te1)) {
    goto after_loop1;
   }
   else {
    if (FSETIDENT_elt_eq_IDENT_I(self, te1, e)) {
     FSETIDENT_aset_INT_IDENT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 FSETIDENT_aset_INT_IDENT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


IDENT FSETIDENT_aeltb_IDENT(FSETIDENT_aeltb_IDENT_frame frame) {
 IDENT dummy = IDENT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FSETIDENT_aget_INT_IDENT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


IDENT FSETIDENT_aget_INT_IDENT(FSETIDENT self, INT ind) {
 IDENT ret_val = IDENT_zero;
 return ARR(self,ind);
}


IDENT FSETIDENT_elt_nil_IDENT(FSETIDENT self) {
 IDENT ret_val = IDENT_zero;
 IDENT t = IDENT_zero;
 ret_val = IDENT_zero;
 return ret_val;
}


IDENT FSETIDENT_eltb_IDENT(FSETIDENT_eltb_IDENT_frame frame) {
 IDENT dummy = IDENT_zero;
 BOOL L1;
 IDENT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FSETIDENT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FSETIDENT_aeltb_IDENT_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FSETIDENT_aeltb_IDENT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FSETIDENT_is_elt_nil_IDE(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IFC FMAPdTPIFC_get_dTP_IFC(FMAPdTPIFC self, dTP k) {
 IFC ret_val;
 INT h = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPdTPIFC) NULL))) {
  ret_val = ((IFC) NULL);
  return ret_val;
 }
 L1 = FMAPdTPIFC_key_hash_dTP_(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPdTPIFC_aget_INT_TUPd(self, h).t1;
  if (FMAPdTPIFC_is_key_nil_dT(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPdTPIFC_key_eq_dTP_dT(self, tk, k)) {
    ret_val = FMAPdTPIFC_aget_INT_TUPd(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPIFC_aget_INT_TUPd(self, h).t1;
   if (FMAPdTPIFC_is_key_nil_dT(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPdTPIFC_key_eq_dTP_dT(self, tk1, k)) {
     ret_val = FMAPdTPIFC_aget_INT_TUPd(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((IFC) NULL);
 return ret_val;
}


IMPL FMAPdTPIMPL_get_dTP_IMPL(FMAPdTPIMPL self, dTP k) {
 IMPL ret_val;
 INT h = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPdTPIMPL) NULL))) {
  ret_val = ((IMPL) NULL);
  return ret_val;
 }
 L1 = FMAPdTPIMPL_key_hash_dTP(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPdTPIMPL_aget_INT_TUP(self, h).t1;
  if (FMAPdTPIMPL_is_key_nil_d(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPdTPIMPL_key_eq_dTP_d(self, tk, k)) {
    ret_val = FMAPdTPIMPL_aget_INT_TUP(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPIMPL_aget_INT_TUP(self, h).t1;
   if (FMAPdTPIMPL_is_key_nil_d(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPdTPIMPL_key_eq_dTP_d(self, tk1, k)) {
     ret_val = FMAPdTPIMPL_aget_INT_TUP(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((IMPL) NULL);
 return ret_val;
}


INT FMAPdTPIFC_asize_INT(FMAPdTPIFC self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPdTPIMPL_asize_INT(FMAPdTPIMPL self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPdTPINT_asize_INT(FMAPdTPINT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FMAPdTPINT_get_dTP_INT(FMAPdTPINT self, dTP k) {
 INT ret_val = ((INT) 0);
 INT h = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPdTPINT) NULL))) {
  ret_val = ((INT) 0);
  return ret_val;
 }
 L1 = FMAPdTPINT_key_hash_dTP_(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPdTPINT_aget_INT_TUPd(self, h).t1;
  if (FMAPdTPINT_is_key_nil_dT(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPdTPINT_key_eq_dTP_dT(self, tk, k)) {
    ret_val = FMAPdTPINT_aget_INT_TUPd(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPINT_aget_INT_TUPd(self, h).t1;
   if (FMAPdTPINT_is_key_nil_dT(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPdTPINT_key_eq_dTP_dT(self, tk1, k)) {
     ret_val = FMAPdTPINT_aget_INT_TUPd(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((INT) 0);
 return ret_val;
}


INT FMAPdTPINT_key_hash_dTP_(FMAPdTPINT self, dTP k) {
 INT ret_val = ((INT) 0);
 if (k==NULL) {
  ret_val = INT_hash_INT((SYSID(((OB) k))));
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = INT_hash_INT((SYSID(((OB) k))));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FMAPdTPINT_size_INT(FMAPdTPINT self) {
 INT ret_val = ((INT) 0);
 if ((self==((FMAPdTPINT) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,hsize);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FMAPdTPINT_targetsb_INT(FMAPdTPINT_targetsb_INT_frame frame) {
 INT dummy = ((INT) 0);
 BOOL L1;
 TUPdTPINT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPINT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPINT_aeltb_TUPdTPI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPINT_aeltb_TUPdTPI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->e = L2;
    L4 = FMAPdTPINT_is_key_nil_dT(frame->self, frame->e.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->e.t2;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


INT FMAPdTPdLAYOUT_asize_INT(FMAPdTPdLAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETABSTRACT_LAYOUT_asiz(FSETABSTRACT_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETABSTRACT_LAYOUT_elt_1(FSETABSTRACT_LAYOUT self, ABSTRACT_LAYOUT e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETAM_GLOBAL_EXPR_asize(FSETAM_GLOBAL_EXPR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETAM_GLOBAL_EXPR_elt_h(FSETAM_GLOBAL_EXPR self, AM_GLOBAL_EXPR e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETAM_GLOBAL_EXPR_size_(FSETAM_GLOBAL_EXPR self) {
 INT ret_val = ((INT) 0);
 if ((self==((FSETAM_GLOBAL_EXPR) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,hsize);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FSETAM_ROUT_DEF_asize_IN(FSETAM_ROUT_DEF self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETAM_ROUT_DEF_elt_hash(FSETAM_ROUT_DEF self, AM_ROUT_DEF e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETAM_ROUT_DEF_size_INT(FSETAM_ROUT_DEF self) {
 INT ret_val = ((INT) 0);
 if ((self==((FSETAM_ROUT_DEF) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,hsize);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FSETAS_FEAT_MOD_asize_IN(FSETAS_FEAT_MOD self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETAS_FEAT_MOD_elt_hash(FSETAS_FEAT_MOD self, AS_FEAT_MOD e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETAS_FEAT_MOD_size_INT(FSETAS_FEAT_MOD self) {
 INT ret_val = ((INT) 0);
 if ((self==((FSETAS_FEAT_MOD) NULL))) {
  ret_val = 0;
  return ret_val;
 }
 else {
  ret_val = ATTR(self,hsize);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT FSETBOUND_TYPE_LAYOUT_as(FSETBOUND_TYPE_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETBOUND_TYPE_LAYOUT_el2(FSETBOUND_TYPE_LAYOUT self, BOUND_TYPE_LAYOUT e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETBUILTIN_LAYOUT_asize(FSETBUILTIN_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETBUILTIN_LAYOUT_elt_h(FSETBUILTIN_LAYOUT self, BUILTIN_LAYOUT e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETCLASS_LAYOUT_asize_I(FSETCLASS_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETCLASS_LAYOUT_elt_has(FSETCLASS_LAYOUT self, CLASS_LAYOUT e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETEXTERNAL_LAYOUT_asiz(FSETEXTERNAL_LAYOUT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT FSETEXTERNAL_LAYOUT_elt_1(FSETEXTERNAL_LAYOUT self, EXTERNAL_LAYOUT e) {
 INT ret_val = ((INT) 0);
 ret_val = INT_hash_INT((SYSID(((OB) e))));
 return ret_val;
}


INT FSETIDENT_asize_INT(FSETIDENT self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


STR FRAME_LAYOUT_str_STR(FRAME_LAYOUT self) {
 return ATTR(self,str1);
}


STR FRAME_LAYOUT_typedef_CGE(FRAME_LAYOUT self, CGEN c) {
 STR ret_val;
 MANGLE m;
 STR res;
 AM_ROUT_DEF L11;
 AM_LOCAL_EXPR fi;
 STR name11;
 FLISTAM_LOCAL_EXPR L21;
 AM_LOCAL_EXPR fli;
 STR name211;
 FLISTAM_ITER_CALL_EXPR L31;
 AM_ITER_CALL_EXPR ni;
 INT L41 = ((INT) 0);
 STR name311;
 extern STR typedefstruct;
 STR L5;
 extern STR S_frame_struct1;
 STR L6;
 extern STR S_frame_struct2;
 AM_LOCAL_EXPR L7;
 dSTR L8;
 STR L9;
 dTP L10;
 STR L12;
 dSTR L13;
 STR L14;
 STR L15;
 dSTR L16;
 extern STR Formalargument;
 STR L17;
 STR L18;
 extern STR name112;
 extern STR INTstate;
 BOOL L19;
 AM_LOCAL_EXPR L20;
 dSTR L22;
 STR L23;
 dTP L24;
 STR L25;
 dSTR L26;
 STR L27;
 STR L28;
 extern STR name85;
 AM_ITER_CALL_EXPR L29;
 extern STR struct3;
 STR L30;
 STR L32;
 extern STR S_frame_struct3;
 extern STR nested;
 INT L33;
 dSTR L34;
 STR L35;
 extern STR nestediterframe;
 extern STR name113;
 STR L36;
 STR L37;
 extern STR S_frame5;
 STR L38;
 extern STR S_frame3;
 m = ATTR(c,mangler);
 L5 = STR_plus_dSTR_STR(((STR) &typedefstruct), ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,f1),sig11)), ((OB) c))));
 res = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &S_frame_struct1)));
 L6 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,f1),sig11)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L6, ((dSTR) ((STR) &S_frame_struct2))));
 {
  struct AM_ROUT_DEF_eltb_AM_LOCA_frame_struct other1_0;
  AM_ROUT_DEF_eltb_AM_LOCA_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,f1);
    noname1->self = L11;
   }
   L7 = AM_ROUT_DEF_eltb_AM_LOCA(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   fi = L7;
   name11 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) fi), ((OB) ATTR(ATTR(self,f1),sig11)));
   L8 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L8)->value_part = ' ';
   L9 = STR_plus_dSTR_STR(res, L8);
   L10 = AM_LOCAL_EXPR_tp_dTP(fi);
   L12 = STR_plus_dSTR_STR(L9, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) L10), ((OB) c))));
   L13 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L13)->value_part = ' ';
   L14 = STR_plus_dSTR_STR(L12, L13);
   L15 = STR_plus_dSTR_STR(L14, ((dSTR) name11));
   L16 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L16)->value_part = ';';
   res = STR_plus_dSTR_STR(L15, L16);
   L17 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &Formalargument)));
   L18 = STR_plus_dSTR_STR(L17, ((dSTR) ATTR(fi,name1).str));
   res = STR_plus_dSTR_STR(L18, ((dSTR) ((STR) &name112)));
  }
 }
 after_loop: ;
 res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &INTstate)));
 L19 = (ATTR(ATTR(self,f1),locals1)==((FLISTAM_LOCAL_EXPR) NULL));
 if ((!(L19))) {
  {
   struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other2_0;
   FLISTAM_LOCAL_EXPR_eltb__frame 
   noname2 = &other2_0;
   noname2->state = 0;
   while (1) {
    if (noname2->state == 0) {
     L21 = ATTR(ATTR(self,f1),locals1);
     noname2->self = L21;
    }
    L20 = FLISTAM_LOCAL_EXPR_eltb_(noname2);
    if (noname2->state == -1) {
     goto after_loop1;
    }
    fli = L20;
    name211 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) fli), ((OB) ATTR(ATTR(self,f1),sig11)));
    L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L22)->value_part = ' ';
    L23 = STR_plus_dSTR_STR(res, L22);
    L24 = AM_LOCAL_EXPR_tp_dTP(fli);
    L25 = STR_plus_dSTR_STR(L23, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) L24), ((OB) c))));
    L26 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L26)->value_part = ' ';
    L27 = STR_plus_dSTR_STR(L25, L26);
    L28 = STR_plus_dSTR_STR(L27, ((dSTR) name211));
    res = STR_plus_dSTR_STR(L28, ((dSTR) ((STR) &name85)));
   }
  }
  after_loop1: ;
 }
 {
  struct FLISTAM_ITER_CALL_EXPR_e_frame_struct other3_0;
  FLISTAM_ITER_CALL_EXPR_e_frame 
  noname3 = &other3_0;
  struct INT_upb_INT_frame_struct other3_1;
  INT_upb_INT_frame 
  noname4 = &other3_1;
  noname3->state = 0;
  noname4->state = 0;
  while (1) {
   if (noname3->state == 0) {
    L31 = FMAPAM_ROUT_DEFFLISTAM_I19(ATTR(LAYOUT_TBL_cgen,nested_its), ATTR(self,f1));
    noname3->self = L31;
   }
   L29 = FLISTAM_ITER_CALL_EXPR_e(noname3);
   if (noname3->state == -1) {
    goto after_loop2;
   }
   ni = L29;
   L30 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
   L32 = STR_plus_dSTR_STR(L30, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ni,fun)), ((OB) c))));
   res = STR_plus_dSTR_STR(L32, ((dSTR) ((STR) &S_frame_struct3)));
   if (noname4->state == 0) {
    L41 = 1;
    noname4->self = L41;
   }
   L33 = INT_upb_INT(noname4);
   if (noname4->state == -1) {
    goto after_loop2;
   }
   L34 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
   ((INT_boxed) L34)->value_part = L33;
   name311 = STR_plus_dSTR_STR(((STR) &nested), L34);
   L35 = STR_plus_dSTR_STR(res, ((dSTR) name311));
   res = STR_plus_dSTR_STR(L35, ((dSTR) ((STR) &nestediterframe)));
  }
 }
 after_loop2: ;
 L36 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name113)));
 L37 = STR_plus_dSTR_STR(L36, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,f1),sig11)), ((OB) c))));
 res = STR_plus_dSTR_STR(L37, ((dSTR) ((STR) &S_frame5)));
 L38 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,f1),sig11)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L38, ((dSTR) ((STR) &S_frame3))));
 ret_val = res;
 return ret_val;
}


TUPdTPIFC FMAPdTPIFC_aeltb_TUPdTPI(FMAPdTPIFC_aeltb_TUPdTPI_frame frame) {
 TUPdTPIFC dummy = TUPdTPIFC_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPdTPIFC_aget_INT_TUPd(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPdTPIFC FMAPdTPIFC_aget_INT_TUPd(FMAPdTPIFC self, INT ind) {
 TUPdTPIFC ret_val = TUPdTPIFC_zero;
 return ARR(self,ind);
}


TUPdTPIFC FMAPdTPIFC_pairsb_TUPdTP(FMAPdTPIFC_pairsb_TUPdTP_frame frame) {
 TUPdTPIFC dummy = TUPdTPIFC_zero;
 BOOL L1;
 TUPdTPIFC L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPIFC) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPIFC_aeltb_TUPdTPI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPIFC_aeltb_TUPdTPI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPdTPIFC_is_key_nil_dT(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPdTPIMPL FMAPdTPIMPL_aeltb_TUPdTP(FMAPdTPIMPL_aeltb_TUPdTP_frame frame) {
 TUPdTPIMPL dummy = TUPdTPIMPL_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPdTPIMPL_aget_INT_TUP(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPdTPIMPL FMAPdTPIMPL_aget_INT_TUP(FMAPdTPIMPL self, INT ind) {
 TUPdTPIMPL ret_val = TUPdTPIMPL_zero;
 return ARR(self,ind);
}


TUPdTPIMPL FMAPdTPIMPL_pairsb_TUPdT(FMAPdTPIMPL_pairsb_TUPdT_frame frame) {
 TUPdTPIMPL dummy = TUPdTPIMPL_zero;
 BOOL L1;
 TUPdTPIMPL L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPIMPL) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPIMPL_aeltb_TUPdTP_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPIMPL_aeltb_TUPdTP(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPdTPIMPL_is_key_nil_d(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPdTPINT FMAPdTPINT_aeltb_TUPdTPI(FMAPdTPINT_aeltb_TUPdTPI_frame frame) {
 TUPdTPINT dummy = TUPdTPINT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPdTPINT_aget_INT_TUPd(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPdTPINT FMAPdTPINT_aget_INT_TUPd(FMAPdTPINT self, INT ind) {
 TUPdTPINT ret_val = TUPdTPINT_zero;
 return ARR(self,ind);
}


TUPdTPINT FMAPdTPINT_pairsb_TUPdTP(FMAPdTPINT_pairsb_TUPdTP_frame frame) {
 TUPdTPINT dummy = TUPdTPINT_zero;
 BOOL L1;
 TUPdTPINT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPINT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPINT_aeltb_TUPdTPI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPINT_aeltb_TUPdTPI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPdTPINT_is_key_nil_dT(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPdTPdLAYOUT FMAPdTPdLAYOUT_aeltb_TUP(FMAPdTPdLAYOUT_aeltb_TUP_frame frame) {
 TUPdTPdLAYOUT dummy = TUPdTPdLAYOUT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return FMAPdTPdLAYOUT_aget_INT_(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPdTPdLAYOUT FMAPdTPdLAYOUT_aget_INT_(FMAPdTPdLAYOUT self, INT ind) {
 TUPdTPdLAYOUT ret_val = TUPdTPdLAYOUT_zero;
 return ARR(self,ind);
}


TUPdTPdLAYOUT FMAPdTPdLAYOUT_pairsb_TU(FMAPdTPdLAYOUT_pairsb_TU_frame frame) {
 TUPdTPdLAYOUT dummy = TUPdTPdLAYOUT_zero;
 BOOL L1;
 TUPdTPdLAYOUT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPdLAYOUT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPdLAYOUT_aeltb_TUP_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPdLAYOUT_aeltb_TUP(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = FMAPdTPdLAYOUT_is_key_ni(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT self, dTP k) {
 dLAYOUT ret_val;
 INT h = ((INT) 0);
 dTP tk;
 dTP tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((FMAPdTPdLAYOUT) NULL))) {
  ret_val = ((dLAYOUT) NULL);
  return ret_val;
 }
 L1 = FMAPdTPdLAYOUT_key_hash_(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = FMAPdTPdLAYOUT_aget_INT_(self, h).t1;
  if (FMAPdTPdLAYOUT_is_key_ni(self, tk)) {
   goto after_loop;
  }
  else {
   if (FMAPdTPdLAYOUT_key_eq_dT(self, tk, k)) {
    ret_val = FMAPdTPdLAYOUT_aget_INT_(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = FMAPdTPdLAYOUT_aget_INT_(self, h).t1;
   if (FMAPdTPdLAYOUT_is_key_ni(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (FMAPdTPdLAYOUT_key_eq_dT(self, tk1, k)) {
     ret_val = FMAPdTPdLAYOUT_aget_INT_(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((dLAYOUT) NULL);
 return ret_val;
}


dTP FMAPdTPIFC_key_nil_dTP(FMAPdTPIFC self) {
 dTP ret_val;
 dTP k = ((dTP) NULL);
 if (k==NULL) {
  ret_val = ((dTP) NULL);
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = ((dTP) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dTP FMAPdTPIMPL_key_nil_dTP(FMAPdTPIMPL self) {
 dTP ret_val;
 dTP k = ((dTP) NULL);
 if (k==NULL) {
  ret_val = ((dTP) NULL);
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = ((dTP) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dTP FMAPdTPINT_key_nil_dTP(FMAPdTPINT self) {
 dTP ret_val;
 dTP k = ((dTP) NULL);
 if (k==NULL) {
  ret_val = ((dTP) NULL);
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = ((dTP) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dTP FMAPdTPINT_keysb_dTP(FMAPdTPINT_keysb_dTP_frame frame) {
 dTP dummy = ((dTP) NULL);
 BOOL L1;
 TUPdTPINT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((FMAPdTPINT) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(FMAPdTPINT_aeltb_TUPdTPI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = FMAPdTPINT_aeltb_TUPdTPI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2.t1;
    L4 = FMAPdTPINT_is_key_nil_dT(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dTP FMAPdTPdLAYOUT_key_nil_d(FMAPdTPdLAYOUT self) {
 dTP ret_val;
 dTP k = ((dTP) NULL);
 if (k==NULL) {
  ret_val = ((dTP) NULL);
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = ((dTP) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


void FMAPdTPIFC_aset_INT_TUPd(FMAPdTPIFC self, INT ind, TUPdTPIFC val1) {
 SARR(self,ind,val1);
}


void FMAPdTPIFC_asetb_TUPdTPI(FMAPdTPIFC_asetb_TUPdTPI_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPdTPIFC_aset_INT_TUPd(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPdTPIMPL_aset_INT_TUP(FMAPdTPIMPL self, INT ind, TUPdTPIMPL val1) {
 SARR(self,ind,val1);
}


void FMAPdTPIMPL_asetb_TUPdTP(FMAPdTPIMPL_asetb_TUPdTP_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPdTPIMPL_aset_INT_TUP(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPdTPINT_aset_INT_TUPd(FMAPdTPINT self, INT ind, TUPdTPINT val1) {
 SARR(self,ind,val1);
}


void FMAPdTPINT_asetb_TUPdTPI(FMAPdTPINT_asetb_TUPdTPI_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPdTPINT_aset_INT_TUPd(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FMAPdTPdLAYOUT_aset_INT_(FMAPdTPdLAYOUT self, INT ind, TUPdTPdLAYOUT val1) {
 SARR(self,ind,val1);
}


void FMAPdTPdLAYOUT_asetb_TUP(FMAPdTPdLAYOUT_asetb_TUP_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FMAPdTPdLAYOUT_aset_INT_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETABSTRACT_LAYOUT_aset(FSETABSTRACT_LAYOUT self, INT ind, ABSTRACT_LAYOUT val1) {
 SARR(self,ind,val1);
}


void FSETABSTRACT_LAYOUT_aset1(FSETABSTRACT_LAYOUT_aset1_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETABSTRACT_LAYOUT_aset(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETAM_GLOBAL_EXPR_aset_(FSETAM_GLOBAL_EXPR self, INT ind, AM_GLOBAL_EXPR val1) {
 SARR(self,ind,val1);
}


void FSETAM_GLOBAL_EXPR_asetb(FSETAM_GLOBAL_EXPR_asetb_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETAM_GLOBAL_EXPR_aset_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETAM_ROUT_DEF_aset_INT(FSETAM_ROUT_DEF self, INT ind, AM_ROUT_DEF val1) {
 SARR(self,ind,val1);
}


void FSETAM_ROUT_DEF_asetb_AM(FSETAM_ROUT_DEF_asetb_AM_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETAM_ROUT_DEF_aset_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETAS_FEAT_MOD_aset_INT(FSETAS_FEAT_MOD self, INT ind, AS_FEAT_MOD val1) {
 SARR(self,ind,val1);
}


void FSETAS_FEAT_MOD_asetb_AS(FSETAS_FEAT_MOD_asetb_AS_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETAS_FEAT_MOD_aset_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETBOUND_TYPE_LAYOUT_as1(FSETBOUND_TYPE_LAYOUT self, INT ind, BOUND_TYPE_LAYOUT val1) {
 SARR(self,ind,val1);
}


void FSETBOUND_TYPE_LAYOUT_as2(FSETBOUND_TYPE_LAYOUT_as2_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETBOUND_TYPE_LAYOUT_as1(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETBUILTIN_LAYOUT_aset_(FSETBUILTIN_LAYOUT self, INT ind, BUILTIN_LAYOUT val1) {
 SARR(self,ind,val1);
}


void FSETBUILTIN_LAYOUT_asetb(FSETBUILTIN_LAYOUT_asetb_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETBUILTIN_LAYOUT_aset_(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETCLASS_LAYOUT_aset_IN(FSETCLASS_LAYOUT self, INT ind, CLASS_LAYOUT val1) {
 SARR(self,ind,val1);
}


void FSETCLASS_LAYOUT_asetb_C(FSETCLASS_LAYOUT_asetb_C_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETCLASS_LAYOUT_aset_IN(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETEXTERNAL_LAYOUT_aset(FSETEXTERNAL_LAYOUT self, INT ind, EXTERNAL_LAYOUT val1) {
 SARR(self,ind,val1);
}


void FSETEXTERNAL_LAYOUT_aset1(FSETEXTERNAL_LAYOUT_aset1_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETEXTERNAL_LAYOUT_aset(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void FSETIDENT_aset_INT_IDENT(FSETIDENT self, INT ind, IDENT val1) {
 SARR(self,ind,val1);
}


void FSETIDENT_asetb_IDENT(FSETIDENT_asetb_IDENT_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   FSETIDENT_aset_INT_IDENT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}

/* C for type FMAPdTPIFC */




INT FMAPdTPIFC_key_hash_dTP_(FMAPdTPIFC self, dTP k) {
 INT ret_val = ((INT) 0);
 if (k==NULL) {
  ret_val = INT_hash_INT((SYSID(((OB) k))));
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = INT_hash_INT((SYSID(((OB) k))));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}

/* C for type FMAPdTPIMPL */




INT FMAPdTPIMPL_key_hash_dTP(FMAPdTPIMPL self, dTP k) {
 INT ret_val = ((INT) 0);
 if (k==NULL) {
  ret_val = INT_hash_INT((SYSID(((OB) k))));
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = INT_hash_INT((SYSID(((OB) k))));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}

/* C for type FMAPdTPINT */




FMAPdTPINT FMAPdTPINT_create_FMAPdT(FMAPdTPINT self) {
 FMAPdTPINT ret_val;
 ret_val = ((FMAPdTPINT) NULL);
 return ret_val;
}

/* C for type FMAPdTPdLAYOUT */




INT FMAPdTPdLAYOUT_key_hash_(FMAPdTPdLAYOUT self, dTP k) {
 INT ret_val = ((INT) 0);
 if (k==NULL) {
  ret_val = INT_hash_INT((SYSID(((OB) k))));
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = INT_hash_INT((SYSID(((OB) k))));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}

/* C for type FRAME_LAYOUT */




void FRAME_LAYOUT_layouts_FMA(FRAME_LAYOUT self, FMAPAM_ROUT_DEFFRAME_LAY layouts) {
 FRAME_LAYOUT_layouts = layouts;
}

/* C for type FSETABSTRACT_LAYOUT */




ABSTRACT_LAYOUT FSETABSTRACT_LAYOUT_elt_(FSETABSTRACT_LAYOUT self) {
 ABSTRACT_LAYOUT ret_val;
 ABSTRACT_LAYOUT t = ((ABSTRACT_LAYOUT) NULL);
 ret_val = ((ABSTRACT_LAYOUT) NULL);
 return ret_val;
}

/* C for type FSETAM_GLOBAL_EXPR */




FSETAM_GLOBAL_EXPR FSETAM_GLOBAL_EXPR_creat(FSETAM_GLOBAL_EXPR self) {
 FSETAM_GLOBAL_EXPR ret_val;
 ret_val = ((FSETAM_GLOBAL_EXPR) NULL);
 return ret_val;
}

/* C for type FSETAM_ROUT_DEF */




FSETAM_ROUT_DEF FSETAM_ROUT_DEF_create_F(FSETAM_ROUT_DEF self) {
 FSETAM_ROUT_DEF ret_val;
 ret_val = ((FSETAM_ROUT_DEF) NULL);
 return ret_val;
}

/* C for type FSETAS_FEAT_MOD */




AS_FEAT_MOD FSETAS_FEAT_MOD_elt_nil_(FSETAS_FEAT_MOD self) {
 AS_FEAT_MOD ret_val;
 AS_FEAT_MOD t = ((AS_FEAT_MOD) NULL);
 ret_val = ((AS_FEAT_MOD) NULL);
 return ret_val;
}

/* C for type FSETBOUND_TYPE_LAYOUT */




BOUND_TYPE_LAYOUT FSETBOUND_TYPE_LAYOUT_el(FSETBOUND_TYPE_LAYOUT self) {
 BOUND_TYPE_LAYOUT ret_val;
 BOUND_TYPE_LAYOUT t = ((BOUND_TYPE_LAYOUT) NULL);
 ret_val = ((BOUND_TYPE_LAYOUT) NULL);
 return ret_val;
}

/* C for type FSETBUILTIN_LAYOUT */




BUILTIN_LAYOUT FSETBUILTIN_LAYOUT_elt_n(FSETBUILTIN_LAYOUT self) {
 BUILTIN_LAYOUT ret_val;
 BUILTIN_LAYOUT t = ((BUILTIN_LAYOUT) NULL);
 ret_val = ((BUILTIN_LAYOUT) NULL);
 return ret_val;
}

/* C for type FSETCLASS_LAYOUT */




CLASS_LAYOUT FSETCLASS_LAYOUT_elt_nil(FSETCLASS_LAYOUT self) {
 CLASS_LAYOUT ret_val;
 CLASS_LAYOUT t = ((CLASS_LAYOUT) NULL);
 ret_val = ((CLASS_LAYOUT) NULL);
 return ret_val;
}

/* C for type FSETEXTERNAL_LAYOUT */




EXTERNAL_LAYOUT FSETEXTERNAL_LAYOUT_elt_(FSETEXTERNAL_LAYOUT self) {
 EXTERNAL_LAYOUT ret_val;
 EXTERNAL_LAYOUT t = ((EXTERNAL_LAYOUT) NULL);
 ret_val = ((EXTERNAL_LAYOUT) NULL);
 return ret_val;
}

/* C for type FSETIDENT */




INT FSETIDENT_elt_hash_IDENT(FSETIDENT self, IDENT e) {
 INT ret_val = ((INT) 0);
 ret_val = IDENT_hash_INT(e);
 return ret_val;
}
