#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dAS_CLASS_ELT_struct {
 OB_HEADER header;
 } *dAS_CLASS_ELT;

typedef struct dBACK_END_struct {
 OB_HEADER header;
 } *dBACK_END;

typedef struct dINLINE_ITER_SIG_struct {
 OB_HEADER header;
 } *dINLINE_ITER_SIG;

typedef struct dINLINE_ROUT_SIG_struct {
 OB_HEADER header;
 } *dINLINE_ROUT_SIG;

typedef struct dPARSE_struct {
 OB_HEADER header;
 } *dPARSE;

typedef struct dPROG_ERR_struct {
 OB_HEADER header;
 } *dPROG_ERR;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;

typedef struct ARRAYSTR_struct {/* layout for ARRAY{STR} */
 OB_HEADER header;
 INT asize;
 STR arr_part[1];
 } *ARRAYSTR;

typedef struct CHANGE_VARS_struct {/* layout for CHANGE_VARS */
 OB_HEADER header;
 struct dAM_STMT_struct *init_hot1;
 struct dAM_STMT_struct *init_nonhot1;
 struct dAM_STMT_struct *init_parms1;
 struct dAM_STMT_struct *init_vars1;
 struct ARRAYINT_struct *pind_hot;
 struct ARRAYINT_struct *pind_nonhot;
 struct FLISTAM_LOCAL_EXPR_struct *new_vars;
 struct FLISTAM_LOCAL_EXPR_struct *saved_vars;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *new_subst;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *saved_subst;
 } *CHANGE_VARS;

typedef struct ELT_struct {/* layout for ELT */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *as1;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 BOOL is_private1;
 } *ELT;

typedef struct ERR1_struct {/* layout for ERR */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *ERR1;

typedef struct FILE1_struct {/* layout for FILE */
 OB_HEADER header;
 EXT_OB fp;
 } *FILE1;

typedef struct GLOBAL_TBL_struct {/* layout for GLOBAL_TBL */
 OB_HEADER header;
 struct FLISTAM_GLOBAL_EXPR_struct *top_sort;
 struct FMAPdTPFMAPIDENTAM_GLOBA_struct *tbl;
 struct PROG_struct *prog1;
 } *GLOBAL_TBL;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IDENT_BUILTIN_struct {/* layout for IDENT_BUILTIN */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *IDENT_BUILTIN;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IFC_ABS_CREATE_struct {/* layout for IFC_ABS_CREATE */
 OB_HEADER header;
 struct AS_CLASS_DEF_struct *tr;
 struct FLISTIFC_struct *supers;
 struct SIG_TBL_struct *class_sigs;
 struct TP_CLASS_struct *tp1;
 struct TP_CONTEXT_struct *con1;
 } *IFC_ABS_CREATE;

typedef struct IFC_TBL_struct {/* layout for IFC_TBL */
 OB_HEADER header;
 struct FMAPdTPIFC_struct *tbl;
 struct FSETTUPIDENTINT_struct *abs_cur;
 struct PROG_struct *prog1;
 } *IFC_TBL;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_CREATE_struct {/* layout for IMPL_CREATE */
 OB_HEADER header;
 struct AS_CLASS_DEF_struct *as1;
 struct ELT_TBL_struct *class_elts;
 struct FLISTIMPL_INCLUDE_struct *incs;
 struct TP_CLASS_struct *tp1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 } *IMPL_CREATE;

typedef struct IMPL_INCLUDE_struct {/* layout for IMPL_INCLUDE */
 OB_HEADER header;
 struct AS_INCLUDE_CLAUSE_struct *as1;
 struct ELT_TBL_struct *elt_tbl;
 struct FSETAS_FEAT_MOD_struct *used_mods;
 struct IMPL_struct *impl;
 struct TP_CLASS_struct *itp;
 struct TP_CLASS_struct *tp1;
 } *IMPL_INCLUDE;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;

typedef struct IMPORT_EXPORT_TBL_struct {/* layout for IMPORT_EXPORT_TBL */
 OB_HEADER header;
 struct FSETTUPIDENTIDENT_struct *exports;
 struct FSETTUPIDENTIDENT_struct *imports;
 struct PROG_struct *prog1;
 } *IMPORT_EXPORT_TBL;

typedef struct INLINE_ARR_READ_struct {/* layout for INLINE_ARR_READ */
 OB_HEADER header;
 struct SIG_struct *sig11;
 } *INLINE_ARR_READ;

typedef struct INLINE_ARR_WRITE_struct {/* layout for INLINE_ARR_WRITE */
 OB_HEADER header;
 struct SIG_struct *sig11;
 } *INLINE_ARR_WRITE;

typedef struct INLINE_ATTR_READ_struct {/* layout for INLINE_ATTR_READ */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_READ;

typedef struct INLINE_ATTR_WRITE_struct {/* layout for INLINE_ATTR_WRITE */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_WRITE;

typedef struct INLINE_BUILTIN_struct {/* layout for INLINE_BUILTIN */
 OB_HEADER header;
 struct SIG_struct *sig11;
 } *INLINE_BUILTIN;

typedef struct INLINE_GLOBAL_READ_struct {/* layout for INLINE_GLOBAL_READ */
 OB_HEADER header;
 struct AM_GLOBAL_EXPR_struct *age11;
 struct SIG_struct *sig11;
 } *INLINE_GLOBAL_READ;

typedef struct INLINE_INT_FOLD_struct {/* layout for INLINE_INT_FOLD */
 OB_HEADER header;
 struct SIG_struct *sig1;
 } *INLINE_INT_FOLD;

typedef struct INLINE_ITER_struct {/* layout for INLINE_ITER */
 OB_HEADER header;
 struct dAM_EXPR_struct *yield_cond;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *BEFLOOP_code;
 struct dAM_STMT_struct *IINIT_code;
 struct dAM_STMT_struct *ITERM_code;
 struct dAM_STMT_struct *WNOY_code;
 struct dAM_STMT_struct *WYAFT_code;
 struct dAM_STMT_struct *WYBEF_code;
 struct CHANGE_VARS_struct *change_vars;
 struct FLISTAM_LOCAL_EXPR_struct *loop_firsts;
 struct SIG_struct *signature;
 BOOL flat_yield;
 } *INLINE_ITER;


typedef struct INT_downtob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_downtob_INT_INT_frame;


typedef struct INT_timesb_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT i;
 } *INT_timesb_frame;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SIG_TBL_struct {/* layout for SIG_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *SIG_TBL;


typedef struct SIG_TBL_eltb_SIG_frame_struct {
 SIG_TBL self;/* Formal argument: self */
 INT state;
 SIG ret_val;
 SIG_TBL L31;
 SIG r;
 struct SIG_TBL_aeltb_SIG_frame_struct *nested1; /* nested iter frame */
 } *SIG_TBL_eltb_SIG_frame;


typedef struct SIG_TBL_get_queryb_IDENT_frame_struct {
 SIG_TBL self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: q */
 INT state;
 SIG ret_val;
 INT h;
 SIG e;
 SIG e1;
 } *SIG_TBL_get_queryb_IDENT_frame;


typedef struct STR_eltb_CHAR_frame_struct {
 STR self;/* Formal argument: self */
 INT state;
 CHAR ret_val;
 STR L31;
 struct STR_aeltb_CHAR_frame_struct *nested1; /* nested iter frame */
 } *STR_eltb_CHAR_frame;


typedef struct STR_separateb_STR_STR_frame_struct {
 STR self;/* Formal argument: self */
 STR arg1;/* Formal argument: s */
 INT state;
 STR ret_val;
 } *STR_separateb_STR_STR_frame;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct SYSTEM_LEX_struct {/* layout for SYSTEM_LEX */
 OB_HEADER header;
 struct FSTR_struct *buf11;
 INT lex_state;
 INT pos1;
 STR name1;
 } *SYSTEM_LEX;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_CONTEXT_struct {/* layout for TP_CONTEXT */
 OB_HEADER header;
 struct ARRAYdTP_struct *ptypes1;
 struct ARRAYIDENT_struct *pnames1;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *same11;
 BOOL is_abs;
 } *TP_CONTEXT;

typedef struct TP_ITER_struct {/* layout for TP_ITER */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct ARRAYBOOL_struct *hot;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ITER;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_struct {/* layout for TUP{$TP,FMAP{IDENT,AM_GLOBAL_EXPR}} */
 struct dTP_struct *t1;
 struct FMAPIDENTAM_GLOBAL_EXPR_struct *t2;
 } TUPdTPFMAPIDENTAM_GLOBAL;
static TUPdTPFMAPIDENTAM_GLOBAL TUPdTPFMAPIDENTAM_GLOBAL_zero;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_boxed_struct {
 OB_HEADER header;
 TUPdTPFMAPIDENTAM_GLOBAL value_part;
 } *TUPdTPFMAPIDENTAM_GLOBAL_boxed;

typedef struct TUPdTPIFC_struct {/* layout for TUP{$TP,IFC} */
 struct dTP_struct *t1;
 struct IFC_struct *t2;
 } TUPdTPIFC;
static TUPdTPIFC TUPdTPIFC_zero;

typedef struct TUPdTPIFC_boxed_struct {
 OB_HEADER header;
 TUPdTPIFC value_part;
 } *TUPdTPIFC_boxed;

typedef struct TUPdTPIMPL_struct {/* layout for TUP{$TP,IMPL} */
 struct dTP_struct *t1;
 struct IMPL_struct *t2;
 } TUPdTPIMPL;
static TUPdTPIMPL TUPdTPIMPL_zero;

typedef struct TUPdTPIMPL_boxed_struct {
 OB_HEADER header;
 TUPdTPIMPL value_part;
 } *TUPdTPIMPL_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPIDENTAM_GLOBAL_EXPR_struct {/* layout for TUP{IDENT,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTAM_GLOBAL_EXPR;
static TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_zero;

typedef struct TUPIDENTAM_GLOBAL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPIDENTAM_GLOBAL_EXPR value_part;
 } *TUPIDENTAM_GLOBAL_EXPR_boxed;

typedef struct TUPIDENTIDENT_struct {/* layout for TUP{IDENT,IDENT} */
 struct IDENT_struct t1;
 struct IDENT_struct t2;
 } TUPIDENTIDENT;
static TUPIDENTIDENT TUPIDENTIDENT_zero;

typedef struct TUPIDENTIDENT_boxed_struct {
 OB_HEADER header;
 TUPIDENTIDENT value_part;
 } *TUPIDENTIDENT_boxed;

typedef struct TUPIDENTINT_struct {/* layout for TUP{IDENT,INT} */
 struct IDENT_struct t1;
 INT t2;
 } TUPIDENTINT;
static TUPIDENTINT TUPIDENTINT_zero;

typedef struct TUPIDENTINT_boxed_struct {
 OB_HEADER header;
 TUPIDENTINT value_part;
 } *TUPIDENTINT_boxed;

typedef struct TUPSTRSTR_struct {/* layout for TUP{STR,STR} */
 STR t1;
 STR t2;
 } TUPSTRSTR;
static TUPSTRSTR TUPSTRSTR_zero;

typedef struct TUPSTRSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRSTR value_part;
 } *TUPSTRSTR_boxed;

typedef struct UNIX_struct {/* layout for UNIX */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *UNIX;

typedef struct WEIGH_CODE_struct {/* layout for WEIGH_CODE */
 OB_HEADER header;
 struct dAM_STMT_struct *badstmt;
 struct AM_IF_STMT_struct *enclosing_if;
 INT level1;
 INT max_weight;
 INT weight;
 BOOL true_branch;
 } *WEIGH_CODE;

typedef struct XFORM_CODE_struct {/* layout for XFORM_CODE */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *after_yield;
 struct AM_IF_STMT_struct *enclosing_if;
 struct AM_IF_STMT_struct *if_encl_yield;
 struct AM_LOOP_STMT_struct *loop_stmt;
 struct AM_LOOP_STMT_struct *new_loop_stmt;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *subst1;
 BOOL record_calls;
 BOOL true_br_yield;
 BOOL true_branch;
 } *XFORM_CODE;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTR_EXPR_struct {/* layout for AM_ATTR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_ATTR_EXPR;

typedef struct AM_BOOL_CONST_struct {/* layout for AM_BOOL_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 BOOL val11;
 } *AM_BOOL_CONST;

typedef struct AM_BREAK_STMT_struct {/* layout for AM_BREAK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_BREAK_STMT;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_IF_STMT_struct {/* layout for AM_IF_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *if_false;
 struct dAM_STMT_struct *if_true;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_IF_STMT;

typedef struct AM_INT_CONST_struct {/* layout for AM_INT_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_INT_CONST;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_LOOP_STMT_struct {/* layout for AM_LOOP_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct SFILE_ID_struct source11;
 BOOL has_yield;
 } *AM_LOOP_STMT;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AM_STMT_EXPR_struct {/* layout for AM_STMT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *stmts;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 struct SFILE_ID_struct source11;
 } *AM_STMT_EXPR;

typedef struct AM_YIELD_STMT_struct {/* layout for AM_YIELD_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 INT ret1;
 struct SFILE_ID_struct source11;
 } *AM_YIELD_STMT;

typedef struct ARRAYIDENT_struct {/* layout for ARRAY{IDENT} */
 OB_HEADER header;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *ARRAYIDENT;

typedef struct ARRAYINT_struct {/* layout for ARRAY{INT} */
 OB_HEADER header;
 INT asize;
 INT arr_part[1];
 } *ARRAYINT;


typedef struct ARRAYINT_eltb_INT_frame_struct {
 ARRAYINT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 ARRAYINT L31;
 struct ARRAYINT_aeltb_INT_frame_struct *nested1; /* nested iter frame */
 } *ARRAYINT_eltb_INT_frame;

typedef struct AS_ATTR_DEF_struct {/* layout for AS_ATTR_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_ATTR_DEF;

typedef struct AS_CLASS_DEF_struct {/* layout for AS_CLASS_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *body;
 struct AS_CLASS_DEF_struct *next;
 struct AS_PARAM_DEC_struct *params1;
 struct AS_TYPE_SPEC_struct *over;
 struct AS_TYPE_SPEC_struct *under;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 } *AS_CLASS_DEF;

typedef struct AS_CONST_DEF_struct {/* layout for AS_CONST_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_CONST_DEF;

typedef struct AS_FEAT_MOD_struct {/* layout for AS_FEAT_MOD */
 OB_HEADER header;
 struct AS_FEAT_MOD_struct *next;
 struct IDENT_struct name1;
 struct IDENT_struct new_name;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_FEAT_MOD;

typedef struct AS_INCLUDE_CLAUSE_struct {/* layout for AS_INCLUDE_CLAUSE */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_FEAT_MOD_struct *mods;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_INCLUDE_CLAUSE;

typedef struct AS_ROUT_DEF_struct {/* layout for AS_ROUT_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *post_e;
 struct dAS_EXPR_struct *pre_e;
 struct AS_ARG_DEC_struct *args_dec;
 struct AS_STMT_LIST_struct *body;
 struct AS_TYPE_SPEC_struct *ret_dec;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL is_private;
 } *AS_ROUT_DEF;

typedef struct AS_SHARED_DEF_struct {/* layout for AS_SHARED_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_SHARED_DEF;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct CALL_SIG_struct {/* layout for CALL_SIG */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ARRAYdCALL_TP_struct *args1;
 struct IDENT_struct name1;
 BOOL has_ret;
 BOOL unknown_ret;
 } *CALL_SIG;

typedef struct ELT_TBL_struct {/* layout for ELT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ELT_struct *arr_part[1];
 } *ELT_TBL;


typedef struct ELT_TBL_eltb_ELT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 INT state;
 ELT ret_val;
 ELT_TBL L31;
 ELT r;
 struct ELT_TBL_aeltb_ELT_frame_struct *nested1; /* nested iter frame */
 } *ELT_TBL_eltb_ELT_frame;


typedef struct ELT_TBL_get_queryb_IDENT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: q */
 INT state;
 ELT ret_val;
 INT h;
 ELT e;
 ELT e1;
 } *ELT_TBL_get_queryb_IDENT_frame;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;

typedef struct FLISTAM_BND_ITER_CALL_EX_struct {/* layout for FLIST{AM_BND_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_ITER_CALL_EX;

typedef struct FLISTAM_GLOBAL_EXPR_struct {/* layout for FLIST{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FLISTAM_GLOBAL_EXPR;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FLISTIFC_struct {/* layout for FLIST{IFC} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IFC_struct *arr_part[1];
 } *FLISTIFC;

typedef struct FLISTIMPL_INCLUDE_struct {/* layout for FLIST{IMPL_INCLUDE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IMPL_INCLUDE_struct *arr_part[1];
 } *FLISTIMPL_INCLUDE;


typedef struct FLISTIMPL_INCLUDE_eltb_I_frame_struct {
 FLISTIMPL_INCLUDE self;/* Formal argument: self */
 INT state;
 IMPL_INCLUDE ret_val;
 FLISTIMPL_INCLUDE L31;
 INT L41;
 INT L51;
 struct FLISTIMPL_INCLUDE_aeltb__frame_struct *nested1; /* nested iter frame */
 } *FLISTIMPL_INCLUDE_eltb_I_frame;

typedef struct FLISTSTR_struct {/* layout for FLIST{STR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 STR arr_part[1];
 } *FLISTSTR;

typedef struct FMAPdTPFMAPIDENTAM_GLOBA_struct {/* layout for FMAP{$TP,FMAP{IDENT,AM_GLOBAL_EXPR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPFMAPIDENTAM_GLOBAL_struct arr_part[1];
 } *FMAPdTPFMAPIDENTAM_GLOBA;

typedef struct FMAPdTPIFC_struct {/* layout for FMAP{$TP,IFC} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIFC_struct arr_part[1];
 } *FMAPdTPIFC;

typedef struct FMAPdTPIMPL_struct {/* layout for FMAP{$TP,IMPL} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIMPL_struct arr_part[1];
 } *FMAPdTPIMPL;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;

typedef struct FMAPIDENTAM_GLOBAL_EXPR_struct {/* layout for FMAP{IDENT,AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTAM_GLOBAL_EXPR_struct arr_part[1];
 } *FMAPIDENTAM_GLOBAL_EXPR;

typedef struct FMAPSTRSTR_struct {/* layout for FMAP{STR,STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSTR_struct arr_part[1];
 } *FMAPSTRSTR;

typedef struct FSETAS_FEAT_MOD_struct {/* layout for FSET{AS_FEAT_MOD} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_FEAT_MOD_struct *arr_part[1];
 } *FSETAS_FEAT_MOD;

typedef struct FSETSTR_struct {/* layout for FSET{STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 STR arr_part[1];
 } *FSETSTR;


typedef struct FSETSTR_eltb_STR_frame_struct {
 FSETSTR self;/* Formal argument: self */
 INT state;
 STR ret_val;
 FSETSTR L31;
 STR r;
 struct FSETSTR_aeltb_STR_frame_struct *nested1; /* nested iter frame */
 } *FSETSTR_eltb_STR_frame;

typedef struct FSETTUPIDENTIDENT_struct {/* layout for FSET{TUP{IDENT,IDENT}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTIDENT_struct arr_part[1];
 } *FSETTUPIDENTIDENT;

typedef struct FSETTUPIDENTINT_struct {/* layout for FSET{TUP{IDENT,INT}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTINT_struct arr_part[1];
 } *FSETTUPIDENTINT;


typedef struct FSETTUPIDENTINT_eltb_TUP_frame_struct {
 FSETTUPIDENTINT self;/* Formal argument: self */
 INT state;
 TUPIDENTINT ret_val;
 FSETTUPIDENTINT L31;
 TUPIDENTINT r;
 struct FSETTUPIDENTINT_aeltb_TU_frame_struct *nested1; /* nested iter frame */
 } *FSETTUPIDENTINT_eltb_TUP_frame;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct GET_OPTIONS_struct {/* layout for GET_OPTIONS */
 OB_HEADER header;
 struct ARRAYSTR_struct *args1;
 struct FMAPSTRSTR_struct *module_inclusion;
 struct FSETSTR_struct *classes1;
 struct FSETSTR_struct *paths;
 INT next;
 struct PROG_struct *prog1;
 BOOL all1;
 } *GET_OPTIONS;

typedef struct IDENT_TBL_struct {/* layout for IDENT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *IDENT_TBL;


typedef struct IDENT_TBL_aeltb_IDENT_frame_struct {
 IDENT_TBL self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 INT i;
 } *IDENT_TBL_aeltb_IDENT_frame;


typedef struct IDENT_TBL_asetb_IDENT_frame_struct {
 IDENT_TBL self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *IDENT_TBL_asetb_IDENT_frame;


typedef struct IDENT_TBL_eltb_IDENT_frame_struct {
 IDENT_TBL self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 IDENT_TBL L31;
 IDENT r;
 struct IDENT_TBL_aeltb_IDENT_frame_struct *nested1; /* nested iter frame */
 } *IDENT_TBL_eltb_IDENT_frame;

typedef struct INLINE_struct {/* layout for INLINE */
 OB_HEADER header;
 struct INLINE_ITER_TBL_struct *itbl;
 struct INLINE_ROUT_TBL_struct *rtbl;
 INT iter_thres;
 INT rout_thres;
 struct PROG_struct *prog1;
 BOOL inline_iters;
 BOOL inline_routs;
 } *INLINE;

typedef struct INLINE_ITER_TBL_struct {/* layout for INLINE_ITER_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ITER_SIG_struct *arr_part[1];
 } *INLINE_ITER_TBL;

typedef struct INLINE_ROUT_TBL_struct {/* layout for INLINE_ROUT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ROUT_SIG_struct *arr_part[1];
 } *INLINE_ROUT_TBL;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern IDENT IDENT_BUILTIN_AREF_ident1;
extern IDENT IDENT_BUILTIN_ARRAY_iden1;
extern IDENT IDENT_BUILTIN_ARR_ident;
extern IDENT IDENT_BUILTIN_AVAL_ident1;
extern IDENT IDENT_BUILTIN_FLTDX_iden1;
extern IDENT IDENT_BUILTIN_FLTD_ident1;
extern IDENT IDENT_BUILTIN_FLTX_ident1;
extern IDENT IDENT_BUILTIN_FLT_ident;
extern IDENT IDENT_BUILTIN_GATE_ident1;
extern IDENT IDENT_BUILTIN_INTI_ident1;
extern IDENT IDENT_BUILTIN_INT_ident;
extern IDENT IDENT_BUILTIN_SYS_ident;
extern IDENT IDENT_BUILTIN_aget_ident1;
extern IDENT IDENT_BUILTIN_aset_ident1;
extern IDENT IDENT_BUILTIN_asize_iden1;
extern IDENT IDENT_BUILTIN_bang_ident1;
extern IDENT IDENT_BUILTIN_call_bang_1;
extern IDENT IDENT_BUILTIN_call_ident1;
extern IDENT IDENT_BUILTIN_create_ide1;
extern IDENT IDENT_BUILTIN_div_ident;
extern IDENT IDENT_BUILTIN_dollar_OB_1;
extern IDENT IDENT_BUILTIN_invariant_1;
extern IDENT IDENT_BUILTIN_is_eq_iden1;
extern IDENT IDENT_BUILTIN_is_geq_ide1;
extern IDENT IDENT_BUILTIN_is_gt_iden1;
extern IDENT IDENT_BUILTIN_is_leq_ide1;
extern IDENT IDENT_BUILTIN_is_lt_iden1;
extern IDENT IDENT_BUILTIN_is_neq_ide1;
extern IDENT IDENT_BUILTIN_main_ident1;
extern IDENT IDENT_BUILTIN_minus_iden1;
extern IDENT IDENT_BUILTIN_mod_ident;
extern IDENT IDENT_BUILTIN_negate_ide1;
extern IDENT IDENT_BUILTIN_not_ident;
extern IDENT IDENT_BUILTIN_ob_eq_iden1;
extern IDENT IDENT_BUILTIN_plus_ident1;
extern IDENT IDENT_BUILTIN_pow_ident;
extern IDENT IDENT_BUILTIN_ret_ident;
extern IDENT IDENT_BUILTIN_self_ident1;
extern IDENT IDENT_BUILTIN_times_iden1;
extern IDENT_TBL IDENT_ident_tbl;
extern INT IDENT_TBL_load_ratio;
extern INT IDENT_tmp_count;
extern INT INLINE_ATTR_READ_inlined1;
extern INT INLINE_ATTR_READ_routine1;
extern INT INLINE_ATTR_WRITE_inline1;
extern INT INLINE_ATTR_WRITE_routin1;
extern INT INLINE_GLOBAL_READ_inlin1;
extern INT INLINE_GLOBAL_READ_routi1;
extern INT INLINE_INT_FOLD_inlined;
extern INT INLINE_INT_FOLD_routines1;
extern INT INLINE_ITER_inlined;
extern INT INLINE_ITER_iters;
extern INT INLINE_default_iter_thre;
extern INT INLINE_default_rout_thre;
extern INT TP_KIND_ext_tp;
extern INT TP_KIND_ref_tp;
extern INT TP_KIND_spr_tp;
extern INT TP_KIND_val_tp;
extern TP_CLASS TP_BUILTIN_bool;
extern TP_CLASS TP_BUILTIN_int;

/* Function declarations */

AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT, SFILE_ID);
AM_ATTR_EXPR AM_ATTR_EXPR_create_SFIL(AM_ATTR_EXPR, SFILE_ID);
AM_BOOL_CONST AM_BOOL_CONST_create_SFI(AM_BOOL_CONST, SFILE_ID);
AM_BREAK_STMT AM_BREAK_STMT_create_SFI(AM_BREAK_STMT, SFILE_ID);
AM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_5(FMAPIDENTAM_GLOBAL_EXPR, IDENT);
AM_GLOBAL_EXPR GLOBAL_TBL_get_IDENT_dTP(GLOBAL_TBL, IDENT, dTP);
AM_IF_STMT AM_IF_STMT_create_SFILE_(AM_IF_STMT, SFILE_ID);
AM_INT_CONST AM_INT_CONST_create_SFIL(AM_INT_CONST, SFILE_ID);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI1(AM_LOCAL_EXPR, SFILE_ID, IDENT, dTP);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA19(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR);
AM_LOOP_STMT AM_LOOP_STMT_create_SFIL(AM_LOOP_STMT, SFILE_ID);
AM_ROUT_CALL_EXPR AM_ROUT_CALL_EXPR_create(AM_ROUT_CALL_EXPR, INT, SFILE_ID);
AM_STMT_EXPR AM_STMT_EXPR_create_SFIL(AM_STMT_EXPR, SFILE_ID);
ARRAYSTR ARRAYSTR_append_ARRAYSTR(ARRAYSTR, ARRAYSTR);
ARRAYSTR ARRAYSTR_create_INT_ARRA(ARRAYSTR, INT);
ARRAYSTR ARRAYSTR_subarr_INT_INT_(ARRAYSTR, INT, INT);
ARRAYSTR FLISTSTR_array_ARRAYSTR(FLISTSTR);
AS_FEAT_MOD IMPL_INCLUDE_modifier_fo(IMPL_INCLUDE, IDENT);
BOOL AM_ROUT_DEF_is_iter_BOOL(AM_ROUT_DEF);
BOOL CALL_SIG_conforms_to_SIG(CALL_SIG, SIG);
BOOL CHAR_is_space_BOOL(CHAR);
BOOL ELT_is_abstract_BOOL(ELT);
BOOL ELT_is_attr_access_BOOL(ELT);
BOOL ELT_is_attr_reader_BOOL(ELT);
BOOL ELT_is_attr_writer_BOOL(ELT);
BOOL ELT_is_const_reader_BOOL(ELT);
BOOL ELT_is_invariant_BOOL(ELT);
BOOL ELT_is_shared_writer_BOO(ELT);
BOOL FILE_error_BOOL(FILE1);
BOOL FLISTIFC_is_empty_BOOL(FLISTIFC);
BOOL FLISTIMPL_INCLUDE_is_emp(FLISTIMPL_INCLUDE);
BOOL FSETAS_FEAT_MOD_test_AS_(FSETAS_FEAT_MOD, AS_FEAT_MOD);
BOOL FSETSTR_test_STR_BOOL(FSETSTR, STR);
BOOL FSETTUPIDENTIDENT_test_T(FSETTUPIDENTIDENT, TUPIDENTIDENT);
BOOL FSETTUPIDENTINT_test_TUP(FSETTUPIDENTINT, TUPIDENTINT);
BOOL GET_OPTIONS_is_filename_(GET_OPTIONS, STR);
BOOL GET_OPTIONS_more_args_BO(GET_OPTIONS);
BOOL IDENT_TBL_elt_eq_IDENT_I(IDENT_TBL, IDENT, IDENT);
BOOL IDENT_TBL_is_elt_nil_IDE(IDENT_TBL, IDENT);
BOOL IDENT_TBL_not_too_many_I(IDENT_TBL, INT, INT);
BOOL IDENT_TBL_query_test_STR(IDENT_TBL, STR, IDENT);
BOOL IDENT_TBL_should_grow_BO(IDENT_TBL);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL IDENT_is_iter_BOOL(IDENT);
BOOL IDENT_is_neq_IDENT_BOOL(IDENT, IDENT);
BOOL IFC_conforms_to_IFC_BOOL(IFC, IFC);
BOOL IMPL_INCLUDE_test_array_(IMPL_INCLUDE);
BOOL IMPL_INCLUDE_test_duplic(IMPL_INCLUDE);
BOOL IMPL_is_atomic_BOOL(IMPL);
BOOL IMPORT_EXPORT_TBL_has_ex(IMPORT_EXPORT_TBL, SIG);
BOOL IMPORT_EXPORT_TBL_has_im(IMPORT_EXPORT_TBL, SIG);
BOOL IMPORT_EXPORT_TBL_is_sys(IMPORT_EXPORT_TBL, SIG);
BOOL IMPORT_EXPORT_TBL_is_sys1(IMPORT_EXPORT_TBL, SIG);
BOOL INLINE_ITER_is_inlineabl(INLINE_ITER, AM_ROUT_DEF, INT);
BOOL INLINE_inlined_SIG_BOOL(INLINE, SIG);
BOOL SIG_conforms_to_SIG_BOOL(SIG, SIG);
BOOL SIG_is_eq_but_tp_SIG_BOO(SIG, SIG);
BOOL SIG_is_iter_BOOL(SIG);
BOOL SIG_is_legal_ext_abs_BOO(SIG);
BOOL SIG_is_legal_ext_bod_BOO(SIG);
BOOL STR_is_eq_STR_BOOL(STR, STR);
BOOL STR_is_neq_STR_BOOL(STR, STR);
BOOL TP_CLASS_is_abstract_BOO(TP_CLASS);
BOOL TP_CLASS_is_eq_dTP_BOOL(TP_CLASS, dTP);
BOOL TP_CONTEXT_type_spec_is_(TP_CONTEXT, AS_TYPE_SPEC);
CHANGE_VARS CHANGE_VARS_create_AM_RO(CHANGE_VARS, AM_ROUT_DEF);
CHAR STR_eltb_CHAR(STR_eltb_CHAR_frame);
ELT ELT_TBL_elt_conflicting_(ELT_TBL, ELT);
ELT ELT_TBL_elt_same_name_as(ELT_TBL, ELT);
ELT ELT_TBL_elt_with_sig_SIG(ELT_TBL, SIG);
ELT ELT_TBL_eltb_ELT(ELT_TBL_eltb_ELT_frame);
ELT ELT_TBL_get_queryb_IDENT(ELT_TBL_get_queryb_IDENT_frame);
ELT ELT_create_SIG_SIG_dAS_C(ELT, SIG, SIG, dAS_CLASS_ELT, TP_CONTEXT, BOOL);
ELT IMPL_CREATE_reader_elt_f(IMPL_CREATE, dAS_CLASS_ELT);
ELT IMPL_CREATE_writer_elt_f(IMPL_CREATE, dAS_CLASS_ELT);
ELT IMPL_INCLUDE_modify_elt_(IMPL_INCLUDE, ELT);
ELT IMPL_elt_with_sig_SIG_EL(IMPL, SIG);
ELT_TBL ELT_TBL_insert_ELT_ELT_T(ELT_TBL, ELT);
ELT_TBL IMPL_CREATE_elt_tbl_ELT_(IMPL_CREATE);
ELT_TBL IMPL_CREATE_explicit_cla(IMPL_CREATE);
ELT_TBL IMPL_INCLUDE_included_el(IMPL_INCLUDE);
ERR1 ERR_create_ERR(ERR1);
ERR1 ERR_plus_dSTR_ERR(ERR1, dSTR);
FILE1 FILE_open_for_read_STR_F(FILE1, STR);
FLISTAM_GLOBAL_EXPR FLISTAM_GLOBAL_EXPR_push(FLISTAM_GLOBAL_EXPR, AM_GLOBAL_EXPR);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_creat(FLISTAM_LOCAL_EXPR, INT);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR, AM_LOCAL_EXPR);
FLISTIFC FLISTIFC_push_IFC_FLISTI(FLISTIFC, IFC);
FLISTIMPL_INCLUDE FLISTIMPL_INCLUDE_push_I(FLISTIMPL_INCLUDE, IMPL_INCLUDE);
FLISTSTR FLISTSTR_create_FLISTSTR(FLISTSTR);
FLISTSTR FLISTSTR_push_STR_FLISTS(FLISTSTR, STR);
FLISTSTR GET_OPTIONS_args_from_en(GET_OPTIONS);
FLISTSTR GET_OPTIONS_args_from_fi(GET_OPTIONS, STR);
FMAPIDENTAM_GLOBAL_EXPR FMAPIDENTAM_GLOBAL_EXPR_15(FMAPIDENTAM_GLOBAL_EXPR, IDENT, AM_GLOBAL_EXPR);
FMAPIDENTAM_GLOBAL_EXPR FMAPdTPFMAPIDENTAM_GLOBA6(FMAPdTPFMAPIDENTAM_GLOBA, dTP);
FMAPSTRSTR FMAPSTRSTR_insert_STR_ST(FMAPSTRSTR, STR, STR);
FMAPdTPFMAPIDENTAM_GLOBA FMAPdTPFMAPIDENTAM_GLOBA16(FMAPdTPFMAPIDENTAM_GLOBA, dTP, FMAPIDENTAM_GLOBAL_EXPR);
FMAPdTPIFC FMAPdTPIFC_insert_dTP_IF(FMAPdTPIFC, dTP, IFC);
FMAPdTPIMPL FMAPdTPIMPL_insert_dTP_I(FMAPdTPIMPL, dTP, IMPL);
FSETAS_FEAT_MOD FSETAS_FEAT_MOD_insert_A(FSETAS_FEAT_MOD, AS_FEAT_MOD);
FSETSTR FSETSTR_insert_STR_FSETS(FSETSTR, STR);
FSETTUPIDENTIDENT FSETTUPIDENTIDENT_create(FSETTUPIDENTIDENT);
FSETTUPIDENTIDENT FSETTUPIDENTIDENT_insert(FSETTUPIDENTIDENT, TUPIDENTIDENT);
FSETTUPIDENTINT FSETTUPIDENTINT_clear_FS(FSETTUPIDENTINT);
FSETTUPIDENTINT FSETTUPIDENTINT_delete_T(FSETTUPIDENTINT, TUPIDENTINT);
FSETTUPIDENTINT FSETTUPIDENTINT_insert_T(FSETTUPIDENTINT, TUPIDENTINT);
FSTR FILE_fstr_FSTR(FILE1);
FSTR FSTR_plus_CHAR_FSTR(FSTR, CHAR);
GLOBAL_TBL GLOBAL_TBL_create_PROG_G(GLOBAL_TBL, PROG);
IDENT ELT_name_IDENT(ELT);
IDENT IDENT_TBL_aeltb_IDENT(IDENT_TBL_aeltb_IDENT_frame);
IDENT IDENT_TBL_aget_INT_IDENT(IDENT_TBL, INT);
IDENT IDENT_TBL_elt_nil_IDENT(IDENT_TBL);
IDENT IDENT_TBL_eltb_IDENT(IDENT_TBL_eltb_IDENT_frame);
IDENT IDENT_TBL_get_query_STR_(IDENT_TBL, STR);
IDENT IDENT_create_STR_IDENT(IDENT, STR);
IDENT_TBL IDENT_TBL_allocate_INT_I(IDENT_TBL, INT);
IDENT_TBL IDENT_TBL_double_size_ID(IDENT_TBL);
IDENT_TBL IDENT_TBL_insert_IDENT_I(IDENT_TBL, IDENT);
IFC ELT_TBL_public_ifc_IFC(ELT_TBL);
IFC FLISTIFC_aget_INT_IFC(FLISTIFC, INT);
IFC FLISTIFC_pop_IFC(FLISTIFC);
IFC FMAPdTPIFC_get_dTP_IFC(FMAPdTPIFC, dTP);
IFC IFC_ABS_CREATE_ifc_of_TP(IFC_ABS_CREATE, TP_CLASS);
IFC IFC_TBL_ifc_of_dTP_IFC(IFC_TBL, dTP);
IFC IFC_create_SIG_TBL_dTP_I(IFC, SIG_TBL, dTP);
IFC IFC_ifc_for_iter_TP_ITER(IFC, TP_ITER);
IFC IFC_ifc_for_rout_TP_ROUT(IFC, TP_ROUT);
IFC_TBL IFC_TBL_create_PROG_IFC_(IFC_TBL, PROG);
IMPL FMAPdTPIMPL_get_dTP_IMPL(FMAPdTPIMPL, dTP);
IMPL IMPL_CREATE_impl_of_TP_C(IMPL_CREATE, TP_CLASS);
IMPL IMPL_INCLUDE_included_im(IMPL_INCLUDE);
IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL, dTP);
IMPL IMPL_create_IMPL(IMPL);
IMPL IMPL_create_for_tp_dTP_I(IMPL, dTP);
IMPL_INCLUDE FLISTIMPL_INCLUDE_eltb_I(FLISTIMPL_INCLUDE_eltb_I_frame);
IMPL_INCLUDE FLISTIMPL_INCLUDE_pop_IM(FLISTIMPL_INCLUDE);
IMPL_INCLUDE IMPL_INCLUDE_create_TP_C(IMPL_INCLUDE, TP_CLASS, AS_INCLUDE_CLAUSE);
IMPL_TBL IMPL_TBL_create_PROG_IMP(IMPL_TBL, PROG);
IMPORT_EXPORT_TBL IMPORT_EXPORT_TBL_create(IMPORT_EXPORT_TBL, PROG);
INLINE INLINE_create_PROG_INLIN(INLINE, PROG);
INLINE_ATTR_READ INLINE_ATTR_READ_create_(INLINE_ATTR_READ, AM_ROUT_DEF);
INLINE_ATTR_WRITE INLINE_ATTR_WRITE_create(INLINE_ATTR_WRITE, AM_ROUT_DEF);
INLINE_GLOBAL_READ INLINE_GLOBAL_READ_creat(INLINE_GLOBAL_READ, AM_ROUT_DEF);
INLINE_INT_FOLD INLINE_INT_FOLD_create_S(INLINE_INT_FOLD, SIG);
INLINE_ITER INLINE_ITER_create_AM_RO(INLINE_ITER, AM_ROUT_DEF);
INLINE_ITER_TBL INLINE_ITER_TBL_create_I(INLINE_ITER_TBL, INT);
INLINE_ITER_TBL INLINE_ITER_TBL_test_and(INLINE_ITER_TBL, AM_ROUT_DEF, BOOL, INT);
INLINE_ROUT_TBL INLINE_ROUT_TBL_create_I(INLINE_ROUT_TBL, INT);
INLINE_ROUT_TBL INLINE_ROUT_TBL_insert_d(INLINE_ROUT_TBL, dINLINE_ROUT_SIG);
INLINE_ROUT_TBL INLINE_ROUT_TBL_test_and(INLINE_ROUT_TBL, AM_ROUT_DEF, BOOL, INT);
INT ARRAYINT_eltb_INT(ARRAYINT_eltb_INT_frame);
INT ARRAYSTR_size_INT(ARRAYSTR);
INT ARRAYdTP_size_INT(ARRAYdTP);
INT AS_FEAT_MOD_size_INT(AS_FEAT_MOD);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTIFC_size_INT(FLISTIFC);
INT FSETAS_FEAT_MOD_size_INT(FSETAS_FEAT_MOD);
INT FSTR_size_INT(FSTR);
INT IDENT_TBL_asize_INT(IDENT_TBL);
INT IDENT_TBL_elt_hash_IDENT(IDENT_TBL, IDENT);
INT IDENT_TBL_query_hash_STR(IDENT_TBL, STR);
INT IDENT_hash_INT(IDENT);
INT IMPL_asize_val_INT(IMPL);
INT INT_downtob_INT_INT(INT_downtob_INT_INT_frame);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT STR_hash_INT(STR);
INT STR_length_INT(STR);
INT STR_search_CHAR_INT(STR, CHAR);
INT STR_size_INT(STR);
INT TP_CLASS_kind_INT(TP_CLASS);
INTI INTI_plus_INTI_INTI(INTI, INTI);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
PROG CALL_SIG_prog_PROG(CALL_SIG);
PROG IFC_ABS_CREATE_prog_PROG(IFC_ABS_CREATE);
PROG IMPL_CREATE_prog_PROG(IMPL_CREATE);
PROG IMPL_INCLUDE_prog_PROG(IMPL_INCLUDE);
PROG IMPL_prog_PROG(IMPL);
SIG IFC_nonconforming_sig_IF(IFC, IFC);
SIG IFC_sig_conforming_to_SI(IFC, SIG);
SIG IFC_sig_for_call_CALL_SI(IFC, CALL_SIG);
SIG IMPL_invariant_sig_SIG(IMPL);
SIG IMPL_sig_for_internal_ca(IMPL, CALL_SIG);
SIG INLINE_ATTR_READ_sig_SIG(INLINE_ATTR_READ);
SIG INLINE_ATTR_WRITE_sig_SI(INLINE_ATTR_WRITE);
SIG INLINE_GLOBAL_READ_sig_S(INLINE_GLOBAL_READ);
SIG INLINE_INT_FOLD_sig_SIG(INLINE_INT_FOLD);
SIG INLINE_ITER_sig_SIG(INLINE_ITER);
SIG SIG_TBL_eltb_SIG(SIG_TBL_eltb_SIG_frame);
SIG SIG_TBL_get_queryb_IDENT(SIG_TBL_get_queryb_IDENT_frame);
SIG SIG_TBL_sig_conflicting_(SIG_TBL, SIG);
SIG SIG_attr_reader_sig_AS_A(SIG, AS_ATTR_DEF, IDENT, TP_CONTEXT);
SIG SIG_attr_writer_sig_AS_A(SIG, AS_ATTR_DEF, IDENT, TP_CONTEXT);
SIG SIG_bound_iter_call_TP_I(SIG, TP_ITER);
SIG SIG_bound_routine_call_T(SIG, TP_ROUT);
SIG SIG_const_reader_sig_AS_(SIG, AS_CONST_DEF, IDENT, TP_CONTEXT);
SIG SIG_create_dTP_IDENT_ARR(SIG, dTP, IDENT, ARRAYdTP, dTP);
SIG SIG_rout_sig_AS_ROUT_DEF(SIG, AS_ROUT_DEF, IDENT, TP_CONTEXT);
SIG SIG_shared_reader_sig_AS(SIG, AS_SHARED_DEF, IDENT, TP_CONTEXT);
SIG SIG_shared_writer_sig_AS(SIG, AS_SHARED_DEF, IDENT, TP_CONTEXT);
SIG SIG_with_new_type_dTP_SI(SIG, dTP);
SIG_TBL IFC_ABS_CREATE_do_sigs_S(IFC_ABS_CREATE);
SIG_TBL SIG_TBL_insert_SIG_SIG_T(SIG_TBL, SIG);
STR ARRAYSTR_aget_INT_STR(ARRAYSTR, INT);
STR CALL_SIG_str_STR(CALL_SIG);
STR FILE_resolve_path_STR_ST(FILE1, STR);
STR FSETSTR_eltb_STR(FSETSTR_eltb_STR_frame);
STR GET_OPTIONS_directory_ST(GET_OPTIONS, STR);
STR GET_OPTIONS_mention_STR_(GET_OPTIONS, STR, STR, STR);
STR GET_OPTIONS_next_arg_STR(GET_OPTIONS);
STR GET_OPTIONS_str_STR(GET_OPTIONS);
STR GET_OPTIONS_suffix_STR_S(GET_OPTIONS, STR);
STR IDENT_next_tmp_STR_STR(IDENT, STR);
STR IFC_TBL_tup_str_TUPIDENT(IFC_TBL, TUPIDENTINT);
STR IMPL_TBL_tup_str_TUPIDEN(IMPL_TBL, TUPIDENTINT);
STR INT_str_STR(INT);
STR STR_create_STR(STR);
STR STR_head_INT_STR(STR, INT);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_separateb_STR_STR(STR_separateb_STR_STR_frame);
STR STR_tail_INT_STR(STR, INT);
STR SYSTEM_LEX_get_str_STR(SYSTEM_LEX);
STR TP_CLASS_str_STR(TP_CLASS);
STR TP_ITER_str_STR(TP_ITER);
STR TP_ROUT_str_STR(TP_ROUT);
STR UNIX_get_env_STR_STR(UNIX, STR);
SYSTEM_LEX SYSTEM_LEX_create_STR_SY(SYSTEM_LEX, STR);
TP_CLASS IMPL_CREATE_get_arr_TP_C(IMPL_CREATE);
TP_CLASS IMPL_INCLUDE_included_tp(IMPL_INCLUDE);
TP_CONTEXT TP_CLASS_tp_context_for_(TP_CLASS);
TP_CONTEXT TP_CONTEXT_create_TP_CLA(TP_CONTEXT, TP_CLASS, ARRAYIDENT, ARRAYdTP, PROG);
TUPIDENTIDENT TUPIDENTIDENT_create_IDE(TUPIDENTIDENT, IDENT, IDENT);
TUPIDENTINT FSETTUPIDENTINT_eltb_TUP(FSETTUPIDENTINT_eltb_TUP_frame);
TUPIDENTINT TUPIDENTINT_create_IDENT(TUPIDENTINT, IDENT, INT);
WEIGH_CODE WEIGH_CODE_create_INT_WE(WEIGH_CODE, INT);
XFORM_CODE XFORM_CODE_create_FMAPAM(XFORM_CODE, FMAPAM_LOCAL_EXPRAM_LOCA);
dAM_EXPR AM_ITER_CALL_EXPR_aget_I(AM_ITER_CALL_EXPR, INT);
dAM_EXPR AM_ROUT_CALL_EXPR_aget_I(AM_ROUT_CALL_EXPR, INT);
dAM_EXPR INLINE_ARR_READ_inline_A(INLINE_ARR_READ, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_ARR_WRITE_inline_(INLINE_ARR_WRITE, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_ATTR_READ_inline_(INLINE_ATTR_READ, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_ATTR_WRITE_inline2(INLINE_ATTR_WRITE, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_BUILTIN_inline_AM(INLINE_BUILTIN, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_GLOBAL_READ_inlin2(INLINE_GLOBAL_READ, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_INT_FOLD_inline_A(INLINE_INT_FOLD, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_ITER_inline_AM_IT(INLINE_ITER, AM_ITER_CALL_EXPR);
dAM_EXPR INLINE_inline_AM_ITER_CA(INLINE, AM_ITER_CALL_EXPR);
dAM_EXPR INLINE_inline_AM_ROUT_CA(INLINE, AM_ROUT_CALL_EXPR);
dAM_EXPR XFORM_CODE_xform_expr_dA(XFORM_CODE, dAM_EXPR);
dAM_STMT XFORM_CODE_xform_stmt_li(XFORM_CODE, dAM_STMT);
dINLINE_ITER_SIG INLINE_ITER_TBL_get_quer(INLINE_ITER_TBL, SIG);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_get_quer(INLINE_ROUT_TBL, SIG);
dTP ARRAYdTP_aget_INT_dTP(ARRAYdTP, INT);
dTP TP_CONTEXT_tp_of_AS_TYPE(TP_CONTEXT, AS_TYPE_SPEC);
extern const int dAM_EXPR_source_SFILE_ID_offset;

extern const SFILE_ID (*dAM_EXPR_source_SFILE_ID[])(dAM_EXPR);
extern const int dAM_STMT_append_dAM_STMT_offset;

extern const  (*dAM_STMT_append_dAM_STMT[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT1_offset;

extern const  (*dAM_STMT_next_dAM_STMT1[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT_offset;

extern const dAM_STMT (*dAM_STMT_next_dAM_STMT[])(dAM_STMT);
extern const int dAS_CLASS_ELT_is_private_offset;

extern const BOOL (*dAS_CLASS_ELT_is_private[])(dAS_CLASS_ELT);
extern const int dAS_CLASS_ELT_next_dAS_C_offset;

extern const dAS_CLASS_ELT (*dAS_CLASS_ELT_next_dAS_C[])(dAS_CLASS_ELT);
extern const int dBACK_END_is_built_in_SI_offset;

extern const BOOL (*dBACK_END_is_built_in_SI[])(dBACK_END, SIG);
extern const int dINLINE_ITER_SIG_inline__offset;

extern const dAM_EXPR (*dINLINE_ITER_SIG_inline_[])(dINLINE_ITER_SIG, AM_ITER_CALL_EXPR);
extern const int dINLINE_ROUT_SIG_inline__offset;

extern const dAM_EXPR (*dINLINE_ROUT_SIG_inline_[])(dINLINE_ROUT_SIG, AM_ROUT_CALL_EXPR);
extern const int dPARSE_tree_for_IDENT_IN_offset;

extern const AS_CLASS_DEF (*dPARSE_tree_for_IDENT_IN[])(dPARSE, IDENT, INT);
extern const int dTP_is_atomic_BOOL_offset;

extern const BOOL (*dTP_is_atomic_BOOL[])(dTP);
extern const int dTP_is_eq_dTP_BOOL_offset;

extern const BOOL (*dTP_is_eq_dTP_BOOL[])(dTP, dTP);
extern const int dTP_is_value_BOOL_offset;

extern const BOOL (*dTP_is_value_BOOL[])(dTP);
extern const int dTP_prog_PROG_offset;

extern const PROG (*dTP_prog_PROG[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void AM_ASSIGN_STMT_append_dA(AM_ASSIGN_STMT, dAM_STMT);
void AM_ROUT_CALL_EXPR_aset_I(AM_ROUT_CALL_EXPR, INT, dAM_EXPR);
void CHANGE_VARS_after_one_us(CHANGE_VARS);
void CHANGE_VARS_after_saving(CHANGE_VARS);
void CHANGE_VARS_new_copy_SFI(CHANGE_VARS, SFILE_ID);
void ERR_plus_dSTR(ERR1, dSTR);
void FILE_close(FILE1);
void GET_OPTIONS_barf_STR(GET_OPTIONS, STR);
void GET_OPTIONS_get_files(GET_OPTIONS);
void GET_OPTIONS_handle_files(GET_OPTIONS, STR);
void GET_OPTIONS_handle_other(GET_OPTIONS, STR, STR);
void GET_OPTIONS_handle_other1(GET_OPTIONS, STR);
void GET_OPTIONS_insert_here_(GET_OPTIONS, FLISTSTR);
void GET_OPTIONS_interpret_AR(GET_OPTIONS, ARRAYSTR);
void GET_OPTIONS_other_initia(GET_OPTIONS);
void GET_OPTIONS_rewind(GET_OPTIONS);
void GET_OPTIONS_usage(GET_OPTIONS);
void GLOBAL_TBL_insert_AM_GLO(GLOBAL_TBL, AM_GLOBAL_EXPR);
void IDENT_BUILTIN_AREF_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_ARRAY_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_ARR_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_AVAL_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_FLTDX_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_FLTD_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_FLTX_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_FLT_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_GATE_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_INTI_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_INT_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_SYS_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_aget_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_aset_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_asize_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_bang_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_call_bang_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_call_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_create_ide(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_div_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_dollar_OB_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_init(IDENT_BUILTIN);
void IDENT_BUILTIN_invariant_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_eq_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_geq_ide(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_gt_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_leq_ide(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_lt_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_is_neq_ide(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_main_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_minus_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_mod_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_negate_ide(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_not_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_ob_eq_iden(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_plus_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_pow_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_ret_ident_(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_self_ident(IDENT_BUILTIN, IDENT);
void IDENT_BUILTIN_times_iden(IDENT_BUILTIN, IDENT);
void IDENT_TBL_aset_INT_IDENT(IDENT_TBL, INT, IDENT);
void IDENT_TBL_asetb_IDENT(IDENT_TBL_asetb_IDENT_frame);
void IDENT_ident_tbl_IDENT_TB(IDENT, IDENT_TBL);
void IDENT_tmp_count_INT(IDENT, INT);
void IFC_ABS_CREATE_do_explic(IFC_ABS_CREATE);
void IFC_ABS_CREATE_do_supers(IFC_ABS_CREATE);
void IFC_TBL_cycle_err(IFC_TBL);
void IFC_show(IFC);
void IMPL_CREATE_array_confli(IMPL_CREATE, IMPL_INCLUDE, TP_CLASS, TP_CLASS);
void IMPL_CREATE_attr_conflic(IMPL_CREATE, ELT, ELT, IMPL_INCLUDE);
void IMPL_CREATE_do_incs(IMPL_CREATE);
void IMPL_CREATE_ext_conflict(IMPL_CREATE, ELT, ELT);
void IMPL_CREATE_include_conf(IMPL_CREATE, IMPL_INCLUDE, IMPL_INCLUDE, ELT, ELT);
void IMPL_CREATE_reader_confl(IMPL_CREATE, ELT, ELT);
void IMPL_CREATE_writer_confl(IMPL_CREATE, ELT, ELT);
void IMPL_INCLUDE_include_bou(IMPL_INCLUDE, dAS_CLASS_ELT);
void IMPL_INCLUDE_include_con(IMPL_INCLUDE, ELT, ELT);
void IMPL_INCLUDE_include_ext(IMPL_INCLUDE, dAS_CLASS_ELT);
void IMPL_INCLUDE_param_inclu(IMPL_INCLUDE, dAS_CLASS_ELT);
void IMPL_INCLUDE_unused_mod_(IMPL_INCLUDE, AS_FEAT_MOD);
void IMPL_TBL_cycle_err(IMPL_TBL);
void IMPL_TBL_err_STR(IMPL_TBL, STR);
void IMPORT_EXPORT_TBL_err_ST(IMPORT_EXPORT_TBL, STR);
void INLINE_ATTR_READ_inlined(INLINE_ATTR_READ, INT);
void INLINE_ATTR_READ_routine(INLINE_ATTR_READ, INT);
void INLINE_ATTR_WRITE_inline(INLINE_ATTR_WRITE, INT);
void INLINE_ATTR_WRITE_routin(INLINE_ATTR_WRITE, INT);
void INLINE_GLOBAL_READ_inlin(INLINE_GLOBAL_READ, INT);
void INLINE_GLOBAL_READ_routi(INLINE_GLOBAL_READ, INT);
void INLINE_INT_FOLD_inlined_(INLINE_INT_FOLD, INT);
void INLINE_INT_FOLD_routines(INLINE_INT_FOLD, INT);
void INLINE_ITER_copy_iter_AM(INLINE_ITER, AM_ROUT_DEF);
void INLINE_ITER_inlined_INT(INLINE_ITER, INT);
void INLINE_ITER_iters_INT(INLINE_ITER, INT);
void INLINE_consider_AM_ROUT_(INLINE, AM_ROUT_DEF);
void INT_timesb(INT_timesb_frame);
void OUT_plus_dSTR(OUT, dSTR);
void PROG_barf_STR(PROG, STR);
void PROG_err_STR(PROG, STR);
void PROG_err_loc_dPROG_ERR(PROG, dPROG_ERR);
void UNIX_exit_INT(UNIX, INT);
void WEIGH_CODE_calc_expr_wei(WEIGH_CODE, dAM_EXPR);
void WEIGH_CODE_calc_stmt_lis(WEIGH_CODE, dAM_STMT);
void WEIGH_CODE_clear_badstmt(WEIGH_CODE);
void WEIGH_CODE_uplevel(WEIGH_CODE);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




AM_GLOBAL_EXPR GLOBAL_TBL_get_IDENT_dTP(GLOBAL_TBL self, IDENT name11, dTP tp) {
 AM_GLOBAL_EXPR ret_val;
 FMAPIDENTAM_GLOBAL_EXPR m;
 BOOL L1;
 m = FMAPdTPFMAPIDENTAM_GLOBA6(ATTR(self,tbl), tp);
 L1 = (m==((FMAPIDENTAM_GLOBAL_EXPR) NULL));
 if ((!(L1))) {
  ret_val = FMAPIDENTAM_GLOBAL_EXPR_5(m, name11);
  return ret_val;
 }
 ret_val = ((AM_GLOBAL_EXPR) NULL);
 return ret_val;
}


AS_FEAT_MOD IMPL_INCLUDE_modifier_fo(IMPL_INCLUDE self, IDENT i) {
 AS_FEAT_MOD ret_val;
 AS_FEAT_MOD e;
 e = ATTR(ATTR(self,as1),mods);
 while (1) {
  if ((e==((AS_FEAT_MOD) NULL))) {
   goto after_loop;
  }
  if (IDENT_is_eq_IDENT_BOOL(ATTR(e,name1), i)) {
   SATTR(self,used_mods,FSETAS_FEAT_MOD_insert_A(ATTR(self,used_mods), e));
   ret_val = e;
   return ret_val;
  }
  e = ATTR(e,next);
 }
 after_loop: ;
 ret_val = ((AS_FEAT_MOD) NULL);
 return ret_val;
}


BOOL GET_OPTIONS_is_filename_(GET_OPTIONS self, STR fn) {
 BOOL ret_val = ((BOOL) 0);
 CHAR L1;
 CHAR L2;
 INT L3;
 L1 = (STRAGET(fn,0));
 if ((L1=='-')) {
  ret_val = FALSE;
  return ret_val;
 }
 L2 = (STRAGET(fn,0));
 if ((L2=='/')) {
  ret_val = TRUE;
  return ret_val;
 }
 L3 = STR_search_CHAR_INT(fn, '.');
 ret_val = (L3!=-1);
 return ret_val;
}


BOOL IDENT_TBL_elt_eq_IDENT_I(IDENT_TBL self, IDENT e1, IDENT e2) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = IDENT_is_eq_IDENT_BOOL(e1, e2);
 return ret_val;
}


BOOL IDENT_TBL_is_elt_nil_IDE(IDENT_TBL self, IDENT e) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (e.str==(STR)0);
 return ret_val;
}


BOOL IDENT_TBL_not_too_many_I(IDENT_TBL self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 IDENT t = IDENT_zero;
 INT L1;
 ERR1 L2;
 extern STR Foundaproblemexcessiveco;
 ERR1 L3;
 INT L4;
 ERR1 L5;
 extern STR possiblyduetoabadhashfun;
 ERR1 L6;
 IDENT L7;
 OB L8;
 INT L9;
 ERR1 L10;
 extern STR name3;
 L1 = (INTPLUS(start1,50));
 if ((finish>L1)) {
  L2 = ERR_create_ERR(((ERR1) NULL));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L4 = (SYSTP(((OB) self)));
  L5 = ERR_plus_dSTR_ERR(L3, ((dSTR) (SYSSTRFORTP(L4))));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &possiblyduetoabadhashfun)));
  L7 = IDENT_TBL_aget_INT_IDENT(self, start1);
  L8 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
  ((IDENT_boxed) L8)->value_part = L7;
  L9 = (SYSTP(L8));
  L10 = ERR_plus_dSTR_ERR(L6, ((dSTR) (SYSSTRFORTP(L9))));
  ERR_plus_dSTR(L10, ((dSTR) ((STR) &name3)));
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL IDENT_TBL_query_test_STR(IDENT_TBL self, STR s, IDENT i) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = STR_is_eq_STR_BOOL(s, i.str);
 return ret_val;
}


BOOL IDENT_TBL_should_grow_BO(IDENT_TBL self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = IDENT_TBL_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL IDENT_is_iter_BOOL(IDENT self) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 BOOL L2;
 STR L3;
 INT L4;
 INT L5;
 CHAR L6;
 L2 = (self.str==((STR) NULL));
 if ((!(L2))) {
  L3 = self.str;
  L4 = STR_size_INT(self.str);
  L5 = (INTMINUS(L4,1));
  L6 = (STRAGET(L3,L5));
  L1 = (L6=='!');
 } else {
  L1 = FALSE;
 }
 ret_val = L1;
 return ret_val;
}


BOOL IDENT_is_neq_IDENT_BOOL(IDENT self, IDENT i) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 L1 = (self.str==i.str);
 ret_val = (!(L1));
 return ret_val;
}


BOOL IFC_conforms_to_IFC_BOOL(IFC self, IFC i) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (IFC_nonconforming_sig_IF(self, i)==((SIG) NULL));
 return ret_val;
}


BOOL IMPL_INCLUDE_test_array_(IMPL_INCLUDE self) {
 BOOL ret_val = ((BOOL) 0);
 INT k = ((INT) 0);
 BOOL L1;
 INT L2;
 PROG L3;
 PROG L4;
 extern STR Thevaluetype;
 STR L5;
 extern STR maynothaveanincludepatht;
 STR L6;
 STR L7;
 dSTR L8;
 BOOL L9;
 BOOL L10;
 INT L11;
 INT L12;
 PROG L13;
 PROG L14;
 extern STR Thereferencetype;
 STR L15;
 extern STR maynothaveanincludepatht1;
 STR L16;
 STR L17;
 dSTR L18;
 k = TP_CLASS_kind_INT(ATTR(self,tp1));
 if ((ATTR(ATTR(self,impl),arr1)==((TP_CLASS) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L2 = TP_KIND_val_tp;
 if ((k==L2)) {
  L1 = IDENT_is_eq_IDENT_BOOL(ATTR(ATTR(ATTR(self,impl),arr1),name1), IDENT_BUILTIN_AREF_ident1);
 } else {
  L1 = FALSE;
 }
 if (L1) {
  L3 = IMPL_INCLUDE_prog_PROG(self);
  PROG_err_loc_dPROG_ERR(L3, ((dPROG_ERR) ATTR(self,as1)));
  L4 = IMPL_INCLUDE_prog_PROG(self);
  L5 = STR_plus_dSTR_STR(((STR) &Thevaluetype), ((dSTR) TP_CLASS_str_STR(ATTR(self,tp1))));
  L6 = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &maynothaveanincludepatht)));
  L7 = STR_plus_dSTR_STR(L6, ((dSTR) TP_CLASS_str_STR(ATTR(ATTR(self,impl),arr1))));
  L8 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L8)->value_part = '.';
  PROG_err_STR(L4, STR_plus_dSTR_STR(L7, L8));
  ret_val = TRUE;
  return ret_val;
 }
 else {
  L11 = TP_KIND_ref_tp;
  if ((k==L11)) {
   L10 = TRUE;
  } else {
   L12 = TP_KIND_spr_tp;
   L10 = (k==L12);
  }
  if (L10) {
   L9 = IDENT_is_eq_IDENT_BOOL(ATTR(ATTR(ATTR(self,impl),arr1),name1), IDENT_BUILTIN_AVAL_ident1);
  } else {
   L9 = FALSE;
  }
  if (L9) {
   L13 = IMPL_INCLUDE_prog_PROG(self);
   PROG_err_loc_dPROG_ERR(L13, ((dPROG_ERR) ATTR(self,as1)));
   L14 = IMPL_INCLUDE_prog_PROG(self);
   L15 = STR_plus_dSTR_STR(((STR) &Thereferencetype), ((dSTR) TP_CLASS_str_STR(ATTR(self,tp1))));
   L16 = STR_plus_dSTR_STR(L15, ((dSTR) ((STR) &maynothaveanincludepatht1)));
   L17 = STR_plus_dSTR_STR(L16, ((dSTR) TP_CLASS_str_STR(ATTR(ATTR(self,impl),arr1))));
   L18 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L18)->value_part = '.';
   PROG_err_STR(L14, STR_plus_dSTR_STR(L17, L18));
   ret_val = TRUE;
   return ret_val;
  }
 }
 ret_val = FALSE;
 return ret_val;
}


BOOL IMPL_INCLUDE_test_duplic(IMPL_INCLUDE self) {
 BOOL ret_val = ((BOOL) 0);
 AS_FEAT_MOD m1;
 AS_FEAT_MOD m2;
 BOOL L1;
 BOOL L2;
 PROG L3;
 PROG L4;
 extern STR Therearetwofeaturemodifi;
 STR L5;
 extern STR name5;
 m1 = ATTR(ATTR(self,as1),mods);
 while (1) {
  if ((m1==((AS_FEAT_MOD) NULL))) {
   goto after_loop;
  }
  m2 = ATTR(ATTR(self,as1),mods);
  while (1) {
   if ((m2==((AS_FEAT_MOD) NULL))) {
    goto after_loop1;
   }
   L2 = (m1==m2);
   if ((!(L2))) {
    L1 = IDENT_is_eq_IDENT_BOOL(ATTR(m1,name1), ATTR(m2,name1));
   } else {
    L1 = FALSE;
   }
   if (L1) {
    L3 = IMPL_INCLUDE_prog_PROG(self);
    PROG_err_loc_dPROG_ERR(L3, ((dPROG_ERR) m1));
    L4 = IMPL_INCLUDE_prog_PROG(self);
    L5 = STR_plus_dSTR_STR(((STR) &Therearetwofeaturemodifi), ((dSTR) ATTR(m1,name1).str));
    PROG_err_STR(L4, STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name5))));
    ret_val = TRUE;
    return ret_val;
   }
   m2 = ATTR(m2,next);
  }
  after_loop1: ;
  m1 = ATTR(m1,next);
 }
 after_loop: ;
 ret_val = FALSE;
 return ret_val;
}


BOOL IMPL_is_atomic_BOOL(IMPL self) {
 BOOL ret_val = ((BOOL) 0);
 ELT_TBL L11;
 ELT e;
 dTP atp;
 dTP tparam;
 ELT L2;
 dTP L3;
 BOOL L4;
 dTP L5;
 BOOL L6;
 INT L7;
 dTP L8;
 BOOL L9;
 dTP L10;
 BOOL L12;
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,elts);
    noname1->self = L11;
   }
   L2 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
   if (ELT_is_attr_reader_BOOL(e)) {
    atp = ATTR(ATTR(e,sig11),ret1);
    L3 = atp;
    if (L3==NULL) {
     FATAL("Dispatch on void in IMPL::is_atomic:BOOL");
    }
    L4 = (*dTP_is_value_BOOL[TAG(L3)+dTP_is_value_BOOL_offset])(L3);
    if ((!(L4))) {
     ret_val = FALSE;
     return ret_val;
    }
    L5 = atp;
    if (L5==NULL) {
     FATAL("Dispatch on void in IMPL::is_atomic:BOOL");
    }
    L6 = (*dTP_is_atomic_BOOL[TAG(L5)+dTP_is_atomic_BOOL_offset])(L5);
    if ((!(L6))) {
     ret_val = FALSE;
     return ret_val;
    }
   }
  }
 }
 after_loop: ;
 if ((ATTR(self,arr1)==((TP_CLASS) NULL))) {
  ret_val = TRUE;
  return ret_val;
 }
 else {
  if ((ATTR(ATTR(self,arr1),params)==((ARRAYdTP) NULL))) {
   ret_val = FALSE;
   return ret_val;
  }
  else {
   L7 = (ASIZE(ATTR(ATTR(self,arr1),params)));
   if ((L7!=1)) {
    ret_val = FALSE;
    return ret_val;
   }
   else {
    tparam = ARRAYdTP_aget_INT_dTP(ATTR(ATTR(self,arr1),params), 0);
    L8 = tparam;
    if (L8==NULL) {
     FATAL("Dispatch on void in IMPL::is_atomic:BOOL");
    }
    L9 = (*dTP_is_value_BOOL[TAG(L8)+dTP_is_value_BOOL_offset])(L8);
    if ((!(L9))) {
     ret_val = FALSE;
     return ret_val;
    }
    else {
     L10 = tparam;
     if (L10==NULL) {
      FATAL("Dispatch on void in IMPL::is_atomic:BOOL");
     }
     L12 = (*dTP_is_atomic_BOOL[TAG(L10)+dTP_is_atomic_BOOL_offset])(L10);
     if ((!(L12))) {
      ret_val = FALSE;
      return ret_val;
     }
     else {
      ret_val = TRUE;
      return ret_val;
     }
    }
   }
  }
 }
 FATAL("Last statement wasn't return");
}


BOOL IMPORT_EXPORT_TBL_has_ex(IMPORT_EXPORT_TBL self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 dTP tp;
 extern STR CompilerErrorIMP_EXP_TBL2;
 FSETTUPIDENTIDENT L1;
 if ((ATTR(self,exports)==((FSETTUPIDENTIDENT) NULL))) {
  IMPORT_EXPORT_TBL_err_ST(self, ((STR) &CompilerErrorIMP_EXP_TBL2));
  ret_val = FALSE;
  return ret_val;
 }
 tp = ATTR(s,tp);
 if (tp==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(tp)) {
  case TP_CLASS_tag:
   L1 = ATTR(self,exports);
   ret_val = FSETTUPIDENTIDENT_test_T(L1, TUPIDENTIDENT_create_IDE(TUPIDENTIDENT_zero, ATTR(((TP_CLASS) tp),name1), ATTR(s,name1)));
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL IMPORT_EXPORT_TBL_has_im(IMPORT_EXPORT_TBL self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 dTP tp;
 extern STR CompilerErrorIMP_EXP_TBL;
 FSETTUPIDENTIDENT L1;
 if ((ATTR(self,imports)==((FSETTUPIDENTIDENT) NULL))) {
  IMPORT_EXPORT_TBL_err_ST(self, ((STR) &CompilerErrorIMP_EXP_TBL));
  ret_val = FALSE;
  return ret_val;
 }
 tp = ATTR(s,tp);
 if (tp==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(tp)) {
  case TP_CLASS_tag:
   L1 = ATTR(self,imports);
   ret_val = FSETTUPIDENTIDENT_test_T(L1, TUPIDENTIDENT_create_IDE(TUPIDENTIDENT_zero, ATTR(((TP_CLASS) tp),name1), ATTR(s,name1)));
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL IMPORT_EXPORT_TBL_is_sys(IMPORT_EXPORT_TBL self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 dTP tp;
 extern STR CompilerErrorIMP_EXP_TBL1;
 BOOL L1;
 IDENT L2;
 extern STR SYS1;
 IDENT L3;
 extern STR import;
 if ((ATTR(self,imports)==((FSETTUPIDENTIDENT) NULL))) {
  IMPORT_EXPORT_TBL_err_ST(self, ((STR) &CompilerErrorIMP_EXP_TBL1));
  ret_val = FALSE;
  return ret_val;
 }
 tp = ATTR(s,tp);
 if (tp==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(tp)) {
  case TP_CLASS_tag:
   L2 = ATTR(((TP_CLASS) tp),name1);
   if (IDENT_is_eq_IDENT_BOOL(L2, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &SYS1)))) {
    L3 = ATTR(s,name1);
    L1 = IDENT_is_eq_IDENT_BOOL(L3, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &import)));
   } else {
    L1 = FALSE;
   }
   ret_val = L1;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL IMPORT_EXPORT_TBL_is_sys1(IMPORT_EXPORT_TBL self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 dTP tp;
 extern STR CompilerErrorIMP_EXP_TBL3;
 BOOL L1;
 IDENT L2;
 extern STR SYS1;
 IDENT L3;
 extern STR export1;
 if ((ATTR(self,exports)==((FSETTUPIDENTIDENT) NULL))) {
  IMPORT_EXPORT_TBL_err_ST(self, ((STR) &CompilerErrorIMP_EXP_TBL3));
  ret_val = FALSE;
  return ret_val;
 }
 tp = ATTR(s,tp);
 if (tp==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(tp)) {
  case TP_CLASS_tag:
   L2 = ATTR(((TP_CLASS) tp),name1);
   if (IDENT_is_eq_IDENT_BOOL(L2, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &SYS1)))) {
    L3 = ATTR(s,name1);
    L1 = IDENT_is_eq_IDENT_BOOL(L3, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &export1)));
   } else {
    L1 = FALSE;
   }
   ret_val = L1;
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL INLINE_ITER_is_inlineabl(INLINE_ITER self, AM_ROUT_DEF rout, INT threshold1) {
 BOOL ret_val = ((BOOL) 0);
 WEIGH_CODE sb;
 AM_LOOP_STMT loopstmt = ((AM_LOOP_STMT) NULL);
 dAM_STMT badstmt;
 AM_YIELD_STMT yieldstmt = ((AM_YIELD_STMT) NULL);
 INT L1;
 BOOL L2;
 INT L3;
 BOOL L4;
 INT L5;
 BOOL L6;
 INT L7;
 BOOL L8;
 INT L9;
 BOOL L10;
 BOOL L11;
 INT L12;
 BOOL L13;
 BOOL L14;
 INT L15;
 INT L16;
 BOOL L17;
 BOOL L18;
 INT L19;
 BOOL L20;
 BOOL L21;
 INT L22;
 BOOL L23;
 sb = WEIGH_CODE_create_INT_WE(((WEIGH_CODE) NULL), threshold1);
 WEIGH_CODE_calc_stmt_lis(sb, ATTR(rout,code11));
 L1 = ATTR(sb,weight);
 if ((L1>threshold1)) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 badstmt = ATTR(sb,badstmt);
 WEIGH_CODE_clear_badstmt(sb);
 if (badstmt==NULL) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(badstmt)) {
  case AM_LOOP_STMT_tag:
   L3 = ATTR(sb,level1);
   if ((L3!=1)) {
    L2 = TRUE;
   } else {
    L4 = ATTR(((AM_LOOP_STMT) badstmt),has_yield);
    L2 = (!(L4));
   }
   if (L2) {
    SYSDESTROY(((OB) sb));
    ret_val = FALSE;
    return ret_val;
   }
   else {
    loopstmt = ((AM_LOOP_STMT) badstmt);
   } break;
  default: ;
   SYSDESTROY(((OB) sb));
   ret_val = FALSE;
   return ret_val;
 }
 WEIGH_CODE_calc_stmt_lis(sb, ATTR(loopstmt,body));
 L5 = ATTR(sb,weight);
 if ((L5>threshold1)) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 badstmt = ATTR(sb,badstmt);
 WEIGH_CODE_clear_badstmt(sb);
 if (badstmt==NULL) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(badstmt)) {
  case AM_YIELD_STMT_tag:
   L7 = ATTR(sb,level1);
   if ((L7==2)) {
    L6 = TRUE;
   } else {
    L9 = ATTR(sb,level1);
    if ((L9==3)) {
     L10 = (ATTR(sb,enclosing_if)==((AM_IF_STMT) NULL));
     L8 = (!(L10));
    } else {
     L8 = FALSE;
    }
    L6 = L8;
   }
   L11 = L6;
   if ((!(L11))) {
    SYSDESTROY(((OB) sb));
    ret_val = FALSE;
    return ret_val;
   }
   else {
    yieldstmt = ((AM_YIELD_STMT) badstmt);
   } break;
  default: ;
   SYSDESTROY(((OB) sb));
   ret_val = FALSE;
   return ret_val;
 }
 WEIGH_CODE_calc_expr_wei(sb, ATTR(yieldstmt,val11));
 L12 = ATTR(sb,weight);
 if ((L12>threshold1)) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 WEIGH_CODE_calc_stmt_lis(sb, ATTR(yieldstmt,next1));
 L14 = (ATTR(sb,badstmt)==((dAM_STMT) NULL));
 if ((!(L14))) {
  L13 = TRUE;
 } else {
  L15 = ATTR(sb,weight);
  L13 = (L15>threshold1);
 }
 if (L13) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 WEIGH_CODE_uplevel(sb);
 L16 = ATTR(sb,level1);
 if ((L16==2)) {
  if (ATTR(sb,true_branch)) {
   WEIGH_CODE_calc_stmt_lis(sb, ATTR(ATTR(sb,enclosing_if),if_false));
  }
  else {
   WEIGH_CODE_calc_stmt_lis(sb, ATTR(ATTR(sb,enclosing_if),if_true));
  }
  L18 = (ATTR(sb,badstmt)==((dAM_STMT) NULL));
  if ((!(L18))) {
   L17 = TRUE;
  } else {
   L19 = ATTR(sb,weight);
   L17 = (L19>threshold1);
  }
  if (L17) {
   SYSDESTROY(((OB) sb));
   ret_val = FALSE;
   return ret_val;
  }
  WEIGH_CODE_calc_stmt_lis(sb, ATTR(ATTR(sb,enclosing_if),next1));
  L21 = (ATTR(sb,badstmt)==((dAM_STMT) NULL));
  if ((!(L21))) {
   L20 = TRUE;
  } else {
   L22 = ATTR(sb,weight);
   L20 = (L22>threshold1);
  }
  if (L20) {
   SYSDESTROY(((OB) sb));
   ret_val = FALSE;
   return ret_val;
  }
  WEIGH_CODE_uplevel(sb);
 }
 L23 = (ATTR(loopstmt,next1)==((dAM_STMT) NULL));
 if ((!(L23))) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 WEIGH_CODE_uplevel(sb);
 SYSDESTROY(((OB) sb));
 ret_val = TRUE;
 return ret_val;
}


BOOL INLINE_inlined_SIG_BOOL(INLINE self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 dINLINE_ITER_SIG inl;
 dINLINE_ROUT_SIG inl1;
 BOOL L1;
 BOOL L2;
 if (SIG_is_iter_BOOL(s)) {
  inl = INLINE_ITER_TBL_get_quer(ATTR(self,itbl), s);
  L1 = (inl==((dINLINE_ITER_SIG) NULL));
  ret_val = (!(L1));
  return ret_val;
 }
 else {
  inl1 = INLINE_ROUT_TBL_get_quer(ATTR(self,rtbl), s);
  L2 = (inl1==((dINLINE_ROUT_SIG) NULL));
  ret_val = (!(L2));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


ELT IMPL_CREATE_reader_elt_f(IMPL_CREATE self, dAS_CLASS_ELT t) {
 ELT ret_val;
 SIG sig1 = ((SIG) NULL);
 ELT r = ((ELT) NULL);
 PROG L1;
 PROG L2;
 extern STR Externalclassesmaynotdef;
 PROG L3;
 PROG L4;
 extern STR Externalclassesmaynotdef1;
 PROG L5;
 PROG L6;
 extern STR Externalclassesmaynotdef2;
 BOOL L7;
 PROG L8;
 PROG L9;
 extern STR Onlyexternalclassesmayha;
 BOOL L10;
 TP_CONTEXT L11;
 dAS_CLASS_ELT L12;
 if (t==NULL) {
  ret_val = ((ELT) NULL);
  return ret_val;
 } else
 switch (TAG(t)) {
  case AS_CONST_DEF_tag:
   if (ATTR(self,is_external)) {
    L1 = IMPL_CREATE_prog_PROG(self);
    PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) t));
    L2 = IMPL_CREATE_prog_PROG(self);
    PROG_err_STR(L2, ((STR) &Externalclassesmaynotdef));
    ret_val = ((ELT) NULL);
    return ret_val;
   }
   sig1 = SIG_const_reader_sig_AS_(((SIG) NULL), ((AS_CONST_DEF) t), ATTR(((AS_CONST_DEF) t),name1), ATTR(self,con1)); break;
  case AS_SHARED_DEF_tag:
   if (ATTR(self,is_external)) {
    L3 = IMPL_CREATE_prog_PROG(self);
    PROG_err_loc_dPROG_ERR(L3, ((dPROG_ERR) t));
    L4 = IMPL_CREATE_prog_PROG(self);
    PROG_err_STR(L4, ((STR) &Externalclassesmaynotdef1));
    ret_val = ((ELT) NULL);
    return ret_val;
   }
   sig1 = SIG_shared_reader_sig_AS(((SIG) NULL), ((AS_SHARED_DEF) t), ATTR(((AS_SHARED_DEF) t),name1), ATTR(self,con1)); break;
  case AS_ATTR_DEF_tag:
   if (ATTR(self,is_external)) {
    L5 = IMPL_CREATE_prog_PROG(self);
    PROG_err_loc_dPROG_ERR(L5, ((dPROG_ERR) t));
    L6 = IMPL_CREATE_prog_PROG(self);
    PROG_err_STR(L6, ((STR) &Externalclassesmaynotdef2));
    ret_val = ((ELT) NULL);
    return ret_val;
   }
   sig1 = SIG_attr_reader_sig_AS_A(((SIG) NULL), ((AS_ATTR_DEF) t), ATTR(((AS_ATTR_DEF) t),name1), ATTR(self,con1)); break;
  case AS_ROUT_DEF_tag:
   sig1 = SIG_rout_sig_AS_ROUT_DEF(((SIG) NULL), ((AS_ROUT_DEF) t), ATTR(((AS_ROUT_DEF) t),name1), ATTR(self,con1));
   if (ATTR(((AS_ROUT_DEF) t),is_abstract)) {
    if (ATTR(self,is_external)) {
     L7 = SIG_is_legal_ext_abs_BOO(sig1);
     if ((!(L7))) {
      ret_val = ((ELT) NULL);
      return ret_val;
     }
     r = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, sig1, t, ATTR(self,con1), ATTR(((AS_ROUT_DEF) t),is_private));
     SATTR(r,is_external,TRUE);
     ret_val = r;
     return ret_val;
    }
    else {
     L8 = IMPL_CREATE_prog_PROG(self);
     PROG_err_loc_dPROG_ERR(L8, ((dPROG_ERR) t));
     L9 = IMPL_CREATE_prog_PROG(self);
     PROG_err_STR(L9, ((STR) &Onlyexternalclassesmayha));
     ret_val = ((ELT) NULL);
     return ret_val;
    }
   }
   else {
    if (ATTR(self,is_external)) {
     L10 = SIG_is_legal_ext_bod_BOO(sig1);
     if ((!(L10))) {
      ret_val = ((ELT) NULL);
      return ret_val;
     }
     r = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, sig1, t, ATTR(self,con1), ATTR(((AS_ROUT_DEF) t),is_private));
     SATTR(r,is_external,TRUE);
     ret_val = r;
     return ret_val;
    }
   } break;
  default: ;
   ret_val = ((ELT) NULL);
   return ret_val;
 }
 if ((sig1==((SIG) NULL))) {
  ret_val = ((ELT) NULL);
  return ret_val;
 }
 L11 = ATTR(self,con1);
 L12 = t;
 if (L12==NULL) {
  FATAL("Dispatch on void in IMPL_CREATE::reader_elt_for($AS_CLASS_ELT):ELT");
 }
 r = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, sig1, t, L11, (*dAS_CLASS_ELT_is_private[TAG(L12)+dAS_CLASS_ELT_is_private_offset])(L12));
 ret_val = r;
 return ret_val;
}


ELT IMPL_CREATE_writer_elt_f(IMPL_CREATE self, dAS_CLASS_ELT t) {
 ELT ret_val;
 SIG sig1 = ((SIG) NULL);
 BOOL pri1 = ((BOOL) 0);
 BOOL L1;
 BOOL L2;
 if (ATTR(self,is_external)) {
  ret_val = ((ELT) NULL);
  return ret_val;
 }
 if (t==NULL) {
  ret_val = ((ELT) NULL);
  return ret_val;
 } else
 switch (TAG(t)) {
  case AS_SHARED_DEF_tag:
   sig1 = SIG_shared_writer_sig_AS(((SIG) NULL), ((AS_SHARED_DEF) t), ATTR(((AS_SHARED_DEF) t),name1), ATTR(self,con1));
   if (ATTR(((AS_SHARED_DEF) t),is_private)) {
    L1 = TRUE;
   } else {
    L1 = ATTR(((AS_SHARED_DEF) t),is_readonly);
   }
   pri1 = L1; break;
  case AS_ATTR_DEF_tag:
   sig1 = SIG_attr_writer_sig_AS_A(((SIG) NULL), ((AS_ATTR_DEF) t), ATTR(((AS_ATTR_DEF) t),name1), ATTR(self,con1));
   if (ATTR(((AS_ATTR_DEF) t),is_private)) {
    L2 = TRUE;
   } else {
    L2 = ATTR(((AS_ATTR_DEF) t),is_readonly);
   }
   pri1 = L2; break;
  default: ;
   ret_val = ((ELT) NULL);
   return ret_val;
 }
 if ((sig1==((SIG) NULL))) {
  ret_val = ((ELT) NULL);
  return ret_val;
 }
 ret_val = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, sig1, t, ATTR(self,con1), pri1);
 return ret_val;
}


ELT IMPL_INCLUDE_modify_elt_(IMPL_INCLUDE self, ELT e) {
 ELT ret_val;
 TP_CONTEXT con;
 IDENT name11 = IDENT_zero;
 BOOL read_pri = ((BOOL) 0);
 BOOL write_pri = ((BOOL) 0);
 AS_FEAT_MOD m;
 SIG sig1 = ((SIG) NULL);
 BOOL pri1 = ((BOOL) 0);
 dAS_CLASS_ELT eas;
 TP_CLASS L1;
 ARRAYIDENT L2;
 ARRAYdTP L3;
 BOOL L4;
 IDENT L5;
 BOOL L6;
 BOOL L7;
 L1 = ATTR(self,tp1);
 L2 = ATTR(ATTR(e,con1),pnames1);
 L3 = ATTR(ATTR(e,con1),ptypes1);
 con = TP_CONTEXT_create_TP_CLA(((TP_CONTEXT) NULL), L1, L2, L3, IMPL_INCLUDE_prog_PROG(self));
 if ((con==((TP_CONTEXT) NULL))) {
  ret_val = ((ELT) NULL);
  return ret_val;
 }
 m = IMPL_INCLUDE_modifier_fo(self, ELT_name_IDENT(e));
 L4 = (m==((AS_FEAT_MOD) NULL));
 if ((!(L4))) {
  L5 = ATTR(m,new_name);
  if (IDENT_is_eq_IDENT_BOOL(L5, IDENT_create_STR_IDENT(IDENT_zero, ((STR) NULL)))) {
   ret_val = ((ELT) NULL);
   return ret_val;
  }
  name11 = ATTR(m,new_name);
  read_pri = ATTR(m,is_private);
  if (ATTR(m,is_private)) {
   L6 = TRUE;
  } else {
   L6 = ATTR(m,is_readonly);
  }
  write_pri = L6;
 }
 else {
  name11 = ELT_name_IDENT(e);
  if (ATTR(ATTR(self,as1),is_private)) {
   L7 = TRUE;
  } else {
   L7 = ATTR(e,is_private1);
  }
  read_pri = L7;
  write_pri = read_pri;
 }
 eas = ATTR(e,as1);
 if (eas==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(eas)) {
  case AS_CONST_DEF_tag:
   sig1 = SIG_const_reader_sig_AS_(((SIG) NULL), ((AS_CONST_DEF) eas), name11, con);
   pri1 = read_pri; break;
  case AS_SHARED_DEF_tag:
   if (ELT_is_shared_writer_BOO(e)) {
    sig1 = SIG_shared_writer_sig_AS(((SIG) NULL), ((AS_SHARED_DEF) eas), name11, con);
    pri1 = write_pri;
   }
   else {
    sig1 = SIG_shared_reader_sig_AS(((SIG) NULL), ((AS_SHARED_DEF) eas), name11, con);
    pri1 = read_pri;
   } break;
  case AS_ATTR_DEF_tag:
   if (ELT_is_attr_writer_BOOL(e)) {
    sig1 = SIG_attr_writer_sig_AS_A(((SIG) NULL), ((AS_ATTR_DEF) eas), name11, con);
    pri1 = write_pri;
   }
   else {
    sig1 = SIG_attr_reader_sig_AS_A(((SIG) NULL), ((AS_ATTR_DEF) eas), name11, con);
    pri1 = read_pri;
   } break;
  case AS_ROUT_DEF_tag:
   sig1 = SIG_rout_sig_AS_ROUT_DEF(((SIG) NULL), ((AS_ROUT_DEF) eas), name11, con);
   pri1 = read_pri; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 if ((sig1==((SIG) NULL))) {
  ret_val = ((ELT) NULL);
  return ret_val;
 }
 ret_val = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, ATTR(e,srcsig1), ATTR(e,as1), con, pri1);
 return ret_val;
}


ELT IMPL_elt_with_sig_SIG_EL(IMPL self, SIG s) {
 ELT ret_val;
 ret_val = ELT_TBL_elt_with_sig_SIG(ATTR(self,elts), s);
 return ret_val;
}


ELT_TBL IMPL_CREATE_elt_tbl_ELT_(IMPL_CREATE self) {
 ELT_TBL ret_val;
 ELT_TBL r = ((ELT_TBL) NULL);
 ELT_TBL L11;
 IMPL_INCLUDE inc;
 ELT_TBL L21;
 ELT e;
 ELT f;
 FLISTIMPL_INCLUDE L31;
 IMPL_INCLUDE inc2;
 ELT g1;
 ELT L4;
 BOOL L5;
 ELT L6;
 BOOL L7;
 BOOL L8;
 BOOL L9;
 BOOL L10;
 BOOL L12;
 BOOL L13;
 BOOL L14;
 IMPL_INCLUDE L15;
 BOOL L16;
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,class_elts);
    noname1->self = L11;
   }
   L4 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = ELT_TBL_insert_ELT_ELT_T(r, L4);
  }
 }
 after_loop: ;
 while (1) {
  L5 = FLISTIMPL_INCLUDE_is_emp(ATTR(self,incs));
  if ((!(L5))) {
  }
  else {
   goto after_loop1;
  }
  inc = FLISTIMPL_INCLUDE_pop_IM(ATTR(self,incs));
  {
   struct ELT_TBL_eltb_ELT_frame_struct other3_0;
   ELT_TBL_eltb_ELT_frame 
   noname2 = &other3_0;
   noname2->state = 0;
   while (1) {
    if (noname2->state == 0) {
     L21 = ATTR(inc,elt_tbl);
     noname2->self = L21;
    }
    L6 = ELT_TBL_eltb_ELT(noname2);
    if (noname2->state == -1) {
     goto after_loop2;
    }
    e = L6;
    f = ELT_TBL_elt_conflicting_(r, e);
    L9 = (f==((ELT) NULL));
    if ((!(L9))) {
     L8 = ELT_is_attr_access_BOOL(e);
    } else {
     L8 = FALSE;
    }
    if (L8) {
     L10 = ELT_is_attr_access_BOOL(f);
     L7 = (!(L10));
    } else {
     L7 = FALSE;
    }
    if (L7) {
     IMPL_CREATE_attr_conflic(self, e, f, inc);
    }
    if ((f==((ELT) NULL))) {
     L14 = ELT_is_abstract_BOOL(e);
     if ((!(L14))) {
      L13 = TRUE;
     } else {
      L13 = TP_CLASS_is_abstract_BOO(ATTR(self,tp1));
     }
     L12 = L13;
    } else {
     L12 = FALSE;
    }
    if (L12) {
     {
      struct FLISTIMPL_INCLUDE_eltb_I_frame_struct other4_0;
      FLISTIMPL_INCLUDE_eltb_I_frame 
      noname3 = &other4_0;
      noname3->state = 0;
      while (1) {
       if (noname3->state == 0) {
        L31 = ATTR(self,incs);
        noname3->self = L31;
       }
       L15 = FLISTIMPL_INCLUDE_eltb_I(noname3);
       if (noname3->state == -1) {
        goto after_loop3;
       }
       inc2 = L15;
       g1 = ELT_TBL_elt_conflicting_(ATTR(inc2,elt_tbl), e);
       L16 = (g1==((ELT) NULL));
       if ((!(L16))) {
        IMPL_CREATE_include_conf(self, inc, inc2, e, g1);
       }
      }
     }
     after_loop3: ;
     r = ELT_TBL_insert_ELT_ELT_T(r, e);
    }
   }
  }
  after_loop2: ;
 }
 after_loop1: ;
 ret_val = r;
 return ret_val;
}


ELT_TBL IMPL_CREATE_explicit_cla(IMPL_CREATE self) {
 ELT_TBL ret_val;
 dAS_CLASS_ELT t;
 ELT_TBL r = ((ELT_TBL) NULL);
 ELT er;
 ELT f;
 ELT f11;
 ELT ew;
 ELT f21;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 BOOL L5;
 BOOL L6;
 dAS_CLASS_ELT L7;
 t = ATTR(ATTR(self,as1),body);
 while (1) {
  L1 = (t==((dAS_CLASS_ELT) NULL));
  if ((!(L1))) {
  }
  else {
   goto after_loop;
  }
  er = IMPL_CREATE_reader_elt_f(self, t);
  L2 = (er==((ELT) NULL));
  if ((!(L2))) {
   if (ATTR(self,is_external)) {
    f = ELT_TBL_elt_same_name_as(r, er);
    L3 = (f==((ELT) NULL));
    if ((!(L3))) {
     IMPL_CREATE_ext_conflict(self, er, f);
    }
    else {
     r = ELT_TBL_insert_ELT_ELT_T(r, er);
    }
   }
   else {
    f11 = ELT_TBL_elt_conflicting_(r, er);
    L4 = (f11==((ELT) NULL));
    if ((!(L4))) {
     IMPL_CREATE_reader_confl(self, er, f11);
    }
    else {
     r = ELT_TBL_insert_ELT_ELT_T(r, er);
    }
   }
  }
  ew = IMPL_CREATE_writer_elt_f(self, t);
  L5 = (ew==((ELT) NULL));
  if ((!(L5))) {
   f21 = ELT_TBL_elt_conflicting_(r, ew);
   L6 = (f21==((ELT) NULL));
   if ((!(L6))) {
    IMPL_CREATE_writer_confl(self, ew, f21);
   }
   else {
    r = ELT_TBL_insert_ELT_ELT_T(r, ew);
   }
  }
  L7 = t;
  if (L7==NULL) {
   FATAL("Dispatch on void in IMPL_CREATE::explicit_class_elts:ELT_TBL");
  }
  t = (*dAS_CLASS_ELT_next_dAS_C[TAG(L7)+dAS_CLASS_ELT_next_dAS_C_offset])(L7);
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


ELT_TBL IMPL_INCLUDE_included_el(IMPL_INCLUDE self) {
 ELT_TBL ret_val;
 ELT_TBL r = ((ELT_TBL) NULL);
 ELT_TBL L11;
 ELT e;
 ELT en;
 ELT f;
 AS_FEAT_MOD m;
 ELT L2;
 BOOL L3;
 BOOL L4;
 INT L5;
 INT L6;
 BOOL L7;
 {
  struct ELT_TBL_eltb_ELT_frame_struct other1_0;
  ELT_TBL_eltb_ELT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,impl),elts);
    noname1->self = L11;
   }
   L2 = ELT_TBL_eltb_ELT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L2;
   en = IMPL_INCLUDE_modify_elt_(self, e);
   L3 = (en==((ELT) NULL));
   if ((!(L3))) {
    f = ELT_TBL_elt_conflicting_(r, en);
    L4 = (f==((ELT) NULL));
    if ((!(L4))) {
     IMPL_INCLUDE_include_con(self, en, f);
    }
    else {
     r = ELT_TBL_insert_ELT_ELT_T(r, en);
    }
   }
  }
 }
 after_loop: ;
 L5 = FSETAS_FEAT_MOD_size_INT(ATTR(self,used_mods));
 L6 = AS_FEAT_MOD_size_INT(ATTR(ATTR(self,as1),mods));
 if ((L5!=L6)) {
  m = ATTR(ATTR(self,as1),mods);
  while (1) {
   if ((m==((AS_FEAT_MOD) NULL))) {
    goto after_loop1;
   }
   L7 = FSETAS_FEAT_MOD_test_AS_(ATTR(self,used_mods), m);
   if ((!(L7))) {
    IMPL_INCLUDE_unused_mod_(self, m);
   }
   m = ATTR(m,next);
  }
  after_loop1: ;
 }
 ret_val = r;
 return ret_val;
}


FLISTSTR GET_OPTIONS_args_from_en(GET_OPTIONS self) {
 FLISTSTR ret_val;
 FLISTSTR cl;
 STR sc;
 STR sh;
 STR sl;
 STR tok;
 STR L11;
 CHAR c = ((CHAR) 0);
 extern STR SATHER_COMMANDS;
 BOOL L2;
 extern STR TheSATHER_COMMANDSvariab;
 extern STR SATHER_HOME;
 extern STR TheSATHER_HOMEenvironmen;
 extern STR SATHER_LIBRARY;
 extern STR LibraryLibrarymodule;
 extern STR name1;
 CHAR L3;
 STR L4;
 CHAR *L3p; INT L3n;
 BOOL L5;
 dSTR L6;
 extern STR name1;
 extern STR name1;
 extern STR name1;
 cl = FLISTSTR_create_FLISTSTR(((FLISTSTR) NULL));
 sc = UNIX_get_env_STR_STR(((UNIX) NULL), ((STR) &SATHER_COMMANDS));
 L2 = (sc==((STR) NULL));
 if ((!(L2))) {
  GET_OPTIONS_barf_STR(self, ((STR) &TheSATHER_COMMANDSvariab));
 }
 sh = UNIX_get_env_STR_STR(((UNIX) NULL), ((STR) &SATHER_HOME));
 if ((sh==((STR) NULL))) {
  GET_OPTIONS_barf_STR(self, ((STR) &TheSATHER_HOMEenvironmen));
 }
 SATTR(ATTR(self,prog1),home,sh);
 sl = UNIX_get_env_STR_STR(((UNIX) NULL), ((STR) &SATHER_LIBRARY));
 if ((sl==((STR) NULL))) {
  sl = STR_plus_dSTR_STR(sh, ((dSTR) ((STR) &LibraryLibrarymodule)));
 }
 tok = ((STR) &name1);
 {
  BOOL noname1 = TRUE;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = sl;
    L4 = L11;
    L3p = L4->arr_part; L3n = L4->asize;
   } else {
    L3p++; L3n--;
   }
   if (L3n<=0) goto after_loop; L3 = *L3p;
   c = L3;
   L5 = CHAR_is_space_BOOL(c);
   if ((!(L5))) {
    L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L6)->value_part = c;
    tok = STR_plus_dSTR_STR(tok, L6);
   }
   else {
    if (STR_is_neq_STR_BOOL(tok, ((STR) &name1))) {
     cl = FLISTSTR_push_STR_FLISTS(cl, tok);
     tok = ((STR) &name1);
    }
   }
  }
 }
 after_loop: ;
 if (STR_is_neq_STR_BOOL(tok, ((STR) &name1))) {
  cl = FLISTSTR_push_STR_FLISTS(cl, tok);
 }
 ret_val = cl;
 return ret_val;
}


FLISTSTR GET_OPTIONS_args_from_fi(GET_OPTIONS self, STR name11) {
 FLISTSTR ret_val;
 STR wd;
 FLISTSTR cl;
 FILE1 f;
 FSTR fs;
 STR tok;
 INT pos = ((INT) 0);
 CHAR c = ((CHAR) 0);
 CHAR op = ((CHAR) 0);
 BOOL skip1 = ((BOOL) 0);
 CHAR cp = ((CHAR) 0);
 STR tenv;
 STR e;
 ERR1 L1;
 extern STR Couldntopenfile;
 ERR1 L2;
 ERR1 L3;
 dSTR L4;
 FSTR L5;
 extern STR name1;
 INT L6;
 INT L7;
 CHAR L8;
 BOOL L9;
 BOOL L10;
 INT L11;
 CHAR L12;
 CHAR L13;
 dSTR L14;
 INT L15;
 CHAR L16;
 INT L17;
 INT L18;
 ERR1 L19;
 extern STR Unterminatedcommentin;
 ERR1 L20;
 ERR1 L21;
 dSTR L22;
 BOOL L23;
 CHAR L24;
 INT L25;
 CHAR L26;
 dSTR L27;
 INT L28;
 BOOL L29;
 extern STR name1;
 BOOL L30;
 INT L31;
 CHAR L32;
 BOOL L33;
 BOOL L34;
 BOOL L35;
 CHAR L36;
 CHAR L37;
 CHAR L38;
 CHAR L39;
 ERR1 L40;
 extern STR Unterminatedenvironmentv;
 ERR1 L41;
 extern STR name6;
 ERR1 L42;
 ERR1 L43;
 extern STR in1;
 ERR1 L44;
 ERR1 L45;
 extern STR assume;
 ERR1 L46;
 dSTR L47;
 ERR1 L48;
 extern STR name7;
 ERR1 L49;
 extern STR skipthistoken;
 dSTR L50;
 INT L51;
 BOOL L52;
 BOOL L53;
 BOOL L54;
 BOOL L55;
 INT L56;
 dSTR L57;
 extern STR name1;
 dSTR L58;
 BOOL L59;
 dSTR L60;
 extern STR name1;
 BOOL L61;
 CHAR L62;
 dSTR L63;
 STR L64;
 extern STR name1;
 wd = GET_OPTIONS_directory_ST(self, name11);
 cl = FLISTSTR_create_FLISTSTR(((FLISTSTR) NULL));
 f = FILE_open_for_read_STR_F(((FILE1) NULL), name11);
 if (FILE_error_BOOL(f)) {
  L1 = ERR_create_ERR(((ERR1) NULL));
  L2 = ERR_plus_dSTR_ERR(L1, ((dSTR) ((STR) &Couldntopenfile)));
  L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) name11));
  L4 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L4)->value_part = '\n';
  ERR_plus_dSTR(L3, L4);
  GET_OPTIONS_usage(self);
 }
 L5 = FILE_fstr_FSTR(f);
 fs = FSTR_plus_CHAR_FSTR(L5, ' ');
 FILE_close(f);
 tok = ((STR) &name1);
 pos = 0;
 while (1) {
  L6 = FSTR_size_INT(fs);
  if ((pos>=L6)) {
   goto after_loop;
  }
  c = (FSTRAGET(fs,pos));
  if ((c=='-')) {
   L7 = (INTPLUS(pos,1));
   L8 = (FSTRAGET(fs,L7));
   if ((L8=='-')) {
    while (1) {
     pos = (INTPLUS(pos,1));
     L11 = FSTR_size_INT(fs);
     if ((pos>=L11)) {
      L10 = TRUE;
     } else {
      L12 = (FSTRAGET(fs,pos));
      L10 = (L12=='\n');
     }
     if (L10) {
      L9 = TRUE;
     } else {
      L13 = (FSTRAGET(fs,pos));
      L9 = (L13=='\r');
     }
     if (L9) {
      goto after_loop1;
     }
    }
    after_loop1: ;
   }
   else {
    L14 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L14)->value_part = '-';
    tok = STR_plus_dSTR_STR(tok, L14);
   }
  }
  else {
   if ((c=='(')) {
    L15 = (INTPLUS(pos,1));
    L16 = (FSTRAGET(fs,L15));
    if ((L16=='*')) {
     while (1) {
      pos = (INTPLUS(pos,1));
      L17 = FSTR_size_INT(fs);
      L18 = (INTMINUS(L17,1));
      if ((pos>=L18)) {
       L19 = ERR_create_ERR(((ERR1) NULL));
       L20 = ERR_plus_dSTR_ERR(L19, ((dSTR) ((STR) &Unterminatedcommentin)));
       L21 = ERR_plus_dSTR_ERR(L20, ((dSTR) name11));
       L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
       ((CHAR_boxed) L22)->value_part = '\n';
       ERR_plus_dSTR(L21, L22);
       goto after_loop2;
      }
      L24 = (FSTRAGET(fs,pos));
      if ((L24=='*')) {
       L25 = (INTPLUS(pos,1));
       L26 = (FSTRAGET(fs,L25));
       L23 = (L26==')');
      } else {
       L23 = FALSE;
      }
      if (L23) {
       goto after_loop2;
      }
     }
     after_loop2: ;
     pos = (INTPLUS(pos,1));
    }
    else {
     L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
     ((CHAR_boxed) L27)->value_part = '(';
     tok = STR_plus_dSTR_STR(tok, L27);
    }
   }
   else {
    if ((c=='$')) {
     L28 = (INTPLUS(pos,1));
     op = (FSTRAGET(fs,L28));
     if ((op=='{')) {
      L29 = TRUE;
     } else {
      L29 = (op=='(');
     }
     if (L29) {
      skip1 = FALSE;
      cp = '}';
      if ((op=='(')) {
       cp = ')';
      }
      tenv = ((STR) &name1);
      pos = (INTPLUS(pos,2));
      while (1) {
       L31 = FSTR_size_INT(fs);
       if ((pos<L31)) {
        L32 = (FSTRAGET(fs,pos));
        L30 = (L32!=cp);
       } else {
        L30 = FALSE;
       }
       if (L30) {
       }
       else {
        goto after_loop3;
       }
       L36 = (FSTRAGET(fs,pos));
       if ((L36==')')) {
        L35 = TRUE;
       } else {
        L37 = (FSTRAGET(fs,pos));
        L35 = (L37=='}');
       }
       if (L35) {
        L34 = TRUE;
       } else {
        L38 = (FSTRAGET(fs,pos));
        L34 = (L38=='\n');
       }
       if (L34) {
        L33 = TRUE;
       } else {
        L39 = (FSTRAGET(fs,pos));
        L33 = (L39=='\r');
       }
       if (L33) {
        L40 = ERR_create_ERR(((ERR1) NULL));
        L41 = ERR_plus_dSTR_ERR(L40, ((dSTR) ((STR) &Unterminatedenvironmentv)));
        L42 = ERR_plus_dSTR_ERR(L41, ((dSTR) ((STR) &name6)));
        L43 = ERR_plus_dSTR_ERR(L42, ((dSTR) tenv));
        L44 = ERR_plus_dSTR_ERR(L43, ((dSTR) ((STR) &in1)));
        L45 = ERR_plus_dSTR_ERR(L44, ((dSTR) name11));
        L46 = ERR_plus_dSTR_ERR(L45, ((dSTR) ((STR) &assume)));
        L47 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L47)->value_part = cp;
        L48 = ERR_plus_dSTR_ERR(L46, L47);
        L49 = ERR_plus_dSTR_ERR(L48, ((dSTR) ((STR) &name7)));
        ERR_plus_dSTR(L49, ((dSTR) ((STR) &skipthistoken)));
        skip1 = TRUE;
        goto after_loop3;
       }
       L50 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
       ((CHAR_boxed) L50)->value_part = (FSTRAGET(fs,pos));
       tenv = STR_plus_dSTR_STR(tenv, L50);
       pos = (INTPLUS(pos,1));
      }
      after_loop3: ;
      if ((!(skip1))) {
       L51 = FSTR_size_INT(fs);
       if ((pos<L51)) {
        pos = (INTPLUS(pos,1));
       }
       e = UNIX_get_env_STR_STR(((UNIX) NULL), tenv);
       L52 = (e==((STR) NULL));
       if ((!(L52))) {
        tok = STR_plus_dSTR_STR(tok, ((dSTR) e));
       }
       L53 = (tok==((STR) NULL));
       if ((!(L53))) {
        while (1) {
         L55 = CHAR_is_space_BOOL((FSTRAGET(fs,pos)));
         if ((!(L55))) {
          L56 = FSTR_size_INT(fs);
          L54 = (pos<L56);
         } else {
          L54 = FALSE;
         }
         if (L54) {
         }
         else {
          goto after_loop4;
         }
         L57 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
         ((CHAR_boxed) L57)->value_part = (FSTRAGET(fs,pos));
         tok = STR_plus_dSTR_STR(tok, L57);
         pos = (INTPLUS(pos,1));
        }
        after_loop4: ;
        cl = FLISTSTR_push_STR_FLISTS(cl, tok);
       }
      }
      tok = ((STR) &name1);
     }
     else {
      L58 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
      ((CHAR_boxed) L58)->value_part = '$';
      tok = STR_plus_dSTR_STR(tok, L58);
     }
    }
    else {
     L59 = CHAR_is_space_BOOL(c);
     if ((!(L59))) {
      L60 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
      ((CHAR_boxed) L60)->value_part = c;
      tok = STR_plus_dSTR_STR(tok, L60);
     }
     else {
      if (STR_is_neq_STR_BOOL(tok, ((STR) &name1))) {
       if (GET_OPTIONS_is_filename_(self, tok)) {
        L62 = (STRAGET(tok,0));
        L61 = (L62!='/');
       } else {
        L61 = FALSE;
       }
       if (L61) {
        L63 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L63)->value_part = '/';
        L64 = STR_plus_dSTR_STR(wd, L63);
        tok = STR_plus_dSTR_STR(L64, ((dSTR) tok));
       }
       if (GET_OPTIONS_is_filename_(self, tok)) {
        SATTR(self,module_inclusion,FMAPSTRSTR_insert_STR_ST(ATTR(self,module_inclusion), tok, name11));
       }
       cl = FLISTSTR_push_STR_FLISTS(cl, tok);
       tok = ((STR) &name1);
      }
     }
    }
   }
  }
  pos = (INTPLUS(pos,1));
 }
 after_loop: ;
 ret_val = cl;
 return ret_val;
}


IDENT IDENT_TBL_aeltb_IDENT(IDENT_TBL_aeltb_IDENT_frame frame) {
 IDENT dummy = IDENT_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return IDENT_TBL_aget_INT_IDENT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


IDENT IDENT_TBL_aget_INT_IDENT(IDENT_TBL self, INT ind) {
 IDENT ret_val = IDENT_zero;
 return ARR(self,ind);
}


IDENT IDENT_TBL_elt_nil_IDENT(IDENT_TBL self) {
 IDENT ret_val = IDENT_zero;
 IDENT t = IDENT_zero;
 ret_val = IDENT_zero;
 return ret_val;
}


IDENT IDENT_TBL_eltb_IDENT(IDENT_TBL_eltb_IDENT_frame frame) {
 IDENT dummy = IDENT_zero;
 BOOL L1;
 IDENT L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((IDENT_TBL) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(IDENT_TBL_aeltb_IDENT_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = IDENT_TBL_aeltb_IDENT(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = IDENT_TBL_is_elt_nil_IDE(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


IDENT IDENT_TBL_get_query_STR_(IDENT_TBL self, STR q) {
 IDENT ret_val = IDENT_zero;
 INT h = ((INT) 0);
 IDENT e = IDENT_zero;
 IDENT e1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((IDENT_TBL) NULL))) {
  ret_val = IDENT_zero;
  return ret_val;
 }
 L1 = IDENT_TBL_query_hash_STR(self, q);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  e = IDENT_TBL_aget_INT_IDENT(self, h);
  if (IDENT_TBL_is_elt_nil_IDE(self, e)) {
   goto after_loop;
  }
  else {
   if (IDENT_TBL_query_test_STR(self, q, e)) {
    ret_val = e;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   e1 = IDENT_TBL_aget_INT_IDENT(self, h);
   if (IDENT_TBL_is_elt_nil_IDE(self, e1)) {
    goto after_loop1;
   }
   else {
    if (IDENT_TBL_query_test_STR(self, q, e1)) {
     ret_val = e1;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = IDENT_TBL_elt_nil_IDENT(self);
 return ret_val;
}


IDENT IDENT_create_STR_IDENT(IDENT self, STR s) {
 IDENT ret_val = IDENT_zero;
 IDENT i = IDENT_zero;
 if ((s==((STR) NULL))) {
  ret_val = IDENT_zero;
  return ret_val;
 }
 i = IDENT_TBL_get_query_STR_(IDENT_ident_tbl, s);
 if ((i.str==(STR)0)) {
  i.str = s;
  IDENT_ident_tbl_IDENT_TB(self, IDENT_TBL_insert_IDENT_I(IDENT_ident_tbl, i));
 }
 ret_val = i;
 return ret_val;
}


IDENT_TBL IDENT_TBL_allocate_INT_I(IDENT_TBL self, INT n) {
 IDENT_TBL ret_val;
 IDENT_TBL r;
 IDENT_TBL L11;
 IDENT_TBL L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((IDENT_TBL) rt_arr_alloc(sizeof(struct IDENT_TBL_struct), IDENT_TBL_tag, sizeof(IDENT) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (IDENT_TBL_elt_nil_IDENT(self).str==(STR)0);
 if ((!(L4))) {
  {
   struct IDENT_TBL_asetb_IDENT_frame_struct other1_0;
   IDENT_TBL_asetb_IDENT_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = IDENT_TBL_elt_nil_IDENT(self);
    IDENT_TBL_asetb_IDENT(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


IDENT_TBL IDENT_TBL_double_size_ID(IDENT_TBL self) {
 IDENT_TBL ret_val;
 IDENT_TBL r;
 IDENT_TBL L11;
 INT L2;
 INT L3;
 INT L4;
 IDENT L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = IDENT_TBL_allocate_INT_I(self, (INTPLUS(L4,1)));
 {
  struct IDENT_TBL_eltb_IDENT_frame_struct other1_0;
  IDENT_TBL_eltb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = IDENT_TBL_eltb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = IDENT_TBL_insert_IDENT_I(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


IDENT_TBL IDENT_TBL_insert_IDENT_I(IDENT_TBL self, IDENT e) {
 IDENT_TBL ret_val;
 IDENT_TBL r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 IDENT te = IDENT_zero;
 IDENT te1 = IDENT_zero;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if (IDENT_TBL_is_elt_nil_IDE(self, e)) {
  ret_val = r;
  return ret_val;
 }
 if ((r==((IDENT_TBL) NULL))) {
  r = IDENT_TBL_allocate_INT_I(self, 5);
 }
 else {
  if (IDENT_TBL_should_grow_BO(self)) {
   r = IDENT_TBL_double_size_ID(r);
  }
 }
 asz = (ASIZE(r));
 L1 = IDENT_TBL_elt_hash_IDENT(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = IDENT_TBL_aget_INT_IDENT(r, h);
  if (IDENT_TBL_is_elt_nil_IDE(self, te)) {
   goto after_loop;
  }
  else {
   if (IDENT_TBL_elt_eq_IDENT_I(self, te, e)) {
    IDENT_TBL_aset_INT_IDENT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = IDENT_TBL_aget_INT_IDENT(r, h);
   if (IDENT_TBL_is_elt_nil_IDE(self, te1)) {
    goto after_loop1;
   }
   else {
    if (IDENT_TBL_elt_eq_IDENT_I(self, te1, e)) {
     IDENT_TBL_aset_INT_IDENT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 IDENT_TBL_aset_INT_IDENT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


IFC IFC_ABS_CREATE_ifc_of_TP(IFC_ABS_CREATE self, TP_CLASS t) {
 IFC ret_val;
 IFC_ABS_CREATE ic;
 OUT L1;
 extern STR Abstractifccreate;
 OUT L2;
 OUT L3;
 extern STR name20;
 IFC_ABS_CREATE L4;
 dPARSE L5;
 IDENT L6;
 dPARSE L7;
 PROG L8;
 extern STR CompilererrorIFC_ABS_CRE;
 STR L9;
 extern STR name5;
 SIG_TBL L10;
 if (ATTR(ATTR(t,prog1),show_ifc_abs_create)) {
  L1 = OUT_create_OUT(((OUT) NULL));
  L2 = OUT_plus_dSTR_OUT(L1, ((dSTR) ((STR) &Abstractifccreate)));
  L3 = OUT_plus_dSTR_OUT(L2, ((dSTR) TP_CLASS_str_STR(t)));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &name20)));
 }
 L4 = ((IFC_ABS_CREATE) rt_alloc(sizeof(struct IFC_ABS_CREATE_struct), IFC_ABS_CREATE_tag));
 ic = L4;
 SATTR(ic,tp1,t);
 SATTR(ic,con1,TP_CLASS_tp_context_for_(t));
 if ((ATTR(ic,con1)==((TP_CONTEXT) NULL))) {
  ret_val = ((IFC) NULL);
  return ret_val;
 }
 L5 = ATTR(IFC_ABS_CREATE_prog_PROG(ic),parse);
 L6 = ATTR(t,name1);
 L7 = L5;
 if (L7==NULL) {
  FATAL("Dispatch on void in IFC_ABS_CREATE::ifc_of(TP_CLASS):IFC");
 }
 SATTR(ic,tr,(*dPARSE_tree_for_IDENT_IN[TAG(L7)+dPARSE_tree_for_IDENT_IN_offset])(L7, L6, ARRAYdTP_size_INT(ATTR(t,params))));
 if ((ATTR(ic,tr)==((AS_CLASS_DEF) NULL))) {
  L8 = ATTR(t,prog1);
  L9 = STR_plus_dSTR_STR(((STR) &CompilererrorIFC_ABS_CRE), ((dSTR) TP_CLASS_str_STR(t)));
  PROG_err_STR(L8, STR_plus_dSTR_STR(L9, ((dSTR) ((STR) &name5))));
  ret_val = ((IFC) NULL);
  return ret_val;
 }
 IFC_ABS_CREATE_do_explic(ic);
 IFC_ABS_CREATE_do_supers(ic);
 L10 = IFC_ABS_CREATE_do_sigs_S(ic);
 ret_val = IFC_create_SIG_TBL_dTP_I(((IFC) NULL), L10, ((dTP) t));
 return ret_val;
}


IFC IFC_TBL_ifc_of_dTP_IFC(IFC_TBL self, dTP t) {
 IFC ret_val;
 IFC r;
 TUPIDENTINT cq = TUPIDENTINT_zero;
 IMPL im;
 BOOL L1;
 IDENT L2;
 extern STR CompilererrorIFC_TBLifc_;
 r = FMAPdTPIFC_get_dTP_IFC(ATTR(self,tbl), t);
 L1 = (r==((IFC) NULL));
 if ((!(L1))) {
  ret_val = r;
  return ret_val;
 }
 if (t==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(t)) {
  case TP_CLASS_tag:
   if (TP_CLASS_is_abstract_BOO(((TP_CLASS) t))) {
    L2 = ATTR(((TP_CLASS) t),name1);
    cq = TUPIDENTINT_create_IDENT(TUPIDENTINT_zero, L2, ARRAYdTP_size_INT(ATTR(((TP_CLASS) t),params)));
    if (FSETTUPIDENTINT_test_TUP(ATTR(self,abs_cur), cq)) {
     IFC_TBL_cycle_err(self);
     SATTR(self,abs_cur,FSETTUPIDENTINT_clear_FS(ATTR(self,abs_cur)));
    }
    else {
     SATTR(self,abs_cur,FSETTUPIDENTINT_insert_T(ATTR(self,abs_cur), cq));
     r = IFC_ABS_CREATE_ifc_of_TP(((IFC_ABS_CREATE) NULL), ((TP_CLASS) t));
     SATTR(self,abs_cur,FSETTUPIDENTINT_delete_T(ATTR(self,abs_cur), cq));
    }
   }
   else {
    im = IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), t);
    if ((im==((IMPL) NULL))) {
     r = ((IFC) NULL);
    }
    else {
     r = ATTR(im,ifc);
    }
   } break;
  case TP_ROUT_tag:
   r = IFC_ifc_for_rout_TP_ROUT(((IFC) NULL), ((TP_ROUT) t)); break;
  case TP_ITER_tag:
   r = IFC_ifc_for_iter_TP_ITER(((IFC) NULL), ((TP_ITER) t)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 if ((r==((IFC) NULL))) {
  PROG_err_STR(ATTR(self,prog1), ((STR) &CompilererrorIFC_TBLifc_));
 }
 SATTR(self,tbl,FMAPdTPIFC_insert_dTP_IF(ATTR(self,tbl), t, r));
 ret_val = r;
 return ret_val;
}


IFC IFC_ifc_for_iter_TP_ITER(IFC self, TP_ITER t) {
 IFC ret_val;
 IFC r;
 IFC L1;
 SIG_TBL L2;
 L1 = ((IFC) rt_alloc(sizeof(struct IFC_struct), IFC_tag));
 r = L1;
 SATTR(r,tp1,((dTP) t));
 L2 = ATTR(r,sigs1);
 SATTR(r,sigs1,SIG_TBL_insert_SIG_SIG_T(L2, SIG_bound_iter_call_TP_I(((SIG) NULL), t)));
 ret_val = r;
 return ret_val;
}


IFC IFC_ifc_for_rout_TP_ROUT(IFC self, TP_ROUT t) {
 IFC ret_val;
 IFC r;
 IFC L1;
 SIG_TBL L2;
 L1 = ((IFC) rt_alloc(sizeof(struct IFC_struct), IFC_tag));
 r = L1;
 SATTR(r,tp1,((dTP) t));
 L2 = ATTR(r,sigs1);
 SATTR(r,sigs1,SIG_TBL_insert_SIG_SIG_T(L2, SIG_bound_routine_call_T(((SIG) NULL), t)));
 ret_val = r;
 return ret_val;
}


IMPL IMPL_CREATE_impl_of_TP_C(IMPL_CREATE self, TP_CLASS t) {
 IMPL ret_val;
 IMPL_CREATE ic;
 IMPL r;
 OUT L1;
 extern STR Implcreate;
 OUT L2;
 OUT L3;
 extern STR name20;
 IMPL_CREATE L4;
 INT L5;
 INT L6;
 dPARSE L7;
 IDENT L8;
 dPARSE L9;
 if (ATTR(ATTR(t,prog1),show_impl_create)) {
  L1 = OUT_create_OUT(((OUT) NULL));
  L2 = OUT_plus_dSTR_OUT(L1, ((dSTR) ((STR) &Implcreate)));
  L3 = OUT_plus_dSTR_OUT(L2, ((dSTR) TP_CLASS_str_STR(t)));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &name20)));
 }
 L4 = ((IMPL_CREATE) rt_alloc(sizeof(struct IMPL_CREATE_struct), IMPL_CREATE_tag));
 ic = L4;
 SATTR(ic,tp1,t);
 L5 = TP_CLASS_kind_INT(t);
 L6 = TP_KIND_ext_tp;
 SATTR(ic,is_external,(L5==L6));
 SATTR(ic,con1,TP_CLASS_tp_context_for_(t));
 if ((ATTR(ic,con1)==((TP_CONTEXT) NULL))) {
  ret_val = ((IMPL) NULL);
  return ret_val;
 }
 L7 = ATTR(IMPL_CREATE_prog_PROG(ic),parse);
 L8 = ATTR(t,name1);
 L9 = L7;
 if (L9==NULL) {
  FATAL("Dispatch on void in IMPL_CREATE::impl_of(TP_CLASS):IMPL");
 }
 SATTR(ic,as1,(*dPARSE_tree_for_IDENT_IN[TAG(L9)+dPARSE_tree_for_IDENT_IN_offset])(L9, L8, ARRAYdTP_size_INT(ATTR(t,params))));
 if ((ATTR(ic,as1)==((AS_CLASS_DEF) NULL))) {
  ret_val = ((IMPL) NULL);
  return ret_val;
 }
 SATTR(ic,class_elts,IMPL_CREATE_explicit_cla(ic));
 IMPL_CREATE_do_incs(ic);
 r = IMPL_create_IMPL(((IMPL) NULL));
 SATTR(r,tp1,((dTP) t));
 SATTR(r,arr1,IMPL_CREATE_get_arr_TP_C(ic));
 SATTR(r,elts,IMPL_CREATE_elt_tbl_ELT_(ic));
 SATTR(r,ifc,ELT_TBL_public_ifc_IFC(ATTR(r,elts)));
 if ((ATTR(r,ifc)==((IFC) NULL))) {
  SATTR(r,ifc,IFC_create_SIG_TBL_dTP_I(((IFC) NULL), ((SIG_TBL) NULL), ((dTP) t)));
 }
 ret_val = r;
 return ret_val;
}


IMPL IMPL_INCLUDE_included_im(IMPL_INCLUDE self) {
 IMPL ret_val;
 PROG L1;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(self,as1)));
 ret_val = IMPL_TBL_impl_of_dTP_IMP(ATTR(IMPL_INCLUDE_prog_PROG(self),impl_tbl), ((dTP) ATTR(self,itp)));
 return ret_val;
}


IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL self, dTP t) {
 IMPL ret_val;
 IMPL r;
 BOOL L1;
 extern STR Compilererrorabstracttyp;
 STR L2;
 extern STR name24;
 FSETTUPIDENTINT L3;
 IDENT L4;
 FSETTUPIDENTINT L5;
 IDENT L6;
 FSETTUPIDENTINT L7;
 IDENT L8;
 extern STR Compilererrorboundroutin;
 STR L9;
 extern STR name24;
 extern STR Compilererrorbounditerse;
 STR L10;
 extern STR name24;
 r = FMAPdTPIMPL_get_dTP_IMPL(ATTR(self,tbl), t);
 L1 = (r==((IMPL) NULL));
 if ((!(L1))) {
  ret_val = r;
  return ret_val;
 }
 if (t==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(t)) {
  case TP_CLASS_tag:
   if (TP_CLASS_is_abstract_BOO(((TP_CLASS) t))) {
    L2 = STR_plus_dSTR_STR(((STR) &Compilererrorabstracttyp), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) t))));
    IMPL_TBL_err_STR(self, STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &name24))));
    ret_val = ((IMPL) NULL);
    return ret_val;
   }
   L3 = ATTR(self,cur);
   L4 = ATTR(((TP_CLASS) t),name1);
   if (FSETTUPIDENTINT_test_TUP(L3, TUPIDENTINT_create_IDENT(TUPIDENTINT_zero, L4, ARRAYdTP_size_INT(ATTR(((TP_CLASS) t),params))))) {
    IMPL_TBL_cycle_err(self);
    SATTR(self,cur,FSETTUPIDENTINT_clear_FS(ATTR(self,cur)));
    ret_val = ((IMPL) NULL);
    return ret_val;
   }
   else {
    L5 = ATTR(self,cur);
    L6 = ATTR(((TP_CLASS) t),name1);
    SATTR(self,cur,FSETTUPIDENTINT_insert_T(L5, TUPIDENTINT_create_IDENT(TUPIDENTINT_zero, L6, ARRAYdTP_size_INT(ATTR(((TP_CLASS) t),params)))));
    r = IMPL_create_for_tp_dTP_I(((IMPL) NULL), t);
    SATTR(self,tbl,FMAPdTPIMPL_insert_dTP_I(ATTR(self,tbl), t, r));
    L7 = ATTR(self,cur);
    L8 = ATTR(((TP_CLASS) t),name1);
    SATTR(self,cur,FSETTUPIDENTINT_delete_T(L7, TUPIDENTINT_create_IDENT(TUPIDENTINT_zero, L8, ARRAYdTP_size_INT(ATTR(((TP_CLASS) t),params)))));
    ret_val = r;
    return ret_val;
   } break;
  case TP_ROUT_tag:
   L9 = STR_plus_dSTR_STR(((STR) &Compilererrorboundroutin), ((dSTR) TP_ROUT_str_STR(((TP_ROUT) t))));
   IMPL_TBL_err_STR(self, STR_plus_dSTR_STR(L9, ((dSTR) ((STR) &name24))));
   ret_val = ((IMPL) NULL);
   return ret_val; break;
  case TP_ITER_tag:
   L10 = STR_plus_dSTR_STR(((STR) &Compilererrorbounditerse), ((dSTR) TP_ITER_str_STR(((TP_ITER) t))));
   IMPL_TBL_err_STR(self, STR_plus_dSTR_STR(L10, ((dSTR) ((STR) &name24))));
   ret_val = ((IMPL) NULL);
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


IMPL IMPL_create_IMPL(IMPL self) {
 IMPL ret_val;
 IMPL L1;
 L1 = ((IMPL) rt_alloc(sizeof(struct IMPL_struct), IMPL_tag));
 ret_val = L1;
 return ret_val;
}


IMPL IMPL_create_for_tp_dTP_I(IMPL self, dTP t) {
 IMPL ret_val;
 dTP L1;
 PROG L2;
 extern STR CompilererrorIMPLrequest;
 PROG L3;
 extern STR CompilererrorImplementat;
 dTP L4;
 PROG L5;
 extern STR CompilererrorIMPLrequest;
 if (t==NULL) {
  L1 = t;
  if (L1==NULL) {
   FATAL("Dispatch on void in IMPL::create_for_tp($TP):IMPL");
  }
  L2 = (*dTP_prog_PROG[TAG(L1)+dTP_prog_PROG_offset])(L1);
  PROG_err_STR(L2, ((STR) &CompilererrorIMPLrequest));
  ret_val = ((IMPL) NULL);
  return ret_val;
 } else
 switch (TAG(t)) {
  case TP_CLASS_tag:
   if (TP_CLASS_is_abstract_BOO(((TP_CLASS) t))) {
    L3 = IMPL_prog_PROG(self);
    PROG_err_STR(L3, STR_plus_dSTR_STR(((STR) &CompilererrorImplementat), ((dSTR) TP_CLASS_str_STR(((TP_CLASS) t)))));
    ret_val = ((IMPL) NULL);
    return ret_val;
   }
   ret_val = IMPL_CREATE_impl_of_TP_C(((IMPL_CREATE) NULL), ((TP_CLASS) t));
   return ret_val; break;
  default: ;
   L4 = t;
   if (L4==NULL) {
    FATAL("Dispatch on void in IMPL::create_for_tp($TP):IMPL");
   }
   L5 = (*dTP_prog_PROG[TAG(L4)+dTP_prog_PROG_offset])(L4);
   PROG_err_STR(L5, ((STR) &CompilererrorIMPLrequest));
   ret_val = ((IMPL) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


IMPL_INCLUDE IMPL_INCLUDE_create_TP_C(IMPL_INCLUDE self, TP_CLASS tp, AS_INCLUDE_CLAUSE as) {
 IMPL_INCLUDE ret_val;
 IMPL_INCLUDE r;
 IMPL_INCLUDE L1;
 OUT L2;
 extern STR Including;
 OUT L3;
 OUT L4;
 extern STR in1;
 OUT L5;
 OUT L6;
 extern STR name20;
 L1 = ((IMPL_INCLUDE) rt_alloc(sizeof(struct IMPL_INCLUDE_struct), IMPL_INCLUDE_tag));
 r = L1;
 SATTR(r,tp1,tp);
 SATTR(r,as1,as);
 SATTR(r,itp,IMPL_INCLUDE_included_tp(r));
 if ((ATTR(r,itp)==((TP_CLASS) NULL))) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 if (ATTR(ATTR(tp,prog1),show_include)) {
  L2 = OUT_create_OUT(((OUT) NULL));
  L3 = OUT_plus_dSTR_OUT(L2, ((dSTR) ((STR) &Including)));
  L4 = OUT_plus_dSTR_OUT(L3, ((dSTR) TP_CLASS_str_STR(ATTR(r,itp))));
  L5 = OUT_plus_dSTR_OUT(L4, ((dSTR) ((STR) &in1)));
  L6 = OUT_plus_dSTR_OUT(L5, ((dSTR) TP_CLASS_str_STR(tp)));
  OUT_plus_dSTR(L6, ((dSTR) ((STR) &name20)));
 }
 SATTR(r,impl,IMPL_INCLUDE_included_im(r));
 if ((ATTR(r,impl)==((IMPL) NULL))) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 if (IMPL_INCLUDE_test_array_(r)) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 if (IMPL_INCLUDE_test_duplic(r)) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 SATTR(r,elt_tbl,IMPL_INCLUDE_included_el(r));
 if ((ATTR(r,elt_tbl)==((ELT_TBL) NULL))) {
  ret_val = ((IMPL_INCLUDE) NULL);
  return ret_val;
 }
 ret_val = r;
 return ret_val;
}


INLINE_ATTR_READ INLINE_ATTR_READ_create_(INLINE_ATTR_READ self, AM_ROUT_DEF am) {
 INLINE_ATTR_READ ret_val;
 INLINE_ATTR_READ r;
 dAM_STMT stmt;
 dAM_EXPR val1;
 INLINE_ATTR_READ L1;
 INT L2;
 L1 = ((INLINE_ATTR_READ) rt_alloc(sizeof(struct INLINE_ATTR_READ_struct), INLINE_ATTR_READ_tag));
 r = L1;
 SATTR(r,sig11,ATTR(am,sig11));
 stmt = ATTR(am,code11);
 if (stmt==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(stmt)) {
  case AM_RETURN_STMT_tag:
   val1 = ATTR(((AM_RETURN_STMT) stmt),val11);
   if (val1==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(val1)) {
    case AM_ATTR_EXPR_tag:
     SATTR(r,at11,ATTR(((AM_ATTR_EXPR) val1),at11));
     SATTR(r,self_tp,ATTR(((AM_ATTR_EXPR) val1),self_tp));
     SATTR(r,tp_at,ATTR(((AM_ATTR_EXPR) val1),tp_at)); break;
    default: ;
     FATAL("No applicable type in typecase");
   } break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L2 = INLINE_ATTR_READ_routine1;
 INLINE_ATTR_READ_routine(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ATTR_WRITE INLINE_ATTR_WRITE_create(INLINE_ATTR_WRITE self, AM_ROUT_DEF am) {
 INLINE_ATTR_WRITE ret_val;
 INLINE_ATTR_WRITE r;
 dAM_STMT stmt;
 dAM_EXPR dest1;
 INLINE_ATTR_WRITE L1;
 INT L2;
 L1 = ((INLINE_ATTR_WRITE) rt_alloc(sizeof(struct INLINE_ATTR_WRITE_struct), INLINE_ATTR_WRITE_tag));
 r = L1;
 SATTR(r,sig11,ATTR(am,sig11));
 stmt = ATTR(am,code11);
 if (stmt==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(stmt)) {
  case AM_ASSIGN_STMT_tag:
   dest1 = ATTR(((AM_ASSIGN_STMT) stmt),dest);
   if (dest1==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(dest1)) {
    case AM_ATTR_EXPR_tag:
     SATTR(r,self_tp,ATTR(((AM_ATTR_EXPR) dest1),self_tp));
     SATTR(r,at11,ATTR(((AM_ATTR_EXPR) dest1),at11));
     SATTR(r,tp_at,ATTR(((AM_ATTR_EXPR) dest1),tp_at)); break;
    default: ;
     FATAL("No applicable type in typecase");
   } break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L2 = INLINE_ATTR_WRITE_routin1;
 INLINE_ATTR_WRITE_routin(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INLINE_GLOBAL_READ INLINE_GLOBAL_READ_creat(INLINE_GLOBAL_READ self, AM_ROUT_DEF am) {
 INLINE_GLOBAL_READ ret_val;
 INLINE_GLOBAL_READ r;
 dAM_STMT stmt;
 dAM_EXPR val1;
 INLINE_GLOBAL_READ L1;
 INT L2;
 L1 = ((INLINE_GLOBAL_READ) rt_alloc(sizeof(struct INLINE_GLOBAL_READ_struct), INLINE_GLOBAL_READ_tag));
 r = L1;
 SATTR(r,sig11,ATTR(am,sig11));
 stmt = ATTR(am,code11);
 if (stmt==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(stmt)) {
  case AM_RETURN_STMT_tag:
   val1 = ATTR(((AM_RETURN_STMT) stmt),val11);
   if (val1==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(val1)) {
    case AM_GLOBAL_EXPR_tag:
     SATTR(r,age11,((AM_GLOBAL_EXPR) val1)); break;
    default: ;
     FATAL("No applicable type in typecase");
   } break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L2 = INLINE_GLOBAL_READ_routi1;
 INLINE_GLOBAL_READ_routi(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INLINE_INT_FOLD INLINE_INT_FOLD_create_S(INLINE_INT_FOLD self, SIG s) {
 INLINE_INT_FOLD ret_val;
 INLINE_INT_FOLD r;
 INLINE_INT_FOLD L1;
 INT L2;
 L1 = ((INLINE_INT_FOLD) rt_alloc(sizeof(struct INLINE_INT_FOLD_struct), INLINE_INT_FOLD_tag));
 r = L1;
 SATTR(r,sig1,s);
 L2 = INLINE_INT_FOLD_routines1;
 INLINE_INT_FOLD_routines(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ITER INLINE_ITER_create_AM_RO(INLINE_ITER self, AM_ROUT_DEF rout) {
 INLINE_ITER ret_val;
 INLINE_ITER r;
 INLINE_ITER L1;
 INT L2;
 L1 = ((INLINE_ITER) rt_alloc(sizeof(struct INLINE_ITER_struct), INLINE_ITER_tag));
 r = L1;
 SATTR(r,signature,ATTR(rout,sig11));
 INLINE_ITER_copy_iter_AM(r, rout);
 L2 = INLINE_ITER_iters;
 INLINE_ITER_iters_INT(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INT IDENT_TBL_asize_INT(IDENT_TBL self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT IDENT_TBL_elt_hash_IDENT(IDENT_TBL self, IDENT i) {
 INT ret_val = ((INT) 0);
 ret_val = STR_hash_INT(i.str);
 return ret_val;
}


INT IDENT_hash_INT(IDENT self) {
 INT ret_val = ((INT) 0);
 INT x = ((INT) 0);
 STR L1;
 INT L2;
 L1 = self.str;
 x = (SYSID(((OB) L1)));
 L2 = (((unsigned)x)*((unsigned)1664525));
 ret_val = (((unsigned)L2)+((unsigned)1013904223));
 return ret_val;
}


INT IMPL_asize_val_INT(IMPL self) {
 INT ret_val = ((INT) 0);
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT asze;
 ELT L3;
 BOOL L4;
 dTP L5;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,elts);
    L21 = IDENT_BUILTIN_asize_iden1;
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   asze = L3;
   if (ELT_is_const_reader_BOOL(asze)) {
    L5 = ATTR(ATTR(asze,sig11),ret1);
    if (L5==NULL) {
     FATAL("Dispatch on void in IMPL::asize_val:INT");
    }
    L4 = (*dTP_is_eq_dTP_BOOL[TAG(L5)+dTP_is_eq_dTP_BOOL_offset])(L5, ((dTP) TP_BUILTIN_int));
   } else {
    L4 = FALSE;
   }
   if (L4) {
    ret_val = 32;
    return ret_val;
   }
   else {
    ret_val = -1;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = -1;
 return ret_val;
}


SIG IFC_nonconforming_sig_IF(IFC self, IFC i) {
 SIG ret_val;
 SIG_TBL L11;
 SIG s;
 SIG L2;
 {
  struct SIG_TBL_eltb_SIG_frame_struct other1_0;
  SIG_TBL_eltb_SIG_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(i,sigs1);
    noname1->self = L11;
   }
   L2 = SIG_TBL_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   s = L2;
   if ((IFC_sig_conforming_to_SI(self, s)==((SIG) NULL))) {
    ret_val = s;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = ((SIG) NULL);
 return ret_val;
}


SIG IFC_sig_conforming_to_SI(IFC self, SIG s) {
 SIG ret_val;
 SIG_TBL L11;
 IDENT L21 = IDENT_zero;
 SIG ts;
 SIG L3;
 {
  struct SIG_TBL_get_queryb_IDENT_frame_struct other1_0;
  SIG_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,sigs1);
    L21 = ATTR(s,name1);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = SIG_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   ts = L3;
   if (SIG_conforms_to_SIG_BOOL(ts, s)) {
    ret_val = ts;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = ((SIG) NULL);
 return ret_val;
}


SIG IFC_sig_for_call_CALL_SI(IFC self, CALL_SIG c) {
 SIG ret_val;
 SIG r = ((SIG) NULL);
 SIG_TBL L11;
 IDENT L21 = IDENT_zero;
 SIG s;
 SIG L3;
 BOOL L4;
 BOOL L5;
 BOOL L6;
 BOOL L7;
 BOOL L8;
 BOOL L9;
 PROG L10;
 extern STR Thecall;
 STR L12;
 extern STR matchesboththefeatures;
 STR L13;
 STR L14;
 extern STR and3;
 STR L15;
 STR L16;
 extern STR name5;
 PROG L17;
 extern STR Nomatchforthecall;
 STR L18;
 extern STR name5;
 {
  struct SIG_TBL_get_queryb_IDENT_frame_struct other1_0;
  SIG_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,sigs1);
    L21 = ATTR(c,name1);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = SIG_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   s = L3;
   if (CALL_SIG_conforms_to_SIG(c, s)) {
    if ((r==((SIG) NULL))) {
     r = s;
    }
    else {
     if (ATTR(c,unknown_ret)) {
      L5 = (ATTR(r,ret1)==((dTP) NULL));
     } else {
      L5 = FALSE;
     }
     if (L5) {
      L6 = (ATTR(s,ret1)==((dTP) NULL));
      L4 = (!(L6));
     } else {
      L4 = FALSE;
     }
     if (L4) {
     }
     else {
      if (ATTR(c,unknown_ret)) {
       L9 = (ATTR(r,ret1)==((dTP) NULL));
       L8 = (!(L9));
      } else {
       L8 = FALSE;
      }
      if (L8) {
       L7 = (ATTR(s,ret1)==((dTP) NULL));
      } else {
       L7 = FALSE;
      }
      if (L7) {
       r = s;
      }
      else {
       L10 = CALL_SIG_prog_PROG(c);
       L12 = STR_plus_dSTR_STR(((STR) &Thecall), ((dSTR) CALL_SIG_str_STR(c)));
       L13 = STR_plus_dSTR_STR(L12, ((dSTR) ((STR) &matchesboththefeatures)));
       L14 = STR_plus_dSTR_STR(L13, ((dSTR) ATTR(r,str)));
       L15 = STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &and3)));
       L16 = STR_plus_dSTR_STR(L15, ((dSTR) ATTR(s,str)));
       PROG_err_STR(L10, STR_plus_dSTR_STR(L16, ((dSTR) ((STR) &name5))));
       ret_val = ((SIG) NULL);
       return ret_val;
      }
     }
    }
   }
  }
 }
 after_loop: ;
 if ((r==((SIG) NULL))) {
  L17 = CALL_SIG_prog_PROG(c);
  L18 = STR_plus_dSTR_STR(((STR) &Nomatchforthecall), ((dSTR) CALL_SIG_str_STR(c)));
  PROG_err_STR(L17, STR_plus_dSTR_STR(L18, ((dSTR) ((STR) &name5))));
 }
 ret_val = r;
 return ret_val;
}


SIG IMPL_invariant_sig_SIG(IMPL self) {
 SIG ret_val;
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT e;
 ELT L3;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,elts);
    L21 = IDENT_BUILTIN_invariant_1;
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   e = L3;
   if (ELT_is_invariant_BOOL(e)) {
    ret_val = ATTR(e,sig11);
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = ((SIG) NULL);
 return ret_val;
}


SIG IMPL_sig_for_internal_ca(IMPL self, CALL_SIG c) {
 SIG ret_val;
 SIG r = ((SIG) NULL);
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 SIG s;
 ELT L3;
 PROG L4;
 extern STR Theinternalcall;
 STR L5;
 extern STR matchesboththefeatures;
 STR L6;
 STR L7;
 extern STR and3;
 STR L8;
 STR L9;
 extern STR name5;
 PROG L10;
 extern STR Nomatchfortheinternalcal;
 STR L12;
 extern STR name5;
 {
  struct ELT_TBL_get_queryb_IDENT_frame_struct other1_0;
  ELT_TBL_get_queryb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,elts);
    L21 = ATTR(c,name1);
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = ELT_TBL_get_queryb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   s = ATTR(L3,sig11);
   if (CALL_SIG_conforms_to_SIG(c, s)) {
    if ((r==((SIG) NULL))) {
     r = s;
    }
    else {
     L4 = CALL_SIG_prog_PROG(c);
     L5 = STR_plus_dSTR_STR(((STR) &Theinternalcall), ((dSTR) CALL_SIG_str_STR(c)));
     L6 = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &matchesboththefeatures)));
     L7 = STR_plus_dSTR_STR(L6, ((dSTR) ATTR(r,str)));
     L8 = STR_plus_dSTR_STR(L7, ((dSTR) ((STR) &and3)));
     L9 = STR_plus_dSTR_STR(L8, ((dSTR) ATTR(s,str)));
     PROG_err_STR(L4, STR_plus_dSTR_STR(L9, ((dSTR) ((STR) &name5))));
    }
   }
  }
 }
 after_loop: ;
 if ((r==((SIG) NULL))) {
  L10 = CALL_SIG_prog_PROG(c);
  L12 = STR_plus_dSTR_STR(((STR) &Nomatchfortheinternalcal), ((dSTR) CALL_SIG_str_STR(c)));
  PROG_err_STR(L10, STR_plus_dSTR_STR(L12, ((dSTR) ((STR) &name5))));
 }
 ret_val = r;
 return ret_val;
}


SIG INLINE_ATTR_READ_sig_SIG(INLINE_ATTR_READ self) {
 return ATTR(self,sig11);
}


SIG INLINE_ATTR_WRITE_sig_SI(INLINE_ATTR_WRITE self) {
 return ATTR(self,sig11);
}


SIG INLINE_GLOBAL_READ_sig_S(INLINE_GLOBAL_READ self) {
 return ATTR(self,sig11);
}


SIG INLINE_INT_FOLD_sig_SIG(INLINE_INT_FOLD self) {
 return ATTR(self,sig1);
}


SIG_TBL IFC_ABS_CREATE_do_sigs_S(IFC_ABS_CREATE self) {
 SIG_TBL ret_val;
 SIG_TBL r = ((SIG_TBL) NULL);
 SIG_TBL L11;
 IFC si;
 SIG_TBL L21;
 SIG sig1;
 INT i = ((INT) 0);
 SIG cs;
 SIG L3;
 SIG L4;
 BOOL L5;
 INT L6;
 BOOL L7;
 BOOL L8;
 PROG L9;
 PROG L10;
 extern STR Thesignatures;
 STR L12;
 extern STR and3;
 STR L13;
 STR L14;
 extern STR mustbedisambiguatedbyane;
 {
  struct SIG_TBL_eltb_SIG_frame_struct other1_0;
  SIG_TBL_eltb_SIG_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,class_sigs);
    noname1->self = L11;
   }
   L3 = SIG_TBL_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = SIG_TBL_insert_SIG_SIG_T(r, L3);
  }
 }
 after_loop: ;
 while (1) {
  if (FLISTIFC_is_empty_BOOL(ATTR(self,supers))) {
   goto after_loop1;
  }
  else {
   si = FLISTIFC_pop_IFC(ATTR(self,supers));
   {
    struct SIG_TBL_eltb_SIG_frame_struct other3_0;
    SIG_TBL_eltb_SIG_frame 
    noname2 = &other3_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = ATTR(si,sigs1);
      noname2->self = L21;
     }
     L4 = SIG_TBL_eltb_SIG(noname2);
     if (noname2->state == -1) {
      goto after_loop2;
     }
     sig1 = L4;
     L5 = (SIG_TBL_sig_conflicting_(r, sig1)==((SIG) NULL));
     if ((!(L5))) {
     }
     else {
      i = 0;
      while (1) {
       L6 = FLISTIFC_size_INT(ATTR(self,supers));
       if ((i<L6)) {
       }
       else {
        goto after_loop3;
       }
       cs = SIG_TBL_sig_conflicting_(ATTR(FLISTIFC_aget_INT_IFC(ATTR(self,supers), i),sigs1), sig1);
       L7 = (cs==((SIG) NULL));
       if ((!(L7))) {
        L8 = SIG_is_eq_but_tp_SIG_BOO(cs, sig1);
        if ((!(L8))) {
         L9 = IFC_ABS_CREATE_prog_PROG(self);
         PROG_err_loc_dPROG_ERR(L9, ((dPROG_ERR) ATTR(self,tr)));
         L10 = IFC_ABS_CREATE_prog_PROG(self);
         L12 = STR_plus_dSTR_STR(((STR) &Thesignatures), ((dSTR) ATTR(sig1,str)));
         L13 = STR_plus_dSTR_STR(L12, ((dSTR) ((STR) &and3)));
         L14 = STR_plus_dSTR_STR(L13, ((dSTR) ATTR(cs,str)));
         PROG_err_STR(L10, STR_plus_dSTR_STR(L14, ((dSTR) ((STR) &mustbedisambiguatedbyane))));
        }
       }
       i = (INTPLUS(i,1));
      }
      after_loop3: ;
      r = SIG_TBL_insert_SIG_SIG_T(r, SIG_with_new_type_dTP_SI(sig1, ((dTP) ATTR(self,tp1))));
     }
    }
   }
   after_loop2: ;
  }
 }
 after_loop1: ;
 ret_val = r;
 return ret_val;
}


STR GET_OPTIONS_directory_ST(GET_OPTIONS self, STR nm) {
 STR ret_val;
 INT pos = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 STR r;
 INT L3;
 INT L4;
 CHAR L5;
 extern STR name1;
 extern STR name5;
 {
  struct INT_downtob_INT_INT_frame_struct other1_0;
  INT_downtob_INT_INT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L4 = STR_size_INT(nm);
    L11 = (INTMINUS(L4,1));
    L21 = 0;
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = INT_downtob_INT_INT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   pos = L3;
   L5 = (STRAGET(nm,pos));
   if ((L5=='/')) {
    goto after_loop;
   }
  }
 }
 after_loop: ;
 r = STR_head_INT_STR(nm, pos);
 if (STR_is_eq_STR_BOOL(r, ((STR) &name1))) {
  r = ((STR) &name5);
 }
 ret_val = r;
 return ret_val;
}


STR GET_OPTIONS_mention_STR_(GET_OPTIONS self, STR name11, STR s1, STR s2) {
 STR ret_val;
 extern STR name1;
 dSTR L1;
 STR L2;
 STR L3;
 extern STR name14;
 STR L4;
 if (STR_is_neq_STR_BOOL(s2, ((STR) &name1))) {
  L1 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
  ((CHAR_boxed) L1)->value_part = '\n';
  L2 = STR_plus_dSTR_STR(s1, L1);
  L3 = STR_plus_dSTR_STR(L2, ((dSTR) name11));
  L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &name14)));
  ret_val = STR_plus_dSTR_STR(L4, ((dSTR) s2));
  return ret_val;
 }
 else {
  ret_val = s1;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


STR GET_OPTIONS_next_arg_STR(GET_OPTIONS self) {
 STR ret_val;
 STR res;
 INT L1;
 extern STR name1;
 if (GET_OPTIONS_more_args_BO(self)) {
  res = ARRAYSTR_aget_INT_STR(ATTR(self,args1), ATTR(self,next));
  L1 = ATTR(self,next);
  SATTR(self,next,(INTPLUS(L1,1)));
  ret_val = res;
  return ret_val;
 }
 else {
  GET_OPTIONS_usage(self);
  ret_val = ((STR) &name1);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


STR GET_OPTIONS_str_STR(GET_OPTIONS self) {
 STR ret_val;
 STR r = ((STR) NULL);
 STR s = ((STR) NULL);
 FSETSTR L11;
 extern STR name1;
 dSTR L2;
 STR L3;
 STR L4;
 extern STR Satherfiles;
 extern STR name1;
 extern STR Mainclass;
 extern STR Homedirectory;
 STR L5;
 extern STR Prolix;
 extern STR Verbose;
 extern STR AcceptpSathercode;
 r = ((STR) &name1);
 {
  struct FSETSTR_eltb_STR_frame_struct other1_0;
  FSETSTR_eltb_STR_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   L2 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L2)->value_part = ' ';
   L3 = STR_plus_dSTR_STR(r, L2);
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,prog1),sather_files);
    noname1->self = L11;
   }
   L4 = FSETSTR_eltb_STR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = STR_plus_dSTR_STR(L3, ((dSTR) L4));
  }
 }
 after_loop: ;
 s = GET_OPTIONS_mention_STR_(self, ((STR) &Satherfiles), ((STR) &name1), r);
 s = GET_OPTIONS_mention_STR_(self, ((STR) &Mainclass), s, ATTR(ATTR(self,prog1),main_class));
 L5 = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &Homedirectory)));
 s = STR_plus_dSTR_STR(L5, ((dSTR) ATTR(ATTR(self,prog1),home)));
 if (ATTR(ATTR(self,prog1),prolix)) {
  s = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &Prolix)));
 }
 if (ATTR(ATTR(self,prog1),verbose)) {
  s = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &Verbose)));
 }
 if (ATTR(ATTR(self,prog1),psather)) {
  s = STR_plus_dSTR_STR(s, ((dSTR) ((STR) &AcceptpSathercode)));
 }
 ret_val = s;
 return ret_val;
}


STR GET_OPTIONS_suffix_STR_S(GET_OPTIONS self, STR a) {
 STR ret_val;
 INT pos = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT L3;
 INT L4;
 CHAR L5;
 INT L6;
 {
  struct INT_downtob_INT_INT_frame_struct other1_0;
  INT_downtob_INT_INT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L4 = STR_length_INT(a);
    L11 = (INTMINUS(L4,1));
    L21 = 0;
    noname1->self = L11;
    noname1->arg1 = L21;
   }
   L3 = INT_downtob_INT_INT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   pos = L3;
   L5 = (STRAGET(a,pos));
   if ((L5=='.')) {
    goto after_loop;
   }
  }
 }
 after_loop: ;
 L6 = STR_length_INT(a);
 ret_val = STR_tail_INT_STR(a, (INTMINUS(L6,pos)));
 return ret_val;
}


STR IDENT_next_tmp_STR_STR(IDENT self, STR oldident) {
 STR ret_val;
 STR ret;
 extern STR S_pS_;
 STR L1;
 extern STR S_;
 STR L2;
 INT L3;
 ret = STR_create_STR(((STR) NULL));
 L1 = STR_plus_dSTR_STR(((STR) &S_pS_), ((dSTR) oldident));
 L2 = STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &S_)));
 ret = STR_plus_dSTR_STR(L2, ((dSTR) INT_str_STR(IDENT_tmp_count)));
 L3 = IDENT_tmp_count;
 IDENT_tmp_count_INT(self, (INTPLUS(L3,1)));
 ret_val = ret;
 return ret_val;
}


STR IFC_TBL_tup_str_TUPIDENT(IFC_TBL self, TUPIDENTINT t) {
 STR ret_val;
 STR r;
 INT L11 = ((INT) 0);
 STR L21;
 INT L3;
 extern STR name23;
 INT L4;
 INT noname1t;
 STR L5;
 extern STR name2;
 extern STR S_;
 extern STR name19;
 r = t.t1.str;
 L3 = t.t2;
 if ((L3==0)) {
  ret_val = r;
  return ret_val;
 }
 r = STR_plus_dSTR_STR(r, ((dSTR) ((STR) &name23)));
 {
  BOOL noname1 = TRUE;
  struct STR_separateb_STR_STR_frame_struct other1_0;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_0;
  noname2->state = 0;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = t.t2;
    L4 = L11;
    noname1t = L4;
   } else {
    noname1t--;
   }
   if (noname1t<=0) goto after_loop;
   /* no return value from inlined iter */;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = ((STR) &S_);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   r = STR_plus_dSTR_STR(r, ((dSTR) L5));
  }
 }
 after_loop: ;
 r = STR_plus_dSTR_STR(r, ((dSTR) ((STR) &name19)));
 ret_val = r;
 return ret_val;
}


STR IMPL_TBL_tup_str_TUPIDEN(IMPL_TBL self, TUPIDENTINT t) {
 STR ret_val;
 STR r;
 INT L11 = ((INT) 0);
 STR L21;
 INT L3;
 extern STR name23;
 INT L4;
 INT noname1t;
 STR L5;
 extern STR name2;
 extern STR S_;
 extern STR name19;
 r = t.t1.str;
 L3 = t.t2;
 if ((L3==0)) {
  ret_val = r;
  return ret_val;
 }
 r = STR_plus_dSTR_STR(r, ((dSTR) ((STR) &name23)));
 {
  BOOL noname1 = TRUE;
  struct STR_separateb_STR_STR_frame_struct other1_0;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_0;
  noname2->state = 0;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = t.t2;
    L4 = L11;
    noname1t = L4;
   } else {
    noname1t--;
   }
   if (noname1t<=0) goto after_loop;
   /* no return value from inlined iter */;
   if (noname2->state == 0) {
    L21 = ((STR) &name2);
    noname2->self = L21;
   }
   noname2->arg1 = ((STR) &S_);
   L5 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   r = STR_plus_dSTR_STR(r, ((dSTR) L5));
  }
 }
 after_loop: ;
 r = STR_plus_dSTR_STR(r, ((dSTR) ((STR) &name19)));
 ret_val = r;
 return ret_val;
}


TP_CLASS IMPL_CREATE_get_arr_TP_C(IMPL_CREATE self) {
 TP_CLASS ret_val;
 TP_CLASS r = ((TP_CLASS) NULL);
 FLISTIMPL_INCLUDE L11;
 IMPL_INCLUDE inc;
 TP_CLASS a;
 BOOL L2;
 INT L3;
 BOOL L4;
 INT L5;
 IMPL_INCLUDE L6;
 BOOL L7;
 if (IDENT_is_eq_IDENT_BOOL(ATTR(ATTR(self,tp1),name1), IDENT_BUILTIN_AREF_ident1)) {
  L3 = ARRAYdTP_size_INT(ATTR(ATTR(self,tp1),params));
  L2 = (L3==1);
 } else {
  L2 = FALSE;
 }
 if (L2) {
  ret_val = ATTR(self,tp1);
  return ret_val;
 }
 if (IDENT_is_eq_IDENT_BOOL(ATTR(ATTR(self,tp1),name1), IDENT_BUILTIN_AVAL_ident1)) {
  L5 = ARRAYdTP_size_INT(ATTR(ATTR(self,tp1),params));
  L4 = (L5==1);
 } else {
  L4 = FALSE;
 }
 if (L4) {
  ret_val = ATTR(self,tp1);
  return ret_val;
 }
 {
  struct FLISTIMPL_INCLUDE_eltb_I_frame_struct other1_0;
  FLISTIMPL_INCLUDE_eltb_I_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,incs);
    noname1->self = L11;
   }
   L6 = FLISTIMPL_INCLUDE_eltb_I(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   inc = L6;
   a = ATTR(ATTR(inc,impl),arr1);
   L7 = (a==((TP_CLASS) NULL));
   if ((!(L7))) {
    if ((r==((TP_CLASS) NULL))) {
     r = a;
    }
    else {
     if (TP_CLASS_is_eq_dTP_BOOL(r, ((dTP) a))) {
     }
     else {
      IMPL_CREATE_array_confli(self, inc, r, a);
     }
    }
   }
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


TP_CLASS IMPL_INCLUDE_included_tp(IMPL_INCLUDE self) {
 TP_CLASS ret_val;
 TP_CONTEXT con;
 dTP r;
 PROG L1;
 PROG L2;
 extern STR Classesmaynotincludeabst;
 INT L3;
 INT L4;
 con = TP_CLASS_tp_context_for_(ATTR(self,tp1));
 if (TP_CONTEXT_type_spec_is_(con, ATTR(ATTR(self,as1),tp1))) {
  IMPL_INCLUDE_param_inclu(self, ((dAS_CLASS_ELT) ATTR(self,as1)));
  ret_val = ((TP_CLASS) NULL);
  return ret_val;
 }
 r = TP_CONTEXT_tp_of_AS_TYPE(con, ATTR(ATTR(self,as1),tp1));
 if (r==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(r)) {
  case TP_CLASS_tag:
   if (TP_CLASS_is_abstract_BOO(((TP_CLASS) r))) {
    L1 = IMPL_INCLUDE_prog_PROG(self);
    PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(self,as1)));
    L2 = IMPL_INCLUDE_prog_PROG(self);
    PROG_err_STR(L2, ((STR) &Classesmaynotincludeabst));
    ret_val = ((TP_CLASS) NULL);
    return ret_val;
   }
   L3 = TP_CLASS_kind_INT(((TP_CLASS) r));
   L4 = TP_KIND_ext_tp;
   if ((L3==L4)) {
    IMPL_INCLUDE_include_ext(self, ((dAS_CLASS_ELT) ATTR(self,as1)));
    ret_val = ((TP_CLASS) NULL);
    return ret_val;
   }
   ret_val = ((TP_CLASS) r);
   return ret_val; break;
  case TP_ROUT_tag:
   IMPL_INCLUDE_include_bou(self, ((dAS_CLASS_ELT) ATTR(self,as1)));
   ret_val = ((TP_CLASS) NULL);
   return ret_val; break;
  case TP_ITER_tag:
   IMPL_INCLUDE_include_bou(self, ((dAS_CLASS_ELT) ATTR(self,as1)));
   ret_val = ((TP_CLASS) NULL);
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


dAM_EXPR INLINE_ATTR_READ_inline_(INLINE_ATTR_READ self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 AM_ATTR_EXPR r;
 INT L1;
 L1 = INLINE_ATTR_READ_inlined1;
 INLINE_ATTR_READ_inlined(self, (INTPLUS(L1,1)));
 r = AM_ATTR_EXPR_create_SFIL(((AM_ATTR_EXPR) NULL), ATTR(call11,source11));
 SATTR(r,ob1,AM_ROUT_CALL_EXPR_aget_I(call11, 0));
 SATTR(r,self_tp,ATTR(self,self_tp));
 SATTR(r,at11,ATTR(self,at11));
 SATTR(r,tp_at,ATTR(self,tp_at));
 ret_val = ((dAM_EXPR) r);
 return ret_val;
}


dAM_EXPR INLINE_ATTR_WRITE_inline2(INLINE_ATTR_WRITE self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 AM_ATTR_EXPR a;
 AM_ASSIGN_STMT as;
 AM_STMT_EXPR r;
 INT L1;
 L1 = INLINE_ATTR_WRITE_inline1;
 INLINE_ATTR_WRITE_inline(self, (INTPLUS(L1,1)));
 a = AM_ATTR_EXPR_create_SFIL(((AM_ATTR_EXPR) NULL), ATTR(call11,source11));
 SATTR(a,ob1,AM_ROUT_CALL_EXPR_aget_I(call11, 0));
 SATTR(a,self_tp,ATTR(self,self_tp));
 SATTR(a,at11,ATTR(self,at11));
 SATTR(a,tp_at,ATTR(self,tp_at));
 as = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(call11,source11));
 SATTR(as,dest,((dAM_EXPR) a));
 SATTR(as,src11,AM_ROUT_CALL_EXPR_aget_I(call11, 1));
 r = AM_STMT_EXPR_create_SFIL(((AM_STMT_EXPR) NULL), ATTR(call11,source11));
 SATTR(r,stmts,((dAM_STMT) as));
 ret_val = ((dAM_EXPR) r);
 return ret_val;
}


dAM_EXPR INLINE_GLOBAL_READ_inlin2(INLINE_GLOBAL_READ self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 INT L1;
 L1 = INLINE_GLOBAL_READ_inlin1;
 INLINE_GLOBAL_READ_inlin(self, (INTPLUS(L1,1)));
 ret_val = ((dAM_EXPR) ATTR(self,age11));
 return ret_val;
}


dAM_EXPR INLINE_INT_FOLD_inline_A(INLINE_INT_FOLD self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 dAM_EXPR arg11;
 dAM_EXPR arg21;
 AM_INT_CONST r;
 INT L1;
 arg11 = AM_ROUT_CALL_EXPR_aget_I(call11, 0);
 arg21 = AM_ROUT_CALL_EXPR_aget_I(call11, 1);
 if (arg11==NULL) {
 } else
 switch (TAG(arg11)) {
  case AM_INT_CONST_tag:
   if (arg21==NULL) {
   } else
   switch (TAG(arg21)) {
    case AM_INT_CONST_tag:
     r = AM_INT_CONST_create_SFIL(((AM_INT_CONST) NULL), ATTR(((AM_INT_CONST) arg11),source11));
     SATTR(r,val11,INTI_plus_INTI_INTI(ATTR(((AM_INT_CONST) arg11),val11), ATTR(((AM_INT_CONST) arg21),val11)));
     SATTR(r,tp_at,ATTR(((AM_INT_CONST) arg11),tp_at));
     L1 = INLINE_INT_FOLD_inlined;
     INLINE_INT_FOLD_inlined_(self, (INTPLUS(L1,1)));
     ret_val = ((dAM_EXPR) r);
     return ret_val; break;
    default: ;
   } break;
  default: ;
 }
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}


dAM_EXPR INLINE_ITER_inline_AM_IT(INLINE_ITER self, AM_ITER_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 AM_BOOL_CONST bcfalse;
 AM_BOOL_CONST bctrue;
 AM_STMT_EXPR se;
 XFORM_CODE xc1;
 AM_LOOP_STMT proxy_loop_stmt;
 dAM_STMT init_nonhot;
 dAM_STMT s;
 ARRAYINT L11;
 dAM_STMT init_hot;
 ARRAYINT L21;
 dAM_STMT ftm1;
 AM_LOCAL_EXPR if_first;
 AM_IF_STMT iffstmt1;
 dAM_STMT init_vars;
 dAM_STMT ftm2;
 dAM_STMT BEFLOOP;
 AM_ASSIGN_STMT ass;
 dAM_STMT nftm2 = ((dAM_STMT) NULL);
 dAM_STMT ITERM;
 AM_IF_STMT iffstmt2;
 AM_LOCAL_EXPR if_yld;
 AM_LOOP_STMT loopstmt;
 dAM_STMT lbd;
 AM_IF_STMT ifcstmt;
 AM_IF_STMT ifzstmt;
 FLISTAM_LOCAL_EXPR L31;
 INT L4;
 INT L5;
 dAM_STMT L6;
 INT L7;
 dAM_STMT L8;
 BOOL L9;
 dAM_STMT L10;
 SFILE_ID L12;
 extern STR S_if_first;
 IDENT L13;
 BOOL L14;
 dAM_STMT L15;
 BOOL L16;
 dAM_STMT L17;
 BOOL L18;
 BOOL L19;
 dAM_STMT L20;
 BOOL L22;
 dAM_STMT L23;
 dAM_STMT L24;
 BOOL L25;
 dAM_STMT L26;
 BOOL L27;
 SFILE_ID L28;
 extern STR S_if_yld;
 IDENT L29;
 dAM_STMT L30;
 BOOL L32;
 dAM_STMT L33;
 dAM_STMT L34;
 dAM_STMT L35;
 dAM_STMT L36;
 dAM_STMT L37;
 dAM_STMT L38;
 dAM_STMT L39;
 BOOL L40;
 INT L41;
 FLISTAM_LOCAL_EXPR L42;
 FMAPAM_LOCAL_EXPRAM_LOCA L43;
 AM_LOCAL_EXPR L44;
 L4 = INLINE_ITER_inlined;
 INLINE_ITER_inlined_INT(self, (INTPLUS(L4,1)));
 bcfalse = AM_BOOL_CONST_create_SFI(((AM_BOOL_CONST) NULL), ATTR(call11,source11));
 SATTR(bcfalse,tp_at,((dTP) TP_BUILTIN_bool));
 SATTR(bcfalse,val11,FALSE);
 bctrue = AM_BOOL_CONST_create_SFI(((AM_BOOL_CONST) NULL), ATTR(call11,source11));
 SATTR(bctrue,tp_at,((dTP) TP_BUILTIN_bool));
 SATTR(bctrue,val11,TRUE);
 se = AM_STMT_EXPR_create_SFIL(((AM_STMT_EXPR) NULL), ATTR(call11,source11));
 CHANGE_VARS_new_copy_SFI(ATTR(self,change_vars), ATTR(call11,source11));
 SATTR(se,locals1,ATTR(ATTR(self,change_vars),new_vars));
 xc1 = XFORM_CODE_create_FMAPAM(((XFORM_CODE) NULL), ATTR(ATTR(self,change_vars),new_subst));
 SATTR(xc1,record_calls,TRUE);
 proxy_loop_stmt = AM_LOOP_STMT_create_SFIL(((AM_LOOP_STMT) NULL), ATTR(call11,source11));
 SATTR(xc1,new_loop_stmt,proxy_loop_stmt);
 init_nonhot = XFORM_CODE_xform_stmt_li(xc1, ATTR(ATTR(self,change_vars),init_nonhot1));
 s = init_nonhot;
 {
  struct ARRAYINT_eltb_INT_frame_struct other1_0;
  ARRAYINT_eltb_INT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if ((s==((dAM_STMT) NULL))) {
    goto after_loop;
   }
   if (s==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(s)) {
    case AM_ASSIGN_STMT_tag:
     if ((ATTR(((AM_ASSIGN_STMT) s),src11)==((dAM_EXPR) NULL))) {
      if (noname1->state == 0) {
       L11 = ATTR(ATTR(self,change_vars),pind_nonhot);
       noname1->self = L11;
      }
      L5 = ARRAYINT_eltb_INT(noname1);
      if (noname1->state == -1) {
       goto after_loop;
      }
      SATTR(((AM_ASSIGN_STMT) s),src11,AM_ITER_CALL_EXPR_aget_I(call11, L5));
     } break;
    default: ;
     FATAL("No applicable type in typecase");
   }
   L6 = s;
   if (L6==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
   }
   s = (*dAM_STMT_next_dAM_STMT[TAG(L6)+dAM_STMT_next_dAM_STMT_offset])(L6);
  }
 }
 after_loop: ;
 init_hot = XFORM_CODE_xform_stmt_li(xc1, ATTR(ATTR(self,change_vars),init_hot1));
 s = init_hot;
 {
  struct ARRAYINT_eltb_INT_frame_struct other2_0;
  ARRAYINT_eltb_INT_frame 
  noname2 = &other2_0;
  noname2->state = 0;
  while (1) {
   if ((s==((dAM_STMT) NULL))) {
    goto after_loop1;
   }
   if (s==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(s)) {
    case AM_ASSIGN_STMT_tag:
     if ((ATTR(((AM_ASSIGN_STMT) s),src11)==((dAM_EXPR) NULL))) {
      if (noname2->state == 0) {
       L21 = ATTR(ATTR(self,change_vars),pind_hot);
       noname2->self = L21;
      }
      L7 = ARRAYINT_eltb_INT(noname2);
      if (noname2->state == -1) {
       goto after_loop1;
      }
      SATTR(((AM_ASSIGN_STMT) s),src11,AM_ITER_CALL_EXPR_aget_I(call11, L7));
     } break;
    default: ;
     FATAL("No applicable type in typecase");
   }
   L8 = s;
   if (L8==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
   }
   s = (*dAM_STMT_next_dAM_STMT[TAG(L8)+dAM_STMT_next_dAM_STMT_offset])(L8);
  }
 }
 after_loop1: ;
 ftm1 = ATTR(call11,init1);
 L9 = (ftm1==((dAM_STMT) NULL));
 if ((!(L9))) {
  L10 = ftm1;
  if (L10==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L10)+dAM_STMT_append_dAM_STMT_offset])(L10, init_nonhot);
 }
 else {
  ftm1 = init_nonhot;
 }
 L12 = ATTR(call11,source11);
 L13 = IDENT_create_STR_IDENT(IDENT_zero, STR_plus_dSTR_STR(ATTR(INLINE_ITER_sig_SIG(self),name1).str, ((dSTR) ((STR) &S_if_first))));
 if_first = AM_LOCAL_EXPR_create_SFI1(((AM_LOCAL_EXPR) NULL), L12, L13, ((dTP) TP_BUILTIN_bool));
 SATTR(se,locals1,FLISTAM_LOCAL_EXPR_push_(ATTR(se,locals1), if_first));
 iffstmt1 = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(call11,source11));
 SATTR(iffstmt1,test11,((dAM_EXPR) if_first));
 SATTR(iffstmt1,if_true,ftm1);
 SATTR(iffstmt1,if_false,((dAM_STMT) NULL));
 SATTR(se,stmts,((dAM_STMT) iffstmt1));
 init_vars = XFORM_CODE_xform_stmt_li(xc1, ATTR(ATTR(self,change_vars),init_vars1));
 ftm2 = init_vars;
 BEFLOOP = XFORM_CODE_xform_stmt_li(xc1, ATTR(self,BEFLOOP_code));
 L14 = (ftm2==((dAM_STMT) NULL));
 if ((!(L14))) {
  L15 = ftm2;
  if (L15==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L15)+dAM_STMT_append_dAM_STMT_offset])(L15, BEFLOOP);
 }
 else {
  ftm2 = BEFLOOP;
 }
 ass = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(call11,source11));
 SATTR(ass,dest,((dAM_EXPR) if_first));
 SATTR(ass,src11,((dAM_EXPR) bcfalse));
 L16 = (ftm2==((dAM_STMT) NULL));
 if ((!(L16))) {
  L17 = ftm2;
  if (L17==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L17)+dAM_STMT_append_dAM_STMT_offset])(L17, ((dAM_STMT) ass));
 }
 else {
  ftm2 = ((dAM_STMT) ass);
 }
 L18 = ATTR(self,flat_yield);
 if ((!(L18))) {
  nftm2 = XFORM_CODE_xform_stmt_li(xc1, ATTR(self,WYAFT_code));
 }
 ITERM = XFORM_CODE_xform_stmt_li(xc1, ATTR(self,ITERM_code));
 L19 = (nftm2==((dAM_STMT) NULL));
 if ((!(L19))) {
  L20 = nftm2;
  if (L20==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L20)+dAM_STMT_append_dAM_STMT_offset])(L20, ITERM);
 }
 else {
  nftm2 = ITERM;
 }
 L22 = (init_hot==((dAM_STMT) NULL));
 if ((!(L22))) {
  L23 = ATTR(se,stmts);
  if (L23==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L23)+dAM_STMT_append_dAM_STMT_offset])(L23, init_hot);
  iffstmt2 = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(call11,source11));
  SATTR(iffstmt2,test11,((dAM_EXPR) if_first));
  SATTR(iffstmt2,if_true,ftm2);
  SATTR(iffstmt2,if_false,nftm2);
  L24 = ATTR(se,stmts);
  if (L24==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L24)+dAM_STMT_append_dAM_STMT_offset])(L24, ((dAM_STMT) iffstmt2));
 }
 else {
  L25 = (ATTR(iffstmt1,if_true)==((dAM_STMT) NULL));
  if ((!(L25))) {
   L26 = ATTR(iffstmt1,if_true);
   if (L26==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
   }
   (*dAM_STMT_append_dAM_STMT[TAG(L26)+dAM_STMT_append_dAM_STMT_offset])(L26, ftm2);
  }
  else {
   SATTR(iffstmt1,if_true,ftm2);
  }
  SATTR(iffstmt1,if_false,nftm2);
 }
 L27 = ATTR(self,flat_yield);
 if ((!(L27))) {
  L28 = ATTR(call11,source11);
  L29 = IDENT_create_STR_IDENT(IDENT_zero, STR_plus_dSTR_STR(ATTR(INLINE_ITER_sig_SIG(self),name1).str, ((dSTR) ((STR) &S_if_yld))));
  if_yld = AM_LOCAL_EXPR_create_SFI1(((AM_LOCAL_EXPR) NULL), L28, L29, ((dTP) TP_BUILTIN_bool));
  SATTR(se,locals1,FLISTAM_LOCAL_EXPR_push_(ATTR(se,locals1), if_yld));
  ass = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(call11,source11));
  SATTR(ass,dest,((dAM_EXPR) if_yld));
  SATTR(ass,src11,((dAM_EXPR) bcfalse));
  L30 = ATTR(se,stmts);
  if (L30==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L30)+dAM_STMT_append_dAM_STMT_offset])(L30, ((dAM_STMT) ass));
  loopstmt = AM_LOOP_STMT_create_SFIL(((AM_LOOP_STMT) NULL), ATTR(call11,source11));
  SATTR(loopstmt,has_yield,FALSE);
  lbd = XFORM_CODE_xform_stmt_li(xc1, ATTR(self,IINIT_code));
  ass = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(call11,source11));
  SATTR(ass,dest,((dAM_EXPR) if_yld));
  SATTR(ass,src11,((dAM_EXPR) bctrue));
  AM_ASSIGN_STMT_append_dA(ass, ((dAM_STMT) AM_BREAK_STMT_create_SFI(((AM_BREAK_STMT) NULL), ATTR(call11,source11))));
  ifcstmt = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(call11,source11));
  SATTR(ifcstmt,test11,XFORM_CODE_xform_expr_dA(xc1, ATTR(self,yield_cond)));
  SATTR(ifcstmt,if_true,((dAM_STMT) ass));
  SATTR(ifcstmt,if_false,((dAM_STMT) NULL));
  L32 = (lbd==((dAM_STMT) NULL));
  if ((!(L32))) {
   L33 = lbd;
   if (L33==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
   }
   (*dAM_STMT_append_dAM_STMT[TAG(L33)+dAM_STMT_append_dAM_STMT_offset])(L33, ((dAM_STMT) ifcstmt));
  }
  else {
   lbd = ((dAM_STMT) ifcstmt);
  }
  L34 = lbd;
  if (L34==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L34)+dAM_STMT_append_dAM_STMT_offset])(L34, XFORM_CODE_xform_stmt_li(xc1, ATTR(self,WNOY_code)));
  L35 = lbd;
  if (L35==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L35)+dAM_STMT_append_dAM_STMT_offset])(L35, XFORM_CODE_xform_stmt_li(xc1, ATTR(self,ITERM_code)));
  SATTR(loopstmt,body,lbd);
  L36 = ATTR(se,stmts);
  if (L36==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L36)+dAM_STMT_append_dAM_STMT_offset])(L36, ((dAM_STMT) loopstmt));
  ifzstmt = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(call11,source11));
  SATTR(ifzstmt,test11,((dAM_EXPR) if_yld));
  SATTR(ifzstmt,if_true,XFORM_CODE_xform_stmt_li(xc1, ATTR(self,WYBEF_code)));
  SATTR(ifzstmt,if_false,((dAM_STMT) AM_BREAK_STMT_create_SFI(((AM_BREAK_STMT) NULL), ATTR(call11,source11))));
  L37 = ATTR(se,stmts);
  if (L37==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L37)+dAM_STMT_append_dAM_STMT_offset])(L37, ((dAM_STMT) ifzstmt));
 }
 else {
  L38 = ATTR(se,stmts);
  L39 = L38;
  if (L39==NULL) {
   FATAL("Dispatch on void in INLINE_ITER::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L39)+dAM_STMT_append_dAM_STMT_offset])(L39, XFORM_CODE_xform_stmt_li(xc1, ATTR(self,IINIT_code)));
 }
 L40 = (ATTR(self,yield_val)==((dAM_EXPR) NULL));
 if ((!(L40))) {
  SATTR(se,expr,XFORM_CODE_xform_expr_dA(xc1, ATTR(self,yield_val)));
 }
 SATTR(se,calls1,ATTR(xc1,calls1));
 SATTR(se,its1,ATTR(proxy_loop_stmt,its1));
 SATTR(se,bits1,ATTR(proxy_loop_stmt,bits1));
 L41 = FLISTAM_LOCAL_EXPR_size_(ATTR(self,loop_firsts));
 SATTR(se,firsts,FLISTAM_LOCAL_EXPR_creat(((FLISTAM_LOCAL_EXPR) NULL), (INTPLUS(L41,1))));
 SATTR(se,firsts,FLISTAM_LOCAL_EXPR_push_(ATTR(se,firsts), if_first));
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other3_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname3 = &other3_0;
  noname3->state = 0;
  while (1) {
   L42 = ATTR(se,firsts);
   L43 = ATTR(ATTR(self,change_vars),new_subst);
   if (noname3->state == 0) {
    L31 = ATTR(self,loop_firsts);
    noname3->self = L31;
   }
   L44 = FLISTAM_LOCAL_EXPR_eltb_(noname3);
   if (noname3->state == -1) {
    goto after_loop2;
   }
   SATTR(se,firsts,FLISTAM_LOCAL_EXPR_push_(L42, FMAPAM_LOCAL_EXPRAM_LOCA19(L43, L44)));
  }
 }
 after_loop2: ;
 SYSDESTROY(((OB) proxy_loop_stmt));
 CHANGE_VARS_after_one_us(ATTR(self,change_vars));
 SYSDESTROY(((OB) xc1));
 ret_val = ((dAM_EXPR) se);
 return ret_val;
}


dAM_EXPR INLINE_inline_AM_ITER_CA(INLINE self, AM_ITER_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 dINLINE_ITER_SIG inl;
 dINLINE_ITER_SIG L1;
 inl = INLINE_ITER_TBL_get_quer(ATTR(self,itbl), ATTR(call11,fun));
 if ((inl==((dINLINE_ITER_SIG) NULL))) {
  ret_val = ((dAM_EXPR) call11);
  return ret_val;
 }
 L1 = inl;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE::inline(AM_ITER_CALL_EXPR):$AM_EXPR");
 }
 ret_val = (*dINLINE_ITER_SIG_inline_[TAG(L1)+dINLINE_ITER_SIG_inline__offset])(L1, call11);
 return ret_val;
}


dAM_EXPR INLINE_inline_AM_ROUT_CA(INLINE self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 dINLINE_ROUT_SIG in;
 dINLINE_ROUT_SIG L1;
 in = INLINE_ROUT_TBL_get_quer(ATTR(self,rtbl), ATTR(call11,fun));
 if ((in==((dINLINE_ROUT_SIG) NULL))) {
  ret_val = ((dAM_EXPR) call11);
  return ret_val;
 }
 L1 = in;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE::inline(AM_ROUT_CALL_EXPR):$AM_EXPR");
 }
 ret_val = (*dINLINE_ROUT_SIG_inline_[TAG(L1)+dINLINE_ROUT_SIG_inline__offset])(L1, call11);
 return ret_val;
}


void GET_OPTIONS_barf_STR(GET_OPTIONS self, STR msg1) {
 ERR1 L1;
 ERR1 L2;
 dSTR L3;
 L1 = ERR_create_ERR(((ERR1) NULL));
 L2 = ERR_plus_dSTR_ERR(L1, ((dSTR) msg1));
 L3 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L3)->value_part = '\n';
 ERR_plus_dSTR(L2, L3);
 UNIX_exit_INT(((UNIX) NULL), 1);
}


void GET_OPTIONS_get_files(GET_OPTIONS self) {
 STR arg;
 STR suf;
 STR path11;
 BOOL L1;
 extern STR sa;
 BOOL L2;
 extern STR module;
 while (1) {
  if (GET_OPTIONS_more_args_BO(self)) {
  }
  else {
   goto after_loop;
  }
  arg = GET_OPTIONS_next_arg_STR(self);
  L1 = GET_OPTIONS_is_filename_(self, arg);
  if ((!(L1))) {
   GET_OPTIONS_rewind(self);
   goto after_loop;
  }
  suf = GET_OPTIONS_suffix_STR_S(self, arg);
  if (STR_is_eq_STR_BOOL(suf, ((STR) &sa))) {
   path11 = FILE_resolve_path_STR_ST(((FILE1) NULL), arg);
   L2 = FSETSTR_test_STR_BOOL(ATTR(self,paths), path11);
   if ((!(L2))) {
    SATTR(ATTR(self,prog1),sather_files,FSETSTR_insert_STR_FSETS(ATTR(ATTR(self,prog1),sather_files), arg));
    SATTR(self,paths,FSETSTR_insert_STR_FSETS(ATTR(self,paths), path11));
   }
  }
  else {
   if (STR_is_eq_STR_BOOL(suf, ((STR) &module))) {
    GET_OPTIONS_insert_here_(self, GET_OPTIONS_args_from_fi(self, arg));
   }
   else {
    GET_OPTIONS_handle_other(self, arg, suf);
    return;
   }
  }
 }
 after_loop: ;
}


void GET_OPTIONS_handle_files(GET_OPTIONS self, STR s) {
 if (GET_OPTIONS_is_filename_(self, s)) {
  GET_OPTIONS_rewind(self);
  GET_OPTIONS_get_files(self);
 }
 else {
  GET_OPTIONS_rewind(self);
  GET_OPTIONS_usage(self);
  return;
 }
}


void GET_OPTIONS_handle_other(GET_OPTIONS self, STR arg, STR suf) {
 STR L11;
 extern STR c1;
 extern STR o;
 extern STR a1;
 extern STR obj;
 extern STR lib1;
 ERR1 L2;
 extern STR Didntunderstandapparentf;
 ERR1 L3;
 ERR1 L4;
 dSTR L5;
 L11 = suf;
 if (STR_is_eq_STR_BOOL(L11, ((STR) &c1))) {
  return;
 }
 else {
  if (STR_is_eq_STR_BOOL(L11, ((STR) &o))) {
   return;
  }
  else {
   if (STR_is_eq_STR_BOOL(L11, ((STR) &a1))) {
    return;
   }
   else {
    if (STR_is_eq_STR_BOOL(L11, ((STR) &obj))) {
     return;
    }
    else {
     if (STR_is_eq_STR_BOOL(L11, ((STR) &lib1))) {
      return;
     }
     else {
      L2 = ERR_create_ERR(((ERR1) NULL));
      L3 = ERR_plus_dSTR_ERR(L2, ((dSTR) ((STR) &Didntunderstandapparentf)));
      L4 = ERR_plus_dSTR_ERR(L3, ((dSTR) arg));
      L5 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
      ((CHAR_boxed) L5)->value_part = '\n';
      ERR_plus_dSTR(L4, L5);
      GET_OPTIONS_usage(self);
     }
    }
   }
  }
 }
}


void GET_OPTIONS_handle_other1(GET_OPTIONS self, STR s) {
 GET_OPTIONS_handle_files(self, s);
}


void GET_OPTIONS_insert_here_(GET_OPTIONS self, FLISTSTR cl) {
 ARRAYSTR tail = ((ARRAYSTR) NULL);
 ARRAYSTR L1;
 INT L2;
 INT L3;
 INT L4;
 ARRAYSTR L5;
 if (GET_OPTIONS_more_args_BO(self)) {
  L1 = ATTR(self,args1);
  L2 = ATTR(self,next);
  L3 = ARRAYSTR_size_INT(ATTR(self,args1));
  L4 = ATTR(self,next);
  tail = ARRAYSTR_subarr_INT_INT_(L1, L2, (INTMINUS(L3,L4)));
 }
 else {
  tail = ARRAYSTR_create_INT_ARRA(((ARRAYSTR) NULL), 0);
 }
 L5 = FLISTSTR_array_ARRAYSTR(cl);
 SATTR(self,args1,ARRAYSTR_append_ARRAYSTR(L5, tail));
 SATTR(self,next,0);
}


void GET_OPTIONS_interpret_AR(GET_OPTIONS self, ARRAYSTR a) {
 STR s;
 STR L11;
 extern STR main2;
 extern STR home;
 extern STR homeisnotusedanymoreuseS;
 extern STR verbose;
 extern STR prolix;
 extern STR psather;
 extern STR com;
 extern STR end1;
 extern STR Nohomedirectoryspecified;
 SATTR(self,args1,a);
 SATTR(self,next,1);
 GET_OPTIONS_get_files(self);
 GET_OPTIONS_insert_here_(self, GET_OPTIONS_args_from_en(self));
 while (1) {
  if (GET_OPTIONS_more_args_BO(self)) {
  }
  else {
   goto after_loop;
  }
  s = GET_OPTIONS_next_arg_STR(self);
  L11 = s;
  if (STR_is_eq_STR_BOOL(L11, ((STR) &main2))) {
   SATTR(ATTR(self,prog1),main_class,GET_OPTIONS_next_arg_STR(self));
  }
  else {
   if (STR_is_eq_STR_BOOL(L11, ((STR) &home))) {
    GET_OPTIONS_barf_STR(self, ((STR) &homeisnotusedanymoreuseS));
   }
   else {
    if (STR_is_eq_STR_BOOL(L11, ((STR) &verbose))) {
     SATTR(ATTR(self,prog1),verbose,TRUE);
    }
    else {
     if (STR_is_eq_STR_BOOL(L11, ((STR) &prolix))) {
      SATTR(ATTR(self,prog1),verbose,TRUE);
      SATTR(ATTR(self,prog1),prolix,TRUE);
     }
     else {
      if (STR_is_eq_STR_BOOL(L11, ((STR) &psather))) {
       SATTR(ATTR(self,prog1),psather,TRUE);
      }
      else {
       if (STR_is_eq_STR_BOOL(L11, ((STR) &com))) {
        GET_OPTIONS_insert_here_(self, GET_OPTIONS_args_from_fi(self, GET_OPTIONS_next_arg_STR(self)));
       }
       else {
        if (STR_is_eq_STR_BOOL(L11, ((STR) &end1))) {
        }
        else {
         GET_OPTIONS_handle_other1(self, s);
        }
       }
      }
     }
    }
   }
  }
 }
 after_loop: ;
 if ((ATTR(ATTR(self,prog1),home)==((STR) NULL))) {
  GET_OPTIONS_barf_STR(self, ((STR) &Nohomedirectoryspecified));
 }
 GET_OPTIONS_other_initia(self);
}


void GET_OPTIONS_other_initia(GET_OPTIONS self) {
}


void GET_OPTIONS_rewind(GET_OPTIONS self) {
 INT L1;
 L1 = ATTR(self,next);
 SATTR(self,next,(INTMINUS(L1,1)));
}


void GET_OPTIONS_usage(GET_OPTIONS self) {
 ERR1 L1;
 extern STR Commandlineerrornear;
 ERR1 L2;
 ARRAYSTR L3;
 INT L4;
 INT L5;
 INT L6;
 ERR1 L7;
 dSTR L8;
 ERR1 L9;
 extern STR Seemanpage;
 L1 = ERR_create_ERR(((ERR1) NULL));
 L2 = ERR_plus_dSTR_ERR(L1, ((dSTR) ((STR) &Commandlineerrornear)));
 L3 = ATTR(self,args1);
 L4 = ATTR(self,next);
 L5 = ARRAYSTR_size_INT(ATTR(self,args1));
 L6 = (INTMINUS(L5,1));
 L7 = ERR_plus_dSTR_ERR(L2, ((dSTR) ARRAYSTR_aget_INT_STR(L3, ((L4<L6)?L4:L6))));
 L8 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L8)->value_part = '\n';
 ERR_plus_dSTR(L7, L8);
 L9 = ERR_create_ERR(((ERR1) NULL));
 ERR_plus_dSTR(L9, ((dSTR) ((STR) &Seemanpage)));
 UNIX_exit_INT(((UNIX) NULL), 1);
}


void GLOBAL_TBL_insert_AM_GLO(GLOBAL_TBL self, AM_GLOBAL_EXPR g1) {
 FMAPIDENTAM_GLOBAL_EXPR m;
 m = FMAPdTPFMAPIDENTAM_GLOBA6(ATTR(self,tbl), ATTR(g1,class_tp));
 m = FMAPIDENTAM_GLOBAL_EXPR_15(m, ATTR(g1,name1), g1);
 SATTR(self,tbl,FMAPdTPFMAPIDENTAM_GLOBA16(ATTR(self,tbl), ATTR(g1,class_tp), m));
 SATTR(self,top_sort,FLISTAM_GLOBAL_EXPR_push(ATTR(self,top_sort), g1));
}


void IDENT_BUILTIN_AREF_ident(IDENT_BUILTIN self, IDENT AREF_ident) {
 IDENT_BUILTIN_AREF_ident1 = AREF_ident;
}


void IDENT_BUILTIN_ARRAY_iden(IDENT_BUILTIN self, IDENT ARRAY_ident) {
 IDENT_BUILTIN_ARRAY_iden1 = ARRAY_ident;
}


void IDENT_BUILTIN_ARR_ident_(IDENT_BUILTIN self, IDENT ARR_ident) {
 IDENT_BUILTIN_ARR_ident = ARR_ident;
}


void IDENT_BUILTIN_AVAL_ident(IDENT_BUILTIN self, IDENT AVAL_ident) {
 IDENT_BUILTIN_AVAL_ident1 = AVAL_ident;
}


void IDENT_BUILTIN_FLTDX_iden(IDENT_BUILTIN self, IDENT FLTDX_ident) {
 IDENT_BUILTIN_FLTDX_iden1 = FLTDX_ident;
}


void IDENT_BUILTIN_FLTD_ident(IDENT_BUILTIN self, IDENT FLTD_ident) {
 IDENT_BUILTIN_FLTD_ident1 = FLTD_ident;
}


void IDENT_BUILTIN_FLTX_ident(IDENT_BUILTIN self, IDENT FLTX_ident) {
 IDENT_BUILTIN_FLTX_ident1 = FLTX_ident;
}


void IDENT_BUILTIN_FLT_ident_(IDENT_BUILTIN self, IDENT FLT_ident) {
 IDENT_BUILTIN_FLT_ident = FLT_ident;
}


void IDENT_BUILTIN_GATE_ident(IDENT_BUILTIN self, IDENT GATE_ident) {
 IDENT_BUILTIN_GATE_ident1 = GATE_ident;
}


void IDENT_BUILTIN_INTI_ident(IDENT_BUILTIN self, IDENT INTI_ident) {
 IDENT_BUILTIN_INTI_ident1 = INTI_ident;
}


void IDENT_BUILTIN_INT_ident_(IDENT_BUILTIN self, IDENT INT_ident) {
 IDENT_BUILTIN_INT_ident = INT_ident;
}


void IDENT_BUILTIN_SYS_ident_(IDENT_BUILTIN self, IDENT SYS_ident) {
 IDENT_BUILTIN_SYS_ident = SYS_ident;
}


void IDENT_BUILTIN_aget_ident(IDENT_BUILTIN self, IDENT aget_ident) {
 IDENT_BUILTIN_aget_ident1 = aget_ident;
}


void IDENT_BUILTIN_aset_ident(IDENT_BUILTIN self, IDENT aset_ident) {
 IDENT_BUILTIN_aset_ident1 = aset_ident;
}


void IDENT_BUILTIN_asize_iden(IDENT_BUILTIN self, IDENT asize_ident) {
 IDENT_BUILTIN_asize_iden1 = asize_ident;
}


void IDENT_BUILTIN_bang_ident(IDENT_BUILTIN self, IDENT bang_ident) {
 IDENT_BUILTIN_bang_ident1 = bang_ident;
}


void IDENT_BUILTIN_call_bang_(IDENT_BUILTIN self, IDENT call_bang_ident) {
 IDENT_BUILTIN_call_bang_1 = call_bang_ident;
}


void IDENT_BUILTIN_call_ident(IDENT_BUILTIN self, IDENT call_ident) {
 IDENT_BUILTIN_call_ident1 = call_ident;
}


void IDENT_BUILTIN_create_ide(IDENT_BUILTIN self, IDENT create_ident) {
 IDENT_BUILTIN_create_ide1 = create_ident;
}


void IDENT_BUILTIN_div_ident_(IDENT_BUILTIN self, IDENT div_ident) {
 IDENT_BUILTIN_div_ident = div_ident;
}


void IDENT_BUILTIN_init(IDENT_BUILTIN self) {
 extern STR dOB;
 extern STR ARR;
 extern STR INT1;
 extern STR INTI1;
 extern STR FLT1;
 extern STR FLTD1;
 extern STR FLTDX1;
 extern STR FLTX1;
 extern STR plus1;
 extern STR minus;
 extern STR times1;
 extern STR div1;
 extern STR pow1;
 extern STR mod;
 extern STR is_lt;
 extern STR is_leq;
 extern STR is_gt;
 extern STR is_geq;
 extern STR negate;
 extern STR not1;
 extern STR AVAL;
 extern STR AREF;
 extern STR aget;
 extern STR aset;
 extern STR call1;
 extern STR callb;
 extern STR create1;
 extern STR ARRAY;
 extern STR ret_val1;
 extern STR self1;
 extern STR invariant;
 extern STR asize;
 extern STR main1;
 extern STR is_eq;
 extern STR is_neq;
 extern STR GATE1;
 extern STR ob_eq;
 extern STR b1;
 extern STR SYS1;
 IDENT_BUILTIN_dollar_OB_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &dOB)));
 IDENT_BUILTIN_ARR_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &ARR)));
 IDENT_BUILTIN_INT_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &INT1)));
 IDENT_BUILTIN_INTI_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &INTI1)));
 IDENT_BUILTIN_FLT_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &FLT1)));
 IDENT_BUILTIN_FLTD_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &FLTD1)));
 IDENT_BUILTIN_FLTDX_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &FLTDX1)));
 IDENT_BUILTIN_FLTX_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &FLTX1)));
 IDENT_BUILTIN_plus_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &plus1)));
 IDENT_BUILTIN_minus_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &minus)));
 IDENT_BUILTIN_times_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &times1)));
 IDENT_BUILTIN_div_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &div1)));
 IDENT_BUILTIN_pow_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &pow1)));
 IDENT_BUILTIN_mod_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &mod)));
 IDENT_BUILTIN_is_lt_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_lt)));
 IDENT_BUILTIN_is_leq_ide(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_leq)));
 IDENT_BUILTIN_is_gt_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_gt)));
 IDENT_BUILTIN_is_geq_ide(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_geq)));
 IDENT_BUILTIN_negate_ide(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &negate)));
 IDENT_BUILTIN_not_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &not1)));
 IDENT_BUILTIN_AVAL_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &AVAL)));
 IDENT_BUILTIN_AREF_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &AREF)));
 IDENT_BUILTIN_aget_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &aget)));
 IDENT_BUILTIN_aset_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &aset)));
 IDENT_BUILTIN_call_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &call1)));
 IDENT_BUILTIN_call_bang_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &callb)));
 IDENT_BUILTIN_create_ide(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &create1)));
 IDENT_BUILTIN_ARRAY_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &ARRAY)));
 IDENT_BUILTIN_ret_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &ret_val1)));
 IDENT_BUILTIN_self_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &self1)));
 IDENT_BUILTIN_invariant_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &invariant)));
 IDENT_BUILTIN_asize_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &asize)));
 IDENT_BUILTIN_main_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &main1)));
 IDENT_BUILTIN_is_eq_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_eq)));
 IDENT_BUILTIN_is_neq_ide(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &is_neq)));
 IDENT_BUILTIN_GATE_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &GATE1)));
 IDENT_BUILTIN_ob_eq_iden(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &ob_eq)));
 IDENT_BUILTIN_bang_ident(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &b1)));
 IDENT_BUILTIN_SYS_ident_(self, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &SYS1)));
}


void IDENT_BUILTIN_invariant_(IDENT_BUILTIN self, IDENT invariant_ident) {
 IDENT_BUILTIN_invariant_1 = invariant_ident;
}


void IDENT_BUILTIN_is_eq_iden(IDENT_BUILTIN self, IDENT is_eq_ident) {
 IDENT_BUILTIN_is_eq_iden1 = is_eq_ident;
}


void IDENT_BUILTIN_is_geq_ide(IDENT_BUILTIN self, IDENT is_geq_ident) {
 IDENT_BUILTIN_is_geq_ide1 = is_geq_ident;
}


void IDENT_BUILTIN_is_gt_iden(IDENT_BUILTIN self, IDENT is_gt_ident) {
 IDENT_BUILTIN_is_gt_iden1 = is_gt_ident;
}


void IDENT_BUILTIN_is_leq_ide(IDENT_BUILTIN self, IDENT is_leq_ident) {
 IDENT_BUILTIN_is_leq_ide1 = is_leq_ident;
}


void IDENT_BUILTIN_is_lt_iden(IDENT_BUILTIN self, IDENT is_lt_ident) {
 IDENT_BUILTIN_is_lt_iden1 = is_lt_ident;
}


void IDENT_BUILTIN_is_neq_ide(IDENT_BUILTIN self, IDENT is_neq_ident) {
 IDENT_BUILTIN_is_neq_ide1 = is_neq_ident;
}


void IDENT_BUILTIN_main_ident(IDENT_BUILTIN self, IDENT main_ident) {
 IDENT_BUILTIN_main_ident1 = main_ident;
}


void IDENT_BUILTIN_minus_iden(IDENT_BUILTIN self, IDENT minus_ident) {
 IDENT_BUILTIN_minus_iden1 = minus_ident;
}


void IDENT_BUILTIN_mod_ident_(IDENT_BUILTIN self, IDENT mod_ident) {
 IDENT_BUILTIN_mod_ident = mod_ident;
}


void IDENT_BUILTIN_negate_ide(IDENT_BUILTIN self, IDENT negate_ident) {
 IDENT_BUILTIN_negate_ide1 = negate_ident;
}


void IDENT_BUILTIN_not_ident_(IDENT_BUILTIN self, IDENT not_ident) {
 IDENT_BUILTIN_not_ident = not_ident;
}


void IDENT_BUILTIN_ob_eq_iden(IDENT_BUILTIN self, IDENT ob_eq_ident) {
 IDENT_BUILTIN_ob_eq_iden1 = ob_eq_ident;
}


void IDENT_BUILTIN_plus_ident(IDENT_BUILTIN self, IDENT plus_ident) {
 IDENT_BUILTIN_plus_ident1 = plus_ident;
}


void IDENT_BUILTIN_pow_ident_(IDENT_BUILTIN self, IDENT pow_ident) {
 IDENT_BUILTIN_pow_ident = pow_ident;
}


void IDENT_BUILTIN_ret_ident_(IDENT_BUILTIN self, IDENT ret_ident) {
 IDENT_BUILTIN_ret_ident = ret_ident;
}


void IDENT_BUILTIN_self_ident(IDENT_BUILTIN self, IDENT self_ident) {
 IDENT_BUILTIN_self_ident1 = self_ident;
}


void IDENT_BUILTIN_times_iden(IDENT_BUILTIN self, IDENT times_ident) {
 IDENT_BUILTIN_times_iden1 = times_ident;
}


void IDENT_TBL_aset_INT_IDENT(IDENT_TBL self, INT ind, IDENT val1) {
 SARR(self,ind,val1);
}


void IDENT_TBL_asetb_IDENT(IDENT_TBL_asetb_IDENT_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   IDENT_TBL_aset_INT_IDENT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void IDENT_ident_tbl_IDENT_TB(IDENT self, IDENT_TBL ident_tbl) {
 IDENT_ident_tbl = ident_tbl;
}


void IDENT_tmp_count_INT(IDENT self, INT tmp_count) {
 IDENT_tmp_count = tmp_count;
}


void IFC_ABS_CREATE_do_explic(IFC_ABS_CREATE self) {
 dAS_CLASS_ELT be;
 SIG ns;
 SIG cs;
 PROG L1;
 PROG L2;
 extern STR Abstractclassesmaynotdef;
 PROG L3;
 extern STR Abstractclassesmaynotdef1;
 PROG L4;
 extern STR Abstractclassesmaynotdef2;
 BOOL L5;
 PROG L6;
 extern STR Abstractclassesmayonlyha;
 BOOL L7;
 PROG L8;
 extern STR Thetwoexplicitlydefineds;
 STR L9;
 extern STR and3;
 STR L10;
 STR L11;
 extern STR conflict;
 PROG L12;
 extern STR Abstractclassesmaynothav;
 dAS_CLASS_ELT L13;
 be = ATTR(ATTR(self,tr),body);
 while (1) {
  if ((be==((dAS_CLASS_ELT) NULL))) {
   goto after_loop;
  }
  L1 = IFC_ABS_CREATE_prog_PROG(self);
  PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) be));
  if (be==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(be)) {
   case AS_CONST_DEF_tag:
    L2 = IFC_ABS_CREATE_prog_PROG(self);
    PROG_err_STR(L2, ((STR) &Abstractclassesmaynotdef)); break;
   case AS_SHARED_DEF_tag:
    L3 = IFC_ABS_CREATE_prog_PROG(self);
    PROG_err_STR(L3, ((STR) &Abstractclassesmaynotdef1)); break;
   case AS_ATTR_DEF_tag:
    L4 = IFC_ABS_CREATE_prog_PROG(self);
    PROG_err_STR(L4, ((STR) &Abstractclassesmaynotdef2)); break;
   case AS_ROUT_DEF_tag:
    L5 = ATTR(((AS_ROUT_DEF) be),is_abstract);
    if ((!(L5))) {
     L6 = IFC_ABS_CREATE_prog_PROG(self);
     PROG_err_STR(L6, ((STR) &Abstractclassesmayonlyha));
    }
    ns = SIG_rout_sig_AS_ROUT_DEF(((SIG) NULL), ((AS_ROUT_DEF) be), ATTR(((AS_ROUT_DEF) be),name1), ATTR(self,con1));
    cs = SIG_TBL_sig_conflicting_(ATTR(self,class_sigs), ns);
    L7 = (cs==((SIG) NULL));
    if ((!(L7))) {
     L8 = IFC_ABS_CREATE_prog_PROG(self);
     L9 = STR_plus_dSTR_STR(((STR) &Thetwoexplicitlydefineds), ((dSTR) ATTR(ns,str)));
     L10 = STR_plus_dSTR_STR(L9, ((dSTR) ((STR) &and3)));
     L11 = STR_plus_dSTR_STR(L10, ((dSTR) ATTR(cs,str)));
     PROG_err_STR(L8, STR_plus_dSTR_STR(L11, ((dSTR) ((STR) &conflict))));
    }
    else {
     SATTR(self,class_sigs,SIG_TBL_insert_SIG_SIG_T(ATTR(self,class_sigs), ns));
    } break;
   case AS_INCLUDE_CLAUSE_tag:
    L12 = IFC_ABS_CREATE_prog_PROG(self);
    PROG_err_STR(L12, ((STR) &Abstractclassesmaynothav)); break;
   default: ;
    FATAL("No applicable type in typecase");
  }
  L13 = be;
  if (L13==NULL) {
   FATAL("Dispatch on void in IFC_ABS_CREATE::do_explicit_class_sigs");
  }
  be = (*dAS_CLASS_ELT_next_dAS_C[TAG(L13)+dAS_CLASS_ELT_next_dAS_C_offset])(L13);
 }
 after_loop: ;
}


void IFC_ABS_CREATE_do_supers(IFC_ABS_CREATE self) {
 AS_TYPE_SPEC ut;
 dTP tp;
 IFC itp;
 PROG L1;
 PROG L2;
 extern STR Abstracttypesmusthaveabs;
 BOOL L3;
 PROG L4;
 extern STR Abstracttypesmusthaveabs;
 PROG L5;
 extern STR Abstracttypesmusthaveabs;
 ut = ATTR(ATTR(self,tr),under);
 while (1) {
  if ((ut==((AS_TYPE_SPEC) NULL))) {
   goto after_loop;
  }
  tp = TP_CONTEXT_tp_of_AS_TYPE(ATTR(self,con1), ut);
  L1 = IFC_ABS_CREATE_prog_PROG(self);
  PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ut));
  if (tp==NULL) {
   L2 = IFC_ABS_CREATE_prog_PROG(self);
   PROG_err_STR(L2, ((STR) &Abstracttypesmusthaveabs));
  } else
  switch (TAG(tp)) {
   case TP_CLASS_tag:
    L3 = TP_CLASS_is_abstract_BOO(((TP_CLASS) tp));
    if ((!(L3))) {
     L4 = IFC_ABS_CREATE_prog_PROG(self);
     PROG_err_STR(L4, ((STR) &Abstracttypesmusthaveabs));
    }
    else {
     itp = IFC_TBL_ifc_of_dTP_IFC(ATTR(IFC_ABS_CREATE_prog_PROG(self),ifc_tbl), tp);
     SATTR(self,supers,FLISTIFC_push_IFC_FLISTI(ATTR(self,supers), itp));
    } break;
   default: ;
    L5 = IFC_ABS_CREATE_prog_PROG(self);
    PROG_err_STR(L5, ((STR) &Abstracttypesmusthaveabs));
  }
  ut = ATTR(ut,next);
 }
 after_loop: ;
}


void IFC_TBL_cycle_err(IFC_TBL self) {
 STR s;
 FSETTUPIDENTINT L11;
 STR L21;
 extern STR Cycledetectedinsubtyping;
 STR L3;
 extern STR name18;
 TUPIDENTINT L4;
 s = ((STR) &Cycledetectedinsubtyping);
 {
  struct FSETTUPIDENTINT_eltb_TUP_frame_struct other1_0;
  FSETTUPIDENTINT_eltb_TUP_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = ((STR) &name18);
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = ATTR(self,abs_cur);
    noname1->self = L11;
   }
   L4 = FSETTUPIDENTINT_eltb_TUP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = IFC_TBL_tup_str_TUPIDENT(self, L4);
   L3 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   s = STR_plus_dSTR_STR(s, ((dSTR) L3));
  }
 }
 after_loop: ;
 PROG_err_STR(ATTR(self,prog1), s);
}


void IFC_show(IFC self) {
 SIG_TBL L11;
 SIG s;
 STR L21;
 OUT L3;
 extern STR Interfacevoid;
 OUT L4;
 extern STR Interfacetpvoid;
 OUT L5;
 extern STR Interfaceof;
 OUT L6;
 dTP L7;
 OUT L8;
 extern STR name28;
 OUT L9;
 extern STR void4;
 SIG L10;
 BOOL L12;
 OUT L13;
 STR L14;
 extern STR name25;
 OUT L15;
 extern STR name15;
 if ((self==((IFC) NULL))) {
  L3 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L3, ((dSTR) ((STR) &Interfacevoid)));
  return;
 }
 if ((ATTR(self,tp1)==((dTP) NULL))) {
  L4 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L4, ((dSTR) ((STR) &Interfacetpvoid)));
  return;
 }
 L5 = OUT_create_OUT(((OUT) NULL));
 L6 = OUT_plus_dSTR_OUT(L5, ((dSTR) ((STR) &Interfaceof)));
 L7 = ATTR(self,tp1);
 if (L7==NULL) {
  FATAL("Dispatch on void in IFC::show");
 }
 L8 = OUT_plus_dSTR_OUT(L6, ((dSTR) (*dTP_str_STR[TAG(L7)+dTP_str_STR_offset])(L7)));
 OUT_plus_dSTR(L8, ((dSTR) ((STR) &name28)));
 if ((ATTR(self,sigs1)==((SIG_TBL) NULL))) {
  L9 = OUT_create_OUT(((OUT) NULL));
  OUT_plus_dSTR(L9, ((dSTR) ((STR) &void4)));
  return;
 }
 {
  struct SIG_TBL_eltb_SIG_frame_struct other1_0;
  SIG_TBL_eltb_SIG_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,sigs1);
    noname1->self = L11;
   }
   L10 = SIG_TBL_eltb_SIG(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   s = L10;
   L12 = (s==((SIG) NULL));
   if ((!(L12))) {
    L13 = OUT_create_OUT(((OUT) NULL));
    if (noname2->state == 0) {
     L21 = ((STR) &name25);
     noname2->self = L21;
    }
    noname2->arg1 = ATTR(s,str);
    L14 = STR_separateb_STR_STR(noname2);
    if (noname2->state == -1) {
     goto after_loop;
    }
    OUT_plus_dSTR(L13, ((dSTR) L14));
   }
  }
 }
 after_loop: ;
 L15 = OUT_create_OUT(((OUT) NULL));
 OUT_plus_dSTR(L15, ((dSTR) ((STR) &name15)));
}


void IMPL_CREATE_array_confli(IMPL_CREATE self, IMPL_INCLUDE inc, TP_CLASS a11, TP_CLASS a21) {
 PROG L1;
 PROG L2;
 extern STR Thisclasshasincludepaths;
 STR L3;
 extern STR and3;
 STR L4;
 STR L5;
 dSTR L6;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(inc,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thisclasshasincludepaths), ((dSTR) TP_CLASS_str_STR(a11)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &and3)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) TP_CLASS_str_STR(a21)));
 L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L6)->value_part = '.';
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, L6));
}


void IMPL_CREATE_attr_conflic(IMPL_CREATE self, ELT e, ELT f, IMPL_INCLUDE inc) {
 PROG L1;
 PROG L2;
 extern STR Thisexplicitlydefinedrou;
 STR L3;
 extern STR whichisincludedfrom;
 STR L4;
 STR L5;
 extern STR name5;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(f,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thisexplicitlydefinedrou), ((dSTR) ATTR(ATTR(e,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &whichisincludedfrom)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) TP_CLASS_str_STR(ATTR(inc,itp))));
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name5))));
}


void IMPL_CREATE_do_incs(IMPL_CREATE self) {
 dAS_CLASS_ELT e;
 IMPL_INCLUDE ii;
 BOOL L1;
 PROG L2;
 PROG L3;
 extern STR Externalclassesmaynothav;
 BOOL L4;
 dAS_CLASS_ELT L5;
 e = ATTR(ATTR(self,as1),body);
 while (1) {
  L1 = (e==((dAS_CLASS_ELT) NULL));
  if ((!(L1))) {
  }
  else {
   goto after_loop;
  }
  if (e==NULL) {
  } else
  switch (TAG(e)) {
   case AS_INCLUDE_CLAUSE_tag:
    if (ATTR(self,is_external)) {
     L2 = IMPL_CREATE_prog_PROG(self);
     PROG_err_loc_dPROG_ERR(L2, ((dPROG_ERR) e));
     L3 = IMPL_CREATE_prog_PROG(self);
     PROG_err_STR(L3, ((STR) &Externalclassesmaynothav));
    }
    else {
     ii = IMPL_INCLUDE_create_TP_C(((IMPL_INCLUDE) NULL), ATTR(self,tp1), ((AS_INCLUDE_CLAUSE) e));
     L4 = (ii==((IMPL_INCLUDE) NULL));
     if ((!(L4))) {
      SATTR(self,incs,FLISTIMPL_INCLUDE_push_I(ATTR(self,incs), ii));
     }
    } break;
   default: ;
  }
  L5 = e;
  if (L5==NULL) {
   FATAL("Dispatch on void in IMPL_CREATE::do_incs");
  }
  e = (*dAS_CLASS_ELT_next_dAS_C[TAG(L5)+dAS_CLASS_ELT_next_dAS_C_offset])(L5);
 }
 after_loop: ;
}


void IMPL_CREATE_ext_conflict(IMPL_CREATE self, ELT er, ELT f) {
 PROG L1;
 PROG L2;
 extern STR Thesignature1;
 STR L3;
 extern STR hasthesamenameastheearli;
 STR L4;
 STR L5;
 extern STR inanexternalclass;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(er,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thesignature1), ((dSTR) ATTR(ATTR(er,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &hasthesamenameastheearli)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ATTR(ATTR(f,sig11),str)));
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &inanexternalclass))));
}


void IMPL_CREATE_include_conf(IMPL_CREATE self, IMPL_INCLUDE inc, IMPL_INCLUDE inc2, ELT e, ELT g1) {
 PROG L1;
 PROG L2;
 extern STR Thisincludesthefeature;
 STR L3;
 extern STR whichconflictswith;
 STR L4;
 STR L5;
 extern STR whichisincludedfrom1;
 STR L6;
 STR L7;
 extern STR name5;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(inc,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thisincludesthefeature), ((dSTR) ATTR(ATTR(e,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &whichconflictswith)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ATTR(ATTR(g1,sig11),str)));
 L6 = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &whichisincludedfrom1)));
 L7 = STR_plus_dSTR_STR(L6, ((dSTR) TP_CLASS_str_STR(ATTR(inc2,itp))));
 PROG_err_STR(L2, STR_plus_dSTR_STR(L7, ((dSTR) ((STR) &name5))));
}


void IMPL_CREATE_reader_confl(IMPL_CREATE self, ELT er, ELT f) {
 PROG L1;
 PROG L2;
 extern STR Thesignature1;
 STR L3;
 extern STR ofthereaderroutineforthi;
 STR L4;
 STR L5;
 dSTR L6;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(er,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thesignature1), ((dSTR) ATTR(ATTR(er,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &ofthereaderroutineforthi)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ATTR(ATTR(f,sig11),str)));
 L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L6)->value_part = '.';
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, L6));
}


void IMPL_CREATE_writer_confl(IMPL_CREATE self, ELT ew, ELT f) {
 PROG L1;
 PROG L2;
 extern STR Thesignature1;
 STR L3;
 extern STR ofthewriterroutineforthi;
 STR L4;
 STR L5;
 dSTR L6;
 L1 = IMPL_CREATE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(ew,as1)));
 L2 = IMPL_CREATE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Thesignature1), ((dSTR) ATTR(ATTR(ew,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &ofthewriterroutineforthi)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ATTR(ATTR(f,sig11),str)));
 L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L6)->value_part = '.';
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, L6));
}


void IMPL_INCLUDE_include_bou(IMPL_INCLUDE self, dAS_CLASS_ELT t) {
 PROG L1;
 PROG L2;
 extern STR Classesmaynotincludeboun;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) t));
 L2 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_STR(L2, ((STR) &Classesmaynotincludeboun));
}


void IMPL_INCLUDE_include_con(IMPL_INCLUDE self, ELT en, ELT f) {
 PROG L1;
 PROG L2;
 extern STR Twooftheincludedsignatur;
 STR L3;
 extern STR and3;
 STR L4;
 STR L5;
 extern STR name5;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) ATTR(self,as1)));
 L2 = IMPL_INCLUDE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Twooftheincludedsignatur), ((dSTR) ATTR(ATTR(en,sig11),str)));
 L4 = STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &and3)));
 L5 = STR_plus_dSTR_STR(L4, ((dSTR) ATTR(ATTR(f,sig11),str)));
 PROG_err_STR(L2, STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name5))));
}


void IMPL_INCLUDE_include_ext(IMPL_INCLUDE self, dAS_CLASS_ELT t) {
 PROG L1;
 PROG L2;
 extern STR Classesmaynotincludeexte;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) t));
 L2 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_STR(L2, ((STR) &Classesmaynotincludeexte));
}


void IMPL_INCLUDE_param_inclu(IMPL_INCLUDE self, dAS_CLASS_ELT t) {
 PROG L1;
 PROG L2;
 extern STR Typespecifiersinincludec;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) t));
 L2 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_STR(L2, ((STR) &Typespecifiersinincludec));
}


void IMPL_INCLUDE_unused_mod_(IMPL_INCLUDE self, AS_FEAT_MOD t) {
 PROG L1;
 PROG L2;
 extern STR Therearenofeatureswithth;
 STR L3;
 extern STR name5;
 L1 = IMPL_INCLUDE_prog_PROG(self);
 PROG_err_loc_dPROG_ERR(L1, ((dPROG_ERR) t));
 L2 = IMPL_INCLUDE_prog_PROG(self);
 L3 = STR_plus_dSTR_STR(((STR) &Therearenofeatureswithth), ((dSTR) ATTR(t,name1).str));
 PROG_err_STR(L2, STR_plus_dSTR_STR(L3, ((dSTR) ((STR) &name5))));
}


void IMPL_TBL_cycle_err(IMPL_TBL self) {
 STR s;
 FSETTUPIDENTINT L11;
 STR L21;
 extern STR Cycledetectedinincludecl;
 STR L3;
 extern STR name18;
 TUPIDENTINT L4;
 s = ((STR) &Cycledetectedinincludecl);
 {
  struct FSETTUPIDENTINT_eltb_TUP_frame_struct other1_0;
  FSETTUPIDENTINT_eltb_TUP_frame 
  noname1 = &other1_0;
  struct STR_separateb_STR_STR_frame_struct other1_1;
  STR_separateb_STR_STR_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = ((STR) &name18);
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = ATTR(self,cur);
    noname1->self = L11;
   }
   L4 = FSETTUPIDENTINT_eltb_TUP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = IMPL_TBL_tup_str_TUPIDEN(self, L4);
   L3 = STR_separateb_STR_STR(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   s = STR_plus_dSTR_STR(s, ((dSTR) L3));
  }
 }
 after_loop: ;
 IMPL_TBL_err_STR(self, s);
}


void IMPL_TBL_err_STR(IMPL_TBL self, STR s) {
 PROG_err_STR(ATTR(self,prog1), s);
}


void IMPORT_EXPORT_TBL_err_ST(IMPORT_EXPORT_TBL self, STR s) {
 PROG_err_STR(ATTR(self,prog1), s);
}


void INLINE_ATTR_READ_routine(INLINE_ATTR_READ self, INT routines1) {
 INLINE_ATTR_READ_routine1 = routines1;
}


void INLINE_ATTR_WRITE_routin(INLINE_ATTR_WRITE self, INT routines1) {
 INLINE_ATTR_WRITE_routin1 = routines1;
}


void INLINE_GLOBAL_READ_routi(INLINE_GLOBAL_READ self, INT routines1) {
 INLINE_GLOBAL_READ_routi1 = routines1;
}


void INLINE_INT_FOLD_inlined_(INLINE_INT_FOLD self, INT inlined) {
 INLINE_INT_FOLD_inlined = inlined;
}


void INLINE_ITER_copy_iter_AM(INLINE_ITER self, AM_ROUT_DEF rout) {
 XFORM_CODE xc1;
 AM_LOOP_STMT proxy_loop_stmt;
 FLISTAM_LOCAL_EXPR L11;
 AM_IF_STMT iey;
 dAM_STMT s1;
 TP_CLASS bool_tp;
 SIG notsig;
 AM_ROUT_CALL_EXPR yc;
 FLISTAM_LOCAL_EXPR L2;
 FMAPAM_LOCAL_EXPRAM_LOCA L3;
 AM_LOCAL_EXPR L4;
 dAM_STMT L5;
 dAM_STMT L6;
 BOOL L7;
 dAM_EXPR L8;
 SATTR(self,change_vars,CHANGE_VARS_create_AM_RO(((CHANGE_VARS) NULL), rout));
 xc1 = XFORM_CODE_create_FMAPAM(((XFORM_CODE) NULL), ATTR(ATTR(self,change_vars),saved_subst));
 SATTR(xc1,record_calls,FALSE);
 proxy_loop_stmt = AM_LOOP_STMT_create_SFIL(((AM_LOOP_STMT) NULL), SFILE_ID_zero);
 SATTR(xc1,new_loop_stmt,proxy_loop_stmt);
 SATTR(self,BEFLOOP_code,XFORM_CODE_xform_stmt_li(xc1, ATTR(rout,code11)));
 if ((ATTR(xc1,loop_stmt)==((AM_LOOP_STMT) NULL))) {
  SATTR(self,flat_yield,TRUE);
  CHANGE_VARS_after_saving(ATTR(self,change_vars));
  SYSDESTROY(((OB) xc1));
  return;
 }
 SATTR(self,loop_firsts,FLISTAM_LOCAL_EXPR_creat(((FLISTAM_LOCAL_EXPR) NULL), FLISTAM_LOCAL_EXPR_size_(ATTR(ATTR(xc1,loop_stmt),firsts))));
 {
  struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other1_0;
  FLISTAM_LOCAL_EXPR_eltb__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   L2 = ATTR(self,loop_firsts);
   L3 = ATTR(ATTR(self,change_vars),saved_subst);
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(xc1,loop_stmt),firsts);
    noname1->self = L11;
   }
   L4 = FLISTAM_LOCAL_EXPR_eltb_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   SATTR(self,loop_firsts,FLISTAM_LOCAL_EXPR_push_(L2, FMAPAM_LOCAL_EXPRAM_LOCA19(L3, L4)));
  }
 }
 after_loop: ;
 SATTR(self,IINIT_code,XFORM_CODE_xform_stmt_li(xc1, ATTR(ATTR(xc1,loop_stmt),body)));
 iey = ATTR(xc1,if_encl_yield);
 SATTR(self,flat_yield,(iey==((AM_IF_STMT) NULL)));
 if (ATTR(self,flat_yield)) {
  SATTR(self,ITERM_code,ATTR(xc1,after_yield));
 }
 else {
  s1 = ATTR(self,IINIT_code);
  if (SYSOBEQ(((OB) s1),((OB) iey))) {
   SATTR(self,IINIT_code,((dAM_STMT) NULL));
  }
  else {
   while (1) {
    L5 = s1;
    if (L5==NULL) {
     FATAL("Dispatch on void in INLINE_ITER::copy_iter(AM_ROUT_DEF)");
    }
    if (SYSOBEQ(((OB) (*dAM_STMT_next_dAM_STMT[TAG(L5)+dAM_STMT_next_dAM_STMT_offset])(L5)),((OB) iey))) {
     goto after_loop1;
    }
   }
   after_loop1: ;
   L6 = s1;
   if (L6==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::copy_iter(AM_ROUT_DEF)");
   }
   (*dAM_STMT_next_dAM_STMT1[TAG(L6)+dAM_STMT_next_dAM_STMT1_offset])(L6, ((dAM_STMT) NULL));
  }
  SATTR(self,ITERM_code,ATTR(iey,next1));
 }
 SATTR(self,yield_val,ATTR(xc1,yield_val));
 L7 = ATTR(self,flat_yield);
 if ((!(L7))) {
  if (ATTR(xc1,true_br_yield)) {
   SATTR(self,yield_cond,ATTR(iey,test11));
   SATTR(self,WYBEF_code,ATTR(iey,if_true));
   SATTR(self,WYAFT_code,ATTR(xc1,after_yield));
   SATTR(self,WNOY_code,ATTR(iey,if_false));
  }
  else {
   bool_tp = TP_BUILTIN_bool;
   notsig = SIG_create_dTP_IDENT_ARR(((SIG) NULL), ((dTP) bool_tp), IDENT_BUILTIN_not_ident, ((ARRAYdTP) NULL), ((dTP) bool_tp));
   L8 = ATTR(iey,test11);
   if (L8==NULL) {
    FATAL("Dispatch on void in INLINE_ITER::copy_iter(AM_ROUT_DEF)");
   }
   yc = AM_ROUT_CALL_EXPR_create(((AM_ROUT_CALL_EXPR) NULL), 1, (*dAM_EXPR_source_SFILE_ID[TAG(L8)+dAM_EXPR_source_SFILE_ID_offset])(L8));
   SATTR(yc,fun,notsig);
   AM_ROUT_CALL_EXPR_aset_I(yc, 0, ATTR(iey,test11));
   SATTR(self,yield_cond,((dAM_EXPR) yc));
   SATTR(self,WYBEF_code,ATTR(iey,if_false));
   SATTR(self,WYAFT_code,ATTR(xc1,after_yield));
   SATTR(self,WNOY_code,ATTR(iey,if_true));
  }
 }
 SYSDESTROY(((OB) proxy_loop_stmt));
 CHANGE_VARS_after_saving(ATTR(self,change_vars));
 SYSDESTROY(((OB) xc1));
}


void INLINE_ITER_inlined_INT(INLINE_ITER self, INT inlined) {
 INLINE_ITER_inlined = inlined;
}


void INLINE_ITER_iters_INT(INLINE_ITER self, INT iters) {
 INLINE_ITER_iters = iters;
}


void INLINE_consider_AM_ROUT_(INLINE self, AM_ROUT_DEF am) {
 dBACK_END L1;
 BOOL L2;
 L1 = ATTR(ATTR(self,prog1),back_end);
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE::consider(AM_ROUT_DEF)");
 }
 L2 = (*dBACK_END_is_built_in_SI[TAG(L1)+dBACK_END_is_built_in_SI_offset])(L1, ATTR(am,sig11));
 if ((!(L2))) {
  if (AM_ROUT_DEF_is_iter_BOOL(am)) {
   SATTR(self,itbl,INLINE_ITER_TBL_test_and(ATTR(self,itbl), am, ATTR(self,inline_iters), ATTR(self,iter_thres)));
  }
  else {
   SATTR(self,rtbl,INLINE_ROUT_TBL_test_and(ATTR(self,rtbl), am, ATTR(self,inline_routs), ATTR(self,rout_thres)));
  }
 }
}

/* C for type GET_OPTIONS */




BOOL GET_OPTIONS_more_args_BO(GET_OPTIONS self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 L1 = ATTR(self,next);
 L2 = ARRAYSTR_size_INT(ATTR(self,args1));
 ret_val = (L1<L2);
 return ret_val;
}

/* C for type GLOBAL_TBL */




GLOBAL_TBL GLOBAL_TBL_create_PROG_G(GLOBAL_TBL self, PROG p) {
 GLOBAL_TBL ret_val;
 GLOBAL_TBL L1;
 L1 = ((GLOBAL_TBL) rt_alloc(sizeof(struct GLOBAL_TBL_struct), GLOBAL_TBL_tag));
 ret_val = L1;
 return ret_val;
}

/* C for type IDENT */




BOOL IDENT_is_eq_IDENT_BOOL(IDENT self, IDENT i) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = (self.str==i.str);
 return ret_val;
}

/* C for type IDENT_BUILTIN */




void IDENT_BUILTIN_dollar_OB_(IDENT_BUILTIN self, IDENT dollar_OB_ident) {
 IDENT_BUILTIN_dollar_OB_1 = dollar_OB_ident;
}

/* C for type IDENT_TBL */




INT IDENT_TBL_query_hash_STR(IDENT_TBL self, STR s) {
 INT ret_val = ((INT) 0);
 ret_val = STR_hash_INT(s);
 return ret_val;
}

/* C for type IFC */




IFC IFC_create_SIG_TBL_dTP_I(IFC self, SIG_TBL sigs, dTP tp) {
 IFC ret_val;
 IFC r;
 IFC L1;
 L1 = ((IFC) rt_alloc(sizeof(struct IFC_struct), IFC_tag));
 r = L1;
 SATTR(r,sigs1,sigs);
 SATTR(r,tp1,tp);
 ret_val = r;
 return ret_val;
}

/* C for type IFC_ABS_CREATE */




PROG IFC_ABS_CREATE_prog_PROG(IFC_ABS_CREATE self) {
 PROG ret_val;
 ret_val = ATTR(ATTR(self,tp1),prog1);
 return ret_val;
}

/* C for type IFC_TBL */




IFC_TBL IFC_TBL_create_PROG_IFC_(IFC_TBL self, PROG p) {
 IFC_TBL ret_val;
 IFC_TBL r;
 IFC_TBL L1;
 L1 = ((IFC_TBL) rt_alloc(sizeof(struct IFC_TBL_struct), IFC_TBL_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type IMPL */




PROG IMPL_prog_PROG(IMPL self) {
 PROG ret_val;
 dTP L1;
 L1 = ATTR(self,tp1);
 if (L1==NULL) {
  FATAL("Dispatch on void in IMPL::prog:PROG");
 }
 ret_val = (*dTP_prog_PROG[TAG(L1)+dTP_prog_PROG_offset])(L1);
 return ret_val;
}

/* C for type IMPL_CREATE */




PROG IMPL_CREATE_prog_PROG(IMPL_CREATE self) {
 PROG ret_val;
 ret_val = ATTR(ATTR(self,tp1),prog1);
 return ret_val;
}

/* C for type IMPL_INCLUDE */




PROG IMPL_INCLUDE_prog_PROG(IMPL_INCLUDE self) {
 PROG ret_val;
 ret_val = ATTR(ATTR(self,tp1),prog1);
 return ret_val;
}

/* C for type IMPL_TBL */




IMPL_TBL IMPL_TBL_create_PROG_IMP(IMPL_TBL self, PROG p) {
 IMPL_TBL ret_val;
 IMPL_TBL r;
 IMPL_TBL L1;
 L1 = ((IMPL_TBL) rt_alloc(sizeof(struct IMPL_TBL_struct), IMPL_TBL_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type IMPORT_EXPORT_TBL */




IMPORT_EXPORT_TBL IMPORT_EXPORT_TBL_create(IMPORT_EXPORT_TBL self, PROG p) {
 IMPORT_EXPORT_TBL ret_val;
 IMPORT_EXPORT_TBL res;
 SYSTEM_LEX l;
 STR class_name;
 STR routine_name;
 STR class_name1;
 STR routine_name1;
 IMPORT_EXPORT_TBL L1;
 extern STR SystemIMPORTS;
 extern STR MalformedIMPORTSfile;
 FSETTUPIDENTIDENT L2;
 IDENT L3;
 extern STR SystemEXPORTS;
 extern STR MalformedEXPORTSfile;
 FSETTUPIDENTIDENT L4;
 IDENT L5;
 L1 = ((IMPORT_EXPORT_TBL) rt_alloc(sizeof(struct IMPORT_EXPORT_TBL_struct), IMPORT_EXPORT_TBL_tag));
 res = L1;
 SATTR(res,imports,FSETTUPIDENTIDENT_create(((FSETTUPIDENTIDENT) NULL)));
 l = SYSTEM_LEX_create_STR_SY(((SYSTEM_LEX) NULL), STR_plus_dSTR_STR(ATTR(p,home), ((dSTR) ((STR) &SystemIMPORTS))));
 while (1) {
  class_name = SYSTEM_LEX_get_str_STR(l);
  routine_name = SYSTEM_LEX_get_str_STR(l);
  if ((class_name==((STR) NULL))) {
   goto after_loop;
  }
  else {
   if ((routine_name==((STR) NULL))) {
    PROG_barf_STR(p, ((STR) &MalformedIMPORTSfile));
   }
   else {
    L2 = ATTR(res,imports);
    L3 = IDENT_create_STR_IDENT(IDENT_zero, class_name);
    SATTR(res,imports,FSETTUPIDENTIDENT_insert(L2, TUPIDENTIDENT_create_IDE(TUPIDENTIDENT_zero, L3, IDENT_create_STR_IDENT(IDENT_zero, routine_name))));
   }
  }
 }
 after_loop: ;
 SATTR(res,exports,FSETTUPIDENTIDENT_create(((FSETTUPIDENTIDENT) NULL)));
 l = SYSTEM_LEX_create_STR_SY(((SYSTEM_LEX) NULL), STR_plus_dSTR_STR(ATTR(p,home), ((dSTR) ((STR) &SystemEXPORTS))));
 while (1) {
  class_name1 = SYSTEM_LEX_get_str_STR(l);
  routine_name1 = SYSTEM_LEX_get_str_STR(l);
  if ((class_name1==((STR) NULL))) {
   goto after_loop1;
  }
  else {
   if ((routine_name1==((STR) NULL))) {
    PROG_barf_STR(p, ((STR) &MalformedEXPORTSfile));
   }
   else {
    L4 = ATTR(res,exports);
    L5 = IDENT_create_STR_IDENT(IDENT_zero, class_name1);
    SATTR(res,exports,FSETTUPIDENTIDENT_insert(L4, TUPIDENTIDENT_create_IDE(TUPIDENTIDENT_zero, L5, IDENT_create_STR_IDENT(IDENT_zero, routine_name1))));
   }
  }
 }
 after_loop1: ;
 ret_val = res;
 return ret_val;
}

/* C for type INLINE */




INLINE INLINE_create_PROG_INLIN(INLINE self, PROG p) {
 INLINE ret_val;
 INLINE r;
 TP_CLASS int_tp;
 SIG ipiis;
 INLINE L1;
 ARRAYdTP L2;
 INLINE_ROUT_TBL L3;
 L1 = ((INLINE) rt_alloc(sizeof(struct INLINE_struct), INLINE_tag));
 r = L1;
 SATTR(r,rtbl,INLINE_ROUT_TBL_create_I(((INLINE_ROUT_TBL) NULL), 1024));
 SATTR(r,itbl,INLINE_ITER_TBL_create_I(((INLINE_ITER_TBL) NULL), 64));
 SATTR(r,prog1,p);
 int_tp = TP_BUILTIN_int;
 L2 = ((ARRAYdTP) rt_arr_alloc(sizeof(struct ARRAYdTP_struct), ARRAYdTP_tag, sizeof(dTP) , 1));
 L2->asize = 1;
 L2->arr_part[0] = ((dTP) int_tp);
 ipiis = SIG_create_dTP_IDENT_ARR(((SIG) NULL), ((dTP) int_tp), IDENT_BUILTIN_plus_ident1, L2, ((dTP) int_tp));
 L3 = ATTR(r,rtbl);
 SATTR(r,rtbl,INLINE_ROUT_TBL_insert_d(L3, ((dINLINE_ROUT_SIG) INLINE_INT_FOLD_create_S(((INLINE_INT_FOLD) NULL), ipiis))));
 SATTR(r,inline_routs,FALSE);
 SATTR(r,inline_iters,FALSE);
 SATTR(r,rout_thres,INLINE_default_rout_thre);
 SATTR(r,iter_thres,INLINE_default_iter_thre);
 ret_val = r;
 return ret_val;
}

/* C for type INLINE_ARR_READ */




dAM_EXPR INLINE_ARR_READ_inline_A(INLINE_ARR_READ self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}

/* C for type INLINE_ARR_WRITE */




dAM_EXPR INLINE_ARR_WRITE_inline_(INLINE_ARR_WRITE self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}

/* C for type INLINE_ATTR_READ */




void INLINE_ATTR_READ_inlined(INLINE_ATTR_READ self, INT inlined) {
 INLINE_ATTR_READ_inlined1 = inlined;
}

/* C for type INLINE_ATTR_WRITE */




void INLINE_ATTR_WRITE_inline(INLINE_ATTR_WRITE self, INT inlined) {
 INLINE_ATTR_WRITE_inline1 = inlined;
}

/* C for type INLINE_BUILTIN */




dAM_EXPR INLINE_BUILTIN_inline_AM(INLINE_BUILTIN self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}

/* C for type INLINE_GLOBAL_READ */




void INLINE_GLOBAL_READ_inlin(INLINE_GLOBAL_READ self, INT inlined) {
 INLINE_GLOBAL_READ_inlin1 = inlined;
}

/* C for type INLINE_INT_FOLD */




void INLINE_INT_FOLD_routines(INLINE_INT_FOLD self, INT routines1) {
 INLINE_INT_FOLD_routines1 = routines1;
}

/* C for type INLINE_ITER */




SIG INLINE_ITER_sig_SIG(INLINE_ITER self) {
 SIG ret_val;
 ret_val = ATTR(self,signature);
 return ret_val;
}
