#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dBACK_END_struct {
 OB_HEADER header;
 } *dBACK_END;

typedef struct dHASH_struct {
 OB_HEADER header;
 } *dHASH;

typedef struct dINLINE_ITER_SIG_struct {
 OB_HEADER header;
 } *dINLINE_ITER_SIG;

typedef struct dINLINE_ROUT_SIG_struct {
 OB_HEADER header;
 } *dINLINE_ROUT_SIG;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_LAYOUT_struct {/* layout for ABSTRACT_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct PROG_struct *prog1;
 STR str1;
 } *ABSTRACT_LAYOUT;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;


typedef struct ARRAYdTP_eltb_dTP_frame_struct {
 ARRAYdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 ARRAYdTP L31;
 struct ARRAYdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdTP_eltb_dTP_frame;

typedef struct BOUND_TYPE_LAYOUT_struct {/* layout for BOUND_TYPE_LAYOUT */
 OB_HEADER header;
 STR str1;
 struct TP_ROUT_struct *tp1;
 } *BOUND_TYPE_LAYOUT;

typedef struct BUILTIN_LAYOUT_struct {/* layout for BUILTIN_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *BUILTIN_LAYOUT;

typedef struct CHANGE_VARS_struct {/* layout for CHANGE_VARS */
 OB_HEADER header;
 struct dAM_STMT_struct *init_hot1;
 struct dAM_STMT_struct *init_nonhot1;
 struct dAM_STMT_struct *init_parms1;
 struct dAM_STMT_struct *init_vars1;
 struct ARRAYINT_struct *pind_hot;
 struct ARRAYINT_struct *pind_nonhot;
 struct FLISTAM_LOCAL_EXPR_struct *new_vars;
 struct FLISTAM_LOCAL_EXPR_struct *saved_vars;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *new_subst;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *saved_subst;
 } *CHANGE_VARS;

typedef struct CLASS_LAYOUT_struct {/* layout for CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *CLASS_LAYOUT;

typedef struct ERR1_struct {/* layout for ERR */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *ERR1;

typedef struct EXTERNAL_LAYOUT_struct {/* layout for EXTERNAL_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *EXTERNAL_LAYOUT;

typedef struct FILE1_struct {/* layout for FILE */
 OB_HEADER header;
 EXT_OB fp;
 } *FILE1;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct INLINE_ATTR_READ_struct {/* layout for INLINE_ATTR_READ */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_READ;

typedef struct INLINE_ATTR_WRITE_struct {/* layout for INLINE_ATTR_WRITE */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_WRITE;

typedef struct INLINE_GLOBAL_READ_struct {/* layout for INLINE_GLOBAL_READ */
 OB_HEADER header;
 struct AM_GLOBAL_EXPR_struct *age11;
 struct SIG_struct *sig11;
 } *INLINE_GLOBAL_READ;

typedef struct INLINE_ITER_struct {/* layout for INLINE_ITER */
 OB_HEADER header;
 struct dAM_EXPR_struct *yield_cond;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *BEFLOOP_code;
 struct dAM_STMT_struct *IINIT_code;
 struct dAM_STMT_struct *ITERM_code;
 struct dAM_STMT_struct *WNOY_code;
 struct dAM_STMT_struct *WYAFT_code;
 struct dAM_STMT_struct *WYBEF_code;
 struct CHANGE_VARS_struct *change_vars;
 struct FLISTAM_LOCAL_EXPR_struct *loop_firsts;
 struct SIG_struct *signature;
 BOOL flat_yield;
 } *INLINE_ITER;

typedef struct INLINE_ROUT_struct {/* layout for INLINE_ROUT */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_STMT_struct *code11;
 struct CHANGE_VARS_struct *change_vars;
 struct SIG_struct *signature;
 } *INLINE_ROUT;

typedef struct INLINE_VARR_READ_struct {/* layout for INLINE_VARR_READ */
 OB_HEADER header;
 struct SIG_struct *sig11;
 } *INLINE_VARR_READ;

typedef struct INLINE_VARR_WRITE_struct {/* layout for INLINE_VARR_WRITE */
 OB_HEADER header;
 struct SIG_struct *sig11;
 } *INLINE_VARR_WRITE;

typedef struct INLINE_VATTR_WRITE_struct {/* layout for INLINE_VATTR_WRITE */
 OB_HEADER header;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_VATTR_WRITE;


typedef struct INT_downtob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_downtob_INT_INT_frame;


typedef struct INT_forb_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 INT e;
 } *INT_forb_INT_INT_frame;


typedef struct INT_timesb_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT i;
 } *INT_timesb_frame;


typedef struct INT_timesb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_timesb_INT_frame;


typedef struct INT_upb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_upb_INT_frame;


typedef struct INT_uptob_INT_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT arg1;/* Formal argument: i */
 INT state;
 INT ret_val;
 INT r;
 } *INT_uptob_INT_INT_frame;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct ITER_INLINE_struct {/* layout for ITER_INLINE */
 OB_HEADER header;
 STR after1;
 STR at_decs;
 STR before1;
 STR when_first_seen;
 } *ITER_INLINE;

typedef struct LAYOUT_ARRAY_struct {/* layout for LAYOUT_ARRAY */
 OB_HEADER header;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *LAYOUT_ARRAY;


typedef struct LAYOUT_ARRAY_aeltb_dLAYO_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 INT state;
 dLAYOUT ret_val;
 INT i;
 } *LAYOUT_ARRAY_aeltb_dLAYO_frame;


typedef struct LAYOUT_ARRAY_asetb_dLAYO_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 dLAYOUT arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARRAY_asetb_dLAYO_frame;


typedef struct LAYOUT_ARRAY_eltb_dLAYOU_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 INT state;
 dLAYOUT ret_val;
 LAYOUT_ARRAY L31;
 struct LAYOUT_ARRAY_aeltb_dLAYO_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARRAY_eltb_dLAYOU_frame;


typedef struct LAYOUT_ARRAY_setb_dLAYOU_frame_struct {
 LAYOUT_ARRAY self;/* Formal argument: self */
 dLAYOUT arg1;/* Formal argument: val */
 INT state;
 LAYOUT_ARRAY L21;
 struct LAYOUT_ARRAY_asetb_dLAYO_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARRAY_setb_dLAYOU_frame;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct MS_RANDOM_GEN_struct {/* layout for MS_RANDOM_GEN */
 OB_HEADER header;
 INT seed;
 } *MS_RANDOM_GEN;

typedef struct NAMESPACE_struct {/* layout for NAMESPACE */
 OB_HEADER header;
 struct FMAPSTRINT_struct *uniques;
 struct FSETSTR_struct *set;
 INT counter1;
 struct NAMEMAP_struct *map;
 } *NAMESPACE;

typedef struct NULL_OPTIMIZE_struct {/* layout for NULL_OPTIMIZE */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *NULL_OPTIMIZE;

typedef struct OUT_struct {/* layout for OUT */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *OUT;

typedef struct RND_struct {/* layout for RND */
 OB_HEADER header;
 struct MS_RANDOM_GEN_struct *gen;
 } *RND;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;


typedef struct STR_eltb_CHAR_frame_struct {
 STR self;/* Formal argument: self */
 INT state;
 CHAR ret_val;
 STR L31;
 struct STR_aeltb_CHAR_frame_struct *nested1; /* nested iter frame */
 } *STR_eltb_CHAR_frame;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct SYSTEM_LEX_struct {/* layout for SYSTEM_LEX */
 OB_HEADER header;
 struct FSTR_struct *buf11;
 INT lex_state;
 INT pos1;
 STR name1;
 } *SYSTEM_LEX;


typedef struct SYSTEM_LEX_eltb_STR_frame_struct {
 SYSTEM_LEX self;/* Formal argument: self */
 INT state;
 STR ret_val;
 STR s;
 } *SYSTEM_LEX_eltb_STR_frame;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TRANS_struct {/* layout for TRANS */
 OB_HEADER header;
 struct dAM_STMT_struct *cur_lock;
 struct dAM_STMT_struct *init_stmts;
 struct dTP_struct *ex_tp;
 struct AM_INVARIANT_STMT_struct *inv_stmt;
 struct AM_LOCAL_EXPR_struct *cur_cohort;
 struct AM_LOCAL_EXPR_struct *cur_par_ob;
 struct AM_LOCAL_EXPR_struct *cur_param_ob;
 struct AM_LOOP_STMT_struct *cur_loop;
 struct AM_POST_STMT_struct *post_stmt;
 struct AM_ROUT_DEF_struct *cur_rout;
 struct FLISTAM_LOCAL_EXPR_struct *active_locals;
 struct IMPL_struct *impl1;
 INT cur_yield_ind;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *tp_con;
 BOOL in_constant;
 BOOL in_external;
 BOOL in_initial;
 BOOL in_invariant;
 BOOL in_post;
 BOOL in_pre;
 BOOL in_protect_body;
 BOOL in_protect_then;
 } *TRANS;

typedef struct TUPdOBNAMESPACE_struct {/* layout for TUP{$OB,NAMESPACE} */
 OB t1;
 struct NAMESPACE_struct *t2;
 } TUPdOBNAMESPACE;
static TUPdOBNAMESPACE TUPdOBNAMESPACE_zero;

typedef struct TUPdOBNAMESPACE_boxed_struct {
 OB_HEADER header;
 TUPdOBNAMESPACE value_part;
 } *TUPdOBNAMESPACE_boxed;

typedef struct TUPdOBSTR_struct {/* layout for TUP{$OB,STR} */
 OB t1;
 STR t2;
 } TUPdOBSTR;
static TUPdOBSTR TUPdOBSTR_zero;

typedef struct TUPdOBSTR_boxed_struct {
 OB_HEADER header;
 TUPdOBSTR value_part;
 } *TUPdOBSTR_boxed;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPIDENTdTP_struct {/* layout for TUP{IDENT,$TP} */
 struct dTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTdTP;
static TUPIDENTdTP TUPIDENTdTP_zero;

typedef struct TUPIDENTdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTdTP value_part;
 } *TUPIDENTdTP_boxed;

typedef struct TUPSTRINT_struct {/* layout for TUP{STR,INT} */
 INT t2;
 STR t1;
 } TUPSTRINT;
static TUPSTRINT TUPSTRINT_zero;

typedef struct TUPSTRINT_boxed_struct {
 OB_HEADER header;
 TUPSTRINT value_part;
 } *TUPSTRINT_boxed;

typedef struct VALUE_CLASS_LAYOUT_struct {/* layout for VALUE_CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *VALUE_CLASS_LAYOUT;

typedef struct WEIGH_CODE_struct {/* layout for WEIGH_CODE */
 OB_HEADER header;
 struct dAM_STMT_struct *badstmt;
 struct AM_IF_STMT_struct *enclosing_if;
 INT level1;
 INT max_weight;
 INT weight;
 BOOL true_branch;
 } *WEIGH_CODE;

typedef struct XFORM_CODE_struct {/* layout for XFORM_CODE */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *after_yield;
 struct AM_IF_STMT_struct *enclosing_if;
 struct AM_IF_STMT_struct *if_encl_yield;
 struct AM_LOOP_STMT_struct *loop_stmt;
 struct AM_LOOP_STMT_struct *new_loop_stmt;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *subst1;
 BOOL record_calls;
 BOOL true_br_yield;
 BOOL true_branch;
 } *XFORM_CODE;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTR_EXPR_struct {/* layout for AM_ATTR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_ATTR_EXPR;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;


typedef struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ROUT_CALL_EXPR L31;
 struct AM_ROUT_CALL_EXPR_aeltb__frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_eltb_d_frame;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AM_STMT_EXPR_struct {/* layout for AM_STMT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *stmts;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 struct SFILE_ID_struct source11;
 } *AM_STMT_EXPR;

typedef struct AM_STR_CONST_struct {/* layout for AM_STR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 STR bval;
 } *AM_STR_CONST;

typedef struct AM_VATTR_ASSIGN_EXPR_struct {/* layout for AM_VATTR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_VATTR_ASSIGN_EXPR;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;

typedef struct FLISTINT_struct {/* layout for FLIST{INT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 INT arr_part[1];
 } *FLISTINT;

typedef struct FMAPdOBNAMESPACE_struct {/* layout for FMAP{$OB,NAMESPACE} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdOBNAMESPACE_struct arr_part[1];
 } *FMAPdOBNAMESPACE;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;

typedef struct FMAPSTRINT_struct {/* layout for FMAP{STR,INT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRINT_struct arr_part[1];
 } *FMAPSTRINT;

typedef struct FSETSTR_struct {/* layout for FSET{STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 STR arr_part[1];
 } *FSETSTR;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct INLINE_ITER_TBL_struct {/* layout for INLINE_ITER_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ITER_SIG_struct *arr_part[1];
 } *INLINE_ITER_TBL;


typedef struct INLINE_ITER_TBL_aeltb_dI_frame_struct {
 INLINE_ITER_TBL self;/* Formal argument: self */
 INT state;
 dINLINE_ITER_SIG ret_val;
 INT i;
 } *INLINE_ITER_TBL_aeltb_dI_frame;


typedef struct INLINE_ITER_TBL_asetb_dI_frame_struct {
 INLINE_ITER_TBL self;/* Formal argument: self */
 dINLINE_ITER_SIG arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *INLINE_ITER_TBL_asetb_dI_frame;


typedef struct INLINE_ITER_TBL_eltb_dIN_frame_struct {
 INLINE_ITER_TBL self;/* Formal argument: self */
 INT state;
 dINLINE_ITER_SIG ret_val;
 INLINE_ITER_TBL L31;
 dINLINE_ITER_SIG r;
 struct INLINE_ITER_TBL_aeltb_dI_frame_struct *nested1; /* nested iter frame */
 } *INLINE_ITER_TBL_eltb_dIN_frame;

typedef struct INLINE_ROUT_TBL_struct {/* layout for INLINE_ROUT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ROUT_SIG_struct *arr_part[1];
 } *INLINE_ROUT_TBL;


typedef struct INLINE_ROUT_TBL_aeltb_dI_frame_struct {
 INLINE_ROUT_TBL self;/* Formal argument: self */
 INT state;
 dINLINE_ROUT_SIG ret_val;
 INT i;
 } *INLINE_ROUT_TBL_aeltb_dI_frame;


typedef struct INLINE_ROUT_TBL_asetb_dI_frame_struct {
 INLINE_ROUT_TBL self;/* Formal argument: self */
 dINLINE_ROUT_SIG arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *INLINE_ROUT_TBL_asetb_dI_frame;


typedef struct INLINE_ROUT_TBL_eltb_dIN_frame_struct {
 INLINE_ROUT_TBL self;/* Formal argument: self */
 INT state;
 dINLINE_ROUT_SIG ret_val;
 INLINE_ROUT_TBL L31;
 dINLINE_ROUT_SIG r;
 struct INLINE_ROUT_TBL_aeltb_dI_frame_struct *nested1; /* nested iter frame */
 } *INLINE_ROUT_TBL_eltb_dIN_frame;

typedef struct LAYOUT_ARR_struct {/* layout for LAYOUT_ARR */
 OB_HEADER header;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *LAYOUT_ARR;


typedef struct LAYOUT_ARR_aeltb_TUPIDEN_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 INT i;
 } *LAYOUT_ARR_aeltb_TUPIDEN_frame;


typedef struct LAYOUT_ARR_asetb_TUPIDEN_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 TUPIDENTdTP arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_asetb_TUPIDEN_frame;


typedef struct LAYOUT_ARR_eltb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 LAYOUT_ARR L31;
 struct LAYOUT_ARR_aeltb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_eltb_TUPIDENT_frame;


typedef struct LAYOUT_ARR_setb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 TUPIDENTdTP arg1;/* Formal argument: val */
 INT state;
 LAYOUT_ARR L21;
 struct LAYOUT_ARR_asetb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_setb_TUPIDENT_frame;

typedef struct NAMEMAP_struct {/* layout for NAMEMAP */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdOBSTR_struct arr_part[1];
 } *NAMEMAP;


typedef struct NAMEMAP_aeltb_TUPdOBSTR_frame_struct {
 NAMEMAP self;/* Formal argument: self */
 INT state;
 TUPdOBSTR ret_val;
 INT i;
 } *NAMEMAP_aeltb_TUPdOBSTR_frame;


typedef struct NAMEMAP_asetb_TUPdOBSTR_frame_struct {
 NAMEMAP self;/* Formal argument: self */
 TUPdOBSTR arg1;/* Formal argument: val */
 INT state;
 INT L21;
 struct INT_timesb_INT_frame_struct *nested1; /* nested iter frame */
 } *NAMEMAP_asetb_TUPdOBSTR_frame;


typedef struct NAMEMAP_pairsb_TUPdOBSTR_frame_struct {
 NAMEMAP self;/* Formal argument: self */
 INT state;
 TUPdOBSTR ret_val;
 NAMEMAP L31;
 TUPdOBSTR r;
 struct NAMEMAP_aeltb_TUPdOBSTR_frame_struct *nested1; /* nested iter frame */
 } *NAMEMAP_pairsb_TUPdOBSTR_frame;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern CGEN LAYOUT_TBL_cgen;
extern FLTD MS_RANDOM_GEN_ms_a;
extern FLTD MS_RANDOM_GEN_ms_m;
extern FLTD MS_RANDOM_GEN_ms_md;
extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSTR INTI_buf;
extern FSTR INT_buf;
extern INT INLINE_ITER_TBL_load_rat;
extern INT INLINE_ROUT_TBL_load_rat;
extern INT INLINE_ROUT_inlined;
extern INT INLINE_ROUT_routines;
extern INT INLINE_VATTR_WRITE_inlin1;
extern INT INLINE_VATTR_WRITE_routi1;
extern INT INTI_B;
extern INT INTI_D;
extern INT INTI_log10D;
extern INT INTI_log2B;
extern INT INT_asize;
extern INT LAYOUT_ARRAY_quicksort_l;
extern INT LAYOUT_ARR_quicksort_lim;
extern INT NAMEMAP_load_ratio;
extern INT TP_KIND_ext_tp;
extern PROG LAYOUT_TBL_prog;
extern TP_CLASS TP_BUILTIN_bool;
extern TP_CLASS TP_BUILTIN_char;
extern TP_CLASS TP_BUILTIN_fltd;

/* Function declarations */

ABSTRACT_LAYOUT ABSTRACT_LAYOUT_create_d(ABSTRACT_LAYOUT, dTP, PROG);
AM_LOCAL_EXPR AM_ROUT_DEF_aget_INT_AM_(AM_ROUT_DEF, INT);
AM_STMT_EXPR AM_STMT_EXPR_create_SFIL(AM_STMT_EXPR, SFILE_ID);
AM_VATTR_ASSIGN_EXPR AM_VATTR_ASSIGN_EXPR_cre(AM_VATTR_ASSIGN_EXPR, SFILE_ID);
BOOL CGEN_is_built_in_type_dT(CGEN, dTP);
BOOL FSETSTR_test_STR_BOOL(FSETSTR, STR);
BOOL INLINE_ITER_TBL_elt_eq_d(INLINE_ITER_TBL, dINLINE_ITER_SIG, dINLINE_ITER_SIG);
BOOL INLINE_ITER_TBL_is_elt_n(INLINE_ITER_TBL, dINLINE_ITER_SIG);
BOOL INLINE_ITER_TBL_not_too_(INLINE_ITER_TBL, INT, INT);
BOOL INLINE_ITER_TBL_query_te(INLINE_ITER_TBL, SIG, dINLINE_ITER_SIG);
BOOL INLINE_ITER_TBL_should_g(INLINE_ITER_TBL);
BOOL INLINE_ITER_is_inlineabl(INLINE_ITER, AM_ROUT_DEF, INT);
BOOL INLINE_ROUT_TBL_elt_eq_d(INLINE_ROUT_TBL, dINLINE_ROUT_SIG, dINLINE_ROUT_SIG);
BOOL INLINE_ROUT_TBL_is_elt_n(INLINE_ROUT_TBL, dINLINE_ROUT_SIG);
BOOL INLINE_ROUT_TBL_not_too_(INLINE_ROUT_TBL, INT, INT);
BOOL INLINE_ROUT_TBL_query_te(INLINE_ROUT_TBL, SIG, dINLINE_ROUT_SIG);
BOOL INLINE_ROUT_TBL_should_g(INLINE_ROUT_TBL);
BOOL INLINE_ROUT_is_inlineabl(INLINE_ROUT, AM_ROUT_DEF, INT);
BOOL INTI_is_eq_INTI_BOOL(INTI, INTI);
BOOL INTI_is_geq_INTI_BOOL(INTI, INTI);
BOOL INTI_is_gt_INTI_BOOL(INTI, INTI);
BOOL INTI_is_lt_INTI_BOOL(INTI, INTI);
BOOL INTI_is_neg_BOOL(INTI);
BOOL INTI_is_odd_BOOL(INTI);
BOOL INTI_is_pos_BOOL(INTI);
BOOL INTI_is_zero_BOOL(INTI);
BOOL INT_is_nil_BOOL(INT);
BOOL LAYOUT_ARRAY_elt_lt_dLAY(LAYOUT_ARRAY, dLAYOUT, dLAYOUT);
BOOL LAYOUT_ARRAY_is_sorted_B(LAYOUT_ARRAY);
BOOL LAYOUT_ARR_elt_lt_TUPIDE(LAYOUT_ARR, TUPIDENTdTP, TUPIDENTdTP);
BOOL LAYOUT_ARR_is_sorted_BOO(LAYOUT_ARR);
BOOL NAMEMAP_is_key_nil_dOB_B(NAMEMAP, OB);
BOOL NAMEMAP_key_eq_dOB_dOB_B(NAMEMAP, OB, OB);
BOOL NAMEMAP_not_too_many_INT(NAMEMAP, INT, INT);
BOOL NAMEMAP_should_grow_BOOL(NAMEMAP);
BOOL NAMESPACE_is_taken_STR_B(NAMESPACE, STR);
BOOL SIG_is_eq_SIG_BOOL(SIG, SIG);
BOOL STR_is_lt_STR_BOOL(STR, STR);
BOOL STR_is_neq_STR_BOOL(STR, STR);
BOOL TRANS_is_array_sig_SIG_B(TRANS, SIG);
BOUND_TYPE_LAYOUT BOUND_TYPE_LAYOUT_create(BOUND_TYPE_LAYOUT, dTP);
BUILTIN_LAYOUT BUILTIN_LAYOUT_create_dT(BUILTIN_LAYOUT, dTP);
CHANGE_VARS CHANGE_VARS_create_AM_RO(CHANGE_VARS, AM_ROUT_DEF);
CHAR INT_digit_char_CHAR(INT);
CHAR STR_eltb_CHAR(STR_eltb_CHAR_frame);
CLASS_LAYOUT CLASS_LAYOUT_create_dTP_(CLASS_LAYOUT, dTP, PROG);
ERR1 ERR_create_ERR(ERR1);
ERR1 ERR_plus_dSTR_ERR(ERR1, dSTR);
EXTERNAL_LAYOUT EXTERNAL_LAYOUT_create_d(EXTERNAL_LAYOUT, dTP);
FILE1 FILE_stdout_FILE(FILE1);
FLISTINT FLISTINT_push_INT_FLISTI(FLISTINT, INT);
FLTD FLTD_floor_FLTD(FLTD);
FLTD MS_RANDOM_GEN_get_FLTD(MS_RANDOM_GEN);
FMAPSTRINT FMAPSTRINT_create_FMAPST(FMAPSTRINT);
FMAPSTRINT FMAPSTRINT_insert_STR_IN(FMAPSTRINT, STR, INT);
FMAPdOBNAMESPACE FMAPdOBNAMESPACE_create_(FMAPdOBNAMESPACE);
FMAPdOBNAMESPACE FMAPdOBNAMESPACE_delete_(FMAPdOBNAMESPACE, OB);
FMAPdOBNAMESPACE FMAPdOBNAMESPACE_insert_1(FMAPdOBNAMESPACE, OB, NAMESPACE);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FSETSTR FSETSTR_create_FSETSTR(FSETSTR);
FSETSTR FSETSTR_insert_STR_FSETS(FSETSTR, STR);
FSTR FSTR_create_FSTR(FSTR);
FSTR FSTR_plus_CHAR_FSTR(FSTR, CHAR);
FSTR FSTR_plus_FSTR_FSTR(FSTR, FSTR);
FSTR FSTR_plus_STR_FSTR(FSTR, STR);
FSTR INTI_str_in_FSTR_FSTR(INTI, FSTR);
FSTR INTI_str_in_FSTR_INT_INT(INTI, FSTR, INT, INT, CHAR);
FSTR INT_str_in_FSTR_FSTR(INT, FSTR);
FSTR INT_str_in_FSTR_INT_INT_(INT, FSTR, INT, INT, CHAR);
INLINE_ATTR_READ INLINE_ATTR_READ_create_(INLINE_ATTR_READ, AM_ROUT_DEF);
INLINE_ATTR_WRITE INLINE_ATTR_WRITE_create(INLINE_ATTR_WRITE, AM_ROUT_DEF);
INLINE_GLOBAL_READ INLINE_GLOBAL_READ_creat(INLINE_GLOBAL_READ, AM_ROUT_DEF);
INLINE_ITER INLINE_ITER_create_AM_RO(INLINE_ITER, AM_ROUT_DEF);
INLINE_ITER_TBL INLINE_ITER_TBL_allocate(INLINE_ITER_TBL, INT);
INLINE_ITER_TBL INLINE_ITER_TBL_create_I(INLINE_ITER_TBL, INT);
INLINE_ITER_TBL INLINE_ITER_TBL_double_s(INLINE_ITER_TBL);
INLINE_ITER_TBL INLINE_ITER_TBL_insert_d(INLINE_ITER_TBL, dINLINE_ITER_SIG);
INLINE_ITER_TBL INLINE_ITER_TBL_test_and(INLINE_ITER_TBL, AM_ROUT_DEF, BOOL, INT);
INLINE_ROUT INLINE_ROUT_create_AM_RO(INLINE_ROUT, AM_ROUT_DEF);
INLINE_ROUT_TBL INLINE_ROUT_TBL_allocate(INLINE_ROUT_TBL, INT);
INLINE_ROUT_TBL INLINE_ROUT_TBL_create_I(INLINE_ROUT_TBL, INT);
INLINE_ROUT_TBL INLINE_ROUT_TBL_double_s(INLINE_ROUT_TBL);
INLINE_ROUT_TBL INLINE_ROUT_TBL_insert_d(INLINE_ROUT_TBL, dINLINE_ROUT_SIG);
INLINE_ROUT_TBL INLINE_ROUT_TBL_test_and(INLINE_ROUT_TBL, AM_ROUT_DEF, BOOL, INT);
INLINE_VATTR_WRITE INLINE_VATTR_WRITE_creat(INLINE_VATTR_WRITE, AM_ROUT_DEF);
INT FLISTINT_pop_INT(FLISTINT);
INT FLISTINT_size_INT(FLISTINT);
INT FMAPSTRINT_get_STR_INT(FMAPSTRINT, STR);
INT FSTR_length_INT(FSTR);
INT IDENT_hash_INT(IDENT);
INT INLINE_ITER_TBL_asize_IN(INLINE_ITER_TBL);
INT INLINE_ITER_TBL_elt_hash(INLINE_ITER_TBL, dINLINE_ITER_SIG);
INT INLINE_ITER_TBL_query_ha(INLINE_ITER_TBL, SIG);
INT INLINE_ROUT_TBL_asize_IN(INLINE_ROUT_TBL);
INT INLINE_ROUT_TBL_elt_hash(INLINE_ROUT_TBL, dINLINE_ROUT_SIG);
INT INLINE_ROUT_TBL_query_ha(INLINE_ROUT_TBL, SIG);
INT INTI_aget_INT_INT(INTI, INT);
INT INTI_asize_INT(INTI);
INT INTI_cmp_INTI_INT(INTI, INTI);
INT INTI_int_INT(INTI);
INT INTI_log2_INT(INTI);
INT INTI_u_cmp_INTI_INTI_INT(INTI, INTI, INTI);
INT INTI_u_mod_INTI_INT_INT(INTI, INTI, INT);
INT INT_create_STR_INT(INT, STR);
INT INT_downtob_INT_INT(INT_downtob_INT_INT_frame);
INT INT_forb_INT_INT(INT_forb_INT_INT_frame);
INT INT_hash_INT(INT);
INT INT_highest_bit_INT(INT);
INT INT_nil_INT(INT);
INT INT_pow_INT_INT(INT, INT);
INT INT_timesb_INT(INT_timesb_INT_frame);
INT INT_upb_INT(INT_upb_INT_frame);
INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame);
INT LAYOUT_ARRAY_asize_INT(LAYOUT_ARRAY);
INT LAYOUT_ARR_alignment_dTP(LAYOUT_ARR, dTP);
INT LAYOUT_ARR_asize_INT(LAYOUT_ARR);
INT NAMEMAP_asize_INT(NAMEMAP);
INT NAMEMAP_key_hash_dOB_INT(NAMEMAP, OB);
INT RND_int_INT_INT_INT(RND, INT, INT);
INT STR_length_INT(STR);
INTI INTI_abs_INTI(INTI);
INTI INTI_copy_INTI(INTI);
INTI INTI_create_INT_INTI(INTI, INT);
INTI INTI_div_INTI_INTI(INTI, INTI);
INTI INTI_gcd_INTI_INTI(INTI, INTI);
INTI INTI_get_u_div_INTI_INTI(INTI, INTI, INTI, INTI);
INTI INTI_get_u_mod_INTI_INTI(INTI, INTI, INTI, INTI);
INTI INTI_minus_INTI_INTI(INTI, INTI);
INTI INTI_mod_INTI_INTI(INTI, INTI);
INTI INTI_negate_INTI(INTI);
INTI INTI_plus_INTI_INTI(INTI, INTI);
INTI INTI_pow_INT_INTI(INTI, INT);
INTI INTI_square_INTI(INTI);
INTI INTI_times_INTI_INTI(INTI, INTI);
INTI INTI_u_div_mod_INTI_INTI(INTI, INTI, INTI);
INTI INTI_u_minus_INTI_INTI_I(INTI, INTI, INTI);
INTI INTI_u_plus_INTI_INTI_IN(INTI, INTI, INTI);
INTI INTI_u_times_INTI_INTI_I(INTI, INTI, INTI);
INTI INTI_u_times_plus_INTI_I(INTI, INTI, INT, INT);
ITER_INLINE ITER_INLINE_create_STR_S(ITER_INLINE, STR, STR, STR, STR);
LAYOUT_ARR LAYOUT_ARR_create_INT_LA(LAYOUT_ARR, INT);
LAYOUT_ARRAY LAYOUT_ARRAY_create_INT_(LAYOUT_ARRAY, INT);
MANGLE MANGLE_create_PROG_MANGL(MANGLE, PROG);
MS_RANDOM_GEN MS_RANDOM_GEN_create_MS_(MS_RANDOM_GEN);
NAMEMAP NAMEMAP_allocate_INT_NAM(NAMEMAP, INT);
NAMEMAP NAMEMAP_create_NAMEMAP(NAMEMAP);
NAMEMAP NAMEMAP_double_size_NAME(NAMEMAP);
NAMEMAP NAMEMAP_insert_dOB_STR_N(NAMEMAP, OB, STR);
NAMEMAP NAMEMAP_insert_pair_TUPd(NAMEMAP, TUPdOBSTR);
NAMESPACE FMAPdOBNAMESPACE_get_dOB(FMAPdOBNAMESPACE, OB);
NAMESPACE MANGLE_space_dOB_NAMESPA(MANGLE, OB);
NAMESPACE NAMESPACE_create_NAMESPA(NAMESPACE);
NULL_OPTIMIZE NULL_OPTIMIZE_create_PRO(NULL_OPTIMIZE, PROG);
OB NAMEMAP_key_nil_dOB(NAMEMAP);
OUT OUT_create_OUT(OUT);
OUT OUT_plus_dSTR_OUT(OUT, dSTR);
SIG INLINE_ROUT_sig_SIG(INLINE_ROUT);
SIG INLINE_VATTR_WRITE_sig_S(INLINE_VATTR_WRITE);
STR FSTR_str_STR(FSTR);
STR INTI_str_STR(INTI);
STR INT_hex_str_STR(INT);
STR INT_octal_str_STR(INT);
STR INT_str_STR(INT);
STR MANGLE_Cify_CHAR_STR(MANGLE, CHAR);
STR MANGLE_Cify_STR_STR(MANGLE, STR);
STR MANGLE_genlocal_dOB_STR(MANGLE, OB);
STR MANGLE_genother_dOB_STR(MANGLE, OB);
STR MANGLE_mangle_dOB_dOB_ST(MANGLE, OB, OB);
STR NAMEMAP_get_dOB_STR(NAMEMAP, OB);
STR NAMESPACE_get_dOB_STR(NAMESPACE, OB);
STR NAMESPACE_unique_with_pr(NAMESPACE, STR);
STR NAMESPACE_with_prefix_ST(NAMESPACE, STR);
STR STR_append_STR_STR_STR(STR, STR, STR);
STR STR_head_INT_STR(STR, INT);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_pretty_STR(STR);
STR STR_substring_INT_INT_ST(STR, INT, INT);
STR SYSTEM_LEX_eltb_STR(SYSTEM_LEX_eltb_STR_frame);
STR TP_CLASS_str_STR(TP_CLASS);
STR TP_ROUT_str_STR(TP_ROUT);
SYSTEM_LEX SYSTEM_LEX_create_STR_SY(SYSTEM_LEX, STR);
TUPIDENTdTP LAYOUT_ARR_aeltb_TUPIDEN(LAYOUT_ARR_aeltb_TUPIDEN_frame);
TUPIDENTdTP LAYOUT_ARR_aget_INT_TUPI(LAYOUT_ARR, INT);
TUPIDENTdTP LAYOUT_ARR_eltb_TUPIDENT(LAYOUT_ARR_eltb_TUPIDENT_frame);
TUPdOBSTR NAMEMAP_aeltb_TUPdOBSTR(NAMEMAP_aeltb_TUPdOBSTR_frame);
TUPdOBSTR NAMEMAP_aget_INT_TUPdOBS(NAMEMAP, INT);
TUPdOBSTR NAMEMAP_pairsb_TUPdOBSTR(NAMEMAP_pairsb_TUPdOBSTR_frame);
TUPdOBSTR TUPdOBSTR_create_dOB_STR(TUPdOBSTR, OB, STR);
VALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_creat(VALUE_CLASS_LAYOUT, dTP, PROG);
WEIGH_CODE WEIGH_CODE_create_INT_WE(WEIGH_CODE, INT);
XFORM_CODE XFORM_CODE_create_FMAPAM(XFORM_CODE, FMAPAM_LOCAL_EXPRAM_LOCA);
dAM_EXPR AM_ROUT_CALL_EXPR_aget_I(AM_ROUT_CALL_EXPR, INT);
dAM_EXPR AM_ROUT_CALL_EXPR_eltb_d(AM_ROUT_CALL_EXPR_eltb_d_frame);
dAM_EXPR INLINE_ROUT_inline_AM_RO(INLINE_ROUT, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_VARR_READ_inline_(INLINE_VARR_READ, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_VARR_WRITE_inline(INLINE_VARR_WRITE, AM_ROUT_CALL_EXPR);
dAM_EXPR INLINE_VATTR_WRITE_inlin2(INLINE_VATTR_WRITE, AM_ROUT_CALL_EXPR);
dAM_EXPR XFORM_CODE_xform_expr_dA(XFORM_CODE, dAM_EXPR);
dAM_STMT XFORM_CODE_xform_stmt_li(XFORM_CODE, dAM_STMT);
dINLINE_ITER_SIG INLINE_ITER_TBL_aeltb_dI(INLINE_ITER_TBL_aeltb_dI_frame);
dINLINE_ITER_SIG INLINE_ITER_TBL_aget_INT(INLINE_ITER_TBL, INT);
dINLINE_ITER_SIG INLINE_ITER_TBL_elt_nil_(INLINE_ITER_TBL);
dINLINE_ITER_SIG INLINE_ITER_TBL_eltb_dIN(INLINE_ITER_TBL_eltb_dIN_frame);
dINLINE_ITER_SIG INLINE_ITER_TBL_get_quer(INLINE_ITER_TBL, SIG);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_aeltb_dI(INLINE_ROUT_TBL_aeltb_dI_frame);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_aget_INT(INLINE_ROUT_TBL, INT);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_elt_nil_(INLINE_ROUT_TBL);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_eltb_dIN(INLINE_ROUT_TBL_eltb_dIN_frame);
dINLINE_ROUT_SIG INLINE_ROUT_TBL_get_quer(INLINE_ROUT_TBL, SIG);
dLAYOUT LAYOUT_ARRAY_aeltb_dLAYO(LAYOUT_ARRAY_aeltb_dLAYO_frame);
dLAYOUT LAYOUT_ARRAY_aget_INT_dL(LAYOUT_ARRAY, INT);
dLAYOUT LAYOUT_ARRAY_eltb_dLAYOU(LAYOUT_ARRAY_eltb_dLAYOU_frame);
dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL, dTP);
dTP ARRAYdTP_eltb_dTP(ARRAYdTP_eltb_dTP_frame);
extern const int dAM_STMT_append_dAM_STMT_offset;

extern const  (*dAM_STMT_append_dAM_STMT[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT_offset;

extern const dAM_STMT (*dAM_STMT_next_dAM_STMT[])(dAM_STMT);
extern const int dBACK_END_emit_AM_ROUT_D_offset;

extern const  (*dBACK_END_emit_AM_ROUT_D[])(dBACK_END, AM_ROUT_DEF);
extern const int dBACK_END_finalize_offset;

extern const  (*dBACK_END_finalize[])(dBACK_END);
extern const int dBACK_END_init_offset;

extern const  (*dBACK_END_init[])(dBACK_END);
extern const int dHASH_hash_INT_offset;

extern const INT (*dHASH_hash_INT[])(dHASH);
extern const int dINLINE_ITER_SIG_sig_SIG_offset;

extern const SIG (*dINLINE_ITER_SIG_sig_SIG[])(dINLINE_ITER_SIG);
extern const int dINLINE_ROUT_SIG_sig_SIG_offset;

extern const SIG (*dINLINE_ROUT_SIG_sig_SIG[])(dINLINE_ROUT_SIG);
extern const int dLAYOUT_str_STR_offset;

extern const STR (*dLAYOUT_str_STR[])(dLAYOUT);
extern const int dSTR_str_STR_offset;

extern const STR (*dSTR_str_STR[])(dSTR);
extern const int dTP_is_abstract_BOOL_offset;

extern const BOOL (*dTP_is_abstract_BOOL[])(dTP);
extern const int dTP_is_bound_BOOL_offset;

extern const BOOL (*dTP_is_bound_BOOL[])(dTP);
extern const int dTP_is_eq_dTP_BOOL_offset;

extern const BOOL (*dTP_is_eq_dTP_BOOL[])(dTP, dTP);
extern const int dTP_is_neq_dTP_BOOL_offset;

extern const BOOL (*dTP_is_neq_dTP_BOOL[])(dTP, dTP);
extern const int dTP_is_value_BOOL_offset;

extern const BOOL (*dTP_is_value_BOOL[])(dTP);
extern const int dTP_kind_INT_offset;

extern const INT (*dTP_kind_INT[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void CHANGE_VARS_after_one_us(CHANGE_VARS);
void CHANGE_VARS_after_saving(CHANGE_VARS);
void CHANGE_VARS_new_copy_SFI(CHANGE_VARS, SFILE_ID);
void ERR_plus_dSTR(ERR1, dSTR);
void FILE_flush(FILE1);
void FILE_plus_dSTR(FILE1, dSTR);
void FSTR_clear(FSTR);
void FSTR_to_reverse(FSTR);
void INLINE_ITER_TBL_aset_INT(INLINE_ITER_TBL, INT, dINLINE_ITER_SIG);
void INLINE_ITER_TBL_asetb_dI(INLINE_ITER_TBL_asetb_dI_frame);
void INLINE_ROUT_TBL_aset_INT(INLINE_ROUT_TBL, INT, dINLINE_ROUT_SIG);
void INLINE_ROUT_TBL_asetb_dI(INLINE_ROUT_TBL_asetb_dI_frame);
void INLINE_ROUT_copy_rout_AM(INLINE_ROUT, AM_ROUT_DEF);
void INLINE_ROUT_inlined_INT(INLINE_ROUT, INT);
void INLINE_ROUT_routines_INT(INLINE_ROUT, INT);
void INLINE_VATTR_WRITE_inlin(INLINE_VATTR_WRITE, INT);
void INLINE_VATTR_WRITE_routi(INLINE_VATTR_WRITE, INT);
void INTI_aset_INT_INT(INTI, INT, INT);
void INTI_buf_FSTR(INTI, FSTR);
void INT_buf_FSTR(INT, FSTR);
void INT_timesb(INT_timesb_frame);
void LAYOUT_ARRAY_aset_INT_dL(LAYOUT_ARRAY, INT, dLAYOUT);
void LAYOUT_ARRAY_asetb_dLAYO(LAYOUT_ARRAY_asetb_dLAYO_frame);
void LAYOUT_ARRAY_insertion_s(LAYOUT_ARRAY, INT, INT);
void LAYOUT_ARRAY_quicksort_r(LAYOUT_ARRAY, INT, INT);
void LAYOUT_ARRAY_setb_dLAYOU(LAYOUT_ARRAY_setb_dLAYOU_frame);
void LAYOUT_ARRAY_sort(LAYOUT_ARRAY);
void LAYOUT_ARR_aset_INT_TUPI(LAYOUT_ARR, INT, TUPIDENTdTP);
void LAYOUT_ARR_asetb_TUPIDEN(LAYOUT_ARR_asetb_TUPIDEN_frame);
void LAYOUT_ARR_insertion_sor(LAYOUT_ARR, INT, INT);
void LAYOUT_ARR_quicksort_ran(LAYOUT_ARR, INT, INT);
void LAYOUT_ARR_setb_TUPIDENT(LAYOUT_ARR_setb_TUPIDENT_frame);
void LAYOUT_ARR_sort(LAYOUT_ARR);
void LAYOUT_TBL_add_dTP_dLAYO(LAYOUT_TBL, dTP, dLAYOUT);
void LAYOUT_TBL_cgen_CGEN(LAYOUT_TBL, CGEN);
void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL, FMAPdTPdLAYOUT);
void LAYOUT_TBL_prog_PROG(LAYOUT_TBL, PROG);
void MANGLE_barf_STR(MANGLE, STR);
void MANGLE_dispose_namespace(MANGLE, OB);
void MANGLE_forbid_STR(MANGLE, STR);
void MANGLE_force_mangle_dOB_(MANGLE, OB, STR, OB);
void MANGLE_warning_STR(MANGLE, STR);
void MS_RANDOM_GEN_init_INT(MS_RANDOM_GEN, INT);
void MS_RANDOM_GEN_ms_m_FLTD(MS_RANDOM_GEN, FLTD);
void MS_RANDOM_GEN_ms_md_FLTD(MS_RANDOM_GEN, FLTD);
void NAMEMAP_aset_INT_TUPdOBS(NAMEMAP, INT, TUPdOBSTR);
void NAMEMAP_asetb_TUPdOBSTR(NAMEMAP_asetb_TUPdOBSTR_frame);
void NAMESPACE_insert_dOB_STR(NAMESPACE, OB, STR);
void NULL_OPTIMIZE_finalize(NULL_OPTIMIZE);
void NULL_OPTIMIZE_init(NULL_OPTIMIZE);
void NULL_OPTIMIZE_optimize_A(NULL_OPTIMIZE, AM_ROUT_DEF);
void OUT_flush(OUT);
void OUT_plus_dSTR(OUT, dSTR);
void PROG_barf_STR(PROG, STR);
void PROG_warning_STR(PROG, STR);
void WEIGH_CODE_calc_expr_wei(WEIGH_CODE, dAM_EXPR);
void WEIGH_CODE_calc_stmt_lis(WEIGH_CODE, dAM_STMT);
void WEIGH_CODE_clear_badstmt(WEIGH_CODE);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */



/* Code */




BOOL INLINE_ITER_TBL_elt_eq_d(INLINE_ITER_TBL self, dINLINE_ITER_SIG e1, dINLINE_ITER_SIG e2) {
 BOOL ret_val = ((BOOL) 0);
 if (e1==NULL) {
  ret_val = SYSOBEQ(((OB) e1),((OB) e2));
  return ret_val;
 } else
 switch (TAG(e1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) e1),((OB) e2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL INLINE_ITER_TBL_is_elt_n(INLINE_ITER_TBL self, dINLINE_ITER_SIG e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dINLINE_ITER_SIG) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dINLINE_ITER_SIG) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL INLINE_ITER_TBL_not_too_(INLINE_ITER_TBL self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dINLINE_ITER_SIG t = ((dINLINE_ITER_SIG) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dINLINE_ITER_SIG e;
 INT h = ((INT) 0);
 INT L3;
 ERR1 L4;
 extern STR Foundaproblemexcessiveco;
 ERR1 L5;
 INT L6;
 ERR1 L7;
 extern STR possiblyduetoabadhashfun;
 ERR1 L8;
 dINLINE_ITER_SIG L9;
 INT L10;
 ERR1 L12;
 extern STR name3;
 L3 = (INTPLUS(start1,50));
 if ((finish>L3)) {
  L4 = ERR_create_ERR(((ERR1) NULL));
  L5 = ERR_plus_dSTR_ERR(L4, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L6 = (SYSTP(((OB) self)));
  L7 = ERR_plus_dSTR_ERR(L5, ((dSTR) (SYSSTRFORTP(L6))));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &possiblyduetoabadhashfun)));
  L9 = INLINE_ITER_TBL_aget_INT(self, start1);
  L10 = (SYSTP(((OB) L9)));
  L12 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L10))));
  ERR_plus_dSTR(L12, ((dSTR) ((STR) &name3)));
  if (t==NULL) {
  } else
  switch (TAG(t)) {
   default: ;
  }
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL INLINE_ITER_TBL_query_te(INLINE_ITER_TBL self, SIG s, dINLINE_ITER_SIG in) {
 BOOL ret_val = ((BOOL) 0);
 dINLINE_ITER_SIG L1;
 SIG L2;
 if ((in==((dINLINE_ITER_SIG) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L1 = in;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE_ITER_TBL::query_test(SIG,$INLINE_ITER_SIG):BOOL");
 }
 L2 = (*dINLINE_ITER_SIG_sig_SIG[TAG(L1)+dINLINE_ITER_SIG_sig_SIG_offset])(L1);
 ret_val = SIG_is_eq_SIG_BOOL(L2, s);
 return ret_val;
}


BOOL INLINE_ITER_TBL_should_g(INLINE_ITER_TBL self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = INLINE_ITER_TBL_load_rat;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL INLINE_ROUT_TBL_elt_eq_d(INLINE_ROUT_TBL self, dINLINE_ROUT_SIG e1, dINLINE_ROUT_SIG e2) {
 BOOL ret_val = ((BOOL) 0);
 if (e1==NULL) {
  ret_val = SYSOBEQ(((OB) e1),((OB) e2));
  return ret_val;
 } else
 switch (TAG(e1)) {
  default: ;
   ret_val = SYSOBEQ(((OB) e1),((OB) e2));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL INLINE_ROUT_TBL_is_elt_n(INLINE_ROUT_TBL self, dINLINE_ROUT_SIG e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((dINLINE_ROUT_SIG) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((dINLINE_ROUT_SIG) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL INLINE_ROUT_TBL_not_too_(INLINE_ROUT_TBL self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 dINLINE_ROUT_SIG t = ((dINLINE_ROUT_SIG) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dINLINE_ROUT_SIG e;
 INT h = ((INT) 0);
 INT L3;
 ERR1 L4;
 extern STR Foundaproblemexcessiveco;
 ERR1 L5;
 INT L6;
 ERR1 L7;
 extern STR possiblyduetoabadhashfun;
 ERR1 L8;
 dINLINE_ROUT_SIG L9;
 INT L10;
 ERR1 L12;
 extern STR name3;
 L3 = (INTPLUS(start1,50));
 if ((finish>L3)) {
  L4 = ERR_create_ERR(((ERR1) NULL));
  L5 = ERR_plus_dSTR_ERR(L4, ((dSTR) ((STR) &Foundaproblemexcessiveco)));
  L6 = (SYSTP(((OB) self)));
  L7 = ERR_plus_dSTR_ERR(L5, ((dSTR) (SYSSTRFORTP(L6))));
  L8 = ERR_plus_dSTR_ERR(L7, ((dSTR) ((STR) &possiblyduetoabadhashfun)));
  L9 = INLINE_ROUT_TBL_aget_INT(self, start1);
  L10 = (SYSTP(((OB) L9)));
  L12 = ERR_plus_dSTR_ERR(L8, ((dSTR) (SYSSTRFORTP(L10))));
  ERR_plus_dSTR(L12, ((dSTR) ((STR) &name3)));
  if (t==NULL) {
  } else
  switch (TAG(t)) {
   default: ;
  }
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL INLINE_ROUT_TBL_query_te(INLINE_ROUT_TBL self, SIG s, dINLINE_ROUT_SIG in) {
 BOOL ret_val = ((BOOL) 0);
 dINLINE_ROUT_SIG L1;
 SIG L2;
 if ((in==((dINLINE_ROUT_SIG) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 L1 = in;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE_ROUT_TBL::query_test(SIG,$INLINE_ROUT_SIG):BOOL");
 }
 L2 = (*dINLINE_ROUT_SIG_sig_SIG[TAG(L1)+dINLINE_ROUT_SIG_sig_SIG_offset])(L1);
 ret_val = SIG_is_eq_SIG_BOOL(L2, s);
 return ret_val;
}


BOOL INLINE_ROUT_TBL_should_g(INLINE_ROUT_TBL self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = INLINE_ROUT_TBL_load_rat;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL INLINE_ROUT_is_inlineabl(INLINE_ROUT self, AM_ROUT_DEF rout, INT threshold1) {
 BOOL ret_val = ((BOOL) 0);
 WEIGH_CODE sb;
 dAM_STMT badstmt;
 INT L1;
 BOOL L2;
 INT L3;
 INT L4;
 sb = WEIGH_CODE_create_INT_WE(((WEIGH_CODE) NULL), threshold1);
 WEIGH_CODE_calc_stmt_lis(sb, ATTR(rout,code11));
 L1 = ATTR(sb,weight);
 if ((L1>threshold1)) {
  SYSDESTROY(((OB) sb));
  ret_val = FALSE;
  return ret_val;
 }
 badstmt = ATTR(sb,badstmt);
 WEIGH_CODE_clear_badstmt(sb);
 L2 = (badstmt==((dAM_STMT) NULL));
 if ((!(L2))) {
  if (badstmt==NULL) {
   SYSDESTROY(((OB) sb));
   ret_val = FALSE;
   return ret_val;
  } else
  switch (TAG(badstmt)) {
   case AM_RETURN_STMT_tag:
    L3 = ATTR(sb,level1);
    if ((L3!=1)) {
     SYSDESTROY(((OB) sb));
     ret_val = FALSE;
     return ret_val;
    }
    WEIGH_CODE_calc_expr_wei(sb, ATTR(((AM_RETURN_STMT) badstmt),val11));
    L4 = ATTR(sb,weight);
    if ((L4>threshold1)) {
     SYSDESTROY(((OB) sb));
     ret_val = FALSE;
     return ret_val;
    } break;
   default: ;
    SYSDESTROY(((OB) sb));
    ret_val = FALSE;
    return ret_val;
  }
 }
 SYSDESTROY(((OB) sb));
 ret_val = TRUE;
 return ret_val;
}


BOOL INTI_is_eq_INTI_BOOL(INTI self, INTI y) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 INT L2;
 if ((self==y)) {
  L1 = TRUE;
 } else {
  L2 = INTI_cmp_INTI_INT(self, y);
  L1 = (L2==0);
 }
 ret_val = L1;
 return ret_val;
}


BOOL INTI_is_geq_INTI_BOOL(INTI self, INTI y) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = INTI_cmp_INTI_INT(self, y);
 ret_val = (L1>=0);
 return ret_val;
}


BOOL INTI_is_gt_INTI_BOOL(INTI self, INTI y) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = INTI_cmp_INTI_INT(self, y);
 ret_val = (L1>0);
 return ret_val;
}


BOOL INTI_is_lt_INTI_BOOL(INTI self, INTI y) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = INTI_cmp_INTI_INT(self, y);
 ret_val = (L1<0);
 return ret_val;
}


BOOL INTI_is_neg_BOOL(INTI self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = ATTR(self,len1);
 ret_val = (L1<0);
 return ret_val;
}


BOOL INTI_is_odd_BOOL(INTI self) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 INT L2;
 INT L3;
 L2 = ATTR(self,len1);
 if ((L2==0)) {
  L1 = TRUE;
 } else {
  L3 = INTI_aget_INT_INT(self, 0);
  L1 = ((L3&1)!=0);
 }
 ret_val = L1;
 return ret_val;
}


BOOL INTI_is_pos_BOOL(INTI self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = ATTR(self,len1);
 ret_val = (L1>0);
 return ret_val;
}


BOOL INTI_is_zero_BOOL(INTI self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 L1 = ATTR(self,len1);
 ret_val = (L1==0);
 return ret_val;
}


BOOL INT_is_nil_BOOL(INT self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 L1 = INT_asize;
 L2 = (INTMINUS(L1,1));
 L3 = (((unsigned)1<<(unsigned)L2));
 ret_val = (self==L3);
 return ret_val;
}


BOOL LAYOUT_ARRAY_elt_lt_dLAY(LAYOUT_ARRAY self, dLAYOUT x, dLAYOUT y) {
 BOOL ret_val = ((BOOL) 0);
 dLAYOUT L1;
 STR L2;
 dLAYOUT L3;
 L1 = x;
 if (L1==NULL) {
  FATAL("Dispatch on void in LAYOUT_ARRAY::elt_lt($LAYOUT,$LAYOUT):BOOL");
 }
 L2 = (*dLAYOUT_str_STR[TAG(L1)+dLAYOUT_str_STR_offset])(L1);
 L3 = y;
 if (L3==NULL) {
  FATAL("Dispatch on void in LAYOUT_ARRAY::elt_lt($LAYOUT,$LAYOUT):BOOL");
 }
 ret_val = STR_is_lt_STR_BOOL(L2, (*dLAYOUT_str_STR[TAG(L3)+dLAYOUT_str_STR_offset])(L3));
 return ret_val;
}


BOOL LAYOUT_ARRAY_is_sorted_B(LAYOUT_ARRAY self) {
 BOOL ret_val = ((BOOL) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 BOOL L3;
 INT L4;
 INT L5;
 INT L6;
 
 INT L7;
 dLAYOUT L8;
 L3 = (self==((LAYOUT_ARRAY) NULL));
 if ((!(L3))) {
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = 1;
     L7 = (ASIZE(self));
     L21 = (INTMINUS(L7,1));
     L5 = L11;
     L6 = L21;
     L4 = L5;
    } else {
     L4++;
    }
    if (L4>L6) goto after_loop;
    i = L4;
    L8 = LAYOUT_ARRAY_aget_INT_dL(self, i);
    if (LAYOUT_ARRAY_elt_lt_dLAY(self, L8, LAYOUT_ARRAY_aget_INT_dL(self, (INTMINUS(i,1))))) {
     ret_val = FALSE;
     return ret_val;
    }
   }
  }
  after_loop: ;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL LAYOUT_ARR_elt_lt_TUPIDE(LAYOUT_ARR self, TUPIDENTdTP e1, TUPIDENTdTP e2) {
 BOOL ret_val = ((BOOL) 0);
 dTP tp11;
 dTP tp2;
 INT a11 = ((INT) 0);
 INT a21 = ((INT) 0);
 dTP L1;
 dTP L2;
 STR L3;
 dTP L4;
 tp11 = e1.t2;
 tp2 = e2.t2;
 a11 = LAYOUT_ARR_alignment_dTP(self, tp11);
 a21 = LAYOUT_ARR_alignment_dTP(self, tp2);
 if ((a11!=a21)) {
  ret_val = (a11>a21);
  return ret_val;
 }
 else {
  L1 = tp11;
  if (L1==NULL) {
   FATAL("Dispatch on void in LAYOUT_ARR::elt_lt(TUP{IDENT,$TP},TUP{IDENT,$TP}):BOOL");
  }
  if ((*dTP_is_neq_dTP_BOOL[TAG(L1)+dTP_is_neq_dTP_BOOL_offset])(L1, tp2)) {
   L2 = tp11;
   if (L2==NULL) {
    FATAL("Dispatch on void in LAYOUT_ARR::elt_lt(TUP{IDENT,$TP},TUP{IDENT,$TP}):BOOL");
   }
   L3 = (*dTP_str_STR[TAG(L2)+dTP_str_STR_offset])(L2);
   L4 = tp2;
   if (L4==NULL) {
    FATAL("Dispatch on void in LAYOUT_ARR::elt_lt(TUP{IDENT,$TP},TUP{IDENT,$TP}):BOOL");
   }
   ret_val = STR_is_lt_STR_BOOL(L3, (*dTP_str_STR[TAG(L4)+dTP_str_STR_offset])(L4));
   return ret_val;
  }
  else {
   ret_val = STR_is_lt_STR_BOOL(e1.t1.str, e2.t1.str);
   return ret_val;
  }
 }
 FATAL("Last statement wasn't return");
}


BOOL LAYOUT_ARR_is_sorted_BOO(LAYOUT_ARR self) {
 BOOL ret_val = ((BOOL) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 BOOL L3;
 INT L4;
 INT L5;
 INT L6;
 
 INT L7;
 TUPIDENTdTP L8;
 L3 = (self==((LAYOUT_ARR) NULL));
 if ((!(L3))) {
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = 1;
     L7 = (ASIZE(self));
     L21 = (INTMINUS(L7,1));
     L5 = L11;
     L6 = L21;
     L4 = L5;
    } else {
     L4++;
    }
    if (L4>L6) goto after_loop;
    i = L4;
    L8 = LAYOUT_ARR_aget_INT_TUPI(self, i);
    if (LAYOUT_ARR_elt_lt_TUPIDE(self, L8, LAYOUT_ARR_aget_INT_TUPI(self, (INTMINUS(i,1))))) {
     ret_val = FALSE;
     return ret_val;
    }
   }
  }
  after_loop: ;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL NAMEMAP_is_key_nil_dOB_B(NAMEMAP self, OB e) {
 BOOL ret_val = ((BOOL) 0);
 if (e==NULL) {
  ret_val = (e==((OB) NULL));
  return ret_val;
 } else
 switch (TAG(e)) {
  default: ;
   ret_val = (e==((OB) NULL));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL NAMEMAP_key_eq_dOB_dOB_B(NAMEMAP self, OB k1, OB k2) {
 BOOL ret_val = ((BOOL) 0);
 if (k1==NULL) {
  ret_val = SYSOBEQ(k1,k2);
  return ret_val;
 } else
 switch (TAG(k1)) {
  case SIG_tag:
   if (k2==NULL) {
    ret_val = FALSE;
    return ret_val;
   } else
   switch (TAG(k2)) {
    case SIG_tag:
     ret_val = SIG_is_eq_SIG_BOOL(((SIG) k1), ((SIG) k2));
     return ret_val; break;
    default: ;
     ret_val = FALSE;
     return ret_val;
   } break;
  default: ;
   ret_val = SYSOBEQ(k1,k2);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL NAMEMAP_not_too_many_INT(NAMEMAP self, INT start1, INT finish) {
 BOOL ret_val = ((BOOL) 0);
 OB k = ((OB) NULL);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 OB e;
 INT h = ((INT) 0);
 INT L3;
 ERR1 L4;
 extern STR Foundaproblemexcessiveco1;
 ERR1 L5;
 extern STR duetoabadhashfunctionint;
 ERR1 L6;
 TUPdOBSTR L7;
 OB L8;
 INT L9;
 ERR1 L10;
 extern STR name3;
 OUT L12;
 extern STR Snowballingvalues;
 INT L13;
 INT L14;
 INT L15;
 
 OUT L16;
 dSTR L17;
 OUT L18;
 dSTR L19;
 OUT L20;
 OUT L22;
 dSTR L23;
 OUT L24;
 INT L25;
 INT L26;
 dSTR L27;
 OUT L28;
 dSTR L29;
 OUT L30;
 dSTR L31;
 OUT L32;
 dSTR L33;
 L3 = (INTPLUS(start1,50));
 if ((finish>L3)) {
  L4 = ERR_create_ERR(((ERR1) NULL));
  L5 = ERR_plus_dSTR_ERR(L4, ((dSTR) ((STR) &Foundaproblemexcessiveco1)));
  L6 = ERR_plus_dSTR_ERR(L5, ((dSTR) ((STR) &duetoabadhashfunctionint)));
  L7 = NAMEMAP_aget_INT_TUPdOBS(self, start1);
  L8 = (OB)((TUPdOBSTR_boxed) rt_alloc(sizeof(struct TUPdOBSTR_boxed_struct), TUPdOBSTR_tag));
  ((TUPdOBSTR_boxed) L8)->value_part = L7;
  L9 = (SYSTP(L8));
  L10 = ERR_plus_dSTR_ERR(L6, ((dSTR) (SYSSTRFORTP(L9))));
  ERR_plus_dSTR(L10, ((dSTR) ((STR) &name3)));
  if (k==NULL) {
  } else
  switch (TAG(k)) {
   case ABSTRACT_FRAME_LAYOUT_tag:
   case ABSTRACT_LAYOUT_tag:
   case ARG_LAYOUT_tag:
   case BOOL_tag:
   case BOUND_OBJECT_LAYOUT_tag:
   case BOUND_TYPE_LAYOUT_tag:
   case BUILTIN_LAYOUT_tag:
   case CHAR_tag:
   case CLASS_LAYOUT_tag:
   case EXTERNAL_LAYOUT_tag:
   case FLISTdAM_CONST_tag:
   case FLISTdAM_EXPR_tag:
   case FLISTdAM_STMT_tag:
   case FLISTdLAYOUT_tag:
   case FLISTdTP_tag:
   case FLISTAM_BND_CREATE_EXPR_tag:
   case FLISTAM_BND_ITER_CALL_EX_tag:
   case FLISTAM_GLOBAL_EXPR_tag:
   case FLISTAM_ITER_CALL_EXPR_tag:
   case FLISTAM_LOCAL_EXPR_tag:
   case FLISTAM_ROUT_DEF_tag:
   case FLISTAS_CLASS_DEF_tag:
   case FLISTCHAR_tag:
   case FLISTCODE_FILE_tag:
   case FLISTFLISTdAM_CONST_tag:
   case FLISTFSTR_tag:
   case FLISTIDENT_tag:
   case FLISTIFC_tag:
   case FLISTIMPL_INCLUDE_tag:
   case FLISTINT_tag:
   case FLISTSFILE_ID_tag:
   case FLISTSIG_tag:
   case FLISTSTR_tag:
   case FLT_tag:
   case FLTD_tag:
   case FLTDX_tag:
   case FLTI_tag:
   case FLTX_tag:
   case FRAME_LAYOUT_tag:
   case FSTR_tag:
   case INT_tag:
   case INTI_tag:
   case RAT_tag:
   case SFILE_ID_tag:
   case SIG_tag:
   case STR_tag:
   case TP_CLASS_tag:
   case TP_ITER_tag:
   case TP_LAYOUT_tag:
   case TP_ROUT_tag:
   case VALUE_CLASS_LAYOUT_tag:
    L12 = OUT_create_OUT(((OUT) NULL));
    OUT_plus_dSTR(L12, ((dSTR) ((STR) &Snowballingvalues)));
    {
     BOOL noname1 = TRUE;
     while (1) {
      if (noname1) {
       noname1 = FALSE;
       L11 = start1;
       L21 = (INTMINUS(finish,1));
       L14 = L11;
       L15 = L21;
       L13 = L14;
      } else {
       L13++;
      }
      if (L13>L15) goto after_loop;
      i = L13;
      e = NAMEMAP_aget_INT_TUPdOBS(self, i).t1;
      h = NAMEMAP_key_hash_dOB_INT(self, e);
      if (e==NULL) {
       FATAL("Void object of typecase");
      } else
      switch (TAG(e)) {
       case ABSTRACT_FRAME_LAYOUT_tag:
       case ABSTRACT_LAYOUT_tag:
       case ARG_LAYOUT_tag:
       case BOOL_tag:
       case BOUND_OBJECT_LAYOUT_tag:
       case BOUND_TYPE_LAYOUT_tag:
       case BUILTIN_LAYOUT_tag:
       case CHAR_tag:
       case CLASS_LAYOUT_tag:
       case EXTERNAL_LAYOUT_tag:
       case FLISTdAM_CONST_tag:
       case FLISTdAM_EXPR_tag:
       case FLISTdAM_STMT_tag:
       case FLISTdLAYOUT_tag:
       case FLISTdTP_tag:
       case FLISTAM_BND_CREATE_EXPR_tag:
       case FLISTAM_BND_ITER_CALL_EX_tag:
       case FLISTAM_GLOBAL_EXPR_tag:
       case FLISTAM_ITER_CALL_EXPR_tag:
       case FLISTAM_LOCAL_EXPR_tag:
       case FLISTAM_ROUT_DEF_tag:
       case FLISTAS_CLASS_DEF_tag:
       case FLISTCHAR_tag:
       case FLISTCODE_FILE_tag:
       case FLISTFLISTdAM_CONST_tag:
       case FLISTFSTR_tag:
       case FLISTIDENT_tag:
       case FLISTIFC_tag:
       case FLISTIMPL_INCLUDE_tag:
       case FLISTINT_tag:
       case FLISTSFILE_ID_tag:
       case FLISTSIG_tag:
       case FLISTSTR_tag:
       case FLT_tag:
       case FLTD_tag:
       case FLTDX_tag:
       case FLTI_tag:
       case FLTX_tag:
       case FRAME_LAYOUT_tag:
       case FSTR_tag:
       case INT_tag:
       case INTI_tag:
       case RAT_tag:
       case SFILE_ID_tag:
       case SIG_tag:
       case STR_tag:
       case TP_CLASS_tag:
       case TP_ITER_tag:
       case TP_LAYOUT_tag:
       case TP_ROUT_tag:
       case VALUE_CLASS_LAYOUT_tag:
        L16 = OUT_create_OUT(((OUT) NULL));
        L17 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
        ((INT_boxed) L17)->value_part = i;
        L18 = OUT_plus_dSTR_OUT(L16, L17);
        L19 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L19)->value_part = '\t';
        L20 = OUT_plus_dSTR_OUT(L18, L19);
        L22 = OUT_plus_dSTR_OUT(L20, ((dSTR) INT_hex_str_STR(h)));
        L23 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L23)->value_part = '\t';
        L24 = OUT_plus_dSTR_OUT(L22, L23);
        L25 = (ASIZE(self));
        L26 = (INTMINUS(L25,2));
        L27 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
        ((INT_boxed) L27)->value_part = (h&L26);
        L28 = OUT_plus_dSTR_OUT(L24, L27);
        L29 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L29)->value_part = '\t';
        L30 = OUT_plus_dSTR_OUT(L28, L29);
        L31 = ((dSTR) e);
        if (L31==NULL) {
         FATAL("Dispatch on void in NAMEMAP::not_too_many(INT,INT):BOOL");
        }
        L32 = OUT_plus_dSTR_OUT(L30, ((dSTR) STR_pretty_STR((*dSTR_str_STR[TAG(L31)+dSTR_str_STR_offset])(L31))));
        L33 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
        ((CHAR_boxed) L33)->value_part = '\n';
        OUT_plus_dSTR(L32, L33); break;
       default: ;
        FATAL("No applicable type in typecase");
      }
     }
    }
    after_loop: ; break;
   default: ;
  }
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL NAMEMAP_should_grow_BOOL(NAMEMAP self) {
 BOOL ret_val = ((BOOL) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,hsize);
 L2 = (INTPLUS(L1,1));
 L3 = NAMEMAP_load_ratio;
 L4 = (INTTIMES(L2,L3));
 L5 = (ASIZE(self));
 ret_val = (L4>L5);
 return ret_val;
}


BOOL NAMESPACE_is_taken_STR_B(NAMESPACE self, STR s) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = FSETSTR_test_STR_BOOL(ATTR(self,set), s);
 return ret_val;
}


CHAR INT_digit_char_CHAR(INT self) {
 CHAR ret_val = ((CHAR) 0);
 extern STR S0123456789ABCDEF;
 ret_val = (STRAGET(((STR) &S0123456789ABCDEF),self));
 return ret_val;
}


FLTD MS_RANDOM_GEN_get_FLTD(MS_RANDOM_GEN self) {
 FLTD ret_val = ((FLTD) 0);
 FLTD tmp1 = ((FLTD) 0);
 FLTD L1;
 INT L2;
 FLTD L3;
 FLTD L4;
 FLTD L5;
 FLTD L6;
 FLTD L7;
 FLTD L8;
 INT L9;
 INT L10;
 FLTD L11;
 FLTD L12;
 L1 = MS_RANDOM_GEN_ms_a;
 L2 = ATTR(self,seed);
 L3 = (INTFLTD(L2));
 tmp1 = (L1*L3);
 L4 = MS_RANDOM_GEN_ms_m;
 L5 = MS_RANDOM_GEN_ms_m;
 L6 = FLTD_floor_FLTD((FLTDDIV(tmp1,L5)));
 L7 = (L4*L6);
 L8 = (tmp1-L7);
 SATTR(self,seed,(FLTDINT(L8)));
 L9 = ATTR(self,seed);
 L10 = (INTMINUS(L9,1));
 L11 = (INTFLTD(L10));
 L12 = MS_RANDOM_GEN_ms_md;
 ret_val = (FLTDDIV(L11,L12));
 return ret_val;
}


FSTR INTI_str_in_FSTR_FSTR(INTI self, FSTR s) {
 FSTR ret_val;
 INTI x;
 FLISTINT d = ((FLISTINT) NULL);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 L1 = ATTR(self,len1);
 if ((L1==0)) {
  ret_val = FSTR_plus_CHAR_FSTR(s, '0');
  return ret_val;
 }
 else {
  L2 = ATTR(self,len1);
  if ((L2<0)) {
   s = FSTR_plus_CHAR_FSTR(s, '-');
  }
  L3 = ATTR(self,len1);
  L4 = (L3<0?-L3:L3);
  if ((L4==1)) {
   L5 = INTI_aget_INT_INT(self, 0);
   ret_val = INT_str_in_FSTR_FSTR(L5, s);
   return ret_val;
  }
  else {
   x = INTI_copy_INTI(self);
   while (1) {
    d = FLISTINT_push_INT_FLISTI(d, INTI_u_mod_INTI_INT_INT(self, x, INTI_D));
    L6 = ATTR(x,len1);
    if ((L6==0)) {
     goto after_loop;
    }
   }
   after_loop: ;
   L7 = FLISTINT_pop_INT(d);
   s = INT_str_in_FSTR_FSTR(L7, s);
   while (1) {
    L8 = FLISTINT_size_INT(d);
    if ((L8>0)) {
    }
    else {
     goto after_loop1;
    }
    L9 = FLISTINT_pop_INT(d);
    s = INT_str_in_FSTR_INT_INT_(L9, s, INTI_log10D, 10, '0');
   }
   after_loop1: ;
   ret_val = s;
   return ret_val;
  }
 }
 FATAL("Last statement wasn't return");
}


FSTR INTI_str_in_FSTR_INT_INT(INTI self, FSTR s, INT n, INT b, CHAR f) {
 FSTR ret_val;
 INTI x;
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 CHAR ch = ((CHAR) 0);
 INT L1;
 INT L2;
 INT L3;
 CHAR L4;
 x = INTI_copy_INTI(self);
 i = FSTR_length_INT(s);
 while (1) {
  s = FSTR_plus_CHAR_FSTR(s, INT_digit_char_CHAR(INTI_u_mod_INTI_INT_INT(self, x, b)));
  n = (INTMINUS(n,1));
  L1 = ATTR(x,len1);
  if ((L1==0)) {
   goto after_loop;
  }
 }
 after_loop: ;
 L2 = ATTR(self,len1);
 if ((L2<0)) {
  s = FSTR_plus_CHAR_FSTR(s, '-');
  n = (INTMINUS(n,1));
 }
 while (1) {
  if ((n>0)) {
  }
  else {
   goto after_loop1;
  }
  s = FSTR_plus_CHAR_FSTR(s, f);
  n = (INTMINUS(n,1));
 }
 after_loop1: ;
 L3 = FSTR_length_INT(s);
 j = (INTMINUS(L3,1));
 while (1) {
  if ((i<j)) {
  }
  else {
   goto after_loop2;
  }
  ch = (FSTRAGET(s,i));
  L4 = (FSTRAGET(s,j));
  FSTRASET(s,i,L4);
  FSTRASET(s,j,ch);
  i = (INTPLUS(i,1));
  j = (INTMINUS(j,1));
 }
 after_loop2: ;
 ret_val = s;
 return ret_val;
}


FSTR INT_str_in_FSTR_FSTR(INT self, FSTR s) {
 FSTR ret_val;
 ret_val = INT_str_in_FSTR_INT_INT_(self, s, 0, 10, ' ');
 return ret_val;
}


FSTR INT_str_in_FSTR_INT_INT_(INT self, FSTR s, INT n, INT b, CHAR f) {
 FSTR ret_val;
 INT x = ((INT) 0);
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 CHAR ch = ((CHAR) 0);
 INTI L1;
 INT L2;
 CHAR L3;
 if (INT_is_nil_BOOL(self)) {
  L1 = INTI_create_INT_INTI(((INTI) NULL), INT_nil_INT(self));
  ret_val = INTI_str_in_FSTR_INT_INT(L1, s, n, b, f);
  return ret_val;
 }
 else {
  x = (self<0?-self:self);
  i = FSTR_length_INT(s);
  while (1) {
   s = FSTR_plus_CHAR_FSTR(s, INT_digit_char_CHAR((INTMOD(x,b))));
   x = (INTDIV(x,b));
   n = (INTMINUS(n,1));
   if ((x==0)) {
    goto after_loop;
   }
  }
  after_loop: ;
  if ((self<0)) {
   s = FSTR_plus_CHAR_FSTR(s, '-');
   n = (INTMINUS(n,1));
  }
  while (1) {
   if ((n>0)) {
   }
   else {
    goto after_loop1;
   }
   s = FSTR_plus_CHAR_FSTR(s, f);
   n = (INTMINUS(n,1));
  }
  after_loop1: ;
  L2 = FSTR_length_INT(s);
  j = (INTMINUS(L2,1));
  while (1) {
   if ((i<j)) {
   }
   else {
    goto after_loop2;
   }
   ch = (FSTRAGET(s,i));
   L3 = (FSTRAGET(s,j));
   FSTRASET(s,i,L3);
   FSTRASET(s,j,ch);
   i = (INTPLUS(i,1));
   j = (INTMINUS(j,1));
  }
  after_loop2: ;
  ret_val = s;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INLINE_ITER_TBL INLINE_ITER_TBL_allocate(INLINE_ITER_TBL self, INT n) {
 INLINE_ITER_TBL ret_val;
 INLINE_ITER_TBL r;
 INLINE_ITER_TBL L11;
 INLINE_ITER_TBL L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((INLINE_ITER_TBL) rt_arr_alloc(sizeof(struct INLINE_ITER_TBL_struct), INLINE_ITER_TBL_tag, sizeof(dINLINE_ITER_SIG) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (INLINE_ITER_TBL_elt_nil_(self)==((dINLINE_ITER_SIG) NULL));
 if ((!(L4))) {
  {
   struct INLINE_ITER_TBL_asetb_dI_frame_struct other1_0;
   INLINE_ITER_TBL_asetb_dI_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = INLINE_ITER_TBL_elt_nil_(self);
    INLINE_ITER_TBL_asetb_dI(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


INLINE_ITER_TBL INLINE_ITER_TBL_create_I(INLINE_ITER_TBL self, INT n) {
 INLINE_ITER_TBL ret_val;
 INLINE_ITER_TBL r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 L1 = INLINE_ITER_TBL_load_rat;
 L2 = (INTTIMES(3,L1));
 L3 = (INTTIMES(L2,n));
 L4 = INT_highest_bit_INT((INTDIV(L3,4)));
 L5 = (INTPLUS(L4,1));
 L6 = (((unsigned)1<<(unsigned)L5));
 r = INLINE_ITER_TBL_allocate(self, (INTPLUS(L6,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ITER_TBL INLINE_ITER_TBL_double_s(INLINE_ITER_TBL self) {
 INLINE_ITER_TBL ret_val;
 INLINE_ITER_TBL r;
 INLINE_ITER_TBL L11;
 INT L2;
 INT L3;
 INT L4;
 dINLINE_ITER_SIG L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = INLINE_ITER_TBL_allocate(self, (INTPLUS(L4,1)));
 {
  struct INLINE_ITER_TBL_eltb_dIN_frame_struct other1_0;
  INLINE_ITER_TBL_eltb_dIN_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = INLINE_ITER_TBL_eltb_dIN(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = INLINE_ITER_TBL_insert_d(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


INLINE_ITER_TBL INLINE_ITER_TBL_insert_d(INLINE_ITER_TBL self, dINLINE_ITER_SIG e) {
 INLINE_ITER_TBL ret_val;
 INLINE_ITER_TBL r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 dINLINE_ITER_SIG te;
 dINLINE_ITER_SIG te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if (INLINE_ITER_TBL_is_elt_n(self, e)) {
  ret_val = r;
  return ret_val;
 }
 if ((r==((INLINE_ITER_TBL) NULL))) {
  r = INLINE_ITER_TBL_allocate(self, 5);
 }
 else {
  if (INLINE_ITER_TBL_should_g(self)) {
   r = INLINE_ITER_TBL_double_s(r);
  }
 }
 asz = (ASIZE(r));
 L1 = INLINE_ITER_TBL_elt_hash(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = INLINE_ITER_TBL_aget_INT(r, h);
  if (INLINE_ITER_TBL_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (INLINE_ITER_TBL_elt_eq_d(self, te, e)) {
    INLINE_ITER_TBL_aset_INT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = INLINE_ITER_TBL_aget_INT(r, h);
   if (INLINE_ITER_TBL_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (INLINE_ITER_TBL_elt_eq_d(self, te1, e)) {
     INLINE_ITER_TBL_aset_INT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 INLINE_ITER_TBL_aset_INT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ITER_TBL INLINE_ITER_TBL_test_and(INLINE_ITER_TBL self, AM_ROUT_DEF am, BOOL inline_short, INT threshold1) {
 INLINE_ITER_TBL ret_val;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 if (ATTR(am,is_abstract)) {
  L2 = TRUE;
 } else {
  L2 = ATTR(am,is_external);
 }
 if (L2) {
  L1 = TRUE;
 } else {
  L1 = (ATTR(am,code11)==((dAM_STMT) NULL));
 }
 if (L1) {
  ret_val = self;
  return ret_val;
 }
 if (inline_short) {
  L3 = INLINE_ITER_is_inlineabl(((INLINE_ITER) NULL), am, threshold1);
 } else {
  L3 = FALSE;
 }
 if (L3) {
  ret_val = INLINE_ITER_TBL_insert_d(self, ((dINLINE_ITER_SIG) INLINE_ITER_create_AM_RO(((INLINE_ITER) NULL), am)));
  return ret_val;
 }
 else {
  ret_val = self;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INLINE_ROUT INLINE_ROUT_create_AM_RO(INLINE_ROUT self, AM_ROUT_DEF rout) {
 INLINE_ROUT ret_val;
 INLINE_ROUT r;
 INLINE_ROUT L1;
 INT L2;
 L1 = ((INLINE_ROUT) rt_alloc(sizeof(struct INLINE_ROUT_struct), INLINE_ROUT_tag));
 r = L1;
 SATTR(r,signature,ATTR(rout,sig11));
 INLINE_ROUT_copy_rout_AM(r, rout);
 L2 = INLINE_ROUT_routines;
 INLINE_ROUT_routines_INT(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ROUT_TBL INLINE_ROUT_TBL_allocate(INLINE_ROUT_TBL self, INT n) {
 INLINE_ROUT_TBL ret_val;
 INLINE_ROUT_TBL r;
 INLINE_ROUT_TBL L11;
 INLINE_ROUT_TBL L2;
 INT L3;
 BOOL L4;
 L3 = n;
 L2 = ((INLINE_ROUT_TBL) rt_arr_alloc(sizeof(struct INLINE_ROUT_TBL_struct), INLINE_ROUT_TBL_tag, sizeof(dINLINE_ROUT_SIG) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (INLINE_ROUT_TBL_elt_nil_(self)==((dINLINE_ROUT_SIG) NULL));
 if ((!(L4))) {
  {
   struct INLINE_ROUT_TBL_asetb_dI_frame_struct other1_0;
   INLINE_ROUT_TBL_asetb_dI_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    noname1->arg1 = INLINE_ROUT_TBL_elt_nil_(self);
    INLINE_ROUT_TBL_asetb_dI(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


INLINE_ROUT_TBL INLINE_ROUT_TBL_create_I(INLINE_ROUT_TBL self, INT n) {
 INLINE_ROUT_TBL ret_val;
 INLINE_ROUT_TBL r;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 L1 = INLINE_ROUT_TBL_load_rat;
 L2 = (INTTIMES(3,L1));
 L3 = (INTTIMES(L2,n));
 L4 = INT_highest_bit_INT((INTDIV(L3,4)));
 L5 = (INTPLUS(L4,1));
 L6 = (((unsigned)1<<(unsigned)L5));
 r = INLINE_ROUT_TBL_allocate(self, (INTPLUS(L6,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ROUT_TBL INLINE_ROUT_TBL_double_s(INLINE_ROUT_TBL self) {
 INLINE_ROUT_TBL ret_val;
 INLINE_ROUT_TBL r;
 INLINE_ROUT_TBL L11;
 INT L2;
 INT L3;
 INT L4;
 dINLINE_ROUT_SIG L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 r = INLINE_ROUT_TBL_allocate(self, (INTPLUS(L4,1)));
 {
  struct INLINE_ROUT_TBL_eltb_dIN_frame_struct other1_0;
  INLINE_ROUT_TBL_eltb_dIN_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = INLINE_ROUT_TBL_eltb_dIN(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = INLINE_ROUT_TBL_insert_d(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


INLINE_ROUT_TBL INLINE_ROUT_TBL_insert_d(INLINE_ROUT_TBL self, dINLINE_ROUT_SIG e) {
 INLINE_ROUT_TBL ret_val;
 INLINE_ROUT_TBL r;
 INT asz = ((INT) 0);
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 dINLINE_ROUT_SIG te;
 dINLINE_ROUT_SIG te1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 r = self;
 if (INLINE_ROUT_TBL_is_elt_n(self, e)) {
  ret_val = r;
  return ret_val;
 }
 if ((r==((INLINE_ROUT_TBL) NULL))) {
  r = INLINE_ROUT_TBL_allocate(self, 5);
 }
 else {
  if (INLINE_ROUT_TBL_should_g(self)) {
   r = INLINE_ROUT_TBL_double_s(r);
  }
 }
 asz = (ASIZE(r));
 L1 = INLINE_ROUT_TBL_elt_hash(r, e);
 L2 = (INTMINUS(asz,2));
 orig_h = (L1&L2);
 h = orig_h;
 while (1) {
  te = INLINE_ROUT_TBL_aget_INT(r, h);
  if (INLINE_ROUT_TBL_is_elt_n(self, te)) {
   goto after_loop;
  }
  else {
   if (INLINE_ROUT_TBL_elt_eq_d(self, te, e)) {
    INLINE_ROUT_TBL_aset_INT(r, h, e);
    ret_val = r;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L3 = (INTMINUS(asz,1));
 if ((h==L3)) {
  h = 0;
  while (1) {
   te1 = INLINE_ROUT_TBL_aget_INT(r, h);
   if (INLINE_ROUT_TBL_is_elt_n(self, te1)) {
    goto after_loop1;
   }
   else {
    if (INLINE_ROUT_TBL_elt_eq_d(self, te1, e)) {
     INLINE_ROUT_TBL_aset_INT(r, h, e);
     ret_val = r;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 INLINE_ROUT_TBL_aset_INT(r, h, e);
 L4 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L4,1)));
 ret_val = r;
 return ret_val;
}


INLINE_ROUT_TBL INLINE_ROUT_TBL_test_and(INLINE_ROUT_TBL self, AM_ROUT_DEF am, BOOL inline_short, INT threshold1) {
 INLINE_ROUT_TBL ret_val;
 dAM_STMT stmts11;
 dAM_EXPR val1;
 dAM_EXPR dest1;
 dAM_EXPR src1;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 dAM_STMT L4;
 BOOL L5;
 BOOL L6;
 INT L7;
 BOOL L8;
 if (ATTR(am,is_abstract)) {
  L3 = TRUE;
 } else {
  L3 = ATTR(am,is_external);
 }
 if (L3) {
  L2 = TRUE;
 } else {
  L2 = (ATTR(am,code11)==((dAM_STMT) NULL));
 }
 if (L2) {
  L1 = TRUE;
 } else {
  L1 = TRANS_is_array_sig_SIG_B(((TRANS) NULL), ATTR(am,srcsig1));
 }
 if (L1) {
  ret_val = self;
  return ret_val;
 }
 L4 = ATTR(am,code11);
 if (L4==NULL) {
  FATAL("Dispatch on void in INLINE_ROUT_TBL::test_and_insert(AM_ROUT_DEF,BOOL,INT):INLINE_ROUT_TBL");
 }
 if (((*dAM_STMT_next_dAM_STMT[TAG(L4)+dAM_STMT_next_dAM_STMT_offset])(L4)==((dAM_STMT) NULL))) {
  stmts11 = ATTR(am,code11);
  if (stmts11==NULL) {
  } else
  switch (TAG(stmts11)) {
   case AM_RETURN_STMT_tag:
    val1 = ATTR(((AM_RETURN_STMT) stmts11),val11);
    if (val1==NULL) {
    } else
    switch (TAG(val1)) {
     case AM_ATTR_EXPR_tag:
      if (SYSOBEQ(((OB) ATTR(((AM_ATTR_EXPR) val1),ob1)),((OB) AM_ROUT_DEF_aget_INT_AM_(am, 0)))) {
       ret_val = INLINE_ROUT_TBL_insert_d(self, ((dINLINE_ROUT_SIG) INLINE_ATTR_READ_create_(((INLINE_ATTR_READ) NULL), am)));
       return ret_val;
      } break;
     case AM_VATTR_ASSIGN_EXPR_tag:
      if (SYSOBEQ(((OB) ATTR(((AM_VATTR_ASSIGN_EXPR) val1),ob1)),((OB) AM_ROUT_DEF_aget_INT_AM_(am, 0)))) {
       ret_val = INLINE_ROUT_TBL_insert_d(self, ((dINLINE_ROUT_SIG) INLINE_VATTR_WRITE_creat(((INLINE_VATTR_WRITE) NULL), am)));
       return ret_val;
      } break;
     case AM_GLOBAL_EXPR_tag:
      ret_val = INLINE_ROUT_TBL_insert_d(self, ((dINLINE_ROUT_SIG) INLINE_GLOBAL_READ_creat(((INLINE_GLOBAL_READ) NULL), am)));
      return ret_val; break;
     default: ;
    } break;
   case AM_ASSIGN_STMT_tag:
    dest1 = ATTR(((AM_ASSIGN_STMT) stmts11),dest);
    src1 = ATTR(((AM_ASSIGN_STMT) stmts11),src11);
    if (dest1==NULL) {
    } else
    switch (TAG(dest1)) {
     case AM_ATTR_EXPR_tag:
      L7 = (ASIZE(am));
      if ((L7>1)) {
       L6 = SYSOBEQ(((OB) ATTR(((AM_ATTR_EXPR) dest1),ob1)),((OB) AM_ROUT_DEF_aget_INT_AM_(am, 0)));
      } else {
       L6 = FALSE;
      }
      if (L6) {
       L5 = SYSOBEQ(((OB) src1),((OB) AM_ROUT_DEF_aget_INT_AM_(am, 1)));
      } else {
       L5 = FALSE;
      }
      if (L5) {
       ret_val = INLINE_ROUT_TBL_insert_d(self, ((dINLINE_ROUT_SIG) INLINE_ATTR_WRITE_create(((INLINE_ATTR_WRITE) NULL), am)));
       return ret_val;
      } break;
     default: ;
    } break;
   default: ;
  }
 }
 if (inline_short) {
  L8 = INLINE_ROUT_is_inlineabl(((INLINE_ROUT) NULL), am, threshold1);
 } else {
  L8 = FALSE;
 }
 if (L8) {
  ret_val = INLINE_ROUT_TBL_insert_d(self, ((dINLINE_ROUT_SIG) INLINE_ROUT_create_AM_RO(((INLINE_ROUT) NULL), am)));
  return ret_val;
 }
 ret_val = self;
 return ret_val;
}


INLINE_VATTR_WRITE INLINE_VATTR_WRITE_creat(INLINE_VATTR_WRITE self, AM_ROUT_DEF am) {
 INLINE_VATTR_WRITE ret_val;
 INLINE_VATTR_WRITE r;
 dAM_STMT stmt;
 dAM_EXPR val1;
 INLINE_VATTR_WRITE L1;
 INT L2;
 L1 = ((INLINE_VATTR_WRITE) rt_alloc(sizeof(struct INLINE_VATTR_WRITE_struct), INLINE_VATTR_WRITE_tag));
 r = L1;
 SATTR(r,sig11,ATTR(am,sig11));
 stmt = ATTR(am,code11);
 if (stmt==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(stmt)) {
  case AM_RETURN_STMT_tag:
   val1 = ATTR(((AM_RETURN_STMT) stmt),val11);
   if (val1==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(val1)) {
    case AM_VATTR_ASSIGN_EXPR_tag:
     SATTR(r,at11,ATTR(((AM_VATTR_ASSIGN_EXPR) val1),at11)); break;
    default: ;
     FATAL("No applicable type in typecase");
   } break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 L2 = INLINE_VATTR_WRITE_routi1;
 INLINE_VATTR_WRITE_routi(self, (INTPLUS(L2,1)));
 ret_val = r;
 return ret_val;
}


INT INLINE_ITER_TBL_asize_IN(INLINE_ITER_TBL self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT INLINE_ITER_TBL_elt_hash(INLINE_ITER_TBL self, dINLINE_ITER_SIG in) {
 INT ret_val = ((INT) 0);
 dINLINE_ITER_SIG L1;
 L1 = in;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE_ITER_TBL::elt_hash($INLINE_ITER_SIG):INT");
 }
 ret_val = INLINE_ITER_TBL_query_ha(self, (*dINLINE_ITER_SIG_sig_SIG[TAG(L1)+dINLINE_ITER_SIG_sig_SIG_offset])(L1));
 return ret_val;
}


INT INLINE_ITER_TBL_query_ha(INLINE_ITER_TBL self, SIG s) {
 INT ret_val = ((INT) 0);
 INT sc = ((INT) 0);
 INT r = ((INT) 0);
 ARRAYdTP L11;
 dTP L2;
 INT L3;
 INT L4;
 dTP L5;
 dTP L6;
 INT L7;
 INT L8;
 sc = 3;
 r = IDENT_hash_INT(ATTR(s,name1));
 L2 = ATTR(s,tp);
 L3 = (SYSID(((OB) L2)));
 L4 = (INTTIMES(L3,sc));
 r = (r^L4);
 {
  struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
  ARRAYdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   sc = (((unsigned)sc)+((unsigned)98));
   if (noname1->state == 0) {
    L11 = ATTR(s,args1);
    noname1->self = L11;
   }
   L5 = ARRAYdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   L6 = L5;
   L7 = (SYSID(((OB) L6)));
   L8 = (((unsigned)L7)*((unsigned)sc));
   r = (r^L8);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


INT INLINE_ROUT_TBL_asize_IN(INLINE_ROUT_TBL self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT INLINE_ROUT_TBL_elt_hash(INLINE_ROUT_TBL self, dINLINE_ROUT_SIG in) {
 INT ret_val = ((INT) 0);
 dINLINE_ROUT_SIG L1;
 L1 = in;
 if (L1==NULL) {
  FATAL("Dispatch on void in INLINE_ROUT_TBL::elt_hash($INLINE_ROUT_SIG):INT");
 }
 ret_val = INLINE_ROUT_TBL_query_ha(self, (*dINLINE_ROUT_SIG_sig_SIG[TAG(L1)+dINLINE_ROUT_SIG_sig_SIG_offset])(L1));
 return ret_val;
}


INT INLINE_ROUT_TBL_query_ha(INLINE_ROUT_TBL self, SIG s) {
 INT ret_val = ((INT) 0);
 INT sc = ((INT) 0);
 INT r = ((INT) 0);
 ARRAYdTP L11;
 dTP L2;
 INT L3;
 INT L4;
 dTP L5;
 dTP L6;
 INT L7;
 INT L8;
 sc = 3;
 r = IDENT_hash_INT(ATTR(s,name1));
 L2 = ATTR(s,tp);
 L3 = (SYSID(((OB) L2)));
 L4 = (INTTIMES(L3,sc));
 r = (r^L4);
 {
  struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
  ARRAYdTP_eltb_dTP_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   sc = (((unsigned)sc)+((unsigned)98));
   if (noname1->state == 0) {
    L11 = ATTR(s,args1);
    noname1->self = L11;
   }
   L5 = ARRAYdTP_eltb_dTP(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   L6 = L5;
   L7 = (SYSID(((OB) L6)));
   L8 = (((unsigned)L7)*((unsigned)sc));
   r = (r^L8);
  }
 }
 after_loop: ;
 ret_val = r;
 return ret_val;
}


INT INTI_aget_INT_INT(INTI self, INT ind) {
 INT ret_val = ((INT) 0);
 return ARR(self,ind);
}


INT INTI_cmp_INTI_INT(INTI self, INTI y) {
 INT ret_val = ((INT) 0);
 INT L1;
 BOOL L2;
 INT L3;
 BOOL L4;
 INT L5;
 L1 = ATTR(self,len1);
 L2 = (L1<0);
 L3 = ATTR(y,len1);
 L4 = (L3<0);
 if (((L2)!=(L4))) {
  ret_val = ATTR(self,len1);
  return ret_val;
 }
 else {
  L5 = ATTR(self,len1);
  if ((L5<0)) {
   ret_val = INTI_u_cmp_INTI_INTI_INT(self, y, self);
   return ret_val;
  }
  else {
   ret_val = INTI_u_cmp_INTI_INTI_INT(self, self, y);
   return ret_val;
  }
 }
 FATAL("Last statement wasn't return");
}


INT INTI_int_INT(INTI self) {
 INT ret_val = ((INT) 0);
 INT i = ((INT) 0);
 INT z = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(self,len1);
 i = (L1<0?-L1:L1);
 z = 0;
 while (1) {
  if ((i>0)) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
  L2 = INTI_B;
  L3 = (INTTIMES(z,L2));
  L4 = INTI_aget_INT_INT(self, i);
  z = (INTPLUS(L3,L4));
 }
 after_loop: ;
 L5 = ATTR(self,len1);
 if ((L5<0)) {
  z = (INTMINUS(0,z));
 }
 ret_val = z;
 return ret_val;
}


INT INTI_log2_INT(INTI self) {
 INT ret_val = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 L1 = ATTR(self,len1);
 L2 = (INTMINUS(L1,1));
 L3 = INTI_log2B;
 L4 = (INTTIMES(L2,L3));
 L5 = ATTR(self,len1);
 L6 = INT_highest_bit_INT(INTI_aget_INT_INT(self, (INTMINUS(L5,1))));
 ret_val = (INTPLUS(L4,L6));
 return ret_val;
}


INT INTI_u_cmp_INTI_INTI_INT(INTI self, INTI x, INTI y) {
 INT ret_val = ((INT) 0);
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 INT z = ((INT) 0);
 INT L1;
 INT L2;
 BOOL L3;
 BOOL L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 L1 = ATTR(x,len1);
 i = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 j = (L2<0?-L2:L2);
 if ((i==j)) {
  L3 = (i!=0);
 } else {
  L3 = FALSE;
 }
 if (L3) {
  i = (INTMINUS(i,1));
  while (1) {
   if ((i!=0)) {
    L5 = INTI_aget_INT_INT(x, i);
    L6 = INTI_aget_INT_INT(y, i);
    L4 = (L5==L6);
   } else {
    L4 = FALSE;
   }
   if (L4) {
   }
   else {
    goto after_loop;
   }
   i = (INTMINUS(i,1));
  }
  after_loop: ;
  L7 = INTI_aget_INT_INT(x, i);
  L8 = INTI_aget_INT_INT(y, i);
  z = (INTMINUS(L7,L8));
 }
 else {
  z = (INTMINUS(i,j));
 }
 ret_val = z;
 return ret_val;
}


INT INTI_u_mod_INTI_INT_INT(INTI self, INTI x, INT d) {
 INT ret_val = ((INT) 0);
 INT xl = ((INT) 0);
 INT i = ((INT) 0);
 INT c = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 i = xl;
 c = 0;
 while (1) {
  if ((i>0)) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
  L2 = INTI_B;
  L3 = (INTTIMES(c,L2));
  L4 = INTI_aget_INT_INT(x, i);
  c = (INTPLUS(L3,L4));
  INTI_aset_INT_INT(x, i, (INTDIV(c,d)));
  c = (INTMOD(c,d));
 }
 after_loop: ;
 L5 = INTI_aget_INT_INT(x, (INTMINUS(xl,1)));
 if ((L5==0)) {
  SATTR(x,len1,(INTMINUS(xl,1)));
 }
 ret_val = c;
 return ret_val;
}


INT INT_create_STR_INT(INT self, STR s) {
 INT ret_val = ((INT) 0);
 STR L1;
 L1 = s;
 ret_val = atoi(((L1==NULL)?NULL:L1->arr_part));
 return ret_val;
}


INT INT_downtob_INT_INT(INT_downtob_INT_INT_frame frame) {
 INT dummy = ((INT) 0);
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->r = frame->self;
 while (1) {
  if ((frame->r<frame->arg1)) {
   goto after_loop;
  }
  frame->state = 1;
  return frame->r;
  state1:;
  frame->r = (INTMINUS(frame->r,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


INT INT_forb_INT_INT(INT_forb_INT_INT_frame frame) {
 INT dummy = ((INT) 0);
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->r = frame->self;
 frame->e = (INTPLUS(frame->self,frame->arg1));
 while (1) {
  if ((frame->r>=frame->e)) {
   goto after_loop;
  }
  frame->state = 1;
  return frame->r;
  state1:;
  frame->r = (INTPLUS(frame->r,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


INT INT_hash_INT(INT self) {
 INT ret_val = ((INT) 0);
 INT r = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 r = self;
 L1 = (((unsigned)r<<(unsigned)17));
 r = (r^L1);
 L2 = (((unsigned)r)>>((unsigned)15));
 r = (r^L2);
 L3 = (((unsigned)r<<(unsigned)17));
 r = (r^L3);
 L4 = (((unsigned)r)>>((unsigned)15));
 r = (r^L4);
 L5 = (((unsigned)r<<(unsigned)17));
 r = (r^L5);
 L6 = (((unsigned)r)>>((unsigned)15));
 r = (r^L6);
 ret_val = r;
 return ret_val;
}


INT INT_highest_bit_INT(INT self) {
 INT ret_val = ((INT) 0);
 INT x = ((INT) 0);
 INT z = ((INT) 0);
 INT r = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 
 INT L7;
 INT L8;
 INT L9;
 if ((self==0)) {
  ret_val = -1;
  return ret_val;
 }
 L3 = INT_asize;
 if ((L3==32)) {
  x = self;
  z = (((unsigned)x)>>((unsigned)16));
  if ((z!=0)) {
   x = z;
   r = (INTPLUS(r,16));
  }
  z = (((unsigned)x)>>((unsigned)8));
  if ((z!=0)) {
   x = z;
   r = (INTPLUS(r,8));
  }
  z = (((unsigned)x)>>((unsigned)4));
  if ((z!=0)) {
   x = z;
   r = (INTPLUS(r,4));
  }
  z = (((unsigned)x)>>((unsigned)2));
  if ((z!=0)) {
   x = z;
   r = (INTPLUS(r,2));
  }
  z = (((unsigned)x)>>((unsigned)1));
  if ((z!=0)) {
   x = z;
   r = (INTPLUS(r,1));
  }
  ret_val = r;
  return ret_val;
 }
 else {
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = 1;
     L7 = INT_asize;
     L21 = (INTMINUS(L7,1));
     L5 = L11;
     L6 = L21;
     L4 = L5;
    } else {
     L4++;
    }
    if (L4>L6) goto after_loop;
    i = L4;
    L8 = (INTRSHIFT(self,i));
    if ((L8==0)) {
     ret_val = (INTMINUS(i,1));
     return ret_val;
    }
   }
  }
  after_loop: ;
  L9 = INT_asize;
  ret_val = (INTMINUS(L9,1));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT INT_nil_INT(INT self) {
 INT ret_val = ((INT) 0);
 INT L1;
 INT L2;
 L1 = INT_asize;
 L2 = (INTMINUS(L1,1));
 ret_val = (((unsigned)1<<(unsigned)L2));
 return ret_val;
}


INT INT_pow_INT_INT(INT self, INT i) {
 INT ret_val = ((INT) 0);
 INT r = ((INT) 0);
 INT L11 = ((INT) 0);
 INT x = ((INT) 0);
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 L11 = i;
 switch (L11) {
  case 0:
   ret_val = 1;
   return ret_val;
   break;
  case 1:
   ret_val = self;
   return ret_val;
   break;
  case 2:
   ret_val = (INTTIMES(self,self));
   return ret_val;
   break;
  case 3:
   L2 = (INTTIMES(self,self));
   ret_val = (INTTIMES(L2,self));
   return ret_val;
   break;
  case 4:
   r = (INTTIMES(self,self));
   ret_val = (INTTIMES(r,r));
   return ret_val;
   break;
  case 5:
   r = (INTTIMES(self,self));
   L3 = (INTTIMES(self,r));
   ret_val = (INTTIMES(L3,r));
   return ret_val;
   break;
  case 6:
   r = (INTTIMES(self,self));
   L4 = (INTTIMES(r,r));
   ret_val = (INTTIMES(L4,r));
   return ret_val;
   break;
  case 7:
   r = (INTTIMES(self,self));
   L5 = (INTTIMES(self,r));
   L6 = (INTTIMES(L5,r));
   ret_val = (INTTIMES(L6,r));
   return ret_val;
   break;
  case 8:
   r = (INTTIMES(self,self));
   r = (INTTIMES(r,r));
   ret_val = (INTTIMES(r,r));
   return ret_val;
   break;
  case 9:
   r = (INTTIMES(self,self));
   r = (INTTIMES(r,r));
   L7 = (INTTIMES(self,r));
   ret_val = (INTTIMES(L7,r));
   return ret_val;
   break;
  case 10:
   r = (INTTIMES(self,self));
   L8 = (INTTIMES(self,r));
   r = (INTTIMES(L8,r));
   ret_val = (INTTIMES(r,r));
   return ret_val;
   break;
  default: ;
   x = self;
   r = 1;
   while (1) {
    if (((i&1)!=0)) {
     r = (INTTIMES(r,x));
    }
    i = (INTRSHIFT(i,1));
    if ((i>0)) {
    }
    else {
     goto after_loop;
    }
    x = (INTTIMES(x,x));
   }
   after_loop: ;
   ret_val = r;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INT INT_upb_INT(INT_upb_INT_frame frame) {
 INT dummy = ((INT) 0);
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->r = frame->self;
 while (1) {
  frame->state = 1;
  return frame->r;
  state1:;
  frame->r = (INTPLUS(frame->r,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


INT INT_uptob_INT_INT(INT_uptob_INT_INT_frame frame) {
 INT dummy = ((INT) 0);
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->r = frame->self;
 while (1) {
  if ((frame->r>frame->arg1)) {
   goto after_loop;
  }
  frame->state = 1;
  return frame->r;
  state1:;
  frame->r = (INTPLUS(frame->r,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


INT LAYOUT_ARRAY_asize_INT(LAYOUT_ARRAY self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT LAYOUT_ARR_alignment_dTP(LAYOUT_ARR self, dTP t) {
 INT ret_val = ((INT) 0);
 dTP L11;
 dTP L2;
 dTP L3;
 dTP L4;
 L11 = t;
 L2 = L11;
 if (L2==NULL) {
  FATAL("Dispatch on void in LAYOUT_ARR::alignment($TP):INT");
 }
 if ((*dTP_is_eq_dTP_BOOL[TAG(L2)+dTP_is_eq_dTP_BOOL_offset])(L2, ((dTP) TP_BUILTIN_fltd))) {
  ret_val = 64;
  return ret_val;
 }
 else {
  L3 = L11;
  if (L3==NULL) {
   FATAL("Dispatch on void in LAYOUT_ARR::alignment($TP):INT");
  }
  if ((*dTP_is_eq_dTP_BOOL[TAG(L3)+dTP_is_eq_dTP_BOOL_offset])(L3, ((dTP) TP_BUILTIN_char))) {
   ret_val = 8;
   return ret_val;
  }
  else {
   L4 = L11;
   if (L4==NULL) {
    FATAL("Dispatch on void in LAYOUT_ARR::alignment($TP):INT");
   }
   if ((*dTP_is_eq_dTP_BOOL[TAG(L4)+dTP_is_eq_dTP_BOOL_offset])(L4, ((dTP) TP_BUILTIN_bool))) {
    ret_val = 1;
    return ret_val;
   }
   else {
    ret_val = 32;
    return ret_val;
   }
  }
 }
 FATAL("Last statement wasn't return");
}


INT LAYOUT_ARR_asize_INT(LAYOUT_ARR self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT NAMEMAP_asize_INT(NAMEMAP self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}


INT NAMEMAP_key_hash_dOB_INT(NAMEMAP self, OB k) {
 INT ret_val = ((INT) 0);
 dHASH L1;
 if (k==NULL) {
  ret_val = INT_hash_INT((SYSID(k)));
  return ret_val;
 } else
 switch (TAG(k)) {
  case CHAR_tag:
  case FLT_tag:
  case FLTD_tag:
  case FSTR_tag:
  case IDENT_tag:
  case INT_tag:
  case STR_tag:
  case TUPdAM_CONSTdAM_CONST_tag:
  case TUPdAM_EXPRdAM_EXPR_tag:
  case TUPdAM_EXPRdTP_tag:
  case TUPdAM_STMTdAM_STMT_tag:
  case TUPdLAYOUTdLAYOUT_tag:
  case TUPdOBNAMESPACE_tag:
  case TUPdOBSTR_tag:
  case TUPdTPdLAYOUT_tag:
  case TUPdTPdTP_tag:
  case TUPdTPCODE_FILE_tag:
  case TUPdTPFMAPIDENTAM_GLOBAL_tag:
  case TUPdTPIFC_tag:
  case TUPdTPIMPL_tag:
  case TUPdTPINT_tag:
  case TUPAM_BND_CREATE_EXPRAM__tag:
  case TUPAM_BND_CREATE_EXPRBOU_tag:
  case TUPAM_BND_ITER_CALL_EXPR_tag:
  case TUPAM_GLOBAL_EXPRAM_GLOB_tag:
  case TUPAM_ITER_CALL_EXPRAM_I_tag:
  case TUPAM_LOCAL_EXPRAM_LOCAL_tag:
  case TUPAM_ROUT_DEFAM_ROUT_DE_tag:
  case TUPAM_ROUT_DEFFLISTAM_IT_tag:
  case TUPAM_ROUT_DEFFRAME_LAYO_tag:
  case TUPARRAYdTPdTP_tag:
  case TUPARRAYdTPARRAYBOOLdTP_tag:
  case TUPAS_CLASS_DEFAS_CLASS__tag:
  case TUPBOOLINTIINTBOOL_tag:
  case TUPCHARCHAR_tag:
  case TUPCODE_FILECODE_FILE_tag:
  case TUPFLISTdAM_CONSTFLISTdA_tag:
  case TUPFLTFLT_tag:
  case TUPFLTDFLTD_tag:
  case TUPFSTRFSTR_tag:
  case TUPIDENTdTP_tag:
  case TUPIDENTAM_GLOBAL_EXPR_tag:
  case TUPIDENTARRAYdTP_tag:
  case TUPIDENTIDENT_tag:
  case TUPIDENTINT_tag:
  case TUPIFCIFC_tag:
  case TUPIMPL_INCLUDEIMPL_INCL_tag:
  case TUPINTINTINT_tag:
  case TUPINTINT_tag:
  case TUPINTIINTIINTI_tag:
  case TUPSFILE_IDSFILE_ID_tag:
  case TUPSIGABSTRACT_FRAME_LAY_tag:
  case TUPSIGAM_ROUT_DEF_tag:
  case TUPSIGARG_LAYOUT_tag:
  case TUPSIGSIG_tag:
  case TUPSIGSTR_tag:
  case TUPSTRFSETSTR_tag:
  case TUPSTRINT_tag:
  case TUPSTRITER_INLINE_tag:
  case TUPSTRSIG_tag:
  case TUPSTRSTR_tag:
  case TUPTP_CLASSFSETdTP_tag:
  case TUPTP_CLASSFSETTP_CLASS_tag:
   L1 = ((dHASH) k);
   if (L1==NULL) {
    FATAL("Dispatch on void in NAMEMAP::key_hash($OB):INT");
   }
   ret_val = (*dHASH_hash_INT[TAG(L1)+dHASH_hash_INT_offset])(L1);
   return ret_val; break;
  default: ;
   ret_val = INT_hash_INT((SYSID(k)));
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INTI INTI_abs_INTI(INTI self) {
 INTI ret_val;
 INTI z;
 INT L1;
 INT L2;
 L1 = ATTR(self,len1);
 if ((L1<0)) {
  z = INTI_copy_INTI(self);
  L2 = ATTR(self,len1);
  SATTR(z,len1,(INTMINUS(0,L2)));
  ret_val = z;
  return ret_val;
 }
 else {
  ret_val = self;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INTI INTI_copy_INTI(INTI self) {
 INTI ret_val;
 INT i = ((INT) 0);
 INTI z;
 INT L1;
 INTI L2;
 INT L3;
 L1 = ATTR(self,len1);
 i = (L1<0?-L1:L1);
 L3 = (INTPLUS(i,1));
 L2 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L3));
 L2->asize = L3;
 z = L2;
 SATTR(z,len1,ATTR(self,len1));
 while (1) {
  if ((i>0)) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
  INTI_aset_INT_INT(z, i, INTI_aget_INT_INT(self, i));
 }
 after_loop: ;
 ret_val = z;
 return ret_val;
}


INTI INTI_create_INT_INTI(INTI self, INT x) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 INT a = ((INT) 0);
 INT i = ((INT) 0);
 INTI L1;
 INT L2;
 INTI L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 if (INT_is_nil_BOOL(x)) {
  L1 = INTI_create_INT_INTI(((INTI) NULL), 2);
  L2 = INT_asize;
  z = INTI_negate_INTI(INTI_pow_INT_INTI(L1, (INTMINUS(L2,1))));
 }
 else {
  a = (x<0?-x:x);
  i = 0;
  L5 = INT_highest_bit_INT(a);
  L6 = INTI_log2B;
  L7 = (INTDIV(L5,L6));
  L4 = (INTPLUS(L7,1));
  L3 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L4));
  L3->asize = L4;
  z = L3;
  while (1) {
   if ((a!=0)) {
   }
   else {
    goto after_loop;
   }
   L8 = INTI_B;
   INTI_aset_INT_INT(z, i, (INTMOD(a,L8)));
   L9 = INTI_B;
   a = (INTDIV(a,L9));
   i = (INTPLUS(i,1));
  }
  after_loop: ;
  if ((x<0)) {
   SATTR(z,len1,(INTMINUS(0,i)));
  }
  else {
   SATTR(z,len1,i);
  }
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_div_INTI_INTI(INTI self, INTI y) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 INTI qr;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 BOOL L5;
 INT L6;
 INT L7;
 INT L8;
 BOOL L9;
 INT L10;
 BOOL L11;
 INT L12;
 L1 = ATTR(self,len1);
 L2 = (L1<0?-L1:L1);
 L3 = ATTR(y,len1);
 L4 = (L3<0?-L3:L3);
 if ((L2<L4)) {
  z = INTI_create_INT_INTI(((INTI) NULL), 0);
 }
 else {
  qr = INTI_u_div_mod_INTI_INTI(self, self, y);
  z = INTI_get_u_div_INTI_INTI(self, self, y, qr);
  L6 = ATTR(self,len1);
  if ((L6<0)) {
   L7 = ATTR(INTI_get_u_mod_INTI_INTI(self, self, y, qr),len1);
   L5 = (L7!=0);
  } else {
   L5 = FALSE;
  }
  if (L5) {
   z = INTI_u_times_plus_INTI_I(self, z, 1, 1);
  }
  L8 = ATTR(self,len1);
  L9 = (L8<0);
  L10 = ATTR(y,len1);
  L11 = (L10<0);
  if (((L9)!=(L11))) {
   L12 = ATTR(z,len1);
   SATTR(z,len1,(INTMINUS(0,L12)));
  }
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_gcd_INTI_INTI(INTI self, INTI i) {
 INTI ret_val;
 INTI c;
 INTI d;
 INTI r;
 INT L1;
 c = INTI_abs_INTI(self);
 d = INTI_abs_INTI(i);
 while (1) {
  L1 = ATTR(d,len1);
  if ((L1==0)) {
   goto after_loop;
  }
  r = INTI_mod_INTI_INTI(c, d);
  c = d;
  d = r;
 }
 after_loop: ;
 ret_val = c;
 return ret_val;
}


INTI INTI_get_u_div_INTI_INTI(INTI self, INTI x, INTI y, INTI q) {
 INTI ret_val;
 INT i = ((INT) 0);
 INT yl = ((INT) 0);
 INTI z;
 INT L1;
 INT L2;
 BOOL L3;
 INT L4;
 INTI L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 L1 = ATTR(x,len1);
 i = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 yl = (L2<0?-L2:L2);
 while (1) {
  if ((i>=yl)) {
   L4 = INTI_aget_INT_INT(q, i);
   L3 = (L4==0);
  } else {
   L3 = FALSE;
  }
  if (L3) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
 }
 after_loop: ;
 L7 = (INTMINUS(i,yl));
 L6 = (INTPLUS(L7,1));
 L5 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L6));
 L5->asize = L6;
 z = L5;
 L8 = (INTMINUS(i,yl));
 SATTR(z,len1,(INTPLUS(L8,1)));
 while (1) {
  if ((i>=yl)) {
  }
  else {
   goto after_loop1;
  }
  L9 = (INTMINUS(i,yl));
  INTI_aset_INT_INT(z, L9, INTI_aget_INT_INT(q, i));
  i = (INTMINUS(i,1));
 }
 after_loop1: ;
 ret_val = z;
 return ret_val;
}


INTI INTI_get_u_mod_INTI_INTI(INTI self, INTI x, INTI y, INTI q) {
 INTI ret_val;
 INT i = ((INT) 0);
 INTI z;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 BOOL L6;
 INT L7;
 INTI L8;
 INT L9;
 L1 = ATTR(x,len1);
 L2 = (L1<0?-L1:L1);
 L3 = ATTR(y,len1);
 L4 = (L3<0?-L3:L3);
 L5 = ((L2<L4)?L2:L4);
 i = (INTMINUS(L5,1));
 while (1) {
  if ((i>=0)) {
   L7 = INTI_aget_INT_INT(q, i);
   L6 = (L7==0);
  } else {
   L6 = FALSE;
  }
  if (L6) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
 }
 after_loop: ;
 L9 = (INTPLUS(i,1));
 L8 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L9));
 L8->asize = L9;
 z = L8;
 SATTR(z,len1,(INTPLUS(i,1)));
 while (1) {
  if ((i>=0)) {
  }
  else {
   goto after_loop1;
  }
  INTI_aset_INT_INT(z, i, INTI_aget_INT_INT(q, i));
  i = (INTMINUS(i,1));
 }
 after_loop1: ;
 ret_val = z;
 return ret_val;
}


INTI INTI_minus_INTI_INTI(INTI self, INTI y) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 INT L1;
 BOOL L2;
 INT L3;
 BOOL L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 L1 = ATTR(self,len1);
 L2 = (L1<0);
 L3 = ATTR(y,len1);
 L4 = (L3<0);
 if (((L2)!=(L4))) {
  z = INTI_u_plus_INTI_INTI_IN(self, self, y);
 }
 else {
  L5 = INTI_u_cmp_INTI_INTI_INT(self, self, y);
  if ((L5<0)) {
   z = INTI_u_minus_INTI_INTI_I(self, y, self);
   L6 = ATTR(z,len1);
   SATTR(z,len1,(INTMINUS(0,L6)));
  }
  else {
   z = INTI_u_minus_INTI_INTI_I(self, self, y);
  }
 }
 L7 = ATTR(self,len1);
 if ((L7<0)) {
  L8 = ATTR(z,len1);
  SATTR(z,len1,(INTMINUS(0,L8)));
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_mod_INTI_INTI(INTI self, INTI y) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 BOOL L5;
 INT L6;
 INT L7;
 L1 = ATTR(self,len1);
 L2 = (L1<0?-L1:L1);
 L3 = ATTR(y,len1);
 L4 = (L3<0?-L3:L3);
 if ((L2<L4)) {
  z = self;
 }
 else {
  z = INTI_get_u_mod_INTI_INTI(self, self, y, INTI_u_div_mod_INTI_INTI(self, self, y));
  L6 = ATTR(self,len1);
  if ((L6<0)) {
   L7 = ATTR(z,len1);
   L5 = (L7!=0);
  } else {
   L5 = FALSE;
  }
  if (L5) {
   z = INTI_u_minus_INTI_INTI_I(self, y, z);
  }
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_negate_INTI(INTI self) {
 INTI ret_val;
 INTI z;
 INT L1;
 INT L2;
 L1 = ATTR(self,len1);
 if ((L1!=0)) {
  z = INTI_copy_INTI(self);
  L2 = ATTR(self,len1);
  SATTR(z,len1,(INTMINUS(0,L2)));
  ret_val = z;
  return ret_val;
 }
 else {
  ret_val = self;
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


INTI INTI_plus_INTI_INTI(INTI self, INTI y) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 INT L1;
 BOOL L2;
 INT L3;
 BOOL L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 L1 = ATTR(self,len1);
 L2 = (L1<0);
 L3 = ATTR(y,len1);
 L4 = (L3<0);
 if (((L2)==(L4))) {
  z = INTI_u_plus_INTI_INTI_IN(self, self, y);
 }
 else {
  L5 = INTI_u_cmp_INTI_INTI_INT(self, self, y);
  if ((L5<0)) {
   z = INTI_u_minus_INTI_INTI_I(self, y, self);
   L6 = ATTR(z,len1);
   SATTR(z,len1,(INTMINUS(0,L6)));
  }
  else {
   z = INTI_u_minus_INTI_INTI_I(self, self, y);
  }
 }
 L7 = ATTR(self,len1);
 if ((L7<0)) {
  L8 = ATTR(z,len1);
  SATTR(z,len1,(INTMINUS(0,L8)));
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_pow_INT_INTI(INTI self, INT i) {
 INTI ret_val;
 INTI x;
 INTI z;
 x = self;
 z = INTI_create_INT_INTI(((INTI) NULL), 1);
 while (1) {
  if ((i>0)) {
  }
  else {
   goto after_loop;
  }
  if (((i&1)!=0)) {
   z = INTI_times_INTI_INTI(z, x);
  }
  x = INTI_square_INTI(x);
  i = (INTDIV(i,2));
 }
 after_loop: ;
 ret_val = z;
 return ret_val;
}


INTI INTI_square_INTI(INTI self) {
 INTI ret_val;
 ret_val = INTI_times_INTI_INTI(self, self);
 return ret_val;
}


INTI INTI_times_INTI_INTI(INTI self, INTI y) {
 INTI ret_val;
 INTI z = ((INTI) NULL);
 BOOL L1;
 INT L2;
 INT L3;
 BOOL L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L11;
 INT L12;
 INT L13;
 INT L14;
 INT L15;
 BOOL L16;
 INT L17;
 BOOL L18;
 INT L19;
 L2 = ATTR(self,len1);
 if ((L2==0)) {
  L1 = TRUE;
 } else {
  L3 = ATTR(y,len1);
  L1 = (L3==0);
 }
 if (L1) {
  z = INTI_create_INT_INTI(((INTI) NULL), 0);
 }
 else {
  L5 = ATTR(self,len1);
  L6 = (L5<0?-L5:L5);
  if ((L6==1)) {
   L7 = ATTR(y,len1);
   L8 = (L7<0?-L7:L7);
   L4 = (L8==1);
  } else {
   L4 = FALSE;
  }
  if (L4) {
   L9 = INTI_aget_INT_INT(self, 0);
   L10 = INTI_aget_INT_INT(y, 0);
   z = INTI_create_INT_INTI(((INTI) NULL), (INTTIMES(L9,L10)));
  }
  else {
   L11 = ATTR(self,len1);
   L12 = (L11<0?-L11:L11);
   L13 = ATTR(y,len1);
   L14 = (L13<0?-L13:L13);
   if ((L12<L14)) {
    z = INTI_u_times_INTI_INTI_I(self, self, y);
   }
   else {
    z = INTI_u_times_INTI_INTI_I(self, y, self);
   }
  }
 }
 L15 = ATTR(self,len1);
 L16 = (L15<0);
 L17 = ATTR(y,len1);
 L18 = (L17<0);
 if (((L16)!=(L18))) {
  L19 = ATTR(z,len1);
  SATTR(z,len1,(INTMINUS(0,L19)));
 }
 ret_val = z;
 return ret_val;
}


INTI INTI_u_div_mod_INTI_INTI(INTI self, INTI x, INTI y) {
 INTI ret_val;
 INT xl = ((INT) 0);
 INT yl = ((INT) 0);
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 INT k = ((INT) 0);
 INT c = ((INT) 0);
 INT d = ((INT) 0);
 INT q = ((INT) 0);
 INT y11 = ((INT) 0);
 INT y2 = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L11;
 INT L12;
 INT L13;
 INT L14;
 INT L15;
 INT L16;
 INT L17;
 INT L18;
 INT L19;
 INT L20;
 INT L21;
 INT L22;
 INT L23;
 INT L24;
 INT L25;
 INT L26;
 INT L27;
 INT L28;
 INT L29;
 INT L30;
 INT L31;
 INT L32;
 INT L33;
 INT L34;
 INT L35;
 INT L36;
 INT L37;
 INT L38;
 INT L39;
 INT L40;
 INT L41;
 INT L42;
 INT L43;
 INT L44;
 INT L45;
 INT L46;
 INT L47;
 INT L48;
 INT L49;
 INT L50;
 INT L51;
 INT L52;
 INT L53;
 INT L54;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 yl = (L2<0?-L2:L2);
 x = INTI_copy_INTI(x);
 if ((yl==1)) {
  i = (INTMINUS(xl,1));
  c = 0;
  d = INTI_aget_INT_INT(y, 0);
  while (1) {
   if ((i>=0)) {
   }
   else {
    goto after_loop;
   }
   L3 = INTI_B;
   L4 = (INTTIMES(c,L3));
   L5 = INTI_aget_INT_INT(x, i);
   c = (INTPLUS(L4,L5));
   L6 = (INTPLUS(i,1));
   INTI_aset_INT_INT(x, L6, (INTDIV(c,d)));
   c = (INTMOD(c,d));
   i = (INTMINUS(i,1));
  }
  after_loop: ;
  INTI_aset_INT_INT(x, 0, c);
 }
 else {
  if ((xl>=yl)) {
   INTI_aset_INT_INT(x, xl, 0);
   L7 = INTI_B;
   L8 = (INTDIV(L7,2));
   L9 = (INTMINUS(L8,1));
   L10 = INTI_aget_INT_INT(y, (INTMINUS(yl,1)));
   L11 = (INTDIV(L9,L10));
   d = (INTPLUS(L11,1));
   if ((d!=1)) {
    y = INTI_copy_INTI(y);
    i = 0;
    c = 0;
    while (1) {
     if ((i<xl)) {
     }
     else {
      goto after_loop1;
     }
     L12 = INTI_aget_INT_INT(x, i);
     L13 = (INTTIMES(d,L12));
     c = (INTPLUS(c,L13));
     L14 = INTI_B;
     INTI_aset_INT_INT(x, i, (INTMOD(c,L14)));
     L15 = INTI_B;
     c = (INTDIV(c,L15));
     i = (INTPLUS(i,1));
    }
    after_loop1: ;
    INTI_aset_INT_INT(x, i, c);
    i = 0;
    c = 0;
    while (1) {
     if ((i<yl)) {
     }
     else {
      goto after_loop2;
     }
     L16 = INTI_aget_INT_INT(y, i);
     L17 = (INTTIMES(d,L16));
     c = (INTPLUS(c,L17));
     L18 = INTI_B;
     INTI_aset_INT_INT(y, i, (INTMOD(c,L18)));
     L19 = INTI_B;
     c = (INTDIV(c,L19));
     i = (INTPLUS(i,1));
    }
    after_loop2: ;
   }
   y11 = INTI_aget_INT_INT(y, (INTMINUS(yl,1)));
   y2 = INTI_aget_INT_INT(y, (INTMINUS(yl,2)));
   i = xl;
   while (1) {
    if ((i>=yl)) {
    }
    else {
     goto after_loop3;
    }
    L20 = INTI_aget_INT_INT(x, i);
    if ((L20!=y11)) {
     L21 = INTI_aget_INT_INT(x, i);
     L22 = INTI_B;
     L23 = (INTTIMES(L21,L22));
     L24 = INTI_aget_INT_INT(x, (INTMINUS(i,1)));
     L25 = (INTPLUS(L23,L24));
     q = (INTDIV(L25,y11));
    }
    else {
     L26 = INTI_B;
     q = (INTMINUS(L26,1));
    }
    while (1) {
     L27 = (INTTIMES(y2,q));
     L28 = INTI_aget_INT_INT(x, i);
     L29 = INTI_B;
     L30 = (INTTIMES(L28,L29));
     L31 = INTI_aget_INT_INT(x, (INTMINUS(i,1)));
     L32 = (INTPLUS(L30,L31));
     L33 = (INTTIMES(y11,q));
     L34 = (INTMINUS(L32,L33));
     L35 = INTI_B;
     L36 = (INTTIMES(L34,L35));
     L37 = INTI_aget_INT_INT(x, (INTMINUS(i,2)));
     L38 = (INTPLUS(L36,L37));
     if ((L27>L38)) {
     }
     else {
      goto after_loop4;
     }
     q = (INTMINUS(q,1));
    }
    after_loop4: ;
    j = (INTMINUS(i,yl));
    k = 0;
    c = 0;
    while (1) {
     if ((k<yl)) {
     }
     else {
      goto after_loop5;
     }
     L39 = INTI_aget_INT_INT(x, j);
     L40 = (INTPLUS(c,L39));
     L41 = INTI_aget_INT_INT(y, k);
     L42 = (INTTIMES(q,L41));
     c = (INTMINUS(L40,L42));
     L43 = INTI_B;
     INTI_aset_INT_INT(x, j, (INTMOD(c,L43)));
     L44 = INTI_B;
     c = (INTDIV(c,L44));
     j = (INTPLUS(j,1));
     k = (INTPLUS(k,1));
    }
    after_loop5: ;
    L45 = INTI_aget_INT_INT(x, i);
    L46 = (INTPLUS(c,L45));
    if ((L46!=0)) {
     j = (INTMINUS(i,yl));
     k = 0;
     c = 0;
     while (1) {
      if ((k<yl)) {
      }
      else {
       goto after_loop6;
      }
      L47 = INTI_aget_INT_INT(x, j);
      L48 = (INTPLUS(c,L47));
      L49 = INTI_aget_INT_INT(y, k);
      c = (INTPLUS(L48,L49));
      L50 = INTI_B;
      INTI_aset_INT_INT(x, j, (INTMOD(c,L50)));
      L51 = INTI_B;
      c = (INTDIV(c,L51));
      j = (INTPLUS(j,1));
      k = (INTPLUS(k,1));
     }
     after_loop6: ;
     INTI_aset_INT_INT(x, i, (INTMINUS(q,1)));
    }
    else {
     INTI_aset_INT_INT(x, i, q);
    }
    i = (INTMINUS(i,1));
   }
   after_loop3: ;
   if ((d!=1)) {
    i = yl;
    c = 0;
    while (1) {
     if ((i>0)) {
     }
     else {
      goto after_loop7;
     }
     i = (INTMINUS(i,1));
     L52 = INTI_B;
     L53 = (INTTIMES(c,L52));
     L54 = INTI_aget_INT_INT(x, i);
     c = (INTPLUS(L53,L54));
     INTI_aset_INT_INT(x, i, (INTDIV(c,d)));
     c = (INTMOD(c,d));
    }
    after_loop7: ;
   }
  }
 }
 ret_val = x;
 return ret_val;
}


INTI INTI_u_minus_INTI_INTI_I(INTI self, INTI x, INTI y) {
 INTI ret_val;
 INT xl = ((INT) 0);
 INT yl = ((INT) 0);
 INT i = ((INT) 0);
 INT c = ((INT) 0);
 INTI z = ((INTI) NULL);
 INT L1;
 INT L2;
 INTI L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L11;
 INT L12;
 BOOL L13;
 INT L14;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 yl = (L2<0?-L2:L2);
 i = 0;
 c = 0;
 L4 = xl;
 L3 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L4));
 L3->asize = L4;
 z = L3;
 while (1) {
  if ((i<yl)) {
  }
  else {
   goto after_loop;
  }
  L5 = INTI_aget_INT_INT(x, i);
  L6 = (INTPLUS(c,L5));
  L7 = INTI_aget_INT_INT(y, i);
  c = (INTMINUS(L6,L7));
  L8 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L8)));
  L9 = INTI_B;
  c = (INTDIV(c,L9));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 while (1) {
  if ((i<xl)) {
  }
  else {
   goto after_loop1;
  }
  L10 = INTI_aget_INT_INT(x, i);
  c = (INTPLUS(c,L10));
  L11 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L11)));
  L12 = INTI_B;
  c = (INTDIV(c,L12));
  i = (INTPLUS(i,1));
 }
 after_loop1: ;
 while (1) {
  if ((i>0)) {
   L14 = INTI_aget_INT_INT(z, (INTMINUS(i,1)));
   L13 = (L14==0);
  } else {
   L13 = FALSE;
  }
  if (L13) {
  }
  else {
   goto after_loop2;
  }
  i = (INTMINUS(i,1));
 }
 after_loop2: ;
 SATTR(z,len1,i);
 ret_val = z;
 return ret_val;
}


INTI INTI_u_plus_INTI_INTI_IN(INTI self, INTI x, INTI y) {
 INTI ret_val;
 INT xl = ((INT) 0);
 INT yl = ((INT) 0);
 INT l = ((INT) 0);
 INT i = ((INT) 0);
 INT c = ((INT) 0);
 INTI z = ((INTI) NULL);
 INT L1;
 INT L2;
 INTI L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 INT L11;
 INT L12;
 INT L13;
 INT L14;
 INT L15;
 INT L16;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 yl = (L2<0?-L2:L2);
 l = ((xl<yl)?xl:yl);
 i = 0;
 c = 0;
 L5 = ((xl>yl)?xl:yl);
 L4 = (INTPLUS(L5,1));
 L3 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L4));
 L3->asize = L4;
 z = L3;
 while (1) {
  if ((i<l)) {
  }
  else {
   goto after_loop;
  }
  L6 = INTI_aget_INT_INT(x, i);
  L7 = (INTPLUS(c,L6));
  L8 = INTI_aget_INT_INT(y, i);
  c = (INTPLUS(L7,L8));
  L9 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L9)));
  L10 = INTI_B;
  c = (INTDIV(c,L10));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 while (1) {
  if ((i<xl)) {
  }
  else {
   goto after_loop1;
  }
  L11 = INTI_aget_INT_INT(x, i);
  c = (INTPLUS(c,L11));
  L12 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L12)));
  L13 = INTI_B;
  c = (INTDIV(c,L13));
  i = (INTPLUS(i,1));
 }
 after_loop1: ;
 while (1) {
  if ((i<yl)) {
  }
  else {
   goto after_loop2;
  }
  L14 = INTI_aget_INT_INT(y, i);
  c = (INTPLUS(c,L14));
  L15 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L15)));
  L16 = INTI_B;
  c = (INTDIV(c,L16));
  i = (INTPLUS(i,1));
 }
 after_loop2: ;
 if ((c!=0)) {
  INTI_aset_INT_INT(z, i, c);
  i = (INTPLUS(i,1));
 }
 SATTR(z,len1,i);
 ret_val = z;
 return ret_val;
}


INTI INTI_u_times_INTI_INTI_I(INTI self, INTI x, INTI y) {
 INTI ret_val;
 INT xl = ((INT) 0);
 INT yl = ((INT) 0);
 INT i = ((INT) 0);
 INT j = ((INT) 0);
 INT k = ((INT) 0);
 INT d = ((INT) 0);
 INT c = ((INT) 0);
 INTI z;
 INT L1;
 INT L2;
 INTI L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 INT L8;
 INT L9;
 INT L10;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 L2 = ATTR(y,len1);
 yl = (L2<0?-L2:L2);
 i = (INTPLUS(xl,yl));
 L4 = i;
 L3 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L4));
 L3->asize = L4;
 z = L3;
 while (1) {
  if ((i>0)) {
  }
  else {
   goto after_loop;
  }
  i = (INTMINUS(i,1));
  INTI_aset_INT_INT(z, i, 0);
 }
 after_loop: ;
 while (1) {
  if ((i<xl)) {
  }
  else {
   goto after_loop1;
  }
  d = INTI_aget_INT_INT(x, i);
  if ((d!=0)) {
   j = 0;
   k = i;
   c = 0;
   while (1) {
    if ((j<yl)) {
    }
    else {
     goto after_loop2;
    }
    L5 = INTI_aget_INT_INT(z, k);
    L6 = (INTPLUS(c,L5));
    L7 = INTI_aget_INT_INT(y, j);
    L8 = (INTTIMES(d,L7));
    c = (INTPLUS(L6,L8));
    L9 = INTI_B;
    INTI_aset_INT_INT(z, k, (INTMOD(c,L9)));
    L10 = INTI_B;
    c = (INTDIV(c,L10));
    j = (INTPLUS(j,1));
    k = (INTPLUS(k,1));
   }
   after_loop2: ;
   if ((c!=0)) {
    INTI_aset_INT_INT(z, k, c);
    k = (INTPLUS(k,1));
   }
  }
  i = (INTPLUS(i,1));
 }
 after_loop1: ;
 SATTR(z,len1,k);
 ret_val = z;
 return ret_val;
}


INTI INTI_u_times_plus_INTI_I(INTI self, INTI x, INT y, INT c) {
 INTI ret_val;
 INT xl = ((INT) 0);
 INT i = ((INT) 0);
 INTI z;
 INT L1;
 INTI L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 L1 = ATTR(x,len1);
 xl = (L1<0?-L1:L1);
 i = 0;
 L3 = (INTPLUS(xl,1));
 L2 = ((INTI) rt_arr_alloc_atomic(sizeof(struct INTI_struct), INTI_tag, sizeof(INT) , L3));
 L2->asize = L3;
 z = L2;
 while (1) {
  if ((i<xl)) {
  }
  else {
   goto after_loop;
  }
  L4 = INTI_aget_INT_INT(x, i);
  L5 = (INTTIMES(L4,y));
  c = (INTPLUS(c,L5));
  L6 = INTI_B;
  INTI_aset_INT_INT(z, i, (INTMOD(c,L6)));
  L7 = INTI_B;
  c = (INTDIV(c,L7));
  i = (INTPLUS(i,1));
 }
 after_loop: ;
 if ((c!=0)) {
  INTI_aset_INT_INT(z, i, c);
  i = (INTPLUS(i,1));
 }
 SATTR(z,len1,i);
 ret_val = z;
 return ret_val;
}


MANGLE MANGLE_create_PROG_MANGL(MANGLE self, PROG p) {
 MANGLE ret_val;
 MANGLE res;
 SYSTEM_LEX l;
 SYSTEM_LEX L11;
 MANGLE L2;
 extern STR SystemFORBID;
 STR L3;
 extern STR self1;
 L2 = ((MANGLE) rt_alloc(sizeof(struct MANGLE_struct), MANGLE_tag));
 res = L2;
 SATTR(res,prog1,p);
 SATTR(res,namespaces,FMAPdOBNAMESPACE_create_(((FMAPdOBNAMESPACE) NULL)));
 SATTR(res,forbidden,FSETSTR_create_FSETSTR(((FSETSTR) NULL)));
 SATTR(res,used_by_local,FSETSTR_create_FSETSTR(((FSETSTR) NULL)));
 SATTR(res,global_space,MANGLE_space_dOB_NAMESPA(res, ((OB) ATTR(p,back_end))));
 l = SYSTEM_LEX_create_STR_SY(((SYSTEM_LEX) NULL), STR_plus_dSTR_STR(ATTR(p,home), ((dSTR) ((STR) &SystemFORBID))));
 {
  struct SYSTEM_LEX_eltb_STR_frame_struct other1_0;
  SYSTEM_LEX_eltb_STR_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = l;
    noname1->self = L11;
   }
   L3 = SYSTEM_LEX_eltb_STR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   MANGLE_forbid_STR(res, L3);
  }
 }
 after_loop: ;
 MANGLE_forbid_STR(res, ((STR) &self1));
 ret_val = res;
 return ret_val;
}


MS_RANDOM_GEN MS_RANDOM_GEN_create_MS_(MS_RANDOM_GEN self) {
 MS_RANDOM_GEN ret_val;
 MS_RANDOM_GEN res;
 MS_RANDOM_GEN L1;
 L1 = ((MS_RANDOM_GEN) rt_alloc_atomic(sizeof(struct MS_RANDOM_GEN_struct), MS_RANDOM_GEN_tag));
 res = L1;
 MS_RANDOM_GEN_init_INT(res, 1);
 ret_val = res;
 return ret_val;
}


NAMEMAP NAMEMAP_allocate_INT_NAM(NAMEMAP self, INT n) {
 NAMEMAP ret_val;
 NAMEMAP r;
 NAMEMAP L11;
 NAMEMAP L2;
 INT L3;
 BOOL L4;
 OB L5;
 L3 = n;
 L2 = ((NAMEMAP) rt_arr_alloc(sizeof(struct NAMEMAP_struct), NAMEMAP_tag, sizeof(TUPdOBSTR) , L3));
 L2->asize = L3;
 r = L2;
 L4 = (NAMEMAP_key_nil_dOB(self)==((OB) NULL));
 if ((!(L4))) {
  {
   struct NAMEMAP_asetb_TUPdOBSTR_frame_struct other1_0;
   NAMEMAP_asetb_TUPdOBSTR_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = r;
     noname1->self = L11;
    }
    L5 = NAMEMAP_key_nil_dOB(self);
    noname1->arg1 = TUPdOBSTR_create_dOB_STR(TUPdOBSTR_zero, L5, ((STR) NULL));
    NAMEMAP_asetb_TUPdOBSTR(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
   }
  }
  after_loop: ;
 }
 ret_val = r;
 return ret_val;
}


NAMEMAP NAMEMAP_double_size_NAME(NAMEMAP self) {
 NAMEMAP ret_val;
 INT ns = ((INT) 0);
 NAMEMAP r;
 NAMEMAP L11;
 INT L2;
 INT L3;
 INT L4;
 TUPdOBSTR L5;
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,1));
 L4 = (INTTIMES(L3,2));
 ns = (INTPLUS(L4,1));
 r = NAMEMAP_allocate_INT_NAM(self, ns);
 {
  struct NAMEMAP_pairsb_TUPdOBSTR_frame_struct other1_0;
  NAMEMAP_pairsb_TUPdOBSTR_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = NAMEMAP_pairsb_TUPdOBSTR(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   r = NAMEMAP_insert_pair_TUPd(r, L5);
  }
 }
 after_loop: ;
 SYSDESTROY(((OB) self));
 ret_val = r;
 return ret_val;
}


NAMEMAP NAMEMAP_insert_dOB_STR_N(NAMEMAP self, OB k, STR t) {
 NAMEMAP ret_val;
 NAMEMAP r;
 INT orig_h = ((INT) 0);
 INT h = ((INT) 0);
 INT asm1 = ((INT) 0);
 OB tk;
 OB tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 r = self;
 if ((r==((NAMEMAP) NULL))) {
  r = NAMEMAP_allocate_INT_NAM(self, 5);
 }
 else {
  if (NAMEMAP_should_grow_BOOL(self)) {
   r = NAMEMAP_double_size_NAME(self);
  }
 }
 L1 = NAMEMAP_key_hash_dOB_INT(r, k);
 L2 = (ASIZE(r));
 L3 = (INTMINUS(L2,2));
 orig_h = (L1&L3);
 h = orig_h;
 L4 = (ASIZE(r));
 asm1 = (INTMINUS(L4,1));
 while (1) {
  tk = NAMEMAP_aget_INT_TUPdOBS(r, h).t1;
  if (NAMEMAP_is_key_nil_dOB_B(self, tk)) {
   goto after_loop;
  }
  if (NAMEMAP_key_eq_dOB_dOB_B(self, tk, k)) {
   NAMEMAP_aset_INT_TUPdOBS(r, h, TUPdOBSTR_create_dOB_STR(TUPdOBSTR_zero, k, t));
   ret_val = r;
   return ret_val;
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 if ((h==asm1)) {
  h = 0;
  while (1) {
   tk1 = NAMEMAP_aget_INT_TUPdOBS(r, h).t1;
   if (NAMEMAP_is_key_nil_dOB_B(self, tk1)) {
    goto after_loop1;
   }
   if (NAMEMAP_key_eq_dOB_dOB_B(self, tk1, k)) {
    NAMEMAP_aset_INT_TUPdOBS(r, h, TUPdOBSTR_create_dOB_STR(TUPdOBSTR_zero, k, t));
    ret_val = r;
    return ret_val;
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 NAMEMAP_aset_INT_TUPdOBS(r, h, TUPdOBSTR_create_dOB_STR(TUPdOBSTR_zero, k, t));
 L5 = ATTR(r,hsize);
 SATTR(r,hsize,(INTPLUS(L5,1)));
 ret_val = r;
 return ret_val;
}


NAMEMAP NAMEMAP_insert_pair_TUPd(NAMEMAP self, TUPdOBSTR p) {
 NAMEMAP ret_val;
 ret_val = NAMEMAP_insert_dOB_STR_N(self, p.t1, p.t2);
 return ret_val;
}


OB NAMEMAP_key_nil_dOB(NAMEMAP self) {
 OB ret_val;
 OB k = ((OB) NULL);
 if (k==NULL) {
  ret_val = ((OB) NULL);
  return ret_val;
 } else
 switch (TAG(k)) {
  default: ;
   ret_val = ((OB) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


OUT OUT_plus_dSTR_OUT(OUT self, dSTR s) {
 OUT ret_val;
 FILE1 L1;
 L1 = FILE_stdout_FILE(((FILE1) NULL));
 FILE_plus_dSTR(L1, s);
 ret_val = self;
 return ret_val;
}


SIG INLINE_VATTR_WRITE_sig_S(INLINE_VATTR_WRITE self) {
 return ATTR(self,sig11);
}


STR INTI_str_STR(INTI self) {
 STR ret_val;
 FSTR_clear(INTI_buf);
 INTI_buf_FSTR(self, INTI_str_in_FSTR_FSTR(self, INTI_buf));
 ret_val = FSTR_str_STR(INTI_buf);
 return ret_val;
}


STR INT_hex_str_STR(INT self) {
 STR ret_val;
 INT i = ((INT) 0);
 FSTR L1;
 extern STR x0;
 FSTR_clear(INT_buf);
 i = self;
 while (1) {
  L1 = INT_buf;
  INT_buf_FSTR(self, FSTR_plus_CHAR_FSTR(L1, INT_digit_char_CHAR((i&15))));
  i = (((unsigned)i)>>((unsigned)4));
  if ((i==0)) {
   goto after_loop;
  }
 }
 after_loop: ;
 INT_buf_FSTR(self, FSTR_plus_STR_FSTR(INT_buf, ((STR) &x0)));
 FSTR_to_reverse(INT_buf);
 ret_val = FSTR_str_STR(INT_buf);
 return ret_val;
}


STR INT_octal_str_STR(INT self) {
 STR ret_val;
 INT i = ((INT) 0);
 FSTR L1;
 extern STR o0;
 FSTR_clear(INT_buf);
 i = self;
 while (1) {
  L1 = INT_buf;
  INT_buf_FSTR(self, FSTR_plus_CHAR_FSTR(L1, INT_digit_char_CHAR((i&7))));
  i = (((unsigned)i)>>((unsigned)3));
  if ((i==0)) {
   goto after_loop;
  }
 }
 after_loop: ;
 INT_buf_FSTR(self, FSTR_plus_STR_FSTR(INT_buf, ((STR) &o0)));
 FSTR_to_reverse(INT_buf);
 ret_val = FSTR_str_STR(INT_buf);
 return ret_val;
}


STR INT_str_STR(INT self) {
 STR ret_val;
 FSTR_clear(INT_buf);
 INT_buf_FSTR(self, INT_str_in_FSTR_FSTR(self, INT_buf));
 ret_val = FSTR_str_STR(INT_buf);
 return ret_val;
}


STR MANGLE_Cify_CHAR_STR(MANGLE self, CHAR c) {
 STR ret_val;
 STR res;
 CHAR L11 = ((CHAR) 0);
 STR oc;
 extern STR name1;
 dSTR L2;
 dSTR L3;
 dSTR L4;
 dSTR L5;
 dSTR L6;
 dSTR L7;
 dSTR L8;
 dSTR L9;
 dSTR L10;
 dSTR L12;
 dSTR L13;
 dSTR L14;
 dSTR L15;
 dSTR L16;
 dSTR L17;
 dSTR L18;
 dSTR L19;
 dSTR L20;
 dSTR L21;
 dSTR L22;
 dSTR L23;
 dSTR L24;
 dSTR L25;
 dSTR L26;
 dSTR L27;
 dSTR L28;
 dSTR L29;
 dSTR L30;
 dSTR L31;
 dSTR L32;
 dSTR L33;
 dSTR L34;
 dSTR L35;
 dSTR L36;
 dSTR L37;
 dSTR L38;
 dSTR L39;
 dSTR L40;
 dSTR L41;
 dSTR L42;
 dSTR L43;
 dSTR L44;
 dSTR L45;
 dSTR L46;
 dSTR L47;
 dSTR L48;
 dSTR L49;
 dSTR L50;
 dSTR L51;
 dSTR L52;
 dSTR L53;
 dSTR L54;
 dSTR L55;
 dSTR L56;
 dSTR L57;
 dSTR L58;
 dSTR L59;
 dSTR L60;
 dSTR L61;
 dSTR L62;
 dSTR L63;
 dSTR L64;
 dSTR L65;
 dSTR L66;
 dSTR L67;
 dSTR L68;
 dSTR L69;
 dSTR L70;
 dSTR L71;
 dSTR L72;
 dSTR L73;
 dSTR L74;
 dSTR L75;
 dSTR L76;
 dSTR L77;
 dSTR L78;
 dSTR L79;
 dSTR L80;
 dSTR L81;
 dSTR L82;
 dSTR L83;
 dSTR L84;
 dSTR L85;
 dSTR L86;
 dSTR L87;
 dSTR L88;
 dSTR L89;
 dSTR L90;
 dSTR L91;
 dSTR L92;
 dSTR L93;
 dSTR L94;
 extern STR b3;
 extern STR f3;
 extern STR n2;
 extern STR r31;
 extern STR t3;
 extern STR v111;
 extern STR name56;
 extern STR name57;
 extern STR name58;
 INT L95;
 dSTR L96;
 STR L97;
 res = ((STR) &name1);
 L11 = c;
 switch (L11) {
  case 'a':
   L2 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L2)->value_part = c;
   res = STR_plus_dSTR_STR(res, L2);
   break;
  case 'b':
   L3 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L3)->value_part = c;
   res = STR_plus_dSTR_STR(res, L3);
   break;
  case 'c':
   L4 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L4)->value_part = c;
   res = STR_plus_dSTR_STR(res, L4);
   break;
  case 'd':
   L5 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L5)->value_part = c;
   res = STR_plus_dSTR_STR(res, L5);
   break;
  case 'e':
   L6 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L6)->value_part = c;
   res = STR_plus_dSTR_STR(res, L6);
   break;
  case 'f':
   L7 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L7)->value_part = c;
   res = STR_plus_dSTR_STR(res, L7);
   break;
  case 'g':
   L8 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L8)->value_part = c;
   res = STR_plus_dSTR_STR(res, L8);
   break;
  case 'h':
   L9 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L9)->value_part = c;
   res = STR_plus_dSTR_STR(res, L9);
   break;
  case 'i':
   L10 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L10)->value_part = c;
   res = STR_plus_dSTR_STR(res, L10);
   break;
  case 'j':
   L12 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L12)->value_part = c;
   res = STR_plus_dSTR_STR(res, L12);
   break;
  case 'k':
   L13 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L13)->value_part = c;
   res = STR_plus_dSTR_STR(res, L13);
   break;
  case 'l':
   L14 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L14)->value_part = c;
   res = STR_plus_dSTR_STR(res, L14);
   break;
  case 'm':
   L15 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L15)->value_part = c;
   res = STR_plus_dSTR_STR(res, L15);
   break;
  case 'n':
   L16 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L16)->value_part = c;
   res = STR_plus_dSTR_STR(res, L16);
   break;
  case 'o':
   L17 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L17)->value_part = c;
   res = STR_plus_dSTR_STR(res, L17);
   break;
  case 'p':
   L18 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L18)->value_part = c;
   res = STR_plus_dSTR_STR(res, L18);
   break;
  case 'q':
   L19 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L19)->value_part = c;
   res = STR_plus_dSTR_STR(res, L19);
   break;
  case 'r':
   L20 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L20)->value_part = c;
   res = STR_plus_dSTR_STR(res, L20);
   break;
  case 's':
   L21 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L21)->value_part = c;
   res = STR_plus_dSTR_STR(res, L21);
   break;
  case 't':
   L22 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L22)->value_part = c;
   res = STR_plus_dSTR_STR(res, L22);
   break;
  case 'u':
   L23 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L23)->value_part = c;
   res = STR_plus_dSTR_STR(res, L23);
   break;
  case 'v':
   L24 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L24)->value_part = c;
   res = STR_plus_dSTR_STR(res, L24);
   break;
  case 'w':
   L25 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L25)->value_part = c;
   res = STR_plus_dSTR_STR(res, L25);
   break;
  case 'x':
   L26 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L26)->value_part = c;
   res = STR_plus_dSTR_STR(res, L26);
   break;
  case 'y':
   L27 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L27)->value_part = c;
   res = STR_plus_dSTR_STR(res, L27);
   break;
  case 'z':
   L28 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L28)->value_part = c;
   res = STR_plus_dSTR_STR(res, L28);
   break;
  case '0':
   L29 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L29)->value_part = c;
   res = STR_plus_dSTR_STR(res, L29);
   break;
  case '1':
   L30 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L30)->value_part = c;
   res = STR_plus_dSTR_STR(res, L30);
   break;
  case '2':
   L31 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L31)->value_part = c;
   res = STR_plus_dSTR_STR(res, L31);
   break;
  case '3':
   L32 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L32)->value_part = c;
   res = STR_plus_dSTR_STR(res, L32);
   break;
  case '4':
   L33 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L33)->value_part = c;
   res = STR_plus_dSTR_STR(res, L33);
   break;
  case '5':
   L34 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L34)->value_part = c;
   res = STR_plus_dSTR_STR(res, L34);
   break;
  case '6':
   L35 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L35)->value_part = c;
   res = STR_plus_dSTR_STR(res, L35);
   break;
  case '7':
   L36 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L36)->value_part = c;
   res = STR_plus_dSTR_STR(res, L36);
   break;
  case '8':
   L37 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L37)->value_part = c;
   res = STR_plus_dSTR_STR(res, L37);
   break;
  case '9':
   L38 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L38)->value_part = c;
   res = STR_plus_dSTR_STR(res, L38);
   break;
  case 'A':
   L39 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L39)->value_part = c;
   res = STR_plus_dSTR_STR(res, L39);
   break;
  case 'B':
   L40 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L40)->value_part = c;
   res = STR_plus_dSTR_STR(res, L40);
   break;
  case 'C':
   L41 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L41)->value_part = c;
   res = STR_plus_dSTR_STR(res, L41);
   break;
  case 'D':
   L42 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L42)->value_part = c;
   res = STR_plus_dSTR_STR(res, L42);
   break;
  case 'E':
   L43 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L43)->value_part = c;
   res = STR_plus_dSTR_STR(res, L43);
   break;
  case 'F':
   L44 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L44)->value_part = c;
   res = STR_plus_dSTR_STR(res, L44);
   break;
  case 'G':
   L45 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L45)->value_part = c;
   res = STR_plus_dSTR_STR(res, L45);
   break;
  case 'H':
   L46 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L46)->value_part = c;
   res = STR_plus_dSTR_STR(res, L46);
   break;
  case 'I':
   L47 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L47)->value_part = c;
   res = STR_plus_dSTR_STR(res, L47);
   break;
  case 'J':
   L48 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L48)->value_part = c;
   res = STR_plus_dSTR_STR(res, L48);
   break;
  case 'K':
   L49 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L49)->value_part = c;
   res = STR_plus_dSTR_STR(res, L49);
   break;
  case 'L':
   L50 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L50)->value_part = c;
   res = STR_plus_dSTR_STR(res, L50);
   break;
  case 'M':
   L51 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L51)->value_part = c;
   res = STR_plus_dSTR_STR(res, L51);
   break;
  case 'N':
   L52 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L52)->value_part = c;
   res = STR_plus_dSTR_STR(res, L52);
   break;
  case 'O':
   L53 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L53)->value_part = c;
   res = STR_plus_dSTR_STR(res, L53);
   break;
  case 'P':
   L54 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L54)->value_part = c;
   res = STR_plus_dSTR_STR(res, L54);
   break;
  case 'Q':
   L55 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L55)->value_part = c;
   res = STR_plus_dSTR_STR(res, L55);
   break;
  case 'R':
   L56 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L56)->value_part = c;
   res = STR_plus_dSTR_STR(res, L56);
   break;
  case 'S':
   L57 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L57)->value_part = c;
   res = STR_plus_dSTR_STR(res, L57);
   break;
  case 'T':
   L58 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L58)->value_part = c;
   res = STR_plus_dSTR_STR(res, L58);
   break;
  case 'U':
   L59 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L59)->value_part = c;
   res = STR_plus_dSTR_STR(res, L59);
   break;
  case 'V':
   L60 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L60)->value_part = c;
   res = STR_plus_dSTR_STR(res, L60);
   break;
  case 'W':
   L61 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L61)->value_part = c;
   res = STR_plus_dSTR_STR(res, L61);
   break;
  case 'X':
   L62 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L62)->value_part = c;
   res = STR_plus_dSTR_STR(res, L62);
   break;
  case 'Y':
   L63 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L63)->value_part = c;
   res = STR_plus_dSTR_STR(res, L63);
   break;
  case 'Z':
   L64 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L64)->value_part = c;
   res = STR_plus_dSTR_STR(res, L64);
   break;
  case '!':
   L65 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L65)->value_part = c;
   res = STR_plus_dSTR_STR(res, L65);
   break;
  case '@':
   L66 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L66)->value_part = c;
   res = STR_plus_dSTR_STR(res, L66);
   break;
  case '#':
   L67 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L67)->value_part = c;
   res = STR_plus_dSTR_STR(res, L67);
   break;
  case '$':
   L68 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L68)->value_part = c;
   res = STR_plus_dSTR_STR(res, L68);
   break;
  case '%':
   L69 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L69)->value_part = c;
   res = STR_plus_dSTR_STR(res, L69);
   break;
  case '^':
   L70 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L70)->value_part = c;
   res = STR_plus_dSTR_STR(res, L70);
   break;
  case '&':
   L71 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L71)->value_part = c;
   res = STR_plus_dSTR_STR(res, L71);
   break;
  case '*':
   L72 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L72)->value_part = c;
   res = STR_plus_dSTR_STR(res, L72);
   break;
  case '(':
   L73 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L73)->value_part = c;
   res = STR_plus_dSTR_STR(res, L73);
   break;
  case ')':
   L74 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L74)->value_part = c;
   res = STR_plus_dSTR_STR(res, L74);
   break;
  case '-':
   L75 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L75)->value_part = c;
   res = STR_plus_dSTR_STR(res, L75);
   break;
  case '=':
   L76 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L76)->value_part = c;
   res = STR_plus_dSTR_STR(res, L76);
   break;
  case '+':
   L77 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L77)->value_part = c;
   res = STR_plus_dSTR_STR(res, L77);
   break;
  case '|':
   L78 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L78)->value_part = c;
   res = STR_plus_dSTR_STR(res, L78);
   break;
  case ':':
   L79 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L79)->value_part = c;
   res = STR_plus_dSTR_STR(res, L79);
   break;
  case ';':
   L80 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L80)->value_part = c;
   res = STR_plus_dSTR_STR(res, L80);
   break;
  case '`':
   L81 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L81)->value_part = c;
   res = STR_plus_dSTR_STR(res, L81);
   break;
  case '~':
   L82 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L82)->value_part = c;
   res = STR_plus_dSTR_STR(res, L82);
   break;
  case '_':
   L83 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L83)->value_part = c;
   res = STR_plus_dSTR_STR(res, L83);
   break;
  case ' ':
   L84 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L84)->value_part = c;
   res = STR_plus_dSTR_STR(res, L84);
   break;
  case ',':
   L85 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L85)->value_part = c;
   res = STR_plus_dSTR_STR(res, L85);
   break;
  case '.':
   L86 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L86)->value_part = c;
   res = STR_plus_dSTR_STR(res, L86);
   break;
  case '<':
   L87 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L87)->value_part = c;
   res = STR_plus_dSTR_STR(res, L87);
   break;
  case '>':
   L88 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L88)->value_part = c;
   res = STR_plus_dSTR_STR(res, L88);
   break;
  case '/':
   L89 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L89)->value_part = c;
   res = STR_plus_dSTR_STR(res, L89);
   break;
  case '?':
   L90 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L90)->value_part = c;
   res = STR_plus_dSTR_STR(res, L90);
   break;
  case '[':
   L91 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L91)->value_part = c;
   res = STR_plus_dSTR_STR(res, L91);
   break;
  case ']':
   L92 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L92)->value_part = c;
   res = STR_plus_dSTR_STR(res, L92);
   break;
  case '{':
   L93 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L93)->value_part = c;
   res = STR_plus_dSTR_STR(res, L93);
   break;
  case '}':
   L94 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L94)->value_part = c;
   res = STR_plus_dSTR_STR(res, L94);
   break;
  case '\b':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &b3)));
   break;
  case '\f':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &f3)));
   break;
  case '\n':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &n2)));
   break;
  case '\r':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &r31)));
   break;
  case '\t':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &t3)));
   break;
  case '\v':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &v111)));
   break;
  case '\\':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name56)));
   break;
  case '\'':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name57)));
   break;
  case '\"':
   res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name58)));
   break;
  default: ;
   oc = INT_octal_str_STR(((INT)((unsigned char)c)));
   L95 = STR_length_INT(oc);
   oc = STR_substring_INT_INT_ST(oc, 2, (INTMINUS(L95,2)));
   L96 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L96)->value_part = '\\';
   L97 = STR_plus_dSTR_STR(res, L96);
   res = STR_plus_dSTR_STR(L97, ((dSTR) oc));
 }
 ret_val = res;
 return ret_val;
}


STR MANGLE_Cify_STR_STR(MANGLE self, STR arg) {
 STR ret_val;
 FSTR res;
 STR L11;
 CHAR L2;
 STR L3;
 CHAR *L2p; INT L2n;
 res = FSTR_create_FSTR(((FSTR) NULL));
 {
  BOOL noname1 = TRUE;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = arg;
    L3 = L11;
    L2p = L3->arr_part; L2n = L3->asize;
   } else {
    L2p++; L2n--;
   }
   if (L2n<=0) goto after_loop; L2 = *L2p;
   res = FSTR_plus_STR_FSTR(res, MANGLE_Cify_CHAR_STR(self, L2));
  }
 }
 after_loop: ;
 ret_val = FSTR_str_STR(res);
 return ret_val;
}


STR MANGLE_genlocal_dOB_STR(MANGLE self, OB ns) {
 STR ret_val;
 STR name11;
 NAMESPACE L1;
 extern STR L;
 L1 = MANGLE_space_dOB_NAMESPA(self, ns);
 name11 = NAMESPACE_unique_with_pr(L1, ((STR) &L));
 SATTR(self,used_by_local,FSETSTR_insert_STR_FSETS(ATTR(self,used_by_local), name11));
 ret_val = name11;
 return ret_val;
}


STR MANGLE_genother_dOB_STR(MANGLE self, OB ns) {
 STR ret_val;
 NAMESPACE L1;
 extern STR other1;
 L1 = MANGLE_space_dOB_NAMESPA(self, ns);
 ret_val = NAMESPACE_with_prefix_ST(L1, ((STR) &other1));
 return ret_val;
}


STR MANGLE_mangle_dOB_dOB_ST(MANGLE self, OB ob, OB ns) {
 STR ret_val;
 NAMESPACE sp;
 STR res;
 STR s = ((STR) NULL);
 BOOL is_local = ((BOOL) 0);
 ARRAYdTP L11;
 FSTR tmp1;
 STR L21;
 CHAR c = ((CHAR) 0);
 CHAR L31 = ((CHAR) 0);
 CHAR L41 = ((CHAR) 0);
 dTP L5;
 STR L6;
 extern STR S_;
 BOOL L7;
 extern STR S_;
 dTP L8;
 dTP L9;
 BOOL L10;
 extern STR S_;
 dTP L12;
 BOOL L13;
 extern STR L;
 extern STR bound;
 IDENT L14;
 dTP L15;
 STR L16;
 dSTR L17;
 STR L18;
 extern STR after_loop;
 extern STR noname;
 CHAR L19;
 STR L20;
 CHAR *L19p; INT L19n;
 INT L22;
 extern STR name29;
 FSTR L23;
 extern STR S;
 FSTR L24;
 FSTR L25;
 extern STR S;
 FSTR L26;
 FSTR L27;
 extern STR S;
 FSTR L28;
 FSTR L29;
 extern STR S;
 FSTR L30;
 FSTR L32;
 extern STR S;
 FSTR L33;
 FSTR L34;
 extern STR S;
 FSTR L35;
 FSTR L36;
 extern STR S;
 FSTR L37;
 FSTR L38;
 extern STR S;
 FSTR L39;
 FSTR L40;
 extern STR S;
 FSTR L42;
 FSTR L43;
 extern STR S;
 FSTR L44;
 FSTR L45;
 extern STR S;
 FSTR L46;
 INT L47;
 BOOL L48;
 BOOL L49;
 BOOL L50;
 BOOL L51;
 BOOL L52;
 INT L53;
 sp = MANGLE_space_dOB_NAMESPA(self, ns);
 res = NAMESPACE_get_dOB_STR(sp, ob);
 if ((res==((STR) NULL))) {
  is_local = FALSE;
  if (ob==NULL) {
  } else
  switch (TAG(ob)) {
   case SIG_tag:
    L5 = ATTR(((SIG) ob),tp);
    if (L5==NULL) {
     FATAL("Dispatch on void in MANGLE::mangle($OB,$OB):STR");
    }
    L6 = (*dTP_str_STR[TAG(L5)+dTP_str_STR_offset])(L5);
    s = STR_append_STR_STR_STR(L6, ((STR) &S_), ATTR(((SIG) ob),name1).str);
    L7 = (ATTR(((SIG) ob),args1)==((ARRAYdTP) NULL));
    if ((!(L7))) {
     {
      struct ARRAYdTP_eltb_dTP_frame_struct other1_0;
      ARRAYdTP_eltb_dTP_frame 
      noname1 = &other1_0;
      noname1->state = 0;
      while (1) {
       if (noname1->state == 0) {
        L11 = ATTR(((SIG) ob),args1);
        noname1->self = L11;
       }
       L8 = ARRAYdTP_eltb_dTP(noname1);
       if (noname1->state == -1) {
        goto after_loop;
       }
       L9 = L8;
       if (L9==NULL) {
        FATAL("Dispatch on void in MANGLE::mangle($OB,$OB):STR");
       }
       s = STR_append_STR_STR_STR(s, ((STR) &S_), (*dTP_str_STR[TAG(L9)+dTP_str_STR_offset])(L9));
      }
     }
     after_loop: ;
    }
    L10 = (ATTR(((SIG) ob),ret1)==((dTP) NULL));
    if ((!(L10))) {
     L12 = ATTR(((SIG) ob),ret1);
     if (L12==NULL) {
      FATAL("Dispatch on void in MANGLE::mangle($OB,$OB):STR");
     }
     s = STR_append_STR_STR_STR(s, ((STR) &S_), (*dTP_str_STR[TAG(L12)+dTP_str_STR_offset])(L12));
    } break;
   case AM_LOCAL_EXPR_tag:
    L13 = (ATTR(((AM_LOCAL_EXPR) ob),name1).str==(STR)0);
    if ((!(L13))) {
     s = ATTR(((AM_LOCAL_EXPR) ob),name1).str;
    }
    else {
     s = NAMESPACE_unique_with_pr(sp, ((STR) &L));
    }
    is_local = TRUE; break;
   case TP_CLASS_tag:
    s = TP_CLASS_str_STR(((TP_CLASS) ob)); break;
   case TP_ROUT_tag:
    s = TP_ROUT_str_STR(((TP_ROUT) ob)); break;
   case AM_BND_CREATE_EXPR_tag:
    s = ((STR) &bound); break;
   case STR_tag:
    s = ((STR) ob); break;
   case IDENT_tag:
    L14 = ((IDENT_boxed) ob)->value_part;
    s = L14.str; break;
   case AM_GLOBAL_EXPR_tag:
    L15 = ATTR(((AM_GLOBAL_EXPR) ob),class_tp);
    if (L15==NULL) {
     FATAL("Dispatch on void in MANGLE::mangle($OB,$OB):STR");
    }
    L16 = (*dTP_str_STR[TAG(L15)+dTP_str_STR_offset])(L15);
    L17 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
    ((CHAR_boxed) L17)->value_part = '_';
    L18 = STR_plus_dSTR_STR(L16, L17);
    s = STR_plus_dSTR_STR(L18, ((dSTR) ATTR(((AM_GLOBAL_EXPR) ob),name1).str)); break;
   case AM_LOOP_STMT_tag:
    s = ((STR) &after_loop); break;
   case AM_STR_CONST_tag:
    s = ATTR(((AM_STR_CONST) ob),bval); break;
   default: ;
  }
  if ((s==((STR) NULL))) {
   res = NAMESPACE_with_prefix_ST(sp, ((STR) &noname));
  }
  else {
   tmp1 = FSTR_create_FSTR(((FSTR) NULL));
   {
    BOOL noname2 = TRUE;
    while (1) {
     if (noname2) {
      noname2 = FALSE;
      L21 = s;
      L20 = L21;
      L19p = L20->arr_part; L19n = L20->asize;
     } else {
      L19p++; L19n--;
     }
     if (L19n<=0) goto after_loop1; L19 = *L19p;
     c = L19;
     L31 = c;
     switch (L31) {
      case 'a':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'b':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'c':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'd':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'e':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'f':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'g':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'h':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'i':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'j':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'k':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'l':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'm':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'n':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'o':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'p':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'q':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'r':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 's':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 't':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'u':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'v':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'w':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'x':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'y':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'z':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '0':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '1':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '2':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '3':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '4':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '5':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '6':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '7':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '8':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '9':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '_':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'A':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'B':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'C':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'D':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'E':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'F':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'G':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'H':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'I':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'J':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'K':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'L':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'M':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'N':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'O':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'P':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'Q':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'R':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'S':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'T':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'U':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'V':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'W':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'X':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'Y':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case 'Z':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, c);
       break;
      case '$':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, 'd');
       break;
      case '!':
       tmp1 = FSTR_plus_CHAR_FSTR(tmp1, 'b');
       break;
      default: ;
     }
    }
   }
   after_loop1: ;
   L22 = FSTR_length_INT(tmp1);
   if ((L22==0)) {
    tmp1 = FSTR_plus_STR_FSTR(tmp1, ((STR) &name29));
   }
   L41 = (FSTRAGET(tmp1,0));
   switch (L41) {
    case '0':
     L23 = FSTR_create_FSTR(((FSTR) NULL));
     L24 = FSTR_plus_STR_FSTR(L23, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L24, tmp1);
     break;
    case '1':
     L25 = FSTR_create_FSTR(((FSTR) NULL));
     L26 = FSTR_plus_STR_FSTR(L25, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L26, tmp1);
     break;
    case '2':
     L27 = FSTR_create_FSTR(((FSTR) NULL));
     L28 = FSTR_plus_STR_FSTR(L27, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L28, tmp1);
     break;
    case '3':
     L29 = FSTR_create_FSTR(((FSTR) NULL));
     L30 = FSTR_plus_STR_FSTR(L29, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L30, tmp1);
     break;
    case '4':
     L32 = FSTR_create_FSTR(((FSTR) NULL));
     L33 = FSTR_plus_STR_FSTR(L32, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L33, tmp1);
     break;
    case '5':
     L34 = FSTR_create_FSTR(((FSTR) NULL));
     L35 = FSTR_plus_STR_FSTR(L34, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L35, tmp1);
     break;
    case '6':
     L36 = FSTR_create_FSTR(((FSTR) NULL));
     L37 = FSTR_plus_STR_FSTR(L36, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L37, tmp1);
     break;
    case '7':
     L38 = FSTR_create_FSTR(((FSTR) NULL));
     L39 = FSTR_plus_STR_FSTR(L38, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L39, tmp1);
     break;
    case '8':
     L40 = FSTR_create_FSTR(((FSTR) NULL));
     L42 = FSTR_plus_STR_FSTR(L40, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L42, tmp1);
     break;
    case '9':
     L43 = FSTR_create_FSTR(((FSTR) NULL));
     L44 = FSTR_plus_STR_FSTR(L43, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L44, tmp1);
     break;
    case '_':
     L45 = FSTR_create_FSTR(((FSTR) NULL));
     L46 = FSTR_plus_STR_FSTR(L45, ((STR) &S));
     tmp1 = FSTR_plus_FSTR_FSTR(L46, tmp1);
     break;
    default: ;
   }
   res = FSTR_str_STR(tmp1);
   L47 = STR_length_INT(res);
   if ((L47>24)) {
    res = STR_head_INT_STR(res, 24);
   }
   while (1) {
    if (NAMESPACE_is_taken_STR_B(sp, res)) {
     L50 = TRUE;
    } else {
     L50 = FSETSTR_test_STR_BOOL(ATTR(self,forbidden), res);
    }
    if (L50) {
     L49 = TRUE;
    } else {
     if (is_local) {
      L51 = NAMESPACE_is_taken_STR_B(ATTR(self,global_space), res);
     } else {
      L51 = FALSE;
     }
     L49 = L51;
    }
    if (L49) {
     L48 = TRUE;
    } else {
     if ((!(is_local))) {
      L52 = FSETSTR_test_STR_BOOL(ATTR(self,used_by_local), res);
     } else {
      L52 = FALSE;
     }
     L48 = L52;
    }
    if (L48) {
    }
    else {
     goto after_loop2;
    }
    L53 = STR_length_INT(res);
    res = NAMESPACE_with_prefix_ST(sp, STR_head_INT_STR(res, ((24<L53)?24:L53)));
   }
   after_loop2: ;
  }
  NAMESPACE_insert_dOB_STR(sp, ob, res);
  if (is_local) {
   SATTR(self,used_by_local,FSETSTR_insert_STR_FSETS(ATTR(self,used_by_local), res));
  }
 }
 ret_val = res;
 return ret_val;
}


STR NAMEMAP_get_dOB_STR(NAMEMAP self, OB k) {
 STR ret_val;
 INT h = ((INT) 0);
 OB tk;
 OB tk1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((NAMEMAP) NULL))) {
  ret_val = ((STR) NULL);
  return ret_val;
 }
 L1 = NAMEMAP_key_hash_dOB_INT(self, k);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  tk = NAMEMAP_aget_INT_TUPdOBS(self, h).t1;
  if (NAMEMAP_is_key_nil_dOB_B(self, tk)) {
   goto after_loop;
  }
  else {
   if (NAMEMAP_key_eq_dOB_dOB_B(self, tk, k)) {
    ret_val = NAMEMAP_aget_INT_TUPdOBS(self, h).t2;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   tk1 = NAMEMAP_aget_INT_TUPdOBS(self, h).t1;
   if (NAMEMAP_is_key_nil_dOB_B(self, tk1)) {
    goto after_loop1;
   }
   else {
    if (NAMEMAP_key_eq_dOB_dOB_B(self, tk1, k)) {
     ret_val = NAMEMAP_aget_INT_TUPdOBS(self, h).t2;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = ((STR) NULL);
 return ret_val;
}


STR NAMESPACE_get_dOB_STR(NAMESPACE self, OB ob) {
 STR ret_val;
 ret_val = NAMEMAP_get_dOB_STR(ATTR(self,map), ob);
 return ret_val;
}


STR NAMESPACE_unique_with_pr(NAMESPACE self, STR s) {
 STR ret_val;
 STR res = ((STR) NULL);
 INT L1;
 dSTR L2;
 BOOL L3;
 while (1) {
  L1 = ATTR(self,counter1);
  SATTR(self,counter1,(INTPLUS(L1,1)));
  L2 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L2)->value_part = ATTR(self,counter1);
  res = STR_plus_dSTR_STR(s, L2);
  L3 = FSETSTR_test_STR_BOOL(ATTR(self,set), res);
  if ((!(L3))) {
   goto after_loop;
  }
 }
 after_loop: ;
 SATTR(self,set,FSETSTR_insert_STR_FSETS(ATTR(self,set), res));
 ret_val = res;
 return ret_val;
}


STR NAMESPACE_with_prefix_ST(NAMESPACE self, STR s) {
 STR ret_val;
 STR res = ((STR) NULL);
 INT i = ((INT) 0);
 dSTR L1;
 BOOL L2;
 i = FMAPSTRINT_get_STR_INT(ATTR(self,uniques), s);
 if ((i==((INT) 0))) {
  i = 0;
 }
 while (1) {
  i = (INTPLUS(i,1));
  L1 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L1)->value_part = i;
  res = STR_plus_dSTR_STR(s, L1);
  L2 = FSETSTR_test_STR_BOOL(ATTR(self,set), res);
  if ((!(L2))) {
   goto after_loop;
  }
 }
 after_loop: ;
 SATTR(self,uniques,FMAPSTRINT_insert_STR_IN(ATTR(self,uniques), s, i));
 ret_val = res;
 return ret_val;
}


TUPIDENTdTP LAYOUT_ARR_aeltb_TUPIDEN(LAYOUT_ARR_aeltb_TUPIDEN_frame frame) {
 TUPIDENTdTP dummy = TUPIDENTdTP_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return LAYOUT_ARR_aget_INT_TUPI(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPIDENTdTP LAYOUT_ARR_aget_INT_TUPI(LAYOUT_ARR self, INT ind) {
 TUPIDENTdTP ret_val = TUPIDENTdTP_zero;
 return ARR(self,ind);
}


TUPIDENTdTP LAYOUT_ARR_eltb_TUPIDENT(LAYOUT_ARR_eltb_TUPIDENT_frame frame) {
 TUPIDENTdTP dummy = TUPIDENTdTP_zero;
 BOOL L1;
 TUPIDENTdTP L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((LAYOUT_ARR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(LAYOUT_ARR_aeltb_TUPIDEN_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = LAYOUT_ARR_aeltb_TUPIDEN(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


TUPdOBSTR NAMEMAP_aeltb_TUPdOBSTR(NAMEMAP_aeltb_TUPdOBSTR_frame frame) {
 TUPdOBSTR dummy = TUPdOBSTR_zero;
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return NAMEMAP_aget_INT_TUPdOBS(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


TUPdOBSTR NAMEMAP_aget_INT_TUPdOBS(NAMEMAP self, INT ind) {
 TUPdOBSTR ret_val = TUPdOBSTR_zero;
 return ARR(self,ind);
}


TUPdOBSTR NAMEMAP_pairsb_TUPdOBSTR(NAMEMAP_pairsb_TUPdOBSTR_frame frame) {
 TUPdOBSTR dummy = TUPdOBSTR_zero;
 BOOL L1;
 TUPdOBSTR L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((NAMEMAP) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(NAMEMAP_aeltb_TUPdOBSTR_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = NAMEMAP_aeltb_TUPdOBSTR(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = NAMEMAP_is_key_nil_dOB_B(frame->self, frame->r.t1);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dAM_EXPR INLINE_ROUT_inline_AM_RO(INLINE_ROUT self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 AM_STMT_EXPR se;
 XFORM_CODE xc1;
 dAM_STMT init_parms;
 dAM_STMT s;
 AM_ROUT_CALL_EXPR L11;
 INT L2;
 dAM_EXPR L3;
 dAM_STMT L4;
 BOOL L5;
 dAM_STMT L6;
 BOOL L7;
 L2 = INLINE_ROUT_inlined;
 INLINE_ROUT_inlined_INT(self, (INTPLUS(L2,1)));
 se = AM_STMT_EXPR_create_SFIL(((AM_STMT_EXPR) NULL), ATTR(call11,source11));
 CHANGE_VARS_new_copy_SFI(ATTR(self,change_vars), ATTR(call11,source11));
 SATTR(se,locals1,ATTR(ATTR(self,change_vars),new_vars));
 xc1 = XFORM_CODE_create_FMAPAM(((XFORM_CODE) NULL), ATTR(ATTR(self,change_vars),new_subst));
 SATTR(xc1,record_calls,FALSE);
 init_parms = XFORM_CODE_xform_stmt_li(xc1, ATTR(ATTR(self,change_vars),init_parms1));
 s = init_parms;
 {
  struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct other1_0;
  AM_ROUT_CALL_EXPR_eltb_d_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if ((s==((dAM_STMT) NULL))) {
    goto after_loop;
   }
   if (s==NULL) {
    FATAL("Void object of typecase");
   } else
   switch (TAG(s)) {
    case AM_ASSIGN_STMT_tag:
     if ((ATTR(((AM_ASSIGN_STMT) s),src11)==((dAM_EXPR) NULL))) {
      if (noname1->state == 0) {
       L11 = call11;
       noname1->self = L11;
      }
      L3 = AM_ROUT_CALL_EXPR_eltb_d(noname1);
      if (noname1->state == -1) {
       goto after_loop;
      }
      SATTR(((AM_ASSIGN_STMT) s),src11,L3);
     } break;
    default: ;
     FATAL("No applicable type in typecase");
   }
   L4 = s;
   if (L4==NULL) {
    FATAL("Dispatch on void in INLINE_ROUT::inline(AM_ROUT_CALL_EXPR):$AM_EXPR");
   }
   s = (*dAM_STMT_next_dAM_STMT[TAG(L4)+dAM_STMT_next_dAM_STMT_offset])(L4);
  }
 }
 after_loop: ;
 SATTR(xc1,record_calls,TRUE);
 SATTR(se,stmts,XFORM_CODE_xform_stmt_li(xc1, ATTR(self,code11)));
 L5 = (init_parms==((dAM_STMT) NULL));
 if ((!(L5))) {
  L6 = init_parms;
  if (L6==NULL) {
   FATAL("Dispatch on void in INLINE_ROUT::inline(AM_ROUT_CALL_EXPR):$AM_EXPR");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L6)+dAM_STMT_append_dAM_STMT_offset])(L6, ATTR(se,stmts));
  SATTR(se,stmts,init_parms);
 }
 L7 = (ATTR(self,return_val)==((dAM_EXPR) NULL));
 if ((!(L7))) {
  SATTR(se,expr,XFORM_CODE_xform_expr_dA(xc1, ATTR(self,return_val)));
 }
 SATTR(se,calls1,ATTR(xc1,calls1));
 SYSDESTROY(((OB) xc1));
 CHANGE_VARS_after_one_us(ATTR(self,change_vars));
 ret_val = ((dAM_EXPR) se);
 return ret_val;
}


dAM_EXPR INLINE_VATTR_WRITE_inlin2(INLINE_VATTR_WRITE self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 AM_VATTR_ASSIGN_EXPR r;
 INT L1;
 L1 = INLINE_VATTR_WRITE_inlin1;
 INLINE_VATTR_WRITE_inlin(self, (INTPLUS(L1,1)));
 r = AM_VATTR_ASSIGN_EXPR_cre(((AM_VATTR_ASSIGN_EXPR) NULL), ATTR(call11,source11));
 SATTR(r,ob1,AM_ROUT_CALL_EXPR_aget_I(call11, 0));
 SATTR(r,val11,AM_ROUT_CALL_EXPR_aget_I(call11, 1));
 SATTR(r,at11,ATTR(self,at11));
 ret_val = ((dAM_EXPR) r);
 return ret_val;
}


dINLINE_ITER_SIG INLINE_ITER_TBL_aeltb_dI(INLINE_ITER_TBL_aeltb_dI_frame frame) {
 dINLINE_ITER_SIG dummy = ((dINLINE_ITER_SIG) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return INLINE_ITER_TBL_aget_INT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dINLINE_ITER_SIG INLINE_ITER_TBL_aget_INT(INLINE_ITER_TBL self, INT ind) {
 dINLINE_ITER_SIG ret_val;
 return ARR(self,ind);
}


dINLINE_ITER_SIG INLINE_ITER_TBL_eltb_dIN(INLINE_ITER_TBL_eltb_dIN_frame frame) {
 dINLINE_ITER_SIG dummy = ((dINLINE_ITER_SIG) NULL);
 BOOL L1;
 dINLINE_ITER_SIG L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((INLINE_ITER_TBL) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(INLINE_ITER_TBL_aeltb_dI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = INLINE_ITER_TBL_aeltb_dI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = INLINE_ITER_TBL_is_elt_n(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dINLINE_ITER_SIG INLINE_ITER_TBL_get_quer(INLINE_ITER_TBL self, SIG q) {
 dINLINE_ITER_SIG ret_val;
 INT h = ((INT) 0);
 dINLINE_ITER_SIG e;
 dINLINE_ITER_SIG e1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((INLINE_ITER_TBL) NULL))) {
  ret_val = ((dINLINE_ITER_SIG) NULL);
  return ret_val;
 }
 L1 = INLINE_ITER_TBL_query_ha(self, q);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  e = INLINE_ITER_TBL_aget_INT(self, h);
  if (INLINE_ITER_TBL_is_elt_n(self, e)) {
   goto after_loop;
  }
  else {
   if (INLINE_ITER_TBL_query_te(self, q, e)) {
    ret_val = e;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   e1 = INLINE_ITER_TBL_aget_INT(self, h);
   if (INLINE_ITER_TBL_is_elt_n(self, e1)) {
    goto after_loop1;
   }
   else {
    if (INLINE_ITER_TBL_query_te(self, q, e1)) {
     ret_val = e1;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = INLINE_ITER_TBL_elt_nil_(self);
 return ret_val;
}


dINLINE_ROUT_SIG INLINE_ROUT_TBL_aeltb_dI(INLINE_ROUT_TBL_aeltb_dI_frame frame) {
 dINLINE_ROUT_SIG dummy = ((dINLINE_ROUT_SIG) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return INLINE_ROUT_TBL_aget_INT(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dINLINE_ROUT_SIG INLINE_ROUT_TBL_aget_INT(INLINE_ROUT_TBL self, INT ind) {
 dINLINE_ROUT_SIG ret_val;
 return ARR(self,ind);
}


dINLINE_ROUT_SIG INLINE_ROUT_TBL_eltb_dIN(INLINE_ROUT_TBL_eltb_dIN_frame frame) {
 dINLINE_ROUT_SIG dummy = ((dINLINE_ROUT_SIG) NULL);
 BOOL L1;
 dINLINE_ROUT_SIG L2;
 BOOL L4;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((INLINE_ROUT_TBL) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(INLINE_ROUT_TBL_aeltb_dI_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = INLINE_ROUT_TBL_aeltb_dI(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    frame->r = L2;
    L4 = INLINE_ROUT_TBL_is_elt_n(frame->self, frame->r);
    if ((!(L4))) {
     frame->state = 1;
     return frame->r;
     state1:;
    }
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dINLINE_ROUT_SIG INLINE_ROUT_TBL_get_quer(INLINE_ROUT_TBL self, SIG q) {
 dINLINE_ROUT_SIG ret_val;
 INT h = ((INT) 0);
 dINLINE_ROUT_SIG e;
 dINLINE_ROUT_SIG e1;
 INT L1;
 INT L2;
 INT L3;
 INT L4;
 INT L5;
 if ((self==((INLINE_ROUT_TBL) NULL))) {
  ret_val = ((dINLINE_ROUT_SIG) NULL);
  return ret_val;
 }
 L1 = INLINE_ROUT_TBL_query_ha(self, q);
 L2 = (ASIZE(self));
 L3 = (INTMINUS(L2,2));
 h = (L1&L3);
 while (1) {
  e = INLINE_ROUT_TBL_aget_INT(self, h);
  if (INLINE_ROUT_TBL_is_elt_n(self, e)) {
   goto after_loop;
  }
  else {
   if (INLINE_ROUT_TBL_query_te(self, q, e)) {
    ret_val = e;
    return ret_val;
   }
  }
  h = (INTPLUS(h,1));
 }
 after_loop: ;
 L4 = (ASIZE(self));
 L5 = (INTMINUS(L4,1));
 if ((h==L5)) {
  h = 0;
  while (1) {
   e1 = INLINE_ROUT_TBL_aget_INT(self, h);
   if (INLINE_ROUT_TBL_is_elt_n(self, e1)) {
    goto after_loop1;
   }
   else {
    if (INLINE_ROUT_TBL_query_te(self, q, e1)) {
     ret_val = e1;
     return ret_val;
    }
   }
   h = (INTPLUS(h,1));
  }
  after_loop1: ;
 }
 ret_val = INLINE_ROUT_TBL_elt_nil_(self);
 return ret_val;
}


dLAYOUT LAYOUT_ARRAY_aeltb_dLAYO(LAYOUT_ARRAY_aeltb_dLAYO_frame frame) {
 dLAYOUT dummy = ((dLAYOUT) NULL);
 INT L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = 0;
 while (1) {
  L1 = (ASIZE(frame->self));
  if ((frame->i>=L1)) {
   goto after_loop;
  }
  frame->state = 1;
  return LAYOUT_ARRAY_aget_INT_dL(frame->self, frame->i);
  state1:;
  frame->i = (INTPLUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}


dLAYOUT LAYOUT_ARRAY_aget_INT_dL(LAYOUT_ARRAY self, INT ind) {
 dLAYOUT ret_val;
 return ARR(self,ind);
}


dLAYOUT LAYOUT_ARRAY_eltb_dLAYOU(LAYOUT_ARRAY_eltb_dLAYOU_frame frame) {
 dLAYOUT dummy = ((dLAYOUT) NULL);
 BOOL L1;
 dLAYOUT L2;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((LAYOUT_ARRAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(LAYOUT_ARRAY_aeltb_dLAYO_frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = frame->self;
     frame->nested1->self = frame->L31;
    }
    L2 = LAYOUT_ARRAY_aeltb_dLAYO(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return dummy;
}


dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL self, dTP t) {
 dLAYOUT ret_val;
 dLAYOUT l = ((dLAYOUT) NULL);
 dTP L1;
 INT L2;
 INT L3;
 dTP L4;
 dTP L5;
 dTP L6;
 if (CGEN_is_built_in_type_dT(LAYOUT_TBL_cgen, t)) {
  l = ((dLAYOUT) BUILTIN_LAYOUT_create_dT(((BUILTIN_LAYOUT) NULL), t));
 }
 else {
  L1 = t;
  if (L1==NULL) {
   FATAL("Dispatch on void in LAYOUT_TBL::layout($TP):$LAYOUT");
  }
  L2 = (*dTP_kind_INT[TAG(L1)+dTP_kind_INT_offset])(L1);
  L3 = TP_KIND_ext_tp;
  if ((L2==L3)) {
   l = ((dLAYOUT) EXTERNAL_LAYOUT_create_d(((EXTERNAL_LAYOUT) NULL), t));
  }
  else {
   L4 = t;
   if (L4==NULL) {
    FATAL("Dispatch on void in LAYOUT_TBL::layout($TP):$LAYOUT");
   }
   if ((*dTP_is_abstract_BOOL[TAG(L4)+dTP_is_abstract_BOOL_offset])(L4)) {
    l = ((dLAYOUT) ABSTRACT_LAYOUT_create_d(((ABSTRACT_LAYOUT) NULL), t, LAYOUT_TBL_prog));
   }
   else {
    L5 = t;
    if (L5==NULL) {
     FATAL("Dispatch on void in LAYOUT_TBL::layout($TP):$LAYOUT");
    }
    if ((*dTP_is_bound_BOOL[TAG(L5)+dTP_is_bound_BOOL_offset])(L5)) {
     l = ((dLAYOUT) BOUND_TYPE_LAYOUT_create(((BOUND_TYPE_LAYOUT) NULL), t));
    }
    else {
     L6 = t;
     if (L6==NULL) {
      FATAL("Dispatch on void in LAYOUT_TBL::layout($TP):$LAYOUT");
     }
     if ((*dTP_is_value_BOOL[TAG(L6)+dTP_is_value_BOOL_offset])(L6)) {
      l = ((dLAYOUT) VALUE_CLASS_LAYOUT_creat(((VALUE_CLASS_LAYOUT) NULL), t, LAYOUT_TBL_prog));
     }
     else {
      l = ((dLAYOUT) CLASS_LAYOUT_create_dTP_(((CLASS_LAYOUT) NULL), t, LAYOUT_TBL_prog));
     }
    }
   }
  }
 }
 ret_val = l;
 return ret_val;
}


void INLINE_ITER_TBL_aset_INT(INLINE_ITER_TBL self, INT ind, dINLINE_ITER_SIG val1) {
 SARR(self,ind,val1);
}


void INLINE_ITER_TBL_asetb_dI(INLINE_ITER_TBL_asetb_dI_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   INLINE_ITER_TBL_aset_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void INLINE_ROUT_TBL_aset_INT(INLINE_ROUT_TBL self, INT ind, dINLINE_ROUT_SIG val1) {
 SARR(self,ind,val1);
}


void INLINE_ROUT_TBL_asetb_dI(INLINE_ROUT_TBL_asetb_dI_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   INLINE_ROUT_TBL_aset_INT(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void INLINE_ROUT_copy_rout_AM(INLINE_ROUT self, AM_ROUT_DEF rout) {
 XFORM_CODE xc1;
 SATTR(self,change_vars,CHANGE_VARS_create_AM_RO(((CHANGE_VARS) NULL), rout));
 xc1 = XFORM_CODE_create_FMAPAM(((XFORM_CODE) NULL), ATTR(ATTR(self,change_vars),saved_subst));
 SATTR(xc1,record_calls,FALSE);
 SATTR(self,code11,XFORM_CODE_xform_stmt_li(xc1, ATTR(rout,code11)));
 SATTR(self,return_val,ATTR(xc1,return_val));
 CHANGE_VARS_after_saving(ATTR(self,change_vars));
 SYSDESTROY(((OB) xc1));
}


void INLINE_ROUT_inlined_INT(INLINE_ROUT self, INT inlined) {
 INLINE_ROUT_inlined = inlined;
}


void INLINE_ROUT_routines_INT(INLINE_ROUT self, INT routines1) {
 INLINE_ROUT_routines = routines1;
}


void INLINE_VATTR_WRITE_routi(INLINE_VATTR_WRITE self, INT routines1) {
 INLINE_VATTR_WRITE_routi1 = routines1;
}


void INTI_aset_INT_INT(INTI self, INT ind, INT val1) {
 SARR(self,ind,val1);
}


void INTI_buf_FSTR(INTI self, FSTR buf1) {
 INTI_buf = buf1;
}


void INT_buf_FSTR(INT self, FSTR buf1) {
 INT_buf = buf1;
}


void INT_timesb(INT_timesb_frame frame) {
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->i = frame->self;
 while (1) {
  if ((frame->i<=0)) {
   goto after_loop;
  }
  frame->state = 1;
  return;
  state1:;
  frame->i = (INTMINUS(frame->i,1));
 }
 after_loop: ;
 frame->state = -1;
 return;
}


void LAYOUT_ARRAY_aset_INT_dL(LAYOUT_ARRAY self, INT ind, dLAYOUT val1) {
 SARR(self,ind,val1);
}


void LAYOUT_ARRAY_asetb_dLAYO(LAYOUT_ARRAY_asetb_dLAYO_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   LAYOUT_ARRAY_aset_INT_dL(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void LAYOUT_ARRAY_insertion_s(LAYOUT_ARRAY self, INT l, INT u) {
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dLAYOUT e;
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT j = ((INT) 0);
 INT L5;
 INT L6;
 INT L7;
 
 INT L8;
 dLAYOUT L9;
 INT L10;
 INT L12;
 {
  BOOL noname1 = TRUE;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = (INTPLUS(l,1));
    L21 = u;
    L6 = L11;
    L7 = L21;
    L5 = L6;
   } else {
    L5++;
   }
   if (L5>L7) goto after_loop;
   i = L5;
   e = LAYOUT_ARRAY_aget_INT_dL(self, i);
   {
    struct INT_downtob_INT_INT_frame_struct other2_0;
    INT_downtob_INT_INT_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L31 = (INTMINUS(i,1));
      L41 = (INTMINUS(l,1));
      noname2->self = L31;
      noname2->arg1 = L41;
     }
     L8 = INT_downtob_INT_INT(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     j = L8;
     if ((j<l)) {
      LAYOUT_ARRAY_aset_INT_dL(self, l, e);
      goto after_loop1;
     }
     else {
      L9 = LAYOUT_ARRAY_aget_INT_dL(self, j);
      if (LAYOUT_ARRAY_elt_lt_dLAY(self, L9, e)) {
       L10 = (INTPLUS(j,1));
       LAYOUT_ARRAY_aset_INT_dL(self, L10, e);
       goto after_loop1;
      }
      else {
       L12 = (INTPLUS(j,1));
       LAYOUT_ARRAY_aset_INT_dL(self, L12, LAYOUT_ARRAY_aget_INT_dL(self, j));
      }
     }
    }
   }
   after_loop1: ;
  }
 }
 after_loop: ;
}


void LAYOUT_ARRAY_quicksort_r(LAYOUT_ARRAY self, INT l, INT u) {
 INT r = ((INT) 0);
 dLAYOUT t;
 INT m = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 dLAYOUT s;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 
 dLAYOUT L8;
 INT L9;
 INT L10;
 INT L12;
 L3 = (INTMINUS(u,l));
 L4 = LAYOUT_ARRAY_quicksort_l;
 if ((L3>L4)) {
  r = RND_int_INT_INT_INT(((RND) NULL), l, u);
  t = LAYOUT_ARRAY_aget_INT_dL(self, r);
  LAYOUT_ARRAY_aset_INT_dL(self, r, LAYOUT_ARRAY_aget_INT_dL(self, l));
  LAYOUT_ARRAY_aset_INT_dL(self, l, t);
  m = l;
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = (INTPLUS(l,1));
     L21 = u;
     L6 = L11;
     L7 = L21;
     L5 = L6;
    } else {
     L5++;
    }
    if (L5>L7) goto after_loop;
    i = L5;
    L8 = LAYOUT_ARRAY_aget_INT_dL(self, i);
    if (LAYOUT_ARRAY_elt_lt_dLAY(self, L8, t)) {
     m = (INTPLUS(m,1));
     s = LAYOUT_ARRAY_aget_INT_dL(self, m);
     LAYOUT_ARRAY_aset_INT_dL(self, m, LAYOUT_ARRAY_aget_INT_dL(self, i));
     LAYOUT_ARRAY_aset_INT_dL(self, i, s);
    }
   }
  }
  after_loop: ;
  t = LAYOUT_ARRAY_aget_INT_dL(self, l);
  LAYOUT_ARRAY_aset_INT_dL(self, l, LAYOUT_ARRAY_aget_INT_dL(self, m));
  LAYOUT_ARRAY_aset_INT_dL(self, m, t);
  L9 = (INTMINUS(m,1));
  if ((l<L9)) {
   LAYOUT_ARRAY_quicksort_r(self, l, (INTMINUS(m,1)));
  }
  L10 = (INTPLUS(m,1));
  if ((L10<u)) {
   L12 = (INTPLUS(m,1));
   LAYOUT_ARRAY_quicksort_r(self, L12, u);
  }
 }
 else {
  LAYOUT_ARRAY_insertion_s(self, l, u);
 }
}


void LAYOUT_ARRAY_setb_dLAYOU(LAYOUT_ARRAY_setb_dLAYOU_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((LAYOUT_ARRAY) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(LAYOUT_ARRAY_asetb_dLAYO_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    LAYOUT_ARRAY_asetb_dLAYO(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void LAYOUT_ARRAY_sort(LAYOUT_ARRAY self) {
 BOOL L1;
 INT L2;
 L1 = (self==((LAYOUT_ARRAY) NULL));
 if ((!(L1))) {
  L2 = (ASIZE(self));
  LAYOUT_ARRAY_quicksort_r(self, 0, (INTMINUS(L2,1)));
 }
}


void LAYOUT_ARR_aset_INT_TUPI(LAYOUT_ARR self, INT ind, TUPIDENTdTP val1) {
 SARR(self,ind,val1);
}


void LAYOUT_ARR_asetb_TUPIDEN(LAYOUT_ARR_asetb_TUPIDEN_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   LAYOUT_ARR_aset_INT_TUPI(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void LAYOUT_ARR_insertion_sor(LAYOUT_ARR self, INT l, INT u) {
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 TUPIDENTdTP e = TUPIDENTdTP_zero;
 INT L31 = ((INT) 0);
 INT L41 = ((INT) 0);
 INT j = ((INT) 0);
 INT L5;
 INT L6;
 INT L7;
 
 INT L8;
 TUPIDENTdTP L9;
 INT L10;
 INT L12;
 {
  BOOL noname1 = TRUE;
  while (1) {
   if (noname1) {
    noname1 = FALSE;
    L11 = (INTPLUS(l,1));
    L21 = u;
    L6 = L11;
    L7 = L21;
    L5 = L6;
   } else {
    L5++;
   }
   if (L5>L7) goto after_loop;
   i = L5;
   e = LAYOUT_ARR_aget_INT_TUPI(self, i);
   {
    struct INT_downtob_INT_INT_frame_struct other2_0;
    INT_downtob_INT_INT_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L31 = (INTMINUS(i,1));
      L41 = (INTMINUS(l,1));
      noname2->self = L31;
      noname2->arg1 = L41;
     }
     L8 = INT_downtob_INT_INT(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     j = L8;
     if ((j<l)) {
      LAYOUT_ARR_aset_INT_TUPI(self, l, e);
      goto after_loop1;
     }
     else {
      L9 = LAYOUT_ARR_aget_INT_TUPI(self, j);
      if (LAYOUT_ARR_elt_lt_TUPIDE(self, L9, e)) {
       L10 = (INTPLUS(j,1));
       LAYOUT_ARR_aset_INT_TUPI(self, L10, e);
       goto after_loop1;
      }
      else {
       L12 = (INTPLUS(j,1));
       LAYOUT_ARR_aset_INT_TUPI(self, L12, LAYOUT_ARR_aget_INT_TUPI(self, j));
      }
     }
    }
   }
   after_loop1: ;
  }
 }
 after_loop: ;
}


void LAYOUT_ARR_quicksort_ran(LAYOUT_ARR self, INT l, INT u) {
 INT r = ((INT) 0);
 TUPIDENTdTP t = TUPIDENTdTP_zero;
 INT m = ((INT) 0);
 INT L11 = ((INT) 0);
 INT L21 = ((INT) 0);
 INT i = ((INT) 0);
 TUPIDENTdTP s = TUPIDENTdTP_zero;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 
 TUPIDENTdTP L8;
 INT L9;
 INT L10;
 INT L12;
 L3 = (INTMINUS(u,l));
 L4 = LAYOUT_ARR_quicksort_lim;
 if ((L3>L4)) {
  r = RND_int_INT_INT_INT(((RND) NULL), l, u);
  t = LAYOUT_ARR_aget_INT_TUPI(self, r);
  LAYOUT_ARR_aset_INT_TUPI(self, r, LAYOUT_ARR_aget_INT_TUPI(self, l));
  LAYOUT_ARR_aset_INT_TUPI(self, l, t);
  m = l;
  {
   BOOL noname1 = TRUE;
   while (1) {
    if (noname1) {
     noname1 = FALSE;
     L11 = (INTPLUS(l,1));
     L21 = u;
     L6 = L11;
     L7 = L21;
     L5 = L6;
    } else {
     L5++;
    }
    if (L5>L7) goto after_loop;
    i = L5;
    L8 = LAYOUT_ARR_aget_INT_TUPI(self, i);
    if (LAYOUT_ARR_elt_lt_TUPIDE(self, L8, t)) {
     m = (INTPLUS(m,1));
     s = LAYOUT_ARR_aget_INT_TUPI(self, m);
     LAYOUT_ARR_aset_INT_TUPI(self, m, LAYOUT_ARR_aget_INT_TUPI(self, i));
     LAYOUT_ARR_aset_INT_TUPI(self, i, s);
    }
   }
  }
  after_loop: ;
  t = LAYOUT_ARR_aget_INT_TUPI(self, l);
  LAYOUT_ARR_aset_INT_TUPI(self, l, LAYOUT_ARR_aget_INT_TUPI(self, m));
  LAYOUT_ARR_aset_INT_TUPI(self, m, t);
  L9 = (INTMINUS(m,1));
  if ((l<L9)) {
   LAYOUT_ARR_quicksort_ran(self, l, (INTMINUS(m,1)));
  }
  L10 = (INTPLUS(m,1));
  if ((L10<u)) {
   L12 = (INTPLUS(m,1));
   LAYOUT_ARR_quicksort_ran(self, L12, u);
  }
 }
 else {
  LAYOUT_ARR_insertion_sor(self, l, u);
 }
}


void LAYOUT_ARR_setb_TUPIDENT(LAYOUT_ARR_setb_TUPIDENT_frame frame) {
 BOOL L1;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 L1 = (frame->self==((LAYOUT_ARR) NULL));
 if ((!(L1))) {
  {
   frame->nested1
    = ALLOCATE(LAYOUT_ARR_asetb_TUPIDEN_frame);
   frame->nested1->state = 0;
   while (1) {
    if (frame->nested1->state == 0) {
     frame->L21 = frame->self;
     frame->nested1->self = frame->L21;
    }
    frame->nested1->arg1 = frame->arg1;
    LAYOUT_ARR_asetb_TUPIDEN(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    /* No return value from iter call */;
    frame->state = 1;
    return;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 frame->state = -1;
 return;
}


void LAYOUT_ARR_sort(LAYOUT_ARR self) {
 BOOL L1;
 INT L2;
 L1 = (self==((LAYOUT_ARR) NULL));
 if ((!(L1))) {
  L2 = (ASIZE(self));
  LAYOUT_ARR_quicksort_ran(self, 0, (INTMINUS(L2,1)));
 }
}


void LAYOUT_TBL_add_dTP_dLAYO(LAYOUT_TBL self, dTP t, dLAYOUT l) {
 LAYOUT_TBL_layout_tbl_FM(self, FMAPdTPdLAYOUT_insert_dT(LAYOUT_TBL_layout_tbl, t, l));
}


void LAYOUT_TBL_cgen_CGEN(LAYOUT_TBL self, CGEN cgen) {
 LAYOUT_TBL_cgen = cgen;
}


void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL self, FMAPdTPdLAYOUT layout_tbl) {
 LAYOUT_TBL_layout_tbl = layout_tbl;
}


void MANGLE_barf_STR(MANGLE self, STR msg1) {
 PROG_barf_STR(ATTR(self,prog1), msg1);
}


void MANGLE_dispose_namespace(MANGLE self, OB ns) {
 SATTR(self,namespaces,FMAPdOBNAMESPACE_delete_(ATTR(self,namespaces), ns));
}


void MANGLE_forbid_STR(MANGLE self, STR s) {
 SATTR(self,forbidden,FSETSTR_insert_STR_FSETS(ATTR(self,forbidden), s));
}


void MANGLE_force_mangle_dOB_(MANGLE self, OB ob, STR s, OB ns) {
 NAMESPACE sp;
 STR x;
 extern STR Name;
 STR L1;
 extern STR alreadyinusesamenameinmo;
 extern STR Name;
 STR L2;
 extern STR couldnotbeassignedbythem;
 STR L3;
 sp = MANGLE_space_dOB_NAMESPA(self, ns);
 x = NAMESPACE_get_dOB_STR(sp, ob);
 if ((x==((STR) NULL))) {
  if (NAMESPACE_is_taken_STR_B(sp, s)) {
   L1 = STR_plus_dSTR_STR(((STR) &Name), ((dSTR) s));
   MANGLE_warning_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &alreadyinusesamenameinmo))));
  }
  NAMESPACE_insert_dOB_STR(sp, ob, s);
 }
 else {
  if (STR_is_neq_STR_BOOL(x, s)) {
   L2 = STR_plus_dSTR_STR(((STR) &Name), ((dSTR) s));
   L3 = STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &couldnotbeassignedbythem)));
   MANGLE_barf_STR(self, STR_plus_dSTR_STR(L3, ((dSTR) x)));
  }
 }
}


void MANGLE_warning_STR(MANGLE self, STR s) {
 PROG_warning_STR(ATTR(self,prog1), s);
}


void MS_RANDOM_GEN_init_INT(MS_RANDOM_GEN self, INT nseed) {
 INT L1;
 INT L2;
 INT L3;
 FLTD L4;
 FLTD L5;
 L1 = (INTMINUS(nseed,1));
 L2 = (INTMOD(L1,2147483645));
 SATTR(self,seed,(INTPLUS(1,L2)));
 L3 = (((unsigned)1<<(unsigned)31));
 L4 = (INTFLTD(L3));
 MS_RANDOM_GEN_ms_m_FLTD(self, (L4-1.));
 L5 = MS_RANDOM_GEN_ms_m;
 MS_RANDOM_GEN_ms_md_FLTD(self, (L5-1.));
}


void MS_RANDOM_GEN_ms_md_FLTD(MS_RANDOM_GEN self, FLTD ms_md) {
 MS_RANDOM_GEN_ms_md = ms_md;
}


void NAMEMAP_aset_INT_TUPdOBS(NAMEMAP self, INT ind, TUPdOBSTR val1) {
 SARR(self,ind,val1);
}


void NAMEMAP_asetb_TUPdOBSTR(NAMEMAP_asetb_TUPdOBSTR_frame frame) {
 INT L1;
 INT L3;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 {
  frame->nested1
   = ALLOCATE(INT_timesb_INT_frame);
  frame->nested1->state = 0;
  while (1) {
   if (frame->nested1->state == 0) {
    frame->L21 = (ASIZE(frame->self));
    frame->nested1->self = frame->L21;
   }
   L1 = INT_timesb_INT(frame->nested1);
   if (frame->nested1->state == -1) {
    goto after_loop;
   }
   L3 = L1;
   NAMEMAP_aset_INT_TUPdOBS(frame->self, L3, frame->arg1);
   frame->state = 1;
   return;
   state1:;
  }
 }
 after_loop: ;
 GC_free(frame->nested1); frame->nested1 = NULL;
 frame->state = -1;
 return;
}


void NAMESPACE_insert_dOB_STR(NAMESPACE self, OB ob, STR nm) {
 SATTR(self,map,NAMEMAP_insert_dOB_STR_N(ATTR(self,map), ob, nm));
 SATTR(self,set,FSETSTR_insert_STR_FSETS(ATTR(self,set), nm));
}


void NULL_OPTIMIZE_finalize(NULL_OPTIMIZE self) {
 dBACK_END L1;
 L1 = ATTR(ATTR(self,prog1),back_end);
 if (L1==NULL) {
  FATAL("Dispatch on void in NULL_OPTIMIZE::finalize");
 }
 (*dBACK_END_finalize[TAG(L1)+dBACK_END_finalize_offset])(L1);
}


void NULL_OPTIMIZE_init(NULL_OPTIMIZE self) {
 dBACK_END L1;
 L1 = ATTR(ATTR(self,prog1),back_end);
 if (L1==NULL) {
  FATAL("Dispatch on void in NULL_OPTIMIZE::init");
 }
 (*dBACK_END_init[TAG(L1)+dBACK_END_init_offset])(L1);
}


void NULL_OPTIMIZE_optimize_A(NULL_OPTIMIZE self, AM_ROUT_DEF func) {
 dBACK_END L1;
 L1 = ATTR(ATTR(self,prog1),back_end);
 if (L1==NULL) {
  FATAL("Dispatch on void in NULL_OPTIMIZE::optimize(AM_ROUT_DEF)");
 }
 (*dBACK_END_emit_AM_ROUT_D[TAG(L1)+dBACK_END_emit_AM_ROUT_D_offset])(L1, func);
}


void OUT_flush(OUT self) {
 FILE_flush(FILE_stdout_FILE(((FILE1) NULL)));
}


void OUT_plus_dSTR(OUT self, dSTR s) {
 FILE1 L1;
 L1 = FILE_stdout_FILE(((FILE1) NULL));
 FILE_plus_dSTR(L1, s);
}

/* C for type INLINE_ITER_TBL */




dINLINE_ITER_SIG INLINE_ITER_TBL_elt_nil_(INLINE_ITER_TBL self) {
 dINLINE_ITER_SIG ret_val;
 dINLINE_ITER_SIG t = ((dINLINE_ITER_SIG) NULL);
 if (t==NULL) {
  ret_val = ((dINLINE_ITER_SIG) NULL);
  return ret_val;
 } else
 switch (TAG(t)) {
  default: ;
   ret_val = ((dINLINE_ITER_SIG) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}

/* C for type INLINE_ROUT */




SIG INLINE_ROUT_sig_SIG(INLINE_ROUT self) {
 SIG ret_val;
 ret_val = ATTR(self,signature);
 return ret_val;
}

/* C for type INLINE_ROUT_TBL */




dINLINE_ROUT_SIG INLINE_ROUT_TBL_elt_nil_(INLINE_ROUT_TBL self) {
 dINLINE_ROUT_SIG ret_val;
 dINLINE_ROUT_SIG t = ((dINLINE_ROUT_SIG) NULL);
 if (t==NULL) {
  ret_val = ((dINLINE_ROUT_SIG) NULL);
  return ret_val;
 } else
 switch (TAG(t)) {
  default: ;
   ret_val = ((dINLINE_ROUT_SIG) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}

/* C for type INLINE_VARR_READ */




dAM_EXPR INLINE_VARR_READ_inline_(INLINE_VARR_READ self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}

/* C for type INLINE_VARR_WRITE */




dAM_EXPR INLINE_VARR_WRITE_inline(INLINE_VARR_WRITE self, AM_ROUT_CALL_EXPR call11) {
 dAM_EXPR ret_val;
 ret_val = ((dAM_EXPR) call11);
 return ret_val;
}

/* C for type INLINE_VATTR_WRITE */




void INLINE_VATTR_WRITE_inlin(INLINE_VATTR_WRITE self, INT inlined) {
 INLINE_VATTR_WRITE_inlin1 = inlined;
}

/* C for type INT */




INT INT_timesb_INT(INT_timesb_INT_frame frame) {
 INT dummy = ((INT) 0);
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  }
 state0:;
 frame->r = ((INT) 0);
 while (1) {
  if ((frame->r>=frame->self)) {
   goto after_loop;
  }
  frame->state = 1;
  return frame->r;
  state1:;
  frame->r = (INTPLUS(frame->r,1));
 }
 after_loop: ;
 frame->state = -1;
 return dummy;
}

/* C for type INTI */




INT INTI_asize_INT(INTI self) {
 INT ret_val = ((INT) 0);
  return ASIZE(self);
 FATAL("Last statement wasn't return");
}

/* C for type ITER_INLINE */




ITER_INLINE ITER_INLINE_create_STR_S(ITER_INLINE self, STR s1, STR s2, STR s3, STR s4) {
 ITER_INLINE ret_val;
 ITER_INLINE res;
 ITER_INLINE L1;
 L1 = ((ITER_INLINE) rt_alloc(sizeof(struct ITER_INLINE_struct), ITER_INLINE_tag));
 res = L1;
 SATTR(res,at_decs,s1);
 SATTR(res,when_first_seen,s2);
 SATTR(res,before1,s3);
 SATTR(res,after1,s4);
 ret_val = res;
 return ret_val;
}

/* C for type LAYOUT_ARR */




LAYOUT_ARR LAYOUT_ARR_create_INT_LA(LAYOUT_ARR self, INT n) {
 LAYOUT_ARR ret_val;
 LAYOUT_ARR L1;
 INT L2;
 L2 = n;
 L1 = ((LAYOUT_ARR) rt_arr_alloc(sizeof(struct LAYOUT_ARR_struct), LAYOUT_ARR_tag, sizeof(TUPIDENTdTP) , L2));
 L1->asize = L2;
 ret_val = L1;
 return ret_val;
}

/* C for type LAYOUT_ARRAY */




LAYOUT_ARRAY LAYOUT_ARRAY_create_INT_(LAYOUT_ARRAY self, INT n) {
 LAYOUT_ARRAY ret_val;
 LAYOUT_ARRAY L1;
 INT L2;
 L2 = n;
 L1 = ((LAYOUT_ARRAY) rt_arr_alloc(sizeof(struct LAYOUT_ARRAY_struct), LAYOUT_ARRAY_tag, sizeof(dLAYOUT) , L2));
 L1->asize = L2;
 ret_val = L1;
 return ret_val;
}

/* C for type LAYOUT_TBL */




void LAYOUT_TBL_prog_PROG(LAYOUT_TBL self, PROG prog) {
 LAYOUT_TBL_prog = prog;
}

/* C for type MANGLE */




NAMESPACE MANGLE_space_dOB_NAMESPA(MANGLE self, OB ns) {
 NAMESPACE ret_val;
 NAMESPACE r;
 r = FMAPdOBNAMESPACE_get_dOB(ATTR(self,namespaces), ns);
 if ((r==((NAMESPACE) NULL))) {
  r = NAMESPACE_create_NAMESPA(((NAMESPACE) NULL));
  SATTR(self,namespaces,FMAPdOBNAMESPACE_insert_1(ATTR(self,namespaces), ns, r));
 }
 ret_val = r;
 return ret_val;
}

/* C for type MS_RANDOM_GEN */




void MS_RANDOM_GEN_ms_m_FLTD(MS_RANDOM_GEN self, FLTD ms_m) {
 MS_RANDOM_GEN_ms_m = ms_m;
}

/* C for type NAMEMAP */




NAMEMAP NAMEMAP_create_NAMEMAP(NAMEMAP self) {
 NAMEMAP ret_val;
 ret_val = ((NAMEMAP) NULL);
 return ret_val;
}

/* C for type NAMESPACE */




NAMESPACE NAMESPACE_create_NAMESPA(NAMESPACE self) {
 NAMESPACE ret_val;
 NAMESPACE r;
 NAMESPACE L1;
 L1 = ((NAMESPACE) rt_alloc(sizeof(struct NAMESPACE_struct), NAMESPACE_tag));
 r = L1;
 SATTR(r,map,NAMEMAP_create_NAMEMAP(((NAMEMAP) NULL)));
 SATTR(r,set,FSETSTR_create_FSETSTR(((FSETSTR) NULL)));
 SATTR(r,counter1,0);
 SATTR(r,uniques,FMAPSTRINT_create_FMAPST(((FMAPSTRINT) NULL)));
 ret_val = r;
 return ret_val;
}

/* C for type NULL_OPTIMIZE */




NULL_OPTIMIZE NULL_OPTIMIZE_create_PRO(NULL_OPTIMIZE self, PROG p) {
 NULL_OPTIMIZE ret_val;
 NULL_OPTIMIZE r;
 NULL_OPTIMIZE L1;
 L1 = ((NULL_OPTIMIZE) rt_alloc(sizeof(struct NULL_OPTIMIZE_struct), NULL_OPTIMIZE_tag));
 r = L1;
 SATTR(r,prog1,p);
 ret_val = r;
 return ret_val;
}

/* C for type OUT */




OUT OUT_create_OUT(OUT self) {
 OUT ret_val;
 ret_val = self;
 return ret_val;
}
