#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_CONST_struct {
 OB_HEADER header;
 } *dAM_CONST;

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dAS_CLASS_ELT_struct {
 OB_HEADER header;
 } *dAS_CLASS_ELT;

typedef struct dAS_EXPR_struct {
 OB_HEADER header;
 } *dAS_EXPR;

typedef struct dAS_STMT_struct {
 OB_HEADER header;
 } *dAS_STMT;

typedef struct dCALL_TP_struct {
 OB_HEADER header;
 } *dCALL_TP;

typedef struct dPARSE_struct {
 OB_HEADER header;
 } *dPARSE;

typedef struct dPROG_ERR_struct {
 OB_HEADER header;
 } *dPROG_ERR;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ARRAYdAM_EXPR_struct {/* layout for ARRAY{$AM_EXPR} */
 OB_HEADER header;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *ARRAYdAM_EXPR;

typedef struct ARRAYdCALL_TP_struct {/* layout for ARRAY{$CALL_TP} */
 OB_HEADER header;
 INT asize;
 struct dCALL_TP_struct *arr_part[1];
 } *ARRAYdCALL_TP;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;

typedef struct BOUND_OBJECT_LAYOUT_struct {/* layout for BOUND_OBJECT_LAYOUT */
 OB_HEADER header;
 struct AM_BND_CREATE_EXPR_struct *e11;
 STR str1;
 } *BOUND_OBJECT_LAYOUT;

typedef struct ELT_struct {/* layout for ELT */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *as1;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 BOOL is_private1;
 } *ELT;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;


typedef struct INT_upb_INT_frame_struct {
 INT self;/* Formal argument: self */
 INT state;
 INT ret_val;
 INT r;
 } *INT_upb_INT_frame;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct PROG_AS_TBL_struct {/* layout for PROG_AS_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_CLASS_DEF_struct *arr_part[1];
 } *PROG_AS_TBL;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_CONTEXT_struct {/* layout for TP_CONTEXT */
 OB_HEADER header;
 struct ARRAYdTP_struct *ptypes1;
 struct ARRAYIDENT_struct *pnames1;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *same11;
 BOOL is_abs;
 } *TP_CONTEXT;

typedef struct TP_GRAPH_struct {/* layout for TP_GRAPH */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_GRAPH_ANC_struct *anc;
 struct TP_GRAPH_DES_struct *des1;
 } *TP_GRAPH;

typedef struct TP_GRAPH_ABS_DES_struct {/* layout for TP_GRAPH_ABS_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *tbl;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *dollar_lock1;
 struct TP_CLASS_struct *gate1;
 struct TP_CLASS_struct *mutex1;
 } *TP_GRAPH_ABS_DES;

typedef struct TP_GRAPH_ANC_struct {/* layout for TP_GRAPH_ANC */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *anc_tbl;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *par_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_ANC;

typedef struct TP_GRAPH_DES_struct {/* layout for TP_GRAPH_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *child_tbl;
 struct FMAPTP_CLASSFSETdTP_struct *des_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_DES;

typedef struct TP_TBL_struct {/* layout for TP_TBL */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_CLASS_TBL_struct *class_tbl;
 struct TP_ITER_TBL_struct *iter_tbl;
 struct TP_ROUT_TBL_struct *rout_tbl;
 } *TP_TBL;

typedef struct TRANS_struct {/* layout for TRANS */
 OB_HEADER header;
 struct dAM_STMT_struct *cur_lock;
 struct dAM_STMT_struct *init_stmts;
 struct dTP_struct *ex_tp;
 struct AM_INVARIANT_STMT_struct *inv_stmt;
 struct AM_LOCAL_EXPR_struct *cur_cohort;
 struct AM_LOCAL_EXPR_struct *cur_par_ob;
 struct AM_LOCAL_EXPR_struct *cur_param_ob;
 struct AM_LOOP_STMT_struct *cur_loop;
 struct AM_POST_STMT_struct *post_stmt;
 struct AM_ROUT_DEF_struct *cur_rout;
 struct FLISTAM_LOCAL_EXPR_struct *active_locals;
 struct IMPL_struct *impl1;
 INT cur_yield_ind;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *tp_con;
 BOOL in_constant;
 BOOL in_external;
 BOOL in_initial;
 BOOL in_invariant;
 BOOL in_post;
 BOOL in_pre;
 BOOL in_protect_body;
 BOOL in_protect_then;
 } *TRANS;

typedef struct TUPAM_BND_CREATE_EXPRAM__struct {/* layout for TUP{AM_BND_CREATE_EXPR,AM_BND_CREATE_EXPR} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct AM_BND_CREATE_EXPR_struct *t2;
 } TUPAM_BND_CREATE_EXPRAM_;
static TUPAM_BND_CREATE_EXPRAM_ TUPAM_BND_CREATE_EXPRAM__zero;

typedef struct TUPAM_BND_CREATE_EXPRAM__boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRAM_ value_part;
 } *TUPAM_BND_CREATE_EXPRAM__boxed;

typedef struct TUPAM_BND_CREATE_EXPRBOU_struct {/* layout for TUP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct BOUND_OBJECT_LAYOUT_struct *t2;
 } TUPAM_BND_CREATE_EXPRBOU;
static TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU_zero;

typedef struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRBOU value_part;
 } *TUPAM_BND_CREATE_EXPRBOU_boxed;

typedef struct TUPAM_BND_ITER_CALL_EXPR_struct {/* layout for TUP{AM_BND_ITER_CALL_EXPR,AM_BND_ITER_CALL_EXPR} */
 struct AM_BND_ITER_CALL_EXPR_struct *t1;
 struct AM_BND_ITER_CALL_EXPR_struct *t2;
 } TUPAM_BND_ITER_CALL_EXPR;
static TUPAM_BND_ITER_CALL_EXPR TUPAM_BND_ITER_CALL_EXPR_zero;

typedef struct TUPAM_BND_ITER_CALL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_ITER_CALL_EXPR value_part;
 } *TUPAM_BND_ITER_CALL_EXPR_boxed;

typedef struct TUPAM_GLOBAL_EXPRAM_GLOB_struct {/* layout for TUP{AM_GLOBAL_EXPR,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t1;
 struct AM_GLOBAL_EXPR_struct *t2;
 } TUPAM_GLOBAL_EXPRAM_GLOB;
static TUPAM_GLOBAL_EXPRAM_GLOB TUPAM_GLOBAL_EXPRAM_GLOB_zero;

typedef struct TUPAM_GLOBAL_EXPRAM_GLOB_boxed_struct {
 OB_HEADER header;
 TUPAM_GLOBAL_EXPRAM_GLOB value_part;
 } *TUPAM_GLOBAL_EXPRAM_GLOB_boxed;

typedef struct TUPAM_ITER_CALL_EXPRAM_I_struct {/* layout for TUP{AM_ITER_CALL_EXPR,AM_ITER_CALL_EXPR} */
 struct AM_ITER_CALL_EXPR_struct *t1;
 struct AM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ITER_CALL_EXPRAM_I;
static TUPAM_ITER_CALL_EXPRAM_I TUPAM_ITER_CALL_EXPRAM_I_zero;

typedef struct TUPAM_ITER_CALL_EXPRAM_I_boxed_struct {
 OB_HEADER header;
 TUPAM_ITER_CALL_EXPRAM_I value_part;
 } *TUPAM_ITER_CALL_EXPRAM_I_boxed;

typedef struct AM_ASSERT_STMT_struct {/* layout for AM_ASSERT_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_ASSERT_STMT;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTACH_STMT_struct {/* layout for AM_ATTACH_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_STMT_struct *next1;
 struct AM_LOCAL_EXPR_struct *gate1;
 struct AM_LOCAL_EXPR_struct *helper;
 struct SFILE_ID_struct source11;
 struct SIG_struct *rout1;
 } *AM_ATTACH_STMT;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;

typedef struct AM_BND_ITER_CALL_EXPR_struct {/* layout for AM_BND_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *bi;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ITER_CALL_EXPR;

typedef struct AM_BREAK_STMT_struct {/* layout for AM_BREAK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_BREAK_STMT;

typedef struct AM_CASE_STMT_struct {/* layout for AM_CASE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTFLISTdAM_CONST_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_CASE_STMT;

typedef struct AM_EXPR_STMT_struct {/* layout for AM_EXPR_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_EXPR_STMT;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_IF_STMT_struct {/* layout for AM_IF_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *if_false;
 struct dAM_STMT_struct *if_true;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_IF_STMT;

typedef struct AM_INVARIANT_STMT_struct {/* layout for AM_INVARIANT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 } *AM_INVARIANT_STMT;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_LOCK_STMT_struct {/* layout for AM_LOCK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_LOCK_STMT;

typedef struct AM_LOOP_STMT_struct {/* layout for AM_LOOP_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct SFILE_ID_struct source11;
 BOOL has_yield;
 } *AM_LOOP_STMT;

typedef struct AM_POST_STMT_struct {/* layout for AM_POST_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_POST_STMT;

typedef struct AM_PRE_STMT_struct {/* layout for AM_PRE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_PRE_STMT;

typedef struct AM_PROTECT_STMT_struct {/* layout for AM_PROTECT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_PROTECT_STMT;

typedef struct AM_RAISE_STMT_struct {/* layout for AM_RAISE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RAISE_STMT;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;


typedef struct AM_ROUT_DEF_eltb_INT_AM__frame_struct {
 AM_ROUT_DEF self;/* Formal argument: self */
 INT arg1;/* Formal argument: beg */
 INT state;
 AM_LOCAL_EXPR ret_val;
 AM_ROUT_DEF L21;
 INT L31;
 struct AM_ROUT_DEF_aeltb_INT_AM_frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_DEF_eltb_INT_AM__frame;

typedef struct AM_TRY_STMT_struct {/* layout for AM_TRY_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *then_part1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_TRY_STMT;

typedef struct AM_TYPECASE_STMT_struct {/* layout for AM_TYPECASE_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *void_stmts;
 struct AM_LOCAL_EXPR_struct *test11;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL has_void_stmts;
 BOOL no_else;
 } *AM_TYPECASE_STMT;

typedef struct AM_UNCAUGHT_STMT_struct {/* layout for AM_UNCAUGHT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNCAUGHT_STMT;

typedef struct AM_UNLOCK_STMT_struct {/* layout for AM_UNLOCK_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *lock1;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNLOCK_STMT;

typedef struct AM_WITH_NEAR_STMT_struct {/* layout for AM_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *near_part;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *objects1;
 struct SFILE_ID_struct source11;
 } *AM_WITH_NEAR_STMT;

typedef struct AM_YIELD_STMT_struct {/* layout for AM_YIELD_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 INT ret1;
 struct SFILE_ID_struct source11;
 } *AM_YIELD_STMT;

typedef struct AS_ARG_DEC_struct {/* layout for AS_ARG_DEC */
 OB_HEADER header;
 struct AS_ARG_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_ARG_DEC;

typedef struct AS_ASSERT_STMT_struct {/* layout for AS_ASSERT_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_ASSERT_STMT;

typedef struct AS_ASSIGN_STMT_struct {/* layout for AS_ASSIGN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs_expr;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_ASSIGN_STMT;

typedef struct AS_ATTACH_STMT_struct {/* layout for AS_ATTACH_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL dont_print;
 BOOL transformed;
 } *AS_ATTACH_STMT;

typedef struct AS_ATTR_DEF_struct {/* layout for AS_ATTR_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_ATTR_DEF;

typedef struct AS_AT_EXPR_struct {/* layout for AS_AT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_AT_EXPR;

typedef struct AS_CALL_EXPR_struct {/* layout for AS_CALL_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *args1;
 struct dAS_EXPR_struct *next;
 struct dAS_EXPR_struct *ob1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_array;
 } *AS_CALL_EXPR;

typedef struct AS_CASE_STMT_struct {/* layout for AS_CASE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_CASE_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_CASE_STMT;

typedef struct AS_CASE_WHEN_struct {/* layout for AS_CASE_WHEN */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct AS_CASE_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 } *AS_CASE_WHEN;

typedef struct AS_CLASS_DEF_struct {/* layout for AS_CLASS_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *body;
 struct AS_CLASS_DEF_struct *next;
 struct AS_PARAM_DEC_struct *params1;
 struct AS_TYPE_SPEC_struct *over;
 struct AS_TYPE_SPEC_struct *under;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 } *AS_CLASS_DEF;

typedef struct AS_CONST_DEF_struct {/* layout for AS_CONST_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_CONST_DEF;

typedef struct AS_CREATE_EXPR_struct {/* layout for AS_CREATE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *elts;
 struct dAS_EXPR_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_CREATE_EXPR;

typedef struct AS_DEC_STMT_struct {/* layout for AS_DEC_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_DEC_STMT;

typedef struct AS_EXPR_STMT_struct {/* layout for AS_EXPR_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_EXPR_STMT;

typedef struct AS_FORK_STMT_struct {/* layout for AS_FORK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_FORK_STMT;

typedef struct AS_IDENT_LIST_struct {/* layout for AS_IDENT_LIST */
 OB_HEADER header;
 struct AS_IDENT_LIST_struct *next;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 } *AS_IDENT_LIST;

typedef struct AS_IF_STMT_struct {/* layout for AS_IF_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_IF_STMT;

typedef struct AS_INTERF_ATTACH_STMT_struct {/* layout for AS_INTERF_ATTACH_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct gatename;
 struct IDENT_struct helpername;
 struct IDENT_struct routname1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_INTERF_ATTACH_STMT;

typedef struct AS_INT_LIT_EXPR_struct {/* layout for AS_INT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 BOOL is_inti;
 } *AS_INT_LIT_EXPR;

typedef struct AS_LOCK_STMT_struct {/* layout for AS_LOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_LOCK_STMT;

typedef struct AS_LOOP_STMT_struct {/* layout for AS_LOOP_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_LOOP_STMT;

typedef struct AS_NEW_EXPR_struct {/* layout for AS_NEW_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *arg1;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_NEW_EXPR;

typedef struct AS_PARAM_DEC_struct {/* layout for AS_PARAM_DEC */
 OB_HEADER header;
 struct AS_PARAM_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *type_constraint;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 } *AS_PARAM_DEC;

typedef struct AS_PAR_STMT_struct {/* layout for AS_PAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_PAR_STMT;

typedef struct AS_PROTECT_STMT_struct {/* layout for AS_PROTECT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_PROTECT_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_PROTECT_STMT;

typedef struct AS_PROTECT_WHEN_struct {/* layout for AS_PROTECT_WHEN */
 OB_HEADER header;
 struct AS_PROTECT_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_PROTECT_WHEN;

typedef struct AS_QUIT_STMT_struct {/* layout for AS_QUIT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_QUIT_STMT;

typedef struct AS_RAISE_STMT_struct {/* layout for AS_RAISE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RAISE_STMT;

typedef struct AS_RETURN_STMT_struct {/* layout for AS_RETURN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RETURN_STMT;

typedef struct AS_ROUT_DEF_struct {/* layout for AS_ROUT_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *post_e;
 struct dAS_EXPR_struct *pre_e;
 struct AS_ARG_DEC_struct *args_dec;
 struct AS_STMT_LIST_struct *body;
 struct AS_TYPE_SPEC_struct *ret_dec;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL is_private;
 } *AS_ROUT_DEF;

typedef struct AS_SHARED_DEF_struct {/* layout for AS_SHARED_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_SHARED_DEF;

typedef struct AS_STMT_LIST_struct {/* layout for AS_STMT_LIST */
 OB_HEADER header;
 struct dAS_STMT_struct *stmts;
 struct SFILE_ID_struct source11;
 } *AS_STMT_LIST;

typedef struct AS_TRY_STMT_struct {/* layout for AS_TRY_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_TRY_STMT;

typedef struct AS_TYPECASE_STMT_struct {/* layout for AS_TYPECASE_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_TYPECASE_WHEN_struct *when_part;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed1;
 } *AS_TYPECASE_STMT;

typedef struct AS_TYPECASE_WHEN_struct {/* layout for AS_TYPECASE_WHEN */
 OB_HEADER header;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPECASE_WHEN_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_TYPECASE_WHEN;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct AS_UNCAUGHT_STMT_struct {/* layout for AS_UNCAUGHT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_UNCAUGHT_STMT;

typedef struct AS_UNLOCK_STMT_struct {/* layout for AS_UNLOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_UNLOCK_STMT;

typedef struct AS_WITH_NEAR_STMT_struct {/* layout for AS_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_IDENT_LIST_struct *idents;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *near_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 INT elts_size;
 struct SFILE_ID_struct source11;
 BOOL self_occurred;
 BOOL transformed1;
 } *AS_WITH_NEAR_STMT;

typedef struct AS_YIELD_STMT_struct {/* layout for AS_YIELD_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_YIELD_STMT;

typedef struct CALL_SIG_struct {/* layout for CALL_SIG */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ARRAYdCALL_TP_struct *args1;
 struct IDENT_struct name1;
 BOOL has_ret;
 BOOL unknown_ret;
 } *CALL_SIG;

typedef struct ELT_TBL_struct {/* layout for ELT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ELT_struct *arr_part[1];
 } *ELT_TBL;


typedef struct ELT_TBL_eltb_ELT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 INT state;
 ELT ret_val;
 ELT_TBL L31;
 ELT r;
 struct ELT_TBL_aeltb_ELT_frame_struct *nested1; /* nested iter frame */
 } *ELT_TBL_eltb_ELT_frame;


typedef struct ELT_TBL_get_queryb_IDENT_frame_struct {
 ELT_TBL self;/* Formal argument: self */
 IDENT arg1;/* Formal argument: q */
 INT state;
 ELT ret_val;
 INT h;
 ELT e;
 ELT e1;
 } *ELT_TBL_get_queryb_IDENT_frame;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;

typedef struct FLISTdAM_STMT_struct {/* layout for FLIST{$AM_STMT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_STMT_struct *arr_part[1];
 } *FLISTdAM_STMT;

typedef struct FLISTdTP_struct {/* layout for FLIST{$TP} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FLISTdTP;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FLISTFLISTdAM_CONST_struct {/* layout for FLIST{FLIST{$AM_CONST}} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FLISTdAM_CONST_struct *arr_part[1];
 } *FLISTFLISTdAM_CONST;

typedef struct FLISTIDENT_struct {/* layout for FLIST{IDENT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FLISTIDENT;


typedef struct FLISTIDENT_eltb_IDENT_frame_struct {
 FLISTIDENT self;/* Formal argument: self */
 INT state;
 IDENT ret_val;
 FLISTIDENT L31;
 INT L41;
 INT L51;
 struct FLISTIDENT_aeltb_INT_INT_frame_struct *nested1; /* nested iter frame */
 } *FLISTIDENT_eltb_IDENT_frame;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;

typedef struct FSETTP_CLASS_struct {/* layout for FSET{TP_CLASS} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_CLASS_struct *arr_part[1];
 } *FSETTP_CLASS;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;


typedef struct TRANS_active_locals_and__frame_struct {
 TRANS self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 AM_ROUT_DEF L31;
 INT L41;
 FLISTAM_LOCAL_EXPR L71;
 AM_LOCAL_EXPR loc;
 struct AM_ROUT_DEF_eltb_INT_AM__frame_struct *nested1; /* nested iter frame */
 struct FLISTAM_LOCAL_EXPR_eltb__frame_struct *nested2; /* nested iter frame */
 } *TRANS_active_locals_and__frame;

#include "tags.h"

/* Globals */

extern BOOL TRANS_do_direct_export;
extern BOOL TRANS_do_helper_export;
extern BOOL TRANS_do_helper_import;
extern IDENT IDENT_BUILTIN_is_eq_iden1;
extern IDENT IDENT_BUILTIN_ret_ident;
extern IDENT IDENT_BUILTIN_self_ident1;
extern INT AS_CLASS_DEF_ref;
extern INT AS_TYPE_SPEC_same;
extern INT TP_KIND_ref_tp;
extern INT TP_KIND_spr_tp;
extern INT TRANS_att_code;
extern INT TRANS_export_code;
extern INT TRANS_frk_code;
extern INT TRANS_import_code;
extern INT TRANS_par_code;
extern TP_CLASS TP_BUILTIN_bool;
extern TP_CLASS TP_BUILTIN_dollar_lock;
extern TP_CLASS TP_BUILTIN_dollar_ob;
extern TP_CLASS TP_BUILTIN_int;

/* Function declarations */

AM_ASSERT_STMT AM_ASSERT_STMT_create_SF(AM_ASSERT_STMT, SFILE_ID);
AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT, SFILE_ID);
AM_ATTACH_STMT AM_ATTACH_STMT_create_SF(AM_ATTACH_STMT, SFILE_ID);
AM_BREAK_STMT AM_BREAK_STMT_create_SFI(AM_BREAK_STMT, SFILE_ID);
AM_CASE_STMT AM_CASE_STMT_create_SFIL(AM_CASE_STMT, SFILE_ID);
AM_EXPR_STMT AM_EXPR_STMT_create_SFIL(AM_EXPR_STMT, SFILE_ID);
AM_IF_STMT AM_IF_STMT_create_SFILE_(AM_IF_STMT, SFILE_ID);
AM_INVARIANT_STMT AM_INVARIANT_STMT_copy_A(AM_INVARIANT_STMT);
AM_INVARIANT_STMT AM_INVARIANT_STMT_create(AM_INVARIANT_STMT, SFILE_ID);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI(AM_LOCAL_EXPR, SFILE_ID, IDENT, dTP, AS_TYPE_SPEC);
AM_LOCAL_EXPR AM_LOCAL_EXPR_create_SFI1(AM_LOCAL_EXPR, SFILE_ID, IDENT, dTP);
AM_LOCAL_EXPR AM_ROUT_DEF_aget_INT_AM_(AM_ROUT_DEF, INT);
AM_LOCAL_EXPR AM_ROUT_DEF_eltb_INT_AM_(AM_ROUT_DEF_eltb_INT_AM__frame);
AM_LOCAL_EXPR AM_ROUT_DEF_self_local_A(AM_ROUT_DEF);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_aget_(FLISTAM_LOCAL_EXPR, INT);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_pop_A(FLISTAM_LOCAL_EXPR);
AM_LOCAL_EXPR TRANS_active_locals_and_(TRANS_active_locals_and__frame);
AM_LOCAL_EXPR TRANS_create_helper_obje(TRANS, dAS_STMT, IDENT, IDENT, AS_CLASS_DEF, ARRAYdTP);
AM_LOCAL_EXPR TRANS_last_declared_help(TRANS);
AM_LOCAL_EXPR TRANS_last_declared_par_(TRANS);
AM_LOCAL_EXPR TRANS_local_with_name_ID(TRANS, IDENT);
AM_LOCK_STMT AM_LOCK_STMT_create_SFIL(AM_LOCK_STMT, SFILE_ID);
AM_LOOP_STMT AM_LOOP_STMT_create_SFIL(AM_LOOP_STMT, SFILE_ID);
AM_POST_STMT AM_POST_STMT_copy_AM_POS(AM_POST_STMT);
AM_POST_STMT AM_POST_STMT_create_SFIL(AM_POST_STMT, SFILE_ID);
AM_PRE_STMT AM_PRE_STMT_create_SFILE(AM_PRE_STMT, SFILE_ID);
AM_PROTECT_STMT AM_PROTECT_STMT_create_S(AM_PROTECT_STMT, SFILE_ID);
AM_RAISE_STMT AM_RAISE_STMT_create_SFI(AM_RAISE_STMT, SFILE_ID);
AM_RETURN_STMT AM_RETURN_STMT_create_SF(AM_RETURN_STMT, SFILE_ID);
AM_ROUT_CALL_EXPR AM_ROUT_CALL_EXPR_create(AM_ROUT_CALL_EXPR, INT, SFILE_ID);
AM_ROUT_DEF AM_ROUT_DEF_create_INT_S(AM_ROUT_DEF, INT, SFILE_ID);
AM_ROUT_DEF TRANS_transform_attr_elt(TRANS, ELT, AS_ATTR_DEF);
AM_ROUT_DEF TRANS_transform_const_el(TRANS, ELT, AS_CONST_DEF);
AM_ROUT_DEF TRANS_transform_elt_ELT_(TRANS, ELT);
AM_ROUT_DEF TRANS_transform_rout_elt(TRANS, ELT, AS_ROUT_DEF);
AM_ROUT_DEF TRANS_transform_shared_e(TRANS, ELT, AS_SHARED_DEF);
AM_TRY_STMT AM_TRY_STMT_create_SFILE(AM_TRY_STMT, SFILE_ID);
AM_TYPECASE_STMT AM_TYPECASE_STMT_create_(AM_TYPECASE_STMT, SFILE_ID);
AM_UNCAUGHT_STMT AM_UNCAUGHT_STMT_create_(AM_UNCAUGHT_STMT, SFILE_ID);
AM_UNLOCK_STMT AM_UNLOCK_STMT_create_SF(AM_UNLOCK_STMT, SFILE_ID);
AM_WITH_NEAR_STMT AM_WITH_NEAR_STMT_create(AM_WITH_NEAR_STMT, SFILE_ID);
AM_YIELD_STMT AM_YIELD_STMT_create_SFI(AM_YIELD_STMT, SFILE_ID);
ARRAYdAM_EXPR ARRAYdAM_EXPR_create_INT(ARRAYdAM_EXPR, INT);
ARRAYdCALL_TP ARRAYdCALL_TP_create_INT(ARRAYdCALL_TP, INT);
AS_ARG_DEC AS_ARG_DEC_create_AS_ARG(AS_ARG_DEC);
AS_ASSIGN_STMT AS_ASSIGN_STMT_create_AS(AS_ASSIGN_STMT);
AS_ASSIGN_STMT TRANS_create_helper_obje1(TRANS, IDENT, IDENT, AS_CLASS_DEF, AS_STMT_LIST, SFILE_ID);
AS_ASSIGN_STMT TRANS_link_helper_stmt_I(TRANS, IDENT, AS_STMT_LIST, SFILE_ID);
AS_ATTR_DEF AS_ATTR_DEF_create_AS_AT(AS_ATTR_DEF);
AS_CALL_EXPR AS_CALL_EXPR_create_AS_C(AS_CALL_EXPR);
AS_CALL_EXPR TRANS_as_of_local_in_hel(TRANS, IDENT, AM_LOCAL_EXPR, SFILE_ID);
AS_CLASS_DEF AS_CLASS_DEF_create_AS_C(AS_CLASS_DEF);
AS_CREATE_EXPR AS_CREATE_EXPR_create_AS(AS_CREATE_EXPR);
AS_DEC_STMT AS_DEC_STMT_create_AS_DE(AS_DEC_STMT);
AS_EXPR_STMT AS_EXPR_STMT_create_AS_E(AS_EXPR_STMT);
AS_INTERF_ATTACH_STMT AS_INTERF_ATTACH_STMT_cr(AS_INTERF_ATTACH_STMT);
AS_INT_LIT_EXPR AS_INT_LIT_EXPR_create_A(AS_INT_LIT_EXPR);
AS_LOCK_STMT AS_LOCK_STMT_create_AS_L(AS_LOCK_STMT);
AS_NEW_EXPR AS_NEW_EXPR_create_AS_NE(AS_NEW_EXPR);
AS_PARAM_DEC AS_PARAM_DEC_create_AS_P(AS_PARAM_DEC);
AS_PROTECT_STMT AS_PROTECT_STMT_create_A(AS_PROTECT_STMT);
AS_PROTECT_WHEN AS_PROTECT_WHEN_create_A(AS_PROTECT_WHEN);
AS_RETURN_STMT AS_RETURN_STMT_create_AS(AS_RETURN_STMT);
AS_ROUT_DEF AS_ROUT_DEF_create_AS_RO(AS_ROUT_DEF);
AS_ROUT_DEF TRANS_turn_into_routine_(TRANS, IDENT, IDENT, IDENT, AM_LOCAL_EXPR, AS_CLASS_DEF, TP_CLASS, IDENT, AS_TYPE_SPEC, AS_STMT_LIST, INT, SFILE_ID);
AS_STMT_LIST AS_STMT_LIST_create_AS_S(AS_STMT_LIST);
AS_TYPE_SPEC AS_TYPE_SPEC_create_AS_T(AS_TYPE_SPEC);
AS_TYPE_SPEC ELT_as_tp_AS_TYPE_SPEC(ELT);
AS_UNCAUGHT_STMT AS_UNCAUGHT_STMT_create_(AS_UNCAUGHT_STMT);
BOOL AM_ROUT_DEF_export_call_(AM_ROUT_DEF);
BOOL AM_ROUT_DEF_export_local(AM_ROUT_DEF);
BOOL AM_ROUT_DEF_import_call_(AM_ROUT_DEF);
BOOL AM_ROUT_DEF_import_local(AM_ROUT_DEF);
BOOL AM_ROUT_DEF_is_iter_BOOL(AM_ROUT_DEF);
BOOL AM_ROUT_DEF_local_is_hot(AM_ROUT_DEF, AM_LOCAL_EXPR);
BOOL ELT_is_invariant_BOOL(ELT);
BOOL FSETdTP_test_dTP_BOOL(FSETdTP, dTP);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL SIG_has_ret_BOOL(SIG);
BOOL STR_is_eq_STR_BOOL(STR, STR);
BOOL STR_is_neq_STR_BOOL(STR, STR);
BOOL TP_CLASS_is_eq_dTP_BOOL(TP_CLASS, dTP);
BOOL TRANS_contains_iter_call(TRANS, dAM_EXPR);
BOOL TRANS_is_array_sig_SIG_B(TRANS, SIG);
BOOL TRANS_is_in_loop_and_cal(TRANS, dAS_EXPR);
BOOL TRANS_is_in_par_or_fork_(TRANS);
BOOL TRANS_is_in_try_or_lock_(TRANS);
BOOL TRANS_is_iter_BOOL(TRANS);
BOOL TRANS_local_is_in_par_he(TRANS, IDENT, AM_LOCAL_EXPR);
CALL_SIG CALL_SIG_create_CALL_SIG(CALL_SIG);
ELT ELT_TBL_elt_same_name_as(ELT_TBL, ELT);
ELT ELT_TBL_eltb_ELT(ELT_TBL_eltb_ELT_frame);
ELT ELT_TBL_get_queryb_IDENT(ELT_TBL_get_queryb_IDENT_frame);
ELT ELT_create_SIG_SIG_dAS_C(ELT, SIG, SIG, dAS_CLASS_ELT, TP_CONTEXT, BOOL);
ELT_TBL ELT_TBL_insert_ELT_ELT_T(ELT_TBL, ELT);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR, AM_LOCAL_EXPR);
FLISTFLISTdAM_CONST FLISTFLISTdAM_CONST_push(FLISTFLISTdAM_CONST, FLISTdAM_CONST);
FLISTIDENT FLISTIDENT_create_FLISTI(FLISTIDENT);
FLISTIDENT FLISTIDENT_push_IDENT_FL(FLISTIDENT, IDENT);
FLISTIDENT TRANS_name_of_local_in_h(TRANS, IDENT, AM_LOCAL_EXPR);
FLISTdAM_CONST FLISTFLISTdAM_CONST_pop_(FLISTFLISTdAM_CONST);
FLISTdAM_CONST FLISTdAM_CONST_push_dAM_(FLISTdAM_CONST, dAM_CONST);
FLISTdAM_EXPR FLISTdAM_EXPR_push_dAM_E(FLISTdAM_EXPR, dAM_EXPR);
FLISTdAM_STMT FLISTdAM_STMT_push_dAM_S(FLISTdAM_STMT, dAM_STMT);
FLISTdTP FLISTdTP_push_dTP_FLISTd(FLISTdTP, dTP);
FSETTP_CLASS TP_GRAPH_ANC_get_anc_TP_(TP_GRAPH_ANC, TP_CLASS);
FSETdTP FSETdTP_insert_dTP_FSETd(FSETdTP, dTP);
FSETdTP TP_GRAPH_DES_get_des_TP_(TP_GRAPH_DES, TP_CLASS);
IDENT ELT_name_IDENT(ELT);
IDENT FLISTIDENT_aget_INT_IDEN(FLISTIDENT, INT);
IDENT FLISTIDENT_eltb_IDENT(FLISTIDENT_eltb_IDENT_frame);
IDENT IDENT_create_STR_IDENT(IDENT, STR);
IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL, dTP);
INT AM_ROUT_DEF_size_INT(AM_ROUT_DEF);
INT ARRAYdTP_size_INT(ARRAYdTP);
INT AS_ARG_DEC_size_INT(AS_ARG_DEC);
INT AS_LOCK_STMT_elts_size_I(AS_LOCK_STMT);
INT AS_TRY_STMT_elts_size_IN(AS_TRY_STMT);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTIDENT_size_INT(FLISTIDENT);
INT INT_upb_INT(INT_upb_INT_frame);
INT STR_size_INT(STR);
INT TUPAM_BND_CREATE_EXPRAM_1(TUPAM_BND_CREATE_EXPRAM_);
INT TUPAM_BND_CREATE_EXPRBOU1(TUPAM_BND_CREATE_EXPRBOU);
INT TUPAM_BND_ITER_CALL_EXPR1(TUPAM_BND_ITER_CALL_EXPR);
INT TUPAM_GLOBAL_EXPRAM_GLOB1(TUPAM_GLOBAL_EXPRAM_GLOB);
INT TUPAM_ITER_CALL_EXPRAM_I1(TUPAM_ITER_CALL_EXPRAM_I);
INTI INTI_create_INT_INTI(INTI, INT);
PROG_AS_TBL PROG_AS_TBL_insert_AS_CL(PROG_AS_TBL, AS_CLASS_DEF);
SIG CALL_SIG_lookup_BOOL_SIG(CALL_SIG, BOOL);
SIG IMPL_invariant_sig_SIG(IMPL);
SIG SIG_rout_sig_AS_ROUT_DEF(SIG, AS_ROUT_DEF, IDENT, TP_CONTEXT);
STR IDENT_next_tmp_STR_STR(IDENT, STR);
STR STR_head_INT_STR(STR, INT);
STR STR_plus_dSTR_STR(STR, dSTR);
TP_CLASS TP_TBL_tp_class_for_IDEN(TP_TBL, IDENT, ARRAYdTP);
TP_CLASS TRANS_add_helper_to_tbls(TRANS, IDENT, ARRAYdTP);
TRANS TRANS_create_ELT_TRANS(TRANS, ELT);
TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU, AM_BND_CREATE_EXPR, BOUND_OBJECT_LAYOUT);
dAM_CONST TRANS_const_to_switch_dA(TRANS, dAM_EXPR);
dAM_EXPR TRANS_inline_AM_ROUT_CAL(TRANS, AM_ROUT_CALL_EXPR);
dAM_EXPR TRANS_transform_call_exp(TRANS, AS_CALL_EXPR, dTP, BOOL);
dAM_EXPR TRANS_transform_expr_dAS(TRANS, dAS_EXPR, dTP);
dAM_STMT TRANS_transform_array_as(TRANS, AS_CALL_EXPR, AS_ASSIGN_STMT);
dAM_STMT TRANS_transform_array_bo(TRANS, ELT);
dAM_STMT TRANS_transform_assert_s(TRANS, AS_ASSERT_STMT);
dAM_STMT TRANS_transform_assign_d(TRANS, AS_ASSIGN_STMT);
dAM_STMT TRANS_transform_assign_s(TRANS, AS_ASSIGN_STMT);
dAM_STMT TRANS_transform_attach_s(TRANS, AS_ATTACH_STMT);
dAM_STMT TRANS_transform_call_ass(TRANS, AS_CALL_EXPR, AS_ASSIGN_STMT);
dAM_STMT TRANS_transform_case_stm(TRANS, AS_CASE_STMT);
dAM_STMT TRANS_transform_case_whe(TRANS, AS_CASE_STMT, AS_CASE_WHEN, AM_LOCAL_EXPR);
dAM_STMT TRANS_transform_dec_stmt(TRANS, AS_DEC_STMT);
dAM_STMT TRANS_transform_expr_stm(TRANS, AS_EXPR_STMT);
dAM_STMT TRANS_transform_fork_stm(TRANS, AS_FORK_STMT);
dAM_STMT TRANS_transform_if_stmt_(TRANS, AS_IF_STMT);
dAM_STMT TRANS_transform_interf_a(TRANS, AS_INTERF_ATTACH_STMT);
dAM_STMT TRANS_transform_local_as(TRANS, AM_LOCAL_EXPR, AS_ASSIGN_STMT);
dAM_STMT TRANS_transform_lock_stm(TRANS, AS_LOCK_STMT);
dAM_STMT TRANS_transform_loop_stm(TRANS, AS_LOOP_STMT);
dAM_STMT TRANS_transform_pSather_4(TRANS, dAS_STMT);
dAM_STMT TRANS_transform_par_stmt(TRANS, AS_PAR_STMT);
dAM_STMT TRANS_transform_protect_(TRANS, AS_PROTECT_STMT);
dAM_STMT TRANS_transform_quit_stm(TRANS, AS_QUIT_STMT);
dAM_STMT TRANS_transform_raise_st(TRANS, AS_RAISE_STMT);
dAM_STMT TRANS_transform_return_s(TRANS, AS_RETURN_STMT);
dAM_STMT TRANS_transform_stmt_dAS(TRANS, dAS_STMT);
dAM_STMT TRANS_transform_stmt_lis(TRANS, AS_STMT_LIST);
dAM_STMT TRANS_transform_try_stmt(TRANS, AS_TRY_STMT);
dAM_STMT TRANS_transform_typecase(TRANS, AS_TYPECASE_STMT);
dAM_STMT TRANS_transform_uncaught(TRANS, AS_UNCAUGHT_STMT);
dAM_STMT TRANS_transform_unlock_s(TRANS, AS_UNLOCK_STMT);
dAM_STMT TRANS_transform_with_nea(TRANS, AS_WITH_NEAR_STMT);
dAM_STMT TRANS_transform_yield_st(TRANS, AS_YIELD_STMT);
dAS_STMT TRANS_as_for_import_expo(TRANS, INT, AS_STMT_LIST, SFILE_ID);
dAS_STMT TRANS_as_for_sys_import_(TRANS, INT, AS_STMT_LIST, SFILE_ID);
dAS_STMT TRANS_previous_dAS_STMT_(TRANS, dAS_STMT);
dCALL_TP TRANS_call_tp_of_expr_dA(TRANS, dAS_EXPR);
dTP AM_LOCAL_EXPR_tp_dTP(AM_LOCAL_EXPR);
dTP ARRAYdTP_aget_INT_dTP(ARRAYdTP, INT);
dTP ELT_ret_dTP(ELT);
dTP ELT_tp_dTP(ELT);
dTP TRANS_tp_of_AS_TYPE_SPEC(TRANS, AS_TYPE_SPEC);
extern const int dAM_EXPR_tp_dTP_offset;

extern const dTP (*dAM_EXPR_tp_dTP[])(dAM_EXPR);
extern const int dAM_STMT_append_dAM_STMT_offset;

extern const  (*dAM_STMT_append_dAM_STMT[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT1_offset;

extern const  (*dAM_STMT_next_dAM_STMT1[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT_offset;

extern const dAM_STMT (*dAM_STMT_next_dAM_STMT[])(dAM_STMT);
extern const int dAS_CLASS_ELT_append_dAS_offset;

extern const  (*dAS_CLASS_ELT_append_dAS[])(dAS_CLASS_ELT, dAS_CLASS_ELT);
extern const int dAS_EXPR_next_dAS_EXPR_offset;

extern const dAS_EXPR (*dAS_EXPR_next_dAS_EXPR[])(dAS_EXPR);
extern const int dAS_STMT_append_dAS_STMT_offset;

extern const  (*dAS_STMT_append_dAS_STMT[])(dAS_STMT, dAS_STMT);
extern const int dAS_STMT_next_dAS_STMT1_offset;

extern const  (*dAS_STMT_next_dAS_STMT1[])(dAS_STMT, dAS_STMT);
extern const int dAS_STMT_next_dAS_STMT_offset;

extern const dAS_STMT (*dAS_STMT_next_dAS_STMT[])(dAS_STMT);
extern const int dAS_STMT_source_SFILE_ID1_offset;

extern const SFILE_ID (*dAS_STMT_source_SFILE_ID1[])(dAS_STMT);
extern const int dAS_STMT_surr_stmt_list_1_offset;

extern const AS_STMT_LIST (*dAS_STMT_surr_stmt_list_1[])(dAS_STMT);
extern const int dAS_STMT_transformed_BOO1_offset;

extern const BOOL (*dAS_STMT_transformed_BOO1[])(dAS_STMT);
extern const int dAS_STMT_transformed_BOO_offset;

extern const  (*dAS_STMT_transformed_BOO[])(dAS_STMT, BOOL);
extern const int dPARSE_tree_for_IDENT_IN_offset;

extern const AS_CLASS_DEF (*dPARSE_tree_for_IDENT_IN[])(dPARSE, IDENT, INT);
extern const int dTP_as_AS_TYPE_SPEC_offset;

extern const AS_TYPE_SPEC (*dTP_as_AS_TYPE_SPEC[])(dTP);
extern const int dTP_is_abstract_BOOL_offset;

extern const BOOL (*dTP_is_abstract_BOOL[])(dTP);
extern const int dTP_is_neq_dTP_BOOL_offset;

extern const BOOL (*dTP_is_neq_dTP_BOOL[])(dTP, dTP);
extern const int dTP_is_subtype_dTP_BOOL_offset;

extern const BOOL (*dTP_is_subtype_dTP_BOOL[])(dTP, dTP);
extern const int dTP_kind_INT_offset;

extern const INT (*dTP_kind_INT[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void AM_ROUT_CALL_EXPR_aset_I(AM_ROUT_CALL_EXPR, INT, dAM_EXPR);
void AM_ROUT_DEF_aset_INT_AM_(AM_ROUT_DEF, INT, AM_LOCAL_EXPR);
void AM_ROUT_DEF_export_done(AM_ROUT_DEF);
void AM_ROUT_DEF_import_done(AM_ROUT_DEF);
void AM_ROUT_DEF_needs_import(AM_ROUT_DEF);
void AM_ROUT_DEF_needs_import1(AM_ROUT_DEF);
void ARRAYdAM_EXPR_aset_INT_d(ARRAYdAM_EXPR, INT, dAM_EXPR);
void ARRAYdCALL_TP_aset_INT_d(ARRAYdCALL_TP, INT, dCALL_TP);
void AS_ARG_DEC_append_AS_ARG(AS_ARG_DEC, AS_ARG_DEC);
void AS_PARAM_DEC_append_AS_P(AS_PARAM_DEC, AS_PARAM_DEC);
void AS_TYPE_SPEC_append_AS_T(AS_TYPE_SPEC, AS_TYPE_SPEC);
void PROG_warning_STR(PROG, STR);
void TP_GRAPH_ABS_DES_add_TP_(TP_GRAPH_ABS_DES, TP_CLASS, dTP);
void TRANS_add_local_AM_LOCAL(TRANS, AM_LOCAL_EXPR);
void TRANS_append_export_in_l(TRANS, AS_STMT_LIST, BOOL);
void TRANS_attach_without_gat(TRANS, AS_ATTACH_STMT);
void TRANS_break_not_in_loop_(TRANS, AS_EXPR_STMT);
void TRANS_check_return_AS_RO(TRANS, AS_ROUT_DEF);
void TRANS_err_STR(TRANS, STR);
void TRANS_err_loc_dPROG_ERR(TRANS, dPROG_ERR);
void TRANS_expr_stmt_err_AS_E(TRANS, AS_EXPR_STMT);
void TRANS_extra_return_value(TRANS, AS_RETURN_STMT, SIG);
void TRANS_extra_yield_value_(TRANS, AS_YIELD_STMT, SIG);
void TRANS_fork_outside_par_e(TRANS, AS_FORK_STMT);
void TRANS_insert_import_AS_S(TRANS, AS_STMT_LIST, SFILE_ID);
void TRANS_insert_import_afte(TRANS, dAS_STMT);
void TRANS_missing_return_val(TRANS, AS_RETURN_STMT, dTP);
void TRANS_missing_yield_valu(TRANS, AS_YIELD_STMT, dTP);
void TRANS_prev_export_dAS_ST(TRANS, dAS_STMT, dAS_STMT, AS_STMT_LIST);
void TRANS_quit_in_par_fork_e(TRANS, AS_QUIT_STMT);
void TRANS_quit_in_rout_err_A(TRANS, AS_QUIT_STMT);
void TRANS_return_in_iter_err(TRANS, AS_RETURN_STMT);
void TRANS_return_in_par_fork(TRANS, AS_RETURN_STMT);
void TRANS_stmts_after_quit_e(TRANS, AS_QUIT_STMT);
void TRANS_stmts_after_raise_(TRANS, AS_RAISE_STMT);
void TRANS_stmts_after_return(TRANS, AS_RETURN_STMT);
void TRANS_transform_pSather_1(TRANS, AS_ROUT_DEF);
void TRANS_transform_pSather_2(TRANS, AM_LOCAL_EXPR, AS_ASSIGN_STMT);
void TRANS_transform_pSather_3(TRANS, AS_ASSIGN_STMT);
void TRANS_typecase_hot_local(TRANS, AS_TYPECASE_STMT);
void TRANS_typecase_local_err(TRANS, AS_TYPECASE_STMT);
void TRANS_typecase_no_branch(TRANS, AS_TYPECASE_STMT);
void TRANS_unlock_in_par_fork(TRANS, AS_UNLOCK_STMT);
void TRANS_unlock_outside_try(TRANS, AS_UNLOCK_STMT);
void TRANS_unprotected_raise_(TRANS, AS_RAISE_STMT);
void TRANS_update_routine_in_(TRANS, TP_CLASS, AS_ROUT_DEF);
void TRANS_warning_STR(TRANS, STR);
void TRANS_with_near_locals_o(TRANS, AS_IDENT_LIST);
void TRANS_with_near_non_ref_(TRANS, AS_IDENT_LIST);
void TRANS_yield_in_par_fork_(TRANS, AS_YIELD_STMT);
void TRANS_yield_in_protect_e(TRANS, AS_YIELD_STMT);
void TRANS_yield_in_rout_err_(TRANS, AS_YIELD_STMT);
void TRANS_yield_in_try_lock_(TRANS, AS_YIELD_STMT);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




AM_LOCAL_EXPR TRANS_active_locals_and_(TRANS_active_locals_and__frame frame) {
 AM_LOCAL_EXPR dummy = ((AM_LOCAL_EXPR) NULL);
 INT L1;
 AM_LOCAL_EXPR L2;
 INT L5;
 AM_LOCAL_EXPR L6;
 BOOL L8;
 BOOL L9;
 BOOL L10;
 switch (frame->state) {
  case 0: goto state0;
  case 1: goto state1;
  case 2: goto state2;
  }
 state0:;
 if ((ATTR(frame->self,cur_rout)==((AM_ROUT_DEF) NULL))) {
  frame->state = -1;
  return;
 }
 L1 = (ASIZE(ATTR(frame->self,cur_rout)));
 if ((L1>1)) {
  {
   frame->nested1
    = ALLOCATE(AM_ROUT_DEF_eltb_INT_AM__frame);
   frame->nested1->state = 0;
   while (1) {
    frame->state = 1;
    if (frame->nested1->state == 0) {
     frame->L31 = ATTR(frame->self,cur_rout);
     frame->L41 = 1;
     frame->nested1->self = frame->L31;
     frame->nested1->arg1 = frame->L41;
    }
    L2 = AM_ROUT_DEF_eltb_INT_AM_(frame->nested1);
    if (frame->nested1->state == -1) {
     goto after_loop;
    }
    return L2;
    state1:;
   }
  }
  after_loop: ;
  GC_free(frame->nested1); frame->nested1 = NULL;
 }
 L5 = FLISTAM_LOCAL_EXPR_size_(ATTR(frame->self,active_locals));
 if ((L5>0)) {
  {
   frame->nested2
    = ALLOCATE(FLISTAM_LOCAL_EXPR_eltb__frame);
   frame->nested2->state = 0;
   while (1) {
    if (frame->nested2->state == 0) {
     frame->L71 = ATTR(frame->self,active_locals);
     frame->nested2->self = frame->L71;
    }
    L6 = FLISTAM_LOCAL_EXPR_eltb_(frame->nested2);
    if (frame->nested2->state == -1) {
     goto after_loop1;
    }
    frame->loc = L6;
    L9 = (ATTR(frame->loc,name1).str==(STR)0);
    if ((!(L9))) {
     L10 = (ATTR(frame->loc,tp_at)==((dTP) NULL));
     L8 = (!(L10));
    } else {
     L8 = FALSE;
    }
    if (L8) {
     frame->state = 2;
     return frame->loc;
     state2:;
    }
   }
  }
  after_loop1: ;
  GC_free(frame->nested2); frame->nested2 = NULL;
 }
 frame->state = -1;
 return dummy;
}


AM_LOCAL_EXPR TRANS_create_helper_obje(TRANS self, dAS_STMT s, IDENT newid_ob, IDENT newid_cl, AS_CLASS_DEF current_class_as, ARRAYdTP current_params) {
 AM_LOCAL_EXPR ret_val;
 AS_CLASS_DEF as;
 AS_PARAM_DEC class_param;
 AS_PARAM_DEC pardec;
 TP_CLASS tp;
 TRANS L11;
 AM_LOCAL_EXPR loc;
 AS_ATTR_DEF var;
 AS_TYPE_SPEC tps = ((AS_TYPE_SPEC) NULL);
 AS_ATTR_DEF var1;
 AS_TYPE_SPEC tps1;
 AS_ATTR_DEF var2;
 AS_TYPE_SPEC tps2 = ((AS_TYPE_SPEC) NULL);
 ELT_TBL elts1;
 ELT_TBL L21;
 ELT elt1;
 AS_ATTR_DEF var3;
 AS_TYPE_SPEC tps3 = ((AS_TYPE_SPEC) NULL);
 AS_ROUT_DEF crt;
 AS_TYPE_SPEC ret_dec;
 AS_RETURN_STMT crtbdy;
 AS_NEW_EXPR crtnew;
 IMPL impl;
 TP_CLASS dob;
 FSETTP_CLASS ip1;
 FSETdTP ip2;
 dAS_STMT L3;
 dAS_STMT L4;
 AM_LOCAL_EXPR L5;
 BOOL L6;
 STR L7;
 extern STR S_;
 BOOL L8;
 BOOL L9;
 dAS_STMT L10;
 BOOL L12;
 dTP L13;
 dAS_CLASS_ELT L14;
 BOOL L15;
 STR L16;
 extern STR S_pS_att;
 extern STR CompilerErrPTRANScreateh;
 dAS_STMT L17;
 dAS_STMT L18;
 extern STR GATE1;
 dAS_CLASS_ELT L19;
 BOOL L20;
 dAS_STMT L22;
 BOOL L23;
 dTP L24;
 dAS_CLASS_ELT L25;
 BOOL L26;
 IMPL_TBL L27;
 ELT L28;
 STR L29;
 extern STR S_;
 BOOL L30;
 BOOL L31;
 INT L32;
 STR L33;
 extern STR S_pS_par_;
 dAS_STMT L34;
 BOOL L35;
 dTP L36;
 dAS_CLASS_ELT L37;
 dAS_STMT L38;
 extern STR create1;
 dAS_STMT L39;
 dAS_STMT L40;
 dAS_STMT L41;
 dAS_STMT L42;
 dAS_CLASS_ELT L43;
 dAS_STMT L44;
 SFILE_ID L45;
 as = AS_CLASS_DEF_create_AS_C(((AS_CLASS_DEF) NULL));
 L3 = s;
 if (L3==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(as,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L3)+dAS_STMT_source_SFILE_ID1_offset])(L3));
 SATTR(as,kind,AS_CLASS_DEF_ref);
 SATTR(as,name1,newid_cl);
 class_param = ATTR(current_class_as,params1);
 while (1) {
  if ((class_param==((AS_PARAM_DEC) NULL))) {
   goto after_loop;
  }
  pardec = AS_PARAM_DEC_create_AS_P(((AS_PARAM_DEC) NULL));
  L4 = s;
  if (L4==NULL) {
   FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
  }
  SATTR(pardec,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L4)+dAS_STMT_source_SFILE_ID1_offset])(L4));
  SATTR(pardec,name1,ATTR(class_param,name1));
  if ((ATTR(as,params1)==((AS_PARAM_DEC) NULL))) {
   SATTR(as,params1,pardec);
  }
  else {
   AS_PARAM_DEC_append_AS_P(ATTR(as,params1), pardec);
  }
  class_param = ATTR(class_param,next);
 }
 after_loop: ;
 SATTR(ATTR(self,prog1),as_tbl,PROG_AS_TBL_insert_AS_CL(ATTR(ATTR(self,prog1),as_tbl), as));
 tp = TRANS_add_helper_to_tbls(self, newid_cl, current_params);
 {
  struct TRANS_active_locals_and__frame_struct other2_0;
  TRANS_active_locals_and__frame 
  noname1 = &other2_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L5 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop1;
   }
   loc = L5;
   L7 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L7, ((STR) &S_))) {
    if ((ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL))) {
     L8 = TRUE;
    } else {
     L9 = TRANS_local_is_in_par_he(self, ATTR(loc,name1), ATTR(self,cur_param_ob));
     L8 = (!(L9));
    }
    L6 = L8;
   } else {
    L6 = FALSE;
   }
   if (L6) {
    var = AS_ATTR_DEF_create_AS_AT(((AS_ATTR_DEF) NULL));
    L10 = s;
    if (L10==NULL) {
     FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
    }
    SATTR(var,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L10)+dAS_STMT_source_SFILE_ID1_offset])(L10));
    SATTR(var,name1,ATTR(loc,name1));
    L12 = (ATTR(loc,as_type)==((AS_TYPE_SPEC) NULL));
    if ((!(L12))) {
     tps = ATTR(loc,as_type);
    }
    else {
     L13 = AM_LOCAL_EXPR_tp_dTP(loc);
     if (L13==NULL) {
      FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
     }
     tps = (*dTP_as_AS_TYPE_SPEC[TAG(L13)+dTP_as_AS_TYPE_SPEC_offset])(L13);
    }
    SATTR(var,tp1,tps);
    if ((ATTR(as,body)==((dAS_CLASS_ELT) NULL))) {
     SATTR(as,body,((dAS_CLASS_ELT) var));
    }
    else {
     L14 = ATTR(as,body);
     if (L14==NULL) {
      FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
     }
     (*dAS_CLASS_ELT_append_dAS[TAG(L14)+dAS_CLASS_ELT_append_dAS_offset])(L14, ((dAS_CLASS_ELT) var));
    }
   }
  }
 }
 after_loop1: ;
 if (TRANS_is_in_par_or_fork_(self)) {
  L16 = STR_head_INT_STR(newid_cl.str, 7);
  L15 = STR_is_eq_STR_BOOL(L16, ((STR) &S_pS_att));
 } else {
  L15 = FALSE;
 }
 if (L15) {
  if ((ATTR(self,cur_cohort)==((AM_LOCAL_EXPR) NULL))) {
   TRANS_err_STR(self, ((STR) &CompilerErrPTRANScreateh));
  }
  var1 = AS_ATTR_DEF_create_AS_AT(((AS_ATTR_DEF) NULL));
  L17 = s;
  if (L17==NULL) {
   FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
  }
  SATTR(var1,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L17)+dAS_STMT_source_SFILE_ID1_offset])(L17));
  SATTR(var1,name1,ATTR(ATTR(self,cur_cohort),name1));
  tps1 = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
  L18 = s;
  if (L18==NULL) {
   FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
  }
  SATTR(tps1,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L18)+dAS_STMT_source_SFILE_ID1_offset])(L18));
  SATTR(tps1,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &GATE1)));
  SATTR(var1,tp1,tps1);
  if ((ATTR(as,body)==((dAS_CLASS_ELT) NULL))) {
   SATTR(as,body,((dAS_CLASS_ELT) var1));
  }
  else {
   L19 = ATTR(as,body);
   if (L19==NULL) {
    FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
   }
   (*dAS_CLASS_ELT_append_dAS[TAG(L19)+dAS_CLASS_ELT_append_dAS_offset])(L19, ((dAS_CLASS_ELT) var1));
  }
 }
 L20 = (ATTR(self,cur_par_ob)==((AM_LOCAL_EXPR) NULL));
 if ((!(L20))) {
  var2 = AS_ATTR_DEF_create_AS_AT(((AS_ATTR_DEF) NULL));
  L22 = s;
  if (L22==NULL) {
   FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
  }
  SATTR(var2,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L22)+dAS_STMT_source_SFILE_ID1_offset])(L22));
  SATTR(var2,name1,ATTR(ATTR(self,cur_par_ob),name1));
  L23 = (ATTR(ATTR(self,cur_par_ob),as_type)==((AS_TYPE_SPEC) NULL));
  if ((!(L23))) {
   tps2 = ATTR(ATTR(self,cur_par_ob),as_type);
  }
  else {
   L24 = AM_LOCAL_EXPR_tp_dTP(ATTR(self,cur_par_ob));
   if (L24==NULL) {
    FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
   }
   tps2 = (*dTP_as_AS_TYPE_SPEC[TAG(L24)+dTP_as_AS_TYPE_SPEC_offset])(L24);
  }
  SATTR(var2,tp1,tps2);
  if ((ATTR(as,body)==((dAS_CLASS_ELT) NULL))) {
   SATTR(as,body,((dAS_CLASS_ELT) var2));
  }
  else {
   L25 = ATTR(as,body);
   if (L25==NULL) {
    FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
   }
   (*dAS_CLASS_ELT_append_dAS[TAG(L25)+dAS_CLASS_ELT_append_dAS_offset])(L25, ((dAS_CLASS_ELT) var2));
  }
 }
 else {
  L26 = (ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL));
  if ((!(L26))) {
   L27 = ATTR(ATTR(self,prog1),impl_tbl);
   elts1 = ATTR(IMPL_TBL_impl_of_dTP_IMP(L27, AM_LOCAL_EXPR_tp_dTP(ATTR(self,cur_param_ob))),elts);
   {
    struct ELT_TBL_eltb_ELT_frame_struct other3_0;
    ELT_TBL_eltb_ELT_frame 
    noname2 = &other3_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = elts1;
      noname2->self = L21;
     }
     L28 = ELT_TBL_eltb_ELT(noname2);
     if (noname2->state == -1) {
      goto after_loop2;
     }
     elt1 = L28;
     L29 = STR_head_INT_STR(ELT_name_IDENT(elt1).str, 1);
     if (STR_is_eq_STR_BOOL(L29, ((STR) &S_))) {
      L30 = (ELT_ret_dTP(elt1)==((dTP) NULL));
      if ((!(L30))) {
       L32 = STR_size_INT(ELT_name_IDENT(elt1).str);
       if ((L32>=8)) {
        L33 = STR_head_INT_STR(ELT_name_IDENT(elt1).str, 8);
        L31 = STR_is_eq_STR_BOOL(L33, ((STR) &S_pS_par_));
       } else {
        L31 = FALSE;
       }
       if (L31) {
        var3 = AS_ATTR_DEF_create_AS_AT(((AS_ATTR_DEF) NULL));
        L34 = s;
        if (L34==NULL) {
         FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
        }
        SATTR(var3,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L34)+dAS_STMT_source_SFILE_ID1_offset])(L34));
        SATTR(var3,name1,ELT_name_IDENT(elt1));
        L35 = (ELT_as_tp_AS_TYPE_SPEC(elt1)==((AS_TYPE_SPEC) NULL));
        if ((!(L35))) {
         tps3 = ELT_as_tp_AS_TYPE_SPEC(elt1);
        }
        else {
         L36 = ELT_ret_dTP(elt1);
         if (L36==NULL) {
          FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
         }
         tps3 = (*dTP_as_AS_TYPE_SPEC[TAG(L36)+dTP_as_AS_TYPE_SPEC_offset])(L36);
        }
        SATTR(var3,tp1,tps3);
        if ((ATTR(as,body)==((dAS_CLASS_ELT) NULL))) {
         SATTR(as,body,((dAS_CLASS_ELT) var3));
        }
        else {
         L37 = ATTR(as,body);
         if (L37==NULL) {
          FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
         }
         (*dAS_CLASS_ELT_append_dAS[TAG(L37)+dAS_CLASS_ELT_append_dAS_offset])(L37, ((dAS_CLASS_ELT) var3));
        }
        goto after_loop2;
       }
      }
     }
    }
   }
   after_loop2: ;
  }
 }
 crt = AS_ROUT_DEF_create_AS_RO(((AS_ROUT_DEF) NULL));
 L38 = s;
 if (L38==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(crt,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L38)+dAS_STMT_source_SFILE_ID1_offset])(L38));
 SATTR(crt,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &create1)));
 ret_dec = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 L39 = s;
 if (L39==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(ret_dec,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L39)+dAS_STMT_source_SFILE_ID1_offset])(L39));
 SATTR(ret_dec,kind,AS_TYPE_SPEC_same);
 SATTR(crt,ret_dec,ret_dec);
 crtbdy = AS_RETURN_STMT_create_AS(((AS_RETURN_STMT) NULL));
 L40 = s;
 if (L40==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(crtbdy,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L40)+dAS_STMT_source_SFILE_ID1_offset])(L40));
 crtnew = AS_NEW_EXPR_create_AS_NE(((AS_NEW_EXPR) NULL));
 L41 = s;
 if (L41==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(crtnew,source11,(*dAS_STMT_source_SFILE_ID1[TAG(L41)+dAS_STMT_source_SFILE_ID1_offset])(L41));
 SATTR(crtbdy,val11,((dAS_EXPR) crtnew));
 SATTR(crt,body,AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL)));
 L42 = s;
 if (L42==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 SATTR(ATTR(crt,body),source11,(*dAS_STMT_source_SFILE_ID1[TAG(L42)+dAS_STMT_source_SFILE_ID1_offset])(L42));
 SATTR(crtbdy,surr_stmt_list,ATTR(crt,body));
 SATTR(crtbdy,surr_stmt_list,ATTR(crt,body));
 SATTR(ATTR(crt,body),stmts,((dAS_STMT) crtbdy));
 if ((ATTR(as,body)==((dAS_CLASS_ELT) NULL))) {
  SATTR(as,body,((dAS_CLASS_ELT) crt));
 }
 else {
  L43 = ATTR(as,body);
  if (L43==NULL) {
   FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
  }
  (*dAS_CLASS_ELT_append_dAS[TAG(L43)+dAS_CLASS_ELT_append_dAS_offset])(L43, ((dAS_CLASS_ELT) crt));
 }
 impl = IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), ((dTP) tp));
 dob = TP_BUILTIN_dollar_ob;
 TP_GRAPH_ABS_DES_add_TP_(ATTR(ATTR(self,prog1),tp_graph_abs_des), dob, ((dTP) tp));
 ip1 = TP_GRAPH_ANC_get_anc_TP_(ATTR(ATTR(ATTR(self,prog1),tp_graph),anc), tp);
 ip2 = TP_GRAPH_DES_get_des_TP_(ATTR(ATTR(ATTR(self,prog1),tp_graph),des1), tp);
 L44 = s;
 if (L44==NULL) {
  FATAL("Dispatch on void in TRANS::create_helper_object($AS_STMT,IDENT,IDENT,AS_CLASS_DEF,ARRAY{$TP}):AM_LOCAL_EXPR");
 }
 L45 = (*dAS_STMT_source_SFILE_ID1[TAG(L44)+dAS_STMT_source_SFILE_ID1_offset])(L44);
 ret_val = AM_LOCAL_EXPR_create_SFI1(((AM_LOCAL_EXPR) NULL), L45, newid_ob, ((dTP) tp));
 return ret_val;
}


AM_LOCAL_EXPR TRANS_last_declared_par_(TRANS self) {
 AM_LOCAL_EXPR ret_val;
 INT idx = ((INT) 0);
 AM_LOCAL_EXPR loc;
 AM_LOCAL_EXPR loc1;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 BOOL L5;
 INT L6;
 STR L7;
 extern STR S_pS_par_ob;
 BOOL L8;
 BOOL L9;
 BOOL L10;
 BOOL L11;
 BOOL L12;
 INT L13;
 STR L14;
 extern STR S_pS_par_ob;
 idx = FLISTAM_LOCAL_EXPR_size_(ATTR(self,active_locals));
 while (1) {
  if ((idx>0)) {
  }
  else {
   goto after_loop;
  }
  idx = (INTMINUS(idx,1));
  loc = FLISTAM_LOCAL_EXPR_aget_(ATTR(self,active_locals), idx);
  L4 = (ATTR(loc,name1).str==(STR)0);
  if ((!(L4))) {
   L5 = (ATTR(loc,tp_at)==((dTP) NULL));
   L3 = (!(L5));
  } else {
   L3 = FALSE;
  }
  if (L3) {
   L6 = STR_size_INT(ATTR(loc,name1).str);
   L2 = (L6>=10);
  } else {
   L2 = FALSE;
  }
  if (L2) {
   L7 = STR_head_INT_STR(ATTR(loc,name1).str, 10);
   L1 = STR_is_eq_STR_BOOL(L7, ((STR) &S_pS_par_ob));
  } else {
   L1 = FALSE;
  }
  if (L1) {
   ret_val = loc;
   return ret_val;
  }
 }
 after_loop: ;
 idx = AM_ROUT_DEF_size_INT(ATTR(self,cur_rout));
 while (1) {
  if ((idx>0)) {
  }
  else {
   goto after_loop1;
  }
  idx = (INTMINUS(idx,1));
  loc1 = AM_ROUT_DEF_aget_INT_AM_(ATTR(self,cur_rout), idx);
  L11 = (ATTR(loc1,name1).str==(STR)0);
  if ((!(L11))) {
   L12 = (ATTR(loc1,tp_at)==((dTP) NULL));
   L10 = (!(L12));
  } else {
   L10 = FALSE;
  }
  if (L10) {
   L13 = STR_size_INT(ATTR(loc1,name1).str);
   L9 = (L13>=10);
  } else {
   L9 = FALSE;
  }
  if (L9) {
   L14 = STR_head_INT_STR(ATTR(loc1,name1).str, 10);
   L8 = STR_is_eq_STR_BOOL(L14, ((STR) &S_pS_par_ob));
  } else {
   L8 = FALSE;
  }
  if (L8) {
   ret_val = loc1;
   return ret_val;
  }
 }
 after_loop1: ;
 ret_val = ((AM_LOCAL_EXPR) NULL);
 return ret_val;
}


AM_ROUT_DEF TRANS_transform_elt_ELT_(TRANS self, ELT e) {
 AM_ROUT_DEF ret_val;
 TRANS t;
 dAS_CLASS_ELT as;
 AM_ROUT_DEF r = ((AM_ROUT_DEF) NULL);
 t = TRANS_create_ELT_TRANS(((TRANS) NULL), e);
 if ((t==((TRANS) NULL))) {
  ret_val = ((AM_ROUT_DEF) NULL);
  return ret_val;
 }
 as = ATTR(e,as1);
 if (as==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(as)) {
  case AS_CONST_DEF_tag:
   r = TRANS_transform_const_el(t, e, ((AS_CONST_DEF) as)); break;
  case AS_SHARED_DEF_tag:
   r = TRANS_transform_shared_e(t, e, ((AS_SHARED_DEF) as)); break;
  case AS_ATTR_DEF_tag:
   r = TRANS_transform_attr_elt(t, e, ((AS_ATTR_DEF) as)); break;
  case AS_ROUT_DEF_tag:
   r = TRANS_transform_rout_elt(t, e, ((AS_ROUT_DEF) as)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 SYSDESTROY(((OB) t));
 ret_val = r;
 return ret_val;
}


AM_ROUT_DEF TRANS_transform_rout_elt(TRANS self, ELT e, AS_ROUT_DEF as) {
 AM_ROUT_DEF ret_val;
 AM_ROUT_DEF r;
 INT i = ((INT) 0);
 AS_ARG_DEC na;
 AM_LOCAL_EXPR l;
 AM_PRE_STMT pres = ((AM_PRE_STMT) NULL);
 SIG isig;
 AM_ROUT_CALL_EXPR icall;
 dAM_STMT code1 = ((dAM_STMT) NULL);
 extern STR CompilererrorTRANStranfo;
 INT L1;
 INT L2;
 SFILE_ID L3;
 IDENT L4;
 dTP L5;
 SFILE_ID L6;
 IDENT L7;
 INT L8;
 INT L9;
 extern STR CompilererrorTRANStransf4;
 INT L10;
 SFILE_ID L11;
 IDENT L12;
 dTP L13;
 INT L14;
 BOOL L15;
 BOOL L16;
 BOOL L17;
 BOOL L18;
 BOOL L19;
 BOOL L20;
 dAM_STMT L21;
 dAM_STMT L22;
 dAM_STMT L23;
 dAM_STMT L24;
 if (ELT_is_invariant_BOOL(e)) {
  SATTR(self,in_invariant,TRUE);
 }
 else {
  SATTR(self,in_invariant,FALSE);
 }
 if (ATTR(as,is_abstract)) {
  if (ATTR(e,is_external)) {
   ret_val = ((AM_ROUT_DEF) NULL);
   return ret_val;
  }
  else {
   TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) as));
   TRANS_err_STR(self, ((STR) &CompilererrorTRANStranfo));
   ret_val = ((AM_ROUT_DEF) NULL);
   return ret_val;
  }
 }
 TRANS_check_return_AS_RO(self, as);
 L1 = ARRAYdTP_size_INT(ATTR(ATTR(e,sig11),args1));
 L2 = (INTPLUS(1,L1));
 r = AM_ROUT_DEF_create_INT_S(((AM_ROUT_DEF) NULL), L2, ATTR(as,source11));
 SATTR(r,srcsig1,ATTR(e,srcsig1));
 SATTR(r,sig11,ATTR(e,sig11));
 if (ATTR(e,is_external)) {
  SATTR(r,is_external,TRUE);
 }
 L3 = ATTR(as,source11);
 L4 = IDENT_BUILTIN_self_ident1;
 L5 = ELT_tp_dTP(e);
 AM_ROUT_DEF_aset_INT_AM_(r, 0, AM_LOCAL_EXPR_create_SFI(((AM_LOCAL_EXPR) NULL), L3, L4, L5, ELT_as_tp_AS_TYPE_SPEC(e)));
 if (SIG_has_ret_BOOL(ATTR(e,sig11))) {
  L6 = ATTR(as,source11);
  L7 = IDENT_BUILTIN_ret_ident;
  SATTR(r,rres,AM_LOCAL_EXPR_create_SFI1(((AM_LOCAL_EXPR) NULL), L6, L7, ELT_ret_dTP(e)));
  SATTR(r,locals1,FLISTAM_LOCAL_EXPR_push_(ATTR(r,locals1), ATTR(r,rres)));
 }
 i = 0;
 na = ATTR(as,args_dec);
 L8 = AS_ARG_DEC_size_INT(na);
 L9 = ARRAYdTP_size_INT(ATTR(ATTR(e,sig11),args1));
 if ((L8!=L9)) {
  TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) as));
  TRANS_err_STR(self, ((STR) &CompilererrorTRANStransf4));
  ret_val = ((AM_ROUT_DEF) NULL);
  return ret_val;
 }
 while (1) {
  L10 = ARRAYdTP_size_INT(ATTR(ATTR(e,sig11),args1));
  if ((i<L10)) {
  }
  else {
   goto after_loop;
  }
  L11 = ATTR(as,source11);
  L12 = ATTR(na,name1);
  L13 = ARRAYdTP_aget_INT_dTP(ATTR(ATTR(e,sig11),args1), i);
  l = AM_LOCAL_EXPR_create_SFI(((AM_LOCAL_EXPR) NULL), L11, L12, L13, ATTR(na,tp1));
  L14 = (INTPLUS(i,1));
  AM_ROUT_DEF_aset_INT_AM_(r, L14, l);
  i = (INTPLUS(i,1));
  na = ATTR(na,next);
 }
 after_loop: ;
 SATTR(self,cur_rout,r);
 if (ATTR(ATTR(self,prog1),psather)) {
  TRANS_transform_pSather_1(self, as);
 }
 L15 = (ATTR(as,pre_e)==((dAS_EXPR) NULL));
 if ((!(L15))) {
  SATTR(self,in_pre,TRUE);
  pres = AM_PRE_STMT_create_SFILE(((AM_PRE_STMT) NULL), ATTR(as,source11));
  SATTR(pres,tp1,ATTR(ATTR(self,impl1),tp1));
  SATTR(pres,test11,TRANS_transform_expr_dAS(self, ATTR(as,pre_e), ((dTP) TP_BUILTIN_bool)));
  if ((ATTR(pres,test11)==((dAM_EXPR) NULL))) {
   pres = ((AM_PRE_STMT) NULL);
  }
  SATTR(self,in_pre,FALSE);
 }
 SATTR(self,post_stmt,((AM_POST_STMT) NULL));
 L16 = (ATTR(as,post_e)==((dAS_EXPR) NULL));
 if ((!(L16))) {
  SATTR(self,in_post,TRUE);
  SATTR(self,post_stmt,AM_POST_STMT_create_SFIL(((AM_POST_STMT) NULL), ATTR(as,source11)));
  SATTR(ATTR(self,post_stmt),tp1,ATTR(ATTR(self,impl1),tp1));
  SATTR(ATTR(self,post_stmt),test11,TRANS_transform_expr_dAS(self, ATTR(as,post_e), ((dTP) TP_BUILTIN_bool)));
  if ((ATTR(ATTR(self,post_stmt),test11)==((dAM_EXPR) NULL))) {
   SATTR(self,post_stmt,((AM_POST_STMT) NULL));
  }
  SATTR(self,in_post,FALSE);
 }
 SATTR(self,inv_stmt,((AM_INVARIANT_STMT) NULL));
 L18 = ATTR(e,is_private1);
 if ((!(L18))) {
  L19 = ATTR(self,in_invariant);
  L17 = (!(L19));
 } else {
  L17 = FALSE;
 }
 if (L17) {
  isig = IMPL_invariant_sig_SIG(ATTR(self,impl1));
  L20 = (isig==((SIG) NULL));
  if ((!(L20))) {
   SATTR(self,inv_stmt,AM_INVARIANT_STMT_create(((AM_INVARIANT_STMT) NULL), ATTR(as,source11)));
   SATTR(ATTR(self,inv_stmt),sig11,isig);
   icall = AM_ROUT_CALL_EXPR_create(((AM_ROUT_CALL_EXPR) NULL), 1, ATTR(as,source11));
   SATTR(icall,fun,isig);
   SATTR(r,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(r,calls1), ((dAM_EXPR) icall)));
  }
 }
 if (TRANS_is_array_sig_SIG_B(self, ATTR(e,srcsig1))) {
  code1 = TRANS_transform_array_bo(self, e);
 }
 else {
  code1 = TRANS_transform_stmt_lis(self, ATTR(as,body));
 }
 SATTR(r,code11,ATTR(self,init_stmts));
 if ((ATTR(r,code11)==((dAM_STMT) NULL))) {
  SATTR(r,code11,((dAM_STMT) pres));
 }
 else {
  L21 = ATTR(r,code11);
  if (L21==NULL) {
   FATAL("Dispatch on void in TRANS::transform_rout_elt(ELT,AS_ROUT_DEF):AM_ROUT_DEF");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L21)+dAM_STMT_append_dAM_STMT_offset])(L21, ((dAM_STMT) pres));
 }
 if ((ATTR(r,code11)==((dAM_STMT) NULL))) {
  SATTR(r,code11,code1);
 }
 else {
  L22 = ATTR(r,code11);
  if (L22==NULL) {
   FATAL("Dispatch on void in TRANS::transform_rout_elt(ELT,AS_ROUT_DEF):AM_ROUT_DEF");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L22)+dAM_STMT_append_dAM_STMT_offset])(L22, code1);
 }
 if ((ATTR(as,ret_dec)==((AS_TYPE_SPEC) NULL))) {
  if ((ATTR(r,code11)==((dAM_STMT) NULL))) {
   SATTR(r,code11,((dAM_STMT) ATTR(self,post_stmt)));
  }
  else {
   L23 = ATTR(r,code11);
   if (L23==NULL) {
    FATAL("Dispatch on void in TRANS::transform_rout_elt(ELT,AS_ROUT_DEF):AM_ROUT_DEF");
   }
   (*dAM_STMT_append_dAM_STMT[TAG(L23)+dAM_STMT_append_dAM_STMT_offset])(L23, ((dAM_STMT) ATTR(self,post_stmt)));
  }
  if ((ATTR(r,code11)==((dAM_STMT) NULL))) {
   SATTR(r,code11,((dAM_STMT) ATTR(self,inv_stmt)));
  }
  else {
   L24 = ATTR(r,code11);
   if (L24==NULL) {
    FATAL("Dispatch on void in TRANS::transform_rout_elt(ELT,AS_ROUT_DEF):AM_ROUT_DEF");
   }
   (*dAM_STMT_append_dAM_STMT[TAG(L24)+dAM_STMT_append_dAM_STMT_offset])(L24, ((dAM_STMT) ATTR(self,inv_stmt)));
  }
 }
 ret_val = r;
 return ret_val;
}


AS_ASSIGN_STMT TRANS_create_helper_obje1(TRANS self, IDENT newid_ob, IDENT newid_cl, AS_CLASS_DEF current_class_as, AS_STMT_LIST body1, SFILE_ID source1) {
 AS_ASSIGN_STMT ret_val;
 AS_ASSIGN_STMT as3;
 AS_TYPE_SPEC tp3;
 AS_PARAM_DEC class_param;
 AS_TYPE_SPEC pardec;
 AS_CREATE_EXPR rhs3;
 as3 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
 SATTR(as3,source11,source1);
 SATTR(as3,name1,newid_ob);
 SATTR(as3,surr_stmt_list,body1);
 tp3 = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(tp3,source11,source1);
 SATTR(tp3,name1,newid_cl);
 class_param = ATTR(current_class_as,params1);
 while (1) {
  if ((class_param==((AS_PARAM_DEC) NULL))) {
   goto after_loop;
  }
  pardec = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
  SATTR(pardec,source11,source1);
  SATTR(pardec,name1,ATTR(class_param,name1));
  if ((ATTR(tp3,params1)==((AS_TYPE_SPEC) NULL))) {
   SATTR(tp3,params1,pardec);
  }
  else {
   AS_TYPE_SPEC_append_AS_T(ATTR(tp3,params1), pardec);
  }
  class_param = ATTR(class_param,next);
 }
 after_loop: ;
 rhs3 = AS_CREATE_EXPR_create_AS(((AS_CREATE_EXPR) NULL));
 SATTR(rhs3,source11,source1);
 SATTR(rhs3,tp1,tp3);
 SATTR(as3,rhs,((dAS_EXPR) rhs3));
 ret_val = as3;
 return ret_val;
}


AS_ASSIGN_STMT TRANS_link_helper_stmt_I(TRANS self, IDENT newid_ob, AS_STMT_LIST body1, SFILE_ID source1) {
 AS_ASSIGN_STMT ret_val;
 AS_ASSIGN_STMT exp1 = ((AS_ASSIGN_STMT) NULL);
 AS_CALL_EXPR lhs;
 AS_CALL_EXPR lhsob;
 AS_CALL_EXPR rhs;
 ELT_TBL elts1;
 IDENT par_ob = IDENT_zero;
 ELT_TBL L11;
 ELT elt1;
 AS_CALL_EXPR rhs1;
 AS_CALL_EXPR lhs1;
 AS_CALL_EXPR lhsob1;
 BOOL L2;
 BOOL L3;
 IMPL_TBL L4;
 ELT L5;
 STR L6;
 extern STR S_;
 BOOL L7;
 BOOL L8;
 INT L9;
 STR L10;
 extern STR S_pS_par_;
 extern STR CompilerErrorPTRANSlink_;
 L2 = (ATTR(self,cur_par_ob)==((AM_LOCAL_EXPR) NULL));
 if ((!(L2))) {
  exp1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
  SATTR(exp1,source11,source1);
  SATTR(exp1,surr_stmt_list,body1);
  lhs = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(lhs,source11,source1);
  lhsob = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(lhsob,source11,source1);
  SATTR(lhsob,name1,newid_ob);
  SATTR(lhs,ob1,((dAS_EXPR) lhsob));
  SATTR(lhs,name1,ATTR(ATTR(self,cur_par_ob),name1));
  SATTR(exp1,lhs_expr,((dAS_EXPR) lhs));
  rhs = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(rhs,source11,source1);
  SATTR(rhs,name1,ATTR(ATTR(self,cur_par_ob),name1));
  SATTR(exp1,rhs,((dAS_EXPR) rhs));
 }
 else {
  L3 = (ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL));
  if ((!(L3))) {
   exp1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
   SATTR(exp1,source11,source1);
   SATTR(exp1,surr_stmt_list,body1);
   L4 = ATTR(ATTR(self,prog1),impl_tbl);
   elts1 = ATTR(IMPL_TBL_impl_of_dTP_IMP(L4, AM_LOCAL_EXPR_tp_dTP(ATTR(self,cur_param_ob))),elts);
   {
    struct ELT_TBL_eltb_ELT_frame_struct other1_0;
    ELT_TBL_eltb_ELT_frame 
    noname1 = &other1_0;
    noname1->state = 0;
    while (1) {
     if (noname1->state == 0) {
      L11 = elts1;
      noname1->self = L11;
     }
     L5 = ELT_TBL_eltb_ELT(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     elt1 = L5;
     L6 = STR_head_INT_STR(ELT_name_IDENT(elt1).str, 1);
     if (STR_is_eq_STR_BOOL(L6, ((STR) &S_))) {
      L7 = (ELT_ret_dTP(elt1)==((dTP) NULL));
      if ((!(L7))) {
       L9 = STR_size_INT(ELT_name_IDENT(elt1).str);
       if ((L9>=8)) {
        L10 = STR_head_INT_STR(ELT_name_IDENT(elt1).str, 8);
        L8 = STR_is_eq_STR_BOOL(L10, ((STR) &S_pS_par_));
       } else {
        L8 = FALSE;
       }
       if (L8) {
        par_ob = ELT_name_IDENT(elt1);
        goto after_loop;
       }
      }
     }
    }
   }
   after_loop: ;
   if ((par_ob.str==(STR)0)) {
    TRANS_err_STR(self, ((STR) &CompilerErrorPTRANSlink_));
   }
   rhs1 = TRANS_as_of_local_in_hel(self, par_ob, ATTR(self,cur_param_ob), source1);
   lhs1 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
   SATTR(lhs1,source11,source1);
   lhsob1 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
   SATTR(lhsob1,source11,source1);
   SATTR(lhsob1,name1,newid_ob);
   SATTR(lhs1,ob1,((dAS_EXPR) lhsob1));
   SATTR(lhs1,name1,par_ob);
   SATTR(exp1,lhs_expr,((dAS_EXPR) lhs1));
   SATTR(exp1,rhs,((dAS_EXPR) rhs1));
  }
 }
 ret_val = exp1;
 return ret_val;
}


AS_CALL_EXPR TRANS_as_of_local_in_hel(TRANS self, IDENT local1, AM_LOCAL_EXPR helper1, SFILE_ID source1) {
 AS_CALL_EXPR ret_val;
 FLISTIDENT names1;
 AS_CALL_EXPR as = ((AS_CALL_EXPR) NULL);
 FLISTIDENT L11;
 IDENT name11 = IDENT_zero;
 AS_CALL_EXPR as_new;
 IDENT L2;
 names1 = TRANS_name_of_local_in_h(self, local1, helper1);
 {
  struct FLISTIDENT_eltb_IDENT_frame_struct other1_0;
  FLISTIDENT_eltb_IDENT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = names1;
    noname1->self = L11;
   }
   L2 = FLISTIDENT_eltb_IDENT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   name11 = L2;
   if ((as==((AS_CALL_EXPR) NULL))) {
    as = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(as,source11,source1);
   }
   else {
    as_new = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(as_new,source11,source1);
    SATTR(as_new,ob1,((dAS_EXPR) as));
    as = as_new;
   }
   SATTR(as,name1,name11);
  }
 }
 after_loop: ;
 ret_val = as;
 return ret_val;
}


AS_ROUT_DEF TRANS_turn_into_routine_(TRANS self, IDENT routname, IDENT helper_ob, IDENT helper_cl, AM_LOCAL_EXPR helper1, AS_CLASS_DEF current_class_as, TP_CLASS current_class_tp, IDENT gate, AS_TYPE_SPEC gate_tp, AS_STMT_LIST body1, INT code1, SFILE_ID source1) {
 AS_ROUT_DEF ret_val;
 AS_ROUT_DEF newrout;
 INT L11 = ((INT) 0);
 AS_ARG_DEC argdec0;
 AS_TYPE_SPEC argdec0tp;
 AS_PARAM_DEC class_param;
 AS_TYPE_SPEC pardec;
 AS_ARG_DEC argdec1;
 AS_ARG_DEC argdec2;
 AS_TYPE_SPEC argdec2tp;
 dAS_STMT decl_stmts = ((dAS_STMT) NULL);
 AS_DEC_STMT asdec = ((AS_DEC_STMT) NULL);
 TRANS L21;
 AM_LOCAL_EXPR loc;
 dAS_STMT copy_in_stmts = ((dAS_STMT) NULL);
 AS_ASSIGN_STMT asin1 = ((AS_ASSIGN_STMT) NULL);
 TRANS L31;
 AM_LOCAL_EXPR loc1;
 AS_CALL_EXPR asinlhs;
 dAS_STMT copy_out_stmts = ((dAS_STMT) NULL);
 AS_PROTECT_STMT prtct;
 AS_STMT_LIST else_part;
 dAS_STMT exp0;
 AS_UNCAUGHT_STMT uncg;
 AS_PROTECT_WHEN when_part;
 AS_TYPE_SPEC when_part_tp;
 dAS_STMT exp1;
 extern STR GATE1;
 extern STR S_pS_at;
 extern STR INT1;
 dAS_CLASS_ELT L4;
 AM_LOCAL_EXPR L5;
 BOOL L6;
 STR L7;
 extern STR S_;
 BOOL L8;
 BOOL L9;
 BOOL L10;
 BOOL L12;
 dTP L13;
 dAS_STMT L14;
 AM_LOCAL_EXPR L15;
 BOOL L16;
 BOOL L17;
 STR L18;
 extern STR S_;
 BOOL L19;
 BOOL L20;
 BOOL L22;
 BOOL L23;
 dAS_STMT L24;
 BOOL L25;
 BOOL L26;
 dAS_STMT L27;
 dAS_STMT L28;
 dAS_STMT L29;
 extern STR CLEARED_EX1;
 dAS_STMT L30;
 newrout = AS_ROUT_DEF_create_AS_RO(((AS_ROUT_DEF) NULL));
 SATTR(newrout,source11,source1);
 SATTR(newrout,name1,routname);
 L11 = code1;
 switch (L11) {
  case 12:
   SATTR(newrout,is_par_routine,TRUE);
   break;
  case 11:
   SATTR(newrout,is_fork_routine,TRUE);
   break;
  case 13:
   SATTR(newrout,is_attach_routine,TRUE);
   break;
  default: ;
   FATAL("No applicable target in case statement");
 }
 argdec0 = AS_ARG_DEC_create_AS_ARG(((AS_ARG_DEC) NULL));
 SATTR(argdec0,source11,source1);
 SATTR(argdec0,name1,helper_ob);
 argdec0tp = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(argdec0tp,source11,source1);
 SATTR(argdec0tp,name1,helper_cl);
 class_param = ATTR(current_class_as,params1);
 while (1) {
  if ((class_param==((AS_PARAM_DEC) NULL))) {
   goto after_loop;
  }
  pardec = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
  SATTR(pardec,source11,source1);
  SATTR(pardec,name1,ATTR(class_param,name1));
  if ((ATTR(argdec0tp,params1)==((AS_TYPE_SPEC) NULL))) {
   SATTR(argdec0tp,params1,pardec);
  }
  else {
   AS_TYPE_SPEC_append_AS_T(ATTR(argdec0tp,params1), pardec);
  }
  class_param = ATTR(class_param,next);
 }
 after_loop: ;
 SATTR(argdec0,tp1,argdec0tp);
 argdec1 = AS_ARG_DEC_create_AS_ARG(((AS_ARG_DEC) NULL));
 SATTR(argdec1,source11,source1);
 SATTR(argdec1,name1,gate);
 if ((gate_tp==((AS_TYPE_SPEC) NULL))) {
  gate_tp = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
  SATTR(gate_tp,source11,source1);
  SATTR(gate_tp,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &GATE1)));
 }
 SATTR(argdec1,tp1,gate_tp);
 argdec2 = AS_ARG_DEC_create_AS_ARG(((AS_ARG_DEC) NULL));
 SATTR(argdec2,source11,source1);
 SATTR(argdec2,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &S_pS_at)));
 argdec2tp = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(argdec2tp,source11,source1);
 SATTR(argdec2tp,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &INT1)));
 SATTR(argdec2,tp1,argdec2tp);
 AS_ARG_DEC_append_AS_ARG(argdec0, argdec1);
 AS_ARG_DEC_append_AS_ARG(argdec0, argdec2);
 SATTR(newrout,args_dec,argdec0);
 SATTR(newrout,is_private,TRUE);
 SATTR(newrout,body,AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL)));
 SATTR(ATTR(newrout,body),source11,source1);
 L4 = ATTR(current_class_as,body);
 if (L4==NULL) {
  FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
 }
 (*dAS_CLASS_ELT_append_dAS[TAG(L4)+dAS_CLASS_ELT_append_dAS_offset])(L4, ((dAS_CLASS_ELT) newrout));
 TRANS_update_routine_in_(self, current_class_tp, newrout);
 {
  struct TRANS_active_locals_and__frame_struct other2_0;
  TRANS_active_locals_and__frame 
  noname1 = &other2_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L21 = self;
    noname1->self = L21;
   }
   L5 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop1;
   }
   loc = L5;
   L7 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L7, ((STR) &S_))) {
    L6 = TRUE;
   } else {
    if (ATTR(newrout,is_attach_routine)) {
     L10 = (ATTR(self,cur_cohort)==((AM_LOCAL_EXPR) NULL));
     L9 = (!(L10));
    } else {
     L9 = FALSE;
    }
    if (L9) {
     L8 = IDENT_is_eq_IDENT_BOOL(ATTR(loc,name1), ATTR(ATTR(self,cur_cohort),name1));
    } else {
     L8 = FALSE;
    }
    L6 = L8;
   }
   if (L6) {
    asdec = AS_DEC_STMT_create_AS_DE(((AS_DEC_STMT) NULL));
    SATTR(asdec,source11,source1);
    SATTR(asdec,name1,ATTR(loc,name1));
    SATTR(asdec,surr_stmt_list,ATTR(newrout,body));
    L12 = (ATTR(loc,as_type)==((AS_TYPE_SPEC) NULL));
    if ((!(L12))) {
     SATTR(asdec,tp1,ATTR(loc,as_type));
    }
    else {
     L13 = AM_LOCAL_EXPR_tp_dTP(loc);
     if (L13==NULL) {
      FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
     }
     SATTR(asdec,tp1,(*dTP_as_AS_TYPE_SPEC[TAG(L13)+dTP_as_AS_TYPE_SPEC_offset])(L13));
    }
    if ((decl_stmts==((dAS_STMT) NULL))) {
     decl_stmts = ((dAS_STMT) asdec);
    }
    else {
     L14 = decl_stmts;
     if (L14==NULL) {
      FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L14)+dAS_STMT_append_dAS_STMT_offset])(L14, ((dAS_STMT) asdec));
    }
   }
  }
 }
 after_loop1: ;
 copy_in_stmts = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(newrout,body), source1);
 {
  struct TRANS_active_locals_and__frame_struct other3_0;
  TRANS_active_locals_and__frame 
  noname2 = &other3_0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L31 = self;
    noname2->self = L31;
   }
   L15 = TRANS_active_locals_and_(noname2);
   if (noname2->state == -1) {
    goto after_loop2;
   }
   loc1 = L15;
   L18 = STR_head_INT_STR(ATTR(loc1,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L18, ((STR) &S_))) {
    L17 = TRUE;
   } else {
    if (ATTR(newrout,is_attach_routine)) {
     L22 = (ATTR(self,cur_cohort)==((AM_LOCAL_EXPR) NULL));
     L20 = (!(L22));
    } else {
     L20 = FALSE;
    }
    if (L20) {
     L19 = IDENT_is_eq_IDENT_BOOL(ATTR(loc1,name1), ATTR(ATTR(self,cur_cohort),name1));
    } else {
     L19 = FALSE;
    }
    L17 = L19;
   }
   if (L17) {
    L23 = TRANS_local_is_in_par_he(self, ATTR(loc1,name1), helper1);
    L16 = (!(L23));
   } else {
    L16 = FALSE;
   }
   if (L16) {
    asin1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
    SATTR(asin1,source11,source1);
    SATTR(asin1,transformed,TRUE);
    asinlhs = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(asinlhs,source11,source1);
    SATTR(asinlhs,name1,ATTR(loc1,name1));
    SATTR(asin1,lhs_expr,((dAS_EXPR) asinlhs));
    SATTR(asin1,rhs,((dAS_EXPR) TRANS_as_of_local_in_hel(self, ATTR(loc1,name1), helper1, source1)));
    SATTR(asin1,surr_stmt_list,ATTR(newrout,body));
    L24 = copy_in_stmts;
    if (L24==NULL) {
     FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L24)+dAS_STMT_append_dAS_STMT_offset])(L24, ((dAS_STMT) asin1));
   }
  }
 }
 after_loop2: ;
 copy_out_stmts = TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(newrout,body), source1);
 prtct = AS_PROTECT_STMT_create_A(((AS_PROTECT_STMT) NULL));
 SATTR(prtct,source11,source1);
 SATTR(prtct,surr_stmt_list,ATTR(newrout,body));
 SATTR(prtct,body,body1);
 L25 = (ATTR(body1,stmts)==((dAS_STMT) NULL));
 if ((!(L25))) {
  L26 = (copy_in_stmts==((dAS_STMT) NULL));
  if ((!(L26))) {
   L27 = copy_in_stmts;
   if (L27==NULL) {
    FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
   }
   (*dAS_STMT_append_dAS_STMT[TAG(L27)+dAS_STMT_append_dAS_STMT_offset])(L27, ATTR(body1,stmts));
   SATTR(body1,stmts,copy_in_stmts);
  }
  L28 = ATTR(ATTR(prtct,body),stmts);
  if (L28==NULL) {
   FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L28)+dAS_STMT_append_dAS_STMT_offset])(L28, copy_out_stmts);
 }
 else_part = AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL));
 SATTR(else_part,source11,source1);
 exp0 = TRANS_as_for_sys_import_(self, TRANS_export_code, else_part, source1);
 uncg = AS_UNCAUGHT_STMT_create_(((AS_UNCAUGHT_STMT) NULL));
 SATTR(uncg,source11,source1);
 SATTR(uncg,surr_stmt_list,else_part);
 L29 = exp0;
 if (L29==NULL) {
  FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L29)+dAS_STMT_append_dAS_STMT_offset])(L29, ((dAS_STMT) uncg));
 SATTR(else_part,stmts,exp0);
 when_part = AS_PROTECT_WHEN_create_A(((AS_PROTECT_WHEN) NULL));
 SATTR(when_part,source11,source1);
 when_part_tp = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(when_part_tp,source11,source1);
 SATTR(when_part_tp,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &CLEARED_EX1)));
 SATTR(when_part,tp1,when_part_tp);
 SATTR(when_part,then_part,AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL)));
 SATTR(ATTR(when_part,then_part),source11,source1);
 exp1 = TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(when_part,then_part), source1);
 SATTR(ATTR(when_part,then_part),stmts,exp1);
 SATTR(prtct,else_part,else_part);
 SATTR(prtct,when_part,when_part);
 SATTR(prtct,transformed,TRUE);
 SATTR(ATTR(newrout,body),stmts,decl_stmts);
 if ((decl_stmts==((dAS_STMT) NULL))) {
  SATTR(ATTR(newrout,body),stmts,((dAS_STMT) prtct));
 }
 else {
  L30 = ATTR(ATTR(newrout,body),stmts);
  if (L30==NULL) {
   FATAL("Dispatch on void in TRANS::turn_into_routine(IDENT,IDENT,IDENT,AM_LOCAL_EXPR,AS_CLASS_DEF,TP_CLASS,IDENT,AS_TYPE_SPEC,AS_STMT_LIST,INT,SFILE_ID):AS_ROUT_DEF");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L30)+dAS_STMT_append_dAS_STMT_offset])(L30, ((dAS_STMT) prtct));
 }
 ret_val = newrout;
 return ret_val;
}


BOOL TRANS_is_in_loop_and_cal(TRANS self, dAS_EXPR e) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 BOOL L2;
 L2 = (ATTR(self,cur_loop)==((AM_LOOP_STMT) NULL));
 if ((!(L2))) {
  L1 = TRANS_contains_iter_call(self, TRANS_transform_expr_dAS(self, e, ((dTP) NULL)));
 } else {
  L1 = FALSE;
 }
 ret_val = L1;
 return ret_val;
}


BOOL TRANS_is_in_try_or_lock_(TRANS self) {
 BOOL ret_val = ((BOOL) 0);
 BOOL L1;
 BOOL L2;
 L1 = ATTR(ATTR(self,prog1),psather);
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 else {
  L2 = (ATTR(self,cur_lock)==((dAM_STMT) NULL));
  ret_val = (!(L2));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL TRANS_is_iter_BOOL(TRANS self) {
 BOOL ret_val = ((BOOL) 0);
 if ((ATTR(self,cur_rout)==((AM_ROUT_DEF) NULL))) {
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = AM_ROUT_DEF_is_iter_BOOL(ATTR(self,cur_rout));
 return ret_val;
}


BOOL TRANS_local_is_in_par_he(TRANS self, IDENT local1, AM_LOCAL_EXPR helper1) {
 BOOL ret_val = ((BOOL) 0);
 FLISTIDENT names1;
 BOOL L1;
 INT L2;
 BOOL L3;
 INT L4;
 INT L5;
 INT L6;
 STR L7;
 extern STR S_pS_par_ob;
 names1 = TRANS_name_of_local_in_h(self, local1, helper1);
 if ((names1==((FLISTIDENT) NULL))) {
  L1 = TRUE;
 } else {
  L2 = FLISTIDENT_size_INT(names1);
  L1 = (L2<2);
 }
 if (L1) {
  ret_val = FALSE;
  return ret_val;
 }
 L4 = FLISTIDENT_size_INT(names1);
 L5 = STR_size_INT(FLISTIDENT_aget_INT_IDEN(names1, (INTMINUS(L4,2))).str);
 if ((L5>=10)) {
  L6 = FLISTIDENT_size_INT(names1);
  L7 = STR_head_INT_STR(FLISTIDENT_aget_INT_IDEN(names1, (INTMINUS(L6,2))).str, 10);
  L3 = STR_is_eq_STR_BOOL(L7, ((STR) &S_pS_par_ob));
 } else {
  L3 = FALSE;
 }
 ret_val = L3;
 return ret_val;
}


FLISTIDENT TRANS_name_of_local_in_h(TRANS self, IDENT local1, AM_LOCAL_EXPR helper1) {
 FLISTIDENT ret_val;
 FLISTIDENT names1;
 dTP tp;
 ELT_TBL elts1;
 BOOL found1 = ((BOOL) 0);
 ELT_TBL L11;
 IDENT L21 = IDENT_zero;
 ELT elt1;
 ELT_TBL L31;
 ELT elt2;
 ELT L4;
 ELT L5;
 BOOL L6;
 INT L7;
 STR L8;
 extern STR S_pS_par;
 BOOL L9;
 names1 = FLISTIDENT_create_FLISTI(((FLISTIDENT) NULL));
 tp = AM_LOCAL_EXPR_tp_dTP(helper1);
 names1 = FLISTIDENT_push_IDENT_FL(names1, ATTR(helper1,name1));
 if (IDENT_is_eq_IDENT_BOOL(ATTR(helper1,name1), local1)) {
  ret_val = names1;
  return ret_val;
 }
 while (1) {
  elts1 = ATTR(IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), tp),elts);
  found1 = FALSE;
  {
   struct ELT_TBL_get_queryb_IDENT_frame_struct other2_0;
   ELT_TBL_get_queryb_IDENT_frame 
   noname1 = &other2_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = elts1;
     L21 = local1;
     noname1->self = L11;
     noname1->arg1 = L21;
    }
    L4 = ELT_TBL_get_queryb_IDENT(noname1);
    if (noname1->state == -1) {
     goto after_loop1;
    }
    elt1 = L4;
    found1 = TRUE;
    names1 = FLISTIDENT_push_IDENT_FL(names1, local1);
    goto after_loop1;
   }
  }
  after_loop1: ;
  if (found1) {
   goto after_loop;
  }
  found1 = FALSE;
  {
   struct ELT_TBL_eltb_ELT_frame_struct other3_0;
   ELT_TBL_eltb_ELT_frame 
   noname2 = &other3_0;
   noname2->state = 0;
   while (1) {
    if (noname2->state == 0) {
     L31 = elts1;
     noname2->self = L31;
    }
    L5 = ELT_TBL_eltb_ELT(noname2);
    if (noname2->state == -1) {
     goto after_loop2;
    }
    elt2 = L5;
    L7 = STR_size_INT(ELT_name_IDENT(elt2).str);
    if ((L7>=7)) {
     L8 = STR_head_INT_STR(ELT_name_IDENT(elt2).str, 7);
     L6 = STR_is_eq_STR_BOOL(L8, ((STR) &S_pS_par));
    } else {
     L6 = FALSE;
    }
    if (L6) {
     L9 = (ELT_ret_dTP(elt2)==((dTP) NULL));
     if ((!(L9))) {
      found1 = TRUE;
      tp = ELT_ret_dTP(elt2);
      names1 = FLISTIDENT_push_IDENT_FL(names1, ELT_name_IDENT(elt2));
      goto after_loop2;
     }
    }
   }
  }
  after_loop2: ;
  if ((!(found1))) {
   ret_val = ((FLISTIDENT) NULL);
   return ret_val;
  }
 }
 after_loop: ;
 ret_val = names1;
 return ret_val;
}


TP_CLASS TRANS_add_helper_to_tbls(TRANS self, IDENT helper1, ARRAYdTP current_params) {
 TP_CLASS ret_val;
 TP_CLASS tp;
 extern STR CompilerErrPTRANSadd_hel;
 BOOL L1;
 tp = TP_TBL_tp_class_for_IDEN(ATTR(ATTR(self,prog1),tp_tbl), helper1, current_params);
 if ((tp==((TP_CLASS) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrPTRANSadd_hel));
 }
 L1 = FSETdTP_test_dTP_BOOL(ATTR(ATTR(self,prog1),tp_done), ((dTP) tp));
 if ((!(L1))) {
  SATTR(ATTR(self,prog1),tp_done,FSETdTP_insert_dTP_FSETd(ATTR(ATTR(self,prog1),tp_done), ((dTP) tp)));
 }
 ret_val = tp;
 return ret_val;
}


TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU2(TUPAM_BND_CREATE_EXPRBOU self, AM_BND_CREATE_EXPR at1, BOUND_OBJECT_LAYOUT at2) {
 TUPAM_BND_CREATE_EXPRBOU ret_val = TUPAM_BND_CREATE_EXPRBOU_zero;
 TUPAM_BND_CREATE_EXPRBOU L1;
 TUPAM_BND_CREATE_EXPRBOU L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


dAM_CONST TRANS_const_to_switch_dA(TRANS self, dAM_EXPR e) {
 dAM_CONST ret_val;
 if ((e==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_CONST) NULL);
  return ret_val;
 }
 if (e==NULL) {
  ret_val = ((dAM_CONST) NULL);
  return ret_val;
 } else
 switch (TAG(e)) {
  case AM_CHAR_CONST_tag:
   ret_val = ((dAM_CONST) e);
   return ret_val; break;
  case AM_INT_CONST_tag:
   ret_val = ((dAM_CONST) e);
   return ret_val; break;
  case AM_GLOBAL_EXPR_tag:
   ret_val = TRANS_const_to_switch_dA(self, ATTR(((AM_GLOBAL_EXPR) e),init1));
   return ret_val; break;
  default: ;
   ret_val = ((dAM_CONST) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dAM_STMT TRANS_transform_assert_s(TRANS self, AS_ASSERT_STMT s) {
 dAM_STMT ret_val;
 AM_ASSERT_STMT r;
 r = AM_ASSERT_STMT_create_SF(((AM_ASSERT_STMT) NULL), ATTR(s,source11));
 SATTR(r,test11,TRANS_transform_expr_dAS(self, ATTR(s,test1), ((dTP) TP_BUILTIN_bool)));
 if ((ATTR(r,test11)==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_assign_s(TRANS self, AS_ASSIGN_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT r;
 dAS_EXPR lhs;
 dAM_STMT r11;
 dAM_STMT r21;
 extern STR Itisillegaltoassigntosel;
 extern STR Itisillegaltoassigntovoi;
 extern STR Itisillegaltoassigntoavo;
 extern STR Itisillegaltoassigntoana2;
 extern STR Itisillegaltoassigntoacr;
 extern STR Itisillegaltoassigntoabo;
 extern STR Itisillegaltoassigntoana3;
 extern STR Itisillegaltoassigntoano;
 extern STR Itisillegaltoassigntoane1;
 extern STR Itisillegaltoassigntoane2;
 extern STR Itisillegaltoassigntoani;
 extern STR Itisillegaltoassigntoabr;
 extern STR Itisillegaltoassigntoare;
 extern STR Itisillegaltoassigntoabo1;
 extern STR Itisillegaltoassigntoach;
 extern STR Itisillegaltoassigntoast;
 extern STR Itisillegaltoassigntoani1;
 extern STR Itisillegaltoassigntoafl;
 extern STR Itisillegaltoassigntoanc;
 if ((ATTR(s,lhs_expr)==((dAS_EXPR) NULL))) {
  r = TRANS_transform_assign_d(self, s);
  ret_val = r;
  return ret_val;
 }
 lhs = ATTR(s,lhs_expr);
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) lhs));
 if (lhs==NULL) {
  if (ATTR(ATTR(self,prog1),psather)) {
   TRANS_transform_pSather_3(self, s);
  }
 } else
 switch (TAG(lhs)) {
  case AS_CALL_EXPR_tag:
   if (ATTR(((AS_CALL_EXPR) lhs),is_array)) {
    r11 = TRANS_transform_array_as(self, ((AS_CALL_EXPR) lhs), s);
    ret_val = r11;
    return ret_val;
   }
   else {
    r21 = TRANS_transform_call_ass(self, ((AS_CALL_EXPR) lhs), s);
    ret_val = r21;
    return ret_val;
   } break;
  case AS_SELF_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntosel)); break;
  case AS_VOID_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntovoi)); break;
  case AS_IS_VOID_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoavo)); break;
  case AS_ARRAY_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoana2)); break;
  case AS_CREATE_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoacr)); break;
  case AS_BOUND_CREATE_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoabo)); break;
  case AS_AND_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoana3)); break;
  case AS_OR_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoano)); break;
  case AS_EXCEPT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoane1)); break;
  case AS_NEW_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoane2)); break;
  case AS_INITIAL_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoani)); break;
  case AS_BREAK_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoabr)); break;
  case AS_RESULT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoare)); break;
  case AS_BOOL_LIT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoabo1)); break;
  case AS_CHAR_LIT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoach)); break;
  case AS_STR_LIT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoast)); break;
  case AS_INT_LIT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoani1)); break;
  case AS_FLT_LIT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoafl)); break;
  case AS_CLUSTER_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoanc)); break;
  default: ;
   if (ATTR(ATTR(self,prog1),psather)) {
    TRANS_transform_pSather_3(self, s);
   }
 }
 ret_val = ((dAM_STMT) NULL);
 return ret_val;
}


dAM_STMT TRANS_transform_attach_s(TRANS self, AS_ATTACH_STMT s) {
 dAM_STMT ret_val;
 dAM_EXPR lhs_am;
 dTP lhs_tp;
 dTP rhs_tp;
 AS_TYPE_SPEC lhs_as;
 dAS_EXPR rhs;
 dAS_EXPR at = ((dAS_EXPR) NULL);
 AS_AT_EXPR atexpr = ((AS_AT_EXPR) NULL);
 dAS_EXPR rhsexpr;
 dAM_EXPR ignore1;
 dAM_EXPR rhs_am = ((dAM_EXPR) NULL);
 dAS_STMT ret_as = ((dAS_STMT) NULL);
 dTP current_tp;
 TP_CLASS current_class_tp = ((TP_CLASS) NULL);
 AS_CLASS_DEF current_class_as = ((AS_CLASS_DEF) NULL);
 ARRAYdTP current_params = ((ARRAYdTP) NULL);
 INT num1 = ((INT) 0);
 TP_CLASS dummy1;
 IDENT newidattach = IDENT_zero;
 IDENT newidattach_cl = IDENT_zero;
 IDENT newidattach_ob = IDENT_zero;
 IDENT newidgate = IDENT_zero;
 AM_LOCAL_EXPR helper1;
 AS_ASSIGN_STMT as1;
 TRANS L11;
 AM_LOCAL_EXPR loc;
 AS_ASSIGN_STMT exp1;
 AS_CALL_EXPR rhsx;
 AS_STMT_LIST attachbody;
 AS_EXPR_STMT call11;
 AS_CALL_EXPR callexpr;
 AS_CALL_EXPR callexprob;
 AS_EXPR_STMT exprstmt;
 AS_EXPR_STMT call2;
 AS_CALL_EXPR callexpr1;
 AS_CALL_EXPR callexprob1;
 AS_INTERF_ATTACH_STMT att8;
 dAM_EXPR L2;
 dAM_EXPR L3;
 dTP L4;
 extern STR GATE1;
 BOOL L5;
 BOOL L6;
 BOOL L7;
 extern STR CompilerErrorPTRANStrans4;
 BOOL L8;
 dPARSE L9;
 extern STR CompilerErrorPTRANStrans4;
 extern STR attach;
 extern STR attach_cl;
 extern STR attach_ob;
 extern STR gate2;
 dAS_STMT L10;
 dAS_STMT L12;
 dAS_STMT L13;
 AM_LOCAL_EXPR L14;
 BOOL L15;
 BOOL L16;
 STR L17;
 extern STR S_;
 BOOL L18;
 BOOL L19;
 BOOL L20;
 BOOL L21;
 dAS_STMT L22;
 dAS_STMT L23;
 BOOL L24;
 extern STR enqueue;
 extern STR enqueue;
 dAS_STMT L25;
 dAS_STMT L26;
 dAS_STMT L27;
 if ((ATTR(s,lhs)==((dAS_EXPR) NULL))) {
  TRANS_attach_without_gat(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 lhs_am = TRANS_transform_expr_dAS(self, ATTR(s,lhs), ((dTP) NULL));
 if ((lhs_am==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L2 = lhs_am;
 if (L2==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 lhs_tp = (*dAM_EXPR_tp_dTP[TAG(L2)+dAM_EXPR_tp_dTP_offset])(L2);
 rhs_tp = ((dTP) NULL);
 L3 = lhs_am;
 if (L3==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 L4 = (*dAM_EXPR_tp_dTP[TAG(L3)+dAM_EXPR_tp_dTP_offset])(L3);
 if (L4==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 lhs_as = (*dTP_as_AS_TYPE_SPEC[TAG(L4)+dTP_as_AS_TYPE_SPEC_offset])(L4);
 if (STR_is_neq_STR_BOOL(ATTR(lhs_as,name1).str, ((STR) &GATE1))) {
  TRANS_attach_without_gat(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L5 = (ATTR(lhs_as,params1)==((AS_TYPE_SPEC) NULL));
 if ((!(L5))) {
  L6 = (ATTR(ATTR(lhs_as,params1),next)==((AS_TYPE_SPEC) NULL));
  if ((!(L6))) {
   TRANS_attach_without_gat(self, s);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  rhs_tp = TRANS_tp_of_AS_TYPE_SPEC(self, ATTR(lhs_as,params1));
 }
 rhs = ATTR(s,rhs);
 rhsexpr = ATTR(s,rhs);
 while (1) {
  if (rhsexpr==NULL) {
   goto after_loop;
  } else
  switch (TAG(rhsexpr)) {
   case AS_AT_EXPR_tag:
    atexpr = ((AS_AT_EXPR) rhsexpr);
    ignore1 = TRANS_transform_expr_dAS(self, ATTR(atexpr,at11), ((dTP) TP_BUILTIN_int));
    if ((at==((dAS_EXPR) NULL))) {
     at = ATTR(atexpr,at11);
    } break;
   default: ;
    goto after_loop;
  }
  rhsexpr = ATTR(atexpr,e11);
 }
 after_loop: ;
 rhs = rhsexpr;
 if (rhs==NULL) {
  rhs_am = TRANS_transform_expr_dAS(self, rhs, rhs_tp);
 } else
 switch (TAG(rhs)) {
  case AS_CALL_EXPR_tag:
   L7 = (rhs_tp==((dTP) NULL));
   rhs_am = TRANS_transform_call_exp(self, ((AS_CALL_EXPR) rhs), rhs_tp, (!(L7))); break;
  default: ;
   rhs_am = TRANS_transform_expr_dAS(self, rhs, rhs_tp);
 }
 if ((rhs_am==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 current_tp = AM_LOCAL_EXPR_tp_dTP(AM_ROUT_DEF_aget_INT_AM_(ATTR(self,cur_rout), 0));
 if (current_tp==NULL) {
  TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans4));
 } else
 switch (TAG(current_tp)) {
  case TP_CLASS_tag:
   current_class_tp = ((TP_CLASS) current_tp);
   current_params = ATTR(current_class_tp,params);
   num1 = 0;
   L8 = (current_params==((ARRAYdTP) NULL));
   if ((!(L8))) {
    num1 = ARRAYdTP_size_INT(current_params);
   }
   L9 = ATTR(ATTR(self,prog1),parse);
   if (L9==NULL) {
    FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
   }
   current_class_as = (*dPARSE_tree_for_IDENT_IN[TAG(L9)+dPARSE_tree_for_IDENT_IN_offset])(L9, ATTR(current_class_tp,name1), num1); break;
  default: ;
   TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans4));
 }
 if (ATTR(s,transformed)) {
  dummy1 = TRANS_add_helper_to_tbls(self, ATTR(s,helper_class), current_params);
  TRANS_update_routine_in_(self, current_class_tp, ATTR(s,rout1));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 newidattach = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &attach)));
 newidattach_cl = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &attach_cl)));
 newidattach_ob = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &attach_ob)));
 newidgate = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &gate2)));
 SATTR(s,helper_class,newidattach_cl);
 helper1 = TRANS_create_helper_obje(self, ((dAS_STMT) s), newidattach_ob, newidattach_cl, current_class_as, current_params);
 as1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
 SATTR(as1,source11,ATTR(s,source11));
 SATTR(as1,surr_stmt_list,ATTR(s,surr_stmt_list));
 SATTR(as1,name1,newidgate);
 SATTR(as1,rhs,ATTR(s,lhs));
 if ((ret_as==((dAS_STMT) NULL))) {
  ret_as = ((dAS_STMT) as1);
 }
 else {
  L10 = ret_as;
  if (L10==NULL) {
   FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L10)+dAS_STMT_append_dAS_STMT_offset])(L10, ((dAS_STMT) as1));
 }
 L12 = ret_as;
 if (L12==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L12)+dAS_STMT_append_dAS_STMT_offset])(L12, ((dAS_STMT) TRANS_create_helper_obje1(self, newidattach_ob, newidattach_cl, current_class_as, ATTR(s,surr_stmt_list), ATTR(s,source11))));
 L13 = ret_as;
 if (L13==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L13)+dAS_STMT_append_dAS_STMT_offset])(L13, ((dAS_STMT) TRANS_link_helper_stmt_I(self, newidattach_ob, ATTR(s,surr_stmt_list), ATTR(s,source11))));
 {
  struct TRANS_active_locals_and__frame_struct other2_0;
  TRANS_active_locals_and__frame 
  noname1 = &other2_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L14 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop1;
   }
   loc = L14;
   L17 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L17, ((STR) &S_))) {
    L16 = TRUE;
   } else {
    L19 = (ATTR(self,cur_cohort)==((AM_LOCAL_EXPR) NULL));
    if ((!(L19))) {
     L18 = IDENT_is_eq_IDENT_BOOL(ATTR(loc,name1), ATTR(ATTR(self,cur_cohort),name1));
    } else {
     L18 = FALSE;
    }
    L16 = L18;
   }
   if (L16) {
    if ((ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL))) {
     L20 = TRUE;
    } else {
     L21 = TRANS_local_is_in_par_he(self, ATTR(loc,name1), ATTR(self,cur_param_ob));
     L20 = (!(L21));
    }
    L15 = L20;
   } else {
    L15 = FALSE;
   }
   if (L15) {
    exp1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
    SATTR(exp1,source11,ATTR(s,source11));
    SATTR(exp1,surr_stmt_list,ATTR(s,surr_stmt_list));
    SATTR(exp1,lhs_expr,((dAS_EXPR) TRANS_as_of_local_in_hel(self, ATTR(loc,name1), helper1, ATTR(s,source11))));
    rhsx = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(rhsx,source11,ATTR(s,source11));
    SATTR(rhsx,name1,ATTR(loc,name1));
    SATTR(exp1,rhs,((dAS_EXPR) rhsx));
    L22 = ret_as;
    if (L22==NULL) {
     FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L22)+dAS_STMT_append_dAS_STMT_offset])(L22, ((dAS_STMT) exp1));
   }
  }
 }
 after_loop1: ;
 L23 = ret_as;
 if (L23==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L23)+dAS_STMT_append_dAS_STMT_offset])(L23, TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(s,surr_stmt_list), ATTR(s,source11)));
 attachbody = AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL));
 SATTR(attachbody,source11,ATTR(s,source11));
 L24 = (rhs_tp==((dTP) NULL));
 if ((!(L24))) {
  call11 = AS_EXPR_STMT_create_AS_E(((AS_EXPR_STMT) NULL));
  SATTR(call11,source11,ATTR(s,source11));
  SATTR(call11,surr_stmt_list,attachbody);
  callexpr = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(callexpr,source11,ATTR(s,source11));
  SATTR(callexpr,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &enqueue)));
  callexprob = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(callexprob,source11,ATTR(s,source11));
  SATTR(callexprob,name1,newidgate);
  SATTR(callexpr,ob1,((dAS_EXPR) callexprob));
  SATTR(callexpr,args1,rhs);
  SATTR(call11,e11,((dAS_EXPR) callexpr));
  SATTR(call11,transformed,TRUE);
  SATTR(attachbody,stmts,((dAS_STMT) call11));
 }
 else {
  exprstmt = AS_EXPR_STMT_create_AS_E(((AS_EXPR_STMT) NULL));
  SATTR(exprstmt,source11,ATTR(s,source11));
  SATTR(exprstmt,surr_stmt_list,attachbody);
  SATTR(exprstmt,e11,rhs);
  SATTR(attachbody,stmts,((dAS_STMT) exprstmt));
  call2 = AS_EXPR_STMT_create_AS_E(((AS_EXPR_STMT) NULL));
  SATTR(call2,source11,ATTR(s,source11));
  SATTR(call2,surr_stmt_list,attachbody);
  callexpr1 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(callexpr1,source11,ATTR(s,source11));
  SATTR(callexpr1,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &enqueue)));
  callexprob1 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
  SATTR(callexprob1,source11,ATTR(s,source11));
  SATTR(callexprob1,name1,newidgate);
  SATTR(callexpr1,ob1,((dAS_EXPR) callexprob1));
  SATTR(call2,e11,((dAS_EXPR) callexpr1));
  SATTR(call2,transformed,TRUE);
  L25 = ATTR(attachbody,stmts);
  if (L25==NULL) {
   FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L25)+dAS_STMT_append_dAS_STMT_offset])(L25, ((dAS_STMT) call2));
 }
 SATTR(s,rout1,TRANS_turn_into_routine_(self, newidattach, newidattach_ob, newidattach_cl, helper1, current_class_as, current_class_tp, newidgate, lhs_as, attachbody, TRANS_att_code, ATTR(s,source11)));
 att8 = AS_INTERF_ATTACH_STMT_cr(((AS_INTERF_ATTACH_STMT) NULL));
 SATTR(att8,source11,ATTR(s,source11));
 SATTR(att8,surr_stmt_list,ATTR(s,surr_stmt_list));
 SATTR(att8,routname1,newidattach);
 SATTR(att8,helpername,newidattach_ob);
 SATTR(att8,gatename,newidgate);
 SATTR(att8,at11,at);
 L26 = ret_as;
 if (L26==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L26)+dAS_STMT_append_dAS_STMT_offset])(L26, ((dAS_STMT) att8));
 L27 = ret_as;
 if (L27==NULL) {
  FATAL("Dispatch on void in TRANS::transform_attach_stmt(AS_ATTACH_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L27)+dAS_STMT_append_dAS_STMT_offset])(L27, ATTR(s,next));
 SATTR(s,next,ret_as);
 SATTR(s,dont_print,TRUE);
 ret_val = ((dAM_STMT) NULL);
 return ret_val;
}


dAM_STMT TRANS_transform_call_ass(TRANS self, AS_CALL_EXPR l, AS_ASSIGN_STMT s) {
 dAM_STMT ret_val;
 AM_LOCAL_EXPR loc;
 dAM_STMT r;
 AM_EXPR_STMT r11;
 BOOL L1;
 extern STR Itisillegaltoassigntoaca;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 L1 = (ATTR(l,args1)==((dAS_EXPR) NULL));
 if ((!(L1))) {
  TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) l));
  TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoaca));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if ((ATTR(l,ob1)==((dAS_EXPR) NULL))) {
  L2 = (ATTR(l,tp1)==((AS_TYPE_SPEC) NULL));
 } else {
  L2 = FALSE;
 }
 if (L2) {
  loc = TRANS_local_with_name_ID(self, ATTR(l,name1));
  L3 = (loc==((AM_LOCAL_EXPR) NULL));
  if ((!(L3))) {
   r = TRANS_transform_local_as(self, loc, s);
   ret_val = r;
   return ret_val;
  }
 }
 SATTR(l,args1,ATTR(s,rhs));
 r11 = AM_EXPR_STMT_create_SFIL(((AM_EXPR_STMT) NULL), ATTR(l,source11));
 SATTR(r11,expr,TRANS_transform_call_exp(self, l, ((dTP) NULL), FALSE));
 SATTR(l,args1,((dAS_EXPR) NULL));
 L4 = (ATTR(r11,expr)==((dAM_EXPR) NULL));
 if ((!(L4))) {
  ret_val = ((dAM_STMT) r11);
  return ret_val;
 }
 else {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dAM_STMT TRANS_transform_case_stm(TRANS self, AS_CASE_STMT s) {
 dAM_STMT ret_val;
 AM_ASSIGN_STMT r;
 AM_LOCAL_EXPR l;
 AS_CASE_WHEN wp;
 AS_CASE_WHEN wp1;
 dAS_STMT sys_imp;
 dAS_STMT sys_imp1;
 SFILE_ID L1;
 dAM_EXPR L2;
 BOOL L3;
 BOOL L4;
 dAS_STMT L5;
 dAS_STMT L6;
 BOOL L7;
 dAS_STMT L8;
 dAS_STMT L9;
 if ((s==((AS_CASE_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 r = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(s,source11));
 SATTR(r,src11,TRANS_transform_expr_dAS(self, ATTR(s,test1), ((dTP) NULL)));
 if ((ATTR(r,src11)==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L1 = ATTR(s,source11);
 L2 = ATTR(r,src11);
 if (L2==NULL) {
  FATAL("Dispatch on void in TRANS::transform_case_stmt(AS_CASE_STMT):$AM_STMT");
 }
 l = AM_LOCAL_EXPR_create_SFI1(((AM_LOCAL_EXPR) NULL), L1, IDENT_zero, (*dAM_EXPR_tp_dTP[TAG(L2)+dAM_EXPR_tp_dTP_offset])(L2));
 TRANS_add_local_AM_LOCAL(self, l);
 SATTR(r,dest,((dAM_EXPR) l));
 if (ATTR(ATTR(self,prog1),psather)) {
  L3 = ATTR(s,transformed);
  if ((!(L3))) {
   if (AM_ROUT_DEF_import_local(ATTR(self,cur_rout))) {
    wp = ATTR(s,when_part);
    while (1) {
     if ((wp==((AS_CASE_WHEN) NULL))) {
      goto after_loop;
     }
     TRANS_insert_import_AS_S(self, ATTR(wp,then_part), ATTR(s,source11));
     wp = ATTR(wp,next);
    }
    after_loop: ;
    L4 = (ATTR(s,else_part)==((AS_STMT_LIST) NULL));
    if ((!(L4))) {
     TRANS_insert_import_AS_S(self, ATTR(s,else_part), ATTR(s,source11));
    }
   }
   if (AM_ROUT_DEF_import_call_(ATTR(self,cur_rout))) {
    wp1 = ATTR(s,when_part);
    while (1) {
     if ((wp1==((AS_CASE_WHEN) NULL))) {
      goto after_loop1;
     }
     sys_imp = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(wp1,then_part), ATTR(s,source11));
     L5 = sys_imp;
     if (L5==NULL) {
      FATAL("Dispatch on void in TRANS::transform_case_stmt(AS_CASE_STMT):$AM_STMT");
     }
     (*dAS_STMT_transformed_BOO[TAG(L5)+dAS_STMT_transformed_BOO_offset])(L5, TRUE);
     L6 = sys_imp;
     if (L6==NULL) {
      FATAL("Dispatch on void in TRANS::transform_case_stmt(AS_CASE_STMT):$AM_STMT");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L6)+dAS_STMT_append_dAS_STMT_offset])(L6, ATTR(ATTR(wp1,then_part),stmts));
     SATTR(ATTR(wp1,then_part),stmts,sys_imp);
     wp1 = ATTR(wp1,next);
    }
    after_loop1: ;
    L7 = (ATTR(s,else_part)==((AS_STMT_LIST) NULL));
    if ((!(L7))) {
     sys_imp1 = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,else_part), ATTR(s,source11));
     L8 = sys_imp1;
     if (L8==NULL) {
      FATAL("Dispatch on void in TRANS::transform_case_stmt(AS_CASE_STMT):$AM_STMT");
     }
     (*dAS_STMT_transformed_BOO[TAG(L8)+dAS_STMT_transformed_BOO_offset])(L8, TRUE);
     L9 = sys_imp1;
     if (L9==NULL) {
      FATAL("Dispatch on void in TRANS::transform_case_stmt(AS_CASE_STMT):$AM_STMT");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L9)+dAS_STMT_append_dAS_STMT_offset])(L9, ATTR(ATTR(s,else_part),stmts));
     SATTR(ATTR(s,else_part),stmts,sys_imp1);
    }
   }
  }
  AM_ROUT_DEF_import_done(ATTR(self,cur_rout));
 }
 SATTR(r,next1,TRANS_transform_case_whe(self, s, ATTR(s,when_part), l));
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_case_whe(TRANS self, AS_CASE_STMT s, AS_CASE_WHEN cw, AM_LOCAL_EXPR l) {
 dAM_STMT ret_val;
 AM_CASE_STMT r;
 dAM_STMT r11;
 dCALL_TP ct;
 dAM_EXPR v11 = ((dAM_EXPR) NULL);
 dAM_CONST cv;
 AM_CASE_STMT r21;
 dAS_STMT last_then;
 FLISTdAM_CONST ls = ((FLISTdAM_CONST) NULL);
 CALL_SIG cs;
 SIG sig1;
 AM_ROUT_CALL_EXPR arc;
 AM_IF_STMT r3;
 BOOL L1;
 FLISTdAM_STMT L2;
 BOOL L3;
 BOOL L4;
 FLISTdAM_STMT L5;
 BOOL L6;
 ARRAYdCALL_TP L7;
 dAM_EXPR L8;
 dTP L9;
 extern STR Theis_eqroutinecorrespon;
 dAS_EXPR L10;
 if ((cw==((AS_CASE_WHEN) NULL))) {
  if (ATTR(s,no_else)) {
   r = AM_CASE_STMT_create_SFIL(((AM_CASE_STMT) NULL), ATTR(s,source11));
   SATTR(r,test11,((dAM_EXPR) l));
   SATTR(r,no_else,TRUE);
   ret_val = ((dAM_STMT) r);
   return ret_val;
  }
  else {
   r11 = TRANS_transform_stmt_lis(self, ATTR(s,else_part));
   ret_val = r11;
   return ret_val;
  }
 }
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) cw));
 ct = TRANS_call_tp_of_expr_dA(self, ATTR(cw,val11));
 if ((ct==((dCALL_TP) NULL))) {
  v11 = TRANS_transform_expr_dAS(self, ATTR(cw,val11), ((dTP) NULL));
  if ((v11==((dAM_EXPR) NULL))) {
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  cv = TRANS_const_to_switch_dA(self, v11);
  L1 = (cv==((dAM_CONST) NULL));
  if ((!(L1))) {
   r21 = AM_CASE_STMT_create_SFIL(((AM_CASE_STMT) NULL), ATTR(cw,source11));
   SATTR(r21,test11,((dAM_EXPR) l));
   last_then = ATTR(ATTR(cw,then_part),stmts);
   ls = FLISTdAM_CONST_push_dAM_(ls, cv);
   SATTR(r21,tgts,FLISTFLISTdAM_CONST_push(ATTR(r21,tgts), ls));
   L2 = ATTR(r21,stmts);
   SATTR(r21,stmts,FLISTdAM_STMT_push_dAM_S(L2, TRANS_transform_stmt_lis(self, ATTR(cw,then_part))));
   while (1) {
    cw = ATTR(cw,next);
    if ((cw==((AS_CASE_WHEN) NULL))) {
     if (ATTR(s,no_else)) {
      SATTR(r21,no_else,TRUE);
     }
     else {
      SATTR(r21,else_stmts,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
     }
     ret_val = ((dAM_STMT) r21);
     return ret_val;
    }
    L3 = (TRANS_call_tp_of_expr_dA(self, ATTR(cw,val11))==((dCALL_TP) NULL));
    if ((!(L3))) {
     SATTR(r21,else_stmts,TRANS_transform_case_whe(self, s, cw, l));
     ret_val = ((dAM_STMT) r21);
     return ret_val;
    }
    v11 = TRANS_transform_expr_dAS(self, ATTR(cw,val11), ((dTP) NULL));
    if ((v11==((dAM_EXPR) NULL))) {
     ret_val = ((dAM_STMT) NULL);
     return ret_val;
    }
    cv = TRANS_const_to_switch_dA(self, v11);
    L4 = (cv==((dAM_CONST) NULL));
    if ((!(L4))) {
     if (SYSOBEQ(((OB) last_then),((OB) ATTR(cw,then_part)))) {
      ls = FLISTFLISTdAM_CONST_pop_(ATTR(r21,tgts));
      ls = FLISTdAM_CONST_push_dAM_(ls, cv);
      SATTR(r21,tgts,FLISTFLISTdAM_CONST_push(ATTR(r21,tgts), ls));
     }
     else {
      ls = ((FLISTdAM_CONST) NULL);
      ls = FLISTdAM_CONST_push_dAM_(ls, cv);
      SATTR(r21,tgts,FLISTFLISTdAM_CONST_push(ATTR(r21,tgts), ls));
      L5 = ATTR(r21,stmts);
      SATTR(r21,stmts,FLISTdAM_STMT_push_dAM_S(L5, TRANS_transform_stmt_lis(self, ATTR(cw,then_part))));
     }
    }
    else {
     SATTR(r21,else_stmts,TRANS_transform_case_whe(self, s, cw, l));
     ret_val = ((dAM_STMT) r21);
     return ret_val;
    }
   }
   after_loop: ;
  }
 }
 cs = CALL_SIG_create_CALL_SIG(((CALL_SIG) NULL));
 SATTR(cs,tp1,ATTR(l,tp_at));
 SATTR(cs,name1,IDENT_BUILTIN_is_eq_iden1);
 SATTR(cs,has_ret,TRUE);
 SATTR(cs,args1,ARRAYdCALL_TP_create_INT(((ARRAYdCALL_TP) NULL), 1));
 L6 = (ct==((dCALL_TP) NULL));
 if ((!(L6))) {
  ARRAYdCALL_TP_aset_INT_d(ATTR(cs,args1), 0, ct);
 }
 else {
  L7 = ATTR(cs,args1);
  L8 = v11;
  if (L8==NULL) {
   FATAL("Dispatch on void in TRANS::transform_case_when(AS_CASE_STMT,AS_CASE_WHEN,AM_LOCAL_EXPR):$AM_STMT");
  }
  ARRAYdCALL_TP_aset_INT_d(L7, 0, ((dCALL_TP) (*dAM_EXPR_tp_dTP[TAG(L8)+dAM_EXPR_tp_dTP_offset])(L8)));
 }
 sig1 = CALL_SIG_lookup_BOOL_SIG(cs, TP_CLASS_is_eq_dTP_BOOL(ATTR(ATTR(self,tp_con),same11), ATTR(cs,tp1)));
 if ((sig1==((SIG) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L9 = ATTR(sig1,ret1);
 if (L9==NULL) {
  FATAL("Dispatch on void in TRANS::transform_case_when(AS_CASE_STMT,AS_CASE_WHEN,AM_LOCAL_EXPR):$AM_STMT");
 }
 if ((*dTP_is_neq_dTP_BOOL[TAG(L9)+dTP_is_neq_dTP_BOOL_offset])(L9, ((dTP) TP_BUILTIN_bool))) {
  TRANS_err_STR(self, ((STR) &Theis_eqroutinecorrespon));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if ((v11==((dAM_EXPR) NULL))) {
  L10 = ATTR(cw,val11);
  v11 = TRANS_transform_expr_dAS(self, L10, ARRAYdTP_aget_INT_dTP(ATTR(sig1,args1), 0));
 }
 if ((v11==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 arc = AM_ROUT_CALL_EXPR_create(((AM_ROUT_CALL_EXPR) NULL), 2, ATTR(cw,source11));
 SATTR(arc,fun,sig1);
 AM_ROUT_CALL_EXPR_aset_I(arc, 0, ((dAM_EXPR) l));
 AM_ROUT_CALL_EXPR_aset_I(arc, 1, v11);
 r3 = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(cw,source11));
 SATTR(r3,test11,TRANS_inline_AM_ROUT_CAL(self, arc));
 SATTR(r3,if_true,TRANS_transform_stmt_lis(self, ATTR(cw,then_part)));
 SATTR(r3,if_false,TRANS_transform_case_whe(self, s, ATTR(cw,next), l));
 ret_val = ((dAM_STMT) r3);
 return ret_val;
}


dAM_STMT TRANS_transform_expr_stm(TRANS self, AS_EXPR_STMT s) {
 dAM_STMT ret_val;
 dAS_EXPR e;
 AM_BREAK_STMT r;
 AM_EXPR_STMT r11;
 dAS_EXPR at;
 dAM_EXPR at_am;
 BOOL L1;
 BOOL L2;
 e = ATTR(s,e11);
 if (e==NULL) {
  TRANS_expr_stmt_err_AS_E(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 } else
 switch (TAG(e)) {
  case AS_BREAK_EXPR_tag:
   if ((ATTR(self,cur_loop)==((AM_LOOP_STMT) NULL))) {
    TRANS_break_not_in_loop_(self, s);
    ret_val = ((dAM_STMT) NULL);
    return ret_val;
   }
   r = AM_BREAK_STMT_create_SFI(((AM_BREAK_STMT) NULL), ATTR(s,source11));
   ret_val = ((dAM_STMT) r);
   return ret_val; break;
  case AS_CALL_EXPR_tag:
   r11 = AM_EXPR_STMT_create_SFIL(((AM_EXPR_STMT) NULL), ATTR(s,source11));
   SATTR(r11,expr,TRANS_transform_call_exp(self, ((AS_CALL_EXPR) e), ((dTP) NULL), FALSE));
   L1 = (ATTR(s,at11)==((dAS_EXPR) NULL));
   if ((!(L1))) {
    SATTR(r11,at11,TRANS_transform_expr_dAS(self, ATTR(s,at11), ((dTP) TP_BUILTIN_int)));
   }
   L2 = (ATTR(r11,expr)==((dAM_EXPR) NULL));
   if ((!(L2))) {
    ret_val = ((dAM_STMT) r11);
    return ret_val;
   }
   else {
    ret_val = ((dAM_STMT) NULL);
    return ret_val;
   } break;
  case AS_AT_EXPR_tag:
   at = ATTR(((AS_AT_EXPR) e),at11);
   at_am = TRANS_transform_expr_dAS(self, at, ((dTP) TP_BUILTIN_int));
   SATTR(s,e11,ATTR(((AS_AT_EXPR) e),e11));
   SATTR(s,at11,ATTR(((AS_AT_EXPR) e),at11));
   ret_val = TRANS_transform_expr_stm(self, s);
   return ret_val; break;
  default: ;
   TRANS_expr_stmt_err_AS_E(self, s);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dAM_STMT TRANS_transform_fork_stm(TRANS self, AS_FORK_STMT s) {
 dAM_STMT ret_val;
 dAS_STMT ret_as = ((dAS_STMT) NULL);
 dTP current_tp;
 TP_CLASS current_class_tp = ((TP_CLASS) NULL);
 AS_CLASS_DEF current_class_as = ((AS_CLASS_DEF) NULL);
 ARRAYdTP current_params = ((ARRAYdTP) NULL);
 INT num1 = ((INT) 0);
 TP_CLASS dummy1;
 IDENT newidfork = IDENT_zero;
 IDENT newidparams_cl = IDENT_zero;
 IDENT newidparams_ob = IDENT_zero;
 AM_LOCAL_EXPR helper1;
 AS_ASSIGN_STMT chos;
 TRANS L11;
 AM_LOCAL_EXPR loc;
 AS_ASSIGN_STMT exp1;
 AS_CALL_EXPR rhs;
 AS_INTERF_ATTACH_STMT att8;
 BOOL L2;
 extern STR CompilerErrorPTRANStrans5;
 BOOL L3;
 dPARSE L4;
 extern STR CompilerErrorPTRANStrans5;
 extern STR fork11;
 extern STR params_cl;
 extern STR params_ob;
 dAS_STMT L5;
 dAS_STMT L6;
 AM_LOCAL_EXPR L7;
 BOOL L8;
 STR L9;
 extern STR S_;
 BOOL L10;
 dAS_STMT L12;
 dAS_STMT L13;
 dAS_STMT L14;
 dAS_STMT L15;
 L2 = TRANS_is_in_par_or_fork_(self);
 if ((!(L2))) {
  TRANS_fork_outside_par_e(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 current_tp = AM_LOCAL_EXPR_tp_dTP(AM_ROUT_DEF_aget_INT_AM_(ATTR(self,cur_rout), 0));
 if (current_tp==NULL) {
  TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans5));
 } else
 switch (TAG(current_tp)) {
  case TP_CLASS_tag:
   current_class_tp = ((TP_CLASS) current_tp);
   current_params = ATTR(current_class_tp,params);
   num1 = 0;
   L3 = (current_params==((ARRAYdTP) NULL));
   if ((!(L3))) {
    num1 = ARRAYdTP_size_INT(current_params);
   }
   L4 = ATTR(ATTR(self,prog1),parse);
   if (L4==NULL) {
    FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
   }
   current_class_as = (*dPARSE_tree_for_IDENT_IN[TAG(L4)+dPARSE_tree_for_IDENT_IN_offset])(L4, ATTR(current_class_tp,name1), num1); break;
  default: ;
   TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans5));
 }
 if (ATTR(s,transformed)) {
  dummy1 = TRANS_add_helper_to_tbls(self, ATTR(s,helper_class), current_params);
  TRANS_update_routine_in_(self, current_class_tp, ATTR(s,rout1));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 newidfork = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &fork11)));
 newidparams_cl = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &params_cl)));
 newidparams_ob = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &params_ob)));
 SATTR(s,helper_class,newidparams_cl);
 helper1 = TRANS_create_helper_obje(self, ((dAS_STMT) s), newidparams_ob, newidparams_cl, current_class_as, current_params);
 chos = TRANS_create_helper_obje1(self, newidparams_ob, newidparams_cl, current_class_as, ATTR(s,surr_stmt_list), ATTR(s,source11));
 if ((ret_as==((dAS_STMT) NULL))) {
  ret_as = ((dAS_STMT) chos);
 }
 else {
  L5 = ret_as;
  if (L5==NULL) {
   FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L5)+dAS_STMT_append_dAS_STMT_offset])(L5, ((dAS_STMT) chos));
 }
 L6 = ret_as;
 if (L6==NULL) {
  FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L6)+dAS_STMT_append_dAS_STMT_offset])(L6, ((dAS_STMT) TRANS_link_helper_stmt_I(self, newidparams_ob, ATTR(s,surr_stmt_list), ATTR(s,source11))));
 {
  struct TRANS_active_locals_and__frame_struct other1_0;
  TRANS_active_locals_and__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L7 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   loc = L7;
   L9 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L9, ((STR) &S_))) {
    L10 = TRANS_local_is_in_par_he(self, ATTR(loc,name1), ATTR(self,cur_param_ob));
    L8 = (!(L10));
   } else {
    L8 = FALSE;
   }
   if (L8) {
    exp1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
    SATTR(exp1,source11,ATTR(s,source11));
    SATTR(exp1,surr_stmt_list,ATTR(s,surr_stmt_list));
    SATTR(exp1,lhs_expr,((dAS_EXPR) TRANS_as_of_local_in_hel(self, ATTR(loc,name1), helper1, ATTR(s,source11))));
    rhs = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(rhs,source11,ATTR(s,source11));
    SATTR(rhs,name1,ATTR(loc,name1));
    SATTR(exp1,rhs,((dAS_EXPR) rhs));
    L12 = ret_as;
    if (L12==NULL) {
     FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L12)+dAS_STMT_append_dAS_STMT_offset])(L12, ((dAS_STMT) exp1));
   }
  }
 }
 after_loop: ;
 L13 = ret_as;
 if (L13==NULL) {
  FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L13)+dAS_STMT_append_dAS_STMT_offset])(L13, TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(s,surr_stmt_list), ATTR(s,source11)));
 SATTR(s,rout1,TRANS_turn_into_routine_(self, newidfork, newidparams_ob, newidparams_cl, helper1, current_class_as, current_class_tp, ATTR(ATTR(self,cur_cohort),name1), ((AS_TYPE_SPEC) NULL), ATTR(s,body), TRANS_frk_code, ATTR(s,source11)));
 SATTR(s,body,((AS_STMT_LIST) NULL));
 att8 = AS_INTERF_ATTACH_STMT_cr(((AS_INTERF_ATTACH_STMT) NULL));
 SATTR(att8,source11,ATTR(s,source11));
 SATTR(att8,surr_stmt_list,ATTR(s,surr_stmt_list));
 SATTR(att8,routname1,newidfork);
 SATTR(att8,helpername,newidparams_ob);
 SATTR(att8,gatename,ATTR(ATTR(self,cur_cohort),name1));
 SATTR(att8,at11,ATTR(s,at11));
 L14 = ret_as;
 if (L14==NULL) {
  FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L14)+dAS_STMT_append_dAS_STMT_offset])(L14, ((dAS_STMT) att8));
 L15 = ret_as;
 if (L15==NULL) {
  FATAL("Dispatch on void in TRANS::transform_fork_stmt(AS_FORK_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L15)+dAS_STMT_append_dAS_STMT_offset])(L15, ATTR(s,next));
 SATTR(s,next,ret_as);
 ret_val = ((dAM_STMT) NULL);
 return ret_val;
}


dAM_STMT TRANS_transform_if_stmt_(TRANS self, AS_IF_STMT s) {
 dAM_STMT ret_val;
 AM_IF_STMT r;
 dAS_STMT sys_imp;
 dAS_STMT sys_imp1;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 dAS_STMT L5;
 dAS_STMT L6;
 BOOL L7;
 dAS_STMT L8;
 dAS_STMT L9;
 r = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(s,source11));
 SATTR(r,test11,TRANS_transform_expr_dAS(self, ATTR(s,test1), ((dTP) TP_BUILTIN_bool)));
 if ((ATTR(r,test11)==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (ATTR(ATTR(self,prog1),psather)) {
  L1 = ATTR(s,transformed);
  if ((!(L1))) {
   if (AM_ROUT_DEF_import_local(ATTR(self,cur_rout))) {
    L2 = (ATTR(s,then_part)==((AS_STMT_LIST) NULL));
    if ((!(L2))) {
     TRANS_insert_import_AS_S(self, ATTR(s,then_part), ATTR(s,source11));
    }
    L3 = (ATTR(s,else_part)==((AS_STMT_LIST) NULL));
    if ((!(L3))) {
     TRANS_insert_import_AS_S(self, ATTR(s,else_part), ATTR(s,source11));
    }
   }
   if (AM_ROUT_DEF_import_call_(ATTR(self,cur_rout))) {
    L4 = (ATTR(s,then_part)==((AS_STMT_LIST) NULL));
    if ((!(L4))) {
     sys_imp = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,then_part), ATTR(s,source11));
     L5 = sys_imp;
     if (L5==NULL) {
      FATAL("Dispatch on void in TRANS::transform_if_stmt(AS_IF_STMT):$AM_STMT");
     }
     (*dAS_STMT_transformed_BOO[TAG(L5)+dAS_STMT_transformed_BOO_offset])(L5, TRUE);
     L6 = sys_imp;
     if (L6==NULL) {
      FATAL("Dispatch on void in TRANS::transform_if_stmt(AS_IF_STMT):$AM_STMT");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L6)+dAS_STMT_append_dAS_STMT_offset])(L6, ATTR(ATTR(s,then_part),stmts));
     SATTR(ATTR(s,then_part),stmts,sys_imp);
    }
    L7 = (ATTR(s,else_part)==((AS_STMT_LIST) NULL));
    if ((!(L7))) {
     sys_imp1 = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,else_part), ATTR(s,source11));
     L8 = sys_imp1;
     if (L8==NULL) {
      FATAL("Dispatch on void in TRANS::transform_if_stmt(AS_IF_STMT):$AM_STMT");
     }
     (*dAS_STMT_transformed_BOO[TAG(L8)+dAS_STMT_transformed_BOO_offset])(L8, TRUE);
     L9 = sys_imp1;
     if (L9==NULL) {
      FATAL("Dispatch on void in TRANS::transform_if_stmt(AS_IF_STMT):$AM_STMT");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L9)+dAS_STMT_append_dAS_STMT_offset])(L9, ATTR(ATTR(s,else_part),stmts));
     SATTR(ATTR(s,else_part),stmts,sys_imp1);
    }
   }
  }
  AM_ROUT_DEF_import_done(ATTR(self,cur_rout));
 }
 SATTR(r,if_true,TRANS_transform_stmt_lis(self, ATTR(s,then_part)));
 SATTR(r,if_false,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_interf_a(TRANS self, AS_INTERF_ATTACH_STMT s) {
 dAM_STMT ret_val;
 AM_ATTACH_STMT r;
 AS_CALL_EXPR callexpr;
 AS_CALL_EXPR arg11;
 AS_CALL_EXPR arg21;
 AS_INT_LIT_EXPR arg31;
 dAM_EXPR callam;
 BOOL L1;
 dTP L2;
 extern STR CompilerErrorPTRANStrans1;
 extern STR CompilerErrorPTRANStrans2;
 extern STR CompilerErrorPTRANStrans2;
 r = AM_ATTACH_STMT_create_SF(((AM_ATTACH_STMT) NULL), ATTR(s,source11));
 SATTR(r,helper,TRANS_local_with_name_ID(self, ATTR(s,helpername)));
 SATTR(r,gate1,TRANS_local_with_name_ID(self, ATTR(s,gatename)));
 L1 = (ATTR(s,at11)==((dAS_EXPR) NULL));
 if ((!(L1))) {
  SATTR(r,at11,TRANS_transform_expr_dAS(self, ATTR(s,at11), ((dTP) TP_BUILTIN_int)));
 }
 callexpr = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(callexpr,source11,ATTR(s,source11));
 SATTR(callexpr,name1,ATTR(s,routname1));
 arg11 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(arg11,source11,ATTR(s,source11));
 SATTR(arg11,name1,ATTR(s,helpername));
 arg21 = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(arg21,source11,ATTR(s,source11));
 SATTR(arg21,name1,ATTR(s,gatename));
 arg31 = AS_INT_LIT_EXPR_create_A(((AS_INT_LIT_EXPR) NULL));
 SATTR(arg31,source11,ATTR(s,source11));
 SATTR(arg31,val11,INTI_create_INT_INTI(((INTI) NULL), 0));
 SATTR(arg11,next,((dAS_EXPR) arg21));
 SATTR(arg21,next,((dAS_EXPR) arg31));
 SATTR(callexpr,args1,((dAS_EXPR) arg11));
 L2 = AM_LOCAL_EXPR_tp_dTP(AM_ROUT_DEF_aget_INT_AM_(ATTR(self,cur_rout), 0));
 callam = TRANS_transform_call_exp(self, callexpr, L2, FALSE);
 if ((callam==((dAM_EXPR) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans1));
 }
 else {
  if (callam==NULL) {
   TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans2));
  } else
  switch (TAG(callam)) {
   case AM_ROUT_CALL_EXPR_tag:
    SATTR(r,rout1,ATTR(((AM_ROUT_CALL_EXPR) callam),fun)); break;
   default: ;
    TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans2));
  }
  SATTR(ATTR(self,cur_rout),calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(ATTR(self,cur_rout),calls1), callam));
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_local_as(TRANS self, AM_LOCAL_EXPR loc, AS_ASSIGN_STMT s) {
 dAM_STMT ret_val;
 AM_ASSIGN_STMT r;
 extern STR Itisillegaltoassigntothe;
 dAS_EXPR L1;
 if (ATTR(loc,no_assign)) {
  TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
  TRANS_err_STR(self, ((STR) &Itisillegaltoassigntothe));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 r = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(s,source11));
 SATTR(r,dest,((dAM_EXPR) loc));
 if (ATTR(self,in_protect_body)) {
  SATTR(loc,is_volatile,TRUE);
 }
 L1 = ATTR(s,rhs);
 SATTR(r,src11,TRANS_transform_expr_dAS(self, L1, AM_LOCAL_EXPR_tp_dTP(loc)));
 if ((ATTR(r,src11)==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (ATTR(ATTR(self,prog1),psather)) {
  TRANS_transform_pSather_2(self, loc, s);
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_lock_stm(TRANS self, AS_LOCK_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT ret = ((dAM_STMT) NULL);
 AM_LOCK_STMT r;
 dAS_EXPR lck;
 INT L11 = ((INT) 0);
 INT idx = ((INT) 0);
 dAS_STMT import1;
 dAM_STMT L2;
 BOOL L3;
 INT L4;
 ARRAYdAM_EXPR L5;
 dAS_EXPR L6;
 BOOL L7;
 dAS_STMT L8;
 r = AM_LOCK_STMT_create_SFIL(((AM_LOCK_STMT) NULL), ATTR(s,source11));
 if ((ret==((dAM_STMT) NULL))) {
  ret = ((dAM_STMT) r);
 }
 else {
  L2 = ret;
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::transform_lock_stmt(AS_LOCK_STMT):$AM_STMT");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L2)+dAM_STMT_append_dAM_STMT_offset])(L2, ((dAM_STMT) r));
 }
 SATTR(r,locks1,ARRAYdAM_EXPR_create_INT(((ARRAYdAM_EXPR) NULL), AS_LOCK_STMT_elts_size_I(s)));
 lck = ATTR(s,e_list);
 {
  struct INT_upb_INT_frame_struct other1_0;
  INT_upb_INT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   L3 = (lck==((dAS_EXPR) NULL));
   if ((!(L3))) {
   }
   else {
    goto after_loop;
   }
   if (noname1->state == 0) {
    L11 = 0;
    noname1->self = L11;
   }
   L4 = INT_upb_INT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   idx = L4;
   L5 = ATTR(r,locks1);
   ARRAYdAM_EXPR_aset_INT_d(L5, idx, TRANS_transform_expr_dAS(self, lck, ((dTP) TP_BUILTIN_dollar_lock)));
   L6 = lck;
   if (L6==NULL) {
    FATAL("Dispatch on void in TRANS::transform_lock_stmt(AS_LOCK_STMT):$AM_STMT");
   }
   lck = (*dAS_EXPR_next_dAS_EXPR[TAG(L6)+dAS_EXPR_next_dAS_EXPR_offset])(L6);
  }
 }
 after_loop: ;
 SATTR(self,cur_lock,((dAM_STMT) r));
 L7 = ATTR(s,transformed);
 if ((!(L7))) {
  if ((ATTR(s,then_part)==((AS_STMT_LIST) NULL))) {
   SATTR(s,then_part,AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL)));
   SATTR(ATTR(s,then_part),source11,ATTR(s,source11));
  }
  import1 = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,then_part), ATTR(s,source11));
  if ((ATTR(ATTR(s,then_part),stmts)==((dAS_STMT) NULL))) {
   SATTR(ATTR(s,then_part),stmts,import1);
  }
  else {
   L8 = import1;
   if (L8==NULL) {
    FATAL("Dispatch on void in TRANS::transform_lock_stmt(AS_LOCK_STMT):$AM_STMT");
   }
   (*dAS_STMT_next_dAS_STMT1[TAG(L8)+dAS_STMT_next_dAS_STMT1_offset])(L8, ATTR(ATTR(s,then_part),stmts));
   SATTR(ATTR(s,then_part),stmts,import1);
  }
  TRANS_append_export_in_l(self, ATTR(s,then_part), FALSE);
 }
 SATTR(r,body,TRANS_transform_stmt_lis(self, ATTR(s,then_part)));
 SATTR(self,cur_lock,((dAM_STMT) NULL));
 ret_val = ret;
 return ret_val;
}


dAM_STMT TRANS_transform_loop_stm(TRANS self, AS_LOOP_STMT s) {
 dAM_STMT ret_val;
 AM_LOOP_STMT ol;
 AM_LOOP_STMT r;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 ol = ATTR(self,cur_loop);
 r = AM_LOOP_STMT_create_SFIL(((AM_LOOP_STMT) NULL), ATTR(s,source11));
 SATTR(self,cur_loop,r);
 SATTR(r,body,TRANS_transform_stmt_lis(self, ATTR(s,body)));
 L2 = (ol==((AM_LOOP_STMT) NULL));
 if ((!(L2))) {
  L3 = (r==((AM_LOOP_STMT) NULL));
  L1 = (!(L3));
 } else {
  L1 = FALSE;
 }
 if (L1) {
  if (ATTR(ol,has_yield)) {
   L4 = TRUE;
  } else {
   L4 = ATTR(r,has_yield);
  }
  SATTR(ol,has_yield,L4);
 }
 SATTR(self,cur_loop,ol);
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_pSather_4(TRANS self, dAS_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT r = ((dAM_STMT) NULL);
 if ((s==((dAS_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (s==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(s)) {
  case AS_PAR_STMT_tag:
   r = TRANS_transform_par_stmt(self, ((AS_PAR_STMT) s)); break;
  case AS_INTERF_ATTACH_STMT_tag:
   r = TRANS_transform_interf_a(self, ((AS_INTERF_ATTACH_STMT) s)); break;
  case AS_LOCK_STMT_tag:
   r = TRANS_transform_lock_stm(self, ((AS_LOCK_STMT) s)); break;
  case AS_UNLOCK_STMT_tag:
   r = TRANS_transform_unlock_s(self, ((AS_UNLOCK_STMT) s)); break;
  case AS_TRY_STMT_tag:
   r = TRANS_transform_try_stmt(self, ((AS_TRY_STMT) s)); break;
  case AS_WITH_NEAR_STMT_tag:
   r = TRANS_transform_with_nea(self, ((AS_WITH_NEAR_STMT) s)); break;
  case AS_ATTACH_STMT_tag:
   r = TRANS_transform_attach_s(self, ((AS_ATTACH_STMT) s)); break;
  case AS_FORK_STMT_tag:
   r = TRANS_transform_fork_stm(self, ((AS_FORK_STMT) s)); break;
  case AS_UNCAUGHT_STMT_tag:
   r = TRANS_transform_uncaught(self, ((AS_UNCAUGHT_STMT) s)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 ret_val = r;
 return ret_val;
}


dAM_STMT TRANS_transform_par_stmt(TRANS self, AS_PAR_STMT s) {
 dAM_STMT ret_val;
 dAS_STMT ret_as = ((dAS_STMT) NULL);
 dTP current_tp;
 TP_CLASS current_class_tp = ((TP_CLASS) NULL);
 AS_CLASS_DEF current_class_as = ((AS_CLASS_DEF) NULL);
 ARRAYdTP current_params = ((ARRAYdTP) NULL);
 INT num1 = ((INT) 0);
 TP_CLASS dummy1;
 IDENT newidpar = IDENT_zero;
 IDENT newidpar_cl = IDENT_zero;
 IDENT newidpar_ob = IDENT_zero;
 IDENT newidcohort = IDENT_zero;
 AM_LOCAL_EXPR helper1;
 AS_ASSIGN_STMT asc;
 AS_TYPE_SPEC tpc;
 AS_CREATE_EXPR rhsc;
 TRANS L11;
 AM_LOCAL_EXPR loc;
 AS_ASSIGN_STMT exp1;
 AS_CALL_EXPR rhs;
 AS_INTERF_ATTACH_STMT att8;
 AS_LOCK_STMT aslck;
 AS_CALL_EXPR nthr;
 AS_CALL_EXPR nthrob;
 extern STR CompilerErrorPTRANStrans;
 BOOL L2;
 dPARSE L3;
 extern STR CompilerErrorPTRANStrans;
 extern STR par;
 extern STR par_cl;
 extern STR par_ob1;
 extern STR cohort;
 extern STR GATE1;
 dAS_STMT L4;
 dAS_STMT L5;
 AM_LOCAL_EXPR L6;
 BOOL L7;
 STR L8;
 extern STR S_;
 BOOL L9;
 BOOL L10;
 dAS_STMT L12;
 dAS_STMT L13;
 dAS_STMT L14;
 extern STR no_threads;
 dAS_STMT L15;
 dAS_STMT L16;
 dAS_STMT L17;
 current_tp = AM_LOCAL_EXPR_tp_dTP(AM_ROUT_DEF_aget_INT_AM_(ATTR(self,cur_rout), 0));
 if (current_tp==NULL) {
  TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans));
 } else
 switch (TAG(current_tp)) {
  case TP_CLASS_tag:
   current_class_tp = ((TP_CLASS) current_tp);
   current_params = ATTR(current_class_tp,params);
   num1 = 0;
   L2 = (current_params==((ARRAYdTP) NULL));
   if ((!(L2))) {
    num1 = ARRAYdTP_size_INT(current_params);
   }
   L3 = ATTR(ATTR(self,prog1),parse);
   if (L3==NULL) {
    FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
   }
   current_class_as = (*dPARSE_tree_for_IDENT_IN[TAG(L3)+dPARSE_tree_for_IDENT_IN_offset])(L3, ATTR(current_class_tp,name1), num1); break;
  default: ;
   TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans));
 }
 if (ATTR(s,transformed)) {
  dummy1 = TRANS_add_helper_to_tbls(self, ATTR(s,helper_class), current_params);
  TRANS_update_routine_in_(self, current_class_tp, ATTR(s,rout1));
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 newidpar = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &par)));
 newidpar_cl = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &par_cl)));
 newidpar_ob = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &par_ob1)));
 newidcohort = IDENT_create_STR_IDENT(IDENT_zero, IDENT_next_tmp_STR_STR(IDENT_zero, ((STR) &cohort)));
 SATTR(s,helper_class,newidpar_cl);
 helper1 = TRANS_create_helper_obje(self, ((dAS_STMT) s), newidpar_ob, newidpar_cl, current_class_as, current_params);
 asc = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
 SATTR(asc,source11,ATTR(s,source11));
 SATTR(asc,name1,newidcohort);
 SATTR(asc,surr_stmt_list,ATTR(s,surr_stmt_list));
 tpc = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(tpc,source11,ATTR(s,source11));
 SATTR(tpc,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &GATE1)));
 rhsc = AS_CREATE_EXPR_create_AS(((AS_CREATE_EXPR) NULL));
 SATTR(rhsc,source11,ATTR(s,source11));
 SATTR(rhsc,tp1,tpc);
 SATTR(asc,rhs,((dAS_EXPR) rhsc));
 ret_as = ((dAS_STMT) asc);
 L4 = ret_as;
 if (L4==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L4)+dAS_STMT_append_dAS_STMT_offset])(L4, ((dAS_STMT) TRANS_create_helper_obje1(self, newidpar_ob, newidpar_cl, current_class_as, ATTR(s,surr_stmt_list), ATTR(s,source11))));
 L5 = ret_as;
 if (L5==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L5)+dAS_STMT_append_dAS_STMT_offset])(L5, ((dAS_STMT) TRANS_link_helper_stmt_I(self, newidpar_ob, ATTR(s,surr_stmt_list), ATTR(s,source11))));
 {
  struct TRANS_active_locals_and__frame_struct other1_0;
  TRANS_active_locals_and__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L6 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   loc = L6;
   L8 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L8, ((STR) &S_))) {
    if ((ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL))) {
     L9 = TRUE;
    } else {
     L10 = TRANS_local_is_in_par_he(self, ATTR(loc,name1), ATTR(self,cur_param_ob));
     L9 = (!(L10));
    }
    L7 = L9;
   } else {
    L7 = FALSE;
   }
   if (L7) {
    exp1 = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
    SATTR(exp1,source11,ATTR(s,source11));
    SATTR(exp1,surr_stmt_list,ATTR(s,surr_stmt_list));
    SATTR(exp1,lhs_expr,((dAS_EXPR) TRANS_as_of_local_in_hel(self, ATTR(loc,name1), helper1, ATTR(s,source11))));
    rhs = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(rhs,source11,ATTR(s,source11));
    SATTR(rhs,name1,ATTR(loc,name1));
    SATTR(exp1,rhs,((dAS_EXPR) rhs));
    L12 = ret_as;
    if (L12==NULL) {
     FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L12)+dAS_STMT_append_dAS_STMT_offset])(L12, ((dAS_STMT) exp1));
   }
  }
 }
 after_loop: ;
 L13 = ret_as;
 if (L13==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L13)+dAS_STMT_append_dAS_STMT_offset])(L13, TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(s,surr_stmt_list), ATTR(s,source11)));
 SATTR(s,rout1,TRANS_turn_into_routine_(self, newidpar, newidpar_ob, newidpar_cl, helper1, current_class_as, current_class_tp, newidcohort, ((AS_TYPE_SPEC) NULL), ATTR(s,body), TRANS_par_code, ATTR(s,source11)));
 SATTR(s,body,((AS_STMT_LIST) NULL));
 att8 = AS_INTERF_ATTACH_STMT_cr(((AS_INTERF_ATTACH_STMT) NULL));
 SATTR(att8,source11,ATTR(s,source11));
 SATTR(att8,surr_stmt_list,ATTR(s,surr_stmt_list));
 SATTR(att8,routname1,newidpar);
 SATTR(att8,helpername,newidpar_ob);
 SATTR(att8,gatename,newidcohort);
 SATTR(att8,at11,((dAS_EXPR) NULL));
 L14 = ret_as;
 if (L14==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L14)+dAS_STMT_append_dAS_STMT_offset])(L14, ((dAS_STMT) att8));
 aslck = AS_LOCK_STMT_create_AS_L(((AS_LOCK_STMT) NULL));
 SATTR(aslck,source11,ATTR(s,source11));
 SATTR(aslck,surr_stmt_list,ATTR(s,surr_stmt_list));
 nthr = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(nthr,source11,ATTR(s,source11));
 nthrob = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(nthrob,source11,ATTR(s,source11));
 SATTR(nthrob,name1,newidcohort);
 SATTR(nthr,ob1,((dAS_EXPR) nthrob));
 SATTR(nthr,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &no_threads)));
 SATTR(aslck,e_list,((dAS_EXPR) nthr));
 SATTR(aslck,transformed,TRUE);
 L15 = ret_as;
 if (L15==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L15)+dAS_STMT_append_dAS_STMT_offset])(L15, ((dAS_STMT) aslck));
 L16 = ret_as;
 if (L16==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L16)+dAS_STMT_append_dAS_STMT_offset])(L16, TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,surr_stmt_list), ATTR(s,source11)));
 L17 = ret_as;
 if (L17==NULL) {
  FATAL("Dispatch on void in TRANS::transform_par_stmt(AS_PAR_STMT):$AM_STMT");
 }
 (*dAS_STMT_append_dAS_STMT[TAG(L17)+dAS_STMT_append_dAS_STMT_offset])(L17, ATTR(s,next));
 SATTR(s,next,ret_as);
 ret_val = ((dAM_STMT) NULL);
 return ret_val;
}


dAM_STMT TRANS_transform_protect_(TRANS self, AS_PROTECT_STMT s) {
 dAM_STMT ret_val;
 AM_PROTECT_STMT r;
 BOOL old_in_protect_body = ((BOOL) 0);
 AS_PROTECT_WHEN wp;
 dTP tp;
 dTP oex_tp;
 BOOL old_in_protect_then = ((BOOL) 0);
 dTP oex_tp1;
 BOOL old_in_protect_then1 = ((BOOL) 0);
 BOOL L1;
 FLISTdAM_STMT L2;
 r = AM_PROTECT_STMT_create_S(((AM_PROTECT_STMT) NULL), ATTR(s,source11));
 old_in_protect_body = ATTR(self,in_protect_body);
 SATTR(self,in_protect_body,TRUE);
 SATTR(r,body,TRANS_transform_stmt_lis(self, ATTR(s,body)));
 SATTR(self,in_protect_body,old_in_protect_body);
 wp = ATTR(s,when_part);
 while (1) {
  L1 = (wp==((AS_PROTECT_WHEN) NULL));
  if ((!(L1))) {
  }
  else {
   goto after_loop;
  }
  tp = TRANS_tp_of_AS_TYPE_SPEC(self, ATTR(wp,tp1));
  oex_tp = ATTR(self,ex_tp);
  SATTR(self,ex_tp,tp);
  old_in_protect_then = ATTR(self,in_protect_then);
  SATTR(self,in_protect_then,TRUE);
  SATTR(r,tgts,FLISTdTP_push_dTP_FLISTd(ATTR(r,tgts), tp));
  L2 = ATTR(r,stmts);
  SATTR(r,stmts,FLISTdAM_STMT_push_dAM_S(L2, TRANS_transform_stmt_lis(self, ATTR(wp,then_part))));
  SATTR(self,in_protect_then,old_in_protect_then);
  SATTR(self,ex_tp,oex_tp);
  wp = ATTR(wp,next);
 }
 after_loop: ;
 if (ATTR(s,no_else)) {
  SATTR(r,no_else,TRUE);
 }
 else {
  oex_tp1 = ATTR(self,ex_tp);
  SATTR(self,ex_tp,((dTP) TP_BUILTIN_dollar_ob));
  old_in_protect_then1 = ATTR(self,in_protect_then);
  SATTR(self,in_protect_then,TRUE);
  SATTR(r,else_stmts,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
  SATTR(self,in_protect_then,old_in_protect_then1);
  SATTR(self,ex_tp,oex_tp1);
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_quit_stm(TRANS self, AS_QUIT_STMT s) {
 dAM_STMT ret_val;
 AM_RETURN_STMT r;
 BOOL L1;
 BOOL L2;
 if (TRANS_is_in_par_or_fork_(self)) {
  TRANS_quit_in_par_fork_e(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L1 = TRANS_is_iter_BOOL(self);
 if ((!(L1))) {
  TRANS_quit_in_rout_err_A(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L2 = (ATTR(s,next)==((dAS_STMT) NULL));
 if ((!(L2))) {
  TRANS_stmts_after_quit_e(self, s);
 }
 r = AM_RETURN_STMT_create_SF(((AM_RETURN_STMT) NULL), ATTR(s,source11));
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_raise_st(TRANS self, AS_RAISE_STMT s) {
 dAM_STMT ret_val;
 AM_RAISE_STMT r;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 L1 = (ATTR(s,next)==((dAS_STMT) NULL));
 if ((!(L1))) {
  TRANS_stmts_after_raise_(self, s);
 }
 if (TRANS_is_in_par_or_fork_(self)) {
  L3 = ATTR(self,in_protect_body);
  L2 = (!(L3));
 } else {
  L2 = FALSE;
 }
 if (L2) {
  TRANS_unprotected_raise_(self, s);
 }
 r = AM_RAISE_STMT_create_SFI(((AM_RAISE_STMT) NULL), ATTR(s,source11));
 SATTR(r,val11,TRANS_transform_expr_dAS(self, ATTR(s,val11), ((dTP) NULL)));
 if ((ATTR(r,val11)==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_return_s(TRANS self, AS_RETURN_STMT s) {
 dAM_STMT ret_val;
 dTP rtp;
 dAM_STMT res = ((dAM_STMT) NULL);
 AM_ASSIGN_STMT a;
 AM_RETURN_STMT r;
 AM_INVARIANT_STMT stmt;
 AM_POST_STMT stmt1;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 dAM_STMT L4;
 dAM_STMT L5;
 BOOL L6;
 dAM_STMT L7;
 dAM_STMT L8;
 if (TRANS_is_iter_BOOL(self)) {
  TRANS_return_in_iter_err(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (TRANS_is_in_par_or_fork_(self)) {
  TRANS_return_in_par_fork(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L1 = (ATTR(s,next)==((dAS_STMT) NULL));
 if ((!(L1))) {
  TRANS_stmts_after_return(self, s);
 }
 rtp = ATTR(ATTR(ATTR(self,cur_rout),sig11),ret1);
 if ((ATTR(s,val11)==((dAS_EXPR) NULL))) {
  L2 = (rtp==((dTP) NULL));
  if ((!(L2))) {
   TRANS_missing_return_val(self, s, rtp);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  res = ((dAM_STMT) AM_RETURN_STMT_create_SF(((AM_RETURN_STMT) NULL), ATTR(s,source11)));
 }
 else {
  a = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(s,source11));
  SATTR(a,dest,((dAM_EXPR) ATTR(ATTR(self,cur_rout),rres)));
  if ((rtp==((dTP) NULL))) {
   TRANS_extra_return_value(self, s, ATTR(ATTR(self,cur_rout),sig11));
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  r = AM_RETURN_STMT_create_SF(((AM_RETURN_STMT) NULL), ATTR(s,source11));
  SATTR(a,next1,((dAM_STMT) r));
  SATTR(r,val11,((dAM_EXPR) ATTR(ATTR(self,cur_rout),rres)));
  SATTR(a,src11,TRANS_transform_expr_dAS(self, ATTR(s,val11), rtp));
  if ((ATTR(a,src11)==((dAM_EXPR) NULL))) {
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  res = ((dAM_STMT) a);
 }
 L3 = (ATTR(self,inv_stmt)==((AM_INVARIANT_STMT) NULL));
 if ((!(L3))) {
  stmt = AM_INVARIANT_STMT_copy_A(ATTR(self,inv_stmt));
  L4 = res;
  if (L4==NULL) {
   FATAL("Dispatch on void in TRANS::transform_return_stmt(AS_RETURN_STMT):$AM_STMT");
  }
  SATTR(stmt,next1,(*dAM_STMT_next_dAM_STMT[TAG(L4)+dAM_STMT_next_dAM_STMT_offset])(L4));
  L5 = res;
  if (L5==NULL) {
   FATAL("Dispatch on void in TRANS::transform_return_stmt(AS_RETURN_STMT):$AM_STMT");
  }
  (*dAM_STMT_next_dAM_STMT1[TAG(L5)+dAM_STMT_next_dAM_STMT1_offset])(L5, ((dAM_STMT) stmt));
 }
 L6 = (ATTR(self,post_stmt)==((AM_POST_STMT) NULL));
 if ((!(L6))) {
  stmt1 = AM_POST_STMT_copy_AM_POS(ATTR(self,post_stmt));
  L7 = res;
  if (L7==NULL) {
   FATAL("Dispatch on void in TRANS::transform_return_stmt(AS_RETURN_STMT):$AM_STMT");
  }
  SATTR(stmt1,next1,(*dAM_STMT_next_dAM_STMT[TAG(L7)+dAM_STMT_next_dAM_STMT_offset])(L7));
  L8 = res;
  if (L8==NULL) {
   FATAL("Dispatch on void in TRANS::transform_return_stmt(AS_RETURN_STMT):$AM_STMT");
  }
  (*dAM_STMT_next_dAM_STMT1[TAG(L8)+dAM_STMT_next_dAM_STMT1_offset])(L8, ((dAM_STMT) stmt1));
 }
 ret_val = res;
 return ret_val;
}


dAM_STMT TRANS_transform_stmt_dAS(TRANS self, dAS_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT r = ((dAM_STMT) NULL);
 if ((s==((dAS_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (s==NULL) {
  if (ATTR(ATTR(self,prog1),psather)) {
   r = TRANS_transform_pSather_4(self, s);
  }
 } else
 switch (TAG(s)) {
  case AS_DEC_STMT_tag:
   r = TRANS_transform_dec_stmt(self, ((AS_DEC_STMT) s)); break;
  case AS_ASSIGN_STMT_tag:
   r = TRANS_transform_assign_s(self, ((AS_ASSIGN_STMT) s)); break;
  case AS_IF_STMT_tag:
   r = TRANS_transform_if_stmt_(self, ((AS_IF_STMT) s)); break;
  case AS_LOOP_STMT_tag:
   r = TRANS_transform_loop_stm(self, ((AS_LOOP_STMT) s)); break;
  case AS_RETURN_STMT_tag:
   r = TRANS_transform_return_s(self, ((AS_RETURN_STMT) s)); break;
  case AS_YIELD_STMT_tag:
   r = TRANS_transform_yield_st(self, ((AS_YIELD_STMT) s)); break;
  case AS_QUIT_STMT_tag:
   r = TRANS_transform_quit_stm(self, ((AS_QUIT_STMT) s)); break;
  case AS_CASE_STMT_tag:
   r = TRANS_transform_case_stm(self, ((AS_CASE_STMT) s)); break;
  case AS_TYPECASE_STMT_tag:
   r = TRANS_transform_typecase(self, ((AS_TYPECASE_STMT) s)); break;
  case AS_ASSERT_STMT_tag:
   r = TRANS_transform_assert_s(self, ((AS_ASSERT_STMT) s)); break;
  case AS_PROTECT_STMT_tag:
   r = TRANS_transform_protect_(self, ((AS_PROTECT_STMT) s)); break;
  case AS_RAISE_STMT_tag:
   r = TRANS_transform_raise_st(self, ((AS_RAISE_STMT) s)); break;
  case AS_EXPR_STMT_tag:
   r = TRANS_transform_expr_stm(self, ((AS_EXPR_STMT) s)); break;
  default: ;
   if (ATTR(ATTR(self,prog1),psather)) {
    r = TRANS_transform_pSather_4(self, s);
   }
 }
 ret_val = r;
 return ret_val;
}


dAM_STMT TRANS_transform_stmt_lis(TRANS self, AS_STMT_LIST l) {
 dAM_STMT ret_val;
 dAS_STMT s;
 INT osize = ((INT) 0);
 dAM_STMT r = ((dAM_STMT) NULL);
 dAS_STMT last1 = ((dAS_STMT) NULL);
 dAM_STMT t;
 dAS_STMT export11;
 dAS_STMT sys_exp;
 BOOL imp_local_pending = ((BOOL) 0);
 BOOL imp_call_pending = ((BOOL) 0);
 AS_STMT_LIST exp_stmt_list;
 dAM_STMT exp1;
 dAS_STMT sys_imp;
 dAS_STMT sys_imp1;
 AM_LOCAL_EXPR ignore1;
 BOOL L1;
 BOOL L2;
 dAS_STMT L3;
 BOOL L4;
 INT L5;
 dAS_STMT L6;
 INT L7;
 dAS_STMT L8;
 dAS_STMT L9;
 dAS_STMT L10;
 BOOL L11;
 dAS_STMT L12;
 dAS_STMT L13;
 BOOL L14;
 dAM_STMT L15;
 dAM_STMT L16;
 dAS_STMT L17;
 BOOL L18;
 INT L19;
 dAS_STMT L20;
 dAS_STMT L21;
 dAS_STMT L22;
 dAS_STMT L23;
 dAS_STMT L24;
 INT L25;
 dAS_STMT L26;
 dAS_STMT L27;
 dAS_STMT L28;
 dAS_STMT L29;
 dAS_STMT L30;
 dAS_STMT L31;
 dAS_STMT L32;
 BOOL L33;
 INT L34;
 if ((l==((AS_STMT_LIST) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 s = ATTR(l,stmts);
 if ((s==((dAS_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L1 = (ATTR(self,active_locals)==((FLISTAM_LOCAL_EXPR) NULL));
 if ((!(L1))) {
  osize = FLISTAM_LOCAL_EXPR_size_(ATTR(self,active_locals));
 }
 while (1) {
  L2 = (s==((dAS_STMT) NULL));
  if ((!(L2))) {
  }
  else {
   goto after_loop;
  }
  t = TRANS_transform_stmt_dAS(self, s);
  if (ATTR(ATTR(self,prog1),psather)) {
   export11 = ((dAS_STMT) NULL);
   L3 = s;
   if (L3==NULL) {
    FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
   }
   L4 = (*dAS_STMT_transformed_BOO1[TAG(L3)+dAS_STMT_transformed_BOO1_offset])(L3);
   if ((!(L4))) {
    if (AM_ROUT_DEF_export_local(ATTR(self,cur_rout))) {
     if (TRANS_do_helper_export) {
      L5 = TRANS_export_code;
      L6 = s;
      if (L6==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      export11 = TRANS_as_for_import_expo(self, L5, l, (*dAS_STMT_source_SFILE_ID1[TAG(L6)+dAS_STMT_source_SFILE_ID1_offset])(L6));
     }
    }
    if (AM_ROUT_DEF_export_call_(ATTR(self,cur_rout))) {
     L7 = TRANS_export_code;
     L8 = s;
     if (L8==NULL) {
      FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
     }
     sys_exp = TRANS_as_for_sys_import_(self, L7, l, (*dAS_STMT_source_SFILE_ID1[TAG(L8)+dAS_STMT_source_SFILE_ID1_offset])(L8));
     L9 = sys_exp;
     if (L9==NULL) {
      FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
     }
     (*dAS_STMT_transformed_BOO[TAG(L9)+dAS_STMT_transformed_BOO_offset])(L9, TRUE);
     if ((export11==((dAS_STMT) NULL))) {
      export11 = sys_exp;
     }
     else {
      L10 = export11;
      if (L10==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      (*dAS_STMT_append_dAS_STMT[TAG(L10)+dAS_STMT_append_dAS_STMT_offset])(L10, sys_exp);
     }
    }
   }
   AM_ROUT_DEF_export_done(ATTR(self,cur_rout));
   L11 = (export11==((dAS_STMT) NULL));
   if ((!(L11))) {
    imp_local_pending = AM_ROUT_DEF_import_local(ATTR(self,cur_rout));
    imp_call_pending = AM_ROUT_DEF_import_call_(ATTR(self,cur_rout));
    exp_stmt_list = AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL));
    SATTR(exp_stmt_list,stmts,export11);
    exp1 = TRANS_transform_stmt_lis(self, exp_stmt_list);
    L12 = export11;
    if (L12==NULL) {
     FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L12)+dAS_STMT_append_dAS_STMT_offset])(L12, s);
    if ((last1==((dAS_STMT) NULL))) {
     SATTR(l,stmts,export11);
    }
    else {
     L13 = last1;
     if (L13==NULL) {
      FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
     }
     (*dAS_STMT_next_dAS_STMT1[TAG(L13)+dAS_STMT_next_dAS_STMT1_offset])(L13, export11);
    }
    L14 = (exp1==((dAM_STMT) NULL));
    if ((!(L14))) {
     L15 = exp1;
     if (L15==NULL) {
      FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
     }
     (*dAM_STMT_append_dAM_STMT[TAG(L15)+dAM_STMT_append_dAM_STMT_offset])(L15, t);
     t = exp1;
    }
    if (imp_local_pending) {
     AM_ROUT_DEF_needs_import(ATTR(self,cur_rout));
    }
    if (imp_call_pending) {
     AM_ROUT_DEF_needs_import1(ATTR(self,cur_rout));
    }
   }
  }
  if ((r==((dAM_STMT) NULL))) {
   r = t;
  }
  else {
   L16 = r;
   if (L16==NULL) {
    FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
   }
   (*dAM_STMT_append_dAM_STMT[TAG(L16)+dAM_STMT_append_dAM_STMT_offset])(L16, t);
  }
  if (ATTR(ATTR(self,prog1),psather)) {
   L17 = s;
   if (L17==NULL) {
    FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
   }
   L18 = (*dAS_STMT_transformed_BOO1[TAG(L17)+dAS_STMT_transformed_BOO1_offset])(L17);
   if ((!(L18))) {
    if (AM_ROUT_DEF_import_local(ATTR(self,cur_rout))) {
     TRANS_insert_import_afte(self, s);
    }
    if (AM_ROUT_DEF_import_call_(ATTR(self,cur_rout))) {
     if (t==NULL) {
      L19 = TRANS_import_code;
      L20 = s;
      if (L20==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      sys_imp1 = TRANS_as_for_sys_import_(self, L19, l, (*dAS_STMT_source_SFILE_ID1[TAG(L20)+dAS_STMT_source_SFILE_ID1_offset])(L20));
      L21 = sys_imp1;
      if (L21==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      (*dAS_STMT_transformed_BOO[TAG(L21)+dAS_STMT_transformed_BOO_offset])(L21, TRUE);
      L22 = s;
      if (L22==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      L23 = sys_imp1;
      if (L23==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      (*dAS_STMT_append_dAS_STMT[TAG(L23)+dAS_STMT_append_dAS_STMT_offset])(L23, (*dAS_STMT_next_dAS_STMT[TAG(L22)+dAS_STMT_next_dAS_STMT_offset])(L22));
      L24 = s;
      if (L24==NULL) {
       FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
      }
      (*dAS_STMT_next_dAS_STMT1[TAG(L24)+dAS_STMT_next_dAS_STMT1_offset])(L24, sys_imp1);
     } else
     switch (TAG(t)) {
      default: ;
       L25 = TRANS_import_code;
       L26 = s;
       if (L26==NULL) {
        FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
       }
       sys_imp = TRANS_as_for_sys_import_(self, L25, l, (*dAS_STMT_source_SFILE_ID1[TAG(L26)+dAS_STMT_source_SFILE_ID1_offset])(L26));
       L27 = sys_imp;
       if (L27==NULL) {
        FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
       }
       (*dAS_STMT_transformed_BOO[TAG(L27)+dAS_STMT_transformed_BOO_offset])(L27, TRUE);
       L28 = s;
       if (L28==NULL) {
        FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
       }
       L29 = sys_imp;
       if (L29==NULL) {
        FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
       }
       (*dAS_STMT_append_dAS_STMT[TAG(L29)+dAS_STMT_append_dAS_STMT_offset])(L29, (*dAS_STMT_next_dAS_STMT[TAG(L28)+dAS_STMT_next_dAS_STMT_offset])(L28));
       L30 = s;
       if (L30==NULL) {
        FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
       }
       (*dAS_STMT_next_dAS_STMT1[TAG(L30)+dAS_STMT_next_dAS_STMT1_offset])(L30, sys_imp);
     }
    }
   }
   AM_ROUT_DEF_import_done(ATTR(self,cur_rout));
  }
  L31 = s;
  if (L31==NULL) {
   FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
  }
  (*dAS_STMT_transformed_BOO[TAG(L31)+dAS_STMT_transformed_BOO_offset])(L31, TRUE);
  last1 = s;
  L32 = s;
  if (L32==NULL) {
   FATAL("Dispatch on void in TRANS::transform_stmt_list(AS_STMT_LIST):$AM_STMT");
  }
  s = (*dAS_STMT_next_dAS_STMT[TAG(L32)+dAS_STMT_next_dAS_STMT_offset])(L32);
 }
 after_loop: ;
 L33 = (ATTR(self,active_locals)==((FLISTAM_LOCAL_EXPR) NULL));
 if ((!(L33))) {
  while (1) {
   L34 = FLISTAM_LOCAL_EXPR_size_(ATTR(self,active_locals));
   if ((L34>osize)) {
   }
   else {
    goto after_loop1;
   }
   ignore1 = FLISTAM_LOCAL_EXPR_pop_A(ATTR(self,active_locals));
  }
  after_loop1: ;
 }
 ret_val = r;
 return ret_val;
}


dAM_STMT TRANS_transform_try_stmt(TRANS self, AS_TRY_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT ret = ((dAM_STMT) NULL);
 AM_TRY_STMT r;
 dAS_EXPR lck;
 INT L11 = ((INT) 0);
 INT idx = ((INT) 0);
 dAS_STMT import1;
 dAM_STMT L2;
 BOOL L3;
 INT L4;
 ARRAYdAM_EXPR L5;
 dAS_EXPR L6;
 BOOL L7;
 dAS_STMT L8;
 r = AM_TRY_STMT_create_SFILE(((AM_TRY_STMT) NULL), ATTR(s,source11));
 if ((ret==((dAM_STMT) NULL))) {
  ret = ((dAM_STMT) r);
 }
 else {
  L2 = ret;
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::transform_try_stmt(AS_TRY_STMT):$AM_STMT");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L2)+dAM_STMT_append_dAM_STMT_offset])(L2, ((dAM_STMT) r));
 }
 SATTR(r,locks1,ARRAYdAM_EXPR_create_INT(((ARRAYdAM_EXPR) NULL), AS_TRY_STMT_elts_size_IN(s)));
 lck = ATTR(s,e_list);
 {
  struct INT_upb_INT_frame_struct other1_0;
  INT_upb_INT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   L3 = (lck==((dAS_EXPR) NULL));
   if ((!(L3))) {
   }
   else {
    goto after_loop;
   }
   if (noname1->state == 0) {
    L11 = 0;
    noname1->self = L11;
   }
   L4 = INT_upb_INT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   idx = L4;
   L5 = ATTR(r,locks1);
   ARRAYdAM_EXPR_aset_INT_d(L5, idx, TRANS_transform_expr_dAS(self, lck, ((dTP) TP_BUILTIN_dollar_lock)));
   L6 = lck;
   if (L6==NULL) {
    FATAL("Dispatch on void in TRANS::transform_try_stmt(AS_TRY_STMT):$AM_STMT");
   }
   lck = (*dAS_EXPR_next_dAS_EXPR[TAG(L6)+dAS_EXPR_next_dAS_EXPR_offset])(L6);
  }
 }
 after_loop: ;
 SATTR(self,cur_lock,((dAM_STMT) r));
 L7 = ATTR(s,transformed);
 if ((!(L7))) {
  if ((ATTR(s,then_part)==((AS_STMT_LIST) NULL))) {
   SATTR(s,then_part,AS_STMT_LIST_create_AS_S(((AS_STMT_LIST) NULL)));
   SATTR(ATTR(s,then_part),source11,ATTR(s,source11));
  }
  import1 = TRANS_as_for_sys_import_(self, TRANS_import_code, ATTR(s,then_part), ATTR(s,source11));
  if ((ATTR(ATTR(s,then_part),stmts)==((dAS_STMT) NULL))) {
   SATTR(ATTR(s,then_part),stmts,import1);
  }
  else {
   L8 = import1;
   if (L8==NULL) {
    FATAL("Dispatch on void in TRANS::transform_try_stmt(AS_TRY_STMT):$AM_STMT");
   }
   (*dAS_STMT_next_dAS_STMT1[TAG(L8)+dAS_STMT_next_dAS_STMT1_offset])(L8, ATTR(ATTR(s,then_part),stmts));
   SATTR(ATTR(s,then_part),stmts,import1);
  }
  TRANS_append_export_in_l(self, ATTR(s,then_part), FALSE);
 }
 SATTR(r,then_part1,TRANS_transform_stmt_lis(self, ATTR(s,then_part)));
 SATTR(self,cur_lock,((dAM_STMT) NULL));
 SATTR(r,else_part1,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
 ret_val = ret;
 return ret_val;
}


dAM_STMT TRANS_transform_typecase(TRANS self, AS_TYPECASE_STMT s) {
 dAM_STMT ret_val;
 AM_LOCAL_EXPR l;
 BOOL old_no_assign = ((BOOL) 0);
 dTP ltp;
 AM_TYPECASE_STMT r;
 AS_TYPECASE_WHEN wp;
 dTP tp;
 BOOL L1;
 dTP L2;
 dTP L3;
 FLISTdAM_STMT L4;
 BOOL L5;
 BOOL L6;
 l = TRANS_local_with_name_ID(self, ATTR(s,name1));
 if ((l==((AM_LOCAL_EXPR) NULL))) {
  TRANS_typecase_local_err(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (AM_ROUT_DEF_local_is_hot(ATTR(self,cur_rout), l)) {
  TRANS_typecase_hot_local(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 old_no_assign = ATTR(l,no_assign);
 SATTR(l,no_assign,TRUE);
 ltp = AM_LOCAL_EXPR_tp_dTP(l);
 r = AM_TYPECASE_STMT_create_(((AM_TYPECASE_STMT) NULL), ATTR(s,source11));
 SATTR(r,test11,l);
 SATTR(r,no_else,TRUE);
 SATTR(r,has_void_stmts,FALSE);
 wp = ATTR(s,when_part);
 while (1) {
  L1 = (wp==((AS_TYPECASE_WHEN) NULL));
  if ((!(L1))) {
  }
  else {
   goto after_loop;
  }
  tp = TRANS_tp_of_AS_TYPE_SPEC(self, ATTR(wp,tp1));
  L2 = ltp;
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::transform_typecase_stmt(AS_TYPECASE_STMT):$AM_STMT");
  }
  if ((*dTP_is_subtype_dTP_BOOL[TAG(L2)+dTP_is_subtype_dTP_BOOL_offset])(L2, tp)) {
   SATTR(r,no_else,FALSE);
   SATTR(r,else_stmts,TRANS_transform_stmt_lis(self, ATTR(wp,then_part)));
   SATTR(r,has_void_stmts,TRUE);
   SATTR(r,void_stmts,TRANS_transform_stmt_lis(self, ATTR(wp,then_part)));
   goto after_loop;
  }
  else {
   L3 = ltp;
   if (L3==NULL) {
    FATAL("Dispatch on void in TRANS::transform_typecase_stmt(AS_TYPECASE_STMT):$AM_STMT");
   }
   if ((*dTP_is_abstract_BOOL[TAG(L3)+dTP_is_abstract_BOOL_offset])(L3)) {
    SATTR(l,tp_at,tp);
    SATTR(r,tgts,FLISTdTP_push_dTP_FLISTd(ATTR(r,tgts), tp));
    L4 = ATTR(r,stmts);
    SATTR(r,stmts,FLISTdAM_STMT_push_dAM_S(L4, TRANS_transform_stmt_lis(self, ATTR(wp,then_part))));
    SATTR(l,tp_at,ltp);
   }
  }
  wp = ATTR(wp,next);
 }
 after_loop: ;
 SATTR(l,no_assign,old_no_assign);
 if (ATTR(r,no_else)) {
  L6 = ATTR(s,no_else);
  L5 = (!(L6));
 } else {
  L5 = FALSE;
 }
 if (L5) {
  SATTR(r,no_else,FALSE);
  SATTR(r,else_stmts,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
  SATTR(r,has_void_stmts,TRUE);
  SATTR(r,void_stmts,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
 }
 if ((ATTR(r,stmts)==((FLISTdAM_STMT) NULL))) {
  if (ATTR(r,no_else)) {
   TRANS_typecase_no_branch(self, s);
   ret_val = ((dAM_STMT) r);
   return ret_val;
  }
  else {
   ret_val = ATTR(r,else_stmts);
   return ret_val;
  }
 }
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_uncaught(TRANS self, AS_UNCAUGHT_STMT s) {
 dAM_STMT ret_val;
 AM_UNCAUGHT_STMT r;
 r = AM_UNCAUGHT_STMT_create_(((AM_UNCAUGHT_STMT) NULL), ATTR(s,source11));
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_unlock_s(TRANS self, AS_UNLOCK_STMT s) {
 dAM_STMT ret_val;
 dAM_STMT ret = ((dAM_STMT) NULL);
 dAS_STMT prev;
 dAS_STMT export11;
 AM_UNLOCK_STMT r;
 BOOL L1;
 BOOL L2;
 dAS_STMT L3;
 dAS_STMT L4;
 dAM_STMT L5;
 L1 = TRANS_is_in_try_or_lock_(self);
 if ((!(L1))) {
  if (TRANS_is_in_par_or_fork_(self)) {
   TRANS_unlock_in_par_fork(self, s);
  }
  else {
   TRANS_unlock_outside_try(self, s);
  }
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 L2 = ATTR(s,transformed);
 if ((!(L2))) {
  prev = TRANS_previous_dAS_STMT_(self, ((dAS_STMT) s));
  export11 = TRANS_as_for_sys_import_(self, TRANS_export_code, ATTR(s,surr_stmt_list), ATTR(s,source11));
  L3 = export11;
  if (L3==NULL) {
   FATAL("Dispatch on void in TRANS::transform_unlock_stmt(AS_UNLOCK_STMT):$AM_STMT");
  }
  (*dAS_STMT_next_dAS_STMT1[TAG(L3)+dAS_STMT_next_dAS_STMT1_offset])(L3, ((dAS_STMT) s));
  if ((prev==((dAS_STMT) NULL))) {
   SATTR(ATTR(s,surr_stmt_list),stmts,export11);
  }
  else {
   L4 = prev;
   if (L4==NULL) {
    FATAL("Dispatch on void in TRANS::transform_unlock_stmt(AS_UNLOCK_STMT):$AM_STMT");
   }
   (*dAS_STMT_next_dAS_STMT1[TAG(L4)+dAS_STMT_next_dAS_STMT1_offset])(L4, export11);
  }
  ret = TRANS_transform_stmt_dAS(self, export11);
 }
 r = AM_UNLOCK_STMT_create_SF(((AM_UNLOCK_STMT) NULL), ATTR(s,source11));
 if ((ret==((dAM_STMT) NULL))) {
  ret = ((dAM_STMT) r);
 }
 else {
  L5 = ret;
  if (L5==NULL) {
   FATAL("Dispatch on void in TRANS::transform_unlock_stmt(AS_UNLOCK_STMT):$AM_STMT");
  }
  (*dAM_STMT_append_dAM_STMT[TAG(L5)+dAM_STMT_append_dAM_STMT_offset])(L5, ((dAM_STMT) r));
 }
 SATTR(r,lock1,TRANS_transform_expr_dAS(self, ATTR(s,e11), ((dTP) TP_BUILTIN_dollar_lock)));
 ret_val = ret;
 return ret_val;
}


dAM_STMT TRANS_transform_with_nea(TRANS self, AS_WITH_NEAR_STMT s) {
 dAM_STMT ret_val;
 AM_WITH_NEAR_STMT r;
 AS_IDENT_LIST obj1;
 INT idx = ((INT) 0);
 AM_LOCAL_EXPR l;
 INT k = ((INT) 0);
 extern STR CompilerErrorPTRANStrans3;
 BOOL L1;
 dTP L2;
 BOOL L3;
 INT L4;
 INT L5;
 ARRAYdAM_EXPR L6;
 INT L7;
 INT L8;
 r = AM_WITH_NEAR_STMT_create(((AM_WITH_NEAR_STMT) NULL), ATTR(s,source11));
 SATTR(r,objects1,ARRAYdAM_EXPR_create_INT(((ARRAYdAM_EXPR) NULL), ATTR(s,elts_size)));
 obj1 = ATTR(s,idents);
 idx = 0;
 if ((ATTR(self,cur_rout)==((AM_ROUT_DEF) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrorPTRANStrans3));
 }
 while (1) {
  L1 = (obj1==((AS_IDENT_LIST) NULL));
  if ((!(L1))) {
  }
  else {
   goto after_loop;
  }
  l = TRANS_local_with_name_ID(self, ATTR(obj1,name1));
  if ((l==((AM_LOCAL_EXPR) NULL))) {
   TRANS_with_near_locals_o(self, obj1);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  L2 = AM_LOCAL_EXPR_tp_dTP(l);
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::transform_with_near_stmt(AS_WITH_NEAR_STMT):$AM_STMT");
  }
  k = (*dTP_kind_INT[TAG(L2)+dTP_kind_INT_offset])(L2);
  L4 = TP_KIND_ref_tp;
  if ((k!=L4)) {
   L5 = TP_KIND_spr_tp;
   L3 = (k!=L5);
  } else {
   L3 = FALSE;
  }
  if (L3) {
   TRANS_with_near_non_ref_(self, obj1);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  ARRAYdAM_EXPR_aset_INT_d(ATTR(r,objects1), idx, ((dAM_EXPR) l));
  obj1 = ATTR(obj1,next);
 }
 after_loop: ;
 if (ATTR(s,self_occurred)) {
  L6 = ATTR(r,objects1);
  L7 = ATTR(s,elts_size);
  L8 = (INTMINUS(L7,1));
  ARRAYdAM_EXPR_aset_INT_d(L6, L8, ((dAM_EXPR) AM_ROUT_DEF_self_local_A(ATTR(self,cur_rout))));
 }
 SATTR(r,near_part,TRANS_transform_stmt_lis(self, ATTR(s,near_part)));
 SATTR(r,else_part1,TRANS_transform_stmt_lis(self, ATTR(s,else_part)));
 ret_val = ((dAM_STMT) r);
 return ret_val;
}


dAM_STMT TRANS_transform_yield_st(TRANS self, AS_YIELD_STMT s) {
 dAM_STMT ret_val;
 dTP rtp;
 AM_YIELD_STMT y;
 AM_YIELD_STMT r;
 BOOL L1;
 BOOL L2;
 INT L3;
 INT L4;
 BOOL L5;
 INT L6;
 INT L7;
 BOOL L8;
 L1 = TRANS_is_iter_BOOL(self);
 if ((!(L1))) {
  TRANS_yield_in_rout_err_(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (ATTR(self,in_protect_body)) {
  TRANS_yield_in_protect_e(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (ATTR(self,in_protect_then)) {
  TRANS_yield_in_protect_e(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (TRANS_is_in_par_or_fork_(self)) {
  TRANS_yield_in_par_fork_(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 if (TRANS_is_in_try_or_lock_(self)) {
  TRANS_yield_in_try_lock_(self, s);
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 rtp = ATTR(ATTR(ATTR(self,cur_rout),sig11),ret1);
 if ((ATTR(s,val11)==((dAS_EXPR) NULL))) {
  L2 = (rtp==((dTP) NULL));
  if ((!(L2))) {
   TRANS_missing_yield_valu(self, s, rtp);
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  y = AM_YIELD_STMT_create_SFI(((AM_YIELD_STMT) NULL), ATTR(s,source11));
  L3 = ATTR(self,cur_yield_ind);
  SATTR(self,cur_yield_ind,(INTPLUS(L3,1)));
  SATTR(y,ret1,ATTR(self,cur_yield_ind));
  L4 = ATTR(ATTR(self,cur_rout),num_yields);
  SATTR(ATTR(self,cur_rout),num_yields,(INTPLUS(L4,1)));
  L5 = (ATTR(self,cur_loop)==((AM_LOOP_STMT) NULL));
  if ((!(L5))) {
   SATTR(ATTR(self,cur_loop),has_yield,TRUE);
  }
  ret_val = ((dAM_STMT) y);
  return ret_val;
 }
 else {
  if ((rtp==((dTP) NULL))) {
   TRANS_extra_yield_value_(self, s, ATTR(ATTR(self,cur_rout),sig11));
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  r = AM_YIELD_STMT_create_SFI(((AM_YIELD_STMT) NULL), ATTR(s,source11));
  SATTR(r,val11,TRANS_transform_expr_dAS(self, ATTR(s,val11), rtp));
  if ((ATTR(r,val11)==((dAM_EXPR) NULL))) {
   ret_val = ((dAM_STMT) NULL);
   return ret_val;
  }
  L6 = ATTR(self,cur_yield_ind);
  SATTR(self,cur_yield_ind,(INTPLUS(L6,1)));
  SATTR(r,ret1,ATTR(self,cur_yield_ind));
  L7 = ATTR(ATTR(self,cur_rout),num_yields);
  SATTR(ATTR(self,cur_rout),num_yields,(INTPLUS(L7,1)));
  L8 = (ATTR(self,cur_loop)==((AM_LOOP_STMT) NULL));
  if ((!(L8))) {
   SATTR(ATTR(self,cur_loop),has_yield,TRUE);
  }
  ret_val = ((dAM_STMT) r);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


dAS_STMT TRANS_as_for_import_expo(TRANS self, INT imporexp, AS_STMT_LIST body1, SFILE_ID source1) {
 dAS_STMT ret_val;
 AS_ASSIGN_STMT as = ((AS_ASSIGN_STMT) NULL);
 dAS_STMT code1;
 AM_LOCAL_EXPR last_helper;
 AM_LOCAL_EXPR rel_helper = ((AM_LOCAL_EXPR) NULL);
 TRANS L11;
 AM_LOCAL_EXPR loc;
 AS_CALL_EXPR locvar;
 AS_CALL_EXPR helploc;
 INT L21 = ((INT) 0);
 AM_LOCAL_EXPR L3;
 BOOL L4;
 STR L5;
 extern STR S_;
 dAS_STMT L6;
 code1 = ((dAS_STMT) NULL);
 last_helper = TRANS_last_declared_help(self);
 if ((last_helper==((AM_LOCAL_EXPR) NULL))) {
  ret_val = code1;
  return ret_val;
 }
 if ((ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL))) {
  rel_helper = last_helper;
 }
 else {
  rel_helper = TRANS_last_declared_par_(self);
  if ((rel_helper==((AM_LOCAL_EXPR) NULL))) {
   rel_helper = last_helper;
  }
 }
 if ((rel_helper==((AM_LOCAL_EXPR) NULL))) {
  ret_val = code1;
  return ret_val;
 }
 {
  struct TRANS_active_locals_and__frame_struct other1_0;
  TRANS_active_locals_and__frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = self;
    noname1->self = L11;
   }
   L3 = TRANS_active_locals_and_(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   loc = L3;
   L5 = STR_head_INT_STR(ATTR(loc,name1).str, 1);
   if (STR_is_neq_STR_BOOL(L5, ((STR) &S_))) {
    L4 = TRANS_local_is_in_par_he(self, ATTR(loc,name1), rel_helper);
   } else {
    L4 = FALSE;
   }
   if (L4) {
    as = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
    SATTR(as,source11,source1);
    SATTR(as,surr_stmt_list,body1);
    SATTR(as,transformed,TRUE);
    locvar = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
    SATTR(locvar,source11,source1);
    SATTR(locvar,name1,ATTR(loc,name1));
    helploc = TRANS_as_of_local_in_hel(self, ATTR(loc,name1), rel_helper, source1);
    L21 = imporexp;
    switch (L21) {
     case 1:
      SATTR(as,lhs_expr,((dAS_EXPR) locvar));
      SATTR(as,rhs,((dAS_EXPR) helploc));
      break;
     case 2:
      SATTR(as,lhs_expr,((dAS_EXPR) helploc));
      SATTR(as,rhs,((dAS_EXPR) locvar));
      break;
     default: ;
      FATAL("No applicable target in case statement");
    }
    if ((code1==((dAS_STMT) NULL))) {
     code1 = ((dAS_STMT) as);
    }
    else {
     L6 = code1;
     if (L6==NULL) {
      FATAL("Dispatch on void in TRANS::as_for_import_export(INT,AS_STMT_LIST,SFILE_ID):$AS_STMT");
     }
     (*dAS_STMT_append_dAS_STMT[TAG(L6)+dAS_STMT_append_dAS_STMT_offset])(L6, ((dAS_STMT) as));
    }
   }
  }
 }
 after_loop: ;
 ret_val = code1;
 return ret_val;
}


dAS_STMT TRANS_as_for_sys_import_(TRANS self, INT imporexp, AS_STMT_LIST body1, SFILE_ID source1) {
 dAS_STMT ret_val;
 AS_EXPR_STMT impexp;
 AS_CALL_EXPR impexpe;
 AS_TYPE_SPEC impexpetp;
 INT L11 = ((INT) 0);
 extern STR SYS1;
 extern STR import;
 extern STR export1;
 impexp = AS_EXPR_STMT_create_AS_E(((AS_EXPR_STMT) NULL));
 SATTR(impexp,source11,source1);
 SATTR(impexp,surr_stmt_list,body1);
 impexpe = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
 SATTR(impexpe,source11,source1);
 impexpetp = AS_TYPE_SPEC_create_AS_T(((AS_TYPE_SPEC) NULL));
 SATTR(impexpetp,source11,source1);
 SATTR(impexpetp,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &SYS1)));
 SATTR(impexpe,tp1,impexpetp);
 L11 = imporexp;
 switch (L11) {
  case 1:
   SATTR(impexpe,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &import)));
   break;
  case 2:
   SATTR(impexpe,name1,IDENT_create_STR_IDENT(IDENT_zero, ((STR) &export1)));
   break;
  default: ;
   FATAL("No applicable target in case statement");
 }
 SATTR(impexp,e11,((dAS_EXPR) impexpe));
 ret_val = ((dAS_STMT) impexp);
 return ret_val;
}


dAS_STMT TRANS_previous_dAS_STMT_(TRANS self, dAS_STMT s) {
 dAS_STMT ret_val;
 AS_STMT_LIST body1;
 dAS_STMT curr;
 dAS_STMT prev = ((dAS_STMT) NULL);
 dAS_STMT L1;
 dAS_STMT L2;
 L1 = s;
 if (L1==NULL) {
  FATAL("Dispatch on void in TRANS::previous($AS_STMT):$AS_STMT");
 }
 body1 = (*dAS_STMT_surr_stmt_list_1[TAG(L1)+dAS_STMT_surr_stmt_list_1_offset])(L1);
 curr = ATTR(body1,stmts);
 while (1) {
  if ((curr==((dAS_STMT) NULL))) {
   goto after_loop;
  }
  if (SYSOBEQ(((OB) curr),((OB) s))) {
   ret_val = prev;
   return ret_val;
  }
  prev = curr;
  L2 = curr;
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::previous($AS_STMT):$AS_STMT");
  }
  curr = (*dAS_STMT_next_dAS_STMT[TAG(L2)+dAS_STMT_next_dAS_STMT_offset])(L2);
 }
 after_loop: ;
 ret_val = ((dAS_STMT) NULL);
 return ret_val;
}


void TRANS_append_export_in_l(TRANS self, AS_STMT_LIST l, BOOL on_exit_only) {
 dAS_STMT s;
 dAS_STMT export11;
 dAS_STMT p;
 dAS_EXPR e;
 AS_CASE_WHEN wp;
 AS_TYPECASE_WHEN wp1;
 dAS_EXPR lck;
 dAS_EXPR lck1;
 dAS_STMT export2;
 dAS_STMT export3;
 BOOL L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 BOOL L5;
 BOOL L6;
 BOOL L7;
 BOOL L8;
 dAS_EXPR L9;
 BOOL L10;
 dAS_EXPR L11;
 dAS_STMT L12;
 dAS_STMT L13;
 INT L14;
 dAS_STMT L15;
 dAS_STMT L16;
 INT L17;
 dAS_STMT L18;
 dAS_STMT L19;
 if ((l==((AS_STMT_LIST) NULL))) {
  return;
 }
 s = ATTR(l,stmts);
 if ((s==((dAS_STMT) NULL))) {
  export11 = TRANS_as_for_sys_import_(self, TRANS_export_code, l, ATTR(l,source11));
  SATTR(l,stmts,export11);
  return;
 }
 p = ((dAS_STMT) NULL);
 while (1) {
  if (TRANS_is_in_try_or_lock_(self)) {
   if (s==NULL) {
   } else
   switch (TAG(s)) {
    case AS_ASSIGN_STMT_tag:
     if (TRANS_is_in_loop_and_cal(self, ATTR(((AS_ASSIGN_STMT) s),rhs))) {
      TRANS_prev_export_dAS_ST(self, p, s, l);
     } break;
    case AS_ASSERT_STMT_tag:
     if (TRANS_is_in_loop_and_cal(self, ATTR(((AS_ASSERT_STMT) s),test1))) {
      TRANS_prev_export_dAS_ST(self, p, s, l);
     } break;
    case AS_EXPR_STMT_tag:
     e = ATTR(((AS_EXPR_STMT) s),e11);
     if (e==NULL) {
     } else
     switch (TAG(e)) {
      case AS_BREAK_EXPR_tag:
       TRANS_prev_export_dAS_ST(self, p, s, l); break;
      case AS_CALL_EXPR_tag:
       L2 = (ATTR(self,cur_loop)==((AM_LOOP_STMT) NULL));
       if ((!(L2))) {
        L1 = TRANS_contains_iter_call(self, TRANS_transform_call_exp(self, ((AS_CALL_EXPR) e), ((dTP) NULL), FALSE));
       } else {
        L1 = FALSE;
       }
       if (L1) {
        TRANS_prev_export_dAS_ST(self, p, s, l);
       } break;
      case AS_AT_EXPR_tag:
       if (TRANS_is_in_loop_and_cal(self, ATTR(((AS_AT_EXPR) e),e11))) {
        L3 = TRUE;
       } else {
        L3 = TRANS_is_in_loop_and_cal(self, ATTR(((AS_AT_EXPR) e),at11));
       }
       if (L3) {
        TRANS_prev_export_dAS_ST(self, p, s, l);
       } break;
      default: ;
     } break;
    case AS_IF_STMT_tag:
     if (TRANS_is_in_loop_and_cal(self, ATTR(((AS_IF_STMT) s),test1))) {
      TRANS_prev_export_dAS_ST(self, p, s, l);
     }
     TRANS_append_export_in_l(self, ATTR(((AS_IF_STMT) s),then_part), TRUE);
     TRANS_append_export_in_l(self, ATTR(((AS_IF_STMT) s),else_part), TRUE); break;
    case AS_LOOP_STMT_tag:
     TRANS_append_export_in_l(self, ATTR(((AS_LOOP_STMT) s),body), TRUE); break;
    case AS_CASE_STMT_tag:
     if (TRANS_is_in_loop_and_cal(self, ATTR(((AS_CASE_STMT) s),test1))) {
      TRANS_prev_export_dAS_ST(self, p, s, l);
     }
     L4 = ATTR(((AS_CASE_STMT) s),no_else);
     if ((!(L4))) {
      TRANS_append_export_in_l(self, ATTR(((AS_CASE_STMT) s),else_part), TRUE);
     }
     wp = ATTR(((AS_CASE_STMT) s),when_part);
     while (1) {
      L5 = (wp==((AS_CASE_WHEN) NULL));
      if ((!(L5))) {
      }
      else {
       goto after_loop1;
      }
      TRANS_append_export_in_l(self, ATTR(wp,then_part), TRUE);
      wp = ATTR(wp,next);
     }
     after_loop1: ; break;
    case AS_TYPECASE_STMT_tag:
     L6 = ATTR(((AS_TYPECASE_STMT) s),no_else);
     if ((!(L6))) {
      TRANS_append_export_in_l(self, ATTR(((AS_TYPECASE_STMT) s),else_part), TRUE);
     }
     wp1 = ATTR(((AS_TYPECASE_STMT) s),when_part);
     while (1) {
      L7 = (wp1==((AS_TYPECASE_WHEN) NULL));
      if ((!(L7))) {
      }
      else {
       goto after_loop2;
      }
      TRANS_append_export_in_l(self, ATTR(wp1,then_part), TRUE);
      wp1 = ATTR(wp1,next);
     }
     after_loop2: ; break;
    case AS_WITH_NEAR_STMT_tag:
     TRANS_append_export_in_l(self, ATTR(((AS_WITH_NEAR_STMT) s),near_part), TRUE);
     TRANS_append_export_in_l(self, ATTR(((AS_WITH_NEAR_STMT) s),else_part), TRUE); break;
    case AS_LOCK_STMT_tag:
     lck = ATTR(((AS_LOCK_STMT) s),e_list);
     while (1) {
      L8 = (lck==((dAS_EXPR) NULL));
      if ((!(L8))) {
      }
      else {
       goto after_loop3;
      }
      if (TRANS_is_in_loop_and_cal(self, lck)) {
       TRANS_prev_export_dAS_ST(self, p, s, l);
      }
      L9 = lck;
      if (L9==NULL) {
       FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
      }
      lck = (*dAS_EXPR_next_dAS_EXPR[TAG(L9)+dAS_EXPR_next_dAS_EXPR_offset])(L9);
     }
     after_loop3: ; break;
    case AS_TRY_STMT_tag:
     lck1 = ATTR(((AS_TRY_STMT) s),e_list);
     while (1) {
      L10 = (lck1==((dAS_EXPR) NULL));
      if ((!(L10))) {
      }
      else {
       goto after_loop4;
      }
      if (TRANS_is_in_loop_and_cal(self, lck1)) {
       TRANS_prev_export_dAS_ST(self, p, s, l);
      }
      L11 = lck1;
      if (L11==NULL) {
       FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
      }
      lck1 = (*dAS_EXPR_next_dAS_EXPR[TAG(L11)+dAS_EXPR_next_dAS_EXPR_offset])(L11);
     }
     after_loop4: ; break;
    default: ;
   }
  }
  L12 = s;
  if (L12==NULL) {
   FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
  }
  if (((*dAS_STMT_next_dAS_STMT[TAG(L12)+dAS_STMT_next_dAS_STMT_offset])(L12)==((dAS_STMT) NULL))) {
   goto after_loop;
  }
  p = s;
  L13 = s;
  if (L13==NULL) {
   FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
  }
  s = (*dAS_STMT_next_dAS_STMT[TAG(L13)+dAS_STMT_next_dAS_STMT_offset])(L13);
 }
 after_loop: ;
 if ((!(on_exit_only))) {
  if (s==NULL) {
   L14 = TRANS_export_code;
   L15 = s;
   if (L15==NULL) {
    FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
   }
   export3 = TRANS_as_for_sys_import_(self, L14, l, (*dAS_STMT_source_SFILE_ID1[TAG(L15)+dAS_STMT_source_SFILE_ID1_offset])(L15));
   L16 = s;
   if (L16==NULL) {
    FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
   }
   (*dAS_STMT_append_dAS_STMT[TAG(L16)+dAS_STMT_append_dAS_STMT_offset])(L16, export3);
  } else
  switch (TAG(s)) {
   case AS_RETURN_STMT_tag:
    return; break;
   case AS_YIELD_STMT_tag:
    return; break;
   case AS_QUIT_STMT_tag:
    return; break;
   case AS_RAISE_STMT_tag:
    return; break;
   case AS_UNCAUGHT_STMT_tag:
    return; break;
   default: ;
    L17 = TRANS_export_code;
    L18 = s;
    if (L18==NULL) {
     FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
    }
    export2 = TRANS_as_for_sys_import_(self, L17, l, (*dAS_STMT_source_SFILE_ID1[TAG(L18)+dAS_STMT_source_SFILE_ID1_offset])(L18));
    L19 = s;
    if (L19==NULL) {
     FATAL("Dispatch on void in TRANS::append_export_in_list(AS_STMT_LIST,BOOL)");
    }
    (*dAS_STMT_append_dAS_STMT[TAG(L19)+dAS_STMT_append_dAS_STMT_offset])(L19, export2);
  }
 }
}


void TRANS_attach_without_gat(TRANS self, AS_ATTACH_STMT s) {
 extern STR statementmusthaveGATEorG;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &statementmusthaveGATEorG));
}


void TRANS_break_not_in_loop_(TRANS self, AS_EXPR_STMT s) {
 extern STR breakbwhilebanduntilbcal;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &breakbwhilebanduntilbcal));
}


void TRANS_expr_stmt_err_AS_E(TRANS self, AS_EXPR_STMT s) {
 extern STR Expressionsusedasstateme;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &Expressionsusedasstateme));
}


void TRANS_extra_return_value(TRANS self, AS_RETURN_STMT s, SIG sig1) {
 extern STR Noreturnvalueshouldbepro;
 STR L1;
 extern STR name5;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = STR_plus_dSTR_STR(((STR) &Noreturnvalueshouldbepro), ((dSTR) ATTR(sig1,str)));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &name5))));
}


void TRANS_extra_yield_value_(TRANS self, AS_YIELD_STMT s, SIG sig1) {
 extern STR Noyieldvalueshouldbeprov;
 STR L1;
 extern STR name5;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = STR_plus_dSTR_STR(((STR) &Noyieldvalueshouldbeprov), ((dSTR) ATTR(sig1,str)));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &name5))));
}


void TRANS_fork_outside_par_e(TRANS self, AS_FORK_STMT s) {
 extern STR forkstatementmustappeari;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &forkstatementmustappeari));
}


void TRANS_insert_import_AS_S(TRANS self, AS_STMT_LIST l, SFILE_ID source1) {
 dAS_STMT import1 = ((dAS_STMT) NULL);
 BOOL L1;
 BOOL L2;
 dAS_STMT L3;
 if (TRANS_do_helper_import) {
  import1 = TRANS_as_for_import_expo(self, TRANS_import_code, l, source1);
 }
 L1 = (import1==((dAS_STMT) NULL));
 if ((!(L1))) {
  L2 = (l==((AS_STMT_LIST) NULL));
  if ((!(L2))) {
   L3 = import1;
   if (L3==NULL) {
    FATAL("Dispatch on void in TRANS::insert_import(AS_STMT_LIST,SFILE_ID)");
   }
   (*dAS_STMT_append_dAS_STMT[TAG(L3)+dAS_STMT_append_dAS_STMT_offset])(L3, ATTR(l,stmts));
  }
  SATTR(l,stmts,import1);
 }
}


void TRANS_insert_import_afte(TRANS self, dAS_STMT t) {
 dAS_STMT import1 = ((dAS_STMT) NULL);
 INT L1;
 dAS_STMT L2;
 AS_STMT_LIST L3;
 dAS_STMT L4;
 BOOL L5;
 dAS_STMT L6;
 dAS_STMT L7;
 dAS_STMT L8;
 if (t==NULL) {
 } else
 switch (TAG(t)) {
  case AS_RETURN_STMT_tag:
   return; break;
  case AS_RAISE_STMT_tag:
   return; break;
  case AS_UNCAUGHT_STMT_tag:
   return; break;
  case AS_QUIT_STMT_tag:
   return; break;
  default: ;
 }
 if (TRANS_do_helper_import) {
  L1 = TRANS_import_code;
  L2 = t;
  if (L2==NULL) {
   FATAL("Dispatch on void in TRANS::insert_import_after($AS_STMT)");
  }
  L3 = (*dAS_STMT_surr_stmt_list_1[TAG(L2)+dAS_STMT_surr_stmt_list_1_offset])(L2);
  L4 = t;
  if (L4==NULL) {
   FATAL("Dispatch on void in TRANS::insert_import_after($AS_STMT)");
  }
  import1 = TRANS_as_for_import_expo(self, L1, L3, (*dAS_STMT_source_SFILE_ID1[TAG(L4)+dAS_STMT_source_SFILE_ID1_offset])(L4));
 }
 L5 = (import1==((dAS_STMT) NULL));
 if ((!(L5))) {
  L6 = t;
  if (L6==NULL) {
   FATAL("Dispatch on void in TRANS::insert_import_after($AS_STMT)");
  }
  L7 = import1;
  if (L7==NULL) {
   FATAL("Dispatch on void in TRANS::insert_import_after($AS_STMT)");
  }
  (*dAS_STMT_append_dAS_STMT[TAG(L7)+dAS_STMT_append_dAS_STMT_offset])(L7, (*dAS_STMT_next_dAS_STMT[TAG(L6)+dAS_STMT_next_dAS_STMT_offset])(L6));
  L8 = t;
  if (L8==NULL) {
   FATAL("Dispatch on void in TRANS::insert_import_after($AS_STMT)");
  }
  (*dAS_STMT_next_dAS_STMT1[TAG(L8)+dAS_STMT_next_dAS_STMT1_offset])(L8, import1);
 }
}


void TRANS_missing_return_val(TRANS self, AS_RETURN_STMT s, dTP tp) {
 extern STR Areturnvalueoftype;
 dTP L1;
 STR L2;
 extern STR mustbespecified;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = tp;
 if (L1==NULL) {
  FATAL("Dispatch on void in TRANS::missing_return_value_err(AS_RETURN_STMT,$TP)");
 }
 L2 = STR_plus_dSTR_STR(((STR) &Areturnvalueoftype), ((dSTR) (*dTP_str_STR[TAG(L1)+dTP_str_STR_offset])(L1)));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &mustbespecified))));
}


void TRANS_missing_yield_valu(TRANS self, AS_YIELD_STMT s, dTP tp) {
 extern STR Ayieldvalueoftype;
 dTP L1;
 STR L2;
 extern STR mustbespecified;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = tp;
 if (L1==NULL) {
  FATAL("Dispatch on void in TRANS::missing_yield_value_err(AS_YIELD_STMT,$TP)");
 }
 L2 = STR_plus_dSTR_STR(((STR) &Ayieldvalueoftype), ((dSTR) (*dTP_str_STR[TAG(L1)+dTP_str_STR_offset])(L1)));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &mustbespecified))));
}


void TRANS_prev_export_dAS_ST(TRANS self, dAS_STMT p, dAS_STMT s, AS_STMT_LIST l) {
 dAS_STMT export11;
 INT L1;
 dAS_STMT L2;
 dAS_STMT L3;
 dAS_STMT L4;
 L1 = TRANS_export_code;
 L2 = s;
 if (L2==NULL) {
  FATAL("Dispatch on void in TRANS::prev_export($AS_STMT,$AS_STMT,AS_STMT_LIST)");
 }
 export11 = TRANS_as_for_sys_import_(self, L1, l, (*dAS_STMT_source_SFILE_ID1[TAG(L2)+dAS_STMT_source_SFILE_ID1_offset])(L2));
 L3 = export11;
 if (L3==NULL) {
  FATAL("Dispatch on void in TRANS::prev_export($AS_STMT,$AS_STMT,AS_STMT_LIST)");
 }
 (*dAS_STMT_next_dAS_STMT1[TAG(L3)+dAS_STMT_next_dAS_STMT1_offset])(L3, s);
 if ((p==((dAS_STMT) NULL))) {
  SATTR(l,stmts,export11);
 }
 else {
  L4 = p;
  if (L4==NULL) {
   FATAL("Dispatch on void in TRANS::prev_export($AS_STMT,$AS_STMT,AS_STMT_LIST)");
  }
  (*dAS_STMT_next_dAS_STMT1[TAG(L4)+dAS_STMT_next_dAS_STMT1_offset])(L4, export11);
 }
}


void TRANS_quit_in_par_fork_e(TRANS self, AS_QUIT_STMT s) {
 extern STR quitstatementsmaynotappe;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &quitstatementsmaynotappe));
}


void TRANS_quit_in_rout_err_A(TRANS self, AS_QUIT_STMT s) {
 extern STR quitstatementsmaynotappe1;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &quitstatementsmaynotappe1));
}


void TRANS_return_in_iter_err(TRANS self, AS_RETURN_STMT s) {
 extern STR returnstatementsmaynotap;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &returnstatementsmaynotap));
}


void TRANS_return_in_par_fork(TRANS self, AS_RETURN_STMT s) {
 extern STR returnstatementsmaynotap1;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &returnstatementsmaynotap1));
}


void TRANS_stmts_after_quit_e(TRANS self, AS_QUIT_STMT s) {
 extern STR Nostatementsmayfollowqui;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &Nostatementsmayfollowqui));
}


void TRANS_stmts_after_raise_(TRANS self, AS_RAISE_STMT s) {
 extern STR Nostatementsmayfollowrai;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &Nostatementsmayfollowrai));
}


void TRANS_stmts_after_return(TRANS self, AS_RETURN_STMT s) {
 extern STR Nostatementsmayfollowret;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &Nostatementsmayfollowret));
}


void TRANS_transform_pSather_2(TRANS self, AM_LOCAL_EXPR loc, AS_ASSIGN_STMT s) {
 AS_ASSIGN_STMT as;
 AM_LOCAL_EXPR last_helper;
 AM_LOCAL_EXPR rel_helper = ((AM_LOCAL_EXPR) NULL);
 AS_CALL_EXPR locvar;
 AS_CALL_EXPR helploc;
 BOOL L1;
 INT L2;
 STR L3;
 extern STR S_pS_cohort;
 BOOL L4;
 BOOL L5;
 L2 = STR_size_INT(ATTR(loc,name1).str);
 if ((L2>=10)) {
  L3 = STR_head_INT_STR(ATTR(loc,name1).str, 10);
  L1 = STR_is_eq_STR_BOOL(L3, ((STR) &S_pS_cohort));
 } else {
  L1 = FALSE;
 }
 if (L1) {
  if ((ATTR(self,cur_cohort)==((AM_LOCAL_EXPR) NULL))) {
   SATTR(self,cur_cohort,loc);
  }
 }
 L4 = ATTR(s,transformed);
 if ((!(L4))) {
  SATTR(s,transformed,TRUE);
  L5 = TRANS_do_direct_export;
  if ((!(L5))) {
   return;
  }
  as = ((AS_ASSIGN_STMT) NULL);
  last_helper = TRANS_last_declared_help(self);
  if ((last_helper==((AM_LOCAL_EXPR) NULL))) {
   return;
  }
  if ((ATTR(self,cur_param_ob)==((AM_LOCAL_EXPR) NULL))) {
   rel_helper = last_helper;
  }
  else {
   rel_helper = TRANS_last_declared_par_(self);
   if ((rel_helper==((AM_LOCAL_EXPR) NULL))) {
    rel_helper = last_helper;
   }
  }
  if (TRANS_local_is_in_par_he(self, ATTR(loc,name1), rel_helper)) {
   as = AS_ASSIGN_STMT_create_AS(((AS_ASSIGN_STMT) NULL));
   SATTR(as,source11,ATTR(s,source11));
   SATTR(as,surr_stmt_list,ATTR(s,surr_stmt_list));
   locvar = AS_CALL_EXPR_create_AS_C(((AS_CALL_EXPR) NULL));
   SATTR(locvar,source11,ATTR(s,source11));
   SATTR(locvar,name1,ATTR(loc,name1));
   helploc = TRANS_as_of_local_in_hel(self, ATTR(loc,name1), rel_helper, ATTR(s,source11));
   SATTR(as,lhs_expr,((dAS_EXPR) helploc));
   SATTR(as,rhs,((dAS_EXPR) locvar));
   SATTR(as,next,ATTR(s,next));
   SATTR(s,next,((dAS_STMT) as));
   return;
  }
 }
}


void TRANS_transform_pSather_3(TRANS self, AS_ASSIGN_STMT s) {
 dAS_EXPR lhs;
 extern STR Itisillegaltoassigntoahe;
 extern STR Itisillegaltoassigntoana;
 extern STR Itisillegaltoassigntoaco;
 extern STR Itisillegaltoassigntoawh;
 extern STR Itisillegaltoassigntoane;
 extern STR Itisillegaltoassigntoafa;
 extern STR Itisillegaltoassigntoana1;
 lhs = ATTR(s,lhs_expr);
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) lhs));
 if (lhs==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(lhs)) {
  case AS_HERE_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoahe)); break;
  case AS_ANY_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoana)); break;
  case AS_COHORT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoaco)); break;
  case AS_WHERE_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoawh)); break;
  case AS_NEAR_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoane)); break;
  case AS_FAR_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoafa)); break;
  case AS_AT_EXPR_tag:
   TRANS_err_STR(self, ((STR) &Itisillegaltoassigntoana1)); break;
  default: ;
   FATAL("No applicable type in typecase");
 }
}


void TRANS_typecase_hot_local(TRANS self, AS_TYPECASE_STMT s) {
 extern STR Thetypecasetestlocal;
 STR L1;
 extern STR mustnotbeabargumenttoani;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = STR_plus_dSTR_STR(((STR) &Thetypecasetestlocal), ((dSTR) ATTR(s,name1).str));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &mustnotbeabargumenttoani))));
}


void TRANS_typecase_local_err(TRANS self, AS_TYPECASE_STMT s) {
 extern STR Thename;
 STR L1;
 extern STR isntalocalvariable;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 L1 = STR_plus_dSTR_STR(((STR) &Thename), ((dSTR) ATTR(s,name1).str));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &isntalocalvariable))));
}


void TRANS_typecase_no_branch(TRANS self, AS_TYPECASE_STMT s) {
 extern STR Therearenomatchingbranch;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &Therearenomatchingbranch));
}


void TRANS_unlock_in_par_fork(TRANS self, AS_UNLOCK_STMT s) {
 extern STR unlockstatementmaynotnot;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &unlockstatementmaynotnot));
}


void TRANS_unlock_outside_try(TRANS self, AS_UNLOCK_STMT s) {
 extern STR unlockstatementmustappea;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &unlockstatementmustappea));
}


void TRANS_unprotected_raise_(TRANS self, AS_RAISE_STMT s) {
 extern STR Insideofparparlooporfork;
 extern STR shouldbeinsideofaprotect;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_warning_STR(self, STR_plus_dSTR_STR(((STR) &Insideofparparlooporfork), ((dSTR) ((STR) &shouldbeinsideofaprotect))));
}


void TRANS_update_routine_in_(TRANS self, TP_CLASS cur_class_tp, AS_ROUT_DEF newrout) {
 SIG sig1;
 ELT elt1;
 IMPL impl;
 ELT f;
 extern STR CompilerErrPTRANSupdate_;
 extern STR CompilerErrPTRANSupdate_1;
 extern STR CompilerErrPTRANSupdate_2;
 sig1 = SIG_rout_sig_AS_ROUT_DEF(((SIG) NULL), newrout, ATTR(newrout,name1), ATTR(self,tp_con));
 if ((sig1==((SIG) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrPTRANSupdate_));
 }
 elt1 = ELT_create_SIG_SIG_dAS_C(((ELT) NULL), sig1, sig1, ((dAS_CLASS_ELT) newrout), ATTR(self,tp_con), ATTR(newrout,is_private));
 if ((elt1==((ELT) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrPTRANSupdate_1));
 }
 impl = IMPL_TBL_impl_of_dTP_IMP(ATTR(ATTR(self,prog1),impl_tbl), ((dTP) cur_class_tp));
 if ((impl==((IMPL) NULL))) {
  TRANS_err_STR(self, ((STR) &CompilerErrPTRANSupdate_2));
 }
 f = ELT_TBL_elt_same_name_as(ATTR(impl,elts), elt1);
 if ((f==((ELT) NULL))) {
  SATTR(impl,elts,ELT_TBL_insert_ELT_ELT_T(ATTR(impl,elts), elt1));
 }
}


void TRANS_warning_STR(TRANS self, STR s) {
 PROG_warning_STR(ATTR(self,prog1), s);
}


void TRANS_with_near_locals_o(TRANS self, AS_IDENT_LIST i) {
 extern STR withnearcantuse;
 STR L1;
 extern STR Localsargumentsandselfon;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) i));
 L1 = STR_plus_dSTR_STR(((STR) &withnearcantuse), ((dSTR) ATTR(i,name1).str));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &Localsargumentsandselfon))));
}


void TRANS_with_near_non_ref_(TRANS self, AS_IDENT_LIST i) {
 extern STR withnearcantuse1;
 STR L1;
 extern STR Referenceobjectsonly;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) i));
 L1 = STR_plus_dSTR_STR(((STR) &withnearcantuse1), ((dSTR) ATTR(i,name1).str));
 TRANS_err_STR(self, STR_plus_dSTR_STR(L1, ((dSTR) ((STR) &Referenceobjectsonly))));
}


void TRANS_yield_in_par_fork_(TRANS self, AS_YIELD_STMT s) {
 extern STR yieldstatementsmaynotapp2;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &yieldstatementsmaynotapp2));
}


void TRANS_yield_in_protect_e(TRANS self, AS_YIELD_STMT s) {
 extern STR yieldstatementsmaynotapp1;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &yieldstatementsmaynotapp1));
}


void TRANS_yield_in_rout_err_(TRANS self, AS_YIELD_STMT s) {
 extern STR yieldstatementsmaynotapp;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &yieldstatementsmaynotapp));
}


void TRANS_yield_in_try_lock_(TRANS self, AS_YIELD_STMT s) {
 extern STR yieldstatementsmaynotapp3;
 TRANS_err_loc_dPROG_ERR(self, ((dPROG_ERR) s));
 TRANS_err_STR(self, ((STR) &yieldstatementsmaynotapp3));
}

/* C for type TUPAM_BND_CREATE_EXPRAM_ */




INT TUPAM_BND_CREATE_EXPRAM_1(TUPAM_BND_CREATE_EXPRAM_ self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_BND_CREATE_EXPR lt1;
 AM_BND_CREATE_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_BND_CREATE_EXPRBOU */




INT TUPAM_BND_CREATE_EXPRBOU1(TUPAM_BND_CREATE_EXPRBOU self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_BND_CREATE_EXPR lt1;
 BOUND_OBJECT_LAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_BND_ITER_CALL_EXPR */




INT TUPAM_BND_ITER_CALL_EXPR1(TUPAM_BND_ITER_CALL_EXPR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_BND_ITER_CALL_EXPR lt1;
 AM_BND_ITER_CALL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_GLOBAL_EXPRAM_GLOB */




INT TUPAM_GLOBAL_EXPRAM_GLOB1(TUPAM_GLOBAL_EXPRAM_GLOB self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_GLOBAL_EXPR lt1;
 AM_GLOBAL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_ITER_CALL_EXPRAM_I */




INT TUPAM_ITER_CALL_EXPRAM_I1(TUPAM_ITER_CALL_EXPRAM_I self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_ITER_CALL_EXPR lt1;
 AM_ITER_CALL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}
