#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dAM_CONST_struct {
 OB_HEADER header;
 } *dAM_CONST;

typedef struct dAM_EXPR_struct {
 OB_HEADER header;
 } *dAM_EXPR;

typedef struct dAM_STMT_struct {
 OB_HEADER header;
 } *dAM_STMT;

typedef struct dHASH_struct {
 OB_HEADER header;
 } *dHASH;

typedef struct dLAYOUT_struct {
 OB_HEADER header;
 } *dLAYOUT;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ABSTRACT_FRAME_LAYOUT_struct {/* layout for ABSTRACT_FRAME_LAYOUT */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct SIG_struct *sig11;
 STR str1;
 } *ABSTRACT_FRAME_LAYOUT;

typedef struct ARG_LAYOUT_struct {/* layout for ARG_LAYOUT */
 OB_HEADER header;
 struct SIG_struct *sig11;
 STR str1;
 } *ARG_LAYOUT;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;

typedef struct FRAME_LAYOUT_struct {/* layout for FRAME_LAYOUT */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *f1;
 struct PROG_struct *prog1;
 STR str1;
 } *FRAME_LAYOUT;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_INCLUDE_struct {/* layout for IMPL_INCLUDE */
 OB_HEADER header;
 struct AS_INCLUDE_CLAUSE_struct *as1;
 struct ELT_TBL_struct *elt_tbl;
 struct FSETAS_FEAT_MOD_struct *used_mods;
 struct IMPL_struct *impl;
 struct TP_CLASS_struct *itp;
 struct TP_CLASS_struct *tp1;
 } *IMPL_INCLUDE;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct ITER_INLINE_struct {/* layout for ITER_INLINE */
 OB_HEADER header;
 STR after1;
 STR at_decs;
 STR before1;
 STR when_first_seen;
 } *ITER_INLINE;

typedef struct LAYOUT_TBL_struct {/* layout for LAYOUT_TBL */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *LAYOUT_TBL;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct NAMESPACE_struct {/* layout for NAMESPACE */
 OB_HEADER header;
 struct FMAPSTRINT_struct *uniques;
 struct FSETSTR_struct *set;
 INT counter1;
 struct NAMEMAP_struct *map;
 } *NAMESPACE;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TUPdAM_CONSTdAM_CONST_struct {/* layout for TUP{$AM_CONST,$AM_CONST} */
 struct dAM_CONST_struct *t1;
 struct dAM_CONST_struct *t2;
 } TUPdAM_CONSTdAM_CONST;
static TUPdAM_CONSTdAM_CONST TUPdAM_CONSTdAM_CONST_zero;

typedef struct TUPdAM_CONSTdAM_CONST_boxed_struct {
 OB_HEADER header;
 TUPdAM_CONSTdAM_CONST value_part;
 } *TUPdAM_CONSTdAM_CONST_boxed;

typedef struct TUPdAM_EXPRdAM_EXPR_struct {/* layout for TUP{$AM_EXPR,$AM_EXPR} */
 struct dAM_EXPR_struct *t1;
 struct dAM_EXPR_struct *t2;
 } TUPdAM_EXPRdAM_EXPR;
static TUPdAM_EXPRdAM_EXPR TUPdAM_EXPRdAM_EXPR_zero;

typedef struct TUPdAM_EXPRdAM_EXPR_boxed_struct {
 OB_HEADER header;
 TUPdAM_EXPRdAM_EXPR value_part;
 } *TUPdAM_EXPRdAM_EXPR_boxed;

typedef struct TUPdAM_EXPRdTP_struct {/* layout for TUP{$AM_EXPR,$TP} */
 struct dAM_EXPR_struct *t1;
 struct dTP_struct *t2;
 } TUPdAM_EXPRdTP;
static TUPdAM_EXPRdTP TUPdAM_EXPRdTP_zero;

typedef struct TUPdAM_EXPRdTP_boxed_struct {
 OB_HEADER header;
 TUPdAM_EXPRdTP value_part;
 } *TUPdAM_EXPRdTP_boxed;

typedef struct TUPdAM_STMTdAM_STMT_struct {/* layout for TUP{$AM_STMT,$AM_STMT} */
 struct dAM_STMT_struct *t1;
 struct dAM_STMT_struct *t2;
 } TUPdAM_STMTdAM_STMT;
static TUPdAM_STMTdAM_STMT TUPdAM_STMTdAM_STMT_zero;

typedef struct TUPdAM_STMTdAM_STMT_boxed_struct {
 OB_HEADER header;
 TUPdAM_STMTdAM_STMT value_part;
 } *TUPdAM_STMTdAM_STMT_boxed;

typedef struct TUPdLAYOUTdLAYOUT_struct {/* layout for TUP{$LAYOUT,$LAYOUT} */
 struct dLAYOUT_struct *t1;
 struct dLAYOUT_struct *t2;
 } TUPdLAYOUTdLAYOUT;
static TUPdLAYOUTdLAYOUT TUPdLAYOUTdLAYOUT_zero;

typedef struct TUPdLAYOUTdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdLAYOUTdLAYOUT value_part;
 } *TUPdLAYOUTdLAYOUT_boxed;

typedef struct TUPdOBNAMESPACE_struct {/* layout for TUP{$OB,NAMESPACE} */
 OB t1;
 struct NAMESPACE_struct *t2;
 } TUPdOBNAMESPACE;
static TUPdOBNAMESPACE TUPdOBNAMESPACE_zero;

typedef struct TUPdOBNAMESPACE_boxed_struct {
 OB_HEADER header;
 TUPdOBNAMESPACE value_part;
 } *TUPdOBNAMESPACE_boxed;

typedef struct TUPdOBSTR_struct {/* layout for TUP{$OB,STR} */
 OB t1;
 STR t2;
 } TUPdOBSTR;
static TUPdOBSTR TUPdOBSTR_zero;

typedef struct TUPdOBSTR_boxed_struct {
 OB_HEADER header;
 TUPdOBSTR value_part;
 } *TUPdOBSTR_boxed;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPdTPdTP_struct {/* layout for TUP{$TP,$TP} */
 struct dTP_struct *t1;
 struct dTP_struct *t2;
 } TUPdTPdTP;
static TUPdTPdTP TUPdTPdTP_zero;

typedef struct TUPdTPdTP_boxed_struct {
 OB_HEADER header;
 TUPdTPdTP value_part;
 } *TUPdTPdTP_boxed;

typedef struct TUPdTPCODE_FILE_struct {/* layout for TUP{$TP,CODE_FILE} */
 struct dTP_struct *t1;
 struct CODE_FILE_struct *t2;
 } TUPdTPCODE_FILE;
static TUPdTPCODE_FILE TUPdTPCODE_FILE_zero;

typedef struct TUPdTPCODE_FILE_boxed_struct {
 OB_HEADER header;
 TUPdTPCODE_FILE value_part;
 } *TUPdTPCODE_FILE_boxed;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_struct {/* layout for TUP{$TP,FMAP{IDENT,AM_GLOBAL_EXPR}} */
 struct dTP_struct *t1;
 struct FMAPIDENTAM_GLOBAL_EXPR_struct *t2;
 } TUPdTPFMAPIDENTAM_GLOBAL;
static TUPdTPFMAPIDENTAM_GLOBAL TUPdTPFMAPIDENTAM_GLOBAL_zero;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_boxed_struct {
 OB_HEADER header;
 TUPdTPFMAPIDENTAM_GLOBAL value_part;
 } *TUPdTPFMAPIDENTAM_GLOBAL_boxed;

typedef struct TUPdTPIFC_struct {/* layout for TUP{$TP,IFC} */
 struct dTP_struct *t1;
 struct IFC_struct *t2;
 } TUPdTPIFC;
static TUPdTPIFC TUPdTPIFC_zero;

typedef struct TUPdTPIFC_boxed_struct {
 OB_HEADER header;
 TUPdTPIFC value_part;
 } *TUPdTPIFC_boxed;

typedef struct TUPdTPIMPL_struct {/* layout for TUP{$TP,IMPL} */
 struct dTP_struct *t1;
 struct IMPL_struct *t2;
 } TUPdTPIMPL;
static TUPdTPIMPL TUPdTPIMPL_zero;

typedef struct TUPdTPIMPL_boxed_struct {
 OB_HEADER header;
 TUPdTPIMPL value_part;
 } *TUPdTPIMPL_boxed;

typedef struct TUPdTPINT_struct {/* layout for TUP{$TP,INT} */
 struct dTP_struct *t1;
 INT t2;
 } TUPdTPINT;
static TUPdTPINT TUPdTPINT_zero;

typedef struct TUPdTPINT_boxed_struct {
 OB_HEADER header;
 TUPdTPINT value_part;
 } *TUPdTPINT_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPAM_ROUT_DEFAM_ROUT_DE_struct {/* layout for TUP{AM_ROUT_DEF,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t1;
 struct AM_ROUT_DEF_struct *t2;
 } TUPAM_ROUT_DEFAM_ROUT_DE;
static TUPAM_ROUT_DEFAM_ROUT_DE TUPAM_ROUT_DEFAM_ROUT_DE_zero;

typedef struct TUPAM_ROUT_DEFAM_ROUT_DE_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFAM_ROUT_DE value_part;
 } *TUPAM_ROUT_DEFAM_ROUT_DE_boxed;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_struct {/* layout for TUP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 struct AM_ROUT_DEF_struct *t1;
 struct FLISTAM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ROUT_DEFFLISTAM_IT;
static TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT_zero;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFLISTAM_IT value_part;
 } *TUPAM_ROUT_DEFFLISTAM_IT_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct TUPARRAYdTPdTP_struct {/* layout for TUP{ARRAY{$TP},$TP} */
 struct dTP_struct *t2;
 struct ARRAYdTP_struct *t1;
 } TUPARRAYdTPdTP;
static TUPARRAYdTPdTP TUPARRAYdTPdTP_zero;

typedef struct TUPARRAYdTPdTP_boxed_struct {
 OB_HEADER header;
 TUPARRAYdTPdTP value_part;
 } *TUPARRAYdTPdTP_boxed;

typedef struct TUPARRAYdTPARRAYBOOLdTP_struct {/* layout for TUP{ARRAY{$TP},ARRAY{BOOL},$TP} */
 struct dTP_struct *t3;
 struct ARRAYdTP_struct *t1;
 struct ARRAYBOOL_struct *t2;
 } TUPARRAYdTPARRAYBOOLdTP;
static TUPARRAYdTPARRAYBOOLdTP TUPARRAYdTPARRAYBOOLdTP_zero;

typedef struct TUPARRAYdTPARRAYBOOLdTP_boxed_struct {
 OB_HEADER header;
 TUPARRAYdTPARRAYBOOLdTP value_part;
 } *TUPARRAYdTPARRAYBOOLdTP_boxed;

typedef struct TUPAS_CLASS_DEFAS_CLASS__struct {/* layout for TUP{AS_CLASS_DEF,AS_CLASS_DEF} */
 struct AS_CLASS_DEF_struct *t1;
 struct AS_CLASS_DEF_struct *t2;
 } TUPAS_CLASS_DEFAS_CLASS_;
static TUPAS_CLASS_DEFAS_CLASS_ TUPAS_CLASS_DEFAS_CLASS__zero;

typedef struct TUPAS_CLASS_DEFAS_CLASS__boxed_struct {
 OB_HEADER header;
 TUPAS_CLASS_DEFAS_CLASS_ value_part;
 } *TUPAS_CLASS_DEFAS_CLASS__boxed;

typedef struct TUPBOOLINTIINTBOOL_struct {/* layout for TUP{BOOL,INTI,INT,BOOL} */
 INT t3;
 struct INTI_struct *t2;
 BOOL t1;
 BOOL t4;
 } TUPBOOLINTIINTBOOL;
static TUPBOOLINTIINTBOOL TUPBOOLINTIINTBOOL_zero;

typedef struct TUPBOOLINTIINTBOOL_boxed_struct {
 OB_HEADER header;
 TUPBOOLINTIINTBOOL value_part;
 } *TUPBOOLINTIINTBOOL_boxed;

typedef struct TUPCHARCHAR_struct {/* layout for TUP{CHAR,CHAR} */
 CHAR t1;
 CHAR t2;
 } TUPCHARCHAR;
static TUPCHARCHAR TUPCHARCHAR_zero;

typedef struct TUPCHARCHAR_boxed_struct {
 OB_HEADER header;
 TUPCHARCHAR value_part;
 } *TUPCHARCHAR_boxed;

typedef struct TUPCODE_FILECODE_FILE_struct {/* layout for TUP{CODE_FILE,CODE_FILE} */
 struct CODE_FILE_struct *t1;
 struct CODE_FILE_struct *t2;
 } TUPCODE_FILECODE_FILE;
static TUPCODE_FILECODE_FILE TUPCODE_FILECODE_FILE_zero;

typedef struct TUPCODE_FILECODE_FILE_boxed_struct {
 OB_HEADER header;
 TUPCODE_FILECODE_FILE value_part;
 } *TUPCODE_FILECODE_FILE_boxed;

typedef struct TUPFLISTdAM_CONSTFLISTdA_struct {/* layout for TUP{FLIST{$AM_CONST},FLIST{$AM_CONST}} */
 struct FLISTdAM_CONST_struct *t1;
 struct FLISTdAM_CONST_struct *t2;
 } TUPFLISTdAM_CONSTFLISTdA;
static TUPFLISTdAM_CONSTFLISTdA TUPFLISTdAM_CONSTFLISTdA_zero;

typedef struct TUPFLISTdAM_CONSTFLISTdA_boxed_struct {
 OB_HEADER header;
 TUPFLISTdAM_CONSTFLISTdA value_part;
 } *TUPFLISTdAM_CONSTFLISTdA_boxed;

typedef struct TUPFLTFLT_struct {/* layout for TUP{FLT,FLT} */
 FLT t1;
 FLT t2;
 } TUPFLTFLT;
static TUPFLTFLT TUPFLTFLT_zero;

typedef struct TUPFLTFLT_boxed_struct {
 OB_HEADER header;
 TUPFLTFLT value_part;
 } *TUPFLTFLT_boxed;

typedef struct TUPFLTDFLTD_struct {/* layout for TUP{FLTD,FLTD} */
 FLTD t1;
 FLTD t2;
 } TUPFLTDFLTD;
static TUPFLTDFLTD TUPFLTDFLTD_zero;

typedef struct TUPFLTDFLTD_boxed_struct {
 OB_HEADER header;
 TUPFLTDFLTD value_part;
 } *TUPFLTDFLTD_boxed;

typedef struct TUPFSTRFSTR_struct {/* layout for TUP{FSTR,FSTR} */
 struct FSTR_struct *t1;
 struct FSTR_struct *t2;
 } TUPFSTRFSTR;
static TUPFSTRFSTR TUPFSTRFSTR_zero;

typedef struct TUPFSTRFSTR_boxed_struct {
 OB_HEADER header;
 TUPFSTRFSTR value_part;
 } *TUPFSTRFSTR_boxed;

typedef struct TUPIDENTdTP_struct {/* layout for TUP{IDENT,$TP} */
 struct dTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTdTP;
static TUPIDENTdTP TUPIDENTdTP_zero;

typedef struct TUPIDENTdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTdTP value_part;
 } *TUPIDENTdTP_boxed;

typedef struct TUPIDENTAM_GLOBAL_EXPR_struct {/* layout for TUP{IDENT,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTAM_GLOBAL_EXPR;
static TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_zero;

typedef struct TUPIDENTAM_GLOBAL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPIDENTAM_GLOBAL_EXPR value_part;
 } *TUPIDENTAM_GLOBAL_EXPR_boxed;

typedef struct TUPIDENTARRAYdTP_struct {/* layout for TUP{IDENT,ARRAY{$TP}} */
 struct ARRAYdTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTARRAYdTP;
static TUPIDENTARRAYdTP TUPIDENTARRAYdTP_zero;

typedef struct TUPIDENTARRAYdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTARRAYdTP value_part;
 } *TUPIDENTARRAYdTP_boxed;

typedef struct TUPIDENTIDENT_struct {/* layout for TUP{IDENT,IDENT} */
 struct IDENT_struct t1;
 struct IDENT_struct t2;
 } TUPIDENTIDENT;
static TUPIDENTIDENT TUPIDENTIDENT_zero;

typedef struct TUPIDENTIDENT_boxed_struct {
 OB_HEADER header;
 TUPIDENTIDENT value_part;
 } *TUPIDENTIDENT_boxed;

typedef struct TUPIDENTINT_struct {/* layout for TUP{IDENT,INT} */
 struct IDENT_struct t1;
 INT t2;
 } TUPIDENTINT;
static TUPIDENTINT TUPIDENTINT_zero;

typedef struct TUPIDENTINT_boxed_struct {
 OB_HEADER header;
 TUPIDENTINT value_part;
 } *TUPIDENTINT_boxed;

typedef struct TUPIFCIFC_struct {/* layout for TUP{IFC,IFC} */
 struct IFC_struct *t1;
 struct IFC_struct *t2;
 } TUPIFCIFC;
static TUPIFCIFC TUPIFCIFC_zero;

typedef struct TUPIFCIFC_boxed_struct {
 OB_HEADER header;
 TUPIFCIFC value_part;
 } *TUPIFCIFC_boxed;

typedef struct TUPIMPL_INCLUDEIMPL_INCL_struct {/* layout for TUP{IMPL_INCLUDE,IMPL_INCLUDE} */
 struct IMPL_INCLUDE_struct *t1;
 struct IMPL_INCLUDE_struct *t2;
 } TUPIMPL_INCLUDEIMPL_INCL;
static TUPIMPL_INCLUDEIMPL_INCL TUPIMPL_INCLUDEIMPL_INCL_zero;

typedef struct TUPIMPL_INCLUDEIMPL_INCL_boxed_struct {
 OB_HEADER header;
 TUPIMPL_INCLUDEIMPL_INCL value_part;
 } *TUPIMPL_INCLUDEIMPL_INCL_boxed;

typedef struct TUPINTINTINT_struct {/* layout for TUP{INT,INT,INT} */
 INT t1;
 INT t2;
 INT t3;
 } TUPINTINTINT;
static TUPINTINTINT TUPINTINTINT_zero;

typedef struct TUPINTINTINT_boxed_struct {
 OB_HEADER header;
 TUPINTINTINT value_part;
 } *TUPINTINTINT_boxed;

typedef struct TUPINTINT_struct {/* layout for TUP{INT,INT} */
 INT t1;
 INT t2;
 } TUPINTINT;
static TUPINTINT TUPINTINT_zero;

typedef struct TUPINTINT_boxed_struct {
 OB_HEADER header;
 TUPINTINT value_part;
 } *TUPINTINT_boxed;

typedef struct TUPINTIINTIINTI_struct {/* layout for TUP{INTI,INTI,INTI} */
 struct INTI_struct *t1;
 struct INTI_struct *t2;
 struct INTI_struct *t3;
 } TUPINTIINTIINTI;
static TUPINTIINTIINTI TUPINTIINTIINTI_zero;

typedef struct TUPINTIINTIINTI_boxed_struct {
 OB_HEADER header;
 TUPINTIINTIINTI value_part;
 } *TUPINTIINTIINTI_boxed;

typedef struct TUPSFILE_IDSFILE_ID_struct {/* layout for TUP{SFILE_ID,SFILE_ID} */
 struct SFILE_ID_struct t1;
 struct SFILE_ID_struct t2;
 } TUPSFILE_IDSFILE_ID;
static TUPSFILE_IDSFILE_ID TUPSFILE_IDSFILE_ID_zero;

typedef struct TUPSFILE_IDSFILE_ID_boxed_struct {
 OB_HEADER header;
 TUPSFILE_IDSFILE_ID value_part;
 } *TUPSFILE_IDSFILE_ID_boxed;

typedef struct TUPSIGABSTRACT_FRAME_LAY_struct {/* layout for TUP{SIG,ABSTRACT_FRAME_LAYOUT} */
 struct ABSTRACT_FRAME_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGABSTRACT_FRAME_LAY;
static TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY_zero;

typedef struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct {
 OB_HEADER header;
 TUPSIGABSTRACT_FRAME_LAY value_part;
 } *TUPSIGABSTRACT_FRAME_LAY_boxed;

typedef struct TUPSIGAM_ROUT_DEF_struct {/* layout for TUP{SIG,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGAM_ROUT_DEF;
static TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_zero;

typedef struct TUPSIGAM_ROUT_DEF_boxed_struct {
 OB_HEADER header;
 TUPSIGAM_ROUT_DEF value_part;
 } *TUPSIGAM_ROUT_DEF_boxed;

typedef struct TUPSIGARG_LAYOUT_struct {/* layout for TUP{SIG,ARG_LAYOUT} */
 struct ARG_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGARG_LAYOUT;
static TUPSIGARG_LAYOUT TUPSIGARG_LAYOUT_zero;

typedef struct TUPSIGARG_LAYOUT_boxed_struct {
 OB_HEADER header;
 TUPSIGARG_LAYOUT value_part;
 } *TUPSIGARG_LAYOUT_boxed;

typedef struct TUPSIGSIG_struct {/* layout for TUP{SIG,SIG} */
 struct SIG_struct *t1;
 struct SIG_struct *t2;
 } TUPSIGSIG;
static TUPSIGSIG TUPSIGSIG_zero;

typedef struct TUPSIGSIG_boxed_struct {
 OB_HEADER header;
 TUPSIGSIG value_part;
 } *TUPSIGSIG_boxed;

typedef struct TUPSIGSTR_struct {/* layout for TUP{SIG,STR} */
 struct SIG_struct *t1;
 STR t2;
 } TUPSIGSTR;
static TUPSIGSTR TUPSIGSTR_zero;

typedef struct TUPSIGSTR_boxed_struct {
 OB_HEADER header;
 TUPSIGSTR value_part;
 } *TUPSIGSTR_boxed;

typedef struct TUPSTRFSETSTR_struct {/* layout for TUP{STR,FSET{STR}} */
 struct FSETSTR_struct *t2;
 STR t1;
 } TUPSTRFSETSTR;
static TUPSTRFSETSTR TUPSTRFSETSTR_zero;

typedef struct TUPSTRFSETSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRFSETSTR value_part;
 } *TUPSTRFSETSTR_boxed;

typedef struct TUPSTRINT_struct {/* layout for TUP{STR,INT} */
 INT t2;
 STR t1;
 } TUPSTRINT;
static TUPSTRINT TUPSTRINT_zero;

typedef struct TUPSTRINT_boxed_struct {
 OB_HEADER header;
 TUPSTRINT value_part;
 } *TUPSTRINT_boxed;

typedef struct TUPSTRITER_INLINE_struct {/* layout for TUP{STR,ITER_INLINE} */
 struct ITER_INLINE_struct *t2;
 STR t1;
 } TUPSTRITER_INLINE;
static TUPSTRITER_INLINE TUPSTRITER_INLINE_zero;

typedef struct TUPSTRITER_INLINE_boxed_struct {
 OB_HEADER header;
 TUPSTRITER_INLINE value_part;
 } *TUPSTRITER_INLINE_boxed;

typedef struct TUPSTRSIG_struct {/* layout for TUP{STR,SIG} */
 struct SIG_struct *t2;
 STR t1;
 } TUPSTRSIG;
static TUPSTRSIG TUPSTRSIG_zero;

typedef struct TUPSTRSIG_boxed_struct {
 OB_HEADER header;
 TUPSTRSIG value_part;
 } *TUPSTRSIG_boxed;

typedef struct TUPSTRSTR_struct {/* layout for TUP{STR,STR} */
 STR t1;
 STR t2;
 } TUPSTRSTR;
static TUPSTRSTR TUPSTRSTR_zero;

typedef struct TUPSTRSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRSTR value_part;
 } *TUPSTRSTR_boxed;

typedef struct TUPTP_CLASSFSETdTP_struct {/* layout for TUP{TP_CLASS,FSET{$TP}} */
 struct FSETdTP_struct *t2;
 struct TP_CLASS_struct *t1;
 } TUPTP_CLASSFSETdTP;
static TUPTP_CLASSFSETdTP TUPTP_CLASSFSETdTP_zero;

typedef struct TUPTP_CLASSFSETdTP_boxed_struct {
 OB_HEADER header;
 TUPTP_CLASSFSETdTP value_part;
 } *TUPTP_CLASSFSETdTP_boxed;

typedef struct TUPTP_CLASSFSETTP_CLASS_struct {/* layout for TUP{TP_CLASS,FSET{TP_CLASS}} */
 struct FSETTP_CLASS_struct *t2;
 struct TP_CLASS_struct *t1;
 } TUPTP_CLASSFSETTP_CLASS;
static TUPTP_CLASSFSETTP_CLASS TUPTP_CLASSFSETTP_CLASS_zero;

typedef struct TUPTP_CLASSFSETTP_CLASS_boxed_struct {
 OB_HEADER header;
 TUPTP_CLASSFSETTP_CLASS value_part;
 } *TUPTP_CLASSFSETTP_CLASS_boxed;

typedef struct UNIX_struct {/* layout for UNIX */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *UNIX;

typedef struct VALUE_CLASS_LAYOUT_struct {/* layout for VALUE_CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *VALUE_CLASS_LAYOUT;

typedef struct WEIGH_CODE_struct {/* layout for WEIGH_CODE */
 OB_HEADER header;
 struct dAM_STMT_struct *badstmt;
 struct AM_IF_STMT_struct *enclosing_if;
 INT level1;
 INT max_weight;
 INT weight;
 BOOL true_branch;
 } *WEIGH_CODE;

typedef struct XFORM_CODE_struct {/* layout for XFORM_CODE */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *after_yield;
 struct AM_IF_STMT_struct *enclosing_if;
 struct AM_IF_STMT_struct *if_encl_yield;
 struct AM_LOOP_STMT_struct *loop_stmt;
 struct AM_LOOP_STMT_struct *new_loop_stmt;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *subst1;
 BOOL record_calls;
 BOOL true_br_yield;
 BOOL true_branch;
 } *XFORM_CODE;

typedef struct AM_ARRAY_EXPR_struct {/* layout for AM_ARRAY_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ARRAY_EXPR;


typedef struct AM_ARRAY_EXPR_eltb_dAM_E_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ARRAY_EXPR L31;
 struct AM_ARRAY_EXPR_aeltb_dAM__frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_eltb_dAM_E_frame;


typedef struct AM_ARRAY_EXPR_setb_dAM_E_frame_struct {
 AM_ARRAY_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ARRAY_EXPR L21;
 struct AM_ARRAY_EXPR_asetb_dAM__frame_struct *nested1; /* nested iter frame */
 } *AM_ARRAY_EXPR_setb_dAM_E_frame;

typedef struct AM_ARR_EXPR_struct {/* layout for AM_ARR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_ARR_EXPR;

typedef struct AM_ASSERT_STMT_struct {/* layout for AM_ASSERT_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_ASSERT_STMT;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTR_EXPR_struct {/* layout for AM_ATTR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_ATTR_EXPR;

typedef struct AM_AT_EXPR_struct {/* layout for AM_AT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *e11;
 struct SFILE_ID_struct source11;
 } *AM_AT_EXPR;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;


typedef struct AM_BND_CREATE_EXPR_eltb__frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_CREATE_EXPR L31;
 struct AM_BND_CREATE_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_eltb__frame;


typedef struct AM_BND_CREATE_EXPR_setb__frame_struct {
 AM_BND_CREATE_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_CREATE_EXPR L21;
 struct AM_BND_CREATE_EXPR_asetb_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_CREATE_EXPR_setb__frame;

typedef struct AM_BND_ITER_CALL_EXPR_struct {/* layout for AM_BND_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *bi;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ITER_CALL_EXPR;


typedef struct AM_BND_ITER_CALL_EXPR_el_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_ITER_CALL_EXPR L31;
 struct AM_BND_ITER_CALL_EXPR_ae_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ITER_CALL_EXPR_el_frame;


typedef struct AM_BND_ITER_CALL_EXPR_se_frame_struct {
 AM_BND_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_ITER_CALL_EXPR L21;
 struct AM_BND_ITER_CALL_EXPR_as2_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ITER_CALL_EXPR_se_frame;

typedef struct AM_BND_ROUT_CALL_EXPR_struct {/* layout for AM_BND_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *br;
 struct SFILE_ID_struct source11;
 struct TP_ROUT_struct *br_tp;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ROUT_CALL_EXPR;


typedef struct AM_BND_ROUT_CALL_EXPR_el_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_BND_ROUT_CALL_EXPR L31;
 struct AM_BND_ROUT_CALL_EXPR_ae_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_el_frame;


typedef struct AM_BND_ROUT_CALL_EXPR_se_frame_struct {
 AM_BND_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_BND_ROUT_CALL_EXPR L21;
 struct AM_BND_ROUT_CALL_EXPR_as2_frame_struct *nested1; /* nested iter frame */
 } *AM_BND_ROUT_CALL_EXPR_se_frame;

typedef struct AM_BREAK_STMT_struct {/* layout for AM_BREAK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_BREAK_STMT;

typedef struct AM_CASE_STMT_struct {/* layout for AM_CASE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTFLISTdAM_CONST_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_CASE_STMT;

typedef struct AM_EXPR_STMT_struct {/* layout for AM_EXPR_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_EXPR_STMT;

typedef struct AM_EXT_CALL_EXPR_struct {/* layout for AM_EXT_CALL_EXPR */
 OB_HEADER header;
 struct IDENT_struct nm1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_EXT_CALL_EXPR;


typedef struct AM_EXT_CALL_EXPR_eltb_dA_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_EXT_CALL_EXPR L31;
 struct AM_EXT_CALL_EXPR_aeltb_d_frame_struct *nested1; /* nested iter frame */
 } *AM_EXT_CALL_EXPR_eltb_dA_frame;


typedef struct AM_EXT_CALL_EXPR_setb_dA_frame_struct {
 AM_EXT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_EXT_CALL_EXPR L21;
 struct AM_EXT_CALL_EXPR_asetb_d_frame_struct *nested1; /* nested iter frame */
 } *AM_EXT_CALL_EXPR_setb_dA_frame;

typedef struct AM_FAR_EXPR_struct {/* layout for AM_FAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_FAR_EXPR;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_IF_EXPR_struct {/* layout for AM_IF_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *if_false;
 struct dAM_EXPR_struct *if_true;
 struct dAM_EXPR_struct *test11;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IF_EXPR;

typedef struct AM_IF_STMT_struct {/* layout for AM_IF_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *if_false;
 struct dAM_STMT_struct *if_true;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_IF_STMT;

typedef struct AM_INITIAL_STMT_struct {/* layout for AM_INITIAL_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *stmts;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_INITIAL_STMT;

typedef struct AM_INVARIANT_STMT_struct {/* layout for AM_INVARIANT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 } *AM_INVARIANT_STMT;

typedef struct AM_IS_VOID_EXPR_struct {/* layout for AM_IS_VOID_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IS_VOID_EXPR;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;


typedef struct AM_ITER_CALL_EXPR_eltb_d_frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ITER_CALL_EXPR L31;
 struct AM_ITER_CALL_EXPR_aeltb__frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_eltb_d_frame;


typedef struct AM_ITER_CALL_EXPR_setb_d_frame_struct {
 AM_ITER_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ITER_CALL_EXPR L21;
 struct AM_ITER_CALL_EXPR_asetb__frame_struct *nested1; /* nested iter frame */
 } *AM_ITER_CALL_EXPR_setb_d_frame;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_LOOP_STMT_struct {/* layout for AM_LOOP_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct SFILE_ID_struct source11;
 BOOL has_yield;
 } *AM_LOOP_STMT;

typedef struct AM_NEAR_EXPR_struct {/* layout for AM_NEAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_NEAR_EXPR;

typedef struct AM_NEW_EXPR_struct {/* layout for AM_NEW_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *asz1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_NEW_EXPR;

typedef struct AM_OB_DEF_struct {/* layout for AM_OB_DEF */
 OB_HEADER header;
 struct dTP_struct *arr1;
 struct dTP_struct *tp1;
 struct FMAPIDENTdTP_struct *at11;
 INT asize;
 struct SFILE_ID_struct source11;
 } *AM_OB_DEF;

typedef struct AM_POST_STMT_struct {/* layout for AM_POST_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_POST_STMT;

typedef struct AM_PRE_STMT_struct {/* layout for AM_PRE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_PRE_STMT;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;


typedef struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 INT state;
 dAM_EXPR ret_val;
 AM_ROUT_CALL_EXPR L31;
 struct AM_ROUT_CALL_EXPR_aeltb__frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_eltb_d_frame;


typedef struct AM_ROUT_CALL_EXPR_setb_d_frame_struct {
 AM_ROUT_CALL_EXPR self;/* Formal argument: self */
 dAM_EXPR arg1;/* Formal argument: val */
 INT state;
 AM_ROUT_CALL_EXPR L21;
 struct AM_ROUT_CALL_EXPR_asetb__frame_struct *nested1; /* nested iter frame */
 } *AM_ROUT_CALL_EXPR_setb_d_frame;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AM_STMT_EXPR_struct {/* layout for AM_STMT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *stmts;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 struct SFILE_ID_struct source11;
 } *AM_STMT_EXPR;

typedef struct AM_TYPECASE_STMT_struct {/* layout for AM_TYPECASE_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *void_stmts;
 struct AM_LOCAL_EXPR_struct *test11;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL has_void_stmts;
 BOOL no_else;
 } *AM_TYPECASE_STMT;

typedef struct AM_VARR_ASSIGN_EXPR_struct {/* layout for AM_VARR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_VARR_ASSIGN_EXPR;

typedef struct AM_VATTR_ASSIGN_EXPR_struct {/* layout for AM_VATTR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_VATTR_ASSIGN_EXPR;

typedef struct AM_WHERE_EXPR_struct {/* layout for AM_WHERE_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_WHERE_EXPR;

typedef struct AM_YIELD_STMT_struct {/* layout for AM_YIELD_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 INT ret1;
 struct SFILE_ID_struct source11;
 } *AM_YIELD_STMT;

typedef struct ARRAYBOOL_struct {/* layout for ARRAY{BOOL} */
 OB_HEADER header;
 INT asize;
 BOOL arr_part[1];
 } *ARRAYBOOL;

typedef struct ARRAYINT_struct {/* layout for ARRAY{INT} */
 OB_HEADER header;
 INT asize;
 INT arr_part[1];
 } *ARRAYINT;

typedef struct AS_CLASS_DEF_struct {/* layout for AS_CLASS_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *body;
 struct AS_CLASS_DEF_struct *next;
 struct AS_PARAM_DEC_struct *params1;
 struct AS_TYPE_SPEC_struct *over;
 struct AS_TYPE_SPEC_struct *under;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 } *AS_CLASS_DEF;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct CODE_FILE_struct {/* layout for CODE_FILE */
 OB_HEADER header;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTFSTR_struct *text1;
 struct FSETdLAYOUT_struct *layouts;
 struct FSETAM_GLOBAL_EXPR_struct *globals;
 struct FSETSIG_struct *decs;
 struct FSETSIG_struct *iters;
 struct FSETSTR_struct *externs1;
 struct FSETTUPSIGSIG_struct *unboxes;
 struct FSTR_struct *ntext;
 INT length1;
 STR name1;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL do_not_merge;
 BOOL is_c_code;
 } *CODE_FILE;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;

typedef struct FLISTdAM_STMT_struct {/* layout for FLIST{$AM_STMT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_STMT_struct *arr_part[1];
 } *FLISTdAM_STMT;


typedef struct FLISTdAM_STMT_eltb_dAM_S_frame_struct {
 FLISTdAM_STMT self;/* Formal argument: self */
 INT state;
 dAM_STMT ret_val;
 FLISTdAM_STMT L31;
 INT L41;
 INT L51;
 struct FLISTdAM_STMT_aeltb_INT__frame_struct *nested1; /* nested iter frame */
 } *FLISTdAM_STMT_eltb_dAM_S_frame;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTdTP_struct {/* layout for FLIST{$TP} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FLISTdTP;

typedef struct FLISTAM_BND_ITER_CALL_EX_struct {/* layout for FLIST{AM_BND_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_ITER_CALL_EX;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;


typedef struct FLISTAM_LOCAL_EXPR_eltb__frame_struct {
 FLISTAM_LOCAL_EXPR self;/* Formal argument: self */
 INT state;
 AM_LOCAL_EXPR ret_val;
 FLISTAM_LOCAL_EXPR L31;
 INT L41;
 INT L51;
 struct FLISTAM_LOCAL_EXPR_aeltb_frame_struct *nested1; /* nested iter frame */
 } *FLISTAM_LOCAL_EXPR_eltb__frame;

typedef struct FLISTFLISTdAM_CONST_struct {/* layout for FLIST{FLIST{$AM_CONST}} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FLISTdAM_CONST_struct *arr_part[1];
 } *FLISTFLISTdAM_CONST;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;

typedef struct FMAPIDENTdTP_struct {/* layout for FMAP{IDENT,$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *FMAPIDENTdTP;


typedef struct FMAPIDENTdTP_pairsb_TUPI_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP r;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_pairsb_TUPI_frame;


typedef struct FMAPIDENTdTP_targetsb_dT_frame_struct {
 FMAPIDENTdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 FMAPIDENTdTP L31;
 TUPIDENTdTP e;
 struct FMAPIDENTdTP_aeltb_TUPID_frame_struct *nested1; /* nested iter frame */
 } *FMAPIDENTdTP_targetsb_dT_frame;

typedef struct FMAPIDENTAM_GLOBAL_EXPR_struct {/* layout for FMAP{IDENT,AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTAM_GLOBAL_EXPR_struct arr_part[1];
 } *FMAPIDENTAM_GLOBAL_EXPR;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;

typedef struct FSETSTR_struct {/* layout for FSET{STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 STR arr_part[1];
 } *FSETSTR;

typedef struct FSETTP_CLASS_struct {/* layout for FSET{TP_CLASS} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_CLASS_struct *arr_part[1];
 } *FSETTP_CLASS;

typedef struct FSETVALUE_CLASS_LAYOUT_struct {/* layout for FSET{VALUE_CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct VALUE_CLASS_LAYOUT_struct *arr_part[1];
 } *FSETVALUE_CLASS_LAYOUT;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct LAYOUT_ARR_struct {/* layout for LAYOUT_ARR */
 OB_HEADER header;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *LAYOUT_ARR;


typedef struct LAYOUT_ARR_eltb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 INT state;
 TUPIDENTdTP ret_val;
 LAYOUT_ARR L31;
 struct LAYOUT_ARR_aeltb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_eltb_TUPIDENT_frame;


typedef struct LAYOUT_ARR_setb_TUPIDENT_frame_struct {
 LAYOUT_ARR self;/* Formal argument: self */
 TUPIDENTdTP arg1;/* Formal argument: val */
 INT state;
 LAYOUT_ARR L21;
 struct LAYOUT_ARR_asetb_TUPIDEN_frame_struct *nested1; /* nested iter frame */
 } *LAYOUT_ARR_setb_TUPIDENT_frame;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern CGEN LAYOUT_TBL_cgen;
extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSETVALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_layou1;
extern INT WEIGH_CODE_assign_weight;
extern INT WEIGH_CODE_if_weight;
extern INT WEIGH_CODE_iter_call_wei;
extern INT WEIGH_CODE_rout_call_wei;

/* Function declarations */

AM_ARRAY_EXPR AM_ARRAY_EXPR_create_INT(AM_ARRAY_EXPR, INT, SFILE_ID);
AM_ARR_EXPR AM_ARR_EXPR_create_SFILE(AM_ARR_EXPR, SFILE_ID);
AM_ASSERT_STMT AM_ASSERT_STMT_create_SF(AM_ASSERT_STMT, SFILE_ID);
AM_ASSIGN_STMT AM_ASSIGN_STMT_create_SF(AM_ASSIGN_STMT, SFILE_ID);
AM_ATTR_EXPR AM_ATTR_EXPR_create_SFIL(AM_ATTR_EXPR, SFILE_ID);
AM_AT_EXPR AM_AT_EXPR_create_SFILE_(AM_AT_EXPR, SFILE_ID);
AM_BND_CREATE_EXPR AM_BND_CREATE_EXPR_creat(AM_BND_CREATE_EXPR, INT, SFILE_ID);
AM_BND_ITER_CALL_EXPR AM_BND_ITER_CALL_EXPR_cr(AM_BND_ITER_CALL_EXPR, INT, SFILE_ID);
AM_BND_ROUT_CALL_EXPR AM_BND_ROUT_CALL_EXPR_cr(AM_BND_ROUT_CALL_EXPR, INT, SFILE_ID);
AM_BREAK_STMT AM_BREAK_STMT_create_SFI(AM_BREAK_STMT, SFILE_ID);
AM_CASE_STMT AM_CASE_STMT_create_SFIL(AM_CASE_STMT, SFILE_ID);
AM_EXPR_STMT AM_EXPR_STMT_create_SFIL(AM_EXPR_STMT, SFILE_ID);
AM_EXT_CALL_EXPR AM_EXT_CALL_EXPR_create_1(AM_EXT_CALL_EXPR, INT, SFILE_ID, IDENT);
AM_FAR_EXPR AM_FAR_EXPR_create_SFILE(AM_FAR_EXPR, SFILE_ID);
AM_IF_EXPR AM_IF_EXPR_create_SFILE_(AM_IF_EXPR, SFILE_ID);
AM_IF_STMT AM_IF_STMT_create_SFILE_(AM_IF_STMT, SFILE_ID);
AM_INITIAL_STMT AM_INITIAL_STMT_create_S(AM_INITIAL_STMT, SFILE_ID);
AM_INVARIANT_STMT AM_INVARIANT_STMT_create(AM_INVARIANT_STMT, SFILE_ID);
AM_IS_VOID_EXPR AM_IS_VOID_EXPR_create_S(AM_IS_VOID_EXPR, SFILE_ID);
AM_ITER_CALL_EXPR AM_ITER_CALL_EXPR_create(AM_ITER_CALL_EXPR, INT, SFILE_ID);
AM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_eltb_(FLISTAM_LOCAL_EXPR_eltb__frame);
AM_LOCAL_EXPR FMAPAM_LOCAL_EXPRAM_LOCA19(FMAPAM_LOCAL_EXPRAM_LOCA, AM_LOCAL_EXPR);
AM_NEAR_EXPR AM_NEAR_EXPR_create_SFIL(AM_NEAR_EXPR, SFILE_ID);
AM_NEW_EXPR AM_NEW_EXPR_create_SFILE(AM_NEW_EXPR, SFILE_ID);
AM_OB_DEF CGEN_am_ob_def_for_tp_dT(CGEN, dTP);
AM_POST_STMT AM_POST_STMT_create_SFIL(AM_POST_STMT, SFILE_ID);
AM_PRE_STMT AM_PRE_STMT_create_SFILE(AM_PRE_STMT, SFILE_ID);
AM_ROUT_CALL_EXPR AM_ROUT_CALL_EXPR_create(AM_ROUT_CALL_EXPR, INT, SFILE_ID);
AM_STMT_EXPR AM_STMT_EXPR_create_SFIL(AM_STMT_EXPR, SFILE_ID);
AM_TYPECASE_STMT AM_TYPECASE_STMT_create_(AM_TYPECASE_STMT, SFILE_ID);
AM_VARR_ASSIGN_EXPR AM_VARR_ASSIGN_EXPR_crea(AM_VARR_ASSIGN_EXPR, SFILE_ID);
AM_VATTR_ASSIGN_EXPR AM_VATTR_ASSIGN_EXPR_cre(AM_VATTR_ASSIGN_EXPR, SFILE_ID);
AM_WHERE_EXPR AM_WHERE_EXPR_create_SFI(AM_WHERE_EXPR, SFILE_ID);
BOOL CGEN_is_built_in_type_dT(CGEN, dTP);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL SIG_is_eq_SIG_BOOL(SIG, SIG);
BOOL TUPIDENTIDENT_is_eq_TUPI(TUPIDENTIDENT, TUPIDENTIDENT);
BOOL TUPIDENTINT_is_eq_TUPIDE(TUPIDENTINT, TUPIDENTINT);
BOOL TUPSIGSIG_is_eq_TUPSIGSI(TUPSIGSIG, TUPSIGSIG);
FLISTAM_BND_ITER_CALL_EX FLISTAM_BND_ITER_CALL_EX10(FLISTAM_BND_ITER_CALL_EX, AM_BND_ITER_CALL_EXPR);
FLISTAM_ITER_CALL_EXPR FLISTAM_ITER_CALL_EXPR_p(FLISTAM_ITER_CALL_EXPR, AM_ITER_CALL_EXPR);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_creat(FLISTAM_LOCAL_EXPR, INT);
FLISTAM_LOCAL_EXPR FLISTAM_LOCAL_EXPR_push_(FLISTAM_LOCAL_EXPR, AM_LOCAL_EXPR);
FLISTdAM_EXPR FLISTdAM_EXPR_concat_FLI(FLISTdAM_EXPR, FLISTdAM_EXPR);
FLISTdAM_EXPR FLISTdAM_EXPR_push_dAM_E(FLISTdAM_EXPR, dAM_EXPR);
FLISTdAM_STMT FLISTdAM_STMT_create_INT(FLISTdAM_STMT, INT);
FLISTdAM_STMT FLISTdAM_STMT_push_dAM_S(FLISTdAM_STMT, dAM_STMT);
FLISTdLAYOUT FLISTdLAYOUT_create_FLIS(FLISTdLAYOUT);
FLISTdLAYOUT FLISTdLAYOUT_push_dLAYOU(FLISTdLAYOUT, dLAYOUT);
FLISTdLAYOUT VALUE_CLASS_LAYOUT_depen(VALUE_CLASS_LAYOUT);
FMAPdTPdLAYOUT FMAPdTPdLAYOUT_insert_dT(FMAPdTPdLAYOUT, dTP, dLAYOUT);
FSETVALUE_CLASS_LAYOUT FSETVALUE_CLASS_LAYOUT_i1(FSETVALUE_CLASS_LAYOUT, VALUE_CLASS_LAYOUT);
INT CHAR_hash_INT(CHAR);
INT FLISTAM_LOCAL_EXPR_size_(FLISTAM_LOCAL_EXPR);
INT FLISTdAM_STMT_size_INT(FLISTdAM_STMT);
INT FLTD_hash_INT(FLTD);
INT FLT_hash_INT(FLT);
INT FMAPIDENTdTP_size_INT(FMAPIDENTdTP);
INT FSTR_hash_INT(FSTR);
INT IDENT_hash_INT(IDENT);
INT INT_hash_INT(INT);
INT STR_hash_INT(STR);
INT TUPAM_LOCAL_EXPRAM_LOCAL1(TUPAM_LOCAL_EXPRAM_LOCAL);
INT TUPAM_ROUT_DEFAM_ROUT_DE1(TUPAM_ROUT_DEFAM_ROUT_DE);
INT TUPAM_ROUT_DEFFLISTAM_IT1(TUPAM_ROUT_DEFFLISTAM_IT);
INT TUPAM_ROUT_DEFFRAME_LAYO1(TUPAM_ROUT_DEFFRAME_LAYO);
INT TUPARRAYdTPARRAYBOOLdTP_(TUPARRAYdTPARRAYBOOLdTP);
INT TUPARRAYdTPdTP_hash_INT(TUPARRAYdTPdTP);
INT TUPAS_CLASS_DEFAS_CLASS_1(TUPAS_CLASS_DEFAS_CLASS_);
INT TUPBOOLINTIINTBOOL_hash_(TUPBOOLINTIINTBOOL);
INT TUPCHARCHAR_hash_INT(TUPCHARCHAR);
INT TUPCODE_FILECODE_FILE_ha(TUPCODE_FILECODE_FILE);
INT TUPFLISTdAM_CONSTFLISTdA1(TUPFLISTdAM_CONSTFLISTdA);
INT TUPFLTDFLTD_hash_INT(TUPFLTDFLTD);
INT TUPFLTFLT_hash_INT(TUPFLTFLT);
INT TUPFSTRFSTR_hash_INT(TUPFSTRFSTR);
INT TUPIDENTAM_GLOBAL_EXPR_h(TUPIDENTAM_GLOBAL_EXPR);
INT TUPIDENTARRAYdTP_hash_IN(TUPIDENTARRAYdTP);
INT TUPIDENTIDENT_hash_INT(TUPIDENTIDENT);
INT TUPIDENTINT_hash_INT(TUPIDENTINT);
INT TUPIDENTdTP_hash_INT(TUPIDENTdTP);
INT TUPIFCIFC_hash_INT(TUPIFCIFC);
INT TUPIMPL_INCLUDEIMPL_INCL1(TUPIMPL_INCLUDEIMPL_INCL);
INT TUPINTIINTIINTI_hash_INT(TUPINTIINTIINTI);
INT TUPINTINTINT_hash_INT(TUPINTINTINT);
INT TUPINTINT_hash_INT(TUPINTINT);
INT TUPSFILE_IDSFILE_ID_hash(TUPSFILE_IDSFILE_ID);
INT TUPSIGABSTRACT_FRAME_LAY1(TUPSIGABSTRACT_FRAME_LAY);
INT TUPSIGAM_ROUT_DEF_hash_I(TUPSIGAM_ROUT_DEF);
INT TUPSIGARG_LAYOUT_hash_IN(TUPSIGARG_LAYOUT);
INT TUPSIGSIG_hash_INT(TUPSIGSIG);
INT TUPSIGSTR_hash_INT(TUPSIGSTR);
INT TUPSTRFSETSTR_hash_INT(TUPSTRFSETSTR);
INT TUPSTRINT_hash_INT(TUPSTRINT);
INT TUPSTRITER_INLINE_hash_I(TUPSTRITER_INLINE);
INT TUPSTRSIG_hash_INT(TUPSTRSIG);
INT TUPSTRSTR_hash_INT(TUPSTRSTR);
INT TUPTP_CLASSFSETTP_CLASS_(TUPTP_CLASSFSETTP_CLASS);
INT TUPTP_CLASSFSETdTP_hash_(TUPTP_CLASSFSETdTP);
INT TUPdAM_CONSTdAM_CONST_ha(TUPdAM_CONSTdAM_CONST);
INT TUPdAM_EXPRdAM_EXPR_hash(TUPdAM_EXPRdAM_EXPR);
INT TUPdAM_EXPRdTP_hash_INT(TUPdAM_EXPRdTP);
INT TUPdAM_STMTdAM_STMT_hash(TUPdAM_STMTdAM_STMT);
INT TUPdLAYOUTdLAYOUT_hash_I(TUPdLAYOUTdLAYOUT);
INT TUPdOBNAMESPACE_hash_INT(TUPdOBNAMESPACE);
INT TUPdOBSTR_hash_INT(TUPdOBSTR);
INT TUPdTPCODE_FILE_hash_INT(TUPdTPCODE_FILE);
INT TUPdTPFMAPIDENTAM_GLOBAL1(TUPdTPFMAPIDENTAM_GLOBAL);
INT TUPdTPIFC_hash_INT(TUPdTPIFC);
INT TUPdTPIMPL_hash_INT(TUPdTPIMPL);
INT TUPdTPINT_hash_INT(TUPdTPINT);
INT TUPdTPdLAYOUT_hash_INT(TUPdTPdLAYOUT);
INT TUPdTPdTP_hash_INT(TUPdTPdTP);
INT UNIX_system_STR_INT(UNIX, STR);
LAYOUT_ARR LAYOUT_ARR_create_INT_LA(LAYOUT_ARR, INT);
LAYOUT_ARR VALUE_CLASS_LAYOUT_sorte(VALUE_CLASS_LAYOUT, FMAPIDENTdTP);
STR MANGLE_mangle_dOB_dOB_ST(MANGLE, OB, OB);
STR STR_create_from_c_string(STR, EXT_OB);
STR STR_plus_dSTR_STR(STR, dSTR);
STR UNIX_get_env_STR_STR(UNIX, STR);
STR VALUE_CLASS_LAYOUT_str_S(VALUE_CLASS_LAYOUT);
STR VALUE_CLASS_LAYOUT_typed(VALUE_CLASS_LAYOUT, CGEN);
TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL, AM_LOCAL_EXPR, AM_LOCAL_EXPR);
TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT, AM_ROUT_DEF, FLISTAM_ITER_CALL_EXPR);
TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO, AM_ROUT_DEF, FRAME_LAYOUT);
TUPARRAYdTPARRAYBOOLdTP TUPARRAYdTPARRAYBOOLdTP_1(TUPARRAYdTPARRAYBOOLdTP, ARRAYdTP, ARRAYBOOL, dTP);
TUPARRAYdTPdTP TUPARRAYdTPdTP_create_AR(TUPARRAYdTPdTP, ARRAYdTP, dTP);
TUPBOOLINTIINTBOOL TUPBOOLINTIINTBOOL_creat(TUPBOOLINTIINTBOOL, BOOL, INTI, INT, BOOL);
TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR, IDENT, AM_GLOBAL_EXPR);
TUPIDENTARRAYdTP TUPIDENTARRAYdTP_create_(TUPIDENTARRAYdTP, IDENT, ARRAYdTP);
TUPIDENTIDENT TUPIDENTIDENT_create_IDE(TUPIDENTIDENT, IDENT, IDENT);
TUPIDENTINT TUPIDENTINT_create_IDENT(TUPIDENTINT, IDENT, INT);
TUPIDENTdTP FMAPIDENTdTP_pairsb_TUPI(FMAPIDENTdTP_pairsb_TUPI_frame);
TUPIDENTdTP LAYOUT_ARR_eltb_TUPIDENT(LAYOUT_ARR_eltb_TUPIDENT_frame);
TUPIDENTdTP TUPIDENTdTP_create_IDENT(TUPIDENTdTP, IDENT, dTP);
TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY, SIG, ABSTRACT_FRAME_LAYOUT);
TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF, SIG, AM_ROUT_DEF);
TUPSIGSIG TUPSIGSIG_create_SIG_SIG(TUPSIGSIG, SIG, SIG);
TUPSIGSTR TUPSIGSTR_create_SIG_STR(TUPSIGSTR, SIG, STR);
TUPSTRFSETSTR TUPSTRFSETSTR_create_STR(TUPSTRFSETSTR, STR, FSETSTR);
TUPSTRINT TUPSTRINT_create_STR_INT(TUPSTRINT, STR, INT);
TUPSTRITER_INLINE TUPSTRITER_INLINE_create(TUPSTRITER_INLINE, STR, ITER_INLINE);
TUPSTRSIG TUPSTRSIG_create_STR_SIG(TUPSTRSIG, STR, SIG);
TUPSTRSTR TUPSTRSTR_create_STR_STR(TUPSTRSTR, STR, STR);
TUPTP_CLASSFSETTP_CLASS TUPTP_CLASSFSETTP_CLASS_1(TUPTP_CLASSFSETTP_CLASS, TP_CLASS, FSETTP_CLASS);
TUPTP_CLASSFSETdTP TUPTP_CLASSFSETdTP_creat(TUPTP_CLASSFSETdTP, TP_CLASS, FSETdTP);
TUPdAM_EXPRdTP TUPdAM_EXPRdTP_create_dA(TUPdAM_EXPRdTP, dAM_EXPR, dTP);
TUPdOBNAMESPACE TUPdOBNAMESPACE_create_d(TUPdOBNAMESPACE, OB, NAMESPACE);
TUPdOBSTR TUPdOBSTR_create_dOB_STR(TUPdOBSTR, OB, STR);
TUPdTPCODE_FILE TUPdTPCODE_FILE_create_d(TUPdTPCODE_FILE, dTP, CODE_FILE);
TUPdTPFMAPIDENTAM_GLOBAL TUPdTPFMAPIDENTAM_GLOBAL2(TUPdTPFMAPIDENTAM_GLOBAL, dTP, FMAPIDENTAM_GLOBAL_EXPR);
TUPdTPIFC TUPdTPIFC_create_dTP_IFC(TUPdTPIFC, dTP, IFC);
TUPdTPIMPL TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL, dTP, IMPL);
TUPdTPINT TUPdTPINT_create_dTP_INT(TUPdTPINT, dTP, INT);
TUPdTPdLAYOUT TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT, dTP, dLAYOUT);
VALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_creat(VALUE_CLASS_LAYOUT, dTP, PROG);
WEIGH_CODE WEIGH_CODE_create_INT_WE(WEIGH_CODE, INT);
XFORM_CODE XFORM_CODE_create_FMAPAM(XFORM_CODE, FMAPAM_LOCAL_EXPRAM_LOCA);
dAM_EXPR AM_ARRAY_EXPR_eltb_dAM_E(AM_ARRAY_EXPR_eltb_dAM_E_frame);
dAM_EXPR AM_BND_CREATE_EXPR_eltb_(AM_BND_CREATE_EXPR_eltb__frame);
dAM_EXPR AM_BND_ITER_CALL_EXPR_el(AM_BND_ITER_CALL_EXPR_el_frame);
dAM_EXPR AM_BND_ROUT_CALL_EXPR_el(AM_BND_ROUT_CALL_EXPR_el_frame);
dAM_EXPR AM_EXT_CALL_EXPR_eltb_dA(AM_EXT_CALL_EXPR_eltb_dA_frame);
dAM_EXPR AM_ITER_CALL_EXPR_eltb_d(AM_ITER_CALL_EXPR_eltb_d_frame);
dAM_EXPR AM_ROUT_CALL_EXPR_eltb_d(AM_ROUT_CALL_EXPR_eltb_d_frame);
dAM_EXPR XFORM_CODE_xform_expr_dA(XFORM_CODE, dAM_EXPR);
dAM_STMT FLISTdAM_STMT_eltb_dAM_S(FLISTdAM_STMT_eltb_dAM_S_frame);
dAM_STMT XFORM_CODE_xform_stmt_dA(XFORM_CODE, dAM_STMT);
dAM_STMT XFORM_CODE_xform_stmt_li(XFORM_CODE, dAM_STMT);
dLAYOUT FMAPdTPdLAYOUT_get_dTP_d(FMAPdTPdLAYOUT, dTP);
dLAYOUT LAYOUT_TBL_layout_dTP_dL(LAYOUT_TBL, dTP);
dTP FMAPIDENTdTP_targetsb_dT(FMAPIDENTdTP_targetsb_dT_frame);
extern const int dAM_STMT_next_dAM_STMT1_offset;

extern const  (*dAM_STMT_next_dAM_STMT1[])(dAM_STMT, dAM_STMT);
extern const int dAM_STMT_next_dAM_STMT_offset;

extern const dAM_STMT (*dAM_STMT_next_dAM_STMT[])(dAM_STMT);
extern const int dHASH_hash_INT_offset;

extern const INT (*dHASH_hash_INT[])(dHASH);
extern const int dTP_is_value_BOOL_offset;

extern const BOOL (*dTP_is_value_BOOL[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void AM_ARRAY_EXPR_setb_dAM_E(AM_ARRAY_EXPR_setb_dAM_E_frame);
void AM_BND_CREATE_EXPR_setb_(AM_BND_CREATE_EXPR_setb__frame);
void AM_BND_ITER_CALL_EXPR_se(AM_BND_ITER_CALL_EXPR_se_frame);
void AM_BND_ROUT_CALL_EXPR_se(AM_BND_ROUT_CALL_EXPR_se_frame);
void AM_EXT_CALL_EXPR_setb_dA(AM_EXT_CALL_EXPR_setb_dA_frame);
void AM_ITER_CALL_EXPR_setb_d(AM_ITER_CALL_EXPR_setb_d_frame);
void AM_ROUT_CALL_EXPR_setb_d(AM_ROUT_CALL_EXPR_setb_d_frame);
void LAYOUT_ARR_setb_TUPIDENT(LAYOUT_ARR_setb_TUPIDENT_frame);
void LAYOUT_ARR_sort(LAYOUT_ARR);
void LAYOUT_TBL_layout_tbl_FM(LAYOUT_TBL, FMAPdTPdLAYOUT);
void MANGLE_forbid_STR(MANGLE, STR);
void UNIX_exit_INT(UNIX, INT);
void VALUE_CLASS_LAYOUT_layou(VALUE_CLASS_LAYOUT, FSETVALUE_CLASS_LAYOUT);
void VALUE_CLASS_LAYOUT_make_(VALUE_CLASS_LAYOUT);
void WEIGH_CODE_calc_expr_wei(WEIGH_CODE, dAM_EXPR);
void WEIGH_CODE_calc_stmt_lis(WEIGH_CODE, dAM_STMT);
void WEIGH_CODE_calc_stmt_wei(WEIGH_CODE, dAM_STMT);
void WEIGH_CODE_clear_badstmt(WEIGH_CODE);
void WEIGH_CODE_uplevel(WEIGH_CODE);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


#if defined(__osf__) || defined(sun) || defined(__hpux) || defined(__sgi) || defined(WIN32) || defined(__NeXT__) || defined(__ultrix) || defined(__NetBSD__) || defined(__FreeBSD__)
    extern char *getenv(const char *);
#else
# ifndef _AIX
#   ifndef _STDLIB_H
      extern char *getenv(char *);
#   endif
# endif
#endif

/* Code */




BOOL TUPIDENTIDENT_is_eq_TUPI(TUPIDENTIDENT self, TUPIDENTIDENT e) {
 BOOL ret_val = ((BOOL) 0);
 IDENT lt1 = IDENT_zero;
 IDENT lt2 = IDENT_zero;
 BOOL L1;
 BOOL L2;
 lt1 = self.t1;
 L1 = IDENT_is_eq_IDENT_BOOL(lt1, e.t1);
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 lt2 = self.t2;
 L2 = IDENT_is_eq_IDENT_BOOL(lt2, e.t2);
 if ((!(L2))) {
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL TUPIDENTINT_is_eq_TUPIDE(TUPIDENTINT self, TUPIDENTINT e) {
 BOOL ret_val = ((BOOL) 0);
 IDENT lt1 = IDENT_zero;
 INT lt2 = ((INT) 0);
 BOOL L1;
 INT L2;
 BOOL L3;
 lt1 = self.t1;
 L1 = IDENT_is_eq_IDENT_BOOL(lt1, e.t1);
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 lt2 = self.t2;
 L2 = e.t2;
 L3 = (lt2==L2);
 if ((!(L3))) {
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


BOOL TUPSIGSIG_is_eq_TUPSIGSI(TUPSIGSIG self, TUPSIGSIG e) {
 BOOL ret_val = ((BOOL) 0);
 SIG lt1;
 SIG lt2;
 BOOL L1;
 BOOL L2;
 lt1 = self.t1;
 L1 = SIG_is_eq_SIG_BOOL(lt1, e.t1);
 if ((!(L1))) {
  ret_val = FALSE;
  return ret_val;
 }
 lt2 = self.t2;
 L2 = SIG_is_eq_SIG_BOOL(lt2, e.t2);
 if ((!(L2))) {
  ret_val = FALSE;
  return ret_val;
 }
 ret_val = TRUE;
 return ret_val;
}


FLISTdLAYOUT VALUE_CLASS_LAYOUT_depen(VALUE_CLASS_LAYOUT self) {
 return ATTR(self,dependencies);
}


INT TUPARRAYdTPdTP_hash_INT(TUPARRAYdTPdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 ARRAYdTP lt1;
 dTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPIDENTARRAYdTP_hash_IN(TUPIDENTARRAYdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IDENT lt1 = IDENT_zero;
 ARRAYdTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = IDENT_hash_INT(lt1);
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPIDENTIDENT_hash_INT(TUPIDENTIDENT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IDENT lt1 = IDENT_zero;
 IDENT lt2 = IDENT_zero;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = IDENT_hash_INT(lt1);
 h2 = IDENT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPIDENTINT_hash_INT(TUPIDENTINT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IDENT lt1 = IDENT_zero;
 INT lt2 = ((INT) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = IDENT_hash_INT(lt1);
 h2 = INT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPSTRFSETSTR_hash_INT(TUPSTRFSETSTR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 STR lt1;
 FSETSTR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = STR_hash_INT(lt1);
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPSTRSIG_hash_INT(TUPSTRSIG self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 STR lt1;
 SIG lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = STR_hash_INT(lt1);
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT TUPSTRSTR_hash_INT(TUPSTRSTR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 STR lt1;
 STR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = STR_hash_INT(lt1);
 h2 = STR_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}


INT UNIX_system_STR_INT(UNIX self, STR s) {
 INT ret_val = ((INT) 0);
 STR L1;
 L1 = s;
 ret_val = system(((L1==NULL)?NULL:L1->arr_part));
 return ret_val;
}


LAYOUT_ARR VALUE_CLASS_LAYOUT_sorte(VALUE_CLASS_LAYOUT self, FMAPIDENTdTP map) {
 LAYOUT_ARR ret_val;
 LAYOUT_ARR res;
 FMAPIDENTdTP L11;
 LAYOUT_ARR L21;
 TUPIDENTdTP L3;
 res = LAYOUT_ARR_create_INT_LA(((LAYOUT_ARR) NULL), FMAPIDENTdTP_size_INT(map));
 {
  struct FMAPIDENTdTP_pairsb_TUPI_frame_struct other1_0;
  FMAPIDENTdTP_pairsb_TUPI_frame 
  noname1 = &other1_0;
  struct LAYOUT_ARR_setb_TUPIDENT_frame_struct other1_1;
  LAYOUT_ARR_setb_TUPIDENT_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname2->state == 0) {
    L21 = res;
    noname2->self = L21;
   }
   if (noname1->state == 0) {
    L11 = map;
    noname1->self = L11;
   }
   L3 = FMAPIDENTdTP_pairsb_TUPI(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   noname2->arg1 = L3;
   LAYOUT_ARR_setb_TUPIDENT(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   /* No return value from iter call */;
  }
 }
 after_loop: ;
 LAYOUT_ARR_sort(res);
 ret_val = res;
 return ret_val;
}


STR UNIX_get_env_STR_STR(UNIX self, STR var) {
 STR ret_val;
 EXT_OB r;
 STR L1;
 L1 = var;
 r = getenv(((L1==NULL)?NULL:L1->arr_part));
 if ((r==((EXT_OB) NULL))) {
  ret_val = ((STR) NULL);
  return ret_val;
 }
 else {
  ret_val = STR_create_from_c_string(((STR) NULL), r);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


STR VALUE_CLASS_LAYOUT_str_S(VALUE_CLASS_LAYOUT self) {
 return ATTR(self,str1);
}


STR VALUE_CLASS_LAYOUT_typed(VALUE_CLASS_LAYOUT self, CGEN c) {
 STR ret_val;
 MANGLE m;
 STR cname;
 STR res;
 LAYOUT_ARR L11;
 TUPIDENTdTP p = TUPIDENTdTP_zero;
 extern STR typedefstruct1;
 STR L2;
 extern STR S_struct3;
 extern STR layoutfor;
 STR L3;
 dTP L4;
 STR L5;
 extern STR name112;
 STR L6;
 extern STR S_struct1;
 BOOL L7;
 TUPIDENTdTP L8;
 dSTR L9;
 STR L10;
 STR L12;
 dSTR L13;
 STR L14;
 OB L15;
 STR L16;
 extern STR name85;
 dTP L17;
 BOOL L18;
 extern STR struct3;
 STR L19;
 STR L20;
 extern STR S_struct4;
 STR L21;
 OB L22;
 STR L23;
 extern STR name85;
 extern STR struct3;
 STR L24;
 STR L25;
 extern STR S_struct5;
 STR L26;
 OB L27;
 STR L28;
 extern STR name85;
 BOOL L29;
 dSTR L30;
 STR L31;
 STR L32;
 extern STR arr_part4;
 dTP L33;
 BOOL L34;
 extern STR struct3;
 STR L35;
 STR L36;
 extern STR S_structarr_part;
 extern STR struct3;
 STR L37;
 STR L38;
 extern STR S_structarr_part1;
 INT L39;
 dSTR L40;
 STR L41;
 extern STR name118;
 BOOL L42;
 extern STR CHARfield_so_not_empty;
 extern STR name119;
 STR L43;
 STR L44;
 extern STR name85;
 STR L45;
 extern STR static1;
 STR L46;
 STR L47;
 extern STR name25;
 STR L48;
 STR L49;
 extern STR S_zero2;
 extern STR S_zero;
 extern STR typedefstruct1;
 STR L50;
 STR L51;
 extern STR S_boxed_struct1;
 STR L52;
 extern STR OB_HEADERheader;
 STR L53;
 dSTR L54;
 STR L55;
 STR L56;
 extern STR value_part2;
 STR L57;
 extern STR name113;
 STR L58;
 STR L59;
 extern STR S_boxed1;
 extern STR S_boxed2;
 extern STR S_boxed_struct2;
 m = ATTR(c,mangler);
 cname = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),tp1)), ((OB) c));
 L2 = STR_plus_dSTR_STR(((STR) &typedefstruct1), ((dSTR) cname));
 res = STR_plus_dSTR_STR(L2, ((dSTR) ((STR) &S_struct3)));
 L3 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &layoutfor)));
 L4 = ATTR(ATTR(self,l1),tp1);
 if (L4==NULL) {
  FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::typedef(CGEN):STR");
 }
 L5 = STR_plus_dSTR_STR(L3, ((dSTR) (*dTP_str_STR[TAG(L4)+dTP_str_STR_offset])(L4)));
 res = STR_plus_dSTR_STR(L5, ((dSTR) ((STR) &name112)));
 L6 = MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(self,tp1)), ((OB) c));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(L6, ((dSTR) ((STR) &S_struct1))));
 L7 = (ATTR(ATTR(self,l1),at11)==((FMAPIDENTdTP) NULL));
 if ((!(L7))) {
  {
   struct LAYOUT_ARR_eltb_TUPIDENT_frame_struct other1_0;
   LAYOUT_ARR_eltb_TUPIDENT_frame 
   noname1 = &other1_0;
   noname1->state = 0;
   while (1) {
    if (noname1->state == 0) {
     L11 = VALUE_CLASS_LAYOUT_sorte(self, ATTR(ATTR(self,l1),at11));
     noname1->self = L11;
    }
    L8 = LAYOUT_ARR_eltb_TUPIDENT(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    p = L8;
    if (CGEN_is_built_in_type_dT(LAYOUT_TBL_cgen, p.t2)) {
     L9 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
     ((CHAR_boxed) L9)->value_part = ' ';
     L10 = STR_plus_dSTR_STR(res, L9);
     L12 = STR_plus_dSTR_STR(L10, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
     L13 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
     ((CHAR_boxed) L13)->value_part = ' ';
     L14 = STR_plus_dSTR_STR(L12, L13);
     L15 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
     ((IDENT_boxed) L15)->value_part = p.t1;
     L16 = STR_plus_dSTR_STR(L14, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L15, ((OB) ATTR(ATTR(self,l1),tp1)))));
     res = STR_plus_dSTR_STR(L16, ((dSTR) ((STR) &name85)));
    }
    else {
     L17 = p.t2;
     if (L17==NULL) {
      FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::typedef(CGEN):STR");
     }
     L18 = (*dTP_is_value_BOOL[TAG(L17)+dTP_is_value_BOOL_offset])(L17);
     if ((!(L18))) {
      L19 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
      L20 = STR_plus_dSTR_STR(L19, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
      L21 = STR_plus_dSTR_STR(L20, ((dSTR) ((STR) &S_struct4)));
      L22 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
      ((IDENT_boxed) L22)->value_part = p.t1;
      L23 = STR_plus_dSTR_STR(L21, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L22, ((OB) ATTR(ATTR(self,l1),tp1)))));
      res = STR_plus_dSTR_STR(L23, ((dSTR) ((STR) &name85)));
     }
     else {
      L24 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
      L25 = STR_plus_dSTR_STR(L24, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) p.t2), ((OB) c))));
      L26 = STR_plus_dSTR_STR(L25, ((dSTR) ((STR) &S_struct5)));
      L27 = (OB)((IDENT_boxed) rt_alloc(sizeof(struct IDENT_boxed_struct), IDENT_tag));
      ((IDENT_boxed) L27)->value_part = p.t1;
      L28 = STR_plus_dSTR_STR(L26, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, L27, ((OB) ATTR(ATTR(self,l1),tp1)))));
      res = STR_plus_dSTR_STR(L28, ((dSTR) ((STR) &name85)));
     }
    }
   }
  }
  after_loop: ;
 }
 L29 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 if ((!(L29))) {
  if (CGEN_is_built_in_type_dT(LAYOUT_TBL_cgen, ATTR(ATTR(self,l1),arr1))) {
   L30 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
   ((CHAR_boxed) L30)->value_part = ' ';
   L31 = STR_plus_dSTR_STR(res, L30);
   L32 = STR_plus_dSTR_STR(L31, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
   res = STR_plus_dSTR_STR(L32, ((dSTR) ((STR) &arr_part4)));
  }
  else {
   L33 = ATTR(ATTR(self,l1),arr1);
   if (L33==NULL) {
    FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::typedef(CGEN):STR");
   }
   L34 = (*dTP_is_value_BOOL[TAG(L33)+dTP_is_value_BOOL_offset])(L33);
   if ((!(L34))) {
    L35 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
    L36 = STR_plus_dSTR_STR(L35, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
    res = STR_plus_dSTR_STR(L36, ((dSTR) ((STR) &S_structarr_part)));
   }
   else {
    L37 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &struct3)));
    L38 = STR_plus_dSTR_STR(L37, ((dSTR) MANGLE_mangle_dOB_dOB_ST(m, ((OB) ATTR(ATTR(self,l1),arr1)), ((OB) c))));
    res = STR_plus_dSTR_STR(L38, ((dSTR) ((STR) &S_structarr_part1)));
   }
  }
  L39 = ATTR(ATTR(self,l1),asize);
  L40 = (dSTR)((INT_boxed) rt_alloc_atomic(sizeof(struct INT_boxed_struct), INT_tag));
  ((INT_boxed) L40)->value_part = ((1>L39)?1:L39);
  L41 = STR_plus_dSTR_STR(res, L40);
  res = STR_plus_dSTR_STR(L41, ((dSTR) ((STR) &name118)));
 }
 if ((ATTR(ATTR(self,l1),at11)==((FMAPIDENTdTP) NULL))) {
  L42 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 } else {
  L42 = FALSE;
 }
 if (L42) {
  res = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &CHARfield_so_not_empty)));
 }
 L43 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &name119)));
 L44 = STR_plus_dSTR_STR(L43, ((dSTR) cname));
 L45 = STR_plus_dSTR_STR(L44, ((dSTR) ((STR) &name85)));
 L46 = STR_plus_dSTR_STR(L45, ((dSTR) ((STR) &static1)));
 L47 = STR_plus_dSTR_STR(L46, ((dSTR) cname));
 L48 = STR_plus_dSTR_STR(L47, ((dSTR) ((STR) &name25)));
 L49 = STR_plus_dSTR_STR(L48, ((dSTR) cname));
 res = STR_plus_dSTR_STR(L49, ((dSTR) ((STR) &S_zero2)));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(cname, ((dSTR) ((STR) &S_zero))));
 L50 = STR_plus_dSTR_STR(res, ((dSTR) ((STR) &typedefstruct1)));
 L51 = STR_plus_dSTR_STR(L50, ((dSTR) cname));
 L52 = STR_plus_dSTR_STR(L51, ((dSTR) ((STR) &S_boxed_struct1)));
 L53 = STR_plus_dSTR_STR(L52, ((dSTR) ((STR) &OB_HEADERheader)));
 L54 = (dSTR)((CHAR_boxed) rt_alloc_atomic(sizeof(struct CHAR_boxed_struct), CHAR_tag));
 ((CHAR_boxed) L54)->value_part = ' ';
 L55 = STR_plus_dSTR_STR(L53, L54);
 L56 = STR_plus_dSTR_STR(L55, ((dSTR) cname));
 L57 = STR_plus_dSTR_STR(L56, ((dSTR) ((STR) &value_part2)));
 L58 = STR_plus_dSTR_STR(L57, ((dSTR) ((STR) &name113)));
 L59 = STR_plus_dSTR_STR(L58, ((dSTR) cname));
 res = STR_plus_dSTR_STR(L59, ((dSTR) ((STR) &S_boxed1)));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(cname, ((dSTR) ((STR) &S_boxed2))));
 MANGLE_forbid_STR(m, STR_plus_dSTR_STR(cname, ((dSTR) ((STR) &S_boxed_struct2))));
 ret_val = res;
 return ret_val;
}


TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL2(TUPAM_LOCAL_EXPRAM_LOCAL self, AM_LOCAL_EXPR at1, AM_LOCAL_EXPR at2) {
 TUPAM_LOCAL_EXPRAM_LOCAL ret_val = TUPAM_LOCAL_EXPRAM_LOCAL_zero;
 TUPAM_LOCAL_EXPRAM_LOCAL L1;
 TUPAM_LOCAL_EXPRAM_LOCAL L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT2(TUPAM_ROUT_DEFFLISTAM_IT self, AM_ROUT_DEF at1, FLISTAM_ITER_CALL_EXPR at2) {
 TUPAM_ROUT_DEFFLISTAM_IT ret_val = TUPAM_ROUT_DEFFLISTAM_IT_zero;
 TUPAM_ROUT_DEFFLISTAM_IT L1;
 TUPAM_ROUT_DEFFLISTAM_IT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO2(TUPAM_ROUT_DEFFRAME_LAYO self, AM_ROUT_DEF at1, FRAME_LAYOUT at2) {
 TUPAM_ROUT_DEFFRAME_LAYO ret_val = TUPAM_ROUT_DEFFRAME_LAYO_zero;
 TUPAM_ROUT_DEFFRAME_LAYO L1;
 TUPAM_ROUT_DEFFRAME_LAYO L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPARRAYdTPARRAYBOOLdTP TUPARRAYdTPARRAYBOOLdTP_1(TUPARRAYdTPARRAYBOOLdTP self, ARRAYdTP at1, ARRAYBOOL at2, dTP at3) {
 TUPARRAYdTPARRAYBOOLdTP ret_val = TUPARRAYdTPARRAYBOOLdTP_zero;
 TUPARRAYdTPARRAYBOOLdTP L1;
 TUPARRAYdTPARRAYBOOLdTP L2;
 TUPARRAYdTPARRAYBOOLdTP L3;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 L3 = L2;
 L3.t3 = at3;
 ret_val = L3;
 return ret_val;
}


TUPBOOLINTIINTBOOL TUPBOOLINTIINTBOOL_creat(TUPBOOLINTIINTBOOL self, BOOL at1, INTI at2, INT at3, BOOL at4) {
 TUPBOOLINTIINTBOOL ret_val = TUPBOOLINTIINTBOOL_zero;
 TUPBOOLINTIINTBOOL L1;
 TUPBOOLINTIINTBOOL L2;
 TUPBOOLINTIINTBOOL L3;
 TUPBOOLINTIINTBOOL L4;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 L3 = L2;
 L3.t3 = at3;
 L4 = L3;
 L4.t4 = at4;
 ret_val = L4;
 return ret_val;
}


TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_c(TUPIDENTAM_GLOBAL_EXPR self, IDENT at1, AM_GLOBAL_EXPR at2) {
 TUPIDENTAM_GLOBAL_EXPR ret_val = TUPIDENTAM_GLOBAL_EXPR_zero;
 TUPIDENTAM_GLOBAL_EXPR L1;
 TUPIDENTAM_GLOBAL_EXPR L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPIDENTdTP TUPIDENTdTP_create_IDENT(TUPIDENTdTP self, IDENT at1, dTP at2) {
 TUPIDENTdTP ret_val = TUPIDENTdTP_zero;
 TUPIDENTdTP L1;
 TUPIDENTdTP L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY2(TUPSIGABSTRACT_FRAME_LAY self, SIG at1, ABSTRACT_FRAME_LAYOUT at2) {
 TUPSIGABSTRACT_FRAME_LAY ret_val = TUPSIGABSTRACT_FRAME_LAY_zero;
 TUPSIGABSTRACT_FRAME_LAY L1;
 TUPSIGABSTRACT_FRAME_LAY L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_create(TUPSIGAM_ROUT_DEF self, SIG at1, AM_ROUT_DEF at2) {
 TUPSIGAM_ROUT_DEF ret_val = TUPSIGAM_ROUT_DEF_zero;
 TUPSIGAM_ROUT_DEF L1;
 TUPSIGAM_ROUT_DEF L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSIGSIG TUPSIGSIG_create_SIG_SIG(TUPSIGSIG self, SIG at1, SIG at2) {
 TUPSIGSIG ret_val = TUPSIGSIG_zero;
 TUPSIGSIG L1;
 TUPSIGSIG L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSIGSTR TUPSIGSTR_create_SIG_STR(TUPSIGSTR self, SIG at1, STR at2) {
 TUPSIGSTR ret_val = TUPSIGSTR_zero;
 TUPSIGSTR L1;
 TUPSIGSTR L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSTRINT TUPSTRINT_create_STR_INT(TUPSTRINT self, STR at1, INT at2) {
 TUPSTRINT ret_val = TUPSTRINT_zero;
 TUPSTRINT L1;
 TUPSTRINT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPSTRITER_INLINE TUPSTRITER_INLINE_create(TUPSTRITER_INLINE self, STR at1, ITER_INLINE at2) {
 TUPSTRITER_INLINE ret_val = TUPSTRITER_INLINE_zero;
 TUPSTRITER_INLINE L1;
 TUPSTRITER_INLINE L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPTP_CLASSFSETTP_CLASS TUPTP_CLASSFSETTP_CLASS_1(TUPTP_CLASSFSETTP_CLASS self, TP_CLASS at1, FSETTP_CLASS at2) {
 TUPTP_CLASSFSETTP_CLASS ret_val = TUPTP_CLASSFSETTP_CLASS_zero;
 TUPTP_CLASSFSETTP_CLASS L1;
 TUPTP_CLASSFSETTP_CLASS L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPTP_CLASSFSETdTP TUPTP_CLASSFSETdTP_creat(TUPTP_CLASSFSETdTP self, TP_CLASS at1, FSETdTP at2) {
 TUPTP_CLASSFSETdTP ret_val = TUPTP_CLASSFSETdTP_zero;
 TUPTP_CLASSFSETdTP L1;
 TUPTP_CLASSFSETdTP L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdAM_EXPRdTP TUPdAM_EXPRdTP_create_dA(TUPdAM_EXPRdTP self, dAM_EXPR at1, dTP at2) {
 TUPdAM_EXPRdTP ret_val = TUPdAM_EXPRdTP_zero;
 TUPdAM_EXPRdTP L1;
 TUPdAM_EXPRdTP L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdOBNAMESPACE TUPdOBNAMESPACE_create_d(TUPdOBNAMESPACE self, OB at1, NAMESPACE at2) {
 TUPdOBNAMESPACE ret_val = TUPdOBNAMESPACE_zero;
 TUPdOBNAMESPACE L1;
 TUPdOBNAMESPACE L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdOBSTR TUPdOBSTR_create_dOB_STR(TUPdOBSTR self, OB at1, STR at2) {
 TUPdOBSTR ret_val = TUPdOBSTR_zero;
 TUPdOBSTR L1;
 TUPdOBSTR L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPCODE_FILE TUPdTPCODE_FILE_create_d(TUPdTPCODE_FILE self, dTP at1, CODE_FILE at2) {
 TUPdTPCODE_FILE ret_val = TUPdTPCODE_FILE_zero;
 TUPdTPCODE_FILE L1;
 TUPdTPCODE_FILE L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPFMAPIDENTAM_GLOBAL TUPdTPFMAPIDENTAM_GLOBAL2(TUPdTPFMAPIDENTAM_GLOBAL self, dTP at1, FMAPIDENTAM_GLOBAL_EXPR at2) {
 TUPdTPFMAPIDENTAM_GLOBAL ret_val = TUPdTPFMAPIDENTAM_GLOBAL_zero;
 TUPdTPFMAPIDENTAM_GLOBAL L1;
 TUPdTPFMAPIDENTAM_GLOBAL L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPIFC TUPdTPIFC_create_dTP_IFC(TUPdTPIFC self, dTP at1, IFC at2) {
 TUPdTPIFC ret_val = TUPdTPIFC_zero;
 TUPdTPIFC L1;
 TUPdTPIFC L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPIMPL TUPdTPIMPL_create_dTP_IM(TUPdTPIMPL self, dTP at1, IMPL at2) {
 TUPdTPIMPL ret_val = TUPdTPIMPL_zero;
 TUPdTPIMPL L1;
 TUPdTPIMPL L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPINT TUPdTPINT_create_dTP_INT(TUPdTPINT self, dTP at1, INT at2) {
 TUPdTPINT ret_val = TUPdTPINT_zero;
 TUPdTPINT L1;
 TUPdTPINT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


TUPdTPdLAYOUT TUPdTPdLAYOUT_create_dTP(TUPdTPdLAYOUT self, dTP at1, dLAYOUT at2) {
 TUPdTPdLAYOUT ret_val = TUPdTPdLAYOUT_zero;
 TUPdTPdLAYOUT L1;
 TUPdTPdLAYOUT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}


VALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_creat(VALUE_CLASS_LAYOUT self, dTP tp, PROG prog) {
 VALUE_CLASS_LAYOUT ret_val;
 VALUE_CLASS_LAYOUT res = ((VALUE_CLASS_LAYOUT) NULL);
 dLAYOUT r;
 BOOL L1;
 VALUE_CLASS_LAYOUT L2;
 dTP L3;
 STR L4;
 extern STR value3;
 r = FMAPdTPdLAYOUT_get_dTP_d(LAYOUT_TBL_layout_tbl, tp);
 L1 = (r==((dLAYOUT) NULL));
 if ((!(L1))) {
  if (r==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(r)) {
   case VALUE_CLASS_LAYOUT_tag:
    res = ((VALUE_CLASS_LAYOUT) r); break;
   default: ;
    FATAL("No applicable type in typecase");
  }
 }
 else {
  L2 = ((VALUE_CLASS_LAYOUT) rt_alloc(sizeof(struct VALUE_CLASS_LAYOUT_struct), VALUE_CLASS_LAYOUT_tag));
  res = L2;
  SATTR(res,tp1,tp);
  SATTR(res,prog1,prog);
  SATTR(res,l1,CGEN_am_ob_def_for_tp_dT(LAYOUT_TBL_cgen, tp));
  VALUE_CLASS_LAYOUT_make_(res);
  L3 = ATTR(res,tp1);
  if (L3==NULL) {
   FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::create($TP,PROG):VALUE_CLASS_LAYOUT");
  }
  L4 = (*dTP_str_STR[TAG(L3)+dTP_str_STR_offset])(L3);
  SATTR(res,str1,STR_plus_dSTR_STR(L4, ((dSTR) ((STR) &value3))));
  VALUE_CLASS_LAYOUT_layou(self, FSETVALUE_CLASS_LAYOUT_i1(VALUE_CLASS_LAYOUT_layou1, res));
  LAYOUT_TBL_layout_tbl_FM(((LAYOUT_TBL) NULL), FMAPdTPdLAYOUT_insert_dT(LAYOUT_TBL_layout_tbl, tp, ((dLAYOUT) res)));
 }
 ret_val = res;
 return ret_val;
}


dAM_EXPR XFORM_CODE_xform_expr_dA(XFORM_CODE self, dAM_EXPR expr1) {
 dAM_EXPR ret_val;
 AM_ARRAY_EXPR enew;
 AM_ARRAY_EXPR L11;
 AM_ARRAY_EXPR L21;
 AM_BND_CREATE_EXPR enew1;
 AM_BND_CREATE_EXPR L31;
 AM_BND_CREATE_EXPR L41;
 AM_IF_EXPR enew2;
 AM_NEW_EXPR enew3;
 AM_IS_VOID_EXPR enew4;
 AM_ATTR_EXPR enew5;
 AM_ARR_EXPR enew6;
 AM_VATTR_ASSIGN_EXPR enew7;
 AM_VARR_ASSIGN_EXPR enew8;
 AM_WHERE_EXPR enew9;
 AM_NEAR_EXPR enew10;
 AM_FAR_EXPR enew11;
 AM_AT_EXPR enew12;
 AM_ROUT_CALL_EXPR enew13;
 AM_ROUT_CALL_EXPR L51;
 AM_ROUT_CALL_EXPR L61;
 AM_ITER_CALL_EXPR enew14;
 AM_ITER_CALL_EXPR L71;
 AM_ITER_CALL_EXPR L81;
 AM_BND_ROUT_CALL_EXPR enew15;
 AM_BND_ROUT_CALL_EXPR L91;
 AM_BND_ROUT_CALL_EXPR L101;
 AM_BND_ITER_CALL_EXPR enew16;
 AM_BND_ITER_CALL_EXPR L121;
 AM_BND_ITER_CALL_EXPR L131;
 AM_EXT_CALL_EXPR enew17;
 AM_EXT_CALL_EXPR L141;
 AM_EXT_CALL_EXPR L151;
 AM_STMT_EXPR enew18;
 FLISTdAM_EXPR save_calls;
 FLISTAM_LOCAL_EXPR L161;
 INT L17;
 dAM_EXPR L18;
 INT L19;
 dAM_EXPR L20;
 INT L22;
 dAM_EXPR L23;
 INT L24;
 dAM_EXPR L25;
 INT L26;
 dAM_EXPR L27;
 INT L28;
 dAM_EXPR L29;
 INT L30;
 dAM_EXPR L32;
 FLISTAM_LOCAL_EXPR L33;
 FMAPAM_LOCAL_EXPRAM_LOCA L34;
 AM_LOCAL_EXPR L35;
 if ((expr1==((dAM_EXPR) NULL))) {
  ret_val = ((dAM_EXPR) NULL);
  return ret_val;
 }
 if (expr1==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(expr1)) {
  case AM_LOCAL_EXPR_tag:
   ret_val = ((dAM_EXPR) FMAPAM_LOCAL_EXPRAM_LOCA19(ATTR(self,subst1), ((AM_LOCAL_EXPR) expr1)));
   return ret_val; break;
  case AM_ARRAY_EXPR_tag:
   L17 = (ASIZE(((AM_ARRAY_EXPR) expr1)));
   enew = AM_ARRAY_EXPR_create_INT(((AM_ARRAY_EXPR) NULL), L17, ATTR(((AM_ARRAY_EXPR) expr1),source11));
   SATTR(enew,tp_at,ATTR(((AM_ARRAY_EXPR) expr1),tp_at));
   {
    struct AM_ARRAY_EXPR_eltb_dAM_E_frame_struct other1_0;
    AM_ARRAY_EXPR_eltb_dAM_E_frame 
    noname1 = &other1_0;
    struct AM_ARRAY_EXPR_setb_dAM_E_frame_struct other1_1;
    AM_ARRAY_EXPR_setb_dAM_E_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = enew;
      noname2->self = L21;
     }
     if (noname1->state == 0) {
      L11 = ((AM_ARRAY_EXPR) expr1);
      noname1->self = L11;
     }
     L18 = AM_ARRAY_EXPR_eltb_dAM_E(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     noname2->arg1 = XFORM_CODE_xform_expr_dA(self, L18);
     AM_ARRAY_EXPR_setb_dAM_E(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     /* No return value from iter call */;
    }
   }
   after_loop: ;
   ret_val = ((dAM_EXPR) enew);
   return ret_val; break;
  case AM_BND_CREATE_EXPR_tag:
   L19 = (ASIZE(((AM_BND_CREATE_EXPR) expr1)));
   enew1 = AM_BND_CREATE_EXPR_creat(((AM_BND_CREATE_EXPR) NULL), L19, ATTR(((AM_BND_CREATE_EXPR) expr1),source11));
   SATTR(enew1,fun,ATTR(((AM_BND_CREATE_EXPR) expr1),fun));
   SATTR(enew1,bnd_args,ATTR(((AM_BND_CREATE_EXPR) expr1),bnd_args));
   SATTR(enew1,unbnd_args,ATTR(((AM_BND_CREATE_EXPR) expr1),unbnd_args));
   SATTR(enew1,tp_at,ATTR(((AM_BND_CREATE_EXPR) expr1),tp_at));
   {
    struct AM_BND_CREATE_EXPR_eltb__frame_struct other2_0;
    AM_BND_CREATE_EXPR_eltb__frame 
    noname3 = &other2_0;
    struct AM_BND_CREATE_EXPR_setb__frame_struct other2_1;
    AM_BND_CREATE_EXPR_setb__frame 
    noname4 = &other2_1;
    noname3->state = 0;
    noname4->state = 0;
    while (1) {
     if (noname4->state == 0) {
      L41 = enew1;
      noname4->self = L41;
     }
     if (noname3->state == 0) {
      L31 = ((AM_BND_CREATE_EXPR) expr1);
      noname3->self = L31;
     }
     L20 = AM_BND_CREATE_EXPR_eltb_(noname3);
     if (noname3->state == -1) {
      goto after_loop1;
     }
     noname4->arg1 = XFORM_CODE_xform_expr_dA(self, L20);
     AM_BND_CREATE_EXPR_setb_(noname4);
     if (noname4->state == -1) {
      goto after_loop1;
     }
     /* No return value from iter call */;
    }
   }
   after_loop1: ;
   ret_val = ((dAM_EXPR) enew1);
   return ret_val; break;
  case AM_IF_EXPR_tag:
   enew2 = AM_IF_EXPR_create_SFILE_(((AM_IF_EXPR) NULL), ATTR(((AM_IF_EXPR) expr1),source11));
   SATTR(enew2,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_IF_EXPR) expr1),test11)));
   SATTR(enew2,if_true,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_IF_EXPR) expr1),if_true)));
   SATTR(enew2,if_false,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_IF_EXPR) expr1),if_false)));
   SATTR(enew2,tp_at,ATTR(((AM_IF_EXPR) expr1),tp_at));
   ret_val = ((dAM_EXPR) enew2);
   return ret_val; break;
  case AM_NEW_EXPR_tag:
   enew3 = AM_NEW_EXPR_create_SFILE(((AM_NEW_EXPR) NULL), ATTR(((AM_NEW_EXPR) expr1),source11));
   SATTR(enew3,tp_at,ATTR(((AM_NEW_EXPR) expr1),tp_at));
   SATTR(enew3,asz1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_NEW_EXPR) expr1),asz1)));
   ret_val = ((dAM_EXPR) enew3);
   return ret_val; break;
  case AM_IS_VOID_EXPR_tag:
   enew4 = AM_IS_VOID_EXPR_create_S(((AM_IS_VOID_EXPR) NULL), ATTR(((AM_IS_VOID_EXPR) expr1),source11));
   SATTR(enew4,tp_at,ATTR(((AM_IS_VOID_EXPR) expr1),tp_at));
   SATTR(enew4,arg1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_IS_VOID_EXPR) expr1),arg1)));
   ret_val = ((dAM_EXPR) enew4);
   return ret_val; break;
  case AM_GLOBAL_EXPR_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_ATTR_EXPR_tag:
   enew5 = AM_ATTR_EXPR_create_SFIL(((AM_ATTR_EXPR) NULL), ATTR(((AM_ATTR_EXPR) expr1),source11));
   SATTR(enew5,ob1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ATTR_EXPR) expr1),ob1)));
   SATTR(enew5,self_tp,ATTR(((AM_ATTR_EXPR) expr1),self_tp));
   SATTR(enew5,at11,ATTR(((AM_ATTR_EXPR) expr1),at11));
   SATTR(enew5,tp_at,ATTR(((AM_ATTR_EXPR) expr1),tp_at));
   SATTR(enew5,as_type,ATTR(((AM_ATTR_EXPR) expr1),as_type));
   ret_val = ((dAM_EXPR) enew5);
   return ret_val; break;
  case AM_ARR_EXPR_tag:
   enew6 = AM_ARR_EXPR_create_SFILE(((AM_ARR_EXPR) NULL), ATTR(((AM_ARR_EXPR) expr1),source11));
   SATTR(enew6,ob1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ARR_EXPR) expr1),ob1)));
   SATTR(enew6,ind1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ARR_EXPR) expr1),ind1)));
   SATTR(enew6,tp_at,ATTR(((AM_ARR_EXPR) expr1),tp_at));
   ret_val = ((dAM_EXPR) enew6);
   return ret_val; break;
  case AM_VATTR_ASSIGN_EXPR_tag:
   enew7 = AM_VATTR_ASSIGN_EXPR_cre(((AM_VATTR_ASSIGN_EXPR) NULL), ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),source11));
   SATTR(enew7,ob1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),ob1)));
   SATTR(enew7,at11,ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),at11));
   SATTR(enew7,val11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),val11)));
   ret_val = ((dAM_EXPR) enew7);
   return ret_val; break;
  case AM_VARR_ASSIGN_EXPR_tag:
   enew8 = AM_VARR_ASSIGN_EXPR_crea(((AM_VARR_ASSIGN_EXPR) NULL), ATTR(((AM_VARR_ASSIGN_EXPR) expr1),source11));
   SATTR(enew8,ob1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),ob1)));
   SATTR(enew8,ind1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),ind1)));
   SATTR(enew8,val11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),val11)));
   ret_val = ((dAM_EXPR) enew8);
   return ret_val; break;
  case AM_EXCEPT_EXPR_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_HERE_EXPR_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_ANY_EXPR_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_CLUSTER_EXPR_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_WHERE_EXPR_tag:
   enew9 = AM_WHERE_EXPR_create_SFI(((AM_WHERE_EXPR) NULL), ATTR(((AM_WHERE_EXPR) expr1),source11));
   SATTR(enew9,arg1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_WHERE_EXPR) expr1),arg1)));
   ret_val = ((dAM_EXPR) enew9);
   return ret_val; break;
  case AM_NEAR_EXPR_tag:
   enew10 = AM_NEAR_EXPR_create_SFIL(((AM_NEAR_EXPR) NULL), ATTR(((AM_NEAR_EXPR) expr1),source11));
   SATTR(enew10,arg1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_NEAR_EXPR) expr1),arg1)));
   ret_val = ((dAM_EXPR) enew10);
   return ret_val; break;
  case AM_FAR_EXPR_tag:
   enew11 = AM_FAR_EXPR_create_SFILE(((AM_FAR_EXPR) NULL), ATTR(((AM_FAR_EXPR) expr1),source11));
   SATTR(enew11,arg1,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_FAR_EXPR) expr1),arg1)));
   ret_val = ((dAM_EXPR) enew11);
   return ret_val; break;
  case AM_AT_EXPR_tag:
   enew12 = AM_AT_EXPR_create_SFILE_(((AM_AT_EXPR) NULL), ATTR(((AM_AT_EXPR) expr1),source11));
   SATTR(enew12,at11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_AT_EXPR) expr1),at11)));
   SATTR(enew12,e11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_AT_EXPR) expr1),e11)));
   ret_val = ((dAM_EXPR) enew12);
   return ret_val; break;
  case AM_ROUT_CALL_EXPR_tag:
   L22 = (ASIZE(((AM_ROUT_CALL_EXPR) expr1)));
   enew13 = AM_ROUT_CALL_EXPR_create(((AM_ROUT_CALL_EXPR) NULL), L22, ATTR(((AM_ROUT_CALL_EXPR) expr1),source11));
   SATTR(enew13,fun,ATTR(((AM_ROUT_CALL_EXPR) expr1),fun));
   SATTR(enew13,as_type,ATTR(((AM_ROUT_CALL_EXPR) expr1),as_type));
   {
    struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct other3_0;
    AM_ROUT_CALL_EXPR_eltb_d_frame 
    noname5 = &other3_0;
    struct AM_ROUT_CALL_EXPR_setb_d_frame_struct other3_1;
    AM_ROUT_CALL_EXPR_setb_d_frame 
    noname6 = &other3_1;
    noname5->state = 0;
    noname6->state = 0;
    while (1) {
     if (noname6->state == 0) {
      L61 = enew13;
      noname6->self = L61;
     }
     if (noname5->state == 0) {
      L51 = ((AM_ROUT_CALL_EXPR) expr1);
      noname5->self = L51;
     }
     L23 = AM_ROUT_CALL_EXPR_eltb_d(noname5);
     if (noname5->state == -1) {
      goto after_loop2;
     }
     noname6->arg1 = XFORM_CODE_xform_expr_dA(self, L23);
     AM_ROUT_CALL_EXPR_setb_d(noname6);
     if (noname6->state == -1) {
      goto after_loop2;
     }
     /* No return value from iter call */;
    }
   }
   after_loop2: ;
   if (ATTR(self,record_calls)) {
    SATTR(self,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(self,calls1), ((dAM_EXPR) enew13)));
   }
   ret_val = ((dAM_EXPR) enew13);
   return ret_val; break;
  case AM_ITER_CALL_EXPR_tag:
   L24 = (ASIZE(((AM_ITER_CALL_EXPR) expr1)));
   enew14 = AM_ITER_CALL_EXPR_create(((AM_ITER_CALL_EXPR) NULL), L24, ATTR(((AM_ITER_CALL_EXPR) expr1),source11));
   SATTR(enew14,fun,ATTR(((AM_ITER_CALL_EXPR) expr1),fun));
   SATTR(enew14,init1,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_ITER_CALL_EXPR) expr1),init1)));
   SATTR(enew14,lp1,ATTR(self,new_loop_stmt));
   SATTR(ATTR(self,new_loop_stmt),its1,FLISTAM_ITER_CALL_EXPR_p(ATTR(ATTR(self,new_loop_stmt),its1), enew14));
   {
    struct AM_ITER_CALL_EXPR_eltb_d_frame_struct other4_0;
    AM_ITER_CALL_EXPR_eltb_d_frame 
    noname7 = &other4_0;
    struct AM_ITER_CALL_EXPR_setb_d_frame_struct other4_1;
    AM_ITER_CALL_EXPR_setb_d_frame 
    noname8 = &other4_1;
    noname7->state = 0;
    noname8->state = 0;
    while (1) {
     if (noname8->state == 0) {
      L81 = enew14;
      noname8->self = L81;
     }
     if (noname7->state == 0) {
      L71 = ((AM_ITER_CALL_EXPR) expr1);
      noname7->self = L71;
     }
     L25 = AM_ITER_CALL_EXPR_eltb_d(noname7);
     if (noname7->state == -1) {
      goto after_loop3;
     }
     noname8->arg1 = XFORM_CODE_xform_expr_dA(self, L25);
     AM_ITER_CALL_EXPR_setb_d(noname8);
     if (noname8->state == -1) {
      goto after_loop3;
     }
     /* No return value from iter call */;
    }
   }
   after_loop3: ;
   if (ATTR(self,record_calls)) {
    SATTR(self,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(self,calls1), ((dAM_EXPR) enew14)));
   }
   ret_val = ((dAM_EXPR) enew14);
   return ret_val; break;
  case AM_BND_ROUT_CALL_EXPR_tag:
   L26 = (ASIZE(((AM_BND_ROUT_CALL_EXPR) expr1)));
   enew15 = AM_BND_ROUT_CALL_EXPR_cr(((AM_BND_ROUT_CALL_EXPR) NULL), L26, ATTR(((AM_BND_ROUT_CALL_EXPR) expr1),source11));
   SATTR(enew15,br,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_BND_ROUT_CALL_EXPR) expr1),br)));
   SATTR(enew15,br_tp,ATTR(((AM_BND_ROUT_CALL_EXPR) expr1),br_tp));
   {
    struct AM_BND_ROUT_CALL_EXPR_el_frame_struct other5_0;
    AM_BND_ROUT_CALL_EXPR_el_frame 
    noname9 = &other5_0;
    struct AM_BND_ROUT_CALL_EXPR_se_frame_struct other5_1;
    AM_BND_ROUT_CALL_EXPR_se_frame 
    noname10 = &other5_1;
    noname9->state = 0;
    noname10->state = 0;
    while (1) {
     if (noname10->state == 0) {
      L101 = enew15;
      noname10->self = L101;
     }
     if (noname9->state == 0) {
      L91 = ((AM_BND_ROUT_CALL_EXPR) expr1);
      noname9->self = L91;
     }
     L27 = AM_BND_ROUT_CALL_EXPR_el(noname9);
     if (noname9->state == -1) {
      goto after_loop4;
     }
     noname10->arg1 = XFORM_CODE_xform_expr_dA(self, L27);
     AM_BND_ROUT_CALL_EXPR_se(noname10);
     if (noname10->state == -1) {
      goto after_loop4;
     }
     /* No return value from iter call */;
    }
   }
   after_loop4: ;
   if (ATTR(self,record_calls)) {
    SATTR(self,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(self,calls1), ((dAM_EXPR) enew15)));
   }
   ret_val = ((dAM_EXPR) enew15);
   return ret_val; break;
  case AM_BND_ITER_CALL_EXPR_tag:
   L28 = (ASIZE(((AM_BND_ITER_CALL_EXPR) expr1)));
   enew16 = AM_BND_ITER_CALL_EXPR_cr(((AM_BND_ITER_CALL_EXPR) NULL), L28, ATTR(((AM_BND_ITER_CALL_EXPR) expr1),source11));
   SATTR(enew16,bi,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_BND_ITER_CALL_EXPR) expr1),bi)));
   SATTR(enew16,init1,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_BND_ITER_CALL_EXPR) expr1),init1)));
   SATTR(enew16,lp1,ATTR(self,new_loop_stmt));
   SATTR(ATTR(self,new_loop_stmt),bits1,FLISTAM_BND_ITER_CALL_EX10(ATTR(ATTR(self,new_loop_stmt),bits1), enew16));
   {
    struct AM_BND_ITER_CALL_EXPR_el_frame_struct other6_0;
    AM_BND_ITER_CALL_EXPR_el_frame 
    noname11 = &other6_0;
    struct AM_BND_ITER_CALL_EXPR_se_frame_struct other6_1;
    AM_BND_ITER_CALL_EXPR_se_frame 
    noname12 = &other6_1;
    noname11->state = 0;
    noname12->state = 0;
    while (1) {
     if (noname12->state == 0) {
      L131 = enew16;
      noname12->self = L131;
     }
     if (noname11->state == 0) {
      L121 = ((AM_BND_ITER_CALL_EXPR) expr1);
      noname11->self = L121;
     }
     L29 = AM_BND_ITER_CALL_EXPR_el(noname11);
     if (noname11->state == -1) {
      goto after_loop5;
     }
     noname12->arg1 = XFORM_CODE_xform_expr_dA(self, L29);
     AM_BND_ITER_CALL_EXPR_se(noname12);
     if (noname12->state == -1) {
      goto after_loop5;
     }
     /* No return value from iter call */;
    }
   }
   after_loop5: ;
   if (ATTR(self,record_calls)) {
    SATTR(self,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(self,calls1), ((dAM_EXPR) enew16)));
   }
   ret_val = ((dAM_EXPR) enew16);
   return ret_val; break;
  case AM_EXT_CALL_EXPR_tag:
   L30 = (ASIZE(((AM_EXT_CALL_EXPR) expr1)));
   enew17 = AM_EXT_CALL_EXPR_create_1(((AM_EXT_CALL_EXPR) NULL), L30, ATTR(((AM_EXT_CALL_EXPR) expr1),source11), ATTR(((AM_EXT_CALL_EXPR) expr1),nm1));
   SATTR(enew17,fun,ATTR(((AM_EXT_CALL_EXPR) expr1),fun));
   {
    struct AM_EXT_CALL_EXPR_eltb_dA_frame_struct other7_0;
    AM_EXT_CALL_EXPR_eltb_dA_frame 
    noname13 = &other7_0;
    struct AM_EXT_CALL_EXPR_setb_dA_frame_struct other7_1;
    AM_EXT_CALL_EXPR_setb_dA_frame 
    noname14 = &other7_1;
    noname13->state = 0;
    noname14->state = 0;
    while (1) {
     if (noname14->state == 0) {
      L151 = enew17;
      noname14->self = L151;
     }
     if (noname13->state == 0) {
      L141 = ((AM_EXT_CALL_EXPR) expr1);
      noname13->self = L141;
     }
     L32 = AM_EXT_CALL_EXPR_eltb_dA(noname13);
     if (noname13->state == -1) {
      goto after_loop6;
     }
     noname14->arg1 = XFORM_CODE_xform_expr_dA(self, L32);
     AM_EXT_CALL_EXPR_setb_dA(noname14);
     if (noname14->state == -1) {
      goto after_loop6;
     }
     /* No return value from iter call */;
    }
   }
   after_loop6: ;
   if (ATTR(self,record_calls)) {
    SATTR(self,calls1,FLISTdAM_EXPR_push_dAM_E(ATTR(self,calls1), ((dAM_EXPR) enew17)));
   }
   ret_val = ((dAM_EXPR) enew17);
   return ret_val; break;
  case AM_ARR_CONST_tag:
  case AM_BOOL_CONST_tag:
  case AM_CHAR_CONST_tag:
  case AM_CONST_tag:
  case AM_FLTDX_CONST_tag:
  case AM_FLTD_CONST_tag:
  case AM_FLTI_CONST_tag:
  case AM_FLTX_CONST_tag:
  case AM_FLT_CONST_tag:
  case AM_INTI_CONST_tag:
  case AM_INT_CONST_tag:
  case AM_STR_CONST_tag:
  case AM_VOID_CONST_tag:
   ret_val = expr1;
   return ret_val; break;
  case AM_STMT_EXPR_tag:
   enew18 = AM_STMT_EXPR_create_SFIL(((AM_STMT_EXPR) NULL), ATTR(((AM_STMT_EXPR) expr1),source11));
   save_calls = ATTR(self,calls1);
   SATTR(self,calls1,((FLISTdAM_EXPR) NULL));
   SATTR(enew18,stmts,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_STMT_EXPR) expr1),stmts)));
   SATTR(enew18,calls1,ATTR(self,calls1));
   SATTR(self,calls1,FLISTdAM_EXPR_concat_FLI(save_calls, ATTR(self,calls1)));
   SATTR(enew18,locals1,FLISTAM_LOCAL_EXPR_creat(((FLISTAM_LOCAL_EXPR) NULL), FLISTAM_LOCAL_EXPR_size_(ATTR(((AM_STMT_EXPR) expr1),locals1))));
   {
    struct FLISTAM_LOCAL_EXPR_eltb__frame_struct other8_0;
    FLISTAM_LOCAL_EXPR_eltb__frame 
    noname15 = &other8_0;
    noname15->state = 0;
    while (1) {
     L33 = ATTR(enew18,locals1);
     L34 = ATTR(self,subst1);
     if (noname15->state == 0) {
      L161 = ATTR(((AM_STMT_EXPR) expr1),locals1);
      noname15->self = L161;
     }
     L35 = FLISTAM_LOCAL_EXPR_eltb_(noname15);
     if (noname15->state == -1) {
      goto after_loop7;
     }
     SATTR(enew18,locals1,FLISTAM_LOCAL_EXPR_push_(L33, FMAPAM_LOCAL_EXPRAM_LOCA19(L34, L35)));
    }
   }
   after_loop7: ;
   SATTR(enew18,expr,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_STMT_EXPR) expr1),expr)));
   ret_val = ((dAM_EXPR) enew18);
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


dAM_STMT XFORM_CODE_xform_stmt_dA(XFORM_CODE self, dAM_STMT stmt) {
 dAM_STMT ret_val;
 AM_ASSIGN_STMT snew;
 AM_PRE_STMT snew1;
 AM_POST_STMT snew2;
 AM_INITIAL_STMT snew3;
 AM_ASSERT_STMT snew4;
 AM_INVARIANT_STMT snew5;
 AM_EXPR_STMT snew6;
 AM_IF_STMT snew7;
 AM_IF_STMT old_eif;
 AM_CASE_STMT snew8;
 FLISTdAM_STMT L11;
 AM_TYPECASE_STMT snew9;
 FLISTdAM_STMT L21;
 FLISTdAM_STMT L3;
 dAM_STMT L4;
 BOOL L5;
 FLISTdAM_STMT L6;
 dAM_STMT L7;
 BOOL L8;
 if (stmt==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(stmt)) {
  case AM_ASSIGN_STMT_tag:
   snew = AM_ASSIGN_STMT_create_SF(((AM_ASSIGN_STMT) NULL), ATTR(((AM_ASSIGN_STMT) stmt),source11));
   SATTR(snew,dest,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ASSIGN_STMT) stmt),dest)));
   SATTR(snew,src11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ASSIGN_STMT) stmt),src11)));
   ret_val = ((dAM_STMT) snew);
   return ret_val; break;
  case AM_PRE_STMT_tag:
   snew1 = AM_PRE_STMT_create_SFILE(((AM_PRE_STMT) NULL), ATTR(((AM_PRE_STMT) stmt),source11));
   SATTR(snew1,tp1,ATTR(((AM_PRE_STMT) stmt),tp1));
   SATTR(snew1,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_PRE_STMT) stmt),test11)));
   ret_val = ((dAM_STMT) snew1);
   return ret_val; break;
  case AM_POST_STMT_tag:
   snew2 = AM_POST_STMT_create_SFIL(((AM_POST_STMT) NULL), ATTR(((AM_POST_STMT) stmt),source11));
   SATTR(snew2,tp1,ATTR(((AM_POST_STMT) stmt),tp1));
   SATTR(snew2,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_POST_STMT) stmt),test11)));
   ret_val = ((dAM_STMT) snew2);
   return ret_val; break;
  case AM_INITIAL_STMT_tag:
   snew3 = AM_INITIAL_STMT_create_S(((AM_INITIAL_STMT) NULL), ATTR(((AM_INITIAL_STMT) stmt),source11));
   SATTR(snew3,tp1,ATTR(((AM_INITIAL_STMT) stmt),tp1));
   SATTR(snew3,stmts,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_INITIAL_STMT) stmt),stmts)));
   ret_val = ((dAM_STMT) snew3);
   return ret_val; break;
  case AM_ASSERT_STMT_tag:
   snew4 = AM_ASSERT_STMT_create_SF(((AM_ASSERT_STMT) NULL), ATTR(((AM_ASSERT_STMT) stmt),source11));
   SATTR(snew4,tp1,ATTR(((AM_ASSERT_STMT) stmt),tp1));
   SATTR(snew4,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_ASSERT_STMT) stmt),test11)));
   ret_val = ((dAM_STMT) snew4);
   return ret_val; break;
  case AM_INVARIANT_STMT_tag:
   snew5 = AM_INVARIANT_STMT_create(((AM_INVARIANT_STMT) NULL), ATTR(((AM_INVARIANT_STMT) stmt),source11));
   SATTR(snew5,sig11,ATTR(((AM_INVARIANT_STMT) stmt),sig11));
   ret_val = ((dAM_STMT) snew5);
   return ret_val; break;
  case AM_EXPR_STMT_tag:
   snew6 = AM_EXPR_STMT_create_SFIL(((AM_EXPR_STMT) NULL), ATTR(((AM_EXPR_STMT) stmt),source11));
   SATTR(snew6,expr,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_EXPR_STMT) stmt),expr)));
   ret_val = ((dAM_STMT) snew6);
   return ret_val; break;
  case AM_IF_STMT_tag:
   snew7 = AM_IF_STMT_create_SFILE_(((AM_IF_STMT) NULL), ATTR(((AM_IF_STMT) stmt),source11));
   old_eif = ATTR(self,enclosing_if);
   SATTR(self,enclosing_if,snew7);
   SATTR(snew7,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_IF_STMT) stmt),test11)));
   SATTR(self,true_branch,TRUE);
   SATTR(snew7,if_true,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_IF_STMT) stmt),if_true)));
   SATTR(self,true_branch,FALSE);
   SATTR(snew7,if_false,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_IF_STMT) stmt),if_false)));
   SATTR(self,enclosing_if,old_eif);
   ret_val = ((dAM_STMT) snew7);
   return ret_val; break;
  case AM_CASE_STMT_tag:
   snew8 = AM_CASE_STMT_create_SFIL(((AM_CASE_STMT) NULL), ATTR(((AM_CASE_STMT) stmt),source11));
   SATTR(snew8,test11,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_CASE_STMT) stmt),test11)));
   SATTR(snew8,tgts,ATTR(((AM_CASE_STMT) stmt),tgts));
   SATTR(snew8,stmts,FLISTdAM_STMT_create_INT(((FLISTdAM_STMT) NULL), FLISTdAM_STMT_size_INT(ATTR(((AM_CASE_STMT) stmt),stmts))));
   {
    struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other1_0;
    FLISTdAM_STMT_eltb_dAM_S_frame 
    noname1 = &other1_0;
    noname1->state = 0;
    while (1) {
     L3 = ATTR(snew8,stmts);
     if (noname1->state == 0) {
      L11 = ATTR(((AM_CASE_STMT) stmt),stmts);
      noname1->self = L11;
     }
     L4 = FLISTdAM_STMT_eltb_dAM_S(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     SATTR(snew8,stmts,FLISTdAM_STMT_push_dAM_S(L3, XFORM_CODE_xform_stmt_li(self, L4)));
    }
   }
   after_loop: ;
   SATTR(snew8,no_else,ATTR(((AM_CASE_STMT) stmt),no_else));
   L5 = ATTR(snew8,no_else);
   if ((!(L5))) {
    SATTR(snew8,else_stmts,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_CASE_STMT) stmt),else_stmts)));
   }
   ret_val = ((dAM_STMT) snew8);
   return ret_val; break;
  case AM_TYPECASE_STMT_tag:
   snew9 = AM_TYPECASE_STMT_create_(((AM_TYPECASE_STMT) NULL), ATTR(((AM_TYPECASE_STMT) stmt),source11));
   SATTR(snew9,test11,FMAPAM_LOCAL_EXPRAM_LOCA19(ATTR(self,subst1), ATTR(((AM_TYPECASE_STMT) stmt),test11)));
   SATTR(snew9,tgts,ATTR(((AM_TYPECASE_STMT) stmt),tgts));
   SATTR(snew9,stmts,FLISTdAM_STMT_create_INT(((FLISTdAM_STMT) NULL), FLISTdAM_STMT_size_INT(ATTR(((AM_TYPECASE_STMT) stmt),stmts))));
   {
    struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other2_0;
    FLISTdAM_STMT_eltb_dAM_S_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     L6 = ATTR(snew9,stmts);
     if (noname2->state == 0) {
      L21 = ATTR(((AM_TYPECASE_STMT) stmt),stmts);
      noname2->self = L21;
     }
     L7 = FLISTdAM_STMT_eltb_dAM_S(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     SATTR(snew9,stmts,FLISTdAM_STMT_push_dAM_S(L6, XFORM_CODE_xform_stmt_li(self, L7)));
    }
   }
   after_loop1: ;
   SATTR(snew9,no_else,ATTR(((AM_TYPECASE_STMT) stmt),no_else));
   L8 = ATTR(snew9,no_else);
   if ((!(L8))) {
    SATTR(snew9,else_stmts,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_TYPECASE_STMT) stmt),else_stmts)));
   }
   ret_val = ((dAM_STMT) snew9);
   return ret_val; break;
  case AM_RETURN_STMT_tag:
   SATTR(self,return_val,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_RETURN_STMT) stmt),val11)));
   ret_val = ((dAM_STMT) NULL);
   return ret_val; break;
  case AM_YIELD_STMT_tag:
   SATTR(self,yield_val,XFORM_CODE_xform_expr_dA(self, ATTR(((AM_YIELD_STMT) stmt),val11)));
   SATTR(self,if_encl_yield,ATTR(self,enclosing_if));
   SATTR(self,true_br_yield,ATTR(self,true_branch));
   SATTR(self,after_yield,XFORM_CODE_xform_stmt_li(self, ATTR(((AM_YIELD_STMT) stmt),next1)));
   ret_val = ((dAM_STMT) NULL);
   return ret_val; break;
  case AM_BREAK_STMT_tag:
   ret_val = ((dAM_STMT) AM_BREAK_STMT_create_SFI(((AM_BREAK_STMT) NULL), ATTR(((AM_BREAK_STMT) stmt),source11)));
   return ret_val; break;
  case AM_LOOP_STMT_tag:
   SATTR(self,loop_stmt,((AM_LOOP_STMT) stmt));
   ret_val = ((dAM_STMT) NULL);
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


dAM_STMT XFORM_CODE_xform_stmt_li(XFORM_CODE self, dAM_STMT code1) {
 dAM_STMT ret_val;
 dAM_STMT temp1;
 dAM_STMT copy;
 dAM_STMT L1;
 dAM_STMT L2;
 dAM_STMT L3;
 if ((code1==((dAM_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 temp1 = XFORM_CODE_xform_stmt_dA(self, code1);
 if ((temp1==((dAM_STMT) NULL))) {
  ret_val = ((dAM_STMT) NULL);
  return ret_val;
 }
 copy = temp1;
 while (1) {
  L1 = code1;
  if (L1==NULL) {
   FATAL("Dispatch on void in XFORM_CODE::xform_stmt_list($AM_STMT):$AM_STMT");
  }
  code1 = (*dAM_STMT_next_dAM_STMT[TAG(L1)+dAM_STMT_next_dAM_STMT_offset])(L1);
  if ((code1==((dAM_STMT) NULL))) {
   goto after_loop;
  }
  L2 = temp1;
  if (L2==NULL) {
   FATAL("Dispatch on void in XFORM_CODE::xform_stmt_list($AM_STMT):$AM_STMT");
  }
  (*dAM_STMT_next_dAM_STMT1[TAG(L2)+dAM_STMT_next_dAM_STMT1_offset])(L2, XFORM_CODE_xform_stmt_dA(self, code1));
  L3 = temp1;
  if (L3==NULL) {
   FATAL("Dispatch on void in XFORM_CODE::xform_stmt_list($AM_STMT):$AM_STMT");
  }
  temp1 = (*dAM_STMT_next_dAM_STMT[TAG(L3)+dAM_STMT_next_dAM_STMT_offset])(L3);
  if ((temp1==((dAM_STMT) NULL))) {
   goto after_loop;
  }
 }
 after_loop: ;
 ret_val = copy;
 return ret_val;
}


void VALUE_CLASS_LAYOUT_layou(VALUE_CLASS_LAYOUT self, FSETVALUE_CLASS_LAYOUT layouts) {
 VALUE_CLASS_LAYOUT_layou1 = layouts;
}


void WEIGH_CODE_calc_expr_wei(WEIGH_CODE self, dAM_EXPR expr1) {
 AM_ARRAY_EXPR L11;
 AM_BND_CREATE_EXPR L21;
 AM_ROUT_CALL_EXPR L31;
 AM_ITER_CALL_EXPR L41;
 AM_BND_ROUT_CALL_EXPR L51;
 AM_BND_ITER_CALL_EXPR L61;
 AM_EXT_CALL_EXPR L71;
 BOOL L8;
 INT L9;
 INT L10;
 INT L12;
 INT L13;
 dAM_EXPR L14;
 BOOL L15;
 BOOL L16;
 INT L17;
 INT L18;
 dAM_EXPR L19;
 BOOL L20;
 BOOL L22;
 INT L23;
 INT L24;
 INT L25;
 INT L26;
 INT L27;
 INT L28;
 BOOL L29;
 BOOL L30;
 INT L32;
 INT L33;
 BOOL L34;
 BOOL L35;
 INT L36;
 INT L37;
 INT L38;
 INT L39;
 INT L40;
 INT L42;
 BOOL L43;
 BOOL L44;
 INT L45;
 INT L46;
 INT L47;
 INT L48;
 INT L49;
 INT L50;
 BOOL L52;
 BOOL L53;
 INT L54;
 INT L55;
 BOOL L56;
 BOOL L57;
 INT L58;
 INT L59;
 BOOL L60;
 BOOL L62;
 INT L63;
 INT L64;
 BOOL L65;
 BOOL L66;
 INT L67;
 INT L68;
 INT L69;
 INT L70;
 BOOL L72;
 BOOL L73;
 INT L74;
 INT L75;
 INT L76;
 INT L77;
 INT L78;
 INT L79;
 dAM_EXPR L80;
 BOOL L81;
 BOOL L82;
 INT L83;
 INT L84;
 INT L85;
 INT L86;
 INT L87;
 INT L88;
 dAM_EXPR L89;
 BOOL L90;
 BOOL L91;
 INT L92;
 INT L93;
 INT L94;
 INT L95;
 INT L96;
 INT L97;
 INT L98;
 INT L99;
 dAM_EXPR L100;
 BOOL L101;
 BOOL L102;
 INT L103;
 INT L104;
 INT L105;
 INT L106;
 INT L107;
 INT L108;
 dAM_EXPR L109;
 BOOL L110;
 BOOL L111;
 INT L112;
 INT L113;
 INT L114;
 INT L115;
 BOOL L116;
 BOOL L117;
 INT L118;
 INT L119;
 INT L120;
 INT L121;
 INT L122;
 INT L123;
 dAM_EXPR L124;
 BOOL L125;
 BOOL L126;
 INT L127;
 INT L128;
 BOOL L129;
 BOOL L130;
 INT L131;
 INT L132;
 L8 = (expr1==((dAM_EXPR) NULL));
 if ((!(L8))) {
  if (expr1==NULL) {
   FATAL("Void object of typecase");
  } else
  switch (TAG(expr1)) {
   case AM_LOCAL_EXPR_tag: break;
   case AM_ARRAY_EXPR_tag:
    L9 = ATTR(self,weight);
    L10 = WEIGH_CODE_rout_call_wei;
    SATTR(self,weight,(INTPLUS(L9,L10)));
    L12 = ATTR(self,weight);
    L13 = ATTR(self,max_weight);
    if ((L12>L13)) {
     return;
    }
    {
     struct AM_ARRAY_EXPR_eltb_dAM_E_frame_struct other1_0;
     AM_ARRAY_EXPR_eltb_dAM_E_frame 
     noname1 = &other1_0;
     noname1->state = 0;
     while (1) {
      if (noname1->state == 0) {
       L11 = ((AM_ARRAY_EXPR) expr1);
       noname1->self = L11;
      }
      L14 = AM_ARRAY_EXPR_eltb_dAM_E(noname1);
      if (noname1->state == -1) {
       goto after_loop;
      }
      WEIGH_CODE_calc_expr_wei(self, L14);
      L16 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L16))) {
       L15 = TRUE;
      } else {
       L17 = ATTR(self,weight);
       L18 = ATTR(self,max_weight);
       L15 = (L17>L18);
      }
      if (L15) {
       return;
      }
     }
    }
    after_loop: ; break;
   case AM_BND_CREATE_EXPR_tag:
    {
     struct AM_BND_CREATE_EXPR_eltb__frame_struct other2_0;
     AM_BND_CREATE_EXPR_eltb__frame 
     noname2 = &other2_0;
     noname2->state = 0;
     while (1) {
      if (noname2->state == 0) {
       L21 = ((AM_BND_CREATE_EXPR) expr1);
       noname2->self = L21;
      }
      L19 = AM_BND_CREATE_EXPR_eltb_(noname2);
      if (noname2->state == -1) {
       goto after_loop1;
      }
      WEIGH_CODE_calc_expr_wei(self, L19);
      L22 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L22))) {
       L20 = TRUE;
      } else {
       L23 = ATTR(self,weight);
       L24 = ATTR(self,max_weight);
       L20 = (L23>L24);
      }
      if (L20) {
       return;
      }
     }
    }
    after_loop1: ; break;
   case AM_IF_EXPR_tag:
    L25 = ATTR(self,weight);
    L26 = WEIGH_CODE_if_weight;
    SATTR(self,weight,(INTPLUS(L25,L26)));
    L27 = ATTR(self,weight);
    L28 = ATTR(self,max_weight);
    if ((L27>L28)) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_IF_EXPR) expr1),test11));
    L30 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L30))) {
     L29 = TRUE;
    } else {
     L32 = ATTR(self,weight);
     L33 = ATTR(self,max_weight);
     L29 = (L32>L33);
    }
    if (L29) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_IF_EXPR) expr1),if_true));
    L35 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L35))) {
     L34 = TRUE;
    } else {
     L36 = ATTR(self,weight);
     L37 = ATTR(self,max_weight);
     L34 = (L36>L37);
    }
    if (L34) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_IF_EXPR) expr1),if_false)); break;
   case AM_NEW_EXPR_tag:
    L38 = ATTR(self,weight);
    L39 = WEIGH_CODE_rout_call_wei;
    SATTR(self,weight,(INTPLUS(L38,L39))); break;
   case AM_IS_VOID_EXPR_tag:
    L40 = ATTR(self,weight);
    L42 = WEIGH_CODE_if_weight;
    SATTR(self,weight,(INTPLUS(L40,L42))); break;
   case AM_GLOBAL_EXPR_tag: break;
   case AM_ATTR_EXPR_tag:
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ATTR_EXPR) expr1),ob1)); break;
   case AM_ARR_EXPR_tag:
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ARR_EXPR) expr1),ob1));
    L44 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L44))) {
     L43 = TRUE;
    } else {
     L45 = ATTR(self,weight);
     L46 = ATTR(self,max_weight);
     L43 = (L45>L46);
    }
    if (L43) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ARR_EXPR) expr1),ind1)); break;
   case AM_VATTR_ASSIGN_EXPR_tag:
    L47 = ATTR(self,weight);
    L48 = WEIGH_CODE_assign_weight;
    SATTR(self,weight,(INTPLUS(L47,L48)));
    L49 = ATTR(self,weight);
    L50 = ATTR(self,max_weight);
    if ((L49>L50)) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),ob1));
    L53 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L53))) {
     L52 = TRUE;
    } else {
     L54 = ATTR(self,weight);
     L55 = ATTR(self,max_weight);
     L52 = (L54>L55);
    }
    if (L52) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_VATTR_ASSIGN_EXPR) expr1),val11)); break;
   case AM_VARR_ASSIGN_EXPR_tag:
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),ob1));
    L57 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L57))) {
     L56 = TRUE;
    } else {
     L58 = ATTR(self,weight);
     L59 = ATTR(self,max_weight);
     L56 = (L58>L59);
    }
    if (L56) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),ind1));
    L62 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L62))) {
     L60 = TRUE;
    } else {
     L63 = ATTR(self,weight);
     L64 = ATTR(self,max_weight);
     L60 = (L63>L64);
    }
    if (L60) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_VARR_ASSIGN_EXPR) expr1),val11)); break;
   case AM_EXCEPT_EXPR_tag: break;
   case AM_STMT_EXPR_tag:
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_STMT_EXPR) expr1),expr));
    L66 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L66))) {
     L65 = TRUE;
    } else {
     L67 = ATTR(self,weight);
     L68 = ATTR(self,max_weight);
     L65 = (L67>L68);
    }
    if (L65) {
     return;
    }
    L69 = ATTR(self,level1);
    SATTR(self,level1,(INTMINUS(L69,1)));
    WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_STMT_EXPR) expr1),stmts));
    L70 = ATTR(self,level1);
    SATTR(self,level1,(INTPLUS(L70,1)));
    L73 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L73))) {
     L72 = TRUE;
    } else {
     L74 = ATTR(self,weight);
     L75 = ATTR(self,max_weight);
     L72 = (L74>L75);
    }
    if (L72) {
     return;
    } break;
   case AM_ROUT_CALL_EXPR_tag:
    L76 = ATTR(self,weight);
    L77 = WEIGH_CODE_rout_call_wei;
    SATTR(self,weight,(INTPLUS(L76,L77)));
    L78 = ATTR(self,weight);
    L79 = ATTR(self,max_weight);
    if ((L78>L79)) {
     return;
    }
    {
     struct AM_ROUT_CALL_EXPR_eltb_d_frame_struct other3_0;
     AM_ROUT_CALL_EXPR_eltb_d_frame 
     noname3 = &other3_0;
     noname3->state = 0;
     while (1) {
      if (noname3->state == 0) {
       L31 = ((AM_ROUT_CALL_EXPR) expr1);
       noname3->self = L31;
      }
      L80 = AM_ROUT_CALL_EXPR_eltb_d(noname3);
      if (noname3->state == -1) {
       goto after_loop2;
      }
      WEIGH_CODE_calc_expr_wei(self, L80);
      L82 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L82))) {
       L81 = TRUE;
      } else {
       L83 = ATTR(self,weight);
       L84 = ATTR(self,max_weight);
       L81 = (L83>L84);
      }
      if (L81) {
       return;
      }
     }
    }
    after_loop2: ; break;
   case AM_ITER_CALL_EXPR_tag:
    L85 = ATTR(self,weight);
    L86 = WEIGH_CODE_iter_call_wei;
    SATTR(self,weight,(INTPLUS(L85,L86)));
    L87 = ATTR(self,weight);
    L88 = ATTR(self,max_weight);
    if ((L87>L88)) {
     return;
    }
    {
     struct AM_ITER_CALL_EXPR_eltb_d_frame_struct other4_0;
     AM_ITER_CALL_EXPR_eltb_d_frame 
     noname4 = &other4_0;
     noname4->state = 0;
     while (1) {
      if (noname4->state == 0) {
       L41 = ((AM_ITER_CALL_EXPR) expr1);
       noname4->self = L41;
      }
      L89 = AM_ITER_CALL_EXPR_eltb_d(noname4);
      if (noname4->state == -1) {
       goto after_loop3;
      }
      WEIGH_CODE_calc_expr_wei(self, L89);
      L91 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L91))) {
       L90 = TRUE;
      } else {
       L92 = ATTR(self,weight);
       L93 = ATTR(self,max_weight);
       L90 = (L92>L93);
      }
      if (L90) {
       return;
      }
     }
    }
    after_loop3: ;
    L94 = ATTR(self,level1);
    SATTR(self,level1,(INTMINUS(L94,1)));
    WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_ITER_CALL_EXPR) expr1),init1));
    L95 = ATTR(self,level1);
    SATTR(self,level1,(INTPLUS(L95,1))); break;
   case AM_BND_ROUT_CALL_EXPR_tag:
    L96 = ATTR(self,weight);
    L97 = WEIGH_CODE_rout_call_wei;
    SATTR(self,weight,(INTPLUS(L96,L97)));
    L98 = ATTR(self,weight);
    L99 = ATTR(self,max_weight);
    if ((L98>L99)) {
     return;
    }
    {
     struct AM_BND_ROUT_CALL_EXPR_el_frame_struct other5_0;
     AM_BND_ROUT_CALL_EXPR_el_frame 
     noname5 = &other5_0;
     noname5->state = 0;
     while (1) {
      if (noname5->state == 0) {
       L51 = ((AM_BND_ROUT_CALL_EXPR) expr1);
       noname5->self = L51;
      }
      L100 = AM_BND_ROUT_CALL_EXPR_el(noname5);
      if (noname5->state == -1) {
       goto after_loop4;
      }
      WEIGH_CODE_calc_expr_wei(self, L100);
      L102 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L102))) {
       L101 = TRUE;
      } else {
       L103 = ATTR(self,weight);
       L104 = ATTR(self,max_weight);
       L101 = (L103>L104);
      }
      if (L101) {
       return;
      }
     }
    }
    after_loop4: ;
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_BND_ROUT_CALL_EXPR) expr1),br)); break;
   case AM_BND_ITER_CALL_EXPR_tag:
    L105 = ATTR(self,weight);
    L106 = WEIGH_CODE_iter_call_wei;
    SATTR(self,weight,(INTPLUS(L105,L106)));
    L107 = ATTR(self,weight);
    L108 = ATTR(self,max_weight);
    if ((L107>L108)) {
     return;
    }
    {
     struct AM_BND_ITER_CALL_EXPR_el_frame_struct other6_0;
     AM_BND_ITER_CALL_EXPR_el_frame 
     noname6 = &other6_0;
     noname6->state = 0;
     while (1) {
      if (noname6->state == 0) {
       L61 = ((AM_BND_ITER_CALL_EXPR) expr1);
       noname6->self = L61;
      }
      L109 = AM_BND_ITER_CALL_EXPR_el(noname6);
      if (noname6->state == -1) {
       goto after_loop5;
      }
      WEIGH_CODE_calc_expr_wei(self, L109);
      L111 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L111))) {
       L110 = TRUE;
      } else {
       L112 = ATTR(self,weight);
       L113 = ATTR(self,max_weight);
       L110 = (L112>L113);
      }
      if (L110) {
       return;
      }
     }
    }
    after_loop5: ;
    L114 = ATTR(self,level1);
    SATTR(self,level1,(INTMINUS(L114,1)));
    WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_BND_ITER_CALL_EXPR) expr1),init1));
    L115 = ATTR(self,level1);
    SATTR(self,level1,(INTPLUS(L115,1)));
    L117 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L117))) {
     L116 = TRUE;
    } else {
     L118 = ATTR(self,weight);
     L119 = ATTR(self,max_weight);
     L116 = (L118>L119);
    }
    if (L116) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_BND_ITER_CALL_EXPR) expr1),bi)); break;
   case AM_EXT_CALL_EXPR_tag:
    L120 = ATTR(self,weight);
    L121 = WEIGH_CODE_rout_call_wei;
    SATTR(self,weight,(INTPLUS(L120,L121)));
    L122 = ATTR(self,weight);
    L123 = ATTR(self,max_weight);
    if ((L122>L123)) {
     return;
    }
    {
     struct AM_EXT_CALL_EXPR_eltb_dA_frame_struct other7_0;
     AM_EXT_CALL_EXPR_eltb_dA_frame 
     noname7 = &other7_0;
     noname7->state = 0;
     while (1) {
      if (noname7->state == 0) {
       L71 = ((AM_EXT_CALL_EXPR) expr1);
       noname7->self = L71;
      }
      L124 = AM_EXT_CALL_EXPR_eltb_dA(noname7);
      if (noname7->state == -1) {
       goto after_loop6;
      }
      WEIGH_CODE_calc_expr_wei(self, L124);
      L126 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
      if ((!(L126))) {
       L125 = TRUE;
      } else {
       L127 = ATTR(self,weight);
       L128 = ATTR(self,max_weight);
       L125 = (L127>L128);
      }
      if (L125) {
       return;
      }
     }
    }
    after_loop6: ; break;
   case AM_HERE_EXPR_tag: break;
   case AM_ANY_EXPR_tag: break;
   case AM_CLUSTER_EXPR_tag: break;
   case AM_WHERE_EXPR_tag: break;
   case AM_NEAR_EXPR_tag: break;
   case AM_FAR_EXPR_tag: break;
   case AM_AT_EXPR_tag:
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_AT_EXPR) expr1),at11));
    L130 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
    if ((!(L130))) {
     L129 = TRUE;
    } else {
     L131 = ATTR(self,weight);
     L132 = ATTR(self,max_weight);
     L129 = (L131>L132);
    }
    if (L129) {
     return;
    }
    WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_AT_EXPR) expr1),e11)); break;
   case AM_ARR_CONST_tag:
   case AM_BOOL_CONST_tag:
   case AM_CHAR_CONST_tag:
   case AM_CONST_tag:
   case AM_FLTDX_CONST_tag:
   case AM_FLTD_CONST_tag:
   case AM_FLTI_CONST_tag:
   case AM_FLTX_CONST_tag:
   case AM_FLT_CONST_tag:
   case AM_INTI_CONST_tag:
   case AM_INT_CONST_tag:
   case AM_STR_CONST_tag:
   case AM_VOID_CONST_tag: break;
   default: ;
    FATAL("No applicable type in typecase");
  }
 }
}


void WEIGH_CODE_calc_stmt_lis(WEIGH_CODE self, dAM_STMT code1) {
 INT L1;
 BOOL L2;
 BOOL L3;
 BOOL L4;
 INT L5;
 INT L6;
 dAM_STMT L7;
 INT L8;
 L1 = ATTR(self,level1);
 SATTR(self,level1,(INTPLUS(L1,1)));
 while (1) {
  L2 = (code1==((dAM_STMT) NULL));
  if ((!(L2))) {
  }
  else {
   goto after_loop;
  }
  WEIGH_CODE_calc_stmt_wei(self, code1);
  L4 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
  if ((!(L4))) {
   L3 = TRUE;
  } else {
   L5 = ATTR(self,weight);
   L6 = ATTR(self,max_weight);
   L3 = (L5>L6);
  }
  if (L3) {
   return;
  }
  L7 = code1;
  if (L7==NULL) {
   FATAL("Dispatch on void in WEIGH_CODE::calc_stmt_list_weight($AM_STMT)");
  }
  code1 = (*dAM_STMT_next_dAM_STMT[TAG(L7)+dAM_STMT_next_dAM_STMT_offset])(L7);
 }
 after_loop: ;
 L8 = ATTR(self,level1);
 SATTR(self,level1,(INTMINUS(L8,1)));
}


void WEIGH_CODE_calc_stmt_wei(WEIGH_CODE self, dAM_STMT stmt) {
 AM_IF_STMT old_eif;
 FLISTdAM_STMT L11;
 FLISTdAM_STMT L21;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 BOOL L7;
 BOOL L8;
 INT L9;
 INT L10;
 INT L12;
 INT L13;
 INT L14;
 INT L15;
 INT L16;
 INT L17;
 INT L18;
 INT L19;
 INT L20;
 INT L22;
 BOOL L23;
 BOOL L24;
 INT L25;
 INT L26;
 BOOL L27;
 BOOL L28;
 INT L29;
 INT L30;
 BOOL L31;
 BOOL L32;
 INT L33;
 INT L34;
 BOOL L35;
 BOOL L36;
 INT L37;
 INT L38;
 INT L39;
 INT L40;
 INT L41;
 INT L42;
 dAM_STMT L43;
 BOOL L44;
 BOOL L45;
 INT L46;
 INT L47;
 dAM_STMT L48;
 BOOL L49;
 BOOL L50;
 INT L51;
 INT L52;
 if (stmt==NULL) {
  SATTR(self,badstmt,stmt);
 } else
 switch (TAG(stmt)) {
  case AM_ASSIGN_STMT_tag:
   L3 = ATTR(self,weight);
   L4 = WEIGH_CODE_assign_weight;
   SATTR(self,weight,(INTPLUS(L3,L4)));
   L5 = ATTR(self,weight);
   L6 = ATTR(self,max_weight);
   if ((L5>L6)) {
    return;
   }
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ASSIGN_STMT) stmt),dest));
   L8 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
   if ((!(L8))) {
    L7 = TRUE;
   } else {
    L9 = ATTR(self,weight);
    L10 = ATTR(self,max_weight);
    L7 = (L9>L10);
   }
   if (L7) {
    return;
   }
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ASSIGN_STMT) stmt),src11)); break;
  case AM_PRE_STMT_tag:
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_PRE_STMT) stmt),test11)); break;
  case AM_POST_STMT_tag:
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_POST_STMT) stmt),test11)); break;
  case AM_INITIAL_STMT_tag:
   WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_INITIAL_STMT) stmt),stmts)); break;
  case AM_ASSERT_STMT_tag:
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_ASSERT_STMT) stmt),test11)); break;
  case AM_INVARIANT_STMT_tag:
   L12 = ATTR(self,weight);
   L13 = WEIGH_CODE_rout_call_wei;
   L14 = (INTPLUS(L12,L13));
   L15 = WEIGH_CODE_if_weight;
   SATTR(self,weight,(INTPLUS(L14,L15)));
   L16 = ATTR(self,weight);
   L17 = ATTR(self,max_weight);
   if ((L16>L17)) {
    return;
   } break;
  case AM_EXPR_STMT_tag:
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_EXPR_STMT) stmt),expr)); break;
  case AM_BREAK_STMT_tag: break;
  case AM_IF_STMT_tag:
   L18 = ATTR(self,weight);
   L19 = WEIGH_CODE_if_weight;
   SATTR(self,weight,(INTPLUS(L18,L19)));
   L20 = ATTR(self,weight);
   L22 = ATTR(self,max_weight);
   if ((L20>L22)) {
    return;
   }
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_IF_STMT) stmt),test11));
   L24 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
   if ((!(L24))) {
    L23 = TRUE;
   } else {
    L25 = ATTR(self,weight);
    L26 = ATTR(self,max_weight);
    L23 = (L25>L26);
   }
   if (L23) {
    return;
   }
   old_eif = ATTR(self,enclosing_if);
   SATTR(self,enclosing_if,((AM_IF_STMT) stmt));
   SATTR(self,true_branch,TRUE);
   WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_IF_STMT) stmt),if_true));
   L28 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
   if ((!(L28))) {
    L27 = TRUE;
   } else {
    L29 = ATTR(self,weight);
    L30 = ATTR(self,max_weight);
    L27 = (L29>L30);
   }
   if (L27) {
    return;
   }
   SATTR(self,true_branch,FALSE);
   WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_IF_STMT) stmt),if_false));
   L32 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
   if ((!(L32))) {
    L31 = TRUE;
   } else {
    L33 = ATTR(self,weight);
    L34 = ATTR(self,max_weight);
    L31 = (L33>L34);
   }
   if (L31) {
    return;
   }
   SATTR(self,enclosing_if,old_eif); break;
  case AM_CASE_STMT_tag:
   WEIGH_CODE_calc_expr_wei(self, ATTR(((AM_CASE_STMT) stmt),test11));
   L36 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
   if ((!(L36))) {
    L35 = TRUE;
   } else {
    L37 = ATTR(self,weight);
    L38 = ATTR(self,max_weight);
    L35 = (L37>L38);
   }
   if (L35) {
    return;
   }
   {
    struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other1_0;
    FLISTdAM_STMT_eltb_dAM_S_frame 
    noname1 = &other1_0;
    noname1->state = 0;
    while (1) {
     L39 = ATTR(self,weight);
     L40 = WEIGH_CODE_if_weight;
     SATTR(self,weight,(INTPLUS(L39,L40)));
     L41 = ATTR(self,weight);
     L42 = ATTR(self,max_weight);
     if ((L41>L42)) {
      return;
     }
     if (noname1->state == 0) {
      L11 = ATTR(((AM_CASE_STMT) stmt),stmts);
      noname1->self = L11;
     }
     L43 = FLISTdAM_STMT_eltb_dAM_S(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     WEIGH_CODE_calc_stmt_lis(self, L43);
     L45 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
     if ((!(L45))) {
      L44 = TRUE;
     } else {
      L46 = ATTR(self,weight);
      L47 = ATTR(self,max_weight);
      L44 = (L46>L47);
     }
     if (L44) {
      return;
     }
    }
   }
   after_loop: ;
   WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_CASE_STMT) stmt),else_stmts)); break;
  case AM_TYPECASE_STMT_tag:
   {
    struct FLISTdAM_STMT_eltb_dAM_S_frame_struct other2_0;
    FLISTdAM_STMT_eltb_dAM_S_frame 
    noname2 = &other2_0;
    noname2->state = 0;
    while (1) {
     if (noname2->state == 0) {
      L21 = ATTR(((AM_TYPECASE_STMT) stmt),stmts);
      noname2->self = L21;
     }
     L48 = FLISTdAM_STMT_eltb_dAM_S(noname2);
     if (noname2->state == -1) {
      goto after_loop1;
     }
     WEIGH_CODE_calc_stmt_lis(self, L48);
     L50 = (ATTR(self,badstmt)==((dAM_STMT) NULL));
     if ((!(L50))) {
      L49 = TRUE;
     } else {
      L51 = ATTR(self,weight);
      L52 = ATTR(self,max_weight);
      L49 = (L51>L52);
     }
     if (L49) {
      return;
     }
    }
   }
   after_loop1: ;
   WEIGH_CODE_calc_stmt_lis(self, ATTR(((AM_TYPECASE_STMT) stmt),else_stmts)); break;
  default: ;
   SATTR(self,badstmt,stmt);
 }
}


void WEIGH_CODE_clear_badstmt(WEIGH_CODE self) {
 SATTR(self,badstmt,((dAM_STMT) NULL));
}


void WEIGH_CODE_uplevel(WEIGH_CODE self) {
 INT L1;
 L1 = ATTR(self,level1);
 SATTR(self,level1,(INTMINUS(L1,1)));
}

/* C for type TUPAM_LOCAL_EXPRAM_LOCAL */




INT TUPAM_LOCAL_EXPRAM_LOCAL1(TUPAM_LOCAL_EXPRAM_LOCAL self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_LOCAL_EXPR lt1;
 AM_LOCAL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_ROUT_DEFAM_ROUT_DE */




INT TUPAM_ROUT_DEFAM_ROUT_DE1(TUPAM_ROUT_DEFAM_ROUT_DE self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_ROUT_DEF lt1;
 AM_ROUT_DEF lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_ROUT_DEFFLISTAM_IT */




INT TUPAM_ROUT_DEFFLISTAM_IT1(TUPAM_ROUT_DEFFLISTAM_IT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_ROUT_DEF lt1;
 FLISTAM_ITER_CALL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPAM_ROUT_DEFFRAME_LAYO */




INT TUPAM_ROUT_DEFFRAME_LAYO1(TUPAM_ROUT_DEFFRAME_LAYO self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AM_ROUT_DEF lt1;
 FRAME_LAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPARRAYdTPARRAYBOOLdTP */




INT TUPARRAYdTPARRAYBOOLdTP_(TUPARRAYdTPARRAYBOOLdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 INT h3 = ((INT) 0);
 ARRAYdTP lt1;
 ARRAYBOOL lt2;
 dTP lt3;
 INT L1;
 INT L2;
 INT L3;
 lt1 = self.t1;
 lt2 = self.t2;
 lt3 = self.t3;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 if (lt3==NULL) {
  h3 = (SYSID(((OB) lt3)));
 } else
 switch (TAG(lt3)) {
  default: ;
   h3 = (SYSID(((OB) lt3)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 L2 = (h1^L1);
 L3 = (((unsigned)h3<<(unsigned)4));
 ret_val = (L2^L3);
 return ret_val;
}

/* C for type TUPARRAYdTPdTP */




TUPARRAYdTPdTP TUPARRAYdTPdTP_create_AR(TUPARRAYdTPdTP self, ARRAYdTP at1, dTP at2) {
 TUPARRAYdTPdTP ret_val = TUPARRAYdTPdTP_zero;
 TUPARRAYdTPdTP L1;
 TUPARRAYdTPdTP L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPAS_CLASS_DEFAS_CLASS_ */




INT TUPAS_CLASS_DEFAS_CLASS_1(TUPAS_CLASS_DEFAS_CLASS_ self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 AS_CLASS_DEF lt1;
 AS_CLASS_DEF lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPBOOLINTIINTBOOL */




INT TUPBOOLINTIINTBOOL_hash_(TUPBOOLINTIINTBOOL self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 INT h3 = ((INT) 0);
 INT h4 = ((INT) 0);
 BOOL lt1 = ((BOOL) 0);
 INTI lt2;
 INT lt3 = ((INT) 0);
 BOOL lt4 = ((BOOL) 0);
 OB L1;
 OB L2;
 INT L3;
 INT L4;
 INT L5;
 INT L6;
 INT L7;
 lt1 = self.t1;
 lt2 = self.t2;
 lt3 = self.t3;
 lt4 = self.t4;
 L1 = (OB)((BOOL_boxed) rt_alloc_atomic(sizeof(struct BOOL_boxed_struct), BOOL_tag));
 ((BOOL_boxed) L1)->value_part = lt1;
 h1 = (SYSID(L1));
 h2 = (SYSID(((OB) lt2)));
 h3 = INT_hash_INT(lt3);
 L2 = (OB)((BOOL_boxed) rt_alloc_atomic(sizeof(struct BOOL_boxed_struct), BOOL_tag));
 ((BOOL_boxed) L2)->value_part = lt4;
 h4 = (SYSID(L2));
 L3 = (((unsigned)h2<<(unsigned)2));
 L4 = (h1^L3);
 L5 = (((unsigned)h3<<(unsigned)4));
 L6 = (L4^L5);
 L7 = (((unsigned)h4<<(unsigned)6));
 ret_val = (L6^L7);
 return ret_val;
}

/* C for type TUPCHARCHAR */




INT TUPCHARCHAR_hash_INT(TUPCHARCHAR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 CHAR lt1 = ((CHAR) 0);
 CHAR lt2 = ((CHAR) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = CHAR_hash_INT(lt1);
 h2 = CHAR_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPCODE_FILECODE_FILE */




INT TUPCODE_FILECODE_FILE_ha(TUPCODE_FILECODE_FILE self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 CODE_FILE lt1;
 CODE_FILE lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPFLISTdAM_CONSTFLISTdA */




INT TUPFLISTdAM_CONSTFLISTdA1(TUPFLISTdAM_CONSTFLISTdA self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 FLISTdAM_CONST lt1;
 FLISTdAM_CONST lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPFLTDFLTD */




INT TUPFLTDFLTD_hash_INT(TUPFLTDFLTD self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 FLTD lt1 = ((FLTD) 0);
 FLTD lt2 = ((FLTD) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = FLTD_hash_INT(lt1);
 h2 = FLTD_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPFLTFLT */




INT TUPFLTFLT_hash_INT(TUPFLTFLT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 FLT lt1 = ((FLT) 0);
 FLT lt2 = ((FLT) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = FLT_hash_INT(lt1);
 h2 = FLT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPFSTRFSTR */




INT TUPFSTRFSTR_hash_INT(TUPFSTRFSTR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 FSTR lt1;
 FSTR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = FSTR_hash_INT(lt1);
 h2 = FSTR_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPIDENTAM_GLOBAL_EXPR */




INT TUPIDENTAM_GLOBAL_EXPR_h(TUPIDENTAM_GLOBAL_EXPR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IDENT lt1 = IDENT_zero;
 AM_GLOBAL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = IDENT_hash_INT(lt1);
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPIDENTARRAYdTP */




TUPIDENTARRAYdTP TUPIDENTARRAYdTP_create_(TUPIDENTARRAYdTP self, IDENT at1, ARRAYdTP at2) {
 TUPIDENTARRAYdTP ret_val = TUPIDENTARRAYdTP_zero;
 TUPIDENTARRAYdTP L1;
 TUPIDENTARRAYdTP L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPIDENTIDENT */




TUPIDENTIDENT TUPIDENTIDENT_create_IDE(TUPIDENTIDENT self, IDENT at1, IDENT at2) {
 TUPIDENTIDENT ret_val = TUPIDENTIDENT_zero;
 TUPIDENTIDENT L1;
 TUPIDENTIDENT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPIDENTINT */




TUPIDENTINT TUPIDENTINT_create_IDENT(TUPIDENTINT self, IDENT at1, INT at2) {
 TUPIDENTINT ret_val = TUPIDENTINT_zero;
 TUPIDENTINT L1;
 TUPIDENTINT L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPIDENTdTP */




INT TUPIDENTdTP_hash_INT(TUPIDENTdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IDENT lt1 = IDENT_zero;
 dTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = IDENT_hash_INT(lt1);
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPIFCIFC */




INT TUPIFCIFC_hash_INT(TUPIFCIFC self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IFC lt1;
 IFC lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPIMPL_INCLUDEIMPL_INCL */




INT TUPIMPL_INCLUDEIMPL_INCL1(TUPIMPL_INCLUDEIMPL_INCL self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 IMPL_INCLUDE lt1;
 IMPL_INCLUDE lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPINTIINTIINTI */




INT TUPINTIINTIINTI_hash_INT(TUPINTIINTIINTI self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 INT h3 = ((INT) 0);
 INTI lt1;
 INTI lt2;
 INTI lt3;
 INT L1;
 INT L2;
 INT L3;
 lt1 = self.t1;
 lt2 = self.t2;
 lt3 = self.t3;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 h3 = (SYSID(((OB) lt3)));
 L1 = (((unsigned)h2<<(unsigned)2));
 L2 = (h1^L1);
 L3 = (((unsigned)h3<<(unsigned)4));
 ret_val = (L2^L3);
 return ret_val;
}

/* C for type TUPINTINT */




INT TUPINTINT_hash_INT(TUPINTINT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 INT lt1 = ((INT) 0);
 INT lt2 = ((INT) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = INT_hash_INT(lt1);
 h2 = INT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPINTINTINT */




INT TUPINTINTINT_hash_INT(TUPINTINTINT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 INT h3 = ((INT) 0);
 INT lt1 = ((INT) 0);
 INT lt2 = ((INT) 0);
 INT lt3 = ((INT) 0);
 INT L1;
 INT L2;
 INT L3;
 lt1 = self.t1;
 lt2 = self.t2;
 lt3 = self.t3;
 h1 = INT_hash_INT(lt1);
 h2 = INT_hash_INT(lt2);
 h3 = INT_hash_INT(lt3);
 L1 = (((unsigned)h2<<(unsigned)2));
 L2 = (h1^L1);
 L3 = (((unsigned)h3<<(unsigned)4));
 ret_val = (L2^L3);
 return ret_val;
}

/* C for type TUPSFILE_IDSFILE_ID */




INT TUPSFILE_IDSFILE_ID_hash(TUPSFILE_IDSFILE_ID self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SFILE_ID lt1 = SFILE_ID_zero;
 SFILE_ID lt2 = SFILE_ID_zero;
 OB L1;
 OB L2;
 INT L3;
 lt1 = self.t1;
 lt2 = self.t2;
 L1 = (OB)((SFILE_ID_boxed) rt_alloc_atomic(sizeof(struct SFILE_ID_boxed_struct), SFILE_ID_tag));
 ((SFILE_ID_boxed) L1)->value_part = lt1;
 h1 = (SYSID(L1));
 L2 = (OB)((SFILE_ID_boxed) rt_alloc_atomic(sizeof(struct SFILE_ID_boxed_struct), SFILE_ID_tag));
 ((SFILE_ID_boxed) L2)->value_part = lt2;
 h2 = (SYSID(L2));
 L3 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L3);
 return ret_val;
}

/* C for type TUPSIGABSTRACT_FRAME_LAY */




INT TUPSIGABSTRACT_FRAME_LAY1(TUPSIGABSTRACT_FRAME_LAY self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SIG lt1;
 ABSTRACT_FRAME_LAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSIGAM_ROUT_DEF */




INT TUPSIGAM_ROUT_DEF_hash_I(TUPSIGAM_ROUT_DEF self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SIG lt1;
 AM_ROUT_DEF lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSIGARG_LAYOUT */




INT TUPSIGARG_LAYOUT_hash_IN(TUPSIGARG_LAYOUT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SIG lt1;
 ARG_LAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSIGSIG */




INT TUPSIGSIG_hash_INT(TUPSIGSIG self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SIG lt1;
 SIG lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSIGSTR */




INT TUPSIGSTR_hash_INT(TUPSIGSTR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 SIG lt1;
 STR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = STR_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSTRFSETSTR */




TUPSTRFSETSTR TUPSTRFSETSTR_create_STR(TUPSTRFSETSTR self, STR at1, FSETSTR at2) {
 TUPSTRFSETSTR ret_val = TUPSTRFSETSTR_zero;
 TUPSTRFSETSTR L1;
 TUPSTRFSETSTR L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPSTRINT */




INT TUPSTRINT_hash_INT(TUPSTRINT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 STR lt1;
 INT lt2 = ((INT) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = STR_hash_INT(lt1);
 h2 = INT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSTRITER_INLINE */




INT TUPSTRITER_INLINE_hash_I(TUPSTRITER_INLINE self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 STR lt1;
 ITER_INLINE lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = STR_hash_INT(lt1);
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPSTRSIG */




TUPSTRSIG TUPSTRSIG_create_STR_SIG(TUPSTRSIG self, STR at1, SIG at2) {
 TUPSTRSIG ret_val = TUPSTRSIG_zero;
 TUPSTRSIG L1;
 TUPSTRSIG L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPSTRSTR */




TUPSTRSTR TUPSTRSTR_create_STR_STR(TUPSTRSTR self, STR at1, STR at2) {
 TUPSTRSTR ret_val = TUPSTRSTR_zero;
 TUPSTRSTR L1;
 TUPSTRSTR L2;
 L1 = self;
 L1.t1 = at1;
 L2 = L1;
 L2.t2 = at2;
 ret_val = L2;
 return ret_val;
}

/* C for type TUPTP_CLASSFSETTP_CLASS */




INT TUPTP_CLASSFSETTP_CLASS_(TUPTP_CLASSFSETTP_CLASS self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 TP_CLASS lt1;
 FSETTP_CLASS lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPTP_CLASSFSETdTP */




INT TUPTP_CLASSFSETdTP_hash_(TUPTP_CLASSFSETdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 TP_CLASS lt1;
 FSETdTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 h1 = (SYSID(((OB) lt1)));
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdAM_CONSTdAM_CONST */




INT TUPdAM_CONSTdAM_CONST_ha(TUPdAM_CONSTdAM_CONST self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dAM_CONST lt1;
 dAM_CONST lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdAM_EXPRdAM_EXPR */




INT TUPdAM_EXPRdAM_EXPR_hash(TUPdAM_EXPRdAM_EXPR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dAM_EXPR lt1;
 dAM_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdAM_EXPRdTP */




INT TUPdAM_EXPRdTP_hash_INT(TUPdAM_EXPRdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dAM_EXPR lt1;
 dTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdAM_STMTdAM_STMT */




INT TUPdAM_STMTdAM_STMT_hash(TUPdAM_STMTdAM_STMT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dAM_STMT lt1;
 dAM_STMT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdLAYOUTdLAYOUT */




INT TUPdLAYOUTdLAYOUT_hash_I(TUPdLAYOUTdLAYOUT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dLAYOUT lt1;
 dLAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdOBNAMESPACE */




INT TUPdOBNAMESPACE_hash_INT(TUPdOBNAMESPACE self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 OB lt1;
 NAMESPACE lt2;
 dHASH L1;
 INT L2;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(lt1));
 } else
 switch (TAG(lt1)) {
  case CHAR_tag:
  case FLT_tag:
  case FLTD_tag:
  case FSTR_tag:
  case IDENT_tag:
  case INT_tag:
  case STR_tag:
  case TUPdAM_CONSTdAM_CONST_tag:
  case TUPdAM_EXPRdAM_EXPR_tag:
  case TUPdAM_EXPRdTP_tag:
  case TUPdAM_STMTdAM_STMT_tag:
  case TUPdLAYOUTdLAYOUT_tag:
  case TUPdOBNAMESPACE_tag:
  case TUPdOBSTR_tag:
  case TUPdTPdLAYOUT_tag:
  case TUPdTPdTP_tag:
  case TUPdTPCODE_FILE_tag:
  case TUPdTPFMAPIDENTAM_GLOBAL_tag:
  case TUPdTPIFC_tag:
  case TUPdTPIMPL_tag:
  case TUPdTPINT_tag:
  case TUPAM_BND_CREATE_EXPRAM__tag:
  case TUPAM_BND_CREATE_EXPRBOU_tag:
  case TUPAM_BND_ITER_CALL_EXPR_tag:
  case TUPAM_GLOBAL_EXPRAM_GLOB_tag:
  case TUPAM_ITER_CALL_EXPRAM_I_tag:
  case TUPAM_LOCAL_EXPRAM_LOCAL_tag:
  case TUPAM_ROUT_DEFAM_ROUT_DE_tag:
  case TUPAM_ROUT_DEFFLISTAM_IT_tag:
  case TUPAM_ROUT_DEFFRAME_LAYO_tag:
  case TUPARRAYdTPdTP_tag:
  case TUPARRAYdTPARRAYBOOLdTP_tag:
  case TUPAS_CLASS_DEFAS_CLASS__tag:
  case TUPBOOLINTIINTBOOL_tag:
  case TUPCHARCHAR_tag:
  case TUPCODE_FILECODE_FILE_tag:
  case TUPFLISTdAM_CONSTFLISTdA_tag:
  case TUPFLTFLT_tag:
  case TUPFLTDFLTD_tag:
  case TUPFSTRFSTR_tag:
  case TUPIDENTdTP_tag:
  case TUPIDENTAM_GLOBAL_EXPR_tag:
  case TUPIDENTARRAYdTP_tag:
  case TUPIDENTIDENT_tag:
  case TUPIDENTINT_tag:
  case TUPIFCIFC_tag:
  case TUPIMPL_INCLUDEIMPL_INCL_tag:
  case TUPINTINTINT_tag:
  case TUPINTINT_tag:
  case TUPINTIINTIINTI_tag:
  case TUPSFILE_IDSFILE_ID_tag:
  case TUPSIGABSTRACT_FRAME_LAY_tag:
  case TUPSIGAM_ROUT_DEF_tag:
  case TUPSIGARG_LAYOUT_tag:
  case TUPSIGSIG_tag:
  case TUPSIGSTR_tag:
  case TUPSTRFSETSTR_tag:
  case TUPSTRINT_tag:
  case TUPSTRITER_INLINE_tag:
  case TUPSTRSIG_tag:
  case TUPSTRSTR_tag:
  case TUPTP_CLASSFSETdTP_tag:
  case TUPTP_CLASSFSETTP_CLASS_tag:
   L1 = ((dHASH) lt1);
   if (L1==NULL) {
    FATAL("Dispatch on void in TUP{$OB,NAMESPACE}::hash:INT");
   }
   h1 = (*dHASH_hash_INT[TAG(L1)+dHASH_hash_INT_offset])(L1); break;
  default: ;
   h1 = (SYSID(lt1));
 }
 h2 = (SYSID(((OB) lt2)));
 L2 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L2);
 return ret_val;
}

/* C for type TUPdOBSTR */




INT TUPdOBSTR_hash_INT(TUPdOBSTR self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 OB lt1;
 STR lt2;
 dHASH L1;
 INT L2;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(lt1));
 } else
 switch (TAG(lt1)) {
  case CHAR_tag:
  case FLT_tag:
  case FLTD_tag:
  case FSTR_tag:
  case IDENT_tag:
  case INT_tag:
  case STR_tag:
  case TUPdAM_CONSTdAM_CONST_tag:
  case TUPdAM_EXPRdAM_EXPR_tag:
  case TUPdAM_EXPRdTP_tag:
  case TUPdAM_STMTdAM_STMT_tag:
  case TUPdLAYOUTdLAYOUT_tag:
  case TUPdOBNAMESPACE_tag:
  case TUPdOBSTR_tag:
  case TUPdTPdLAYOUT_tag:
  case TUPdTPdTP_tag:
  case TUPdTPCODE_FILE_tag:
  case TUPdTPFMAPIDENTAM_GLOBAL_tag:
  case TUPdTPIFC_tag:
  case TUPdTPIMPL_tag:
  case TUPdTPINT_tag:
  case TUPAM_BND_CREATE_EXPRAM__tag:
  case TUPAM_BND_CREATE_EXPRBOU_tag:
  case TUPAM_BND_ITER_CALL_EXPR_tag:
  case TUPAM_GLOBAL_EXPRAM_GLOB_tag:
  case TUPAM_ITER_CALL_EXPRAM_I_tag:
  case TUPAM_LOCAL_EXPRAM_LOCAL_tag:
  case TUPAM_ROUT_DEFAM_ROUT_DE_tag:
  case TUPAM_ROUT_DEFFLISTAM_IT_tag:
  case TUPAM_ROUT_DEFFRAME_LAYO_tag:
  case TUPARRAYdTPdTP_tag:
  case TUPARRAYdTPARRAYBOOLdTP_tag:
  case TUPAS_CLASS_DEFAS_CLASS__tag:
  case TUPBOOLINTIINTBOOL_tag:
  case TUPCHARCHAR_tag:
  case TUPCODE_FILECODE_FILE_tag:
  case TUPFLISTdAM_CONSTFLISTdA_tag:
  case TUPFLTFLT_tag:
  case TUPFLTDFLTD_tag:
  case TUPFSTRFSTR_tag:
  case TUPIDENTdTP_tag:
  case TUPIDENTAM_GLOBAL_EXPR_tag:
  case TUPIDENTARRAYdTP_tag:
  case TUPIDENTIDENT_tag:
  case TUPIDENTINT_tag:
  case TUPIFCIFC_tag:
  case TUPIMPL_INCLUDEIMPL_INCL_tag:
  case TUPINTINTINT_tag:
  case TUPINTINT_tag:
  case TUPINTIINTIINTI_tag:
  case TUPSFILE_IDSFILE_ID_tag:
  case TUPSIGABSTRACT_FRAME_LAY_tag:
  case TUPSIGAM_ROUT_DEF_tag:
  case TUPSIGARG_LAYOUT_tag:
  case TUPSIGSIG_tag:
  case TUPSIGSTR_tag:
  case TUPSTRFSETSTR_tag:
  case TUPSTRINT_tag:
  case TUPSTRITER_INLINE_tag:
  case TUPSTRSIG_tag:
  case TUPSTRSTR_tag:
  case TUPTP_CLASSFSETdTP_tag:
  case TUPTP_CLASSFSETTP_CLASS_tag:
   L1 = ((dHASH) lt1);
   if (L1==NULL) {
    FATAL("Dispatch on void in TUP{$OB,STR}::hash:INT");
   }
   h1 = (*dHASH_hash_INT[TAG(L1)+dHASH_hash_INT_offset])(L1); break;
  default: ;
   h1 = (SYSID(lt1));
 }
 h2 = STR_hash_INT(lt2);
 L2 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L2);
 return ret_val;
}

/* C for type TUPdTPCODE_FILE */




INT TUPdTPCODE_FILE_hash_INT(TUPdTPCODE_FILE self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 CODE_FILE lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPFMAPIDENTAM_GLOBAL */




INT TUPdTPFMAPIDENTAM_GLOBAL1(TUPdTPFMAPIDENTAM_GLOBAL self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 FMAPIDENTAM_GLOBAL_EXPR lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPIFC */




INT TUPdTPIFC_hash_INT(TUPdTPIFC self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 IFC lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPIMPL */




INT TUPdTPIMPL_hash_INT(TUPdTPIMPL self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 IMPL lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 h2 = (SYSID(((OB) lt2)));
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPINT */




INT TUPdTPINT_hash_INT(TUPdTPINT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 INT lt2 = ((INT) 0);
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 h2 = INT_hash_INT(lt2);
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPdLAYOUT */




INT TUPdTPdLAYOUT_hash_INT(TUPdTPdLAYOUT self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 dLAYOUT lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type TUPdTPdTP */




INT TUPdTPdTP_hash_INT(TUPdTPdTP self) {
 INT ret_val = ((INT) 0);
 INT h1 = ((INT) 0);
 INT h2 = ((INT) 0);
 dTP lt1;
 dTP lt2;
 INT L1;
 lt1 = self.t1;
 lt2 = self.t2;
 if (lt1==NULL) {
  h1 = (SYSID(((OB) lt1)));
 } else
 switch (TAG(lt1)) {
  default: ;
   h1 = (SYSID(((OB) lt1)));
 }
 if (lt2==NULL) {
  h2 = (SYSID(((OB) lt2)));
 } else
 switch (TAG(lt2)) {
  default: ;
   h2 = (SYSID(((OB) lt2)));
 }
 L1 = (((unsigned)h2<<(unsigned)2));
 ret_val = (h1^L1);
 return ret_val;
}

/* C for type UNIX */




void UNIX_exit_INT(UNIX self, INT code1) {
 exit(code1);
}

/* C for type VALUE_CLASS_LAYOUT */




void VALUE_CLASS_LAYOUT_make_(VALUE_CLASS_LAYOUT self) {
 FLISTdLAYOUT res;
 FMAPIDENTdTP L11;
 dTP tp;
 dTP L2;
 dTP L3;
 BOOL L4;
 BOOL L5;
 dTP L6;
 res = FLISTdLAYOUT_create_FLIS(((FLISTdLAYOUT) NULL));
 {
  struct FMAPIDENTdTP_targetsb_dT_frame_struct other1_0;
  FMAPIDENTdTP_targetsb_dT_frame 
  noname1 = &other1_0;
  noname1->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(ATTR(self,l1),at11);
    noname1->self = L11;
   }
   L2 = FMAPIDENTdTP_targetsb_dT(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   tp = L2;
   L3 = tp;
   if (L3==NULL) {
    FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::make_dependencies");
   }
   if ((*dTP_is_value_BOOL[TAG(L3)+dTP_is_value_BOOL_offset])(L3)) {
    res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), tp));
   }
  }
 }
 after_loop: ;
 L5 = (ATTR(ATTR(self,l1),arr1)==((dTP) NULL));
 if ((!(L5))) {
  L6 = ATTR(ATTR(self,l1),arr1);
  if (L6==NULL) {
   FATAL("Dispatch on void in VALUE_CLASS_LAYOUT::make_dependencies");
  }
  L4 = (*dTP_is_value_BOOL[TAG(L6)+dTP_is_value_BOOL_offset])(L6);
 } else {
  L4 = FALSE;
 }
 if (L4) {
  res = FLISTdLAYOUT_push_dLAYOU(res, LAYOUT_TBL_layout_dTP_dL(((LAYOUT_TBL) NULL), ATTR(ATTR(self,l1),arr1)));
 }
 SATTR(self,dependencies,res);
}

/* C for type WEIGH_CODE */




WEIGH_CODE WEIGH_CODE_create_INT_WE(WEIGH_CODE self, INT threshold1) {
 WEIGH_CODE ret_val;
 WEIGH_CODE r;
 WEIGH_CODE L1;
 L1 = ((WEIGH_CODE) rt_alloc(sizeof(struct WEIGH_CODE_struct), WEIGH_CODE_tag));
 r = L1;
 SATTR(r,max_weight,threshold1);
 SATTR(r,weight,0);
 SATTR(r,level1,0);
 ret_val = r;
 return ret_val;
}

/* C for type XFORM_CODE */




XFORM_CODE XFORM_CODE_create_FMAPAM(XFORM_CODE self, FMAPAM_LOCAL_EXPRAM_LOCA subst) {
 XFORM_CODE ret_val;
 XFORM_CODE xc1;
 XFORM_CODE L1;
 L1 = ((XFORM_CODE) rt_alloc(sizeof(struct XFORM_CODE_struct), XFORM_CODE_tag));
 xc1 = L1;
 SATTR(xc1,subst1,subst);
 ret_val = xc1;
 return ret_val;
}
