#include "sather.h"

/* Layouts */

typedef struct ABSTRACT_FRAME_LAYOUT_struct {/* layout for ABSTRACT_FRAME_LAYOUT */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct SIG_struct *sig11;
 STR str1;
 } *ABSTRACT_FRAME_LAYOUT;

typedef struct ABSTRACT_LAYOUT_struct {/* layout for ABSTRACT_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct PROG_struct *prog1;
 STR str1;
 } *ABSTRACT_LAYOUT;

typedef struct ARG_LAYOUT_struct {/* layout for ARG_LAYOUT */
 OB_HEADER header;
 struct SIG_struct *sig11;
 STR str1;
 } *ARG_LAYOUT;

typedef struct ARRAYdAM_EXPR_struct {/* layout for ARRAY{$AM_EXPR} */
 OB_HEADER header;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *ARRAYdAM_EXPR;

typedef struct ARRAYdCALL_TP_struct {/* layout for ARRAY{$CALL_TP} */
 OB_HEADER header;
 INT asize;
 struct dCALL_TP_struct *arr_part[1];
 } *ARRAYdCALL_TP;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;

typedef struct ARRAYARRAYSTR_struct {/* layout for ARRAY{ARRAY{STR}} */
 OB_HEADER header;
 INT asize;
 struct ARRAYSTR_struct *arr_part[1];
 } *ARRAYARRAYSTR;

typedef struct ARRAYFSTR_struct {/* layout for ARRAY{FSTR} */
 OB_HEADER header;
 INT asize;
 struct FSTR_struct *arr_part[1];
 } *ARRAYFSTR;

typedef struct ARRAYSTR_struct {/* layout for ARRAY{STR} */
 OB_HEADER header;
 INT asize;
 STR arr_part[1];
 } *ARRAYSTR;

typedef struct BOUND_OBJECT_LAYOUT_struct {/* layout for BOUND_OBJECT_LAYOUT */
 OB_HEADER header;
 struct AM_BND_CREATE_EXPR_struct *e11;
 STR str1;
 } *BOUND_OBJECT_LAYOUT;

typedef struct BOUND_TYPE_LAYOUT_struct {/* layout for BOUND_TYPE_LAYOUT */
 OB_HEADER header;
 STR str1;
 struct TP_ROUT_struct *tp1;
 } *BOUND_TYPE_LAYOUT;

typedef struct BUILD_TYPE_GRAPH_struct {/* layout for BUILD_TYPE_GRAPH */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *BUILD_TYPE_GRAPH;

typedef struct BUILTIN_LAYOUT_struct {/* layout for BUILTIN_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *BUILTIN_LAYOUT;

typedef struct CALL_TP_ARRAY_struct {/* layout for CALL_TP_ARRAY */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_ARRAY;

typedef struct CALL_TP_CREATE_struct {/* layout for CALL_TP_CREATE */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_CREATE;

typedef struct CALL_TP_UNDERSCORE_struct {/* layout for CALL_TP_UNDERSCORE */
 OB_HEADER header;
 struct dTP_struct *tp1;
 } *CALL_TP_UNDERSCORE;

typedef struct CALL_TP_VOID_struct {/* layout for CALL_TP_VOID */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_VOID;

typedef struct CHANGE_VARS_struct {/* layout for CHANGE_VARS */
 OB_HEADER header;
 struct dAM_STMT_struct *init_hot1;
 struct dAM_STMT_struct *init_nonhot1;
 struct dAM_STMT_struct *init_parms1;
 struct dAM_STMT_struct *init_vars1;
 struct ARRAYINT_struct *pind_hot;
 struct ARRAYINT_struct *pind_nonhot;
 struct FLISTAM_LOCAL_EXPR_struct *new_vars;
 struct FLISTAM_LOCAL_EXPR_struct *saved_vars;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *new_subst;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *saved_subst;
 } *CHANGE_VARS;

typedef struct CHECK_AM_struct {/* layout for CHECK_AM */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *CHECK_AM;

typedef struct CHECK_IFC_CONFORMANCE_struct {/* layout for CHECK_IFC_CONFORMANCE */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *CHECK_IFC_CONFORMANCE;

typedef struct CLASS_LAYOUT_struct {/* layout for CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *CLASS_LAYOUT;

typedef struct CODE_FILE_ARRAY_struct {/* layout for CODE_FILE_ARRAY */
 OB_HEADER header;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *CODE_FILE_ARRAY;

typedef struct CS_struct {/* layout for CS */
 OB_HEADER header;
 BOOL only_parse;
 BOOL only_reachable;
 } *CS;

typedef struct ELT_struct {/* layout for ELT */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *as1;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 BOOL is_private1;
 } *ELT;

typedef struct EXTERNAL_LAYOUT_struct {/* layout for EXTERNAL_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *EXTERNAL_LAYOUT;

typedef struct FILE1_struct {/* layout for FILE */
 OB_HEADER header;
 EXT_OB fp;
 } *FILE1;

typedef struct FIND_TYPES_struct {/* layout for FIND_TYPES */
 OB_HEADER header;
 struct FSETdTP_struct *tp_todo;
 struct FSETIDENT_struct *err_names;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *con1;
 } *FIND_TYPES;

typedef struct FLTI_struct {/* layout for FLTI */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *FLTI;

typedef struct FRAME_LAYOUT_struct {/* layout for FRAME_LAYOUT */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *f1;
 struct PROG_struct *prog1;
 STR str1;
 } *FRAME_LAYOUT;

typedef struct GENERATE_AM_struct {/* layout for GENERATE_AM */
 OB_HEADER header;
 struct FLISTSIG_struct *sig_list;
 struct FSETSIG_struct *sig_inprocout;
 struct FSETSIG_struct *sig_recursive;
 struct GLOBAL_TBL_struct *global_tbl;
 struct PROG_struct *prog1;
 } *GENERATE_AM;

typedef struct GET_MAIN_SIG_struct {/* layout for GET_MAIN_SIG */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct SIG_struct *main_sig;
 } *GET_MAIN_SIG;

typedef struct GLOBAL_TBL_struct {/* layout for GLOBAL_TBL */
 OB_HEADER header;
 struct FLISTAM_GLOBAL_EXPR_struct *top_sort;
 struct FMAPdTPFMAPIDENTAM_GLOBA_struct *tbl;
 struct PROG_struct *prog1;
 } *GLOBAL_TBL;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IFC_ABS_CREATE_struct {/* layout for IFC_ABS_CREATE */
 OB_HEADER header;
 struct AS_CLASS_DEF_struct *tr;
 struct FLISTIFC_struct *supers;
 struct SIG_TBL_struct *class_sigs;
 struct TP_CLASS_struct *tp1;
 struct TP_CONTEXT_struct *con1;
 } *IFC_ABS_CREATE;

typedef struct IFC_TBL_struct {/* layout for IFC_TBL */
 OB_HEADER header;
 struct FMAPdTPIFC_struct *tbl;
 struct FSETTUPIDENTINT_struct *abs_cur;
 struct PROG_struct *prog1;
 } *IFC_TBL;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_CREATE_struct {/* layout for IMPL_CREATE */
 OB_HEADER header;
 struct AS_CLASS_DEF_struct *as1;
 struct ELT_TBL_struct *class_elts;
 struct FLISTIMPL_INCLUDE_struct *incs;
 struct TP_CLASS_struct *tp1;
 struct TP_CONTEXT_struct *con1;
 BOOL is_external;
 } *IMPL_CREATE;

typedef struct IMPL_INCLUDE_struct {/* layout for IMPL_INCLUDE */
 OB_HEADER header;
 struct AS_INCLUDE_CLAUSE_struct *as1;
 struct ELT_TBL_struct *elt_tbl;
 struct FSETAS_FEAT_MOD_struct *used_mods;
 struct IMPL_struct *impl;
 struct TP_CLASS_struct *itp;
 struct TP_CLASS_struct *tp1;
 } *IMPL_INCLUDE;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;

typedef struct IMPORT_EXPORT_TBL_struct {/* layout for IMPORT_EXPORT_TBL */
 OB_HEADER header;
 struct FSETTUPIDENTIDENT_struct *exports;
 struct FSETTUPIDENTIDENT_struct *imports;
 struct PROG_struct *prog1;
 } *IMPORT_EXPORT_TBL;

typedef struct INLINE_ATTR_READ_struct {/* layout for INLINE_ATTR_READ */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_READ;

typedef struct INLINE_ATTR_WRITE_struct {/* layout for INLINE_ATTR_WRITE */
 OB_HEADER header;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_ATTR_WRITE;

typedef struct INLINE_GLOBAL_READ_struct {/* layout for INLINE_GLOBAL_READ */
 OB_HEADER header;
 struct AM_GLOBAL_EXPR_struct *age11;
 struct SIG_struct *sig11;
 } *INLINE_GLOBAL_READ;

typedef struct INLINE_INT_FOLD_struct {/* layout for INLINE_INT_FOLD */
 OB_HEADER header;
 struct SIG_struct *sig1;
 } *INLINE_INT_FOLD;

typedef struct INLINE_ITER_struct {/* layout for INLINE_ITER */
 OB_HEADER header;
 struct dAM_EXPR_struct *yield_cond;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *BEFLOOP_code;
 struct dAM_STMT_struct *IINIT_code;
 struct dAM_STMT_struct *ITERM_code;
 struct dAM_STMT_struct *WNOY_code;
 struct dAM_STMT_struct *WYAFT_code;
 struct dAM_STMT_struct *WYBEF_code;
 struct CHANGE_VARS_struct *change_vars;
 struct FLISTAM_LOCAL_EXPR_struct *loop_firsts;
 struct SIG_struct *signature;
 BOOL flat_yield;
 } *INLINE_ITER;

typedef struct INLINE_ROUT_struct {/* layout for INLINE_ROUT */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_STMT_struct *code11;
 struct CHANGE_VARS_struct *change_vars;
 struct SIG_struct *signature;
 } *INLINE_ROUT;

typedef struct INLINE_VATTR_WRITE_struct {/* layout for INLINE_VATTR_WRITE */
 OB_HEADER header;
 struct IDENT_struct at11;
 struct SIG_struct *sig11;
 } *INLINE_VATTR_WRITE;

typedef struct INTI_struct {/* layout for INTI */
 OB_HEADER header;
 INT len1;
 INT asize;
 INT arr_part[1];
 } *INTI;

typedef struct ITER_INLINE_struct {/* layout for ITER_INLINE */
 OB_HEADER header;
 STR after1;
 STR at_decs;
 STR before1;
 STR when_first_seen;
 } *ITER_INLINE;

typedef struct LAYOUT_ARRAY_struct {/* layout for LAYOUT_ARRAY */
 OB_HEADER header;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *LAYOUT_ARRAY;

typedef struct MANGLE_struct {/* layout for MANGLE */
 OB_HEADER header;
 struct FMAPdOBNAMESPACE_struct *namespaces;
 struct FSETSTR_struct *forbidden;
 struct FSETSTR_struct *used_by_local;
 struct NAMESPACE_struct *global_space;
 struct PROG_struct *prog1;
 } *MANGLE;

typedef struct MS_RANDOM_GEN_struct {/* layout for MS_RANDOM_GEN */
 OB_HEADER header;
 INT seed;
 } *MS_RANDOM_GEN;

typedef struct NAMESPACE_struct {/* layout for NAMESPACE */
 OB_HEADER header;
 struct FMAPSTRINT_struct *uniques;
 struct FSETSTR_struct *set;
 INT counter1;
 struct NAMEMAP_struct *map;
 } *NAMESPACE;

typedef struct NULL_OPTIMIZE_struct {/* layout for NULL_OPTIMIZE */
 OB_HEADER header;
 struct PROG_struct *prog1;
 } *NULL_OPTIMIZE;

typedef struct PARSE_struct {/* layout for PARSE */
 OB_HEADER header;
 struct FMAPSTRSTR_struct *has;
 struct FSETSTR_struct *known_files;
 struct FSETSTR_struct *parsed;
 struct PROG_struct *prog1;
 } *PARSE;

typedef struct PROG_AS_TBL_struct {/* layout for PROG_AS_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_CLASS_DEF_struct *arr_part[1];
 } *PROG_AS_TBL;

typedef struct RAT_struct {/* layout for RAT */
 struct INTI_struct *u;
 struct INTI_struct *v;
 } RAT;
static RAT RAT_zero;

typedef struct RAT_boxed_struct {
 OB_HEADER header;
 RAT value_part;
 } *RAT_boxed;

typedef struct SCANNER_struct {/* layout for SCANNER */
 OB_HEADER header;
 struct FSTR_struct *buf11;
 struct IDENT_struct lex_value;
 INT value_type;
 struct PROG_struct *prog1;
 struct RAT_struct num_value;
 CHAR char_value;
 CHAR last_char;
 CHAR next;
 BOOL backed_up;
 BOOL pSather1;
 } *SCANNER;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;

typedef struct SIG_TBL_struct {/* layout for SIG_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *SIG_TBL;

typedef struct STR_CURSOR_struct {/* layout for STR_CURSOR */
 OB_HEADER header;
 INT error1;
 INT index1;
 INT line_no;
 STR buf11;
 CHAR comment_char1;
 CHAR comment_char2;
 BOOL is_done;
 } *STR_CURSOR;

typedef struct SYS_struct {/* layout for SYS */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *SYS;

typedef struct SYSTEM_LEX_struct {/* layout for SYSTEM_LEX */
 OB_HEADER header;
 struct FSTR_struct *buf11;
 INT lex_state;
 INT pos1;
 STR name1;
 } *SYSTEM_LEX;

typedef struct TOKEN_struct {/* layout for TOKEN */
 INT val11;
 } TOKEN;
static TOKEN TOKEN_zero;

typedef struct TOKEN_boxed_struct {
 OB_HEADER header;
 TOKEN value_part;
 } *TOKEN_boxed;

typedef struct TP_ARRAY_struct {/* layout for TP_ARRAY */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *TP_ARRAY;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_CLASS_TBL_struct {/* layout for TP_CLASS_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_CLASS_struct *arr_part[1];
 } *TP_CLASS_TBL;

typedef struct TP_CONTEXT_struct {/* layout for TP_CONTEXT */
 OB_HEADER header;
 struct ARRAYdTP_struct *ptypes1;
 struct ARRAYIDENT_struct *pnames1;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *same11;
 BOOL is_abs;
 } *TP_CONTEXT;

typedef struct TP_GRAPH_struct {/* layout for TP_GRAPH */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_GRAPH_ANC_struct *anc;
 struct TP_GRAPH_DES_struct *des1;
 } *TP_GRAPH;

typedef struct TP_GRAPH_ABS_DES_struct {/* layout for TP_GRAPH_ABS_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *tbl;
 struct PROG_struct *prog1;
 struct TP_CLASS_struct *dollar_lock1;
 struct TP_CLASS_struct *gate1;
 struct TP_CLASS_struct *mutex1;
 } *TP_GRAPH_ABS_DES;

typedef struct TP_GRAPH_ANC_struct {/* layout for TP_GRAPH_ANC */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *anc_tbl;
 struct FMAPTP_CLASSFSETTP_CLASS_struct *par_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_ANC;

typedef struct TP_GRAPH_DES_struct {/* layout for TP_GRAPH_DES */
 OB_HEADER header;
 struct FMAPTP_CLASSFSETdTP_struct *child_tbl;
 struct FMAPTP_CLASSFSETdTP_struct *des_tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *TP_GRAPH_DES;

typedef struct TP_ITER_struct {/* layout for TP_ITER */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct ARRAYBOOL_struct *hot;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ITER;

typedef struct TP_ITER_TBL_struct {/* layout for TP_ITER_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_ITER_struct *arr_part[1];
 } *TP_ITER_TBL;

typedef struct TP_LAYOUT_struct {/* layout for TP_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 STR str1;
 } *TP_LAYOUT;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TP_ROUT_TBL_struct {/* layout for TP_ROUT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_ROUT_struct *arr_part[1];
 } *TP_ROUT_TBL;

typedef struct TP_TBL_struct {/* layout for TP_TBL */
 OB_HEADER header;
 struct PROG_struct *prog1;
 struct TP_CLASS_TBL_struct *class_tbl;
 struct TP_ITER_TBL_struct *iter_tbl;
 struct TP_ROUT_TBL_struct *rout_tbl;
 } *TP_TBL;

typedef struct TRANS_struct {/* layout for TRANS */
 OB_HEADER header;
 struct dAM_STMT_struct *cur_lock;
 struct dAM_STMT_struct *init_stmts;
 struct dTP_struct *ex_tp;
 struct AM_INVARIANT_STMT_struct *inv_stmt;
 struct AM_LOCAL_EXPR_struct *cur_cohort;
 struct AM_LOCAL_EXPR_struct *cur_par_ob;
 struct AM_LOCAL_EXPR_struct *cur_param_ob;
 struct AM_LOOP_STMT_struct *cur_loop;
 struct AM_POST_STMT_struct *post_stmt;
 struct AM_ROUT_DEF_struct *cur_rout;
 struct FLISTAM_LOCAL_EXPR_struct *active_locals;
 struct IMPL_struct *impl1;
 INT cur_yield_ind;
 struct PROG_struct *prog1;
 struct TP_CONTEXT_struct *tp_con;
 BOOL in_constant;
 BOOL in_external;
 BOOL in_initial;
 BOOL in_invariant;
 BOOL in_post;
 BOOL in_pre;
 BOOL in_protect_body;
 BOOL in_protect_then;
 } *TRANS;

typedef struct TUPdAM_CONSTdAM_CONST_struct {/* layout for TUP{$AM_CONST,$AM_CONST} */
 struct dAM_CONST_struct *t1;
 struct dAM_CONST_struct *t2;
 } TUPdAM_CONSTdAM_CONST;
static TUPdAM_CONSTdAM_CONST TUPdAM_CONSTdAM_CONST_zero;

typedef struct TUPdAM_CONSTdAM_CONST_boxed_struct {
 OB_HEADER header;
 TUPdAM_CONSTdAM_CONST value_part;
 } *TUPdAM_CONSTdAM_CONST_boxed;

typedef struct TUPdAM_EXPRdAM_EXPR_struct {/* layout for TUP{$AM_EXPR,$AM_EXPR} */
 struct dAM_EXPR_struct *t1;
 struct dAM_EXPR_struct *t2;
 } TUPdAM_EXPRdAM_EXPR;
static TUPdAM_EXPRdAM_EXPR TUPdAM_EXPRdAM_EXPR_zero;

typedef struct TUPdAM_EXPRdAM_EXPR_boxed_struct {
 OB_HEADER header;
 TUPdAM_EXPRdAM_EXPR value_part;
 } *TUPdAM_EXPRdAM_EXPR_boxed;

typedef struct TUPdAM_EXPRdTP_struct {/* layout for TUP{$AM_EXPR,$TP} */
 struct dAM_EXPR_struct *t1;
 struct dTP_struct *t2;
 } TUPdAM_EXPRdTP;
static TUPdAM_EXPRdTP TUPdAM_EXPRdTP_zero;

typedef struct TUPdAM_EXPRdTP_boxed_struct {
 OB_HEADER header;
 TUPdAM_EXPRdTP value_part;
 } *TUPdAM_EXPRdTP_boxed;

typedef struct TUPdAM_STMTdAM_STMT_struct {/* layout for TUP{$AM_STMT,$AM_STMT} */
 struct dAM_STMT_struct *t1;
 struct dAM_STMT_struct *t2;
 } TUPdAM_STMTdAM_STMT;
static TUPdAM_STMTdAM_STMT TUPdAM_STMTdAM_STMT_zero;

typedef struct TUPdAM_STMTdAM_STMT_boxed_struct {
 OB_HEADER header;
 TUPdAM_STMTdAM_STMT value_part;
 } *TUPdAM_STMTdAM_STMT_boxed;

typedef struct TUPdLAYOUTdLAYOUT_struct {/* layout for TUP{$LAYOUT,$LAYOUT} */
 struct dLAYOUT_struct *t1;
 struct dLAYOUT_struct *t2;
 } TUPdLAYOUTdLAYOUT;
static TUPdLAYOUTdLAYOUT TUPdLAYOUTdLAYOUT_zero;

typedef struct TUPdLAYOUTdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdLAYOUTdLAYOUT value_part;
 } *TUPdLAYOUTdLAYOUT_boxed;

typedef struct TUPdOBNAMESPACE_struct {/* layout for TUP{$OB,NAMESPACE} */
 OB t1;
 struct NAMESPACE_struct *t2;
 } TUPdOBNAMESPACE;
static TUPdOBNAMESPACE TUPdOBNAMESPACE_zero;

typedef struct TUPdOBNAMESPACE_boxed_struct {
 OB_HEADER header;
 TUPdOBNAMESPACE value_part;
 } *TUPdOBNAMESPACE_boxed;

typedef struct TUPdOBSTR_struct {/* layout for TUP{$OB,STR} */
 OB t1;
 STR t2;
 } TUPdOBSTR;
static TUPdOBSTR TUPdOBSTR_zero;

typedef struct TUPdOBSTR_boxed_struct {
 OB_HEADER header;
 TUPdOBSTR value_part;
 } *TUPdOBSTR_boxed;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPdTPdTP_struct {/* layout for TUP{$TP,$TP} */
 struct dTP_struct *t1;
 struct dTP_struct *t2;
 } TUPdTPdTP;
static TUPdTPdTP TUPdTPdTP_zero;

typedef struct TUPdTPdTP_boxed_struct {
 OB_HEADER header;
 TUPdTPdTP value_part;
 } *TUPdTPdTP_boxed;

typedef struct TUPdTPCODE_FILE_struct {/* layout for TUP{$TP,CODE_FILE} */
 struct dTP_struct *t1;
 struct CODE_FILE_struct *t2;
 } TUPdTPCODE_FILE;
static TUPdTPCODE_FILE TUPdTPCODE_FILE_zero;

typedef struct TUPdTPCODE_FILE_boxed_struct {
 OB_HEADER header;
 TUPdTPCODE_FILE value_part;
 } *TUPdTPCODE_FILE_boxed;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_struct {/* layout for TUP{$TP,FMAP{IDENT,AM_GLOBAL_EXPR}} */
 struct dTP_struct *t1;
 struct FMAPIDENTAM_GLOBAL_EXPR_struct *t2;
 } TUPdTPFMAPIDENTAM_GLOBAL;
static TUPdTPFMAPIDENTAM_GLOBAL TUPdTPFMAPIDENTAM_GLOBAL_zero;

typedef struct TUPdTPFMAPIDENTAM_GLOBAL_boxed_struct {
 OB_HEADER header;
 TUPdTPFMAPIDENTAM_GLOBAL value_part;
 } *TUPdTPFMAPIDENTAM_GLOBAL_boxed;

typedef struct TUPdTPIFC_struct {/* layout for TUP{$TP,IFC} */
 struct dTP_struct *t1;
 struct IFC_struct *t2;
 } TUPdTPIFC;
static TUPdTPIFC TUPdTPIFC_zero;

typedef struct TUPdTPIFC_boxed_struct {
 OB_HEADER header;
 TUPdTPIFC value_part;
 } *TUPdTPIFC_boxed;

typedef struct TUPdTPIMPL_struct {/* layout for TUP{$TP,IMPL} */
 struct dTP_struct *t1;
 struct IMPL_struct *t2;
 } TUPdTPIMPL;
static TUPdTPIMPL TUPdTPIMPL_zero;

typedef struct TUPdTPIMPL_boxed_struct {
 OB_HEADER header;
 TUPdTPIMPL value_part;
 } *TUPdTPIMPL_boxed;

typedef struct TUPdTPINT_struct {/* layout for TUP{$TP,INT} */
 struct dTP_struct *t1;
 INT t2;
 } TUPdTPINT;
static TUPdTPINT TUPdTPINT_zero;

typedef struct TUPdTPINT_boxed_struct {
 OB_HEADER header;
 TUPdTPINT value_part;
 } *TUPdTPINT_boxed;

typedef struct TUPAM_BND_CREATE_EXPRAM__struct {/* layout for TUP{AM_BND_CREATE_EXPR,AM_BND_CREATE_EXPR} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct AM_BND_CREATE_EXPR_struct *t2;
 } TUPAM_BND_CREATE_EXPRAM_;
static TUPAM_BND_CREATE_EXPRAM_ TUPAM_BND_CREATE_EXPRAM__zero;

typedef struct TUPAM_BND_CREATE_EXPRAM__boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRAM_ value_part;
 } *TUPAM_BND_CREATE_EXPRAM__boxed;

typedef struct TUPAM_BND_CREATE_EXPRBOU_struct {/* layout for TUP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct BOUND_OBJECT_LAYOUT_struct *t2;
 } TUPAM_BND_CREATE_EXPRBOU;
static TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU_zero;

typedef struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRBOU value_part;
 } *TUPAM_BND_CREATE_EXPRBOU_boxed;

typedef struct TUPAM_BND_ITER_CALL_EXPR_struct {/* layout for TUP{AM_BND_ITER_CALL_EXPR,AM_BND_ITER_CALL_EXPR} */
 struct AM_BND_ITER_CALL_EXPR_struct *t1;
 struct AM_BND_ITER_CALL_EXPR_struct *t2;
 } TUPAM_BND_ITER_CALL_EXPR;
static TUPAM_BND_ITER_CALL_EXPR TUPAM_BND_ITER_CALL_EXPR_zero;

typedef struct TUPAM_BND_ITER_CALL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_ITER_CALL_EXPR value_part;
 } *TUPAM_BND_ITER_CALL_EXPR_boxed;

typedef struct TUPAM_GLOBAL_EXPRAM_GLOB_struct {/* layout for TUP{AM_GLOBAL_EXPR,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t1;
 struct AM_GLOBAL_EXPR_struct *t2;
 } TUPAM_GLOBAL_EXPRAM_GLOB;
static TUPAM_GLOBAL_EXPRAM_GLOB TUPAM_GLOBAL_EXPRAM_GLOB_zero;

typedef struct TUPAM_GLOBAL_EXPRAM_GLOB_boxed_struct {
 OB_HEADER header;
 TUPAM_GLOBAL_EXPRAM_GLOB value_part;
 } *TUPAM_GLOBAL_EXPRAM_GLOB_boxed;

typedef struct TUPAM_ITER_CALL_EXPRAM_I_struct {/* layout for TUP{AM_ITER_CALL_EXPR,AM_ITER_CALL_EXPR} */
 struct AM_ITER_CALL_EXPR_struct *t1;
 struct AM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ITER_CALL_EXPRAM_I;
static TUPAM_ITER_CALL_EXPRAM_I TUPAM_ITER_CALL_EXPRAM_I_zero;

typedef struct TUPAM_ITER_CALL_EXPRAM_I_boxed_struct {
 OB_HEADER header;
 TUPAM_ITER_CALL_EXPRAM_I value_part;
 } *TUPAM_ITER_CALL_EXPRAM_I_boxed;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_struct {/* layout for TUP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 struct AM_LOCAL_EXPR_struct *t1;
 struct AM_LOCAL_EXPR_struct *t2;
 } TUPAM_LOCAL_EXPRAM_LOCAL;
static TUPAM_LOCAL_EXPRAM_LOCAL TUPAM_LOCAL_EXPRAM_LOCAL_zero;

typedef struct TUPAM_LOCAL_EXPRAM_LOCAL_boxed_struct {
 OB_HEADER header;
 TUPAM_LOCAL_EXPRAM_LOCAL value_part;
 } *TUPAM_LOCAL_EXPRAM_LOCAL_boxed;

typedef struct TUPAM_ROUT_DEFAM_ROUT_DE_struct {/* layout for TUP{AM_ROUT_DEF,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t1;
 struct AM_ROUT_DEF_struct *t2;
 } TUPAM_ROUT_DEFAM_ROUT_DE;
static TUPAM_ROUT_DEFAM_ROUT_DE TUPAM_ROUT_DEFAM_ROUT_DE_zero;

typedef struct TUPAM_ROUT_DEFAM_ROUT_DE_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFAM_ROUT_DE value_part;
 } *TUPAM_ROUT_DEFAM_ROUT_DE_boxed;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_struct {/* layout for TUP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 struct AM_ROUT_DEF_struct *t1;
 struct FLISTAM_ITER_CALL_EXPR_struct *t2;
 } TUPAM_ROUT_DEFFLISTAM_IT;
static TUPAM_ROUT_DEFFLISTAM_IT TUPAM_ROUT_DEFFLISTAM_IT_zero;

typedef struct TUPAM_ROUT_DEFFLISTAM_IT_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFLISTAM_IT value_part;
 } *TUPAM_ROUT_DEFFLISTAM_IT_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct TUPARRAYdTPdTP_struct {/* layout for TUP{ARRAY{$TP},$TP} */
 struct dTP_struct *t2;
 struct ARRAYdTP_struct *t1;
 } TUPARRAYdTPdTP;
static TUPARRAYdTPdTP TUPARRAYdTPdTP_zero;

typedef struct TUPARRAYdTPdTP_boxed_struct {
 OB_HEADER header;
 TUPARRAYdTPdTP value_part;
 } *TUPARRAYdTPdTP_boxed;

typedef struct TUPARRAYdTPARRAYBOOLdTP_struct {/* layout for TUP{ARRAY{$TP},ARRAY{BOOL},$TP} */
 struct dTP_struct *t3;
 struct ARRAYdTP_struct *t1;
 struct ARRAYBOOL_struct *t2;
 } TUPARRAYdTPARRAYBOOLdTP;
static TUPARRAYdTPARRAYBOOLdTP TUPARRAYdTPARRAYBOOLdTP_zero;

typedef struct TUPARRAYdTPARRAYBOOLdTP_boxed_struct {
 OB_HEADER header;
 TUPARRAYdTPARRAYBOOLdTP value_part;
 } *TUPARRAYdTPARRAYBOOLdTP_boxed;

typedef struct TUPAS_CLASS_DEFAS_CLASS__struct {/* layout for TUP{AS_CLASS_DEF,AS_CLASS_DEF} */
 struct AS_CLASS_DEF_struct *t1;
 struct AS_CLASS_DEF_struct *t2;
 } TUPAS_CLASS_DEFAS_CLASS_;
static TUPAS_CLASS_DEFAS_CLASS_ TUPAS_CLASS_DEFAS_CLASS__zero;

typedef struct TUPAS_CLASS_DEFAS_CLASS__boxed_struct {
 OB_HEADER header;
 TUPAS_CLASS_DEFAS_CLASS_ value_part;
 } *TUPAS_CLASS_DEFAS_CLASS__boxed;

typedef struct TUPBOOLINTIINTBOOL_struct {/* layout for TUP{BOOL,INTI,INT,BOOL} */
 INT t3;
 struct INTI_struct *t2;
 BOOL t1;
 BOOL t4;
 } TUPBOOLINTIINTBOOL;
static TUPBOOLINTIINTBOOL TUPBOOLINTIINTBOOL_zero;

typedef struct TUPBOOLINTIINTBOOL_boxed_struct {
 OB_HEADER header;
 TUPBOOLINTIINTBOOL value_part;
 } *TUPBOOLINTIINTBOOL_boxed;

typedef struct TUPCHARCHAR_struct {/* layout for TUP{CHAR,CHAR} */
 CHAR t1;
 CHAR t2;
 } TUPCHARCHAR;
static TUPCHARCHAR TUPCHARCHAR_zero;

typedef struct TUPCHARCHAR_boxed_struct {
 OB_HEADER header;
 TUPCHARCHAR value_part;
 } *TUPCHARCHAR_boxed;

typedef struct TUPCODE_FILECODE_FILE_struct {/* layout for TUP{CODE_FILE,CODE_FILE} */
 struct CODE_FILE_struct *t1;
 struct CODE_FILE_struct *t2;
 } TUPCODE_FILECODE_FILE;
static TUPCODE_FILECODE_FILE TUPCODE_FILECODE_FILE_zero;

typedef struct TUPCODE_FILECODE_FILE_boxed_struct {
 OB_HEADER header;
 TUPCODE_FILECODE_FILE value_part;
 } *TUPCODE_FILECODE_FILE_boxed;

typedef struct TUPFLISTdAM_CONSTFLISTdA_struct {/* layout for TUP{FLIST{$AM_CONST},FLIST{$AM_CONST}} */
 struct FLISTdAM_CONST_struct *t1;
 struct FLISTdAM_CONST_struct *t2;
 } TUPFLISTdAM_CONSTFLISTdA;
static TUPFLISTdAM_CONSTFLISTdA TUPFLISTdAM_CONSTFLISTdA_zero;

typedef struct TUPFLISTdAM_CONSTFLISTdA_boxed_struct {
 OB_HEADER header;
 TUPFLISTdAM_CONSTFLISTdA value_part;
 } *TUPFLISTdAM_CONSTFLISTdA_boxed;

typedef struct TUPFLTFLT_struct {/* layout for TUP{FLT,FLT} */
 FLT t1;
 FLT t2;
 } TUPFLTFLT;
static TUPFLTFLT TUPFLTFLT_zero;

typedef struct TUPFLTFLT_boxed_struct {
 OB_HEADER header;
 TUPFLTFLT value_part;
 } *TUPFLTFLT_boxed;

typedef struct TUPFLTDFLTD_struct {/* layout for TUP{FLTD,FLTD} */
 FLTD t1;
 FLTD t2;
 } TUPFLTDFLTD;
static TUPFLTDFLTD TUPFLTDFLTD_zero;

typedef struct TUPFLTDFLTD_boxed_struct {
 OB_HEADER header;
 TUPFLTDFLTD value_part;
 } *TUPFLTDFLTD_boxed;

typedef struct TUPFSTRFSTR_struct {/* layout for TUP{FSTR,FSTR} */
 struct FSTR_struct *t1;
 struct FSTR_struct *t2;
 } TUPFSTRFSTR;
static TUPFSTRFSTR TUPFSTRFSTR_zero;

typedef struct TUPFSTRFSTR_boxed_struct {
 OB_HEADER header;
 TUPFSTRFSTR value_part;
 } *TUPFSTRFSTR_boxed;

typedef struct TUPIDENTdTP_struct {/* layout for TUP{IDENT,$TP} */
 struct dTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTdTP;
static TUPIDENTdTP TUPIDENTdTP_zero;

typedef struct TUPIDENTdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTdTP value_part;
 } *TUPIDENTdTP_boxed;

typedef struct TUPIDENTAM_GLOBAL_EXPR_struct {/* layout for TUP{IDENT,AM_GLOBAL_EXPR} */
 struct AM_GLOBAL_EXPR_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTAM_GLOBAL_EXPR;
static TUPIDENTAM_GLOBAL_EXPR TUPIDENTAM_GLOBAL_EXPR_zero;

typedef struct TUPIDENTAM_GLOBAL_EXPR_boxed_struct {
 OB_HEADER header;
 TUPIDENTAM_GLOBAL_EXPR value_part;
 } *TUPIDENTAM_GLOBAL_EXPR_boxed;

typedef struct TUPIDENTARRAYdTP_struct {/* layout for TUP{IDENT,ARRAY{$TP}} */
 struct ARRAYdTP_struct *t2;
 struct IDENT_struct t1;
 } TUPIDENTARRAYdTP;
static TUPIDENTARRAYdTP TUPIDENTARRAYdTP_zero;

typedef struct TUPIDENTARRAYdTP_boxed_struct {
 OB_HEADER header;
 TUPIDENTARRAYdTP value_part;
 } *TUPIDENTARRAYdTP_boxed;

typedef struct TUPIDENTIDENT_struct {/* layout for TUP{IDENT,IDENT} */
 struct IDENT_struct t1;
 struct IDENT_struct t2;
 } TUPIDENTIDENT;
static TUPIDENTIDENT TUPIDENTIDENT_zero;

typedef struct TUPIDENTIDENT_boxed_struct {
 OB_HEADER header;
 TUPIDENTIDENT value_part;
 } *TUPIDENTIDENT_boxed;

typedef struct TUPIDENTINT_struct {/* layout for TUP{IDENT,INT} */
 struct IDENT_struct t1;
 INT t2;
 } TUPIDENTINT;
static TUPIDENTINT TUPIDENTINT_zero;

typedef struct TUPIDENTINT_boxed_struct {
 OB_HEADER header;
 TUPIDENTINT value_part;
 } *TUPIDENTINT_boxed;

typedef struct TUPIFCIFC_struct {/* layout for TUP{IFC,IFC} */
 struct IFC_struct *t1;
 struct IFC_struct *t2;
 } TUPIFCIFC;
static TUPIFCIFC TUPIFCIFC_zero;

typedef struct TUPIFCIFC_boxed_struct {
 OB_HEADER header;
 TUPIFCIFC value_part;
 } *TUPIFCIFC_boxed;

typedef struct TUPIMPL_INCLUDEIMPL_INCL_struct {/* layout for TUP{IMPL_INCLUDE,IMPL_INCLUDE} */
 struct IMPL_INCLUDE_struct *t1;
 struct IMPL_INCLUDE_struct *t2;
 } TUPIMPL_INCLUDEIMPL_INCL;
static TUPIMPL_INCLUDEIMPL_INCL TUPIMPL_INCLUDEIMPL_INCL_zero;

typedef struct TUPIMPL_INCLUDEIMPL_INCL_boxed_struct {
 OB_HEADER header;
 TUPIMPL_INCLUDEIMPL_INCL value_part;
 } *TUPIMPL_INCLUDEIMPL_INCL_boxed;

typedef struct TUPINTINTINT_struct {/* layout for TUP{INT,INT,INT} */
 INT t1;
 INT t2;
 INT t3;
 } TUPINTINTINT;
static TUPINTINTINT TUPINTINTINT_zero;

typedef struct TUPINTINTINT_boxed_struct {
 OB_HEADER header;
 TUPINTINTINT value_part;
 } *TUPINTINTINT_boxed;

typedef struct TUPINTINT_struct {/* layout for TUP{INT,INT} */
 INT t1;
 INT t2;
 } TUPINTINT;
static TUPINTINT TUPINTINT_zero;

typedef struct TUPINTINT_boxed_struct {
 OB_HEADER header;
 TUPINTINT value_part;
 } *TUPINTINT_boxed;

typedef struct TUPINTIINTIINTI_struct {/* layout for TUP{INTI,INTI,INTI} */
 struct INTI_struct *t1;
 struct INTI_struct *t2;
 struct INTI_struct *t3;
 } TUPINTIINTIINTI;
static TUPINTIINTIINTI TUPINTIINTIINTI_zero;

typedef struct TUPINTIINTIINTI_boxed_struct {
 OB_HEADER header;
 TUPINTIINTIINTI value_part;
 } *TUPINTIINTIINTI_boxed;

typedef struct TUPSFILE_IDSFILE_ID_struct {/* layout for TUP{SFILE_ID,SFILE_ID} */
 struct SFILE_ID_struct t1;
 struct SFILE_ID_struct t2;
 } TUPSFILE_IDSFILE_ID;
static TUPSFILE_IDSFILE_ID TUPSFILE_IDSFILE_ID_zero;

typedef struct TUPSFILE_IDSFILE_ID_boxed_struct {
 OB_HEADER header;
 TUPSFILE_IDSFILE_ID value_part;
 } *TUPSFILE_IDSFILE_ID_boxed;

typedef struct TUPSIGABSTRACT_FRAME_LAY_struct {/* layout for TUP{SIG,ABSTRACT_FRAME_LAYOUT} */
 struct ABSTRACT_FRAME_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGABSTRACT_FRAME_LAY;
static TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY_zero;

typedef struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct {
 OB_HEADER header;
 TUPSIGABSTRACT_FRAME_LAY value_part;
 } *TUPSIGABSTRACT_FRAME_LAY_boxed;

typedef struct TUPSIGAM_ROUT_DEF_struct {/* layout for TUP{SIG,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGAM_ROUT_DEF;
static TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_zero;

typedef struct TUPSIGAM_ROUT_DEF_boxed_struct {
 OB_HEADER header;
 TUPSIGAM_ROUT_DEF value_part;
 } *TUPSIGAM_ROUT_DEF_boxed;

typedef struct TUPSIGARG_LAYOUT_struct {/* layout for TUP{SIG,ARG_LAYOUT} */
 struct ARG_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGARG_LAYOUT;
static TUPSIGARG_LAYOUT TUPSIGARG_LAYOUT_zero;

typedef struct TUPSIGARG_LAYOUT_boxed_struct {
 OB_HEADER header;
 TUPSIGARG_LAYOUT value_part;
 } *TUPSIGARG_LAYOUT_boxed;

typedef struct TUPSIGSIG_struct {/* layout for TUP{SIG,SIG} */
 struct SIG_struct *t1;
 struct SIG_struct *t2;
 } TUPSIGSIG;
static TUPSIGSIG TUPSIGSIG_zero;

typedef struct TUPSIGSIG_boxed_struct {
 OB_HEADER header;
 TUPSIGSIG value_part;
 } *TUPSIGSIG_boxed;

typedef struct TUPSIGSTR_struct {/* layout for TUP{SIG,STR} */
 struct SIG_struct *t1;
 STR t2;
 } TUPSIGSTR;
static TUPSIGSTR TUPSIGSTR_zero;

typedef struct TUPSIGSTR_boxed_struct {
 OB_HEADER header;
 TUPSIGSTR value_part;
 } *TUPSIGSTR_boxed;

typedef struct TUPSTRFSETSTR_struct {/* layout for TUP{STR,FSET{STR}} */
 struct FSETSTR_struct *t2;
 STR t1;
 } TUPSTRFSETSTR;
static TUPSTRFSETSTR TUPSTRFSETSTR_zero;

typedef struct TUPSTRFSETSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRFSETSTR value_part;
 } *TUPSTRFSETSTR_boxed;

typedef struct TUPSTRINT_struct {/* layout for TUP{STR,INT} */
 INT t2;
 STR t1;
 } TUPSTRINT;
static TUPSTRINT TUPSTRINT_zero;

typedef struct TUPSTRINT_boxed_struct {
 OB_HEADER header;
 TUPSTRINT value_part;
 } *TUPSTRINT_boxed;

typedef struct TUPSTRITER_INLINE_struct {/* layout for TUP{STR,ITER_INLINE} */
 struct ITER_INLINE_struct *t2;
 STR t1;
 } TUPSTRITER_INLINE;
static TUPSTRITER_INLINE TUPSTRITER_INLINE_zero;

typedef struct TUPSTRITER_INLINE_boxed_struct {
 OB_HEADER header;
 TUPSTRITER_INLINE value_part;
 } *TUPSTRITER_INLINE_boxed;

typedef struct TUPSTRSIG_struct {/* layout for TUP{STR,SIG} */
 struct SIG_struct *t2;
 STR t1;
 } TUPSTRSIG;
static TUPSTRSIG TUPSTRSIG_zero;

typedef struct TUPSTRSIG_boxed_struct {
 OB_HEADER header;
 TUPSTRSIG value_part;
 } *TUPSTRSIG_boxed;

typedef struct TUPSTRSTR_struct {/* layout for TUP{STR,STR} */
 STR t1;
 STR t2;
 } TUPSTRSTR;
static TUPSTRSTR TUPSTRSTR_zero;

typedef struct TUPSTRSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRSTR value_part;
 } *TUPSTRSTR_boxed;

typedef struct TUPTP_CLASSFSETdTP_struct {/* layout for TUP{TP_CLASS,FSET{$TP}} */
 struct FSETdTP_struct *t2;
 struct TP_CLASS_struct *t1;
 } TUPTP_CLASSFSETdTP;
static TUPTP_CLASSFSETdTP TUPTP_CLASSFSETdTP_zero;

typedef struct TUPTP_CLASSFSETdTP_boxed_struct {
 OB_HEADER header;
 TUPTP_CLASSFSETdTP value_part;
 } *TUPTP_CLASSFSETdTP_boxed;

typedef struct TUPTP_CLASSFSETTP_CLASS_struct {/* layout for TUP{TP_CLASS,FSET{TP_CLASS}} */
 struct FSETTP_CLASS_struct *t2;
 struct TP_CLASS_struct *t1;
 } TUPTP_CLASSFSETTP_CLASS;
static TUPTP_CLASSFSETTP_CLASS TUPTP_CLASSFSETTP_CLASS_zero;

typedef struct TUPTP_CLASSFSETTP_CLASS_boxed_struct {
 OB_HEADER header;
 TUPTP_CLASSFSETTP_CLASS value_part;
 } *TUPTP_CLASSFSETTP_CLASS_boxed;

typedef struct VALUE_CLASS_LAYOUT_struct {/* layout for VALUE_CLASS_LAYOUT */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct AM_OB_DEF_struct *l1;
 struct FLISTdLAYOUT_struct *dependencies;
 struct PROG_struct *prog1;
 STR str1;
 } *VALUE_CLASS_LAYOUT;

typedef struct WEIGH_CODE_struct {/* layout for WEIGH_CODE */
 OB_HEADER header;
 struct dAM_STMT_struct *badstmt;
 struct AM_IF_STMT_struct *enclosing_if;
 INT level1;
 INT max_weight;
 INT weight;
 BOOL true_branch;
 } *WEIGH_CODE;

typedef struct XFORM_CODE_struct {/* layout for XFORM_CODE */
 OB_HEADER header;
 struct dAM_EXPR_struct *return_val;
 struct dAM_EXPR_struct *yield_val;
 struct dAM_STMT_struct *after_yield;
 struct AM_IF_STMT_struct *enclosing_if;
 struct AM_IF_STMT_struct *if_encl_yield;
 struct AM_LOOP_STMT_struct *loop_stmt;
 struct AM_LOOP_STMT_struct *new_loop_stmt;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FMAPAM_LOCAL_EXPRAM_LOCA_struct *subst1;
 BOOL record_calls;
 BOOL true_br_yield;
 BOOL true_branch;
 } *XFORM_CODE;

typedef struct AM_ANY_EXPR_struct {/* layout for AM_ANY_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_ANY_EXPR;

typedef struct AM_ARRAY_EXPR_struct {/* layout for AM_ARRAY_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ARRAY_EXPR;

typedef struct AM_ARR_CONST_struct {/* layout for AM_ARR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYdAM_CONST_struct *elts;
 struct SFILE_ID_struct source11;
 struct TP_CLASS_struct *elt_tp;
 } *AM_ARR_CONST;

typedef struct AM_ARR_EXPR_struct {/* layout for AM_ARR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_ARR_EXPR;

typedef struct AM_ASSERT_STMT_struct {/* layout for AM_ASSERT_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_ASSERT_STMT;

typedef struct AM_ASSIGN_STMT_struct {/* layout for AM_ASSIGN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *dest;
 struct dAM_EXPR_struct *src11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_ASSIGN_STMT;

typedef struct AM_ATTACH_STMT_struct {/* layout for AM_ATTACH_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_STMT_struct *next1;
 struct AM_LOCAL_EXPR_struct *gate1;
 struct AM_LOCAL_EXPR_struct *helper;
 struct SFILE_ID_struct source11;
 struct SIG_struct *rout1;
 } *AM_ATTACH_STMT;

typedef struct AM_ATTR_EXPR_struct {/* layout for AM_ATTR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dTP_struct *self_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_ATTR_EXPR;

typedef struct AM_AT_EXPR_struct {/* layout for AM_AT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *e11;
 struct SFILE_ID_struct source11;
 } *AM_AT_EXPR;

typedef struct AM_BND_CREATE_EXPR_struct {/* layout for AM_BND_CREATE_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct ARRAYINT_struct *bnd_args;
 struct ARRAYINT_struct *unbnd_args;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_CREATE_EXPR;

typedef struct AM_BND_ITER_CALL_EXPR_struct {/* layout for AM_BND_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *bi;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ITER_CALL_EXPR;

typedef struct AM_BND_ROUT_CALL_EXPR_struct {/* layout for AM_BND_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *br;
 struct SFILE_ID_struct source11;
 struct TP_ROUT_struct *br_tp;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_BND_ROUT_CALL_EXPR;

typedef struct AM_BOOL_CONST_struct {/* layout for AM_BOOL_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 BOOL val11;
 } *AM_BOOL_CONST;

typedef struct AM_BREAK_STMT_struct {/* layout for AM_BREAK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_BREAK_STMT;

typedef struct AM_CASE_STMT_struct {/* layout for AM_CASE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTFLISTdAM_CONST_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_CASE_STMT;

typedef struct AM_CHAR_CONST_struct {/* layout for AM_CHAR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 CHAR bval;
 } *AM_CHAR_CONST;

typedef struct AM_CLUSTER_EXPR_struct {/* layout for AM_CLUSTER_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_CLUSTER_EXPR;

typedef struct AM_CONST_struct {/* layout for AM_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_CONST;

typedef struct AM_EXCEPT_EXPR_struct {/* layout for AM_EXCEPT_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_EXCEPT_EXPR;

typedef struct AM_EXPR_STMT_struct {/* layout for AM_EXPR_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *at11;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_EXPR_STMT;

typedef struct AM_EXT_CALL_EXPR_struct {/* layout for AM_EXT_CALL_EXPR */
 OB_HEADER header;
 struct IDENT_struct nm1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_EXT_CALL_EXPR;

typedef struct AM_FAR_EXPR_struct {/* layout for AM_FAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_FAR_EXPR;

typedef struct AM_FLTDX_CONST_struct {/* layout for AM_FLTDX_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTDX_CONST;

typedef struct AM_FLTD_CONST_struct {/* layout for AM_FLTD_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTD_CONST;

typedef struct AM_FLTI_CONST_struct {/* layout for AM_FLTI_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTI_CONST;

typedef struct AM_FLTX_CONST_struct {/* layout for AM_FLTX_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLTX_CONST;

typedef struct AM_FLT_CONST_struct {/* layout for AM_FLT_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AM_FLT_CONST;

typedef struct AM_GLOBAL_EXPR_struct {/* layout for AM_GLOBAL_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *init1;
 struct dTP_struct *class_tp;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_const;
 } *AM_GLOBAL_EXPR;

typedef struct AM_HERE_EXPR_struct {/* layout for AM_HERE_EXPR */
 OB_HEADER header;
 struct SFILE_ID_struct source11;
 } *AM_HERE_EXPR;

typedef struct AM_IF_EXPR_struct {/* layout for AM_IF_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *if_false;
 struct dAM_EXPR_struct *if_true;
 struct dAM_EXPR_struct *test11;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IF_EXPR;

typedef struct AM_IF_STMT_struct {/* layout for AM_IF_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *if_false;
 struct dAM_STMT_struct *if_true;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_IF_STMT;

typedef struct AM_INITIAL_STMT_struct {/* layout for AM_INITIAL_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *stmts;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_INITIAL_STMT;

typedef struct AM_INTI_CONST_struct {/* layout for AM_INTI_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_INTI_CONST;

typedef struct AM_INT_CONST_struct {/* layout for AM_INT_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_INT_CONST;

typedef struct AM_INVARIANT_STMT_struct {/* layout for AM_INVARIANT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 } *AM_INVARIANT_STMT;

typedef struct AM_IS_VOID_EXPR_struct {/* layout for AM_IS_VOID_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_IS_VOID_EXPR;

typedef struct AM_ITER_CALL_EXPR_struct {/* layout for AM_ITER_CALL_EXPR */
 OB_HEADER header;
 struct dAM_STMT_struct *init1;
 struct AM_LOOP_STMT_struct *lp1;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ITER_CALL_EXPR;

typedef struct AM_LOCAL_EXPR_struct {/* layout for AM_LOCAL_EXPR */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct AS_TYPE_SPEC_struct *as_type;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_volatile;
 BOOL needs_init;
 BOOL no_assign;
 } *AM_LOCAL_EXPR;

typedef struct AM_LOCK_STMT_struct {/* layout for AM_LOCK_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_LOCK_STMT;

typedef struct AM_LOOP_STMT_struct {/* layout for AM_LOOP_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *next1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct SFILE_ID_struct source11;
 BOOL has_yield;
 } *AM_LOOP_STMT;

typedef struct AM_NEAR_EXPR_struct {/* layout for AM_NEAR_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_NEAR_EXPR;

typedef struct AM_NEW_EXPR_struct {/* layout for AM_NEW_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *asz1;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_NEW_EXPR;

typedef struct AM_OB_DEF_struct {/* layout for AM_OB_DEF */
 OB_HEADER header;
 struct dTP_struct *arr1;
 struct dTP_struct *tp1;
 struct FMAPIDENTdTP_struct *at11;
 INT asize;
 struct SFILE_ID_struct source11;
 } *AM_OB_DEF;

typedef struct AM_POST_STMT_struct {/* layout for AM_POST_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_POST_STMT;

typedef struct AM_PRE_STMT_struct {/* layout for AM_PRE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *test11;
 struct dAM_STMT_struct *next1;
 struct dTP_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AM_PRE_STMT;

typedef struct AM_PROTECT_STMT_struct {/* layout for AM_PROTECT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *body;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 } *AM_PROTECT_STMT;

typedef struct AM_RAISE_STMT_struct {/* layout for AM_RAISE_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RAISE_STMT;

typedef struct AM_RETURN_STMT_struct {/* layout for AM_RETURN_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_RETURN_STMT;

typedef struct AM_ROUT_CALL_EXPR_struct {/* layout for AM_ROUT_CALL_EXPR */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *as_type;
 struct SFILE_ID_struct source11;
 struct SIG_struct *fun;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *AM_ROUT_CALL_EXPR;

typedef struct AM_ROUT_DEF_struct {/* layout for AM_ROUT_DEF */
 OB_HEADER header;
 struct dAM_STMT_struct *code11;
 struct AM_LOCAL_EXPR_struct *rres;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 INT num_yields;
 struct SFILE_ID_struct source11;
 struct SIG_struct *sig11;
 struct SIG_struct *srcsig1;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_clean;
 BOOL is_external;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL n_export_call;
 BOOL n_export_locals;
 BOOL n_import_call;
 BOOL n_import_locals;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *AM_ROUT_DEF;

typedef struct AM_STMT_EXPR_struct {/* layout for AM_STMT_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *expr;
 struct dAM_STMT_struct *stmts;
 struct FLISTdAM_EXPR_struct *calls1;
 struct FLISTAM_BND_ITER_CALL_EX_struct *bits1;
 struct FLISTAM_ITER_CALL_EXPR_struct *its1;
 struct FLISTAM_LOCAL_EXPR_struct *firsts;
 struct FLISTAM_LOCAL_EXPR_struct *locals1;
 struct SFILE_ID_struct source11;
 } *AM_STMT_EXPR;

typedef struct AM_STR_CONST_struct {/* layout for AM_STR_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 STR bval;
 } *AM_STR_CONST;

typedef struct AM_TRY_STMT_struct {/* layout for AM_TRY_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *then_part1;
 struct ARRAYdAM_EXPR_struct *locks1;
 struct SFILE_ID_struct source11;
 } *AM_TRY_STMT;

typedef struct AM_TYPECASE_STMT_struct {/* layout for AM_TYPECASE_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_stmts;
 struct dAM_STMT_struct *next1;
 struct dAM_STMT_struct *void_stmts;
 struct AM_LOCAL_EXPR_struct *test11;
 struct FLISTdAM_STMT_struct *stmts;
 struct FLISTdTP_struct *tgts;
 struct SFILE_ID_struct source11;
 BOOL has_void_stmts;
 BOOL no_else;
 } *AM_TYPECASE_STMT;

typedef struct AM_UNCAUGHT_STMT_struct {/* layout for AM_UNCAUGHT_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNCAUGHT_STMT;

typedef struct AM_UNLOCK_STMT_struct {/* layout for AM_UNLOCK_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *lock1;
 struct dAM_STMT_struct *next1;
 struct SFILE_ID_struct source11;
 } *AM_UNLOCK_STMT;

typedef struct AM_VARR_ASSIGN_EXPR_struct {/* layout for AM_VARR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ind1;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct SFILE_ID_struct source11;
 } *AM_VARR_ASSIGN_EXPR;

typedef struct AM_VATTR_ASSIGN_EXPR_struct {/* layout for AM_VATTR_ASSIGN_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *ob1;
 struct dAM_EXPR_struct *val11;
 struct IDENT_struct at11;
 struct SFILE_ID_struct source11;
 } *AM_VATTR_ASSIGN_EXPR;

typedef struct AM_VOID_CONST_struct {/* layout for AM_VOID_CONST */
 OB_HEADER header;
 struct dTP_struct *tp_at;
 struct SFILE_ID_struct source11;
 } *AM_VOID_CONST;

typedef struct AM_WHERE_EXPR_struct {/* layout for AM_WHERE_EXPR */
 OB_HEADER header;
 struct dAM_EXPR_struct *arg1;
 struct SFILE_ID_struct source11;
 } *AM_WHERE_EXPR;

typedef struct AM_WITH_NEAR_STMT_struct {/* layout for AM_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAM_STMT_struct *else_part1;
 struct dAM_STMT_struct *near_part;
 struct dAM_STMT_struct *next1;
 struct ARRAYdAM_EXPR_struct *objects1;
 struct SFILE_ID_struct source11;
 } *AM_WITH_NEAR_STMT;

typedef struct AM_YIELD_STMT_struct {/* layout for AM_YIELD_STMT */
 OB_HEADER header;
 struct dAM_EXPR_struct *val11;
 struct dAM_STMT_struct *next1;
 INT ret1;
 struct SFILE_ID_struct source11;
 } *AM_YIELD_STMT;

typedef struct ARRAYBOOL_struct {/* layout for ARRAY{BOOL} */
 OB_HEADER header;
 INT asize;
 BOOL arr_part[1];
 } *ARRAYBOOL;

typedef struct ARRAYIDENT_struct {/* layout for ARRAY{IDENT} */
 OB_HEADER header;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *ARRAYIDENT;

typedef struct ARRAYINT_struct {/* layout for ARRAY{INT} */
 OB_HEADER header;
 INT asize;
 INT arr_part[1];
 } *ARRAYINT;

typedef struct AS_AND_EXPR_struct {/* layout for AS_AND_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *e21;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_AND_EXPR;

typedef struct AS_ANY_EXPR_struct {/* layout for AS_ANY_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_ANY_EXPR;

typedef struct AS_ARG_DEC_struct {/* layout for AS_ARG_DEC */
 OB_HEADER header;
 struct AS_ARG_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_ARG_DEC;

typedef struct AS_ARRAY_EXPR_struct {/* layout for AS_ARRAY_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *elts;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_ARRAY_EXPR;

typedef struct AS_ASSERT_STMT_struct {/* layout for AS_ASSERT_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_ASSERT_STMT;

typedef struct AS_ASSIGN_STMT_struct {/* layout for AS_ASSIGN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs_expr;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_ASSIGN_STMT;

typedef struct AS_ATTACH_STMT_struct {/* layout for AS_ATTACH_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *lhs;
 struct dAS_EXPR_struct *rhs;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL dont_print;
 BOOL transformed;
 } *AS_ATTACH_STMT;

typedef struct AS_ATTR_DEF_struct {/* layout for AS_ATTR_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_ATTR_DEF;

typedef struct AS_AT_EXPR_struct {/* layout for AS_AT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_AT_EXPR;

typedef struct AS_BOOL_LIT_EXPR_struct {/* layout for AS_BOOL_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 BOOL val11;
 } *AS_BOOL_LIT_EXPR;

typedef struct AS_BOUND_CREATE_EXPR_struct {/* layout for AS_BOUND_CREATE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct AS_CALL_EXPR_struct *call1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct SFILE_ID_struct source11;
 BOOL is_iter1;
 } *AS_BOUND_CREATE_EXPR;

typedef struct AS_BREAK_EXPR_struct {/* layout for AS_BREAK_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_BREAK_EXPR;

typedef struct AS_CALL_EXPR_struct {/* layout for AS_CALL_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *args1;
 struct dAS_EXPR_struct *next;
 struct dAS_EXPR_struct *ob1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_array;
 } *AS_CALL_EXPR;

typedef struct AS_CASE_STMT_struct {/* layout for AS_CASE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_CASE_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_CASE_STMT;

typedef struct AS_CASE_WHEN_struct {/* layout for AS_CASE_WHEN */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct AS_CASE_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 } *AS_CASE_WHEN;

typedef struct AS_CHAR_LIT_EXPR_struct {/* layout for AS_CHAR_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT val11;
 struct SFILE_ID_struct source11;
 } *AS_CHAR_LIT_EXPR;

typedef struct AS_CLASS_DEF_struct {/* layout for AS_CLASS_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *body;
 struct AS_CLASS_DEF_struct *next;
 struct AS_PARAM_DEC_struct *params1;
 struct AS_TYPE_SPEC_struct *over;
 struct AS_TYPE_SPEC_struct *under;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 } *AS_CLASS_DEF;

typedef struct AS_CLUSTER_EXPR_struct {/* layout for AS_CLUSTER_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_CLUSTER_EXPR;

typedef struct AS_COHORT_EXPR_struct {/* layout for AS_COHORT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct IDENT_struct name_after_pSather_trafo;
 struct SFILE_ID_struct source11;
 } *AS_COHORT_EXPR;

typedef struct AS_CONST_DEF_struct {/* layout for AS_CONST_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_CONST_DEF;

typedef struct AS_CREATE_EXPR_struct {/* layout for AS_CREATE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *elts;
 struct dAS_EXPR_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_CREATE_EXPR;

typedef struct AS_DEC_STMT_struct {/* layout for AS_DEC_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_DEC_STMT;

typedef struct AS_EXCEPT_EXPR_struct {/* layout for AS_EXCEPT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_EXCEPT_EXPR;

typedef struct AS_EXPR_STMT_struct {/* layout for AS_EXPR_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_EXPR_STMT;

typedef struct AS_FAR_EXPR_struct {/* layout for AS_FAR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_FAR_EXPR;

typedef struct AS_FEAT_MOD_struct {/* layout for AS_FEAT_MOD */
 OB_HEADER header;
 struct AS_FEAT_MOD_struct *next;
 struct IDENT_struct name1;
 struct IDENT_struct new_name;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_FEAT_MOD;

typedef struct AS_FLT_LIT_EXPR_struct {/* layout for AS_FLT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 INT tp1;
 struct RAT_struct val11;
 struct SFILE_ID_struct source11;
 } *AS_FLT_LIT_EXPR;

typedef struct AS_FORK_STMT_struct {/* layout for AS_FORK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_FORK_STMT;

typedef struct AS_HERE_EXPR_struct {/* layout for AS_HERE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_HERE_EXPR;

typedef struct AS_IDENT_LIST_struct {/* layout for AS_IDENT_LIST */
 OB_HEADER header;
 struct AS_IDENT_LIST_struct *next;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 } *AS_IDENT_LIST;

typedef struct AS_IF_STMT_struct {/* layout for AS_IF_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *test1;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_IF_STMT;

typedef struct AS_INCLUDE_CLAUSE_struct {/* layout for AS_INCLUDE_CLAUSE */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct AS_FEAT_MOD_struct *mods;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 } *AS_INCLUDE_CLAUSE;

typedef struct AS_INITIAL_EXPR_struct {/* layout for AS_INITIAL_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_INITIAL_EXPR;

typedef struct AS_INTERF_ATTACH_STMT_struct {/* layout for AS_INTERF_ATTACH_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *at11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct gatename;
 struct IDENT_struct helpername;
 struct IDENT_struct routname1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_INTERF_ATTACH_STMT;

typedef struct AS_INT_LIT_EXPR_struct {/* layout for AS_INT_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct INTI_struct *val11;
 struct SFILE_ID_struct source11;
 BOOL is_inti;
 } *AS_INT_LIT_EXPR;

typedef struct AS_IS_VOID_EXPR_struct {/* layout for AS_IS_VOID_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *arg1;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_IS_VOID_EXPR;

typedef struct AS_LOCK_STMT_struct {/* layout for AS_LOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_LOCK_STMT;

typedef struct AS_LOOP_STMT_struct {/* layout for AS_LOOP_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_LOOP_STMT;

typedef struct AS_NEAR_EXPR_struct {/* layout for AS_NEAR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_NEAR_EXPR;

typedef struct AS_NEW_EXPR_struct {/* layout for AS_NEW_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *arg1;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_NEW_EXPR;

typedef struct AS_OR_EXPR_struct {/* layout for AS_OR_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *e21;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_OR_EXPR;

typedef struct AS_PARAM_DEC_struct {/* layout for AS_PARAM_DEC */
 OB_HEADER header;
 struct AS_PARAM_DEC_struct *next;
 struct AS_TYPE_SPEC_struct *type_constraint;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 } *AS_PARAM_DEC;

typedef struct AS_PAR_STMT_struct {/* layout for AS_PAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_ROUT_DEF_struct *rout1;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct IDENT_struct helper_class;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_PAR_STMT;

typedef struct AS_PROTECT_STMT_struct {/* layout for AS_PROTECT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_PROTECT_WHEN_struct *when_part;
 struct AS_STMT_LIST_struct *body;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed;
 } *AS_PROTECT_STMT;

typedef struct AS_PROTECT_WHEN_struct {/* layout for AS_PROTECT_WHEN */
 OB_HEADER header;
 struct AS_PROTECT_WHEN_struct *next;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_PROTECT_WHEN;

typedef struct AS_QUIT_STMT_struct {/* layout for AS_QUIT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_QUIT_STMT;

typedef struct AS_RAISE_STMT_struct {/* layout for AS_RAISE_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RAISE_STMT;

typedef struct AS_RESULT_EXPR_struct {/* layout for AS_RESULT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_RESULT_EXPR;

typedef struct AS_RETURN_STMT_struct {/* layout for AS_RETURN_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_RETURN_STMT;

typedef struct AS_ROUT_DEF_struct {/* layout for AS_ROUT_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *post_e;
 struct dAS_EXPR_struct *pre_e;
 struct AS_ARG_DEC_struct *args_dec;
 struct AS_STMT_LIST_struct *body;
 struct AS_TYPE_SPEC_struct *ret_dec;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_abstract;
 BOOL is_attach_routine;
 BOOL is_fork_routine;
 BOOL is_par_routine;
 BOOL is_private;
 } *AS_ROUT_DEF;

typedef struct AS_SELF_EXPR_struct {/* layout for AS_SELF_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_SELF_EXPR;

typedef struct AS_SHARED_DEF_struct {/* layout for AS_SHARED_DEF */
 OB_HEADER header;
 struct dAS_CLASS_ELT_struct *next;
 struct dAS_EXPR_struct *init1;
 struct AS_TYPE_SPEC_struct *tp1;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL is_private;
 BOOL is_readonly;
 } *AS_SHARED_DEF;

typedef struct AS_STMT_LIST_struct {/* layout for AS_STMT_LIST */
 OB_HEADER header;
 struct dAS_STMT_struct *stmts;
 struct SFILE_ID_struct source11;
 } *AS_STMT_LIST;

typedef struct AS_STR_LIT_EXPR_struct {/* layout for AS_STR_LIT_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 STR s11;
 } *AS_STR_LIT_EXPR;

typedef struct AS_TRY_STMT_struct {/* layout for AS_TRY_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e_list;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_STMT_LIST_struct *then_part;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_TRY_STMT;

typedef struct AS_TYPECASE_STMT_struct {/* layout for AS_TYPECASE_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct AS_TYPECASE_WHEN_struct *when_part;
 struct IDENT_struct name1;
 struct SFILE_ID_struct source11;
 BOOL no_else;
 BOOL transformed1;
 } *AS_TYPECASE_STMT;

typedef struct AS_TYPECASE_WHEN_struct {/* layout for AS_TYPECASE_WHEN */
 OB_HEADER header;
 struct AS_STMT_LIST_struct *then_part;
 struct AS_TYPECASE_WHEN_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_TYPECASE_WHEN;

typedef struct AS_TYPE_SPEC_struct {/* layout for AS_TYPE_SPEC */
 OB_HEADER header;
 struct AS_TYPE_SPEC_struct *next;
 struct AS_TYPE_SPEC_struct *params1;
 struct AS_TYPE_SPEC_struct *ret1;
 struct IDENT_struct name1;
 INT kind;
 struct SFILE_ID_struct source11;
 BOOL is_hot;
 } *AS_TYPE_SPEC;

typedef struct AS_UNCAUGHT_STMT_struct {/* layout for AS_UNCAUGHT_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_UNCAUGHT_STMT;

typedef struct AS_UNDERSCORE_ARG_struct {/* layout for AS_UNDERSCORE_ARG */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct AS_TYPE_SPEC_struct *tp1;
 struct SFILE_ID_struct source11;
 } *AS_UNDERSCORE_ARG;

typedef struct AS_UNLOCK_STMT_struct {/* layout for AS_UNLOCK_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list;
 struct SFILE_ID_struct source11;
 BOOL transformed;
 } *AS_UNLOCK_STMT;

typedef struct AS_VOID_EXPR_struct {/* layout for AS_VOID_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_VOID_EXPR;

typedef struct AS_WHERE_EXPR_struct {/* layout for AS_WHERE_EXPR */
 OB_HEADER header;
 struct dAS_EXPR_struct *e11;
 struct dAS_EXPR_struct *next;
 struct SFILE_ID_struct source11;
 } *AS_WHERE_EXPR;

typedef struct AS_WITH_NEAR_STMT_struct {/* layout for AS_WITH_NEAR_STMT */
 OB_HEADER header;
 struct dAS_STMT_struct *next;
 struct AS_IDENT_LIST_struct *idents;
 struct AS_STMT_LIST_struct *else_part;
 struct AS_STMT_LIST_struct *near_part;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 INT elts_size;
 struct SFILE_ID_struct source11;
 BOOL self_occurred;
 BOOL transformed1;
 } *AS_WITH_NEAR_STMT;

typedef struct AS_YIELD_STMT_struct {/* layout for AS_YIELD_STMT */
 OB_HEADER header;
 struct dAS_EXPR_struct *val11;
 struct dAS_STMT_struct *next;
 struct AS_STMT_LIST_struct *surr_stmt_list1;
 struct SFILE_ID_struct source11;
 BOOL transformed1;
 } *AS_YIELD_STMT;

typedef struct CALL_SIG_struct {/* layout for CALL_SIG */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ARRAYdCALL_TP_struct *args1;
 struct IDENT_struct name1;
 BOOL has_ret;
 BOOL unknown_ret;
 } *CALL_SIG;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct CODE_FILE_struct {/* layout for CODE_FILE */
 OB_HEADER header;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTFSTR_struct *text1;
 struct FSETdLAYOUT_struct *layouts;
 struct FSETAM_GLOBAL_EXPR_struct *globals;
 struct FSETSIG_struct *decs;
 struct FSETSIG_struct *iters;
 struct FSETSTR_struct *externs1;
 struct FSETTUPSIGSIG_struct *unboxes;
 struct FSTR_struct *ntext;
 INT length1;
 STR name1;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL do_not_merge;
 BOOL is_c_code;
 } *CODE_FILE;

typedef struct CS_OPTIONS_struct {/* layout for CS_OPTIONS */
 OB_HEADER header;
 struct ARRAYSTR_struct *args1;
 struct CGEN_struct *cgen1;
 struct CS_struct *cs1;
 struct FMAPSTRSTR_struct *module_inclusion;
 struct FSETSTR_struct *arith_in;
 struct FSETSTR_struct *arith_out;
 struct FSETSTR_struct *assert_in;
 struct FSETSTR_struct *assert_out;
 struct FSETSTR_struct *bounds_in;
 struct FSETSTR_struct *bounds_out;
 struct FSETSTR_struct *classes1;
 struct FSETSTR_struct *invariant_in;
 struct FSETSTR_struct *invariant_out;
 struct FSETSTR_struct *paths;
 struct FSETSTR_struct *post_in;
 struct FSETSTR_struct *post_out;
 struct FSETSTR_struct *pre_in;
 struct FSETSTR_struct *pre_out;
 struct FSETSTR_struct *return_in;
 struct FSETSTR_struct *return_out;
 struct FSETSTR_struct *void_in;
 struct FSETSTR_struct *void_out;
 struct FSETSTR_struct *when_in;
 struct FSETSTR_struct *when_out;
 struct INLINE_struct *inliner;
 INT next;
 struct PARSE_struct *parser;
 struct PROG_struct *prog1;
 BOOL all1;
 BOOL arith_all;
 BOOL assert_all;
 BOOL bounds_all;
 BOOL destroy_chk;
 BOOL invariant_all;
 BOOL post_all;
 BOOL pre_all;
 BOOL psather_chk;
 BOOL psather_stats;
 BOOL psather_trace;
 BOOL return_all;
 BOOL stats;
 BOOL void_all;
 BOOL when_all;
 } *CS_OPTIONS;

typedef struct ELT_TBL_struct {/* layout for ELT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ELT_struct *arr_part[1];
 } *ELT_TBL;

typedef struct FLISTdAM_CONST_struct {/* layout for FLIST{$AM_CONST} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_CONST_struct *arr_part[1];
 } *FLISTdAM_CONST;

typedef struct FLISTdAM_EXPR_struct {/* layout for FLIST{$AM_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_EXPR_struct *arr_part[1];
 } *FLISTdAM_EXPR;

typedef struct FLISTdAM_STMT_struct {/* layout for FLIST{$AM_STMT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dAM_STMT_struct *arr_part[1];
 } *FLISTdAM_STMT;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTdTP_struct {/* layout for FLIST{$TP} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FLISTdTP;

typedef struct FLISTAM_BND_CREATE_EXPR_struct {/* layout for FLIST{AM_BND_CREATE_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_CREATE_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_CREATE_EXPR;

typedef struct FLISTAM_BND_ITER_CALL_EX_struct {/* layout for FLIST{AM_BND_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_BND_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_BND_ITER_CALL_EX;

typedef struct FLISTAM_GLOBAL_EXPR_struct {/* layout for FLIST{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FLISTAM_GLOBAL_EXPR;

typedef struct FLISTAM_ITER_CALL_EXPR_struct {/* layout for FLIST{AM_ITER_CALL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ITER_CALL_EXPR_struct *arr_part[1];
 } *FLISTAM_ITER_CALL_EXPR;

typedef struct FLISTAM_LOCAL_EXPR_struct {/* layout for FLIST{AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_LOCAL_EXPR_struct *arr_part[1];
 } *FLISTAM_LOCAL_EXPR;

typedef struct FLISTAM_ROUT_DEF_struct {/* layout for FLIST{AM_ROUT_DEF} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AM_ROUT_DEF_struct *arr_part[1];
 } *FLISTAM_ROUT_DEF;

typedef struct FLISTAS_CLASS_DEF_struct {/* layout for FLIST{AS_CLASS_DEF} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct AS_CLASS_DEF_struct *arr_part[1];
 } *FLISTAS_CLASS_DEF;

typedef struct FLISTCHAR_struct {/* layout for FLIST{CHAR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FLISTCHAR;

typedef struct FLISTCODE_FILE_struct {/* layout for FLIST{CODE_FILE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *FLISTCODE_FILE;

typedef struct FLISTFLISTdAM_CONST_struct {/* layout for FLIST{FLIST{$AM_CONST}} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FLISTdAM_CONST_struct *arr_part[1];
 } *FLISTFLISTdAM_CONST;

typedef struct FLISTFSTR_struct {/* layout for FLIST{FSTR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct FSTR_struct *arr_part[1];
 } *FLISTFSTR;

typedef struct FLISTIDENT_struct {/* layout for FLIST{IDENT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FLISTIDENT;

typedef struct FLISTIFC_struct {/* layout for FLIST{IFC} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IFC_struct *arr_part[1];
 } *FLISTIFC;

typedef struct FLISTIMPL_INCLUDE_struct {/* layout for FLIST{IMPL_INCLUDE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct IMPL_INCLUDE_struct *arr_part[1];
 } *FLISTIMPL_INCLUDE;

typedef struct FLISTINT_struct {/* layout for FLIST{INT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 INT arr_part[1];
 } *FLISTINT;

typedef struct FLISTSFILE_ID_struct {/* layout for FLIST{SFILE_ID} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct SFILE_ID_struct arr_part[1];
 } *FLISTSFILE_ID;

typedef struct FLISTSIG_struct {/* layout for FLIST{SIG} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *FLISTSIG;

typedef struct FLISTSTR_struct {/* layout for FLIST{STR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 STR arr_part[1];
 } *FLISTSTR;

typedef struct FMAPdOBNAMESPACE_struct {/* layout for FMAP{$OB,NAMESPACE} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdOBNAMESPACE_struct arr_part[1];
 } *FMAPdOBNAMESPACE;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPdTPCODE_FILE_struct {/* layout for FMAP{$TP,CODE_FILE} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPCODE_FILE_struct arr_part[1];
 } *FMAPdTPCODE_FILE;

typedef struct FMAPdTPFMAPIDENTAM_GLOBA_struct {/* layout for FMAP{$TP,FMAP{IDENT,AM_GLOBAL_EXPR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPFMAPIDENTAM_GLOBAL_struct arr_part[1];
 } *FMAPdTPFMAPIDENTAM_GLOBA;

typedef struct FMAPdTPIFC_struct {/* layout for FMAP{$TP,IFC} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIFC_struct arr_part[1];
 } *FMAPdTPIFC;

typedef struct FMAPdTPIMPL_struct {/* layout for FMAP{$TP,IMPL} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPIMPL_struct arr_part[1];
 } *FMAPdTPIMPL;

typedef struct FMAPdTPINT_struct {/* layout for FMAP{$TP,INT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPINT_struct arr_part[1];
 } *FMAPdTPINT;

typedef struct FMAPAM_BND_CREATE_EXPRBO_struct {/* layout for FMAP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_BND_CREATE_EXPRBOU_struct arr_part[1];
 } *FMAPAM_BND_CREATE_EXPRBO;

typedef struct FMAPAM_LOCAL_EXPRAM_LOCA_struct {/* layout for FMAP{AM_LOCAL_EXPR,AM_LOCAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_LOCAL_EXPRAM_LOCAL_struct arr_part[1];
 } *FMAPAM_LOCAL_EXPRAM_LOCA;

typedef struct FMAPAM_ROUT_DEFFLISTAM_I_struct {/* layout for FMAP{AM_ROUT_DEF,FLIST{AM_ITER_CALL_EXPR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFLISTAM_IT_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFLISTAM_I;

typedef struct FMAPAM_ROUT_DEFFRAME_LAY_struct {/* layout for FMAP{AM_ROUT_DEF,FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFRAME_LAYO_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFRAME_LAY;

typedef struct FMAPIDENTdTP_struct {/* layout for FMAP{IDENT,$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *FMAPIDENTdTP;

typedef struct FMAPIDENTAM_GLOBAL_EXPR_struct {/* layout for FMAP{IDENT,AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTAM_GLOBAL_EXPR_struct arr_part[1];
 } *FMAPIDENTAM_GLOBAL_EXPR;

typedef struct FMAPSIGABSTRACT_FRAME_LA_struct {/* layout for FMAP{SIG,ABSTRACT_FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGABSTRACT_FRAME_LAY_struct arr_part[1];
 } *FMAPSIGABSTRACT_FRAME_LA;

typedef struct FMAPSIGAM_ROUT_DEF_struct {/* layout for FMAP{SIG,AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGAM_ROUT_DEF_struct arr_part[1];
 } *FMAPSIGAM_ROUT_DEF;

typedef struct FMAPSIGARG_LAYOUT_struct {/* layout for FMAP{SIG,ARG_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGARG_LAYOUT_struct arr_part[1];
 } *FMAPSIGARG_LAYOUT;

typedef struct FMAPSIGSTR_struct {/* layout for FMAP{SIG,STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGSTR_struct arr_part[1];
 } *FMAPSIGSTR;

typedef struct FMAPSTRFSETSTR_struct {/* layout for FMAP{STR,FSET{STR}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRFSETSTR_struct arr_part[1];
 } *FMAPSTRFSETSTR;

typedef struct FMAPSTRINT_struct {/* layout for FMAP{STR,INT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRINT_struct arr_part[1];
 } *FMAPSTRINT;

typedef struct FMAPSTRITER_INLINE_struct {/* layout for FMAP{STR,ITER_INLINE} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRITER_INLINE_struct arr_part[1];
 } *FMAPSTRITER_INLINE;

typedef struct FMAPSTRSIG_struct {/* layout for FMAP{STR,SIG} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSIG_struct arr_part[1];
 } *FMAPSTRSIG;

typedef struct FMAPSTRSTR_struct {/* layout for FMAP{STR,STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSTR_struct arr_part[1];
 } *FMAPSTRSTR;

typedef struct FMAPTP_CLASSFSETdTP_struct {/* layout for FMAP{TP_CLASS,FSET{$TP}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPTP_CLASSFSETdTP_struct arr_part[1];
 } *FMAPTP_CLASSFSETdTP;

typedef struct FMAPTP_CLASSFSETTP_CLASS_struct {/* layout for FMAP{TP_CLASS,FSET{TP_CLASS}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPTP_CLASSFSETTP_CLASS_struct arr_part[1];
 } *FMAPTP_CLASSFSETTP_CLASS;

typedef struct FSETdLAYOUT_struct {/* layout for FSET{$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FSETdLAYOUT;

typedef struct FSETdTP_struct {/* layout for FSET{$TP} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *FSETdTP;

typedef struct FSETABSTRACT_LAYOUT_struct {/* layout for FSET{ABSTRACT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ABSTRACT_LAYOUT_struct *arr_part[1];
 } *FSETABSTRACT_LAYOUT;

typedef struct FSETAM_GLOBAL_EXPR_struct {/* layout for FSET{AM_GLOBAL_EXPR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AM_GLOBAL_EXPR_struct *arr_part[1];
 } *FSETAM_GLOBAL_EXPR;

typedef struct FSETAM_ROUT_DEF_struct {/* layout for FSET{AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AM_ROUT_DEF_struct *arr_part[1];
 } *FSETAM_ROUT_DEF;

typedef struct FSETAS_FEAT_MOD_struct {/* layout for FSET{AS_FEAT_MOD} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct AS_FEAT_MOD_struct *arr_part[1];
 } *FSETAS_FEAT_MOD;

typedef struct FSETBOUND_TYPE_LAYOUT_struct {/* layout for FSET{BOUND_TYPE_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BOUND_TYPE_LAYOUT_struct *arr_part[1];
 } *FSETBOUND_TYPE_LAYOUT;

typedef struct FSETBUILTIN_LAYOUT_struct {/* layout for FSET{BUILTIN_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BUILTIN_LAYOUT_struct *arr_part[1];
 } *FSETBUILTIN_LAYOUT;

typedef struct FSETCLASS_LAYOUT_struct {/* layout for FSET{CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct CLASS_LAYOUT_struct *arr_part[1];
 } *FSETCLASS_LAYOUT;

typedef struct FSETEXTERNAL_LAYOUT_struct {/* layout for FSET{EXTERNAL_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct EXTERNAL_LAYOUT_struct *arr_part[1];
 } *FSETEXTERNAL_LAYOUT;

typedef struct FSETIDENT_struct {/* layout for FSET{IDENT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *FSETIDENT;

typedef struct FSETSIG_struct {/* layout for FSET{SIG} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct SIG_struct *arr_part[1];
 } *FSETSIG;

typedef struct FSETSTR_struct {/* layout for FSET{STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 STR arr_part[1];
 } *FSETSTR;

typedef struct FSETTP_CLASS_struct {/* layout for FSET{TP_CLASS} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TP_CLASS_struct *arr_part[1];
 } *FSETTP_CLASS;

typedef struct FSETTUPIDENTIDENT_struct {/* layout for FSET{TUP{IDENT,IDENT}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTIDENT_struct arr_part[1];
 } *FSETTUPIDENTIDENT;

typedef struct FSETTUPIDENTINT_struct {/* layout for FSET{TUP{IDENT,INT}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPIDENTINT_struct arr_part[1];
 } *FSETTUPIDENTINT;

typedef struct FSETTUPSIGSIG_struct {/* layout for FSET{TUP{SIG,SIG}} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGSIG_struct arr_part[1];
 } *FSETTUPSIGSIG;

typedef struct FSETVALUE_CLASS_LAYOUT_struct {/* layout for FSET{VALUE_CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct VALUE_CLASS_LAYOUT_struct *arr_part[1];
 } *FSETVALUE_CLASS_LAYOUT;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct IDENT_TBL_struct {/* layout for IDENT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *IDENT_TBL;

typedef struct INLINE_struct {/* layout for INLINE */
 OB_HEADER header;
 struct INLINE_ITER_TBL_struct *itbl;
 struct INLINE_ROUT_TBL_struct *rtbl;
 INT iter_thres;
 INT rout_thres;
 struct PROG_struct *prog1;
 BOOL inline_iters;
 BOOL inline_routs;
 } *INLINE;

typedef struct INLINE_ITER_TBL_struct {/* layout for INLINE_ITER_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ITER_SIG_struct *arr_part[1];
 } *INLINE_ITER_TBL;

typedef struct INLINE_ROUT_TBL_struct {/* layout for INLINE_ROUT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct dINLINE_ROUT_SIG_struct *arr_part[1];
 } *INLINE_ROUT_TBL;

typedef struct LAYOUT_ARR_struct {/* layout for LAYOUT_ARR */
 OB_HEADER header;
 INT asize;
 struct TUPIDENTdTP_struct arr_part[1];
 } *LAYOUT_ARR;

typedef struct NAMEMAP_struct {/* layout for NAMEMAP */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdOBSTR_struct arr_part[1];
 } *NAMEMAP;

typedef struct PARSER_struct {/* layout for PARSER */
 OB_HEADER header;
 struct FLISTSTR_struct *entered;
 struct PROG_struct *prog1;
 struct SCANNER_struct *scanner;
 struct TOKEN_struct next;
 } *PARSER;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern BOOL SFILE_ID_newline;
extern BOOL TRANS_do_direct_export;
extern BOOL TRANS_do_helper_export;
extern BOOL TRANS_do_helper_import;
extern CALL_TP_ARRAY CALL_TP_ARRAY_cache;
extern CALL_TP_CREATE CALL_TP_CREATE_cache;
extern CALL_TP_VOID CALL_TP_VOID_cache;
extern CGEN CODE_FILE_cgen;
extern CGEN LAYOUT_TBL_cgen;
extern CHAR SFILE_ID_eof_char;
extern FLISTCODE_FILE CODE_FILE_all;
extern FLISTCODE_FILE CODE_FILE_todo;
extern FLISTINT SFILE_ID_lines;
extern FLISTSTR CODE_FILE_layout_text;
extern FLISTSTR SFILE_ID_files;
extern FLISTdLAYOUT CODE_FILE_layout_order;
extern FLT FLT_log2_e;
extern FLTD MS_RANDOM_GEN_ms_a;
extern FLTD MS_RANDOM_GEN_ms_m;
extern FLTD MS_RANDOM_GEN_ms_md;
extern FLTD TIME_time_at_start;
extern FMAPAM_BND_CREATE_EXPRBO BOUND_OBJECT_LAYOUT_layo1;
extern FMAPAM_ROUT_DEFFRAME_LAY FRAME_LAYOUT_layouts;
extern FMAPSIGABSTRACT_FRAME_LA ABSTRACT_FRAME_LAYOUT_la1;
extern FMAPSIGAM_ROUT_DEF CODE_FILE_iter_sigs;
extern FMAPSIGARG_LAYOUT ARG_LAYOUT_layouts;
extern FMAPSTRSIG SIG_sigs;
extern FMAPSTRSTR CODE_FILE_thumbprints;
extern FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl;
extern FSETABSTRACT_LAYOUT ABSTRACT_LAYOUT_layouts;
extern FSETBOUND_TYPE_LAYOUT BOUND_TYPE_LAYOUT_layout1;
extern FSETBUILTIN_LAYOUT BUILTIN_LAYOUT_layouts;
extern FSETCLASS_LAYOUT CLASS_LAYOUT_layouts;
extern FSETEXTERNAL_LAYOUT EXTERNAL_LAYOUT_layouts;
extern FSETVALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_layou1;
extern FSTR FLTD_fdbuf;
extern FSTR FLT_fbuf;
extern FSTR INTI_buf;
extern FSTR INT_buf;
extern FSTR SFILE_ID_source;
extern FSTR STR_buf;
extern IDENT IDENT_BUILTIN_AREF_ident1;
extern IDENT IDENT_BUILTIN_ARRAY_iden1;
extern IDENT IDENT_BUILTIN_ARR_ident;
extern IDENT IDENT_BUILTIN_AVAL_ident1;
extern IDENT IDENT_BUILTIN_FLTDX_iden1;
extern IDENT IDENT_BUILTIN_FLTD_ident1;
extern IDENT IDENT_BUILTIN_FLTX_ident1;
extern IDENT IDENT_BUILTIN_FLT_ident;
extern IDENT IDENT_BUILTIN_GATE_ident1;
extern IDENT IDENT_BUILTIN_INTI_ident1;
extern IDENT IDENT_BUILTIN_INT_ident;
extern IDENT IDENT_BUILTIN_SYS_ident;
extern IDENT IDENT_BUILTIN_aget_ident1;
extern IDENT IDENT_BUILTIN_aset_ident1;
extern IDENT IDENT_BUILTIN_asize_iden1;
extern IDENT IDENT_BUILTIN_bang_ident1;
extern IDENT IDENT_BUILTIN_call_bang_1;
extern IDENT IDENT_BUILTIN_call_ident1;
extern IDENT IDENT_BUILTIN_create_ide1;
extern IDENT IDENT_BUILTIN_div_ident;
extern IDENT IDENT_BUILTIN_dollar_OB_1;
extern IDENT IDENT_BUILTIN_invariant_1;
extern IDENT IDENT_BUILTIN_is_eq_iden1;
extern IDENT IDENT_BUILTIN_is_geq_ide1;
extern IDENT IDENT_BUILTIN_is_gt_iden1;
extern IDENT IDENT_BUILTIN_is_leq_ide1;
extern IDENT IDENT_BUILTIN_is_lt_iden1;
extern IDENT IDENT_BUILTIN_is_neq_ide1;
extern IDENT IDENT_BUILTIN_main_ident1;
extern IDENT IDENT_BUILTIN_minus_iden1;
extern IDENT IDENT_BUILTIN_mod_ident;
extern IDENT IDENT_BUILTIN_negate_ide1;
extern IDENT IDENT_BUILTIN_not_ident;
extern IDENT IDENT_BUILTIN_ob_eq_iden1;
extern IDENT IDENT_BUILTIN_plus_ident1;
extern IDENT IDENT_BUILTIN_pow_ident;
extern IDENT IDENT_BUILTIN_ret_ident;
extern IDENT IDENT_BUILTIN_self_ident1;
extern IDENT IDENT_BUILTIN_times_iden1;
extern IDENT_TBL IDENT_ident_tbl;
extern INT ARRAYFSTR_quicksort_limi;
extern INT ARRAYSTR_quicksort_limit;
extern INT ARRAYdTP_quicksort_limit;
extern INT AS_CLASS_DEF_abs;
extern INT AS_CLASS_DEF_ext;
extern INT AS_CLASS_DEF_ref;
extern INT AS_CLASS_DEF_spr;
extern INT AS_CLASS_DEF_val;
extern INT AS_FLT_LIT_EXPR_flt;
extern INT AS_FLT_LIT_EXPR_fltd;
extern INT AS_FLT_LIT_EXPR_fltdx;
extern INT AS_FLT_LIT_EXPR_flti;
extern INT AS_FLT_LIT_EXPR_fltx;
extern INT AS_OUT_indent;
extern INT AS_TYPE_SPEC_it;
extern INT AS_TYPE_SPEC_ord;
extern INT AS_TYPE_SPEC_rt;
extern INT AS_TYPE_SPEC_same;
extern INT CODE_FILE_ARRAY_quicksor1;
extern INT ELT_TBL_load_ratio;
extern INT FMAPAM_BND_CREATE_EXPRBO12;
extern INT FMAPAM_LOCAL_EXPRAM_LOCA7;
extern INT FMAPAM_ROUT_DEFFLISTAM_I8;
extern INT FMAPAM_ROUT_DEFFRAME_LAY12;
extern INT FMAPIDENTAM_GLOBAL_EXPR_11;
extern INT FMAPIDENTdTP_load_ratio;
extern INT FMAPSIGABSTRACT_FRAME_LA12;
extern INT FMAPSIGAM_ROUT_DEF_load_;
extern INT FMAPSIGSTR_load_ratio;
extern INT FMAPSTRFSETSTR_load_rati;
extern INT FMAPSTRINT_load_ratio;
extern INT FMAPSTRITER_INLINE_load_;
extern INT FMAPSTRSIG_load_ratio;
extern INT FMAPSTRSTR_load_ratio;
extern INT FMAPTP_CLASSFSETTP_CLASS12;
extern INT FMAPTP_CLASSFSETdTP_load;
extern INT FMAPdOBNAMESPACE_load_ra;
extern INT FMAPdTPCODE_FILE_load_ra;
extern INT FMAPdTPFMAPIDENTAM_GLOBA12;
extern INT FMAPdTPIFC_load_ratio;
extern INT FMAPdTPIMPL_load_ratio;
extern INT FMAPdTPINT_load_ratio;
extern INT FMAPdTPdLAYOUT_load_rati;
extern INT FSETABSTRACT_LAYOUT_load;
extern INT FSETAM_GLOBAL_EXPR_load_;
extern INT FSETAM_ROUT_DEF_load_rat;
extern INT FSETAS_FEAT_MOD_load_rat;
extern INT FSETBOUND_TYPE_LAYOUT_lo;
extern INT FSETBUILTIN_LAYOUT_load_;
extern INT FSETCLASS_LAYOUT_load_ra;
extern INT FSETEXTERNAL_LAYOUT_load;
extern INT FSETIDENT_load_ratio;
extern INT FSETSIG_load_ratio;
extern INT FSETSTR_load_ratio;
extern INT FSETTP_CLASS_load_ratio;
extern INT FSETTUPIDENTIDENT_load_r;
extern INT FSETTUPIDENTINT_load_rat;
extern INT FSETTUPSIGSIG_load_ratio;
extern INT FSETVALUE_CLASS_LAYOUT_l;
extern INT FSETdLAYOUT_load_ratio;
extern INT FSETdTP_load_ratio;
extern INT IDENT_TBL_load_ratio;
extern INT IDENT_tmp_count;
extern INT INLINE_ATTR_READ_inlined1;
extern INT INLINE_ATTR_READ_routine1;
extern INT INLINE_ATTR_WRITE_inline1;
extern INT INLINE_ATTR_WRITE_routin1;
extern INT INLINE_GLOBAL_READ_inlin1;
extern INT INLINE_GLOBAL_READ_routi1;
extern INT INLINE_INT_FOLD_inlined;
extern INT INLINE_INT_FOLD_routines1;
extern INT INLINE_ITER_TBL_load_rat;
extern INT INLINE_ITER_inlined;
extern INT INLINE_ITER_iters;
extern INT INLINE_ROUT_TBL_load_rat;
extern INT INLINE_ROUT_inlined;
extern INT INLINE_ROUT_routines;
extern INT INLINE_VATTR_WRITE_inlin1;
extern INT INLINE_VATTR_WRITE_routi1;
extern INT INLINE_default_iter_thre;
extern INT INLINE_default_rout_thre;
extern INT INTI_B;
extern INT INTI_D;
extern INT INTI_log10D;
extern INT INTI_log2B;
extern INT INT_asize;
extern INT LAYOUT_ARRAY_quicksort_l;
extern INT LAYOUT_ARR_quicksort_lim;
extern INT NAMEMAP_load_ratio;
extern INT PARSER_ITER_tok;
extern INT PARSER_ROUT_tok;
extern INT PARSER_SAME_tok;
extern INT PARSER_and_tok;
extern INT PARSER_any_tok;
extern INT PARSER_assert_tok;
extern INT PARSER_assign_tok;
extern INT PARSER_at_tok;
extern INT PARSER_attach_tok;
extern INT PARSER_attr_tok;
extern INT PARSER_bang_tok;
extern INT PARSER_break_tok;
extern INT PARSER_case_tok;
extern INT PARSER_class_tok;
extern INT PARSER_cluster_bang_tok;
extern INT PARSER_cluster_tok;
extern INT PARSER_cohort_tok;
extern INT PARSER_colon_tok;
extern INT PARSER_comma_tok;
extern INT PARSER_const_tok;
extern INT PARSER_dcolon_tok;
extern INT PARSER_do_tok;
extern INT PARSER_dot_tok;
extern INT PARSER_else_tok;
extern INT PARSER_elsif_tok;
extern INT PARSER_end_tok;
extern INT PARSER_eof_tok;
extern INT PARSER_exception_tok;
extern INT PARSER_external_tok;
extern INT PARSER_false_tok;
extern INT PARSER_far_tok;
extern INT PARSER_fork_tok;
extern INT PARSER_here_tok;
extern INT PARSER_ident_tok;
extern INT PARSER_if_tok;
extern INT PARSER_include_tok;
extern INT PARSER_initial_tok;
extern INT PARSER_is_eq_tok;
extern INT PARSER_is_geq_tok;
extern INT PARSER_is_gt_tok;
extern INT PARSER_is_leq_tok;
extern INT PARSER_is_lt_tok;
extern INT PARSER_is_neq_tok;
extern INT PARSER_is_tok;
extern INT PARSER_iter_bang_tok;
extern INT PARSER_lbrace_tok;
extern INT PARSER_lbracket_tok;
extern INT PARSER_lchar_tok;
extern INT PARSER_lflt_tok;
extern INT PARSER_lint_tok;
extern INT PARSER_lock_tok;
extern INT PARSER_loop_tok;
extern INT PARSER_lparen_tok;
extern INT PARSER_lstr_tok;
extern INT PARSER_minus_tok;
extern INT PARSER_mod_tok;
extern INT PARSER_near_tok;
extern INT PARSER_new_tok;
extern INT PARSER_not_tok;
extern INT PARSER_null_tok;
extern INT PARSER_or_tok;
extern INT PARSER_par_tok;
extern INT PARSER_parloop_tok;
extern INT PARSER_plus_tok;
extern INT PARSER_post_tok;
extern INT PARSER_pow_tok;
extern INT PARSER_pre_tok;
extern INT PARSER_private_tok;
extern INT PARSER_protect_tok;
extern INT PARSER_quit_tok;
extern INT PARSER_quotient_tok;
extern INT PARSER_raise_tok;
extern INT PARSER_rbrace_tok;
extern INT PARSER_rbracket_tok;
extern INT PARSER_readonly_tok;
extern INT PARSER_result_tok;
extern INT PARSER_return_tok;
extern INT PARSER_rparen_tok;
extern INT PARSER_self_tok;
extern INT PARSER_semi_tok;
extern INT PARSER_shared_tok;
extern INT PARSER_sharp_tok;
extern INT PARSER_spread_tok;
extern INT PARSER_then_tok;
extern INT PARSER_times_tok;
extern INT PARSER_transform_tok;
extern INT PARSER_true_tok;
extern INT PARSER_try_tok;
extern INT PARSER_type_name_tok;
extern INT PARSER_type_tok;
extern INT PARSER_typecase_tok;
extern INT PARSER_under_tok;
extern INT PARSER_unlock_tok;
extern INT PARSER_until_tok;
extern INT PARSER_value_tok;
extern INT PARSER_vbar_tok;
extern INT PARSER_void_tok;
extern INT PARSER_when_tok;
extern INT PARSER_where_tok;
extern INT PARSER_while_tok;
extern INT PARSER_with_tok;
extern INT PARSER_yield_tok;
extern INT PROG_AS_TBL_load_ratio;
extern INT SCANNER_ITER_tok;
extern INT SCANNER_ROUT_tok;
extern INT SCANNER_SAME_tok;
extern INT SCANNER_and_tok;
extern INT SCANNER_any_tok;
extern INT SCANNER_assert_tok;
extern INT SCANNER_assign_tok;
extern INT SCANNER_at_tok;
extern INT SCANNER_attach_tok;
extern INT SCANNER_attr_tok;
extern INT SCANNER_bang_tok;
extern INT SCANNER_break_tok;
extern INT SCANNER_case_tok;
extern INT SCANNER_class_tok;
extern INT SCANNER_cluster_bang_tok;
extern INT SCANNER_cluster_tok;
extern INT SCANNER_cohort_tok;
extern INT SCANNER_colon_tok;
extern INT SCANNER_comma_tok;
extern INT SCANNER_const_tok;
extern INT SCANNER_dcolon_tok;
extern INT SCANNER_do_tok;
extern INT SCANNER_dot_tok;
extern INT SCANNER_else_tok;
extern INT SCANNER_elsif_tok;
extern INT SCANNER_end_tok;
extern INT SCANNER_eof_tok;
extern INT SCANNER_exception_tok;
extern INT SCANNER_external_tok;
extern INT SCANNER_false_tok;
extern INT SCANNER_far_tok;
extern INT SCANNER_fork_tok;
extern INT SCANNER_here_tok;
extern INT SCANNER_ident_tok;
extern INT SCANNER_if_tok;
extern INT SCANNER_include_tok;
extern INT SCANNER_initial_tok;
extern INT SCANNER_is_eq_tok;
extern INT SCANNER_is_geq_tok;
extern INT SCANNER_is_gt_tok;
extern INT SCANNER_is_leq_tok;
extern INT SCANNER_is_lt_tok;
extern INT SCANNER_is_neq_tok;
extern INT SCANNER_is_tok;
extern INT SCANNER_iter_bang_tok;
extern INT SCANNER_lbrace_tok;
extern INT SCANNER_lbracket_tok;
extern INT SCANNER_lchar_tok;
extern INT SCANNER_lflt_tok;
extern INT SCANNER_lint_tok;
extern INT SCANNER_lock_tok;
extern INT SCANNER_loop_tok;
extern INT SCANNER_lparen_tok;
extern INT SCANNER_lstr_tok;
extern INT SCANNER_minus_tok;
extern INT SCANNER_mod_tok;
extern INT SCANNER_near_tok;
extern INT SCANNER_new_tok;
extern INT SCANNER_not_tok;
extern INT SCANNER_null_tok;
extern INT SCANNER_or_tok;
extern INT SCANNER_par_tok;
extern INT SCANNER_parloop_tok;
extern INT SCANNER_plus_tok;
extern INT SCANNER_post_tok;
extern INT SCANNER_pow_tok;
extern INT SCANNER_pre_tok;
extern INT SCANNER_private_tok;
extern INT SCANNER_protect_tok;
extern INT SCANNER_quit_tok;
extern INT SCANNER_quotient_tok;
extern INT SCANNER_raise_tok;
extern INT SCANNER_rbrace_tok;
extern INT SCANNER_rbracket_tok;
extern INT SCANNER_readonly_tok;
extern INT SCANNER_result_tok;
extern INT SCANNER_return_tok;
extern INT SCANNER_rparen_tok;
extern INT SCANNER_self_tok;
extern INT SCANNER_semi_tok;
extern INT SCANNER_shared_tok;
extern INT SCANNER_sharp_tok;
extern INT SCANNER_spread_tok;
extern INT SCANNER_then_tok;
extern INT SCANNER_times_tok;
extern INT SCANNER_transform_tok;
extern INT SCANNER_true_tok;
extern INT SCANNER_try_tok;
extern INT SCANNER_type_name_tok;
extern INT SCANNER_type_tok;
extern INT SCANNER_typecase_tok;
extern INT SCANNER_under_tok;
extern INT SCANNER_unlock_tok;
extern INT SCANNER_until_tok;
extern INT SCANNER_value_tok;
extern INT SCANNER_vbar_tok;
extern INT SCANNER_void_tok;
extern INT SCANNER_when_tok;
extern INT SCANNER_where_tok;
extern INT SCANNER_while_tok;
extern INT SCANNER_with_tok;
extern INT SCANNER_yield_tok;
extern INT SFILE_ID_B;
extern INT SFILE_ID_column;
extern INT SFILE_ID_line;
extern INT SFILE_ID_line_pos;
extern INT SFILE_ID_pos;
extern INT SFILE_ID_sentinel;
extern INT SIG_TBL_load_ratio;
extern INT STR_CURSOR_Bad_Digit;
extern INT STR_CURSOR_Int_No_Bits;
extern INT STR_CURSOR_Max_Int_Digit;
extern INT STR_CURSOR_No_Error;
extern INT STR_CURSOR_Past_BOBuf;
extern INT STR_CURSOR_Past_EOBuf;
extern INT STR_CURSOR_Too_Many_Digi;
extern INT TOKEN_ITER_tok;
extern INT TOKEN_ROUT_tok;
extern INT TOKEN_SAME_tok;
extern INT TOKEN_and_tok;
extern INT TOKEN_any_tok;
extern INT TOKEN_assert_tok;
extern INT TOKEN_assign_tok;
extern INT TOKEN_at_tok;
extern INT TOKEN_attach_tok;
extern INT TOKEN_attr_tok;
extern INT TOKEN_bang_tok;
extern INT TOKEN_break_tok;
extern INT TOKEN_case_tok;
extern INT TOKEN_class_tok;
extern INT TOKEN_cluster_bang_tok;
extern INT TOKEN_cluster_tok;
extern INT TOKEN_cohort_tok;
extern INT TOKEN_colon_tok;
extern INT TOKEN_comma_tok;
extern INT TOKEN_const_tok;
extern INT TOKEN_dcolon_tok;
extern INT TOKEN_do_tok;
extern INT TOKEN_dot_tok;
extern INT TOKEN_else_tok;
extern INT TOKEN_elsif_tok;
extern INT TOKEN_end_tok;
extern INT TOKEN_eof_tok;
extern INT TOKEN_exception_tok;
extern INT TOKEN_external_tok;
extern INT TOKEN_false_tok;
extern INT TOKEN_far_tok;
extern INT TOKEN_fork_tok;
extern INT TOKEN_here_tok;
extern INT TOKEN_ident_tok;
extern INT TOKEN_if_tok;
extern INT TOKEN_include_tok;
extern INT TOKEN_initial_tok;
extern INT TOKEN_is_eq_tok;
extern INT TOKEN_is_geq_tok;
extern INT TOKEN_is_gt_tok;
extern INT TOKEN_is_leq_tok;
extern INT TOKEN_is_lt_tok;
extern INT TOKEN_is_neq_tok;
extern INT TOKEN_is_tok;
extern INT TOKEN_iter_bang_tok;
extern INT TOKEN_lbrace_tok;
extern INT TOKEN_lbracket_tok;
extern INT TOKEN_lchar_tok;
extern INT TOKEN_lflt_tok;
extern INT TOKEN_lint_tok;
extern INT TOKEN_lock_tok;
extern INT TOKEN_loop_tok;
extern INT TOKEN_lparen_tok;
extern INT TOKEN_lstr_tok;
extern INT TOKEN_minus_tok;
extern INT TOKEN_mod_tok;
extern INT TOKEN_near_tok;
extern INT TOKEN_new_tok;
extern INT TOKEN_not_tok;
extern INT TOKEN_null_tok;
extern INT TOKEN_or_tok;
extern INT TOKEN_par_tok;
extern INT TOKEN_parloop_tok;
extern INT TOKEN_plus_tok;
extern INT TOKEN_post_tok;
extern INT TOKEN_pow_tok;
extern INT TOKEN_pre_tok;
extern INT TOKEN_private_tok;
extern INT TOKEN_protect_tok;
extern INT TOKEN_quit_tok;
extern INT TOKEN_quotient_tok;
extern INT TOKEN_raise_tok;
extern INT TOKEN_rbrace_tok;
extern INT TOKEN_rbracket_tok;
extern INT TOKEN_readonly_tok;
extern INT TOKEN_return_tok;
extern INT TOKEN_rparen_tok;
extern INT TOKEN_self_tok;
extern INT TOKEN_semi_tok;
extern INT TOKEN_shared_tok;
extern INT TOKEN_sharp_tok;
extern INT TOKEN_spread_tok;
extern INT TOKEN_then_tok;
extern INT TOKEN_times_tok;
extern INT TOKEN_transform_tok;
extern INT TOKEN_true_tok;
extern INT TOKEN_try_tok;
extern INT TOKEN_type_name_tok;
extern INT TOKEN_type_tok;
extern INT TOKEN_typecase_tok;
extern INT TOKEN_under_tok;
extern INT TOKEN_unlock_tok;
extern INT TOKEN_until_tok;
extern INT TOKEN_value_tok;
extern INT TOKEN_vbar_tok;
extern INT TOKEN_void_tok;
extern INT TOKEN_when_tok;
extern INT TOKEN_where_tok;
extern INT TOKEN_while_tok;
extern INT TOKEN_with_tok;
extern INT TOKEN_yield_tok;
extern INT TP_ARRAY_quicksort_limit;
extern INT TP_CLASS_TBL_load_ratio;
extern INT TP_ITER_TBL_load_ratio;
extern INT TP_KIND_abs_tp;
extern INT TP_KIND_ext_tp;
extern INT TP_KIND_iter_tp;
extern INT TP_KIND_missing_tp;
extern INT TP_KIND_ref_tp;
extern INT TP_KIND_rout_tp;
extern INT TP_KIND_spr_tp;
extern INT TP_KIND_val_tp;
extern INT TP_ROUT_TBL_load_ratio;
extern INT TRANS_att_code;
extern INT TRANS_export_code;
extern INT TRANS_frk_code;
extern INT TRANS_import_code;
extern INT TRANS_par_code;
extern INT WEIGH_CODE_assign_weight;
extern INT WEIGH_CODE_if_weight;
extern INT WEIGH_CODE_iter_call_wei;
extern INT WEIGH_CODE_rout_call_wei;
extern MS_RANDOM_GEN RND_s_gen;
extern PROG AS_OUT_prog;
extern PROG CODE_FILE_prog;
extern PROG LAYOUT_TBL_prog;
extern STR CODE_FILE_dir;
extern TP_CLASS TP_BUILTIN_arr_of_str;
extern TP_CLASS TP_BUILTIN_bool;
extern TP_CLASS TP_BUILTIN_char;
extern TP_CLASS TP_BUILTIN_cleared_ex;
extern TP_CLASS TP_BUILTIN_dollar_lock;
extern TP_CLASS TP_BUILTIN_dollar_ob;
extern TP_CLASS TP_BUILTIN_ext_ob;
extern TP_CLASS TP_BUILTIN_flt;
extern TP_CLASS TP_BUILTIN_fltd;
extern TP_CLASS TP_BUILTIN_fltdx;
extern TP_CLASS TP_BUILTIN_flti;
extern TP_CLASS TP_BUILTIN_fltx;
extern TP_CLASS TP_BUILTIN_gate;
extern TP_CLASS TP_BUILTIN_int;
extern TP_CLASS TP_BUILTIN_inti;
extern TP_CLASS TP_BUILTIN_mutex;
extern TP_CLASS TP_BUILTIN_str;
extern TP_CLASS TP_BUILTIN_sys;
extern TP_ROUT TP_BUILTIN_rout;

/* Function declarations */

BOOL SYS_ob_eq_dOB_dOB_BOOL(SYS, OB, OB);
INT INT_pow_INT_INT(INT, INT);
INT sather_main(CS, ARRAYSTR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




BOOL SYS_ob_eq_dOB_dOB_BOOL(SYS self, OB o1, OB o2) {
 BOOL ret_val = ((BOOL) 0);
 extern STR SYSob_eqdOBdOBBOOLundefi;
 RAISE(((OB) ((STR) &SYSob_eqdOBdOBBOOLundefi)));
 FATAL("Last statement wasn't return");
}

int main(int argc, char *argv[]) {
 FLTD L1;

 CS main_ob;
 ARRAYSTR main_args;
 int i,j,length;
 STR s;
 int res=0;
 INTI_B = INT_pow_INT_INT(2, INTI_log2B);
 INTI_D = INT_pow_INT_INT(10, INTI_log10D);
 IDENT_BUILTIN_dollar_OB_1 = IDENT_zero;
 IDENT_BUILTIN_ARR_ident = IDENT_zero;
 IDENT_BUILTIN_INT_ident = IDENT_zero;
 IDENT_BUILTIN_INTI_ident1 = IDENT_zero;
 IDENT_BUILTIN_FLT_ident = IDENT_zero;
 IDENT_BUILTIN_FLTD_ident1 = IDENT_zero;
 IDENT_BUILTIN_FLTDX_iden1 = IDENT_zero;
 IDENT_BUILTIN_FLTX_ident1 = IDENT_zero;
 IDENT_BUILTIN_plus_ident1 = IDENT_zero;
 IDENT_BUILTIN_minus_iden1 = IDENT_zero;
 IDENT_BUILTIN_times_iden1 = IDENT_zero;
 IDENT_BUILTIN_div_ident = IDENT_zero;
 IDENT_BUILTIN_pow_ident = IDENT_zero;
 IDENT_BUILTIN_mod_ident = IDENT_zero;
 IDENT_BUILTIN_is_lt_iden1 = IDENT_zero;
 IDENT_BUILTIN_is_leq_ide1 = IDENT_zero;
 IDENT_BUILTIN_is_gt_iden1 = IDENT_zero;
 IDENT_BUILTIN_is_geq_ide1 = IDENT_zero;
 IDENT_BUILTIN_negate_ide1 = IDENT_zero;
 IDENT_BUILTIN_not_ident = IDENT_zero;
 IDENT_BUILTIN_AVAL_ident1 = IDENT_zero;
 IDENT_BUILTIN_AREF_ident1 = IDENT_zero;
 IDENT_BUILTIN_aget_ident1 = IDENT_zero;
 IDENT_BUILTIN_aset_ident1 = IDENT_zero;
 IDENT_BUILTIN_call_ident1 = IDENT_zero;
 IDENT_BUILTIN_call_bang_1 = IDENT_zero;
 IDENT_BUILTIN_create_ide1 = IDENT_zero;
 IDENT_BUILTIN_ARRAY_iden1 = IDENT_zero;
 IDENT_BUILTIN_ret_ident = IDENT_zero;
 IDENT_BUILTIN_self_ident1 = IDENT_zero;
 IDENT_BUILTIN_invariant_1 = IDENT_zero;
 IDENT_BUILTIN_asize_iden1 = IDENT_zero;
 IDENT_BUILTIN_main_ident1 = IDENT_zero;
 IDENT_BUILTIN_is_eq_iden1 = IDENT_zero;
 IDENT_BUILTIN_is_neq_ide1 = IDENT_zero;
 IDENT_BUILTIN_GATE_ident1 = IDENT_zero;
 IDENT_BUILTIN_ob_eq_iden1 = IDENT_zero;
 IDENT_BUILTIN_bang_ident1 = IDENT_zero;
 IDENT_BUILTIN_SYS_ident = IDENT_zero;
 MS_RANDOM_GEN_ms_a = 1.6807e4;
 L1 = (M_LOG2E);
 FLT_log2_e = ((FLT)L1);
 main_ob = ((CS) rt_alloc_atomic(sizeof(struct CS_struct), CS_tag));
 main_args = ((ARRAYSTR) rt_arr_alloc(sizeof(struct ARRAYSTR_struct), ARRAYSTR_tag, sizeof(STR) , argc));
 main_args->asize = argc;
 for (i=0;i<argc;i++) {
  for (length=0; argv[i][length]!=0; length++);
  s = ((STR) rt_arr_alloc_atomic(sizeof(struct STR_struct), STR_tag, sizeof(CHAR) , length));
  s->asize = length;
  for (j=0;j<length;j++) s->arr_part[j] = argv[i][j];
  main_args->arr_part[i] = s;
 }
 rt_start(argv[0]);
 PROTECT_BEGIN
  res = sather_main(main_ob,main_args);
  rt_stop();
 PROTECT_WHEN
  if (EXCEPTION->header.tag==STR_tag) fprintf(stderr,"Uncaught STR exception: %s\n",((STR)EXCEPTION)->arr_part);
  else fprintf(stderr,"Uncaught exception\n");
  abort();
 PROTECT_END
 return res;
}


STR gen_SYS_str_for_tp(INT i) {

 extern STR TUPdLAYOUTdLAYOUT1;
 extern STR AM_STR_CONST1;
 extern STR FSETdLAYOUT1;
 extern STR TUPdTPIFC1;
 extern STR TUPAM_BND_CREATE_EXPRAM_2;
 extern STR AM_CASE_STMT1;
 extern STR IMPORT_EXPORT_TBL1;
 extern STR AM_ARR_CONST1;
 extern STR FSETBOUND_TYPE_LAYOUT1;
 extern STR TUPCHARCHAR1;
 extern STR FSETIDENT1;
 extern STR TP_GRAPH_ABS_DES1;
 extern STR AM_UNCAUGHT_STMT1;
 extern STR AS_ROUT_DEF1;
 extern STR WEIGH_CODE1;
 extern STR CALL_SIG1;
 extern STR TUPAM_ROUT_DEFFRAME_LAYO3;
 extern STR AS_RAISE_STMT1;
 extern STR ARG_LAYOUT1;
 extern STR AM_PRE_STMT1;
 extern STR CGEN1;
 extern STR SFILE_ID1;
 extern STR EXTERNAL_LAYOUT1;
 extern STR AS_CLUSTER_EXPR1;
 extern STR AM_ANY_EXPR1;
 extern STR INT1;
 extern STR FMAPAM_ROUT_DEFFLISTAM_I20;
 extern STR FMAPSIGABSTRACT_FRAME_LA19;
 extern STR AM_GLOBAL_EXPR1;
 extern STR AS_ATTR_DEF1;
 extern STR CALL_TP_UNDERSCORE1;
 extern STR ARRAYARRAYSTR1;
 extern STR TUPCODE_FILECODE_FILE1;
 extern STR CLASS_LAYOUT1;
 extern STR IFC1;
 extern STR AM_ASSERT_STMT1;
 extern STR FLISTIDENT1;
 extern STR TUPIDENTAM_GLOBAL_EXPR1;
 extern STR FMAPdOBNAMESPACE1;
 extern STR AS_BREAK_EXPR1;
 extern STR FLISTAM_ITER_CALL_EXPR1;
 extern STR AS_BOOL_LIT_EXPR1;
 extern STR AS_NEAR_EXPR1;
 extern STR FMAPAM_LOCAL_EXPRAM_LOCA20;
 extern STR FMAPAM_BND_CREATE_EXPRBO20;
 extern STR TUPAM_BND_CREATE_EXPRBOU3;
 extern STR FSETEXTERNAL_LAYOUT1;
 extern STR AM_VOID_CONST2;
 extern STR AM_CLUSTER_EXPR1;
 extern STR FMAPdTPINT1;
 extern STR BUILTIN_LAYOUT1;
 extern STR ELT_TBL1;
 extern STR AS_WITH_NEAR_STMT1;
 extern STR TUPAM_ROUT_DEFFLISTAM_IT3;
 extern STR AM_WITH_NEAR_STMT1;
 extern STR TP_CLASS1;
 extern STR INTI1;
 extern STR AM_HERE_EXPR1;
 extern STR AS_YIELD_STMT1;
 extern STR AS_IF_STMT1;
 extern STR ARRAYdTP1;
 extern STR INLINE_GLOBAL_READ1;
 extern STR AM_CONST1;
 extern STR STR_CURSOR1;
 extern STR INLINE_ROUT_TBL1;
 extern STR AS_INTERF_ATTACH_STMT1;
 extern STR FMAPdTPCODE_FILE1;
 extern STR AM_POST_STMT1;
 extern STR AM_EXCEPT_EXPR1;
 extern STR TP_CLASS_TBL1;
 extern STR ARRAYFSTR1;
 extern STR AM_ROUT_DEF2;
 extern STR FMAPdTPFMAPIDENTAM_GLOBA19;
 extern STR TUPIDENTARRAYdTP1;
 extern STR FLISTAM_LOCAL_EXPR1;
 extern STR ARRAYSTR1;
 extern STR AS_PARAM_DEC1;
 extern STR TUPBOOLINTIINTBOOL1;
 extern STR AS_WHERE_EXPR1;
 extern STR AS_AND_EXPR1;
 extern STR AS_NEW_EXPR1;
 extern STR AS_UNDERSCORE_ARG1;
 extern STR XFORM_CODE1;
 extern STR PROG_AS_TBL1;
 extern STR AS_CHAR_LIT_EXPR1;
 extern STR TUPTP_CLASSFSETTP_CLASS1;
 extern STR AS_LOCK_STMT1;
 extern STR AS_TRY_STMT1;
 extern STR AS_CONST_DEF1;
 extern STR AM_UNLOCK_STMT1;
 extern STR TP_ROUT1;
 extern STR CALL_TP_ARRAY1;
 extern STR FSETdTP1;
 extern STR ABSTRACT_LAYOUT1;
 extern STR AS_PAR_STMT1;
 extern STR AM_FLTI_CONST1;
 extern STR AS_TYPE_SPEC1;
 extern STR FLISTCHAR1;
 extern STR TP_ITER1;
 extern STR FMAPAM_ROUT_DEFFRAME_LAY20;
 extern STR TUPdAM_EXPRdTP1;
 extern STR CALL_TP_CREATE1;
 extern STR GENERATE_AM1;
 extern STR AM_BND_CREATE_EXPR1;
 extern STR AM_FLTDX_CONST1;
 extern STR FSETAM_ROUT_DEF1;
 extern STR PROG1;
 extern STR FRAME_LAYOUT1;
 extern STR FLISTSTR1;
 extern STR AS_RETURN_STMT1;
 extern STR TUPSIGSTR1;
 extern STR AS_HERE_EXPR1;
 extern STR TUPINTIINTIINTI1;
 extern STR TUPFLISTdAM_CONSTFLISTdA2;
 extern STR GET_MAIN_SIG1;
 extern STR AM_INTI_CONST1;
 extern STR AS_AT_EXPR1;
 extern STR FSTR1;
 extern STR CS2;
 extern STR AM_VARR_ASSIGN_EXPR1;
 extern STR ARRAYdCALL_TP1;
 extern STR CHECK_AM1;
 extern STR TUPSTRITER_INLINE1;
 extern STR ELT1;
 extern STR TUPAM_BND_ITER_CALL_EXPR2;
 extern STR FMAPSTRSTR1;
 extern STR FMAPIDENTAM_GLOBAL_EXPR1;
 extern STR FLISTdLAYOUT1;
 extern STR AS_PROTECT_STMT1;
 extern STR AS_FLT_LIT_EXPR1;
 extern STR SIG_TBL1;
 extern STR IMPL_INCLUDE1;
 extern STR FLT1;
 extern STR FMAPSIGSTR1;
 extern STR TUPdTPdTP1;
 extern STR TUPSTRFSETSTR1;
 extern STR AM_VATTR_ASSIGN_EXPR1;
 extern STR AS_INITIAL_EXPR1;
 extern STR NAMESPACE1;
 extern STR AM_LOCK_STMT1;
 extern STR AS_ATTACH_STMT1;
 extern STR TUPINTINTINT1;
 extern STR AS_DEC_STMT1;
 extern STR AM_PROTECT_STMT1;
 extern STR AM_BREAK_STMT1;
 extern STR AS_ASSERT_STMT1;
 extern STR TUPFSTRFSTR1;
 extern STR INLINE_ITER1;
 extern STR AS_SHARED_DEF1;
 extern STR AM_TRY_STMT1;
 extern STR ARRAYBOOL1;
 extern STR CALL_TP_VOID1;
 extern STR AM_ARRAY_EXPR1;
 extern STR AM_FLTX_CONST1;
 extern STR CODE_FILE_ARRAY1;
 extern STR GLOBAL_TBL1;
 extern STR AS_CASE_STMT1;
 extern STR FLTD1;
 extern STR AS_LOOP_STMT1;
 extern STR INLINE_VATTR_WRITE1;
 extern STR TP_ARRAY1;
 extern STR TP_GRAPH_ANC1;
 extern STR TP_GRAPH_DES1;
 extern STR TUPSIGARG_LAYOUT1;
 extern STR AM_BOOL_CONST1;
 extern STR TUPSTRINT1;
 extern STR IDENT1;
 extern STR AM_INITIAL_STMT1;
 extern STR TP_CONTEXT1;
 extern STR CS_OPTIONS1;
 extern STR FLISTdAM_CONST1;
 extern STR TUPAS_CLASS_DEFAS_CLASS_2;
 extern STR AS_VOID_EXPR1;
 extern STR CHECK_IFC_CONFORMANCE1;
 extern STR TUPSIGABSTRACT_FRAME_LAY3;
 extern STR AM_ITER_CALL_EXPR1;
 extern STR AS_TYPECASE_WHEN1;
 extern STR AS_CALL_EXPR1;
 extern STR FLISTSIG1;
 extern STR INLINE_ATTR_READ1;
 extern STR FLISTFSTR1;
 extern STR AM_FAR_EXPR1;
 extern STR FLISTAM_ROUT_DEF1;
 extern STR AM_ARR_EXPR1;
 extern STR VALUE_CLASS_LAYOUT1;
 extern STR INLINE_ITER_TBL1;
 extern STR SYSTEM_LEX1;
 extern STR FSETAM_GLOBAL_EXPR1;
 extern STR ABSTRACT_FRAME_LAYOUT1;
 extern STR AS_IS_VOID_EXPR1;
 extern STR INLINE_ATTR_WRITE1;
 extern STR AS_FEAT_MOD1;
 extern STR SIG1;
 extern STR FMAPSTRSIG1;
 extern STR STR1;
 extern STR TUPAM_ITER_CALL_EXPRAM_I2;
 extern STR TUPIDENTIDENT1;
 extern STR FMAPSTRITER_INLINE1;
 extern STR FSETAS_FEAT_MOD1;
 extern STR AS_IDENT_LIST1;
 extern STR FMAPIDENTdTP1;
 extern STR AM_BND_ROUT_CALL_EXPR1;
 extern STR AS_CLASS_DEF1;
 extern STR TUPIDENTdTP1;
 extern STR AS_ARG_DEC1;
 extern STR TUPSTRSTR1;
 extern STR FMAPdTPdLAYOUT1;
 extern STR FSETTUPSIGSIG1;
 extern STR TP_ITER_TBL1;
 extern STR FIND_TYPES1;
 extern STR SCANNER1;
 extern STR AM_FLT_CONST1;
 extern STR ARRAYdAM_EXPR1;
 extern STR FSETSIG1;
 extern STR AM_INVARIANT_STMT1;
 extern STR AM_EXT_CALL_EXPR1;
 extern STR BOUND_OBJECT_LAYOUT1;
 extern STR AS_CREATE_EXPR1;
 extern STR TP_TBL1;
 extern STR RAT1;
 extern STR AM_STMT_EXPR1;
 extern STR FMAPSTRFSETSTR1;
 extern STR BUILD_TYPE_GRAPH1;
 extern STR IFC_ABS_CREATE1;
 extern STR FLISTAM_GLOBAL_EXPR1;
 extern STR IDENT_TBL1;
 extern STR FMAPSIGAM_ROUT_DEF1;
 extern STR AS_INT_LIT_EXPR1;
 extern STR AS_EXPR_STMT1;
 extern STR TUPdTPINT1;
 extern STR AS_PROTECT_WHEN1;
 extern STR FMAPdTPIMPL1;
 extern STR TUPARRAYdTPARRAYBOOLdTP1;
 extern STR AM_ATTR_EXPR1;
 extern STR AM_AT_EXPR1;
 extern STR NAMEMAP1;
 extern STR TUPdOBNAMESPACE1;
 extern STR TUPdOBSTR1;
 extern STR AS_COHORT_EXPR1;
 extern STR IFC_TBL1;
 extern STR AM_BND_ITER_CALL_EXPR1;
 extern STR FSETVALUE_CLASS_LAYOUT1;
 extern STR TUPTP_CLASSFSETdTP1;
 extern STR MS_RANDOM_GEN1;
 extern STR TUPSIGSIG1;
 extern STR AS_BOUND_CREATE_EXPR1;
 extern STR AM_FLTD_CONST1;
 extern STR PARSE1;
 extern STR TUPFLTFLT1;
 extern STR FLISTAS_CLASS_DEF1;
 extern STR AM_ASSIGN_STMT1;
 extern STR AS_UNCAUGHT_STMT1;
 extern STR AS_EXCEPT_EXPR1;
 extern STR AS_ANY_EXPR1;
 extern STR FLTI1;
 extern STR ITER_INLINE1;
 extern STR FLISTdAM_STMT1;
 extern STR AS_CASE_WHEN1;
 extern STR FLISTdAM_EXPR1;
 extern STR AM_IF_EXPR1;
 extern STR AS_SELF_EXPR1;
 extern STR FSETABSTRACT_LAYOUT1;
 extern STR ARRAYIDENT1;
 extern STR AS_FAR_EXPR1;
 extern STR FLTDX1;
 extern STR TUPIDENTINT1;
 extern STR FLISTIFC1;
 extern STR FSETTP_CLASS1;
 extern STR TUPINTINT1;
 extern STR AM_ROUT_CALL_EXPR1;
 extern STR AS_UNLOCK_STMT1;
 extern STR TUPdAM_CONSTdAM_CONST1;
 extern STR AM_IS_VOID_EXPR1;
 extern STR AM_TYPECASE_STMT1;
 extern STR FLISTFLISTdAM_CONST1;
 extern STR IMPL_TBL1;
 extern STR TUPIFCIFC1;
 extern STR NULL_OPTIMIZE1;
 extern STR PARSER1;
 extern STR AM_IF_STMT1;
 extern STR TUPdAM_STMTdAM_STMT1;
 extern STR AS_OR_EXPR1;
 extern STR INLINE_INT_FOLD1;
 extern STR FLISTdTP1;
 extern STR TUPdTPFMAPIDENTAM_GLOBAL3;
 extern STR TUPFLTDFLTD1;
 extern STR TUPdAM_EXPRdAM_EXPR1;
 extern STR TUPARRAYdTPdTP1;
 extern STR AM_RETURN_STMT1;
 extern STR TUPdTPCODE_FILE1;
 extern STR AM_OB_DEF1;
 extern STR BOOL1;
 extern STR AM_WHERE_EXPR1;
 extern STR BOUND_TYPE_LAYOUT1;
 extern STR IMPL_CREATE1;
 extern STR TUPSFILE_IDSFILE_ID1;
 extern STR AM_CHAR_CONST1;
 extern STR IMPL1;
 extern STR ARRAYINT1;
 extern STR TUPSTRSIG1;
 extern STR FLISTIMPL_INCLUDE1;
 extern STR FLISTSFILE_ID1;
 extern STR TP_GRAPH1;
 extern STR AS_ARRAY_EXPR1;
 extern STR TUPdTPdLAYOUT1;
 extern STR FMAPdTPIFC1;
 extern STR AM_YIELD_STMT1;
 extern STR TUPAM_GLOBAL_EXPRAM_GLOB2;
 extern STR AS_ASSIGN_STMT1;
 extern STR FMAPSTRINT1;
 extern STR AM_RAISE_STMT1;
 extern STR AS_STMT_LIST1;
 extern STR INLINE1;
 extern STR TP_ROUT_TBL1;
 extern STR CHANGE_VARS1;
 extern STR TUPSIGAM_ROUT_DEF1;
 extern STR FSETCLASS_LAYOUT1;
 extern STR AS_INCLUDE_CLAUSE1;
 extern STR INLINE_ROUT1;
 extern STR FSETTUPIDENTIDENT1;
 extern STR FLTX1;
 extern STR AS_RESULT_EXPR1;
 extern STR AM_LOCAL_EXPR1;
 extern STR AS_TYPECASE_STMT1;
 extern STR FSETBUILTIN_LAYOUT1;
 extern STR AM_LOOP_STMT1;
 extern STR FILE2;
 extern STR MANGLE1;
 extern STR LAYOUT_ARR1;
 extern STR AM_NEW_EXPR1;
 extern STR LAYOUT_ARRAY1;
 extern STR TUPAM_LOCAL_EXPRAM_LOCAL3;
 extern STR FLISTCODE_FILE1;
 extern STR AM_INT_CONST1;
 extern STR FLISTAM_BND_CREATE_EXPR1;
 extern STR TUPAM_ROUT_DEFAM_ROUT_DE2;
 extern STR FSETSTR1;
 extern STR FLISTINT1;
 extern STR FSETTUPIDENTINT1;
 extern STR TUPdTPIMPL1;
 extern STR AM_ATTACH_STMT2;
 extern STR AM_EXPR_STMT1;
 extern STR TP_LAYOUT1;
 extern STR FMAPTP_CLASSFSETTP_CLASS19;
 extern STR AS_QUIT_STMT1;
 extern STR FLISTAM_BND_ITER_CALL_EX12;
 extern STR AS_FORK_STMT1;
 extern STR TRANS1;
 extern STR FMAPTP_CLASSFSETdTP1;
 extern STR TUPIMPL_INCLUDEIMPL_INCL2;
 extern STR AM_NEAR_EXPR1;
 extern STR CHAR1;
 extern STR CODE_FILE1;
 extern STR AS_STR_LIT_EXPR1;

 switch (i) {
  case ABSTRACT_FRAME_LAYOUT_tag: return ((STR) &ABSTRACT_FRAME_LAYOUT1);
  case ABSTRACT_LAYOUT_tag: return ((STR) &ABSTRACT_LAYOUT1);
  case AM_ANY_EXPR_tag: return ((STR) &AM_ANY_EXPR1);
  case AM_ARRAY_EXPR_tag: return ((STR) &AM_ARRAY_EXPR1);
  case AM_ARR_CONST_tag: return ((STR) &AM_ARR_CONST1);
  case AM_ARR_EXPR_tag: return ((STR) &AM_ARR_EXPR1);
  case AM_ASSERT_STMT_tag: return ((STR) &AM_ASSERT_STMT1);
  case AM_ASSIGN_STMT_tag: return ((STR) &AM_ASSIGN_STMT1);
  case AM_ATTACH_STMT_tag: return ((STR) &AM_ATTACH_STMT2);
  case AM_ATTR_EXPR_tag: return ((STR) &AM_ATTR_EXPR1);
  case AM_AT_EXPR_tag: return ((STR) &AM_AT_EXPR1);
  case AM_BND_CREATE_EXPR_tag: return ((STR) &AM_BND_CREATE_EXPR1);
  case AM_BND_ITER_CALL_EXPR_tag: return ((STR) &AM_BND_ITER_CALL_EXPR1);
  case AM_BND_ROUT_CALL_EXPR_tag: return ((STR) &AM_BND_ROUT_CALL_EXPR1);
  case AM_BOOL_CONST_tag: return ((STR) &AM_BOOL_CONST1);
  case AM_BREAK_STMT_tag: return ((STR) &AM_BREAK_STMT1);
  case AM_CASE_STMT_tag: return ((STR) &AM_CASE_STMT1);
  case AM_CHAR_CONST_tag: return ((STR) &AM_CHAR_CONST1);
  case AM_CLUSTER_EXPR_tag: return ((STR) &AM_CLUSTER_EXPR1);
  case AM_CONST_tag: return ((STR) &AM_CONST1);
  case AM_EXCEPT_EXPR_tag: return ((STR) &AM_EXCEPT_EXPR1);
  case AM_EXPR_STMT_tag: return ((STR) &AM_EXPR_STMT1);
  case AM_EXT_CALL_EXPR_tag: return ((STR) &AM_EXT_CALL_EXPR1);
  case AM_FAR_EXPR_tag: return ((STR) &AM_FAR_EXPR1);
  case AM_FLTDX_CONST_tag: return ((STR) &AM_FLTDX_CONST1);
  case AM_FLTD_CONST_tag: return ((STR) &AM_FLTD_CONST1);
  case AM_FLTI_CONST_tag: return ((STR) &AM_FLTI_CONST1);
  case AM_FLTX_CONST_tag: return ((STR) &AM_FLTX_CONST1);
  case AM_FLT_CONST_tag: return ((STR) &AM_FLT_CONST1);
  case AM_GLOBAL_EXPR_tag: return ((STR) &AM_GLOBAL_EXPR1);
  case AM_HERE_EXPR_tag: return ((STR) &AM_HERE_EXPR1);
  case AM_IF_EXPR_tag: return ((STR) &AM_IF_EXPR1);
  case AM_IF_STMT_tag: return ((STR) &AM_IF_STMT1);
  case AM_INITIAL_STMT_tag: return ((STR) &AM_INITIAL_STMT1);
  case AM_INTI_CONST_tag: return ((STR) &AM_INTI_CONST1);
  case AM_INT_CONST_tag: return ((STR) &AM_INT_CONST1);
  case AM_INVARIANT_STMT_tag: return ((STR) &AM_INVARIANT_STMT1);
  case AM_IS_VOID_EXPR_tag: return ((STR) &AM_IS_VOID_EXPR1);
  case AM_ITER_CALL_EXPR_tag: return ((STR) &AM_ITER_CALL_EXPR1);
  case AM_LOCAL_EXPR_tag: return ((STR) &AM_LOCAL_EXPR1);
  case AM_LOCK_STMT_tag: return ((STR) &AM_LOCK_STMT1);
  case AM_LOOP_STMT_tag: return ((STR) &AM_LOOP_STMT1);
  case AM_NEAR_EXPR_tag: return ((STR) &AM_NEAR_EXPR1);
  case AM_NEW_EXPR_tag: return ((STR) &AM_NEW_EXPR1);
  case AM_OB_DEF_tag: return ((STR) &AM_OB_DEF1);
  case AM_POST_STMT_tag: return ((STR) &AM_POST_STMT1);
  case AM_PRE_STMT_tag: return ((STR) &AM_PRE_STMT1);
  case AM_PROTECT_STMT_tag: return ((STR) &AM_PROTECT_STMT1);
  case AM_RAISE_STMT_tag: return ((STR) &AM_RAISE_STMT1);
  case AM_RETURN_STMT_tag: return ((STR) &AM_RETURN_STMT1);
  case AM_ROUT_CALL_EXPR_tag: return ((STR) &AM_ROUT_CALL_EXPR1);
  case AM_ROUT_DEF_tag: return ((STR) &AM_ROUT_DEF2);
  case AM_STMT_EXPR_tag: return ((STR) &AM_STMT_EXPR1);
  case AM_STR_CONST_tag: return ((STR) &AM_STR_CONST1);
  case AM_TRY_STMT_tag: return ((STR) &AM_TRY_STMT1);
  case AM_TYPECASE_STMT_tag: return ((STR) &AM_TYPECASE_STMT1);
  case AM_UNCAUGHT_STMT_tag: return ((STR) &AM_UNCAUGHT_STMT1);
  case AM_UNLOCK_STMT_tag: return ((STR) &AM_UNLOCK_STMT1);
  case AM_VARR_ASSIGN_EXPR_tag: return ((STR) &AM_VARR_ASSIGN_EXPR1);
  case AM_VATTR_ASSIGN_EXPR_tag: return ((STR) &AM_VATTR_ASSIGN_EXPR1);
  case AM_VOID_CONST_tag: return ((STR) &AM_VOID_CONST2);
  case AM_WHERE_EXPR_tag: return ((STR) &AM_WHERE_EXPR1);
  case AM_WITH_NEAR_STMT_tag: return ((STR) &AM_WITH_NEAR_STMT1);
  case AM_YIELD_STMT_tag: return ((STR) &AM_YIELD_STMT1);
  case ARG_LAYOUT_tag: return ((STR) &ARG_LAYOUT1);
  case ARRAYARRAYSTR_tag: return ((STR) &ARRAYARRAYSTR1);
  case ARRAYBOOL_tag: return ((STR) &ARRAYBOOL1);
  case ARRAYFSTR_tag: return ((STR) &ARRAYFSTR1);
  case ARRAYIDENT_tag: return ((STR) &ARRAYIDENT1);
  case ARRAYINT_tag: return ((STR) &ARRAYINT1);
  case ARRAYSTR_tag: return ((STR) &ARRAYSTR1);
  case ARRAYdAM_EXPR_tag: return ((STR) &ARRAYdAM_EXPR1);
  case ARRAYdCALL_TP_tag: return ((STR) &ARRAYdCALL_TP1);
  case ARRAYdTP_tag: return ((STR) &ARRAYdTP1);
  case AS_AND_EXPR_tag: return ((STR) &AS_AND_EXPR1);
  case AS_ANY_EXPR_tag: return ((STR) &AS_ANY_EXPR1);
  case AS_ARG_DEC_tag: return ((STR) &AS_ARG_DEC1);
  case AS_ARRAY_EXPR_tag: return ((STR) &AS_ARRAY_EXPR1);
  case AS_ASSERT_STMT_tag: return ((STR) &AS_ASSERT_STMT1);
  case AS_ASSIGN_STMT_tag: return ((STR) &AS_ASSIGN_STMT1);
  case AS_ATTACH_STMT_tag: return ((STR) &AS_ATTACH_STMT1);
  case AS_ATTR_DEF_tag: return ((STR) &AS_ATTR_DEF1);
  case AS_AT_EXPR_tag: return ((STR) &AS_AT_EXPR1);
  case AS_BOOL_LIT_EXPR_tag: return ((STR) &AS_BOOL_LIT_EXPR1);
  case AS_BOUND_CREATE_EXPR_tag: return ((STR) &AS_BOUND_CREATE_EXPR1);
  case AS_BREAK_EXPR_tag: return ((STR) &AS_BREAK_EXPR1);
  case AS_CALL_EXPR_tag: return ((STR) &AS_CALL_EXPR1);
  case AS_CASE_STMT_tag: return ((STR) &AS_CASE_STMT1);
  case AS_CASE_WHEN_tag: return ((STR) &AS_CASE_WHEN1);
  case AS_CHAR_LIT_EXPR_tag: return ((STR) &AS_CHAR_LIT_EXPR1);
  case AS_CLASS_DEF_tag: return ((STR) &AS_CLASS_DEF1);
  case AS_CLUSTER_EXPR_tag: return ((STR) &AS_CLUSTER_EXPR1);
  case AS_COHORT_EXPR_tag: return ((STR) &AS_COHORT_EXPR1);
  case AS_CONST_DEF_tag: return ((STR) &AS_CONST_DEF1);
  case AS_CREATE_EXPR_tag: return ((STR) &AS_CREATE_EXPR1);
  case AS_DEC_STMT_tag: return ((STR) &AS_DEC_STMT1);
  case AS_EXCEPT_EXPR_tag: return ((STR) &AS_EXCEPT_EXPR1);
  case AS_EXPR_STMT_tag: return ((STR) &AS_EXPR_STMT1);
  case AS_FAR_EXPR_tag: return ((STR) &AS_FAR_EXPR1);
  case AS_FEAT_MOD_tag: return ((STR) &AS_FEAT_MOD1);
  case AS_FLT_LIT_EXPR_tag: return ((STR) &AS_FLT_LIT_EXPR1);
  case AS_FORK_STMT_tag: return ((STR) &AS_FORK_STMT1);
  case AS_HERE_EXPR_tag: return ((STR) &AS_HERE_EXPR1);
  case AS_IDENT_LIST_tag: return ((STR) &AS_IDENT_LIST1);
  case AS_IF_STMT_tag: return ((STR) &AS_IF_STMT1);
  case AS_INCLUDE_CLAUSE_tag: return ((STR) &AS_INCLUDE_CLAUSE1);
  case AS_INITIAL_EXPR_tag: return ((STR) &AS_INITIAL_EXPR1);
  case AS_INTERF_ATTACH_STMT_tag: return ((STR) &AS_INTERF_ATTACH_STMT1);
  case AS_INT_LIT_EXPR_tag: return ((STR) &AS_INT_LIT_EXPR1);
  case AS_IS_VOID_EXPR_tag: return ((STR) &AS_IS_VOID_EXPR1);
  case AS_LOCK_STMT_tag: return ((STR) &AS_LOCK_STMT1);
  case AS_LOOP_STMT_tag: return ((STR) &AS_LOOP_STMT1);
  case AS_NEAR_EXPR_tag: return ((STR) &AS_NEAR_EXPR1);
  case AS_NEW_EXPR_tag: return ((STR) &AS_NEW_EXPR1);
  case AS_OR_EXPR_tag: return ((STR) &AS_OR_EXPR1);
  case AS_PARAM_DEC_tag: return ((STR) &AS_PARAM_DEC1);
  case AS_PAR_STMT_tag: return ((STR) &AS_PAR_STMT1);
  case AS_PROTECT_STMT_tag: return ((STR) &AS_PROTECT_STMT1);
  case AS_PROTECT_WHEN_tag: return ((STR) &AS_PROTECT_WHEN1);
  case AS_QUIT_STMT_tag: return ((STR) &AS_QUIT_STMT1);
  case AS_RAISE_STMT_tag: return ((STR) &AS_RAISE_STMT1);
  case AS_RESULT_EXPR_tag: return ((STR) &AS_RESULT_EXPR1);
  case AS_RETURN_STMT_tag: return ((STR) &AS_RETURN_STMT1);
  case AS_ROUT_DEF_tag: return ((STR) &AS_ROUT_DEF1);
  case AS_SELF_EXPR_tag: return ((STR) &AS_SELF_EXPR1);
  case AS_SHARED_DEF_tag: return ((STR) &AS_SHARED_DEF1);
  case AS_STMT_LIST_tag: return ((STR) &AS_STMT_LIST1);
  case AS_STR_LIT_EXPR_tag: return ((STR) &AS_STR_LIT_EXPR1);
  case AS_TRY_STMT_tag: return ((STR) &AS_TRY_STMT1);
  case AS_TYPECASE_STMT_tag: return ((STR) &AS_TYPECASE_STMT1);
  case AS_TYPECASE_WHEN_tag: return ((STR) &AS_TYPECASE_WHEN1);
  case AS_TYPE_SPEC_tag: return ((STR) &AS_TYPE_SPEC1);
  case AS_UNCAUGHT_STMT_tag: return ((STR) &AS_UNCAUGHT_STMT1);
  case AS_UNDERSCORE_ARG_tag: return ((STR) &AS_UNDERSCORE_ARG1);
  case AS_UNLOCK_STMT_tag: return ((STR) &AS_UNLOCK_STMT1);
  case AS_VOID_EXPR_tag: return ((STR) &AS_VOID_EXPR1);
  case AS_WHERE_EXPR_tag: return ((STR) &AS_WHERE_EXPR1);
  case AS_WITH_NEAR_STMT_tag: return ((STR) &AS_WITH_NEAR_STMT1);
  case AS_YIELD_STMT_tag: return ((STR) &AS_YIELD_STMT1);
  case BOOL_tag: return ((STR) &BOOL1);
  case BOUND_OBJECT_LAYOUT_tag: return ((STR) &BOUND_OBJECT_LAYOUT1);
  case BOUND_TYPE_LAYOUT_tag: return ((STR) &BOUND_TYPE_LAYOUT1);
  case BUILD_TYPE_GRAPH_tag: return ((STR) &BUILD_TYPE_GRAPH1);
  case BUILTIN_LAYOUT_tag: return ((STR) &BUILTIN_LAYOUT1);
  case CALL_SIG_tag: return ((STR) &CALL_SIG1);
  case CALL_TP_ARRAY_tag: return ((STR) &CALL_TP_ARRAY1);
  case CALL_TP_CREATE_tag: return ((STR) &CALL_TP_CREATE1);
  case CALL_TP_UNDERSCORE_tag: return ((STR) &CALL_TP_UNDERSCORE1);
  case CALL_TP_VOID_tag: return ((STR) &CALL_TP_VOID1);
  case CGEN_tag: return ((STR) &CGEN1);
  case CHANGE_VARS_tag: return ((STR) &CHANGE_VARS1);
  case CHAR_tag: return ((STR) &CHAR1);
  case CHECK_AM_tag: return ((STR) &CHECK_AM1);
  case CHECK_IFC_CONFORMANCE_tag: return ((STR) &CHECK_IFC_CONFORMANCE1);
  case CLASS_LAYOUT_tag: return ((STR) &CLASS_LAYOUT1);
  case CODE_FILE_ARRAY_tag: return ((STR) &CODE_FILE_ARRAY1);
  case CODE_FILE_tag: return ((STR) &CODE_FILE1);
  case CS_OPTIONS_tag: return ((STR) &CS_OPTIONS1);
  case CS_tag: return ((STR) &CS2);
  case ELT_TBL_tag: return ((STR) &ELT_TBL1);
  case ELT_tag: return ((STR) &ELT1);
  case EXTERNAL_LAYOUT_tag: return ((STR) &EXTERNAL_LAYOUT1);
  case FILE1_tag: return ((STR) &FILE2);
  case FIND_TYPES_tag: return ((STR) &FIND_TYPES1);
  case FLISTAM_BND_CREATE_EXPR_tag: return ((STR) &FLISTAM_BND_CREATE_EXPR1);
  case FLISTAM_BND_ITER_CALL_EX_tag: return ((STR) &FLISTAM_BND_ITER_CALL_EX12);
  case FLISTAM_GLOBAL_EXPR_tag: return ((STR) &FLISTAM_GLOBAL_EXPR1);
  case FLISTAM_ITER_CALL_EXPR_tag: return ((STR) &FLISTAM_ITER_CALL_EXPR1);
  case FLISTAM_LOCAL_EXPR_tag: return ((STR) &FLISTAM_LOCAL_EXPR1);
  case FLISTAM_ROUT_DEF_tag: return ((STR) &FLISTAM_ROUT_DEF1);
  case FLISTAS_CLASS_DEF_tag: return ((STR) &FLISTAS_CLASS_DEF1);
  case FLISTCHAR_tag: return ((STR) &FLISTCHAR1);
  case FLISTCODE_FILE_tag: return ((STR) &FLISTCODE_FILE1);
  case FLISTFLISTdAM_CONST_tag: return ((STR) &FLISTFLISTdAM_CONST1);
  case FLISTFSTR_tag: return ((STR) &FLISTFSTR1);
  case FLISTIDENT_tag: return ((STR) &FLISTIDENT1);
  case FLISTIFC_tag: return ((STR) &FLISTIFC1);
  case FLISTIMPL_INCLUDE_tag: return ((STR) &FLISTIMPL_INCLUDE1);
  case FLISTINT_tag: return ((STR) &FLISTINT1);
  case FLISTSFILE_ID_tag: return ((STR) &FLISTSFILE_ID1);
  case FLISTSIG_tag: return ((STR) &FLISTSIG1);
  case FLISTSTR_tag: return ((STR) &FLISTSTR1);
  case FLISTdAM_CONST_tag: return ((STR) &FLISTdAM_CONST1);
  case FLISTdAM_EXPR_tag: return ((STR) &FLISTdAM_EXPR1);
  case FLISTdAM_STMT_tag: return ((STR) &FLISTdAM_STMT1);
  case FLISTdLAYOUT_tag: return ((STR) &FLISTdLAYOUT1);
  case FLISTdTP_tag: return ((STR) &FLISTdTP1);
  case FLTDX_tag: return ((STR) &FLTDX1);
  case FLTD_tag: return ((STR) &FLTD1);
  case FLTI_tag: return ((STR) &FLTI1);
  case FLTX_tag: return ((STR) &FLTX1);
  case FLT_tag: return ((STR) &FLT1);
  case FMAPAM_BND_CREATE_EXPRBO_tag: return ((STR) &FMAPAM_BND_CREATE_EXPRBO20);
  case FMAPAM_LOCAL_EXPRAM_LOCA_tag: return ((STR) &FMAPAM_LOCAL_EXPRAM_LOCA20);
  case FMAPAM_ROUT_DEFFLISTAM_I_tag: return ((STR) &FMAPAM_ROUT_DEFFLISTAM_I20);
  case FMAPAM_ROUT_DEFFRAME_LAY_tag: return ((STR) &FMAPAM_ROUT_DEFFRAME_LAY20);
  case FMAPIDENTAM_GLOBAL_EXPR_tag: return ((STR) &FMAPIDENTAM_GLOBAL_EXPR1);
  case FMAPIDENTdTP_tag: return ((STR) &FMAPIDENTdTP1);
  case FMAPSIGABSTRACT_FRAME_LA_tag: return ((STR) &FMAPSIGABSTRACT_FRAME_LA19);
  case FMAPSIGAM_ROUT_DEF_tag: return ((STR) &FMAPSIGAM_ROUT_DEF1);
  case FMAPSIGSTR_tag: return ((STR) &FMAPSIGSTR1);
  case FMAPSTRFSETSTR_tag: return ((STR) &FMAPSTRFSETSTR1);
  case FMAPSTRINT_tag: return ((STR) &FMAPSTRINT1);
  case FMAPSTRITER_INLINE_tag: return ((STR) &FMAPSTRITER_INLINE1);
  case FMAPSTRSIG_tag: return ((STR) &FMAPSTRSIG1);
  case FMAPSTRSTR_tag: return ((STR) &FMAPSTRSTR1);
  case FMAPTP_CLASSFSETTP_CLASS_tag: return ((STR) &FMAPTP_CLASSFSETTP_CLASS19);
  case FMAPTP_CLASSFSETdTP_tag: return ((STR) &FMAPTP_CLASSFSETdTP1);
  case FMAPdOBNAMESPACE_tag: return ((STR) &FMAPdOBNAMESPACE1);
  case FMAPdTPCODE_FILE_tag: return ((STR) &FMAPdTPCODE_FILE1);
  case FMAPdTPFMAPIDENTAM_GLOBA_tag: return ((STR) &FMAPdTPFMAPIDENTAM_GLOBA19);
  case FMAPdTPIFC_tag: return ((STR) &FMAPdTPIFC1);
  case FMAPdTPIMPL_tag: return ((STR) &FMAPdTPIMPL1);
  case FMAPdTPINT_tag: return ((STR) &FMAPdTPINT1);
  case FMAPdTPdLAYOUT_tag: return ((STR) &FMAPdTPdLAYOUT1);
  case FRAME_LAYOUT_tag: return ((STR) &FRAME_LAYOUT1);
  case FSETABSTRACT_LAYOUT_tag: return ((STR) &FSETABSTRACT_LAYOUT1);
  case FSETAM_GLOBAL_EXPR_tag: return ((STR) &FSETAM_GLOBAL_EXPR1);
  case FSETAM_ROUT_DEF_tag: return ((STR) &FSETAM_ROUT_DEF1);
  case FSETAS_FEAT_MOD_tag: return ((STR) &FSETAS_FEAT_MOD1);
  case FSETBOUND_TYPE_LAYOUT_tag: return ((STR) &FSETBOUND_TYPE_LAYOUT1);
  case FSETBUILTIN_LAYOUT_tag: return ((STR) &FSETBUILTIN_LAYOUT1);
  case FSETCLASS_LAYOUT_tag: return ((STR) &FSETCLASS_LAYOUT1);
  case FSETEXTERNAL_LAYOUT_tag: return ((STR) &FSETEXTERNAL_LAYOUT1);
  case FSETIDENT_tag: return ((STR) &FSETIDENT1);
  case FSETSIG_tag: return ((STR) &FSETSIG1);
  case FSETSTR_tag: return ((STR) &FSETSTR1);
  case FSETTP_CLASS_tag: return ((STR) &FSETTP_CLASS1);
  case FSETTUPIDENTIDENT_tag: return ((STR) &FSETTUPIDENTIDENT1);
  case FSETTUPIDENTINT_tag: return ((STR) &FSETTUPIDENTINT1);
  case FSETTUPSIGSIG_tag: return ((STR) &FSETTUPSIGSIG1);
  case FSETVALUE_CLASS_LAYOUT_tag: return ((STR) &FSETVALUE_CLASS_LAYOUT1);
  case FSETdLAYOUT_tag: return ((STR) &FSETdLAYOUT1);
  case FSETdTP_tag: return ((STR) &FSETdTP1);
  case FSTR_tag: return ((STR) &FSTR1);
  case GENERATE_AM_tag: return ((STR) &GENERATE_AM1);
  case GET_MAIN_SIG_tag: return ((STR) &GET_MAIN_SIG1);
  case GLOBAL_TBL_tag: return ((STR) &GLOBAL_TBL1);
  case IDENT_TBL_tag: return ((STR) &IDENT_TBL1);
  case IDENT_tag: return ((STR) &IDENT1);
  case IFC_ABS_CREATE_tag: return ((STR) &IFC_ABS_CREATE1);
  case IFC_TBL_tag: return ((STR) &IFC_TBL1);
  case IFC_tag: return ((STR) &IFC1);
  case IMPL_CREATE_tag: return ((STR) &IMPL_CREATE1);
  case IMPL_INCLUDE_tag: return ((STR) &IMPL_INCLUDE1);
  case IMPL_TBL_tag: return ((STR) &IMPL_TBL1);
  case IMPL_tag: return ((STR) &IMPL1);
  case IMPORT_EXPORT_TBL_tag: return ((STR) &IMPORT_EXPORT_TBL1);
  case INLINE_ATTR_READ_tag: return ((STR) &INLINE_ATTR_READ1);
  case INLINE_ATTR_WRITE_tag: return ((STR) &INLINE_ATTR_WRITE1);
  case INLINE_GLOBAL_READ_tag: return ((STR) &INLINE_GLOBAL_READ1);
  case INLINE_INT_FOLD_tag: return ((STR) &INLINE_INT_FOLD1);
  case INLINE_ITER_TBL_tag: return ((STR) &INLINE_ITER_TBL1);
  case INLINE_ITER_tag: return ((STR) &INLINE_ITER1);
  case INLINE_ROUT_TBL_tag: return ((STR) &INLINE_ROUT_TBL1);
  case INLINE_ROUT_tag: return ((STR) &INLINE_ROUT1);
  case INLINE_VATTR_WRITE_tag: return ((STR) &INLINE_VATTR_WRITE1);
  case INLINE_tag: return ((STR) &INLINE1);
  case INTI_tag: return ((STR) &INTI1);
  case INT_tag: return ((STR) &INT1);
  case ITER_INLINE_tag: return ((STR) &ITER_INLINE1);
  case LAYOUT_ARRAY_tag: return ((STR) &LAYOUT_ARRAY1);
  case LAYOUT_ARR_tag: return ((STR) &LAYOUT_ARR1);
  case MANGLE_tag: return ((STR) &MANGLE1);
  case MS_RANDOM_GEN_tag: return ((STR) &MS_RANDOM_GEN1);
  case NAMEMAP_tag: return ((STR) &NAMEMAP1);
  case NAMESPACE_tag: return ((STR) &NAMESPACE1);
  case NULL_OPTIMIZE_tag: return ((STR) &NULL_OPTIMIZE1);
  case PARSER_tag: return ((STR) &PARSER1);
  case PARSE_tag: return ((STR) &PARSE1);
  case PROG_AS_TBL_tag: return ((STR) &PROG_AS_TBL1);
  case PROG_tag: return ((STR) &PROG1);
  case RAT_tag: return ((STR) &RAT1);
  case SCANNER_tag: return ((STR) &SCANNER1);
  case SFILE_ID_tag: return ((STR) &SFILE_ID1);
  case SIG_TBL_tag: return ((STR) &SIG_TBL1);
  case SIG_tag: return ((STR) &SIG1);
  case STR_CURSOR_tag: return ((STR) &STR_CURSOR1);
  case STR_tag: return ((STR) &STR1);
  case SYSTEM_LEX_tag: return ((STR) &SYSTEM_LEX1);
  case TP_ARRAY_tag: return ((STR) &TP_ARRAY1);
  case TP_CLASS_TBL_tag: return ((STR) &TP_CLASS_TBL1);
  case TP_CLASS_tag: return ((STR) &TP_CLASS1);
  case TP_CONTEXT_tag: return ((STR) &TP_CONTEXT1);
  case TP_GRAPH_ABS_DES_tag: return ((STR) &TP_GRAPH_ABS_DES1);
  case TP_GRAPH_ANC_tag: return ((STR) &TP_GRAPH_ANC1);
  case TP_GRAPH_DES_tag: return ((STR) &TP_GRAPH_DES1);
  case TP_GRAPH_tag: return ((STR) &TP_GRAPH1);
  case TP_ITER_TBL_tag: return ((STR) &TP_ITER_TBL1);
  case TP_ITER_tag: return ((STR) &TP_ITER1);
  case TP_LAYOUT_tag: return ((STR) &TP_LAYOUT1);
  case TP_ROUT_TBL_tag: return ((STR) &TP_ROUT_TBL1);
  case TP_ROUT_tag: return ((STR) &TP_ROUT1);
  case TP_TBL_tag: return ((STR) &TP_TBL1);
  case TRANS_tag: return ((STR) &TRANS1);
  case TUPAM_BND_CREATE_EXPRAM__tag: return ((STR) &TUPAM_BND_CREATE_EXPRAM_2);
  case TUPAM_BND_CREATE_EXPRBOU_tag: return ((STR) &TUPAM_BND_CREATE_EXPRBOU3);
  case TUPAM_BND_ITER_CALL_EXPR_tag: return ((STR) &TUPAM_BND_ITER_CALL_EXPR2);
  case TUPAM_GLOBAL_EXPRAM_GLOB_tag: return ((STR) &TUPAM_GLOBAL_EXPRAM_GLOB2);
  case TUPAM_ITER_CALL_EXPRAM_I_tag: return ((STR) &TUPAM_ITER_CALL_EXPRAM_I2);
  case TUPAM_LOCAL_EXPRAM_LOCAL_tag: return ((STR) &TUPAM_LOCAL_EXPRAM_LOCAL3);
  case TUPAM_ROUT_DEFAM_ROUT_DE_tag: return ((STR) &TUPAM_ROUT_DEFAM_ROUT_DE2);
  case TUPAM_ROUT_DEFFLISTAM_IT_tag: return ((STR) &TUPAM_ROUT_DEFFLISTAM_IT3);
  case TUPAM_ROUT_DEFFRAME_LAYO_tag: return ((STR) &TUPAM_ROUT_DEFFRAME_LAYO3);
  case TUPARRAYdTPARRAYBOOLdTP_tag: return ((STR) &TUPARRAYdTPARRAYBOOLdTP1);
  case TUPARRAYdTPdTP_tag: return ((STR) &TUPARRAYdTPdTP1);
  case TUPAS_CLASS_DEFAS_CLASS__tag: return ((STR) &TUPAS_CLASS_DEFAS_CLASS_2);
  case TUPBOOLINTIINTBOOL_tag: return ((STR) &TUPBOOLINTIINTBOOL1);
  case TUPCHARCHAR_tag: return ((STR) &TUPCHARCHAR1);
  case TUPCODE_FILECODE_FILE_tag: return ((STR) &TUPCODE_FILECODE_FILE1);
  case TUPFLISTdAM_CONSTFLISTdA_tag: return ((STR) &TUPFLISTdAM_CONSTFLISTdA2);
  case TUPFLTDFLTD_tag: return ((STR) &TUPFLTDFLTD1);
  case TUPFLTFLT_tag: return ((STR) &TUPFLTFLT1);
  case TUPFSTRFSTR_tag: return ((STR) &TUPFSTRFSTR1);
  case TUPIDENTAM_GLOBAL_EXPR_tag: return ((STR) &TUPIDENTAM_GLOBAL_EXPR1);
  case TUPIDENTARRAYdTP_tag: return ((STR) &TUPIDENTARRAYdTP1);
  case TUPIDENTIDENT_tag: return ((STR) &TUPIDENTIDENT1);
  case TUPIDENTINT_tag: return ((STR) &TUPIDENTINT1);
  case TUPIDENTdTP_tag: return ((STR) &TUPIDENTdTP1);
  case TUPIFCIFC_tag: return ((STR) &TUPIFCIFC1);
  case TUPIMPL_INCLUDEIMPL_INCL_tag: return ((STR) &TUPIMPL_INCLUDEIMPL_INCL2);
  case TUPINTIINTIINTI_tag: return ((STR) &TUPINTIINTIINTI1);
  case TUPINTINTINT_tag: return ((STR) &TUPINTINTINT1);
  case TUPINTINT_tag: return ((STR) &TUPINTINT1);
  case TUPSFILE_IDSFILE_ID_tag: return ((STR) &TUPSFILE_IDSFILE_ID1);
  case TUPSIGABSTRACT_FRAME_LAY_tag: return ((STR) &TUPSIGABSTRACT_FRAME_LAY3);
  case TUPSIGAM_ROUT_DEF_tag: return ((STR) &TUPSIGAM_ROUT_DEF1);
  case TUPSIGARG_LAYOUT_tag: return ((STR) &TUPSIGARG_LAYOUT1);
  case TUPSIGSIG_tag: return ((STR) &TUPSIGSIG1);
  case TUPSIGSTR_tag: return ((STR) &TUPSIGSTR1);
  case TUPSTRFSETSTR_tag: return ((STR) &TUPSTRFSETSTR1);
  case TUPSTRINT_tag: return ((STR) &TUPSTRINT1);
  case TUPSTRITER_INLINE_tag: return ((STR) &TUPSTRITER_INLINE1);
  case TUPSTRSIG_tag: return ((STR) &TUPSTRSIG1);
  case TUPSTRSTR_tag: return ((STR) &TUPSTRSTR1);
  case TUPTP_CLASSFSETTP_CLASS_tag: return ((STR) &TUPTP_CLASSFSETTP_CLASS1);
  case TUPTP_CLASSFSETdTP_tag: return ((STR) &TUPTP_CLASSFSETdTP1);
  case TUPdAM_CONSTdAM_CONST_tag: return ((STR) &TUPdAM_CONSTdAM_CONST1);
  case TUPdAM_EXPRdAM_EXPR_tag: return ((STR) &TUPdAM_EXPRdAM_EXPR1);
  case TUPdAM_EXPRdTP_tag: return ((STR) &TUPdAM_EXPRdTP1);
  case TUPdAM_STMTdAM_STMT_tag: return ((STR) &TUPdAM_STMTdAM_STMT1);
  case TUPdLAYOUTdLAYOUT_tag: return ((STR) &TUPdLAYOUTdLAYOUT1);
  case TUPdOBNAMESPACE_tag: return ((STR) &TUPdOBNAMESPACE1);
  case TUPdOBSTR_tag: return ((STR) &TUPdOBSTR1);
  case TUPdTPCODE_FILE_tag: return ((STR) &TUPdTPCODE_FILE1);
  case TUPdTPFMAPIDENTAM_GLOBAL_tag: return ((STR) &TUPdTPFMAPIDENTAM_GLOBAL3);
  case TUPdTPIFC_tag: return ((STR) &TUPdTPIFC1);
  case TUPdTPIMPL_tag: return ((STR) &TUPdTPIMPL1);
  case TUPdTPINT_tag: return ((STR) &TUPdTPINT1);
  case TUPdTPdLAYOUT_tag: return ((STR) &TUPdTPdLAYOUT1);
  case TUPdTPdTP_tag: return ((STR) &TUPdTPdTP1);
  case VALUE_CLASS_LAYOUT_tag: return ((STR) &VALUE_CLASS_LAYOUT1);
  case WEIGH_CODE_tag: return ((STR) &WEIGH_CODE1);
  case XFORM_CODE_tag: return ((STR) &XFORM_CODE1);
  default: FATAL("Internal error: unknown tag?\n");
 }}


BOOL gen_SYS_ob_eq(OB o1,OB o2) {
 INT t1,t2;


 if (o1==o2) return TRUE;
 if (o1==NULL || o2==NULL) return FALSE;
 t1 = o1->header.tag; t2 = o2->header.tag;
 if (t1!=t2) return FALSE;
 switch (t1) {
  case TUPdLAYOUTdLAYOUT_tag:
    {TUPdLAYOUTdLAYOUT v1 = ((TUPdLAYOUTdLAYOUT_boxed)o1)->value_part;
     TUPdLAYOUTdLAYOUT v2 = ((TUPdLAYOUTdLAYOUT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdTPIFC_tag:
    {TUPdTPIFC v1 = ((TUPdTPIFC_boxed)o1)->value_part;
     TUPdTPIFC v2 = ((TUPdTPIFC_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_BND_CREATE_EXPRAM__tag:
    {TUPAM_BND_CREATE_EXPRAM_ v1 = ((TUPAM_BND_CREATE_EXPRAM__boxed)o1)->value_part;
     TUPAM_BND_CREATE_EXPRAM_ v2 = ((TUPAM_BND_CREATE_EXPRAM__boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPCHARCHAR_tag:
    {TUPCHARCHAR v1 = ((TUPCHARCHAR_boxed)o1)->value_part;
     TUPCHARCHAR v2 = ((TUPCHARCHAR_boxed)o2)->value_part;
     return (v1.t1==v2.t1)&&(v1.t2==v2.t2);}
  case TUPAM_ROUT_DEFFRAME_LAYO_tag:
    {TUPAM_ROUT_DEFFRAME_LAYO v1 = ((TUPAM_ROUT_DEFFRAME_LAYO_boxed)o1)->value_part;
     TUPAM_ROUT_DEFFRAME_LAYO v2 = ((TUPAM_ROUT_DEFFRAME_LAYO_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case SFILE_ID_tag:
    {SFILE_ID v1 = ((SFILE_ID_boxed)o1)->value_part;
     SFILE_ID v2 = ((SFILE_ID_boxed)o2)->value_part;
     return (v1.loc==v2.loc);}
  case INT_tag:
    {INT v1 = ((INT_boxed)o1)->value_part;
     INT v2 = ((INT_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPCODE_FILECODE_FILE_tag:
    {TUPCODE_FILECODE_FILE v1 = ((TUPCODE_FILECODE_FILE_boxed)o1)->value_part;
     TUPCODE_FILECODE_FILE v2 = ((TUPCODE_FILECODE_FILE_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPIDENTAM_GLOBAL_EXPR_tag:
    {TUPIDENTAM_GLOBAL_EXPR v1 = ((TUPIDENTAM_GLOBAL_EXPR_boxed)o1)->value_part;
     TUPIDENTAM_GLOBAL_EXPR v2 = ((TUPIDENTAM_GLOBAL_EXPR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1.str,v2.t1.str)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_BND_CREATE_EXPRBOU_tag:
    {TUPAM_BND_CREATE_EXPRBOU v1 = ((TUPAM_BND_CREATE_EXPRBOU_boxed)o1)->value_part;
     TUPAM_BND_CREATE_EXPRBOU v2 = ((TUPAM_BND_CREATE_EXPRBOU_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_ROUT_DEFFLISTAM_IT_tag:
    {TUPAM_ROUT_DEFFLISTAM_IT v1 = ((TUPAM_ROUT_DEFFLISTAM_IT_boxed)o1)->value_part;
     TUPAM_ROUT_DEFFLISTAM_IT v2 = ((TUPAM_ROUT_DEFFLISTAM_IT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPIDENTARRAYdTP_tag:
    {TUPIDENTARRAYdTP v1 = ((TUPIDENTARRAYdTP_boxed)o1)->value_part;
     TUPIDENTARRAYdTP v2 = ((TUPIDENTARRAYdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1.str,v2.t1.str)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPBOOLINTIINTBOOL_tag:
    {TUPBOOLINTIINTBOOL v1 = ((TUPBOOLINTIINTBOOL_boxed)o1)->value_part;
     TUPBOOLINTIINTBOOL v2 = ((TUPBOOLINTIINTBOOL_boxed)o2)->value_part;
     return (v1.t3==v2.t3)&&(v1.t4==v2.t4)&&(v1.t1==v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPTP_CLASSFSETTP_CLASS_tag:
    {TUPTP_CLASSFSETTP_CLASS v1 = ((TUPTP_CLASSFSETTP_CLASS_boxed)o1)->value_part;
     TUPTP_CLASSFSETTP_CLASS v2 = ((TUPTP_CLASSFSETTP_CLASS_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdAM_EXPRdTP_tag:
    {TUPdAM_EXPRdTP v1 = ((TUPdAM_EXPRdTP_boxed)o1)->value_part;
     TUPdAM_EXPRdTP v2 = ((TUPdAM_EXPRdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSIGSTR_tag:
    {TUPSIGSTR v1 = ((TUPSIGSTR_boxed)o1)->value_part;
     TUPSIGSTR v2 = ((TUPSIGSTR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPINTIINTIINTI_tag:
    {TUPINTIINTIINTI v1 = ((TUPINTIINTIINTI_boxed)o1)->value_part;
     TUPINTIINTIINTI v2 = ((TUPINTIINTIINTI_boxed)o2)->value_part;
     return SYSOBEQ(v1.t3,v2.t3)&&SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPFLISTdAM_CONSTFLISTdA_tag:
    {TUPFLISTdAM_CONSTFLISTdA v1 = ((TUPFLISTdAM_CONSTFLISTdA_boxed)o1)->value_part;
     TUPFLISTdAM_CONSTFLISTdA v2 = ((TUPFLISTdAM_CONSTFLISTdA_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSTRITER_INLINE_tag:
    {TUPSTRITER_INLINE v1 = ((TUPSTRITER_INLINE_boxed)o1)->value_part;
     TUPSTRITER_INLINE v2 = ((TUPSTRITER_INLINE_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_BND_ITER_CALL_EXPR_tag:
    {TUPAM_BND_ITER_CALL_EXPR v1 = ((TUPAM_BND_ITER_CALL_EXPR_boxed)o1)->value_part;
     TUPAM_BND_ITER_CALL_EXPR v2 = ((TUPAM_BND_ITER_CALL_EXPR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case FLT_tag:
    {FLT v1 = ((FLT_boxed)o1)->value_part;
     FLT v2 = ((FLT_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPdTPdTP_tag:
    {TUPdTPdTP v1 = ((TUPdTPdTP_boxed)o1)->value_part;
     TUPdTPdTP v2 = ((TUPdTPdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSTRFSETSTR_tag:
    {TUPSTRFSETSTR v1 = ((TUPSTRFSETSTR_boxed)o1)->value_part;
     TUPSTRFSETSTR v2 = ((TUPSTRFSETSTR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPINTINTINT_tag:
    {TUPINTINTINT v1 = ((TUPINTINTINT_boxed)o1)->value_part;
     TUPINTINTINT v2 = ((TUPINTINTINT_boxed)o2)->value_part;
     return (v1.t3==v2.t3)&&(v1.t1==v2.t1)&&(v1.t2==v2.t2);}
  case TUPFSTRFSTR_tag:
    {TUPFSTRFSTR v1 = ((TUPFSTRFSTR_boxed)o1)->value_part;
     TUPFSTRFSTR v2 = ((TUPFSTRFSTR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case FLTD_tag:
    {FLTD v1 = ((FLTD_boxed)o1)->value_part;
     FLTD v2 = ((FLTD_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPSIGARG_LAYOUT_tag:
    {TUPSIGARG_LAYOUT v1 = ((TUPSIGARG_LAYOUT_boxed)o1)->value_part;
     TUPSIGARG_LAYOUT v2 = ((TUPSIGARG_LAYOUT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSTRINT_tag:
    {TUPSTRINT v1 = ((TUPSTRINT_boxed)o1)->value_part;
     TUPSTRINT v2 = ((TUPSTRINT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&(v1.t2==v2.t2);}
  case IDENT_tag:
    {IDENT v1 = ((IDENT_boxed)o1)->value_part;
     IDENT v2 = ((IDENT_boxed)o2)->value_part;
     return SYSOBEQ(v1.str,v2.str);}
  case TUPAS_CLASS_DEFAS_CLASS__tag:
    {TUPAS_CLASS_DEFAS_CLASS_ v1 = ((TUPAS_CLASS_DEFAS_CLASS__boxed)o1)->value_part;
     TUPAS_CLASS_DEFAS_CLASS_ v2 = ((TUPAS_CLASS_DEFAS_CLASS__boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSIGABSTRACT_FRAME_LAY_tag:
    {TUPSIGABSTRACT_FRAME_LAY v1 = ((TUPSIGABSTRACT_FRAME_LAY_boxed)o1)->value_part;
     TUPSIGABSTRACT_FRAME_LAY v2 = ((TUPSIGABSTRACT_FRAME_LAY_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_ITER_CALL_EXPRAM_I_tag:
    {TUPAM_ITER_CALL_EXPRAM_I v1 = ((TUPAM_ITER_CALL_EXPRAM_I_boxed)o1)->value_part;
     TUPAM_ITER_CALL_EXPRAM_I v2 = ((TUPAM_ITER_CALL_EXPRAM_I_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPIDENTIDENT_tag:
    {TUPIDENTIDENT v1 = ((TUPIDENTIDENT_boxed)o1)->value_part;
     TUPIDENTIDENT v2 = ((TUPIDENTIDENT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1.str,v2.t1.str)&&SYSOBEQ(v1.t2.str,v2.t2.str);}
  case TUPIDENTdTP_tag:
    {TUPIDENTdTP v1 = ((TUPIDENTdTP_boxed)o1)->value_part;
     TUPIDENTdTP v2 = ((TUPIDENTdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1.str,v2.t1.str)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSTRSTR_tag:
    {TUPSTRSTR v1 = ((TUPSTRSTR_boxed)o1)->value_part;
     TUPSTRSTR v2 = ((TUPSTRSTR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case RAT_tag:
    {RAT v1 = ((RAT_boxed)o1)->value_part;
     RAT v2 = ((RAT_boxed)o2)->value_part;
     return SYSOBEQ(v1.u,v2.u)&&SYSOBEQ(v1.v,v2.v);}
  case TUPdTPINT_tag:
    {TUPdTPINT v1 = ((TUPdTPINT_boxed)o1)->value_part;
     TUPdTPINT v2 = ((TUPdTPINT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&(v1.t2==v2.t2);}
  case TUPARRAYdTPARRAYBOOLdTP_tag:
    {TUPARRAYdTPARRAYBOOLdTP v1 = ((TUPARRAYdTPARRAYBOOLdTP_boxed)o1)->value_part;
     TUPARRAYdTPARRAYBOOLdTP v2 = ((TUPARRAYdTPARRAYBOOLdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t3,v2.t3)&&SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdOBNAMESPACE_tag:
    {TUPdOBNAMESPACE v1 = ((TUPdOBNAMESPACE_boxed)o1)->value_part;
     TUPdOBNAMESPACE v2 = ((TUPdOBNAMESPACE_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdOBSTR_tag:
    {TUPdOBSTR v1 = ((TUPdOBSTR_boxed)o1)->value_part;
     TUPdOBSTR v2 = ((TUPdOBSTR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPTP_CLASSFSETdTP_tag:
    {TUPTP_CLASSFSETdTP v1 = ((TUPTP_CLASSFSETdTP_boxed)o1)->value_part;
     TUPTP_CLASSFSETdTP v2 = ((TUPTP_CLASSFSETdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSIGSIG_tag:
    {TUPSIGSIG v1 = ((TUPSIGSIG_boxed)o1)->value_part;
     TUPSIGSIG v2 = ((TUPSIGSIG_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPFLTFLT_tag:
    {TUPFLTFLT v1 = ((TUPFLTFLT_boxed)o1)->value_part;
     TUPFLTFLT v2 = ((TUPFLTFLT_boxed)o2)->value_part;
     return (v1.t1==v2.t1)&&(v1.t2==v2.t2);}
  case FLTDX_tag:
    {FLTDX v1 = ((FLTDX_boxed)o1)->value_part;
     FLTDX v2 = ((FLTDX_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPIDENTINT_tag:
    {TUPIDENTINT v1 = ((TUPIDENTINT_boxed)o1)->value_part;
     TUPIDENTINT v2 = ((TUPIDENTINT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1.str,v2.t1.str)&&(v1.t2==v2.t2);}
  case TUPINTINT_tag:
    {TUPINTINT v1 = ((TUPINTINT_boxed)o1)->value_part;
     TUPINTINT v2 = ((TUPINTINT_boxed)o2)->value_part;
     return (v1.t1==v2.t1)&&(v1.t2==v2.t2);}
  case TUPdAM_CONSTdAM_CONST_tag:
    {TUPdAM_CONSTdAM_CONST v1 = ((TUPdAM_CONSTdAM_CONST_boxed)o1)->value_part;
     TUPdAM_CONSTdAM_CONST v2 = ((TUPdAM_CONSTdAM_CONST_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPIFCIFC_tag:
    {TUPIFCIFC v1 = ((TUPIFCIFC_boxed)o1)->value_part;
     TUPIFCIFC v2 = ((TUPIFCIFC_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdAM_STMTdAM_STMT_tag:
    {TUPdAM_STMTdAM_STMT v1 = ((TUPdAM_STMTdAM_STMT_boxed)o1)->value_part;
     TUPdAM_STMTdAM_STMT v2 = ((TUPdAM_STMTdAM_STMT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdTPFMAPIDENTAM_GLOBAL_tag:
    {TUPdTPFMAPIDENTAM_GLOBAL v1 = ((TUPdTPFMAPIDENTAM_GLOBAL_boxed)o1)->value_part;
     TUPdTPFMAPIDENTAM_GLOBAL v2 = ((TUPdTPFMAPIDENTAM_GLOBAL_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPFLTDFLTD_tag:
    {TUPFLTDFLTD v1 = ((TUPFLTDFLTD_boxed)o1)->value_part;
     TUPFLTDFLTD v2 = ((TUPFLTDFLTD_boxed)o2)->value_part;
     return (v1.t1==v2.t1)&&(v1.t2==v2.t2);}
  case TUPdAM_EXPRdAM_EXPR_tag:
    {TUPdAM_EXPRdAM_EXPR v1 = ((TUPdAM_EXPRdAM_EXPR_boxed)o1)->value_part;
     TUPdAM_EXPRdAM_EXPR v2 = ((TUPdAM_EXPRdAM_EXPR_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPARRAYdTPdTP_tag:
    {TUPARRAYdTPdTP v1 = ((TUPARRAYdTPdTP_boxed)o1)->value_part;
     TUPARRAYdTPdTP v2 = ((TUPARRAYdTPdTP_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdTPCODE_FILE_tag:
    {TUPdTPCODE_FILE v1 = ((TUPdTPCODE_FILE_boxed)o1)->value_part;
     TUPdTPCODE_FILE v2 = ((TUPdTPCODE_FILE_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case BOOL_tag:
    {BOOL v1 = ((BOOL_boxed)o1)->value_part;
     BOOL v2 = ((BOOL_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPSFILE_IDSFILE_ID_tag:
    {TUPSFILE_IDSFILE_ID v1 = ((TUPSFILE_IDSFILE_ID_boxed)o1)->value_part;
     TUPSFILE_IDSFILE_ID v2 = ((TUPSFILE_IDSFILE_ID_boxed)o2)->value_part;
     return (v1.t1.loc==v2.t1.loc)&&(v1.t2.loc==v2.t2.loc);}
  case TUPSTRSIG_tag:
    {TUPSTRSIG v1 = ((TUPSTRSIG_boxed)o1)->value_part;
     TUPSTRSIG v2 = ((TUPSTRSIG_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdTPdLAYOUT_tag:
    {TUPdTPdLAYOUT v1 = ((TUPdTPdLAYOUT_boxed)o1)->value_part;
     TUPdTPdLAYOUT v2 = ((TUPdTPdLAYOUT_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_GLOBAL_EXPRAM_GLOB_tag:
    {TUPAM_GLOBAL_EXPRAM_GLOB v1 = ((TUPAM_GLOBAL_EXPRAM_GLOB_boxed)o1)->value_part;
     TUPAM_GLOBAL_EXPRAM_GLOB v2 = ((TUPAM_GLOBAL_EXPRAM_GLOB_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPSIGAM_ROUT_DEF_tag:
    {TUPSIGAM_ROUT_DEF v1 = ((TUPSIGAM_ROUT_DEF_boxed)o1)->value_part;
     TUPSIGAM_ROUT_DEF v2 = ((TUPSIGAM_ROUT_DEF_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case FLTX_tag:
    {FLTX v1 = ((FLTX_boxed)o1)->value_part;
     FLTX v2 = ((FLTX_boxed)o2)->value_part;
     return (v1==v2);}
  case TUPAM_LOCAL_EXPRAM_LOCAL_tag:
    {TUPAM_LOCAL_EXPRAM_LOCAL v1 = ((TUPAM_LOCAL_EXPRAM_LOCAL_boxed)o1)->value_part;
     TUPAM_LOCAL_EXPRAM_LOCAL v2 = ((TUPAM_LOCAL_EXPRAM_LOCAL_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPAM_ROUT_DEFAM_ROUT_DE_tag:
    {TUPAM_ROUT_DEFAM_ROUT_DE v1 = ((TUPAM_ROUT_DEFAM_ROUT_DE_boxed)o1)->value_part;
     TUPAM_ROUT_DEFAM_ROUT_DE v2 = ((TUPAM_ROUT_DEFAM_ROUT_DE_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPdTPIMPL_tag:
    {TUPdTPIMPL v1 = ((TUPdTPIMPL_boxed)o1)->value_part;
     TUPdTPIMPL v2 = ((TUPdTPIMPL_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case TUPIMPL_INCLUDEIMPL_INCL_tag:
    {TUPIMPL_INCLUDEIMPL_INCL v1 = ((TUPIMPL_INCLUDEIMPL_INCL_boxed)o1)->value_part;
     TUPIMPL_INCLUDEIMPL_INCL v2 = ((TUPIMPL_INCLUDEIMPL_INCL_boxed)o2)->value_part;
     return SYSOBEQ(v1.t1,v2.t1)&&SYSOBEQ(v1.t2,v2.t2);}
  case CHAR_tag:
    {CHAR v1 = ((CHAR_boxed)o1)->value_part;
     CHAR v2 = ((CHAR_boxed)o2)->value_part;
     return (v1==v2);}
  default: return FALSE;
   }}


